#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";
#
#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;

&get_setup;
fmspm::check_spamb("addurl.cgi", "header", "$data_dir");
$q = CGI->new;

#################

print "Content-type: text/html\n\n";

$gsettings = new_gsettings tseek;

#if ($q->param('fct') eq "fetch"){&fetch; exit;}

if ($gsettings->{addurl_reg_system} eq "Yes"){ &add_url_reg_system; exit; }

if ($q->param('fct') eq ""){&add_url_screen;}


################


sub add_url_reg_system ### CHECK ACCESS
{
pseek::accesscheck("", "", "ADDURL_CL");
&add_url_screen;
}



sub add_url_screen
{

$custom_add_url_form = $q->param('f');

$add_url_form_medium_large = $gsettings->{add_url_form};

if ($q->param('f') ne "")
	{
		for ($ms = 0; $ms < length($q->param('f')); $ms++) 
			{
			$oneletter = substr($q->param('f'), $ms, 1);
			if ($oneletter !~ /[0-9a-zA-Z]/)
				{
				$custom_add_url_form = "";
				}
			}
	}

	if ($custom_add_url_form ne "")
		{
		$cust_dat = "$data_dir/addmod_" . $custom_add_url_form . ".dat";
		if ((-e "$cust_dat") < 1) { $custom_add_url_form = ""; } else { $add_url_form_medium_large = "medium"; }
		}


if ($add_url_form_medium_large eq "medium")
	{
	
	if ($q->param('p') == 1) ### IF PREMIUM LINK SUBMISSION
		{

		if ($gsettings->{addurl_reg_system} eq "Yes") ### IF REGISTRATION SYSTEM IN USE
			{
				if ($custom_add_url_form ne "") ### IF CUSTOM PREMIUM ADD URL FORM
					{
					$addurl_template = pseek::get_file_contents("$data_dir/$custom_add_url_form" . "_rgs_add_url_medp.html");
					}
					else  ### STANDARD PREMIUM ADD URL FORM
					{
					$addurl_template = pseek::get_file_contents("$data_dir/rgs_add_url_medp.html");
					}
			}
			else ### IF REGISTRATION SYSTEM IN NOT USE
			{
			$addurl_template = pseek::get_file_contents("$data_dir/add_url_medp.html");
			}
		
		}
		else ### IF NOT PREMIUM LINK SUBMISSION
		{

		if ($gsettings->{addurl_reg_system} eq "Yes") ### IF REGISTRATION SYSTEM IN USE
			{
					if ($custom_add_url_form ne "") ### IF CUSTOM ADD URL FORM
					{
					$addurl_template = pseek::get_file_contents("$data_dir/$custom_add_url_form" . "_rgs_add_url_med.html");
					}
					else ### STANDARD ADD URL FORM
					{
					$addurl_template = pseek::get_file_contents("$data_dir/rgs_add_url_med.html");
					}
			
			}
			else ### IF REGISTRATION SYSTEM IN NOT USE
			{
			$addurl_template = pseek::get_file_contents("$data_dir/add_url_med.html");
			}		
		}
		
	}
	else ### IF LARGE SEARCH ENGINE ADD URL FORMS ARE USED
	{

	if (int($q->param('cid')) < 1)
		{
		
		if ($gsettings->{addurl_reg_system} eq "Yes") ### IF REG SYSTEM IN USE
			{
			$addurl_template = pseek::get_file_contents("$data_dir/rgs_add_url_instructions.html");
			}
			else
			{
			$addurl_template = pseek::get_file_contents("$data_dir/add_url_instructions.html");
			}
		

		$addurl_template = pseek::ts_insert_template_includes($addurl_template);
		$addurl_template =~ s/!!addurlcgi!!/$script_url\/addurl2.cgi/g;
		$addurl_template =~ s/!!scripts_url!!/$script_url/g;
		
		if ($gsettings->{searchmeth} eq "fulltext")
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
			}
			else
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
			}
		
		$addurl_template =~ s/!build_url!/$web_url/g;
		$addurl_template =~ s/!!build_ursl!!/$web_url/g;
		$addurl_template =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;
		$addurl_template = pseek::fill_vars($addurl_template);
 
 		$addurl_template = &remove_keyvalues($addurl_template);
		print $addurl_template;
		exit;
		}

		###############


	if ($q->param('p') == 1) ### IF PREMIUM URL
		{
		if ($gsettings->{addurl_reg_system} eq "Yes") 
			{
			$addurl_template = pseek::get_file_contents("$data_dir/rgs_add_urlp.html");
			}
			else
			{
			$addurl_template = pseek::get_file_contents("$data_dir/add_urlp.html");
			}
		}
		else
		{
			if ($gsettings->{addurl_reg_system} eq "Yes") 
			{
			$addurl_template = pseek::get_file_contents("$data_dir/rgs_add_url.html");
			}
			else
			{
			$addurl_template = pseek::get_file_contents("$data_dir/add_url.html");
			}
		}	
		
	}



$addurl_template = pseek::ts_insert_template_includes($addurl_template);
$addurl_template =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;


if ($gsettings->{dyn_stat} eq "Dynamic")
	{
	$addurl_template =~ s/!!whatsnew!!/$script_url\/dirs\.cgi?newpop=new/g;
	$addurl_template =~ s/!!tophits!!/$script_url\/dirs\.cgi?newpop=pop/g;
	}
	else
	{
	$addurl_template =~ s/!!whatsnew!!/$web_url\/new\//g;
	$addurl_template =~ s/!!tophits!!/$web_url\/pop\//g;
	}


$addurl_template =~ s/!!add_url_link!!/$script_url\/addurl\.cgi/g;
$addurl_template =~ s/!!add_premium_url_link!!/$script_url\/addurl\.cgi?p=1/g;

$addurl_template =~ s/!!addurlcgi!!/$script_url\/addurl2.cgi/g;
$addurl_template =~ s/!!scripts_url!!/$script_url/g;


		if ($gsettings->{searchmeth} eq "fulltext")
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
			}
			else
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
			}


$addurl_template =~ s/!build_url!/$web_url/g;
$addurl_template =~ s/!!build_ursl!!/$web_url/g;

$texta = "<textarea rows=\"5\" name=\"description\" cols=\"33\" style=\"width:100%\"></textarea>";
$addurl_template =~ s/%%submissionbox%%/$texta/g;

$cid = $q->param('cid');


if ($gsettings->{add_url_form} eq "medium")
	{
		if ($addurl_template =~ /%%category_dropdown%%/i) ##### Standard Add URL
			{
			&get_dropdown($custom_add_url_form); 
			} 
			elsif ($addurl_template =~ /%%category_dropdown_ajax%%/i)  ###### Ajax Add URL
			{
			&get_dropdown_ajax ($custom_add_url_form); 
			}
	}
	else
	{
	if ($custom_add_url_form ne "") 
		{ 
		&get_dropdown($custom_add_url_form);
		}
		else
		{
		&get_cat_large_engines;
		}
	}

if ($q->param('p') == 1){$addurl_template =~ s/!!p!!/1/g;}



### IF IMAGE AUTHENTICATION IS ENABLED THEN DISPLAY LETTERS

#if ($gsettings->{img_auth} eq "Yes")
if ($gsettings->{img_auth} eq "Yes")
	{
	$imgbox = pseek::get_imgboxes_cc;
	
	($imdisp, $imgnames) = split (/:::/, $imgbox);
	
	$imgnames =~ s/\.gif//gi;
	$addurl_template =~ s/!!ia!!/$imgnames/g;
	$addurl_template =~ s/%%imgbox%%/$imdisp/g;
	}


if ($addurl_template =~ /fetchbutton/i)
	{
	$popupfetch = qq[
	<script LANGUAGE="JavaScript">
	<!-- Hide
		function popup(loc)
	   {
		TheNewWin = window.open(loc,'help','height=200,width=300,toolbar=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,location=0');
	   }
	// End Hide -->
	</script>
	];
	
	$addurl_template =~ s/!!fetch!!/$popupfetch/gi;
	
	$onclick_crit = qq["fetchbutton" onClick="popup('$script_url/addurl.cgi?fct=fetch&url=' + url.value); return false;"];
	
	$addurl_template =~ s/"fetchbutton"/$onclick_crit/gi;
	
	
	
	}

$addurl_template = &remove_keyvalues($addurl_template);

print $addurl_template;

}












sub get_cat_large_engines
{

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET CATEGORIES

$sth = $dbh->prepare("SELECT * FROM dirs WHERE cid = '$cid'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE cid = '$cid'";}

while ( @row = $sth->fetchrow() )
	{
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$dcat = $dcat . $row[$ms] . "/";
			}
		}
	$catlock = $row[22];
	}

$sth->finish;
$dbh->disconnect;


###########

if ($catlock eq "Y")
	{
	if ($gsettings->{addurl_reg_system} eq "Yes")
		{
		$addurl_template = pseek::get_file_contents("$data_dir/rgs_locked.html");
		}
		else
		{
		$addurl_template = pseek::get_file_contents("$data_dir/locked.html");
		}

	$addurl_template = pseek::ts_insert_template_includes($addurl_template);
	$addurl_template =~ s/!!addurlcgi!!/$script_url\/addurl2.cgi/g;
	$addurl_template =~ s/!!scripts_url!!/$script_url/g;
	
		if ($gsettings->{searchmeth} eq "fulltext")
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
			}
			else
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
			}
	
	$addurl_template =~ s/!build_url!/$web_url/g;
	$addurl_template =~ s/!!build_url!!/$web_url/g;
	$addurl_template =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;
	$addurl_template = pseek::fill_vars($addurl_template);
	print $addurl_template;
	exit;
	}

$addurl_template =~ s/%%add_category%%/$dcat/g;
$addurl_template =~ s/!!catid!!/$cid/g;

}






sub get_dropdown
{

my ($customaform) = @_;


### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### IF CUSTOM ADD URL FORM

if ($customaform ne "") #addmod_fintest.dat
	{
	$custom_data = pseek::get_file_contents("$data_dir/addmod_" . $customaform . ".dat");
	@custom_ditems = split (/\n/, $custom_data);
	($incl_subs, $inclcats) = split (/::/, $custom_ditems[3]);
	}


if (($customaform ne "") and ($inclcats ne ""))
	{
		$ccount = 0;
		@cids = split (/,/,$inclcats);
			foreach $cid (@cids)
				{
				if (int($cid) > 0)
					{
					$ccount++;
					$sqlstr = $sqlstr . " (cid = '$cid') OR";
					}
				}
			chop ($sqlstr); chop($sqlstr);
	
		if ($incl_subs ne "Y")
			{
			$category_sql = "SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ($sqlstr) ORDER BY level";
			}
			else
			{
					$sth = $dbh->prepare("SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ($sqlstr) ORDER BY level");
					$sth->execute;
					$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
					while ( @row = $sth->fetchrow() )
						{
								
								$lvc=0;
								for ($ms = 2; $ms < 18; $ms++) 
										{
										if ($row[$ms] ne "")
											{
												$lvc++;
												if ($lvc == 1) { $sql_crit = $sql_crit . "("; }
												$sql_crit = $sql_crit . " (l" . $lvc . " = '$row[$ms]') AND"
											}
									} 

						$sql_crit = substr($sql_crit, 0, length($sql_crit) - 3);
						$sql_crit = $sql_crit . ") OR ";
						}
				
				$sql_crit = substr($sql_crit, 0, length($sql_crit) - 3);
				
			$category_sql = "SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND $sql_crit ORDER BY level";
			}
	
	
	}
	else ### if not custom add url form
	{
	$category_sql = "SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY level";
	}



### GET CATEGORIES

$sth = $dbh->prepare($category_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows(); 


$hcount = 0;
while ( @row = $sth->fetchrow() )
	{

	for ($ms = 2; $ms < 19; $ms++) 
		{
		$row[$ms] =~ s/\t//gi; $row[$ms] =~ s/\n//gi;
		}
	
	$dirstring = "";
	if ($row[2] ne "") {$dirstring = $row[2];}
	if ($row[3] ne "") {$dirstring = $dirstring . "/$row[3]";}
	if ($row[4] ne "") {$dirstring = $dirstring . "/$row[4]";}
	if ($row[5] ne "") {$dirstring = $dirstring . "/$row[5]";}
	if ($row[6] ne "") {$dirstring = $dirstring . "/$row[6]";}
	if ($row[7] ne "") {$dirstring = $dirstring . "/$row[7]";}
	if ($row[8] ne "") {$dirstring = $dirstring . "/$row[8]";}
	if ($row[9] ne "") {$dirstring = $dirstring . "/$row[9]";}
	if ($row[10] ne "") {$dirstring = $dirstring . "/$row[10]";}
	if ($row[11] ne "") {$dirstring = $dirstring . "/$row[11]";}
	if ($row[12] ne "") {$dirstring = $dirstring . "/$row[12]";}
	if ($row[13] ne "") {$dirstring = $dirstring . "/$row[13]";}
	if ($row[14] ne "") {$dirstring = $dirstring . "/$row[14]";}
	if ($row[15] ne "") {$dirstring = $dirstring . "/$row[15]";}
	if ($row[16] ne "") {$dirstring = $dirstring . "/$row[16]";}
	if ($row[17] ne "") {$dirstring = $dirstring . "/$row[17]";}


		if (($row[22] ne "H") and ($row[22] ne "Y"))
		{
		
		
			$part_of_hidden = "false";
			foreach $hitem (@hcats)
				{
				$matchcrit = substr($dirstring, 0, length($hitem)) . "/";
				
					if ($matchcrit eq "$hitem/")
					{
					$part_of_hidden = "true";
					}
				
				#print "--> $hitem/ | $matchcrit = $part_of_hidden<BR>\n";
				}
			
			
			if ($part_of_hidden eq "false")
				{
				$atree[$acnt] = $dirstring . "\t" . 
									 $row[0] . "\t" .  	#### CID
									 $row[1] . "\t" .  	#### LEVEL
									 $row[28]; 			 	#### NAME
				$acnt++;
				}
			
		}
		elsif ($row[22] eq "H")
		{
		$hcats[$hcount] = $dirstring;
		$hcount++;
		}
	

	if ($row[1] == 1) { $total_links = $total_links + $row[20]; }
	
	}


#########

$dropdownb = "<select name=\"category_dropdown\" size=\"1\">";

@atree = sort(@atree);

foreach $item (@atree)
	{
	($dirstr, $cid2, $level, $name) = split (/\t/, $item);

	$spacing = "";
	for ($ms = 0; $ms < ($level + 1); $ms++) 
			{
			$spacing = $spacing . "&nbsp; &nbsp; ";
			}

	if ($cid2 eq $cid)
		{
		$dropdownb = $dropdownb . "<option selected value=\"$cid2\">$dirstr</option>";
		}
		else
		{
		$dropdownb = $dropdownb . "<option value=\"$cid2\">$dirstr</option>";
		}
	
	}

$dropdownb = $dropdownb . "</select>";

########

$sth->finish;
$dbh->disconnect;

$addurl_template =~ s/%%category_dropdown%%/$dropdownb/g;

}







sub get_dropdown_ajax
{

my ($customaform) = @_;


### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### IF CUSTOM ADD URL FORM

if ($customaform ne "") #addmod_fintest.dat
	{
	$custom_data = pseek::get_file_contents("$data_dir/addmod_" . $customaform . ".dat");
	@custom_ditems = split (/\n/, $custom_data);
	($incl_subs, $inclcats) = split (/::/, $custom_ditems[3]);
	}


if (($customaform ne "") and ($inclcats ne ""))
	{
		$ccount = 0;
		@cids = split (/,/,$inclcats);
			foreach $cid (@cids)
				{
				if (int($cid) > 0)
					{
					$ccount++;
					$sqlstr = $sqlstr . " (cid = '$cid') OR";
					}
				}
			chop ($sqlstr); chop($sqlstr);
	
		if ($incl_subs ne "Y")
			{
			$category_sql = "SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ($sqlstr) ORDER BY level";
			}
			else
			{
					$sth = $dbh->prepare("SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ($sqlstr) ORDER BY level");
					$sth->execute;
					$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
					while ( @row = $sth->fetchrow() )
						{
								
								$lvc=0;
								for ($ms = 2; $ms < 18; $ms++) 
										{
										if ($row[$ms] ne "")
											{
												$lvc++;
												if ($lvc == 1) { $sql_crit = $sql_crit . "("; }
												$sql_crit = $sql_crit . " (l" . $lvc . " = '$row[$ms]') AND"
											}
									} 

						$sql_crit = substr($sql_crit, 0, length($sql_crit) - 3);
						$sql_crit = $sql_crit . ") OR ";
						}
				
				$sql_crit = substr($sql_crit, 0, length($sql_crit) - 3);
				
			$category_sql = "SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND $sql_crit ORDER BY level";
			}
	
	
	}
	else ### if not custom add url form
	{
	$category_sql = "SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND (level = '1') ORDER BY shortname ASC";
	}



### GET CATEGORIES

$sth = $dbh->prepare($category_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
$rows = $sth->rows(); 


$hcount = 0;
while ( @row = $sth->fetchrow() )
	{
	
	for ($ms = 2; $ms < 19; $ms++) 
		{
		$row[$ms] =~ s/\t//gi; $row[$ms] =~ s/\n//gi;
		}
	
	$dirstring = "";
	if ($row[2] ne "") {$dirstring = $row[2];}
	if ($row[3] ne "") {$dirstring = $dirstring . "/$row[3]";}
	if ($row[4] ne "") {$dirstring = $dirstring . "/$row[4]";}
	if ($row[5] ne "") {$dirstring = $dirstring . "/$row[5]";}
	if ($row[6] ne "") {$dirstring = $dirstring . "/$row[6]";}
	if ($row[7] ne "") {$dirstring = $dirstring . "/$row[7]";}
	if ($row[8] ne "") {$dirstring = $dirstring . "/$row[8]";}
	if ($row[9] ne "") {$dirstring = $dirstring . "/$row[9]";}
	if ($row[10] ne "") {$dirstring = $dirstring . "/$row[10]";}
	if ($row[11] ne "") {$dirstring = $dirstring . "/$row[11]";}
	if ($row[12] ne "") {$dirstring = $dirstring . "/$row[12]";}
	if ($row[13] ne "") {$dirstring = $dirstring . "/$row[13]";}
	if ($row[14] ne "") {$dirstring = $dirstring . "/$row[14]";}
	if ($row[15] ne "") {$dirstring = $dirstring . "/$row[15]";}
	if ($row[16] ne "") {$dirstring = $dirstring . "/$row[16]";}
	if ($row[17] ne "") {$dirstring = $dirstring . "/$row[17]";}

		#if (($row[22] ne "H") and ($row[22] ne "Y"))
		#{
		
			$part_of_hidden = "false";
			foreach $hitem (@hcats)
				{
				$matchcrit = substr($dirstring, 0, length($hitem)) . "/";
				
					if ($matchcrit eq "$hitem/")
					{
					$part_of_hidden = "true";
					}
				
				#print "--> $hitem/ | $matchcrit = $part_of_hidden<BR>\n";
				}
			
			
			if ($part_of_hidden eq "false")
				{
				$atree[$acnt] = $dirstring . "\t" . 
									 $row[0] . "\t" .  	#### CID
									 $row[1] . "\t" .  	#### LEVEL
									 $row[28]; 			 	#### NAME
				$acnt++;
				}
			
		#}
		#elsif ($row[22] eq "H")
		#{
		#$hcats[$hcount] = $dirstring;
		#$hcount++;
		#}
	

	if ($row[1] == 1) { $total_links = $total_links + $row[20]; }
	
	}

#########

$etext = pseek::get_file_contents("$data_dir/addurl2.txt"); 
@texts = split (/\n/, $etext);

if ($texts[18] eq "")
	{
	$catsel_text = "Please Select a Category";
	}
	else
	{
	$catsel_text = $texts[18];
	}
	

#########

$dropdownb = qq[<SCRIPT LANGUAGE="JavaScript">

var dropdownstat = 0;
var lastdropdown = 0;

function xmlhttpPost(resc, display_area, ajcatname, currlv)
	 {

    var xmlHttpReq = false;
    var self = this;
    
    var i=0; currlv++;
	 for (i=currlv;i<17;i++)
	 {
	 	var resname = 'result' + i;
	 	document.getElementById(resname).innerHTML = "";
	 }

	//if (document.getElementById(ajcatname).value != '')
	//{
	 
	 document.getElementById('AJImg').style.display='block';
    strURL = '$script_url/adrldropd.cgi?s=' + resc + '&cid=' + document.getElementById(ajcatname).value + '&' +  parseInt(Math.random()*10000);
  
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
	
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function() 
    	   {
         if (self.xmlHttpReq.readyState == 4) 
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText; 
         		document.getElementById('AJImg').style.display='none';
         		
         				var catloc = ''; var catob = '';
						 	for (i=2;i<17;i++)
						 	{
						 		catob = document.getElementById('cat'+i);
						 			if (catob)
						 			{ 	
						 			 if (catob.options[catob.selectedIndex].value != '') {catloc = catloc + " :: " + catob.options[catob.selectedIndex].text;}
						 			}
	 						}
	 						
	 						var firstcat = document.getElementById('category_dropdown1'); 
	 						
	 						if (firstcat.options[firstcat.selectedIndex].value != '')
	 							{
	 							var firstname = firstcat.options[firstcat.selectedIndex].text;
	 							document.getElementById('cindicator').innerHTML = firstname + catloc;
	 							}
	 							else
	 							{
	 							document.getElementById('cindicator').innerHTML = '';
	 							}
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
    
    //}
    
}

function checkval(aabox)
	{
		
		if (document.getElementById(aabox).value == '')
		{
		return false;
		}
	
	}
</script>

<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td width="1%">
<select name="category_dropdown1" id="category_dropdown1" onchange="xmlhttpPost('2', 'result2', 'category_dropdown1', '1');">\
<option value="">$catsel_text</option>
];

foreach $item (@atree)
	{
	($dirstr, $cid2, $level, $name) = split (/\t/, $item);

	$spacing = "";
	for ($ms = 0; $ms < ($level + 1); $ms++) 
			{
			$spacing = $spacing . "&nbsp; &nbsp; ";
			}

	if ($cid2 eq $cid)
		{
		$dropdownb = $dropdownb . qq[<option selected value="$cid2">$dirstr</option>];
		}
		else
		{
		$dropdownb = $dropdownb . qq[<option value="$cid2">$dirstr</option>];
		}
	
	}

$dropdownb = $dropdownb . qq[
</select>
</td><td><img src="$web_url/ajload3.gif" id="AJImg" style="display: none;"></td></tr></table>
<span id="result2"></span><span id="result3"></span><span id="result4"></span><span id="result5"></span>
<span id="result6"></span><span id="result7"></span><span id="result8"></span><span id="result9"></span>
<span id="result10"></span><span id="result11"></span><span id="result12"></span><span id="result13"></span>
<span id="result14"></span><span id="result15"></span><span id="result16"></span>
];

########

$sth->finish;
$dbh->disconnect;


$catind = qq[<span id="cindicator"></span>];

$addurl_template =~ s/!!category_indicator!!/$catind/g;

$addurl_template =~ s/%%category_dropdown_ajax%%/$dropdownb/g;

}







sub remove_keyvalues
{
my ($rttemplate) = @_;

$rttemplate =~ s/!!error_text!!//gi;

$rttemplate =~ s/!!title!!//gi;
$rttemplate =~ s/!!description!!//gi;
$rttemplate =~ s/!!keywords!!//gi;
$rttemplate =~ s/!!url!!/http:\/\//gi;
$rttemplate =~ s/!!csuggestion!!//gi;

$rttemplate =~ s/!!password1!!//gi;
$rttemplate =~ s/!!password2!!//gi;

$rttemplate =~ s/!!sname!!//gi;
$rttemplate =~ s/!!email!!//gi;

$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);

	foreach $cefield (@akeys)
		{
		($keyname, $visible, $size, $searched, $description_key, $na, $imagef, $numberfield, $req) = split (/\t/, $cefield); 
		$keyvar = "!!" . $keyname . "!!"; 

			if ($numberfield ne "Upload")
			{
			$rttemplate =~ s/$keyvar//gi;
			}
		}
 
 return ($rttemplate);
}











sub get_setup
{

$exists = (-e "$config_cgi") or die ("Unable to open $config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

