#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "add_comment") {&add_comment;}



##################################################################################

sub add_comment
{

$lnkid = $q->param('lnkid');

$name = $q->param('name'); 
$email = $q->param('email');
$revcom = $q->param('revcom');

if ($name eq "") { acs::problem_popup("You have to specify a name."); }
if ($revcom eq "") { acs::problem_popup("You have to specify a review/comment."); }

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }



$wsql = "SELECT cid FROM links WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
while ( @row = $sth->fetchrow() ) { $cid = $row[0]; }

$time = time();

		for ($ms = 1; $ms < 11; $ms++) 
			{
			$fname = "E" . $ms;
			
			if ($q->param($fname) ne "") 
				{
				$revcom = $revcom . "o-o:o-o" .  $q->param($fname);
				}
			
			}

$name = $dbh->quote($name);
$email = $dbh->quote($email);
$revcom = $dbh->quote($revcom);

$wsql = "INSERT INTO reviews SET cid = '$cid', lnkid = '$lnkid', rname = $name, remail = $email, review = $revcom, approved = 'Y', date = '$time' ";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}


$wsql = "UPDATE links SET rev_no = (rev_no + 1) WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}


$sth->finish;
$dbh->disconnect;

$boxdiz = qq[<a href="$admin_url/admin15.cgi?lnkid=$lnkid">Click Here to Continue</a>];
$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Reviews/Comment Added", $boxdiz);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];


}



sub start
{

$lnkid = $q->param('lnkid');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$wsql = "SELECT * FROM links WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}

while ( @row = $sth->fetchrow() )
	{
	$title = $row[2];
	$diz = $row[3];
	$url = $row[5];
	}

$sql = "SELECT * FROM reviews WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr - From: $sql"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();

$icnt = 0;

$ldata = &get_file_contents("$data_dir/keyscom.dat"); 
@allditems = split (/\n/, $ldata);

while ( @row = $sth->fetchrow() )
	{
	$CHKname = "C" . $icnt;
	$CHKvalue = "$row[0]-$row[2]-0";
	$CHKall = $CHKall . "'$CHKname',";
	
	$row[5] =~ s/\n/<BR>/gi;
	
	###########
	
	$all_extra = $row[5];
	my @extra_items = split (/o-o:o-o/, $all_extra);
	
	$comdisplay = $extra_items[0];
	
	$fillboxes = "";
	$extcnt = 1;
	foreach $item (@allditems)
		{
		($ename, $echar, $ereq) = split (/\t/, $item);
			
			if ($ename ne "")
				{
				$extrafielddisp = $extra_items[$extcnt]; $extrafielddisp =~ s/\n/<BR>/g;
				$comdisplay = $comdisplay . "<BR><BR><b>$ename</b>: " . $extrafielddisp;
				}
		
		$extcnt++;
		}
	
$revs = $revs . qq[
<table border="0" cellspacing="1" width="100%" cellpadding="6"
style="border: 1px solid rgb(216,216,216)">
  <tr>
    <td width="100%" colspan="2" valign="top" background="$web_url/bar6.gif" class="normaltext">By: <strong>$row[3] | </strong>Email: <strong>$row[4]
    </strong> | Approved: <strong>$row[6] </strong></td>
  </tr>
  <tr>
    <td width="1%" valign="top" class="normaltext"><input type="checkbox" name="$CHKname" value="$CHKvalue"> </td>
    <td width="99%" class="normaltext">$comdisplay </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
];


	$icnt++;
	}


$CHKall = substr($CHKall, 0, length($CHKall) - 1);

$bdiz = qq[<b><a href="$url" target="_blank">$title</a></b><BR>
$diz<BR>
<b><i>Number of Reviews: $rows</b></i>
];

$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Reviews/Comments For:", $bdiz);


	$ecnt = 1;
	foreach $item (@allditems)
		{
		($ename, $echar, $ereq) = split (/\t/, $item);

		if ($ename ne "")
			{
			$extname = "E" . $ecnt;
				
				if ($echar > 255) 
					{
					$fillboxes = $fillboxes . qq[
					<tr>
		      		<td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>$ename:</strong></td>
		      		<td bgcolor="#FFFFFF" class="normaltext"><textarea name="$extname" cols="50" rows="10"  style="width:100%"></textarea></td>
			   	</tr>
					];					
					}
					else
					{
					$fillboxes = $fillboxes . qq[
					<tr>
		      		<td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>$ename:</strong></td>
		      		<td bgcolor="#FFFFFF" class="normaltext"><input name="$extname" type="text" size="50"  style="width:100%"></td>
			   	</tr>
					];
					}
			}
					
		$ecnt++;
		}


$jser = acs::get_js_errors;

$jspopup_code = acs::get_popupjs; 

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE

$jser

<script LANGUAGE="JavaScript">
<!-- Hide
function checkall(formname,thestate)
	{
	BoxNames=new Array($CHKall);
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}


function submitf()
	{
	var bsel = '';
	for (c=0;c < $icnt; c++)
		{
		var cboxname = select_all.elements['C' + c];
		if (cboxname.checked)
			{
			bsel = cboxname.value;
			}
		}
	if (bsel == '') { alert ('You have to select at least one Comment/Review.'); return false;}
	}

$jspopup_code
	
// End Hide -->
</script>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>

<form method="POST" action="$admin_url/admin14.cgi" name="select_all" style="margin-bottom:0; margin-top:0;" onSubmit="return submitf();">
 <input type="hidden" name="enr" value="$icnt">
 <input type="hidden" name="fct" value="ropps">
 <input type="hidden" name="notnew" value="true">

$hbox
$revs

<table width="100%%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="20%" height="30"><select name="faction" size="1">
      <option value="Edit">Edit</option>
      <option value="Delete2">Delete</option>
    </select>
    <input type="submit" class="psbutton" value="   Go   " name="B1"></td>
    <td width="80%"><span class="normaltext"><a href="javascript:checkall('select_all',true)" class="bordtext">Check All</a> <a href="javascript:checkall('select_all',false)" class="bordtext">UnCheck All</a></span></td>
  </tr>
</table>
</form>


<form name="form1" method="post" action="$admin_url/admin15.cgi" onSubmit="return check_errors_blank('name::You have to specify the name of the person posting the comment::revcom::You have to specify a comment/review');" >
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DFDFDF">
    <tr>
      <td width="100%" colspan="2" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Add a New Review/Comment: </strong></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><label>
        <input name="name" type="text" id="name" size="50" style="width:99%">
      </label></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="email" type="text" id="email" size="50" style="width:99%"></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Review/Comment:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <textarea name="revcom" cols="50" rows="10" id="revcom" style="width:99%"></textarea>
      </label></td>
    </tr>
    $fillboxes
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <input type="submit" class="psbutton" name="Submit" value="Add New Review/Comment">
      </label>
      <input name="fct" type="hidden" id="fct" value="add_comment">
      <input name="lnkid" type="hidden" id="lnkid" value="$lnkid">
      </td>
    </tr>
  </table>
  <table width="100%" border="0" cellpadding="0" cellspacing="0" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
<span class="normaltext"><span class="bordtext">Also See:  <a href="$admin_url/p_comment.cgi" onclick="popup('$admin_url/p_comment.cgi',900,700);return false;"><b>Comment/Review Editor</b></a></span></span>
<BR><BR>
  </form>
</body>
</html>
];


$sth->finish;
$dbh->disconnect;


}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

