#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use DBI;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use acs;
use File::Path;


&get_setup;
$q = CGI->new;

$default_permissions = 0777;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));
$gsettings = new_gsettings acs;

$pages_prev = "5";
$pages_next = "5";


##################################################################################

if (($q->param('fct') eq "") and ($q->param('lv') eq "")) 
	{
	acs::extend_login;
	}
	else
	{
	print "Content-type: text/html\n\n";
	}

if ($q->param('fct') eq "") {&redirect;}
if ($q->param('fct') eq "addir") {&addir;}
if ($q->param('fct') eq "add_dir_final") {&add_dir_final;}
if ($q->param('fct') eq "edit_dir") {&edit_dir;}
if ($q->param('fct') eq "edit_dir_final") {&edit_dir_final;}
if ($q->param('fct') eq "delete_dir") {&delete_dir;}
if ($q->param('fct') eq "delete_dir_final") {&delete_dir_final;}
if ($q->param('fct') eq "addir_m") {&addir_m;}
if ($q->param('fct') eq "add_mdirs_final") {&add_mdirs_final;}
if ($q->param('fct') eq "delete_proc") {&delete_proc;}

if ($q->param('fct') eq "get_left_frame") {&get_left_frame;}
if ($q->param('fct') eq "get_top_frame") {&get_top_frame;}



##################################################################################

sub redirect
{

$lv = $q->param('lv');
$ct = $q->param('ct');
$cid = $q->param('cid');
$rid = $q->param('rid');

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title></title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin84.cgi?lv=$lv&ct=$ct&cid=$cid&rid=$rid">
$HTML_ENCODING_USE
</head>
<body>
</body>
</html>
];

}





sub add_mdirs_final
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');
$mdirs = $q->param('mdirs');
$mdirs =~ s/_/ /g;

########### CHECK MAX 20

#$dir_str_cnt = 0;
#@alldirs1 = split (/\n/, $mdirs);
#foreach $item (@alldirs1)
#	{
#	$item =~ s/\\//g;
#	$mdirs2 = $mdirs2 . $item . "\n";
#	$dir_str_cnt++;
#	}
#$mdirs = $mdirs2;
#
#if ($dir_str_cnt > 20) { acs::problem_popup("You can only add 20 directories at a time."); exit;}

###########




if ($mdirs eq ""){acs::problem_popup("You have to supply at least 1 directory name.");}

acs::htmlencode2();

#### CHECK FOR DUPLICATES

#### RETRIEVE EXISTING DIRS
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($lv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') ORDER BY shortname ASC");
	}
	else
	{
	$lv++;
	@adir = split (/-/, $ct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $lv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				#$adir[$ms] =~ s/\\//g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	
			#### CHECK IF SOMETHING DID'NT CHANGE
			$cclv = $lv - 1;
			$wsql = "SELECT * FROM dirs WHERE (level = '$cclv') and $querystr";
			$sth = $dbh->prepare($wsql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
			$rows = $sth->rows();
			
			#print "SELECT * FROM dirs WHERE (level = '$cclv') and $querystr";
			if ($rows < 1)
				{
				acs::problem_popup("The category/directory to which you are trying to add categories/directories to, changed - unable to save the changes. Close this window, refresh it's parent and try again.");
				$sth->finish;
				$dbh->disconnect;
				}
			######################################

	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$lv') and $querystr ORDER BY shortname ASC");
	}

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows();


####

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$existing_dirs[$smc] = $row[28];
	$smc++;
	}


##### PREPARE NEW DIR NAMES
	
$blcn = 0;
@alldirs1 = split (/\n/, $mdirs);
$ncnt = 0;
foreach $item (@alldirs1)
	{
	$item =~ s/\n//g; 
	$mcrit = chr(10); $item =~ s/$mcrit//g;
	$mcrit = chr(13); $item =~ s/$mcrit//g;
	$item = acs::remove_leading_spacing($item);

	foreach $added_dir (@alldirs)
		{
		if (lc($item) eq lc($added_dir)){$item = "";}
		}

	if ($item ne "")
		{
		$alldirs[$ncnt] = $item;
		$ncnt++;
		}
	}

######################


foreach $edir (@existing_dirs)
	{

	foreach $ndir (@alldirs)
		{
		
		#####
		if (lc($ndir) eq lc($edir))
			{
			$duplicate_found = "true";
			$dupdirs[$blcn] = "$ndir";
			$blcn++;
			}
		#####
			
		}

	}


if ($duplicate_found eq "true")
	{
	&duplicate_found_error;	exit;
	}


#### ADD DIRECTORIES

 ### BUILD QUERY
 if ($lv eq "") { $lv = 1; } 
 $sql = "INSERT INTO dirs SET level = '$lv', linknrs = '0',";
 
	$iic = 1;
	@ditems = split (/-/, $ct);
	foreach $item (@ditems)
		{
		
		$item = acs::decode_dir($item);
		$item =~ s/'/\\'/g;
		#$item =~ s/\\//g;
		$cname = "l" . $iic;
		
		$sql = $sql . " $cname = '$item',";
		$iic++;
		}

		for ($ms = ($iic + 1); $ms < 17; $ms++) 
			{
			$cname = "l" . $ms;
			$sql = $sql . "$cname = '', ";
			}

$last_cname = "l" . $iic;

foreach $item (@alldirs)
{
$item =~ s/'/\\'/g;

$querystr = "$sql $last_cname = '$item', shortname = '$item'";

#print "==> $querystr <br><br><br>";

$sth = $dbh->prepare("$querystr");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $querystr";}


$sth = $dbh->prepare("SELECT cid FROM dirs WHERE cid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ) {$last_ids = $last_ids . $row[0] . ":\n"; }  

}

$sth->finish;
$dbh->disconnect;


if ($cid eq "")
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE $last_ids;
	close (CFILE);
	}
	else
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$cid" . ":F\n";
		print CFILE $last_ids;
	close (CFILE);
	}




############
if ($lv != 0){ $lv = $lv - 1; }

$boxdiz = qq[You may <a href="javascript:onClick=window.close()"><b>close</b></a> this window.];

$hbox = acs::get_heading_box("$web_url/add.gif", "Categories/Directories Created", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Add New Directories</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>
];


}





#######

sub duplicate_found_error
{

foreach $item (@dupdirs)
	{
	$dupdirs = $dupdirs . "<li>$item</li>";
	}

foreach $edir (@alldirs)
	{
	$toad_dirs = $toad_dirs . $edir . "\n";
	}

if ($ct ne "")
	{
	$location = acs::decode_complete_dir($ct);
	}
	else
	{
	$location = "Root ";
	}

if ($lv != 0) { $lv = $lv - 1; }


$boxdiz = qq[<font color="#FF0000"><b>
<p>Problem:</b></font> No categories/directories added because the following
categories/directories already exists:</p>
<blockquote>
  <p><strong>$dupdirs</strong></p>
</blockquote>
<p>Please remove the duplicates from the box below and try again.</p>
];

$hbox = acs::get_heading_box("$web_url/add.gif", "Add Multiple Categories/Directories", $boxdiz);



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Add New Directories</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
<form method="POST" action="$admin_url/admin2.cgi">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr>
      <td height="30" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Enter Category/Directory Names on an empty line:</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="31" name="mdirs" cols="60"
      style="width:100%">$toad_dirs</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">
        <input type="submit" class="psbutton"
      value="Add Categories/Directories" name="B2">
        <input type="hidden" name="ct" value="$ct">
        <input type="hidden" name="fct" value="add_mdirs_final">
        <input type="hidden" name="lv" value="$lv">
        <input type="hidden"
  name="cid" value="$cid">
</font></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </form>
</body>
</html>
];


}






sub addir_m
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');

if ($ct ne "")
	{
	$location = acs::decode_complete_dir($ct);
	}
	else
	{
	$location = "Root ";
	}


$hbox = acs::get_heading_box("$web_url/add.gif", "Add Multiple Categories/Directories", "Add New Categories/Directories To: <b>$location</b>");

$jser = acs::get_js_errors;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Add a New Directories</title>
$jser
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
<form method="POST" action="$admin_url/admin2.cgi" onSubmit="return check_errors_blank('mdirs::You have to provide at least one category.');">
$hbox
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr>
      <td height="30" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Enter One Category/Directory on an empty line: (One category 'per line')</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="28" name="mdirs" cols="60"
      style="width:99%" id="mdirs"></textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">
        <input type="submit" class="psbutton"
      value="Add Categories/Directories" name="B2">
        <input type="hidden" name="ct" value="$ct">
        <input type="hidden" name="fct" value="add_mdirs_final">
        <input type="hidden" name="lv" value="$lv">
        <input type="hidden"
  name="cid" value="$cid">
</font></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </form>
</body>
</html>
];


}





sub delete_dir_final
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');
$crossl = $q->param('crossl');
$prev_cid = $q->param('prev_cid');


##### GET FIRST DIRECTORY IN DIRECTORY SEQUENCE

@adirs = split (/-/, $ct);

$lcntr = 1;
foreach $item (@adirs)
	{
	$item = acs::decode_dir($item);
	$item =~ s/'/\\'/g;

	$fname = "l" . $lcntr;
	$qstring = $qstring  . " ($fname = '$item') and";
	$lcntr++;
	}
	$qstring = substr($qstring, 0, length($qstring) - 3);


##########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


###### GET DIR IDS WHERE LINKS SHOULD BE DELETED

$lvname = "l" . $lv;
$wsql = "SELECT cid FROM dirs WHERE $qstring ORDER BY cid DESC";

$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

$rows = $sth->rows();
if ($rows < 1) 
		{
		$sth->finish;
		$dbh->disconnect;
		acs::problem_popup("The category/directory you are trying to delete does not exist anymore. Close this window, refresh it's parent and try again.");
		}

$cidline_count = 5; $ncount = 1;
while ( @row = $sth->fetchrow() )
	{
	$link_del_sql = $link_del_sql . " (cid = '$row[0]') or";
	

		if ($ncount < $cidline_count)
		{
		$cids_to_del = $cids_to_del . $row[0] . ":";
		}
		else
		{
		$cids_to_del = $cids_to_del . $row[0] . "\n";
		$ncount = 0;
		}
	
	$ncount++;
	
	$normall = $normall . $row[0] . " - ";
	}

$link_del_sql = substr($link_del_sql, 0, length($link_del_sql) - 2);


###### CHECK IF NEW SUBMISSION PRESENT

if (($q->param('newsub_del') ne "newsub_del") and ($crossl ne "true"))
{

	$newsubm_sql = "SELECT title, description, url FROM links WHERE ($link_del_sql) AND (newsubm = 'Y')";
	$sth = $dbh->prepare($newsubm_sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	$rows = $sth->rows();

	if ($rows > 0)
		{
		$newsubm = "";
			while ( @row = $sth->fetchrow() )
			{
			$newsubm = $newsubm . "<a href=\"$row[2]\" target=\"_blank\"><b>$row[0]</a></b><BR>";
			$newsubm = $newsubm . "$row[1]<BR>";
			$newsubm = $newsubm . "<b>$row[2]</b><BR><br>";
			}


$boxdiz = qq[
<form method="POST" action="$admin_url/admin2.cgi">
  <input type="hidden" name="cid" value="$cid"><input type="hidden" name="ct" value="$ct"><input
  type="hidden" name="fct" value="delete_dir_final"><input type="hidden" name="lv"
  value="$lv"><input type="hidden" name="rid" value="$rid"><input type="hidden" name="rid"
  value="$rid"><input type="hidden" name="crossl" value="$crossl"><input type="hidden"
  name="newsub_del" value="newsub_del"><p>The following new submissions has been found in a
  directory that will be deleted. These new submissions will also be deleted:</p>
  <blockquote>
    <p>$newsubm</p>
  </blockquote>
  <p>You can move or approve the above new submissions by going to the new submissions
  approval area.</p>
  <p><strong>Are you sure? <input type="submit" class="psbutton" value="    Yes    " name="B1"> </strong>
  <input type="submit" class="psbutton" value="    No    " name="B2" onclick="window.close(); return false;"></p>
</form>
];

$hbox = acs::get_heading_box("$web_url/ic_exclamation.gif", "Delete Directory/Category", $boxdiz);



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Delete Directory</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

	exit;		
	}
}


### FIND OUT HOW MANY LINKS WILL BE DELETED
$wsql = "SELECT COUNT(*) FROM links WHERE $link_del_sql";
$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	while ( @row = $sth->fetchrow() )
		{
		$total_links_to_delete = $row[0];
		}


#### CREATE TEMP DIR WHERE WE WILL STORE TEMP DATA
$temp_dir = "$data_dir/tmp";
if ((-e $temp_dir) < 1) {
mkdir ($temp_dir, $default_permissions);
chmod($default_permissions,"$temp_dir","$temp_dir"); }

$tmpfname = "$data_dir/tmp/$cid" . ".del";
open (TMPD, "> $tmpfname");
	print TMPD $cids_to_del;
close (TMPD);



$sth->finish;
$dbh->disconnect;



###### UPDATE LINK NUMBERS

if ($crossl ne "true")
{

@rits = split (/-/, $rid);
$nrdirs = @rits; $nrdirs = $nrdirs - 1;

$rits[$nrdirs] = "";

foreach $item (@rits)
	{
	if ($item ne "")
		{
		$new_rid = $new_rid . $item . "-";
		}
	}
	
chop($new_rid);

if ($new_rid ne "")
	{
	acs::update_numbers("-", $total_links_to_delete, $new_rid);
	}
}


#### RECORD CHANGES SO THAT WE CAN GENERATE ONLY CHANGES WHEN GENERATING HTML FILES

if ($prev_cid ne "")
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$prev_cid" . ":LEVEL_WHOLE\n";
	close (CFILE);
	}



### SET UP DELETION

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Deleting Categories/Directories & Listings. Please Wait...", qq[<img src="$web_url/working.gif" width="270" height="36">]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Delete</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin2.cgi?fct=delete_proc&amp;cid=$cid&amp;totlinks=$total_links_to_delete">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox

</body>
</html>

];


}






sub delete_proc
{

$cid = $q->param('cid');
$cpos = $q->param('cpos'); if ($cpos eq "") { $cpos = 0; }
$total = $q->param('total');
$newpos = $cpos + 1;

$totlinks = $q->param('totlinks');

$linecounter = 0;

$tmpfname = "$data_dir/tmp/$cid" . ".del";	
open (STP, "$tmpfname");
 while (defined($line=<STP>))
  {

	if ($linecounter == $cpos)
		{
		$currentdels = $line;
		$currentposition = $linecounter;
		}

	$linecounter++;
  }
close (STP);


if ($cpos == 0) { $total = $linecounter; }



#### IF FINISHED

	if ($currentdels eq "") 
	{
	$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Category/Directory Deleted.", qq[You may <strong><a href="javascript:onClick=window.close()">close</a></strong> this window.]);

	print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<title>Delete Directory</title>
	$HTML_ENCODING_USE
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
	</head>
	<body onUnload="opener.location.reload(true);">
	$hbox
	</body>
	</html>
	];

	unlink ("$tmpfname");
	exit;
	}


@sitems = split (/:/,$currentdels);

	foreach $item (@sitems)
		{
		$sqlq = $sqlq . "(cid = '$item') OR ";
		$crosslink_delete = $crosslink_delete  . " OR (crosslinkid = '$item') ";
			if ((-e "$web_dir/imagefiles/cimage/$item.gif") > 0) { unlink ("$web_dir/imagefiles/cimage/$item.gif"); }
			if ((-e "$web_dir/imagefiles/cimage/$item.jpg") > 0) { unlink ("$web_dir/imagefiles/cimage/$item.jpg"); }
		}
		$sqlq = substr($sqlq, 0, length($sqlq) - 3);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### IF THERE ARE IMAGES THAT NEEDS TO BE DELETED

	$wsql_img = "SELECT lnkid, image FROM links WHERE $sqlq";
	$sth = $dbh->prepare($wsql_img);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql_img";}
	$rows = $sth->rows();
		while ( @row = $sth->fetchrow() )
			{
			unlink ("$web_dir/imagefiles/" . $row[0] . "." . $row[1]);
			if ((-e "$web_dir/imagefiles/$row[0]") > 0)
					{
					rmtree("$web_dir/imagefiles/$row[0]");
					}
			}

	$wsql = "DELETE FROM links WHERE $sqlq";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	$rows = $sth->rows();

	$wsql2 = "DELETE FROM dirs WHERE $sqlq $crosslink_delete";
	$sth = $dbh->prepare($wsql2);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	$rows = $sth->rows();

$sth->finish;
$dbh->disconnect;


	$perc = $currentposition / $total * 100;
	$perc = sprintf("%5.2f",$perc); 
	$perc = $perc . "%";

#$totlinks

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Deleting Categories/Directories & Links. Please Wait...", qq[Deleting $totlinks Links. Deleting $currentposition of $total Categories/Directories]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Delete</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin2.cgi?fct=delete_proc&amp;cid=$cid&amp;cpos=$newpos&amp;total=$total&totlinks=$totlinks">
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
<table border="0" cellpadding="4" cellspacing="0" width="100%"
style="border: 1px solid rgb(192,192,192)">
  <tr>
    <td width="19%" style="border-right: 1px solid rgb(192,192,192)"><img
    src="$web_url/working.gif" width="270" height="36"></td>
    <td width="19%" style="border-right: 1px solid rgb(192,192,192)"><p align="center"><font
    face="Verdana" size="1">Complete: <strong>$perc</strong></font></td>
    <td width="81%" align="left"><table border="0" cellpadding="6" cellspacing="0"
    width="$perc" height="30">
      <tr>
        <td width="100%" background="$web_url/bar.gif"></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
</body>
</html>
];

}






sub delete_dir
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid'); 
$crossl = $q->param('crossl');
$prev_cid = $q->param('prev_cid');

$location = "Root ";
@dits = split (/-/, $ct);
$dc=0;
foreach $item (@dits)
	{
	$dits[$dc] = acs::decode_dir($item);
	$dc++;
	$location = $location . " > $item";
	}

if ($crossl eq "true")
	{
	$dltext = "This category/directory is a crosslink. This action will only remove the crosslink.<br>";
	}
	else
	{
	$dltext = "All sub categories/directories with their links will be lost.";
	}


$boxdiz = qq[
<form method="POST" action="$admin_url/admin2.cgi">
  <input type="hidden" name="cid" value="$cid"><input type="hidden" name="ct" value="$ct"><input
  type="hidden" name="fct" value="delete_dir_final"><input type="hidden" name="lv"
  value="$lv"><input type="hidden" name="rid" value="$rid"><input type="hidden" name="rid"
  value="$rid"><input type="hidden" name="crossl" value="$crossl">
  <input type="hidden" name="prev_cid" value="$prev_cid"><p>$dltext <strong>Are you sure? 
  <BR><BR><input type="submit" class="psbutton" value="    Yes    " name="B1">
  <input type="submit" class="psbutton" value="    No    " name="B2" onclick="window.close(); return false;"></p>
</form>
];

$hbox = acs::get_heading_box("$web_url/ic_exclamation.gif", "Delete Directory/Category", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Delete Directory</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];


}






sub edit_dir_final
{

###### ERROR CHECKING
if ($q->param('directory_name') eq "") {acs::problem_popup("You have to specify a name for the directory/category.");}
######################

$ct =  $q->param('ct');
$lv =  $q->param('lv');
$cid = $q->param('cid');

$cat_title = $q->param('cat_title');
$cat_title =~ s/'/\\'/g;

$metatag = $q->param('metatag');
$metatag =~ s/'/\\'/g;

$mkeyw = $q->param('mkeyw');
$mkeyw =~ s/'/\\'/g;

$directory_name = $q->param('directory_name');
$directory_name =~ s/_/ /g;
$directory_name = acs::remove_leading_spacing($directory_name);
$directory_name =~ s/'/\\'/g;

@adirs = split (/-/, $ct);
$adnr = @adirs; $adnr = $adnr - 1;

$lcntr = 1;
foreach $item (@adirs)
	{
	$cnt = $lcntr - 1;
	$adirs[$cnt] =~ s/'/\\'/g;
	
	$item2 = acs::decode_dir($item);
	$item2 =~ s/'/\\'/g;
	
	$fname = "l" . $lcntr;
	$qstring = $qstring  . " ($fname = '$item2') and";
	
	if ($lcntr != ($adnr + 1)){$qstring2 = $qstring2  . " ($fname = '$item2') and";}
	
	$lcntr++;
	}
	$qstring = substr($qstring, 0, length($qstring) - 3);
	$qstring2 = substr($qstring2, 0, length($qstring2) - 3);

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


###### CHECK DUPLICATES 

$psn = acs::decode_dir($adirs[$adnr]);
$psn =~ s/'/\\'/g;


if ($psn ne $directory_name)
	{
	$qstring2 = $qstring2 . " and (l" . ($lcntr -1) . " = '$directory_name')";
	
	if ($lv == 1) {$qstring2 =~ s/AND/ /gi;}
	
	$wsql = "SELECT shortname FROM dirs where $qstring2";
	
	
	$sth = $dbh->prepare($wsql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From :$wsql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	
	$rows = $sth->rows();
	
	if ($rows > 0){acs::problem_popup("The directory name you specified would create a duplicate.");}
	}



### IF THERE IS RELATED CATEGORIES ASSOCIATED WITH THIS CATEGORY - CHECK IF THEY EXIST

$related_categories = $q->param('related_categories');
$related_categories =~ s/ //g;
if ($related_categories ne "")
{

$related_dirs_sql = "SELECT cid FROM dirs WHERE ";

@rel_items = split (/,/, $related_categories);

foreach $item (@rel_items)
	{
	$item =~ s/ //g;
	$related_dirs_sql = $related_dirs_sql . " (cid = '$item') OR";
	}

$related_dirs_sql = substr($related_dirs_sql, 0, length($related_dirs_sql) - 2);

$sth = $dbh->prepare($related_dirs_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $related_dirs_sql";}
$rows = $sth->rows();

$rc_no = @rel_items;

if ($rc_no != $rows)
	{
	acs::problem_popup("One of the category ID's entered as a 'related category' doesn't exist.");
	}

}


###### ERROR CHECKING
#print "SELECT cid FROM dirs WHERE (lv = '$lv') AND ($qstring)";

$wsql = "SELECT cid FROM dirs WHERE (level = '$lv') AND ($qstring)";
$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

$rows = $sth->rows();
#print "===> $rows <Br><br>";
if ($rows < 1) 
	{
	acs::problem_popup("The category/directory you are trying to save changed - unable to save the changes.
	<a href=\"javascript:onClick=window.close()\">Close</a> this window, refresh it's parent and try again.");
	$sth->finish;
	$dbh->disconnect;
	}



#### IF SET TO BE HIDDEN THEN UPDATE SUB CATEGORIES TO BE HIDDEN AS WELL
$category_status = $q->param('cat_status');
if ($category_status eq "hidden") 
	{
	$sql_h = "UPDATE dirs SET catlock = 'H' WHERE $qstring";
	$sth = $dbh->prepare($sql_h);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	}
	elsif (($category_status ne "hidden") and ($q->param('hv') eq "H"))
	{
	$sql_h = "UPDATE dirs SET catlock = '' WHERE $qstring";
	$sth = $dbh->prepare($sql_h);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	}




###### UPDATE DIR NAME CHANGES

$lvname = "l" . $lv;

if ($psn ne $directory_name)
	{
	$wsql = "UPDATE dirs SET $lvname = '$directory_name' WHERE $qstring";
	$sth = $dbh->prepare($wsql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	}




if ($category_status eq "locked") { $category_status = "Y"; }
if ($category_status eq "hidden") { $category_status = "H"; }


##### GOOGLEMAPS DETAILS

$googlemap_details = $q->param('priority') . "::" . $q->param('change_freq');


###### UPDATE DIR NAME CHANGES

$ctemplate = $q->param('ctemplate');

$sth = $dbh->prepare("UPDATE dirs SET 
							  shortname = '$directory_name',
							  ext2 = '$cat_title',
							  description = '$metatag',
							  keywords = '$mkeyw',
							  related1 = '$related_categories',
							  catlock = '$category_status', 
							  template = '$ctemplate',
							  ext3 = '$googlemap_details'
							WHERE cid = '$cid'
							");
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


###### IF WE NEED TO UPDATE CUSTOM TEMPLATE FOR PARENT DIRECTORIES

if ($q->param('ctemplate_subs') eq "true")
	{
			@dcats = split(/-/, $ct);
	
			$lvc = 1;
				foreach $item(@dcats)
					{
					$item = acs::decode_dir($item);
					
					$item =~ s/'/\\'/g; 
					$fieldname = "l" . $lvc;
					$where_sql = $where_sql . " ($fieldname = '$item') AND";
					$lvc++;
					}
	
	$where_sql = substr($where_sql, 0, length($where_sql) - 3);
	
	$sql = "UPDATE dirs SET template = '$ctemplate' WHERE $where_sql";	
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	}


### RECORD CHANGES SO THAT PARENT DIRECTORY CAN BE RE-GENERATED IF ONLY CHANGED HTML ARE GOING TO BE GENERATED

$prev_cid = $q->param('prev_cid');


	$sth = $dbh->prepare("SELECT cid FROM dirs WHERE $qstring");
	
	#print "--> SELECT cid FROM dirs WHERE $qstring<BR>";
	
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	
	open (CFILE, ">> $data_dir/changed_cats.dat");
	
	while ( @row = $sth->fetchrow() )
		{
			print CFILE "$row[0]" . ":\n";	
		}
	
	if ($prev_cid ne "") {	print CFILE "$prev_cid" . ":\n";	 }
	close (CFILE);


#### Delete old image if required
if ($q->param('delete_img') ne "")
	{
	$imgd = $q->param('delete_img');
	$imgd =~ s/\///g;
	unlink ("$web_dir/imagefiles/cimage/$imgd");
	}


#### Upload new image if required
if ($q->param('catimage') ne "")
	{
	(@fext) = split (/\./, $q->param('catimage'));
	$fnr = @fext;
	$fextension = $fext[$fnr -1];
	$fextension = lc($fextension);
	
	$ufname = $cid . "." . $fextension;
	$ufname = "$web_dir/imagefiles/cimage/$ufname";
	
		### DO UPLOAD
		$upload_filehandle = $q->param('catimage');
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;
		
	if ($fextension eq "gif") { unlink ("$web_dir/imagefiles/cimage/$cid.jpg"); }
	if ($fextension eq "jpg") { unlink ("$web_dir/imagefiles/cimage/$cid.gif"); }
	}



$sth->finish;
$dbh->disconnect;

#####################

$saved_box = acs::get_heading_box("$web_url/add.gif", "Changes Saved", qq[You may now <a href="javascript:onClick=window.close()">close</a> this window.]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Changes Saved</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body onUnload="opener.location.reload(true);">
$saved_box
</body>
</html>
];


}






sub edit_dir
{

$ct = $q->param('ct');
$lv = $q->param('lv');
$cid = $q->param('cid');
$prev_cid = $q->param('prev_cid');


### BUILD QUERY STRING

@adirs = split (/-/, $ct);

$lcntr = 1;
foreach $item (@adirs)
	{
	$dsite = acs::decode_dir($item);
	$lstring = $lstring . $dsite . " > ";
	
	$dsite =~ s/'/\\'/g;
	$fname = "l" . $lcntr;
	$qstring = $qstring  . " ($fname = '$dsite') and";
	
	$lcntr++;
	}
	$qstring = substr($qstring, 0, length($qstring) - 3);

###

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$wsql = "SELECT shortname, description, keywords, crosslinkid, related1, catlock, ext2, template, ext3 FROM dirs WHERE (level = '$lv') AND $qstring";
$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";} 

$rows = $sth->rows();
if ($rows < 1) 
	{
	acs::problem_popup("The category/directory you are trying to edit, does not exist anymore. 
	<a href=\"javascript:onClick=window.close()\">Close</a> this window, refresh it's parent and try again.");
	$sth->finish;
	$dbh->disconnect;
	}


while ( @row = $sth->fetchrow() )
	{
	$directory_name = $row[0];
	$metatag = $row[1];
	$mkeyw = $row[2];
	$crosslinkid = $row[3];
	$related_categories = $row[4];
	$catlock = $row[5];
	$cat_title = $row[6];
	$hv = $row[5];
	
	$custom_template = $row[7];
	$googlemaps_details = $row[8];
	}


if ($crosslinkid > 0)
	{
	$crosslinkid = "<b>$crosslinkid</b><br>This category is a crosslinked to another category. If you want to remove the crosslink, delete this category.";
	}
	else
	{
	
	### RESOLVE RELATED CATEGORIES IF ANY
	if ($related_categories ne "")
		{
		$sql = "SELECT * FROM dirs WHERE ";
		$related_categories =~ s/ //g;
		@rel_items = split (/,/, $related_categories);
			foreach $ritem (@rel_items)
				{
				$sql = $sql . " (cid = '$ritem') OR";
				}
		$sql = substr($sql, 0, length($sql) - 2);
		
		#print "->$sql <Br>";
		
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

		$related_cats = qq[<span class="normaltext">];
			while ( @row = $sth->fetchrow() )
				{ 
				$cats = "";
				for ($ms = 2; $ms < 18; $ms++) 
					{
					if ($row[$ms] ne "")
						{
						$cats = $cats . $row[$ms] . "/";
						}
					}
				
				$related_cats = $related_cats . "($row[0]) $cats <br>";
				}
		$related_cats = $related_cats . "</span>";
		}


	if ($related_cats ne "")
		{
		$related_cats = acs::get_heading_box("$web_url/add.gif", "Related Directories/Categories", qq[$related_cats]);
		}

	
	#### GET CUSTOM TEMPLATES
	
opendir(DIR,"$data_dir");
	@files = readdir(DIR);
	@files = sort(@files);
	foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 11, 11) eq "-1ctst\.html")
			{
			$cust_tmpl_name = substr($filename, 0, length($filename) - 11);
			
			$selectedv = "";
			if ($custom_template eq $cust_tmpl_name) { $selectedv = "selected"; }
			
			$c_tmpl_options = $c_tmpl_options . qq[<option value="$cust_tmpl_name" $selectedv>$cust_tmpl_name</option>];
			
			}
		} 


	#### GET GOOGLE MAPS DETAILS
	@gdetails = split (/::/, $googlemaps_details);
	
	$priority = $gdetails[0];
	$changefreq = $gdetails[1];
	
	if ($changefreq eq "") { $nothing = "selected"; }
	if ($changefreq eq "always") { $s_always = "selected"; }
	if ($changefreq eq "hourly") { $s_hourly = "selected"; }
	if ($changefreq eq "daily") { $s_daily = "selected"; }
	if ($changefreq eq "weekly") { $s_weekly = "selected"; }
	if ($changefreq eq "monthly") { $s_monthly = "selected"; }
	if ($changefreq eq "never") { $s_never = "selected"; }
	
	####	
	
	if ($catlock eq "Y") { $catlock_yes = "checked"; } 
	elsif ($catlock eq "H") { $hidden_yes = "checked"; } 

	$crosslinkid = "<b>This is not a crosslinked category.</b>";

#<img src="$web_url/est_help.gif" onMouseOver=" tooltip.show('This is the standard rate of the unit / night - eg R650');" onMouseOut="tooltip.hide();">




$no_crosslink = qq[

<tr>
        <td width="226" bgcolor="#FFFFFF" class="normaltext">Page Title: (Optional) 
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This title can be used as the page title when displaying this category to end users.');" onMouseOut="tooltip.hide();">
        </td>
        <td width="1197" bgcolor="#FFFFFF" class="normaltext">
          <input type="text" name="cat_title" size="43"
           maxlength="255" value="$cat_title" style="width:99%"></td>
  </tr>
      <tr>
        <td bgcolor="#FFFFFF" class="normaltext">Meta Description: (Optional) 
        
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This description will be be used as meta tags for search engines - Max 255 Characters.');" onMouseOut="tooltip.hide();">
        
        </td>
        <td bgcolor="#FFFFFF" class="normaltext">
          <input type="text"
          name="metatag" size="43"  value="$metatag" maxlength="255" style="width:99%"></td>
      </tr>
      <tr>
        <td bgcolor="#FFFFFF" class="normaltext">Meta Keywords: (Optional) <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Fill in keywords seperated by commas, descriptive of the category. Max 255 Characters.');" onMouseOut="tooltip.hide();"></td>
        <td bgcolor="#FFFFFF" class="normaltext">
          <input type="text"
          name="mkeyw" size="43"  value="$mkeyw" maxlength="255" style="width:99%"></td>
      </tr>
      <tr>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext">Related Categories/Directories: (Optional) <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Please specify related category IDs in a comma-separated list. For example: 10, 313, 423, 35');" onMouseOut="tooltip.hide();"></td>
        <td bgcolor="#FFFFFF" class="normaltext"><input type="text" name="related_categories" size="43"  value="$related_categories" >
          <strong> [ <a href="$admin_url/admin67.cgi" onclick="popup('$admin_url/admin67.cgi?fct=related',550,600, 700, 100);return false;">Browser (To Assign ID's)</a> ] </strong></td>
      </tr>
      <tr>
        <td bgcolor="#FFFFFF" class="normaltext">Category/Directory Type:</td>
        <td bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="0">
          <tr>
            <td width="33%" class="normaltext"><input type="radio" value="standard" name="cat_status"
         checked>
              <strong>Standard</strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('The category is not locked or hidden to end users.');" onMouseOut="tooltip.hide();"></td>
            <td width="33%" class="normaltext"><input type="radio" value="locked" name="cat_status" $catlock_yes>
            <strong>Locked <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('End users are not able to add links to the category.');" onMouseOut="tooltip.hide();"></strong></td>
            <td width="33%" class="normaltext"><input type="radio" value="hidden" name="cat_status" $hidden_yes>
            <strong>Hidden <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This category will not be displayed to end users. (Note that the sub categories will also be set to be hidden)');" onMouseOut="tooltip.hide();"></strong></td>
          </tr>
        </table>
        </td>
  </tr>
     
      <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Custom Category Template: <img src="$web_url/est_help.gif" style="vertical-align:middle" 
           onMouseOver=" tooltip.show('You can create custom category templates by clicking the <b>Template Manager</b> tab in the Control Panel. Then click on <b>Create or Edit Custom Directory/Category Templates</b>. Custom category templates enables you to give specific categories an original look and feel or target advertisements or specific content at specific categories.');" onMouseOut="tooltip.hide();"></td>
           <td bgcolor="#FFFFFF" class="normaltext"><label>
             <select name="ctemplate" id="ctemplate">
               <option value="">Default</option>
               $c_tmpl_options
             </select>
             
              <input name="ctemplate_subs" type="checkbox" id="ctemplate_subs" value="true">
              <b>Assign this template to all sub categories of this category? [ <a href="" onclick="popup('$admin_url/admin27.cgi',950,600, 300, 100);return false;">Custom Category Templates</a> ] </b></label></td>
     </tr>
     
       <tr>
         <td bgcolor="#FFFFFF" class="normaltext"><p>Google SiteMaps Details:</p></td>
         <td bgcolor="#FFFFFF" class="normaltext"><p>Priority: 
           <label>
             <input name="priority" type="text" size="6" value="$priority">
             (From 0.00 to 1.00) / Change Frequency:
             <select name="change_freq" id="gpriority">
               <option value="" $nothing>Not Available</option>
               <option value="always" $s_always>always</option>
               <option value="hourly" $s_hourly>hourly</option>
               <option value="daily" $s_daily>daily</option>
               <option value="weekly" $s_weekly>weekly</option>
               <option value="monthly" $s_monthly>monthly</option>
               <option value="yearly" $s_yearly>yearly</option>
               <option value="never" $s_never>never</option>
             </select>
           </label>
         </p></td>
     </tr> 


];

	}


### Check if category has image

$upload_dir = "$web_dir/imagefiles";
if ((-e $upload_dir) < 1)
	{
	mkdir ($upload_dir, $default_permissions);
	chmod ($default_permissions, $upload_dir);
	}

$upload_dir2 = "$web_dir/imagefiles/cimage";
if ((-e $upload_dir2) < 1)
	{
	mkdir ($upload_dir2, $default_permissions);
	chmod ($default_permissions, $upload_dir2);
	}

if (-e "$web_dir/imagefiles/cimage/$cid.gif" > 0) { $cimage = qq[<img src="$web_url/imagefiles/cimage/$cid.gif">]; $imgname = "$cid" . ".gif"; }
if (-e "$web_dir/imagefiles/cimage/$cid.jpg" > 0) { $cimage = qq[<img src="$web_url/imagefiles/cimage/$cid.jpg">]; $imgname = "$cid" . ".jpg"; }

if ($cimage ne "")
	{
	$cimage = qq[
	<span id="img_display">
	<table width="100%" border="0" cellspacing="1" cellpadding="6">
	  <tr class="normaltext">
	    <td width="1%">$cimage</td>
	    <td width="99%">( <a href="" onClick="delete_img(); return false;"><strong>Delete Image</strong></a> )</td>
	  </tr>
	</table>
	</span>
	];
	}

#$crosslinkid

$lstring = "Root > " . substr($lstring, 0, length($lstring) - 2); 


$headingd = acs::get_heading_box("$web_url/add.gif", "Edit Category/Directory", qq[<b>Location:</b> $lstring]);
	
$jspopup_code = acs::get_popupjs;

$tooltipst = acs::get_tooltip;

$jser = acs::get_js_errors;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Edit Directory</title>

<script LANGUAGE="JavaScript">
$jspopup_code
</script>

$jser

$tooltipst
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
<form method="POST" action="$admin_url/admin2.cgi" name="addu" onSubmit="return check_errors_blank('directory_name::You have to provide a name for the category/directory');" ENCTYPE="multipart/form-data">
$headingd
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Category/Directory Details:</strong></td>
    </tr>
  <tr>
    <td width="27%" bgcolor="#FFFFFF" class="normaltext">Category/Directory Name:</td>
    <td width="73%" bgcolor="#FFFFFF" class="normaltext">
      <input type="text"
      name="directory_name" size="43" id="directory_name" 
      maxlength="100" value="$directory_name" style="width:99%">    </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext"  valign="top">Crosslink Category/Directory ID:</td>
    <td bgcolor="#FFFFFF" class="normaltext">$crosslinkid</td>
  </tr>
$no_crosslink

  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
    <td bgcolor="#FFFFFF" class="normaltext">
      <input type="submit" class="psbutton"
      value="   Save   " name="B2">
      <input type="hidden" name="ct" value="$ct">
      <input type="hidden" name="fct" value="edit_dir_final">
      <input type="hidden" name="lv" value="$lv">
      <input type="hidden" name="cid" value="$cid">
      <input type="hidden" name="prev_cid" value="$prev_cid">
      <input type="hidden" name="hv" value="$hv">
    </td>
  </tr>
</table>
<div align="center"><center>
    <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr><td width="1%" bgcolor="#FFFFFF"></td><td width="99%"></td></tr>
  </table>

  </center></div>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
  </table>
</form>
$related_cats
</body>
</html>
];


#     <tr>
#      <td valign="top" bgcolor="#FFFFFF" class="normaltext">Upload Category Image: <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This image will be displayed next to categories when they are listed - Note that the variable <b>!!cimage!!</b> needs to be available inside the template called <b>Sub Categories/Directories Style 2</b> - It is available in the PowerSeek Control Panel >> Template Manager >> 1. Default Category/Directory Templates >> Sub Categories/Directories Style 2.');" onMouseOut="tooltip.hide();" /></td>
#      <td bgcolor="#FFFFFF" class="normaltext">
#      <input type="file" name="catimage" id="catimage" size="50"/> (Only .gif or .jpg excepted)
#     $cimage</td>
#    </tr>



$sth->finish;
$dbh->disconnect;

}





sub add_dir_final
{

$mscr = $q->param('mscr');

$dirname = $q->param('directory_name');
$dirname =~ s/_/ /g;
$dirname =~ s/\\//g;
$dirname = acs::remove_leading_spacing($dirname);

$cat_title = $q->param('cat_title');
$cat_title =~ s/'/\\'/g;

$metadiz = $q->param('metatag');
$metadiz =~ s/'/\\'/g;

$metakeyw = $q->param('mkeyw');
$metakeyw =~ s/'/\\'/g;

$shortname = $dirname;

$ct = $q->param('ct');
$orig_ct = $ct;

$lv = $q->param('lv');

$custom_template = $q->param('ctemplate');


#$locked = $q->param('locked');
#if ($locked eq 


$catstat = $q->param('cat_status');
if ($catstat eq "locked") { $cat_status = "Y"; }
if ($catstat eq "hidden") { $cat_status = "H"; }


if ($lv eq "") {$lv = 1;}
elsif ($lv == 0) {$lv = 1;}
else {$lv++;}

#### CHECK IF SOMETHING SPECIFIED

if ($dirname eq ""){acs::problem_popup("You have to supply a name for the directory you are about to create.");}

acs::htmlencode2();

###########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }




if ($ct eq "")
	{
	$adir[0] = "$dirname";
	}
	else
	{
	#$rct = acs::decode_dir($ct);
	@adir = split (/-/, $ct);

	$acn = 0;
	foreach $ditem (@adir)
		{
		$currend_decoded = acs::decode_dir($ditem);
		$fname = "l" . ($acn + 1);
		$adir[$acn] = $currend_decoded;
		$acn++;
		
		$currend_decoded =~ s/'/\\'/g;
		$qstring = $qstring  . " ($fname = '$currend_decoded') AND";
		}
	
	$apos = $lv; $apos = $apos - 1;
	$adir[$apos] = $dirname;
	
	### CHECK IF CATEGORY EXISTS
		$qstring = substr($qstring, 0, length($qstring) - 3);
		
		$curr_lv = $lv - 1;
		
		$wsql = "SELECT cid FROM dirs WHERE (level = '$curr_lv') AND ($qstring)";
		$sth = $dbh->prepare($wsql);
		if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";} 
		$rows = $sth->rows();
		while ( @row = $sth->fetchrow() )
			{
			$current_cat_cid = $row[0];
			}

		if ($rows < 1) 
		{
		acs::problem_popup("The category/directory you are trying to add a new directory/category to, changed - unable to save the changes. 
		<a href=\"javascript:onClick=window.close()\">Close</a> this window, refresh it's parent and try again.");
		$sth->finish;
		$dbh->disconnect;
		}
		$qstring = "";
	}



### DUPLICATE CHECKING ################
	$dn2 = $dirname;
	$dn2 =~ s/'/\\'/g;
	
	@adirs = split (/-/, $ct);
	$nrdirs = @adirs; #$nrdirs = $nrdirs - 1;

	for ($ms = 0; $ms < $nrdirs; $ms++) 
		{
		$acnt = $ms + 1;
		
		$adirs[$ms] = acs::decode_dir($adirs[$ms]);
		$adirs[$ms] =~ s/'/\\'/g;
		$querystr = $querystr . " (l" . "$acnt = '$adirs[$ms]') and";
		}
		$querystr = substr($querystr, 0, length($querystr) - 3);
		$acnt++;
		
		if ($acnt > 16) { acs::problem_popup("The maximum number of nested levels you may have is 16."); }
		
		if ($querystr ne "")
			{
			$querystr = $querystr . " and (l" . $acnt . " = '$dn2')";
			}
			else
			{
			$querystr = $querystr . "(l" . $acnt . " = '$dn2')";
			}
	
	
	
	$wsql = "SELECT shortname FROM dirs WHERE $querystr";
	
	#print "$acnt - $wsql";
	
	$sth = $dbh->prepare($wsql);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";} 
	$rows = $sth->rows();
	
	if (($rows > 0) and ($rows < 10000)) {acs::problem_popup("The name of the directory you are trying to add already exists.");}



### IF THIS IS A CROSSLINKED CATEGORY, THEN CHECK IF CATEGORY ID EXISTS

$crosslinkid = $q->param('crosslinkid');

if ($crosslinkid ne "")
{

$sql_crossl = "SELECT cid FROM dirs WHERE cid = '$crosslinkid'";
$sth = $dbh->prepare($sql_crossl);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crossl";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("The crosslink category ID you provided could not be found in the database."); }

$crosslinkid = ",crosslinkid 	= '$crosslinkid'"; 
}



### IF THERE IS RELATED CATEGORIES ASSOCIATED WITH THIS CATEGORY - CHECK IF THEY EXIST

$related_categories = $q->param('related_categories');
if (($crosslinkid eq "") and ($related_categories ne ""))
{

$related_dirs_sql = "SELECT cid FROM dirs WHERE ";

@rel_items = split (/,/, $related_categories);

foreach $item (@rel_items)
	{
	$item =~ s/ //g;
	$related_dirs_sql = $related_dirs_sql . " (cid = '$item') OR";
	}

$related_dirs_sql = substr($related_dirs_sql, 0, length($related_dirs_sql) - 2);

#print "===> $related_dirs_sql <br>";

$sth = $dbh->prepare($related_dirs_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $related_dirs_sql";}
$rows = $sth->rows();

$rc_no = @rel_items;

if ($rc_no != $rows)
	{
	acs::problem_popup("One of the category ID's you entered as a related category doesn't exist.");
	}

$related_categories = ",related1 = '$related_categories'"; 

}


$google_map_details = $q->param('priority') . "::" . $q->param('change_freq');

### ADD DIR ###########################

$adir[0] =~ s/'/\\'/g; $adir[1] =~ s/'/\\'/g;  $adir[2] =~ s/'/\\'/g;  $adir[3] =~ s/'/\\'/g;  $adir[4] =~ s/'/\\'/g; 
$adir[5] =~ s/'/\\'/g; $adir[6] =~ s/'/\\'/g;  $adir[7] =~ s/'/\\'/g;  $adir[8] =~ s/'/\\'/g;  $adir[9] =~ s/'/\\'/g; 
$adir[10] =~ s/'/\\'/g; $adir[11] =~ s/'/\\'/g;  $adir[12] =~ s/'/\\'/g;  $adir[13] =~ s/'/\\'/g;  $adir[14] =~ s/'/\\'/g; 
$adir[15] =~ s/'/\\'/g; $adir[16] =~ s/'/\\'/g; 
$shortname =~ s/'/\\'/g;

$related_categories =~ s/ //g;

if ($crosslinkid ne "") { $related_categories = ""; }

$sth = $dbh->prepare("INSERT INTO dirs SET 
		level				= '$lv',
		
		l1 				= '$adir[0]',
		l2				 	= '$adir[1]',
		l3			 		= '$adir[2]',
		l4		 			= '$adir[3]',
		l5					= '$adir[4]',
		l6					= '$adir[5]',
		l7					= '$adir[6]', 
		l8					= '$adir[7]', 
		l9					= '$adir[8]',
		l10				= '$adir[9]',
		l11				= '$adir[10]',
		l12				= '$adir[11]',
		l13				= '$adir[12]',
		l14				= '$adir[13]',
		l15				= '$adir[14]',
		l16				= '$adir[15]',

		linknrs 			= '0',
		ext2				= '$cat_title',
		ext3				= '$google_map_details',
		description		= '$metadiz',
		keywords			= '$metakeyw',
		shortname		= '$shortname',
		catlock 			= '$cat_status',
		template 		= '$custom_template'
		$crosslinkid
		$related_categories
		");


if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


### GET LAST INSERTED ID
$sth = $dbh->prepare("SELECT cid FROM dirs WHERE cid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() )	
	{
	$last_id = $row[0];
	}  

$sth->finish;
$dbh->disconnect;


######################################################
$lv = $lv - 1;


#if ($mscr eq "mscr")
#	{
#	$bodytag = 	"<body onUnload=\"opener.location.reload(true);\">";
#	}
#	else
#	{
#	$bodytag = "<body>";
#	}



### UPDATE CHANGE FILE SO THAT ONLY CHANGED CATEGORIES GET UPDATED FOR CHANGED HTML GENERATION
if ($lv ==0)
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$last_id" . ":" . "\n";
	close (CFILE);
	}
elsif (($lv == 1) or ($lv == 2))
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$current_cat_cid" . ":" . "F\n";
		print CFILE "$last_id" . ":" . "\n";
	close (CFILE);
	}
	else
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$current_cat_cid" . ":\n";
		print CFILE "$last_id" . ":" . "\n";
	close (CFILE);
	}


### Upload Category Image if specified

$upload_dir = "$web_dir/imagefiles";
if ((-e $upload_dir) < 1)
	{
	mkdir ($upload_dir, $default_permissions);
	chmod ($default_permissions, $upload_dir);
	}

$upload_dir2 = "$web_dir/imagefiles/cimage";
if ((-e $upload_dir2) < 1)
	{
	mkdir ($upload_dir2, $default_permissions);
	chmod ($default_permissions, $upload_dir2);
	}


if ($q->param('catimage') ne "")
	{

		(@fext) = split (/\./, $q->param('catimage'));
		$fnr = @fext;
		$fextension = $fext[$fnr -1];
		$fextension = lc($fextension);
	
		$ufname = $last_id . "." . $fextension;
		$ufname = "$web_dir/imagefiles/cimage/$ufname";
		
			### DO UPLOAD
			$upload_filehandle = $q->param('catimage');
			open UPLOADFILE, ">$ufname"; 
			binmode UPLOADFILE; 
			  while ( <$upload_filehandle> )
				 {
			    print UPLOADFILE;
				 } 	
			close UPLOADFILE;

	}



$boxdiz = qq[
Click <a href="$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv&mscr=$mscr"><strong>here to add</strong></a> another
    directory or <a href="javascript:onClick=window.close()"><strong>here to close</strong></a> this window.
];

$hbox = acs::get_heading_box("$web_url/add.gif", "New Category/Directory Created", $boxdiz);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Directory Added</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>
];


}






sub addir
{
$ct = $q->param('ct');
$lv = $q->param('lv');

$mscr = $q->param('mscr');

$template_cust = $q->param('cust_tmpl');

### GET CUSTOM CATEGORY TEMPLATES

opendir(DIR,"$data_dir");
	@files = readdir(DIR);
	@files = sort(@files);
	foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 11, 11) eq "-1ctst\.html")
			{
			$cust_tmpl_name = substr($filename, 0, length($filename) - 11);
			
				if ($template_cust eq $cust_tmpl_name)
					{
					$ctemplates_avail = $ctemplates_avail . qq[<option value="$cust_tmpl_name" selected>$cust_tmpl_name</option>];
					}
					else
					{
					$ctemplates_avail = $ctemplates_avail . qq[<option value="$cust_tmpl_name">$cust_tmpl_name</option>];
					}
			
			}
		} 




if ($lv eq "") { $lv = "0";}

$location = acs::get_location_string($ct);


$hbox = acs::get_heading_box("$web_url/add.gif", "Add a New Directory/Category", qq[Add a New Category/Directory To: <b>$location</b>]);

$jspopup_code = acs::get_popupjs;

$tlt = acs::get_tooltip;

$jser = acs::get_js_errors;

print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Add a New Directory</title>
<script LANGUAGE="JavaScript">
$jspopup_code
</script>
$jser
$tlt

$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
<form method="POST" action="$admin_url/admin2.cgi" name="addu" onSubmit="return check_errors_blank('directory_name::You have to provide a name for the category/directory');" ENCTYPE="multipart/form-data">
$hbox
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr>
      <td colspan="2" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Category/Directory Details:</strong></td>
    </tr>
    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Category Name: <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Max 255 Characters');" onMouseOut="tooltip.hide();"></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="directory_name" id="directory_name" size="43" maxlength="100" style="width:100%">
        </font></td>
    </tr>
    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext">Crosslink Category ID: (Optional) <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If this is a crosslinked category (symbolic link to another category), specify the ID of the existing category to link this category to. You can view category IDs or assign a category ID by clicking the browse button. Note that none of the settings below (meta details and related categories) will have any effect if this category is a symbolic/crosslinked category.');" onMouseOut="tooltip.hide();" /></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="crosslinkid" size="7">
        <strong>( <a
      href="$admin_url/admin67.cgi" onClick="popup('$admin_url/admin67.cgi',750,600, 500, 100);return false;">Browser</a> )</strong></td>
    </tr>
    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Title:  (Optional) <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This title can be used as the page title when displaying this category to end users. <b>If this is a crosslinked category, then this text has no effect.</b>');" onMouseOut="tooltip.hide();" /></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="cat_title" size="43" 
      maxlength="255" style="width:100%"></td>
    </tr>
    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Meta Description: (Optional) <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This description will be be used as meta tags for search engines - Max 255 Characters <b>If this is a crosslinked category, then this text has no effect.</b>');" onMouseOut="tooltip.hide();" /></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="metatag" size="43" maxlength="255" style="width:100%"></td>
    </tr>
    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Meta Keywords: (Optional) <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Fill in keywords separated by commas, descriptive of the category. Max 255 Characters. <b>If this is a crosslinked category, then this text has no effect.</b>');" onMouseOut="tooltip.hide();" /></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="mkeyw" size="43" maxlength="255" style="width:100%"></td>
    </tr>
    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Related Categories: (Optional) <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Click the <b>Browser</b> link or specify related category IDs in a comma separated list. For example: 10, 313, 423, 35');" onMouseOut="tooltip.hide();" /></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="related_categories" size="43">
        <strong> ( <a
      href="$admin_url/admin67.cgi" onClick="popup('$admin_url/admin67.cgi?fct=related',750,600, 600, 100);return false;">Browser</a> )</strong></td>
    </tr>
    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Category Status:</td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><table width="100%%" cellspacing="0" cellpadding="0">
        <tr class="normaltext">
          <td width="33%"><input type="radio" value="standard" name="cat_status"
      checked="checked" />
            <strong>Standard <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('The category is not locked or hidden to end users.');" onMouseOut="tooltip.hide();" /></strong></td>
          <td width="33%"><input type="radio" value="locked" name="cat_status" />
            <strong>Locked <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('End users are not able to add links to the category. ');" onMouseOut="tooltip.hide();" /></strong></td>
          <td width="33%"><input type="radio" value="hidden" name="cat_status" />
            <strong>Hidden <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This category will not be displayed to end users.');" onMouseOut="tooltip.hide();" /></strong></td>
        </tr>
      </table>
       </td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">Custom Category Template: <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('You can create custom category templates by clicking the <b>Template Manager</b> tab in the Control Panel. Scroll down and click on <b>Create or Edit Custom Directory/Category Templates</b>. Custom category templates enables you to give specific categories an original look and feel or target advertisements or specific content at specific categories.');" onMouseOut="tooltip.hide();" /></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <select name="ctemplate" id="ctemplate">
          <option>Default</option>
          
			$ctemplates_avail          
        
        </select>
      </label></td>
    </tr>
    <tr bgcolor="#E1E1E1">
      <td bgcolor="#FFFFFF" class="normaltext"><p>Google SiteMaps Details:</p></td>
      <td bgcolor="#FFFFFF" class="normaltext"><p>Priority:
          <label>
          <input name="priority" type="text" size="6">
          (From 0.00 to 1.00) / Change Frequency:
          <select name="change_freq" id="gpriority">
            <option value="" selected >Not Available</option>
            <option value="always" >always</option>
            <option value="hourly" >hourly</option>
            <option value="daily" >daily</option>
            <option value="weekly">weekly</option>
            <option value="monthly" >monthly</option>
            <option value="yearly" >yearly</option>
            <option value="never" >never</option>
          </select>
          </label>
        </p></td>
    </tr>


    <tr>
      <td width="28%" valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Add New Directory  " name="B2">
        <input type="hidden" name="fct" value="add_dir_final">
        <input type="hidden" name="ct" value="$ct">
        <input type="hidden" name="lv" value="$lv">
        <input type="hidden" name="mscr" value="$mscr"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>

];

#    <tr>
#      <td valign="top" bgcolor="#FFFFFF" class="normaltext">Upload Category Image: <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This image will be displayed next to categories when they are listed - Note that the variable <b>!!cimage!!</b> needs to be available inside the template called <b>Sub Categories/Directories Style 2</b> - It is available in the PowerSeek Control Panel >> Template Manager >> 1. Default Category/Directory Templates >> Sub Categories/Directories Style 2.');" onMouseOut="tooltip.hide();" /></td>
#      <td bgcolor="#FFFFFF" class="normaltext">
#      <input type="file" name="catimage" id="catimage" size="50" /> (Only .gif or .jpg excepted)
#     </td>
#    </tr>



##  <strong>( <a href="$admin_url/admin80.cgi?fct=cat_image_settings" onClick="popup('$admin_url/admin80.cgi?fct=cat_image_settings',750,600, 500, 100);return false;">Settings</a> )</strong>

}



















##################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}
if ($line =~ /^SWR/){$swr = &get_setup_line($line, SWR);}
if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

