#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use CGI::Carp qw(fatalsToBrowser);  

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

if ($q->param('fct') eq "") {&start;}

##################################################################################

sub start
{

$itemnrs = $q->param('itemnrs');
$itemnrs++;


### CHECK THAT SOMETHING WAS SELECTED TO DO SOMETHING WITH

for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		$sel_found = "true";
		}
	}

if ($sel_found ne "true")
	{
	if ($q->param('from_name') eq "")
		{
		print "Content-type: text/html\n\n";
		acs::problem_popup("You have to select at least one item.");
		}
	}



#### IF BLOCKING OPTIONS HAS BEEN CHOSEN

if (($q->param('blocking') ne "") and ($q->param('B2') eq "Block"))
	{

	if ($q->param('blocking') eq "domain_email_ip")
		{
		print "Content-type: text/html\n\n";
		&delete_email("domain_email_ip");
		}
	elsif ($q->param('blocking') eq "domain_email")
		{
		print "Content-type: text/html\n\n";
		&delete_email("domain_email");
		}
	elsif  ($q->param('blocking') eq "domain")
		{
		print "Content-type: text/html\n\n";
		&delete_email("domain");
		}
	elsif  ($q->param('blocking') eq "emailspam")
		{
		print "Content-type: text/html\n\n";
		&delete_email("emailspam");
		}
	elsif  ($q->param('blocking') eq "ip")
		{
		print "Content-type: text/html\n\n";
		&delete_email("ip");
		}

	exit;
	}




if (($q->param('blocking2') ne "") and ($q->param('B4') eq "Block"))
	{
	if ($q->param('blocking2') eq "domain_email_ip")
		{
		print "Content-type: text/html\n\n";
		&delete_email("domain_email_ip");
		}
	elsif ($q->param('blocking2') eq "domain_email")
		{
		print "Content-type: text/html\n\n";
		&delete_email("domain_email");
		}
	elsif  ($q->param('blocking2') eq "domain")
		{
		print "Content-type: text/html\n\n";
		&delete_email("domain");
		}
	elsif  ($q->param('blocking2') eq "emailspam")
		{
		print "Content-type: text/html\n\n";
		&delete_email("emailspam");
		}
	elsif  ($q->param('blocking2') eq "ip")
		{
		print "Content-type: text/html\n\n";
		&delete_email("ip");
		}

	exit;
	}




####### EDIT LINKS

if ($q->param('B3') eq "Submit")
	{
	if ($q->param('dropdown2') eq "Edit"){&edit_links; exit;}
	if ($q->param('dropdown2') eq "Move"){&move_links; exit;}
	if ($q->param('dropdown2') eq "Move_Email"){&move_links("EMAIL"); exit;}
	}
	elsif ($q->param('B1') eq "Submit")
	{
	if ($q->param('dropdown') eq "Edit"){&edit_links; exit;}
	if ($q->param('dropdown') eq "Move"){&move_links; exit;}
	if ($q->param('dropdown') eq "Move_Email"){&move_links("EMAIL"); exit;}
	}


print "Content-type: text/html\n\n";

####### APPROVE NEW SUBMISSIONS


if ($q->param('B1') eq "Submit")
	{
	if ($q->param('dropdown') eq "Approve_Email"){&aprove_listings("EMAIL");}
	if ($q->param('dropdown') eq "Approve"){&aprove_listings("");}
	}
	elsif ($q->param('B3') eq "Submit")
	{
	if ($q->param('dropdown2') eq "Approve_Email"){&aprove_listings("EMAIL");}
	if ($q->param('dropdown2') eq "Approve"){&aprove_listings("");}
	}
	

####### REJECT NEW SUBMISSIONS

if ($q->param('B1') eq "Submit")
	{
	if ($q->param('dropdown') eq "Delete_Email"){&delete_email("EMAIL");}
	if ($q->param('dropdown') eq "Delete"){&delete_email("");}
	}
	elsif ($q->param('B3') eq "Submit")
	{
	if ($q->param('dropdown2') eq "Delete_Email"){&delete_email("EMAIL");}
	if ($q->param('dropdown2') eq "Delete"){&delete_email("");}
	}


exit;
}




sub move_links
{

my ($email_stat) = @_;

if ($email_stat eq "EMAIL")
	{
	$eml = "email=true";
	}

$pstring = "$admin_url/admin5.cgi?opaction=Move&fct=link_functions&";

for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		($lnkid, $cid, $rid) = &decode_subm_data($q->param($cname));
		$pstring = $pstring . "$cname=$lnkid&";
		}
	}

$pstring = $pstring . "nr_links=$itemnrs&newsub=true&$eml";

#print "Content-type: text/html\n\n";
print "Location: $pstring\n\n";

}





sub edit_links
{

$pstring = "$admin_url/admin5.cgi?opaction=Edit&fct=link_functions&";

for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		($lnkid, $cid, $rid) = &decode_subm_data($q->param($cname));
		$pstring = $pstring . "$cname=$lnkid&";
		}
	}

$pstring = $pstring . "nr_links=$itemnrs&newsub=true";

#print "Content-type: text/html\n\n";
print "Location: $pstring\n\n";


}





sub delete_email
{
my ($email_stat) = @_;

$del_sql = "DELETE FROM links WHERE ";

$email_sel_sql = "SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16, B.* 
						FROM dirs AS A, links as B
						WHERE (A.cid = B.cid) AND (";



##### GET IP ADDRESSES
$iptrans = $q->param('iptrans');
@ipitems = split (/:::/, $iptrans);
foreach $item (@ipitems)
	{
	($ilinkid, $ipaddr) = split (/:/, $item);
	$linkn = "N" . $ilinkid;
	$ipident{$linkn} = $ipaddr;
	}

##############

for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		($lnkid, $cid, $rid) = &decode_subm_data($q->param($cname));
		
		$del_sql = $del_sql . " (lnkid = '$lnkid') OR";
		$eml_rj = $eml_rj . " (lnkid = '$lnkid') OR";
		$email_sel_sql = $email_sel_sql . " (B.lnkid = '$lnkid') OR";
		}
	}

$del_sql = substr($del_sql, 0, length($del_sql) - 2);
$eml_rj = substr($eml_rj, 0, length($eml_rj) - 2);
$email_sel_sql = substr($email_sel_sql, 0, length($email_sel_sql) - 2);
$email_sel_sql = $email_sel_sql . ")";





if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
  

#### SEND REJECTION EMAILS OR BLOCK DOMIANS/EMAILS/IP
if ($email_stat ne "")
	{

	$keydata = acs::get_file_contents("$data_dir/keys.dat");
	@akeys = split(/\n/, $keydata);
	$nrc = 0;

	### GET REJECTION EMAIL

	$approve_email = acs::get_file_contents("$data_dir/rejection.eml");
	
	@elines = split (/\n/, $approve_email);
	
	$from_name = $elines[0];
	
	$html_email_send = ""; $html_email = "";
	if ($from_name =~ /::/) { ($from_name, $html_email) = split (/::/, $from_name); }
	if ($html_email eq "Y") { $html_email_send = "HTML"; }
	
	$from_email = $elines[1];
	$email_subject = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}
	
	### GET PREMIUM REJECTION EMAIL

	$papprove_email = acs::get_file_contents("$data_dir/prejection.eml");
	
	@pelines = split (/\n/, $papprove_email);
	
	$pfrom_name = $pelines[0];
	
	$phtml_email_send = ""; $phtml_email = "";
	if ($pfrom_name =~ /::/) { ($pfrom_name, $phtml_email) = split (/::/, $pfrom_name); }
	if ($phtml_email eq "Y") { $phtml_email_send = "HTML"; }
	
	$pfrom_email = $pelines[1];
	$pemail_subject = $pelines[2];
	
	$plnc = 0;
	foreach $pline (@pelines)
		{
		if ($plnc > 2)
			{
			$pemail_message = $pemail_message . $pline . "\n";
			}
		$plnc++;
	}
	
	####################
	## $reject_lnkids{ELINKID}
	## $reject_emails{EFORMNAME}
	## $reject_emailsp{EFORMNAME}
	
	&init_custom_rejection_emails($eml_rj);
	
	#### GET LINKS TO SEND REJECTION EMAILS TO
	
	$sth = $dbh->prepare($email_sel_sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $email_sel_sql";}
	
	
		while ( @row = $sth->fetchrow() )
		{
		
		### GET CATEGORY
		$cats = "";
		for ($ms1 = 0; $ms1 < 16; $ms1++) 
			{
			if ($row[$ms1] ne "")
				{
				$cats = $cats . $row[$ms1] . "/";
				}
			}

		$lnkid = $row[16];
		$ccid = $row[17];
		$title = $row[18];
		$description = $row[19];
		$keywords = $row[20];
		$url = $row[21];
		$name = $row[24];
		$email = $row[25];
		$date = $row[33];
		$date = acs::decode_date($date);
		$password = $row[38];
		
			
		if ($row[29] > 0)
			{
			$prepared_approve_email = $pemail_message;
			}
			else
			{
			$prepared_approve_email = $email_message;
			}
		
		$prepared_approve_email =~ s/%%title%%/$title/gi;
		$prepared_approve_email =~ s/%%description%%/$description/gi;
		$prepared_approve_email =~ s/%%keywords%%/$keywords/gi;
		$prepared_approve_email =~ s/%%url%%/$url/gi;
		$prepared_approve_email =~ s/%%name%%/$name/gi;
		$prepared_approve_email =~ s/%%email%%/$email/gi;
		$prepared_approve_email =~ s/%%date%%/$date/gi;
		$prepared_approve_email =~ s/%%category_submitted%%/$cats/gi;
		$prepared_approve_email =~ s/%%password%%/$password/gi;


		$elnkid = "E" . $lnkid;
		if ($reject_lnkids{$elnkid} ne "") ### IF CUSTOM ADDURL/MODIFY FORMS
			{
			$custemprm = "E" . $reject_lnkids{$elnkid};
			
				$reject_emails{$custemprm} =~ s/%%title%%/$title/gi;
				$reject_emails{$custemprm} =~ s/%%description%%/$description/gi;
				$reject_emails{$custemprm} =~ s/%%keywords%%/$keywords/gi;
				$reject_emails{$custemprm} =~ s/%%url%%/$url/gi;
				$reject_emails{$custemprm} =~ s/%%name%%/$name/gi;
				$reject_emails{$custemprm} =~ s/%%email%%/$email/gi;
				$reject_emails{$custemprm} =~ s/%%date%%/$date/gi;
				$reject_emails{$custemprm} =~ s/%%category_submitted%%/$cats/gi;
				$reject_emails{$custemprm} =~ s/%%password%%/$password/gi;

				$reject_emailsp{$custemprm} =~ s/%%title%%/$title/gi;
				$reject_emailsp{$custemprm} =~ s/%%description%%/$description/gi;
				$reject_emailsp{$custemprm} =~ s/%%keywords%%/$keywords/gi;
				$reject_emailsp{$custemprm} =~ s/%%url%%/$url/gi;
				$reject_emailsp{$custemprm} =~ s/%%name%%/$name/gi;
				$reject_emailsp{$custemprm} =~ s/%%email%%/$email/gi;
				$reject_emailsp{$custemprm} =~ s/%%date%%/$date/gi;
				$reject_emailsp{$custemprm} =~ s/%%category_submitted%%/$cats/gi;
				$reject_emailsp{$custemprm} =~ s/%%password%%/$password/gi;
			}

		## 43 - INCLUDE EXTRA FIELD DATA
		$keycount = 43;
		foreach $kitem (@akeys)
		{
		($keyname1, $visible1, $size1, $searched1, $description_key1, $na1, $imagef1, $numberfield1, $req1) = split (/\t/, $kitem); 
		
		$repldata = $row[$keycount];
		if ($repldata eq "") { $repldata = $na1; }
		
		$prepared_approve_email =~ s/%%$keyname1%%/$repldata/gi;
		
				if ($reject_lnkids{$elnkid} ne "") ### IF CUSTOM ADDURL/MODIFY FORMS
					{
					$reject_emailsp{$custemprm} =~ s/%%$keyname1%%/$repldata/gi;
					$reject_emails{$custemprm} =~ s/%%$keyname1%%/$repldata/gi;
					}
		
		$keycount++;
		}


		#### IF CHOSEN TO CREATE A SPAM FILTER
		if ($email_stat eq "domain_email_ip")
			{
			 	if ($email ne ""){ push(@email_block, $email); } ### EMAIL
				if ($url ne "")
				{
					$curdomain = &get_domain($url); ### DOMAIN
					push(@domain_block, $curdomain);
				}
				
				$linkipname = "N" . $lnkid;  ### IP
				if ($ipident{$linkipname} ne "") { push (@ip_block, $ipident{$linkipname}); }

			}
			elsif ($email_stat eq "domain_email")
			{
			 	if ($email ne ""){ push(@email_block, $email); } ### EMAIL
				if ($url ne "") ### DOMAIN
				{
				$curdomain = &get_domain($url);
				push(@domain_block, $curdomain);
				}

			}
			elsif ($email_stat eq "emailspam")
			{
				if ($email ne ""){ push(@email_block, $email); } ### EMAIL
			}
			elsif ($email_stat eq "domain") ### CREATE DOMAIN BLOCK SPAM FILTER
			{
				if ($url ne "") ### DOMAIN
				{
				$curdomain = &get_domain($url);
				push(@domain_block, $curdomain);
				}
			}			
			elsif ($email_stat eq "ip") ### IP
			{
				$linkipname = "N" . $lnkid;  
				if ($ipident{$linkipname} ne "") { push (@ip_block, $ipident{$linkipname}); }
			}
			else ### IF $email_stat = EMAIL | SEND REJECTION EMAIL
			{
				
				if ($reject_lnkids{$elnkid} ne "") ### IF CUSTOM ADDURL/MODIFY FORMS
					{
					$custemprm = "E" . $reject_lnkids{$elnkid};
					
						if ($row[29] > 0) ## IF PREMIUM LINK
							{
							($cpfrom_name, $cpfrom_email, $cpemail_subject, $cprepared_approve_email) = &decode_email($reject_emailsp{$custemprm});
							
										$cem_html_email = ""; $cem_html_email_send = "";
										if ($cpfrom_name =~ /::/) { ($cpfrom_name, $cem_html_email) = split (/::/, $cpfrom_name); }
										if ($cem_html_email eq "Y") { $cem_html_email_send = "HTML"; }
							
							acs::send_email ($cpfrom_name, $cpfrom_email, $email, $cpemail_subject, $cprepared_approve_email, $cem_html_email_send);
							}
							else
							{
							($cpfrom_name, $cpfrom_email, $cpemail_subject, $cprepared_approve_email) = &decode_email($reject_emails{$custemprm});
							
										$cem_html_email = ""; $cem_html_email_send = "";
										if ($cpfrom_name =~ /::/) { ($cpfrom_name, $cem_html_email) = split (/::/, $cpfrom_name); }
										if ($cem_html_email eq "Y") { $cem_html_email_send = "HTML"; }
							
							acs::send_email ($cpfrom_name, $cpfrom_email, $email, $cpemail_subject, $cprepared_approve_email, $cem_html_email_send);
							}
						
					}
					else
					{
						if ($row[29] > 0) ### IF PREMIUM LINK
							{
							acs::send_email ($pfrom_name, $pfrom_email, $email, $pemail_subject, $prepared_approve_email, $phtml_email_send);
							}
							else
							{
							acs::send_email ($from_name, $from_email, $email, $email_subject, $prepared_approve_email, $html_email_send);
							}
					}
			}
			
		} ### END OF LOOP THROUGH SELECTED RECORDS

	} ### END OF EMAIL



### CREATE SPAM FILTERS IF SOMETHING WAS BLOCKED

foreach $spam_item (@email_block)
{
		eval 
		{
		$sth = $dbh->prepare("INSERT INTO spamfilter SET criteria = '$spam_item', typefilter = 'E', matchtype = 'W'");
		$sth->execute;
		};
		if ($@ ne "") { $dupl++;  $@ = ""; }
}

foreach $spam_item (@domain_block)
{
		eval 
		{
		$sth = $dbh->prepare("INSERT INTO spamfilter SET criteria = '$spam_item', typefilter = 'D'");
		$sth->execute;
		};
		if ($@ ne "") { $dupl++;  $@ = ""; }
}


foreach $spam_item (@ip_block)
{
		eval 
		{
		$sth = $dbh->prepare("INSERT INTO spamfilter SET criteria = '$spam_item', typefilter = 'I'");
		$sth->execute;
		};
		if ($@ ne "") { $dupl++;  $@ = ""; }
}




#### DELETE NEW SUBMISSIONS

$sth = $dbh->prepare($del_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $del_sql";}
$rows = $sth->rows();

$sth->finish;
$dbh->disconnect;

#########################

$hbox = acs::get_heading_box("$web_url/add.gif", "$rows Listings Deleted", qq[<a href="$admin_url/admin20.cgi">Click Here to Continue</a>]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];



}


sub decode_email
{
my ($enemail) = @_;
my ($ret_email_message);

	my @elines = split (/\n/, $enemail);
	
	$ret_from_name = $elines[0];
	$ret_from_email = $elines[1];
	$ret_email_subject = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$ret_email_message = $ret_email_message . $line . "\n";
			}
		$lnc++;
		}

return ($ret_from_name, $ret_from_email, $ret_email_subject, $ret_email_message);
}



sub init_custom_rejection_emails
{

my ($emreml) = @_;
	
	$rkemlsel = "SELECT * FROM exaddurl WHERE $emreml"; 
	
	$sth = $dbh->prepare($rkemlsel);
	$sth->execute;
	#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $email_sel_sql";}
	
		while ( @row = $sth->fetchrow() )
		{
		$rj_lnkid = "E" . $row[1];
		$reject_lnkids{$rj_lnkid} = $row[2];
		$eformname = "E" . $row[2];
		$reject_emails{$eformname} = acs::get_file_contents("$data_dir/" . $row[2] . "_reject.eml");
		$reject_emailsp{$eformname} = acs::get_file_contents("$data_dir/" . $row[2] . "_preject.eml");
		}

}




sub get_domain
{
my ($sp_url) = @_;
 
$sp_url =~ s/http:\/\/www\.//gi;
$sp_url =~ s/http:\/\///gi;
@alitems = split (/\//, $sp_url);
$realdomain = $alitems[0];

return($realdomain);
}









sub aprove_listings
{
my ($email_stat) = @_;

$now = time();

$approve_sql = "UPDATE links SET newsubm = '', urldate = '$now' WHERE ";

$email_sel_sql = "SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16, B.* 
						FROM dirs AS A, links as B
						WHERE (A.cid = B.cid) AND (";

for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$cname = "C" . $ms;
	if ($q->param($cname) ne "") ### IF ITEM CHECKED
		{
		#$ss = $q->param($cname);
		#print "===> $ss<br>";
		($lnkid, $cid, $rid) = &decode_subm_data($q->param($cname));
		#print "===>  $lnkid, $cid, $rid <br><br><br>";
		
		$approve_sql = $approve_sql . " (lnkid = '$lnkid') OR";
		$email_sel_sql = $email_sel_sql . " (B.lnkid = '$lnkid') OR";
		$custemail_ids = $custemail_ids .  " (lnkid = '$lnkid') OR";
		
		############
		acs::update_numbers("+", 1, $rid);
		############
		
		$to_generate = $to_generate . $lnkid . ":\n";
		}
	}

$approve_sql = substr($approve_sql, 0, length($approve_sql) - 2);
$email_sel_sql = substr($email_sel_sql, 0, length($email_sel_sql) - 2);
$email_sel_sql = $email_sel_sql . ")";
$custemail_ids = substr($custemail_ids, 0, length($custemail_ids) - 2);

acs::htmlencode4;

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
 
### SEND APPROVAL EMAILS IF EMAIL HAS TO BE SENT

if ($email_stat eq "EMAIL")
	{

	$keydata = acs::get_file_contents("$data_dir/keys.dat");
	@akeys = split(/\n/, $keydata);
	$nrc = 0;
	

  #### GET PREMIUM EMAIL

  if ($q->param('premids') ne "")
	{
		$papprove_email = acs::get_file_contents("$data_dir/pacceptance.eml");
		@pelines = split (/\n/, $papprove_email);

		$pfrom_name = $pelines[0];

		if ($pfrom_name =~ /::/) { ($pfrom_name, $phtml_email) = split (/::/, $pfrom_name); }
		if ($phtml_email eq "Y") { $phtml_email_send = "HTML"; }
		
		$pfrom_email = $pelines[1];
		$pemail_subject = $pelines[2];
	
		$plnc = 0;
		foreach $pline (@pelines)
			{
			if ($plnc > 2)
				{
				$pemail_message = $pemail_message . $pline . "\n";
				}
			$plnc++;
			}
	}

	#### GET STANDARD EMAIL #######
	
	$approve_email = acs::get_file_contents("$data_dir/acceptance.eml");
	
	@elines = split (/\n/, $approve_email);
	
	$from_name = $elines[0];
	
	if ($from_name =~ /::/) { ($from_name, $html_email) = split (/::/, $from_name); }
	if ($html_email eq "Y") { $html_email_send = "HTML"; }
	
	$from_email = $elines[1];
	$email_subject = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}
	
	
	#### GET EMAILS IF CUSTOM FORMS ARE USED
	
	$sth = $dbh->prepare("SELECT * FROM exaddurl WHERE $custemail_ids");
	$sth->execute;
	#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $email_sel_sql";}

	while ( @row = $sth->fetchrow() )
		{
		$objn = "E" . $row[1];
		
		$custom_lnkemail{$objn} = $row[2];
		
		$objn2 = "E" . $row[2];
		$objn3 = "EP" . $row[2];
		
		if ($eitems{'from_name'} eq "")
			{
			$cust_eml{$objn2} = &get_cust_email($row[2], "");
			$cust_eml{$objn3} = &get_cust_email($row[2], "PREMIUM");
			}
		}
	
	
	#### GET LINKS TO SEND OUT APPROVAL EMAILS
	
	$sth = $dbh->prepare($email_sel_sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $email_sel_sql";}
	

	
while ( @row = $sth->fetchrow() )
		{
		
		### GET CATEGORY
		$cats = "";
		for ($ms1 = 0; $ms1 < 16; $ms1++) 
			{
			if ($row[$ms1] ne "")
				{
				$cats = $cats . $row[$ms1] . "/";
				}
			}

		$lnkid = $row[16];
		$ccid = $row[17];
		$title = $row[18];
		$description = $row[19];
		$keywords = $row[20];
		$url = $row[21];
		$name = $row[24];
		$email = $row[25];
		$date = $row[33];
		$date = acs::decode_date($date);
		$password = $row[38];

		##### PREPARE EMAIL TO BE SENT
		
		$prememail = "";
		$objt = "E" . $lnkid;
		if ($custom_lnkemail{$objt} ne "") ### SEND CUSTOM EMAIL
			{
			
			$cust_formname = "E" . $custom_lnkemail{$objt};
			$cust_formname2 = "EP" . $custom_lnkemail{$objt};
			
				($cem_from_name, $cem_from_email, $temail, $cem_email_subject, $prepared_approve_email) = &get_custemail_details($cust_eml{$cust_formname});
				($cem_pfrom_name, $cem_pfrom_email, $temail, $cem_pemail_subject, $cem_pemail_message) =  &get_custemail_details($cust_eml{$cust_formname2});
					
					$cem_html_email = ""; $cem_html_email_send = "";
					if ($cem_from_name =~ /::/) { ($cem_from_name, $cem_html_email) = split (/::/, $cem_from_name); }
					if ($cem_html_email eq "Y") { $cem_html_email_send = "HTML"; }
					
					$pcem_html_email = ""; $pcem_html_email_send = "";
					if ($cem_pfrom_name =~ /::/) { ($cem_pfrom_name, $pcem_html_email) = split (/::/, $cem_pfrom_name); }
					if ($pcem_html_email eq "Y") { $pcem_html_email_send = "HTML"; }

				
				### IF PREMIUM EMAIL
				if ($q->param('premids') ne "")
	   			{
						my @pids = split(/-/, $q->param('premids'));
				   	foreach $pitem (@pids)
				   		{
				   		if ($pitem eq $lnkid) { $prememail = "true"; $prepared_approve_email = $cem_pemail_message; }
	   					}
					}
			}
			else ### STANDARD APPROVAL FOR LINKS SUBMITTED FROM STANDARD ADD URL
			{
			
					$prepared_approve_email = $email_message;
			
					#### CHECK IF A PREMIUM EMAIL NEEDS TO BE SENT
					$prememail = "";
				   if ($q->param('premids') ne "")
				   	{
						my @pids = split(/-/, $q->param('premids'));
				   	foreach $pitem (@pids)
				   		{
				   		if ($pitem eq $lnkid) { $prepared_approve_email = $pemail_message; $prememail = "true";}
				   		}
	   				}
			}
		
		$prepared_approve_email =~ s/%%title%%/$title/gi;
		$prepared_approve_email =~ s/%%description%%/$description/gi;
		$prepared_approve_email =~ s/%%keywords%%/$keywords/gi;
		$prepared_approve_email =~ s/%%url%%/$url/gi;
		$prepared_approve_email =~ s/%%name%%/$name/gi;
		$prepared_approve_email =~ s/%%email%%/$email/gi;
		$prepared_approve_email =~ s/%%date%%/$date/gi;
		$prepared_approve_email =~ s/%%category_submitted%%/$cats/gi;
		$prepared_approve_email =~ s/%%password%%/$password/gi;
		
		$rem_rate = "$script_url/gethtml.cgi?id=$lnkid-$ccid";
		$prepared_approve_email =~ s/%%rating_code_url%%/$rem_rate/gi;

		## 43 - INCLUDE EXTRA FIELD DATA
		$keycount = 43;
		foreach $kitem (@akeys)
		{
		($keyname1, $visible1, $size1, $searched1, $description_key1, $na1, $imagef1, $numberfield1, $req1) = split (/\t/, $kitem); 
		
		$repldata = $row[$keycount];
		if ($repldata eq "") { $repldata = $na1; }
		
		$prepared_approve_email =~ s/%%$keyname1%%/$repldata/gi;
		
		$keycount++;
		}
		

		if ($custom_lnkemail{$objt} ne "") ### SEND CUSTOM EMAIL
				{
				
					if ($prememail ne "true") ### SEND STANDARD APPROVAL EMAIL
						{
						acs::send_email ($cem_from_name, $cem_from_email, $email, $cem_email_subject, $prepared_approve_email, $cem_html_email_send);
						}
						else ### SEND PREMIUM APPROVAL EMAIL
						{
						acs::send_email ($cem_pfrom_name, $cem_pfrom_email, $email, $cem_pemail_subject, $prepared_approve_email, $pcem_html_email_send);
						}
				}
				else
				{
				
					if ($prememail ne "true") ### SEND STANDARD APPROVAL EMAIL
						{
						acs::send_email ($from_name, $from_email, $email, $email_subject, $prepared_approve_email, $html_email_send);
						}
						else ### SEND PREMIUM APPROVAL EMAIL
						{
						#print "==> acs::send_email ($pfrom_name, $pfrom_email, $email, $pemail_subject, $prepared_approve_email); <br>:";
						acs::send_email ($pfrom_name, $pfrom_email, $email, $pemail_subject, $prepared_approve_email, $phtml_email_send);
						}
				}
		}
	
	}


### UPDATE LINKS TO REFLECT THAT THEY ARE NOW APPROVED SUBMISSIONS

$sth = $dbh->prepare($approve_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $approve_sql";}
$rows = $sth->rows();

$sth->finish;
$dbh->disconnect;

#### UPDATE CHANGE FILE TO INCLUDE CHANGES WHEN ONLY UPDATING HTML FILES

open (CH, ">> $data_dir/changed_lnks.dat");
	print CH $to_generate;
close (CH);

####


if ($q->param('indiv') eq "true")
	{

$hbox = acs::get_heading_box("$web_url/add.gif", "$rows Listings Approved.", qq[You may <a href="javascript:onClick=window.close()">close</a> this window.]);  
	
print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];
	
	}
	else
	{

$hbox = acs::get_heading_box("$web_url/add.gif", "$rows Listings Approved.", qq[<a href="$admin_url/admin20.cgi">Click Here to Continue</a>]);  

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];


	}


}



sub get_cust_email
{
my ($custname, $custprem) = @_;

if ($custprem eq "PREMIUM")  { $cfilen = "$data_dir/" . $custname . "_paccept.eml"; }
								else { $cfilen = "$data_dir/" . $custname . "_accept.eml"; }

$custa_email = acs::get_file_contents($cfilen);

return ($custa_email);

}






sub decode_subm_data
{
my ($submdat) = @_;

my ($item_nr, @ntit, $lnkid0, $ms0, $rid0, $cid0);

@ntit = split (/-/, $submdat);
$item_nr = @ntit;
$lnkid0 = $ntit[0];

for ($ms0 = 1; $ms0 < $item_nr; $ms0++)
	{
	$rid0 = 	$rid0 . $ntit[$ms0] . "-";
	}

$rid0 = substr($rid0, 0, length($rid0) - 1);

$cid0 = $ntit[$item_nr - 1];

return ($lnkid0, $cid0, $rid0);

}


sub get_custemail_details
{

my ($custdmd) = @_;
my ($r_prepared_approve_email);

		my @pelines = split (/\n/, $custdmd);

		$r_from_name = $pelines[0];
		$r_from_email = $pelines[1];
		$r_email_subject = $pelines[2];
	
		$plnc = 0;
		foreach $pline (@pelines)
			{
			if ($plnc > 2)
				{
				$r_prepared_approve_email = $r_prepared_approve_email . $pline . "\n";
				}
			$plnc++;
			}


return ($r_from_name, $r_from_email, $r_email, $r_email_subject, $r_prepared_approve_email);

}



####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

