#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&settings1;}
if ($q->param('fct') eq "prem_main") {&prem_main;}
if ($q->param('fct') eq "save_premium_info") {&save_premium_info;}
if ($q->param('fct') eq "settings1") {&settings1;}
if ($q->param('fct') eq "addexpiry") {&addexpiry;}

##################################################################################

sub addexpiry
{

$create = $q->param('create');

$usdprice = "usdprice" . $create;
$premium_expire_days = "premium_expire_days" . $create;
$premium_orderform_url = "premium_orderform_url" . $create;
$standard_orderform_url = "standard_orderform_url" .  $create;

$premspan = "premspan" . $create;
$stanspan = "stanspan" . $create;

$paypal =  $q->param('paypal');
if ($paypal eq "true")
	{
	$paypaltrue = qq[style="display:none"];
	}


$closewin = "closewin" . $create;


$premurl_nopaypal_help = qq[
Please specify the URL to the order form of your order processor here. <br>
  Users will be redirected to this URL so that they can make payment. <br>
  You will normally be able to obtain this URL from your order processor. <br><br>
  
  Note that you can use variables inside the URL. This is so that the ID,<br>
  or Title, etc. of the premium link submitted can be passed on to your order <br>
  processor.  This is so that you may know for what link payment was received.<br><br> 
  
  <strong>The following variables can be used inside the URL:</strong><br>
  <strong>!!lnkid!!</strong> = Link id of the link.<br>
  <strong>!!cid!!</strong> = Category id of the link.<br>
  <strong>!!title!!</strong> = Title of the link.<br>
  <strong>!!url!!</strong> = URL of the link.<br>
  <strong>!!email!!</strong> = Email address for link.<br>
  <strong>!!name!!</strong> = Contact person for the link.
];
$premurl_nopaypal_help =~ s/\n//gi;


print qq[
<br>
<table width="80%" border="0" align="center" cellpadding="3" cellspacing="0" class="aborder">
  <tr>
    <td width="49%">Price in USD:</td>
    <td width="50%"><input name="$usdprice" type="text" id="$usdprice" size="10" /></td>
    <td width="1%" align="right"><img src="$web_url/blank.gif" width="16" height="1"><a href="javascript:void(0)" OnClick="RemoveExpiry('$create')" id="$closewin"></a></td>
  </tr>
  <tr>
    <td width="49%">For how many days is a premium URL/Listing valid? </td>
    <td colspan="2"><input type="text" name="$premium_expire_days" id="$premium_expire_days" size="6" />
      <strong>Days </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('When the link is older than this number of days, then it will not be available as a premium listing anymore and only show as an ordinary link/listing.');" onmouseout="tooltip.hide();" /></td>
  </tr>
  <tr $paypaltrue id="$premspan">
    <td width="37%">Premium Link Order Form URL:
    <img id="esthelp" src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('$premurl_nopaypal_help');" onmouseout="tooltip.hide();" />
    </td>
    <td colspan="2"><input type="text" name="$premium_orderform_url" size="50" id="$premium_orderform_url"/> 
    </td>
  </tr>
</table>
];

}




sub prem_main
{

$boxdiz = qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="99%" class="normaltext">The Premium Link Manager enables you to set and manage aspects of your premium links.</td>
    <td width="1%"><a href="$admin_url/help.cgi?fct=premium_mngr" target="_blank"><img src="$web_url/bhelps.gif" border="0"></a></td>
  </tr>
</table>
];

$hbox = acs::get_heading_box("$web_url/ic_premium.gif", "Premium Link Manager", $boxdiz); 


$bdiz2 = qq[
 <ul class="normaltext">
    <li><strong><a href="$admin_url/admin66.cgi">Browse/Edit Premium Links </a><br>
    </strong>This section enables you to view/delete/edit/move/copy premium links.<br>
    <br>
     </li>
    <li><strong><a href="$admin_url/admin23.cgi">Premium Link Settings </a><br>
    </strong>
    This section allows you to set the amount of days a link will be considered as a   premium link. It also allows you to enter the URL to your order form that users will use   to pay you for premium listings.
    Also comes with other configurable Premium Link Options.</li>
  </ul>
];

$hbox2 = acs::get_heading_box("$web_url/ic_dirm.gif", "Premium Link Settings & Premium Links:", $bdiz2);


$bdiz3 = qq[
 <ul class="normaltext">
    <li><strong><a href="$admin_url/admin65.cgi">Send Email To Premium Link Owners </a><br>
    </strong>Choose this option to send email to premium link owners.<br>
    <br>
     </li>
    <li><strong><a href="$admin_url/admin25.cgi">Email Retrieval </a><br>
    </strong>Enables you to retrieve email addresses of premium links to use third party   mailing software.</li>
  </ul>
];
$hbox3 = acs::get_heading_box("$web_url/ic_email4.gif", "Premium Link Email Functions:", $bdiz3); 


$bdiz4 = qq[
<ul class="normaltext">
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_welcome&premsett=Y">Welcome Email </a><br>
    </strong>This email is sent when a premium submission takes place. It almost acts like an   autoresponder, because it is sent just after a user added a premium listing/link via the   'premium add url' form. This is optional and you can disable this by <strong><a href="$admin_url/admin23.cgi" target="_blank">clicking here</a>.</strong><br>
    <br>
  </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_newsub_accept&premsett=Y">New Premium: Submission   Acceptance Email </a><br>
    </strong>This email is sent to a user when his new premium submission has been approved   for inclusion into the directory.<br>
    <br>
  </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_submissionreject&premsett=Y">New Premium Submission   Rejection Email </a><br>
    </strong>This email is sent to a user when his new premium submission has not been   approved for inclusion into the directory. This might be due to non-payment or other   reasons.<br>
     <br>
  </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_submissioninform&premsett=Y">New Premium Submission Informer Email </a><br>
    </strong>This email is sent to you, to inform you that a new premium submission has been   made. This is optional and you can be disabled by <a href="$admin_url/admin23.cgi"><strong>clicking   here. </strong></a><br>
    <br>
  </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_upgrade&premsett=Y">Upgrade From Standard to Premium Informer Email (PayPal Only)</a><br>
    </strong>This email is sent to you, to inform you that a standard link was upgraded to a premium link. This email is only sent when PayPal is in use.<br>
       <br>
  </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=expiry_emails&premsett=Y">Expiry Emails </a><br>
  </strong>These emails are sent out to premium link owners when premium links are about to   expire or when premium links expired. <strong>(Note that you have to use a CRON program to   send out emails. See the manual for more on this)</strong></li>
  </ul>
];


$hbox4 = acs::get_heading_box("$web_url/ic_email3.gif", "Email Customization:", $bdiz4); 


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
$hbox2
$hbox3
$hbox4
</body>
</html>
];

}







sub save_premium_info
{

$order_url = $q->param('premium_orderform_url');

if ($order_url eq "$web_url/sample_orderf.html"){$order_url = "";}

open (PRM, "> $data_dir/prem.cfg");
 print PRM  "\n"; ### $order_url
 print PRM  "\n"; ### $q->param('premium_expire_days')
 print PRM $q->param('welcome_email') . "\n";
 print PRM $q->param('premium_submission_inform') . "\n";
 print PRM $q->param('month_exp') . "\n";
 print PRM $q->param('week_exp') . "\n";
 print PRM $q->param('exp') . "\n";
 print PRM "\n"; ### $q->param('standard_orderform_url')
 print PRM $q->param('pmode') . "\n";
close (PRM);

#############

open (PAYP, "> $data_dir/paypalset.dat");
	print PAYP $q->param('usepaypal') . "\n";  ### Y
	print PAYP $q->param('paypaluser') . "\n";
	print PAYP $q->param('paypalpass') . "\n";
	print PAYP $q->param('paypalsign') . "\n";
	print PAYP $q->param('currency') . "\n";
	print PAYP $q->param('pitemname') . "\n";
close (PAYP);

#############

open (PAYP, "> $data_dir/pexpiryopt.dat");
	print PAYP $q->param('usdprice') . "::" .   $q->param('premium_expire_days') . "::" . $q->param('premium_orderform_url') . "::" .$q->param('standard_orderform_url') . "\n";
	print PAYP $q->param('usdprice2') . "::" .  $q->param('premium_expire_days2') . "::" . $q->param('premium_orderform_url2') . "::" .$q->param('standard_orderform_url2') . "\n";
	print PAYP $q->param('usdprice3') . "::" .  $q->param('premium_expire_days3') . "::" . $q->param('premium_orderform_url3') . "::" .$q->param('standard_orderform_url3') . "\n";
	print PAYP $q->param('usdprice4') . "::" .  $q->param('premium_expire_days4') . "::" . $q->param('premium_orderform_url4') . "::" .$q->param('standard_orderform_url4') . "\n";
	print PAYP $q->param('usdprice5') . "::" .  $q->param('premium_expire_days5') . "::" . $q->param('premium_orderform_url5') . "::" .$q->param('standard_orderform_url5') . "\n";
	print PAYP $q->param('usdprice6') . "::" .  $q->param('premium_expire_days6') . "::" . $q->param('premium_orderform_url6') . "::" .$q->param('standard_orderform_url6') . "\n";
	print PAYP $q->param('usdprice7') . "::" .  $q->param('premium_expire_days7') . "::" . $q->param('premium_orderform_url7') . "::" .$q->param('standard_orderform_url7') . "\n";
	print PAYP $q->param('usdprice8') . "::" .  $q->param('premium_expire_days8') . "::" . $q->param('premium_orderform_url8') . "::" .$q->param('standard_orderform_url8') . "\n";
	print PAYP $q->param('usdprice9') . "::" .  $q->param('premium_expire_days9') . "::" . $q->param('premium_orderform_url9') . "::" .$q->param('standard_orderform_url9') . "\n";
	print PAYP $q->param('usdprice10') . "::" .  $q->param('premium_expire_days10') . "::" . $q->param('premium_orderform_url10') . "::" .$q->param('standard_orderform_url10') . "\n";
close (PAYP);

#############

		for ($ms = 2; $ms < 11; $ms++) 
			{
				$usdprice_c = $q->param("usdprice" . $ms);
				$premium_expire_days_c = $q->param("premium_expire_days" . $ms);
				
				if ($usdprice_c ne "")
					{
					  $expname = "pexpiry" . $ms;
					  $codelines = $codelines . qq[&lt;input type=&quot;radio&quot; name=&quot;premoption&quot; id=&quot;$expname&quot; value=&quot;$ms&quot;&gt; ($premium_expire_days_c days) \$$usdprice_c &lt;br&gt;<br>];
					}
			}


$gsettings = new_gsettings acs; 

	if ($gsettings->{addurl_reg_system} eq "Yes") 
			{
			
					if ($q->param('usepaypal') eq "Y")
						{
						$purchaseb = "Purchase with Paypal";
						}
						else
						{
						$purchaseb = "Purchase";
						}
					
					
					if ($codelines ne "")
						{
						
							$usdprice1 = $q->param('usdprice');
							$premium_expire_days = $q->param('premium_expire_days');
						
							$codelines = qq[&lt;strong&gt;Please choose an option:&lt;/strong&gt; &lt;br&gt;&lt;br&gt;<br>
							&lt;input type=&quot;radio&quot; name=&quot;premoption&quot; id=&quot;pexpiry1&quot; value=&quot;1&quot; checked &gt; ($premium_expire_days days) \$$usdprice1 &lt;br&gt;<br>] . $codelines;

						
							$step34 = qq[
									<p class="normaltext">3. Go to the  Control Panel &gt;&gt; Template Manager &gt;&gt; <a href="admin6.cgi?t=3#3" target="_blank">3. Add URL Templates</a> &gt;&gt; <a href="$admin_url/admin57.cgi?fct=edit_template&amp;template=rgs_upgrade" target="_blank">Upgrade Page Standard to Premium </a></p>
									<p class="normaltext">4. Add the following to the template:<br />
									(The HTML code below represents the upgrade options available)</p>
									<blockquote>
									<p class="normaltext"> &lt;form id=&quot;upgradeform&quot; name=&quot;upgradeform&quot; method=&quot;post&quot; action=&quot;!!upgradescript!!&quot;&gt;<br>
									$codelines
									&lt;br&gt;&lt;input type=&quot;submit&quot; name=&quot;purchase&quot; id=&quot;purchase&quot; value=&quot; $purchaseb &quot;&gt;<br>
									&lt;input name=&quot;lnkid&quot; type=&quot;hidden&quot; id=&quot;lnkid&quot; value=&quot;!!lnkid!!&quot;&gt;<br>
									&lt;/form&gt;</p>
									</blockquote>							
								];
						}
					
			
					$upgrade_options = qq[
						<table width="100%" border="0" cellpadding="6" cellspacing="0" class="aborder">
						<tr class="bar6">
						<td valign="top" class="tdclass"><span class="normaltext"><strong>If you would like to provide the option where users can upgrade standard listings to premium listings then do the following:</strong></span></td>
						</tr>
						<tr>
						<td valign="top" class="tdclass"><p class="normaltext">1.  Go to the  Control Panel &gt;&gt; Template Manager &gt;&gt; <a href="admin6.cgi?t=3#3" target="_blank">3. Add URL Templates</a> &gt;&gt; Control Panel Templates &gt;&gt; <a href="$admin_url/admin57.cgi?fct=edit_template&amp;template=rgs_acclinks" target="_blank">Account Link Style</a></p>
						<p class="normaltext">2. Place the following somewhere inside the Account Link Style Template:</p>
						<blockquote>
						<p class="normaltext">&lt;a href=&quot;!!upgrade_to_premium!!&quot;&gt;Upgrade to Premium Listing&lt;/a&gt;</p>
						</blockquote>
						
						$step34
						
						</td>
						</tr>
						</table>
						<table border="0" cellpadding="0" cellspacing="0" width="100%"
						background="$web_url/shadow.gif">
						<tr>
						<td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
						<td  width="99%"></td>
						</tr>
						</table>
					];
			}



if ($codelines ne "")
{


	if ($gsettings->{add_url_form} eq "medium")
		{
		$edit_link = "admin57.cgi?fct=edit_template&template=rgs_add_url_medp";
		$pnm = 1;
		}
		else
		{
		$edit_link = "admin57.cgi?fct=edit_template&template=rgs_add_urlp";
		$pnm = 2;
		}
		
	
		

		$prem_options = qq[
				<table width="100%" border="0" cellpadding="6" cellspacing="0" class="aborder">
							  <tr class="bar6">
								 <td height="25" valign="top" class="tdclass"><strong class="normaltext">Multiple Premium Link Expiries Instructions:</strong></td>
							  </tr>
							  <tr>
								 <td valign="top" class="tdclass"><span class="normaltext"><strong class="redtext">Important Please Read:<br>
								 </strong>You have specified more than one <em>premium link expiry option</em>. To provide these options to be available from the Premium Add URL form when users submit a premium link, do the following:
			</p>
								  </span>
								   <blockquote>
								     <p><span class="normaltext">Go to the PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt; <a href="admin6.cgi?t=3#3" target="_blank">3. Add URL Templates</a> &gt;&gt; <a href="$edit_link" target="_blank">Paid Add URL Template $pnm</a><br>
									  <br>
									  <strong>Inside the Premium Add URL Template Place the following HTML Code between the <a href="http://www.focalmedia.net/tutorials/chapter13.html" target="_blank">&lt;FORM&gt;</a> tags:</strong><br>
								     (The HTML Code below will provide your users with duration options when adding a Premium link)
									  </span>
								     <blockquote>
									    <p class="normaltext">
									    $codelines
									    </p>
							         </blockquote>
								     <p class="normaltext"></p>
							</blockquote></td>
							  </tr>
							</table>
							<table border="0" cellpadding="0" cellspacing="0" width="100%"
							  background="$web_url/shadow.gif">
							  <tr>
								 <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
								 <td  width="99%"></td>
							  </tr>
			</table>
		];


}



$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Settings Saved", qq[<a href="$admin_url/admin23.cgi?fct=prem_main">Click Here to Continue</a>]); 

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
$prem_options
$upgrade_options 
</body>
</html>
];


}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "<a href='admin23.cgi?fct=prem_main'>Premium Link Manager</a> :: Premium Link Settings", "Choose an option below:");

print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  

<style type="text/css">

.tdclass1 {    border-color: #E4E4E4;
    border-width: 0px 0px 1px 1px;
    border-style: solid;
    margin: 0;
    padding: 6px;
	font-family: Tahoma, Helvetica, sans-serif;
	font-size: 11px;
	line-height: 18px;    
}

.tdclass
{
    border-color: #E4E4E4;
    border-width: 0px 0px 1px 1px;
    border-style: solid;
    margin: 0;
    padding: 6px;
	font-family: Tahoma, Helvetica, sans-serif;
	font-size: 11px;
	line-height: 18px;    
}

.tdtable 
{
border-width: 1px 1px 0px 0px; 
border-style: solid;
border-color: #E4E4E4;
}

div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}

</style>

<script SRC="$web_url/qtip.js"></script> 

</head>
<body>

$hbox
  
<table width="100%"  height="43" border="0"
  cellpadding="6"
  cellspacing="1" class="tdtable">
    <tr>
      <td class="tdclass" height="15" valign="top" 
      background="$web_url/bar6.gif"><strong>Order Form Settings:</strong></td>
    </tr>
    <tr>
      <td height="25" valign="top" class="tdclass" ><ul>
        <li><strong><a href="admin23.cgi?fct=settings1">Premium Link Settings</a></strong><br />
Let's you set various aspects regarding Premium links.<br />
<br />
        </li>
        <li><a href="admin23.cgi?fct=settings2"><strong>Premium Link Expiries</strong></a><br />
          This option let's you specify premium link expiries. For Example: You could have 3 types of premium links that expire in different intervals. (1 Month, 3 Months, 1 Year for example)<br />
          It also allows you specify the URLs to your order processor if you are not going to use PayPal to process orders.<br />
          <br />
        </li>
        <li><strong><a href="admin24.cgi?fct=expiry_emails">Expiry Emails</a></strong><br />
        These emails are sent out to premium link owners when premium links are about to   expire or when premium links expired. (Note that you have to use a CRON program to   send out emails. See the manual for more on this)</li>
      </ul></td>
    </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td  width="99%"></td>
  </tr>
</table>
</body>
</html>

];

}






sub settings1
{

$approve_email = acs::get_file_contents("$data_dir/prem.cfg");
@pconfig = split (/\n/, $approve_email);

#pconfig[0] = Premium ORDER FORM URL
#pconfig[7] = Standard URL Order Form
#$pconfig[1] = how many days

if ($pconfig[0] eq "") {$pconfig[0] = "$web_url/sample_orderf.html";}

if ($pconfig[2] eq "Yes")
	{
	$welcome_email_yes = "selected";
	}
	else
	{
	$welcome_email_no = "selected";
	}


if ($pconfig[3] eq "Yes")
	{
	$premium_submission_inform_yes = "selected";
	}
	else
	{
	$premium_submission_inform_no = "selected";
	}


if ($pconfig[4] eq "Yes") ### ONE MONTH EXPIRY
	{
	$month_exp_yes = "selected";
	}
	else
	{
	$month_exp_no = "selected";
	}


if ($pconfig[5] eq "Yes") ### ONE WEEK EXPIRY
	{
	$week_exp_yes = "selected";
	}
	else
	{
	$week_exp_no = "selected";
	}


if ($pconfig[6] eq "Yes") ### EXPIRED
	{
	$exp_yes = "selected";
	}
	else
	{
	$exp_no = "selected";
	}


if ($pconfig[8] eq "sandbox") ### EXPIRED
	{
	$sandbox_sel = "selected";
	}
	else
	{
	$livemode = "selected";
	}


#################################

$paypalsettings = acs::get_file_contents("$data_dir/paypalset.dat");
@paypsettings = split (/\n/, $paypalsettings);

$usepaypal  = $paypsettings[0];
$paypaluser = $paypsettings[1];
$paypalpass = $paypsettings[2];
$paypalsign = $paypsettings[3];
$pcurrency = $paypsettings[4];
$pitemname = $paypsettings[5];

if ($pitemname eq "") { $pitemname = "Premium Listing"; }

if ($usepaypal eq "Y")
	{
	$paypaly = "checked";
	}
	else
	{
	$pp1visible1 = qq[style="display:none"];
	$pp1visible2 = qq[style="display:none"];
	$pp1visible3 = qq[style="display:none"];
	}
	
#################################

$expirytsettings = acs::get_file_contents("$data_dir/pexpiryopt.dat");
@expsettings = split (/\n/, $expirytsettings);

($usdprice, $premium_expire_days, $premium_orderform_url, $standard_orderform_url) = split (/::/, $expsettings[0]);

if (($pconfig[0] ne "") and ($premium_orderform_url eq "")) { $premium_orderform_url = $pconfig[0]; }
if (($pconfig[1] ne "") and ($premium_expire_days eq "")) { $premium_expire_days = $pconfig[1]; }
if (($pconfig[7] ne "") and ($standard_orderform_url eq "")) { $standard_orderform_url = $pconfig[7]; }


$acnt = 1;
foreach $eitem (@expsettings)
	{
			if ($acnt > 1)
				{
				($usdprice_a, $premium_expire_days_a, $premium_orderform_url_a, $standard_orderform_url_a) = split (/::/, $eitem);
				 if ($premium_expire_days_a ne "")
				 	{
				 	$last_pbox = $acnt;
				 	}
				}
	$acnt++;				
	}


$premurl_nopaypal_help = qq[
Please specify the URL to the order form of your order processor here. <br>
  Users will be redirected to this URL so that they can make payment. <br>
  You will normally be able to obtain this URL from your order processor. <br><br>
  
  Note that you can use variables inside the URL. This is so that the ID,<br>
  or Title, etc. of the premium link submitted can be passed on to your order <br>
  processor.  This is so that you may know for what link payment was received.<br><br> 
  
  <strong>The following variables can be used inside the URL:</strong><br>
  <strong>!!lnkid!!</strong> = Link id of the link.<br>
  <strong>!!cid!!</strong> = Category id of the link.<br>
  <strong>!!title!!</strong> = Title of the link.<br>
  <strong>!!url!!</strong> = URL of the link.<br>
  <strong>!!email!!</strong> = Email address for link.<br>
  <strong>!!name!!</strong> = Contact person for the link.
];
$premurl_nopaypal_help =~ s/\n//gi;



$acnt = 1;
foreach $eitem (@expsettings)
	{
		if ($acnt > 1)
			{
			($usdprice_a, $premium_expire_days_a, $premium_orderform_url_a, $standard_orderform_url_a) = split (/::/, $eitem);
				
				$obj = "exp" . $acnt;
				
				if ($premium_expire_days_a ne "") 
					{
						$usdprice_name = "usdprice" . $acnt;
						$premium_expire_days_name = "premium_expire_days" . $acnt;
						$premium_orderform_url_name = "premium_orderform_url" . $acnt;
						$standard_orderform_url_name = "standard_orderform_url" . $acnt;
					
						$premspan = "premspan" . $acnt;
						$stanspan = "stanspan" . $acnt;
						
						if ($usepaypal eq "Y") { $paypaltrue = qq[style="display:none"]; }
						
						$closewin = "closewin" . $acnt;
						
						if ($last_pbox == $acnt)
							{
							#$cdisp = "block";
							$cdisp = qq[<img src="$web_url/blank.gif" width="16" height="1"><a href="javascript:void(0)" OnClick="RemoveExpiry('$acnt')" id="$closewin" style="display: block"></a>];
							}
							else
							{
							#$cdisp = "none";
							$cdisp = qq[<img src="$web_url/blank.gif" width="16" height="1"><a href="javascript:void(0)" OnClick="RemoveExpiry('$acnt')" id="$closewin" style="display: none"></a>];
							}
					
							$expoptions{$obj} = qq[
								<br>
								<table width="80%" border="0" align="center" cellpadding="3" cellspacing="0" class="aborder">
								  <tr>
									 <td width="49%">Price in USD:</td>
								    <td width="50%"><input name="$usdprice_name" type="text" id="$usdprice_name" value="$usdprice_a" size="10" /></td>
									 <td width="1%" align="right">$cdisp</td>
								  </tr>
								  <tr>
									 <td width="49%">For how many days is a premium URL/Listing valid? </td>
								    <td colspan="2"><input name="$premium_expire_days_name" type="text" id="$premium_expire_days_name" value="$premium_expire_days_a" size="6" />
										<strong>Days </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('When the link is older than this number of days, then it will not be available as a premium listing anymore and only show as an ordinary link/listing.');" onmouseout="tooltip.hide();" /></td>
								  </tr>
								  <tr $paypaltrue id="$premspan">
									 <td>Premium Link Order Form URL: <img id="esthelp" src="$web_url/est_help.gif" style="vertical-align:middle" 
								    onmouseover="tooltip.show('$premurl_nopaypal_help');" onmouseout="tooltip.hide();" /></td>
								    <td colspan="2"><input name="$premium_orderform_url_name" type="text" id="$premium_orderform_url_name" value="$premium_orderform_url_a" size="50"/></td>
								  </tr>
								</table>
							];
					}
				
			}
		$acnt++;
		
	}


if ($closewin eq "closewin10") { $bdisplay = qq[style="display:none"]; }

if ($usepaypal eq "Y") { $paypaltruen = qq[style="display:none"]; }


#################################

$boxdiz = qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="88%" class="normaltext"><a href="$admin_url/admin23.cgi?fct=prem_main"><b>Premium Link Manager</b></a> >> Premium Link Settings</td>
    <td width="6%" valign="top" align="right"><a href="$admin_url/help.cgi?fct=prem_settings"
    target="_blank"><strong><img src="$web_url/bhelps.gif" border="0"> </strong></a></td>
  </tr>
</table>
];

$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Premium Link Settings", $boxdiz);


$qhdiz = qq[
<p><strong>Premium URL: Submission Basics </strong><br>
Users will have to click on the 'Add Premium Listing' link from your Search
Engine/Directory to submit premium listings. Once clicked they will be taken to the new submission
form, just as if they clicked the normal 'add url' link from your Search Engine/Directory.
After completing the 'new submission' form, they will be
redirected to a payment form  or PayPal. </p>

<p><strong>Payment Forms / Order Processors:</strong><br>
Users will be redirected to PayPal for payment or the URLs to order forms of order processors that you specify. This will happen after users add a new premium listing.</p>

<p><strong>PayPal Notes:</strong><br> 
When PayPal is used to process payments for the premium links then premium links still needs approval from the 'New Submissions' section before they will be available in the Index. When users choose to upgrade a standard link to a premium link then the link will just change to a premium link and approval is not necessary before the link changes from a standard link to a premium link.</p>
];

$helpb = acs::quick_help("Help:",$qhdiz); 



$tophelp = qq[
<strong>If you use PayPal:</strong><br><br>
If you use PayPal then users submitting premium links will be redirected to PayPal<br>
  to make payment for the premium link. Note that the premium link being submitted <br>
  will only become a premium link once payment was successfully processed by <br>
PayPal.<br><br>
In the event where the user does not complete the transaction (chickens out) <br>
the premium link    that was  submitted will just be a standard link instead of a <br>
  premium link. The link can then be upgraded to a premium link from the user <br>
  control panel in future.<br><br>
It is important to note that the premium link that was submitted and successfully<br>
paid for with PayPal still needs to be approved by the Administrator.<br>
This can be done in the <br><em>PowerSeek Control Panel &gt;&gt; To Do &gt;&gt;  Approve/Edit New Submissions </em><br>
  Premium submissions will always be listed first (at the top) in this section.
<br><br>
<strong>If you don\\'t use PayPal:</strong><br><br>
The easiest method of handling payments would be to use PayPal as it is integrated<br>
into PowerSeek. If you are using another order processor then you can disable<br>
the use of PayPal and use the other order processor instead.<br><br>
When using another order processor you can place the URLs to the order <br>
processor order forms in the <em>premium link settings</em> section. When payment<br>
time arrives PowerSeek will then redirect users to the URLs you specified<br>
to the order processor.
];
$tophelp =~ s/\n//gi;


$standard_paid = qq[
If you would like to sell standard listings as well then provide the <br>
Order Form URL for standard listings here. <br>
<b>Leave blank if you don\\'t intend to charge a fee for standard links.</b>
<br><Br>
  
  Note that you can use variables inside the URL. This is so that the ID,<br>
  or Title, etc. of the link submitted can be passed on to your order <br>
  processor.  This is so that you may know for what link payment was received.<br><br> 
  
  <strong>The following variables can be used inside the URL:</strong><br>
  <strong>!!lnkid!!</strong> = Link id of the link.<br>
  <strong>!!cid!!</strong> = Category id of the link.<br>
  <strong>!!title!!</strong> = Title of the link.<br>
  <strong>!!url!!</strong> = URL of the link.<br>
  <strong>!!email!!</strong> = Email address for link.<br>
  <strong>!!name!!</strong> = Contact person for the link.
];
$standard_paid =~ s/\n//gi;

###########################

if ($pcurrency eq "USD") { $curs[0] = "selected"; }
if ($pcurrency eq "GBP") { $curs[1] = "selected"; }
if ($pcurrency eq "EUR") { $curs[2] = "selected"; }
if ($pcurrency eq "AUD") { $curs[3] = "selected"; }
if ($pcurrency eq "CAD") { $curs[4] = "selected"; }
if ($pcurrency eq "CZK") { $curs[5] = "selected"; }
if ($pcurrency eq "DKK") { $curs[6] = "selected"; }
if ($pcurrency eq "HKD") { $curs[7] = "selected"; }
if ($pcurrency eq "HUF") { $curs[8] = "selected"; }
if ($pcurrency eq "ILS") { $curs[9] = "selected"; }
if ($pcurrency eq "JPY") { $curs[10] = "selected"; }
if ($pcurrency eq "MXN") { $curs[11] = "selected"; }
if ($pcurrency eq "NOK") { $curs[12] = "selected"; }
if ($pcurrency eq "NZD") { $curs[13] = "selected"; }
if ($pcurrency eq "PHP") { $curs[14] = "selected"; }
if ($pcurrency eq "PLN") { $curs[15] = "selected"; }
if ($pcurrency eq "SGD") { $curs[16] = "selected"; }
if ($pcurrency eq "SEK") { $curs[17] = "selected"; }
if ($pcurrency eq "CHF") { $curs[18] = "selected"; }
if ($pcurrency eq "TWD") { $curs[19] = "selected"; }
if ($pcurrency eq "THB") { $curs[20] = "selected"; }


###########################

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
<style type="text/css">
<!--
.tdclass1 {    border-color: #E4E4E4;
    border-width: 0px 0px 1px 1px;
    border-style: solid;
    margin: 0;
    padding: 6px;
	font-family: Tahoma, Helvetica, sans-serif;
	font-size: 11px;
	line-height: 18px;    
}
.tdclass1 {    border-color: #E4E4E4;
    border-width: 0px 0px 1px 1px;
    border-style: solid;
    margin: 0;
    padding: 6px;
	font-family: Tahoma, Helvetica, sans-serif;
	font-size: 11px;
	line-height: 18px;    
}
.tdclass1 {    border-color: #E4E4E4;
    border-width: 0px 0px 1px 1px;
    border-style: solid;
    margin: 0;
    padding: 6px;
	font-family: Tahoma, Helvetica, sans-serif;
	font-size: 11px;
	line-height: 18px;    
}

#closewin { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin:hover { background-position: 0 -16px; } 
#closewin span {display: none; } 

#closewin1 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin1:hover { background-position: 0 -16px; } 
#closewin1 span {display: none; } 

#closewin2 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin2:hover { background-position: 0 -16px; } 
#closewin2 span {display: none; } 

#closewin3 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin3:hover { background-position: 0 -16px; } 
#closewin3 span {display: none; } 

#closewin4 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin4:hover { background-position: 0 -16px; } 
#closewin4 span {display: none; } 

#closewin5 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin5:hover { background-position: 0 -16px; } 
#closewin5 span {display: none; } 

#closewin6 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin6:hover { background-position: 0 -16px; } 
#closewin6 span {display: none; } 

#closewin7 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin7:hover { background-position: 0 -16px; } 
#closewin7 span {display: none; } 

#closewin8 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin8:hover { background-position: 0 -16px; } 
#closewin8 span {display: none; } 

#closewin9 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin9:hover { background-position: 0 -16px; } 
#closewin9 span {display: none; } 

#closewin10 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin10:hover { background-position: 0 -16px; } 
#closewin10 span {display: none; } 

-->
</style>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  

<style type="text/css">

.tdclass
{
    border-color: #E4E4E4;
    border-width: 0px 0px 1px 1px;
    border-style: solid;
    margin: 0;
    padding: 6px;
	font-family: Tahoma, Helvetica, sans-serif;
	font-size: 11px;
	line-height: 18px;    
}

.tdtable 
{
border-width: 1px 1px 0px 0px; 
border-style: solid;
border-color: #E4E4E4;
}

div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}

</style>
<script SRC="$web_url/qtip.js"></script> 
<script language="javascript">

function RemoveExpiry(expItem)
	{
		var agree=confirm("Are you sure you want to remove this option?");
		if (agree)
			{
			var pitem = 'exp' + expItem;
			document.getElementById(pitem).innerHTML = '';			
			document.getElementById('addbutton').style.display = 'block';
			}
			else
			{
			return false;
			}
		
		 var cwin; var lastb = 1;
				 for (i=1; i<=10; i++)
				 {
				  cwin = 'closewin' + i;
				  if (document.getElementById(cwin))
				  	 {
				  		lastb = i;
				  	 }
			 	 }
			if (lastb > 1) { document.getElementById('closewin' + lastb).style.display = 'block'; }
		
	}


function clickpaypal()
	{
	if (document.getElementById('usepaypal').checked == true)
		{
			document.getElementById('pp1').style.display = 'block';
			document.getElementById('pp2').style.display = 'block';
			document.getElementById('pp3').style.display = 'block';
			document.getElementById('pp4').style.display = 'block';
			document.getElementById('pp5').style.display = 'block';
			document.getElementById('pp6').style.display = 'block';
			
			document.getElementById('premurl1').style.display = 'none';
			document.getElementById('standurl1').style.display = 'none';
			
				 var foundnr = 0; var boxtocreate = 0;
					 for (i=1; i<=10; i++)
					 {
						var premdisp = 'premspan' + i;
						var standisp = 'stanspan' + i;
						
						if (document.getElementById(premdisp)) { 	document.getElementById(premdisp).style.display = 'none'; }
						if (document.getElementById(standisp)) {  document.getElementById(standisp).style.display = 'none'; }
					 }

		}
		else
		{
			document.getElementById('pp1').style.display = 'none';
			document.getElementById('pp2').style.display = 'none';
			document.getElementById('pp3').style.display = 'none';
			document.getElementById('pp4').style.display = 'none';
			document.getElementById('pp5').style.display = 'none';
			document.getElementById('pp6').style.display = 'none';

			document.getElementById('premurl1').style.display = 'block';
			document.getElementById('standurl1').style.display = 'block';

				 var foundnr = 0; var boxtocreate = 0;
					 for (i=1; i<=10; i++)
					 {
						var premdisp = 'premspan' + i;
						var standisp = 'stanspan' + i;
						
						if (document.getElementById(premdisp)) { 	document.getElementById(premdisp).style.display = 'block'; }
						if (document.getElementById(standisp)) {  document.getElementById(standisp).style.display = 'block'; }
					 }
			
		}
	}


function xmlhttpPost(strURL, action_img)
	 {
	 	
	 	 var foundnr = 0; var boxtocreate = 0;
		 for (i=2; i<=10; i++)
		 {
		 	var usdnm = 'usdprice' + i;
			if (document.getElementById(usdnm) == null) 
				{
					if (foundnr == 0)
						{
							boxtocreate = i;
							foundnr++;
						}
				}
			
			var cwin = 'closewin' + i;
			if (document.getElementById(cwin))
				{
				document.getElementById(cwin).style.display = 'none';
				}
		 }
	 	foundnr = 0;
	 	display_area = 'exp' + boxtocreate;
	 	
	 	if (boxtocreate == 10)
	 		{
	 		document.getElementById('addbutton').style.display = 'none';
	 		}
	 	
	 	strURL = strURL + '&create=' + boxtocreate;
	 	
	 	if (document.getElementById('usepaypal').checked == true)
	 		{
	 		strURL = strURL + '&create=' + boxtocreate + '&paypal=true';
	 		}

	 document.getElementById(action_img).style.display='block';
 
    var xmlHttpReq = false;
    var self = this;
 		
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest(); }
 
    // IE
    else if (window.ActiveXObject) { self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP"); }
 
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function()
    	   {
         if (self.xmlHttpReq.readyState == 4)
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText;
         		document.getElementById(action_img).style.display='none';
         		}
    		}
 
    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
 
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
   }

function check_errors()
	{
		if (document.getElementById('usepaypal').checked == true)
			{
				if (document.getElementById('paypaluser').value == '') { alert ('You have to provide a PayPal API user name.'); return false; }
				if (document.getElementById('paypalpass').value == '') { alert ('You have to provide a PayPal API password.');  return false; }
				if (document.getElementById('paypalsign').value == '') { alert ('You have to provide a PayPal API signature.'); return false; }
				if (document.getElementById('usdprice').value == '') { alert ('You have to provide a price in USD for the first expiry option.'); return false; }
				if (document.getElementById('premium_expire_days').value == '') { alert ('You have to provide the number of days which the premium link will be valid for the first expiry option.'); return false; }
				
				var usdprice; 
				var premium_expire_days; 
				
				 for (i=2; i<11; i++)
				 {
				 	usdprice = 'usdprice' + i;
				 	premium_expire_days = 'premium_expire_days' + i;
				 
						if (document.getElementById(usdprice)) 
							{
							if (document.getElementById(usdprice).value == '') { alert ('You have to provide a price for option box ' + i); return false; }
							}

						if (document.getElementById(premium_expire_days)) 
							{
							if (document.getElementById(premium_expire_days).value == '') { alert ('You have to provide the number of days the premium URL will be valid for option box ' + i); return false; }
							}
				 }
				
			}
			else
			{
				if (document.getElementById('premium_expire_days').value == '') { alert ('You have to provide the number of days which the premium link will be valid for the first expiry option.'); return false; }
				if (document.getElementById('premium_orderform_url').value == '') { alert ('You have to provide a URL to the order form of your order processor.'); return false; }

					var usdprice; 
					var premium_expire_days; 
					var premium_orderform_url;

					 for (i=2; i<11; i++)
					 {
						usdprice = 'usdprice' + i;
						premium_expire_days = 'premium_expire_days' + i;
						premium_orderform_url = 'premium_orderform_url' + i;

							if (document.getElementById(usdprice)) 
								{
								if (document.getElementById(usdprice).value == '') { alert ('You have to provide a price for option box ' + i); return false; }
								}

							if (document.getElementById(premium_expire_days)) 
								{
								if (document.getElementById(premium_expire_days).value == '') { alert ('You have to provide the number of days the premium URL will be valid for option box ' + i); return false; }
								}

							if (document.getElementById(premium_orderform_url)) 
								{
								if (document.getElementById(premium_orderform_url).value == '') { alert ('You have to provide a URL to your order processor for option box ' + i); return false; }
								}
					 }
				
			}
	}		


</script>

</head>
<body>
  $hbox

<form method="post" action="$admin_url/admin23.cgi" style="margin-bottom:0; margin-top:0;" onSubmit="return check_errors();">
<input type="hidden" name="fct" value="save_premium_info" />
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="1%" valign="top" class="saveback"><img src="$web_url/saveback3.png" width="15" height="34" /></td>
    <td width="99%"><table width="100%" border="0" cellpadding="6" cellspacing="0" class="tdtable">
      <tr>
      <td class="tdclass" height="15" colspan="2" valign="top" 
      background="$web_url/bar6.gif"><strong>PayPal Settings:</strong></td>
    </tr>
    <tr>
      <td class="tdclass" width="40%" height="25" valign="top">Would you like to use PayPal?
      </td> 
      <td class="tdclass" width="60%" height="25" valign="top"><input type="checkbox" name="usepaypal" id="usepaypal" onclick="clickpaypal();" value="Y" $paypaly/>
      <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('$tophelp');" onmouseout="tooltip.hide();">
      </td>
    </tr>
    <tr id="pp1" $pp1visible1>
      <td class="tdclass" valign="top">PayPal API UserName: </td>
      <td class="tdclass" valign="top"><input type="text"
			name="paypaluser" size="50" value="$paypaluser" id="paypaluser" />
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
    </tr>
    <tr id="pp2" $pp1visible2>
      <td class="tdclass" valign="top" >PayPal API Password: </td>
      <td class="tdclass" valign="top" ><input type="text"
			name="paypalpass" size="50" value="$paypalpass" id="paypalpass" />
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
    </tr>
    <tr id="pp3" $pp1visible3>
      <td class="tdclass" valign="top">Sinature:</td>
      <td class="tdclass" valign="top"><input type="text" name="paypalsign" size="50" value="$paypalsign" id="paypalsign" />
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
    </tr>
    <tr id="pp5" $pp1visible3>
      <td class="tdclass" valign="top">Currency:</td>
      <td class="tdclass" valign="top">
      
      <select name="currency" id="currency">
        <option value="USD" $curs[0]>U.S. Dollar</option>
        <option value="GBP" $curs[1]>Pound Sterling</option>
        <option value="EUR" $curs[2]>Euro</option>
        <option value="AUD" $curs[3]>Australian Dollar </option>
        <option value="CAD" $curs[4]>Canadian Dollar </option>
        <option value="CZK" $curs[5]>Czech Koruna </option>
        <option value="DKK" $curs[6]>Danish Krone  </option>
        <option value="HKD" $curs[7]>Hong Kong Dollar</option>
        <option value="HUF" $curs[8]>Hungarian Forint</option>        
        <option value="ILS" $curs[9]>Israeli New Sheqel</option>
        <option value="JPY" $curs[10]>Japanese Yen</option>
        <option value="MXN" $curs[11]>Mexican Peso</option>
        <option value="NOK" $curs[12]>Norwegian Krone</option>
        <option value="NZD" $curs[13]>New Zealand Dollar</option>
        <option value="PHP" $curs[14]>Philippine Peso</option>
        <option value="PLN" $curs[15]>Polish Zloty</option>
        <option value="SGD" $curs[16]>Singapore Dollar</option>                
        <option value="SEK" $curs[17]>Swedish Krona</option>                
        <option value="CHF" $curs[18]>Swiss Franc</option>                
        <option value="TWD" $curs[19]>Taiwan New Dollar</option>                
        <option value="THB" $curs[20]>Thai Baht</option>
        
      </select></td>
    </tr>
    <tr id="pp4" $pp1visible3>
      <td class="tdclass" valign="top">PayPal Mode:</td>
      <td class="tdclass" valign="top">
        <select name="pmode" id="pmode">
		          <option value="live" $livemode>PayPal Live Production Mode</option>
		          <option value="sandbox" $sandbox_sel>Use PayPal Sandbox</option>
        </select>
        <img src="$web_url/est_help.gif" style="vertical-align:middle" 
        onmouseover=" tooltip.show('<b>Live Production Mode:</b> Payments will be handled by PayPal and is the system is \\'live\\' <br><br> <b>Use PayPal Sandbox:</b> PayPal Test mode using the PayPal sandbox. PayPal is not \\'live\\' and payments will not be processed. This mode is only for testing purposes. ');" onmouseout="tooltip.hide();" /></td>
    </tr>


    <tr id="pp6" $pp1visible3>
      <td class="tdclass" valign="top">Purchase Item Name:</td>
      <td class="tdclass" valign="top">
		   <input name="pitemname" type="text" id="pitemname" size="50" value="$pitemname">
        <img src="$web_url/est_help.gif" style="vertical-align:middle" 
        onmouseover=" tooltip.show('This name will be displayed with the price when making the purchase at Paypal');" onmouseout="tooltip.hide();" /></td>
    </tr>


    
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td  width="99%"></td>
    </tr>
  </table>
  <table width="100%"  border="0"
  cellpadding="6"
  cellspacing="0" class="tdtable">
    <tr>
      <td width="100%" height="15" valign="top" 
      background="$web_url/bar6.gif" class="tdclass"><strong>Premium Link Order Form Expiry Options:</strong></td>
    </tr>
    <tr>
      <td height="25" valign="top" class="tdclass" ><br />
       
	   <table width="80%" border="0" align="center" cellpadding="3" cellspacing="0" class="aborder">
	          <tr>
	            <td width="49%">Price in USD:</td>
	            <td width="50%"><input name="usdprice" type="text" id="usdprice" size="10" value="$usdprice"/></td>
	            <td width="1%" align="right"><img src="$web_url/blank.gif" width="16" height="1"></td>
	         </tr>
	          <tr>
	            <td>For how many days is a premium URL/Listing valid? </td>
	            <td colspan="2"><input type="text" name="premium_expire_days" id="premium_expire_days" size="6" value="$premium_expire_days" />
	              <strong>Days </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('When the link is older than this number of days, it will not be available as a premium listing anymore and only show as an ordinary link/listing.');" onmouseout="tooltip.hide();" /></td>
	          </tr>
	          
	          <tr id="premurl1" $paypaltruen>
	            <td>Premium Link Order Form URL: <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('$premurl_nopaypal_help');" onmouseout="tooltip.hide();" /></td>
	            <td colspan="2"><input type="text" name="premium_orderform_url" size="50" value="$premium_orderform_url" id="premium_orderform_url"/>
	              </td>
	          </tr>
	          <tr id="standurl1" $paypaltruen>
	            <td>Standard Link Order Form:
	            <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('$standard_paid');" onmouseout="tooltip.hide();" />
	            </td>
	            <td colspan="2"><input type="text"
	      name="standard_orderform_url" size="50" value="$standard_orderform_url" id="standard_orderform_url"/>
	              </td>
	          </tr>
        </table>
        
        <span id="exp1">$expoptions{'exp1'}</span> 
        <span id="exp2">$expoptions{'exp2'}</span> 
        <span id="exp3">$expoptions{'exp3'}</span> 
        <span id="exp4">$expoptions{'exp4'}</span> 
        <span id="exp5">$expoptions{'exp5'}</span> 
        <span id="exp6">$expoptions{'exp6'}</span> 
        <span id="exp7">$expoptions{'exp7'}</span> 
        <span id="exp8">$expoptions{'exp8'}</span>
        <span id="exp9">$expoptions{'exp9'}</span>
        <span id="exp10">$expoptions{'exp10'}</span>
        
        <table width="80%" border="0" align="center" cellpadding="0" cellspacing="0">
          <tr>
            <td align="right"><br />
              
              <span id="addbutton" $bdisplay>
              <table width="80%" border="0" cellspacing="0" cellpadding="0">
                <tr>
                  <td width="98%" align="right"><img src="$web_url/ajload3.gif" style="display:none" id="loader" /></td>
                  <td width="1%"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('You can add additional expiry options here. If you would like to have options where links expire within 30 days, 60 days or 120 days then you would add two additional options for 60 and 120 days for example. The first option would be 30 days.&lt;br&gt;&lt;Br&gt;For Example: You could provide the options where it\\'s \$5 for 30 days, \$7 for 60 days and \$15 for 120 days.&lt;br&gt;&lt;Br&gt;Note that you can add up to 9 additional options.');" onmouseout="tooltip.hide();" /></td>
                  <td width="1%"><input type="submit" name="adddays" id="adddays" value="Add additional expiry options" class="psbutton" onclick="xmlhttpPost('$admin_url/admin23.cgi?fct=addexpiry&amp;d=' + parseInt(Math.random()*10000) + '&amp;', 'loader'); return false;" /></td>
                </tr>
              </table>
              </span>
              
              </td>
          </tr>
        </table>
        <br /></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td  width="99%"></td>
    </tr>
  </table>
  <table width="100%"  border="0"
  cellpadding="6"
  cellspacing="0" class="tdtable">
    <tr>
      <td class="tdclass" height="15" colspan="2" valign="top" 
      background="$web_url/bar6.gif"><strong>Email Settings:</strong></td>
    </tr>
    <tr>
      <td class="tdclass" width="40%" valign="top" >Send a 'Welcome Email' when a Premium URL is submitted? </td>
      <td class="tdclass" width="60%" valign="top" ><select name="welcome_email"
      size="1">
        <option $welcome_email_yes value="Yes"> Yes </option>
        <option $welcome_email_no value="No"> No </option>
      </select>
        (<a href="$admin_url/admin24.cgi?fct=edit_welcome&amp;s=s" target="_blank">Edit Welcome Email</a>)</td>
    </tr>
    <tr>
      <td class="tdclass" valign="top" >Be informed
        via email when a Premium URL is submitted? </td>
      <td class="tdclass" valign="top" ><select
      name="premium_submission_inform" size="1">
        <option $premium_submission_inform_yes value="Yes"> Yes </option>
        <option $premium_submission_inform_no value="No"> No </option>
      </select></td>
    </tr>
    <tr>
      <td class="tdclass" valign="top" >Send one month expiry email: </td>
      <td class="tdclass" valign="top" ><select name="month_exp"
      size="1">
        <option $month_exp_yes value="Yes"> Yes </option>
        <option $month_exp_no value="No"> No </option>
      </select>
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('An email will be sent to link owners who\\'s link will expire in one month if set to \\'Yes\\'.  This email can be customized when in the Control Panel &gt;&gt; Plugins &gt;&gt; Premium Link Manager &gt;&gt; Expiry Emails - Note that you have to use a CRON program to send out emails. See the manual for more on this.');" onmouseout="tooltip.hide();" /></td>
    </tr>
    <tr>
      <td class="tdclass" valign="top" >Send one week expiry email: </td>
      <td class="tdclass" valign="top" ><select name="week_exp"
      size="1">
        <option $week_exp_yes value="Yes"> Yes </option>
        <option $week_exp_no value="No"> No </option>
      </select>
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('An email will be sent to link owners who\\'s link will expire in one week if set to \\'Yes\\'.  This email can be customized when in the Control Panel &gt;&gt; Plugins &gt;&gt; Premium Link Manager &gt;&gt; Expiry Emails - Note that you have to use a CRON program to send out emails. See the manual for more on this.');" onmouseout="tooltip.hide();" /></td>
    </tr>
    <tr>
      <td class="tdclass" valign="top" >Send email when link expires: </td>
      <td class="tdclass" valign="top" ><select name="exp" size="1">
        <option $exp_yes value="Yes"> Yes </option>
        <option $exp_no value="No"> No </option>
      </select>
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('An email will be sent to link owners who\\'s link expired. This email can be customized when in the Control Panel &gt;&gt; Plugins &gt;&gt; Premium Link Manager &gt;&gt; Expiry Emails - Note that you have to use a CRON program to send out emails. See the manual for more on this.');" onmouseout="tooltip.hide();" /></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td  width="99%"></td>
    </tr>
  </table>

  </td>
  </tr>
  <tr>
    <td valign="top"><img src="$web_url/saveback2.png" width="15" height="34" /></td>
    <td height="42">
       <input type="submit" value="    Save All Settings    " name="B1" class="psbutton"/>
    </td>
  </tr>
</table>
<br>
$helpb <br />
</form>

</body>
</html>
];


}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

