#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "save_bslots") {&save_bslots;}

##################################################################################


sub save_bslots
{

$cid = $q->param('cid');
$ecat = $q->param('ecat');
$set_sub = $q->param('set_sub');
     
$bslot1 = $q->param('bslot1'); if ($bslot1 eq "None") { $bslot1 = ""; }
$bslot2 = $q->param('bslot2'); if ($bslot2 eq "None") { $bslot2 = ""; }
$bslot3 = $q->param('bslot3'); if ($bslot3 eq "None") { $bslot3 = ""; }
$bslot4 = $q->param('bslot4'); if ($bslot4 eq "None") { $bslot4 = ""; }
$bslot5 = $q->param('bslot5'); if ($bslot5 eq "None") { $bslot5 = ""; }
     
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


if ($set_sub eq "Y")
{
$ecat = substr($ecat, 0, length($ecats) - 1);

@all_cats = split (/\//, $ecat);

$lcount = 1;
foreach $item (@all_cats)
	{
	$decoded_cat = acs::decode_dir($item);
	$disp_string = $disp_string  . "$decoded_cat/";
	
	$decoded_cat =~ s/'/\\'/g;
	$sql_where = $sql_where . " (l" . $lcount . "= '$decoded_cat') AND";
	$lcount++;
	}

$sql_where = substr($sql_where, 0, length($sql_where) - 3);

$sql = "UPDATE dirs SET addslot1 = '$bslot1',
								addslot2 = '$bslot2', 
								addslot3 = '$bslot3', 
								addslot4 = '$bslot4', 
								addslot5 = '$bslot5' 
								WHERE $sql_where";

}
else
{
$sql = "UPDATE dirs SET addslot1 = '$bslot1',
								addslot2 = '$bslot2', 
								addslot3 = '$bslot3', 
								addslot4 = '$bslot4', 
								addslot5 = '$bslot5' 
								WHERE cid = '$cid'";
}


$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

$sth->finish;
$dbh->disconnect;


$boxdiz = qq[
<p>Adverts/Banners assigned to banner slots. <br>
<br>
Please click your browser's refresh button in the parent window (browser window from where
this one was opened) to see the changes you have just made. </p>
<p><strong>You may now <a href="javascript:onClick=window.close()">close</a> this window.</strong></p>
];

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Assign Adverts/Banners To Category/Directory", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

}







sub start
{

$cid = $q->param('cid');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$sql = "SELECT * FROM dirs WHERE cid = '$cid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

while ( @row = $sth->fetchrow() )
	{
  	$cats	= "";
 	for ($ms1 = 2; $ms1 < 18; $ms1++) 
 		{
 		if ($row[$ms1] ne "")
 			{
 			$ecat = $ecat . acs::encode_dir($row[$ms1]) . "/"; 
 			$cats = $cats . $row[$ms1] . "/";
 			}
 		}
  	
  	$adslot1 = $row[30];
  	$adslot2 = $row[31];
  	$adslot3 = $row[32];
  	$adslot4 = $row[33];
  	$adslot5 = $row[34];
  	$ctemplate = $row[27];
	}


######

if ($ctemplate eq "")
	{
	$curr_templ = acs::get_file_contents("$data_dir/defdir.html"); 
	$tmpl_in_use = "Default";
	}
	else
	{
	$curr_templ = acs::get_file_contents("$data_dir/$ctemplate" . "-1ctst.html");
	$tmpl_in_use = $ctemplate;
	}

###### PRINT TOP OF PAGE

$bbdiz = qq[
<p>Choose a group of HTML/Text Adverts or Banners to be rotated in:<br>
<strong>$cats<br>
</strong>Template in use for this category:<br>
<strong>$tmpl_in_use</strong></p>
];

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Assign Banners or HTML/Text Adverts To Category/Directory", $bbdiz);

$jsp1 = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
<script LANGUAGE="JavaScript"> 
$jsp1
</script>
</head>
<body>
$hbox
];



if ($curr_templ !~ /%%bannerslot/i)
	{
	$sth->finish;
	$dbh->disconnect;
	&no_banner_slots_available; exit;
	}





$optionbox = "<select name=\"box_name\" size=\"1\">
<option value=\"None\">None</option>";


### GET ADVERT GROUPS

$sql = "SELECT * FROM advertgrp ORDER BY groupname";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
$rows = $sth->rows(); 

	if ($rows > 0)
		{
		$optionbox = $optionbox . qq[<option value=""></option>]; 
		$optionbox = $optionbox . qq[<option value="">------Text/HTML Advert Groups:-----</option>]; 
		}

while ( @row = $sth->fetchrow() )
	{
	$optionbox = $optionbox . "<option value=\"$row[1]-$row[0]-A\">$row[1]</option>";
 	}


### GET BANNER GROUPS

$sql = "SELECT * FROM bannergrp ORDER BY groupname";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
$rows = $sth->rows(); 

if ($rows > 0) 
	{
	$optionbox = $optionbox . qq[<option value=""></option>]; 
	$optionbox = $optionbox . qq[<option value="">------Banner Groups:-----</option>]; 
	} 

while ( @row = $sth->fetchrow() )
	{
	$optionbox = $optionbox . "<option value=\"$row[1]-$row[0]-B\">$row[1]</option>";
 	}




$sth->finish;
$dbh->disconnect;


$optionbox = $optionbox . "<option value=\"\"></option></select>";



### CREATE BANNER SLOT SELECTION TABLE

$sel_table = qq[
<table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="32%" height="30" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Advert/Banner Slots Available:</strong></td>
    <td width="68%" height="30" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Select an Advert or Banner Group to Rotate For Advert/Banner Slot to the left</strong></td>
  </tr>
];


if ((substr($adslot1, (length($adslot1) - 2), 2) ne "-A") and (substr($adslot1, (length($adslot1) - 2), 2) ne "-B")) {  $adslot1 = $adslot1 . "-B"; }
if ((substr($adslot2, (length($adslot2) - 2), 2) ne "-A") and (substr($adslot2, (length($adslot2) - 2), 2) ne "-B")) {  $adslot2 = $adslot2 . "-B"; }
if ((substr($adslot3, (length($adslot3) - 2), 2) ne "-A") and (substr($adslot3, (length($adslot3) - 2), 2) ne "-B")) {  $adslot3 = $adslot3 . "-B"; }
if ((substr($adslot4, (length($adslot4) - 2), 2) ne "-A") and (substr($adslot4, (length($adslot4) - 2), 2) ne "-B")) {  $adslot4 = $adslot4 . "-B"; }
if ((substr($adslot5, (length($adslot5) - 2), 2) ne "-A") and (substr($adslot5, (length($adslot5) - 2), 2) ne "-B")) {  $adslot5 = $adslot5 . "-B"; }


######## BANNER SLOT ENTRIES

if ($curr_templ =~ /%%bannerslot1%%/)
	{
	$current_optionbox = $optionbox;
	
	if ($adslot1 ne "")
		{
		$crit = "value=\"$adslot1\"";
		$rcrit ="value=\"$adslot1\" selected"; 
		$current_optionbox =~ s/$crit/$rcrit/g;
		
		
		
		}

$current_optionbox =~ s/box_name/bslot1/g;
$current_optionbox = qq[
<tr align="center">
 <td width="25%" bgcolor="#FFFFFF"><div align="left"><span class="normaltext">Advert/Banner Slot 1</span></td>
 <td width="85%" bgcolor="#FFFFFF"><div align="left">
 $current_optionbox 
 </td>
</tr>
];

	$sel_table = $sel_table . $current_optionbox;
	}



if ($curr_templ =~ /%%bannerslot2%%/)
	{
	$current_optionbox = $optionbox;

	if ($adslot2 ne "")
		{
		$crit = "value=\"$adslot2\"";
		$rcrit ="value=\"$adslot2\" selected"; 
		$current_optionbox =~ s/$crit/$rcrit/g;
		}

$current_optionbox =~ s/box_name/bslot2/g;
$current_optionbox = qq[
<tr align="center">
 <td width="25%" bgcolor="#FFFFFF"><div align="left"><span class="normaltext">Advert/Banner Slot 2</span></td>
 <td width="85%" bgcolor="#FFFFFF"><div align="left">
 $current_optionbox 
 </td>
</tr>
];

	$sel_table = $sel_table . $current_optionbox;
	}


if ($curr_templ =~ /%%bannerslot3%%/)
	{
	$current_optionbox = $optionbox;

	if ($adslot3 ne "")
		{
		$crit = "value=\"$adslot3\"";
		$rcrit ="value=\"$adslot3\" selected"; 
		$current_optionbox =~ s/$crit/$rcrit/g;
		}

$current_optionbox =~ s/box_name/bslot3/g;
$current_optionbox = qq[
<tr align="center">
 <td width="25%" bgcolor="#FFFFFF"><div align="left"><span class="normaltext">Advert/Banner Slot 3</span></td>
 <td width="85%" bgcolor="#FFFFFF"><div align="left">
 $current_optionbox 
 </td>
</tr>
];

	$sel_table = $sel_table . $current_optionbox;
	}



if ($curr_templ =~ /%%bannerslot4%%/)
	{
	$current_optionbox = $optionbox;

	if ($adslot4 ne "")
		{
		$crit = "value=\"$adslot4\"";
		$rcrit ="value=\"$adslot4\" selected"; 
		$current_optionbox =~ s/$crit/$rcrit/g;
		}


$current_optionbox =~ s/box_name/bslot4/g;
$current_optionbox = qq[
<tr align="center">
 <td width="25%" bgcolor="#FFFFFF"><div align="left"><span class="normaltext">Advert/Banner Slot 4</span></td>
 <td width="85%" bgcolor="#FFFFFF"><div align="left">
 $current_optionbox 
 </td>
</tr>
];

	$sel_table = $sel_table . $current_optionbox;
	}



if ($curr_templ =~ /%%bannerslot5%%/)
	{
	$current_optionbox = $optionbox;

	if ($adslot5 ne "")
		{
		$crit = "value=\"$adslot5\"";
		$rcrit ="value=\"$adslot5\" selected"; 
		$current_optionbox =~ s/$crit/$rcrit/g;
		}

$current_optionbox =~ s/box_name/bslot5/g;
$current_optionbox = qq[
<tr align="center">
 <td width="25%" bgcolor="#FFFFFF"><div align="left"><span class="normaltext">Advert/Banner Slot 5</span></td>
 <td width="85%" bgcolor="#FFFFFF"><div align="left">
 $current_optionbox 
 </td>
</tr>
];

	$sel_table = $sel_table . $current_optionbox;
	}





#  	$adslot1 = $row[30];
#  	$adslot2 = $row[31];
#  	$adslot3 = $row[32];
#  	$adslot4 = $row[33];
#  	$adslot5 = $row[34];


$sel_table = $sel_table . qq[
    <tr>
      <td width="100%" valign="top" align="left" colspan="2" bgcolor="#FFFFFF">
      	<div align="left"><p><input type="checkbox" name="set_sub" value="Y">Use these Advert/Banner settings for all sub categories/directories of:<br>
      	<blockquote>
      	<p class="normaltext"><font color="#0000FF"><b>$cats</b></font></span><br>
      	</blockquote>
      	<p><input type="submit" class="psbutton" value="      Save      " name="B1">
      	<BR><font color="#FF8000"><b>Note</b></font> : Ticking the checkbox above will destroy all Advert/Banner settings for sub categories/directories of this category/directory.</p>
      	</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
];



$boxhd = qq[
<p>The Advert/Banner rotation system that comes with PowerSeek has been written to be highly
flexible: You can use any shape or size banners or Text/HTML based Adverts and have up to 5 Adverts/Banners rotated on the
same page. You can also use content sensitive Banners or Text/HTML based Adverts in certain
categories/directories of your Directory. The documentation 
explains how the Advert/Banner rotation system works and how you can use it. </p>

<p><strong>Note: </strong>You can create groups of Text/HTML Adverts in the Text/HTML Add Manager Plugin. You can
access the Plugin <a href="$admin_url/p_tadd.cgi" onClick="popup('$admin_url/p_tadd.cgi',950,600);return false;">here</a>.</p>

<p><strong>Note: </strong>You can create groups of banners in the Banner Manager Plugin. You can
access the Banner Manager <a href="$admin_url/admin29.cgi" onClick="popup('$admin_url/admin29.cgi',950,600);return false;">here</a>.</p>
];

$qhelp = acs::quick_help("Help", $boxhd);

$jspopup_code = acs::get_popupjs;


$relatedlinks = qq[
<table width="100%" border="0" cellpadding="6" class="aborder">
  <tr>
    <td background="$web_url/bar6.gif" class="normaltext"><strong>Links to related sections:</strong></td>
  </tr>
  <tr>
    <td class="normaltext"><p>&gt;&gt; Plugins Tab &gt;&gt; <a href="$admin_url/admin29.cgi"  onClick="popup('$admin_url/admin29.cgi',950,600, 300, 100);return false;">Banner Manager</a> (Manage Banners ) </p>
      <p>&gt;&gt; Plugins Tab &gt;&gt; <a href="$admin_url/p_tadd.cgi" onClick="popup('$admin_url/p_tadd.cgi',950,600, 300, 100);return false;">Advert Manager</a> (Manage Adverts ) </p>
      <p>&gt;&gt; Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category Templates &gt;&gt; <a href="$admin_url/admin6.cgi?fct=edit_template&template=defdir"
        onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',850,650, 300, 100);return false;">Main Category/Directory Template</a></p>
      <p>&gt;&gt; Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category Templates &gt;&gt; <a href="$admin_url/admin27.cgi"
      onClick="popup('$admin_url/admin27.cgi',850,650, 300, 100);return false;">Create or Edit Custom Category/Directory Template Sets</a></p></td>
  </tr>
</table>
];



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
<form method="POST" action="$admin_url/admin31.cgi">
<input type="hidden" name="fct" value="save_bslots">
<input type="hidden" name="cid" value="$cid">
<input type="hidden" name="ecat" value="$ecat">
$sel_table

$qhelp
$relatedlinks
</form>
</body>
</html>

];

}





sub no_banner_slots_available
{

$relatedlinks = qq[
<table width="100%" border="0" cellpadding="6" class="aborder">
  <tr>
    <td background="$web_url/bar6.gif" class="normaltext"><strong>Links to related sections:</strong></td>
  </tr>
  <tr>
    <td class="normaltext"><p>&gt;&gt; Plugins Tab &gt;&gt; <a href="$admin_url/admin29.cgi"  onClick="popup('$admin_url/admin29.cgi',950,600, 300, 100);return false;">Banner Manager</a> (Manage Banners ) </p>
      <p>&gt;&gt; Plugins Tab &gt;&gt; <a href="$admin_url/p_tadd.cgi" onClick="popup('$admin_url/p_tadd.cgi',950,600, 300, 100);return false;">Advert Manager</a> (Manage Adverts ) </p>
      <p>&gt;&gt; Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category Templates &gt;&gt; <a href="$admin_url/admin6.cgi?fct=edit_template&template=defdir"
        onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',850,650, 300, 100);return false;">Main Category/Directory Template</a></p>
      <p>&gt;&gt; Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category Templates &gt;&gt; <a href="$admin_url/admin27.cgi"
      onClick="popup('$admin_url/admin27.cgi',850,650, 300, 100);return false;">Create or Edit Custom Category/Directory Template Sets</a></p></td>
  </tr>
</table>
];



print qq[
<table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td height="30" colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>There are currently no Advert/Banner
    slots defined/present in the template used for this category.</strong><a href="$admin_url/help.cgi?fct=target_banner" target="_blank"></a></td>
  </tr>
  <tr>
    <td width="99%" bgcolor="#FFFFFF" class="normaltext"><p>You can define/create Advert/Banner slots by inserting the word/variable <strong>%%bannerslot<font
    color="#0000FF">x</font>%%</strong> into the template in use by this category. (The <strong>x</strong> in <strong>%%bannerslotx%%</strong> can be 1, 2, 3, 4 or 5.) - For example
    %%bannerslot1%%, %%bannerslot2%%, etc...<br>
    <br>
See the online documentation for examples, and full documentation on how the Advert or Banner systems
    works. It is very flexible and functional.</p>
      <blockquote>
        <p><strong>Current Category:<br>
              <font color="#0000FF">$cats</font></strong><br>
              <br>
              <strong>Template Used For This Category:</strong><br>
              <font color="#0000FF"><strong>$tmpl_in_use</strong></font></p>
      </blockquote>
      <p>Please add/define Advert/Banner slots in the template <font color="#0000FF"><strong>$tmpl_in_use</strong></font> so that banner groups can be rotated in these slots.</p>
    <p><strong>You may <a href="javascript:onClick=window.close()">close</a> this window.</strong></p></td>
    <td width="1%" valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$admin_url/help.cgi?fct=target_banner" target="_blank"><img
    src="$web_url/bhelps.gif" border="0"></a></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

$relatedlinks

</body>
</html>
];


}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

