#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "backup") {&do_backup;}
if ($q->param('fct') eq "backup_tables") {&backup_tables;}
if ($q->param('fct') eq "continueb") {&continueb;}

if ($q->param('fct') eq "restore") {&restore_backup;}
if ($q->param('fct') eq "restore_backup_final") {&restore_backup_final;}

if ($q->param('fct') eq "conf") {&conf;}

if ($q->param('fct') eq "nextconf") {&nextconf;}
if ($q->param('fct') eq "mysql_dump_save") {&mysql_dump_save;}



###################################################################################

sub mysql_dump_save
{

if ($q->param('mysqldump') eq "")
	{
	acs::problem_popup("You have to specify the full server path to the mysqldump program."); 
	}

if ($q->param('mysqlp') eq "")
	{
	acs::problem_popup("You have to specify the full server path to the mysql program."); 
	}



if ((-e $q->param('mysqldump')) < 1)
{
acs::problem_popup("The full server path to mysqldump is incorrect. Could not find mysqldump at the path specified.");  exit;
}


if ((-e $q->param('mysqlp')) < 1)
{
acs::problem_popup("The full server path to mysql program is incorrect. Could not find the mysql program at the path specified.");  exit;
}


open (INOUTF, "> $data_dir/backup.cfg");
	print INOUTF "mysqldump" . "\n";
	print INOUTF $q->param('mysqldump') . "\n";
	print INOUTF $q->param('mysqlp') . "\n";
close (INOUTF);
chmod($default_permissions,"$data_dir/backup.cfg","$data_dir/backup.cfg");


$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Conifguration Saved.", qq[<a href="$admin_url/admin43.cgi">Click here to continue.</a>]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}




sub nextconf
{

if ($q->param('sel') ne "mysqldump")
	{
	&save_in_out_file; exit;
	}

### TRY TO LOCATE MYSQLDUMP WITH which

$myslc = &get_file_contents("$data_dir/backup.cfg"); 
@conf_items = split (/\n/, $myslc);

$mysqldump_str = $conf_items[1];
$mysqlp_str = $conf_items[2];

if ($mysqldump_str eq "")
{

open MDM, "which mysqldump|";
$crit = <MDM>;

$crit =~ s/\n//g;
$car_ret = chr(10); $crit =~ s/$car_ret//g;
$car_ret = chr(13); $crit =~ s/$car_ret//g;

if ($crit ne "")
	{
	$mysqldump = $crit;
	}



### IF NOT FOUND TRY slocate

if ($mysqldump eq "")
	{
	open MDM1, "slocate mysqldump|";
	while (defined($line=<MDM1>))
		{
		$crit = $crit . $line;
		}

	@allditems = split (/\n/, $crit);
	
	foreach $ditem (@allditems)
		{
		if (substr($ditem, length($ditem) - 9, 9) eq "mysqldump")
			{
			$mysqldump = $ditem;
			}
		
		}
	}


if (length($mysqldump) > 5)
	{
	$mysqlp = substr($mysqldump, 0, length($mysqldump) - 9) . "mysql";
	}

####

if ($mysqldump ne "")
	{
	$mysql_dump_details = "I tried to locate mysqldump and the above path is what I guees it should be.";
	}
	else
	{
	$mysql_dump_details = "I tried to locate mysqldump but could not find it.";
	}

####

if ($mysqlp ne "")
	{
	$mysqlp_details = "I tried to locate the mysql program and the above path is what I guees it should be.";
	}
	else
	{
	$mysqlp_details = "I tried to locate the mysql program but could not find it.";
	}

####

}
else
{
$mysqldump = $mysqldump_str;
$mysqlp = $mysqlp_str
}



$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Configure Backup Utility", qq[Configuring MySQLDump]);



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<form method="POST" action="$admin_url/admin43.cgi">
  <input type="hidden" name="fct" value="mysql_dump_save"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DBDBDB" height="327">
    <tr>
      <td width="22%" height="138" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Full server path
      to&nbsp; mysqldump: </strong></td>
      <td width="78%" height="138" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="mysqldump"
      size="74" value="$mysqldump"> <p><strong>$mysql_dump_details </strong></p>
      <p>mysqldump is a MySQL program that can be used to backup a database. It dumps the entire
      contents of a database to a file. If you need to find out what the full server path to the
      mysqldump program is, contact your host and ask them for the full server path to the
      mysqldump program. Explain to them that you want to use it in your Perl scripts to backup
      your database. </td>
    </tr>
    <tr>
      <td width="22%" height="120" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Full server path
      to&nbsp; mysql: </strong></td>
      <td width="78%" height="120" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="mysqlp" size="74"
      value="$mysqlp"> <p><strong>$mysqlp_details </strong></p>
      <p>This is the full server path to the mysql client program. The mysql client program is
      normally used to query a database. PowerSeek will use it to restore your backups. </td>
    </tr>
    <tr>
      <td width="22%" height="27" valign="middle" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="78%" height="27" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" value="   Save   "
      name="B1"> </td>
    </tr>
  </table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>
</body>
</html>
];


}



sub save_in_out_file
{

open (INOUTF, "> $data_dir/backup.cfg");
	print INOUTF "sql";
close (INOUTF);
chmod($default_permissions,"$data_dir/backup.cfg","$data_dir/backup.cfg");


$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Conifguration Saved", qq[<a href="$admin_url/admin43.cgi">Click Here to Continue.</a>]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}






sub conf
{

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);


if ($allditems[0] eq "sql")
	{
	$sql_sel = "selected";
	}



$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Configure Backup Utility", qq[Please choose what method you would like to use to backup your database.<BR><b><a href="$admin_url/admin43.cgi">Go Back</a></b>]);


$boxhd = qq[
<ul class="normaltext">
  <li><strong>Use Mysqldump (Recommended) <br>
    </strong>Use this to dump your entire database to a file for backup pruposes. Note that
    you will require access to the <strong>MySQL's mysqldump program. Choose this option and
    click the next button to locate the mysqldump program. The backup utility does not support
    windows based hosts with mysqldump at this stage. <br>
    &nbsp;&nbsp; </strong></li>
  <li><strong>Use MySQL's DATA INFILE AND OUTFILE SQL Syntax <br>
    </strong>Use this if you want to dump all your data from your database to tab delimited
    text files for backup purposes. Note that your database user will require file privileges
    to use this method to backup your database. If your database user does not have file
    privileges to your dabase then you will get <strong>access denied </strong>errors when you
    try to backup your database. </li>
</ul>
];

$helpb = acs::quick_help("Help:",$boxhd); 


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<form method="POST" action="$admin_url/admin43.cgi">
  <input type="hidden" name="fct" value="nextconf"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="15%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong>Backup Method: </strong></td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><select name="sel" size="1">
        <option value="mysqldump"> Use Mysqldump </option>
        <option $sql_sel value="infile"> Use MySQL's DATA INFILE AND OUTFILE SQL Syntax </option>
      </select> </td>
    </tr>
    <tr>
      <td width="15%" valign="middle" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" value="   Next   " name="B1"> </td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
$helpb
</form>
</body>
</html>
];


}





sub restore_backup_final
{

@alltables = ("modified", "links", "dirs", "balogs", "bannergrp", "banners", "brokenlnks", "keywlog", "reviews");

### DO A TEST TO SEE IF WE CAN LOAD DATA INFILE
if ($cn eq "")
	{
	&infile_test;
	}

$cn = $q->param('cn');

if ((-e "$data_dir/dbbackup/$alltables[$cn].txt") > 0)
	{
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

	$sql = "DELETE FROM $alltables[$cn]";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - \n\nFrom: $sql";}

	$sql = "LOAD DATA INFILE '$data_dir/dbbackup/$alltables[$cn].txt' INTO TABLE $alltables[$cn]";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - \n\nFrom: $sql";}

	$sth->finish;
	$dbh->disconnect; 
	}

if ($cn == 8)
	{
	&finish_import;
	}

$cn++;


$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Importing into $alltables[$cn] - Please Wait...", qq[<img src="$web_url/working.gif">]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin43.cgi?fct=restore_backup_final&cn=$cn">
</head>
<body>
$hbox
</body>
</html>
];


}




sub finish_import
{

$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Restore Complete", qq[<a href="$admin_url/admin43.cgi">Click here to continue.</a>]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

exit;

}





sub infile_test
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

#$wsql = "SHOW TABLES FROM $db_name";
$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "pstest") { $create_tbl = "false"; }
	}

#############

if ($create_tbl ne "false")
{
$sql = "CREATE TABLE pstest
				(
				id				int,
				testf1		varchar(255),
				testf2		varchar(255),
				testf3		varchar(255)
				)";
	
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
}

#############

open (DTEST, "> $data_dir/dbbackup/test.txt");
	for ($ms = 0; $ms < 100; $ms++)
	{
	print DTEST "$ms	testfield-$ms	testfield-$ms	testfield-$ms\n";
	}
close (DTEST);

#############

$sql = "LOAD DATA INFILE '$data_dir/dbbackup/test.txt' INTO TABLE pstest";
	
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - \n\nFROM: $sql";} 

##############

$sql = "DROP TABLE pstest";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: SELECT * FROM dirs";} 

unlink ("$data_dir/dbbackup/test.txt");

$sth->finish;
$dbh->disconnect; 

}




sub restore_backup
{

$boxdiz = qq[
<strong><font color="#000000">This action will restore data to the database from backed-up files located in:<br></font>
<font color="#8080C0">$data_dir/backup</font></strong>
<p><font color="#FF8000"><strong>Restoring backups will result in all existing link data being replaced with the data from the backup files.</strong></font></p>
<p><strong>Are you sure you want to restore the backup? <a href="$admin_url/admin43.cgi?fct=restore_backup_final">Yes</a> | <a href="$admin_url/admin43.cgi">No</a></strong>
];

$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Restore Backup", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



#########

sub continueb
{

@alltables = ("links", "dirs", "balogs", "bannergrp", "banners", "brokenlnks", "keywlog", "modified", "reviews");

foreach $item (@alltables)
	{
	unlink ("$data_dir/dbbackup/$item.txt"); 
	
	if ((-e "$data_dir/dbbackup/$item.txt") > 0)
		{ 
		acs::problem_popup("Unabled to delete $data_dir/dbbackup/$item.txt - Go to $data_dir/dbbackup and set all files inside to the permission setting of 777"); exit;
		}

	}


$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Preparing Backup", qq[<img src="$web_url/working.gif">]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin43.cgi?fct=backup_tables&cn=0">
</head>
<body>
$hbox
</body>
</html>
];



}

#########

sub backup_tables
{

$cn = $q->param('cn');

@alltables = ("links", "dirs", "balogs", "bannergrp", "banners", "brokenlnks", "keywlog", "modified", "reviews");

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

#######

$table = $alltables[$cn];
$filename = "$data_dir/dbbackup/" . $alltables[$cn] . ".txt";

#######

$sql = "SELECT * FROM $table INTO OUTFILE '$filename'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: SELECT * FROM dirs";} 

$sth->finish;
$dbh->disconnect; 


if ($cn == 8) { &finish_backup; }

$cn++;


$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Backing up table $table - Please Wait...", qq[<img src="$web_url/working.gif">]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin43.cgi?fct=backup_tables&cn=$cn">
</head>
<body>
$hbox
</body>
</html>
];


}





##########

sub finish_backup
{

foreach $item (@alltables)
	{
	$fsize = (-s "$data_dir/dbbackup/$item.txt");
	$fsize = substr($fsize, 0, length($fsize) - 3);
	if ($fsize eq "") { $fsize = 0; }
	$fsizes = $fsizes . "$data_dir/dbbackup/$item.txt = $fsize k <BR>";
	}
	
####

$boxdiz = qq[
<font color="#000000"><strong>Database backup files placed in:</strong><br>
<font color="#8080FF"><strong>$data_dir/dbbackup</strong></p>
<p><strong>File sizes:</strong><br>
<font color="#FF8000"><strong>$fsizes</strong></font></p>
<p>Download the above files so that it can be placed on a backup medium like CDs,etc.</p>
<p>To make a complete backup of all templates, settings and data, download the entire contents of: <br>
<font color="#8080FF"><strong>$data_dir<br></strong></font> and place it on a suitable medium.</p>
<p>See the PowerSeek documentation for detailed information on data backups.</p>
<p><a href="$admin_url/admin43.cgi"><strong>Click here to continue</strong></a>
];

$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Backup Complete", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

exit;

}




sub do_backup
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "ppc_links") { $fppc_links = "true"; }
	}

$sth->finish;
$dbh->disconnect; 


if ($fppc_links eq "true")
	{

$boxdiza = qq[
You are using the PowerSeek PPC Plugin. Please configure
the backup utility to use mysqldump. The SQL INFILE/OUTFILE SQL Backup method is not
supported when you use the PowerSeek PPC Plugin. <a href="$admin_url/admin43.cgi?fct=conf">Click
Here to Configure the Backup Utility to use mysqldump</a>
];

$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Unable to Make Backup", $boxdiza);

print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

];
exit;
	}


#######################################

if ((-e "$data_dir/dbbackup") < 1)
	{ 
	mkdir ("$data_dir/dbbackup", $default_permissions);
	chmod($default_permissions,"$data_dir/dbbackup","$data_dir/dbbackup");
	}

opendir(DIR,"$data_dir/dbbackup");
@files = readdir(DIR);

foreach $filename (@files)
	{
	if (($filename ne ".") and ($filename ne ".."))
		{
		$fsize = (-s "$data_dir/dbbackup/$filename");
		$fsize = substr($fsize, 0, length($fsize) - 3);
		if ($fsize eq "") { $fsize = 0; }
		$allfiles = $allfiles . "$data_dir/dbbackup/$filename - Size: $fsize k<br>";
		}
	}

if ($allfiles ne "")
{

$boxdaz = qq[
<font color="#000000"><strong>The following files where found in the backup directory:</strong><br>
<font color="#8080FF"><strong>$allfiles</strong>
<p><font color="#FF8000"><strong>These files will be removed and
replaced by the new backup files.</strong></font></p>
<p><strong>Would you like to continue? <a href="$admin_url/admin43.cgi?fct=continueb">Yes</a> | <a href="$admin_url/admin43.cgi">No</a></strong>
];

$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Preparing Data Backup", $boxdaz);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}
else ### SHOW BACKUP SCREEN AND DO BACKUP
{

$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Preparing Data Backup", qq[Please Wait...]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin43.cgi?fct=backup_tables&cn=0">
</head>
<body>
$hbox
</body>
</html>
];

}


}


###########


sub start
{

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);


if ($allditems[0] eq "sql")
	{
	$backup = "$admin_url/admin43.cgi?fct=backup";
	$restore = "$admin_url/admin43.cgi?fct=restore";
	}
	else
	{
	$backup = "$admin_url/admin52.cgi?fct=backup";
	$restore = "$admin_url/admin52.cgi?fct=restore";
	}


$boxdiz = qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="90%" valign="top" class="normaltext">Do a database backup or restore a backup. </td>
    <td width="9%" valign="top" align="right"><a href="$admin_url/help.cgi?fct=backups"
    target="_blank"><strong><img src="$web_url/bhelps.gif" border="0"> </strong></a></td>
  </tr>
</table>
];

$hbox = acs::get_heading_box("$web_url/ic_backup1.gif", "Data Backups", $boxdiz);
 

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<table border="0" cellspacing="1" width="100%" cellpadding="0" bgcolor="#DBDBDB"
height="46">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" valign="top"><img
    src="$web_url/ic_backup2.gif"> </td>
    <td width="99%" bgcolor="#FFFFFF" height="100"><table border="0" cellpadding="6"
    cellspacing="1" width="100%">
      <tr>
        <td width="100%" class="normaltext"><strong><a href="$backup">Backup Database </a><br>
        </strong>This action will backup the contents of your database. In order to make an entire
        backup of all settings, templates, and data of your search engine, download the entire
        contents of your 'data' directory after you made a database backup. The 'data' directory
        is explained in the installation instructions. The database backup files is placed in a
        subdirectory under the 'data' directory that is called 'dbbackup'. See the documentation
        for more on data backups. <p>Please note that it is vital that the MySQL database you are
        using is not used by other programs. This means that it should contain only tables that
        PowerSeek creates inside it. If the PowerSeek database is used by other applications that
        created their own tables, then the backup utility will aditionally try to restore data of
        other programs which can cause severe problems. </td>
      </tr>
    </table>
    </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" valign="middle"><p align="center"><img
    src="$web_url/ic_restore.gif"> </td>
    <td width="99%" bgcolor="#FFFFFF" height="100"><table border="0" cellpadding="6"
    cellspacing="1" width="100%">
      <tr>
        <td width="100%" class="normaltext"><strong><a href="$restore">Restore Database Backup </a><br>
        </strong>Restore data to the database that has previously been backed up. Note that this
        action will replace all data (links, directories, etc..) with the data that was previously
        backed up. </td>
      </tr>
    </table>
    </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" valign="middle"><p align="center"><img
    src="$web_url/ic_settings3.gif"> </td>
    <td width="99%" bgcolor="#FFFFFF" height="100"><table border="0" cellpadding="6"
    cellspacing="1" width="100%">
      <tr class="normaltext">
        <td width="100%"><strong><a href="$admin_url/admin43.cgi?fct=conf">Configure </a><br>
        </strong>Configure the backup utility. Choose between two methods of backing up your
        database.&nbsp; </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</body>
</html>
];



}




####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

