#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use fmparse;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "edit_template") {&edit_template;}
if ($q->param('fct') eq "tinfo") {&tinfo;}
if ($q->param('fct') eq "restore_default_template") {&restore_template_check;}
if ($q->param('fct') eq "explain") {&explain;}
if ($q->param('fct') eq "upload") {&upload;}

##################################################################################


sub upload
{

if ($q->param('upfile') eq "") { acs::problem_popup("You have to specify a file name to upload."); }


$template = $q->param('template'); $curr_template = $template;
$ufname = "$data_dir/$template" . ".html";

		### DO UPLOAD
		$upload_filehandle = $q->param('upfile');
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;	


if ($q->param('extraform') ne "")
	{
	$extraform = $q->param('extraform');
	}

$boxdiz = qq[
<ul>
 <li class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$curr_template&extraform=$extraform">Click here to go back to editing</a></li>
 <li class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&amp;template=$curr_template&f=$extraform" target="_blank">Click here to Preview this template</a></li>
 <li class="normaltext"><a href="javascript:onClick=window.close()">Click here to close this window</a> </li>
</ul>
];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Template Saved", $boxdiz);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>
$hbox
</body>
</html>
];

}






sub explain
{

$curr_template = $q->param('t');
$objn2 = $curr_template . "2";
&get_tmpl_details;
$vars_available = $tmpl_details{$objn2};

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>

<table width="100%" border="0" cellpadding="6" cellspacing="1" bordercolor="#DDDDDD"
style="border: 1px solid rgb(225,225,225)">
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext"
    background="$web_url/bar6.gif"><strong>Explanation of Variables Used
    Inside This Template:</strong></td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext">The words below are variables used
    in this template. Most of these variables will have to be present in this template for it
    to work correctly. These variable words are replaced with data.
    <blockquote>$vars_available</blockquote>
    </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

];


}



sub tinfo
{

$curr_template = $q->param('template');

($dir_details, $vars_available) = &get_tmpl_details($curr_template);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$web_url/add.gif"></td>
    <td width="94%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Template
    Info</strong></font></td>
  </tr>
</table>
<hr size="1" color="#E6E6E6">
<table border="0" cellpadding="10" cellspacing="0" width="100%" style="border: 1px solid">
  <tr>
    <td width="100%" bgcolor="#8080C0"><font face="Verdana" size="1" color="#FFFFFF">$dir_details</font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFE135"><font face="Verdana" size="1"><strong>Variables Used in
    This HTML PLUGIN:<br>
    </strong>The words below are variables used in this templates. Most of these variables
    will have to be present in this template for it to work correctly. These variable words
    are replaced with data.</font></td>
  </tr>
  <tr>
    <td width="100%" valign="top"><font face="Verdana" size="1">$vars_available</font></td>
  </tr>
</table>
</body>
</html>
];


}

#--------------------


sub restore_template_check
{
if ($q->param('Yes') eq "   Yes   ")
	{&restore_template_final;}
	else
	{&edit_template}
}


#====================
sub restore_template_final
{

$curr_template = $q->param('template');

$template_html = acs::get_file_contents("$data_dir/$curr_template.def");


open (htmfn, "> $data_dir/$curr_template.html"); #overwrite
print htmfn $template_html;
close (htmfn); 


$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Template Restored", qq[<a href="$admin_url/admin57.cgi?fct=edit_template&amp;template=$curr_template">Click here to continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>
$hbox
</body>
</html>
];



}



sub restore_template_areyousure
{

$curr_template = $q->param('template');

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$web_url/add.gif"></td>
    <td width="94%" valign="top"><strong><font face="Arial" size="4" color="#000000">Restore
    Default Template<br>
    </font><font face="Verdana" size="1"><font color="#000000">Are you sure? </strong>This
    action will replace the current template called: </font><strong>$curr_template.html</strong></font><form
    method="POST" action="$admin_url/admin6.cgi">
      <input type="hidden" name="fct" value="restore_default_template"><input type="hidden"
      name="template" value="$curr_template"><p><input type="submit" class="psbutton" value="   Yes   " name="Yes">
      <input type="submit" class="psbutton" value="   No   " name="No"></p>
    </form>
    </td>
  </tr>
</table>
</body>
</html>
];




}



#====================
sub save_template
{

if ($q->param('B2') ne "")
{	
&restore_template_areyousure;
exit;
}


$curr_template = $q->param('template');

$tmpln = "$data_dir/$curr_template" . ".html";

########

open (TMPLF, "> $tmpln");
	print TMPLF $q->param('etemplate');
close TMPLF;


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%"><img src="$web_url/edittmpl.gif"></td>
    <td width="94%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Template
    Saved</strong></font></td>
  </tr>
  <tr>
    <td width="6%"></td>
    <td width="94%" valign="top"><font face="Verdana" size="1" color="#000000">$possible_problems</font><p><strong><font
    face="Verdana" size="1">You may now <a href="javascript:onClick=window.close()">close</a>
    this window.</font></strong></td>
  </tr>
</table>
</body>
</html>
];


}



##################

sub edit_template
{
&get_template_help;

$curr_template = $q->param('template');

&get_tmpl_details; ### PLACE TEXTS IN OBJS


$objn1 = $curr_template . "1";
$objn2 = $curr_template . "2";

$dir_details = $tmpl_details{$objn1};
#$vars_available = "<blockquote>" . $tmpl_details{$objn2}  . "</blockquote>";

$template_html = acs::get_file_contents("$data_dir/$curr_template.html");

if (-w "$data_dir/$curr_template.html") #-w writable by current user?
{ 
$template_writing .= qq[<font face="Verdana" color="#FF0080"><strong>&nbsp;&nbsp;<br></strong></font>];
} 
else
{ 
$template_writing .= qq[<font face="Verdana" color="#FF0000"><strong>&nbsp;&nbsp; This file is not
Writeable or does not exist. If it exists please ensure that the file permission setting is set to 777. Please refer<br>
to the documentation on Assigning permissions to directories and files.<br>
</strong></font>];
} 

########################

if ($curr_template eq "rgs_regsuccess_paypal")
	{
	if ($template_html eq "")
		{
		$template_html = acs::get_file_contents("$data_dir/rgs_add_url_success.html");
		}
	}

####################

$dir_details =~ s/<br>/ - /gi;

$extraform = $q->param('extraform');
$extrafr = $q->param('extraform') . "_";

if ($extraform ne "") 
	{
	$vars_explain = $curr_template;
	$vars_explain =~ s/$extrafr//gi;
	}
	else
	{
	$vars_explain = $curr_template;
	}

###################

if ($dir_details ne "") { $dir_details = $dir_details . "<BR>"; }

###################

$editor = acs::get_file_contents("$data_dir/editor.dat");
if ($editor eq "wysiwyg")
	{
	
	### Get CSS being used inside template
	$cssdetails = fmparse::get_css_used($template_html);
	
	### Replace !build_url!
	$template_html =~ s/!build_url!/$web_url/gi;
	
	### See if fullpage is being used
	$fullpage_option = "fullpage,";
	@non_fullpage_items = ("tmplsearch", "tmplsearch_prem", "subdirs", "directories1", "related1", "related2", "lsearchres_loc", "lsearchres_loc_prem", "lsearchres_locdir",
									"rgs_acclinks", "rgs_acclinksp", "rgs_nolinks", "whatsnew_lists", "whatsnew_lists_prem", "tophits_listings", "tophits_listings_prem",
									"fav_standard", "fav_premium");
	foreach $nonitem (@non_fullpage_items)
		{
			if ($curr_template eq $nonitem)
				{
				$fullpage_option = "";
				}
		}
	##################################
	

$head_details = qq[
<script type="text/javascript" src="$web_url/edt/tiny_mce/tiny_mce.js" ></script >

<script type="text/javascript">
tinyMCE.init({
// General options
mode : "textareas",
theme : "advanced",
plugins : "$fullpage_option autolink,lists,spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",

// Theme options
theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,spellchecker,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,blockquote,pagebreak,|,insertfile,insertimage",
theme_advanced_toolbar_location : "top",
theme_advanced_toolbar_align : "left",
theme_advanced_statusbar_location : "bottom",
theme_advanced_resizing : true,

// Skin options
skin : "o2k7",
skin_variant : "silver",

// Example content CSS (should be your site CSS)
content_css : "$cssdetails",

// Drop lists for link/image/media/template dialogs
template_external_list_url : "js/template_list.js",
external_link_list_url : "js/link_list.js",
external_image_list_url : "js/image_list.js",
media_external_list_url : "js/media_list.js"

});
</script>

];

		$editor_buttons = qq[
	      <strong class="buttab_selected">Wysiwyg Editor</strong>
	      <strong><a href="admin6.cgi?template=$curr_template&fct=change_editor&editor=source&admin57=true" class="buttab" onClick="return turnoff();">Template HTML Source Code</a></strong> 
		];

	}
	else
	{
		$copypaste_msg = qq[<span class="normaltext12">Copy and paste the HTML code into your web editor. When finished, copy and paste the HTML code back to this box. You may
      also manually open the HTML file above with your favorite HTML editor and edit it. </span>
      ];
      
      $selectall = qq[<input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.etemplate.focus();this.form.etemplate.select(); return false;">];

		$editor_buttons = qq[
	      <strong><a href="admin6.cgi?template=$curr_template&fct=change_editor&editor=wysiwyg&admin57=true" class="buttab" onClick="return turnoff();">Wysiwyg Editor</a></strong>
	      <strong class="buttab_selected">Template HTML Source Code</strong> 
		];      
	}

###################


$boxdiz = qq[
<b>Editing: $template_title</b> - $dir_details
];

$varlinks = qq[
<b>Help:</b> 
<a href="$admin_url/admin57.cgi?fct=explain&t=$curr_template&body=true" onClick="popup('$admin_url/admin57.cgi?fct=explain&t=$vars_explain&body=true',800,600, 130, 130);return false;" title="Provides you with a list of words or variables that can be used within<BR> the current template. The words are enclosed by !! or %% and are<BR> variables used in this template. These variable words are replaced<BR> with data.">Variables Available</a> | 
<a href="$admin_url/admin78.cgi?fct=global_vars&body=true" onClick="popup('$admin_url/admin78.cgi?fct=global_vars&body=true',800,600, 130, 130);return false;" title="Displays a list of global variables (words enclosed by !! or %%)<BR> that can be used within all PowerSeek templates.">Global Variables</a> | 
<a href="$admin_url/admin78.cgi?fct=how_to_edit&body=true" onClick="popup('$admin_url/admin78.cgi?fct=how_to_edit&body=true',800,600, 130, 130);return false;" title="Explains how to edit templates">How To Edit Templates</a> | 
<a href="$admin_url/admin78.cgi?fct=manual_edit&body=true" onClick="popup('$admin_url/admin78.cgi?fct=manual_edit&body=true',800,600, 130, 130);return false;" title="Explains how to manually edit templates">Manual Editing</a> | 
<a href="$admin_url/admin78.cgi?fct=images_in_templates&body=true" onClick="popup('$admin_url/admin78.cgi?fct=images_in_templates&body=true',800,600, 130, 130);return false;" title="Explains how to use images inside templates">Template Images How To</a> | 
<a href="http://www.focalmedia.net/pseekmanual/pseek6.html" target="_blank" title="PowerSeek template editing instructions">Instructions</a>
];

###################

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Editing Template: $data_dir/$curr_template.html", $boxdiz);


$upload_box = qq[
<form method="POST" action="$admin_url/admin57.cgi" ENCTYPE="multipart/form-data">
  <table width="100%" border="0" cellpadding="6" cellspacing="1"
  bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td colspan="4" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><b>Upload/Download Template:</b></td>
    </tr>
    <tr>
      <td width="10%" align="center" bgcolor="#FFFFFF" class="normaltext"><strong>Upload Template:</strong></td>
      <td width="38%" bgcolor="#FFFFFF" class="normaltext">
        <input type="file" name="upfile" size="40" id="upfile">
        <label>
          <input type="submit" class="psbutton" name="Upload" id="Upload" value="    Upload    ">
        </label>
        <input name="fct" type="hidden" id="fct" value="upload">
        <input name="template" type="hidden" id="template" value="$curr_template">
        <input name="extraform" type="hidden" value="$extraform">
        </td>
      <td width="13%" align="right" bgcolor="#FFFFFF" class="normaltext"><strong>Download Template:</strong></td>
      <td width="39%" bgcolor="#FFFFFF">
      <a href="$admin_url/admin6.cgi?fct=download&template=$curr_template" title="Right Click this button and choose 'Save As'"><img src="$web_url/downloadt.png" border="0"></a>        </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="147%"></td>
    </tr>
  </table>
</form>
];



$template_html =~ s/&/&amp;/gi;
$template_html =~ s/</&lt;/gi;
$template_html =~ s/>/&gt;/gi;

$tooltip = acs::get_tooltip;


if ($extraform eq "")
{
$restore_def_but = qq[<input type="submit" class="psbutton" value="    Restore Default    " name="B2" title="This option let's you restore the default factory template<BR>    that was available when PowerSeek was first installed.<BR>    This can be handy in the event where something stopped <BR>    working and you need to restore the default template to<BR>    get it back to working order.">];
}



$prev_display = acs::get_file_contents("$data_dir/previews.dat");

if ($prev_display ne "false")
	{
	$tpreviews = qq[
	<table width="100%" border="0" cellpadding="6" cellspacing="1" style="border: 1px solid rgb(225,225,225)">
	 <tr>
	 					 <td width="95%" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><b>Template Only Preview:</b></td>
	 				 <td width="5%" align="right" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext">
	 					 <form name="form1" method="post" action="$admin_url/admin6.cgi" onSubmit="return turnoff();">
	 					 <input type="hidden" name="template" value="$curr_template">
	 					 <input type="hidden" name="a" value="a">
	 					 <input type="hidden" name="fct" value="turnoff_previews">
	 						<input type="submit" class="psbutton" name="button" id="button" value="Turn off template previews">
	 					 </form>
	 				</td>
					  </tr>
	  <tr>
	    <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Important Preview Note:</strong>
	    Take note that many templates are combined with other templates to form one page. In other
	    words, many templates work together with other templates. This preview pane will not
	    display templates combined with other templates and will display the preview of the single
	    template being edited now only.</td>
	  </tr>
	  <tr>
	    <td class="normaltext">
	    	<!--webbot bot="HTMLMarkup" startspan -->
	    		<IFRAME src="$admin_url/admin79.cgi?fct=preview&template=$curr_template" width="100%" height="500"></IFRAME>
	    	<!--webbot bot="HTMLMarkup" endspan --> 
	    </td>
	  </tr>
	</table>
	<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
	  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
	</table>
	
	<table width="100%" border="0" cellpadding="6" cellspacing="1" bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)" height="123">
	  <tr>
	    <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><b>Live Preview:</b></td>
	  </tr>
	  <tr>
	    <td valign="top" bgcolor="#FFFFFF" class="normaltext" height="39"><strong>Important 
	    Preview Note:</strong> Take note that many templates are combined with other templates to
	    form one page. In other words, many templates work together with other templates. This
	    preview pane will not display templates combined with other templates and will display the
	    preview of the single template being edited now only.</td>
	  </tr>
	  <tr>
	    <td valign="top" bgcolor="#FFFFFF" class="normaltext" height="21">
	    	<!--webbot bot="HTMLMarkup" startspan -->
	    		<IFRAME src="$admin_url/admin68.cgi?fct=prev&template=$curr_template&f=$extraform" width="100%" height="500"></IFRAME>
	    	<!--webbot bot="HTMLMarkup" endspan --> 
	    </td>
	  </tr>
	</table>
	<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
	  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
	</table>
	];
	}
	else
	{
	$tpreviews = qq[
	<form name="form1" method="post" action="$admin_url/admin6.cgi" onSubmit="return turnoff();">
	 <input type="hidden" name="template" value="$curr_template">
	 <input type="hidden" name="fct" value="turnon_previews">
	 <input type="hidden" name="a" value="a">
		<input type="submit" class="psbutton" name="button" id="button" value="Turn on template previews">
	 </form>
	];	
	}




$jspopup_code = acs::get_popupjs;

$template_writing = qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
$tooltip
<SCRIPT LANGUAGE="JavaScript">

var dropdownstat = 0;
var lastdropdown = 0;

function xmlhttpPost(strURL, display_area, ddown) 
	 {
	 
	 document.getElementById('AJImg').style.display='block';
	 
    var xmlHttpReq = false;
    var self = this;
  
  	 if (dropdownstat == ddown)
  	 	{
  	 	strURL = '$admin_url/admin77.cgi?fct=blank'; dropdownstat = 0;
  	 	}
  	 	else { dropdownstat = ddown; }
  
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
	
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function() 
    	   {
         if (self.xmlHttpReq.readyState == 4) 
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText; 
         		document.getElementById('AJImg').style.display='none';
         		}
    		}

	
    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
    
    
}

$jspopup_code

function turnoff()
	{
	var agree=confirm("This action will discard any changes that you have made to the existing template you are editing. If you made changes to the existing template then first save the changes before taking this action. Are you sure you want to continue?");
	if (agree)
	return true;
	else
	return false;
	}

</script>

$head_details

</head>
<body>
$hbox

<span id="result1"></span>

<style>

.buttab_selected {
	text-decoration:none;
	padding-top: 5px;
	padding-right: 9px;
	padding-bottom: 7px;
	padding-left: 9px;
	border-top: 1px solid #DDD;
	border-left: 1px solid #DDD;
	border-right: 1px solid #DDD;
	background: url($web_url/inp2.gif);
	//line-height: 25px;
}

.buttab {
	text-decoration:none;
	padding-top: 5px;
	padding-right: 9px;
	padding-bottom: 5px;
	padding-left: 9px;
	border-top: 1px solid #DDD;
	border-left: 1px solid #DDD;
	border-right: 1px solid #DDD;
	background: url($web_url/inp3.png);
	line-height: 25px;
}

a.buttab { color: #000; }
a.buttab_selected { color: #000; }

.buttab:hover {
	padding-top: 5px;
	padding-right: 9px;
	padding-bottom: 4px;
	padding-left: 9px;
	border-top: 1px solid #DDD;
	border-left: 1px solid #DDD;
	border-right: 1px solid #DDD;
	background: url($web_url/inp2.gif);
	line-height: 25px;
	text-decoration:none;
}
</style>

<form method="POST" action="$admin_url/admin6.cgi">
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td width="31%" class="normaltext12">
      $editor_buttons
      </td>
      <td width="69%" align="right" class="normaltext">$varlinks $selectall</td>
    </tr>
  </table>
  <table width="100%" border="0" cellpadding="6" cellspacing="1"
  bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td width="100%" valign="top" bgcolor="#FFFFFF">
      <textarea rows="35" name="etemplate" cols="101" style="width:100%">$template_html</textarea>
			$copypaste_msg
      </td>
    </tr>
    <tr>
      <td align="center" bgcolor="#FFFFFF"><dd align="center">
          <input type="submit" class="psbutton" value="     Save Template     " name="B1">
          <font face="Verdana"
    size="1">$restore_def_but</font><font face="Verdana"
    size="1">
          <input type="submit" class="psbutton" value="     View Default     " name="B3" title="View the HTML source code of the default factory template." 
     onClick="popup('$admin_url/admin6.cgi?fct=view_default&template=$curr_template&extraform=$extraform',screen.width-250,screen.height-250);return false;">
          </font><span style="margin-bottom:0; margin-top:0;">
          <input type="hidden" name="fct" value="save_template">
          <input type="hidden" name="template" value="$curr_template">
          <input type="hidden" name="extraform" value="$extraform">
          <input type="hidden" name="rgs_templates" value="true">
          </span></dd>      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="147%"></td>
    </tr>
  </table>
</form>


$upload_box

$tpreviews


</body>
</html>

];

print $template_writing;

}






sub get_tmpl_details
{

$globalmsg = "No variables available for this template other than variables available globally to all templates.";


### GET EXTRA FIELDS SO THAT THEY CAN BE DISPLAYED WHEN NEEDED

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $numbf) = split (/\t/, $k_item);
	$real_kname = $keyname . "_cust";
	
	$sql_extra_keys = $sql_extra_keys . "<font color=\"#8080FF\"><b>!!" . $keyname . "!!</b></font>" . "<BR>This is an extra field/key that has been created. Add !!$keyname!! to this template for it's values to be available.<BR><BR>";
	
	
	
	if ($imgk eq "Yes")
		{
		$sql_extra_keys3 = $sql_extra_keys3 . qq[  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><td><b><font color="#008000">$keyname</font></b></td><td><strong>$description:</strong> &lt;input type=&quot;text&quot; name=&quot;$keyname&quot; size=&quot;20&quot; value=&quot;!!$keyname!!&quot;&gt;</td></tr>];
		
		$sql_extra_keys2 = $sql_extra_keys2 . qq[<tr><td><b><font color="#008000">$keyname</font></b></td>
		<td><strong>$description:</strong> &lt;input type=&quot;text&quot; name=&quot;$keyname&quot; size=&quot;20&quot; value=&quot;!!$keyname!!&quot;&gt; </td></tr>
		];
		
		}
		else
		{
		#$sql_extra_keys = $sql_extra_keys . "<br><font color=\"#8080C0\"><b>!!$keyname!!</b></font> <br>This is an extra field/key that has been created. Add <b>!!$keyname!!</b> to this template for it's values to be available.<br>";
		
			if ($numbf eq "Upload")
				{
				$sql_extra_keys2 = $sql_extra_keys2 . qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><td bgcolor="#FFFFFF"><b><font color="#804040">$keyname</font></b></td>
				<td><strong>$description:</strong> &lt;input type=&quot;file&quot; name=&quot;$keyname&quot; size=&quot;20&quot;&gt;</td></tr>
				];
				
				## %%thumb_file_with_link%%
				$keyname_file_with_link = "%%" . $keyname . "_file_with_link%%";
				
				## [thumb_no_filename_text]
				$thumb_no_filename_text = "<BR>[" . $keyname . "_no_filename_text]" . "No File Available";
			
				## [thumb_no_filename_text_end]
				$thumb_no_filename_text_end = "[" . $keyname . "_no_filename_text_end]";
				
				## [thumb_del_text]
				$thumb_del_text = "[" . $keyname . "_del_text]" . "Delete File?";
				
				## [thumb_del_text_end]
				$thumb_del_text_end = "[" . $keyname . "_del_text_end]"; 
				
				## %%thumb_checkbox%%
				$thumb_checkbox = "%%" . $keyname .  "_checkbox%%";

				$sql_extra_keys3 = $sql_extra_keys3 . qq[ 
				<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><td><b><font color="#804040">$keyname</font></b></td>
				<td>
				$keyname_file_with_link $thumb_no_filename_text $thumb_no_filename_text_end<BR>
		      &lt;br&gt; &lt;input type=&quot;file&quot; name=&quot;$keyname&quot; size=&quot;20&quot;&gt;&lt;br&gt;<br>
				$thumb_del_text $thumb_del_text_end $thumb_checkbox
				</td></tr>
				];
				
				}
			elsif ($numbf eq "Content")
				{
				$idname = $keyname . "_" . "txtContent";
				$edit_obj = $keyname . "_" . "Edit";
				
				#$sql_extra_keys2 = $sql_extra_keys2 . qq[ <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
				#    <td valign="top"><b><font color="#800080">$keyname</font></b></td>
				#    <td>
				#      <p>
				#    		&lt;script language="Javascript" src="$web_url/edt/scripts/innovaeditor.js"&gt;&lt;/script&gt;<br>
				#    		&lt;textarea id=&quot;$idname&quot; name=&quot;$keyname&quot; rows=4 cols=30&gt;!!$keyname!!&lt;/textarea&gt;<br>
				#  	 		&lt;script&gt;<br>
				#  	 		var $edit_obj = new InnovaEditor(&quot;$edit_obj&quot;);<br>
				#  	 		$edit_obj.width=&quot;100%&quot;;<br>
				#  	 		$edit_obj.height=&quot;85%&quot;;<br>
				#  	 		$edit_obj.mode=&quot;HTMLBody&quot;;<br>
				#  	 		$edit_obj.css=&quot;$web_url/ps.css&quot;;<br>
				#  	 		$edit_obj.btnStyles=true;<br>
				#  	 		$edit_obj.REPLACE(&quot;$idname&quot;);<br>
				#	 		&lt;/script&gt;<br>
				#	   </p>
				#    </td>
				#  </tr>
				#];


$textareaboxes = qq[<script type="text/javascript" src="$web_url/edt/tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
tinyMCE.init({
// General options
mode : "specific_textareas",
editor_selector : "mceEditor",
theme : "advanced",
plugins : "autolink,lists,spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",

// Theme options
theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,spellchecker,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,blockquote,pagebreak,|,insertfile,insertimage",
theme_advanced_toolbar_location : "top",
theme_advanced_toolbar_align : "left",
theme_advanced_statusbar_location : "bottom",
theme_advanced_resizing : true,

// Skin options
skin : "o2k7",
skin_variant : "silver",

// Example content CSS (should be your site CSS)
content_css : "$web_url/ps.css",

template_external_list_url : "js/template_list.js",
external_link_list_url : "js/link_list.js",
external_image_list_url : "js/image_list.js",
media_external_list_url : "js/media_list.js"

});
</script>
<textarea name="$keyname" id="mceEditor" class="mceEditor" cols="45" rows="20" style="width:100%">!!$keyname!!</textarea>
];

$textareaboxes =~ s/&/&amp;/gi;
$textareaboxes =~ s/</&lt;/gi;
$textareaboxes =~ s/>/&gt;/gi;
$textareaboxes =~ s/"/&quot;/gi; ##"


$sql_extra_keys2 = $sql_extra_keys2 . qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
<td valign="top"><b><font color="#800080">$keyname</font></b></td>
<td>
<b>Copy and paste the code below into Add URL template:</b>
<textarea name="textarea" id="textarea" cols="45" rows="20" style="width:100%">$textareaboxes</textarea>
</td>
</tr>
];				
				
				
				
				#$field_contents_formodify =~ s/&/&amp;/g;
				#$field_contents_formodify =~ s/</&lt;/g;
				#$field_contents_formodify =~ s/>/&gt;/g;

				#$sql_extra_keys3 = $sql_extra_keys3 . qq[ <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
				#    <td valign="top"><b><font color="#800080">$keyname</font></b></td>
				#    <td>
				#      <p>
				#    		&lt;script language="Javascript" src="$web_url/edt/scripts/innovaeditor.js"&gt;&lt;/script&gt;<br>
				#    		&lt;textarea id=&quot;$idname&quot; name=&quot;$keyname&quot; rows=4 cols=30&gt;!!$keyname!!&lt;/textarea&gt;<br>
				#  	 		&lt;script&gt;<br>
				#  	 		var $edit_obj = new InnovaEditor(&quot;$edit_obj&quot;);<br>
				#  	 		$edit_obj.width=&quot;100%&quot;;<br>
				#  	 		$edit_obj.height=&quot;85%&quot;;<br>
				#  	 		$edit_obj.mode=&quot;HTMLBody&quot;;<br>
				#  	 		$edit_obj.css=&quot;$web_url/ps.css&quot;;<br>
				#  	 		$edit_obj.btnStyles=true;<br>
				#  	 		$edit_obj.REPLACE(&quot;$idname&quot;);<br>
				#	 		&lt;/script&gt;<br>
				#	   </p>
				#    </td>
				#  </tr>
				#];
				


$textareaboxes = qq[<script type="text/javascript" src="$web_url/edt/tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
tinyMCE.init({
// General options
mode : "specific_textareas",
editor_selector : "mceEditor",
theme : "advanced",
plugins : "autolink,lists,spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",

// Theme options
theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,spellchecker,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,blockquote,pagebreak,|,insertfile,insertimage",
theme_advanced_toolbar_location : "top",
theme_advanced_toolbar_align : "left",
theme_advanced_statusbar_location : "bottom",
theme_advanced_resizing : true,

// Skin options
skin : "o2k7",
skin_variant : "silver",

// Example content CSS (should be your site CSS)
content_css : "$web_url/ps.css",

template_external_list_url : "js/template_list.js",
external_link_list_url : "js/link_list.js",
external_image_list_url : "js/image_list.js",
media_external_list_url : "js/media_list.js"

});
</script>
<textarea name="$keyname" id="mceEditor" class="mceEditor" cols="45" rows="20" style="width:100%">!!$keyname!!</textarea>
];

$textareaboxes =~ s/&/&amp;/gi;
$textareaboxes =~ s/</&lt;/gi;
$textareaboxes =~ s/>/&gt;/gi;
$textareaboxes =~ s/"/&quot;/gi; ##"

				$sql_extra_keys3 = $sql_extra_keys3 . qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
				  <td valign="top"><b><font color="#800080">$keyname</font></b></td>
				  <td>
				  <b>Copy and paste the code below into Modify template:</b>
				  	<textarea name="textarea" id="textarea" cols="45" rows="20" style="width:100%">$textareaboxes</textarea>
				  </td>
				  </tr>
				];
				
				}
			else
				{
				$sql_extra_keys3 = $sql_extra_keys3 . qq[ <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
				 <td><b><font color="#8080FF">$keyname</font></b></td>
				 <td><strong>$description:</strong> &lt;input type=&quot;text&quot;
				 name=&quot;$keyname&quot; size=&quot;20&quot; value=&quot;!!$keyname!!&quot;&gt;</td>
			  </tr>
				];
				
				$sql_extra_keys2 = $sql_extra_keys2 . qq[ <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
				 <td><b><font color="#8080FF">$keyname</font></b></td>
				 <td><strong>$description:</strong> &lt;input type=&quot;text&quot;
				 name=&quot;$keyname&quot; size=&quot;20&quot; value=&quot;!!$keyname!!&quot;&gt;</td>
			  </tr>
				];
				}
		}

	}
	

if ($sql_extra_keys2 ne "")
	{
	$extra_details = qq[

<BR><BR><BR>
<table width="100%" border="0" cellpadding="6" cellspacing="1" class="normaltext" style="border: 1px solid rgb(223,223,223)">
  <tr>
    <td colspan="2" class="bar6">
    <b>You have defined extra fields/keys. Please read below:</b>
    </td>
  </tr>
  <tr>
    <td colspan="2">In order to enable users to add/submit data to these extra fields/keys
    when submitting a new submission, you have to provide a field box with the name of your
    field/key. <br>
    <br>
    <b>For example: </b>Let's say you created a key/field called 'price' - In order for users
    to add a price value when submitting a new link, they will need a field box to fill in the
    price. The name of this field box needs to be the name of the field/key you
    defined/created. For example you will need to add something, like the following HTML code,
    to your submit form: (The text in orange is HTML code) Enter a Price: <br>
    <strong>&lt;input type=&quot;text&quot; name=&quot;price&quot; size=&quot;20&quot;&gt; </strong><br>
    <p><strong>Note that if you have upload fields (where users upload files) then the
    &lt;FORM&gt; tag of the form will need to look like this:<br>
    <font color="#FF8000">&lt;form method=&quot;POST&quot; action=&quot;!!addurlcgi!!&quot;
    ENCTYPE=&quot;multipart/form-data&quot;&gt;</font></strong></p>
    <p><b>The following fields/keys have been found to be present in your directory/search
    engine: </b><br>
    </td>
  </tr>
  <tr>
    <td width="26%" class="bar6"><strong>Extra Field/Key Name:</strong></td>
    <td width="74%" class="bar6"><strong>Suggested HTML Code in 'Add URL'
    form (Between &lt;FORM&gt; tags)</strong></td>
  </tr>
$sql_extra_keys2
</table>
<BR><BR>
	
	];




	
$estra_mod_details = qq[

<table width="100%" border="0" cellpadding="6" cellspacing="1" class="normaltext" style="border: 1px solid rgb(223,223,223)">
  <tr>
    <td colspan="2" class="bar6"><b>You have defined extra/fields keys. Please read below:</b></td>
  </tr>
  <tr>
    <td colspan="2">In order to enable users to modify data in these extra fields/keys, you
    have to provide a field box with the name of your field/key and a value inside it. <p><b>For
    example: </b>Let's say you created a key/field called 'price' - In order for users to
    modify the price value of their link, they will need a field box where they can modify the
    price. The name of this field box needs to be the name of the field/key you
    defined/created. For example you will have to add something like the following HTML code
    to your modify form: (The text in orange is HTML code) Price: &lt;input
    type=&quot;text&quot; name=&quot;price&quot; size=&quot;20&quot;
    value=&quot;%%price%%&quot;&gt; <br>
    <br>
    <b>The following fields/keys have been found to be present in your directory/search
    engine: </b></td>
  </tr>
  <tr>
    <td width="26%" class="bar6"><strong>Extra Field/Key Name:</strong></td>
    <td width="74%" class="bar6"><strong>Suggested HTML Code in 'Modify' form
    (Between &lt;FORM&gt; tags)</strong></td>
  </tr>
$sql_extra_keys3
</table>

	
];

	}


#$tmpl_details{''} = qq[
#<b>HEADING<br></b>
#DIZ
#];

#$tmpl_details{''} = qq[



$tmpl_details{'rgs_msgregister1'} = qq[<b>Editing: Add URL Registration Message<br></b>
This template is displayed to a visitor that clicks the 'Add URL' or  'Premium Add URL' button but the 
visitor is not registered. This template tells the visitor that he/she should be registered in order
to Add their link.];

$tmpl_details{'rgs_msgregister2'} = qq[

<b>!!account_create!!</b><BR>
This is replaced by a link to the registration script that enables users to register accounts.
<BR><BR>

<b>!!rgs_login!!</b><BR>
This is replaced by a link to the script that takes care of logins.
<BR><BR>

<b>!!rgs_login!!</b><BR>
This is replaced by a link to the script that takes care of logins.
<BR><BR>

<b>!!retreive_password!!</b><BR>
This is replaced by a link to the script that takes care of helping users to retrieve their passwords.
];

####################


$tmpl_details{'rgs_register1'} = qq[
<b>New User Registration<br></b>
This template is used to collect details from visitors registering new accounts.
];

$tmpl_details{'rgs_register2'} = qq[
<b>!!error_text!!</b><BR>
This is replaced by error messages in the event where a user left out required information to register a new account.<BR><BR>

<b>!!rgs_user!!</b><BR>
This is replaced by the user name a user has chosen.<BR><BR>

<b>!!rgs_pass!!</b><BR>
This is replaced by the password a user has chosen.<BR><BR>

<b>!!name!!</b><BR>
This is replaced by the name of the user.<BR><BR>

<b>!!email!!</b><BR>
This is replaced by the email address of the user.<BR><BR>

<b>!!email2!!</b><BR>
This is replaced by the confirmation email address entered by the user.<BR><BR>

<b>!!extra1!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra2!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra3!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra4!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra5!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra6!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra7!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra8!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra9!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra10!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!rgs_register!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.
];


##########

$tmpl_details{'rgs_regsuccess1'} = qq[
<b>Successfully Registered<br></b>
This template is displayed to a visitor after he/she successfully created an account.
];

$tmpl_details{'rgs_regsuccess2'} = qq[$globalmsg];


##########

$tmpl_details{'rgs_actsuccess1'} = qq[
<b>Successfully Registered<br></b>
This template is displayed to a visitor after he/she activated his/her account.
];

$tmpl_details{'rgs_actsuccess2'} = qq[$globalmsg];

##########

$tmpl_details{'rgs_actfailed1'} = qq[
<b>Successfully Registered<br></b>
This template is displayed to a visitor after he/she activated his/her account.
];

$tmpl_details{'rgs_actfailed2'} = qq[

<b>!!error_text!!</b><BR>
This is replaced by and error message indicating that the user name or password entered was incorrect.<BR><BR>

<b>!!rgs_resendact!!</b><BR>
Replaced by the script that takes care of re-sending the activation email.
];


##########

$tmpl_details{'rgs_actfailed1'} = qq[
<b>Account Activation Failedbr></b>
This template is displayed when there is a problem with account activation.
];

$tmpl_details{'rgs_actfailed2'} = qq[

<b>!!error_text!!</b><BR>
This is replaced by and error message indicating that the user name or password entered was incorrect.<BR><BR>

<b>!!rgs_resendact!!</b><BR>
Replaced by the script that takes care of re-sending the activation email.
];


###########

$tmpl_details{'rgs_resend1'} = qq[
<b>Resend Account Activation Email<br></b>
This template is displayed when a user chooses to have the account activation email resent to him/her.
];

$tmpl_details{'rgs_resend2'} = qq[

<b>!!error_text!!</b><BR>
This is replaced by and error message indicating that the user name or password entered was incorrect.<BR><BR>

<b>!!rgs_resendact!!</b><BR>
Replaced by the script that takes care of re-sending the activation email.
];

##############


$tmpl_details{'rgs_sent1'} = qq[
<b>Resend Account Activation Email<br></b>
This template is displayed when a user chooses to have the account activation email resent to him/her.
];

$tmpl_details{'rgs_sent2'} = qq[

<b>!!error_text!!</b><BR>
This is replaced by and error message indicating that the user name or password entered was incorrect.<BR><BR>

<b>!!rgs_resendact!!</b><BR>
Replaced by the script that takes care of re-sending the activation email.
];

##############

$tmpl_details{'rgs_actsuccess1'} = qq[
<b>Account Activation Email Sent<br></b>
This template is displayed to a visitor after requesting that his/her re-activation email has been sent.
];

$tmpl_details{'rgs_actsuccess2'} = qq[$globalmsg];

##############

$tmpl_details{'rgs_login1'} = qq[
<b>User Login<br></b>
This template is displayed when a user chooses to login to his/her account.
];

$tmpl_details{'rgs_login2'} = qq[

<b>!!error_text!!</b><BR>
This is replaced by and error message indicating that the user name or password entered was incorrect.<BR><BR>

<b>!!rgs_resendact!!</b><BR>
This is replaced by a link to the script that takes care of logins.<BR><BR>

<b>!!retreive_password!!</b><BR>
This is replaced by a link to the script that takes care of helping users to retrieve their passwords.
<BR><BR>

<b>!!resend_activation!!</b><BR>
Replaced by the script that takes care of re-sending the activation email.

];

###############

$tmpl_details{'rgs_logout1'} = qq[
<b>User Log out<br></b>
This template is displayed when a user chooses to log out of his/her account.
];

$tmpl_details{'rgs_logout2'} = qq[$globalmsg];

###############

$tmpl_details{'rgs_retrievepass1'} = qq[
<b>Retrieve Password<br></b>
This template is displayed when a user chooses to have his/her user name and password sent to his/her email address.
];

$tmpl_details{'rgs_retrievepass2'} = qq[
<b>!!error_text!!</b><BR>
This is replaced by an error message when the email address was not found.<BR><BR>
];

###############

$tmpl_details{'rgs_retrievepass_ok1'} = qq[
<b>Retrieve Password Success<br></b>
This template is displayed when a user has successfully requested that his/her password be sent to them.
];

$tmpl_details{'rgs_retrievepass_ok2'} = qq[$globalmsg];


###############

$tmpl_details{'rgs_cpmain1'} = qq[
<b>Main Control Panel<br></b>
This page is displayed when a user logs in. It also lists the links a user has added. A user can also modify his/her links from this page.
];

$tmpl_details{'rgs_cpmain2'} = qq[
<b>!!user_links!!</b><BR>
This is replaced by the link listings the user has. Note that this template works in conjunction with the links template (rgs_acclinks.html) that
defines the style of the link display.
];


###############

$tmpl_details{'rgs_acclinks1'} = qq[
<b>Account Links Style<br></b>
This template defines the style of links when displaying it inside the user account area.
];

$tmpl_details{'rgs_acclinks2'} = qq[

<b>!!title_with_link!!</b><BR>
Replaced by the title of the link and the title is hyperlinked.<br><BR>

<b>!!title_without_link!!</b><BR>
Replaced by the title of the link but it is not hyperlinked.<br><br> 

<b>!!rating_image!!</b><BR>
Replaced by an image representing the rating of the link.<br><br> 

<b>!!new!!</b><BR>
Replaced by a 'New' graphic if the link is considered as being new. Settings regarding this is available
in the Settings tab >> Global Engine Settings >> New & Popular Indication Settings<br><br>

<b>!!pop!!</b><br>
Replaced by a 'Poplar' graphic if the link is considered as being popular. Settings regarding this is available
in the Settings tab >> Global Engine Settings >> New & Popular Indication Settings<br><br>

<b>!!description!!</b><br>
Replaced by the description of the link.<BR><BR>

<b>!!url!!</b><br>
Replaced by the url of the link.<br><BR>

<b>!!keywords!!</b><br>
Replaced by the keywords of the link.<br><BR>

<b>!!keywords!!</b><br>
Replaced by the keywords of the link.<br><BR>

<b>!!more_info_url!!</b><br>
This will be replaced by the link/URL to a page that contains more information about the link. 
<br><br> 

<b>!!rating!!</b><br>
Replaced by the rating of the link.<br><BR>

<b>!!votes!!</b><br>
Replaced by the number of votes received for this link.<br><BR>

<b>!!hits!!</b><br>
Replaced by the number of hits [mouse-clicks] the link has received.<br><br> 

<b>!!date!!</b><br>
Replaced by the date of when the link was added.<br><BR>

<b>!!category!!</b><br>
Replaced by the category of the link. It also has a clickable link to view the category.<br><br>

<b>!!aproval_status!!</b><br>
When a link is added by a user the Administrator needs to a approve the link from the new submissions area
for inclussion into the index. The !!aproval_status!! variable indicates if the link has been approved or
still needs to be approved.
<br><br>

<b>!!cp_modify!!</b><br>
This is replaced by a link to a modify form so that users can modify their links if required.<br><br>

<b>!!cp_com!!</b><br>
This is replaced by a link to view comments posted about this link by other visitors.<br><BR>

<b>!!link_image!!</b><br>
This will be replaced by an uploaded image that was uploaded for the link. You can set the width and height to be fixed by going to the Control Panel >> Settings >> Global Engine Settings >> Directory/Category Listing Settings<br><br>

<strong>!!link_file!!</strong><br>
If something other than an image (like a .pdf or .avi file) was uploaded then this variable can be used and it will be replaced by the full URL path to the file. <BR><BR>

$sql_extra_keys

];

############

$tmpl_details{'rgs_acclinksp1'} = qq[
<b>Account Premium Links Style<br></b>
This template defines the style of premium links when displaying it inside the user account area.
];

$tmpl_details{'rgs_acclinksp2'} = qq[

<b>!!title_with_link!!</b><BR>
Replaced by the title of the link and the title is hyperlinked.<br><BR>

<b>!!title_without_link!!</b><BR>
Replaced by the title of the link but it is not hyperlinked.<br><br> 

<b>!!rating_image!!</b><BR>
Replaced by an image representing the rating of the link.<br><br> 

<b>!!new!!</b><BR>
Replaced by a 'New' graphic if the link is considered as being new. Settings regarding this is available
in the Settings tab >> Global Engine Settings >> New & Popular Indication Settings<br><br>

<b>!!pop!!</b><br>
Replaced by a 'Poplar' graphic if the link is considered as being popular. Settings regarding this is available
in the Settings tab >> Global Engine Settings >> New & Popular Indication Settings<br><br>

<b>!!description!!</b><br>
Replaced by the description of the link.<BR><BR>

<b>!!url!!</b><br>
Replaced by the url of the link.<br><BR>

<b>!!keywords!!</b><br>
Replaced by the keywords of the link.<br><BR>

<b>!!keywords!!</b><br>
Replaced by the keywords of the link.<br><BR>

<b>!!more_info_url!!</b><br>
This will be replaced by the link/URL to a page that contains more information about the link. 
<br><br> 

<b>!!rating!!</b><br>
Replaced by the rating of the link.<br><BR>

<b>!!votes!!</b><br>
Replaced by the number of votes received for this link.<br><BR>

<b>!!hits!!</b><br>
Replaced by the number of hits [mouse-clicks] the link has received.<br><br> 

<b>!!date!!</b><br>
Replaced by the date of when the link was added.<br><BR>

<b>!!category!!</b><br>
Replaced by the category of the link. It also has a clickable link to view the category.<br><br>

<b>!!aproval_status!!</b><br>
When a link is added by a user the Administrator needs to a approve the link from the new submissions area
for inclussion into the index. The !!aproval_status!! variable indicates if the link has been approved or
still needs to be approved.
<br><br>

<b>!!cp_modify!!</b><br>
This is replaced by a link to a modify form so that users can modify their links if required.<br><br>

<b>!!cp_com!!</b><br>
This is replaced by a link to view comments posted about this link by other visitors.<br><br>

<b>!!premium_expiry!!</b><br>
This is replaced by the expiry date to indicate when the premium link will expire. When a premium
link expires it just becomes a standard link.<br><BR>

<b>!!link_image!!</b><br>
This will be replaced by an uploaded image that was uploaded for the link. You can set the width and height to be fixed by going to the Control Panel >> Settings >> Global Engine Settings >> Directory/Category Listing Settings<br><br>

<strong>!!link_file!!</strong><br>
If something other than an image (like a .pdf or .avi file) was uploaded then this variable can be used and it will be replaced by the full URL path to the file. <BR><BR>



$sql_extra_keys

];



###############

$tmpl_details{'rgs_nolinks1'} = qq[
<b>No Links Display<br></b>
If there are no links to display when a user logs in, then the contents of this template will be displayed. It 
will be replaced the !!user_links!! variable. If there are links then this template will not be displayed and
the !!user_links!! will be replaced by the user's link listings.
];

$tmpl_details{'rgs_nolinks2'} = qq[$globalmsg];


##############


$tmpl_details{'rgs_editacc1'} = qq[
<b>Edit Account Details<br></b>
This template is used when a user edits/changes his/her account information.
];

$tmpl_details{'rgs_editacc2'} = qq[

<b>!!error_text!!</b><BR>
This is replaced by error messages in the event where a user left out required information to register a new account.<BR><BR>

<b>!!rgsuser!!</b><BR>
Replaced by the user name of the user.<BR><BR>

<b>!!rgspass!!</b><BR>
This is replaced by the password a user has chosen.<BR><BR>

<b>!!rgsname!!</b><BR>
This is replaced by the name of the user.<BR><BR>

<b>!!rgsemail!!</b><BR>
This is replaced by the email address of the user.<BR><BR>

<b>!!extra1!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra2!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra3!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra4!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra5!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra6!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra7!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra8!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra9!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!extra10!!</b><BR>
This is replaced by extra field data if you make use of extra fields to collect extra data when users register.<BR><BR>

<b>!!save_details!!</b><BR>
This is replaced by the script that saves the account details.

];

##############

$tmpl_details{'rgs_saveacc1'} = qq[
<b>Succesfully Saved Account Details<br></b>
This template is displayed when a user has successfully edited/changed his/her account details.
];

$tmpl_details{'rgs_saveacc2'} = qq[$globalmsg];


##############


$tmpl_details{'rgs_add_url_med1'} = qq[
<b>Editing: Medium-Sized Search Engine Add URL Template<br></b>
This template (when displayed to end users) comes with a drop down menu containing all the categories/directories 
where end users can select where they would like to submit their URL. This template is intended for medium-sized
search engines with less than 5000 categories/directories. 
You can choose what 'add url' forms to use (medium or large-sized engines), in <BR><b>Settings Tab >> Global Engine Settings >>
 New Submission Settings</b>
];




$tmpl_details{'rgs_add_url_med2'} = qq[

<b>!!error_text!!</b><br>
This is replaced by a an error displayed to the user when a submission cannot be accepted due to a mistake like 'missing titles, invalid email address, etc)'. <br><br> 

<b>%%category_dropdown%%</b><br>
This is replaced by a category drop down box where users can select the category wherein they would like to make a new submission.<br><br> 

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box where end users supply descriptions for their new submission.<br><br> 

<b>!!addurlcgi!!</b><br>
Replaced by the path to the 'Add URL' script which handles the new submission.<BR><BR>


<b>%%imgbox%%</b><br>
This is replaced by image letters that a user must type. This is mainly used so that your Search Engine cannot be spammed. 
You can find out <a href="$admin_url/help.cgi?fct=image_auth" target="_blank">here</a> how to turn this functionality on or off.<BR><BR>

<b>!!ia!!</b><br>
A hidden variable that works in conjunction with image authentication.<BR><BR>

<b>!!p!!</b><br>
A hidden variable indicating a premium URL submission or not.

$extra_details

];

###############

$tmpl_details{'rgs_add_url1'} = qq[
<b>Editing: Large-Sized Search Engine Add URL Template<br></b>
This template (when displayed to end users) is intended to be used when you have more than 5000 categories/directories.
It doesn't come with a category dropdown menu where categories can be choosed when doing a new submission. The reason
for this is because having 10 000 categories in the drop down menu would make the add url form load very slowly.
You can choose what add url forms to use (medium or large-sized engines), in the <b>Settings Tab >> Global Engine Settings >>
New Submission Settings</b>
];



$tmpl_details{'rgs_add_url2'} = qq[

<b>!!error_text!!</b><br>
This is replaced by a an error displayed to the user when a submission cannot be accepted due to a mistake like 'missing titles, invalid email address, etc)'. <br><br> 

<b>%%add_category%%</b><br>
This is replaced by the category name where the user is about to make a submission.<br><br> 

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box where end users supply descriptions for their new submission.<br><br> 

<b>!!addurlcgi!!</b><br>
Replaced by the path to the 'Add URL' script which handles the new submission.<BR><BR>


<b>%%imgbox%%</b>
This is replaced by image letters that a user must type. This is mainly used so that your Search Engine cannot be spammed. 
You can find out <a href="$admin_url/help.cgi?fct=image_auth" target="_blank">here</a> how to turn this functionality on or off.<BR><BR>

<b>!!ia!!</b><br>
A hidden variable that works in conjunction with image authentication.<BR><BR>

<b>!!catid!!</b><br>
This is a hidden form variable that is replaced by a category ID so that the add url script which handles the submission
knows to what category the script needs to submit the new submission. <BR><BR>

<b>!!p!!</b><br>
A hidden variable indicating a premium URL submission or not.

$extra_details

];

########################

$tmpl_details{'rgs_add_url_medp1'} = qq[
<b>Editing: Medium-Sized Search Engine Premium Add URL Template</b><BR>
This template (when displayed to end users) is intended to be used when you have less than 5000 categories/directories.
This template is used when users add premium Url's.
];


$tmpl_details{'rgs_add_url_medp2'} = qq[

<b>!!error_text!!</b><br>
This is replaced by a an error displayed to the user when a submission cannot be accepted due to a mistake like 'missing titles, invalid email address, etc)'. <br><br> 


<b>%%category_dropdown%%</b><br>
This is replaced by a category drop down box where users can select the category wherein they would like to make a new submission.<br><br> 

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box where end users supply descriptions for their new submission.<br><br> 

<b>!!addurlcgi!!</b><br>
Replaced by the path to the 'Add URL' script which handles the new submission.<BR><BR>


<b>%%imgbox%%</b>
This is replaced by image letters that a user must type. This is mainly used so that your Search Engine cannot be spammed. 
You can find out <a href="$admin_url/help.cgi?fct=image_auth" target="_blank">here</a> how to turn this functionality on or off.<BR><BR>

<b>!!ia!!</b><br>
A hidden variable that works in conjunction with image authentication.<BR><BR>

<b>!!catid!!</b><br>
This is a hidden form variable that is replaced by a category ID so that the add url script which handles the submission
knows to what category the script needs to submit the new submission. <BR><BR>

<b>!!p!!</b><br>
A hidden variable indicating a premium URL submission or not.

$extra_details

];


##############


$tmpl_details{'rgs_add_urlp1'} = qq[
<b>Editing: Large-Sized Search Engine Premium Add URL Template</b><BR>
This template (when displayed to end users) is intended to be used when you have more than 5000 categories/directories.
It is also used to add premium Url's.
];


$tmpl_details{'rgs_add_urlp2'} = qq[

<b>!!error_text!!</b><br>
This is replaced by a an error displayed to the user when a submission cannot be accepted due to a mistake like 'missing titles, invalid email address, etc)'. <br><br> 

<b>%%add_category%%</b><br>
This is replaced by the category name where the user is about to make a submission.<br><br> 

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box where end users supply descriptions for their new submission.<br><br> 

<b>!!addurlcgi!!</b><br>
Replaced by the path to the 'Add URL' script which handles the new submission.<BR><BR>

<b>%%imgbox%%</b>
This is replaced by image letters that a user must type. This is mainly used so that your Search Engine cannot be spammed. 
You can find out <a href="$admin_url/help.cgi?fct=image_auth" target="_blank">here</a> how to turn this functionality on or off.<BR><BR>

<b>!!ia!!</b><br>
A hidden variable that works in conjunction with image authentication.<BR><BR>

<b>!!catid!!</b><br>
This is a hidden form variable that is replaced by a category ID so that the add url script which handles the submission
knows to what category the script needs to submit the new submission. <BR><BR>

<b>!!p!!</b><br>
A hidden variable indicating a premium URL submission or not.

$extra_details

];

############

$tmpl_details{'rgs_add_url_instructions1'} = qq[
<b>Add URL instructions</b><BR>
This template is used to indicate that a user have to be inside a category to add a URL. This template is only
used when the Add URL forms of Large-Sized Search Engines is used. (rgs_add_url.html and rgs_add_urlp.html)
];


$tmpl_details{'rgs_add_url_instructions2'} = qq[$globalmsg];

############

$tmpl_details{'rgs_locked1'} = qq[
<b>Category Locked</b><BR>
This template is displayed when a user tries to add a listing to a category that has been locked. Users cannot add listings
to categories that has been locked. Categories can be locked by pressing the edit button next to a category when browsing
the Dir Manager. 
];

$tmpl_details{'rgs_locked2'} = qq[$globalmsg];

############

$tmpl_details{'rgs_add_url_problem1'} = qq[
<b>Add URL Problem Template</b><BR>
This template is displayed when a user tries to submit a listing but there was a problem adding the listing.
];

$tmpl_details{'rgs_add_url_problem2'} = qq[

<b>%%problem%%</b><br>
Replaced by text explaining the problem that occurred when trying to submit the listing.

];

#############


$tmpl_details{'rgs_add_url_success1'} = qq[
<b>Add URL Success Template</b><BR>
This template is displayed to a user who successfully added a URL or Premium URL.
];

$tmpl_details{'rgs_add_url_success2'} = qq[$globalmsg];


#############


$tmpl_details{'rgs_modify_link_edit1'} = qq[
<b>Modify/Edit Link</b><BR>
This template is used to display standard link details that is about to be modified by the link owner.
];


$tmpl_details{'rgs_modify_link_edit2'} = qq[

<b>!!error_text!!</b><br>
This is replaced by a an error displayed to the user when a modification cannot be accepted due to a mistake like 'missing titles, invalid email address, etc)'. <br><br> 

<b>%%title%%</b><br>
This is replaced by the title of the link listing.

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box that contains the description of the link listing.<br><br> 

<b>%%keywords%%</b><br>
This is replaced by the keywords of the link listing.<br><br> 

<b>%%url%%</b><br>
This is replaced by the URL of the link listing.<br><br> 

<b>%%name%%</b><br>
Replaced by the contact person for this link.<br><br> 

<b>%%email%%</b><br>
Replaced by the contact email for this link.<br><br> 

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box that contains the description of the link listing.<br><br> 

<b>%%notes%%</b><br>
This is replaced by a fill-in-box where users can write any comments/notes about the modification to the link.<br><br> 

<b>!!cid!!</b><br>
This is part of a hidden form variable, replaced by a category ID for use by the modify script.<br><br> 

<b>!!id!!</b><br>
This is part of a hidden form variable, replaced by a link ID for use by the modify script.<br><br> 

<b>!!modify_cgi!!</b><br>
Replaced by the path to the modify script.<br><br> 

<b>!!password!!</b><br>
This is a hidden form variable used by the modify script. <br><br> 

$estra_mod_details
];


################


$tmpl_details{'rgs_modify_link_editp1'} = qq[
<b>Modify/Edit Link</b><BR>
This template is used to display premium link details that is about to be modified by the link owner.
];


$tmpl_details{'rgs_modify_link_editp2'} = qq[

<b>!!error_text!!</b><br>
This is replaced by a an error displayed to the user when a modification cannot be accepted due to a mistake like 'missing titles, invalid email address, etc)'. <br><br> 

<b>%%title%%</b><br>
This is replaced by the title of the link listing.

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box that contains the description of the link listing.<br><br> 

<b>%%keywords%%</b><br>
This is replaced by the keywords of the link listing.<br><br> 

<b>%%url%%</b><br>
This is replaced by the URL of the link listing.<br><br> 

<b>%%name%%</b><br>
Replaced by the contact person for this link.<br><br> 

<b>%%email%%</b><br>
Replaced by the contact email for this link.<br><br> 

<b>%%submissionbox%%</b><br>
This is replaced by a description fill-in-box that contains the description of the link listing.<br><br> 

<b>%%notes%%</b><br>
This is replaced by a fill-in-box where users can write any comments/notes about the modification to the link.<br><br> 

<b>!!cid!!</b><br>
This is part of a hidden form variable, replaced by a category ID for use by the modify script.<br><br> 

<b>!!id!!</b><br>
This is part of a hidden form variable, replaced by a link ID for use by the modify script.<br><br> 

<b>!!modify_cgi!!</b><br>
Replaced by the path to the modify script.<br><br> 

<b>!!password!!</b><br>
This is a hidden form variable used by the modify script. <br><br> 

$estra_mod_details
];



#################

$tmpl_details{'rgs_modify_link_problem1'} = qq[
<b>Modify/Edit Link</b><BR>
This template is displayed when there was a problem while trying to modify a link.
];


$tmpl_details{'rgs_modify_link_problem2'} = qq[

<b>%%problem%%</b><br>
Replaced by text explaining a problem when trying to modify the link.
];

#################

$tmpl_details{'rgs_modify_instructions1'} = qq[
<b>Modify/Edit Instructions</b><BR>
In the event where a user is not logged in and attempts to modify a link the the following template will be displayed to him/her.
];


$tmpl_details{'rgs_modify_instructions2'} = qq[$globalmsg];

###################


#################

$tmpl_details{'rgs_rcomment1'} = qq[
<b>Registration Required to Post a Comment Page</b><BR>
This template will be displayed informing the user that he/she will need to register an account or be logged in to be able to post a comment.
];


$tmpl_details{'rgs_rcomment2'} = qq[

<b>!!register!!</b><br>
Replaced by the URL to the registration page. (Where visitors can register an account)
<BR><BR>
<b>!!rgs_login!!</b><br>
Replaced by the URL to the login page. (Where visitors log into their user accounts)

];

###################


$tmpl_details{'rgs_rrate1'} = qq[
<b>Registration Required to Rate a Link</b><BR>
This template will be displayed informing the user that he/she will need to register an account or be logged in to be able rate a link.
];


$tmpl_details{'rgs_rrate2'} = qq[

<b>!!register!!</b><br>
Replaced by the URL to the registration page. (Where visitors can register an account)
<BR><BR>
<b>!!rgs_login!!</b><br>
Replaced by the URL to the login page. (Where visitors log into their user accounts)

];

#####################

$tmpl_details{'rgs_regsuccess_paypal1'} = qq[
<b>Success Page PayPal Purchase</b><BR>
This template is displayed to a user after he/she successfully submitted a premium link and paid for it with PayPal. PayPal will redirect to this page after it successfully processed the PayPal payment.
];

$tmpl_details{'rgs_regsuccess_paypal2'} = qq[
This template has no variables.
];

######################

$tmpl_details{'rgs_upgrade1'} = qq[
<b>Upgrade Page Standard to Premium </b><BR>
This template is displayed to users when they click to upgrade a standard listing to a premium listing. This template may be displayed or may not be displayed depending on the Premium Link configuration. 
The premium link configuration can be set by clicking the 'Settings' tab from the PowerSeek control panel. Then click on: Premium Link Settings
];

$tmpl_details{'rgs_upgrade2'} = qq[
This template does contain variables but the HTML code and variables to use inside this template is obtained from the PowerSeek Control Panel >> Settings >> Premium Link Settings - After saving the 
'Premium Link' settings you will receive instructions on what to place inside this template. The HTML code you are given after saving the premium link settings represents options that users can choose
for different premium link order options.
];


$tmpl_details{'rgs_upgrade_paypal_success1'} = qq[
<b>Upgrade Page PayPal Purchase Success </b><Br> 
This template is displayed to users when they have successfully upgraded a standard link to a premium link. It will be displayed after they made payment with PayPal to upgrade
to a premium link.
];

$tmpl_details{'rgs_upgrade_paypal_success2'} = $globalmsg;


#$tmpl_details{'rgs_regsuccess_paypal2'} = qq[
#];


}





sub get_template_help
{

$template_help = qq[
<p><strong><font face="Verdana" size="2">Te<a name="templatehelp"></a>mplate Help</font><font
face="Verdana" size="1"><br>
</strong><br>
Templates are used in conjunction with all aspects <strong>of displaying your directory
to end users</strong>. Each template <strong>consists of</strong> <strong>HTML code</strong>
with <strong>variable words</strong> and is used in combination with each other. These
variable words are enclosed by %% or !! characters. <strong>For example: %%date%%</strong>.
Most of these variables words need to be present to do a certain task. These variable words
are <strong>replaced by data</strong> when displayed to end users of your directory.</font></p>

<p><font face="Verdana" size="1">Probably the easiest way to understand how templates work
is to <strong>play around with the HTML code of templates:</strong> Open the HTML
templates with your web editor or copy and paste the HTML code into your
web editor and start editing. Experiment with the templates and try
different combinations. You'll be surprised with what you can come up. The templates gives
you total control on the look and feel of your search engine and directory.</font></p>
<strong>

<p><font face="Verdana" size="1">Note that when you make use of images</strong> in the
HTML code of templates, you must use a URL link to indicate their locations. <br>
For example:</font></p>

<blockquote>
  <p><font face="Verdana" size="1"><strong><font color="#ff8000">&lt;img
  src=&quot;someimage.gif&quot;&gt; </font>will not work.</strong><br>
  &nbsp; <br>
  <strong>You have to indicate the entire URL</strong> <strong>where someimage.gif is
  located. For example:</strong><br>
  &nbsp;&nbsp;&nbsp;&nbsp; <br>
  <font color="#ff8000"><strong>&lt;img
  src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt;</strong><br>
  </font>&nbsp;&nbsp;&nbsp; <br>
  The <strong>&lt;img</strong> is an HTML tag indicating that you want to insert an image in
  the HTML page. The <strong>src= </strong>part indicates that you want to specify the
  location of the image to be inserted. Some web editors will support inserting images from
  a web url and some won't. If your web editor does not support this, insert the image into
  the HTML page like usual and when finished edit the source of the HTML code and manually
  insert the URL path's to the images. Ensure that the images are on the server for the URL
  path's you specify.</font></p>
  <blockquote>
    <p><font face="Verdana" size="1"><strong>Example, editing the HTML source code:</strong></font></p>
  </blockquote>
  <blockquote>
    <p><font face="Verdana" size="1"><strong>Replace <font color="#ff8000">&lt;img
    src=&quot;someimage.gif&quot;&gt;</font> with<br>
    <font color="#ff8000">&lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt;</font></strong></font></p>
  </blockquote>
</blockquote>
];

}








####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

