#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";


########

$linkchk = $q->param('linkchk');

$ct = $q->param('ct'); ### ORIGINAL CAT
$cid = $q->param('cid'); ### ORIGINAL CID
$rid = $q->param('rid'); ### ORIGINAL RID

$mct = $q->param('mct'); ### TO MOVE TO CAT
$mlv = $q->param('mlv'); ### TO MOVE LEVEL
$mcid = $q->param('mcid'); ### TO MOVE CID

$last_dname = acs::get_last_dirname($mct);

if ($q->param('fct') eq "related") { $fct = "related"; }

########

$location = acs::get_location_string ($ct);

########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
########

if ($mlv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}
	else
	{
	$mlv++;
	@adir = split (/-/, $mct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $mlv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$mlv') AND $querystr AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	
	}

##############

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$mlv = $row[1];

	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]"; } #9
	
	if ($row[11] ne ""){ $row[10] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[10] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[10] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[10] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[10] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[10] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[10] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	$locked_stat = "";
	if ($row[22] eq "Y") { $locked_stat = " <img src=\"$web_url/locked.gif\">"; }

	if ($last_dname eq "") { $last_dname = "Root "; }
	if ($smc == 0) 
		{
		$movedirs = $movedirs . " <img src=\"$web_url/dir.gif\"> <b>$last_dname</b> <br>";
		$selbox = "checked";
		}
		else
		{
		$selbox = "";
		}
	$smc++;
	
	$moveval = "$row[0]" . "___MVSPLT___" . "$row[28]";
	
	$movedirs = $movedirs . "<input type=\"radio\" name=\"movecat\" $selbox value=\"$row[0]\"> <img src=\"$web_url/subdir.gif\"> <a href=\"$admin_url/admin67.cgi?mlv=$mlv&mct=$dirstring&cid=$cid&rid=$rid&&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">$row[28]</a></strong> ($row[20]) ID=$row[0] $locked_stat<br>";
	
	$oid = $row[0];
	}

$sth->finish;
$dbh->disconnect;



#### CURRENT MOVE LOCATION

if ($mct eq "")
	{
	$currentloc = "Root ";
	}
	else
	{
	$currentloc = "<a href=\"$admin_url/admin67.cgi?mlv=&mct=&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">Root</a> ";
	
	$n_mlv = 1;
	
	@allds = split (/-/, $mct);
	$ccnr = @allds;

	foreach $aitem (@allds)
		{
		$n_mct = $n_mct . $aitem . "-";
		
		$cdname = acs::decode_dir($aitem);
		
		$cnn_mct = substr($n_mct, 0, length($n_mct) - 1);
		
		if ($ccnr ne $n_mlv)
			{
			$currentloc = $currentloc . " > <a href=\"$admin_url/admin67.cgi?mlv=$n_mlv&mct=$cnn_mct&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">$cdname</a> ";
			}
			else
			{
			$currentloc = $currentloc . " > $cdname ";
			}
		
		$n_mlv++;
		}
	
	}

#### 

if ($dirstring !~ /-/)
	{
	$pmct = "";
	}
	else
	{
	$pmct = "$mct";
	}


#####

if ($mlv eq "")
	{
	$create_lv = 0;
	}
	else
	{
	$create_lv = $mlv -1;
	}

if ($rows == 0)
	{
$movedirs = qq[
<p><strong>This category contains no sub
directories/categories. <br>
</strong>
<a href="" onClick="history.go(-1); return false;">Go Back</a>
</p>
];

	}
	elsif ($q->param('fct') eq "")
	{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" onclick=\"post_value();\" class=\"psbutton\">";
	}
	elsif ($q->param('fct') eq "related")
	{
	
		if ($q->param('linkchk') eq "true")
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\"  onclick=\"post_value3(); return false;\"  class=\"psbutton\">";
		$linkchk = "true";
		}
		else
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" onclick=\"post_value2(); return false;\"  class=\"psbutton\">";
		}
		
	}

###############

if ($q->param('fct') eq "")
	{
	$move_title = "Find Directory/Category";
	}
	elsif ($q->param('linkchk') ne "true")
	{
	$move_title = "Find Directory/Category";
	}
	elsif ($q->param('linkchk') eq "true")
	{
	$move_title = "Find Directory/Category";
	}

	$movew = "Move";
	$faction = "move_operation";


###############	


$mbox_content = qq[

<b>Current Location:</b> <img src="$web_url/lar.gif" width="6" height="10"> $currentloc

<form method="POST" action="$movecgi" name="asform" >
  <input type="hidden" name="fct" value="$fct">
  <input type="hidden" name="ct" value="$ct">
  <input type="hidden" name="links_to_move" value="$hselstring">
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="rid" value="$rid">
  <input type="hidden" name="mct" value="$pmct">
  <input type="hidden" name="newsub" value="$newsub2">
  <input type="hidden" name="email" value="$newsubemail">
  <input type="hidden" name="lastid" value="$oid">

<BR>
<blockquote>
  <p>$movedirs</p>
</blockquote>
<BR>

  <p>$movebut
    <input type="submit" class="psbutton" value="   Add Dir    " name="createdir" 
  		onClick="popup('$admin_url/admin2.cgi?fct=addir&ct=$mct&lv=$create_lv&mscr=mscr',750,550);return false;">
      <input type="submit" class="psbutton" value="Close Window" name="createdir2"  onClick=window.close()>
</form>


];

$mbox = acs::get_heading_box("$web_url/add.gif", "$move_title", qq[$mbox_content]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>$move_title</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 

<script LANGUAGE="JavaScript">

$jspopup_code 

function post_value()
{


if (document.asform.movecat.length == undefined)
	{
	myOption = 0;
	opener.document.addu.crosslinkid.value = document.asform.lastid.value;
	}
	else
	{
		for (i=document.asform.movecat.length-1; i > -1; i--) 
			{
			if (document.asform.movecat[i].checked) 
				{
				myOption = i;
				}
			}
		opener.document.addu.crosslinkid.value = document.asform.movecat[myOption].value;
	}


window.close();
}


function post_value2()
{

if (document.asform.movecat.length == undefined)
	{
	myOption = 0;
	opener.document.addu.related_categories.value = opener.document.addu.related_categories.value + document.asform.lastid.value + ','; 
	}
	else
	{
	
		for (i= document.asform.movecat.length-1; i > -1; i--) 
			{
			if (document.asform.movecat[i].checked) 
				{
				myOption = i;
				}
			}
	
	opener.document.addu.related_categories.value = opener.document.addu.related_categories.value + document.asform.movecat[myOption].value + ','; 
	}

}


function post_value3()
{

if (document.asform.movecat.length == undefined)
	{
	myOption = 0;
	opener.document.addu.ids.value = opener.document.addu.ids.value + document.asform.lastid.value + ','; 
	}
	else
	{
	
		for (i=document.asform.movecat.length-1; i > -1; i--) 
			{
			if (document.asform.movecat[i].checked) 
				{
				myOption = i;
				}
			}
	
	opener.document.addu.ids.value = opener.document.addu.ids.value + document.asform.movecat[myOption].value + ','; 
	}

}

</script>
</head>
<body>
$mbox
</body>
</html>
];






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

