#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use fmtmplman;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "template_functions")	{ &template_functions; exit;}

if ($q->param('fct') eq "dir_templates")		{ print fmtmplman::dir_templates;}
if ($q->param('fct') eq "search_results")		{ print fmtmplman::search_results; }
if ($q->param('fct') eq "add_url_tmpls")		{ print fmtmplman::add_url_tmpls; }
if ($q->param('fct') eq "add_url_tmpls2")		{ print fmtmplman::add_url_tmpls2; }
if ($q->param('fct') eq "ratings_templates")	{ print fmtmplman::ratings_templates; }
if ($q->param('fct') eq "comments")				{ print fmtmplman::comments; }
if ($q->param('fct') eq "whatsnew")				{ print fmtmplman::whatsnew; }
if ($q->param('fct') eq "tophits")				{ print fmtmplman::tophits; }
if ($q->param('fct') eq "broke_templ")			{ print fmtmplman::broke_templ; }
if ($q->param('fct') eq "mail_remove")			{ print fmtmplman::mail_remove; }
if ($q->param('fct') eq "favorites")			{ print fmtmplman::favorites; }
if ($q->param('fct') eq "contactus")			{ print fmtmplman::contactus; }




####################################################################################

sub ttip
{

print qq[<script SRC="$web_url/qtip.js"></script>
<style type="text/css">
<!--
div#qTip { padding: 10px; border: 1px solid #DBDBDB; width:350px; display: none; background: url("$web_url/tooltback.gif"); color: #000; font: 11px Arial, sans-serif; text-align: left; position: absolute; z-index: 1000; }
-->
</style>
];

}


sub template_functions
{

$template_inc_nr = 0;

opendir(DIR,"$data_dir");
@files = readdir(DIR);

foreach $filename (@files)
	{
	if ((substr($filename, 0, 5) eq "incl_") and (substr($filename, length($filename) - 5, 5) eq ".html"))
		{
		$template_inc_nr++;
		}
	}
closedir(DIR);

print qq[
<table width="100%" border="0" align="center" cellpadding="6" cellspacing="1" class="aborder">
  <tr>
    <td onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><span class="normaltext"><strong><img src="$web_url/lar3.gif" width="10" height="11">
      <a href="$admin_url/admin17.cgi" onClick="popup('$admin_url/admin17.cgi',950, 700);return false;">Create/Edit
      Template Includes </a>($template_inc_nr)<br>
      </strong>Template Includes are pieces of HTML code which you can include in any template.
      These pieces of HTML code could be headers, footers or menu bars. It almost works like
      SSIs (server side includes) or Java Script Includes. Note that the template includes will
    only work in the PowerSeek templates. It will work in any template used by PowerSeek.</span></td>
  </tr>
  <tr>
    <td onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><span class="normaltext"><strong><img src="$web_url/lar3.gif" width="10" height="11">
      <a href="$admin_url/p_tmpglobal.cgi" onClick="popup('$admin_url/p_tmpglobal.cgi',950, 700);return false;">Implement Global Template</a><br>
      </strong>This function allows you to upload a master template (normal HTML file) and
      implement this template throughout all PowerSeek templates to give all PowerSeek end user
      pages the&nbsp; look and feel of the master template. It will act like a frame around all
      end-user PowerSeek pages. This template could contain your logo, graphics, layout, menu
    bars, etc. </span></td>
  </tr>
  <tr>
    <td onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><span class="normaltext"><strong><img src="$web_url/lar3.gif" width="10" height="11"><a href="$admin_url/p_tmptool.cgi" onClick="popup('$admin_url/p_tmptool.cgi',950, 700);return false;">Template Switching Tool </a><br>
    </strong>PowerSeek comes with a number of pre-created template sets (themes) that you can use. This tool enables you to switch to any of the pre-created templates that  comes with PowerSeek.</span></td>
  </tr>
  <tr>
    <td onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><span class="normaltext"><strong><img src="$web_url/lar3.gif" width="10" height="11">Other Template Functions: (Also Available Under the <a href="$admin_url/plugins.cgi">Plugins</a> tab)</strong><br>
        <a href="$admin_url/admin48.cgi" onclick="popup('$admin_url/admin48.cgi',950, 700);return false;">Category Includes</a>, <a href="$admin_url/admin45.cgi" onclick="popup('$admin_url/admin45.cgi',950, 700);return false;">Popular &amp; New Link      Includes</a>, <a href="$admin_url/admin46.cgi" onclick="popup('$admin_url/admin46.cgi',950, 700);return false;">Top Search Term Includes</a>, <a href="$admin_url/p_total_link.cgi" onclick="popup('$admin_url/p_total_link.cgi',950, 700);return false;">Total Link Include</a>, <a href="$admin_url/p_scloud.cgi" onclick="popup('$admin_url/p_scloud.cgi',950, 700);return false;">Search Cloud</a>, 
        <a href="$admin_url/admin27.cgi" onclick="popup('$admin_url/admin27.cgi',950, 700);return false;">Custom Category/Directory Template Sets</a></span></td>
  </tr>
</table>
<BR>
];

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

