#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use fmparse;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "edit") { &edit_field; }
if ($q->param('fct') eq "save_field") { &save_field; }
if ($q->param('fct') eq "change_css") { &change_css; }
if ($q->param('fct') eq "save_css") { &save_css; }
if ($q->param('fct') eq "edit_modified") { &edit_modified; }
if ($q->param('fct') eq "save_field_modified") { &save_field_modified; }
if ($q->param('fct') eq "cat_image_settings") { &cat_image_settings; }

##################################################################################

sub cat_image_settings
{

$hset = qq[

];

$hbox = acs::get_heading_box("$web_url/add.gif", "Category Image Upload Settings", "");

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Content Field Saved</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
<input type="submit" class="psbutton" value="Close Window" name="createdir2"  onClick=window.close()>
</body>
</html>
];

}



sub save_css
{

if ($q->param('global_css') eq "") { acs::problem_popup("You have to specify a Default file to be used globally. The default file is: <b>$web_url/ps.css</b>"); 	}


$id = $q->param('id');
$key1 = $q->param('key');
$key = $key1 . "_cust";

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT $key FROM links WHERE lnkid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$field_contents = $row[0];
	}


($field_contents, $this_css) = split (/o-_-o/, $field_contents);
$this_css = $q->param('this_css');


$field_contents = $field_contents . "o-_-o" . $this_css;

$field_contents = $dbh->quote($field_contents);

$sql = "UPDATE links SET $key = $field_contents WHERE lnkid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

$sth->finish;
$dbh->disconnect;

open (CSF, "> $data_dir/$key.pscs");
	print CSF $q->param('global_css');
close (CSF);


$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_link2.gif", "Changes Saved", qq[<a href="$admin_url/admin80.cgi?id=$id&key=$key1&fct=edit">Click Here to Continue</a>]);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Content Field Saved</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];





}



sub change_css
{

$id = $q->param('id');
$key1 = $q->param('key');
$key = $key1 . "_cust";

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


$sql = "SELECT $key FROM links WHERE lnkid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;

$serror = ""; $serror = $sth->errstr;  if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$field_contents = $row[0];
	}

$sth->finish;
$dbh->disconnect;

$cfield = &get_key_diz($key1);


($field_contents, $this_css) = split (/o-_-o/, $field_contents);

$global_css = acs::get_file_contents("$data_dir/$key.pscs");
if ($global_css eq "") { $global_css = "$web_url/ps.css"; }



$boxdiz = qq[

<form name="form1" method="post" action="$admin_url/admin80.cgi">
  <table width="100%" border="0" cellspacing="1" cellpadding="6">
    <tr>
      <td width="31%" valign="top" class="normaltext">CSS File for this Listing's Content Field called: <b>$cfield</b></td>
      <td width="69%"><label>
        <input name="this_css" type="text" id="this_css" value="$this_css" size="100%">
        <br>
        <span class="normaltext">Assigning a CSS file here will override the Global CSS file setting below. Note that this setting will only be used for the current listing. If you want to globally change the default CSS file used when editing Content Field <strong>$cfield</strong> then assign a CSS file below - it will then be used by default when editing Content Field <strong>$cfield</strong> of any listing. 
        <b>You can leave this field blank if this listing needs to use the default global css file as indicated below.</b>
        </span></label></td>
    </tr>
    <tr>
      <td width="31%" valign="top" class="normaltext">Default CSS file to use globally for Content Field <b>$cfield</b></td>
      <td width="69%"><p>
        <input name="global_css" type="text" id="global_css" value="$global_css" size="100%">
        <br>
        <span class="normaltext">This CSS file will be used by default globally when editing Content Field <strong>$cfield</strong> </span>for any listing. <br>
      </p>
      </td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><label>
        <input name="Save" type="submit" class="psbutton" id="Save" value=" Save ">
        <input name="fct" type="hidden" id="fct" value="save_css">
        <input name="id" type="hidden" id="id" value="$id">
        <input name="key" type="hidden" value="$key1">
</label></td>
    </tr>
  </table>
</form>


];

$hbox = acs::get_heading_box("$web_url/ic_link2.gif", "Change CSS file being used.", $boxdiz);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Content Field Saved</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
<p><a href="" onClick="history.go(-1); return false;"><b>Go Back</b></a></p>
</body>
</html>
];

}





sub save_field_modified
{

$id = $q->param('lnkid');
$key1 = $q->param('key');
$key = $key1 . "_cust";

$txtContent = $q->param('htmlc');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$txtContent = $dbh->quote($txtContent);

$sql = "UPDATE modified SET $key = $txtContent WHERE mdfid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

$sth->finish;
$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/add.gif", "Content Field Updated", qq[You may <a href="javascript:onClick=window.close()">close</a> this window.]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Content Field Saved</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub save_field
{

$id = $q->param('lnkid');
$key1 = $q->param('key');
$key = $key1 . "_cust";

$txtContent = $q->param('htmlc');

$update_cssfile = $q->param('update_cssfile');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$txtContent = $txtContent . "o-_-o" . $update_cssfile;

$txtContent = $dbh->quote($txtContent);

$sql = "UPDATE links SET $key = $txtContent WHERE lnkid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}


$sql = "SELECT * FROM links WHERE lnkid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr;  if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$title = $row[2];
	$diz = $row[3];
	$cid = $row[1];
	$url = $row[5];
	}

$sth->finish;
$dbh->disconnect;





$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);

	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $notext, $imagek, $fieldtype) = split (/\t/, $k_item);
		
		if ($fieldtype eq "Content")
			{
			$more_edit = $more_edit . qq[<a href="$admin_url/admin80.cgi?id=$id&key=$keyname&fct=edit">Edit Content Field: <b>'$description'</b></a>];
			}
		
		if ($keyname eq $key1)
			{
			$field_dname = $description;
			}

		}


$hbox = acs::get_heading_box("$web_url/add.gif", "Content Field '$field_dname' Updated", qq[$more_edit <br><a href="$admin_url/admin56.cgi?itemnrs=1&C0=$id-$cid&dropdown=Edit">Edit Link Listing: $title</a> <br><a href="javascript:onClick=window.close()">Click Here to Close</a> this window.]);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Content Field Saved</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];


}




sub edit_modified
{

$id = $q->param('id');
$key1 = $q->param('key');
$keydiz = $q->param('keydiz');

$key = $key1 . "_cust";

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


$sql = "SELECT $key FROM modified WHERE mdfid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr;  if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$field_contents = $row[0];
	}


($field_contents, $cssfile) = split (/o-_-o/, $field_contents);
if ($cssfile eq "") 
	{
	$defcss = acs::get_file_contents("$data_dir/$key.pscs");
		if ($defcss eq "")
			{
			$cssfile = "$web_url/ps.css"; 
			}
			else
			{
			$cssfile = "$defcss"; 
			}
	}
	else
	{
	$update_cssfile = $cssfile;
	}


$hbox = acs::get_heading_box("$web_url/add.gif", qq[Editing Modified Content Field: '<b>$keydiz</b>'], qq[Please make any changes below.]);

$jspopup_code = acs::get_popupjs;

#print qq[<html>
#<head>
#<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
#<script language="Javascript" src="$web_url/edt/scripts/innovaeditor.js"></script>
#$HTML_ENCODING_USE
#<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
#<script LANGUAGE="JavaScript">
#$jspopup_code 
#function disp_confirm()
#{
#var r=confirm("Changing this setting now will result in any changes made in the Editor being lost. Click the 'Save Content' button below to save changes first if you want to keep any changes made in the Editor. Would you like to continue?");
#if (r==true)
#  {
#  location.href = "$admin_url/admin80.cgi?fct=change_css&id=$id&key=$key1";
#  }
#}
#</script>
#</head>
#<body>
#$hbox
#<form method="post" action="$admin_url/admin80.cgi" id="Form1">
#<input type="hidden" name="fct" value="save_field_modified">
#<input type="hidden" name="key" value="$key1">
#<input type="hidden" name="lnkid" value="$id">
#<input type="hidden" name="update_cssfile" value="$update_cssfile">
#	<textarea id="txtContent" name="htmlc" rows=4 cols=30>
#	$field_contents
#	</textarea>
#<script>
#var oEdit1 = new InnovaEditor("oEdit1");
#oEdit1.width="100%";
#oEdit1.height="500";
#oEdit1.mode="HTMLBody";
#oEdit1.css="$cssfile";
#oEdit1.btnStyles=true;
#oEdit1.REPLACE("txtContent");
#</script>
#<BR>
#<input type="submit" class="psbutton" value="Save Content For: $keydiz"> 
#</form>
#</body>
#</html>
#];









print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<script language="Javascript" src="$web_url/edt/scripts/innovaeditor.js"></script>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="$web_url/edt/tiny_mce/tiny_mce.js"></script>

<script LANGUAGE="JavaScript">
$jspopup_code 
function disp_confirm()
{
var r=confirm("Changing this setting now will result in any changes made in the Editor being lost. Click the 'Save Content' button below to save changes first if you want to keep any changes made in the Editor. Would you like to continue?");
if (r==true)
  {
  location.href = "$admin_url/admin80.cgi?fct=change_css&id=$id&key=$key1";
  }
}

tinyMCE.init({
// General options
mode : "specific_textareas",
editor_selector : "mceEditor",
theme : "advanced",
plugins : "autolink,lists,spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",

// Theme options
theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,spellchecker,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,blockquote,pagebreak,|,insertfile,insertimage",
theme_advanced_toolbar_location : "top",
theme_advanced_toolbar_align : "left",
theme_advanced_statusbar_location : "bottom",
theme_advanced_resizing : true,

// Skin options
skin : "o2k7",
skin_variant : "silver",

// Example content CSS (should be your site CSS)
content_css : "$web_url/ps.css",

template_external_list_url : "js/template_list.js",
external_link_list_url : "js/link_list.js",
external_image_list_url : "js/image_list.js",
media_external_list_url : "js/media_list.js"

});
</script>
</head>
<body>
$hbox
<form method="post" action="$admin_url/admin80.cgi" id="Form1">
<input type="hidden" name="fct" value="save_field_modified">
<input type="hidden" name="key" value="$key1">
<input type="hidden" name="lnkid" value="$id">
<input type="hidden" name="update_cssfile" value="$update_cssfile">

<textarea name="htmlc" id="mceEditor" class="mceEditor" cols="45" rows="30" style="width:100%">$field_contents</textarea>

<BR>
<input type="submit" class="psbutton" value="Save Content For: $keydiz"> 
</form>
</body>
</html>
];


}





sub edit_field
{

$id = $q->param('id');
$key1 = $q->param('key');

$key = $key1 . "_cust";

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


$sql = "SELECT $key FROM links WHERE lnkid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr;  if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$field_contents = $row[0];
	}


($field_contents, $cssfile) = split (/o-_-o/, $field_contents);
if ($cssfile eq "") 
	{
	$defcss = acs::get_file_contents("$data_dir/$key.pscs");
		if ($defcss eq "")
			{
				$cssfile = "$web_url/ps.css"; 
			}
			else
			{
				$cssfile = "$defcss"; 
			}
	}
	else
	{
	$update_cssfile = $cssfile;
	}


$sql = "SELECT * FROM links WHERE lnkid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr;  if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$title = $row[2];
	$diz = $row[3];
	$cid = $row[1];
	$url = $row[5];
	}

$sth->finish;
$dbh->disconnect;




$field_contents =~ s/&/&amp;/g;
$field_contents =~ s/</&lt;/g;
$field_contents =~ s/>/&gt;/g;

$keydiz = &get_key_diz($key1);


$hb1 = qq[
Editing Content Field: '<b>$keydiz</b>' For Listing: <b><a href="" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$id-$cid&dropdown=Edit', screen.width-250, screen.height-250);return false;">
<span title=" $diz " class="popup">$title</span></a></b>
];

$hb2 = qq[
CSS file in use: <b>$cssfile</b> | <a href="$admin_url/admin80.cgi?fct=change_css&id=$id&key=$key1" 
onClick="disp_confirm(); return false;">Change</a>
];

$hbox = acs::get_heading_box("$web_url/add.gif", $hb1, $hb2);


### CHECK IF THERE ARE OTHER CONTENT FIELDS

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);

	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $notext, $imagek, $fieldtype) = split (/\t/, $k_item);
		
		if (($fieldtype eq "Content") and ($keyname ne $key1))
			{
			$more_edit = $more_edit . qq[<li><a href="" onClick="popup('$admin_url/admin80.cgi?id=$id&key=$keyname&fct=edit', screen.width-250, screen.height-250);return false;">Edit Content Field: <b>'$description'</b></a></li>];
			}

		}


$hbox2 = acs::get_heading_box("$web_url/ic_link.gif", "Edit Other Aspects of this Listing", qq[$more_edit <a href="" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$id-$cid&dropdown=Edit', 950, 750, 120, 50);return false;"><span title=" $diz " class="popup">Edit Link Listing - <b>$title</b></span></a>]);

$hbox3 = acs::get_heading_box("$web_url/ic_link2.gif", "Listing Details:", qq[<a href="$url" onClick="window.open('$url','mynewwindow'); return false;">$title</a><BR>$diz<br><b>$url</b>]);

$jspopup_code = acs::get_popupjs;


###################

$cssdetails = fmparse::get_css_used($field_contents);
if ($cssdetails ne "") { $cssfile = $cssfile . "," . $cssdetails; }

##################


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>

$HTML_ENCODING_USE
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">

<script type="text/javascript" src="$web_url/edt/tiny_mce/tiny_mce.js"></script>
<title>Edit Article Field</title>

<script type="text/javascript">
tinyMCE.init({
// General options
mode : "textareas",
theme : "advanced",
plugins : "autolink,lists,spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",

// Theme options
theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,spellchecker,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,blockquote,pagebreak,|,insertfile,insertimage",
theme_advanced_toolbar_location : "top",
theme_advanced_toolbar_align : "left",
theme_advanced_statusbar_location : "bottom",
theme_advanced_resizing : true,

// Skin options
skin : "o2k7",
skin_variant : "silver",

// Example content CSS (should be your site CSS)
content_css : "$cssfile",

// Drop lists for link/image/media/template dialogs
template_external_list_url : "js/template_list.js",
external_link_list_url : "js/link_list.js",
external_image_list_url : "js/image_list.js",
media_external_list_url : "js/media_list.js"

});
</script>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 

<script LANGUAGE="JavaScript">
$jspopup_code 
function disp_confirm()
{
var r=confirm("Changing this setting now will result in any changes made in the Editor being lost. Click the 'Save Content' button below to save changes first if you want to keep any changes made in the Editor. Would you like to continue?");
if (r==true)
  {
  location.href = "$admin_url/admin80.cgi?fct=change_css&id=$id&key=$key1";
  }
}
</script>

</head>
<body>

<form method="post" action="$admin_url/admin80.cgi" id="Form1">
$hbox
<input type="hidden" name="fct" value="save_field">
<input type="hidden" name="key" value="$key1">
<input type="hidden" name="lnkid" value="$id">
<input type="hidden" name="update_cssfile" value="$update_cssfile">

<textarea id="txtContent" name="htmlc" rows="25" style="width:100%">$field_contents</textarea>
	
<BR>
<input type="submit" class="psbutton" value="Save Content For: $keydiz"> 
</form>
<BR>
$hbox2
$hbox3
</body>
</html>
];

}



sub get_key_diz
{
my ($kname) = @_;

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);

	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $notext, $imagek, $fieldtype) = split (/\t/, $k_item);
		
		if ($kname eq $keyname)
			{
			$kdiz = $description;
			}

		}

return ($kdiz);

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

