#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

eval 'use Image::Magick;';
if ($@ ne "") { $IM = "false"; } else { $IM = "true"; }

eval 'use Image::Resize;';
if ($@ ne "") { $IMRES = "false"; } else { $IMRES = "true"; }



&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "res_options")  {&res_options;}
if ($q->param('fct') eq "save_setting") {&save_setting;}
if ($q->param('fct') eq "conf_modules") {&conf_modules;}

##################################################################################


sub conf_modules
{

$mconf = $q->param('mconf');
$field = $q->param('field');
$plug = $q->param('plug');

open (DDT, "> $data_dir/imgresconf.dat");
	print DDT $mconf;
close (DDT);


if ($plug eq "true")
	{
	$cont_link = "$admin_url/p_thumb.cgi";
	}
	else
	{
	$cont_link = "$admin_url/admin81.cgi?fct=res_options&field=$field";
	}


$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Settings Updated", qq[<a href="$cont_link">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

}





sub save_setting
{

$img_fieldname = $q->param('field');

if ($img_fieldname eq "img_standard")
	{
	open (IFF, "> $data_dir/imgres.dat");
		print IFF $q->param('width') . "\n";
		print IFF $q->param('height');
	close (IFF);
	}
	else
	{
	$field_filename = "$data_dir/imgres" . "_" . $img_fieldname . ".dat";
	open (IFF, "> $field_filename");
		print IFF $q->param('width') . "\n";
		print IFF $q->param('height');
	close (IFF);
	}


$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Settings Saved", qq[You may <a href="javascript:onClick=window.close()"><b>close</b></a> this window.]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

}






sub res_options
{


if (($IM eq "false") and ($IMRES eq "false"))
	{
	
	$boxdiz = qq[
	<p><a href="http://www.imagemagick.org" target="_blank">Image Magick</a> or the Perl Module called <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> is not installed on this server. To make use of the image resizing options you need to have <a href="http://www.imagemagick.org" target="_blank">Image Magick</a> 
		or the Perl Module called <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> installed on this server. If you are on a shared host then you can contact your host provider and ask them to  
		install <a href="http://www.imagemagick.org" target="_blank">Image Magick</a> or the Perl Module called <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a>. </p>
		 <p>If this is your own server then you can obtain and install  Image Magick <a href="http://www.imagemagick.org" target="_blank">here</a>. </p>
		 <p>Alternatively it might be easier to  install the  <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> Perl module as the procedure to install   <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> is much easier/quicker than installing <a href="http://www.imagemagick.org" target="_blank">Image Magick</a>. This module can very easily be installed from an SSH shell by doing the following:</p>
		 <blockquote>
		   <p>From an SSH shell issue the following:<br>
	         <strong>perl -MCPAN -e shell</strong></p>
		   <p>Then type:<br> 
		     <strong>install Image::Resize</strong> </p>
	       <p>After doing the above <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> will be installed. </p>
	</blockquote>
     <p>       You may <a href="javascript:onClick=window.close()"><b>close</b></a> this window. </p>
	];
	
	$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Image Magick is not installed", $boxdiz);
	
	print qq[
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<title>PowerSeek</title>
	$HTML_ENCODING_USE
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
	</head>
	<body>
	$hbox
	</body>
	</html>
	];
	exit;
	}


### CONFIGURE WHAT TO USE FOR IMAGE RESIZING
if ((-e "$data_dir/imgresconf.dat") < 1)
	{
		if (($IM eq "true") and ($IMRES eq "false")) ### IMAGE MAGICK
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IM";
			close (DDT);
			}
		elsif (($IM eq "false") and ($IMRES eq "true"))  ### IMAGE RESIZE MODULE
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IMRES";
			close (DDT);	
			}
		else ### IF BOTH MODS INSTALLED USE image::resize
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IMRES";
			close (DDT);	
			}
	}



$img_fieldname = $q->param('field');



### DISPLAY CONF OPTION IF BOTH MODULES ARE INSTALLED

if (($IM eq "true") and ($IMRES eq "true"))
	{

	$im_data = acs::get_file_contents("$data_dir/imgresconf.dat");

	if ($im_data eq "IMRES")
		{
		$chk_imres = "checked";
		}
		else
		{
		$chk_im = "checked";
		}
	

$conf_options = qq[

<form name="form2" method="post" action="$admin_url/admin81.cgi">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DFDFDF">
    <tr>
      <td colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF"><strong class="normaltext">Configure what to use to resize images with: </strong></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF" class="normaltext"><strong>Image Magick <br>
      </strong></td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><label>
      <input name="mconf" type="radio" value="IM" $chk_im>
      </label></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Image::Resize (Perl Module) </strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="mconf" type="radio" value="IMRES" $chk_imres></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <input type="submit" class="psbutton" name="Submit2" value="   Save   ">
        <input name="fct" type="hidden" id="fct" value="conf_modules">
        <input name="field" type="hidden" value="$img_fieldname">
      </label></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </form>
];

	}






if ($img_fieldname eq "img_standard")
	{
	$resdata = acs::get_file_contents("$data_dir/imgres.dat");
	@resoptions = split (/\n/, $resdata);

	$width = $resoptions[0];
	$height = $resoptions[1];
	
	$cur_edit = "Standard Image Field";
	}
	else
	{
	$resdata = acs::get_file_contents("$data_dir/imgres" . "_" . $img_fieldname . ".dat");
	@resoptions = split (/\n/, $resdata);

	$width = $resoptions[0];
	$height = $resoptions[1];
	
	$cur_edit = "File Upload Field: $img_fieldname";
	}

$boxda = qq[
<ul>
<li>If you want to keep the aspect ratio of the image, only provide one value for the width or height. For example: leave the height property blank and provide a value for the width property to resize the image to a specific width but keep the aspect ratio. (The height will automatically be resized to keep the aspect ratio) </li>
<li>Leave the boxes above blank to have no image resizing when an image is uploaded. </li>
<li>Note that this resize setting is globally valid for this field. </li>
<li>Upload fields where files other than image files are uploaded won't be resized as the files will not be valid image files. </li>
</ul>   
];

$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Image Resizing Options for $cur_edit", $boxda);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox

<form name="form1" method="post" action="$admin_url/admin81.cgi">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DFDFDF">
    <tr>
      <td colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF"><strong class="normaltext">Resize Options: </strong></td>
    </tr>
    <tr>
      <td width="49%" bgcolor="#FFFFFF" class="normaltext"><strong>Image Width in Pixels to resize to:<br>
      </strong></td>
      <td width="51%" bgcolor="#FFFFFF" class="normaltext"><label>
        <input name="width" type="text" id="width" value="$width" size="10">
      </label></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Image Height in Pixels to resize to:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="height" type="text" id="height" value="$height" size="10"></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <input type="submit" class="psbutton" name="Submit" value="   Save   ">
        <input name="fct" type="hidden" id="fct" value="save_setting">
        <input name="field" type="hidden" id="field" value="$img_fieldname">
      </label></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

</form>

$conf_options


</body>
</html>
];

}




###################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


