#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

$pages_prev = "3";
$pages_next = "3";


##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; }

####################################################################################




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_users.gif", "User Account Link Browser", "Only browse or search link listings that are linked to user accounts."); 

$jspopup_code = acs::get_popupjs;

$jser = acs::get_js_errors;

$page_top = qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE

$jser

<script LANGUAGE="JavaScript">

$jspopup_code

function checkall(formname,thestate)
	{
	BoxNames=new Array(!!sel_options!!)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

function submitForm(theForm, selv) 
  {
  BoxNames=new Array(!!sel_options!!)
  windowName = "PowerSeek";
  windowURL = theForm.action + '?';
  var c = 0;   var bsel = '';

	for (c=0;c < BoxNames.length; c++)
		{
		chvl = eval("theForm." + BoxNames[c] + ".checked");
		if (chvl)
			{
			boxnm = eval("theForm." + BoxNames[c] + ".value");
			windowURL = windowURL + BoxNames[c] + '=' + boxnm + '&';
			bsel = boxnm;
			}
		}
		
		if (bsel == '') { alert ('You have to select at least one listing.'); return false;}
		
    windowURL = windowURL + 'itemnrs=!!itemnrs!!&';
    
    if (selv == 1)
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown1.value;
    	}
    	else
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown.value;
    	}
    
    if (theForm.dropdown1.value == 'Delete')
    	{
    	var shih = 150;
    	var swid = 600;
    	var winl = 200;
    	var wint = 200;
    	}
    	else
    	{
    	var swid = 900;
		var shih = 600;    	
	   //var winl = (screen.width-swid)/2;
		//var wint = (screen.height-shih)/2;
    	var winl = 105;
    	var wint = 105;
    	}

    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + swid + ',height=' + shih + ',top=' + winl + ',left=' + wint;
    var popupwin = null;
    
    var random = parseInt(Math.random()*10000)
    
    myWindow = window.open(windowURL, 'popupwin' + random, myspecs);
    myWindow.focus();
  } 
</script>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
];


### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
	push(@fields_to_search, "$keyname" . "_cust"); 
	
	if (($searched eq "Yes") and ($imgk ne "Yes") and ($nmbr ne "Y"))
		{
		$full_texti = $full_texti . ",A." . $keyname . "_cust";
		}
	
	}


$keywords = $q->param('keywords');

if ($keywords eq "")
	{

	$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, C.rgsuser, A.*
		 FROM links AS A,
	       	dirs AS B,
	       	lnkusers AS C
	       	WHERE 
	       	(A.cid = B.cid) AND (A.userid = C.userid)
	       	ORDER BY A.userid
	       	";
	 }
	 else
	 {
	 
	$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, C.rgsuser, A.*,
			  MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords') AS SCORE 
		FROM links AS A,
	       	dirs AS B,
	       	lnkusers AS C
	       	WHERE (MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords'))
	       	AND (A.cid = B.cid) AND (A.userid = C.userid)
	       	ORDER BY A.userid
	       	";	 
	 
	 }
	 
	
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();

### PREPARE PAGES

$gsettings = new_gsettings acs; 

$icnt = $rows;
$nr_searchres = $gsettings->{cp_search_listings};
#$nr_searchres = 10;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

$main_nd = $nd;
$main_st = $st;



############

$page_middle = qq[

<form name="form1" method="post" action="admin87.cgi">
  <table width="100%" border="0" cellpadding="0" cellspacing="0">
    <tr class="normaltext">
      <td width="50%" height="30"><b>Search User Links:</b>
        <input name="keywords" type="text" id="keywords" size="40" value="$keywords"> <input type="submit" name="Search" id="Search" value="Search" class="psbutton"></td>
      <td width="50%" align="right">!!pagecrit1!!</td>
    </tr>
    <tr class="normaltext">
      <td height="30" colspan="2"><span class="bordtext">Links Found:<strong> $rows</strong></span> !!pagecrit2!!</td>
    </tr>
  </table>
</form>

$catstring 

<span class="normaltext">
];


$nowtime = time();

$form_c_counter = 0;
$c_counter = 0;
$printcrit = "";
$highnr = 0; $bcnt = 0;


#############################################

while ( @row = $sth->fetchrow() )
	{

	if ($highnr == 0){ $high_number = $row[44 + $knr]; }
	$highnr++;
	
	if (($ippc > $st) and ($ippc <= $nd))
    {
    
		push (@link_arr, $row[17]);
    
		$cats = "";
		for ($ms = 0; $ms < 16; $ms++) 
			{
			if ($row[$ms] ne "")
				{
				$cats = $cats . $row[$ms] . "/";
				}
			}
			
				$cbname = "C" . $c_counter;
				$cb_val = $row[17] . "-" . $row[18];
				$cbox = "<input type=\"checkbox\" name=\"$cbname\" value=\"$cb_val\">";
				$c_counter++;
			
			
			if (($row[38] == 0) and ($row[30] > 0))
			{ $row[38] = 99999999999999; }

			$premimg = ""; $expires = "";
			if (($row[30] > 0) and ($row[38] > $nowtime))### IF PREMIUM LINK
				{
				$premimg = qq[<BR><img src="$web_url/premi2.gif">];
				
					if (($row[38] != 0) and  ($row[38] != 99999999999999))
						{
						$expdate = acs::decode_date($row[38]);
						$expires = qq[<BR><font color="#FF0000"><b>Expires: $expdate</b></font>];
						}
						else
						{
						$expires = qq[<BR><font color="#FF0000"><b>Never Expires</b></font>];
						}
				}

			$printcrit = $printcrit . qq[<BR><table border="0" cellpadding="6" cellspacing="0" width="100%" class="aborder"><tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><td width="1%" valign="top">$cbox $premimg</td><td width="99%" class="normaltext">
			<b>$ippc. <a href="$row[22]" target="_blank">$row[19]</a></b><BR>
			<b><font color="green">User: $row[16]</font></b></b><br>
			$row[20]<BR>
			<b>$row[22]</b><BR>];
			

			#### EXTRA KEYS/FIELDS
			$field_key_count = 44;
			foreach $kitem (@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);

		   if (($visible eq "No") and ($nmbr eq "Content"))
		   	{

		   	$blankv = "";
		   	if (length($row[$field_key_count]) < 10) { $blankv = "- <b>Empty</b>"; }
		   	$printcrit = $printcrit . qq[<a href="" onClick="popup('$admin_url/admin80.cgi?id=$row[17]&key=$keyname&fct=edit',screen.width-200,screen.height-200);return false;"><font color="#800080"><b>$description</b></font></a> <i>(Content Field $blankv)</i><BR>];
			
				}
				elsif (($visible eq "Yes") and ($nmbr eq "Upload"))
					{
					if ($row[$field_key_count] ne "") 
						{
						$ifname = "$web_url/imagefiles/$row[17]/$keyname" . "." . $row[$field_key_count];
						$printcrit = $printcrit . qq[<font color="#804040"><b>$description:</b></font> <a href="$ifname" target="_blank">$ifname</a><BR>];
						}
						else
						{
						$printcrit = $printcrit . qq[<font color="#804040"><b>$description:</b> N/A</font><BR>];
						}
					}
				elsif (($visible eq "Yes") and ($imgk ne "Yes"))
					{
						$printcrit = $printcrit .  "<b><font color=\"#8080C0\">$description:</font></b> $row[$field_key_count]<br>";
					}
				elsif (($imgk eq "Yes") and ($visible eq "Yes"))
					{
						if ($row[$field_key_count] ne "")
						{
						$printcrit = $printcrit .  "<img src=\"$row[$field_key_count]\"><br>";
						}
					}
					
				$field_key_count++;
				}
				

			##### GET CATEGORY

			$ecat = "";
			@acts = split (/\//, $cats);
			foreach $citem (@acts)
				{
				$ecat = $ecat . acs::encode_dir($citem) . "-";
				}
			chop($ecat);

			$printcrit = $printcrit . "<b>ID: $row[17]</b>$expires<BR>";

			$printcrit = $printcrit .  "<img src=\"$web_url/dir.gif\"> <a href=\"$admin_url/admin12.cgi?ct=$ecat&cid=$row[18]&C0=$row[17]&fct=gotocat\"
			 target=\"_blank\"><b>From: $cats</b></a><BR>";

			#$printcrit = $printcrit . "<img src=\"$web_url/dir.gif\"> <a href=\"$admin_url/admin84.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]\"
			#onClick=\"opener.parent.frames('mainFrame').location='$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]'; self.opener.focus(); return false;\"><b>From: $cats</b></a><BR>";
						

			$user_account_jump = "";
			if ($row[33] > 0) ### IF USER ACCOUNT EXISTS FOR LINK
				{
					$user_account_jump = qq[<b><a href="$admin_url/admin55.cgi?fct=editacc&userid=$row[33]" 
					onClick="popup('$admin_url/admin55.cgi?fct=editacc&userid=$row[33]',750,600, 150, 100);return false;" class="bordtext">Edit User Account</a>
					<a href="$admin_url/admin55.cgi?fct=delacc&userid=$row[33]" 
					onClick="popup('$admin_url/admin55.cgi?fct=delacc&userid=$row[33]',750,200, 150, 100);return false;" class="bordtext">Delete User Account</a>
					
					</b>];
				}


$printcrit = $printcrit . qq[<b>
<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]',900,600, 115, 100);return false;" class="bordtext">Edit</a> 
<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]',750,600, 115, 100);return false;" class="bordtext">Move</a> 
<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]',750,600, 115, 100);return false;" class="bordtext">Copy</a></b>
];

$substv = "!!reviews_" . $row[17] . "!!";
		
			$scroe = $row[44 + $knr];
			$printcrit = $printcrit .  "<b><a href=\"$admin_url/admin12.cgi?ct=$ecat&fct=Delete&cid=$row[18]&C0=$row[17]&del_only_one=true\" onClick=\"popup('$admin_url/admin12.cgi?ct=$ecat&fct=Delete&cid=$row[18]&C0=$row[17]&del_only_one=true',600,150, 240, 250);return false;\" class=\"bordtext\">Delete</a> $user_account_jump  $substv</b><Br>";
			$printcrit = $printcrit .  $relg . "<BR></td></tr></table>";


		 $form_c_counter++;
		}
	$ippc++;
	}


### Get Reviews/Comments

foreach $ritem (@link_arr)
	{
	$rsql = $rsql . " (lnkid = '$ritem') OR";
	}
	

if ($rsql ne "")
	{
	$rsql = substr($rsql, 0, length($rsql) - 2);
	
	$sth = $dbh->prepare("SELECT lnkid FROM reviews WHERE $rsql GROUP BY lnkid");
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
		
		while ( @row = $sth->fetchrow() )
			{
			$reviewdisp = qq[ <a href="admin15.cgi?lnkid=$row[0]" onClick="popup('admin15.cgi?lnkid=$row[0]',750,600, 115, 100);return false;" class="bordtext">Reviews</a> ];
			$tosubst = "!!reviews_" . $row[0] . "!!";
			$printcrit =~ s/$tosubst/$reviewdisp/g;
			}

	}

foreach $ritem (@link_arr)
	{
	$revd = "!!reviews_" . $ritem . "!!";
	$printcrit =~ s/$revd//g;
	}
	



$sth->finish;
$dbh->disconnect;

if (($rows < 1) and ($q->param('fct') ne "blinks"))
	{
	$printcrit = $printcrit .  qq[
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DBDBDB"
height="46">
  <tr>
    <td width="100%" bgcolor="#FFFFFF" height="30" align="center"><p align="center"><strong>No
    matches found. </strong>Try using more or different keywords. Note that if you have <br>
    only a handfull of links then the search won't function correctly. You need more or less
    50 links. </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>


	];
	}



#### PAGES 
$fct= $q->param('fct');


for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}

if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

if ($main_nd eq "") {$main_nd = $nr_searchres;}

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($main_nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " <span class=\"bordtext\"><b>[$pg]</b></span> ";
		$targpage = $pg;
		}
	  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . " <a href=\"$admin_url/admin87.cgi?st=$st1&nd=$nd1&keywords=$keywords\" class=\"bordtext\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = " <span class=\"bordtext\"><b>Pages:</b></span> " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}


		####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;
				
				$pgstring = "<a href=\"$admin_url/admin87.cgi?st=$pvst&nd=$pvnd&keywords=$keywords\" class=\"bordtext\"><<</a> " . $pgstring;
				}

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = $pgstring . "<a href=\"$admin_url/admin87.cgi?st=$pvst&nd=$pvnd&keywords=$keywords\" class=\"bordtext\">>></a> ";
				}


$page_crit = $page_crit .  $pgstring;


### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = " <a href=\"$admin_url/admin87.cgi?st=$st1&nd=$nd1&keywords=$keywords\" class=\"bordtext\"><b>Next Page</b> >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = " <a href=\"$admin_url/admin87.cgi?st=$st1&nd=$nd1&keywords=$keywords\" class=\"bordtext\"><b><< Prev Page</b></a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev .  $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

if ($rows > 0)
	{
	$page_crit2 = $page_crit2 .  "$prevnext <span class=\"bordtext\">Page $targpage of $pg</span>";
	}

$printcrit = $printcrit .  "</span>";





if ($rows > 0)
		{

if ($nr_searchres == 10) { $v10 = "selected"; }
if ($nr_searchres == 20) { $v20 = "selected"; }
if ($nr_searchres == 30) { $v30 = "selected"; }
if ($nr_searchres == 40) { $v40 = "selected"; }
if ($nr_searchres == 50) { $v50 = "selected"; }
if ($nr_searchres == 75) { $v75 = "selected"; }
if ($nr_searchres == 100) {$v100 = "selected"; }
if ($nr_searchres == 200) {$v200 = "selected"; }
if ($nr_searchres == 500) { $v500 = "selected"; }
if ($nr_searchres == 1000) { $v1000 = "selected"; }

$print_crit_form = qq[
<form name="select_all" method="POST" action="$admin_url/admin56.cgi" style="margin-bottom: 0; margin-top: 0; ">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="25%" height="30" class="normaltext"> <select name="dropdown1" size="1">
      <option value="Edit">Edit Checked Items</option>
      <option value="Move">Move Checked Items</option>
      <option value="Copy">Copy Checked Items</option>
      <option value="Delete">Delete Checked Items</option>
    </select> <input type="submit" class="psbutton" value="  Go  " name="B1"
    onClick="submitForm(document.select_all,1); return false;"></td>
    <td width="41%" class="normaltext"><a
    href="javascript:checkall('select_all',true)"  class="bordtext"><b>Check All</b></a> <a
    href="javascript:checkall('select_all',false)"  class="bordtext"><b>UnCheck All</b></a></td>
    <td width="34%" class="normaltext" align="right"><input type="hidden" name="itemnrs" value="$c_counter">
      <select name="listperpage1" size="1">
      <option $v10 value="10">List 10 Links Per Page</option>
      <option $v20 value="20">List 20 Links Per Page</option>
      <option $v30 value="30">List 30 Links Per Page</option>
      <option $v40 value="40">List 40 Links Per Page</option>
      <option $v50 value="50">List 50 Links Per Page</option>
      <option $v75 value="75">List 75 Links Per Page</option>
      <option $v100 value="100">List 100 Links Per Page</option>
      <option $v200 value="200">List 200 Links Per Page</option>
      <option $v500 value="500">List 500 Links Per Page</option>
      <option $v1000 value="1000">List 1000 Links Per Page</option>
    </select> <input type="submit" class="psbutton" value="   Go   " name="ppga"
    onClick="popup('$admin_url/admin11.cgi?fct=setpage&v=' + listperpage1.value,600,110, 100, 100);return false;"></td>
  </tr>
</table>

];
	
	
	
$printcrit = $print_crit_form . $printcrit . qq[
<BR>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="26%" height="30" class="normaltext"> <select name="dropdown" size="1">
      <option value="Edit">Edit Checked Items</option>
      <option value="Move">Move Checked Items</option>
      <option value="Copy">Copy Checked Items</option>
      <option value="Delete">Delete Checked Items</option>
    </select> <input type="submit" class="psbutton" value="  Go  " name="B1"
    onClick="submitForm(document.select_all,0); return false;"></td>
    <td width="74%" class="normaltext"><a
    href="javascript:checkall('select_all',true)" class="bordtext"><b>Check All</b></a> <a
    href="javascript:checkall('select_all',false)" class="bordtext"><b>UnCheck All</b></a></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td height="30" class="normaltext">$page_crit2</td>
  </tr>
  <tr>
    <td height="30" class="normaltext">$page_crit</td>
  </tr>
</table>
<BR>
];
		}



$printcrit = $printcrit . "</body></html>";


### FILL JAVASCRIPT VARS

for ($ms = 0; $ms < $form_c_counter; $ms++) 
	{
	$sel_options = $sel_options . "'C" . $ms . "',";
	}
	$sel_options = substr($sel_options, 0, length($sel_optionss) - 1);

$page_top =~ s/!!sel_options!!/$sel_options/gi;
$page_top =~ s/!!itemnrs!!/$form_c_counter/gi;

$page_middle =~ s/!!pagecrit1!!/$page_crit/gi;
$page_middle =~ s/!!pagecrit2!!/$page_crit2/gi;

print $page_top . $page_middle . $printcrit;
}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

