#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}



##################################################################################

sub start
{

$lat = $q->param('lat');
$lon = $q->param('lon');

$latval = $q->param('latval');
$lonval = $q->param('lonval');

if ($latval == 0) { $latval = ""; }
if ($lonval == 0) { $lonval = ""; }


if (($latval ne "") and ($lonval ne ""))
	{
	$mapoptions = qq[
		var myOptions = {
		      zoom: 12,
		      center: latlng,
			  	scaleControl: true,
			 	zoomControl: true,
			  	overviewMapControl: true,
			  	overviewMapControlOptions: { opened: true },
		      mapTypeId: google.maps.MapTypeId.ROADMAP
	    }

			 var marker = new google.maps.Marker
				({
					map: map, 
					position: latlng,
					title : 'Current Coordinates'
				  });


		document.getElementById('lat').value = '$latval';
		document.getElementById('lon').value = '$lonval';
			
		];
		
		$latlon = "$latval" . "," . " $lonval";
		
		$setmapmarker = "marker.setMap(map);";
		
		
	}
	else
	{
	
	$mapoptions = qq[
		var myOptions = {
		      zoom: 2,
		      center: latlng,
			  	scaleControl: true,
			 	zoomControl: true,
			  	overviewMapControl: true,
			  	overviewMapControlOptions: { opened: true },
		      mapTypeId: google.maps.MapTypeId.ROADMAP
	    }
		];

	$latlon = "17.607789, 8.081666000000041";
	
	}



print qq[

<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="initial-scale=1.0, user-scalable=no"/>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<title>Search for Coordinates</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 

<script type="text/javascript" src="//maps.googleapis.com/maps/api/js?sensor=false"></script>
<script type="text/javascript">
  
  var geocoder;
  var map;
  var currentcoord;
  
  function initialize() {
    geocoder = new google.maps.Geocoder();
    latlng = new google.maps.LatLng($latlon);
    
    $mapoptions
    
    map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
    
    $setmapmarker
    
  }


  function codeAddress() 
  {
    var address = document.getElementById("address").value;
	
    geocoder.geocode( { 'address': address}, 
				function(results, status) 
				{
			      if (status == google.maps.GeocoderStatus.OK) 
				  	{
			        map.setCenter(results[0].geometry.location);
					
			        var marker = new google.maps.Marker
						({
			            map: map, 
            			position: results[0].geometry.location
				        });
				        
						
 					   currentcoord = results[0].geometry.location;
					   document.getElementById('hidv').value = currentcoord;
					   var vstring = document.getElementById('hidv').value;
					   vstring = vstring.replace(/\\(/gi, ''); 
					   vstring = vstring.replace(/\\)/gi, ''); 										 
	 				   vstring = vstring.replace(/ /gi, ''); 										 					  
					   var mySplitResult = vstring.split(",");
					   document.getElementById('lat').value = mySplitResult[0];
					   document.getElementById('lon').value = mySplitResult[1];
					   
					   map.setZoom(12);

			      } 
				  else 
				  {
			       alert("Geocode was not successful for the following reason: " + status);
			      }
				  
		    });
  }


function usecoord ()
	{
	opener.document.getElementById('$lat').value = document.getElementById('lat').value;
	opener.document.getElementById('$lon').value = document.getElementById('lon').value;
	opener.document.focus;
	}



</script>

<style>

html, body {
  height: 100%;
  margin: 0;
  padding: 0;
}

#map_canvas {
  height: 100%;
}

@media print {
  html, body {
    height: auto;
  }

  #map_canvas {
    height: 600px;
  }
}

</style>


</head>
<body onload="initialize()">

<br>
<form style="margin-bottom:0; margin-top:0;" >
<table width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td><table width="100%" cellpadding="5" cellspacing="1">
      <tr>
        <td width="20%" class="normaltext12"><strong>Specify Address:</strong></td>
        <td colspan="2"><input id="address" type="textbox" value="For example: 1600 Pennsylvania Avenue, NW Washington, DC 20500" size="80" onfocus="document.getElementById('address').value=''"/></td>
        <td width="39%"><input type="button" value="Get Coordinates" onclick="codeAddress()" /></td>
        </tr>
      <tr>
        <td class="normaltext12"><strong>Latitude:</strong></td>
        <td width="11%"><span class="normaltext12">
          <input type="text" name="lat" id="lat" size="25"/>
        </span></td>
        <td width="30%" align="right"><strong class="normaltext12">Longitude:
          <input type="text" name="lon" id="lon" size="25"/>
        </strong></td>
        <td><span class="normaltext12">
          <input type="button" value="Use Coordinates" onclick="usecoord(); self.close (); return false;" />
        </span></td>
        </tr>
    </table></td>
  </tr>
</table>
</form>
<br>

<div id="map_canvas" style="height:83%;top:0px; border-top: 5px solid #CCC; border-bottom: 5px solid #CCC;"></div>

<input type="text" name="hidv" id="hidv" size="50" style="display:none"/>

</body>
</html>

];

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

