#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Thumbnail Batch Resizer & Importer
# DIZ: Enables you to resize batches of images to thumbnails and import them into the database
# GRAPHIC: ic_banner2.gif
# VERSION: 0.5 Beta
# 
###########################################

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

## REQUIRES MySQL Version 3.23.23+  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use fmresize;
use File::Copy;
use URI::Escape;


&get_setup;
$q = CGI->new;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$imports_per_screen = 10;
$web_wait = 0;

eval 'use Image::Magick;';
if ($@ ne "") { $IM = "false"; } else { $IM = "true"; } 

eval 'use Image::Resize;';
if ($@ ne "") { $IMRES = "false"; } else { $IMRES = "true"; }




##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "do_import1") {&do_import1;}
if ($q->param('fct') eq "do_import2") {&do_import2;}
if ($q->param('fct') eq "dirbrowse") {&dirbrowse;}

##################################################################################

sub dirbrowse
{

if ($q->param('loc') eq "") 
	{
	$loc = "$web_dir/edt/tmpimg"; 
	}
else 
	{ 
	$loc = $q->param('loc'); 
	}

####

my @locitems = split (/\//, $loc);
$itemnr = @locitems; 

for ($ms = 0; $ms < ($itemnr - 1); $ms++)
	{
	$down_loc = $down_loc . $locitems[$ms] . "/";
	}


if (substr($loc, length($loc) - 1, 1) eq "/")
				{
				$locdis = $loc . "*.*";
				
				}
				else
				{
				$locdis = $loc . "/*.*";
				}


$list_dirs = qq[
<b><a href="$admin_url/p_thumb.cgi?fct=dirbrowse&loc=$down_loc">.. << Down one level</a></b><BR>
&nbsp; <img src="$web_url/subdir.gif"> <b>$locdis</b><BR>

];

$dirfound = "false";

opendir(DIR,$loc);
@files = readdir(DIR);
@files = sort(@files);

$cnt = 0;
foreach $filename (@files)
	{
	if (((-d "$loc/$filename") > 0) and ($filename ne ".") and ($filename ne ".."))
		{
			if (substr($loc, length($loc) - 1, 1) eq "/")
				{
				$nowloc = $loc . $filename;
				}
				else
				{
				$nowloc = $loc . "/" . $filename;
				}
			
			
			$list_dirs = $list_dirs . qq[&nbsp; &nbsp; &nbsp; 
			<input name="selv" type="radio" value="$nowloc"> <img src="$web_url/subdir.gif"> <a href="$admin_url/p_thumb.cgi?fct=dirbrowse&loc=$nowloc">$filename</a><BR>
			];
			
			$dirfound = "true";
			
		}
		elsif (($filename ne ".") and ($filename ne ".."))
		{
			$all_files = $all_files . "&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; " . $filename . "<BR>";
		}
	}



$hbox = acs::get_heading_box("$web_url/add.gif", "Select Directory.", qq[Browse and select a directory where images are that needs to be resized and imported into the database.]);


if ($all_files ne "") { $files_inside = "<b>Files inside: $locdis</b><BR><BR>"; }

if ($dirfound eq "false") { $select_directory = "&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; There are no sub directories inside this directory. Please click 'Down one level'"; }
elsif ($dirfound eq "true") { $select_directory = qq[&nbsp; &nbsp; &nbsp; <input type="submit" class="psbutton" name="Submit" value="Select Directory" onclick="post_value(); return false;">]; }


#opener.document.addu.files_loc.value = document.asform.lastid.value;
#for (i=asform.selv.length-1; i > -1; i--)

print qq[
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<title>PowerSeek</title>
	$HTML_ENCODING_USE
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

	<script LANGUAGE="JavaScript">
	<!-- Hide
	
		function post_value()
		{
		
			if (asform.selv.length == undefined)
			{
			opener.document.addu.files_loc.value = document.asform.selv.value;
			}
			else
			{
			
			var foundopt = 'false';
			
				for (i=asform.selv.length-1; i > -1; i--)
					{
					if (asform.selv[i].checked) 
						{
						myOption = i;
						foundopt = 'true';
						}
					}
				
				if (foundopt == 'true')
					{
					opener.document.addu.files_loc.value = document.asform.selv[myOption].value;
					}
					else
					{
					alert ("Please select something.2");
					return false;
					}

			}


		window.close();
		}


	 // End Hide -->
	</script>
	
	</head>
	<body>
	$hbox

<form method="post" action="$admin_url/p_thumb.cgi" name="asform">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
    <tr>
      <td valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext">Current Location:<strong> $loc</strong></td>
    </tr>
	 <tr>
		<td valign="top" bgcolor="#FFFFFF" class="normaltext">$list_dirs<BR>
		$select_directory
		<BR><BR>
		$files_inside
		$all_files
		</td>
	</tr>

  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>
	
	</body>
	</html>
];



}





sub do_import2
{

$files_loc = $q->param('files_loc');
$width = $q->param('width');
$height = $q->param('height'); 
$crosslinkid = $q->param('crosslinkid');
$up_field1 = $q->param('up_field1');
$up_field2 = $q->param('up_field2');
$remove = $q->param('remove');
$disp_cat = $q->param('disp_cat');
$dirs_to_add = $q->param('dirs_to_add'); $impdirs = $q->param('impdirs');
$incl_subdirs = $q->param('incl_subdirs');

$current_count = $q->param('current_count');
if ($current_count eq "") { $current_count = 0; }

$randnr = rand(1000);
$randnr = int($randnr);




if ($dirs_to_add ne "") ### IF IMPORTING WITH DIRECTORIES IN TEMP DIR THEN CREATE THOSE DIRECTORIES
	{

		if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		$dbh = DBI->connect($dsn, $db_username, $db_password);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

		### GET ORIGINAL PS CATEGORY
		
		$sql = "SELECT * FROM dirs WHERE cid = '$crosslinkid'";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}
		
		$lv = 0;
		
		while ( @row = $sth->fetchrow() ) 
			{

					for ($ms = 2; $ms < 18; $ms++) 
						{
						if ($row[$ms] ne "")
							{
							$to_add_cat = $to_add_cat . $row[$ms] . ":::";
							$to_add_cat2[$lv] = $dbh->quote($row[$ms]);
							$lv++;
							}
						}
				
			}
		
		$to_add_cat = substr($to_add_cat, 0, length($to_add_cat) - 3);


		### CREATE NEW PS CATEGORIES
		
		$newlevel = $lv + 1;
		
			for ($ms = 0; $ms < $lv; $ms++) 
				{
				$lvnames = $lvnames . "l" . ($ms + 1) . " = $to_add_cat2[$ms], ";
				$lv_dupcheck = $lv_dupcheck . " (l" . ($ms + 1) . " = $to_add_cat2[$ms]) AND ";
				}
		

			my @alldad = split (/:::/, $dirs_to_add);
		
			$inscnt = 0;
			foreach $item (@alldad)
				{
				$orig_item = $item; #$orig_item =~ s/ /+/g;
				$item = $dbh->quote($item);
					
					### CHECK IF CATEGORY DOESN'NT ALREADY EXIST SO THAT WE DON'T ADD DUPLICATES
					$sql_check_exist = "SELECT shortname, cid FROM dirs WHERE (level = '$newlevel') AND $lv_dupcheck " . "(l" . "$newlevel = $item)";
					$sth = $dbh->prepare($sql_check_exist);
					$sth->execute;
					$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}
					$rows = $sth->rows();
					while ( @row = $sth->fetchrow() ) { $last_cid = $row[1]; }

					
					if ($rows < 1) ### INSERT NEW CATEGORY AS IT WON'T CREATE A DUPLICATE
						{

							$blank_levels = "";
							for ($ms = ($newlevel + 1); $ms < 17; $ms++) 
								{
								$blank_levels = $blank_levels . " l" . $ms . " = '', ";
								}
				
							$insert_statement = "INSERT INTO dirs SET level = '$newlevel', $lvnames " . "l" . $newlevel . " = " . $item . ", $blank_levels shortname = $item";
							$sth = $dbh->prepare($insert_statement);
							$sth->execute;
							$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}
							
							$sth = $dbh->prepare("SELECT cid FROM dirs WHERE cid = LAST_INSERT_ID()");
							$sth->execute;
							$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}	
							while ( @row = $sth->fetchrow() ) { $last_cid = $row[0]; }
							
							$inscnt++;
						}
					
					$impdirs = $impdirs . $orig_item . "-o-" . $last_cid . ":::";
				}
		

		$sth->finish;
		$dbh->disconnect;


	#print "SQL LEVELS: $lvnames<BR><BR>";
	#print "$to_add_cat<BR>LV: $lv - RAND: $randnr :: COUNTER: $inscnt<BR><BR>"; 
	#print "IMP DIRS: $impdirs <BR>";
	
	} ### END OF CREATE CATEGORIES


#print "-IMP-> $impdirs <BR><BR>";


#### GET TOTAL NUMBER OF FILES
$ccn = 0;

	opendir(DIR,"$files_loc");
	@files = readdir(DIR);

		foreach $filename (@files)
			{

				if (($filename ne ".") and ($filename ne "..") and ((-d "$files_loc/$filename") > 0) and ($incl_subdirs eq "Y"))
					{
						opendir(DIR2, "$files_loc/$filename");
							my @subfiles = readdir(DIR2);
						closedir(DIR2);
						
						foreach $ndi (@subfiles)
							{
							if (($ndi ne ".") and ($ndi ne "..") and ($ndi =~ /\./))
								{
								$topv = "$files_loc/$filename" . "::" . "$ndi" . "::" . "$filename"; ### PATH/FILENAME/SUBCAT
								push (@files_to_resize, $topv);
								$ccn++;
								}
							}

					}
					elsif (($filename ne ".") and ($filename ne "..") and ((-d "$files_loc/$filename") < 1)) ### IF FILE
					{
					$topv = "$files_loc" . "::" . "$filename" . "::" . "none"; ### PATH/FILENAME/SUBCAT
					push (@files_to_resize, $topv);
					$ccn++;
					}
			
			}

	closedir(DIR);




#foreach $ttisa (@files_to_resize)
#	{
#	($filep, $fname, $extdir) = split (/::/, $ttisa);
#	print "--> $filep == $fname == $extdir<BR>";
#	}




if ($current_count == $ccn) ### IF FINISHED IMPORTING
	{

	$invalid_images = acs::get_file_contents("$web_dir/edt/tmp/validimg.tmp");

		if ($invalid_images ne "")
			{
			$invalid_images =~ s/\n/<BR>/gi;
			$invaldiz = qq[<b><BR><BR>The following images could not be imported and resized as they where invalid image files:</b><BR><BR>$invalid_images];
			}

		
		acs::update_cat_numbers($crosslinkid, $ccn); ### UPDATE CAT NUMBERS


		$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Images resized and imported.", qq[		<a href="$admin_url/p_thumb.cgi">Click Here to Continue</a>$invaldiz]);
		
		print qq[
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>PowerSeek</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
		</head>
		<body>
		$hbox
		</body>
		</html>
		];
	
	exit;
	}







#### READ FILES & RESIZE FILES

$cnt = 0;
foreach $file_item (@files_to_resize)
	{
	
		if ($current_count == $cnt)
				{
				($filepath, $filename, $extdir) = split (/::/, $file_item);
				
				$current_count++;
					
					$perc = ($current_count / $ccn) * 100;
					$perc = sprintf("%5.2f",$perc);
					$perc2 = 100 - $perc;
					
					
					$impcat = $disp_cat . " / " . $extdir;
						
						$boxdiz = qq[
						<table width="100%" border="0" cellspacing="0" cellpadding="3">
						  <tr>
							 <td width="1%" align="center"><p><img src="$web_url/working3.gif"></p></td>
							 <td width="99%"><p>Resizing and Importing: <b>$filename</b></p></td>
						  </tr>
						  <tr>
							 <td class="normaltext"><b>$perc%</b></td>
							 <td><table width="100%" border="0" cellpadding="1" cellspacing="1" bgcolor="#DFDFDF">
									  <tr>
										 <td width="$perc%" height="20" background="$web_url/bar.gif" bgcolor="#FFFFFF">&nbsp;</td>
										 <td width="$perc2%" bgcolor="#FFFFF0">&nbsp;</td>
									  </tr>
									</table></td>
						</tr>
						  <tr>
							 <td class="normaltext">&nbsp;</td>
							 <td class="normaltext">Resizing and Importing From: <strong>$filepath</strong><BR>Resizing and Importing Into Category: <strong>$impcat</strong></td>
							</tr>
						</table>	
						];
						
					$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Resizing Images and Importing", $boxdiz);
					
					
					### IF FILE HAS A FILE EXTENSION
					if ($filename =~ /\./) 
							{
							### CHECK IF VALID IMAGE
							$valid_image = fmresize::check_valid_image("$filepath/$filename");
							
							
							#print "--> $valid_image - $files_loc/$filename<BR> ";
							
							if ($valid_image eq "true")
							{

							($title_fname, $tmp) = split (/\./, $filename); 
							
									### INSERT NEW RECORD IN DB
									
									if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
									$dbh = DBI->connect($dsn, $db_username, $db_password);
									if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
									
									$title_fname = $dbh->quote($title_fname);
	
											#### GET CID IF ANOTHER DIR
											if ($extdir ne "none")
												{
												my @dirdets = split (/:::/, $impdirs);
												
												foreach $curidir (@dirdets)
													{
														($rdname, $rdcid) = split (/-o-/, $curidir);
														
														if ($extdir eq $rdname) { $crosslinkid = $rdcid; }
													}
												}

									$sql = "INSERT INTO links SET title = $title_fname, cid = '$crosslinkid'";
									$sth = $dbh->prepare($sql);
									$sth->execute;
									$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}

									$sth = $dbh->prepare("SELECT lnkid FROM links WHERE lnkid = LAST_INSERT_ID()");
									$sth->execute;
									$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}	
									while ( @row = $sth->fetchrow() ) { $last_lnkid = $row[0]; }

									$sth->finish;
									$dbh->disconnect;


									#### RESIZE IMAGES TO THUMBNAILS
									my @fileitems = split (/\./, $filename);
									my $itemnr = @fileitems; $itemnr = $itemnr - 1;
									my $cur_file_extension = $fileitems[$itemnr];
									
									if ($up_field1 eq "default") ### IF STANDARD IMAGE FILE
										{
										$to_resize_filename_path = "$web_dir/imagefiles/$last_lnkid" . "." . $cur_file_extension;
										$update_sql = "UPDATE links SET image = '$cur_file_extension' WHERE lnkid = '$last_lnkid'";
										$sth = $dbh->prepare($update_sql);
										$sth->execute;
										$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
										$status = fmresize::resize_file("$filepath/$filename" , $to_resize_filename_path, $width, $height);
										}
										else
										{
										$cust_field = $up_field1 . "_cust";
										&mkdirps("$web_dir/imagefiles/$last_lnkid");
										$to_resize_filename_path = "$web_dir/imagefiles/$last_lnkid/$up_field1" . "." . $cur_file_extension;
										$update_sql = "UPDATE links SET $cust_field = '$cur_file_extension' WHERE lnkid = '$last_lnkid'";
										$sth = $dbh->prepare($update_sql);
										$sth->execute;
										$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
										$status = fmresize::resize_file("$filepath/$filename" , $to_resize_filename_path, $width, $height);
										}
								
									#### IMPORT LARGE IMAGE FILES
									if ($up_field2 ne "blank")
										{
										$cust_field = $up_field2 . "_cust";
										&mkdirps("$web_dir/imagefiles/$last_lnkid");
										$write_path = "$web_dir/imagefiles/$last_lnkid/$up_field2" . "." . $cur_file_extension;
										$update_sql = "UPDATE links SET $cust_field = '$cur_file_extension' WHERE lnkid = '$last_lnkid'";
										$sth = $dbh->prepare($update_sql);
										$sth->execute;
										$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
										copy("$filepath/$filename", $write_path);
										}
									
									#if ($remove eq "Y") { unlink ("$files_loc/$filename"); } 
									
										
 							}
 							else ### IF INVALID IMAGE
 								{
 									&mkdirps("$web_dir/edt/tmp");
 									open (VALIMG, ">> $web_dir/edt/tmp/validimg.tmp");
 										print VALIMG "$filepath/$filename" . "\n";
 									close (VALIMG);
 								}
 							
 							}
 							
 						$impdirs_uri = uri_escape($impdirs);
 							
					print qq[
					<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
					<html xmlns="http://www.w3.org/1999/xhtml">
					<head>
					<title>PowerSeek</title>
					$HTML_ENCODING_USE
					<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
					<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/p_thumb.cgi?width=$width&height=$height&crosslinkid=$crosslinkid&up_field1=$up_field1&up_field2=$up_field2&remove=$remove&ccn=$ccn&current_count=$current_count&fct=do_import2&files_loc=$files_loc&disp_cat=$disp_cat&impdirs=$impdirs_uri&incl_subdirs=$incl_subdirs">
					</head>
					<body>
					$hbox
					</body>
					</html>
					];
					exit;
				
				}
		$cnt++;
	}
	


}






sub do_import1
{

&mkdirps("$web_dir/edt");

if (-e "$web_dir/edt/tmp/validimg.tmp")
	{
	unlink("$web_dir/edt/tmp/validimg.tmp");
	}

$files_loc = $q->param('files_loc');
$width = $q->param('width');
$height = $q->param('height'); 
$crosslinkid = $q->param('crosslinkid');
$up_field1 = $q->param('up_field1');
$up_field2 = $q->param('up_field2');
$remove = $q->param('remove');
$incl_subdirs = $q->param('incl_subdirs');

if (($width eq "") and ($height eq "")) { acs::problem_popup("You have to specify a width or height."); }
if ($crosslinkid eq "") { acs::problem_popup("You have to specify a category ID."); }


if ((-e "$files_loc") < 1)
	{
	acs::problem_popup("The location <b>'$files_loc'</b> where the files are located to be resized and imported into the database doesn't exist.");
	}


### CHECK IF IMPORT CATEGORY EXIST

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sth = $dbh->prepare("SELECT * FROM dirs WHERE cid = '$crosslinkid'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}
$rows = $sth->rows();

	while ( @row = $sth->fetchrow() )
		{

			for ($ms = 2; $ms < 18; $ms++) 
				{
					if ($row[$ms] ne "")
						{
						$disp_cat = $disp_cat . $row[$ms] . " > ";
						}
				}
			
		}

$disp_cat = substr($disp_cat, 0, length($disp_cat) - 2);

$sth->finish;
$dbh->disconnect;

if ($rows < 1) { acs::problem_popup("There is no category for the category ID you specified."); }

##########################


opendir(DIR,"$files_loc");
@files = readdir(DIR);

@files = sort(@files);

$ccn = 0;
foreach $filename (@files)
	{
	if (($filename ne ".") and ($filename ne "..") and ((-d "$files_loc/$filename") > 0) and ($incl_subdirs eq "Y"))
		{
		$all_dirs = $all_dirs . "./$filename" . "<BR>";
		$dirs_to_add = $dirs_to_add . $filename . ":::";
		$ccn++
		}
		elsif (($filename ne ".") and ($filename ne "..") and ((-d "$files_loc/$filename") < 1))
		{
		$all_files = $all_files . $filename . "<BR>";
		$ccn++;
		}
	}

closedir(DIR);


if ($ccn < 1) { acs::problem_popup("Could not find any files inside <b>$files_loc</b>"); }


if ($all_dirs ne "")
	{
	$all_dir_details = qq[
	
	<b>The following directories was found under: $files_loc</b>
	The images inside the directories below will also be resized and imported into PowerSeek. Note that directories below will be recreated in PowerSeek under <b>$disp_cat</b> as
	categories and the resized images placed inside the PowerSeek categories that has been created.
	<blockquote>
	$all_dirs
	</blockquote>
	<BR><BR>
	];
	
	}


## <input name="ccn" type="hidden" value="$ccn">

$boxdiz = qq[

The following images / files  was found inside: <b>$files_loc</b><BR><BR>

<blockquote>
$all_files
</blockquote><BR>

The above images will be resized and imported into category: <b>$disp_cat</b>
<BR>
<BR>
$all_dir_details


<form method="post" action="$admin_url/p_thumb.cgi" name="addu">

	<input name="fct" type="hidden" value="do_import2">
	<input name="width" type="hidden" value="$width">
	<input name="height" type="hidden" value="$height">
	<input name="crosslinkid" type="hidden" value="$crosslinkid">
	<input name="up_field1" type="hidden" value="$up_field1">
	<input name="up_field2" type="hidden" value="$up_field2">
	<input name="remove" type="hidden" value="$remove">
	<input name="files_loc" type="hidden" value="$files_loc">
	<input name="disp_cat" type="hidden" value="$disp_cat">
	<input name="dirs_to_add" type="hidden" value="$dirs_to_add">
	<input name="incl_subdirs" type="hidden" value="$incl_subdirs">
	
	<input type="submit" class="psbutton" name="Submit" value="Resize and Import Images">
	<input type="submit" class="psbutton" value="     Go Back     " name="B1"  onClick="history.go(-1); return false;"> 

</form>
];

$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "The following images will be resized and imported.", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}







sub start
{

&mkdirps("$web_dir/imagefiles");

if (($IM eq "false") and ($IMRES eq "false"))
	{
	
	$boxdiz = qq[
	 <p><a href="http://www.imagemagick.org" target="_blank">Image Magick</a> or the Perl Module called <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> is not installed on this server. To make use of the image resizing options you need to have <a href="http://www.imagemagick.org" target="_blank">Image Magick</a> 
		or the Perl Module called <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> installed on this server. If you are on a shared host then you can contact your host provider and ask them to  
		install <a href="http://www.imagemagick.org" target="_blank">Image Magick</a> or the Perl Module called <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a>. </p>
		 <p>If this is your own server then you can obtain and install  Image Magick <a href="http://www.imagemagick.org" target="_blank">here</a>. </p>
		 <p>Alternatively it might be easier to  install the  <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> Perl module as the procedure to install   <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> is much easier/quicker than installing <a href="http://www.imagemagick.org" target="_blank">Image Magick</a>. This module can very easily be installed from an SSH shell by doing the following:</p>
		 <blockquote>
		   <p>From an SSH shell issue the following:<br>
	         <strong>perl -MCPAN -e shell</strong></p>
		   <p>Then type:<br> 
		     <strong>install Image::Resize</strong> </p>
	       <p>After doing the above <a href="http://kobesearch.cpan.org/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> will be installed. </p>
	</blockquote>
     <p>       You may <a href="javascript:onClick=window.close()"><b>close</b></a> this window. </p>
	];
	
	$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Image Magick is not installed", $boxdiz);
	
	print qq[
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<title>PowerSeek</title>
	$HTML_ENCODING_USE
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
	</head>
	<body>
	$hbox
	</body>
	</html>
	];
	exit;
	}



### CONFIGURE WHAT TO USE FOR IMAGE RESIZING
if ((-e "$data_dir/imgresconf.dat") < 1)
	{
		if (($IM eq "true") and ($IMRES eq "false"))
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IM";
			close (DDT);
			}
		elsif (($IM eq "false") and ($IMRES eq "true"))
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IMRES";
			close (DDT);	
			}
		else ### IF BOTH MODS INSTALLED USE image::resize
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IMRES";
			close (DDT);	
			}
	}



#### CONFIGURE WHAT TO USE FOR RESIZING IMAGES

if (($IM eq "true") and ($IMRES eq "true"))
	{

	$im_data = acs::get_file_contents("$data_dir/imgresconf.dat");

	if ($im_data eq "IMRES")
		{
			$chk_imres = "checked";
		}
		else
		{
			$chk_im = "checked";
		}
 

$conf_options = qq[

<form name="form2" method="post" action="$admin_url/admin81.cgi">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DFDFDF">
    <tr>
      <td colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF"><strong class="normaltext">Configure what to use to resize images with: </strong></td>
    </tr>
    <tr>
      <td width="29%" bgcolor="#FFFFFF" class="normaltext"><strong>Image Magick <br>
      </strong></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><label>
      <input name="mconf" type="radio" value="IM" $chk_im>
      </label></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Image::Resize (Perl Module) </strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="mconf" type="radio" value="IMRES" $chk_imres></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <input type="submit" class="psbutton" name="Submit2" value="   Save   ">
        <input name="fct" type="hidden" id="fct" value="conf_modules">
        <input name="field" type="hidden" value="$img_fieldname">
        <input name="plug" type="hidden" value="true">
      </label></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </form>
];

	}





if ((-e "$web_dir/edt/tmpimg") < 1)
	{ 
	mkdir ("$web_dir/edt/tmpimg", $default_permissions);
	chmod($default_permissions,"$web_dir/edt/tmpimg");
	} 



$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

	#### PREPARE KEY INSERT SQL STRING
		foreach $k_item (@akeys)
			{
			if ($k_item ne "")
				{	
				($keyname, $visible, $size, $searched, $description, $notext, $imagek, $fieldtype) = split (/\t/, $k_item);
				   
					if ($fieldtype eq "Upload")
						{
						#$keyname_dbfield = $keyname . "_cust";
						$eselval = $eselval . qq[<option value="$keyname">$description (Extra Upload Field)</option>];
						}

				}
			
			}	


$boxdiz = qq[
This plugin allows you to resize images to thumbnails and import them directly into the database.
Note that you will need to manually upload the image files to your web hosting account. This plugin will read all uploaded files and resize and import them into the database.
<BR><BR>
To use this plugin, upload images to: <b>$web_dir/edt/tmpimg</b><BR>
The above location's web address is: <b>$web_url/edt/tmpimg</b><BR>
(Note that you can change the above location by choosing 'Change/Browse' for the '<b>Location of files to resize and import</b>' option below.)<BR><BR>

Once uploaded this plugin will read all the images from the specified directory and resize them to your specifications. After
that it will import the images into the database.
];

$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Thumbnail Batch Resizer & Importer", $boxdiz);



$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 

// End Hide -->
</script>

</head>
<body>
$hbox

<form method="post" action="$admin_url/p_thumb.cgi" name="addu">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
    <tr>
      <td colspan="2" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Resize &amp; Import details :</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Location of files to resize and import:</b></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <input name="files_loc" type="text" id="files_loc" value="$web_dir/edt/tmpimg" size="60">
        <a href="$admin_url/p_thumb.cgi?fct=dirbrowse" onClick="popup('$admin_url/p_thumb.cgi?fct=dirbrowse',750,600);return false;">Change / Browse</a></label></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Include sub directories of the above locaton?</b></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label></label>
        <label></label>
        <table width="100%" border="0" cellspacing="0" cellpadding="3">
          <tr>
            <td width="1%" valign="top"><input name="incl_subdirs" type="checkbox" id="incl_subdirs" value="Y"></td>
            <td width="99%" class="normaltext"><p>Checking this box will have the effect of including sub directories of the above path. Images inside sub directories of the above path will also be resized and imported. Note that the sub directories inside the above path will be recreated inside PowerSeek under the category that has been chosen in the 'Category ID' setting below and images imported in the sub categories created in PowerSeek.</p>
            </td>
          </tr>
        </table></td>
    </tr>
    <tr>
      <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Resize images to width: (in pixels)</b></td>
      <td width="72%" bgcolor="#FFFFFF" class="normaltext"><label>
        <input name="width" type="text" id="width" size="10">
      </label></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Resize images to height: (in pixels) </b></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="height" type="text" id="height" size="10"></td>
    </tr>
    <tr>
      <td colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext">If you want to keep the aspect ratio of the images being resized, only provide one  value for the width or height. For example: leave the height property  blank and provide a value for the width property to resize the images to  a specific width but keep the aspect ratio. (The height will  automatically be resized to keep the aspect ratio)</td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Category ID of category to Import images into:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="crosslinkid" type="text" id="cat" size="10"> 
        <a href="$admin_url/admin67.cgi" onClick="popup('$admin_url/admin67.cgi',750,600);return false;">Select Category</a> <br>
        Note that when images are imported into a category that the file name of the image will be used as the title of the listing. Each set of images imported will represent a link listing</td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Extra Field where thumbnail image will be placed:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <select name="up_field1">
          <option value="default">Standard Image Field (Comes standard with link listings)</option>
          $eselval
        </select>
        <br>
        This is the field where the resized image will be placed.</label></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Extra Field where original image will be placed:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><select name="up_field2">
        <option value="blank">Don't Import Original Image Into an Extra Upload Field</option>
        $eselval
      </select>       
         <br>
        This is the field where the original image will be placed in. Choose the 'blank' option if you only want to import the resized image. </td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <input type="submit" class="psbutton" name="Submit" value="Resize and Import Images">
        <input name="fct" type="hidden" id="fct" value="do_import1">
      </label></td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>

$conf_options

</body>
</html>
];



}


sub mkdirps
{
my ($dir_to_create) = @_;

if ((-e $dir_to_create) < 1) 
	{
	mkdir ($dir_to_create, $default_permissions);
	chmod($default_permissions,$dir_to_create); 
	}

} 



####################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


