#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "do_repair") {&do_repair;}


sub do_repair
{

$towrite = $q->param('newfile');
open (DATD, "> $data_dir/keys.dat") or acs::problem_popup("Could not write to: $data_dir/keys.dat - $@");  
	print DATD $towrite;
close (DATD);


$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Extra Fields Repaired", qq[<a href="$admin_url/admin37.cgi">Click here to continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

</body>
</html>
];



}






sub start
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "show columns from links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 
	while ( @row = $sth->fetchrow() )
	{
	if ($row[0] =~ /_cust/)
		{
		push (@dbarr, $row[0]);
		push (@dbarr2, $row[0] . ":::" . $row[1] . ":::" . $row[3]);
		$foundfield = "true";
		
		#print "$row[0] - $row[1] - $row[2] - $row[3] - $row[4] - $row[5]  - $row[6]<BR>";
		}
	}
	


$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Repair Extra Fields Configuration", qq[This utility will make sure that the PowerSeek configuration of extra fields matches the extra fields that is defined inside the MySQL database.]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox
];






if ($foundfield eq "true")
	{

$fielddetails = qq[

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="180%" height="30" colspan="9" valign="middle" background="$web_url/bar6.gif"
    class="normaltext"><strong>Extra Fields Available In PowerSeek MySQL Database: </strong></td>
  </tr>
  <tr>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Field/Key Name: </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Descriptive
    Name: </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Size: </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Visible in
    Control Panel? </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>To Search? </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Image field/key?
    </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Numbers / &nbsp;
    Characters? </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Blank Value: </strong></td>
    <td width="11%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Required? </strong></td>
  </tr>

];

#</table>		
	}
	else
	{
	
print qq[
<font color="#FF8000"><strong>No extra fields/keys found in the
database. To add extra fields/keys go to the Control Panel &gt;&gt; Settings &gt;&gt;
Extra Fields/Keys</strong></font>]; 
$sth->finish;
$dbh->disconnect;
exit;
	
	}


			### GET TABLE CREATION DETAILS SO THAT WE CAN SEE WHAT BROKEN FIELDS IS TO BE SEARCHED

				$sql = "SHOW CREATE TABLE links";
				$sth = $dbh->prepare($sql);
				$sth->execute;
				if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
			
				while ( @row = $sth->fetchrow() )
				{
				@createlines = split (/\n/, $row[1]);
				}
				




### CHECK DATABASE EXTRA FIELDS AGAINST POWERSEEK FIELDS CONFIGURATION

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$account = 0;
	foreach $dbitem (@dbarr)
	{
	
	$foundm = "false";
	foreach $pskitem (@akeys)
		{
		($keyname, $visible, $size, $searched, $description_key, $na, $imagef, $numberfield, $req)= split (/\t/, $pskitem);
		$kname = $keyname . "_cust";
		
			if ($dbitem eq $kname)
				{
				$foundm = "true";
				($keyname2, $visible2, $size2, $searched2, $description_key2, $na2, $imagef2, $numberfield2, $req2)= split (/\t/, $pskitem);
				}
		}

	### IF FIELD WAS NOT FOUND IN keys.dat
	
	if ($foundm eq "false") 
			{
			($ef_name, $ef_size, $ef_index) = split (/:::/, $dbarr2[$account]);
			
			$ef_name =~ s/_cust//g;
			
			if ($ef_size =~ /int/) { $ef_chars = "Numbers"; $ef_chars2 = "Numbers";} 
			if ($ef_size =~ /text/) { $ef_chars = "text"; $ef_chars2 = "Characters"; $ef_size = "10000";}
			if ($ef_size =~ /varchar/) { $ef_chars2 = "Characters"; }
			
			$ef_size =~ s/varchar//g; $ef_size =~ s/int//g;
			$ef_size =~ s/\(//g; $ef_size =~ s/\)//g;
			
			if (length($ef_index) > 2) { $ef_index = "Yes"; } else { $ef_index = "No"; }

			#### CHECK IF THIS BROKEN FIELD IS TO BE SEARCHED
			foreach $itm (@createlines)
				{
				$ef_name_cust = $ef_name . "_cust";
				if (($itm =~ /FULLTEXT KEY/) and ($itm =~ /$ef_name_cust/))
					{
					$ef_index = "Yes";
					}
				}

			$fielddetails = $fielddetails . qq[

		  <tr>
		    <td width="11%" valign="top" class="normaltext"><strong>$ef_name </strong></td>
		    <td width="11%" valign="top" bgcolor="#FBFBFB" class="normaltext">$ef_name </td>
		    <td width="11%" valign="top" class="normaltext">$ef_size </td>
		    <td width="11%" valign="top" bgcolor="#FBFBFB" class="normaltext">Yes </td>
		    <td width="11%" valign="top" class="normaltext">$ef_index </td>
		    <td width="11%" valign="top" bgcolor="#FBFBFB" class="normaltext">No </td>
		    <td width="11%" valign="top" class="normaltext">$ef_chars2 </td>
		    <td width="11%" valign="top" bgcolor="#FBFBFB" class="normaltext"></td>
		    <td width="11%" valign="top" class="normaltext">No </td>
  			</tr>
			
			];
			
			$out_of_sync = "true";
			
			
			$new_key_file = $new_key_file . $ef_name . "\t" . 		### FIELD NAME
													  "Yes" . "\t" .    		### VISIBLE IN CONTROL PANEL
													  $ef_size . "\t" . 		### FIELD SIZE
													  $ef_index . "\t" . 	### IS THIS FIElD TO BE SEARCHED
													  $ef_name . "\t" . 		### DESCRIPTIVE NAME
													  "" . "\t" . 				### NOT AVAILABLE TEXT
													  "No" . "\t" . 			### IMAGE FIELD OR NOT  Yes/No
													  $ef_chars . "\t" . 	### CHARS or NUMBERS
													  "No" . "\n";				### SUBMISSION VALUE REQUIRED
													  
			}
			else
			{
			if ($imgk2 eq "") { $imgk2 = "No"; }
			if ($numberfield2 eq "Y") { $numberfield2 = "Numbers"; } else { $numberfield2 = "Characters"; }
			
			$fielddetails = $fielddetails . qq[

	  <tr>
	    <td width="11%" valign="top"><p><strong>$keyname2 </strong></p></td>
	    <td width="11%" valign="top" bgcolor="#FBFBFB"><p>$description_key2 </p></td>
	    <td width="11%" valign="top"><p>$size2 </p></td>
	    <td width="11%" valign="top" bgcolor="#FBFBFB"><p>$visible2 </p></td>
	    <td width="11%" valign="top"><p>$searched2 </p></td>
	    <td width="11%" valign="top" bgcolor="#FBFBFB"><p>$imgk2 </p></td>
	    <td width="11%" valign="top"><p>$numberfield2 </p></td>
	    <td width="11%" valign="top" bgcolor="#FBFBFB"><p>$na2 </p></td>
	    <td width="11%" valign="top"><p>$req2 </p></td>
  </tr>
			
			];
			
			
						$new_key_file = $new_key_file . $keyname2 . "\t" . 			### FIELD NAME
																  $visible2 . "\t" .   			### VISIBLE IN CONTROL PANEL
																  $size2 . "\t" . 				### FIELD SIZE
																  $searched2 . "\t" . 			### IS THIS FIElD TO BE SEARCHED
																  $description_key2 . "\t" . 	### DESCRIPTIVE NAME
																  $na2 . "\t" . 					### NOT AVAILABLE TEXT
																  $imagef2 . "\t" . 				### IMAGE FIELD OR NOT  Yes/No
																  $numberfield2 . "\t" . 		### CHARS or NUMBERS
													  			  $req2 . "\n";					### SUBMISSION VALUE REQUIRED
			
			}
	
	$account++;
	}


$fielddetails = $fielddetails . qq[</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

];

print $fielddetails;



### CHECK IF THERE ARE NOT MORE FIELDS IN keys.dat THAT THERE SHOULD BE

$dbfields_number = @dbarr;
$psfiekds_number = @akeys;

if ($dbfields_number ne $psfiekds_number)
	{
	$out_of_sync = "true";
	}


$boxdiz = qq[
<p>
In this instance you may experience search errors and various SQL syntax error related
issues due to PowerSeek not being configured correctly for the use of the extra
fields/keys inside the database. These situations mostly occur when: 

<ul>
  <li class="normaltext">A database backup is restored that does not contain extra fields but PowerSeek is
    currently configured to handle extra fields. When restoring data please follow the backup
    restoration instructions inside the manual. </li>
  <li class="normaltext">Faulty upgrades. </li>
  <li class="normaltext">Missing data files or data files being overwritten by accident when doing an upgrade. </li>
</ul>
];

$helpb = acs::quick_help("Explanation/Help:",$boxdiz); 
 






if ($out_of_sync eq "true")
	{
	print qq[

<form method="POST" action="$admin_url/repairfields.cgi">
  <input type="hidden" name="fct" value="do_repair">
  <input type="hidden" name="newfile" value="$new_key_file">
  <p><font face="Arial" size="2"><font
  color="#FF0000"><strong>Rapair Required:</strong></font> There are custom extra
  fields/keys inside your database that PowerSeek is not configured for. (These are
  indicated in red above.) Would you like to repair the PowerSeek configuration for
  these extra fields? (PowerSeek won't function propperly if this is not repaired) <br>
  <br>
  <input type="submit" class="psbutton" value="Repair PowerSeek Extra Field Configuration" name="B1"></font></p>
</form>

$helpb
	];
	}


$sth->finish;
$dbh->disconnect;
}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

