#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################


#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use DBI;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use IO::Socket;

&get_env;


if ($fields{'fct'} eq "import"){ &get_setup; &import_links; exit;}

print "Content-type: text/html\n\n";

&get_setup;
&print_top;

if ($fields{'fct'} eq ""){&start;}
if ($fields{'fct'} eq "step1"){&step1;}
if ($fields{'fct'} eq "verify"){&verify;}
if ($fields{'fct'} eq "step4"){&step4;}
if ($fields{'fct'} eq "step5"){&step5;}
if ($fields{'fct'} eq "step6"){&step6;}
if ($fields{'fct'} eq "step7"){&step7;}
if ($fields{'fct'} eq "step8"){&step8;}
if ($fields{'fct'} eq "step9"){&step9;}
if ($fields{'fct'} eq "step10"){&step10;}
if ($fields{'fct'} eq "step11"){&step11;}


if ($fields{'fct'} eq "pathinfo"){&pathinfo;}

if ($fields{'fct'} eq "import2"){&import_links2;}

if ($fields{'fct'} eq "import_completed"){&import_completed;}


&print_bottom;


#################################

sub step11
{
my ($no_write) = @_;


if ($no_write eq "")
	{
	&write_var("USERNAME", $fields{'username'});
	&write_var("PASSWORD", $fields{'password'});
	&write_var("PRIMEMAIL", $fields{'prim_email'});
	&write_var("FROMWHOM", $fields{'whom_email'});
	
	### WRITE !!TOP!! VARIABLE

	$topvar = &get_file_contents2("$data_dir/frontlink.dat");
	
	if ($topvar eq "")
		{
		open (FFL, "> $data_dir/frontlink.dat");
			print FFL $fields{'domain_name'};
		close (FFL);
		}

	### WRITE EMAIL ADDRESS
	}


### UPDATE EMAILS

if (($fields{'prim_email'} ne "") and ($fields{'update_eml'} eq "Y") and ($fields{'whom_email'} ne ""))
	{
	@emailsc = ("accept_modify.eml",
	"acceptance.eml", 
	"emlnot.eml", 
	"expired_email.eml", 
	"forgot_password.eml", 
	"linkincl.eml", 
	"month_exp.eml", 
	"pacceptance.eml", 
	"prejection.eml", 
	"pwelcome.eml", 
	"reject_modify.eml", 
	"rejection.eml", 
	"retrieve_pass.eml", 
	"retrievepass.eml", 
	"validation.eml", 
	"week_exp.eml", 
	"welcome.eml",
	"informer.eml",
	"pinformer.eml",
	"pinformerupgrade.eml",
	"emlnot.eml",
	"emladm.eml"
	);
	
	foreach $item (@emailsc)
		{
		$e_msg = &get_file_contents2("$data_dir/$item");
		
		my @elines = split (/\n/, $e_msg);
		
			$acnt = 0; $emlwrite = "";
			foreach $eline (@elines)
				{
					if (($item eq "informer.eml") or ($item eq "pinformer.eml") or ($item eq "pinformerupgrade.eml"))
					{
						if ($acnt == 0) { $emlwrite = $emlwrite . $fields{'prim_email'} . "\n"; }
						elsif ($acnt == 1) { $emlwrite = $emlwrite . $fields{'prim_email'} . "\n"; }
						else	{ $emlwrite = $emlwrite . $eline . "\n"; }
					}
					elsif ($item eq "emladm.eml")
					{
						if ($acnt == 0) { $emlwrite = $emlwrite . $fields{'whom_email'} . "\n"; }
						elsif ($acnt == 1) { $emlwrite = $emlwrite . $fields{'prim_email'} . "\n"; }
						elsif ($acnt == 2) { $emlwrite = $emlwrite . $fields{'prim_email'} . "\n"; }
						else	{ $emlwrite = $emlwrite . $eline . "\n"; }
					}
					else
					{
						if ($acnt == 0) { $emlwrite = $emlwrite . $fields{'whom_email'} . "\n"; }
						elsif ($acnt == 1) { $emlwrite = $emlwrite . $fields{'prim_email'} . "\n"; }
						else	{ $emlwrite = $emlwrite . $eline . "\n"; }
					}
				$acnt++;
				}
		
		open (EMWR, "> $data_dir/$item");
			print EMWR $emlwrite;
		close (EMWR);
		}

	}


	

if ($fields{'prim_email'} ne "")
	{
	$contactus1 = &get_file_contents2("$data_dir/contactus1.dat"); 
	@contactus_items = split (/\n/, $contactus1);

	$contact_us_email = 	$fields{'prim_email'}; 
	$autoresponse = 		$contactus_items[1];
	$htmlemail = 			$contactus_items[2];
	$from_name =			$fields{'whom_email'};
	$from_email = 			$fields{'prim_email'};
	$subject = 				$contactus_items[5];

			open (EMWR, "> $data_dir/contactus1.dat");
				print EMWR $contact_us_email . "\n";
				print EMWR $contactus_items[1] . "\n";
				print EMWR $contactus_items[2] . "\n";
				print EMWR $fields{'whom_email'} . "\n";
				print EMWR $fields{'prim_email'} . "\n";
				print EMWR $contactus_items[5] . "\n";
			close (EMWR);	
	}





### DISPLAY FINISHED
#

$left_step_bar = &get_setup_steps(11);

print qq[
<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step5"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8"><p><strong>PowerSeek Setup Complete!</strong></p></td>
        </tr>
        <tr>
          <td valign="top" bgcolor="#FFFFFF"><p><strong>Important Notes:</strong></p>
            <ul>
              <li>
                <p> You have to have cookies enabled inside your browser to be able to log into the PowerSeek SQL Control Panel. If you don't have cookies enabled then enable them now.</p>
              </li>
              <li>                
                <p> If you need to change your Control Panel user name or password then it can be changed by re-running setup.cgi </p>
              </li>
              <li>
                <p>Please delete this setup.cgi script once you don't need to access it anymore. Leaving it on the server creates a security whole.</p>
              </li>
            </ul>            
            <blockquote>
              <p><a href="$admin_url/admin.cgi"><strong>Click Here to Log Into The PowerSeek Admin Control Panel</strong></a></p>
              <p><br>
              </p>
            </blockquote></td>
        </tr>
        <tr>
          <td valign="top" bgcolor="#FFFFFF"><p><strong>Upgrade from Turbo Seek 1.x or 2.x </strong></p>
            <blockquote>
              <p><a href="$admin_url/upgrade.cgi"><strong>Click Here to import links from Turbo Seek ver 1.x or 2.x</strong></a><br>
                <br>
                Please refer to the online upgrade instructions for more on this. (Available inside the PowerSeek Manual)</p>
              <p>&nbsp;</p>
            </blockquote></td>
          </tr>
        <tr>
          <td valign="top" bgcolor="#FFFFFF"><p><strong>Import 14 000 Startup Links</strong></p>
            <blockquote>
              <p><a href="$admin_url/setup.cgi?fct=import"><strong>Click Here to import approximately 14 000 startup links</strong></a></p>
              <p>              This is a compilation of about 14 000 links in 386 categories. Note that you can always remove these links by deleting the main categories at a later stage.<br>
                The main categories of the links are:</p>
              <ul>
                <li>
                  <p> Business and Money</p>
                </li>
                <li>
                  <p> Computing</p>
                </li>
                <li>
                  <p> Entertainment</p>
                </li>
                <li>
                  <p> Health</p>
                </li>
                <li>
                  <p> Lifestyle</p>
                </li>
                <li>
                  <p> News</p>
                </li>
                <li>
                  <p> Sports</p>
                </li>
                <li>
                  <p> Travel</p>
                </li>
              </ul>
            </blockquote></td>
        </tr>
        <tr>
          <td valign="top" bgcolor="#FFFFFF"><input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
</td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
];


}




sub step10
{

$left_step_bar = &get_setup_steps(10);

$topvar = &get_file_contents2("$data_dir/frontlink.dat");

if ($topvar eq "")
	{
	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$domain_name = "http://" . $domain_items[2];
	}
	else
	{
	$domain_name = $topvar;
	}


print qq[

<script language="JavaScript">

function GeneratePassword() {

    var length=7;
    var sPassword = "";

    //var noPunction = (document.aForm.punc.checked);
    //var randomLength = (document.aForm.rLen.checked);

   for (i=0; i < length; i++) {

        numI = getRandomNum();
        while (checkPunc(numI)) { numI = getRandomNum(); }
        sPassword = sPassword + String.fromCharCode(numI);
    }

    document.getElementById('password').value = sPassword;

    return true;
}

function getRandomNum() {

    // between 0 - 1
    var rndNum = Math.random()

    // rndNum from 0 - 1000
    rndNum = parseInt(rndNum * 1000);

    // rndNum from 33 - 127
    rndNum = (rndNum % 94) + 33;

    return rndNum;
}

function checkPunc(num) {

    if ((num >=33) && (num <=47)) { return true; }
    if ((num >=58) && (num <=64)) { return true; }
    if ((num >=91) && (num <=96)) { return true; }
    if ((num >=123) && (num <=126)) { return true; }

    return false;
}

</script>


<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step11"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>Control Panel User/Pass and Other Details:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="35%" valign="top"><p><font color="#0000FF"><strong>Control Panel User Name:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top" width="65%"><p><strong>
            <input type="text" name="username" size="20" value="$username">
          </strong></p>
            <p>This will be the User Name to access the PowerSeek Control Panel</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p><font color="#0000FF"><strong>Control Panel Password:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top"><p><strong>
            <input type="text" name="password" size="20" value="$password" id="password">
            <input type="submit" value="Generate Password" name="B1" onClick="GeneratePassword(); return false;">
              </strong></p>
            <p>This will be the Password to access the PowerSeek Control Panel</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p><font color="#0000FF"><strong>Domain Name:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top"><p><strong>
            <input type="text" name="domain_name" size="15" value="$domain_name" id="domain_name"  style="width:100%" >
          </strong></p>
            <p>Specify the domain name on which PowerSeek is installed.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p><font color="#0000FF"><strong>Primary Email Address:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top"><p><strong>
            <input name="prim_email" type="text" id="prim_email"  style="width:100%" value="$prim_email" size="15" >
          </strong></p>
            <p>This email address will be used to send out email to the Administrator and Users when sending email in various situations where email is sent out by PowerSeek.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p><font color="#0000FF"><strong>Name or Company Name From Whom Email is Sent:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top"><p><strong>
            <input name="whom_email" type="text" id="$whom_email"  style="width:100%" value="$whom_email" size="15" >
            <br>
            <br>
          </strong><strong></strong>When PowerSeek sends email then this name will be used to indicate from whom email is being sent.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top">&nbsp;</td>
          <td bgcolor="#FFFFFF" valign="top"><label>
            </label>
            <table width="100%" cellspacing="0" cellpadding="3">
              <tr>
                <td width="1%" valign="top"><input name="update_eml" type="checkbox" id="update_eml" value="Y" checked></td>
                <td width="99%" class="normaltext">
                Use the <strong>'Primary Email Address'</strong> and <strong>'Name or Company Name'</strong> specified above for <strong>all email messages </strong>being sent by PowerSeek. Note that you can customize these details for individual emails being sent out from the PowerSeek Control Panel under the 'Settings' tab at any time.
                </td>
              </tr>
            </table></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1" /> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
];



}




sub step9
{

if ($fields{'mail_method'} eq "smtp_pm")
	{
	&write_var("SMTP_SERVER", $fields{'smtp_server1'});
	}
	elsif ($fields{'mail_method'} eq "smtp")
	{
	&write_var("SMTP_SERVER", $fields{'smtp_server2'});
	}
	elsif  ($fields{'mail_method'} eq "smtp_auth")
	{
	&write_var("SMTP_SERVER", $fields{'smtp_server3'});
	}

&write_var("MAIL_METHOD", $fields{'mail_method'});
&write_var("SENDMAIL", $fields{'sendmail'});
&write_var("SMTP_USER", $fields{'smtp_user'});
&write_var("SMTP_PASS", $fields{'smtp_pass'});


if ($fields{'mail_method'} eq "smtp_auth")
	{
	if ($fields{'smtp_user'} eq "") {&setup_problem("You have chosen to use smtp with user/pass to send email with. With this option you have to supply a user name.");}
	if ($fields{'smtp_pass'} eq "") {&setup_problem("You have chosen to use smtp with user/pass to send email with. With this option you have to supply a password.");}
	}


###### CHECK EMAIL CONGIG

$red = "<font color=\"#FF0000\">";
$cend = "</font>";
$blue = "<font color=\"#0000FF\">";

if ($fields{'mail_method'} eq "sendmail")
	{
	$email_use = "You have chosen to use sendmail";
	if ((-e "$fields{'sendmail'}") > 0)
		{
		$email_verify = "<ul><li><p><b>Verification Result:</b> $fields{'sendmail'} does exist. $blue <b>OK... </b> $cend</p></ul></li>";
		}
		else
		{
		$email_verify = "<ul><li><p><b>Verification Result:</b> $red $fields{'sendmail'} does not exist. $cend</p></ul><li/>";
		}
	}
	else
	{
	$email_use = "You have chosen to use smtp </b>";
	$email_verify = "<ul><li><p>Verification not available for smtp.</p></ul></li>";  
	}

$left_step_bar = &get_setup_steps(9);

print qq[
<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step10"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>Email Verification:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>You have chosen to use:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top" width="70%"><p><strong>$email_use </strong>$email_verify</p>
            </td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1" /> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
];


}







sub step8
{

if ($mail_method eq "smtp")
	{
	$smtp_sel = "checked";
	}
	elsif ($mail_method eq "sendmail")
	{
	$sendmail_sel = "checked";
	}
	elsif ($mail_method eq "smtp_pm")
	{
	$smtp_pm_sel = "checked";
	}
	elsif ($mail_method eq "smtp_auth")
	{
	$smtp_pm_auth = "checked";
	}
	
$reffr = $ENV{'HTTP_REFERER'};
@domain_items = split (/\//, $reffr);
$smpt_guees = "mail." . $domain_items[2];


if ($smtp_server eq "mail.yourdomain.com")
	{
	$smtp_server = $smpt_guees;
	}



$left_step_bar = &get_setup_steps(8);

print qq[
<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step9"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>Email Configuration:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" colspan="2"><p>This section allows you to configure how PowerSeek will send email.</p>
            <p>If your server/host has <strong>sendmail</strong> installed and you would like PowerSeek to send mail with <strong>sendmail</strong> choose the 'sendmail' option - Most Unix/Linux hosts will have the <strong>sendmail</strong> program available. <strong>Recommended for Unix/Linux based hosts.</strong></p>
            <p>If you are for example on a Windows based host/server that does not have a sendmail program choose one of the 'smtp' options - You will need a mail server which will send or relay the mail for PowerSeek. Some Windows mail servers require a user name and password. This is normally your email user name and password that you use to check email with.</p>
            <p><strong>Select an option below:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="1%" valign="top"><p>
            <input type="radio" value="sendmail" name="mail_method" $sendmail_sel>
          </p></td>
          <td bgcolor="#FFFFFF" valign="top" width="99%"><p><font color="#0000FF"><strong>Sendmail</strong></font> (Recommended for Unix/Linux operating systems)</p>
            <p><strong>Full Server Path to the sendmail Program:</strong> 
              <input type="text" name="sendmail" size="34" value="$sendmail">
            </p>
            <p>If you do not know where sendmail is located, your isp/hosting company should be able to provide you with the path. In almost all Linux distributions the default path is: <strong>/usr/sbin/sendmail</strong></p>
            <p>You may leave this option blank if you are going to use SMTP</p>
            </td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="1%" valign="top"><p>
            <input type="radio" value="smtp_pm" name="mail_method" $smtp_pm_sel>
          </p></td>
          <td bgcolor="#FFFFFF" width="99%" valign="top"><p><strong><font color="#0000FF">smtp.pm</font></strong>(Recommended for Windows based operating systems)</p>
            <p><strong>SMTP Server Address: </strong>
              <input type="text" name="smtp_server1" size="34" value="$smtp_server" $smtp_pm_sel>
            </p>
            <p>Supply an SMTP Server address above. This will likely be: <strong>$smpt_guees</strong></p>
            <p>The <strong>SMTP Server</strong> address you provide above will be used to relay email via PowerSeek. You will normally want to use your mail server (SMTP) for this.</p>
            <p>You may leave this blank if you are going to use sendmail or another option.</p>
            </td>
        </tr>
        <tr>
          <td width="1%" valign="top" bgcolor="#FFFFFF"><input type="radio" value="smtp" name="mail_method" $smtp_sel></td>
          <td width="99%" valign="top" bgcolor="#FFFFFF"><p><strong><font color="#0000FF">SMTP Server where PowerSeek handles connections </font></strong>(Recommended for Windows based operating systems)</p>
            <p><strong>SMTP Server Address:</strong>
              <input type="text" name="smtp_server2" size="34" value="$smtp_server">
              </p>
            <p>Supply an SMTP Server address above. This will likely be: <strong>$smpt_guees</strong></p>
            <p>The <strong>SMTP Server</strong> address you provide above will be used to relay email via PowerSeek. You will normally want to use your mail server (SMTP) for this.</p>
            <p>You may leave this blank if you are going to use sendmail or another option.</p></td>
        </tr>
        <tr>
          <td width="1%" valign="top" bgcolor="#FFFFFF"><input type="radio" value="smtp_auth" name="mail_method" $smtp_pm_auth></td>
          <td width="99%" valign="top" bgcolor="#FFFFFF"><p><strong><font color="#0000FF">SMTP Server requiring authentication to send email</font></strong></p>
            <p><strong>SMTP Server Address:</strong>
                <input type="text" name="smtp_server3" size="34" value="$smtp_server">
              </p>
            <p>Supply an SMTP Server address above. This will likely be: <strong>$smpt_guees</strong></p>
            <p>The <strong>SMTP Server</strong> address you provide above will be used to relay email via PowerSeek. You will normally want to use your mail server (SMTP) for this.</p>
            <table width="100%" border="0" cellspacing="1" cellpadding="3">
              <tr>
                <td width="10%"><p><strong>Username:</strong></p></td>
                <td width="81%"><p>
                  <input type="text" name="smtp_user" size="34" value="$smtp_user">
                </p></td>
              </tr>
              <tr>
                <td width="10%"><p><strong>Password: </strong></p></td>
                <td><p>
                  <input type="text" name="smtp_pass" size="34" value="$smtp_pass">
                </p></td>
              </tr>
            </table>            
            <p>The user name and password will be the user name and password of a valid email address that you will use to send email with.</p>
            <p>You may leave the fields blank if you are going to use sendmail or another option.</p></td>
        </tr>
        <tr>
          <td width="1%" valign="top" bgcolor="#FFFFFF"><p>&nbsp;</p></td>
          <td width="99%" valign="top" bgcolor="#FFFFFF"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1" /> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
];

}



sub step7
{

$left_step_bar = &get_setup_steps(7);

if ($fields{'web_dir'} eq "") { &setup_problem("Please supply the full server path where generated HTML files should be stored."); }
if ($fields{'data_dir'} eq "") { &setup_problem("Please supply the full server path to your 'data' directory"); }
$data_dir = $fields{'data_dir'};

&write_var("WEB_DIR", $fields{'web_dir'});
&write_var("DATA_DIR", $fields{'data_dir'});


$red = "<font color=\"#FF0000\">";
$cend = "</font>";
$blue = "<font color=\"#0000FF\">";



######### WEB_DIR

if ((-e $fields{'web_dir'}) < 1) 
	{
	$web_dir_res = "$red <b>Does not exist.</b> $rede"; 
	}
else 	
	{
	$web_dir_res = "$blue <b>OK... Does exist.</b> $cend";
	if ((-w $fields{'web_dir'}) < 1) 	{$web_dir_res = $web_dir_res . "<BR>$red <b>$fields{'web_dir'} is not writable.</b> Please assign the permission setting of 777 to this directory. Note that all the files inside this directory also needs the permission setting of 777  $cend";}
	}


######### DATA_DIR

if ((-e $fields{'data_dir'}) < 1) 	
	{
	$data_dir_res = "$red <b>Does not exist.</b> $cend";
	}
else 	
	{
	$data_dir_res = "$blue <b>OK... Does exist.</b> $cend";
	if ((-w $fields{'data_dir'}) < 1) {$data_dir_res = $data_dir_res . "<BR>$red <b>$fields{'data_dir'} is not writable.</b> Please assign the permission setting of 777 to this directory. Note that all the files inside this directory also needs the permission setting of 777 $cend";}
	}



print qq[

<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step8"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>Verifying Full Server Paths:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>Full Server Path where HTML files are to be stored:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top" width="70%"><p><font color="#0000FF"><strong>$web_dir</strong></font></p>
            <ul>
              <li>
                <p><strong>Verification Result:</strong> $web_dir_res</p>
              </li>
            </ul></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>Full Server Path to the 'data' directory:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><strong><font color="#0000FF">$data_dir</font> </strong></p>
            <ul>
              <li>
                <p><strong>Verification Result:</strong> $data_dir_res</p>
              </li>
            </ul>            </td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1" /> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>

];

}






sub step6
{


foreach $key (keys(%ENV)) 
	{
	if ($key !~ /cookie/i)
		{
		
		if ($key eq "DOCUMENT_ROOT") 
			{
			$docroot = $ENV{$key};
			}

		if (($key eq "DOCUMENT_ROOT") and ($web_dir eq "/home/yourdomain.com/www/pseek"))
			{
			if ($ENV{$key} ne "")
				{
				$web_dir = $ENV{$key} . "/html";
				}
			}

		
		if (($key eq "DOCUMENT_ROOT") and ($ENV{$key} ne ""))
			{
			$public_dir = $ENV{$key};
			}
		
		
		if (($key eq "SCRIPT_FILENAME") and ($data_dir eq "/home/yourdomain.com/pseek_data"))
			{
			if ($ENV{$key} ne "")
				{
				$data_dir = $ENV{$key};
				$data_dir =~ s/setup\.cgi//g;
				$data_dir = $data_dir . "data";
				}
			}		
		
		}
	}



$left_step_bar = &get_setup_steps(6);


print qq[
<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step7"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>Full Server Paths:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" colspan="2"><p>A full server path is a path to a directory. It indicates the location of a directory on Windows or Unix/Linux.  Each directory on Windows or Unix/Linux is called a path or you could also call it a full server path.</p>
            <p>The full server path where your Public HTML files are situated is:<br>
                <strong>$public_dir</strong></p>
            <p>Your Public HTML directory holds the web pages of your web site.</p>            </td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>Full Server Path where HTML files are to be stored:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top" width="70%"><p><strong>
            <input type="text" name="web_dir" size="42" value="$web_dir"  style="width:100%" >
          </strong></p>
            <p>The above full server path is the location where generated HTML files will be stored. In the setup instructions it has been referred to <strong>as the 'html' directory</strong> that you had to create. This directory also needs the permission setting of 777 and the files contained within it.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>Full Server Path to the 'data' directory:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><strong>
            <input type="text" name="data_dir" size="42" value="$data_dir"  style="width:100%" >
            <font
          face="Arial" size="2"> </font></strong></p>
            <p>The above full server path is the location where PowerSeek's data files will be stored. These files are used by PowerSeek to store templates, settings, and other data files. In the setup instructions it has been referred to<strong> as the 'data' directory</strong> that you had to create. This directory also needs the permission setting of 777 and the files contained within it.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1" /> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
];


}






sub step5
{

$left_step_bar = &get_setup_steps(5); 

if ($fields{'script_url'} eq "") { &setup_problem("Please supply the URL path where the .cgi script files are located."); }
if ($fields{'admin_url'} eq "") { &setup_problem("Please supply the URL path where the .cgi script files are located."); }
if ($fields{'web_url'} eq "") { &setup_problem("Please supply the URL path where generated HTML files should be stored."); }

&write_var("SCRIPT_URL", $fields{'script_url'}); ###
&write_var("ADMIN_URL", $fields{'admin_url'});
&write_var("WEB_URL", $fields{'web_url'});


&get_setup;

######## CHECK URLS...

$url_msg = "A 'failed' result (does not exist) can be reported incorrectly where the path actually exists. 
The script connects to the URL address specified to verify it. The reason it might incorrectly report 
that the URL does not exist, might occur on hosts/servers that has firewalls.
";


$red = "<font color=\"#FF0000\">";
$cend = "</font>";
$blue = "<font color=\"#0000FF\">";


if ($fields{'vpaths'} eq "Yes")
	{

	######### SCRIPT_URL

	($txt, $httpheader, $docdate, $server) = &get_html_document ("$fields{'script_url'}/utest.cgi");

	if ($httpheader =~ /200 OK/)
		{
		$script_url_res =  "<b>$blue OK... Does exist. $cend</b>";
		}
		else
		{
		$script_url_res = "<b>$red does not exist.  - $httpheader </b>$cend - $url_msg";
		}	
	}
	else
	{
	$script_url_res = "Skipped...";
	}

######## ADMIN_URL

if ($fields{'vpaths'} eq "Yes")
	{

	($txt, $httpheader, $docdate, $server) = &get_html_document ("$fields{'admin_url'}/utest.cgi");

	if ($httpheader =~ /200 OK/)
		{
		$admin_url_res =  "<b>$blue OK... Does exist. $cend</b>";
		}
		else
		{
		$admin_url_res = "<b>$red does not exist.  - $httpheader </b>$cend - $url_msg";
		}	

	}
	else
	{
	$admin_url_res = "Skipped...";
	}

######## WEB_URL

if ($fields{'vpaths'} eq "Yes")
	{
	($txt, $httpheader, $docdate, $server) = &get_html_document ("$fields{'web_url'}/logo5.gif");

	if ($httpheader =~ /200 OK/)
		{
		$web_url_res =  "<b>$blue OK... Does exist. $cend</b>";
		}
		else
		{
		$web_url_res = "<b>$red does not exist. - $httpheader </b>$cend - $url_msg";
		}	
	}
	else
	{
	$web_url_res = "Skipped...";
	}


print qq[



<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step6"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>URL Path Verification Results:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" colspan="2"><p><strong>Note:</strong> A 'failed' result meaning that
            the URL path does not exist can be reported incorrectly where the path actually exists.
            The script connects to the URL addresses specified to verify the URL paths. The reason it
            might incorrectly report that the URLs does not exist, might occur on hosts/servers that
            has firewalls.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>URL Path to
            the general .cgi and .pm files:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top" width="70%"><p><strong><font color="#0000FF">$script_url</font></strong></p>
            <ul>
              <li>
                <p><strong>              Verification Result:</strong> $script_url_res</p>
              </li>
            </ul></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>URL Path to
            the admin .cgi and .pm files:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><strong><font color="#0000FF">$admin_url</font></strong></p>
            <ul>
              <li>
                <p><strong>Verification Result:</strong> $admin_url_res</p>
              </li>
            </ul></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>Url Path
            where HTML files are to be stored:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><strong><font color="#0000FF">$web_url</font></strong></p>
            <ul>
              <li>
                <p><strong>Verification Result:</strong> $web_url_res</p>
              </li>
            </ul></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1" /> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>


];



}





sub step4
{

&get_setup;

&create_tables;

$reffr = $ENV{'HTTP_REFERER'};

@domain_items = split (/\//, $reffr);

$yourdomain = "http://" . $domain_items[2];


if (($reffr ne "") and ($script_url eq "http://www.yourdomain.com/cgi-bin/pseek"))
	{
	$script_url = $reffr;
	$script_url =~ s/\/admin\/setup\.cgi//g;
	}

if (($reffr ne "") and ($admin_url eq "http://www.yourdomain.com/cgi-bin/pseek/admin"))
	{
	$admin_url = $reffr;
	$admin_url =~ s/\/setup\.cgi//g;
	}

if (($reffr ne "") and ($web_url eq "http://www.yourdomain.com/pseek"))
	{
	@refitems = split (/\//, $reffr);
	$web_url = $refitems[2];
	$web_url = "http://" . $web_url . "/html";
	}




$left_step_bar = &get_setup_steps(4); ### STEP 2


print qq[



<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step5"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>URL Paths:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" colspan="2"><p>A URL path is a web address. A URL path will always
            start with <strong>http:// </strong>and indicates an address on the Internet. For example
            the web address of the domain where you are currently installing PowerSeek on is: <strong>$yourdomain</strong></p>
            <p><strong>Note
              that this setup script will try to gues the URL paths below but it may be guesing the URL
            path to the 'html' directory wrongly. Please correct if necessary.</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>URL Path to
            the general .cgi and .pm files:</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top" width="70%"><p><strong><font face="Verdana" size="1">
            <input
          type="text" name="script_url" size="42" value="$script_url" style="width:100%">
          </font></strong></p>
            <p>Please
              supply the URL path to the general .cgi and .pm script files above. The general .cgi and
              .pm script files is located inside the 'cgi' directory of the PowerSeek .zip installation
            file.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>URL Path to
            the admin .cgi and .pm files:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><strong><font face="Verdana" size="1">
            <input
          type="text" name="admin_url" size="42" value="$admin_url" style="width:100%">
          </font><font
          face="Arial" size="2"> </font></strong></p>
            <p>Please supply the URL path to the Admin .cgi
              and .pm script files above. The Admin .cgi and .pm script files is located inside the
            'cgi/admin' directory of the PowerSeek .zip installation file.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>Url Path
            where HTML files are to be stored:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><strong><font face="Verdana" size="1">
            <input
          type="text" name="web_url" size="42" value="$web_url" style="width:100%">
          </font><font
          face="Arial" size="2"> </font></strong></p>
            <p>The above URL path is the location where
              generated HTML files will be stored. In the setup instructions it has been refered to the <strong>'html'
                directory</strong> that you had to create. This directory also needs <strong>the
            permission setting of 777</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p><font color="#0000FF"><strong>Verify Above URL Paths?</strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <select name="vpaths" size="1">
              <option value="Yes">Yes</option>
              <option value="No">No</option>
            </select>
          </p>
            <p>Choose 'No' above if the browser seems to hang when you click the 'Next' button. The URLs you supply in this step  is actually fetched to ensure that the URL addresses exist. In some cases, the 'URL fetcher' will return a failed response and be wrong where the URL path actually exists. This is because the 'URL fetcher' used in this setup script is not as advanced as a fully functional web browser. If you get URL addresses that fails and you are sure it exists, then there will probably be other reasons why it fails and does not necessarily mean that the URL paths supplied was wrong.</p>
            </td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1" /> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>


];



}



sub import_completed
{

print qq[<p><font face="Arial" size="4" color="#0000A0"><strong>Import Complete!</strong></font></p>

<hr size="1" color="#EFEFEF">

<p><font face="Arial" size="4" color="#0000A0"><strong>PowerSeek Setup Complete.</strong></font>
</p>

<blockquote>
  <p><font face="Arial" size="2"><strong>Important Notes:</strong></font></p>
</blockquote>

<blockquote>
  <ul>
    <li><font face="Arial" size="2">You have to have cookies enabled inside your browser to be
      able to log into the PowerSeek SQL Control Panel. If you don't have cookies enabled then
      enable them now.</font></li>
    <li><font face="Arial" size="2">If you need to change your Control Panel user name or
      password then it can be changed by re-running setup.cgi</font></li>
  </ul>
</blockquote>

<blockquote>
  <strong><font face="Verdana" color="#8080ff" size="2"><p></font><font face="Arial"
  size="2" color="#8080FF"><a href="$admin_url/admin.cgi">Click Here to Log Into The
  PowerSeek Admin Control Panel</a></font></strong></p>
</blockquote>

<hr size="1" color="#EFEFEF">
];



}







sub import_links2
{

if ($fields{'B2'} =~ /No/) { &step11("NOWRITE"); exit; }

### CHECK IF import.txt exists

if ((-e "$data_dir/import.txt") < 1) { &setup_problem("Could not find import.txt - Please <a href=\"http://www.focalmedia.net/support.html\">contact us</a> for assistance."); exit;}

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head><title></title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/p_import.cgi?filename=import&delimit=tab&date_format=yyyy/mm/dd&extra_fnr=0&fct=do_import&f1=dirs_category&f2=dirs_ext2&f3=dirs_description&f4=dirs_keywords&f5=dirs_catlock&f6=dirs_crosslinkid&f7=links_title&f8=links_description&f9=links_keywords&f10=links_url&f11=links_name&f12=links_email&f13=links_rating&f14=links_votes&f15=links_hits&f16=links_premium&f17=links_newsubm&f18=links_userid&f19=links_urldate&f20=links_subscribed&f21=links_csuggest&22=links_subs_expire&f23=links_lnkpassword&f24=links_rev_no">
</head>
<body>
</body>
</html>
];

}




sub import_links
{


$query = new CGI;

$thecookie1 = $query->cookie(-name=>'nuser',
			    					  -value=>$username,
			    					  -expires=>'+24h',
			    					  -path=>'/');

$thecookie2 = $query->cookie(	-name=>'npass',
			    						-value=>$password,
			    						-expires=>'+24h',
			    						-path=>'/');

print $query->header(-cookie=>[$thecookie1, $thecookie2]); 

&print_top;


### CHECK IF THERE ARE LINKS INSIDE THE DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT count(*) FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - $sql";}
while ( @row = $sth->fetchrow() )
	{
	$total_links = $row[0];
	}

$sth->finish;
$dbh->disconnect;


if ($total_links > 0) 
	{ 
print qq[<p><font face="Arial" size="4" color="#0000A0"><strong>Links in Database Found</strong></font></p>

<blockquote>
  <p><font color="#000000" face="Arial" size="2">You currently have <strong>$total_links links 
  inside your database</strong>. If you already imported these 14 000 links then continuing
  would create duplicate links and categories. You can ignore this if you have never
  imported the 14 000 links.</font></p>
  <p><font color="#000000" face="Arial" size="2">Would you like to continue?</font></p>
</blockquote>

<blockquote>
  <form method="POST" action="$admin_url/setup.cgi">
    <input type="hidden" name="fct" value="import2"><p><input type="submit" value="   Yes   "
    name="B1"><input type="submit" value="   No   " name="B2"></p>
  </form>
</blockquote>
</body>
</html>
];	
	}
	else
	{

print qq[<p><font face="Arial" size="4" color="#0000A0"><strong>Import 14 000 Links</strong></font></p>

<blockquote>
  <p><font color="#000000" face="Arial" size="2">Please note that it can take several
  minutes to import the links and categories.</font></p>
  <p><font color="#000000" face="Arial" size="2"><strong>Please do not close the browser
  window.</strong></font></p>
</blockquote>

<blockquote>
  <form method="POST" action="$admin_url/setup.cgi">
    <input type="hidden" name="fct" value="import2"><p><input type="submit"
    value="Import Links" name="B1"></p>
  </form>
</blockquote>
</body>
</html>];
	
	}


}








sub create_tables
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#$wsql = "SHOW TABLES FROM $db_name";
$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "links") { $links_tbl_found = "True"; }
	if ($row[0] eq "dirs") { $dirs_tbl_found = "True"; }
	if ($row[0] eq "reviews") { $rv_tbl_found = "True"; }
	if ($row[0] eq "modified") { $md_tbl_found = "True"; }
	if ($row[0] eq "keywlog") { $kwlog_tbl_found = "True"; }
	if ($row[0] eq "bannergrp") { $bannergrp_tbl_found = "True"; }
	if ($row[0] eq "banners") { $banners_tbl_found = "True"; }
	if ($row[0] eq "balogs") { $balogs_tbl_found = "True"; }
	if ($row[0] eq "brokenlnks") { $brokenlnk_tbl_found = "True"; }
	if ($row[0] eq "brokenlnks2") { $brokenlnk_tbl_found2 = "True"; }
	if ($row[0] eq "lnkusers") { $lnkusers_tbl_found = "True"; }
	if ($row[0] eq "crawlcats") { $crawlcats_tbl_found = "True"; }
	if ($row[0] eq "crawlresults") { $crawlresults_tbl_found = "True"; }	
	
	if ($row[0] eq "blocklog") { $blocklog_tbl_found = "True"; }	
	if ($row[0] eq "spamfilter") { $spamfilter_tbl_found = "True"; }	
	if ($row[0] eq "exaddurl") { $exaddurl = "True"; }	
	if ($row[0] eq "paypalpremium") { $paypalpremium = "True"; }
	if ($row[0] eq "addurliplog") { $foundiplog = "True"; }
	}


if ($foundiplog ne "True")
	{
		$sql = "CREATE TABLE addurliplog
							(
							ipid					int NOT NULL auto_increment,
							lnkid					int,
							ip						varchar(255),
							hostname				varchar(255),
							rem_ident			varchar(255),
							http_user_agent	varchar(255),
							http_referer		varchar(255),

							PRIMARY KEY(ipid),
							INDEX (lnkid), 
							INDEX (ip)
							)";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}  	
	}



if ($paypalpremium ne "True")
	{


			$sql = "CREATE TABLE paypalpremium
									(
									transid				int NOT NULL auto_increment,
									lnkid					int,
									userid				int,
									TIMESTAMP			date,
									CORRELATIONID		varchar(255),
									TOKEN					varchar(255),
									EMAIL					varchar(255),
									PAYERID				varchar(255),
									PAYERSTATUS			varchar(255),
									FIRSTNAME			varchar(255),
									LASTNAME				varchar(255),
									COUNTRYCODE			varchar(255),
									BUSINESS				varchar(255),
									PAYMENTREQUEST_0_SHIPTONAME				varchar(255),
									PAYMENTREQUEST_0_SHIPTOSTREET				varchar(255),
									PAYMENTREQUEST_0_SHIPTOCITY				varchar(255),
									PAYMENTREQUEST_0_SHIPTOSTATE				varchar(255),
									PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE		varchar(255),
									PAYMENTREQUEST_0_SHIPTOCOUNTRYNAME		varchar(255),
									PAYMENTREQUEST_0_SHIPTOZIP					varchar(255),
									PAYMENTREQUEST_0_ADDRESSID					varchar(255),
									PAYMENTREQUEST_0_ADDRESSSTATUS			varchar(255),
									
									A_TIMESTAMP				date,
									A_CORRELATIONID		varchar(255),
									A_TOKEN					varchar(255),
									A_PAYMENTREQUEST_0_TRANSACTIONID			varchar(255),
									A_PAYMENTREQUEST_0_TRANSACTIONTYPE		varchar(255),
									A_PAYMENTREQUEST_0_PAYMENTTYPE			varchar(255),
									A_PAYMENTREQUEST_0_ORDERTIME				varchar(255),
									A_PAYMENTREQUEST_0_AMT						varchar(255),
									A_PAYMENTREQUEST_0_CURRENCYCODE			varchar(255),
									A_PAYMENTREQUEST_0_TAXAMT					varchar(255),
									A_PAYMENTREQUEST_0_PAYMENTSTATUS			varchar(255),
									A_PAYMENTREQUEST_0_PENDINGREASON			varchar(255),
									A_PAYMENTREQUEST_0_REASONCODE				varchar(255),
									paymentcomplete								varchar(1),
									
									ext1	varchar(255),
									ext2	varchar(255),
									ext3	varchar(255),
									ext4	varchar(255),
									ext5	varchar(255),
									
									PRIMARY KEY(transid),	
									INDEX (lnkid), 
									INDEX (userid), 
									INDEX (EMAIL),
									INDEX (PAYERID),
									INDEX (paymentcomplete)
									)";
		
					$sth = $dbh->prepare($sql);
					$sth->execute;
					$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}  
	
	
	}


if ($exaddurl ne "True")
	{
	$sql = "CREATE TABLE exaddurl
							(
							id				int NOT NULL auto_increment,
							lnkid			int,
							formname		varchar(255),
							tmpwork		int,
							PRIMARY KEY(id),
							INDEX (lnkid), 
							INDEX (formname),
							INDEX (tmpwork)
							)";

			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}  
	}



if ($spamfilter_tbl_found ne "True")
	{

	$sql = "CREATE TABLE spamfilter
					(
					spid				int NOT NULL auto_increment,
					criteria			varchar(255),
					typefilter		varchar(1),
					matchtype		varchar(1),
					
					PRIMARY KEY(spid),
					UNIQUE (criteria),
					INDEX (criteria),
					INDEX (typefilter)
					)";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 		
	
	}


if ($blocklog_tbl_found ne "True")
	{

	$sql = "CREATE TABLE blocklog
					(
					bid				int NOT NULL auto_increment,
					title				varchar(255),
					description		varchar(255),
					keywords			varchar(255),
					url				varchar(255),
					email				varchar(255),
					contact			varchar(255),
					add_date			date,
					ip					varchar(50),
					reason			text,
					ext1				varchar(255),
					ext2				varchar(255),
					
					PRIMARY KEY(bid)
					)";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
		
	}



if ($crawlresults_tbl_found ne "True")
	{

	$sql = 			  "CREATE TABLE crawlresults
							(
							resid				int NOT NULL auto_increment,
							ccid				int,
							title				varchar(255),
							description		text,
							keywords			varchar(255),
							url				varchar(255),
							
							PRIMARY 	KEY(resid),
							INDEX (ccid)
							) "; # TYPE=MyISAM
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	}


if ($crawlcats_tbl_found ne "True")
	{
	$sql = 			  "CREATE TABLE crawlcats
							(
							ccid			int NOT NULL auto_increment,
							catname		varchar(255),
							linksnumber int,

							PRIMARY 	KEY(ccid)
							)  "; #TYPE=MyISAM
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	}



if ($lnkusers_tbl_found ne "True")
	{

	$sql = 			  "CREATE TABLE lnkusers
							(
							userid			int NOT NULL auto_increment,
							rgsuser			varchar(255),
							rgspass			varchar(255),
							rgsname			varchar(255),
							rgsemail			varchar(255),
							rgs_extra1     varchar(255),
							rgs_extra2     varchar(255),
							rgs_extra3     varchar(255),
							rgs_extra4     varchar(255),
							rgs_extra5     varchar(255),
							rgs_extra6     varchar(255),
							rgs_extra7     varchar(255),
							rgs_extra8     varchar(255),
							rgs_extra9     varchar(255),
							rgs_extra10    varchar(255),
							activated		varchar(1),
							subscribed		varchar(1),
							fbid				varchar(1),

							PRIMARY 	KEY(userid),
							INDEX (rgsuser),
							INDEX (rgspass),
							INDEX (rgsname),
							INDEX (rgsemail),
							INDEX (activated),
							INDEX (fbid)
							)";
							

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
		

	}




if ($brokenlnk_tbl_found ne "True")
	{
	
	$sql = 			  "CREATE TABLE brokenlnks
							(
							brid			int NOT NULL auto_increment,
							lnkid			int,
							cid			int,
							lnkproblem	varchar(255),
							lnknotes		text,

							PRIMARY 	KEY(brid)
							)  "; #TYPE=MyISAM
							

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	}


if ($brokenlnk_tbl_found2 ne "True")
	{
	
	$sql = 			  "CREATE TABLE brokenlnks2
							(
							brid			int NOT NULL auto_increment,
							lnkid			int,
							cid			int,
							lnkproblem	varchar(255),
							problemid	varchar(255),

							PRIMARY 	KEY(brid)
							)  "; #TYPE=MyISAM

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	}





if ($balogs_tbl_found ne "True")
	{
		$sql = 			  "CREATE TABLE balogs
								(
								logid			int NOT NULL auto_increment,
								statdate		date,
								groupid		int,
								bid			int,
								impressions	int,
								clicks		int,
								PRIMARY 	KEY(logid),
								INDEX (statdate),
								INDEX (groupid),
								INDEX (bid),
								INDEX (impressions),
								INDEX (clicks)
								)";
							

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	}


if ($banners_tbl_found ne "True")
	{
		$sql = 			  "CREATE TABLE banners
								(
								bid				int NOT NULL auto_increment,
								groupid			int,
								bname				varchar(255) NOT NULL,
								image				varchar(255),
								link				varchar(255),
								weight			int,
								
								PRIMARY 	KEY(bid),
								INDEX (groupid),
								INDEX (bname)
								)";

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	
	}



if ($bannergrp_tbl_found ne "True")
	{
	$sql = 			  "CREATE TABLE bannergrp
							(
							groupid			int NOT NULL auto_increment,
							groupname		varchar(255) NOT NULL,
							maximp			int,
							expirdate		date,
							username			varchar(255),
							password			varchar(255),
							current_imp		int,
							current_clc    int,
							bwidth			int,
							bhieght			int,
							userchange		char(1),
							
							PRIMARY 	KEY(groupid),
							INDEX (groupname),
							INDEX (maximp),
							INDEX (expirdate),
							INDEX (username),
							INDEX (password)
							)";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	}



if ($kwlog_tbl_found ne "True")
	{

	$sql = 				  "CREATE TABLE keywlog (
								keywid			int NOT NULL auto_increment,
								kwdate 			date,
								keyword			varchar(255),
								
								PRIMARY 	KEY(keywid), 
								INDEX (kwdate),
								INDEX (keyword)
							)";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	}

####

if ($md_tbl_found ne "True")
	{

	$sql = 				  "CREATE TABLE modified (
								mdfid				int NOT NULL auto_increment,
								lnkid 			int,
								cid				int,
								
								title				varchar(255) NOT NULL,
								description		text,
								keywords			varchar(255),
								url				varchar(255),
								name				varchar(100),
								email				varchar(255),
								urldate			int,
								lnkpassword		varchar(50),
								notes				text,

								PRIMARY 	KEY(mdfid), 
								INDEX (lnkid),
								INDEX (cid)
							)";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	}



if ($rv_tbl_found ne "True")
	{

	$sql = 				  "CREATE TABLE reviews (
								rvid		int NOT NULL auto_increment,
								cid		int,
								lnkid		int,
								rname		varchar(255),
								remail	varchar(255),
								review	text,
								approved varchar(1),
								date		int(11),

								PRIMARY 	KEY(rvid), 
								INDEX (cid),
								INDEX (lnkid),
								INDEX (approved),
								INDEX (date),
								INDEX (rname),
								INDEX (remail),
								INDEX (review(500)),
								FULLTEXT (rname,remail,review)
							) ENGINE=MyISAM"; 

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	}



if ($dirs_tbl_found ne "True")
	{

	$sql = 				  "CREATE TABLE dirs (
								cid		int NOT NULL auto_increment,
								level		int NOT NULL,
								l1			varchar(255),
								l2			varchar(255),
								l3			varchar(255),
								l4			varchar(255),
								l5			varchar(255),
								l6			varchar(255),
								l7			varchar(255),
								l8			varchar(255),
								l9			varchar(255),
								l10		varchar(255),
								l11		varchar(255),
								l12		varchar(255),
								l13		varchar(255),
								l14		varchar(255),
								l15		varchar(255),
								l16		varchar(255),
	
							description	varchar(255),
							keywords		varchar(255),
							linknrs		varchar(255) NOT NULL,
							related1		varchar(255),
							catlock		varchar(1),
							newindate	varchar(255),
							ext1			varchar(255), 
							ext2			varchar(255),
							ext3			varchar(255),
							template		varchar(255),
							shortname	varchar(255) NOT NULL,
							crosslinkid	int,
							addslot1		varchar(255),
							addslot2		varchar(255),
							addslot3		varchar(255),
							addslot4		varchar(255),
							addslot5		varchar(255),
	
							PRIMARY 	KEY(cid), 
							INDEX (level),							
							INDEX (l1),
							INDEX (l2),
							INDEX (l3),
							INDEX (l4),
							INDEX (l5),
							INDEX (l6),
							INDEX (l7),
							INDEX (l8),
							INDEX (l9),
							INDEX (l10),
							INDEX (l11),
							INDEX (l12),
							INDEX (l13),
							INDEX (l14),
							INDEX (l15),
							INDEX (l16),
							INDEX (description),
							INDEX (keywords)
							)";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	
	### ext1 = used for recounting links
	### ext2 = used for cagegory title
	}



if ($links_tbl_found ne "True")
	{
	
	$sql = 			  "CREATE TABLE links (
							lnkid						int NOT NULL auto_increment,
							cid						int NOT NULL,
							title						varchar(255) NOT NULL,
							description				text,
							keywords					varchar(255),
							url						varchar(255),
							image						varchar(255),
							imagelinked				varchar(1),
							name						varchar(100),
							email						varchar(255),
							rating					DOUBLE(10,2),
							votes						int,
							hits						int,
							premium					int,
							modified					varchar(1),
							newsubm					varchar(1),
							userid					int,
							urldate					int,
							
							subscribed				varchar(1),
							csuggest					varchar(255),
							cidsubm					varchar(255),
							subs_expire				int(12),
							
							lnkpassword				varchar(50),
							rev_no					int,
							extf2						int,
							extf3						varchar(255),
							extf4						varchar(255),
							

							PRIMARY KEY(lnkid),
							INDEX (cid),
							INDEX (title),
							INDEX (description(255)),
							INDEX (votes),
							INDEX (hits),
							INDEX (keywords),
							INDEX (url),
							INDEX (email),
							INDEX (userid),
							INDEX (lnkpassword),
							INDEX (urldate),
							INDEX (modified),
							INDEX (newsubm),
							FULLTEXT (title,description,keywords,url,email)
							) ENGINE=MyISAM"; 


							


	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	}

$sth->finish;
$dbh->disconnect;

}






sub verify
{

### CHECK IF CONFIG.CGI IS WRITABLE

$exists = (-w "$config_cgi");
if ($exists < 1)
	{
	$sprblm = "Unable to write to config.cgi - Please ensure that config.cgi situated in your cgi-bin directory is set to the permission setting of 777.";
	&setup_problem($sprblm);
	}


if ($fields{'db_name'} eq "") { &setup_problem("Please supply the name of the MySQL database you are going to use."); }
if ($fields{'db_username'} eq "") { &setup_problem("Please supply the database user name of the MySQL database you are going to use"); }
if ($fields{'db_password'} eq "") { &setup_problem("Please supply the database password of the MySQL database you are going to use"); }


#if ($fields{'web_dir'} eq "") { &setup_problem("Please supply the full server path where generated HTML files should be stored."); }
#if ($fields{'data_dir'} eq "") { &setup_problem("Please supply the full server path to your 'data' directory"); }
#$data_dir = $fields{'data_dir'};


### RECORD PATHS

&write_var("DB_NAME", $fields{'db_name'});
&write_var("DB_USERNAME", $fields{'db_username'});
&write_var("DB_PASSWORD", $fields{'db_password'});
&write_var("MYSQL_HOSTNAME", $fields{'mysql_hostname'});
&write_var("MYSQL_PORT", $fields{'mysql_port'});


$left_step_bar = &get_setup_steps(3); ### STEP 2

&get_setup;

########## VERIFY MYSQL

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}

$red = "<font color=\"#FF0000\">";
$cend = "</font>";
$blue = "<font color=\"#0000FF\">"; 

$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh )
	{
	$connection_result = "$red Failed... $cend $blue Reason: $cend $DBI::errstr - Error Code: $DBI::err";
	$table_creation_result = "$red Failed... $cend $blue Reason: $cend $DBI::errstr";
	$record_creation_result = "$red Failed... $cend $blue Reason: $cend $DBI::errstr";

	@ary = DBI->available_drivers;
	foreach $item (@ary)	
		{
		if (lc($item) eq "mysql") { $adrivers = $adrivers . "$blue <b>$item</b> $cend"; } else {$adrivers = $adrivers . "$item<Br>";}
		}
		
	}
	else
	{
	$connection_result = "$blue OK.. $cend Connection successful";
	
	@ary = DBI->available_drivers;
	foreach $item (@ary)	
		{
		if (lc($item) eq "mysql") { $adrivers = $adrivers . "$blue <b>$item</b> $cend"; } else {$adrivers = $adrivers . "$item<Br>";}
		}
	}


print qq[

<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step4"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>Verifying MySQL Details:</strong></p></td>
        </tr>
        <tr>
          <td width="20%" valign="top" bgcolor="#FFFFFF"><p class="style1">Connection:</p></td>
          <td bgcolor="#FFFFFF" width="80%"><p><strong>$connection_result</strong></p></td>
        </tr>
        <tr>
          <td width="20%" valign="top" bgcolor="#FFFFFF"><p class="style1">Available Drivers:</p></td>
          <td bgcolor="#FFFFFF" width="80%"><p>$adrivers</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="20%"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" width="80%"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1"> 
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>



</body>
</html>
];


}








sub step1
{


$writable = (-w "$config_cgi");
if ($writable < 1)
	{
	$sprblm = "Unable to write to config.cgi - Please ensure that config.cgi situated in your cgi-bin directory is set to the permission setting of 777.";
	&setup_problem($sprblm);
	}




$left_step_bar = &get_setup_steps(2); ### STEP 2


print qq[

<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="verify"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar <p>&nbsp; </td>
      <td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8" colspan="2"><p><strong>MySQL Details:</strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" colspan="2"><p>If you have access to a Hosting Control Panel then it
            will most likely enable you to create a MySQL database. After the database has been
            created (you specify a database name and create it through your Hosting Control Panel) you
            may then assign a User Name and Password so that the database can be accessed by
            applications such as PowerSeek. The creation of a MySQL Database is normally a simple
            process through Hosting Control Panels. Your Hosting Company will very likely also have
            detailed documentation on the creation of a MySQL Database. They may also be able to
            assist you in the creation of a MySQL Database.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>MySQL
            DataBase Name: </strong></font></p></td>
          <td bgcolor="#FFFFFF" valign="top" width="70%"><p><strong>
            <input type="text" name="db_name"
          size="42" value="$db_name"> 
          </strong></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>MySQL
            Database User Name:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><font face="Arial" size="2"><strong>
            <input
          type="text" name="db_username" size="42" value="$db_username"> 
          </strong></font></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>MySQL
            Database Password:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><font face="Arial" size="2"><strong>
            <input
          type="text" name="db_password" size="42" value="$db_password"> 
          </strong></font></p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>MySQL Host
            Name:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><font face="Arial" size="2"><strong>
            <input
          type="text" name="mysql_hostname" size="42" value="$mysql_hostname"> 
          </strong></font></p>
            <p>If
              you are going to use a remote MySQL database on a remote server which is not situated on
              the same machine or server as PowerSeek, specify a host name above and port number below.
              If the MySQL server is on the same machine or server as PowerSeek, just leave the '<strong>MySQL
                Host Name</strong>' and '<strong>MySQL Port</strong>' fields blank. In the majority of
              situations the '<strong>MySQL Host Name</strong>' and '<strong>MySQL Port</strong>' fields
            can just be left blank.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" width="30%" valign="top"><p><font color="#0000FF"><strong>MySQL Port:</strong></font></p></td>
          <td bgcolor="#FFFFFF" width="70%" valign="top"><p><font face="Arial" size="2"><strong>
            <input
          type="text" name="mysql_port" size="42" value="$mysql_port"> 
          </strong></font></p>
            <p>The <strong>default
              port number for MySQL is 3306</strong> which is normally used. If you are leaving the '<strong>MySQL
            Host Name</strong>' field empty, then also leave this field empty.</p></td>
        </tr>
        <tr>
          <td bgcolor="#FFFFFF" valign="top"><p>&nbsp;</p></td>
          <td bgcolor="#FFFFFF" valign="top"><p>
            <input type="submit" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;">
            <input type="submit" value="     Next Step &gt;&gt;     " name="B1">
            
            
          </p></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
</body>
</html>
];

}



sub start
{

$left_step_bar = &get_setup_steps(1); ### STEP 1

print qq[

<form method="POST" action="setup.cgi">
  <input type="hidden" name="fct" value="step1"><table border="0" cellpadding="6"
  cellspacing="1" width="100%">
    <tr>
      <td width="20%" align="center" valign="top">$left_step_bar
        <p>&nbsp;</td><td width="80%" valign="top"><table border="0" cellpadding="10" cellspacing="1"
      width="100%" bgcolor="#DFDFDF">
        <tr>
          <td bgcolor="#F8F8F8"><strong><font face="Arial" size="2" color="#000000">Terms and
          Conditions of Use:</font></strong></td>
        </tr>
        <tr>
          <td align="center" bgcolor="#FFFFFF"><strong><textarea rows="17" name="S1" cols="69"
          style="width:100%">FocalMedia.Net offers PowerSeek to you, conditioned upon your acceptance without your modification of the terms and conditions (&quot;Terms&quot;) set forth herein. FocalMedia.Net reserves the right to change or modify the Terms, or any part thereof, or to impose new conditions. 

By using PowerSeek you indicate your complete and unconditional acceptance of these terms and conditions set forth.

PowerSeek is a copyrighted work of FocalMedia.Net, and protected by the copyright laws and international copyright treaties as well as other intellectual property laws and treaties.

FocalMedia.Net shall have the right to change or discontinue any aspect or feature of PowerSeek without notice, including, but not limited to, features and availability. You agree that FocalMedia.Net shall not be liable to you or to any third party for any such changes.

PowerSeek is distributed 'as is' and 'as available' basis. In no event shall the liability of FocalMedia.Net for any damages, losses, loss of profits, data losses, and/or causes of action exceed the total amount paid by you, a third party or company for this software.

Under no circumstances will FocalMedia.Net be required to provide support directly or indirectly if any source code of PowerSeek has been modified by anyone, other than FocalMedia.Net

A single license enables you to use this program for one domain. You will need a license for each domain you use PowerSeek on. You can install as many instances of PowerSeek on one domain as required, but multiple domains will require multiple licenses.
  
Selling the code for this program without prior written consent from FocalMedia.Net is expressly forbidden. You may not redistribute this program in any shape or form.

All copyright notices in all scripts must stay intact.</textarea></strong><p><strong><font
          face="Arial" size="2" color="#000000"><input type="submit" value="I Agree To The Terms - Next >>"
          name="B1"></font></strong></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
];


}





sub print_bottom
{
print "</body></html>";
}



sub print_top
{

$thetime = time();
($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($thetime);
$year = "20" . substr($year, 1, 2);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek Setup</title>
<style type="text/css">
p {
font-family: Tahoma;
line-height: : 20px;
font-size: 13px;
line-height: 18px;
}

.normaltext {
font-family: Arial;
line-height: : 20px;
font-size: 13px;
line-height: 18px;
}



input {
	border: 1px solid #C0C0C0;
	background-color: #F8F8F8; 
	font-family: tahoma, helvetica, sans-serif;
	font-style: normal;
	color: #000000;
	
}

input:hover {
	border: 1px solid #000000;
	background-color: #dedede; 
	color: #000000;
}

input:focus {
	border: 1px solid #000000;
	background-color: #dedede; 
	color: #000000;
}
 

textarea {
 border: 1px solid #C0C0C0;
 background-color: #dedede;
 background-color: #F8F8F8; 
 color: #000000;
 font-family: tahoma, helvetica, sans-serif;
}

textarea:focus {
	border: 1px solid #000000;
	background-color: #ffffff; 
	color: #000000;
}


select { 
	border: 1px solid #C0C0C0;
	background-color: #F8F8F8; 
	font-family: tahoma, helvetica, sans-serif;
	font-style: normal;
	color: #000000;
}



</style>
</head>
<body>
<p><strong><font face="Arial" size="4"><font color="#000000"><strong>PowerSeek SQL Setup</strong></font><br>
</font></strong><font color="#808080" face="Arial" size="2">PowerSeek SQL Installation &amp;
Configuration Utillity - Copyright 2003-$year FocalMedia.Net</font></p>
<hr size="1" color="#DFDFDF">
];


}





sub get_env
{
if ($ENV{'QUERY_STRING'} ne "") {
								$temp = $ENV{'QUERY_STRING'};
								}
								else
								{
								read(STDIN, $temp, $ENV{'CONTENT_LENGTH'});
								}

@pairs=split(/&/,$temp);

foreach $item(@pairs) {
	($key,$content)=split (/=/,$item,2);
	$content=~tr/+/ /;
	$content=~ s/%(..)/pack("c",hex($1))/ge;
	$fields{$key}=$content;
}

$fields{'comment'}=~s/\cM//g;
$fields{'comment'}=~s/\n\n/<p>/g;
$fields{'comment'}=~s/\n/<br>/g;
}





sub setup_problem
{

my ($sproblem) = @_;

$refe = $ENV{'HTTP_REFERER'};

print qq[
<p><font face="Arial" size="4" color="#0000A0"><strong>Problem</strong></font></p>
<div align="center"><center>

<table border="0" cellpadding="10" cellspacing="0" width="100%" style="border: 1px dotted">
  <tr>
    <td bgcolor="#FFFFFF" width="963" height="17"><font face="Arial" size="2">$sproblem</font></td>
  </tr>
  <tr>
    <td bgcolor="#F4F4F4" width="963" height="17"><font color="#000000" face="Arial"
    size="2"><strong>Use the back button of your browser to go back and correct the problem.</strong></font></td>
  </tr>
</table>
</center></div>
];


&print_bottom;
exit;
}





sub write_var
{

my ($identifier, $write_crit) = @_;

my ($line, $tocheck, $towrite, $idmatch);

$towrite = "";

open (STP, "$config_cgi");

	while (defined($line=<STP>))
		{

		if ($line =~ m/#/g)
			{
			$r = pos($line);
			$tocheck = substr($line, 0, $r - 1);
			}
			else
			{
			$tocheck = $line;
			}
			
		if ($tocheck =~ /^$identifier/)
			{
			$line = "$identifier \"$write_crit\"\n";
			$idmatch = "true";
			}

		$towrite = $towrite . $line;

		}

	##print "$identifier : $idmatch <br>";
	
	if ($idmatch ne "true")
		{
		$towrite = $towrite . "\n\n$identifier \"$write_crit\"\n";
		}

close (STP);


open (STP, "> $config_cgi");
	print STP $towrite;
close (STP);

}










sub get_html_document
{

my ($document) = @_;

my ($EOL, $BLANK, $remote, $rval, @hitems, @ritems, $Rhttpheader, $host, $Rdocdate, $Rserver, $TCPconnect);

 ($host,$port,$document) = $document =~ m@http://([^/:]+)(:\d+)?(.*)@;

 if ($document eq "") {$document = "/";}

 $remote = IO::Socket::INET->new( 
 										Proto => "tcp",
                              PeerAddr  => $host,
                              PeerPort  => "http(80)"
                                 );

        unless ($remote)
        		{
        		$Rhttpheader = "Connection failed when trying to connect to http daemon at $document";
        		$TCPconnect = "False";
        		}

if ($TCPconnect ne "False")
	{
   
   $remote->autoflush(1);

	print $remote "GET $document HTTP/1.0\r\n";
	print $remote "Host: $host\r\n";
	print $remote "\r\n";
	
  		while (defined($line=<$remote>))
 			{
			$rval = $rval . $line;
  			}
      close $remote;

@ritems = split(/\n/,$rval);
$Rhttpheader = $ritems[0];
$Rdocdate = $ritems[1];
$Rserver = $ritems[2];
	}

$Rdocument = $document;
$Rehost = $host;

$REMR1 = "GET $document HTTP/1.0";
$REMR2 = "Host: $host";

return ($rval, $Rhttpheader, $Rdocdate, $Rserver, $Rdocument);

}





sub get_file_contents2
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

if ((-e "$filename") > 0) 
	{
$filesize = (-s "$filename");
open (TFILECNTS, "$filename") || die "$filename";
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
	}

return ($thefile);

}



sub pathinfo
{


#### GET PERL VERSION

$perl_version = "$]";

#### DETERMINE OPERATING SYSTEM

if ((-d "/etc") > 0)
	{
	$operating_system = "Unix/Linux";
	}
	elsif ((-d "c:/") > 0)
	{
	$operating_system = "Windows";
	}
	else
	{
	$operating_system = "Unknown";
	}

#####

$envtable = qq[
<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="#000000">
  <tr>
    <td width="100%" bgcolor="#FFDF2D" colspan="2"><font face="Arial" size="4" color="#000000"><strong>Environment
    Variables</strong></font></td>
  </tr>
];



foreach $key (keys(%ENV)) 
	{
	if ($key !~ /cookie/i)
		{
	
$envtable = $envtable  . qq[
	<tr>
	    <td width="22%" bgcolor="#F2F2F2"><font face="Arial" size="2">$key</font></td>
	    <td width="78%" bgcolor="#FFFFFF"><font face="Arial" size="2">$ENV{$key}</font></td>
  </tr>
];

		}
	}

$envtable = $envtable  . "</table>";

########################################################

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Details</title>
</head>
<body>
<p><strong><font face="Arial" size="4" color="#000000">Perl Version: </font><font
face="Arial" size="4" color="#FF8000">$perl_version</font><font face="Arial" size="4"
color="#000000"><br>
Operating System: </font><font face="Arial" size="4" color="#FF8000">$operating_system</font></strong></p>
$envtable
</body>
</html>
];


}



sub get_setup_steps
{

my ($step_number) = @_;


@font_color = ("#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0","#C0C0C0");
$font_color[$step_number] = "#0000FF";


$font_bold[$step_number] = "<b>";
$font_bold2[$step_number] = "</b>";


$ret_side_bar = qq[

<table border="0" cellpadding="10" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td bgcolor="#F8F8F8"><p><strong>Setup Steps: </strong></p></td>
  </tr>
  <tr>
    <td align="center" bgcolor="#FFFFFF"><p>
    
    <font color="$font_color[1]"><strong><font face="Arial" size="4">Step 1 </font></strong><br></font>
    <font color="$font_color[1]">$font_bold[1] Terms &amp; Conditions of Use $font_bold2[1]</font>
    
    <br><br>
    
    <font color="$font_color[2]"><strong><font face="Arial" size="4">Step 2 </font></strong><br></font>
    <font color="$font_color[2]">$font_bold[2] MySQL Details $font_bold2[2]</font>
    <br><br>

    <font color="$font_color[3]"><strong><font face="Arial" size="4">Step 3 </font></strong><br></font>
    <font color="$font_color[3]">$font_bold[3] Verify MySQL Details $font_bold2[3]</font>
    <BR><BR>
    
    <font color="$font_color[4]"><strong><font face="Arial" size="4">Step 4 </font></strong><br></font>
    <font color="$font_color[4]">$font_bold[4] URL Paths $font_bold2[4]</font>
    <BR><BR>
    
    <font color="$font_color[5]"><strong><font face="Arial" size="4">Step 5 </font></strong><br></font>
    <font color="$font_color[5]">$font_bold[5] Verify URL Paths $font_bold2[5]</font>
    <br><br>
    
    <font color="$font_color[6]"><strong><font face="Arial" size="4">Step 6 </font></strong><br></font>
    <font color="$font_color[6]">$font_bold[6] Full Server Paths $font_bold2[6]</font>
    <br><br>

    <font color="$font_color[7]"><strong><font face="Arial" size="4">Step 7 </font></strong><br></font>
    <font color="$font_color[7]">$font_bold[7] Verify Full Server Paths $font_bold2[7]</font>
    <br><br>

    <font color="$font_color[8]"><strong><font face="Arial" size="4">Step 8 </font></strong><br></font>
    <font color="$font_color[8]">$font_bold[8] Email Configuration $font_bold2[8]</font>
    <br><br>

    <font color="$font_color[9]"><strong><font face="Arial" size="4">Step 9 </font></strong><br></font>
    <font color="$font_color[9]">$font_bold[9] Email Verification $font_bold2[9]</font>
    <br><br>
    
    <font color="$font_color[10]"><strong><font face="Arial" size="4">Step 10 </font></strong><br></font>
    <font color="$font_color[10]">$font_bold[10] Control Panel User/Pass &amp; Domain Name $font_bold2[10]</font>
    <br><br>
     
    <font color="$font_color[11]"><strong><font face="Arial" size="4">Step 11 </font></strong><br></font>
    <font color="$font_color[11]">$font_bold[11] Complete Setup $font_bold2[11]</font>

    </p></td>
  </tr>
</table>



];


}



sub write_config
{
my ($conf_item, $conf_value) = @_;

open (GSETT, "$data_dir/gsettings.dat");
	@conflines = <GSETT>;
close (GSETT);


$found_item = "";
foreach $ccitem (@conflines)
	{
	($obj, $ident) = split (/=/, $ccitem);
	
		if ($obj eq $conf_item)
			{
			$newfile = $newfile . $conf_item . "=" . $conf_value . "\n";
			$found_item = "true";
			}
			else
			{
			$newfile = $newfile . $ccitem;
			}
	}

#### 
if ($found_item ne "true")
	{
	$newfile = $newfile . $conf_item . "=" . $conf_value . "\n";
	}

open (GSETT, "> $data_dir/gsettings.dat");
	print GSETT $newfile;
close (GSETT);

}



#### GET CONFIGURATION ########################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

if ($line =~ /^MAIL_METHOD/){$mail_method = &get_setup_line($line, MAIL_METHOD);}
if ($line =~ /^SENDMAIL/){$sendmail = &get_setup_line($line, SENDMAIL);}
if ($line =~ /^SMTP_SERVER/){$smtp_server = &get_setup_line($line, SMTP_SERVER);}

if ($line =~ /^SMTP_USER/){$smtp_user = &get_setup_line($line, SMTP_USER);}
if ($line =~ /^SMTP_PASS/){$smtp_pass = &get_setup_line($line, SMTP_PASS);}

if ($line =~ /^PRIMEMAIL/){$prim_email = &get_setup_line($line, PRIMEMAIL);}

if ($line =~ /^FROMWHOM/){$whom_email = &get_setup_line($line, FROMWHOM);}

			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

