#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print "Content-type: text/html\n\n";

$template = $q->param('t');

if ($q->param('fct') eq "how_to_edit") {&how_to_edit; exit;}
if ($q->param('fct') eq "manual_edit") {&manual_edit; exit;}
if ($q->param('fct') eq "images") {&images; exit;}


##############################################################################

sub images
{

print qq[<hr size="1" color="#DFDFDF">

<p><font face="Verdana" size="2"><strong>How to use Images in Templates</strong></font></p>

<p><font face="Verdana" size="2">Templates are used in conjunction with all aspects of
displaying your Forums to users . Each template consists of HTML code with <strong>variable
words</strong> that is used <strong>in combination with each other</strong>. These <strong>variable
words</strong> are enclosed by <strong>!!</strong> <strong>characters</strong>. For
example: <strong>!!date!!</strong>. Most of these variables words need to be present to do
a certain task. These variable words are replaced by data when displayed to end users
viewing your directory.<br>
<br>
One of the easiest ways to understand how templates work is to play around with the HTML
code of the templates: Open the HTML templates with your web editor or copy and paste the
HTML code into your web editor and start editing. Experiment with the templates and try
different combinations. You'll be surprised with what you can come up. The templates gives
you total control on the look and feel of your Search Engine and Directory.<br>
<br>
<strong>Note that when you make use of images in the HTML code of templates, you must use
a URL link to indicate their locations.</strong></font></p>

<p><font face="Verdana" size="2"><strong>For example:<br>
</strong><br>
<strong>&lt;img src=&quot;someimage.gif&quot;&gt;</strong> will not work.<br>
<br>
You have to indicate the entire URL where <strong>someimage.gif</strong> is located. For
example:<br>
<br>
<strong>&lt;img src=&quot;$web_url/someimage.gif&quot;&gt;</strong><br>
<br>
The <strong>&lt;img</strong> is an HTML tag indicating that you want to insert an image in
the HTML page. The <strong>src=</strong> part indicates that you want to specify the
location of the image to be inserted. Some Web Editors will support inserting images from
a web url and some won't. If your web editor does not support this, insert the image into
the HTML page like usual and, when finished, edit the the HTML source code and manually
insert the URL path's to the images. Ensure that the images are on the server/host for the
URL path's you specify.<br>
<br>
<strong>Example: </strong></font></p>

<p><font face="Verdana" size="2"><strong>Editing the HTML source code:<br>
</strong><br>
Replace <strong>&lt;img src=&quot;someimage.gif&quot;&gt; </strong></font></p>

<p><font face="Verdana" size="2">with:</font></p>

<p><font face="Verdana" size="2"><strong>&lt;img
src=&quot;$web_url/someimage.gif&quot;&gt;</strong></font></p>

<a name="1"></a>
];

}


sub manual_edit
{

print qq[<hr size="1" color="#DFDFDF">

<strong>

<p><font face="Verdana" size="2">How to manually edit this template: (or HTML file)</font></strong></p>

<p><font face="Verdana" size="2">SiteNet BBS uses no HTML code of it's own. It obtains all
the HTML code it uses from ordinary HTML files. It then uses these ordinary HTML files to
'skin' all displays that end users see. This functionality gives you the ability to
customize the look and feel exactly like you would like it to look like and makes all
displays 100% customizable.</font></p>

<p><font face="Verdana" size="2">You can manually open this Template (It's a normal HTML
file) with your favorite HTML editor and edit it.<br>
It is located on your web host here:<br>
<strong>$data_dir/$template.html</strong></font></p>

<p><font face="Verdana" size="2">All templates used are normal HTML files and are located
inside SiteNet BBS's 'data' directory. The SiteNet BBS 'data' directory is situated here:<br>
<strong>$data_dir</strong></font></p>
<a name="1"></a>
];


}


sub how_to_edit
{

print qq[<hr size="1" color="#DFDFDF">

<p><strong><font face="Verdana" size="2">How to Edit Templates:</font></strong></p>

<p><font face="Verdana" size="2">SiteNet BBS uses no HTML code of it's own. It obtains all
the HTML code it uses from ordinary HTML files. It then uses these ordinary HTML files to
'skin' all displays that end users see. This functionality gives you the ability to
customize the look and feel exactly like you would like it to look like and makes all
displays 100% customizable.</font>

<ul>
  <li><font face="Verdana" size="2">Copy and paste the HTML code of this template into your
    web editor to edit it. When finished, copy and paste the HTML code back.<br>
    &nbsp; </font></li>
  <li><font face="Verdana" size="2">You may also manually open this Template (It's a normal
    HTML file) with your favorite HTML editor and edit it. The file is located here:<br>
    <strong>$data_dir/$template.html</strong></font></li>
</ul>
<a name="1"></a>
];

}