#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$version = "2.0";
$debug = "OFF";
$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################



$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}



#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print $q->header();

if ($q->param('fct') eq "moderate") {&moderate_start; exit;}
if ($q->param('fct') eq "approve_msgs") {&approve_msgs; exit;}

###############################################################

sub approve_msgs
{

my ($cid, $fid, $fcatname, $forname, $moderf, @mlines, @mdlines, $selval, $item, $selected, $modcrit, $topicfile, 
    $tline, @ititems, $acount, @topics, $msgfile, @msgs, $mline, @mits, $mcount, $statfile, @stats);

$cid = $q->param('cid');
$fid = $q->param('fid');

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);

$topicfile = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@topics = split (/\n/, $topicfile);

$statfile = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@stats = split (/\n/, $statfile);

$mcount = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/mtopics.cnt");



$moderf = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
@mlines = split (/\n/, $moderf);

### (@NEW_TOPICS, @MESSAGES_TO_APPROVE) = APPROVETOPICS($CID, $FID);

foreach $item (@mlines)
	{
		@mdlines = split (/\t/, $item);
		### 0 TOPIC ID
		### 1 REPLY NUMBER
		### 2 USER
		### 3 MESSAGE TOPIC	 
		### 4 DATE TIME	 
		### 5 POLL
		
		$selval = "T_" . $mdlines[0] . "_" . $mdlines[1];
		
		if ($q->param($selval) eq "Y") ### IF MESSAGES SELECTED
			{
			$selected = "true";
			
				### IF TOPIC/POLL SELECTED SET TOPICS TO APPROVED
				if ($mdlines[1] == 0)
					{
						$acount = 0;
						foreach $tline (@topics)
							{
							@ititems = split(/\t/, $tline);
						
							if ($ititems[0] == $mdlines[0])
								{
								if ($q->param('B1') eq "Delete")
									{
									$topics[$acount] = "TO:DELETE:THIS";
									$stats[$acount] = "TO:DELETE:THIS";
									
									$del_appr_stat = "Message(s) discarded";
									}
									else
									{
									$topics[$acount] = $ititems[0] ."\t". 
															 $ititems[1] ."\t". 
															 $ititems[2] ."\t". 
															 $ititems[3] ."\t". 
															 $ititems[4] ."\t".
												 		    $ititems[5] ."\t". 
												 		    $ititems[6] ."\t". 
												 		    $ititems[7] ."\t". 
												 		    $ititems[8] ."\t". 
												 		    "N" 			 ."\t".
												 		    $ititems[10];
									$del_appr_stat = "Messages Approved For Display in Forum";
									}
								}
							$acount++;
							}
					
					}

				### SET MESSAGES APPROVED IN 'ID'.DAT
				$msgfile = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/$mdlines[0].dat");
				@msgs = split (/\n/, $msgfile);
				$acount = 0;

				if ($mdlines[5] ne "POLLQ123")
				{
					open (TWRITE, "> $data_dir/$cid/$fid/$mdlines[0].dat");
					 if ($flocking ne "No"){flock (TWRITE,2);}
					
					   foreach $mline (@msgs)
						{
						
						if ($mdlines[1] == $acount)
							{
							if ($q->param('B1') ne "Delete")
								{
								@mits = split (/\t/, $mline);
								print  TWRITE  $mits[0] ."\t". 
													$mits[1] ."\t". 
													$mits[2] ."\t". 
													$mits[3] ."\t". 
													$mits[4] ."\t".
												   $mits[5] ."\t". 
												   $mits[6] ."\t". 
												   $mits[7] ."\t". 
												   $mits[8] ."\t". 
												   "N" . "\t" .
												   $mits[10] . "\n";

									if ($mdlines[1] != 0)
									{												   
									sn_netbadmin::write_stats($cid, $fid, $mdlines[0], "1", "0", $mits[6], $mits[1]);
									}
								
								}
							$mcount = $mcount - 1;
							}
							else
							{
							print TWRITE $mline . "\n";
							}
						$acount++;
						}
				 
					  if ($flocking ne "No"){flock (TWRITE,8);}
					 close (TWRITE);
				}
				elsif ($q->param('B1') eq "Delete")
				{
				unlink("$data_dir/$cid/$fid/$mdlines[0].dat");
				$mcount = $mcount - 1;
				}
				else
				{
				$mcount = $mcount - 1;
				}
				
				 
				 ## IF MESSAGE FILE IS EMPTY
				 $msgfile = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/$mdlines[0].dat");
				 if ($msgfile eq "") 
				 		{
				 		unlink("$data_dir/$cid/$fid/$mdlines[0].dat");
				 		unlink("$data_dir/$cid/$fid/$mdlines[0].cnt");
				 		}

			}
			else
			{
			### MODIFY ENTRIES LEFT
			$modcrit = $modcrit . $item . "\n";
			}
		
	}


if ($selected ne "true")
		{
		sn_netbadmin::errorbox("Please select a message for display in the forum."); exit;
		}
		else ### WRITE DATA
		{
		## MODERATE ENTRIES LEFT
		open (TWRITE, "> $data_dir/$cid/$fid/moderate.dat");
	    if ($flocking ne "No"){flock (TWRITE,2);}
		  print TWRITE $modcrit;
 		 if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);

		## WRITE EDITED TOPICS.DAT
		open (TWRITE, "> $data_dir/$cid/$fid/topics.dat");
	   if ($flocking ne "No"){flock (TWRITE,2);}
			foreach $item (@topics)
				{
				if ($item !~ /TO:DELETE:THIS/)
					{
					print TWRITE $item . "\n";
					}
				}
		if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);
		
		## UPDATE TSTATS.DAT IF DELETE
		if ($q->param('B1') eq "Delete")
			{
			open (TWRITE, "> $data_dir/$cid/$fid/tstats.dat");
		   if ($flocking ne "No"){flock (TWRITE,2);}
				foreach $item (@stats)
					{
					if ($item !~ /TO:DELETE:THIS/)
						{
						print TWRITE $item . "\n";
						}
					}
			if ($flocking ne "No"){flock (TWRITE,8);}
			close (TWRITE);
			}
		
		
		## MODERATOR COUNT MSG
		open (TWRITE, "> $data_dir/$cid/$fid/mtopics.cnt");
	   if ($flocking ne "No"){flock (TWRITE,2);}
			print TWRITE $mcount;
		if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);


#$scripts_admin/sn_admin3.cgi?fct=moderate&cid=$cid&fid=$fid

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_moder.gif", "$del_appr_stat", qq[
<p><a href="http://" onClick="self.close();return false">Close This Window</a> | <a
href="$scripts_admin/sn_admin3.cgi?fct=moderate&cid=$cid&fid=$fid">Approve More Messages</a></p>
]);


print <<END_OF_APP;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>

END_OF_APP
		
		}


}





sub moderate_start
{

my ($cid, $fid, $fcatname, $forname, $topicfile, @topics, $item, @tlines, $msgstatus, $topicds, @tline, @mtopic, $tt, 
    $nodisp, $tcount, $sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst, $modcrypt, $reply_bookmark);

$cid = $q->param('cid');
$fid = $q->param('fid');

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$modcrypt = crypt ($c_username, $mday);


$printcrit = <<END_OF_TOP;
<form method="POST" action="$scripts_admin/sn_admin3.cgi">
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="fct" value="approve_msgs">
  <input type="hidden" name="fid" value="$fid">
END_OF_TOP

############

$topicfile = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/moderate.dat");

@topics = split (/\n/, $topicfile);

$tcount = 0;

foreach $item (@topics)
{
$tcount++;

	 @tlines = split (/\t/, $item);

			### 0 TOPIC ID
			### 1 REPLY NUMBER
			### 2 USER
			### 3 MESSAGE TOPIC	 
			### 4 DATE TIME	 
			### 5 POLL
	
	### IF REPLY
	if ($tlines[1] > 0)
		{
		
		### PREPARE TOPIC HEADING
		$nodisp = "";
		
		foreach $tt (@mtopic)
			{
			if ($tt == $tlines[0])
				{
				$nodisp = "true";
				}
			}

			if ($nodisp ne "true")
				{
$topicds = $topicds . <<END_OF_MAIN;
<hr size="1" color="#EEEEEE"><font face="Verdana" size="1">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
<img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all" target="_blank"><b>$tlines[3]</b></a></font><br>
END_OF_MAIN
				push(@mtopic, $tlines[0]);
				}

		
		### PREPARE REPLY
		
			$msgstatus =  "T" . "_" . 
 	 					$tlines[0] . "_" . ### TOPIC ID
	 					$tlines[1];  ### REPLY NUMBER
			
			$reply_bookmark = $tlines[1] + 1;
			
$topicds = $topicds . <<END_OFREP;
<input type="checkbox" name="$msgstatus" value="Y"><font face="Verdana" size="1">
&nbsp;<img src="$web_url/sn_dire.gif"><img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all#$reply_bookmark" target="_blank"><b>Reply $tlines[1]</b></a> by <b>$tlines[2]</b></font><br>
END_OFREP

		}
		else ### IF TOPIC
		{

		$msgstatus =  "T" . "_" . 
 					$tlines[0] . "_" . ### TOPIC ID
 					$tlines[1];  ### REPLY NUMBER


if ($tlines[5] eq "POLLQ123")
	{
$topicds = $topicds . <<END_OF_MAIN0;
<hr size="1" color="#EEEEEE"><font face="Verdana" size="1"><input type="checkbox" name="$msgstatus" value="Y">
<img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumpr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt" target="_blank">
<b>$tlines[3]</b></a> <img src="$web_url/sn_poll.gif">  by <b>$tlines[2]</b></font><br>
END_OF_MAIN0
	}
	else
	{
$topicds = $topicds . <<END_OF_MAIN;
<hr size="1" color="#EEEEEE"><font face="Verdana" size="1"><input type="checkbox" name="$msgstatus" value="Y">
<img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all" target="_blank"><b>$tlines[3]</b></a>  by <b>$tlines[2]</b></font><br>
END_OF_MAIN
	}

		}


}

$printcrit = $printcrit . $topicds;

if ($tcount > 0)
	{
	$printcrit = $printcrit . "<br> <input type=\"submit\" value=\"Approve\" name=\"B1\"
			 style=\"font-family: Arial; font-size: 8pt\"> <input type=\"submit\" value=\"Delete\" name=\"B1\"
			 style=\"font-family: Arial; font-size: 8pt\"> </body></html>";
	}
	else
	{
	$printcrit = $printcrit . qq[
	No messages currently needs approval for display.
	];
	}


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_moder.gif", "Approve Messages For Display in Forum:", qq[
$fcatname > $forname<BR><BR>
$printcrit
</form>
]);


print qq[<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}


