#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$version = "2.0";
#$debug = "ON";
$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}



#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print $q->header();

if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "gsettings") {&gsettings; exit;}
if ($q->param('fct') eq "customizeboards") {&customizeboards; exit;}
if ($q->param('fct') eq "save_cust") {&save_cust; exit;}

if ($q->param('fct') eq "modnames") {&modnames; exit;}
if ($q->param('fct') eq "save_modnames") {&save_modnames; exit;}

if ($q->param('fct') eq "emailcust") {&emailcust; exit;}
if ($q->param('fct') eq "edit_email") {&edit_email; exit;}
if ($q->param('fct') eq "save_email") {&save_email; exit;}

if ($q->param('fct') eq "sfriendly") {&sfriendly; exit;}
if ($q->param('fct') eq "save_seo") {&save_seo; exit;}



###############################################################

sub save_seo
{

$seof = $q->param('seof');

if ($seof eq "Y")
	{
	$wval = "SEO_ENABLED";
	}
	else
	{
	$wval = "DISABLED";
	}

open (SF, "> $data_dir/sn_friendly.dat");
print SF $wval;
close (SF);

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_search.gif", "Setting Saved", qq[
<a href="$scripts_admin/sn_admin4.cgi?fct=sfriendly">Click Here to Continue</a>
]);

print qq[
<html>
<head>
<title></title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
]; 

}




sub sfriendly
{

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_search.gif", "Search Engine Friendly URLs", qq[
Adds Search Engine Friendly URLs to your Forums for SEO purposes.
]);


$reffr = $ENV{'HTTP_REFERER'};
#@domain_items = split (/\//, $reffr);
#$yourdomain = "http://" . $domain_items[2];

$reffr =~ s/admin\/sn_admin4\.cgi//gi;
$reffr =~ s/http:\/\///gi;

$tdm = $web_url;
$tdm =~ s/http:\/\///gi;
@domitems = split (/\//, $tdm);

$reffr =~ s/$domitems[0]//gi;
chop($reffr);
$reffr = substr($reffr, 1, length($reffr) - 1);

$surl = $reffr;



$seof = sn_netbadmin::get_file_contents("$data_dir/sn_friendly.dat");

if ($seof eq "SEO_ENABLED")
	{
	$yes_checked = "checked";
	}
	else
	{
	$no_checked = "checked";
	}

$forumurl = "http://$domitems[0]/" . "forumindex.html";


print qq[
<html>
<head>
<title></title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

<form method="POST" action="$scripts_admin/sn_admin4.cgi">
  <input type="hidden" name="fct" value="save_seo"><table width="100%" border="0"
  cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
    <tr>
      <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0"
      cellpadding="6">
        <tr>
          <td background="$web_url/sn_bar6.gif" colspan="2"><font face="Verdana" size="2"><strong
          class="normaltext">Would you like to enable Search Engine Friendly URLs?</strong></font></td>
        </tr>
        <tr>
          <td class="normaltext" align="center" width="1%"><input type="radio" value="Y" name="seof"
          $yes_checked></td>
          <td class="normaltext" width="99%"><font face="Verdana" size="2">Yes, enable Search Engine
          Friendly URLs (Note that you need to follow the instructions below if you enable Search
          Engine Friendly URLs)</font></td>
        </tr>
        <tr>
          <td class="normaltext" align="center" width="1%"><input type="radio" value="N" $no_checked
          name="seof"></td>
          <td class="normaltext" width="99%"><font face="Verdana" size="2">No, don't enable Search
          Engine Friendly URLs</font></td>
        </tr>
        <tr>
          <td class="normaltext" align="center" width="1%"></td>
          <td class="normaltext" width="99%"><input type="submit" value="Save Setting" name="B1"></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
  <table border="0" width="100%" cellspacing="1">
    <tr>
      <td width="100%" height="10"></td>
    </tr>
  </table>
  <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
    <tr>
      <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0"
      cellpadding="6">
        <tr>
          <td background="$web_url/sn_bar6.gif"><font face="Verdana" size="2"><strong
          class="normaltext">Enabling Search Engine Friendly URLs Instructions</strong></font></td>
        </tr>
        <tr>
          <td class="normaltext" width="100%"><blockquote>
            <p><font face="Verdana" size="2"><strong>&nbsp; <br>
            Requirements for Search Engine Friendly URLs to the Forums</strong></font><ul>
              <li><font face="Verdana" size="2">To use Search Engine Friendly URLs you need a host that
                supports .htaccess files. (Most Linux based hosts will support .htaccess files)</font></li>
              <li><font face="Verdana" size="2">You will also need to have an Apache module called
                mod_rewrite enabled. (Most Linux based hosts will also have support for this enabled by
                default. With some hosts you will need to request that this be enabled for you with your
                hosting)</font></li>
            </ul>
            <p><font face="Verdana" size="2"><strong>Step 1 - Enable SiteNet BBS Search Engine
            Friendly URLs</strong></font></p>
            <blockquote>
              <p><font face="Verdana" size="2">Choose to enable Search Engine Friendly URLs above and
              click the 'Save Setting' button.</font></p>
            </blockquote>
            <p><font face="Verdana" size="2"><strong>Step 2 - Create a .htaccess file</strong></font></p>
            <blockquote>
              <p><font face="Verdana" size="2">Create a file called .htaccess with a unix compatible Text Editor like Textpad (can be obtained from textpad.com).</b>
              The file you create needs to have the code displayed in the box below.
              You can copy and paste the code below into the file - no modifications to the code is necessary.   
              <b>Note that you have to save the file in the Unix file format - when saving the file with Textpad there will be a drop down box where you can select the file format.</b></font></p>
            </blockquote>
          </blockquote>
          <div align="center"><center><table border="0" cellspacing="1" width="85%"
          style="border: 1px solid rgb(223,223,223)" cellpadding="10">
            <tr>
              <td width="100%" bgcolor="#FCFCFC"><textarea rows="18" name="S1" cols="51"
              style="width: 100%; font-family: MS Sans Serif; font-size: 8">RewriteEngine on

### TO DISPLAY INDEX PAGE
RewriteRule ^forumindex\\.html\$ /$surl/sn_forum.cgi

### TO DISPLAY TOPICS
RewriteRule ^forum/([a-z]*),([0-9]+),([0-9]+),([0-9]+),([0-9]+) \\
/$surl/sn_forum.cgi?fct=\$1&amp;fid=\$2&amp;cid=\$3&amp;st=\$4&amp;nd=\$5

### TO DISPLAY FORUM CATEGORIES
RewriteRule ^forum/([a-z]*),([0-9]+) \\
/$surl/sn_forum.cgi?fct=\$1&amp;cid=\$2 

### TO DISPLAY TOPICS
RewriteRule ^forum/forumtopic/([0-9]+),([0-9]+),([0-9]+),([0-9]+),([0-9]+),([0-9]+),([0-9]+),([0-9]+) \\
/$surl/sn_forumr.cgi?fid=\$1&amp;cid=\$2&amp;tid=\$3&amp;pg=\$4&amp;sc=\$5&amp;x=\$6&amp;st=\$7&amp;nd=\$8


</textarea></td>
            </tr>
          </table>
          </center></div><blockquote>
            <p><font face="Verdana" size="2"><strong>Step 3 - Upload .htaccess file</strong></font></p>
            <blockquote>
              <p><font face="Verdana" size="2">Now that you have created a file called .htaccess, upload
              it to the root directory of your Public_HTML directory. Your Public_HTML directory is the
              directory that contains the web pages of your web site.</font></p>
            </blockquote>
            <p><font face="Verdana" size="2"><strong>Step 4 - Load the Forums</strong></font></p>
            <blockquote>
              <p><font face="Verdana" size="2">Now load the following URL:<br>
              <a href="http://"><strong><a href="$forumurl" target="_blank">$forumurl</a></strong></a></font></p>
              <p><font face="Verdana" size="2">If you see the Front Page of your Forums then URL
              friendly URLs for your Forums have been implemented.<br>
              &nbsp; </font></p>
            </blockquote>
          </blockquote>
          </td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>



</body>
</html>
];

}



sub save_email
{

$filename = $q->param('f');

if ($q->param('from_name') eq "")		{sn_netbadmin::errorbox("You have to supply a name from whom email is sent."); exit;}
if ($q->param('from_email') eq "")		{sn_netbadmin::errorbox("You have to supply an email address from where email is sent."); exit;}
if ($q->param('email_subject') eq "")	{sn_netbadmin::errorbox("The email needs a subject."); exit;}
if ($q->param('email_message') eq "")	{sn_netbadmin::errorbox("The email needs a message."); exit;}

open (AME, "> $data_dir/$filename");
	print AME $q->param('from_name') . "\n";
	print AME $q->param('from_email') . "\n";
	print AME $q->param('email_subject') . "\n";
	print AME $q->param('email_message') . "\n";
close (AME);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_email1.gif", "Email Saved", qq[
<a href="$scripts_admin/sn_admin4.cgi?fct=emailcust">Click here to continue.</a>
]); 


print qq[
<html>
<head>
<title></title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}




sub edit_email
{

if ($q->param('email') eq "register")
	{
	&edit_email2($q->param('email'), "Editing Registration Email", "This email is sent to users when they register a new account.", 
	qq[<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
  <tr>
    <td width="100%" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"
    colspan="2"><font face="Verdana" size="2"><strong>Variables available inside this email</strong></font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!forum_name!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This
    variable is replaced by the name of your Forums.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!username!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the user name of the user who registered.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!password!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the password of the user who registered.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!forum_web_address!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by a URL to the Forums</font></td>
  </tr>
</table>]
	);
	}
elsif ($q->param('email') eq "psretrieve")
	{
	&edit_email2($q->param('email'), "Editing Password Retrieval Email", "This email is sent to a user requesting that his/her forum password be sent to him/her.",
	qq[
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
  <tr>
    <td width="100%" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"
    colspan="2"><font face="Verdana" size="1"><strong>Variables available inside this email</strong></font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!forum_name!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This
    variable is replaced by the name of your Forums.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!username!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the user name of the user requesting his/her password.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!password!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the password of the user requesting his/her password.</font></td>
  </tr>
</table>]
	);
	}
elsif ($q->param('email') eq "replynotification")
	{
	&edit_email2($q->param('email'), "Editing Notification of Reply", "This email is sent to a user that requested to be notified when a post is made to a topic/reply that he/she posted.",
	qq[<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
  <tr>
    <td width="100%" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"
    colspan="2"><font face="Verdana" size="2"><strong>Variables available inside this email</strong></font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!forum_name!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This
    variable is replaced by the name of your Forums.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!msgtopic!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the topic of the message a reply was posted to.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!forum!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the name of the Forum where a reply was posted.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!topicurl!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by a URL where the topic can be viewed.</font></td>
  </tr>
</table>
]
	);
	}	
elsif ($q->param('email') eq "modnotify")
	{
	&edit_email2($q->param('email'), "Moderator Notifications/Replies", "This email is sent to Moderators or Administrators that requested to receive notifications of new topic posts or replies in the Forums where they
are moderators. The setting to receive notifications can be configured when a Moderator or Administrator clicks the 'Profile' button anywhere from the Forums.
",
	qq[<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
  <tr>
    <td width="100%" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"
    colspan="2"><font face="Verdana" size="2"><strong>Variables available inside this email</strong></font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!forum_name!!</font></strong></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This
    variable is replaced by the name of your Forums.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!forum!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the name of the Forum where a topic/reply was posted.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!posted_by!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the user name of the person that posted the message.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!posted_email!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the email address of the person that posted the message.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!msgtopic!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the subject of the topic</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!message!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by the message that was posted.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!viewlink!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by a URL to view the message that was posted.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!post_reply!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by a URL where a reply can be posted to the message.</font></td>
  </tr>
  <tr>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!edit!!</strong></font></td>
    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
    replaced by a URL where the message can be edited.</font></td>
  </tr>
</table>
]
	);
	}	
elsif ($q->param('email') eq "mvotep")
	{
	&edit_email2($q->param('email'), "Moderator Notifications for New Polls", "This email is sent to Moderators or Administrators that requested to receive notifications of new poll posts in the Forums where they
are Moderators. The setting to receive notifications can be configured when a Moderator or Administrator clicks the 'Profile' button anywhere from the Forums.",
	qq[
	<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
	  <tr>
	    <td width="100%" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"
	    colspan="2"><font face="Verdana" size="2"><strong>Variables available inside this email</strong></font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><strong><font face="Verdana" size="1">!!forum_name!!</font></strong></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This
	    variable is replaced by the name of your Forums.</font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!forum!!</strong></font></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
	    replaced by the name of the Forum where a poll was posted.</font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!posted_by!!</strong></font></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
	    replaced by the user name of the person that posted the poll.</font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!posted_email!!</strong></font></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
	    replaced by the email address of the person that posted the poll.</font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!polltopic!!</strong></font></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
	    replaced by the poll topic.</font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!polldiz!!</strong></font></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
	    replaced by the poll description.</font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!pollanswers!!</strong></font></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
	    replaced by the answers specified for the poll.</font></td>
	  </tr>
	  <tr>
	    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><strong>!!viewlink!!</strong></font></td>
	    <td width="90%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">This is
	    replaced by a URL that can be clicked to view the poll that was posted.</font></td>
	  </tr>
</table>
]
	);
	}	




}



sub edit_email2
{

my ($filename, $heading, $helptext, $extradfk) = @_;

$filename = "sn_" . $filename . ".eml";

$emailmsg = sn_netbadmin::get_file_contents("$data_dir/$filename");

@elines = split (/\n/, $emailmsg);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}


$crit = chr(13); $from_email =~ s/$crit//g; 
$crit = chr(10); $from_email =~ s/$crit//g;
$crit = chr(13); $from_name =~ s/$crit//g; 
$crit = chr(10); $from_name =~ s/$crit//g;


if ($from_email eq "") 
	{
	$settings_txt = sn_netbadmin::get_file_contents("$data_dir/sn_settings.dat");
	(@settings) = split(/\n/, $settings_txt);
	$from_email = $settings[12];
	}
	
if ($from_name eq "") 
	{
	$settings_txt = sn_netbadmin::get_file_contents("$data_dir/sn_settings.dat");
	(@settings) = split(/\n/, $settings_txt);
	$from_name = $settings[11];
	}





$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_email1.gif", "$heading", qq[
$helptext
<BR><a href="$scripts_admin/sn_admin4.cgi?fct=emailcust"><b>Go Back</b></a>
]);



print <<END_OF_EDW;
<html>
<head>
<title>Email</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

<form method="POST" action="$scripts_admin/sn_admin4.cgi">
  <input type="hidden" name="f" value="$filename"><input type="hidden" name="fct" value="save_email">
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="100%" colspan="2" bgcolor="#FFFFFF" class="normaltext"
      background="$web_url/sn_bar6.gif"><font face="Verdana" size="2"><strong>Email Details:</strong></font></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">From Name:
      </font></td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><input
      type="text" name="from_name" size="40" value="$from_name"
      style="width: 100%; font-family: MS Sans Serif; font-size: 8"> $instr </font></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">From
      Email: </font></td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><input
      type="text" name="from_email" size="40" value="$from_email"
      style="width: 100%; font-family: MS Sans Serif; font-size: 8"> </font></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">Email
      Subject: </font></td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><input
      type="text" name="email_subject" size="57" value="$email_subject"
      style="width: 100%; font-family: MS Sans Serif; font-size: 8"> </font></td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana"
      size="1">Message: </font></td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1"><textarea
      rows="24" name="email_message" cols="77"
      style="width: 100%; font-family: MS Sans Serif; font-size: 8">$email_message</textarea> </font></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"><font face="Verdana" size="1"></font></td>
      <td width="85%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="submit"
      value="   Save   " name="B1" style="font-family: MS Sans Serif; font-size: 8"> </font></td>
    </tr>
  </table>
</form>

$extradfk

</body>
</html>

END_OF_EDW

}





sub emailcust
{

$htop = sn_netbadmin::get_heading_box("$web_url/sn_ic_email1.gif", "Customize Email Responses", qq[
Enables you to customize the various email responses sent out by SiteNet BBS.
]);

$hbox = sn_netbadmin::get_heading_box2(qq[<a href="$scripts_admin/sn_admin4.cgi?fct=edit_email&email=register">New User Registration Email</a>], qq[
This email is sent to users when they register a new account.
]);

$hbox2 = sn_netbadmin::get_heading_box2(qq[<a href="$scripts_admin/sn_admin4.cgi?fct=edit_email&email=psretrieve">Password Retrieval</a>], qq[
This email is sent to a user requesting that his/her forum password be sent to him/her.
]);

$hbox3 = sn_netbadmin::get_heading_box2(qq[<a href="$scripts_admin/sn_admin4.cgi?fct=edit_email&email=replynotification">Notification of Reply</a>], qq[
This email is sent to a user that requested to be notified when a post is made to a topic/reply that he/she posted.
]);

$hbox4 = sn_netbadmin::get_heading_box2(qq[<a href="$scripts_admin/sn_admin4.cgi?fct=edit_email&email=modnotify">Moderator Notifications/Replies</a>], qq[
This email is sent to Moderators or Administrators that requested to receive notifications of new topic posts or replies in the Forums where they
are moderators. The setting to receive notifications can be configured when a Moderator or Administrator clicks the 'Profile' button anywhere from the Forums.
]);

$hbox5 = sn_netbadmin::get_heading_box2(qq[<a href="$scripts_admin/sn_admin4.cgi?fct=edit_email&email=mvotep">Moderator Notifications for New Polls</a>], qq[
This email is sent to Moderators or Administrators that requested to receive notifications of new poll posts in the Forums where they
are Moderators. The setting to receive notifications can be configured when a Moderator or Administrator clicks the 'Profile' button anywhere from the Forums.
]);



print qq[<html>
<head>
<title>Email</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body> 
$htop
$hbox
$hbox2
$hbox3
$hbox4
$hbox5
</body>
</html>
];

}



sub save_modnames
{

open (SNM, "> $data_dir/sn_modadm.txt");
print SNM $q->param('adm') . ":::" . $q->param('mod') . ":::" . $q->param('mem');
close (SNM);

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_icmod.gif", "Settings Saved", qq[
<a href="javascript:onClick=window.close()">Close This Window</a>
]);


print qq[<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body> 
$hbox
</body>
</html>
];


}



sub modnames
{

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_icmod.gif", "Moderator/Administrator Names", qq[
Enables you to change the names of Moderators and Administrators. Mainly useful if you create a Forum in another language.
]);

$modadm_data = sn_netbadmin::get_file_contents("$data_dir/sn_modadm.txt");
($adm, $mod, $mem) = split (/:::/, $modadm_data);


print qq[<html>
<head>
<title>Moderator/Administrator Names</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body> 
$hbox

<form method="POST" action="$scripts_admin/sn_admin4.cgi">
  <input type="hidden" name="fct" value="save_modnames"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" bgcolor="#E0E0E0">
    <tr>
      <td width="100%" bgcolor="#F3F3F3" colspan="2" height="30" background="$web_url/sn_bar6.gif"><font
      face="Verdana" size="2"><strong>Moderator/Administrator Names</strong></font></td>
    </tr>
    <tr>
      <td width="20%" bgcolor="#FFFFFF"><font face="Verdana" size="1">Administrator Name/Title:</font></td>
      <td width="80%" bgcolor="#FFFFFF"><input type="text" name="adm" size="28"
      style="font-family: MS Sans Serif; font-size: 8" value="$adm"></td>
    </tr>
    <tr>
      <td width="20%" bgcolor="#FFFFFF"><font face="Verdana" size="1">Moderator Name/Title:</font></td>
      <td width="80%" bgcolor="#FFFFFF"><input type="text" name="mod" size="28"
      style="font-family: MS Sans Serif; font-size: 8" value="$mod"></td>
    </tr>
    <tr>
      <td width="20%" bgcolor="#FFFFFF"><font face="Verdana" size="1">Member Name/Title:</font></td>
      <td width="80%" bgcolor="#FFFFFF"><input type="text" name="mem" size="28"
      style="font-family: MS Sans Serif; font-size: 8" value="$mem"></td>
    </tr>
    <tr>
      <td width="20%" bgcolor="#FFFFFF"></td>
      <td width="80%" bgcolor="#FFFFFF"><input type="submit" value="Save" name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
  </table>
</form>

</body>
</html>
];



}



sub start
{

$globals = sn_netbadmin::get_heading_box("$web_url/sn_ic_settings.gif", 
qq[<a href="$scripts_admin/sn_admin4.cgi?fct=gsettings" onClick="popup('$scripts_admin/sn_admin4.cgi?fct=gsettings',screen.width -200,screen.height -200);return false;">Global Forum Settings</a>], 
qq[Enables you to set various options and settings regarding your forums.]
);

$modsettings = sn_netbadmin::get_heading_box("$web_url/sn_icmod.gif", 
qq[<a href="$scripts_admin/sn_admin4.cgi?fct=modnames" onClick="popup('$scripts_admin/sn_admin4.cgi?fct=modnames',screen.width -200,screen.height -200);return false;">Moderator/Administrator Names</a>], 
qq[Enables you to change the names of Moderators and Administrators. Mainly useful if you create a Forum in another language.]
);

$membertitles = sn_netbadmin::get_heading_box("$web_url/sn_userman2.gif", 
qq[<a href="$scripts_admin/sn_admin.cgi?fct=title_setup" onClick="popup('$scripts_admin/sn_admin.cgi?fct=title_setup',screen.width -200,screen.height -200);return false;">Member/Moderator/Administrator Title Configuration</a>], 
qq[Enables you to set various options and settings regarding your forums.]
);

$emailres = sn_netbadmin::get_heading_box("$web_url/sn_ic_email1.gif", 
qq[<a href="$scripts_admin/sn_admin4.cgi?fct=emailcust" onClick="popup('$scripts_admin/sn_admin4.cgi?fct=emailcust',screen.width -200,screen.height -200);return false;">Customize Email Responses</a>], 
qq[Enables you to customize the various email responses sent out by SiteNet BBS.]
);

$sfriendly = sn_netbadmin::get_heading_box("$web_url/sn_search.gif", 
qq[<a href="$scripts_admin/sn_admin4.cgi?fct=sfriendly" onClick="popup('$scripts_admin/sn_admin4.cgi?fct=sfriendly',screen.width -200,screen.height -200);return false;">Search Engine Friendly URLs</a>], 
qq[Adds Search Engine Friendly URLs to your Forums for SEO purposes.]
);


$disphtml = qq[
$globals
$modsettings
$membertitles
$emailres
$sfriendly
];

$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;

}



sub gsettings
{

my ($ctemplate, $disphtml, $graphic, $tc_mainheading, $tc_subheading, $tc_col1, $tc_col2, $f_hfont,
    $f_genfont, $f_msgposter, $f_shfont, @settings, $f_mainfont,
    $tc_border, $fset, $fsize, $gforumname, $global_email, $tc_hline, @i, $regusers,
    @fontsel, $replies_top, $regusers1, $regusers2, $topicstop1, $topicstop2);


$fsize = (-s "$data_dir/sn_settings.dat");
 open (RVF, "$data_dir/sn_settings.dat");
	read(RVF,$fset,$fsize);
 close (RVF);

if ($debug eq "ON")
	{
	@i = ('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20');
	}

(@settings) = split(/\n/,$fset);

$graphic = 			$settings[0];
$tc_mainheading = $settings[1];
$tc_subheading = 	$settings[2];
$tc_col1 = 			$settings[3];
$tc_col2 = 			$settings[4];
$tc_border = 		$settings[5];
$f_mainfont = 		$settings[6];
$f_hfont = 			$settings[7];
$f_shfont = 		$settings[8];
$f_genfont = 		$settings[9];
$f_msgposter = 	$settings[10];
$gforumname = 		$settings[11];
$global_email = 	$settings[12];
$tc_hline = 		$settings[13];
$regusers = 		$settings[14];
$replies_top = 	$settings[15];

$max_image_size = $settings[16];
$iwidth = 			$settings[17];
#$iheight = 			$settings[18];

if ($max_image_size eq "") { $max_image_size = "5"; }
if ($iwidth eq "") { $iwidth = "70"; }
if ($iheight eq "") { $iheight = "70"; }

if ($f_mainfont eq "Verdana"){$fontsel[0] = "selected";}
if ($f_mainfont eq "Arial"){$fontsel[1] = "selected";}
if ($f_mainfont eq "Helvetica"){$fontsel[2] = "selected";}
if ($f_mainfont eq "Lucida"){$fontsel[3] = "selected";}
if ($f_mainfont eq "Times New Roman"){$fontsel[4] = "selected";}
if ($f_mainfont eq "Sans-Serif"){$fontsel[5] = "selected";}

if ($replies_top eq "") {$replies_top = "N";}

if ($settings[14] eq "Y") {$regusers1 = "selected";} else {$regusers2 = "selected";}

if ($settings[15] eq "Y") {$topicstop1 = "selected";} else {$topicstop2 = "selected";}

if ($settings[17] eq "N") 
	{
	$lastv_no = "selected";
	}
	else
	{
	$lastv_yes = "selected";
	}


$cookie_use = $settings[18];
$ip_checks = $settings[19];

if ($cookie_use eq "N")
	{
	$cookie_use_no = "selected";
	}
	else
	{
	$cookie_use_yes = "selected";
	}


if ($ip_checks eq "N")
	{
	$ip_checks_no = "selected";
	}
	else
	{
	$ip_checks_yes = "selected";
	}



$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_settings.gif", "Global Forum Settings", qq[
Enables you to customize your forums and also allows you to set various options regarding the operation of your forums.
]);




$disphtml = <<END_OF_DSHTML;
$hbox

<form method="POST" action="$scripts_admin/sn_admin4.cgi">
  <input type="hidden" name="fct" value="save_cust"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" bgcolor="#E0E0E0">
    <tr>
      <td width="100%" bgcolor="#F3F3F3" colspan="2" height="30" background="$web_url/sn_bar6.gif"><font
      face="Verdana" size="2"><strong>Global Forum Settings</strong></font></td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"> <font face="Verdana"
      size="1"><strong>Forum Name:<br>
      </strong>This is the name that will be assigned for the whole group of your forums. <br>
      For example: The Webmaster Forum</font></td>
      <td width="52%" bgcolor="#FFFFFF"><input type="text" name="gforumname" size="49"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$gforumname"> $i[11]</td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"> <font face="Verdana"
      size="1"><strong>Email Address:<br>
      </strong>This email address will be used when SiteNet BBS sends passwords &amp;
      notifications to users. This email address will be the sender of the email of email that
      is sent.&nbsp;&nbsp; </font></td>
      <td width="52%" bgcolor="#FFFFFF"><input type="text" name="global_email" size="49"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$global_email"> $i[12]</td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"><strong> Move topics to top when replies are posted:</strong></font></td>
      <td width="52%" bgcolor="#FFFFFF"><select name="replies_top" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $topicstop1 value="Y">Yes</option>
        <option $topicstop2 value="N">No</option>
      </select>$i[15]</td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><img
      src="$web_url/sn_first.gif"> <strong>Default Logo Graphic:<br>
      </strong>This is the default graphic that is displayed in a forum when no other has been
      assigned. It is located at: <br>
      <strong>$web_url/$graphic</strong></font></td>
      <td width="52%" bgcolor="#FFFFFF"><input type="text" name="graphic" size="17"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$graphic"> $i[0]</td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><img
      src="$web_url/sn_first.gif"> <strong>Max image upload size (kilobytes)</strong><br>
      This is the maximum allowable size in kilobytes of images/graphics that is uploaded by
      users. Users can upload their own graphics/images when editing their profiles. </font></td>
      <td width="52%" bgcolor="#FFFFFF"><input type="text" name="max_image_size" size="4"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$max_image_size"><strong><font
      face="Verdana" size="1">Kilobytes</font><font face="Verdana" size="2"> </font></strong>$i[16]</td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><strong></strong></font></td>
      <td width="52%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><strong><input
      type="submit" value="Save Settings" name="B1"
      style="font-family: MS Sans Serif; font-size: 8pt"></strong></font></td>
    </tr>
  </table>
</form>


END_OF_DSHTML

#$ctemplate = sn_netbadmin::get_cpanel_template;
#$ctemplate =~ s/!!criteria!!/$disphtml/g;
#print $ctemplate;

print qq[<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body> 
$disphtml
</body>
</html>
];

}





sub save_cust
{

my ($graphic, $tc_mainheading, $tc_subheading, $tc_col1, $tc_col2, $f_mainfont,
	 $f_hfont, $f_genfont, $f_msgposter, $f_shfont, $tc_border, $gforumname, $global_email,
	 $tc_hline, $regusers, $ferror, $ctemplate, $disphtml, $replies_top);


#### ERROR CHECKING
if ($q->param('gforumname') eq ""){sn_netbadmin::errorbox("You need to specify a name for your forum.");  print "</body></html>"; exit;}

if ($q->param('global_email') eq ""){sn_netbadmin::errorbox("Your forums will require an email address from which all mail are sent.");  print "</body></html>"; exit;}

if ($q->param('graphic') eq ""){sn_netbadmin::errorbox("Your forum will need a graphic."); print "</body></html>"; exit;}

#if ($q->param('tc_mainheading') eq ""){sn_netbadmin::errorbox("Your forum will require a main heading table background.");  print "</body></html>"; exit;}
#if ($q->param('tc_subheading') eq ""){sn_netbadmin::errorbox("Your forum will require a sub heading table background.");  print "</body></html>"; exit;}
#if ($q->param('tc_col1') eq ""){sn_netbadmin::errorbox("Your forum will requires a column color 1.");  print "</body></html>"; exit;}
#if ($q->param('tc_col2') eq ""){sn_netbadmin::errorbox("Your forum will requires a column color 2.");  print "</body></html>"; exit;}
#if ($q->param('tc_border') eq ""){sn_netbadmin::errorbox("Your forum requires a color for table borders.");  print "</body></html>"; exit;}
#if ($q->param('tc_hline') eq ""){sn_netbadmin::errorbox("Your forum needs a color for the horizontal lines used.");  print "</body></html>"; exit;}
#if ($q->param('f_hfont') eq ""){sn_netbadmin::errorbox("Your forum requires the font color of the heading tables.");  print "</body></html>"; exit;}
#if ($q->param('f_shfont') eq ""){sn_netbadmin::errorbox("Your forum requires the font color of the sub heading tables.");  print "</body></html>"; exit;}
#if ($q->param('regusers') eq ""){sn_netbadmin::errorbox("You have to specify if the amount of registered users are shown or not.");  print "</body></html>"; exit;}
#if ($q->param('replies_top') eq ""){sn_netbadmin::errorbox("You have to specify Y or N which indicates if topics move to the top when replies are posted to them.");  print "</body></html>"; exit;}
if ($q->param('max_image_size') < 1){sn_netbadmin::errorbox("The image size you supplied is invalid.");  print "</body></html>"; exit;}


### GRAPHIC
$graphic = $q->param('graphic');

### TABLE SETTINGS
$tc_mainheading = $q->param('tc_mainheading');
$tc_subheading = $q->param('tc_subheading');
$tc_col1 = $q->param('tc_col1');
$tc_col2 = $q->param('tc_col2');
$tc_border = $q->param('tc_border');

### MAIN FONT
$f_mainfont = $q->param('f_mainfont');
$f_hfont = $q->param('f_hfont');
$f_shfont = $q->param('f_shfont');
$f_genfont = $q->param('f_genfont');
$f_msgposter = $q->param('f_msgposter');

### GLOBAL NAME & EMAIL
$gforumname = $q->param('gforumname');
$global_email = $q->param('global_email');

$tc_hline = $q->param('tc_hline');
$regusers = $q->param('regusers');

$replies_top = $q->param('replies_top');

$max_image_size = $q->param('max_image_size');
$lastv = $q->param('last_visitors');

$cookie_use = $q->param('cookie_use');
$ip_checks = $q->param('ip_checks');

### 

open (CSET, "> $data_dir/sn_settings.dat");
 if ($flocking ne "No"){flock (CSET,2);}
	print CSET 	$graphic . "\n" . 				#0
					$tc_mainheading . "\n" . 		#1
					$tc_subheading . "\n" . 		#2
					$tc_col1 . "\n" . 				#3
					$tc_col2 . "\n" . 				#4
					$tc_border . "\n" . 				#5
					$f_mainfont . "\n" . 			#6
					$f_hfont . "\n" . 				#7
					$f_shfont . "\n" . 				#8
					$f_genfont . "\n" . 				#9
					$f_msgposter . "\n" .			#10 
					$gforumname . "\n" . 			#11
					$global_email . "\n" . 			#12
					$tc_hline . "\n" . 				#13
					"Y" . "\n" . 						#14 SHOW HOW MANY USERS
					$replies_top . "\n" .			#15
					$max_image_size . "\n" . 		#16
					"Y" . "\n" .  						#17 LAST VISITORS
					"Y" . "\n" .						#18 USE COOKIES
					"Y" . "\n";				#19 CHECK VOTES AGAINST IPs

 if ($flocking ne "No"){flock (CSET,8);}	
close (CSET);


#$disphtml = sn_netbadmin::main_settings_saved;

$disphtml = sn_netbadmin::get_heading_box("$web_url/sn_ic_settings.gif", "Global Forum Settings Saved", qq[
<a href="javascript:onClick=window.close()">Close This Window</a>
]);


#$ctemplate = sn_netbadmin::get_cpanel_template;
#$ctemplate =~ s/!!criteria!!/$disphtml/g;
#print $ctemplate;

print qq[<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body> 
$disphtml
</body>
</html>
];



exit;


}


