#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict; 
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$version = "2.0";
$debug = "OFF";
$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################



$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print $q->header();

if ($q->param('fct') eq "includes_start") {&includes_start;}
if ($q->param('fct') eq "create_include") {&create_include;}
if ($q->param('fct') eq "create_tmpl_include") {&create_tmpl_include;}
if ($q->param('fct') eq "include_edit_delete") {&include_edit_delete;}
if ($q->param('fct') eq "save_tmpl_include") {&save_tmpl_include;}

###############################################################




sub save_tmpl_include
{

my ($template_include, $ctemplate, $disphtml, $tmpl_name, $ti_topicpage, $ti_read_messages, $ti_postmsg, $ti_postpoll);

$tmpl_name = $q->param('tmpl_name');

$template_include = $q->param('template_include');

open (CTEMPL, "> $data_dir/template_includes/$tmpl_name.html");
  if ($flocking ne "No"){flock (CTEMPL,2);}
	  print CTEMPL $template_include;
  if ($flocking ne "No"){flock (CTEMPL,8);}	
close (CTEMPL);

#########

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_newsub.gif", "Template Include Saved", qq[
<a href="$scripts_admin/sn_admin6.cgi?fct=includes_start">Click Here to Continue</a>
]);

print qq[
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}


########################


sub include_edit_delete
{

if ($q->param('B1') =~ /Edit/)
	{
	&edit_include;
	}
	else
	{
	&delete_include;
	}

}

########################


sub delete_include
{

$incl_name = $q->param('tmpl_include');

$exists = (-e "$data_dir/template_includes/$incl_name.dat");
if ($exists > 0)
	{
	unlink "$data_dir/template_includes/$incl_name.dat";
	}

unlink "$data_dir/template_includes/$incl_name.html";



$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_newsub.gif", "Template Include Removed", qq[
<a href="$scripts_admin/sn_admin6.cgi?fct=includes_start">Click Here to Continue</a>
]);

print qq[
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}


########################


sub edit_include
{

my ($ctemplate, $disphtml, $tincl, $iname, $wdisplay, @wditems, $ti_topicpage, $ti_read_messages,
    $ti_postmsg, $ti_postpoll);

$iname = $q->param('tmpl_include');

$tincl = sn_netbadmin::get_file_contents("$data_dir/template_includes/$iname.html");


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_newsub.gif", "Edit Template Include", qq[
<a href="$scripts_admin/sn_admin6.cgi?fct=includes_start">Go Back</a>
]);


print qq[

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<form method="POST" action="$scripts_admin/sn_admin6.cgi">
  <input type="hidden" name="fct" value="save_tmpl_include"><input type="hidden"
  name="tmpl_name" value="$iname"><table width="1024" border="0" cellpadding="6"
  style="border: 1px solid rgb(226,226,226)">
    <tr>
      <td background="$web_url/sn_bar6.gif" width="1010"><font face="Verdana" size="2"><strong
      class="normaltext">Edit Template Include </strong><font color="#0000A0"><strong>$iname</strong></font></font></td>
    </tr>
    <tr>
      <td class="normaltext" width="996"><textarea rows="15" name="template_include" cols="79"
      style="width:100%">$tincl</textarea></td>
    </tr>
    <tr>
      <td class="normaltext" width="996"><input type="submit"
      value="     Save Template Include   " name="B1"></td>
    </tr>
  </table>
</form>
</body>
</html>
];


}






sub create_tmpl_include
{

my ($ctemplate, $disphtml, $tmpl_name, $template_include);

$tmpl_name = $q->param('tmpl_name');

$template_include = $q->param('template_include');

open (CTEMPL, "> $data_dir/template_includes/$tmpl_name.html");
  if ($flocking ne "No"){flock (CTEMPL,2);}
	  print CTEMPL $template_include;
  if ($flocking ne "No"){flock (CTEMPL,8);}	
close (CTEMPL);

### WHERE TO DISPLAY

#open (CTEMPL, "> $data_dir/template_includes/$tmpl_name.dat");
#  if ($flocking ne "No"){flock (CTEMPL,2);}
#
#	  print CTEMPL $q->param('ti_topicpage') . "\n" . 
#	  					$q->param('ti_read_messages') . "\n" . 
#	  					$q->param('ti_postmsg') . "\n" . 
#	  					$q->param('ti_postpoll');
#
#  if ($flocking ne "No"){flock (CTEMPL,8);}	
#close (CTEMPL);


##########################


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_newsub.gif", "Template Include Created", qq[
<a href="$scripts_admin/sn_admin6.cgi?fct=includes_start">Click Here to Continue</a>
]);


print qq[
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}





sub create_include
{

my ($ms, $oneletter, $error_text, $ctemplate, $disphtml);


for ($ms = 0; $ms < length($q->param('tmpl_include')); $ms++) 
	{
		$oneletter = substr($q->param('tmpl_include'), $ms, 1);
		if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
			{
			sn_netbadmin::errorbox("The name you specified has characters other than characters in the english alphabet.");
			exit;
			}
	}

if ($q->param('tmpl_include') eq "")
	{
	sn_netbadmin::errorbox("You need to specify a name for the template include you are about to create.");
	exit;
	}

### CHECK FOR DUPLICATE TEMPLATES

$tiname = $q->param('tmpl_include');

if ((-e "$data_dir/template_includes/$tiname.html") > 0)
	{
	sn_netbadmin::errorbox("The name you specified is already used for a Template Include.");
	exit;
	}


#######

&create_include2;



}




sub create_include2
{

my ($tmpl_include, $template_include, $disphtml, $tmpl_name, $ctemplate);

if ((-e "$data_dir/template_includes") < 1)
	{
	mkdir("$data_dir/template_includes",0777);
	}

######

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_newsub.gif", "Created Template Include", qq[
Template includes are templates or HTML code that you can include in any templates. Much like headers and 
footers which you can include in your forums. The template includes are referenced/accessed by words/text. 
For example !!-some_template_include-!!
]);



$tmpl_include = $q->param('tmpl_include');

print qq[
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

<form method="POST" action="$scripts_admin/sn_admin6.cgi">
  <input type="hidden" name="fct" value="create_tmpl_include"><input type="hidden"
  name="tmpl_name" value="$tmpl_include"><table width="1024" border="0" cellpadding="6"
  style="border: 1px solid rgb(226,226,226)">
    <tr>
      <td background="$web_url/sn_bar6.gif" width="1010"><font face="Verdana" size="2"><strong
      class="normaltext">Create Template Include</strong></font></td>
    </tr>
    <tr>
      <td class="normaltext" width="996"><textarea rows="15" name="template_include" cols="79"
      style="width:100%">$template_include</textarea></td>
    </tr>
    <tr>
      <td class="normaltext" width="996"><input type="submit"
      value="     Create Template Include   " name="B1"></td>
    </tr>
  </table>
</form>

</body>
</html>
];


######



}




sub includes_start
{

my ($ctemplate, $disphtml, @files, $file, $include_box, $selvalues, $disvals);

	opendir(DIR,"$data_dir/template_includes");
		@files = readdir(DIR);
	closedir(DIR);		
			
	foreach $file (@files)
		{
		if (($file ne ".") and ($file ne "..") and ($file !~ /\.dat/))
			{
			$file =~ s/\.html//g;
			$selvalues = $selvalues . "<option selected value=\"$file\">$file</option>";
			$disvals = $disvals . "<li>!!-$file-!!</li>";
			}
		}


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_newsub.gif", "Template Includes", qq[
Template Includes are pieces of HTML code which you can include in any template. These pieces of 
HTML code could be headers, footers or menu bars. It almost works like SSIs (server side includes) 
or Java Script Includes. Note that the template includes will only work in the SiteNet BBS templates. 
It will work in any template used by SiteNet BBS. 
]);
 



if ($selvalues ne "")
	{

$include_box = <<END_OF_IB;

<form method="POST" action="$scripts_admin/sn_admin6.cgi">
  <input type="hidden" name="fct" value="include_edit_delete"><table width="100%" border="0"
  cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
    <tr>
      <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="1024" border="0"
      cellpadding="6">
        <tr>
          <td background="$web_url/sn_bar6.gif" colspan="2" width="1010"><font face="Verdana" size="2"><strong
          class="normaltext">Edit Template Includes</strong></font></td>
        </tr>
        <tr>
          <td class="normaltext" width="211"><font face="Verdana" size="2">Select a Template
          Include:</font></td>
          <td class="normaltext" width="785"><select name="tmpl_include" size="1">
          $selvalues
          </select> <input type="submit" value="   Edit   " name="B1"> <input type="submit"
          value="   Delete   " name="B2"></td>
        </tr>
        <tr>
          <td class="normaltext" width="211"></td>
          <td class="normaltext" width="785"><font face="Verdana" size="2"><strong>Use the following
          text inside any templates to display template includes in templates:<br>
          </strong>$disvals</font></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>

END_OF_IB
	
	
	}




print qq[
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
$include_box

<form method="POST" action="$scripts_admin/sn_admin6.cgi">
  <input type="hidden" name="fct" value="create_include"><table width="100%" border="0"
  cellpadding="6" style="border: 1px solid rgb(226,226,226)">
    <tr>
      <td background="$web_url/sn_bar6.gif" width="1010"><font face="Verdana" size="2"><strong>Create
      a Template Include</strong></font></td>
    </tr>
    <tr>
      <td class="normaltext" width="996"><strong>Template Include Name:</strong> <input
      type="text" name="tmpl_include" size="40"> <input type="submit"
      value="Create Template Include" name="B1"></td>
    </tr>
    <tr>
      <td class="normaltext" width="996"><font face="Verdana" size="2">Please do not uses spaces
      in this name or characters other than in the english alphabet.</font></td>
    </tr>
  </table>
</form>

</body>
</html>
 ];


#$ctemplate = sn_netbadmin::get_cpanel_template;
#$ctemplate =~ s/!!criteria!!/$disphtml/g;
#print $ctemplate;

}

