#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################



$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}



#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print $q->header();

if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "check_integrity") {&check_integrity; exit;}

###############################################################################

sub check_integrity
{

($cid, $fid) = split (/_/, $q->param('groupname'));

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);

$boardtable = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@alltopics = split (/\n/, $boardtable);

$statstable = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@allstats = split (/\n/, $statstable);

$statcount = 0;

foreach $tpc (@alltopics)
	{
	(@titems) = split (/\t/, $tpc);

	#### TOTAL MESSAGES
	
	$msg = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/$titems[0].dat");
	@msgitems = split (/\n/, $msg);
	$totalmsgs = @msgitems;
	
	####################
	
	($sid, $replies, $views, $dt, $last) = split (/\t/, $allstats[$statcount]);
	
	if ($titems[7] > $dt){$dt = $titems[7];}
	$views1 = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/$titems[0].cnt");
	$views = $views + $views1;
	
	$allstats[$statcount] = $titems[0] . "\t" .  	#### ID
									$totalmsgs . "\t" .		#### MSGS
									$views . "\t" .			#### MSGS
									$dt . "\t" .				#### DATE
									$last . "\n";				#### LAST POST

	$statcount++;
	}


open (ALLSTATS, "> $data_dir/$cid/$fid/tstats.dat");
	foreach $item (@allstats)
		{
		print ALLSTATS $item;
		}
close (ALLSTATS);


$disphtml = <<END_OF_DS;
<p><strong><font face="Verdana" size="2">Checked  $fcatname  $forname</font></strong>
<ul>
 <li><font face="Verdana" size="2">All stats tables has been rewritten and topics has been recounted.</font></li>
</ul>
END_OF_DS

$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;

}




sub start
{

########################################

$boardtable = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
@board_lines = split (/\n/, $boardtable);

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);

$move_table = <<END_OF_MT;
 <p><strong><font face="Arial" size="4" color="#8080C0"><strong>Check &amp; Fix Integrity
 of Forums</strong><br>
 </font></strong></p>
 <form method="POST" action="$scripts_admin/sn_admin7.cgi"><input type="hidden" name="fct" value="check_integrity">
 <font face="Verdana" size="1">
END_OF_MT


	foreach $line (@board_lines)
		{
		($cid1, $cat_name) = split (/\t/, $line);
		$move_table = $move_table . "<img src=\"$web_url/sn_dir.gif\" width=\"16\" height=\"11\" alt=\"Main Category\"> <strong>$cat_name</strong><br>";
            
         	$forumtable = sn_netbadmin::get_file_contents("$data_dir/$cid1/forumtable.dat");
         	@all_forums = split (/\n/, $forumtable);
         	
         	foreach $fline (@all_forums)
         		{
            	($fid1, $forum_name) = split (/\t/, $fline);
            	
            	if ($fid1 != $fid)
            		{
            		if ($radio_value eq "") {$checkedval = "checked";} else {$checkedval = "";}
	            	$radio_value = $cid1 . "_" . $fid1;
            		$move_table = $move_table . "<input type=\"radio\" value=\"$radio_value\" $checkedval name=\"groupname\"><img src=\"$web_url/sn_dire.gif\" width=\"15\" height=\"15\"><img src=\"$web_url/sn_dir.gif\" width=\"16\" height=\"11\" alt=\"Select Forum\"> &nbsp; $forum_name<br>";
            		}
            	}
      
      $move_table = $move_table . "<BR>";
		}

$move_table = $move_table . "</font><input type=\"submit\" value=\"Check and Fix\" name=\"B1\" style=\"font-family: MS Sans Serif; font-size: 8\">";


$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$move_table/g;
print $ctemplate;

}