#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}



#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print $q->header();

if ($q->param('fct') eq "prevnext") {&prevnext; exit;}
if ($q->param('fct') eq "save_prevnext") {&save_prevnext; exit;}

if ($q->param('fct') eq "whopost") {&whopost; exit;}
if ($q->param('fct') eq "save_whpost") {&save_whpost; exit;}

################################################



sub save_whpost
{

open (SNDATA, "> $data_dir/sn_postany.html");
print SNDATA $q->param('anypost');
close (SNDATA);

open (SNDATA, "> $data_dir/sn_postmod.html");
print SNDATA $q->param('modpost');
close (SNDATA);

open (SNDATA, "> $data_dir/sn_postadm.html");
print SNDATA $q->param('admpost');
close (SNDATA);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Settings Saved", qq[
<a href="http://" onClick="self.close();return false">Close This Window</a> 
]);

print qq[
<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



sub whopost
{

$anypost = sn_netbadmin::get_file_contents("$data_dir/sn_postany.html");
$modpost = sn_netbadmin::get_file_contents("$data_dir/sn_postmod.html");
$admpost = sn_netbadmin::get_file_contents("$data_dir/sn_postadm.html");


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Who May Post Text Settings", qq[
<form method="POST" action="$scripts_admin/sn_admin9.cgi">
  <input type="hidden" name="fct" value="save_whpost"><table border="0" width="100%"
  cellpadding="6" cellspacing="1">
    <tr>
      <td width="100%" height="30" colspan="2"><font face="Arial" size="2">The following text
      will be used to indicate who may post in Forums.<br>
      &nbsp;&nbsp; </font></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
      size="2">Text indicating that any users may post whether they are registered or not:</font></td>
      <td width="70%"><input type="text" name="anypost" size="31" value="$anypost"
      style="width:100%"></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
      size="2">Text indicating that registered users may post:</font></td>
      <td width="70%"><input type="text" name="modpost" size="31" value="$modpost"
      style="width:100%"></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
      size="2">Text indicating that moderators or administrators may post:</font></td>
      <td width="70%"><input type="text" name="admpost" size="31" value="$admpost"
      style="width:100%"></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"></td>
      <td width="70%"><input type="submit" value="Save" name="B1"></td>
    </tr>
  </table>
</form>
]);


print qq[
<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}




sub save_prevnext
{


open (SNDATA, "> $data_dir/sn_nextp.html");
print SNDATA $q->param('nextpage');
close (SNDATA);

open (SNDATA, "> $data_dir/sn_prevp.html");
print SNDATA $q->param('prevpage');
close (SNDATA);

open (SNDATA, "> $data_dir/sn_nextprevsep.html");
print SNDATA $q->param('nextprev_sep');
close (SNDATA);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Settings Saved", qq[
<a href="http://" onClick="self.close();return false">Close This Window</a> 
]);

print qq[
<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}




sub prevnext
{

$nextpage = sn_netbadmin::get_file_contents("$data_dir/sn_nextp.html");
$prevpage = sn_netbadmin::get_file_contents("$data_dir/sn_prevp.html");
$nextprev_sep = sn_netbadmin::get_file_contents("$data_dir/sn_nextprevsep.html");


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Previous / Next Page Texts Settings", qq[
<form method="POST" action="$scripts_admin/sn_admin9.cgi">
  <input type="hidden" name="fct" value="save_prevnext"><table border="0" width="100%"
  cellpadding="6" cellspacing="1">
    <tr>
      <td width="100%" height="30" colspan="2"><font face="Arial" size="2"><strong>Previous Page
      / Next Page Settings<br>
      </strong>The following text will be used to indicate a 'Next Page' or 'Previous Page' link
      when browsing the forums.<br>
      &nbsp;&nbsp; </font></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
      size="2">Text indicating a 'Next Page':</font></td>
      <td width="70%"><input type="text" name="nextpage" size="31" value="$nextpage"></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
      size="2">Text indicating a 'Previous' Page:</font></td>
      <td width="70%"><input type="text" name="prevpage" size="31" value="$prevpage"></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
      size="2">If there is a 'Next Page' and a 'Previous Page' specify a seperator:</font></td>
      <td width="70%"><input type="text" name="nextprev_sep" size="9" value="$nextprev_sep"></td>
    </tr>
    <tr>
      <td width="30%" style="border-right: 1px solid rgb(228,228,228)"></td>
      <td width="70%"><input type="submit" value="Save" name="B1"></td>
    </tr>
  </table>
</form>

]);

print qq[
<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];




}