#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "")  {&step1;}
if ($q->param('fct') eq "step2")  {&step2;}
if ($q->param('fct') eq "step3")  {&step3;}

if ($q->param('fct') eq "sampletmpl")  {&sampletmpl;}
if ($q->param('fct') eq "header")  {&header;}
if ($q->param('fct') eq "headerinc")  {&headerinc;}
if ($q->param('fct') eq "frontp")  {&frontp;}

if ($q->param('fct') eq "quickfp")  {&quickfp;}


##################################################################################

sub quickfp
{

	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$ydomain = $domain_items[2];
	


$gsettings = new_gsettings acs;


if ($gsettings->{dyn_stat} eq "Static")
	{
	$whatsnew = "$web_url/new/";
	$tophits = "$web_url/pop/";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}
	else
	{
	$whatsnew = "$script_url/dirs.cgi?newpop=new";
	$tophits = "$script_url/dirs.cgi?newpop=pop";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}


########

@domain_items = split (/\//, $script_url);
$domain_name = $domain_items[2];

$dcntr = 0;
foreach $ditem (@domain_items)
	{
		if ($dcntr > 2)
			{
			$domain_items = $domain_items . "/" . $ditem;
			}
	$dcntr++;
	}

#######

$frontpage_iframe = qq[<iframe width="100%" id="display_fpiframe" 
onLoad="getFPHeight();" 
src=""
scrolling="NO" 
frameborder="0" 
height="50">An iframe capable browser is 
required to view this web site.
</iframe>
<script language="JavaScript">
function GetDomain(url) 
{ return url.match(/:\\/\\/(.[^/]+)/)[1]; }
function getFPHeight() {
var the_height = document.getElementById('display_fpiframe').contentWindow.document.body.scrollHeight;
document.getElementById('display_fpiframe').height = the_height;
}
var realurl = 'http://' + GetDomain(document.URL) + '$domain_items/fpif.cgi';
document.getElementById('display_fpiframe').src = realurl;
</script>
];

	
$hbox = acs::get_heading_box("$web_url/ic_banner_long.gif", "Quick Setup for the Front Page of your Directory ", qq[Note that there are other methods for setting up your Front Page but in this section we will use the most basic and easiest method.<strong> Also note that there is a '<a href="$admin_url/startup.cgi">Startup Wizard</a>' that you can follow instead of these instructions that also covers the setup of the Front Page of your Directory. The Startup Wizard is a more complete approach to get you started in setting up and building your Search Engine &amp; Directory. </strong>]);

$jspopup_code = acs::get_popupjs;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Quick Front Page Setup</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox
<p><strong>Step 1 - Configure category displays for Front Page</strong></p>
<blockquote>
  <p><a href="$admin_url/admin26.cgi?fct=fp_generate0&amp;fpmeth=iframe" onclick="popup('$admin_url/admin26.cgi?fct=fp_generate0&amp;fpmeth=iframe',screen.width-250,screen.height-250);return false;"><strong>Click Here</strong></a> to configure the way categories will be displayed on your Front Page. When you have set the options you would like changed click the <strong>'Next' button.</strong> After that close the popup Window and come back to this section.</p>
  <blockquote>
    <p><strong>Side  Note:</strong> <br />
      You can also get to the section where you configure the way categories are displayed from the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/todo.cgi" target="_blank">To Do</a> &gt;&gt; <a href="$admin_url/admin26.cgi"
				
				onclick="popup('$admin_url/admin26.cgi',screen.width-250,screen.height-250);return false;"
				>Generate Front Page</a> &gt;&gt; Choose the IFRAME option and click the <strong>Next</strong> button. Keep in mind that there are a couple of ways to create/setup your front page for flexibility and different scenarios. </p>
  </blockquote>
  <p>&nbsp;</p>
</blockquote>
<p><strong>Step 2 - Create a Web Page that will act as your Front Page</strong> </p>
<blockquote>
  <p>Now use your <strong>Web Editor</strong> to create a <strong>web page</strong> that will serve as the Front Page of your Directory.</p>
  <p>This <strong>web page</strong> can contain your<strong> logo, graphics,  layout, front page greeting, etc. </strong></p>
  <p>In this example we will call your Front Page <strong>index.html</strong> and assume you will upload it to: <strong>http://$ydomain</strong></p>
  <p>After creating a front page (index.html for example), insert the following HTML code where you want the main categories of your Directory to display:<br />
    (The code below will display the main categories of your Directory) </p>
</blockquote>
<form id="form2" name="form2" method="post" action="">
  <label>
  <blockquote>
    <p name="textarea" cols="90" rows="5">
      <textarea name="textarea" cols="70" rows="18">$frontpage_iframe</textarea>
    </p>
  </blockquote>
  </label>
</form>
<blockquote>
  <p><strong>Note that you may want to adjust the following options inside the code above:</strong></p>
  <blockquote>
    <p> <strong>width=&quot;100%&quot;</strong> - You can change this to fit the width area where you want categories to display on your front page. If you take away the percentage sign then the browser will interpret it as pixel width. </p>
    <p><strong>height=&quot;100%&quot; </strong>- You can change this to fit the height area where you want categories to display on your front page. If you take away the percentage sign then the browser will interpret it as pixel height. </p>
    <p>&nbsp;</p>
  </blockquote>
</blockquote>
<p><strong>Step 3 - Insert Search Box into Front Page</strong> </p>
<blockquote>
  <p>Now insert the following HTML code into the <strong>Front Page (index.html for example)</strong> that you created with your <strong>Web Editor</strong> where you want the <strong>Search Box</strong> to apear on your Front Page:</p>
</blockquote>
<form id="form3" name="form3" method="post" action="">
  <label>
  <blockquote>
    <p name="textarea2" cols="70" rows="3">
      <textarea name="textarea2" cols="70" rows="3">&lt;form method=&quot;POST&quot; action=&quot;$script_url/search2.cgi&quot;&gt;
  &lt;p&gt;&lt;input type=&quot;text&quot; name=&quot;keywords&quot; size=&quot;33&quot;&gt;&lt;input type=&quot;submit&quot; value=&quot;Search&quot;
  name=&quot;search&quot;&gt; &lt;a href=&quot;$script_url/searchadv.cgi&quot;&gt;Advanced&lt;/a&gt;&lt;/p&gt;
&lt;/form&gt;</textarea>
      <br />
      <strong>Note:</strong> You are welcome to customize the HTML code above to give the Search Box another look and feel. </p>
  </blockquote>
  </label>
</form>
<p>&nbsp;</p>
<p><strong>Step 4 - Insert Links to PowerSeek functions in Front Page </strong></p>
<p>Now add the following links to the Front Page. These are links to the PowerSeek functions where users can Register Accounts, Add URLs, etc. </p>
<blockquote>
  <p><strong>What's New: </strong><br />
    This is the link that end users can click to see the latest additions to the Search Engine &amp; Directory. </p>
  <ul>
    <li>
      <p><a href="$script_url/dirs.cgi?newpop=new" target="_blank">$script_url/dirs.cgi?newpop=new</a></p>
    </li>
  </ul>
  <p><strong>Most Popular: (Also Referred to as 'Top Hits')</strong><br />
    This is the link that end users can click to see the most Popular links in the Search Engine &amp; Directory. </p>
  <ul>
    <li>
      <p><a href="$script_url/dirs.cgi?newpop=pop" target="_blank">$script_url/dirs.cgi?newpop=pop</a></p>
    </li>
  </ul>
  <p><strong>Login</strong>:<br />
    This is the login link that end users can click to log into their  accounts to submit or modify  links.</p>
  <ul>
    <li>
      <p><a href="$script_url/rgs_login.cgi" target="_blank">$script_url/rgs_login.cgi</a></p>
    </li>
  </ul>
  <p><strong>Register</strong>:<br />
    This is the link that end users can click to register an account to submit a new link.</p>
  <ul>
    <li>
      <p><a href="$script_url/rgs_register.cgi" target="_blank">$script_url/rgs_register.cgi</a></p>
    </li>
  </ul>
  <p><strong>Advanced Search <br />
  </strong>This link can be clicked to do an Advanced Search on the Search Engine &amp; Directory.</p>
  <ul>
    <li>
      <p><a href="$script_url/searchadv.cgi" target="_blank">$script_url/searchadv.cgi</a></p>
    </li>
  </ul>
  <p><strong>Favorites:</strong><br />
    This is the link end users can click to view their 'Favorite' links.  The favorite links can be added when clicking the 'Add to Favorites'  button or link next to each link when browsing the Search Engine &amp;  Directory.</p>
  <ul>
    <li>
      <p><a href="$script_url/fav.cgi" target="_blank">$script_url/fav.cgi</a></p>
    </li>
  </ul>
  <p><strong>Add URL: </strong><br />
    This is the link that can be clicked to submit a new link.</p>
  <ul>
    <li>
      <p><a href="$script_url/addurl.cgi" target="_blank">$script_url/addurl.cgi</a></p>
    </li>
  </ul>
  <p><strong>Add Premium URL:<br />
  </strong>This is the link that can be clicked to submit a new premium link.</p>
  <ul>
    <li>
      <p><a href="$script_url/addurl.cgi?p=1" target="_blank">$script_url/addurl.cgi?p=1</a></p>
    </li>
  </ul>
  <p><strong>Contact Us:<br />
  </strong>This is the link to the contact form.</p>
  <ul>
    <li>
      <p><a href="$script_url/addurl.cgi?p=1" target="_blank">$script_url/contact.cgi</a></p></li></ul></blockquote>
<p><strong>Step 5 - Example </strong></p>
<blockquote>
  <p><a href="$admin_url/startup.cgi?fct=frontp"
		  onclick="popup('$admin_url/startup.cgi?fct=frontp',screen.width-250,screen.height-250);return false;"><strong>Click Here</strong></a> to see an example of how the Front Page you create could look like. Remember that this is an ordinary web page that you create and upload so that it's available from: <strong>http://$ydomain</strong> for example. The categories are pulled or placed into the Front Page by the HTML code provided to you in Step 2. The Search Box is the HTML code provided to you in step 3. </p>
</blockquote>
<p>&nbsp;</p>
<p><strong>Step 6 - Upload Front Page</strong></p>
<blockquote>
  <p>Now <strong>upload the Front Page (index.html for example) you have created</strong> so that you can load it from <strong>http://$ydomain</strong> for example. After you have uploaded the front page web page you have just created, load it inside your browser and you will see your front page with categories and search box.</p>
  <p><strong>Notes:</strong></p>
  <blockquote>
    <p>If you run a Static Directory where files are generated then you will need to generate the HTML files for the links to work when you click categories from the Front Page. You can generate HTML files by going to the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/todo.cgi" target="_blank">To Do</a> &gt;&gt; <a href="$admin_url/admin8.cgi" onclick="popup('$admin_url/admin8.cgi',screen.width-250,screen.height-250);return false;">Generate HTML Files</a><a href="$admin_url/admin26.cgi?fct=update_frontpage" onclick="popup('$admin_url/admin26.cgi?fct=update_frontpage',screen.width-250,screen.height-250);return false;"></a></p>
  </blockquote>
</blockquote>
</body>
</html>
];



}


sub frontp
{

	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$ydomain = $domain_items[2];


$gsettings = new_gsettings acs;


if ($gsettings->{dyn_stat} eq "Static")
	{
	$whatsnew = "$web_url/new/";
	$tophits = "$web_url/pop/";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}
	else
	{
	$whatsnew = "$script_url/dirs.cgi?newpop=new";
	$tophits = "$script_url/dirs.cgi?newpop=pop";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}



print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>Directory Front Page</title>
<style type="text/css">
A {COLOR: #005CB9}
A:visited {COLOR: #005CB9}
A:active {COLOR: #000000}
A:hover { COLOR: #000000}
.normaltext {font-family: Tahoma;  font-size: 12px; line-height: 18px; color: #333333; }
.barback { background-image: url("http://192.168.0.4/pseek6/undera7.png"); background-repeat: repeat-x; }
.shadow  { background-image: url("http://192.168.0.4/pseek6/shadow.gif"); background-repeat: repeat-x; }
</style>

</head>

<body>
<form method="POST" action="$script_url/search2.cgi" align="center"><div align="center"><center><table border="0" cellpadding="3" cellspacing="1" width="900"
  style="border: 1px solid rgb(219,219,219)">
    <tr>
      <td width="100%" align="center"><img src="$web_url/psdftop.jpg" width="847"
      height="150" alt="psdftop.jpg (33627 bytes)"></td>
    </tr>

    <tr>
      <td width="100%" align="center"><input type="text" name="keywords" size="65">
        <input type="submit" class="psbutton" value="Search" name="Search1"></td>
    </tr>
    <tr>
      <td width="100%" align="center"><p><strong><a href="$ydomain">Home</a> | <a
      href="$whatsnew">What's New</a> | <a href="$tophits">Most Popular</a> | <a
      href="$rgs_login">Login</a> | <a href="$register">Register</a> | <a
      href="$advanced_search">Advanced Search</a> | <a href="$favorites" target="_blank">Favorites</a> | <a href="$add_url">Add URL</a> | <a
      href="$add_url_premium">Add Premium URL</a></strong> | <a href="$script_url/contact.cgi"><strong>Contact Us</strong></a><strong></strong></p></td>
    </tr>
  </table>
  </center></div>
</form>
 </p>
<div align="center"><center>
</center></div><div align="center"><center>

<table border="0" cellpadding="7" cellspacing="0" width="900"
style="border: 1px solid rgb(214,214,214)">

  <tr>
    <td valign="top"><p><strong>Front Page Categories:</strong> (The categories below are displayed by an IFRAME tag as provided in the Setup Wizard Step 2) </p>
      <p>
	  
	  <iframe src="$script_url/fpif.cgi" width="100%" height="100%" frameborder="0" scrolling="no"></iframe>
	  <BR><BR>
	  </p></td>
  </tr>
</table>
</center></div><div align="center"><center>

<table border="0" cellpadding="0" cellspacing="0" width="900"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

</center></div><BR>
</body>
</html>

];




}



sub headerinc
{

print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>!!pagetitle!!</title>
<style type="text/css">
<!--
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover { COLOR: #000000}
p {font-family: Arial; line-height: : 20px; font-size: 13px; line-height: 18px; }
-->
</style>
</head>

<body>
 %%incl_myheader%%
 <div align="center"><center>
</center></div><div align="center"><center>

<table border="0" cellpadding="7" cellspacing="0" width="900"
style="border: 1px solid rgb(214,214,214)">

  <tr>
    <td height="400" valign="top"><p>!!psdata!!
      </p></td>
  </tr>
</table>
</center></div><div align="center"><center>

<table border="0" cellpadding="0" cellspacing="0" width="900"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

</center></div><BR>
</body>
</html>

];


}


sub header
{

	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$ydomain = $domain_items[2];


$gsettings = new_gsettings acs;


if ($gsettings->{dyn_stat} eq "Static")
	{
	$whatsnew = "$web_url/new/";
	$tophits = "$web_url/pop/";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}
	else
	{
	$whatsnew = "$script_url/dirs.cgi?newpop=new";
	$tophits = "$script_url/dirs.cgi?newpop=pop";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}


print qq[<form method="POST" action="$script_url/search2.cgi" align="center"><div align="center"><center><table border="0" cellpadding="3" cellspacing="1" width="900"
  style="border: 1px solid rgb(219,219,219)">
    <tr>
      <td width="100%" align="center"><img src="$web_url/psdftop.jpg" width="847"
      height="150" alt="psdftop.jpg (33627 bytes)"></td>
    </tr>

    <tr>
      <td width="100%" align="center"><input type="text" name="keywords" size="65">
        <input type="submit" class="psbutton" value="Search" name="Search1"></td>
    </tr>
    <tr>
      <td width="100%" align="center"><p><strong><a href="$ydomain">Home</a> | <a
      href="$whatsnew">What's New</a> | <a href="$tophits">Most Popular</a> | <a
      href="$rgs_login">Login</a> | <a href="$register">Register</a> | <a
      href="$advanced_search">Advanced Search</a> | <a href="$favorites" target="_blank">Favorites</a> | <a href="$add_url">Add URL</a> | <a
      href="$add_url_premium">Add Premium URL</a></strong></p></td>
    </tr>
  </table>
  </center></div>
</form>];


}



sub sampletmpl
{

	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$ydomain = $domain_items[2];


$gsettings = new_gsettings acs;


if ($gsettings->{dyn_stat} eq "Static")
	{
	$whatsnew = "$web_url/new/";
	$tophits = "$web_url/pop/";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}
	else
	{
	$whatsnew = "$script_url/dirs.cgi?newpop=new";
	$tophits = "$script_url/dirs.cgi?newpop=pop";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}



print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>!!pagetitle!!</title>
<style type="text/css">
<!--
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover { COLOR: #000000}
p {font-family: Arial; line-height: : 20px; font-size: 13px; line-height: 18px; }
-->
</style>
</head>

<body>
<form method="POST" action="$script_url/search2.cgi" align="center"><div align="center"><center><table border="0" cellpadding="3" cellspacing="1" width="900"
  style="border: 1px solid rgb(219,219,219)">
    <tr>
      <td width="100%" align="center"><img src="$web_url/psdftop.jpg" width="847"
      height="150" alt="psdftop.jpg (33627 bytes)"></td>
    </tr>

    <tr>
      <td width="100%" align="center"><input type="text" name="keywords" size="65">
        <input type="submit" class="psbutton" value="Search" name="Search1"></td>
    </tr>
    <tr>
      <td width="100%" align="center"><p><strong><a href="$ydomain">Home</a> | <a
      href="$whatsnew">What's New</a> | <a href="$tophits">Most Popular</a> | <a
      href="$rgs_login">Login</a> | <a href="$register">Register</a> | <a
      href="$advanced_search">Advanced Search</a> | <a href="$favorites" target="_blank">Favorites</a> | <a href="$add_url">Add URL</a> | <a
      href="$add_url_premium">Add Premium URL</a></strong></p></td>
    </tr>
  </table>
  </center></div>
</form>
 </p>
<div align="center"><center>
</center></div><div align="center"><center>

<table border="0" cellpadding="7" cellspacing="0" width="900"
style="border: 1px solid rgb(214,214,214)">

  <tr>
    <td height="400" valign="top"><p>!!psdata!!
      </p></td>
  </tr>
</table>
</center></div><div align="center"><center>

<table border="0" cellpadding="0" cellspacing="0" width="900"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

</center></div><BR>
</body>
</html>

];


}


sub step3
{


	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$ydomain = $domain_items[2];


$gsettings = new_gsettings acs;


if ($gsettings->{searchmeth} eq "fulltext")
	{
$searchbox = qq[<form method="POST" action="$script_url/search2.cgi">
<p><input type="text" name="keywords" size="33"><input type="submit" class="psbutton" value="Search" name="B1"></p>
</form>];
	}
	else
	{
$searchbox = qq[<form method="POST" action="$script_url/search.cgi">
<p><input type="text" name="keywords" size="33"><input type="submit" class="psbutton" value="Search" name="B1"></p>
</form>];
	}

$searchbox_code = qq[
<form method="POST">
<textarea rows="4" name="S1" cols="69">$searchbox</textarea>
</form>
];



if ($gsettings->{dyn_stat} eq "Static")
	{
	$whatsnew = "$web_url/new/";
	$tophits = "$web_url/pop/";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}
	else
	{
	$whatsnew = "$script_url/dirs.cgi?newpop=new";
	$tophits = "$script_url/dirs.cgi?newpop=pop";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}


$jspopup_code = acs::get_popupjs;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek Startup Wizard</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
.style1 {color: #999999}
-->
</style>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>

<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="11%" align="center" valign="top" bgcolor="#FFFFFF"><p><img src="$web_url/ic_bldir.gif" width="55" height="55" /><br />
        <span class="style1"><strong>Step 1 </strong><br />
        Add Categories 
        &amp; <br />
        Links</span></p>
      <p><span class="style1"><strong><img src="$web_url/ic_blfp.gif" width="66" height="55" /><br />
        Step 2 </strong><br />
        Setup &amp; Configure<br />
      Front Page</span></p>
    <p><strong><img src="$web_url/ic_wiz3.gif" width="66" height="55" /></strong><br />
      <strong>Step 3 </strong><br /> 
      Implement a Global <br />
      Template</p>

<BR>
<hr noshade size="1" color="#E4E4E4">
<p>
<a href="$admin_url/startup.cgi">Step 1</a><br />
<a href="$admin_url/startup.cgi?fct=step2">Step 2</a><br />
<a href="$admin_url/startup.cgi?fct=step3">Step 3</a><br />
</p>
<hr noshade size="1" color="#E4E4E4">

    </td>

    <td width="89%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td background="$web_url/bar6.gif"><strong class="normaltext">PowerSeek Startup Wizard Step 3 </strong></td>
        </tr>
      <tr>
        <td valign="top" class="normaltext"><blockquote>
          <p><strong>Upload a Global Template </strong></p>
          <p>In this section we will upload a Global Template (Normal HTML) file to implement your own look and feel throughout all PowerSeek templates. Keep in mind that the instructions below could have been written in a couple of sentences but it has been written in as much detail as possible so that it's easy to understand and to cover every detail.</p>
          <p>&nbsp;</p>
          <p><strong>Step 1: Create an HTML file that will serve as a frame or template</strong></p>
          <blockquote>
            <p>Create a <strong>normal HTML</strong> file with your <strong>Web Editor.</strong> This file could contain your design layout, company logo, navigational
              buttons, headers, footers, links, etc. This file will be the master template that will be implemented to give all end-user PowerSeek pages the same look and feel. </p>
            <p><strong>Note that this HTML file will need to contain the following links:</strong><br />
              (You will need to place the links listed below in the HTML file you create that is going to serve as the master template)</p>
              <blockquote>
                <p><strong>What's New: </strong><br />
                  This is the link that end users can click to see the latest additions to the Search Engine &amp; Directory. </p>
                <ul>
                  <li><a href="$whatsnew" target="_blank">$whatsnew</a></li>
                </ul>
                <p><strong>Most Popular: (Also Referred to as 'Top Hits')</strong><br />
                  This is the link that end users can click to see the most Popular links in the Search Engine &amp; Directory. </p>
                <ul>
                  <li><a href="$tophits" target="_blank">$tophits</a></li>
                </ul>
                <p><strong>Login</strong>:<br />
                  This is the login link that end users can click to log into their  accounts to submit or modify  links.</p>
                <ul>
                  <li><a href="$rgs_login" target="_blank">$rgs_login</a></li>
                </ul>
                <p><strong>Register</strong>:<br />
                  This is the link that end users can click to register an account to submit a new link.</p>
                <ul>
                  <li><a href="$register" target="_blank">$register</a></li>
                </ul>
                <p><strong>Advanced Search <br />
                              </strong>This link can be clicked to do an Advanced Search on the Search Engine &amp; Directory.</p>
                <ul>
                  <li><a href="$advanced_search" target="_blank">$advanced_search</a></li>
                </ul>
                <p><strong>Favorites:</strong><br />
                  This is the link end users can click to view their 'Favorite' links.  The favorite links can be added when clicking the 'Add to Favorites'  button or link next to each link when browsing the Search Engine &amp; Directory.</p>
                <ul>
                  <li><a href="$favorites" target="_blank">$favorites</a></li>
                </ul>
                <p><strong>Add URL: </strong><br />
                  This is the link that can be clicked to submit a new link.</p>
                <ul>
                  <li><a href="$add_url" target="_blank">$add_url</a></li>
                </ul>
                <p><strong>Add Premium URL:<br />
                              </strong>This is the link that can be clicked to submit a new premium link.</p>
                <ul>
                  <li><a href="$add_url_premium" target="_blank">$add_url_premium</a></li>
                  </ul>
                <p><strong>Contact Us:<br />
                </strong>This is the link to the contact form.</p>
                <ul>
                  <li>
                    <p><a href="$script_url/addurl.cgi?p=1" target="_blank">$script_url/contact.cgi</a></p>
                  </li>
                </ul>
              </blockquote>
              <BR>
              <p><strong>Search Box HTML Code:</strong><br />
              (Place the search box HTML code inside the HTML file you create. It will serve as the Search Box of your Search Engine &amp; Directory)</p>
            <p>$searchbox_code</p><BR><BR>
            <p><strong>The HTML file you create could for example look something like this: </strong></p>
            <p><img src="$web_url/wiz1.jpg" width="782" height="610" border="1" /></p>
            </blockquote>
          <br />
          <p>&nbsp;</p>
          <p><strong>Step 2 - Add !!pagetitle!! word to HTML file</strong></p>
          <blockquote>
            <p> You should now have created an<strong> HTML file</strong> that will act as the master template that will be used.</p>
            <p> Now open the <strong>HTML file</strong> and between the <strong>&lt;TITLE&gt; </strong>tags place the word <strong>!!pagetitle!!</strong></p>
            <p> This word will be replaced by the 'Titles' of PowerSeek templates or PowerSeek pages being viewed by end users.</p>
          </blockquote>
          <p>&nbsp;</p>
          <p><strong>Step 3 - Place the words !!psdata!! inside the HTML file you created.</strong></p>
          <blockquote>
            <p> Now insert the word<strong> !!psdata!!</strong> inside the<strong> HTML file. !!psdata!! </strong>will be replaced by PowerSeek functions &amp; options when your template (HTML file) has been implemented. Functions like displaying links inside categories, login screens, end user control panels, etc. will replace <strong>!!psdata!!</strong> when your template (HTML file) has been implemented.</p>
            <p> The HTML file you create could for example look something like this:</p>
            <p><img src="$web_url/wiz2.jpg" width="782" height="610" border="1" /></p>
            <p><strong><a href="$admin_url/startup.cgi?fct=sampletmpl"
			onclick="popup('$admin_url/startup.cgi?fct=sampletmpl',950,650);return false;">Click Here</a></strong> for another example of how the file could look like. </p>
          </blockquote>
          <p>&nbsp;</p>
          <p><strong>Step 4 - Correctly link up images</strong></p>
          <blockquote>
            <p> You must reference images inside your <strong>HTML file (template)</strong> with the full path to where the images are situated. In other words, upload the images to your web site. Then view/edit the source of the <strong>HTML file</strong> you created and supply the <strong>full URL paths</strong> to where you <strong>uploaded the images on your web site - for all images.</strong><br />
                  <br />
                <strong>For example:</strong></p>
            <p> <strong>&lt;img src=&quot;someimage.gif&quot;&gt;</strong> will not work.<br />
                  <br />
              You have to indicate the entire URL where <strong>someimage.gif </strong>is located. <strong>For example:</strong><br />
                  <br />
                  <strong>&lt;img src=&quot;http://$ydomain/someimage.gif&quot;&gt;</strong><br />
              <br />
              The <strong>&lt;img</strong>  is an HTML tag indicating that you want to insert an image in the <strong>HTML page</strong>. The <strong>src=</strong> part indicates where the <strong>location </strong>of the image is situated. Some Web Editors will support inserting images from a web url and some won't. If your Web Editor does not support this, insert the image into the HTML page like usual and when finished, edit the the HTML source code and <strong>manually insert the URL path's to the images. </strong>Ensure that the images are on the server for the URL path's you specify.</p>
            <p><strong> Example: Editing the HTML source code:</strong></p>
            <p> Replace <strong>&lt;img src=&quot;someimage.gif&quot;&gt;</strong> with<br />
              <strong>&lt;img src=&quot;http://$ydomain/someimage.gif&quot;&gt;</strong></p>
          </blockquote>
          <p>&nbsp;</p>
          <p><strong>Step 5: Style Sheet</strong></p>
          <form method="post" action="$admin_url/p_tmpglobal.cgi" enctype="multipart/form-data">
            <blockquote>
              <p>The style sheet below will be used inside all templates generated by this wizard.       If you are not familiar with style sheets then just ignore this step.       You are welcome to change anything regarding the style sheet below. All the PowerSeek texts/functions       will be using the styles as indicated below.<br />
                <strong>$web_url/globalstyle.css</strong></p>
              <p>
                <textarea name="stylesheet" cols="120" rows="20" id="stylesheet">/*The page_heading style is used for text indicating the heading of pages*/
.page_heading {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_title style is used to display titles of link listings*/
.link_title {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_description style is used to display descriptions of link listings*/
.link_description {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: #333333;
	font-weight: normal;
    line-height: 18px;
}

/*The link_url style is used to display URLs with link listings*/
.link_url {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: normal;
	color: #808080;
}

/*The ratings_votes style is used to display ratings/votes with link listings*/
.ratings_votes {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: normal;
	color: #808080;
}

/*The link_functions style is used to display link functions wiht links like 'Rating it', 'Comments', 'More Info'*/
.link_functions {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_border is used to define a border for tables displaying links*/
.link_border {
	border: 1px solid #DFDFDF;
}

/*The user_comments is used to display user comments to link listings*/
.user_comments {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: #333333;
	font-weight: normal;
    line-height: 18px;
}


/*The from_category style is used when displaying categories with links*/
.from_category {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: normal;
}

/*The relevance style is used when displaying match relevance with search results*/
.relevance {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_approval_status style is used to indicate a links approval status (approved for inclussion in the Index or not)*/
.link_approval_status {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
	color: #0000FF;
}

/*The link_premium_indicate style is used to indicate premium links inside the user control panel*/
.link_premium_indicate {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
	color: #FF0000;
}

/*The parahraph style is used for any other texts displayed on end user PowerSeek pages*/
.plain_text {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}


/*The parahraph style is used for any other texts displayed on end user PowerSeek pages*/
p {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
				
				
				 </textarea>
              </p>
              <p>
                <input name="usecss" value="Y" checked="checked" type="checkbox" />
                Un-tick this box if you don't want to  use the style sheet above.</p>
              <p>&nbsp;</p>
              </blockquote>
            <p><strong>Step 6 - Upload the HTML file you created.</strong></p>
            <blockquote>
              <p>After you have uploaded the HTML file, all templates used by PowerSeek will be updated with        the HTML file you uploaded. In other words, the HTML file you uploaded will be used as a      frame for all pages that your end-users will view when browsing or using your Search Engine &amp; Directory. </p>
              <p><strong>Warning: </strong>Uploading  your HTML file will replace any previous templates. In other words, if  you have made changes to the existing templates then it will be lost.  You can always go back to the factory default templates that was  available when PowerSeek was first installed. An option will be provided to return to the 'PowerSeek factory default template set' after you uploaded the HTML file you just created. </p>
              <p><strong>Upload the HTML file you created that will act as the master template: </strong></p>
              <p>
                <input name="attatch1" size="50" type="file" />
                          </p>
              <p>
                <input value="   Upload   " name="B1" type="submit" class="psbutton" />
                          <input name="fct" type="hidden" id="fct" value="implement" />
                          <input name="wizard" type="hidden" id="wizard" value="y" />
              </p>
              <p><strong>Please read the notes below before Importing the HTML file you just created</strong><strong>.</strong></p>
            </blockquote>
            </form>
          <p>&nbsp;</p>
          <p><strong>Notes on the importation of a master templates </strong></p>
          <ul>
            <li>You can use <strong><a href="$admin_url/admin17.cgi"
            onclick="popup('$admin_url/admin17.cgi',750,650);return false;">Template Includes</a></strong> in the <strong>uploaded HTML file</strong>  to have <strong>headers, footers, left menu's, right menu's,</strong> etc. A '<strong>header</strong>' <strong>Template Include</strong> can for example be <strong>edited/altered</strong> and the header will <strong>automatically be changed throughout all the PowerSeek templates. </strong>It is recommended you use Template Includes with the HTML file you upload as it will make changing the header or any other  <strong>links or graphics in headers/footers/menu's</strong> an easy task. Refer to the <strong><a href="#ti">Template Include Implementation Instructions</a></strong> below to use<strong> Template Includes</strong> inside the <strong>HTML file</strong> you upload here. </li>
            <li>You can also use your own <strong>CSS style sheets</strong> with the <strong>HTML file</strong> you upload here. If  your style sheets are going to be in a seperate .css file then you will  need to use a full URL path to the .css file where it is declared  inside the HTML file between the &lt;HEAD&gt; tags. (Just like you  linked images inside the HTML file with full URL paths.)</li>
            <li>If you run a Static Directory where files are generated then you will need to generate the HTML files for the links to work when you click categories from the Front Page of your Directory. You can generate HTML files by going to the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/todo.cgi" target="_blank">To Do</a> &gt;&gt; <a href="$admin_url/admin8.cgi" onclick="popup('$admin_url/admin8.cgi',750,650);return false;" >Generate HTML Files</a></li>
          </ul>
          <p>&nbsp;</p>
          <p><strong><a name="ti" id="ti"></a>Template Include Implementation Instructions:</strong></p>
          <blockquote>
            <p>With this instructions we will create a header 'Template Include' and place the 'Template Include' inside the file you upload here.</p>
            <p><strong>Step 1:  </strong></p>
            <blockquote>
              <p>Go to the <strong><a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin17.cgi" onclick="popup('$admin_url/admin17.cgi',750,650);return false;">Create/Edit Template Includes</a></strong></p>
            </blockquote>
            <p><strong>Step 2:</strong></p>
            <blockquote>
              <p>Scroll down to the section reading: '<strong>Add a New Template Include:'</strong></p>
              <p>Specify a<strong> Name</strong> for the 'Template Include' where you are asked for a <strong>Name.</strong> In this example we will use <strong>myheader</strong></p>
              <p>From the HTML file (the one you are going to upload here) <strong>copy</strong>  the HTML source code of the <strong>header</strong> and <strong>paste</strong> the HTML source code in the section asking you for '<strong>Template Include HTML      Code:'. </strong>Now click the <strong>'Add New Template Include' button.</strong></p>
              <p><strong><a href="$admin_url/startup.cgi?fct=header"
			onclick="popup('$admin_url/startup.cgi?fct=header',950,650);return false;">Click Here</a></strong> to see an example of how your header could look like. </p>
            </blockquote>
            <p><strong>Step 3:</strong></p>
            <blockquote>
              <p>We have now created a 'Template Include' called <strong>myheader</strong> - Now place <strong>%%incl_myheader%% </strong>into the HTML file you are about to upload in this section. In other words, you will replace the existing header with <strong>%%incl_myheader%% - </strong>After doing this scroll up and upload the HTML file you created as instructed in this step of the Wizard. You can change/alter the header at any time by going to the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin17.cgi" onclick="popup('$admin_url/admin17.cgi',750,650);return false;">Create/Edit Template Includes</a> &gt;&gt; Choose to edit the <strong>'myheader' Template Include.</strong> </p>
              <p><strong><a href="$admin_url/startup.cgi?fct=headerinc" onclick="popup('$admin_url/startup.cgi?fct=headerinc',950,650);return false;">Click Here</a></strong> to see an example of how the template could look like with the <strong>myheader</strong> include.</p>
            </blockquote>
          </blockquote>
          <form id="form1" name="form1" method="post" action="$admin_url/startup.cgi">
          <input name="fct" type="hidden" value="step2" />
            <label>
            <br /><br />
            <input type="submit" class="psbutton" name="Submit2" value="     &lt;&lt; Go Back     " />
            </label>
          </form>
          <p>&nbsp;</p>
        </blockquote>        </td>
      </tr>
    </table></td>
  </tr>
</table>

</body>
</html>
];

}




sub step2
{

	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$ydomain = $domain_items[2];
	
$gsettings = new_gsettings acs;


########

@domain_items = split (/\//, $script_url);
$domain_name = $domain_items[2];

$dcntr = 0;
foreach $ditem (@domain_items)
	{
		if ($dcntr > 2)
			{
			$domain_items = $domain_items . "/" . $ditem;
			}
	$dcntr++;
	}

#######

$frontpage_iframe = qq[<iframe width="100%" id="display_fpiframe" 
onLoad="getFPHeight();" 
src=""
scrolling="NO" 
frameborder="0" 
height="50">An iframe capable browser is 
required to view this web site.
</iframe>
<script language="JavaScript">
function GetDomain(url) 
{ return url.match(/:\\/\\/(.[^/]+)/)[1]; }
function getFPHeight() {
var the_height = document.getElementById('display_fpiframe').contentWindow.document.body.scrollHeight;
document.getElementById('display_fpiframe').height = the_height;
}
var realurl = 'http://' + GetDomain(document.URL) + '$domain_items/fpif.cgi';
document.getElementById('display_fpiframe').src = realurl;
</script>
];



if ($gsettings->{dyn_stat} eq "Static")
	{
	$whatsnew = "$web_url/new/";
	$tophits = "$web_url/pop/";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}
	else
	{
	$whatsnew = "$script_url/dirs.cgi?newpop=new";
	$tophits = "$script_url/dirs.cgi?newpop=pop";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}

	
$jspopup_code = acs::get_popupjs;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek Startup Wizard</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
.style1 {color: #999999}
-->
</style>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>

<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="11%" align="center" valign="top" bgcolor="#FFFFFF"><p><img src="$web_url/ic_bldir.gif" width="55" height="55" /><br />
        <span class="style1"><strong>Step 1 </strong><br />
        Add Categories 
        &amp; <br />
        Links</span></p>
      <p><span class="style1"><strong><img src="$web_url/ic_wiz2.gif" width="66" height="55" /><br />
        </strong></span><strong>Step 2 </strong><br />
        Setup &amp; Configure<br />
      Front Page</p>
    <p><strong><img src="$web_url/ic_bltmpl.gif" width="66" height="55" /></strong><br />
      <span class="style1"><strong>Step 3 </strong><br /> 
      Implement a Global <br />
      Template</span></p>
<BR>
<hr noshade size="1" color="#E4E4E4">
<p>
<a href="$admin_url/startup.cgi">Step 1</a><br />
<a href="$admin_url/startup.cgi?fct=step2">Step 2</a><br />
<a href="$admin_url/startup.cgi?fct=step3">Step 3</a><br />
</p>
<hr noshade size="1" color="#E4E4E4">
      
    </td>

    <td width="89%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td background="$web_url/bar6.gif"><strong class="normaltext">PowerSeek Startup Wizard Step 2</strong></td>
        </tr>
      <tr>
        <td valign="top" class="normaltext"><blockquote>
          <p><strong>Set up the Front Page of your Directory </strong></p>
          <p>Note that there are other methods for setting up your Front Page but for this Wizard we will use the most basic and easiest method.</p>
          <p>&nbsp;</p>
          <p><strong>Step 1 - Configure category displays for Front Page</strong></p>
          <blockquote>
            <p><a href="$admin_url/admin26.cgi?fct=fp_generate0&amp;fpmeth=iframe" onClick="popup('$admin_url/admin26.cgi?fct=fp_generate0&amp;fpmeth=iframe',screen.width-200,screen.height-200);return false;"><strong>Click Here</strong></a> to configure the way categories will be displayed on your Front Page. When you have set the options you would like changed click the <strong>'Next' button.</strong> After that close the popup Window and come back to this section.</p>
            <blockquote>
              <p><strong>Side  Note:</strong> <br />
                You can also get to the section where you configure the way categories are displayed from the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/todo.cgi" target="_blank">To Do</a> &gt;&gt; <a href="$admin_url/admin26.cgi"
				
				onClick="popup('$admin_url/admin26.cgi',screen.width-200,screen.height-200);return false;"
				>Generate Front Page</a> &gt;&gt; Choose the IFRAME option and click the <strong>Next</strong> button. Keep in mind that there are a couple of ways to create/setup your front page for flexibility and different scenarios. </p>
            </blockquote>
            <p>&nbsp;</p>
          </blockquote>
          <p><strong>Step 2 - Create a Web Page that will act as your Front Page</strong> </p>
          <blockquote>
            <p>Now use your <strong>Web Editor</strong> to create a <strong>web page</strong> that will serve as the Front Page of your Directory.</p>
            <p>This <strong>web page</strong> can contain your<strong> logo, graphics,  layout, front page greeting, etc. </strong></p>
            <p>In this example we will call your Front Page <strong>index.html</strong> and assume you will upload it to: <strong>http://$ydomain</strong></p>
            <p>After creating a front page (index.html for example), insert the following HTML code where you want the main categories of your Directory to display:<br />
            (The code below will display the main categories of your Directory) </p>
          </blockquote>
          <form id="form2" name="form2" method="post" action="">
            <label>
              <blockquote>
                <p name="textarea" cols="90" rows="5">
                  <textarea name="textarea" cols="70" rows="18">$frontpage_iframe</textarea>
                </p>
              </blockquote>
            </label>
          </form>
          <blockquote>
            <p><strong>Note that you may want to adjust the following options inside the code above:</strong></p>
            <blockquote>
              <p> <strong>width=&quot;100%&quot;</strong> - You can change this to fit the width area where you want categories to display on your front page. If you take away the percentage sign then the browser will interpret it as pixel width. </p>
              <p><strong>height=&quot;100%&quot; </strong>- You can change this to fit the height area where you want categories to display on your front page. If you take away the percentage sign then the browser will interpret it as pixel height. </p>
              <p>&nbsp;</p>
            </blockquote>
          </blockquote>
          <p><strong>Step 3 - Insert Search Box into Front Page</strong> </p>
          <blockquote>
            <p>Now insert the following HTML code into the <strong>Front Page (index.html for example)</strong> that you created with your <strong>Web Editor</strong> where you want the <strong>Search Box</strong> to apear on your Front Page:</p>
          </blockquote>
          <form id="form3" name="form3" method="post" action="">
            <label>
              <blockquote>
                <p name="textarea2" cols="70" rows="3">
                  <textarea name="textarea2" cols="70" rows="3">&lt;form method=&quot;POST&quot; action=&quot;$script_url/search2.cgi&quot;&gt;
  &lt;p&gt;&lt;input type=&quot;text&quot; name=&quot;keywords&quot; size=&quot;33&quot;&gt;&lt;input type=&quot;submit&quot; value=&quot;Search&quot;
  name=&quot;search&quot;&gt; &lt;a href=&quot;$script_url/searchadv.cgi&quot;&gt;Advanced&lt;/a&gt;&lt;/p&gt;
&lt;/form&gt;</textarea>
                  <br />
                  <strong>Note:</strong> You are welcome to customize the HTML code above to give the Search Box another look and feel. </p>
              </blockquote>
            </label>
          </form>
          <p>&nbsp;</p>
          <p><strong>Step 4 - Insert Links to PowerSeek functions in Front Page </strong></p>
          <p>Now add the following links to the Front Page. These are links to the PowerSeek functions where users can Register Accounts, Add URLs, etc. </p>
          <blockquote>
            <p><strong>What's New: </strong><br />
              This is the link that end users can click to see the latest additions to the Search Engine &amp; Directory. </p>
            <ul>
              <li><a href="$script_url/dirs.cgi?newpop=new" target="_blank">$script_url/dirs.cgi?newpop=new</a></li>
            </ul>
            <p><strong>Most Popular: (Also Referred to as 'Top Hits')</strong><br />
              This is the link that end users can click to see the most Popular links in the Search Engine &amp; Directory. </p>
            <ul>
              <li><a href="$script_url/dirs.cgi?newpop=pop" target="_blank">$script_url/dirs.cgi?newpop=pop</a></li>
            </ul>
            <p><strong>Login</strong>:<br />
              This is the login link that end users can click to log into their  accounts to submit or modify  links.</p>
            <ul>
              <li><a href="$script_url/rgs_login.cgi" target="_blank">$script_url/rgs_login.cgi</a></li>
            </ul>
            <p><strong>Register</strong>:<br />
              This is the link that end users can click to register an account to submit a new link.</p>
            <ul>
              <li><a href="$script_url/rgs_register.cgi" target="_blank">$script_url/rgs_register.cgi</a></li>
            </ul>
            <p><strong>Advanced Search <br />
            </strong>This link can be clicked to do an Advanced Search on the Search Engine &amp; Directory.</p>
            <ul>
              <li><a href="$script_url/searchadv.cgi" target="_blank">$script_url/searchadv.cgi</a></li>
            </ul>
            <p><strong>Favorites:</strong><br />
              This is the link end users can click to view their 'Favorite' links.  The favorite links can be added when clicking the 'Add to Favorites'  button or link next to each link when browsing the Search Engine &amp;  Directory.</p>
            <ul>
              <li><a href="$script_url/fav.cgi" target="_blank">$script_url/fav.cgi</a></li>
            </ul>
            <p><strong>Add URL: </strong><br />
              This is the link that can be clicked to submit a new link.</p>
            <ul>
              <li><a href="$script_url/addurl.cgi" target="_blank">$script_url/addurl.cgi</a></li>
            </ul>
            <p><strong>Add Premium URL:<br />
            </strong>This is the link that can be clicked to submit a new premium link.</p>
            <ul>
              <li><a href="$script_url/addurl.cgi?p=1" target="_blank">$script_url/addurl.cgi?p=1</a></li>
              </ul>
            <p><strong>Contact Us:<br />
            </strong>This is the link to the contact form.</p>
            <ul>
              <li>
                <p><a href="$script_url/addurl.cgi?p=1" target="_blank">$script_url/contact.cgi</a></p></li></ul>
            <br />
          </blockquote>
<p><strong>Step 5 - Example </strong></p>
          <blockquote>
            <p><a href="$admin_url/startup.cgi?fct=frontp"
		  onClick="popup('$admin_url/startup.cgi?fct=frontp',screen.width-200,screen.height-200);return false;"><strong>Click Here</strong></a> to see an example of how the Front Page you create could look like. Remember that this is an ordinary web page that you create and upload so that it's available from: <strong>http://$ydomain</strong> for example. The categories are pulled or placed into the Front Page by the HTML code provided to you in Step 2. The Search Box is the HTML code provided to you in step 3. </p>
          </blockquote>
          <p>&nbsp;</p>
          <p><strong>Step 6 - Upload Front Page</strong></p>
          <blockquote>
            <p>Now <strong>upload the Front Page (index.html for example) you have created</strong> so that you can load it from <strong>http://$ydomain</strong> for example. After you have uploaded the front page web page you have just created, load it inside your browser and you will see your front page with categories and search box.</p>
            <p><strong>Notes:</strong></p>
            <blockquote>
              <p>If you run a Static Directory where files are generated then you will need to generate the HTML files for the links to work when you click categories from the Front Page. You can generate HTML files by going to the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/todo.cgi" target="_blank">To Do</a> &gt;&gt; <a href="$admin_url/admin8.cgi" onclick="popup('$admin_url/admin8.cgi',screen.width-200,screen.height-200);return false;">Generate HTML Files</a><a href="$admin_url/admin26.cgi?fct=update_frontpage" onclick="popup('$admin_url/admin26.cgi?fct=update_frontpage',screen.width-200,screen.height-200);return false;"></a></p>
            </blockquote>
          </blockquote>
          <p>&nbsp;</p>
          <form id="form1" name="form1" method="post" action="$admin_url/startup.cgi">
            <br />
            <input type="submit" class="psbutton" value="     &lt;&lt; Go Back     " name="B1"  onClick="history.go(-1); return false;"> 
            <input type="submit" class="psbutton" name="Submit" value="Next - Continue to Step 3 &gt;&gt;" />
            <input name="fct" type="hidden" value="step3" />
          </form>
          <p>&nbsp;</p>
        </blockquote>        </td>
      </tr>
    </table></td>
  </tr>
</table>
</body>
</html>
];


}





sub step1
{

print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek Startup Wizard</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
.style1 {color: #999999}
-->
</style>
</head>
<body>

<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="11%" align="center" valign="top" bgcolor="#FFFFFF"><p><img src="$web_url/ic_wiz1.gif" width="55" height="55" /><br />
      <strong>Step 1 </strong><br />
        Add Categories 
        &amp; <br />
        Links</p>
      <p class="style1"><strong><img src="$web_url/ic_blfp.gif" width="66" height="55" /><br />
        Step 2 </strong><br />
        Setup &amp; Configure<br />
      Front Page</p>
    <p><strong><img src="$web_url/ic_bltmpl.gif" width="66" height="55" /></strong><br />
      <span class="style1"><strong>Step 3 </strong><br /> 
      Implement a Global <br />
      Template</span></p>
<BR>
<hr noshade size="1" color="#E4E4E4">
<p>
<a href="$admin_url/startup.cgi">Step 1</a><br />
<a href="$admin_url/startup.cgi?fct=step2">Step 2</a><br />
<a href="$admin_url/startup.cgi?fct=step3">Step 3</a><br />
</p>

      
    </td>
    <td width="89%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td background="$web_url/bar6.gif"><strong class="normaltext">PowerSeek Startup Wizard Step 1</strong></td>
        </tr>
      <tr>
        <td valign="top" class="normaltext"><blockquote>
          <p>Follow the 3 steps in this Wizard to build your Directory in the shortest time possible. </p>
          <p>To get started we first need to add categories/directories and links. To add categories and links, <a href="$admin_url/admin2.cgi" target="_blank">click here</a>. The link to the left will open a new window and will take you to the <strong>PowerSeek Control Panel &gt;&gt; Dir Manager</strong> where you can add categories by clicking the <strong>'Add Dir'</strong> or <strong>'Add Multiple Dirs'</strong> button. Once a main category has been added you can click on it to enter it. When you entered a main category you can add links by clicking the <strong>'Add Links'</strong> or <strong>'Add Multiple Links'</strong> buttons. When you have added some categories and links, come back to this <strong>Wizard</strong> to continue to step 2 of this Wizard. </p>
          <p><strong>Additional Notes for the adding of Links: </strong></p>
          <ul>
            <li>There is an <strong>ODP (Open Directory Project) Importer</strong> available to import links from the <strong>ODP</strong>. This function is available to you when clicking the <strong>'ODP' button</strong> when inside any category from the <a href="$admin_url/admin2.cgi" target="_blank">Dir Manager</a>. </li>
            <li>There is also an <a href="$admin_url/p_import.cgi" target="_blank">Importer Plugin</a> available where you can import links with categories from a CSV file or flatfile text file. </li>
            <li>There is also a crawler available to fetch Titles, Meta Descriptions and Meta Keywords of web sites. The crawler can be accessed by clicking the <strong>'Crawl' button</strong> when inside any category from the <a href="$admin_url/admin2.cgi" target="_blank">Dir Manager</a></li>
            </ul>
          <form id="form1" name="form1" method="post" action="$admin_url/startup.cgi">
            <label><br />
            <input type="submit" class="psbutton" name="Submit" value="Next - Continue to Step 2 &gt;&gt;" />
            </label>
            <input name="fct" type="hidden" id="fct" value="step2" />
          </form>
          <p>&nbsp;</p>
        </blockquote>
        </td>
      </tr>
    </table></td>
  </tr>
</table>

</body>
</html>

];

}





###################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


