#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local; 


$q = CGI->new;
&get_setup;


if ($ENV{'HTTP_USER_AGENT'} eq "")
	{
	&build_sshtelnet; exit;
	}


#### IF WEB BASED UPGRADE
print "Content-type: text/html\n\n";
&uptop;

if ($q->param('fct') eq "import_data"){&import_data; exit;}

###################

if ($q->param('fct') eq "upgrade"){&start;}
if ($q->param('fct') eq ""){&start;}

####################

print "</body></html>";

#####################


sub build_sshtelnet
{

print "\n\n\nPlease Type the full server path to \nthe 'data' directory of Turbo Seek Version 1.x:\n";
$data_dir_v1 = <STDIN>; $data_dir_v1 =~ s/\n//g; 
$crit = chr(13); $data_dir_v1 =~ s/$crit//g; 
$crit = chr(10); $data_dir_v1 =~ s/$crit//g; 

if ((-e "$data_dir_v1") < 1){print "\n\nThe directory you specified does'nt exist. Exiting... \n\n";}

if ((-e "$data_dir_v1/dtable.idx") < 1){print "\n\nIt looks like the files inside the directory you specified is not the Turbo Seek ver 1.x data files.\n\n";}


#################

open (DTABLE11, "$data_dir_v1/dtable.idx");
	while (defined($dtable_line=<DTABLE11>))
	{
	($tmpid, $catname) = split (/:/, $dtable_line);

	$fullcatname = $catname;
	$dcatname = &decode_dir ($fullcatname);
	
	print "Importing: $dcatname\n";
	&import_links ($fullcatname);
	}
close (DTABLE11);

print "\n\nImport Complete.\n\n";

}





sub import_links
{

my ($link_loc) = @_;

my ($current_lnk, $current_hts, $decoded_link_loc, $levels, @categories, @all_links, @current_hts, @meta_data, 
	 $linknrs, @akeys, @row, $key_import_string, $item, $shortname, $sql, @litems, $crit, $ccnt,
	 $current_meta, $lvcount, $cat, $level_name, $ms, $sth, $dbh, $serror, $last_cid,
	 $keydata, $keynr, $keyname, $kitem, $visible, $size, $searched, $description, @allreviews, 
	 $TimeInSeconds, $mday, $mon, $year, $lcnt, $dsn, $rev_count, $current_rvw_data, @reviews, 
	 $rev_item, $rev_name, $rev_email, $rev_date, $old_cid, $ts_field_count, $bindcount, $ritems, $time,
	 $sqlr, $nowsql, $cidrow, $bdir, $link_reviews, $rev_review, $old_lnkid
	 );

$link_loc =~ s/\n//g;
$crit = chr(13); $link_loc =~ s/$crit//g; 
$crit = chr(10); $link_loc =~ s/$crit//g;

#### GET CATEGORY INFO

@categories = split (/\//, $link_loc);

$ccnt = 0;
foreach $item (@categories)
	{
	$categories[$ccnt] = &decode_dir ($item);
	$ccnt++;
	}

$levels = @categories;

$shortname = $categories[$levels-1];

$fullcatname =~ s/\n//g;

#### GET LINKS TO BE IMPORTED

$current_lnk = &get_file_contents2("$data_dir_v1/$fullcatname/contents.txt");
@all_links = split (/\n/, $current_lnk);
$linknrs = @all_links;

$current_hts = &get_file_contents2("$data_dir_v1/$fullcatname/hits.dat");
@current_hts = split (/\n/, $current_hts);

$current_meta = &get_file_contents2("$data_dir_v1/$fullcatname/metatag.txt");
@meta_data = split (/\n/, $current_meta);

#### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#### CREATE CATEGORIES

$shortname =~ s/'/\\'/g;
$meta_data[0] =~ s/'/\\'/g;
$meta_data[1] =~ s/'/\\'/g;

$sql = "INSERT INTO dirs SET level = '$levels', shortname = '$shortname', description = '$meta_data[0]', keywords = '$meta_data[1]', ";

$lvcount = 1;
foreach $cat (@categories)
	{
	$cat =~ s/'/\\'/g;
	
	$level_name = "l" . $lvcount;
	
	$sql = $sql . " $level_name = '$cat',";
	
	$lvcount++;
	}

for ($ms = $lvcount; $ms < 17; $ms++)
	{
	$level_name = "l" . $ms;
	$sql = $sql . " $level_name = '',";
	}

chop ($sql);

#print "==> $sql \n\n\n"; sleep (3);

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


#### GET LAST CID

$sth = $dbh->prepare("SELECT cid FROM dirs WHERE cid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() )	
	{
	$last_cid = $row[0]; 
	}



#### GET KEYS IF ANY

$keydata = &get_file_contents2("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$keynr = @akeys;

$key_import_string = ""; $keyname = "";
if ($keynr > 0)
{
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description) = split (/\t/, $kitem);
	$keyname = $keyname . "_cust";
	$key_import_string = $key_import_string . ",$keyname = ?";
	}
}


#### IMPORT LINKS

$sql = qq{INSERT INTO links SET   cid = ?,
											 title = ?,
											 description = ?,
											 keywords = ?,
											 url = ?,
											 rating = ?,
											 votes = ?,
											 hits = ?,
											 premium = ?,
											 urldate = ?,
											 extf2 = ?,
											 rev_no = ?,
											 lnkpassword = ?
											 $key_import_string
			 };


$sth = $dbh->prepare($sql);
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$lcnt = 0; $rev_count = 0; @allreviews = ("nothing");
foreach $item (@all_links)
	{
	
	@litems = split (/\[::\]/, $item);

	if ($litems[1] ne "")
	{

		if (($litems[8] ne "") and ($litems[8] =~ /-/))
			{
			($year, $mon, $mday) = split (/-/, $litems[8]);
			$mon = $mon - 1;
			
				eval { $TimeInSeconds = timegm(0,0,0,$mday,$mon,$year); }; #warn $@ if $@;
 				if ($@)
 					{
 					$TimeInSeconds = time();
 					$@ = "";
 					}  
			$litems[8] = $TimeInSeconds;
			}
			else
			{
			$litems[8] = time();
			}
	
	$litems[6] = $litems[6] + $current_hts[$lcnt];
	
	#if (length($litems[9]) > 0) { $litems[9] = "1"; }
	#($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = gmtime($TimeInSeconds);
	#$mon++;
	#print "$year / $mon / $mday <Br>";
	#print "==!>$litems[1] $litems[8] --- $TimeInSeconds"; exit;
	
	if ($litems[9] eq "Y")
		{
		$litems[9] = 1;
		}
		else
		{
		$litems[9] = 0;
		}
	
	$sth->bind_param(1, $last_cid); 				### CID
   $sth->bind_param(2, $litems[1]); 			### title
   $sth->bind_param(3, $litems[2]);				### description
   $sth->bind_param(4, $litems[10]);			### keywords
   $sth->bind_param(5, $litems[3]);				### url
   $sth->bind_param(6, $litems[4]);				### rating
   $sth->bind_param(7, $litems[5]);				### votes
   $sth->bind_param(8, $litems[6]);				### hits !!
   $sth->bind_param(9, $litems[9]);				### premium !!
   $sth->bind_param(10, $litems[8]);			### urldate !!
   
   $litems[0] = int($litems[0]);
	if ((-e "$data_dir_v1/$fullcatname/$litems[0].rvw") > 0)
		{
   	$sth->bind_param(11, $litems[0]);			### IF REVIEWS

		$current_rvw_data = &get_file_contents2("$data_dir_v1/$fullcatname/$litems[0].rvw");
		@reviews = split (/--=:_:=--/, $current_rvw_data);
				
				$link_reviews = 0;
				$rev_item =~ s/\n//g;
				
				foreach $rev_item (@reviews)
					{
					if (length($rev_item) > 3)
						{
						($rev_name, $rev_email, $rev_review, $rev_date) = split (/:-_-:/, $rev_item);
						$rev_review =~ s/\n/<br>/g;
						$rev_name =~ s/\n//g;
						$rev_date =~ s/\n//g;
						
						$crit = chr(13); $rev_review =~ s/$crit//g; $crit = chr(10); $rev_review =~ s/$crit//g;
						$crit = chr(13); $rev_name =~ s/$crit//g; $crit = chr(10); $rev_name =~ s/$crit//g;
						$crit = chr(13); $rev_date =~ s/$crit//g; $crit = chr(10); $rev_date =~ s/$crit//g;
					
						$allreviews[$rev_count] = 	 $litems[0] . "\t" . 
															 $old_cid . "\t" .
															 $rev_name . "\t" . 
															 $rev_email . "\t" . 
															 $rev_review . "\t" . 
															 $rev_date;
						$rev_count++;
						$link_reviews++;
						}
					}
			
		$sth->bind_param(12, $link_reviews);
   	}
   	else
   	{
   	$sth->bind_param(11, "0");
   	$sth->bind_param(12, "0");
   	}

	$sth->bind_param(13, $litems[7]); ### LINK PASSWORD
	
	#### KEYS
	if ($keynr > 0)
	{	
		$ts_field_count = 11;
		$bindcount = 14;
		foreach $kitem (@akeys)
			{
			($keyname, $visible, $size, $searched, $description) = split (/\t/, $kitem);
			$sth->bind_param($bindcount, $litems[$ts_field_count]);
			$bindcount++;
			$ts_field_count++;
			}
	}


   $sth->execute;
   $serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
   $lcnt++;
   }

}


#### INSERT REVIEWS IF ANY


if ($rev_count > 0)
 	{
 	$time = time();
 	
 	foreach $ritems (@allreviews)
 		{
 		($old_lnkid, $rv_cid, $rev_name, $rev_email, $rev_review, $rev_date) = split (/\t/, $ritems);
 		
 		#print $ritems . "\n";
 		#
 		$sql = "SELECT lnkid FROM links WHERE extf2 = '$old_lnkid'";
 		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		while ( @row = $sth->fetchrow() ) { $rev_linkid = $row[0];}
		
		$rev_name =~ s/'/\\'/g;
		$rev_email =~ s/'/\\'/g;
		$rev_review =~ s/'/\\'/g;
 		
 		$sqlr = "INSERT INTO reviews SET  lnkid = '$rev_linkid', 
 													 rname = '$rev_name', 
 													 remail = '$rev_email',
 													 review = '$rev_review',
 													 date = '$time',
 													 approved = 'Y'";
		$sth = $dbh->prepare($sqlr);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
 		}
 	
 	}



#### GET CATEGORY ID'S TO UPDATE LINK NUMBERS WITH

$bdir = ""; $nowsql = ""; $sql = ""; $cidrow = "";
if ($linknrs != 0)
	{
	$ccnt = 0;
	foreach $item (@categories)
		{
		$ccnt++;
		
		$bdir = $bdir . " (" . "l" . $ccnt . " = '$item') and";
		
		$nowsql = $bdir . " l" . ($ccnt + 1) . "= ''";
		
		$sql = "SELECT cid FROM dirs WHERE $nowsql";
		
		#print "==> $sql <br>";
		
		$sth = $dbh->prepare($sql);
	   $sth->execute;
	   $serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	   
  		while ( @row = $sth->fetchrow() )	
			{
			$cidrow = $cidrow . $row[0] . "-";
			}
		}

	}



############

$sth->finish;
$dbh->disconnect;

############


	if ($linknrs != 0)
	{
	chop($cidrow);
	$linknrs = acs::update_numbers ("+", $linknrs, $cidrow);
	}

}





sub import_data
{

### GET CURRENT LINE
if ($q->param('cline') eq "") 
	{
	$data_dir_v1 = $q->param('data_dir_v1');
	if ((-e "$data_dir_v1") < 1){&setup_problem("The full server path to the 'data' directory of Turbo Seek ver 1.0 you specified does not exist.");}

	$cline = 0;
	open (DTA, "> $data_dir/import.tmp");
		print DTA $data_dir_v1;
	close (DTA);
	}
	else
	{
	$data_dir_v1 = &get_file_contents2("$data_dir/import.tmp");
	$data_dir_v1 =~ s/\n//g;
	$cline = $q->param('cline');
	}


$lnc = 0;
open (DTABLE, "$data_dir_v1/dtable.idx");
	while (defined($line=<DTABLE>))
	{
	($tmpid, $catname) = split (/:/, $line);
		
		if ($lnc == $cline)
			{
			$fullcatname = $catname;
			$dcatname = &decode_dir ($fullcatname);
			&import_links ($fullcatname);
			#print "==> $catname <br>";
			}
		
	$lnc++;
	}
close (DTABLE);

$cline++;

if ($fullcatname eq "")
	{

print qq[
<p><strong>Import Complete!</strong></p>
<p><a href="$admin_url/admin.cgi">Click here to access the PowerSeek Control Panel</a></p>
</body>
</html>
];

	exit;
	}

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek Setup</title>
<style type="text/css">
<!--
p {
font-family: Arial;
line-height: : 20px;
font-size: 13px;
line-height: 18px;
}
-->
</style>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/upgrade.cgi?fct=import_data&cline=$cline">
</head>
<body>
<p><strong>Please Wait... </strong></p>
<p><strong>Importing: </strong>$dcatname </p>
</body>
</html>
];


}




sub get_file_contents2
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

$filesize = (-s "$filename");

open (TFILECNTS, "$filename");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);

return ($thefile);
}





sub start
{

print qq[
<form method="POST" action="$admin_url/upgrade.cgi">
  <table
      width="100%" border="0" cellpadding="10" cellspacing="1" bgcolor="#DFDFDF">
    <tr>
      <td bgcolor="#F8F8F8" colspan="2"><p><strong>Import Links From Turbo Seek:</strong></p></td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF"><p><strong>Specify the Full
      Server Path to the 'data' directory of Turbo Seek:</strong></p>        <input
      type="text" name="data_dir_v1" size="70" value="/home/yourdomain.com/data"> <input type="submit" class="psbutton" value="Next (Import Data)" name="B1"></td>
    </tr>
    
    <tr>
      <td colspan="2" bgcolor="#FFFFFF"><p>The above full server path you
        need to supply is the full server path to the 'data' directory of Turbo
        Seek. All links will be extracted from here and inserted in the MySQL database PowerSeek
      is using. </p></td>
    </tr>
  </table>
  <p>
    <input type="hidden" name="fct" value="import_data">
  </p>
</form>
];


}





sub uptop
{

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek Setup</title>
<style type="text/css">
<!--
p {
font-family: Arial;
line-height: : 20px;
font-size: 13px;
line-height: 18px;
}
-->
</style>
</head>

<body>

<p><strong><font face="Arial" size="4" color="#000000"><strong>Import Links From Turbo to PowerSeek
Seek</strong></font><font face="Arial" size="4"><br>
</font></strong><font color="#808080" face="Arial" size="2">To upgrade Turbo Seek to
PowerSeek</font></p>
<hr size="1" color="#DFDFDF">
];


}






sub setup_problem
{

my ($sproblem) = @_;

$refe = $ENV{'HTTP_REFERER'};

print qq[
<p><font face="Arial" size="4" color="#0000A0"><strong>Problem</strong></font></p>
<div align="center"><center>

<table border="0" cellpadding="10" cellspacing="0" width="100%" style="border: 1px dotted">
  <tr>
    <td bgcolor="#FFFFFF" width="963" height="17"><font face="Verdana" size="2">$sproblem</font></td>
  </tr>
  <tr>
    <td bgcolor="#F4F4F4" width="963" height="17"><font color="#000000" face="Verdana"
    size="2"><strong>
    Use the back button of your browser to go back and correct the problem.</strong></font></td>
  </tr>
</table>
</center></div>
];


print "</body></html>";
exit;
}









sub decode_dir
{

my ($coded_string) = @_;
my ($ms, $oneletter, $decoded_string, $plusval, $dechar, $dechar, $fdchar);

$coded_string =~ s/L2K/&/g;
$coded_string =~ s/_/ /g;

$plusval = 0;

 for ($ms = 0; $ms < length($coded_string); $ms++) 
	{
	$oneletter = substr($coded_string, $ms, 1);

	if ($plusval != 0)
		{
		$plusval++;
		if ($plusval == 4) {$plusval = 0;}
		}
	elsif ($oneletter eq ",")
		{
		$dechar = substr($coded_string, ($ms+1), 3);
		$dechar = int($dechar);
		$dechar = chr($dechar);
		
		$dechar =~ s/<//g;
		
		$decoded_string = $decoded_string . $dechar;
		$plusval++;
		}
	else 
		{
		$decoded_string = $decoded_string . $oneletter;
		}

	}

return($decoded_string);
}







sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


