#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;


&get_setup;
fmspm::check_spamb("contact.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";

if ($q->param('fct') eq ""){&display_contactform;} 

#################

sub display_contactform
{


$contactus1 = pseek::get_file_contents("$data_dir/contactus1.dat"); 
@contactus_items = split (/\n/, $contactus1);

$contact_us_email = 	$contactus_items[0]; 
$autoresponse = 		$contactus_items[1];
$htmlemail = 			$contactus_items[2];
$from_name =			$contactus_items[3];
$from_email = 			$contactus_items[4];
$subject = 				$contactus_items[5];



if ($contact_us_email eq "")
{

	$errtext = qq[There is no email address configured for the contact form where email should be sent to. To solve the problem, log into the 
	PowerSeek Control Panel >> Click the Settings Tab >> Click on: Contact Us Form Setting
	];

	$hbox = pseek::get_heading_box("$web_url/ic_alert.gif", "Critical Error", $errtext);

	print qq[
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<title>Reviews</title>
	$HTML_ENCODING_USE
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
	</head>
	<body>

	<br><br><br>
	<table width="50%" border="0" align="center" cellpadding="0" cellspacing="0">
	  <tr>
		 <td>$hbox</td>
	  </tr>
	</table>
	<br><br><br>

	</body>
	</html>
	];
	
	exit;

}



$cnt_template = pseek::get_file_contents("$data_dir/contact_form.html");


	$imgbox = pseek::get_imgboxes_cc;
	($imdisp, $imgnames) = split (/:::/, $imgbox);
	$imgnames =~ s/\.gif//gi;

	$hinv = qq[ <input type="hidden" name="ia" value="$imgnames">];
	$cnt_template =~ s/<\/form>/$hinv<\/form>/gi;
	$cnt_template =~ s/%%imgbox%%/$imdisp/g;

$cnt_template =~ s/!!error!!//gi;
$cnt_template =~ s/!!name!!//gi;
$cnt_template =~ s/!!email!!//gi;
$cnt_template =~ s/!!subject!!//gi;
$cnt_template =~ s/!!message!!//gi;




#### DISPLAY REGISTERED TEMPLATE
$cnt_template = pseek::ts_insert_template_includes($cnt_template);
$cnt_template = pseek::fill_vars($cnt_template);
print $cnt_template;

}






sub display_regform
{

$reg_template = pseek::get_file_contents("$data_dir/rgs_register.html");

$reg_template =~ s/!!error_text!!/$error_text/gi;

$rgs_user = $q->param('rgs_user');
$reg_template =~ s/!!rgs_user!!/$rgs_user/gi;


$rgs_pass = $q->param('rgs_pass');
$reg_template =~ s/!!rgs_pass!!/$rgs_pass/gi;

$rgs_pass2 = $q->param('rgs_pass2');
$reg_template =~ s/!!rgs_pass2!!/$rgs_pass2/gi;



$name = $q->param('name');
$reg_template =~ s/!!name!!/$name/gi;

$email = $q->param('email');
$reg_template =~ s/!!email!!/$email/gi;

$email2 = $q->param('email2');
$reg_template =~ s/!!email2!!/$email2/gi;

$extra1 = $q->param('extra1');
$reg_template =~ s/!!extra1!!/$extra1/gi;

$extra2 = $q->param('extra2');
$reg_template =~ s/!!extra2!!/$extra2/gi;

$extra3 = $q->param('extra3');
$reg_template =~ s/!!extra3!!/$extra3/gi;

$extra4 = $q->param('extra4');
$reg_template =~ s/!!extra4!!/$extra4/gi;

$extra5 = $q->param('extra5');
$reg_template =~ s/!!extra5!!/$extra5/gi;

$extra6 = $q->param('extra6');
$reg_template =~ s/!!extra6!!/$extra6/gi;

$extra7 = $q->param('extra7');
$reg_template =~ s/!!extra7!!/$extra7/gi;

$extra8 = $q->param('extra8');
$reg_template =~ s/!!extra8!!/$extra8/gi;

$extra9 = $q->param('extra9');
$reg_template =~ s/!!extra9!!/$extra9/gi;

$extra10 = $q->param('extra10');
$reg_template =~ s/!!extra10!!/$extra10/gi;

$reg_template = pseek::ts_insert_template_includes($reg_template);
$reg_template = pseek::fill_vars($reg_template);
$reg_template =~ s/!!rgs_register!!/$script_url\/rgs_register\.cgi/gi;

	$imgbox = pseek::get_imgboxes_cc;
	($imdisp, $imgnames) = split (/:::/, $imgbox);
	$imgnames =~ s/\.gif//gi;

	$hinv = qq[ <input type="hidden" name="ia" value="$imgnames">];
	$reg_template =~ s/<\/form>/$hinv<\/form>/gi;
	$reg_template =~ s/%%imgbox%%/$imdisp/g;


print $reg_template;
}

#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

