#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;


&get_setup;
fmspm::check_spamb("contact.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";

if ($q->param('fct') eq ""){&do_contact;} 

#################

sub do_contact
{

### Check Errors

if ($q->param('name') eq "") { &display_error("name"); }

if ($q->param('email') eq "") { &display_error("email"); }
if ($q->param('email') !~ /\@/) { &display_error("email"); }
if ($q->param('email') !~ /\./) { &display_error("email"); }

if ($q->param('subject') eq "") { &display_error("subject"); }
if ($q->param('message') eq "") { &display_error("message"); }


$img_auth_check = pseek::check_img_auth_cc;
if ($img_auth_check eq "false") { &display_error("captcha"); }


#####

$s_name		= $q->param('name');
$s_email		= $q->param('email');
$s_subject	= $q->param('subject');
$s_message	= $q->param('message');


$contactus1 = pseek::get_file_contents("$data_dir/contactus1.dat"); 
@contactus_items = split (/\n/, $contactus1);

$contact_us_email = 	$contactus_items[0]; 
$autoresponse = 		$contactus_items[1];
$htmlemail = 			$contactus_items[2];
$from_name =			$contactus_items[3];
$from_email = 			$contactus_items[4];
$subject = 				$contactus_items[5];



$send_message = "A new message has been sent from the PowerSeek Contact Form.

Name: $s_name
Email Address: $s_email
Email Subject: $s_subject

Message: 
========
$s_message
";


####### Extra fields

@names = $q->param;

foreach $item_name (@names)
	{
		if (($item_name ne "name") and 
			($item_name ne "email") and 
			($item_name ne "subject") and 
			($item_name ne "message") and 
			($item_name ne "letters") and 
			($item_name ne "button") and 
			($item_name ne "ia"))
			{
			$other_data = $other_data . "$item_name" . ":" . " " . $q->param($item_name) . "\n";
			}
	}


if ($other_data ne "")
	{
	$other_data_msg = "\nOther Data:\n============\n$other_data";
	}


$send_message = $send_message . $other_data_msg;

pseek::send_email ($s_name, $s_email, $contact_us_email, $s_subject, $send_message, ""); 


##### Send AutoReponder if needed

	if ($autoresponse eq "Y")
	{
	if ($htmlemail eq "Y") { $sendHTML = "HTML"; }
	$message = pseek::get_file_contents("$data_dir/contactus2.dat"); 
	$message =~ s/!!name!!/$s_name/gi;
	pseek::send_email ($from_name, $from_email, $s_email, $subject, $message, $sendHTML); 
	}

#####

$cnt_template = pseek::get_file_contents("$data_dir/contact_thank.html");
$cnt_template = pseek::ts_insert_template_includes($cnt_template);
$cnt_template = pseek::fill_vars($cnt_template);
print $cnt_template;

}



sub display_error
{

my ($etype) = @_;

$contactus3 = pseek::get_file_contents("$data_dir/contactus3.dat"); 
@contactus_items2 = split (/\n/, $contactus3);

$no_name 			= $contactus_items2[0];
$invalid_email 	= $contactus_items2[1];
$no_subject			= $contactus_items2[2];
$no_message 		= $contactus_items2[3];
$wrong_captchas 	= $contactus_items2[4];

if ($no_name eq "") 			{ $no_name = "You have to specify a name."; }
if ($invalid_email eq "") 	{ $invalid_email = "The email address you provided is not valid."; }
if ($no_subject eq "") 		{ $no_subject = "You have to specify a subject for your message."; }
if ($no_message eq "") 		{ $no_message = "You have to provide a message."; }
if ($wrong_captchas eq "") { $wrong_captchas = "The image letters you provided was incorrect."; }

if ($etype eq "name") { $error_display = $no_name; }
if ($etype eq "email") { $error_display = $invalid_email; }
if ($etype eq "subject") { $error_display = $no_subject; }
if ($etype eq "message") { $error_display = $no_message; }
if ($etype eq "captcha") { $error_display = $wrong_captchas; }


##########

$cnt_template = pseek::get_file_contents("$data_dir/contact_form.html");

	$imgbox = pseek::get_imgboxes_cc;
	($imdisp, $imgnames) = split (/:::/, $imgbox);
	$imgnames =~ s/\.gif//gi;

	$hinv = qq[ <input type="hidden" name="ia" value="$imgnames">];
	$cnt_template =~ s/<\/form>/$hinv<\/form>/gi;
	$cnt_template =~ s/%%imgbox%%/$imdisp/g;

$cnt_template =~ s/!!error!!/$error_display/gi;


$e_name = $q->param('name');
$e_email = $q->param('email');
$e_subject = $q->param('subject');
$e_message = $q->param('message');

$cnt_template =~ s/!!name!!/$e_name/gi;
$cnt_template =~ s/!!email!!/$e_email/gi;
$cnt_template =~ s/!!subject!!/$e_subject/gi;
$cnt_template =~ s/!!message!!/$e_message/gi;


#### DISPLAY REGISTERED TEMPLATE
$cnt_template = pseek::ts_insert_template_includes($cnt_template);
$cnt_template = pseek::fill_vars($cnt_template);
print $cnt_template;
exit;

}





#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

