#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

use FindBin;
use lib $FindBin::Bin;

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use fms_acs;

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

&get_setup;
$q = CGI->new;

$default_permissions = 0777;  ### DEFAULT PERMISSIONS THAT IS USED FOR DATA FILES IN DATA DIRECTORY

#####
#$setupcrit = &get_setup;
#($data_dir, $web_url, $script_url, $username, $password, $webroot) = split (/\t/, $setupcrit);
#####


fms_acs::check_access($username, $password, $q->param('username'), $q->param('password'));
($template, $popi) = fms_acs::gtemplate("ctl");

print "Content-type: text/html\n\n";


#####


#################################################################################

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "getstats") {&getstats;}
if ($q->param('fct') eq "save_nr") {&save_nr;}


#################################################################################

sub save_nr
{

$lst = $q->param('list');

open (FPARAM, "> $data_dir/sitems.dat");
	print FPARAM "$lst";
close (FPARAM);

$stat = chmod($default_permissions,"$data_dir/sitems.dat","$data_dir/sitems.dat"); 

$tmpledit = qq[
<p>Settings Saved. <a href="$script_url/fms_admin2.cgi">Click here to continue.</a></p>
];

$template = fms_acs::insbuttons($template, "SEARCH_STATISTICS");
$template =~ s/!!controlpanel!!/$tmpledit/g;
print $template;

}







sub getstats
{
$lf = $q->param('l');

$logfile = "$data_dir/$lf" . ".log";
$countfile = "$data_dir/$lf" . ".cnt";

$totalcnt = &get_file_contents($logfile);
@all_searches = split (/\n/, $totalcnt);

@all_searches = sort(@all_searches);

$mcount = 0;

$acnt = 0;


foreach $item (@all_searches)
	{
	($kw, $day) = split(/\t/, $item);
	
	if ($kw ne $oldkw)
		{
		if ($q->param('sort') eq "pop")
			{
			$acnt++;
			$totalitems[$acnt] = $kw. "\t" . $day;
			$tmatches[$acnt] = "1";
			}
			else
			{
			$day = &decode_id($day);
			$acnt++;
			$totalitems[$acnt] = $day. "\t" . $kw;
			$tmatches[$acnt] = "1";
			}
		
		}
		else
		{
		$cval = $tmatches[$acnt];
		$cval++;
		$tmatches[$acnt] = "$cval";
		}
	
	$oldkw = $kw;
	$mcount++;
	}

##################

$mstotal = @totalitems;

for ($ms = 0; $ms < $mstotal; $ms++)
	{
	if ($tmatches[$ms] > $largnr)	{$largnr = $tmatches[$ms];}

	if ($q->param('sort') eq "pop")
		{
		$snr = (100000 - $tmatches[$ms]);
		$snr = &decode_id($snr);
		
		$totalitems[$ms] = $snr . "\t" . $tmatches[$ms] . "\t" . $totalitems[$ms];
		}
		else
		{
		$totalitems[$ms] = $totalitems[$ms] . "\t" . $tmatches[$ms];
		}
	}

@totalitems = sort(@totalitems);

###################

$sta = <<END_OF_STA;
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E2E2E2">
  <tr>
    <td width="15%" height="35" valign="top" background="$web_url/fms_bar7.gif" bgcolor="#FEDF07" class="normaltext"><strong> Day of Month </strong> </td>
    <td width="30%" height="35" valign="top" background="$web_url/fms_bar7.gif" bgcolor="#FEDF07" class="normaltext"><strong> Keywords Searched For </strong> </td>
    <td width="15%" height="35" valign="top" background="$web_url/fms_bar7.gif" bgcolor="#FEDF07" class="normaltext"><strong> Number of Searches</strong></td>
    <td width="1%" valign="top" background="$web_url/fms_bar7.gif" bgcolor="#FEDF07" class="normaltext"><strong> Graph - Based on keyword popularity <BR>
       </strong> </td>
  </tr>
END_OF_STA


$icnt = @totalitems - 1;

$nr_searchres = &get_file_contents("$data_dir/sitems.dat");

if ($nr_searchres eq "")
	{
	$nr_searchres = 100;
	}

if ($nr_searchres == 0)
	{
	$nr_searchres = 100;
	}


$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

foreach $item (@totalitems)
	{

	if (($ippc > $st) and ($ippc <= $nd))
   {

	if ($q->param('sort') eq "pop")
		{
		($tmp, $nrkw, $kw, $day) = split (/\t/, $item);
		}
		else
		{
		($day, $kw, $nrkw) = split (/\t/, $item);
		}
	
	if ($day ne "")
	{
	$day = int($day);

	
	$perc = $nrkw / $largnr * 100;
	$perc = ($perc * 3);
	
	
$sta = $sta . <<END_OF_STA1;
   <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext"> $day </td>
      <td width="30%" valign="top" bgcolor="#FFFFFF" class="normaltext"> $kw </td>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext"> $nrkw </td>
      <td width="1%" valign="top" bgcolor="#FFFFFF" class="normaltext"><img src="$web_url/fms_g2.gif" width="$perc" height="20"> </td>
  </tr>
END_OF_STA1
	}

	}
	$ippc++;
	}

$sta = $sta . "</table>";



#### PAGES
$l_pgs = $q->param('l');
$l_sort = $q->param('sort');

 
 for ($ms = 0; $ms < $pages; $ms++) 
 	{
 	$pg = $ms + 1;
 	if ($nd == ($pg * $nr_searchres))
 		{
 		$pgstring = $pgstring . " [$pg] ";
 		$targpage = $pg;
 		}
 	  	else
 		{
 		$st1 = ($pg * $nr_searchres) - $nr_searchres;
 		$nd1 = ($pg * $nr_searchres);
 		$pgstring = $pgstring . "<a href=\"$script_url/fms_admin2.cgi?fct=getstats&l=$l_pgs&sort=$l_sort&st=$st1&nd=$nd1\">$pg</a> ";
 		}
 	}
 
 if ($pages > 1)
 	{
 	$pgstring = "Pages: " . $pgstring;
 	}
 	else
 	{
 	$pgstring = "";
 	}



#############

$mcount = $mcount - 1;
open (CFILE, "> $countfile");
	print CFILE $mcount;
close (CFILE);

#############

if ($q->param('sort') eq "pop")
	{
	$srotedby = "Popularity";
	}
	else
	{
	$srotedby = "Day of Month";
	}


($mn, $yr) = split (/_/, $lf);

@marray = ("", "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
$mn = $marray[$mn]; 



$hbox = fms_acs::get_heading_box("$web_url/fms_ic_stats.gif", "Search Statistics", qq[
Search Statistics for <b>$mn $yr</b> - Sorted by: <b>$srotedby</b>
]);


$tmpledit = qq[

$hbox
$sta
$pgstring

<form method="POST" action="$script_url/fms_admin2.cgi">
  <input type="hidden" name="fct" value="save_nr">
  <div align="center">
    <center>
      <p> &nbsp;&nbsp;&nbsp;Number of entries to list per page:
        <input    type="text" name="list" size="6" style="font-family: MS Sans Serif; font-size: 8"    value="$nr_searchres">
        <input type="submit" value="Save" name="B1"    style="font-family: MS Sans Serif; font-size: 8">
      </p>
    </center>
  </div>
  <div align="center">
    <center>
      <p> <strong> <a href="$script_url/fms_admin2.cgi"> Go back </a> </strong> </p>
    </center>
  </div>
</form>

];

$template = fms_acs::insbuttons($template, "SEARCH_STATISTICS");
$template =~ s/!!controlpanel!!/$tmpledit/g;
print $template;


}









sub start
{

@marray = ("", "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

opendir(DIR,"$data_dir");
@files = readdir(DIR);

$stable = <<END_OF_TOP;

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E2E2E2">
  <tr>
    <td width="20%" height="35" valign="top" background="$web_url/fms_bar7.gif" class="normaltext"><strong> Month</strong></td>
    <td width="20%" height="25" valign="top" background="$web_url/fms_bar7.gif" class="normaltext"><strong> Total Searches</strong></td>
    <td width="50%" height="25" valign="top" background="$web_url/fms_bar7.gif" class="normaltext"><strong> View Stats Sorted By:</strong></td>
    <td width="10%" valign="top" background="$web_url/fms_bar7.gif" class="normaltext"><strong> Graph</strong> (Based on Number of Searches)</td>
  </tr>
END_OF_TOP


$mcnt = 0;
foreach $item (@files)
	{
	if (($item ne ".") and ($item ne "..") and (substr($item, length($item) - 4, 4) eq ".log") and ($item =~ m/[0-9]/))
		{
		$dcrit = $item;
		$dcrit =~ s/\.log//g;
		($month, $year) = split (/_/, $dcrit);
		$month1 = $month;
		$month = $marray[$month];
		$cfname = "$data_dir/$dcrit" . ".cnt";
		$totalcnt = &get_file_contents($cfname);
		
		$month_nr = $month1; 
		if (length($month_nr) == 1) { $month_nr = "0" . $month_nr; }

		
		$tmp = $year . $month_nr;
		$tmp = &decode_id($tmp);
		
		$monthstats[$mcnt] = $tmp . "\t" . 							#### SORT
									$month1 . "_" . $year ."\t" .		#### MONTH NUMBER
									$totalcnt . "\t" .					#### TOTAL SEARCHES
									"$month $year";				 		#### MONTH YEAR

		
		if ($largest < $totalcnt){$largest = $totalcnt;}
		$mcnt++;
		}
	}

@monthstats = reverse sort(@monthstats); 

foreach $item (@monthstats)
	{
	($tmp, $lfile, $tcnt, $mye) = split(/\t/, $item);
	
	if ($tcnt != 0)
		{
		$perc = $tcnt / $largest * 100;
		}
		$perc = ($perc * 3);
	
$stable = $stable . <<END_OF_ST;
<tr>
  <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$script_url/fms_admin2.cgi?fct=getstats&l=$lfile&sort=pop"> $mye</a> <strong></strong></td>
  <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"> $tcnt <strong></strong></td>
  <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$script_url/fms_admin2.cgi?fct=getstats&l=$lfile&sort=pop"> Keyword Popularity</a> | <a href="$script_url/fms_admin2.cgi?fct=getstats&l=$lfile"> Day of Month</a></td>
  <td width="10%" align="left" valign="top" bgcolor="#FFFFFF" class="normaltext"><img src="$web_url/fms_g2.gif" width="$perc" height="20"></td>
</tr>
END_OF_ST
	}


#<hr noshade size="4" color="#FF8000" width="$perc%">




if ($mcnt == 0)
	{
$stable = <<END_OF_NOS;
<font face="Verdana" size="2">No statistics has been recorded as no searches has been done yet.</font>
END_OF_NOS
	}

$stable = $stable . "</table>";


$hbox = fms_acs::get_heading_box("$web_url/fms_ic_stats.gif", "Search Statistics:", qq[
Select a month below:
]);


$tmpledit = <<END_OF_TN;
$hbox
$stable

END_OF_TN


$template = fms_acs::insbuttons($template, "SEARCH_STATISTICS");
$template =~ s/!!controlpanel!!/$tmpledit/g;
print $template;

}




sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

$filesize = (-s "$filename");
open (TFILECNTS, "$filename");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);

return ($thefile);
}




sub decode_id
{

my ($decid) = @_;

if (length($decid) == 1) {$decid = "000000000000" . $decid;}
if (length($decid) == 2) {$decid = "00000000000" . $decid;}
if (length($decid) == 3) {$decid = "0000000000" . $decid;}
if (length($decid) == 4) {$decid = "000000000" . $decid;}
if (length($decid) == 5) {$decid = "00000000" . $decid;}
if (length($decid) == 6) {$decid = "0000000" . $decid;}
if (length($decid) == 7) {$decid = "000000" . $decid;}
if (length($decid) == 8) {$decid = "00000" . $decid;}
if (length($decid) == 9) {$decid = "0000" . $decid;}
if (length($decid) == 10){$decid = "000" . $decid;}
if (length($decid) == 11){$decid = "00" . $decid;}
if (length($decid) == 12){$decid = "0" . $decid;}	

return ($decid);

}






#### GET CONFIGURATION ########################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}
if ($line =~ /^WEBROOT/){$webroot = &get_setup_line($line, WEBROOT);}
if ($line =~ /^URLROOT/){$urlroot = &get_setup_line($line, URLROOT);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

if ($line =~ /^USE_MYSQL/){$use_mysql = &get_setup_line($line, USE_MYSQL);}
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^RG/){$rg = &get_setup_line($line, RG);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

			}
	close (STP);
	
	}
	else
	{
	print "Could not find $config_cgi"; exit;
	
	}
}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

