#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use frc4;


&get_setup;
fmspm::check_spamb("ppupgrade.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";

if ($q->param('id') ne ""){&start;} 

#################

sub start
{

##### Check if URL was submitted from custom form #######

$lnkid = int($q->param('id'));

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT * FROM exaddurl WHERE lnkid = '$lnkid'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows();
if ($rows > 0)
	{
	while ( @row = $sth->fetchrow() )
		{
		$custom_form_name = $row[2];
		}
	
	$custom_form_settings_file = pseek::get_file_contents("$data_dir/addmod_" . $custom_form_name . ".dat");
	@custom_form_settings = split (/\n/, $custom_form_settings_file);
	}

$sth->finish;
$dbh->disconnect;

####################################


if ($custom_form_name ne "")
	{
		### Check if paypal in use custom add url form
		$pdset = pseek::get_file_contents("$data_dir/" . "addmod_" . $custom_form_name . ".dat");
		@cust_pp_settings = split (/\n/, $pdset);
		if ($cust_pp_settings[7] ne "Y") { &do_no_paypal_custom_addurlform; exit; }  ### if paypal not in use
		
	}
	else
	{
		### Check if paypal in use
		$pdset = pseek::get_file_contents("$data_dir/paypalset.dat");
		@ppsettings = split (/\n/, $pdset);
		$usepaypal = $ppsettings[0];
		if ($usepaypal ne "Y") { &do_no_paypal; exit; }
		###########################
	}


eval "use LWP::UserAgent";
if($@)
	{
	$lwp_useragent = "N";
	$lwp_useragent_err = $@;
	$lwp_notice = "<font color='red'>LWP::UserAgent</font><br>";
 	}
$@ = "";

##############

eval "use HTTP::Request::Common qw(GET)";
if($@)
	{
	$httprequest = "N";
	$httprequest_err = $@;
	$httprequest_notice = "<font color='red'>HTTP::Request::Common</font><br>";
 	}
$@ = "";

##############

eval "use Crypt::SSLeay";
if($@)
	{
	$cryptssl = "N";
	$cryptssl_err = $@;
	$cryptssl_notice = "<font color='red'>Crypt::SSLeay</font><br>";
 	}
$@ = "";



if (($lwp_useragent eq "") and ($lwp_useragent eq "") and ($lwp_useragent eq ""))
	{
		#### redirect do paypal
		
		$id = $q->param('id');
		
		print qq[<html>
		<head>
		<title>Add URL</title>
		<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=ppupgrade2.cgi?id=$id">
		</head>
		<body>
		</body>
		</html>
		];
		
	}
	else
	{
		$use_perl_modules = "N";
		
		$module_warning = qq[
		<table width="94%"  align="center">
					 <tr class="normaltext">
					      <td valign="top">
					        <p>The premium link was submitted but the order could not be processed with PayPal because <b>your web host or web server does not have the following Perl module(s) installed:</b></p>
					        <blockquote>
					          <p><strong>$lwp_notice $httprequest_notice $cryptssl_notice</strong></p>
				            </blockquote>
					        <p> To use Paypal you will need to  install the above mentioned Perl module(s). If you are on a shared host then send an email to your web host and ask them to install the module(s) for you or ask them how you should go about the install the module(s). If this is your own server then install the above mentioned modules.</p>			          </td>
				        </tr>
 		</table>
		];
		
		pseek::display_error("Error: Your web host or web server does not have the following Perl module(s) installed:", $module_warning);
		exit;

	
	}

}




sub do_no_paypal
{

$inusecnt = 0;
$expirytsettings = pseek::get_file_contents("$data_dir/pexpiryopt.dat");
@expsettings = split (/\n/, $expirytsettings);
foreach $item (@expsettings)
{
	($usdprice, $premium_expire_days, $premium_orderform_url, $standard_orderform_url) = split (/::/, $item);
	if ($premium_expire_days > 0) { $inusecnt++;	}
}

##############

	if ($inusecnt < 2)  ### If only 1 expiry option
		{
		
			($usdprice, $premium_expire_days, $premium_orderform_url, $standard_orderform_url) = split (/::/, $expsettings[0]);
			
			if ($premium_orderform_url ne "")
			{
				$redir_url = "$premium_orderform_url";
			}
			else
			{
				$premsetb = pseek::get_file_contents("$data_dir/prem.cfg");
				@pconfig = split (/\n/, $premsetb);
				
				if ($pconfig[0] ne "") { $redir_url = "$premium_orderform_url"; }
				else { $redir_url = "$web_url/sample_orderf.html"; }
			}
		
				print qq[
						<html>
						<head>
						<title></title>
						<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$redir_url">
						</head>
						<body>
						</body>
						</html>
						]; 
				exit; 
		}
		else ### More than 1 order option
		{
			$id = $q->param('id');
			$upgrade_template = pseek::get_file_contents("$data_dir/rgs_upgrade.html");
			$upgrade_template =~ s/!!lnkid!!/$id/gi;
			
			$upgradelnk = "$script_url/manupgrade.cgi";
			$upgrade_template =~ s/!!upgradescript!!/$upgradelnk/gi;
			
			$upgrade_template = pseek::ts_insert_template_includes($upgrade_template);
			$upgrade_template = pseek::fill_vars($upgrade_template);
			$upgrade_template = pseek::fill_cp_vars($upgrade_template);
			print $upgrade_template;
		}


}




sub do_no_paypal_custom_addurlform
{

#@cust_pp_settings
#premium_expire_days2

	if ($cust_pp_settings[16] eq "")  ### If only 1 expiry option and not more than 1
		{

			$premium_orderform_url = $cust_pp_settings[14];

			if ($premium_orderform_url ne "")
			{
				$redir_url = "$premium_orderform_url";
			}
			else
			{
				$premsetb = pseek::get_file_contents("$data_dir/prem.cfg");
				@pconfig = split (/\n/, $premsetb);
				if ($pconfig[0] ne "") { $redir_url = "$premium_orderform_url"; }
				else { $redir_url = "$web_url/sample_orderf.html"; }
			}
		
				print qq[
						<html>
						<head>
						<title></title>
						<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$redir_url">
						</head>
						<body>
						</body>
						</html>
						]; 
				exit; 
		}
		else ### More than 1 order option
		{
			$id = int($q->param('id'));
			
			$upgrade_template = pseek::get_file_contents("$data_dir/" . $custom_form_name . "_rgs_upgrade.html");
			$upgrade_template =~ s/!!lnkid!!/$id/gi;

			$upgradelnk = "$script_url/manupgrade2.cgi";
			$upgrade_template =~ s/!!upgradescript!!/$upgradelnk/gi;
			
			$upgrade_template = pseek::ts_insert_template_includes($upgrade_template);
			$upgrade_template = pseek::fill_vars($upgrade_template);
			$upgrade_template = pseek::fill_cp_vars($upgrade_template);
			print $upgrade_template;
		}




}


#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

