#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use frc4;

use LWP::UserAgent;
use HTTP::Request::Common qw(GET);
use Crypt::SSLeay;

use URI::Escape;
  

&get_setup;
fmspm::check_spamb("ppupgrade2.cgi", "header", "$data_dir");
$q = CGI->new;


################# 

print "Content-type: text/html\n\n";

if ($q->param('id') ne ""){&start;} 

#################

sub start
{

$id = $q->param('id');


##### Check if URL was submitted from custom form #######

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT * FROM exaddurl WHERE lnkid = '$id'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows();
if ($rows > 0)
	{
	while ( @row = $sth->fetchrow() )
		{
		$custom_form_name = $row[2];
		}
	
	$custom_form_settings_file = pseek::get_file_contents("$data_dir/addmod_" . $custom_form_name . ".dat");
	@custom_form_settings = split (/\n/, $custom_form_settings_file);
	}

$sth->finish;
$dbh->disconnect;


#########################################################

if ($custom_form_settings[0] ne "") ### if link was submitted from custom form
	{
	
			$conf_file = "$data_dir/addmod_" . $custom_form_settings[0] . ".dat";
			$conf_file_data = pseek::get_file_contents($conf_file);
			@paypsettings = split (/\n/, $conf_file_data);
			
			$paypalmode  = $paypsettings[11];
			$usepaypal  = $paypsettings[7];
			$paypaluser = $paypsettings[8];
			$paypalpass = $paypsettings[9];
			$paypalsign = $paypsettings[10];

		$expsettings[0] = $paypsettings[12] . "::" .  $paypsettings[13] . "::" .  $paypsettings[14] . "::";
		$expsettings[1] = $paypsettings[15] . "::" .  $paypsettings[16] . "::" .  $paypsettings[17] . "::";
		$expsettings[2] = $paypsettings[18] . "::" .  $paypsettings[19] . "::" .  $paypsettings[20] . "::";
		$expsettings[3] = $paypsettings[21] . "::" .  $paypsettings[22] . "::" .  $paypsettings[23] . "::";
		$expsettings[4] = $paypsettings[24] . "::" .  $paypsettings[25] . "::" .  $paypsettings[26] . "::";
		$expsettings[5] = $paypsettings[27] . "::" .  $paypsettings[28] . "::" .  $paypsettings[29] . "::";
		$expsettings[6] = $paypsettings[30] . "::" .  $paypsettings[31] . "::" .  $paypsettings[32] . "::";
		$expsettings[7] = $paypsettings[33] . "::" .  $paypsettings[34] . "::" .  $paypsettings[35] . "::";
		$expsettings[8] = $paypsettings[36] . "::" .  $paypsettings[37] . "::" .  $paypsettings[38] . "::";
		$expsettings[9] = $paypsettings[39] . "::" .  $paypsettings[40] . "::" .  $paypsettings[41] . "::";

		# usdprice / premium_expire_days / premium_orderform_url / standard_orderform_url
		($usdprice, $prem_exp_days, $prem1tmp, $prem2tmp) = split (/::/, $expsettings[1]);		
		
		if ($prem_exp_days < 1) ### Redirect if there is no premium link options
			{
					$redirlink = "$script_url/ppupgcust.cgi?lnkid=$id&premoption=1";
							print qq[
									<html>
									<head>
									<title></title>
									<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$redirlink">
									</head>
									<body>
									</body>
									</html>
									];
							exit;
			}
			else ### there is premium link options. display template with options
			{
				$custom_upgrade_form = pseek::get_file_contents("$data_dir/$custom_form_name" . "_rgs_upgrade.html");
				$redirlink = "$script_url/ppupgcust.cgi";
				$custom_upgrade_form =~ s/!!upgradescript!!/$redirlink/gi;
				$custom_upgrade_form =~ s/!!lnkid!!/$id/gi;
				
				$custom_upgrade_form = pseek::ts_insert_template_includes($custom_upgrade_form);
				$custom_upgrade_form = pseek::fill_vars($custom_upgrade_form);
				$custom_upgrade_form = pseek::fill_cp_vars($custom_upgrade_form);
				
				print $custom_upgrade_form;
				exit;
			}
			
			
		
	}
	else ### if submitted from standard add url form
	{
			$inusecnt = 0;
			$expirytsettings = pseek::get_file_contents("$data_dir/pexpiryopt.dat");
			@expsettings = split (/\n/, $expirytsettings);
			
				foreach $item (@expsettings)
				{
				($usdprice, $premium_expire_days, $premium_orderform_url, $standard_orderform_url) = split (/::/, $item);
				if ($premium_expire_days > 0) { $inusecnt++;	}
				}

				if ($inusecnt < 2)  ### If only 1 expiry option
					{
					($usdprice, $premium_expire_days, $premium_orderform_url, $standard_orderform_url) = split (/::/, $expsettings[0]);
					$redirlink = "$script_url/ppupgrade3.cgi?lnkid=$id&premoption=1";
							print qq[
									<html>
									<head>
									<title></title>
									<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$redirlink">
									</head>
									<body>
									</body>
									</html>
									];
							exit;
					}

			##### GET PAYPAL SETTINGS
			$pdset = pseek::get_file_contents("$data_dir/paypalset.dat");
			@ppsettings = split (/\n/, $pdset);
			$usepaypal = $ppsettings[0];
			$paypaluser = $ppsettings[1];
			$paypalpass = $ppsettings[2];
			$paypalsign = $ppsettings[3];

			$upgrade_template = pseek::get_file_contents("$data_dir/rgs_upgrade.html");
	}




$upgrade_template =~ s/!!lnkid!!/$id/gi;

$upgrs = "$script_url/ppupgrade3.cgi";
$upgrade_template =~ s/!!upgradescript!!/$upgrs/gi;

$upgrade_template = pseek::ts_insert_template_includes($upgrade_template);
$upgrade_template = pseek::fill_vars($upgrade_template);
$upgrade_template = pseek::fill_cp_vars($upgrade_template);

print $upgrade_template;

}




#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

