#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2003 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi
$use_ppc_plugin = 0;   ## <-- DON'T CHANGE THIS SETTING UNLESS YOU OWN THIS PLUGIN


# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin; 

### FULL TEXT SEARCHING SCRIPT

#$sph_conf = "/home2/esygoing/sphinx/etc/sphinx.conf";
#$sph_exec = "/home2/esygoing/sphinx/bin/search";
#$index_name = "powerseek";

$sph_conf = "/usr/local/sph/etc/sphinx.cong";
$sph_exec = "/usr/local/sph/bin/search";
$index_name = "test1";

use CGI qw(param);
use CGI::Carp qw(fatalsToBrowser); 
use DBI;

&get_setup;

$q = CGI->new;
$gsettings = &new_gsettings;

my $search_res_newwin = $gsettings->{search_res_newwin};

$pages_prev = "3";
$pages_next = "3";

print "Content-type: text/html\n\n";



$search_templat = &get_file_contents("$data_dir/searchres.html");
$search_links = &get_file_contents("$data_dir/lsearchres_loc.html");
$search_links_prem = &get_file_contents("$data_dir/lsearchres_loc_prem.html");
$default_permissions = 0777;



#### DO SPH SEARCH

$st = $q->param('st');
$nd = $q->param('nd');
$file_ext = $gsettings->{gen_file_ext};

$keywords = $q->param('keywords');
$orig_keywords = $keywords;
if ($keywords eq "") { &use_nomatch_template; }

$keywords =~ s/\\//gi;
$keywords =~ s/\///gi;
$keywords = quotemeta($keywords);

if ($st ne "")
	{
	$startcrit = "--offset $st ";
	}
	$limitres = $gsettings->{search_nrlinks_perpage}; if ($limitres < 1) { $limitres = 10; }

$idcheck = `2>&1 $sph_exec $startcrit --limit $limitres -a --config $sph_conf $keywords`;

#print "<B>$sph_exec $startcrit --limit $limitres -a --config $sph_conf $keywords<BR><BR>";

@lines = split (/\n/, $idcheck);

$mcount = 0;

foreach $line (@lines)
   {
	
   if (($line =~ /document=/) and ($line =~ /weight=/))
   	{
   	($lnkid, $weight) = split (/,/,$line);
   	
   		if ($lnkid =~ m/document=/g)
		   {
		   $r = pos($lnkid);
		   $select_statement = $select_statement . " (lnkid = '" . substr($line, $r, length($lnkid) - $r) . "') OR";
		   $mcount++;
		   }
   	}
   	
   if (($line =~ /index/) and ($line =~ /query/) and ($line =~ /returned/) and ($line =~ /matches/) and ($line =~ /total in/) and ($line =~ /'$index_name'/))
   	{

   		if ($line =~ m/matches of /g)
			   {
			   $r = pos($line);
			   $totalmstring = substr($line, $r, length($line) - $r);
			   @mdetails = split (/ /, $totalmstring);
			   $total_matches = $mdetails[0];
			   $seconds = $mdetails[3];
			   }

   	}
      
   }

#print "--> $total_matches / $seconds<BR>";
#print "--SQL> $select_statement <BR>";

$idcheck =~ s/\n/<BR>/gi;
#print "<BR><BR><BR><BR><BR><BR>$idcheck";





#### DISPLAY SEARCH RESULTS
if ($mcount > 0)
{
&display_search_results;
}
else
{
&use_nomatch_template;
}




sub display_search_results
{


##### GET MATCHES FROM DB
chop($select_statement); chop($select_statement);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT A.*, B.* FROM links AS A, dirs AS B WHERE (A.cid = B.cid) AND ($select_statement)";
#print "$sql <BR><BR>";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

### SET UP PAGES

$icnt = $total_matches;
$nr_searchres = $gsettings->{search_nrlinks_perpage};

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$main_nd = $nd;
$main_st = $st;

$ippc = 1;

$crnr = $st + 1;


while ( @row = $sth->fetchrow() )
		{

		### IF PREMIUM LINKS
		if (($row[21] == 0) and ($row[13] > 0))
		{ $row[21] = 99999999999999; }
    
    	if (($row[13] > 0) and ($row[21] > $nowtime))
    	{
    	$search_links_tmp = $search_links_prem;
    	}
    	else
    	{
    	$search_links_tmp = $search_links;
    	}
    
			
 		### %%title_with_link%%
 		if ($search_res_newwin eq "Yes")
 			{
 			$new_win_crit = " target=\"_blank\"";
 			}
			
			
			if ($gsettings->{hideurls} eq "No")
				{
				$title_with_link = "<a href=\"$row[5]\" $new_win_crit>$row[2]</a>";
				}
				else
				{
				$title_with_link = "<a href=\"$script_url/go.cgi?id=$row[0]\" $new_win_crit>$row[2]</a>";
				}
			
			
			
			if (($row[5] eq "http://") or ($row[5] eq ""))
				{
				$title_with_link = "$row[2]";
				}
			
			
			$search_links_tmp =~ s/!!nr!!/$crnr\./g; $crnr++;
			$search_links_tmp =~ s/%%title_with_link%%/$title_with_link/g;
			$search_links_tmp =~ s/!!title_with_link!!/$title_with_link/g;

			$search_links_tmp =~ s/!!cid!!/$row[1]/g;
			$search_links_tmp =~ s/!!id!!/$row[0]/g;
			
			### !!title_without_link!!
			
			$search_links_tmp =~ s/!!title_without_link!!/$row[2]/g;
			
			### %%description%%
			
			$search_links_tmp =~ s/%%description%%/$row[3]/g;
			$search_links_tmp =~ s/!!description!!/$row[3]/g;
			
			### !!url!! or !!itemurl!!
			$search_links_tmp =~ s/!!url!!/$row[5]/g;
			$search_links_tmp =~ s/!!itemurl!!/$row[5]/g;
			$search_links_tmp =~ s/!!hidden_url!!/$script_url\/go\.cgi?id=$row[0]/g;
			
			### !!name!!
			$search_links_tmp =~ s/!!name!!/$row[8]/g;

			### !!email!!
			$search_links_tmp =~ s/!!email!!/$row[9]/g;
			
			### !!gethtml!!
			$search_links_tmp =~ s/!!gethtml!!/$script_url\/gethtml\.cgi?id=$row[0]-$row[1]/g;
			
			### %%date%%
			$reald = $row[17];

			$realdate = $row[17];

			$realdate = &decode_date($row[17]);
			$search_links_tmp =~ s/%%date%%/$realdate/g;
			$search_links_tmp =~ s/!!date!!/$realdate/g;
			
			### %%votes%% 
			if ($row[11] eq "") { $row[11] = 0; }
			$search_links_tmp =~ s/%%votes%%/$row[11]/g;
			$search_links_tmp =~ s/!!votes!!/$row[11]/g;
			
			$nrc = "";
			if ($row[23] > 0) { $nrc = "($row[23])"; }
			
			$reviews = "<a href=\"$script_url/reviews.cgi?id=$row[0]&cid=$row[1]\">$gsettings->{comments}</a> $nrc";
			$search_links_tmp =~ s/%%reviews%%/$reviews/g;

			$search_links_tmp =~ s/!!rno!!/$nrc/gi;
			$search_links_tmp =~ s/!!review_link_url!!/$script_url\/reviews\.cgi?id=$row[0]&cid=$row[1]/gi;
			
			### %%modify%%
			$modifyl = "<a href=\"$script_url/modify.cgi?id=$row[0]&cid=$row[1]\">$modifyl</a>";
			$search_links_tmp =~ s/%%modify%%/$modifyl/gi;
			$search_links_tmp =~ s/!!modify_link!!/$script_url\/modify\.cgi?id=$row[0]&cid=$row[1]/gi;

			### %%report%%
			$rptdl = "<a href=\"$script_url/rprtb.cgi?id=$row[0]&cid=$row[1]\">$rptdl</a>";
			$search_links_tmp =~ s/%%report%%/$rptdl/gi;
			$search_links_tmp =~ s/!!report_dead_link!!/$script_url\/rprtb\.cgi?id=$row[0]&cid=$row[1]/gi;

			### %%rateit%% %%rating%%
			$rateit = "<a href=\"$script_url/rateit.cgi?id=$row[0]&cid=$row[1]\">$gsettings->{rateit}</a>";
			$search_links_tmp =~ s/%%rateit%%/$rateit/g;
			$search_links_tmp =~ s/!!rate_link_url!!/$script_url\/rateit\.cgi?id=$row[0]&cid=$row[1]/g;
			
			if ($row[11] eq "") { $row[11] = 0; }
			$search_links_tmp =~ s/%%rating%%/$row[11]/g;
			$search_links_tmp =~ s/!!rating!!/$row[11]/g;
			
			if ($row[24] eq "") { $row[24] = "0"; }
			$search_links_tmp =~ s/!!cnumber!!/$row[24]/gi;
			
			
			$rating_image = &get_rating_images($row[10]);
			$search_links_tmp =~ s/%%rating_image%%/$rating_image/gi;
			$search_links_tmp =~ s/!!rating_image!!/$rating_image/gi;

			### %%hits%%
			if ($row[12] eq "") { $row[12] = 0; }
			$search_links_tmp =~ s/%%hits%%/$row[12]/g;
			$search_links_tmp =~ s/!!hits!!/$row[12]/g;
			
		### NEW
		if	($reald ne "")
			{
			$time1 = 86400 * $gsettings->{days1};
			if ($reald >= ($today_time - $time1)){ $crit = "<img src=\"!build_url!/new1.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }

			$time2 = 86400 * $gsettings->{days2};
			if ($reald >= ($today_time - $time2)){ $crit = "<img src=\"!build_url!/new2.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }

			$time3 = 86400 * $gsettings->{days3};
			if ($reald >= ($today_time - $time3)){ $crit = "<img src=\"!build_url!/new3.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }
			}
			$search_links_tmp =~ s/!!new!!//gi;


		### POP
			if ($row[12] > $gsettings->{pop_links_amount})
				{
				$crit = "<img src=\"!build_url!/pop.gif\">";
				$search_links_tmp =~ s/!!pop!!/$crit/gi;
				}
				else
				{
				$search_links_tmp =~ s/!!pop!!//gi;
				}





			#$catocrit1 = "%%category1%%-" . $row[1];
			#$catocrit2 = "!!category1!!-" . $row[1];
			#$catocrit3 = "!!short_category1!!-" . $row[1];
			#$search_links_tmp =~ s/%%category%%/$catocrit1/g;
			#$search_links_tmp =~ s/!!category!!/$catocrit2/g;
			#$search_links_tmp =~ s/!!short_category!!/$catocrit3/g;




			#### EXTRA FIELDS KEYS
			$rowcntr = 27;
			foreach $keyitem(@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $keyitem);
		
					if ($imgk eq "Yes")
						{
						if ($row[$rowcntr] ne ""){$imgcrit = "<img src=\"$row[$rowcntr]\">";} else { $imgcrit = ""; }
						$search_links_tmp =~ s/%%$keyname%%/$imgcrit/gi;
						$search_links_tmp =~ s/!!$keyname!!/$imgcrit/gi;
						}
						else
						{
						if ($row[$rowcntr] eq "") { $row[$rowcntr] = $na; }
						$search_links_tmp =~ s/%%$keyname%%/$row[$rowcntr]/gi;
						$search_links_tmp =~ s/!!$keyname!!/$row[$rowcntr]/gi;
						}
						$rowcntr++;
				}
			


		### GET CATGORY
			$rowcntr = $rowcntr + 3;
			$cats = ""; $ecat = ""; $rdcat = ""; $lv = 0;
			for ($ms = $rowcntr; $ms < ($rowcntr + 16); $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . "/";
					$ecat = $ecat . &encode_dir($row[$ms]) . "-";
					$rdcat = $rdcat . &encode_dir($row[$ms]) . "/";
					$lastcat = $row[$ms];
					$lv++;
					}
				}
			chop($ecat);
			
			
			$cats = substr($cats, 0, (length($cats) - 1));
			$cats =~ s/\// \/ /gi;
			
			if ($gsettings->{dyn_stat} eq "Dynamic")
				{
				$from_category = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$cats</a>";
				$lastcat = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$lastcat</a>";
				}
				else
				{
				$from_category = "<a href=\"$web_url/$rdcat\">$cats</a>";
				$lastcat = "<a href=\"$web_url/$rdcat\">$lastcat</a>";
				}
			$search_links_tmp =~ s/!!category!!/$from_category/gi;

			
			### !!more_info_url!!
			if ($gsettings->{dyn_stat} eq "Static")
				{
				#$fext = "$web_url/$rdcat" . $row[0];
				$fext = "$web_url/$rdcat" . "$row[0]" .  $file_ext;
				$search_links_tmp =~ s/!!more_info_url!!/$fext/g;
				}
				else
				{
				$search_links_tmp =~ s/!!more_info_url!!/$script_url\/linfo\.cgi?id=$row[0]/g;
				}


			
			##### INSERT IMAGES
			
			$search_links_tmp = &insert_images($search_links_tmp, "$script_url/go.cgi?id=$row[0]");


			### INSERT UPLOAD IMAGE IF ANY
			if ($search_links_tmp =~ /!!link_image!!/i)
			{
			$img_fname = "$web_dir/imagefiles/" . $row[0] . "." . $row[6];
	
			$image_width = $gsettings->{image_width};
			$image_height = $gsettings->{image_height};
	
			if ($image_width > 0) { $imgw = qq[ width="$image_width" ]; }
			if ($image_height > 0) { $imgh = qq[ height="$image_height" ]; }
	
						
				if (-e "$img_fname")
					{
					$the_image_url = "$web_url/imagefiles/$row[0]" . "." . $row[6];
					$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
					$search_links_tmp =~ s/!!link_image!!/$the_link_image/gi;
					}
					else
					{
					if ($gsettings->{default_image} =~ /http:/)
						{
						$the_image_url = $gsettings->{default_image};
						$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
						$search_links_tmp =~ s/!!link_image!!/$the_link_image/gi;
						}
						else
						{
						$search_links_tmp =~ s/!!link_image!!//gi;
						}
	
					}
			}					
			
			
		###########
		
		$all_links = $all_links . $search_links_tmp;
		
		
		### GET CATEGORIES
		

		$objname = "C" . $row[0];
		$catobj{$objname} = $row[1];
		$category_sql = $category_sql . " (cid = $row[1]) OR";		
		
		}

$sth->finish;
$dbh->disconnect;




#### PAGES 


	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}
	if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

	$hiddenstr = "";
	$pgstring = "";
	
	if ($main_nd eq "") {$main_nd = $nr_searchres;}
	
	for ($ms = 0; $ms < $pages; $ms++)
		{
		$pg = $ms + 1;
		
			if ($main_nd == ($pg * $nr_searchres))
				{
				$pgstring = $pgstring . " [$pg] ";
				$currentpage = $pg;
				}
			  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
				{
				$st = ($pg * $nr_searchres) - $nr_searchres;
				$nd = ($pg * $nr_searchres);
				$pgstring = $pgstring . "<a href=\"$script_url/searchb.cgi?st=$st&nd=$nd&keywords=$orig_keywords&total=$total_matches\">$pg</a> ";
			   }
      } 

			####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = "<a href=\"$script_url/searchb.cgi?st=$pvst&nd=$pvnd&keywords=$orig_keywords&total=$total_matches\"><<</a> " . $pgstring;
				}

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = $pgstring . "<a href=\"$script_url/searchb.cgi?st=$pvst&nd=$pvnd&keywords=$orig_keywords&total=$total_matches\">>></a> ";
				}


if ($pgstring eq "0") { $pgstring = ""; }
if ($pgstring eq " [1] ") { $pgstring = ""; }

if ($pgstring ne "") {$pgstring =  $gsettings->{pages} . $pgstring; }

$search_templat =~ s/%%pages%%/$pgstring/gi;
	

### PREV NEXT PAGES

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}


$spls = $modp;
if ($spls == 0){$spls++;}

if ($nd <= ($icnt - $spls))
{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$script_url/searchb.cgi?st=$st1&nd=$nd1&keywords=$orig_keywords&total=$total_matches\">$gsettings->{nextpage}</a> ";
}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$script_url/searchb.cgi?st=$st1&nd=$nd1&keywords=$orig_keywords&total=$total_matches\">$gsettings->{prevpage}</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

	#if ($rows > 0)
	#{
	#print "$prevnext $myspacer Page $targpage of $pg";
	#}



$search_templat =~ s/%%seconds%%/$seconds/g;
$search_templat =~ s/%%link_matches%%/$total_matches/g;
$search_templat =~ s/%%keywords%%/$orig_keywords/g;


$search_templat =~ s/%%searchresults%%/$all_links/g;
$search_templat =~ s/%%prevnext%%/$prevnext/g;
$search_templat = &ts_insert_template_includes($search_templat);
$search_templat = &fill_vars($search_templat); 
$search_templat =~ s/!!keywords!!/$keywords/g;
$search_templat =~ s/!!advanced!!/$script_url\/searchadv\.cgi/g;

print $search_templat;


} ### END OF display_search_results




################

sub use_nomatch_template
{
my ($nomatch, $addurl);

$nomatch = &get_file_contents("$data_dir/nomatch.html");
$nomatch =~ s/%%keywords%%/$keywords/g;

#################  PAY-PER-CLICK PLUGIN ##############################

if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) {$nomatch =~ s/%%kanoodle_search%%/$all_kan_links/g; }
if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) {$nomatch =~ s/%%searchfeed_search%%/$all_searchfeed_links/g; }

###################################################################
### IF WE ARE GOING TO FETCH PPC RESULTS FROM POWERSEEK PPC PLUGIN
###################################################################

$ppc_ps_loc = $config_cgi;
$ppc_ps_loc =~ s/config\.cgi//gi;
$ppc_ps_loc = $ppc_ps_loc . "ppc_login.cgi";

if (((-e "$ppc_ps_loc") > 0) and ($search_templat =~ /!!ppc_results!!/))
	{
	$ppc_results = ppc_ps::get_ppc_results($okeywords, $currentpage, "NOMATCH");
	$nomatch =~ s/!!ppc_results!!/$ppc_results/gi;
	}
###################################################################


$nomatch =~ s/!!scripts_url!!/$script_url/g;

if ($gsettings->{searchmeth} eq "pseek"){$nomatch =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;}
	else {$nomatch =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;}

$nomatch =~ s/!build_url!/$web_url/g;
$nomatch =~ s/!!build_url!!/$web_url/g;

$nomatch = &ts_insert_template_includes($nomatch);
$nomatch = &fill_vars($nomatch); 

$addurl = "<a href=\"$script_url/addurl.cgi\">$gsettings->{add_url_link}</a>";
$nomatch =~ s/%%addurl%%/$addurl/g;


$nomatch =~ s/!!advanced!!/$script_url\/searchadv\.cgi/g;
$nomatch =~ s/!!rgs_login!!/$script_url\/rgs_login\.cgi/g;
$nomatch =~ s/!!register!!/$script_url\/rgs_register\.cgi/g;


print $nomatch;
exit;
}




sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $thefile);

if ((-e "$filename") > 0) 
	{
$filesize = (-s "$filename");
open (TFILECNTS, "$filename") || die "$filename";
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
	}

return ($thefile);

}





sub decode_dir
{

my ($coded_string) = @_;
my ($ms, $oneletter, $decoded_string, $plusval, $dechar, $fdchar);

$coded_string =~ s/_/ /g;

$plusval = 0;

 for ($ms = 0; $ms < length($coded_string); $ms++) 
	{
	$oneletter = substr($coded_string, $ms, 1);

	if ($plusval != 0)
		{
		$plusval++;
		if ($plusval == 4) {$plusval = 0;}
		}
	elsif ($oneletter eq ",")
		{
		$dechar = substr($coded_string, ($ms+1), 3);
		$dechar = int($dechar);
		$dechar = chr($dechar);
		
		$dechar =~ s/<//g;
		
		$decoded_string = $decoded_string . $dechar;
		$plusval++;
		}
	else 
		{
		$decoded_string = $decoded_string . $oneletter;
		}

	}

return($decoded_string);
}





sub decode_date
{

my ($tvalue) = @_;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst,@marray, $rdvalue, $ampm);

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($tvalue);
$year = "20" . substr($year, 1, 2);
@marray = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

if (length($min) == 1) {$min = "0" . $min;}
if (length($min) == 1) {$min = "0" . $min;}

if ($gsettings->{date_format} == 0)
	{
	$rdvalue = "$marray[$mon] $mday, $year";
	}
	elsif ($gsettings->{date_format} == 1)
	{
	$rdvalue = "$mday $marray[$mon] $year";
	}
	elsif ($gsettings->{date_format} == 2)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$year-$mon-$mday";
	}
	elsif ($gsettings->{date_format} == 3)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$mon-$mday-$year";
	}
	elsif ($gsettings->{date_format} == 4)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$mday-$mon-$year";
	}

#print "==>$dateformat $rdvalue <BR>";

return ($rdvalue);

}





sub get_rating_images
{
my ($rating) = @_;
my ($image_rate, $decm, $images);

	if ($rating > 0)
			{
			($image_rate, $decm) = split (/\./, $rating);
		
			if (length($decm) == 1)
				{
				if ($decm > 4) {$image_rate++;}
				}
			if (length($decm) == 2)
				{
				if ($decm > 49) {$image_rate++;}
				}
		
			$image_rate = "r" . $image_rate . ".gif";
			$image_rate =~ s/ //g;
			$images = "<img src=\"$web_url/$image_rate\">";
			}

return ($images);
}



sub encode_dir
{

my ($fstring) = @_;
my ($ms, $enc_string, $oneletter, $bstr);

$fstring =~ s/ /_/g;

 for ($ms = 0; $ms < length($fstring); $ms++) 
	{
	
	$oneletter = substr($fstring, $ms, 1);
	
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
		{
			$bstr = ord($oneletter);
			if (length($bstr) == 1) {$bstr = "00" . $bstr;}
			if (length($bstr) == 2) {$bstr = "0" . $bstr;}
			$bstr = "," . $bstr;
			$enc_string = $enc_string . $bstr;
		}
		else
		{
			$enc_string = $enc_string . $oneletter;
		}
	}

return ($enc_string);

}



sub insert_images
{
my ($ihtml, $iurl) = @_;
my ($crit);

$crit = "<img src=\""; $ihtml =~ s/\[img\]/$crit/gi;
$crit = "\">"; $ihtml =~ s/\[\/img\]/$crit/gi;
$crit = "<a href=\"$iurl\"><img src=\""; $ihtml =~ s/\[imglnk\]/$crit/gi;
$crit = "\" border=\"0\"></a>"; $ihtml =~ s/\[\/imglnk\]/$crit/gi;							

return ($ihtml);
}



sub ts_insert_template_includes
{

my ($tmpl_page) = @_;
my (@files, $ifilen, $incl, $theincl);

opendir(DIR,"$data_dir");
@files = readdir(DIR);
closedir(DIR);

if ($tmpl_page =~ /%%incl_/)
	{
	foreach $ifilen (@files)
		{
		if (substr($ifilen, 0, 5) eq "incl_")
			{
			$incl = $ifilen;
			$incl =~ s/\.html//g;
			$incl = "%%" . $incl . "%%";
				
				if ($tmpl_page =~ /$incl/)
					{
					$theincl = &get_file_contents ("$data_dir/$ifilen");
					$tmpl_page =~ s/$incl/$theincl/g;
					}
				
			}
		}
	}


if ($gsettings->{searchmeth} eq "pseek"){$tmpl_page =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;}
	else {$tmpl_page =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;}

$tmpl_page =~ s/!build_url!/$web_url/g;
$tmpl_page =~ s/!!scripts_url!!/$script_url/g;


return ($tmpl_page);

}




sub fill_vars
{

my ($filledvar) = @_;
my (@conflines, $statsetting);

$filledvar =~ s/!!scripts_url!!/$script_url/g;

if ($gsettings->{searchmeth} eq "pseek"){$filledvar =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;}
	else {$filledvar =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;}

$filledvar =~ s/!build_url!/$web_url/g;
$filledvar =~ s/!!build_url!!/$web_url/g;

open (GSETT, "$data_dir/gsettings.dat");
	@conflines = <GSETT>;
close (GSETT);
$statsetting = $conflines[29];
chop($statsetting);


####
if ($statsetting =~ /dyn_stat=Dynamic/)
	{
	$filledvar =~ s/!!whatsnew!!/$script_url\/dirs\.cgi?newpop=new/g;
	$filledvar =~ s/!!tophits!!/$script_url\/dirs\.cgi?newpop=pop/g;
	}
	else
	{
	$filledvar =~ s/!!whatsnew!!/$web_url\/new\//g;
	$filledvar =~ s/!!tophits!!/$web_url\/pop\//g;
	}

$filledvar =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;
$filledvar =~ s/!!add_url_link!!/$script_url\/addurl\.cgi/g;
$filledvar =~ s/!!add_premium_url_link!!/$script_url\/addurl\.cgi?p=1/g;
$filledvar =~ s/!!rgs_login!!/$script_url\/rgs_login\.cgi/g;
$filledvar =~ s/!!register!!/$script_url\/rgs_register\.cgi/g;
$filledvar =~ s/!!top!!/$script_url\/fp\.cgi/g;


return ($filledvar);
}




sub new_gsettings
{
my $this = {};
my ($scnts, @all_obj_items, $obji, $obj_prp, $obj_val);

$scnts = &get_file_contents("$data_dir/gsettings.dat");
@all_obj_items = split (/\n/, $scnts);

foreach $obji (@all_obj_items)
	{
	($obj_prp, $obj_val) = split (/=/, $obji);
	$this->{$obj_prp} = $obj_val;
	}

bless $this;
return $this;
}



sub get_setup
{
my ($exists, $line, $r);

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
my ($return_val, $crits);
$crits = "\"";
$setup_line =~ m/$crits/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crits/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

