#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


### MOD REWRITE CONFIGURATION ############################################
$mod_rewrite_in_use = "N"; ## Y = Yes / N = No

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_forum.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");
	

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

if ($q->param('fct') eq "cls") {&clear_cookie; exit;}
if ($q->param('sltime') ne "") {&set_msgtime;}

if ($q->param('fct') eq "forum") {&gotoforum; exit;}
if ($q->param('fct') eq "gotoforum") {&gotoforum; exit;}
if ($q->param('fct') eq "forumjump") {&gotoforum; exit;}

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "showf") {&start; exit;}


##############################

sub set_msgtime
{
my ($tmsgtime);
$tmsgtime = $q->param('sltime');
sn_netbbs::setCookie("SLTIME",$tmsgtime);
}



sub clear_cookie
{
my ($tmp);
sn_netbbs::setCookie("USER","");
print "Content-type: text/html\n\n";
print "Cookie Cleard!!";
}



sub gotoforum
{

my ($forum_stats, $forumloc, $fselbox, $current_catname, $current_boardname, $forumconfig,
    $fsize, $fsett, @fsettings, $template, $fhtml, $fid, $cid, $tline, @fdata, $iclink,
    $topicdate, $tcntr, $atstats, @tstats, $tmptopicid, $tposts, $tviews, $totaltopics,
    $totalposts, $totalviews, $totalmsg, $lastpst, $toptype, $ftcnt, @aflines, $icnt, 
    $modp, $pages, $st, $nd, $nr_searchres, $ippc, $ms, $pg, $pgstring, $spls, $nextt,
    $prev, $spcer, $prevnext, $st1, $nd1, $targpage, $rowcolor, $onoff, $curpage, $myspacer,
    $nhours, $timeind, $today, $time_now_then, @rawc, $item2, $key, $val, %cookies, $ccds,
    $whmp, $ifd, @ifset, $pollbut, $xval, $txtusername, $vuser, @aflines2, @tstats2, $stcn,
    $tmpl_to_open, $retv);


#### GET TEMPLATES

$topic_globalframe = sn_netbbs::get_file_contents("$data_dir/sn_topic_globalframe.html");
$topic_list_table_top = sn_netbbs::get_file_contents("$data_dir/sn_topic_list_table_top.html");
$topic_list_table_cells = sn_netbbs::get_file_contents("$data_dir/sn_topic_list_table_cells.html");
$topic_list_no_topics = sn_netbbs::get_file_contents("$data_dir/sn_topic_list_no_topics.html");
$globlocation = sn_netbbs::get_file_contents("$data_dir/sn_globlocation.html");
$topic_list_poll_cells = sn_netbbs::get_file_contents("$data_dir/sn_topic_list_poll_cells.html");

#### 

$onoff = 0;

if ($q->param('ac') eq "forumjump")
	{
	($cid, $fid) = split (/_/, $q->param('D1'));
	if (($cid eq "") and ($fid eq "")) 
			{
			#print "Content-type: text/html\n\n";
			#&start; exit;
			print "Location: $scripts_url/sn_forum.cgi\n\n";
			}
	}
	else
	{
	$fid = $q->param('fid');
	$cid = $q->param('cid');	
	}


sn_netbbs::check_input($fid);
sn_netbbs::check_input($cid);



#### CONFIG
$ifd = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
(@ifset) = split(/\n/,$ifd);


#### CHECK IF VALID IDS
if ((-e "$data_dir/$cid/$fid/config.dat") < 1)
	{
	print "Content-type: text/html\n\n";
	sn_netbbs::fatal_error("Invalid Forum or Category");
	}






 
### PASSWORD PROTECTION
if (($ifset[10] eq "Y") and ($ifset[11] ne ""))
	{
	$retv = sn_netbbs::check_forum_password($ifd, $cid, $fid);
	}
	elsif ($q->param('preview') eq "sn_passwd")
	{
	$retv = sn_netbbs::check_forum_password($ifd, $cid, $fid);
	}


print "Content-type: text/html\n\n";

### GET TEMPLATE

$template = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html",1);	


### TEMPLATE INCLUDES
$template = sn_netbbs::get_template_includes($template, "TOPIC_PAGE");


### SETTINGS
$forumconfig = "$data_dir/sn_settings.dat";
$fsize = (-s "$forumconfig");
open (RVF, "$forumconfig");
	read(RVF,$fsett,$fsize);
close (RVF);
(@fsettings) = split(/\n/,$fsett);







#### GET LOCATION


$locsep = sn_netbbs::get_file_contents("$data_dir/sn_locsep.html");

	$cur_location = $globlocation;
	$cur_location =~ s/!!location!!/$fsettings[11]/gi;
	
		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$mainflink = "http://" . $domain . "/forumindex.html";
			$cur_location =~ s/!!location_link!!/$mainflink/gi;
			}
			else
			{
			$cur_location =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi/gi;
			}

	####

	$catdetails = sn_netbbs::get_file_contents("$data_dir/sn_boardtable.dat");   ### GET CAT NAME
	my @catitems = split (/\n/, $catdetails);
	foreach $citem (@catitems)
		{
		($tcid, $ctname) = split (/\t/, $citem);
		if ($tcid eq $cid) { $cur_cat_name = $ctname; }
		}

	$cat_location = $globlocation;
	$cat_location =~ s/!!location!!/$cur_cat_name/gi;

		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$mainflink = "http://" . $domain . "/forum/showf,$cid.html";
			$cat_location =~ s/!!location_link!!/$mainflink/gi;
			}
			else
			{	
			$cat_location =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi?cid=$cid&fct=showf/gi;
			}
	
	####
	
	$forumdetails = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");   ### 
	my @forumitems = split (/\n/, $forumdetails);
	
	$forum_location = $globlocation;
	$forum_location =~ s/!!location!!/$forumitems[1]/gi;
	
			if ($url_write eq "SEO_ENABLED")
				{	
				$domain = sn_netbbs::get_domain($web_url);
				$mainflink = "http://" . $domain . "/forum/forum,$fid,$cid,0,20.html";
				$forum_location =~ s/!!location_link!!/$mainflink/gi;
				}
				else
				{	
				$forum_location =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi?fid=$fid&cid=$cid&fct=gotoforum/gi;
				}

	$pagetitle_loc = "$fsettings[11] : $cur_cat_name : $forumitems[1]";
	
	####

$location_string = $cur_location . $locsep . $cat_location . $locsep . $forum_location;
	
$topic_globalframe =~ s/!!location!!/$location_string/gi;





### JUMPBOX
($fselbox, $current_catname, $current_boardname) = sn_netbbs::get_forum_selbox_details();



### CONSTRUCT TOP TOPICS TABLE

$fhtml = $fhtml . $topic_list_table_top;



### DISPLAY FORUM TOPiCS
$tcntr = 0;

$ftcnt = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");   ### GET TOPICS
$atstats = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat"); ### GET TOPIC STATS

$stcn = 0;
if ($ifset[7] eq "Y") ### CHECK FOR MODERATION
	{
	@aflines2 = split (/\n/,$ftcnt);
	@tstats2 = split (/\n/,$atstats);

	foreach $tline (@aflines2)
		{
		@fdata = split (/\t/, $tline);
		if ($fdata[9] ne "Y")
			{
			$aflines[$tcntr] = "$tline";
			$tstats[$tcntr] = $tstats2[$stcn];
			$tcntr++;
			}
		$stcn++;
		}
   $tcntr = 0;	
   }
   else
   {
   @aflines = split (/\n/,$ftcnt);
   @tstats = split (/\n/,$atstats);
   }


$icnt = @aflines;
$nr_searchres = 20;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;
$today = time();
#########

foreach $tline (@aflines)
	 {

### FIGURE OUT STATS
($tmptopicid,$tposts,$tviews,$lastpst,$vuser) = split(/\t/, $tstats[$tcntr]);
$tposts = $tposts - 1;
$totaltopics++;
$totalmsg = $totalmsg + $tposts;
$totalviews = $totalviews + $tviews;

if (-e "$data_dir/$cid/$fid/$tmptopicid.cnt")
	{
	$tviews = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tmptopicid.cnt");
	}


#### LIMITED RESULTS
if (($ippc > $st) and ($ippc <= $nd))
    {

	 (@fdata) = split (/\t/, $tline);

## 0 TOPIC ID
## 1 USER
## 2 USER EMAIL
## 3 MESSAGE TOPIC
## 4 ICON
## 5 RECEIVE NOTIFICATION ON REPLY
## 6 MESSAGES IN TOPIC
## 7 TIME POSTED
## 8 LOCKED TOPIC 
## 9 MODERATED Y/N
## 10 STICKY

$iclink = "&nbsp;";
if (($fdata[4] ne "") and ($fdata[4] ne "POLLQ123"))
	{
	$iclink = "<img src=\"$web_url/icons/$fdata[4]\">";
	}


$topicdate = sn_netbbs::decode_date ($fdata[7]);


### TOPIC ICONS

$timeind = $q->param('sltime');
if ($timeind eq "")
	{
	@rawc = sn_netbbs::getCookies;
	foreach $item2(@rawc)
		{
		($key, $val) = split (/=/,$item2,2);
		$cookies{$key} = $val;
		}
	$timeind = $cookies{'SLTIME'};
	if ($timeind eq ""){$timeind = 86400;}
	}

$time_now_then = ($today - $lastpst);
#print "$time_now_then = $today - $lastpst<br>";
$xval = 0;

if ($fdata[6] == 2)
	{
	$toptype = "<img src=\"$web_url/sn_locked.gif\" alt=\"Topic Locked\">";
	$xval = 1;
	}
	elsif ($time_now_then < $timeind)
	{
	$toptype = "<img src=\"$web_url/sn_time.gif\" alt=\"Posted Within The Last 24 Hours\">";
	}
	elsif ($tposts > 14)
	{
	$toptype = "<img src=\"$web_url/sn_hottopic.gif\" alt=\"Hot Topic\">";
	}
	elsif ($tposts < 15)
	{
	$toptype = "<img src=\"$web_url/sn_opentopic.gif\" alt=\"Open Topic\">";
	}


if ($timeind == 86400){$nhours = "24 Hours";}
if ($timeind == 172800){$nhours = "48 Hours";}
if ($timeind == 259200){$nhours = "3 Days";}
if ($timeind == 432000){$nhours = "5 Days";}
if ($timeind == 864000){$nhours = "10 Days";}
if ($timeind == 1728000){$nhours = "20 Days";}
if ($timeind == 2592000){$nhours = "30 Days";}

$lastpst = sn_netbbs::decode_date ($lastpst);

### STICKY TOPIC

if ($fdata[10] eq "Y")
	{
	$toptype = "<img src=\"$web_url/sn_sticky.gif\" alt=\"Sticky Topic\">";
	$fdata[3] = "$fdata[3]";
	}

### USER ICONS
$txtusername = $fdata[1];
$txtusername =~tr/ /+/;


if (($fdata[8] eq "") or ($fdata[8] eq "Me"))
	{
	if ($fdata[2] eq "")
		{
		$user_status = "$web_url/sn_member.gif";
		$user_status_text = "Member";
		}
		else
		{
		$user_status = "$web_url/sn_member.gif";
		$user_status_text = "Member";
		}
	}
	elsif ($fdata[8] eq "Mo")
	{
	$user_status = "$web_url/sn_moderator.gif";
	$user_status_text = "Moderator";
	}
	elsif ($fdata[8] eq "Ad")
	{
	$user_status = "$web_url/sn_admin.gif";
	$user_status_text = "Administrator";
	}

if ($onoff ==0)
	{
	$rowcolor = "$fsettings[3]";
	$onoff = 1;
	}
	else
	{
	$rowcolor = "$fsettings[4]";
	$onoff = 0;
	}

$curpage = $st / $nr_searchres;
$curpage++;


### IF THIS IS A POLL

if ($fdata[4] eq "POLLQ123")
  {
  
  ### PREPARE POLL TABLE
  
  $iclink = "<img src=\"$web_url/sn_poll.gif\">";
  
  $topic_list_poll_cells_tmp = $topic_list_poll_cells;
  
  #$iclink = "P";

  $topic_list_poll_cells_tmp =~ s/!!icon!!/$toptype/gi;
  $topic_list_poll_cells_tmp =~ s/!!smily!!/$iclink/gi;
  $topic_list_poll_cells_tmp =~ s/!!topic!!/$fdata[3]/gi;
  
  $tplink = "$scripts_url/sn_forumpr.cgi?fid=$fid&cid=$cid&tid=$fdata[0]&pg=$curpage&sc=$nr_searchres";
  $topic_list_poll_cells_tmp =~ s/!!topic_link!!/$tplink/gi;
  
  $topic_list_poll_cells_tmp =~ s/!!author!!/$fdata[1]/gi;
  $topic_list_poll_cells_tmp =~ s/!!author_icon!!/$user_status/gi;
  $topic_list_poll_cells_tmp =~ s/!!member_status!!/$user_status_text/gi;
  
  #!!author_icon!!
  
  $pollpostuser = $fdata[1]; $pollpostuser =~ s/ /+/gi;
  $topic_list_poll_cells_tmp =~ s/!!author_link!!/$scripts_url\/sn_proview\.cgi?user=$pollpostuser/gi;
  
  $topic_list_poll_cells_tmp =~ s/!!views!!/$tviews/gi;    
  $topic_list_poll_cells_tmp =~ s/!!date!!/$lastpst/gi;      

  $fhtml = $fhtml . $topic_list_poll_cells_tmp;

	
  }
  else
  {
### PREPARE TOPIC TABLE

	#if ($mod_rewrite_in_use eq "Y")
		#{
		#$forum_topic_url = "$web_url/snbbsforumtopic/$fid,$cid,$fdata[0],$curpage,$nr_searchres,$xval.html";
		#}
		#else
		#{
		#$forum_topic_url = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$fdata[0]&pg=$curpage&sc=$nr_searchres&x=$xval";
		#}	

$temp_cell = $topic_list_table_cells;

$temp_cell =~ s/!!icon!!/$toptype/gi;
$temp_cell =~ s/!!smily!!/$iclink/gi;

$temp_cell =~ s/!!topic!!/$fdata[3]/gi;


		if ($url_write eq "SEO_ENABLED")
			{
			$domain = sn_netbbs::get_domain($web_url);
			$forum_topic_url = "http://" . $domain . "/forum/forumtopic/$fid,$cid,$fdata[0],$curpage,$nr_searchres,$xval,0,10.html";
			$temp_cell =~ s/!!topic_link!!/$forum_topic_url/gi;
			}
			else
			{
			$forum_topic_url = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$fdata[0]&pg=$curpage&sc=$nr_searchres&x=$xval";
			$temp_cell =~ s/!!topic_link!!/$forum_topic_url/gi;
			}


$temp_cell =~ s/!!author!!/$fdata[1]/gi;
$temp_cell =~ s/!!author_icon!!/$user_status/gi;
$temp_cell =~ s/!!member_status!!/$user_status_text/gi;

$temp_cell =~ s/!!author_link!!/$scripts_url\/sn_proview\.cgi?user=$txtusername/gi;

$temp_cell =~ s/!!views!!/$tviews/gi;
$temp_cell =~ s/!!replies!!/$tposts/gi;

$temp_cell =~ s/!!date!!/$lastpst/gi;
$temp_cell =~ s/!!last_poster!!/$vuser/gi;

$vuser_spc = $vuser; $vuser_spc =~ s/ /+/g;
$temp_cell =~ s/!!last_poster_link!!/$scripts_url\/sn_proview\.cgi?user=$vuser_spc/gi;

$fhtml = $fhtml . $temp_cell;

#$fhtml = $fhtml . <<END_FTOPIC;
#  <tr>
#    <td width="1%" height="27" bgcolor="$rowcolor" valign="middle"><font face="$fsettings[6]" size="2">$toptype</font></td>
#    <td width="1%" height="27" bgcolor="$rowcolor" valign="middle"><font face="$fsettings[6]" size="2"><center>$iclink</center></font></td>
#    <td width="38%" height="27"  bgcolor="$rowcolor" valign="middle"><font face="$fsettings[6]" size="2"><a href="$forum_topic_url">$fdata[3]</a></font></td>
#    <td width="14%" height="27"  bgcolor="$rowcolor" valign="middle"><font face="$fsettings[6]" size="1"><strong>$fdata[1]</strong></font></td>
#    <td width="6%" height="27" bgcolor="$rowcolor" valign="middle"><p align="center"><font face="$fsettings[6]" size="2">$tviews</font></td>
#    <td width="6%" height="27" bgcolor="$rowcolor" valign="middle"><p align="center"><font face="$fsettings[6]" size="2">$tposts</font></td>
#    <td width="23%" height="27" bgcolor="$rowcolor" valign="middle"><font face="$fsettings[6]" size="1">$lastpst<br>$vuser</font></td>
#  </tr>
#END_FTOPIC

  }


  } ### END OF CHECK LIMITED RESULT DISPLAY
	
  $ippc++;
  $tcntr++;

 } ### END OF LOOP

#### IF NO MESSAGES
if ($totaltopics == 0) { $fhtml = $fhtml . $topic_list_no_topics;	}

$topic_globalframe =~ s/!!total_t!!/$totaltopics/gi;
$topic_globalframe =~ s/!!total_r!!/$totalmsg/gi;



#### PAGES 

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		
		$domain = sn_netbbs::get_domain($web_url);
		
		if ($url_write eq "SEO_ENABLED")
			{	
			$rewpg = "http://" . $domain . "/forum/forum,$fid,$cid,$st1,$nd1.html";
			$pgstring = $pgstring . "<a href=\"$rewpg\">$pg</a> ";
			}
			else
			{
			$pgstring = $pgstring . "<a href=\"$scripts_url/sn_forum.cgi?st=$st1&nd=$nd1&fid=$fid&cid=$cid&fct=gotoforum\">$pg</a> ";
			}
		}
	}


$topic_globalframe =~ s/!!pages!!/$pgstring/gi;





### PREV NEXT PAGES

$s_nextpage = sn_netbbs::get_file_contents("$data_dir/sn_nextp.html");
$s_prevpage = sn_netbbs::get_file_contents("$data_dir/sn_prevp.html");
$s_nextprev_sep = sn_netbbs::get_file_contents("$data_dir/sn_nextprevsep.html");



$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
				
				if ($url_write eq "SEO_ENABLED")
					{	
					$domain = sn_netbbs::get_domain($web_url);
					$rewnext = "http://" . $domain . "/forum/forum,$fid,$cid,$st1,$nd1.html";
					$nextt = "<a href=\"$rewnext\">$s_nextpage</a> ";
					}
					else
					{
					$nextt = "<a href=\"$scripts_url/sn_forum.cgi?st=$st1&nd=$nd1&fid=$fid&cid=$cid&fct=gotoforum\">$s_nextpage</a> ";
					}
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		
				if ($url_write eq "SEO_ENABLED")
					{	
					$domain = sn_netbbs::get_domain($web_url);
					$rewprev = "http://" . $domain . "/forum/forum,$fid,$cid,$st1,$nd1.html";
					$prev = "<a href=\"$rewprev\">$s_prevpage</a> ";
					}
					else
					{
					$prev = "<a href=\"$scripts_url/sn_forum.cgi?st=$st1&nd=$nd1&fid=$fid&cid=$cid&fct=gotoforum\">$s_prevpage</a> ";
					}
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " $s_nextprev_sep ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	#if (length($prevnext) > 5){$myspacer = " | ";}
	#$fhtml =~ s/!!page_data!!/<font face="$fsettings[6]" size="1">$prevnext $myspacer Page $targpage of $pg<\/font>/g;


$topic_globalframe =~ s/!!next_page!!/$prevnext/gi;
$topic_globalframe =~ s/!!current_page!!/$targpage/gi;
$topic_globalframe =~ s/!!total_pages!!/$pg/gi;




### CLOSE TABLE AND PRINT JUMP BOX

$sn_postany = sn_netbbs::get_file_contents("$data_dir/sn_postany.html");
$sn_postmod = sn_netbbs::get_file_contents("$data_dir/sn_postmod.html");
$sn_postadm = sn_netbbs::get_file_contents("$data_dir/sn_postadm.html");


if ($ifset[4] eq "Any")
	{ 
	$whmp = $sn_postany;
	}
elsif ($ifset[4] eq "Registered")
	{ 
	$whmp = $sn_postmod;
	}
else
	{ 
	$whmp = $sn_postadm;
	}

$topic_globalframe =~ s/!!post_users!!/$whmp/gi;




#### POLL BUTTON
if (($ifset[5] eq "Y") and ($ifset[12] ne "N")) ### IF POLLS ALLOWED
	{
	$pollbut = "<a href=\"$scripts_url/sn_netbpoll.cgi?fid=$fid&cid=$cid&fct=poll\"><img src=\"$web_url/sn_postpoll.gif\" border=\"0\"></a>";
	}
$topic_globalframe =~ s/!!new_poll_button!!/$pollbut/gi;


#### IF READ ONLY
if ($ifset[12] ne "N") 
	{
	$postbutton = "<a href=\"$scripts_url/sn_forump.cgi?fid=$fid&amp;cid=$cid\"><img src=\"$web_url/sn_post.gif\" border=\"0\"></a>";
	}
$topic_globalframe =~ s/!!new_topic_button!!/$postbutton/gi;


$fhtml = $fhtml . "</table>";



#### GET MODERATORS

$moderator_display = sn_netbbs::get_moderators_new($cid, $fid);
$topic_globalframe =~ s/!!moderators!!/$moderator_display/gi;



#### MESSAGES POSTED IN LAST XX HOURS/DAYS

$time_msg_box = sn_netbbs::get_newmsg_box($cid, $fid);
$topic_globalframe =~ s/!!new_messages_drop_down!!/$time_msg_box/gi;



#### FORUM JUMP BOX

$forum_jump_box = sn_netbbs::get_forum_selbox;
$topic_globalframe =~ s/!!forumjump!!/$forum_jump_box/gi;



## LAST VISITORS
if (@fsettings[17] ne "N")
	{
	$lastvisitors = sn_netbbs::get_last_visitors;
	}
$topic_globalframe =~ s/!!last_visitors!!/$lastvisitors/gi;


$fhtml = $fhtml . $idtmpl;

$template =~ s/!!forums!!/$topic_globalframe/g;

$template =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$template =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$template =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$template =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$template =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi;

$forumlogo = $ifset[8];
$forumlogo = qq[<img src="$web_url/$ifset[8]">];

$template =~ s/!!forum_name!!/$fsettings[11]/gi;

$template =~ s/!!logo!!/$forumlogo/gi;

$template =~ s/!!forums!!/$fhtml/gi;





$totaltopics = int($totaltopics);
$template =~ s/!!ttp!!/$totaltopics/g;

$totalmsg = int($totalmsg);
$template =~ s/!!ttr!!/$totalmsg/g;

$totalviews = int($totalviews);
$template =~ s/!!ttv!!/$totalviews/g;

$totalmsg = $totalmsg + $totaltopics;
$totalmsg = int($totalmsg);
$template =~ s/!!ttm!!/$totalmsg/g;
$template =~ s/!!total_m!!/$totalmsg/g;

$template =~ s/!web_url!/$web_url/g;

$template =~ s/!!pagetitle!!/$pagetitle_loc/g;

print $template;

}





##############################

sub start
{

my ($fsize, $template, $fcats, $iline, $id, $catname, $fdetails, $fid, 
    @fsettings, $fline, $msettings, @forum_settings, $stline, $tmpa, 
    $posts, $views, $ntopics, $nposts, $data1, $totaltopics, $totalreplies,
    $totalmsgs, @files, $usernumber, $lastpdata, $lastdate, $bwhom, $data2,
    $lpdata, $cnum, $ccolor, $ccds, $whopst, $showreg);

$cnum = 1;

if ($q->param('cid') ne "") { sn_netbbs::check_input($q->param('cid')); }

### GET GLOBAL FRAME TEMPLATE
$template = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html",1);


### GET CATEGORY FRAME TEMPLATE
$fp_frame = sn_netbbs::get_file_contents("$data_dir/sn_fp_frame.html");
$template =~ s/!!forums!!/$fp_frame/g;


### GET SETTINGS
$fsize = (-s "$data_dir/sn_settings.dat");
open (RVF, "$data_dir/sn_settings.dat");
	read(RVF,$msettings,$fsize);
close (RVF);
(@forum_settings) = split(/\n/,$msettings);


### (FORUMTOP) = print_forum_gen_top (ACTION, GLOBAL FORUM NAME);

if ($q->param('fct') eq "showf")
	{
	$ctname = sn_netbbs::get_cat_name($q->param('cid'));
	#$fcats = sn_netbbs::print_forum_gen_top ("$ctname", $forum_settings[11]);
	
	### GET LOCATION TEMPLATE
	$locstring = sn_netbbs::get_file_contents("$data_dir/sn_globlocation.html");
	$locsep = sn_netbbs::get_file_contents("$data_dir/sn_locsep.html");
	
	$locstring_tmp1 = $locstring;
	$locstring_tmp1 =~ s/!!location!!/$forum_settings[11]/gi;
	

	if ($url_write eq "SEO_ENABLED")
		{	
		$domain = sn_netbbs::get_domain($web_url);
		$mainflink = "http://" . $domain . "/forumindex.html";
		$locstring_tmp1 =~ s/!!location_link!!/$mainflink/gi;
		}
		else
		{
		$locstring_tmp1 =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi/gi;
		}
	

	$locstring_tmp2 = $locstring;
	$locstring_tmp2 =~ s/!!location!!/$ctname/gi;
	$acid = $q->param('cid');

	
		if ($url_write eq "SEO_ENABLED")
		{
		$domain = sn_netbbs::get_domain($web_url);
		$fcatlink = "http://" . $domain . "/forum/showf,$acid.html";
		$locstring_tmp2 =~ s/!!location_link!!/$fcatlink/gi;
		}
		else
		{
		$locstring_tmp2 =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi\?cid=$acid&fct=showf/gi;
		}
	

	$template =~ s/!!location!!/$locstring_tmp1 $locsep $locstring_tmp2/gi;
	}
	else
	{
	$template =~ s/!!location!!//gi;
	}



### GET TOP OF FORUM TABLE
$fcats = $fcats . sn_netbbs::get_file_contents("$data_dir/sn_fp_toptable.html");

### GET FORUM CATEGORY TABLE TEMPLATE
$template_forum_cat = sn_netbbs::get_file_contents("$data_dir/sn_fp_celcat.html");

### GET FORUM TABLE CELL
$template_forum_cell = sn_netbbs::get_file_contents("$data_dir/sn_fp_forumcel.html");

### MODERATORS ADMINISTRATORS TEMPLATE
$template_modadm = sn_netbbs::get_file_contents("$data_dir/sn_fp_moderators.html");


open (FTBL, "$data_dir/sn_boardtable.dat");
	while (defined($iline=<FTBL>))
		{




###### GET CATEGORY
		
($id, $catname) = split(/\t/,$iline,2);


if (($q->param('fct') eq "showf") and ($id eq $q->param('cid'))) ### ADD FORUM CELL FOR CATEGORY
	{
	$template_forum_cat_temp = $template_forum_cat;
	$template_forum_cat_temp =~ s/!!category_names!!/$catname/gi;
	
		if ($url_write eq "SEO_ENABLED")
			{
			$domain = sn_netbbs::get_domain($web_url);
			$catlinks = "http://" . $domain . "/forum/showf," . $id . ".html";
			$template_forum_cat_temp =~ s/!!category_links!!/$catlinks/gi;
			}
			else
			{
			$catlinks = "$scripts_url/sn_forum.cgi?cid=$id&fct=showf";
			$template_forum_cat_temp =~ s/!!category_links!!/$catlinks/gi;
			}
	
	$fcats = $fcats . $template_forum_cat_temp;
	}
	elsif ($q->param('fct') eq "")
	{

	$template_forum_cat_temp = $template_forum_cat;
	$template_forum_cat_temp =~ s/!!category_names!!/$catname/gi;
	

		if ($url_write eq "SEO_ENABLED")
			{
			$domain = sn_netbbs::get_domain($web_url);
			$catlinks = "http://" . $domain . "/forum/showf," . $id . ".html";
			$template_forum_cat_temp =~ s/!!category_links!!/$catlinks/gi;
			}
			else
			{
			$catlinks = "$scripts_url/sn_forum.cgi?cid=$id&fct=showf";
			$template_forum_cat_temp =~ s/!!category_links!!/$catlinks/gi;
			}

	
	$fcats = $fcats . $template_forum_cat_temp;	
	}






####### GET FORUMS

open (FORUMTABLE, "$data_dir/$id/forumtable.dat");
	while (defined($fline=<FORUMTABLE>))
		{
		($fid, $catname) = split(/\t/,$fline,2);

		$fsize = (-s "$data_dir/$id/$fid/config.dat");
			open (FORUMDETAILS, "$data_dir/$id/$fid/config.dat");
				read(FORUMDETAILS,$fdetails,$fsize);
			close (FORUMDETAILS);
		
		(@fsettings) = split(/\n/,$fdetails);


	### GET STATS
	$ntopics = 0;
	$nposts = 0;

	open (STATABLE, "$data_dir/$id/$fsettings[0]/tstats.dat");
	 if ($flocking ne "No"){flock (STATABLE,2);}
		while (defined($stline=<STATABLE>))
			{
			($tmpa, $posts, $views) = split(/\t/,$stline);
			$ntopics++;
			$nposts = $nposts + $posts;
			$nposts = $nposts - 1;
			}
	 if ($flocking ne "No"){flock (STATABLE,8);}
	close (STATABLE);

	$totaltopics = $totaltopics + $ntopics;
	$totalreplies = $totalreplies + $nposts;

	$lastpdata = sn_netbbs::get_file_contents("$data_dir/$id/$fsettings[0]/sn_last.dat");
	($lastdate, $bwhom) = split (/\t/, $lastpdata);
	if ($lastdate ne "")
		{
		$lastdate = sn_netbbs::decode_date($lastdate);
		$lpdata = "$lastdate";
		}
		else
		{
		$lpdata = "No Posts Yet";
		}

	if ($cnum == 1)
		{
		$ccolor = $forum_settings[3];
		$cnum = 0;
		}
		else
		{
		$ccolor = $forum_settings[4];
		$cnum = 1;
		}
 

	if ($fsettings[4] eq "Any") { $whopst = "<img src=\"$web_url/sn_anypost.gif\">"; }
	elsif ($fsettings[4] eq "Registered") { $whopst = "<img src=\"$web_url/sn_regpost.gif\">"; }
	else { $whopst = "<img src=\"$web_url/sn_modpost.gif\">"; }


	$mcnt = 0;
	foreach $moitem (@all_moderators)
		{
		$all_moderators[$mcnt] = "";
		$mcnt++;
		}


	
	#### GET MODERATORS ADMINISTRATORS
	
	$mostring = "";
	@all_moderators = sn_netbbs::get_moderators($fsettings[3]);

	foreach $moitem (@all_moderators)
		{
		if ($moitem ne "")
			{
			$template_modadm_tmp = $template_modadm;
			
			$CmoString = $moitem;
			$CmoString =~ s/ /+/g;
			
			$template_modadm_tmp =~ s/!!modadm_link!!/$scripts_url\/sn_proview.cgi\?user=$CmoString/gi;
			$template_modadm_tmp =~ s/!!modadm!!/$moitem/gi;
			$mostring = $mostring . $template_modadm_tmp;
			}
		}
		$mostring = substr($mostring, 0, length($mostring) - 1);



	 
	#### IF DISPLAYING FORUM CATEGORY
	
	if (($q->param('fct') eq "showf") and ($id eq $q->param('cid')))
	{

		if ($mod_rewrite_in_use eq "Y")
		{
		$forumurl = "$web_url/snbbsgotoforum/$fsettings[0],$id,gotoforum.html";
		}
		else
		{
		$forumurl = "$scripts_url/sn_forum.cgi?fid=$fsettings[0]&cid=$id&fct=gotoforum";
		}

		$template_forum_cell_tmp = $template_forum_cell;

			$template_forum_cell_tmp =~ s/!!forum_names!!/$fsettings[1]/gi;
			
			if ($url_write eq "SEO_ENABLED")
				{
				$domain = sn_netbbs::get_domain($web_url);
				$replace_crit = "http://" . $domain . "/forum/forum," . $fid . "," . $id . ",0,20" . ".html";
				$template_forum_cell_tmp =~ s/!!forum_links!!/$replace_crit/gi;
				}
				else
				{
				$template_forum_cell_tmp =~ s/!!forum_links!!/$scripts_url\/sn_forum.cgi?fid=$fid&cid=$id&fct=gotoforum/gi;
				}
			
			
			$template_forum_cell_tmp =~ s/!!whop!!/$whopst/gi;
			$template_forum_cell_tmp =~ s/!!forum_description!!/$fsettings[2]/gi;

			$template_forum_cell_tmp =~ s/!!topics!!/$ntopics/gi;
			$template_forum_cell_tmp =~ s/!!replies!!/$nposts/gi;

			$template_forum_cell_tmp =~ s/!!last_post_date!!/$lpdata/gi;
			$template_forum_cell_tmp =~ s/!!last_poster!!/$bwhom/gi;
			$template_forum_cell_tmp =~ s/!!last_poster_link!!/$scripts_url\/sn_proview.cgi\?user\=$bwhom/gi;
			
			$template_forum_cell_tmp =~ s/!!moderators!!/$mostring/gi;
			
			

	$fcats = $fcats . $template_forum_cell_tmp;

	}
	elsif ($q->param('fct') eq "") ### IF VIEWING FRONT PAGE
	{

		if ($mod_rewrite_in_use eq "Y")
			{
			$forumurl = "$web_url/snbbsgotoforum/$fsettings[0],$id,gotoforum.html";
			}
			else
			{
			$forumurl = "$scripts_url/sn_forum.cgi?fid=$fsettings[0]&cid=$id&fct=gotoforum";
			}	


		$template_forum_cell_tmp = $template_forum_cell;

		$template_forum_cell_tmp =~ s/!!forum_names!!/$fsettings[1]/gi;


			if ($url_write eq "SEO_ENABLED")
				{
				$domain = sn_netbbs::get_domain($web_url);
				$replace_crit = "http://" . $domain . "/forum/forum," . $fid . "," . $id . ",0,20" . ".html";
				$template_forum_cell_tmp =~ s/!!forum_links!!/$replace_crit/gi;
				}
				else
				{
				$template_forum_cell_tmp =~ s/!!forum_links!!/$scripts_url\/sn_forum.cgi?fid=$fid&cid=$id&fct=gotoforum/gi;
				}
		
		$template_forum_cell_tmp =~ s/!!whop!!/$whopst/gi;
		$template_forum_cell_tmp =~ s/!!forum_description!!/$fsettings[2]/gi;

		$template_forum_cell_tmp =~ s/!!topics!!/$ntopics/gi;
		$template_forum_cell_tmp =~ s/!!replies!!/$nposts/gi;
		
		$template_forum_cell_tmp =~ s/!!last_post_date!!/$lpdata/gi;
		$template_forum_cell_tmp =~ s/!!last_poster!!/$bwhom/gi;
		$template_forum_cell_tmp =~ s/!!last_poster_link!!/$scripts_url\/sn_proview.cgi\?user\=$bwhom/gi;

		$template_forum_cell_tmp =~ s/!!moderators!!/$mostring/gi;

		$fcats = $fcats . $template_forum_cell_tmp;

	}



		}
		close(FORUMTABLE);		

}
close (FTBL);

$fcats = $fcats . "</table>";


###### LEGEND


###### LAST VISITORS
if ($template =~ /!!last_visitors!!/i)
	{
	$lastvisitors = sn_netbbs::get_last_visitors;
	}
$template =~ s/!!last_visitors!!/$lastvisitors/gi;



### GET TOTAL REGISTERED USERS

$totalmsgs = $totaltopics + $totalreplies;

opendir(DIR,"$data_dir/users");
	@files = readdir(DIR);
closedir(DIR);
$usernumber = push(@files);
$usernumber = $usernumber - 3;

if ($forum_settings[14] eq "Y")
	{
	$showreg = "<b>$usernumber</b> registered users with";
	}



#### SET UP VARIABLES

$template =~ s/!!forum_name!!/$forum_settings[11]/gi;
$template =~ s/!!pagetitle!!/$forum_settings[11]/gi;
$template =~ s/!!total_users!!/$usernumber/gi;
$template =~ s/!!total_messages!!/$totalmsgs/gi;
$template =~ s/!!total_topics!!/$totaltopics/gi;
$template =~ s/!!total_replies!!/$totalreplies/gi;

$forum_logo = qq[<img src="$web_url/$forum_settings[0]" alt="$forum_settings[11]">];
$template =~ s/!!logo!!/$forum_logo/gi;


$template =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$template =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$template =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$template =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$template =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi;




#####

$lastpdata = sn_netbbs::get_file_contents("$data_dir/sn_last.dat");
($lastdate, $bwhom) = split (/\t/, $lastpdata);
$lastdate = sn_netbbs::decode_date($lastdate);

$data2 = <<END_OF_DATA2;
	<font face="$forum_settings[6]" size="1">The last post was made on <br><b>$lastdate</b> by <b>$bwhom</b></font>
END_OF_DATA2

########

$fcats =~ s/!!DATA1!!//g;
$fcats =~ s/!!DATA2!!/$data2/g;
$fcats = $fcats . $idtmpl;

$template =~ s/!!category_forum_table!!/$fcats/g;
$template =~ s/!web_url!/$web_url/gi;

#$template = sn_netbbs::get_template_includes($template, "");

print $template;

}

