#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################



## READ CONFIGURATION ###############################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	sn_fmspm::check_spamb("sn_forume.cgi", "header", $data_dir);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}
#if ($q->param('fct') eq "editmsg") {&editmsg; exit;}
if ($q->param('fct') eq "save_message") {&save_message; exit;}

#### START ########################################################

sub save_message
{

print <<END_OF_NA;

<table border="0" cellspacing="1" width="100%" bgcolor="#C0C0C0" cellpadding="5">
  <tr>
    <td width="100%" bgcolor="#FCDD2C" height="27"><font face="Verdana" size="2"><strong>Feature
    Not Available in Shareware/Evaluation Version</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF" height="27"><font face="Verdana" size="2">This function
    is not available in the shareware/evaluation version of SiteNet BBS. <a
    href="http://www.focalmedia.net/sitenetbbs.html#register" target="_blank">Click here</a>
    to upgrade your copy to the commercial version of SiteNet BBS where all functions are
    enabled. Upgrading is a simple process and will take you under 5 minutes.</font></td>
  </tr>
</table>

END_OF_NA

}



sub start
{

my ($lhtmldata, @rawc, $item2, $key, $val, %cookies, $uname, $upass, $template);

#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
#$lhtmldata = sn_netbbs::login_box("editmsg", "$scripts_url/sn_forume.cgi", "Edit Message", "Edit Message");

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');
$rpm = $q->param('rpm'); 

### CHECK IF USER IS LOGGED IN

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false


if ($logged_in_status eq "false")  ### DISPLAY LOGIN WINDOW
	{
	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_login.cgi?l=editmsg&cid=$cid&fid=$fid&tid=$tid&rpm=$rpm">
	</head>
	<body>
	</body>
	</html>
	];
	}
	else
	{
	&editmsg;
	}


}





sub editmsg
{

my ($uname, $upass, @usettings, $cid, $fid, $tid, $rpm, $allidata, @allitems,
	 @msgitems, $okpass, $moad, $delbutton, @settings, $template, $txt, $crit1, 
	 $crit2, $crit3, $crit4, $crit5, $crit6, $crit7);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

@settings = sn_netbbs::get_global_settings();


@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);


$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');
$rpm = $q->param('rpm');

(@usettings) = sn_netbbs::check_username_password ($uname, $upass);

#### USER DETAILS

$allidata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.dat");
@allitems = split (/\n/, $allidata);
$rpm = $rpm - 1;
@msgitems = split (/\t/, $allitems[$rpm]);

if (lc($msgitems[1]) eq lc($usettings[0])){$okpass = "OK";} ### EDITING BY USER WHO POSTED MSG
#if (substr($usettings[12], 0, 2) eq "Mo"){$okpass = "OK"; $moad = "OK";} ### MODERATOR EDIT
if (substr($usettings[12], 0, 2) eq "Ad"){$okpass = "OK"; $moad = "OK";} ### ADMINISTRATOR EDIT


$forum_moderators_data = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@forum_moderators_adata = split (/\n/, $forum_moderators_data);
@all_moderators = sn_netbbs::get_moderators($forum_moderators_adata[3]); 

foreach $mitem (@all_moderators)
	{
	if (lc($usettings[0]) eq lc($mitem))
		{
		$okpass = "OK";
		$moad = "OK";
		}
	}


#### GET TEMPLATES
$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$template = sn_netbbs::get_file_contents("$data_dir/sn_edit_msg.html");
$ptitle = sn_netbbs::get_page_title("sn_edit_msg");


if (($usettings[0] eq "ERROR") or ($okpass ne "OK"))
	{
	$sn_edit_unable = sn_netbbs::get_file_contents("$data_dir/sn_edit_unable.html");
	$ptitle = sn_netbbs::get_page_title("sn_edit_unable");
	
	@settings = sn_netbbs::get_global_settings();
	
	$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
	$sn_edit_unable =~ s/!!location!!/$loclink/g;
		
	$globalframe =~ s/!!forums!!/$sn_edit_unable/gi;
		
	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
		
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
		
	$globalframe =~ s/!web_url!/$web_url/g;
	$globalframe =~ s/!!pagetitle!!/$ptitle/g;
	
	print $globalframe;
 	exit;

	}
	else
	{

$msgitems[7] =~ s/<br>/\n/g;




	if (($moad eq "OK") and ($rpm > 0))
		{
		#$delbutton = "<input type=\"submit\" value=\"Delete Message\" name=\"B2\" style=\"font-family: MS Sans Serif; font-size: 8pt\"> ";
		$template = sn_netbbs::display_errors($template, "del_msg", "");
		}
		else
		{
		$template = sn_netbbs::display_errors($template, "del_msg", "NODISPLAY");
		}
		
		if ($moad eq "OK")
			{
			#$delbutton = $delbutton . "<input type=\"submit\" value=\"Delete Topic\" name=\"B3\" style=\"font-family: MS Sans Serif; font-size: 8pt\">";
			$template = sn_netbbs::display_errors($template, "del_topic", "");
			
				########
				$stickt = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
				@stitmes = split (/\n/, $stickt);
								
				foreach $topicitem (@stitmes)
				{
				@stpcc = split(/\t/, $topicitem);
				  
					if ($stpcc[0] eq $tid)
						{
						if ($stpcc[6] == 2) { $topic_locked = "true"; } else { $topic_locked = "false"; }
						
						if ($stpcc[10] eq "Y")
							{
							#$delbutton = $delbutton . " <input type=\"submit\" value=\"Unstick Topic\" name=\"B4\" style=\"font-family: MS Sans Serif; font-size: 8pt\">";
							$template = sn_netbbs::display_errors($template, "unstick", "");
							$template = sn_netbbs::display_errors($template, "stick", "NODISPLAY"); 
							$unstickt = "true";
							}
						}
				}
				########
				
			if ($unstickt ne "true") 
			{
			$template = sn_netbbs::display_errors($template, "unstick", "NODISPLAY"); 
			$template = sn_netbbs::display_errors($template, "stick", ""); 
			}
			
			### TOPIC LOCKED
			if ($topic_locked eq "true")
				{
				$template = sn_netbbs::display_errors($template, "unlock_topic", "");
				$template = sn_netbbs::display_errors($template, "lock_topic", "NODISPLAY");
				}
				else
				{
				$template = sn_netbbs::display_errors($template, "unlock_topic", "NODISPLAY");
				$template = sn_netbbs::display_errors($template, "lock_topic", "");
				}
			
			### IP DISPLAY
			$template = sn_netbbs::display_errors($template, "mod_adm_ipdisplay", "");
			
			}
			else
			{
			$template = sn_netbbs::display_errors($template, "del_topic", "NODISPLAY");
			$template = sn_netbbs::display_errors($template, "unstick", "NODISPLAY");
			$template = sn_netbbs::display_errors($template, "mod_adm_ipdisplay", "NODISPLAY");
			$template = sn_netbbs::display_errors($template, "lock_topic", "NODISPLAY");
			$template = sn_netbbs::display_errors($template, "unlock_topic", "NODISPLAY");
			$template = sn_netbbs::display_errors($template, "stick", "NODISPLAY"); 
			}




		$crit1 = "<img src=\"$web_url/sn_happy.gif\">";
		$crit2 = "<img src=\"$web_url/sn_happy2.gif\">";
		$crit3 = "<img src=\"$web_url/sn_ooo.gif\">";
		$crit4 = "<img src=\"$web_url/sn_grin.gif\">";
		$crit5 = "<img src=\"$web_url/sn_question.gif\">";
		$crit6 = "<img src=\"$web_url/sn_cool.gif\">";
		$crit7 = "<img src=\"$web_url/sn_cup.gif\">";

		$msgitems[7] =~ s/$crit1/:\)/g;
		$msgitems[7] =~ s/$crit2/;\)/g;
		$msgitems[7] =~ s/$crit3/:o/g;
		$msgitems[7] =~ s/$crit4/\[biggrin\]/g;
		$msgitems[7] =~ s/$crit5/\[confused\]/g;
		$msgitems[7] =~ s/$crit6/\[cool\]/g;
		$msgitems[7] =~ s/$crit7/\[award\]/g;


$rgsf = $config_cgi;
$rgsf =~ s/config\.cgi//g;


#if ((-e "$rgsf" . "sn_rgst.cgi") > 0)
#	{
#	$execscr = "sn_rgst.cgi";
#	}
#	else
#	{
#	$execscr = "sn_forume.cgi";
#	}


$template =~ s/!!edit_script!!/$scripts_url\/sn_rgst.cgi/gi;

$template =~ s/!!message!!/$msgitems[7]/gi;
$template =~ s/!!ip!!/$msgitems[8]/gi;

$hvars = qq[
<input type="hidden" name="cid" value="$cid">
<input type="hidden" name="fct" value="save_message">
<input type="hidden" name="fid" value="$fid">
<input type="hidden" name="rpm" value="$rpm">
<input type="hidden" name="tid" value="$tid">
</form>
];
$template =~ s/<\/form>/$hvars/gi;

###############


	@settings = sn_netbbs::get_global_settings();
	
	$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
	$template =~ s/!!location!!/$loclink/g;
		
	$globalframe =~ s/!!forums!!/$template/gi;

	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
		
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
	$globalframe =~ s/!!pagetitle!!/$ptitle/g;
	$globalframe =~ s/!web_url!/$web_url/g;
	
	print $globalframe;
 	exit;


	}


}

