#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

### MOD REWRITE CONFIGURATION ############################################
$mod_rewrite_in_use = "N"; ## Y = Yes / N = No


## READ CONFIGURATION ###############################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_forumr.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}



#### START ########################################################

sub start
{

my ($cid, $fid, $tid, $catname, $template, @settings, $ftop, $msgtopic, $username,
 	 $tcline, @mcontents, $bcc, $msgline, @msitem, $ocn, $tbackcolor, $csetter, $tcntr,
 	 $ftcnt, @aflines, $icnt, $nr_searchres, $modp, $pages, $st, $nd, $ippc, $ms, $pg,
 	 $pgstring, $targpage, $st1, $nd1, $spls, $nextt, $prev, $spcer, $prevnext,
 	 $pg1, $sc, $tpage, $nst, $nnd, $dateposted, $ufle, @udataf, $uicon, $uposts, $tline,
 	 $sbcntr, @titlevalues, $ttval, $mmtitle, $memberposts, $fselbox, $ccn, $cfn, $ccds,
 	 $uregistered, $profbut, $embut, $gfrs, $pollbut, @forset, $user_image, $locktxt, 
 	 $lockfct, $replybut, $viewdata, @astln, $stat_item, @astln, $rstatv_count, $old_stat_count2, $mdisplay,
 	 @msglns, $sec1,$min1,$hour1,$mday1,$mon1,$year1,$wday1,$ydat1,$isdst1, $modcrypt, $tmpl_to_open);

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');
$pg1 = $q->param('pg');
$sc = $q->param('sc');


sn_netbbs::check_input($cid);
sn_netbbs::check_input($fid);
sn_netbbs::check_input($tid);

if ((-e "$data_dir/$cid/$fid/$tid.dat") < 1)
	{
	sn_netbbs::fatal_error("Invalid Forum / Category or Message");
	}




$catname = sn_netbbs::get_cat_name($cid);


$modadm_data = &get_file_contents("$data_dir/sn_modadm.txt");
($gadm, $gmod) = split (/:::/, $modadm_data);



### GET GLOBAL FORUM SETTINGS
$forumconfig = "$data_dir/sn_settings.dat";
$fsize = (-s "$forumconfig");
open (RVF, "$forumconfig");
	read(RVF,$fsett,$fsize);
close (RVF);
(@fsettings) = split(/\n/,$fsett);


### GET TEMPLATES

	$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html",1);
	$template = sn_netbbs::get_file_contents("$data_dir/sn_topmsg_frame.html");
	$sn_first_msg = sn_netbbs::get_file_contents("$data_dir/sn_first_msg.html");
	$sn_reply_msg = sn_netbbs::get_file_contents("$data_dir/sn_reply_msg.html");
	$sn_topic_top = sn_netbbs::get_file_contents("$data_dir/sn_topic_top.html");
	$sn_quote = sn_netbbs::get_file_contents("$data_dir/sn_quote.html");
	


### CONF
$gfrs = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@forset = split (/\n/, $gfrs);




 

### WRITE STATS

if (-e "$data_dir/$cid/$fid/$tid.cnt" < 1)
	{
	$rstatv_count = 0;
	$viewdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
	@astln = split (/\n/, $viewdata);
	foreach $stat_item (@astln)
		{
		($stat_id, $stat_posts, $stat_views, $stat_date, $stat_lpost) = split (/\t/, $stat_item);
		if ($stat_id == $tid)
			{
			$rstatv_count = $rstatv_count + $stat_views;
			}
		}
	}

if (-e "$data_dir/$cid/$fid/$tid.cnt")
	{
	$old_stat_count2 = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.cnt");
	$rstatv_count = $rstatv_count + $old_stat_count2;
	}

$rstatv_count++;
open (VIEWS, ">$data_dir/$cid/$fid/$tid.cnt");
 if ($flocking ne "No"){flock (VIEWS,2);}
	print VIEWS $rstatv_count;	
 if ($flocking ne "No"){flock (VIEWS,8);}
close (VIEWS);






### TEMPLATE INCLUDES
#$template = sn_netbbs::get_template_includes($template, "MSG_PAGE");



### GET MESSAGES
$bcc = 0;



### VIEW MODERATED MESSAGES
if ($q->param('mod') ne "")
	{
	($sec1,$min1,$hour1,$mday1,$mon1,$year1,$wday1,$ydat1,$isdst1) = localtime();
	$modcrypt = crypt ($c_username, $mday1);
	}

open (TCONTENTFILE, "$data_dir/$cid/$fid/$tid.dat");
	while (defined($tcline=<TCONTENTFILE>))
		{
		chop($tcline);
		@msglns = split (/\t/, $tcline);

		if (($q->param('mod') eq $modcrypt) and ($q->param('mod') ne ""))
			{
			$mcontents[$bcc] = $tcline;
			$bcc++;
			}
		elsif (($forset[7] ne "Y") or ($msglns[9] ne "Y"))
			{
			$mcontents[$bcc] = $tcline;
			$bcc++;
			}
		
		}
close (TCONTENTFILE);




### GET SETTINGS

(@settings) = sn_netbbs::get_global_settings;


if ($q->param('x') == 1)
	{
	$locktxt = "Unlock Topic";
	$lockfct = "unlocktopic";
	$replybut = "";
	}
	else
	{
	$locktxt = "Lock Topic";
	$lockfct = "locktopic";
	
		if ($forset[12] ne "N") ### IF NOT READ ONLY
		{
		$replybut = "<a href=\"$scripts_url/sn_forump.cgi?fid=$fid&cid=$cid&tid=$tid&fct=reply\"><img src=\"$web_url/sn_postreply.gif\" border=\"0\"></a>";
		}
	
	}

$template =~ s/!!post_reply_button!!/$replybut/gi;




### DISPLAY MESSAGES

$ocn = 0;
$csetter = 0;


### GET TITLE SETTINGS
$sbcntr= 0;
open (UFINFO, "$data_dir/sn_usertitles.dat");
	while (defined($tline=<UFINFO>))
		{
		if ($tline ne "")
			{
			($ttval, $mmtitle) = split (/\t/,$tline);
			$titlevalues[$sbcntr] = $ttval;
			$sbcntr++;
			$titlevalues[$sbcntr] = $mmtitle;
			$sbcntr++;
			}
		}
close (UFINFO);



### FIGURE OUT PAGES
$tcntr = 0;

$icnt = @mcontents;

if ($q->param('all') eq "all")
	{
	$nr_searchres = $icnt;
	}
	else
	{
	$nr_searchres = 10;
	}

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

##########################################

foreach $msgline (@mcontents)
	{
	@msitem = split (/\t/, $msgline);

	if ($ippc == 1) { $omsg_topic = $msitem[0]; }
	
### RESULTS
if (($ippc > $st) and ($ippc <= $nd))
    {
   
	#### GET USER INFO
	my $rfn = $msitem[1];
	$rfn =~ s/ /_/g;

	$user_image = "";
	$uregistered = "";


	if (-e "$data_dir/users/$rfn.dat") 
		{
		$ufle = sn_netbbs::get_file_contents("$data_dir/users/$rfn.dat");
		(@udataf) = split (/\n/,$ufle);
		$uregistered = "true";
		$udataf[15] =~ s/\n//g;
		if ($udataf[15] =~ /USER_DEFINED/)
			{
			$udataf[15]=~ s/USER_DEFINED//g; 
			$user_image = "<img src=\"$web_url/user_imagesc/$udataf[15]\" border=\"1\" width=\"70\" height=\"70\">";
			}
			elsif ($udataf[15] ne "")
			{
			$user_image = "<img src=\"$web_url/user_images/$udataf[15]\" border=\"1\" width=\"70\" height=\"70\">";
			}
	
		}
		else
		{
		$udataf[1] = ""; $udataf[2] = "";$udataf[3] = "";$udataf[4] = "";$udataf[5] = "";$udataf[6] = "";
		$udataf[7] = "";$udataf[8] = "";$udataf[9] = "";$udataf[10] = "";$udataf[11] = "";$udataf[12] = "";
		$udataf[14] = "";$udataf[15] = "";$udataf[16] = "";$udataf[17] = "";$udataf[18] = "";$udataf[19] = "";
		}

		### EMAIL
		if ($udataf[3] ne "Y") 
		{
		$udataf[2] = "Not_Visible";
		}

		$dateposted = sn_netbbs::decode_date($msitem[6]);

		if ($uregistered eq "true")
			{$udataf[13] = sn_netbbs::decode_date($udataf[13]);}
			else
			{$udataf[13] = "Unregistered";}


		### USER STATUS
		
			$uicon = "";
			if (substr($udataf[12], 0, 2) eq "Mo"){$uicon = "$gmod";}
			if (substr($udataf[12], 0, 2) eq "Ad"){$uicon = "$gadm";}
			if (substr($udataf[12], 0, 2) eq "Me"){$uicon = "";}


	
		### CHECK IF MODERATOR IS MODERATOR OF CURRENT FORUM
			@all_moderators = sn_netbbs::get_moderators($forset[3]);
	
				if (substr($udataf[12], 0, 2) ne "Ad")
				   {
						foreach $mdline (@all_moderators)
						{
							if (lc($mdline) eq lc($udataf[0])) { $mdst = "true"; }
						}
				  
					  if ($mdst ne "true") {$uicon = "";}
					}


		### USER TITLES - @alltitles

			if ($udataf[14] > $titlevalues[8]) ### 200
			{
			$memberposts = $titlevalues[9];
			$uposts = "<img src=\"$web_url/sn_rank5.gif\">";
			}
			elsif ($udataf[14] > $titlevalues[6]) ### 150
			{
			$memberposts = $titlevalues[7];
			$uposts = "<img src=\"$web_url/sn_rank4.gif\">";
			}
			elsif ($udataf[14] > $titlevalues[4]) ### 100
			{
			$memberposts = $titlevalues[5];
			$uposts = "<img src=\"$web_url/sn_rank3.gif\">";
			}
			elsif ($udataf[14] > $titlevalues[2]) ### 50
			{
			$memberposts = $titlevalues[3];
			$uposts = "<img src=\"$web_url/sn_rank2.gif\">";
			}
			else ### 25
			{
			$memberposts = $titlevalues[1];
			$uposts = "<img src=\"$web_url/sn_rank1.gif\">";
			}



			#$memberposts = $memberposts . "--$udataf[14] -<br> $titlevalues[0] $titlevalues[1] <br> $titlevalues[2] $titlevalues[3] <br> $titlevalues[4] $titlevalues[5] <br> $titlevalues[6] $titlevalues[7] <br> $titlevalues[8] $titlevalues[9] <br>";
			#if ($uregistered ne "true")
			#	{
			#	$uposts = ""; $memberposts = "";
			#	$udataf[14] = "Unregistered";
			#	}


		if ($uicon ne "") { $memberposts = "$uicon"; }
		

		#### GENERATE MESSAGE TABLE
		$cusericon = "";
		if ($msitem[3] ne "") # if icon
			{
			$cusericon = "<img src=\"$web_url/icons/$msitem[3]\">";
			}
			else
			{
			$msitem[3] = "$msitem[1]";
			}

		## $uicon = moderator / member / administrator
		### FIGURE OUT BUTTONS
		#if ((-e "$data_dir/users/$rfn.dat") > 0)

		if ($uregistered eq "true")
			{
			$profbut = "<img src=\"$web_url/sn_spc.gif\"> &nbsp; <a href=\"$scripts_url/sn_proview.cgi?user=$msitem[1]\" onClick=\"popup('$scripts_url/sn_proview.cgi?user=$msitem[1]',600,400);return false;\">
			<img src=\"$web_url/sn_profile.gif\" alt=\"View Profile of $msitem[1]\" border=\"0\"></a>&nbsp;";
			}
			else
			{
			$profbut = "";
			}
	
			$embut = "";
		if (($msitem[2] ne "") and ($udataf[2] ne "Not_Visible"))
			{
			$embut = " <img src=\"$web_url/sn_spc.gif\"> &nbsp;<a href=\"mailto:$udataf[2]\"><img src=\"$web_url/sn_semail.gif\" alt=\"Send Email To $msitem[1]\" border=\"0\"></a> ";
			}

			
			($start_qtable, $end_qtable) = split (/!!quote!!/, $sn_quote);
			
			$msitem[7] =~ s/\[StartQuote\]/$start_qtable/g;
			$msitem[7] =~ s/\[EndQuote\]/$end_qtable/g;

			if ($msitem[7] =~ /\[/)
				{
				$msitem[7] = sn_netbbs::decode_tags($msitem[7]);
				}
		
			if ($msitem[7] =~ /\[:-/)
				{
				$msitem[7] = sn_netbbs::decode_icons($msitem[7]);
				}

		if ($ocn == 0) ### FIRST MESSAGE (SET TEMPLATE)
		{
		$message_template_tmp = $sn_first_msg;
		}
		else ### REPLY MESSAGE (SET TEMPLATE)
		{
		$message_template_tmp = $sn_reply_msg;
		}

		$approval = "";
		if ($msitem[9] eq "Y") 
			{
			#$approval = "<BR><BR><font color=\"#FF0000\"><strong>[Needs Approval From Moderator/Administrator for Display]</strong></font>";
			$message_template_tmp = sn_netbbs::display_errors($message_template_tmp, "approv", "");  
			}
			else
			{
			$message_template_tmp = sn_netbbs::display_errors($message_template_tmp, "approv", "NODISPLAY");  
			}
		

			$message_template_tmp =~ s/!!message_topic!!/$msitem[0]/gi;
			
			$dateposted = sn_netbbs::decode_date($msitem[6]);
			$message_template_tmp =~ s/!!post_date!!/$dateposted/gi;
		
			$message_template_tmp =~ s/!!auth_name!!/$msitem[1]/gi;
			$message_template_tmp =~ s/!!mem_icon!!/$uposts/gi;
			$message_template_tmp =~ s/!!mem_name!!/$memberposts/gi;
			$message_template_tmp =~ s/!!auth_image!!/$user_image/gi;

			$message_template_tmp =~ s/!!auth_icon!!/$cusericon /gi;
			$message_template_tmp =~ s/!!auth_link!!/sn_proview\.cgi?user=$msitem[1]/gi;
		
			### QUOTE REPLY
			$qmsgn = $ocn + 1;
			$qrlink = "$scripts_url/sn_forump.cgi?fct=reply&fid=$fid&cid=$cid&tid=$tid&rpm=$qmsgn";
			$message_template_tmp =~ s/!!quote_url!!/$qrlink/gi;
			
			### EDIT LINK
			$oncpone = $ocn + 1;
			$edlink = "$scripts_url/sn_forume.cgi?cid=$cid&fid=$fid&tid=$tid&rpm=$oncpone";
			$message_template_tmp =~ s/!!edit_url!!/$edlink/gi;
			
			$message_template_tmp =~ s/!!post_date!!/$dateposted/gi;
			$message_template_tmp =~ s/!!message!!/$msitem[7]/gi;
			$message_template_tmp =~ s/!!total_mem_posts!!/$udataf[14]/gi;
			$message_template_tmp =~ s/!!join_date!!/$udataf[13]/gi;
			
			### IP LOGGED LINK
			$iplink = "$scripts_url/sn_ip.cgi?cid=$cid&fid=$fid&tid=$tid&rpm=$ocn";
			$message_template_tmp =~ s/!!ip_logged_url!!/$iplink/gi;
			
			
			### PAGE HEADER
			
			$disp_message_items = $disp_message_items . $message_template_tmp;
	

	} ### END OF LOOP THROUGH RESULTS PER PAGE
	
	$ocn++;
	$ippc++;
	$tcntr++;

} ### END OF LOOP THROUGH MSGS

$sn_topic_top =~ s/!!message_topic!!/$msitem[0]/gi;
$disp_message_items = $sn_topic_top . $disp_message_items;





#### PAGES

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		
			if ($url_write eq "SEO_ENABLED")
			{
			$pgstring = $pgstring . "<a href=\"/forum/forumtopic/$fid,$cid,$tid,$pg1,$sc,0,$st1,$nd1.html\">$pg</a> ";
			}
			else
			{
			$pgstring = $pgstring . "<a href=\"$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tid&st=$st1&nd=$nd1&pg=$pg1&sc=$sc\">$pg</a> ";
			}
		}
	}


$template =~ s/!!pages!!/$pgstring/gi; 
$template =~ s/!!current_page!!/$targpage/gi;
$template =~ s/!!total_pages!!/$pg/gi;


### PREV NEXT PAGES

$s_nextpage = sn_netbbs::get_file_contents("$data_dir/sn_nextp.html");
$s_prevpage = sn_netbbs::get_file_contents("$data_dir/sn_prevp.html");
$s_nextprev_sep = sn_netbbs::get_file_contents("$data_dir/sn_nextprevsep.html");

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
			
		### REWRITE URLS
		if ($url_write eq "SEO_ENABLED")
		{
		$domain = sn_netbbs::get_domain($web_url);
		$nlink = "http://" . $domain . "/forum/forumtopic/$fid,$cid,$tid,$pg1,$sc,0,$st1,$nd1.html";
		$nextt = qq[<a href="$nlink">$s_nextpage</a>];
		}
		else
		{
		$nextt = "<a href=\"$scripts_url/sn_forumr.cgi?st=$st1&nd=$nd1&fid=$fid&cid=$cid&tid=$tid&pg=$pg1&sc=$sc\">$s_nextpage</a> ";
		}
		
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		
				if ($url_write eq "SEO_ENABLED")
				{
				$domain = sn_netbbs::get_domain($web_url);
				$plink = "http://" . $domain . "/forum/forumtopic/$fid,$cid,$tid,$pg1,$sc,0,$st1,$nd1.html";
				$prev = qq[<a href="$plink">$s_prevpage</a>];
				}
				else
				{
				$prev = "<a href=\"$scripts_url/sn_forumr.cgi?st=$st1&nd=$nd1&fid=$fid&cid=$cid&tid=$tid&pg=$pg1&sc=$sc\">$s_prevpage</a> ";
				}
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " $s_nextprev_sep ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

$template =~ s/!!next_page!!/$prevnext/gi;


### BOTTOM PREV + NEXT + PAGES

$ftop = $ftop . <<END_OF_BPR;
<table border="0" width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="22%" height="25"><p align="left"><font face="$settings[6]" size="1">$prevnext</font></td>
    <td width="78%" height="25"><p align="right"><font face="$settings[6]" size="1">$pgstring</font></td>
  </tr>
</table>
END_OF_BPR

$icnt = $icnt - 1;

### PREV NEXT TOPIC PAGE
$nnd = $pg1 * $sc;
$nst = $nnd - $sc;


		### TO GO BACK TO TOPIC INDEX PAGE
		if ($url_write eq "SEO_ENABLED")
			{
			$domain = sn_netbbs::get_domain($web_url);
			$back_topic_link = "http://" . $domain . "/forum/forum,$fid,$cid,$nst,$nnd.html";
			$template =~ s/!!backpname_link!!/$back_topic_link/gi;
			}
			else
			{
			$back_topic_link = "$scripts_url/sn_forum.cgi?fid=$fid&cid=$cid&st=$nst&nd=$nnd&fct=gotoforum";
			$template =~ s/!!backpname_link!!/$back_topic_link/gi;
			}



$template =~ s/!!backpname!!/$pg1/gi;



if ($pgstring ne ""){$pgstring = "| " . $pgstring; $prevnext = $prevnext . " | ";}

$prevnext = $prevnext . "Page: $targpage of $pg";

$template =~ s/!!replies!!/$icnt/gi;


### JUMP BOX
($fselbox, $ccn, $cfn) = sn_netbbs::get_forum_selbox_details();

### POLL BUTTON

if ($forset[5] eq "Y") ### IF POLLS ALLOWED
	{
		if ($forset[12] ne "N") ### IF NOT READ ONLY
			{
			$pollbut = "<a href=\"$scripts_url/sn_netbpoll.cgi?fid=$fid&cid=$cid&fct=poll\"><img src=\"$web_url/sn_postpoll.gif\" border=\"0\"></a>";
			}
	}
	$template =~ s/!!new_poll_button!!/$pollbut/gi;


if ($forset[12] ne "N") ### IF NOT READ ONLY
	{
	$pbutton = "<a href=\"$scripts_url/sn_forump.cgi?fid=$fid&amp;cid=$cid\"><img src=\"$web_url/sn_post.gif\" border=\"0\"></a> ";
	$template =~ s/!!new_topic_button!!/$pbutton/gi;
	}

$printer_link = "$scripts_url/sn_prntopic.cgi?cid=$cid&fid=$fid&tid=$tid";
$template =~ s/!!printer_friendly!!/$printer_link/gi;

$template =~ s/!!message_topic!!/$omsg_topic/gi;

$template =~ s/!!forums!!/$disp_message_items/g;

$globalframe =~ s/!!forums!!/$template/gi;

$globalframe =~ s/!!pagetitle!!/$omsg_topic/gi;

$globalframe =~ s/!!raname1!!/$titlevalues[1]/gi;

$globalframe =~ s/!!raname2!!/$titlevalues[3]/gi;
$globalframe =~ s/!!ra_post2!!/$titlevalues[2]/gi;

$globalframe =~ s/!!raname3!!/$titlevalues[5]/gi;
$globalframe =~ s/!!ra_post3!!/$titlevalues[4]/gi;

$globalframe =~ s/!!raname4!!/$titlevalues[7]/gi;
$globalframe =~ s/!!ra_post4!!/$titlevalues[6]/gi;

$globalframe =~ s/!!raname5!!/$titlevalues[9]/gi;
$globalframe =~ s/!!ra_post5!!/$titlevalues[8]/gi;



### POPULATE HEADER
$forumlogo = $forset[8];
$forumlogo = qq[<img src="$web_url/$forset[8]">]; 

$globalframe =~ s/!!logo!!/$forumlogo/gi;
$globalframe =~ s/!!forum_name!!/$fsettings[11]/gi;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi;

$moderator_display = sn_netbbs::get_moderators_new($cid, $fid);
$globalframe =~ s/!!moderators!!/$moderator_display/gi; 

$cc_log_string = sn_netbbs::get_location($fsettings[11], $cid, $fid);
$globalframe =~ s/!!location!!/$cc_log_string/gi;

$time_msg_box = sn_netbbs::get_newmsg_box($cid, $fid);
$globalframe =~ s/!!new_messages_drop_down!!/$time_msg_box/gi;

$forum_jump_box = sn_netbbs::get_forum_selbox;
$globalframe =~ s/!!forumjump!!/$forum_jump_box/gi; 

$lastvisitors = sn_netbbs::get_last_visitors;
$globalframe =~ s/!!last_visitors!!/$lastvisitors/gi;

$globalframe = sn_netbbs::get_template_includes($globalframe);

print $globalframe;

}





