#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	sn_fmspm::check_spamb("sn_login.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "login") {&dologin; exit;}
if ($q->param('fct') eq "logout") {&logout; exit;}

#### START ########################################################

sub logout
{

sn_netbbs::setCookie("USER","");

@settings = sn_netbbs::get_global_settings();

$template = sn_netbbs::get_file_contents("$data_dir/sn_logout_screen.html");
$ptitle = sn_netbbs::get_page_title("sn_logout_screen");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$template =~ s/!!location!!/$loclink/g;

$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 

$globalframe =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;
	
$globalframe =~ s/!web_url!/$web_url/g;
	
print "Content-type: text/html\n\n";
print $globalframe;

}





sub start
{

my ($error_msg) = @_;

my ($lhtmldata, @rawc, $citem, $key, $val, %cookies, $item2, $uname, $upass, $template);

#$lhtmldata = sn_netbbs::login_box("login", "$scripts_url/sn_login.cgi", "Login", "Login");

print "Content-type: text/html\n\n";

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false

$template = sn_netbbs::get_file_contents("$data_dir/sn_login_screen.html");
$ptitle = sn_netbbs::get_page_title("sn_login_screen");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

@settings = sn_netbbs::get_global_settings();

	if ($logged_in_status eq "false") 
	{
	if ($error_msg eq "") 
		{
		$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
		}
		elsif ($error_msg eq "error1") 
		{
		$template = sn_netbbs::display_errors($template, "error1", ""); 
		}
	
	
	$template =~ s/!!login_script!!/$scripts_url\/sn_login.cgi/g;
	
	$redirect_location = $q->param('l');
	
	$cid = $q->param('cid');
	$fid = $q->param('fid');
	$tid = $q->param('tid');
	$rpm = $q->param('rpm');
	
	
	$hidvars = qq[
	<input type="hidden" name="fct" value="login">
	<input type="hidden" name="l"   value="$redirect_location">
	<input type="hidden" name="cid" value="$cid">
	<input type="hidden" name="fid" value="$fid">
	<input type="hidden" name="tid" value="$tid">
	<input type="hidden" name="rpm" value="$rpm">
	</form>
	];
	
	$template =~ s/<\/form>/$hidvars/gi;
	
	$template =~ s/!!retrieve_password_link!!/$scripts_url\/sn_lostps.cgi/g;

		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$loclink = "http://$domain/forumindex.html";
			$loclink = qq[<a href="$loclink">$settings[11]</a>];
			}
			else
			{
			$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
			}

	
	
	$template =~ s/!!location!!/$loclink/g;
	
	$globalframe =~ s/!!forums!!/$template/gi;
	
	
	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
	$globalframe =~ s/!web_url!/$web_url/g;
	
	print $globalframe;
	
	exit;
	}
	else
	{
		print qq[<html>
		<head>
		<title></title>
		<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_profile.cgi">
		</head>
		<body>
		</body>
		</html>
		];
		exit;
	}

#@usettings = sn_netbbs::check_username_password($uname, $upass);
#if ($usettings[0] eq "ERROR")
#	{
#	print "Content-type: text/html\n\n";
#	print "Fatal Error: The user account you are trying to post with doesn't exist.";
#	}


}







sub dologin
{

my ($username, $password, @usettings, $cookval, $expdate, @settings, $template, $txt);

@settings = sn_netbbs::get_global_settings();

$username = $q->param('username');
$password = $q->param('password');

@usettings = sn_netbbs::check_username_password($username, $password);

if ($usettings[0] eq "ERROR") ### IF WRONG USER/PASS
	{
	&start("error1");
	exit;
	}
	else ### DO LOGIN
	{

#### SET COOKIE

$username = $usettings[0];
$cookval = $username . ":" . $password;
sn_netbbs::setCookie("USER",$cookval);


print "Content-type: text/html\n\n";

if ($q->param('l') eq "profile") ### REDIRECT TO EDIT PROFILE
	{
	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_profile.cgi">
	</head>
	<body>
	</body>
	</html>
	];	
	exit;
	}
	elsif ($q->param('l') eq "reply") ### REDIRECT TO EDIT PROFILE
	{
	$cid = $q->param('cid');
	$fid = $q->param('fid');
	$tid = $q->param('tid');
	$rpm = $q->param('rpm');
	
	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_forump.cgi?fct=reply&fid=$fid&cid=$cid&tid=$tid&rpm=$rpm">
	</head>
	<body>
	</body>
	</html>
	];	
	
	exit;	
	}
	elsif ($q->param('l') eq "postnew") ### REDIRECT TO EDIT PROFILE
	{
	$cid = $q->param('cid');
	$fid = $q->param('fid');

	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_forump.cgi?fid=$fid&cid=$cid">
	</head>
	<body>
	</body>
	</html>
	];	
	exit;
	}
	elsif ($q->param('l') eq "postpoll") ### REDIRECT TO EDIT PROFILE
	{
	$cid = $q->param('cid');
	$fid = $q->param('fid');

	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_netbpoll.cgi?fid=$fid&cid=$cid&fct=poll">
	</head>
	<body>
	</body>
	</html>
	];
	exit;
	}
	elsif ($q->param('l') eq "view_profile") ### REDIRECT TO VIEW PROFILE
	{
	$vuser = $q->param('user');
	$vuser =~ s/ /+/gi;

	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_proview.cgi?user=$vuser">
	</head>
	<body>
	</body>
	</html>
	];
	exit;
	}
	elsif ($q->param('l') eq "editmsg") ### EDIT MESSAGE
	{

	$cid = $q->param('cid');
	$fid = $q->param('fid');
	$tid = $q->param('tid');
	$rpm = $q->param('rpm');

	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_forume.cgi?cid=$cid&fid=$fid&tid=$tid&rpm=$rpm">
	</head>
	<body>
	</body>
	</html>
	];
	exit;
	}



$template = sn_netbbs::get_file_contents("$data_dir/sn_login_success.html");
$ptitle = sn_netbbs::get_page_title("sn_login_success");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

	
	$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
	$template =~ s/!!location!!/$loclink/g;
	
	$globalframe =~ s/!!forums!!/$template/gi;


		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$loclink = "http://$domain/forumindex.html";
			$globalframe =~ s/!!forum_link!!/$loclink/gi;
			}
			else
			{
			$globalframe =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;
			}

	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
	$globalframe =~ s/!web_url!/$web_url/g;
	
	print $globalframe;
	}



}



