#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_netbpoll.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "poll") {&start; exit;}
if ($q->param('fct') eq "postpoll") {&postpoll1; exit;}

#### START ########################################################


sub postpoll1
{

my ($error_text, $template, $catname, @settings, $ftop, $cid, $fid, $dfata, @fsettings,
	 @usettings, $ausern, $newid, $tcontents, $newpoll, $timep, $tusern, $usersettings,
	 @udetails, $polldiz, $statdata, $newstatline, @gsettings, $ip, $allusers, @eusers,
	 $uitem, $username, $polltopic, $crit1, $crit2, $crit3, $crit4, $crit5, $crit6, $crit7, $pollm,
	 $mdata, $countf);

$cid = $q->param('cid');
$fid = $q->param('fid');

@gsettings = sn_netbbs::get_global_settings;

###### GET TEMPLATES

#if ((-e "$data_dir/$cid/$fid/cust_tmpl.dat") > 0)
#	{
#	$tmpl_to_open = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/cust_tmpl.dat");
#	$tmpl_to_open = "$data_dir/custom_templates/$tmpl_to_open";
#	$template = sn_netbbs::get_file_contents($tmpl_to_open);
#	}
#	else
#	{
#	$template = sn_netbbs::get_file_contents("$data_dir/template.html");	
#	}

$template = sn_netbbs::get_file_contents("$data_dir/sn_post_poll_success.html");
$ptitle = sn_netbbs::get_page_title("sn_post_poll_success");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");


	#$catname = sn_netbbs::get_cat_name($cid);
(@settings) = sn_netbbs::get_global_settings;
	#$ftop = sn_netbbs::print_forum_top("Post a New Poll", $catname, $settings[11], "");

### GET FORUM SETTINGS

if ($q->param('polltopic') eq "")
	{
	#$error_text = sn_netbbs::problembox("You have to specify a topic for the poll you want to post.");
	&start("error2"); exit;
	}

if ($q->param('pollq1') eq "")
	{
	#$error_text = sn_netbbs::problembox("Your poll has to have at least 2 questions to vote on.");
	&start("error4"); exit;
	}

if ($q->param('pollq2') eq "")
	{
	#$error_text = sn_netbbs::problembox("Your poll has to have at least 2 questions to vote on.");
	&start("error4"); exit;
	}


### CHECK IF USER IS LOGGED IN

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$username = $uname;

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false

	if ($logged_in_status eq "false") 
	{
	&start("error1"); exit;
	}


@usettings = sn_netbbs::check_username_password($uname, $upass);
if ($usettings[0] eq "ERROR")
	{
	print "Content-type: text/html\n\n";
	print "Fatal Error: The user account you are trying to post with doesn't exist.";
	}





#########

$dfata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fsettings = split(/\n/,$dfata);


if (($usettings[12] eq "Member") and ($fsettings[4] eq "Moderators"))
	{
	&start("error3"); exit;
	}


$newid = sn_netbbs::increment_id;
$tcontents = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
$timep = time();
$tusern = $uname;
$tusern =~ s/ /_/g;
$usersettings = sn_netbbs::get_file_contents("$data_dir/users/$tusern.dat");
@udetails = split(/\n/,$usersettings);

$polltopic = $q->param('polltopic');
$polltopic =~ s/<[^>]*>//g; ### REMOVE HTML
$polltopic =~ s/\n//g;


	
### MODERATION
	if (($fsettings[7] eq "Y") and (substr($udetails[12], 0, 2) ne "Mo") and (substr($udetails[12], 0, 2) ne "Ad"))
		{ 
		$pollm = "Y"; 
		$mdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
		open (MPOLL, "> $data_dir/$cid/$fid/moderate.dat");
			if ($flocking ne "No"){flock (MPOLL,2);}
				print MPOLL	$newid . "\t" .					### 0 TOPIC ID
								"0" .	"\t" .						### 1 REPLY NUMBER
								$username . "\t" .				### 2 USER
								$polltopic . "\t" .				### 3 MESSAGE TOPIC
								$timep . "\t" .					### 4 DATE TIME
								"POLLQ123" . "\n" . 				### 5 POLL
								$mdata;
			if ($flocking ne "No"){flock (MPOLL,8);}
		close (MPOLL);
		
	######
		
		$countf = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/mtopics.cnt");
		$countf++;
		open (TWRITE, "> $data_dir/$cid/$fid/mtopics.cnt");
			 if ($flocking ne "No"){flock (TWRITE,2);}
					print TWRITE $countf;
			 if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);
		
		$gotopoll = sn_netbbs::get_file_contents("$data_dir/moderatedpoll.txt");
		
		}
		else 
		{ 
		$pollm = "N"; 
		$gotopoll = "<a href=\"$scripts_url/sn_forumpr.cgi?cid=$cid&amp;fid=$fid&amp;tid=$newid&amp;pg=0&amp;sc=0\">Go to the poll you posted</a>";
		}
	
	
	### POLL TOPIC
	$newpoll  = "$newid" . "\t" . 								## 0 TOPIC ID
					$username . "\t" . 								## 1 USER
					$udetails[2] . "\t" . 							## 2 USER EMAIL
					$polltopic . "\t" . 								## 3 MESSAGE TOPIC
					"POLLQ123" . "\t" . 								## 4 ICON
					"N" . "\t" .   									## 5 RECEIVE NOTIFICATION ON REPLY
					"1" . "\t" . 										## 6 MESSAGES IN TOPIC
					"$timep" . "\t" .									## 7 TIME POSTED
					substr($udetails[12], 0, 2) . "\t" .		## 8 USER STATUS (Mo=Moderator, Ad=Administrator, Me=Member)
					$pollm . "\n";										## 9 MODERATED Y / N


	### POLL STATS
	$newstatline = $newid . "\t" . 	### ID
						"1" . "\t" . 		### POSTS
						"0" . "\t" . 		### VIEWS
						$timep . "\n";		### TIME
	

	##### STICKY TOPICS
	$stats_file = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
	@mstat_lines = split (/\n/, $stats_file);
	
	@rtdata = split(/\n/, $tcontents);
	$tcounter = 0;
	foreach $topic_line (@rtdata)
		{
		@to_items = split (/\t/, $topic_line);
		if ($to_items[10] eq "Y")
			{
			$sticky_topic_data = $sticky_topic_data . $topic_line . "\n";
			$sticky_topic_stats = $sticky_topic_stats . $mstat_lines[$tcounter] . "\n";
			}
			else
			{
			$all_topic_data = $all_topic_data . $topic_line . "\n";
			$all_stat_data = $all_stat_data . $mstat_lines[$tcounter] . "\n";
			}
		$tcounter++;
		}

	$tcontents = $newpoll . $all_topic_data;
	$all_stat_data = $newstatline . $all_stat_data;
	
	if ($sticky_topic_data ne "")
		{
		$tcontents = $sticky_topic_data . $tcontents;
		$all_stat_data = $sticky_topic_stats . $all_stat_data;
		}
	

	open (MTPF, "> $data_dir/$cid/$fid/topics.dat");
	 if ($flocking ne "No"){flock (MTPF,2);}
		print MTPF $tcontents;
	 if ($flocking ne "No"){flock (MTPF,8);}
	close (MTPF);

	open (STSTD, "> $data_dir/$cid/$fid/tstats.dat");
	  if ($flocking ne "No"){flock (STSTD,2);}
		print STSTD $all_stat_data;
	  if ($flocking ne "No"){flock (STSTD,8);}
	close (STSTD);


	### WRITE POLL DATA
	$polldiz = $q->param('polldescription');
	$polldiz =~ s/<[^>]*>//g;
	$polldiz =~ s/\n/<br>/g;

		$crit1 = "<img src=\"$web_url/sn_happy.gif\">";
		$crit2 = "<img src=\"$web_url/sn_happy2.gif\">";
		$crit3 = "<img src=\"$web_url/sn_ooo.gif\">";
		$crit4 = "<img src=\"$web_url/sn_grin.gif\">";
		$crit5 = "<img src=\"$web_url/sn_question.gif\">";
		$crit6 = "<img src=\"$web_url/sn_cool.gif\">";
		$crit7 = "<img src=\"$web_url/sn_cup.gif\">";

		$polldiz =~ s/:\)/$crit1/g;
		$polldiz =~ s/;\)/$crit2/g;
		$polldiz =~ s/:o/$crit3/g;
		$polldiz =~ s/\[biggrin\]/$crit4/g;
		$polldiz =~ s/\[confused\]/$crit5/g;
		$polldiz =~ s/\[cool\]/$crit6/g;
		$polldiz =~ s/\[award\]/$crit7/g;

	
	$ip = $ENV{'REMOTE_ADDR'};
	
	open (MTPF, "> $data_dir/$cid/$fid/$newid.dat");
	  if ($flocking ne "No"){flock (MTPF,2);}
		print MTPF $polltopic . "\n" . 		  				  ### POLL TOPIC
				$polldiz . "\n" .									  ### DESCRIPTION
				$q->param('pollq1') . "\t" . "0" . "\n" .	  ### QUESTIONS \t NR VOTES
				$q->param('pollq2') . "\t" . "0" . "\n" .	  ### QUESTIONS \t NR VOTES
				$q->param('pollq3') . "\t" . "0" . "\n" .	  ### QUESTIONS \t NR VOTESs
				$q->param('pollq4') . "\t" . "0" . "\n" .	  ### QUESTIONS \t NR VOTESs
				$q->param('pollq5') . "\t" . "0" . "\n" .	  ### QUESTIONS \t NR VOTESs
				$q->param('pollq6') . "\t" . "0" . "\n" .	  ### QUESTIONS \t NR VOTESs
				$username . "\n" .				  					### User
				$timep . "\n" . 									  ### TIME POSTED
				$ip . "\n";											  ### IP ADDRESS
		if ($flocking ne "No"){flock (MTPF,8);}
	close (MTPF);


if ($fsettings[7] eq "Y")  ### IF FORUM MODERATED
	{
	$template = sn_netbbs::get_file_contents("$data_dir/sn_post_poll_success_mod.html");
	$ptitle = sn_netbbs::get_page_title("sn_post_poll_success_mod");
	}


### SEND NOTIFICATION EMAIL TO MODERATORS IF REQUIRED

@all_moderators = sn_netbbs::get_moderators($fsettings[3]);

$fname = sn_netbbs::get_cat_name($cid);
$fname =~ s/\n//g;
$fname = $fname . " : " . sn_netbbs::get_forum_name($cid, $fid);


($fromname, $fromemail, $emailsubject, $notific) = sn_netbbs::get_email_details("sn_mvotep.eml");
				
(@settings) = sn_netbbs::get_global_settings;
				
if ($fromname eq "") { $fromname = $settings[11]; }
if ($fromemail eq "") { $fromemail = $settings[12]; }
				
$emailsubject =~ s/!!polltopic!!/$polltopic/gi;
$notific =~ s/!!polltopic!!/$polltopic/gi;
				
$notific =~ s/!!forum!!/$fname/gi;
$notific =~ s/!!posted_by!!/$username/gi;
$notific =~ s/!!posted_email!!/$udetails[2]/gi;

$notific =~ s/!!polldiz!!/$polldiz/gi;

if ($q->param('pollq1') ne "") { $pollanswers = $pollanswers . "1. " . $q->param('pollq1') . "\n"; }
if ($q->param('pollq2') ne "") { $pollanswers = $pollanswers . "1. " . $q->param('pollq2') . "\n"; }
if ($q->param('pollq3') ne "") { $pollanswers = $pollanswers . "1. " . $q->param('pollq3') . "\n"; }
if ($q->param('pollq4') ne "") { $pollanswers = $pollanswers . "1. " . $q->param('pollq4') . "\n"; }
if ($q->param('pollq5') ne "") { $pollanswers = $pollanswers . "1. " . $q->param('pollq5') . "\n"; }
if ($q->param('pollq6') ne "") { $pollanswers = $pollanswers . "1. " . $q->param('pollq6') . "\n"; }

$notific =~ s/!!pollanswers!!/$pollanswers/gi;

$pviewlink = "$scripts_url/sn_forumpr.cgi?fid=$fid&cid=$cid&tid=$newid";
$notific =~ s/!!viewlink!!/$pviewlink/gi;

$notific =~ s/!!forum_name!!/$settings[11]/gi;


foreach $rens (@all_moderators)
	{

	opendir(DIR,"$data_dir/users");
	@alusers = readdir(DIR);
	closedir(DIR);
	
		$rens =~ s/ /_/g;
		
		foreach $filename(@alusers)
			{
			$filename =~ s/\.dat//g;
			if (lc($filename) eq lc($rens))
				{
				$rens = $filename;
				}
			}	
			
			$mod_user_conf = sn_netbbs::get_file_contents("$data_dir/users/$rens.dat");
			@muserconf = split (/\n/, $mod_user_conf);


				if ($muserconf[16] eq "15MODERATOR_MESSAGE_NOTIFICATION=Y")
				{

				sn_netbbs::send_email($sendmail_loc,  									### LOCATION OF SENDMAIL
												$fromname,  											### SENDER NAME
												$fromemail,	 											### FROM EMAIL
												$muserconf[2], 										### TO EMAIL ADDRESS
												$emailsubject, 										### SUBJECT
												$notific);												### MESSAGE

				}

			
	
	}


#################


$gotopoll_link = "$scripts_url/sn_forumpr.cgi?cid=$cid&amp;fid=$fid&amp;tid=$newid&amp;pg=0&amp;sc=0";
$template =~ s/!!goto_poll!!/$gotopoll_link/gi;

$goto_forum = "$scripts_url/sn_forum.cgi?fid=$fid&cid=$cid&fct=gotoforum";
$template =~ s/!!posted_forum_link!!/$goto_forum/gi;

$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$template =~ s/!!posted_forum_name!!/$fsettings[1]/gi;

$globalframe =~ s/!!forums!!/$template/g;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 


$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
@gfsettings = split (/\n/, $gfs);

$locationd = sn_netbbs::get_location($gfsettings[11],$cid, $fid);
$globalframe =~ s/!!location!!/$locationd/g;

$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 

$forumlogo = qq[<img src="$web_url/$fsettings[8]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 

$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe;


}






sub start
{

my ($error_message) = @_;

my ($cid, $fid, $template, $catname, @settings, $ftop, $updetails, $usern, $pass,
	 @fsettings, $dfata, @rawc, $item2, $key, $val, %cookies, $whopost, $iprval);

$cid = $q->param('cid');
$fid = $q->param('fid');

###### TOP #######

$template = sn_netbbs::get_file_contents("$data_dir/sn_post_poll.html");
$ptitle = sn_netbbs::get_page_title("sn_post_poll");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

### TEMPLATE INCLUDES
#$template = sn_netbbs::get_template_includes($template, "POST_POLL");

#####

#$catname = sn_netbbs::get_cat_name($cid);
(@settings) = sn_netbbs::get_global_settings;


### GET FORUM SETTINGS
$dfata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fsettings = split(/\n/,$dfata);


### CHECK IP BANNS

$iprval = &check_ip;
if ($iprval eq "true")
	{
print <<END_OF_BANNED;
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#FFFFFF"
height="46" style="border: 1px solid rgb(214,214,214)">
  <tr>
    <td width="100%" background="$web_url/sn_bar6.gif" height="35"
    style="border-bottom: 1px solid rgb(214,214,214)"><font face="Verdana" size="2"><strong>You
    don't have access to post in this Forum</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF" valign="top"><font face="Verdana" size="2"><a
    href="$scripts_url/sn_forum.cgi">$settings[11]</a></font></td>
  </tr>
</table>
END_OF_BANNED
	#$ftop = $ftop . sn_netbbs::getcc();
	#$template =~ s/!!netboard!!/$ftop/gi;
	#print $template;
	exit;
	}


### WHO MAY POST
#if ($fsettings[4] eq "Any")
#	{
#	$updetails = "<br><b>Optional</b> - Only enter a password if you are registered. Registration
#enables you to receive email notification of replies to your topics, enables you to edit
#your messages and more. Registration takes 2 minutes or less.";
#	$whopost = "Any Users";
#	}
#	elsif ($fsettings[4] eq "Registered")
#	{
#	$whopost = "Registered Users";
#	}
#	else
#	{
#	$whopost = "Moderators Only";
#	}



####### GET COOKIES AND CHECK IF USER IS LOGGED IN
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false


	#### IF NOT LOGGED IN
	#print "--> $error_message <BR>";
	
	if (($logged_in_status eq "false") and ($error_message ne "error1"))
	{
	$loggedin_tmpl = sn_netbbs::get_file_contents("$data_dir/sn_not_logged_in.html");
	$ptitle = sn_netbbs::get_page_title("sn_not_logged_in");
	
	$hvars = qq[
	<input type="hidden" name="fct" value="login">
	<input type="hidden" name="cid" value="$cid">
	<input type="hidden" name="fid" value="$fid">
	<input type="hidden" name="l" value="postpoll">
	</form>
	];	
	
	$loggedin_tmpl =~ s/<\/form>/$hvars/gi;
	
	$globalframe =~ s/!!forums!!/$loggedin_tmpl/gi;
	$globalframe =~ s/!web_url!/$web_url/g;
	$globalframe =~ s/!!login_script!!/$scripts_url\/sn_login.cgi/g;
	
	$forumlogo = qq[<img src="$web_url/$fsettings[8]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/g;
 	
 	$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
	@gfsettings = split (/\n/, $gfs);

	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
 
 	$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 
 	
 	$globalframe =~ s/!!pagetitle!!/$ptitle/g;
 	
	print $globalframe;
	exit;
	} 





$template =~ s/!!poll_script!!/$scripts_url\/sn_netbpoll.cgi/gi; 
$template =~ s/!!message_tags_link!!/$scripts_url\/sn_forump.cgi?fct=emoticons/gi;


$polltopic = $q->param('polltopic');
$template =~ s/!!polltopic!!/$polltopic/gi;

$polldescription = $q->param('polldescription');
$template =~ s/!!polldescription!!/$polldescription/gi; 

$pollq1 = $q->param('pollq1');
$template =~ s/!!pollq1!!/$pollq1/gi; 

$pollq2 = $q->param('pollq2');
$template =~ s/!!pollq2!!/$pollq2/gi; 

$pollq3 = $q->param('pollq3');
$template =~ s/!!pollq3!!/$pollq3/gi; 

$pollq4 = $q->param('pollq4');
$template =~ s/!!pollq4!!/$pollq4/gi; 

$pollq5 = $q->param('pollq5');
$template =~ s/!!pollq5!!/$pollq5/gi; 

$pollq6 = $q->param('pollq6');
$template =~ s/!!pollq6!!/$pollq6/gi; 

$hidden_vars = qq[<input type="hidden" name="fct" value="postpoll">
<input type="hidden" name="cid" value="$cid">
<input type="hidden" name="fid" value="$fid">
</form>
];

### IF THERE ARE ERRORS WHEN TRYING TO POST A POLL

if ($error_message eq "")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	}
	elsif ($error_message eq "error1")
	{
	$template = sn_netbbs::display_errors($template, "error1", "");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	}
	elsif ($error_message eq "error2")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	}
	elsif ($error_message eq "error3")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	}	
	elsif ($error_message eq "error4")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "");
	}	



$template =~ s/<\/form>/$hidden_vars/gi;

$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
@gfsettings = split (/\n/, $gfs);

$globalframe =~ s/!!forums!!/$template/gi;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 

$cc_log_string = sn_netbbs::get_location($gfsettings[11], $cid, $fid);
$globalframe =~ s/!!location!!/$cc_log_string/gi;

$forumlogo = qq[<img src="$web_url/$fsettings[8]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/g;

$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe;

}




sub check_ip
{
my ($ipfile, @ips, $ipa, $userip, $loopip, $rval, $tmpstuff);
$userip = $ENV{'REMOTE_ADDR'};
$ipfile = sn_netbbs::get_file_contents("$data_dir/sn_banned_ips.dat");
@ips = split (/\n/, $ipfile);
foreach $ipa(@ips)
	{
	($loopip, $tmpstuff) = split(/\t/, $ipa);
		if ($loopip eq $userip)
			{
			$rval = "true";
			}
	}
return ($rval);
}

