#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_prntopic.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");
	
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}



#### START ########################################################

sub start
{

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');

sn_netbbs::check_input($cid);
sn_netbbs::check_input($fid);
sn_netbbs::check_input($tid);

if ((-e "$data_dir/$cid/$fid/$tid.dat") < 1)
	{
	sn_netbbs::fatal_error("Invalid Forum / Category or Message");
	}


$catname = sn_netbbs::get_cat_name($cid);

### CONF
$gfrs = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@forset = split (/\n/, $gfrs);

#sn_netbbs::write_stats($cid, $fid, $tid, "0","1");

if (-e "$data_dir/$cid/$fid/$tid.cnt" < 1)
	{
	$rstatv_count = 0;
	$viewdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
	@astln = split (/\n/, $viewdata);
	foreach $stat_item (@astln)
		{
		($stat_id, $stat_posts, $stat_views, $stat_date, $stat_lpost) = split (/\t/, $stat_item);
		if ($stat_id == $tid)
			{
			$rstatv_count = $rstatv_count + $stat_views;
			}
		}
	}

##### 

if (-e "$data_dir/$cid/$fid/$tid.cnt")
	{
	$old_stat_count2 = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.cnt");
	$rstatv_count = $rstatv_count + $old_stat_count2;
	}

$rstatv_count++;
open (VIEWS, ">$data_dir/$cid/$fid/$tid.cnt");
 if ($flocking ne "No"){flock (VIEWS,2);}
	print VIEWS $rstatv_count;	
 if ($flocking ne "No"){flock (VIEWS,8);}
close (VIEWS);


### GET MESSAGES
$bcc = 0;


open (TCONTENTFILE, "$data_dir/$cid/$fid/$tid.dat");
	while (defined($tcline=<TCONTENTFILE>))
		{
		chop($tcline);
		@msglns = split (/\t/, $tcline);

		if (($q->param('mod') eq $modcrypt) and ($q->param('mod') ne ""))
			{
			$mcontents[$bcc] = $tcline;
			$bcc++;
			}
		elsif (($forset[7] ne "Y") or ($msglns[9] ne "Y"))
			{
			$mcontents[$bcc] = $tcline;
			$bcc++;
			}
		
		}
close (TCONTENTFILE);


### GET SETTINGS
(@settings) = sn_netbbs::get_global_settings;

$ocn = 0;
$csetter = 0;

### GET TITLE SETTINGS
$sbcntr= 0;
open (UFINFO, "$data_dir/sn_usertitles.dat");
	while (defined($tline=<UFINFO>))
		{
		if ($tline ne "")
			{
			($ttval, $mmtitle) = split (/\t/,$tline);
			$titlevalues[$sbcntr] = $ttval;
			$sbcntr++;
			$titlevalues[$sbcntr] = $mmtitle;
			$sbcntr++;
			}
		}
close (UFINFO);



### FIGURE OUT PAGES
$tcntr = 0;

$icnt = @mcontents;

if ($q->param('all') eq "all")
	{
	$nr_searchres = $icnt;
	}
	else
	{
	$nr_searchres = 10;
	}

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

####

$fsett = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
(@fsettings_main) = split(/\n/,$fsett);


$settings[6] = "Verdana";


$forumname = sn_netbbs::get_forum_name($cid, $fid);

if ($url_write eq "SEO_ENABLED")
{

$domain = sn_netbbs::get_domain($web_url);

$ftop = $ftop . "<font face=\"$settings[6]\" size=\"2\"><b><a href=\"http://$domain/forumindex.html\">$fsettings_main[11]</a></b>
<br><font size=\"1\">
http://$domain/forumindex.html
</font></font><br><br></p>

<font face=\"$settings[6]\" size=\"2\"><b>>> Forum Category: <a href=\"http://$domain/forum/showf,$cid.html\">$catname</a></b>
<br><font size=\"1\">
http://$domain/forum/showf,$cid.html
</font></font><br><br></p>

<font face=\"$settings[6]\" size=\"2\"><b>>> Forum Name: <a href=\"http://$domain/forum/forum,$fid,$cid,0,20.html\">$forumname</a></b>
<br><font size=\"1\">
http://$domain/forum/forum,$fid,$cid,0,20.html
</font></font><br><br></p>
";
}
else
{

$ftop = $ftop . "<font face=\"$settings[6]\" size=\"2\"><b><a href=\"$scripts_url/sn_forum.cgi\">$fsettings_main[11]</a></b>
<br><font size=\"1\">$scripts_url/sn_forum.cgi</font></font><br><br></p>

<font face=\"$settings[6]\" size=\"2\"><b>>> Forum Category: <a href=\"$scripts_url/sn_forum.cgi?cid=$cid&fct=showf\">$catname</a></b>
<br><font size=\"1\">$scripts_url/sn_forum.cgi?cid=$cid&fct=showf</font></font><br><br></p>

<font face=\"$settings[6]\" size=\"2\"><b>>> Forum Name: <a href=\"$scripts_url/sn_forum.cgi?fct=gotoforum&cid=$cid&fid=$fid\">$forumname</a></b>
<br><font size=\"1\">$scripts_url/sn_forum.cgi?fct=gotoforum&cid=$cid&fid=$fid</font></font><br><br></p>
";
}



##########################################

foreach $msgline (@mcontents)
	{
	@msitem = split (/\t/, $msgline);

if ($ocn == 0)
		{
		
			if ($url_write eq "SEO_ENABLED")
			{
			$ftop = $ftop . "<font face=\"$settings[6]\" size=\"2\"><b>>> Topic: 
			<a href=\"$scripts_url/sn_forumr.cgi?cid=$cid&fid=$fid&tid=$tid\">$msitem[0]</a></b>
			<br><font size=\"1\">
			http://$domain/forum/forumtopic,$fid,$cid,$tid,1,20,0,0,10.html
			</font></font><br><br></p><hr size=\"1\">";
			}
			else
			{
			$ftop = $ftop . "<font face=\"$settings[6]\" size=\"2\"><b>>> Topic: 
			<a href=\"$scripts_url/sn_forumr.cgi?cid=$cid&fid=$fid&tid=$tid\">$msitem[0]</a></b>
			<br><font size=\"1\">$scripts_url/sn_forumr.cgi?cid=$cid&fid=$fid&tid=$tid</font></font><br><br></p><hr size=\"1\">";
			}
		
		
		}


$ocn++;

if ($csetter == 0)
	{
	$tbackcolor = "$settings[3]";
	$csetter = 1;
	}
  else
	{
	$tbackcolor = "$settings[4]";
	$csetter = 0;
	}

#### GET USER INFO
my $rfn = $msitem[1];
$rfn =~ s/ /_/g;

$user_image = "";
$uregistered = "";


if (-e "$data_dir/users/$rfn.dat") 
	{
	$ufle = sn_netbbs::get_file_contents("$data_dir/users/$rfn.dat");
	(@udataf) = split (/\n/,$ufle);
	$uregistered = "true";
	$udataf[15] =~ s/\n//g;
	if ($udataf[15] =~ /USER_DEFINED/)
		{$udataf[15]=~ s/USER_DEFINED//g; $user_image = "<img src=\"$web_url/user_imagesc/$udataf[15]\" border=\"1\">";}
		elsif ($udataf[15] ne "")
		{$user_image = "<img src=\"$web_url/user_images/$udataf[15]\" border=\"1\">";}
	}
	else
	{
	$udataf[1] = ""; $udataf[2] = "";$udataf[3] = "";$udataf[4] = "";$udataf[5] = "";$udataf[6] = "";
	$udataf[7] = "";$udataf[8] = "";$udataf[9] = "";$udataf[10] = "";$udataf[11] = "";$udataf[12] = "";
	$udataf[14] = "";$udataf[15] = "";$udataf[16] = "";$udataf[17] = "";$udataf[18] = "";$udataf[19] = "";
	}

### EMAIL
if ($udataf[3] ne "Y"){$udataf[2] = "Not_Visible";}

$dateposted = decode_date($msitem[6]);

if ($uregistered eq "true")
	{$udataf[13] = decode_date($udataf[13]);}
	else
	{$udataf[13] = "Unregistered";}

	$msitem[7] =~ s/\[StartQuote\]/<i>/g;
	$msitem[7] =~ s/\[EndQuote\]/<\/i>/g;
	
	$msitem[3] =~ s///g;
	
$ftop = $ftop . <<END_OF_MSG;
<font face="$settings[6]" size="2">$msitem[7]<br><br>

<i>
<b>Posted By: $msitem[1]</b> | Posted on: $dateposted<br>
Total Posts: $udataf[14] | Joined: $udataf[13]</font></i>
<br><br>
<hr size="1">

END_OF_MSG

	
	$ippc++;
	$tcntr++;

	} ### END OF LOOP THROUGH MSGS

$ftop = $ftop . "</td></tr></table></td></tr></table>";

$ftop =~ s/!!page_data!!/<font face="$settings[6]" size="1">$prevnext<\/font>/g;
$ftop =~ s/!!right_dscrit!!/<font face="$settings[6]" size="1">$tpage | Replies: <b>$icnt<\/b> $pgstring<\/font>/g;


print $ftop;

#$ftop = $ftop . sn_netbbs::getcc();
#$template =~ s/!!netboard!!/$ftop/g; 
#print $template;

}
