#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $web_path $flocking/;

$q = CGI->new;

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_profile.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################

if ($q->param('fct') eq "save_member_info") {&save_member_info; exit;}

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "edit_profile") {&edit_profile; exit;}
if ($q->param('fct') eq "upload_error") {&upload_error; exit;}


#### START ########################################################

sub upload_error
{
&edit_profile($q->param('error'));
exit;
}


sub save_member_info
{

my (@rawc, $item2, $key, $val, %cookies, $uname, $upass, @usettings, @settings);


###### ERROR CHECKING

if ($q->param('password') eq "")  ### YOU HAVE TO SUPPLY A PASSWORD
	{
	print "Content-type: text/html\n\n";
	&edit_profile("error1");
	exit;
	}

if ($q->param('email_address') eq "")  ### YOU HAVE TO SUPPLY A PASSWORD
	{
	print "Content-type: text/html\n\n";
	&edit_profile("error2");
	exit;
	}


##### MAX CHARS
$home_page = $q->param('home_page'); $home_page = substr($home_page, 0, 128);
$homepage_diz = $q->param('homepage_diz'); $homepage_diz = substr($homepage_diz, 0, 255);
$home_page_url = $q->param('home_page_url'); $home_page_url = substr($home_page_url, 0, 255);
$location = $q->param('location'); $location = substr($location, 0, 100);
$interests = $q->param('interests'); $interests = substr($interests, 0, 255);
$occupation = $q->param('occupation'); $occupation = substr($occupation, 0, 100);
$signature = $q->param('signature'); $signature = substr($signature, 0, 255);


####### GET COOKIES
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

#######

(@usettings) = sn_netbbs::check_username_password($q->param('member'), $q->param('fpass'));

if (($usettings[0] ne "ERROR") and ($q->param('email_address') ne "") and ($q->param('password') ne ""))
	{
	&save_member_info2;
	}
	else
	{

@settings = sn_netbbs::get_global_settings();
print "Content-type: text/html\n\n";

print <<END_OF_PROBL;

<html>

<head>
<title>Problem</title>
</head>

<body>

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#D6D6D6"
height="46">
  <tr>
    <td width="100%" background="$web_url/sn_bar6.gif" height="35" bgcolor="#FFFFFF"><font
    face="Verdana" size="2"><strong>Fatal Error</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF" valign="top"><font face="Verdana" size="2"><strong>&nbsp;&nbsp;
    There was a problem in trying to save your profile.</strong><br>
    &nbsp;&nbsp; It might be one of the following reasons.</font><ul>
      <li><font face="Verdana" size="2"><strong>User Account Doesn't Exist<br>
        </strong>Your user account does not exist anymore.<br>
        &nbsp;&nbsp; </font></li>
      <li><font face="Verdana" size="2"><strong>Invalid Password<br>
        </strong>Your password is invalid</font></li>
    </ul>
    </td>
  </tr>
</table>
</body>
</html>
 
END_OF_PROBL

exit;

	}

}





sub save_member_info2
{

my ($ufile, $cookval, $ufcontents, @old_udetails, $homepage_diz, $interests, $signature, 
	 @settings, $ftop, $template, $modemail);

$ufile = $q->param('member');
$ufile =~ s/ /_/g;
$ufcontents = sn_netbbs::get_file_contents("$data_dir/users/$ufile.dat");

(@old_udetails) = split (/\n/,$ufcontents);

$homepage_diz = $q->param('homepage_diz');
$homepage_diz =~ s/\n/<br>/g;

$interests = $q->param('interests');
$interests =~ s/\n/<br>/g;

$signature = $q->param('signature');
$signature =~ s/\n/<br>/g;

if (((substr($old_udetails[12], 0, 2) eq "Mo") or (substr($old_udetails[12], 0, 2) eq "Ad")) and ($q->param('moderator_email') eq "Y"))
	{
	$modemail = "15MODERATOR_MESSAGE_NOTIFICATION=Y";
	}
	else
	{
	$modemail = "15MODERATOR_MESSAGE_NOTIFICATION=N";
	}

open (WUFILE, "> $data_dir/users/$ufile.dat");
 if ($flocking ne "No"){flock (WUFILE,2);}
   $ufile =~ s/_/ /g;
	print WUFILE 	$ufile . "\n" .								## 0 
						$q->param('password') . "\n" . 			## 1
						$q->param('email_address') . "\n" . 	## 2
						$q->param('email_visible') . "\n" . 	## 3
						$q->param('home_page') . "\n" . 			## 4
						$homepage_diz . "\n" . 						## 5
						$q->param('home_page_url') . "\n" . 	## 6
						$q->param('icq_number')  . "\n" . 		## 7
						$q->param('location') . "\n" .  			## 8
						$interests . "\n" .  						## 9
						$q->param('occupation') . "\n" . 		## 10
						$signature . "\n" . 							## 11
						$old_udetails[12] . "\n" . 				## 12
						$old_udetails[13] . "\n" . 				## 13
						$old_udetails[14] . "\n" . 				## 14
						$q->param('user_image') . "\n" .			## 15
						$modemail . "\n";								## 16
																
						
 if ($flocking ne "No"){flock (WUFILE,8);}
close (WUFILE);

### SET COOKIE
$cookval = $ufile . ":" . $q->param('password');
sn_netbbs::setCookie("USER",$cookval);	

@settings = sn_netbbs::get_global_settings();

### PRINT HEADER
print "Content-type: text/html\n\n";


### TOP
$template = sn_netbbs::get_file_contents("$data_dir/sn_profile_saved.html");
$ptitle = sn_netbbs::get_page_title("sn_profile_saved");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

@settings = sn_netbbs::get_global_settings();

$template =~ s/!!forum_name!!/$settings[11]/gi;
$template =~ s/!!edit_profile_link!!/$scripts_url\/sn_profile.cgi/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;


$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$template =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe;

}




sub edit_profile
{

my ($error_msg) = @_;

my (@usettings, $username, $password, $cookval, @settings, $template, @gset, $ftop,
    $user_image, $user_image_box, @files, $Ncount, $item, $selected, $ufn,
    $emailv1, $emailv2, $moderator_setting_html);

#### TOP

$template = sn_netbbs::get_file_contents("$data_dir/template.html");
@gset = sn_netbbs::get_global_settings;

#$ftop = sn_netbbs::print_forum_gen_top ("My Profile", $gset[11]);

#### CHECK IF USER IS LOGGED IN

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$username = $uname;
$password = $upass;

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false

	if ($logged_in_status eq "false") 
	{
	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_login.cgi?l=profile">
	</head>
	<body>
	</body>
	</html>
	];
	exit;
	}

###########

(@usettings) = sn_netbbs::check_username_password ($username, $password);

@settings = sn_netbbs::get_global_settings();

$username = $usettings[0];

#### SET COOKIE
#$cookval = $username . ":" . $password;
#sn_netbbs::setCookie("USER",$cookval);	

#### USER IMAGES
opendir(DIR,"$web_path/user_images");
	@files = readdir(DIR);
closedir(DIR);

#$user_image_box = "<select name=\"user_image\" size=\"1\">";
$user_image_box = $user_image_box . "<option value=\"\">Do Not Use a User Image</option>";

if ($usettings[15] =~ /USER_DEFINED/)
	{
	$user_image_box = $user_image_box . "<option selected value=\"$usettings[15]\">Uploaded Image</option>";
	}

$Ncount = 1;

if ($q->param('user_image') ne "") { $usettings[15] = $q->param('user_image'); }

foreach $item (@files)
	{
	if (($item ne ".") and ($item ne ".."))
		{
		$selected = "";
		if ($usettings[15] eq $item){ $selected = "selected"; }
		$user_image_box = $user_image_box . "<option $selected value=\"$item\">Image $Ncount</option>";
		$Ncount = $Ncount + 1;
		}
	}
	
#$user_image_box = $user_image_box . "</select>";

if ($usettings[15] =~ /USER_DEFINED/)
	{
	$usettings[15] =~ s/USER_DEFINED//g;
	$user_image = "<img src=\"$web_url/user_imagesc/$usettings[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}
	elsif ($usettings[15] ne "")
	{
	$user_image = "<img src=\"$web_url/user_images/$usettings[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}
	else
	{
	$user_image = "None";
	}
##############

$usettings[5] =~ s/<br>/\n/g;
$usettings[9] =~ s/<br>/\n/g;
$usettings[11] =~ s/<br>/\n/g;

$usettings[13] = sn_netbbs::decode_date ($usettings[13]);


$modadm_data = sn_netbbs::get_file_contents("$data_dir/sn_modadm.txt");
($adm, $mod, $mname) = split (/:::/, $modadm_data);


if (substr($usettings[12], 0, 2) eq "Ad")
		{
		$usettings[12] = "Administrator";
		$member_status = $adm;
		}

if (substr($usettings[12], 0, 2) eq "Me")
		{
		$usettings[12] = "Member";
		$member_status = $mname;
		}

if (substr($usettings[12], 0, 2) eq "Mo")
		{
		$usettings[12] = "Moderator";
		$member_status = $mod;
		}


#### EMAIL VISIBLE
#if ($usettings[3] eq "Y")
#	{
#	$emailv1 = "selected";
#	}
#	else
#	{
#	$emailv2 = "selected";
#	}


$template = sn_netbbs::get_file_contents("$data_dir/sn_edit_profile.html");
$ptitle = sn_netbbs::get_page_title("sn_edit_profile");


### MODERATOR SETTINGS IF MODERATOR
if ((substr($usettings[12], 0, 2) eq "Mo") or (substr($usettings[12], 0, 2) eq "Ad"))
	{

	if ($usettings[16] eq "15MODERATOR_MESSAGE_NOTIFICATION=Y")
		{
		$email_moderator1 = "checked";
		}
	else
		{
		$email_moderator1 = "";
		}

	$template = sn_netbbs::display_errors($template, "moderator", "");
	$template =~ s/!!checked!!/$email_moderator1/gi;

	} ## END OF IF MOD
else
	{
	$template = sn_netbbs::display_errors($template, "moderator", "NODISPLAY");
	}


if ($gset[16] eq "") { $gset[16] = 5; }
if ($gset[17] eq "") { $gset[16] = 70; }
if ($gset[18] eq "") { $gset[16] = 70; }


######

$hidden_vars_upload = qq[<input type="hidden" name="ps" value="$usettings[1]">
<input type="hidden" name="user" value="$usettings[0]">
</form>
];


$hidden_vars = qq[<input type="hidden" name="fct" value="save_member_info">
<input type="hidden" name="fpass" value="$usettings[1]">
<input type="hidden" name="member" value="$username">
</form>
];

$template =~ s/<\/form>/$hidden_vars/gi;

###########################

if ($q->param('password') ne "") { $usettings[1] = $q->param('password'); }
$template =~ s/!!password!!/$usettings[1]/gi;

if ($q->param('email_address') ne "") { $usettings[2] = $q->param('email_address'); }
$template =~ s/!!email_address!!/$usettings[2]/gi;

if ($q->param('home_page') ne "") { $usettings[4] = $q->param('home_page'); }
$template =~ s/!!home_page!!/$usettings[4]/gi;

if ($q->param('homepage_diz') ne "") { $usettings[5] = $q->param('homepage_diz'); }
$template =~ s/!!homepage_diz!!/$usettings[5]/gi;

if ($q->param('home_page_url') ne "") { $usettings[6] = $q->param('home_page_url'); }
$template =~ s/!!home_page_url!!/$usettings[6]/gi;

if ($q->param('location') ne "") { $usettings[8] = $q->param('location'); }
$template =~ s/!!location_cc!!/$usettings[8]/gi;

if ($q->param('interests') ne "") { $usettings[9] = $q->param('interests'); }
$template =~ s/!!interests!!/$usettings[9]/gi;

if ($q->param('occupation') ne "") { $usettings[10] = $q->param('occupation'); }
$template =~ s/!!occupation!!/$usettings[10]/gi;

if ($q->param('signature') ne "") { $usettings[11] = $q->param('signature'); }
$template =~ s/!!signature!!/$usettings[11]/gi;

$template =~ s/!!member_name!!/$usettings[0]/gi;


$template =~ s/!!user_image_display!!/$user_image/gi;
$template =~ s/!!save_profile_script!!/$scripts_url\/sn_profile.cgi/gi;
$template =~ s/!!joined!!/$usettings[13]/gi;
$template =~ s/!!total_posts!!/$usettings[14]/gi;
$template =~ s/!!member_status!!/$member_status/gi;


#### UPLOAD DETAILS

$template =~ s/!!upload_script!!/$scripts_url\/sn_upload.cgi/gi;
$template =~ s/<\/form>/$hidden_vars_upload/gi;





###### IMAGE DROP DOWN

$image_dropdown_complete = qq[

<script LANGUAGE="JavaScript">
<!-- Hide
function xmlhttpPost(strURL, display_area, ddown)
	{
    var xmlHttpReq = false;
    var self = this;

    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }

    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
		
		strURL = '$scripts_url/sn_imgd.cgi?i=' + strURL;
		
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	self.xmlHttpReq.onreadystatechange = function()
    	   {
         if (self.xmlHttpReq.readyState == 4)
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText;
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}

    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
	}

// End Hide -->
</script>

<select name="user_image" size="1" onChange="xmlhttpPost(this.form.user_image.options[this.form.user_image.selectedIndex].value, 'result1', 1);">
$user_image_box
</select>
];

$template =~ s/!!image_dropdown!!/$image_dropdown_complete/gi;

$imgprev = qq[<div id="result1"></div>];
$template =~ s/!!image_preview!!/$imgprev/gi;

$template =~ s/!!images_link!!/$scripts_url\/sn_usr_img.cgi/gi; 

$template =~ s/!!max_size!!/$gset[16]/gi; 


#$template =~ s/!!image_preview!!//gi;
#$template =~ s/!!images_link!!//gi;


###### IF THERE ARE ERRORS

if ($error_msg eq "")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
elsif ($error_msg eq "error1")
	{
	$template = sn_netbbs::display_errors($template, "error1", "");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
elsif ($error_msg eq "error2")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
elsif ($error_msg eq "error3")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
elsif ($error_msg eq "error4")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
elsif ($error_msg eq "error5")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "");
	}


	

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

@settings = sn_netbbs::get_global_settings();

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$template =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 

$globalframe =~ s/!!logout!!/$scripts_url\/sn_login.cgi?fct=logout/g;

$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;
	
print $globalframe;



###########################

}




sub start
{

my ($lhtmldata, @rawc, $item2, @rawc, $key, $val, %cookies, $uname, $upass, @gset,
	 $template, $ftop);
	 
	 
	 #sn_netbbs::setCookie("USER","");	

#print "Content-type: text/html\n\n";

### (FORUMTOP) = print_forum_gen_top (ACTION, GLOBAL FORUM NAME);

$template = sn_netbbs::get_file_contents("$data_dir/template.html");
@gset = sn_netbbs::get_global_settings;

#$ftop = sn_netbbs::print_forum_gen_top ("My Profile", $gset[11]);

##################

### WINDOW NAME ### BUTTON NAME
#$lhtmldata = sn_netbbs::login_box("edit_profile", "$scripts_url/sn_profile.cgi", "Login", "Edit Profile");


### CHECK IF USER IS LOGGED IN AND IF NOT LOGGED IN THEN DISPLAY LOGIN SCREEN

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false

	if ($logged_in_status eq "false") 
	{
	print qq[<html>
	<head>
	<title>Turbo Seek Documentation</title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_login.cgi?l=profile">
	</head>
	<body>
	</body>
	</html>
	];
	exit;
	}

&edit_profile;


}





