#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $web_path $flocking/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_register.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "register_user_scr") {&register_user_scr; exit;}
if ($q->param('fct') eq "register_user") {&register_user; exit;}


###############################################################################

sub register_user
{

my ($ms, $oneletter, $error_text, $template, @settings, $ftop, $ausers, @all_users, $user_item);

$error_text = "";

if ($q->param('member_name') eq "")
	{
	#	$error_text = ("You have to specify a member name that will be used to post messages with."); 
	&register_user_scr("error1");
	exit;	
	}
	
if ($q->param('email_address') eq "")
	{
	#$error_text = ("You have to specify an email address where your password will be sent to."); 
	&register_user_scr("error4");
	exit;	
	}


### CHECK INPUT
for ($ms = 0; $ms < length($q->param('member_name')); $ms++) 
	{
	$oneletter = substr($q->param('member_name'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne " "))
		{
		#$error_text = "The member name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.";
		&register_user_scr("error1");
		exit;
		}
	}

### CHECK IF DUPLICATE USER NAME
if ($error_text eq "")
	{
	$ausers = sn_netbbs::get_file_contents("$data_dir/users/users.dat");
	
	@all_users = split (/\n/,$ausers);
		foreach $user_item (@all_users)
			{
			if (lc($q->param('member_name')) eq lc($user_item))
				{
				#$error_text = "The user name you specified already exists. Please choose another.";
				&register_user_scr("error2");
				exit;
				}
			}
	}

### CHECK IMG AUTH

$img_auth_check = sn_netbbs::check_img_auth_cc;
	
if ($img_auth_check eq "false") 
	{
	#if ($regtext[21] eq "") { $regtext[21] = "The letters you typed, did not match the image letters displayed to you."; }
	
	&register_user_scr("error5");
	exit;
	}



&register_user2;

}






sub register_user2
{

my ($template, @settings, $ftop, $password, $randomnumber, $ms, $message, $member_name,
	 $userfilename, $homepage_diz, $interests, $signature, $regmsg, $current_time,
	 $user_image);

### GET TEMPLATE
$template = sn_netbbs::get_file_contents("$data_dir/sn_reg_success.html");
$ptitle = sn_netbbs::get_page_title("sn_reg_success");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html"); 
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

### GET SETTINGS
(@settings) = sn_netbbs::get_global_settings;

#### (FORUM GENERAL TOP) = print_forum_gen_top(PAGE TITLE, GLOBAL FORUM NAME);
#$ftop = sn_netbbs::print_forum_gen_top("Registered", "$settings[11]", "You have been registered!");

### GENERATE PASSWORD
$password = "";

for ($ms = 0; $ms < 6; $ms++) 
	{
	$randomnumber = rand(26);
	$randomnumber = $randomnumber + 97;
	$password = $password . chr($randomnumber);
	}

#### CREATE USER
$member_name = $q->param('member_name');

open (MAINUSERFILE, ">> $data_dir/users/users.dat");
 if ($flocking ne "No"){flock (MAINUSERFILE,2);}
	print MAINUSERFILE "$member_name" . "\n";
 if ($flocking ne "No"){flock (MAINUSERFILE,8);}
close (MAINUSERFILE);

$userfilename = $member_name;
$userfilename =~ s/ /_/g;

$homepage_diz = $q->param('homepage_diz');
$homepage_diz =~ s/\n/<br>/g;

$interests = $q->param('interests');
$interests =~ s/\n/<br>/g;

$signature = $q->param('signature');
$signature =~ s/\n/<br>/g;

$current_time = time();
$user_image = $q->param('user_image');

open (USERDATA, "> $data_dir/users/$userfilename.dat");
 if ($flocking ne "No"){flock (USERDATA,2);}
	print USERDATA "$member_name" . "\n" .						#### 0 USERNAME
						"$password" . "\n" .							#### 1 PASSWORD
						$q->param('email_address') . "\n" .		#### 2 EMAIL ADDRESS
						$q->param('email_visible') . "\n" .	   #### 3 EMAIL VISIBLE
						$q->param('home_page') . "\n" .			#### 4 HOMEPAGE NAME
						$homepage_diz . "\n" .						#### 5 HOME PAGE DESCRIPTION
						$q->param('home_page_url') . "\n" .		#### 6 HOME PAGE URL
						$q->param('icq_number') . "\n" .			#### 7 ICQ NUMBER
						$q->param('location') . "\n" .			#### 8 LOCATION
						$interests . "\n" .							#### 9 INTERESTS
						$q->param('occupation') . "\n" .			#### 10 OCUPATION
						$signature . "\n" . 							#### 11 SIGNATURE
						"Member" . "\n" . 							#### 12 MEMBER STATUS
						$current_time . "\n" . 						#### 13 DATE JOINED
						"0" . "\n" . 									#### 14 TOTAL POSTS
						$user_image . "\n";							#### 15 USER IMAGE
						
 if ($flocking ne "No"){flock (USERDATA,8);}
close (USERDATA);
chmod(0777,"$data_dir/users/$userfilename.dat","$data_dir/users/$userfilename.dat");


#### EMAIL PASSWORD TO USER
($fromname, $fromemail, $emailsubject, $message) = sn_netbbs::get_email_details("sn_register.eml");

$message =~ s/!!forum_name!!/$settings[11]/g;
$message =~ s/!!username!!/$member_name/g;
$message =~ s/!!password!!/$password/g;
$message =~ s/!!forum_web_address!!/$scripts_url\/sn_forum.cgi/g;

$emailsubject =~ s/!!forum_name!!/$settings[11]/g;
$emailsubject =~ s/!!username!!/$member_name/g;



sn_netbbs::send_email($sendmail_loc,  					### LOCATION OF SENDMAIL
							$fromname,  						### SENDER NAME
							$fromemail,	 						### FROM EMAIL
							$q->param('email_address'), 	### TO EMAIL ADDRESS
							$emailsubject, 					### SUBJECT
							$message);							### MESSAGE


#########



$globalframe =~ s/!!forums!!/$template/gi;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi;

$globalframe =~ s/!!forum_name!!/$settings[11]/gi;

$globalframe =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$globalframe =~ s/!!location!!/$loclink/gi;

$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi;

$globalframe =~ s/!web_url!/$web_url/gi;




print $globalframe;

}



sub register_user_scr
{
my ($error_msg) = @_;

my ($template, @settings, $ftop, $image_dropdown, @files, $Ncount, $item);

### GET TEMPLATES
$template = sn_netbbs::get_file_contents("$data_dir/sn_regform.html");
$ptitle = sn_netbbs::get_page_title("sn_regform");
$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html"); 


### GET SETTINGS
(@settings) = sn_netbbs::get_global_settings;


### (FORUM GENERAL TOP) = print_forum_gen_top(PAGE TITLE, GLOBAL FORUM NAME);
#$ftop = sn_netbbs::print_forum_gen_top("Register", "$settings[11]", "Register for access to the forums");


### GET IMAGES DROPDOWN

opendir(DIR,"$web_path/user_images");
	@files = readdir(DIR);
closedir(DIR);

$image_dropdown = $image_dropdown . "<option value=\"\">Do Not Use a User Image</option>";

$Ncount = 1;

foreach $item (@files)
	{
	if (($item ne ".") and ($item ne ".."))
		{
		$image_dropdown = $image_dropdown . "<option value=\"$item\">Image $Ncount</option>";
		$Ncount = $Ncount + 1;
		}
	}
	

### REGISTRATION FORM

$image_dropdown_complete = qq[

<script LANGUAGE="JavaScript">
<!-- Hide


function xmlhttpPost(strURL, display_area, ddown)
	{
    var xmlHttpReq = false;
    var self = this;

    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }

    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
		
		strURL = '$scripts_url/sn_imgd.cgi?i=' + strURL;
		
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	self.xmlHttpReq.onreadystatechange = function()
    	   {
         if (self.xmlHttpReq.readyState == 4)
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText;
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}

    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
	}

// End Hide -->
</script>

<select name="user_image" size="1" onChange="xmlhttpPost(this.form.user_image.options[this.form.user_image.selectedIndex].value, 'result1', 1);">
$image_dropdown
</select>
];

$template =~ s/!!images_link!!/$scripts_url\/sn_usr_img.cgi/gi; 

$imgprev = qq[<div id="result1"></div>];

$template =~ s/!!image_preview!!/$imgprev/gi;

$template =~ s/!!image_dropdown!!/$image_dropdown_complete/gi;


if ($error_msg eq "")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
	elsif ($error_msg eq "error1")
	{
	$template = sn_netbbs::display_errors($template, "error1", "");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
	elsif ($error_msg eq "error2")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
	elsif ($error_msg eq "error3")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
	elsif ($error_msg eq "error4")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "");
	$template = sn_netbbs::display_errors($template, "error5", "NODISPLAY");
	}
	elsif ($error_msg eq "error5")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error5", "");
	}


#### IMG AUTH

$imgbox = sn_netbbs::get_imgboxes_cc;
($imdisp, $imgnames) = split (/:::/, $imgbox);
$imgnames =~ s/\.gif//gi;

$hinv = qq[ <input type="hidden" name="ia" value="$imgnames">];
$template =~ s/<\/form>/$hinv<\/form>/gi;
$template =~ s/%%imgbox%%/$imdisp/g;	

####

$member_name = $q->param('member_name');
$template =~ s/!!member_name!!/$member_name/gi;

$email_address = $q->param('email_address');
$template =~ s/!!email_address!!/$email_address/gi;

$home_page = $q->param('home_page');
$template =~ s/!!home_page!!/$home_page/gi;

$homepage_diz = $q->param('homepage_diz');
$template =~ s/!!homepage_diz!!/$homepage_diz/gi;

$home_page_url = $q->param('home_page_url');
$template =~ s/!!home_page_url!!/$home_page_url/gi;

$locationcc = $q->param('location');
$template =~ s/!!location_cc!!/$locationcc/gi;

$interests = $q->param('interests');
$template =~ s/!!interests!!/$interests/gi;

$occupation = $q->param('occupation');
$template =~ s/!!occupation!!/$occupation/gi;

$signature = $q->param('signature');
$template =~ s/!!signature!!/$signature/gi;


$form_vars = qq[<input type="hidden" name="fct" value="register_user"></form>];
$template =~ s/<\/form>/$form_vars/gi;
$template =~ s/!!register_script!!/$scripts_url\/sn_register.cgi/gi;

$globalframe =~ s/!!forums!!/$template/gi;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi;

$globalframe =~ s/!!forum_name!!/$settings[11]/gi;

		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$loclink = qq[<a href="http://$domain/forumindex.html">$settings[11]</a>];
			}
			else
			{
			$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
			}

$globalframe =~ s/!!location!!/$loclink/gi;

$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi;

$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/gi;

print $globalframe;

}




sub start
{

my ($template, @settings, $ftop, $terms_text);

### GET TEMPLATE
$template = sn_netbbs::get_file_contents("$data_dir/sn_terms.html");
$ptitle = sn_netbbs::get_page_title("sn_terms");
$template =~ s/!!register_script!!/$scripts_url\/sn_register.cgi/gi;
$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html"); 


### GET SETTINGS
(@settings) = sn_netbbs::get_global_settings;


### FORM VARS
$form_vars = qq[<input type="hidden" name="fct" value="register_user_scr"></form>];
$template =~ s/<\/form>/$form_vars/gi;

$globalframe =~ s/!!forums!!/$template/gi;


		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$loclink = qq[<a href="http://$domain/forumindex.html">$settings[11]</a>];
			}
			else
			{
			$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
			}

$globalframe =~ s/!!location!!/$loclink/gi;


$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi;

$globalframe =~ s/!!forum_name!!/$settings[11]/gi;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi;

$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$globalframe =~ s/!web_url!/$web_url/gi;
print $globalframe;

}

