#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $web_path $flocking/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_rgst.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "save_message") {&save_message; exit;}

##########################################################


sub save_message
{

my ($uname, $upass, @usettings, $cid, $fid, $tid, $rpm, $allidata, @allitems,
	 @msgitems, $okpass, $mitem, $msgtowrite, $nrl, $blc, $astat, @sti, $stline, $topid, 
	 $posts, $views, $ttdt, @settings, $template, $txt, $crit1, $crit2, $crit3, $crit4,
	 $crit5, $crit6, $crit7);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
	 
@settings = sn_netbbs::get_global_settings();

#$uname = $q->param('usern');
#$upass = $q->param('password');

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);


$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');
$rpm = $q->param('rpm');

(@usettings) = sn_netbbs::check_username_password ($uname, $upass);

#### USER DETAILS

$allidata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.dat");
@allitems = split (/\n/, $allidata);
#$rpm = $rpm - 1;
@msgitems = split (/\t/, $allitems[$rpm]);

if (lc($msgitems[1]) eq lc($usettings[0])){$okpass = "OK";} ### EDITING BY USER WHO POSTED MSG
if (substr($usettings[12], 0, 2) eq "Mo"){$okpass = "OK";} ### MODERATOR EDIT
if (substr($usettings[12], 0, 2) eq "Ad"){$okpass = "OK";} ### ADMINISTRATOR EDIT



$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");


if (($usettings[0] eq "ERROR") or ($okpass ne "OK") or ($q->param('message') eq ""))
	{
	$sn_edit_unable = sn_netbbs::get_file_contents("$data_dir/sn_edit_unable.html");
	
	@settings = sn_netbbs::get_global_settings();
	
	$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
	$sn_edit_unable =~ s/!!location!!/$loclink/g;
		
	$globalframe =~ s/!!forums!!/$sn_edit_unable/gi;
		
	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
		
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
		
	$globalframe =~ s/!web_url!/$web_url/g;
	
	print $globalframe;
 	exit;


	}
	else ### MESSAGE OPERATIONS
	{
	if (substr($usettings[12], 0, 2) eq "Mo") { $admin_stat = "true"; }
	if (substr($usettings[12], 0, 2) eq "Ad") { $admin_stat = "true"; }
	
	
	### SAVE MESSAGE
	if ($q->param('savemsg') ne "")
		{
		
		$msgtowrite = $q->param('message');
		$msgtowrite =~ s/\n/<br>/g;

		$crit1 = "<img src=\"$web_url/sn_happy.gif\">";
		$crit2 = "<img src=\"$web_url/sn_happy2.gif\">";
		$crit3 = "<img src=\"$web_url/sn_ooo.gif\">";
		$crit4 = "<img src=\"$web_url/sn_grin.gif\">";
		$crit5 = "<img src=\"$web_url/sn_question.gif\">";
		$crit6 = "<img src=\"$web_url/sn_cool.gif\">";
		$crit7 = "<img src=\"$web_url/sn_cup.gif\">";

		$msgtowrite =~ s/:\)/$crit1/g;
		$msgtowrite =~ s/;\)/$crit2/g;
		$msgtowrite =~ s/:o/$crit3/g;
		$msgtowrite =~ s/\[biggrin\]/$crit4/g;
		$msgtowrite =~ s/\[confused\]/$crit5/g;
		$msgtowrite =~ s/\[cool\]/$crit6/g;
		$msgtowrite =~ s/\[award\]/$crit7/g;

		$allitems[$rpm]   = "$msgitems[0]" . "\t" . 				## 0 MESSAGE TOPIC
								  "$msgitems[1]" . "\t" . 				## 1 USER
						 		  "$msgitems[2]" . "\t" . 				## 2 USER EMAIL
								  "$msgitems[3]" . "\t" . 				## 3 ICON
								  "$msgitems[4]" . "\t" .  			## 4 RECEIVE NOTIFICATION ON REPLY
								  "$msgitems[5]" . "\t" . 				## 5 MESSAGES IN TOPIC
								  "$msgitems[6]" . "\t" .				## 6 TIME POSTED
								  "$msgtowrite"  . "\t" .				## 7 MESSAGE
								  "$msgitems[8]";							## 8 IP ADDRESS
		
		$nrl = push(@allitems);
		$blc = 1;
		
		open (MSGDA, "> $data_dir/$cid/$fid/$tid.dat");
		 if ($flocking ne "No"){flock (MSGDA,2);}

			foreach $mitem(@allitems)
				{
					print MSGDA $mitem . "\n";
					$blc++;
				}

		 if ($flocking ne "No"){flock (MSGDA,8);}
		close (MSGDA);
		
		}
		elsif (($q->param('delete_msg') ne "") and ($admin_stat eq "true")) ### DELETE MESSAGE
		{
				
		$allitems[$rpm] = "";
		$nrl = push(@allitems);
		$blc = 1;
		open (MSGDA, "> $data_dir/$cid/$fid/$tid.dat");
		 if ($flocking ne "No"){flock (MSGDA,2);}
			foreach $mitem(@allitems)
				{
				  if ($mitem ne "")
				   {
					if ($blc ne $nrl)	
						{
						print MSGDA $mitem . "\n";
						}
						else
						{
						print MSGDA $mitem;
						}
					}
					$blc++;
				}
		 if ($flocking ne "No"){flock (MSGDA,8);}
		close (MSGDA);

		### SORT OUT STATS

		$astat = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
		@sti = split(/\n/,$astat);
		
		open (TTSTATS, "> $data_dir/$cid/$fid/tstats.dat");
		
		 if ($flocking ne "No"){flock (TTSTATS,2);}
			foreach $stline (@sti)
				{
				($topid, $posts, $views, $ttdt) = split(/\t/,$stline);
					if ($topid eq $tid)
						{
						$posts = $posts - 1;
						print TTSTATS $topid . "\t" . $posts . "\t" . $views . "\t" . $ttdt . "\n";
						}
						else
						{
						print TTSTATS "$stline" . "\n";
						}
				}
		 if ($flocking ne "No"){flock (TTSTATS,8);}
		 
		close(TTSTATS);
		}
		elsif (($q->param('delete_topic') ne "") and ($admin_stat eq "true")) ### DELETE TOPIC
		{
		
		$uname = $usettings[0];
		
		$epassword = crypt($upass, $uname);
		$epassword = $epassword . "foi234ndfis82d2ss1";
		
		$tid_del = "C_" . $tid;

print <<END_OF_DELTOPIC;
<html>
<head>
<title></title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_moderate.cgi?fct=delete_topics_final&m=$uname&p=$epassword&fid=$fid&cid=$cid&$tid_del=Y&indmsg=true">
</head>
<body> 
</body>
</html>
END_OF_DELTOPIC
		
		exit;
		}
		elsif (($q->param('unstick_topic') ne "") and ($admin_stat eq "true")) ### UNSTICK TOPIC
		{
		$toplns = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");

		@alltlines = split (/\n/, $toplns);
		$accnt = 0;
		foreach $titem (@alltlines)
			{
			my @topicline = split(/\t/, $titem);
			if ($topicline[0] eq $tid)
				{
				$topicline[10] = "";
				$newline = "";
				foreach $ttiitem (@topicline)	{ $newline = $newline . $ttiitem . "\t"; }
				$alltlines[$accnt] = $newline;
				}
			$accnt++;
			}
		
		

		open (TTWR, "> $data_dir/$cid/$fid/topics.dat");
			foreach $item (@alltlines)
				{
				print TTWR $item . "\n";
				}
		close (TTWR);
		
		}
		elsif (($q->param('make_sticky') ne "") and ($admin_stat eq "true")) ### UNSTICK TOPIC
		{
		$toplns = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");

		@alltlines = split (/\n/, $toplns);
		$accnt = 0;
		foreach $titem (@alltlines)
			{
			my @topicline = split(/\t/, $titem);
			if ($topicline[0] eq $tid)
				{
				$topicline[10] = "Y";
				$newline = "";
				foreach $ttiitem (@topicline)	{ $newline = $newline . $ttiitem . "\t"; }
				$alltlines[$accnt] = "";
				$move_tid_stats = $topicline[0];
				}
			$accnt++;
			}

		open (TTWR, "> $data_dir/$cid/$fid/topics.dat");
		print TTWR $newline . "\n";
			foreach $item (@alltlines)
				{
				if ($item ne "")
					{
					print TTWR $item . "\n";
					}
				}
		close (TTWR);
		
		### UPDATE tstats.dat
		
		$toplns = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
		@allstats = split (/\n/, $toplns);
		
		$scnt = 0;
		foreach $sitem (@allstats)
			{
			my @statline = split (/\t/, $sitem);
			
			if ($statline[0] eq $move_tid_stats)
				{
				$firstsline = $allstats[$scnt];
				$allstats[$scnt] = "";
				}
			$scnt++;
			}
			
		open (TST, "> $data_dir/$cid/$fid/tstats.dat");
			print TST $firstsline . "\n";
			foreach $sitem (@allstats)
				{
				if ($sitem ne "")
					{
					print TST $sitem . "\n";
					}
				}
		close (TST);
		
		
		}
		elsif (($q->param('lock_topic') ne "") and ($admin_stat eq "true")) ### LOCK TOPIC
		{
		$toplns = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");

		@alltlines = split (/\n/, $toplns);
		$accnt = 0;
		foreach $titem (@alltlines)
			{
			my @topicline = split(/\t/, $titem);
			if ($topicline[0] eq $tid)
				{
				$topicline[6] = "2";
				$newline = "";
				foreach $ttiitem (@topicline)	{ $newline = $newline . $ttiitem . "\t"; }
				$alltlines[$accnt] = $newline;
				}
			$accnt++;
			}
		
		open (TTWR, "> $data_dir/$cid/$fid/topics.dat");
			foreach $item (@alltlines)
				{
				print TTWR $item . "\n";
				}
		close (TTWR);
		}
		elsif (($q->param('unlock_topic') ne "") and ($admin_stat eq "true")) ### LOCK TOPIC
		{
		$toplns = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");

		@alltlines = split (/\n/, $toplns);
		$accnt = 0;
		foreach $titem (@alltlines)
			{
			my @topicline = split(/\t/, $titem);
			if ($topicline[0] eq $tid)
				{
				$topicline[6] = "1";
				$newline = "";
				foreach $ttiitem (@topicline)	{ $newline = $newline . $ttiitem . "\t"; }
				$alltlines[$accnt] = $newline;
				}
			$accnt++;
			}
		
		open (TTWR, "> $data_dir/$cid/$fid/topics.dat");
			foreach $item (@alltlines)
				{
				print TTWR $item . "\n";
				}
		close (TTWR);
		}
		
		###########

$sn_edit_saved = $template = sn_netbbs::get_file_contents("$data_dir/sn_edit_saved.html");
$ptitle = sn_netbbs::get_page_title("sn_edit_saved");

#sn_forumr.cgi?fid=1195&cid=1193&tid=2610&pg=1&sc=20&x=0

$sn_edit_saved =~ s/!!view_message_link!!/$scripts_url\/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tid&&pg=1&sc=20&x=0/gi;

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

@settings = sn_netbbs::get_global_settings();

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$sn_edit_saved =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!forums!!/$sn_edit_saved/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 


$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe;
exit;




$txt = <<END_OFSAVED;

<table border="0" cellspacing="0" width="100%" bgcolor="$settings[5]" cellpadding="0">
  <tr>
    <td width="100%"><table border="0" cellspacing="1" width="100%" cellpadding="3">
      <tr>
        <td width="100%" bgcolor="$settings[2]" height="27"><p align="center"><font face="$settings[6]"
        size="2" color="$settings[8]"><strong>Changes Saved</strong></font></td>
      </tr>
      <tr>
        <td width="100%" bgcolor="$settings[3]" valign="top"><form method="POST" action>
          <div align="center"><center><p>&nbsp;&nbsp;&nbsp; <br>
          &nbsp; <input type="submit" value="    Close Window    " name="B1"
          onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8"></p>
          </center></div>
        </form>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>

END_OFSAVED
	
	$template =~ s/!!netboard!!/$txt/g;
	print $template;
	
	}
}

