#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_search.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "search") {&search; exit;}

#### START ########################################################

sub search
{

my ($cid, $fid, @files, $item, $title, $diz, $link, $relevance, $diz2, @sresults, $cntr,
	 $sresults, $allresults, $modp, $listperpage, $pages, $st_res, $nd_res, $ippc, $lresults,
	 $ms, $pg, $pgstring, $st, $nd, $spls, $nextt, $prev, $spcer, $skeyw, $forum_to_search,
	 $smethod, $skeyw2, $prevnext, $fdata, @fsettings, $template, @settings, $ftop, $fnamelink,
	 @newrs, $newcntr, $current_catname, $current_boardname, $fselbox);

### ERROR CHECKING

(@settings) = sn_netbbs::get_global_settings;

if ($q->param('search_crit') eq "")
		{
		&start("error1"); 
		exit; 
		}
		
		
if ($q->param('D1') eq "")
		{
		&start("error2"); 
		exit; 
		}


### GET TEMPLATES

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html"); 
$template = sn_netbbs::get_file_contents("$data_dir/sn_search_results_page.html");
$ptitle = sn_netbbs::get_page_title("sn_search_results_page");


$sn_search_results = sn_netbbs::get_file_contents("$data_dir/sn_search_results.html");
$dropdown = 	sn_netbbs::get_file_contents("$data_dir/sn_search_dropdown.html");

#################


($cid, $fid) = split (/_/, $q->param('D1'));


sn_netbbs::check_input($cid);
sn_netbbs::check_input($fid);

if ((-e "$data_dir/$cid/$fid/config.dat") < 1)
	{
	sn_netbbs::fatal_error("Invalid Forum / Category");
	}


### DO SEARCH
opendir(DIR,"$data_dir/$cid/$fid");
	@files = readdir(DIR);
closedir(DIR);


$cntr = 0;
foreach $item (@files)
	{
	if ((substr($item, 0, 1) =~ /[0-9]/) and ($item =~ /\.dat/))
	  {
	  ($title, $diz, $diz2, $link, $relevance) = &get_matches("$data_dir/$cid/$fid/$item", $cid, $fid, $item);
		#$relevance = int($relevance);
		#print "==> $title <br> RELEVANCE: $relevance --<br><br>";
	
	  if ($relevance != 0)
	    	{
	    	$sresults[$cntr] = 	$relevance . "\t" . ### Relevance
	    								$title . "\t" . 	  ### Title
	    								$diz . "\t" . 		  ### DIZ
	    								$diz2 . "\t" . 	  ### DIZ 2
	    								$link;				  ### LINK
	    	$cntr++;
	    	}
	    	
	   }
	}

@sresults = sort(@sresults);
$allresults = @sresults;


$newcntr = $allresults;
foreach $item (@sresults)
	{
	$newcntr = $newcntr - 1;
	$newrs[$newcntr] = $item;
	}


$listperpage = 10;

########################

$modp = ($allresults % $listperpage );
$pages = ($allresults - $modp) / $listperpage;
if ($modp != 0) {$pages++;}

$st_res = $q->param('st');
$nd_res = $q->param('nd');

if ($st_res eq ""){$st_res = 0;}
if ($nd_res eq ""){$nd_res = $listperpage;}

$ippc = 1;

foreach $item (@newrs)
	{
	if (($ippc > $st_res) and ($ippc <= $nd_res))
		{
		($relevance, $title, $diz, $diz2, $link) = split(/\t/, $item);
		
		$sn_search_results_tmp = $sn_search_results;
		
		$sn_search_results_tmp =~ s/!!nr!!/$ippc/gi;
		$sn_search_results_tmp =~ s/!!topic!!/$title/gi;
		$sn_search_results_tmp =~ s/!!description!!/$diz/gi;
		
		($topic_starter, $topic_date) = split (/:::/, $diz2);
		
		$sn_search_results_tmp =~ s/!!topic_starter!!/$topic_starter/gi;
		$sn_search_results_tmp =~ s/!!topic_date!!/$topic_date/gi;
		$sn_search_results_tmp =~ s/!!topic_link!!/$link/gi;
		
		#$sn_search_results_tmp =~ s/!!description!!/$diz2/gi;
		#$lresults = $lresults . "<p><font face=\"$settings[6]\"><font size=\"2\"><a href=\"$link\">$ippc. $title</a><br>$diz</font><font size=\"1\">$diz2</font></font></p>";
		
		$lresults = $lresults . $sn_search_results_tmp;
		
		}
	$ippc++;
	}

$skeyw = $q->param('search_crit');
$skeyw =~ s/ /+/g;
$skeyw2 = $q->param('search_crit');

$forum_to_search = $q->param('D1');
$smethod = $q->param('smethod');

#### PAGES

$s_nextpage = sn_netbbs::get_file_contents("$data_dir/sn_nextp.html");
$s_prevpage = sn_netbbs::get_file_contents("$data_dir/sn_prevp.html");
$s_nextprev_sep = sn_netbbs::get_file_contents("$data_dir/sn_nextprevsep.html");


  for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd_res == ($pg * $listperpage))
		{
		$pgstring = $pgstring . " [$pg] ";
		}
	  	else
		{
		$st = ($pg * $listperpage) - $listperpage;
		$nd = ($pg * $listperpage);
		$pgstring = $pgstring . "<a href=\"$scripts_url/sn_search.cgi?search_crit=$skeyw&st=$st&nd=$nd&fct=search&D1=$forum_to_search&smethod=$smethod&cid=$cid&fid=$fid&gts=gts\">$pg</a> ";
		}
	}



#### PREV NEXT

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd_res <= ($allresults - $spls))
 	{
	$st = $st_res + $listperpage;
	$nd = $nd_res + $listperpage;
	$nextt =   "<a href=\"$scripts_url/sn_search.cgi?search_crit=$skeyw&st=$st&nd=$nd&fct=search&D1=$forum_to_search&smethod=$smethod&cid=$cid&fid=$fid&gts=gts\">$s_nextpage</a> ";
	}


 if ($st_res > 0)
	 	{
		$st = $st_res - $listperpage;
		$nd = $nd_res - $listperpage;
		$prev = "<a href=\"$scripts_url/sn_search.cgi?search_crit=$skeyw&st=$st&nd=$nd&fct=search&D1=$forum_to_search&smethod=$smethod&cid=$cid&fid=$fid&gts=gts\">$s_prevpage</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " $s_nextprev_sep ";
	}
	else
	{
	$spcer = " ";
	}

$prevnext = $prev . $spcer . $nextt;


###### TOP #######
$fdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fsettings = split (/\n/, $fdata);

#$fnamelink = "<a href=\"$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid\">$fsettings[1]</a> ";
#$ftop = sn_netbbs::print_forum_gen_top ("$fnamelink Searching for <b>'$skeyw2'</b>", $settings[11], "Searching $fsettings[1] for <b>'$skeyw2'</b>");
#($fselbox, $current_catname, $current_boardname) = sn_netbbs::get_forum_selbox_details();

(@settings) = sn_netbbs::get_global_settings;

### IF NO MATCHES

if ($allresults == 0)
	{
	$template = sn_netbbs::get_file_contents("$data_dir/sn_search_nomatch.html"); 
	$ptitle = sn_netbbs::get_page_title("sn_search_nomatch");
	}


$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$template =~ s/!!location!!/$loclink/g;

$template =~ s/!!next_page!!/$prevnext/g;

$template =~ s/!!pages!!/$pgstring/g;

$kws = $q->param('search_crit');
$template =~ s/!!keywords!!/$kws/g;

$template =~ s/!!matches!!/$allresults/g;

$template =~ s/!!search_results!!/$lresults/g;



### GET CATEGORY TABLE FOR SEARCH AGAIN

	open (CTABLE, "$data_dir/sn_boardtable.dat");
		while (defined($bline=<CTABLE>))
			{		
			($cid1, $cname) = split(/\t/,$bline);
			
				if ($cid == $cid1){$ccname = $cname;}
			
				if ($gencount != 0)
					{
					$seloptions = $seloptions . "<option value=\"\"></option>";
					}
				$seloptions = $seloptions . "<option value=\"\">--- $cname ---</option>";
				$gencount++;  
				
				### GET BOARDS
				
				open (BTABLE, "$data_dir/$cid1/forumtable.dat");
						while (defined($fline=<BTABLE>))
							{		
							($bid, $bname) = split(/\t/,$fline);
							
							if ($fid == $bid){$cbname = $bname;}
							
							$bvalue = "$cid1" . "_" . "$bid";
							
							$selected = "";
							if ($q->param('gts') eq "gts")
								{
								if (($cid1 eq $q->param('cid')) and ($bid eq $q->param('fid')))
									{
									$selected = "selected";
									}
								}
							
							$seloptions = $seloptions . "<option $selected value=\"$bvalue\">$bname</option>";
							}
				close (BTABLE);
				
			}
	close (CTABLE);




 #$seloptions = $seloptions ." </select>";
 
 $dropdown =~ s/!!forum_options!!/$seloptions/gi;
 $template =~ s/!!forumsearch_dropdown!!/$dropdown/gi;
 
 $template =~ s/!!search_script!!/$scripts_url\/sn_search.cgi/gi;
 
 $hvars = qq[
 <input type="hidden" name="fct" value="search">
 <input type="hidden" name="cid" value="$cid">
 <input type="hidden" name="fid" value="$fid">
 <input type="hidden" name="gts" value="gts">
 </form>
 ];
 
 $template =~ s/<\/form>/$hvars/gi;
 
##############


$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi;


$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe; 


exit;

####################

if ($allresults == 0){$lresults = "<p><font face=\"$settings[6]\" size=\"2\">Did not find any matches. Try using different keywords.</font></p>"; $pgstring = 1;}

######################


$lresults = <<END_OF_LRS;
$ftop
<table border="0" cellpadding="0" cellspacing="1" width="100%" height="27">
  <tr>
    <td width="32%"><font face="$settings[6]" size="1">$prevnext</font></td>
    <td width="68%"><p align="right"><font face="$settings[6]" size="1">Pages: $pgstring</font></td>
  </tr>
</table>
<div align="center"><center>

<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="$settings[5]">
  <tr>
    <td width="100%"><table border="0" cellpadding="3" cellspacing="1" width="100%">
      <tr>
        <td width="100%" bgcolor="$settings[2]" height="27"><font face="$settings[6]" size="4"><p
        align="left"></font><font face="$settings[6]" size="1" color="$settings[8]"><strong>Searching for
        '$skeyw2' - Found $allresults</strong> matches</font></td>
      </tr>
      <tr>
        <td width="100%" bgcolor="$settings[3]" height="27"><blockquote>
          <p><br>
          $lresults</p>
        </blockquote>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</center></div>

<table border="0" cellpadding="0" cellspacing="1" width="100%" height="27">
  <tr>
    <td width="32%"><font face="$settings[6]" size="1">$prevnext</font></td>
    <td width="68%"><p align="right"><font face="$settings[6]" size="1">Pages: $pgstring</font></td>
  </tr>
</table>

<form method="POST" action="$scripts_url/sn_search.cgi">
  <input type="hidden" name="fct" value="search"><input type="hidden" name="cid"
  value="$cid"><input type="hidden" name="fid" value="$fid"><input type="hidden" name="gts"
  value="gts"><div align="center"><center><table border="0" cellpadding="0" cellspacing="0"
  width="100%" bgcolor="$settings[5]">
    <tr>
      <td width="100%"><table border="0" cellpadding="3" cellspacing="1" width="100%">
        <tr>
          <td width="100%" bgcolor="$settings[2]" colspan="2" height="27"><font face="$settings[6]" size="4"><div
          align="left"><p></font><font face="$settings[6]" size="1" color="$settings[8]"><strong>Search</strong></font></td>
        </tr>
        <tr>
          <td width="19%" bgcolor="$settings[3]"><strong><font face="$settings[6]" size="2">Keywords:</font></strong></td>
          <td width="81%" bgcolor="$settings[4]"><input type="text" name="search_crit" size="47"
          style="font-family: MS Sans Serif; font-size: 8pt" maxlength="65" value="$skeyw2"></td>
        </tr>
        <tr>
          <td width="19%" bgcolor="$settings[3]"><strong><font face="$settings[6]" size="2">Match Method:</font></strong></td>
          <td width="81%" bgcolor="$settings[4]"><table border="0" cellpadding="0" cellspacing="0"
          width="100%">
            <tr>
              <td width="2%"><font face="$settings[6]" size="1"><input type="radio" value="and"
              name="smethod" checked></font></td>
              <td width="5%"><font face="$settings[6]" size="1">And </font></td>
              <td width="1%"><font face="$settings[6]" size="1"><input type="radio" value="or" name="smethod"></font></td>
              <td width="54%"><font face="$settings[6]" size="1">Or</font></td>
            </tr>
          </table>
          </td>
        </tr>
        <tr>
          <td width="19%" bgcolor="$settings[3]"><strong><font face="$settings[6]" size="2">Forum to Search:</font></strong></td>
          <td width="81%" bgcolor="$settings[4]">$fselbox</td>
        </tr>
        <tr>
          <td width="19%" bgcolor="$settings[3]">&nbsp;</td>
          <td width="81%" bgcolor="$settings[4]"><input type="submit" value="Search" name="B1"
          style="font-family: MS Sans Serif; font-size: 8pt"></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
  </center></div>
</form>

END_OF_LRS

$template =~ s/!!netboard!!/$lresults/g;

$template = sn_netbbs::get_template_includes($template, "");

print $template;

}




sub get_matches
{

my ($file_search, $rcid, $rfid, $sfname) = @_;
my ($fcontents, $filesize, $thefile, $mrelevance, @keywords, $kw, $mrelevance,
	 @flines, $file_line, @titems, $rtitle, $rdiz, $rlink, $rdiz2, $nrkw);

$sfname =~ s/\.dat//g;
$mrelevance = 0;

$filesize = (-s "$file_search");
open (TFILECNTS, "$file_search");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
@flines = split(/\n/, $thefile);

#### KEYWORDS
if ($q->param('search_crit') =~ / /)
 {
  @keywords = split(/ /, $q->param('search_crit'));
 }
 else
 {
  $keywords[0] = $q->param('search_crit')
 }


#### OR
if ($q->param('smethod') eq "or")
	{
	foreach $file_line(@flines)
		{
		foreach $kw (@keywords)
			{
			if ($file_line =~ /$kw/i)
				{
				$mrelevance++;
				}
			}
		}
	}


#### AND 
if ($q->param('smethod') eq "and")
	{
	$nrkw = "true";
		foreach $kw (@keywords)
			{
			if ($thefile =~ /$kw/i)
				{
				$mrelevance++;
					foreach $file_line(@flines)
						{
						if ($file_line =~ /$kw/i){$mrelevance++;}
						}
				}
				else
				{
				$nrkw = "false";
				}
			}
	if ($nrkw eq "false"){$mrelevance = 0;}
	}


if (length($mrelevance) == 1){$mrelevance = "000" . $mrelevance;}
if (length($mrelevance) == 2){$mrelevance = "00" . $mrelevance;}
if (length($mrelevance) == 3){$mrelevance = "0" . $mrelevance;}	


### FIGURE OUT LINK DATA

if ($flines[0] =~ /\t/)
	{
	(@titems) = split (/\t/, $flines[0]);
	$rtitle = $titems[0];
	$titems[6] = sn_netbbs::decode_date($titems[6]);
	$titems[7] = substr($titems[7], 0, 125);
	$titems[7] =~ s/<br>/ /g;
	$titems[7] = $titems[7] . "...";
	$rdiz = $titems[7];
	#$rdiz2 = "<b>Topic Started By:</b> $titems[1], <b>Posted on:</b> $titems[6]";
	$rdiz2 = "$titems[1]:::$titems[6]";
	$rlink = "$scripts_url/sn_forumr.cgi?fid=$rfid&cid=$rcid&tid=$sfname&sc=20&pg=1&x=0";
	}
	else
	{
	$mrelevance = 0;
	}

return ($rtitle, $rdiz, $rdiz2, $rlink, $mrelevance);

}




sub start
{

my ($problem) = @_;
my ($template, $cid, $fid, @settings, $ftop, $catname, $fselbox, $current_catname,
    $current_boardname);

$cid = $q->param('cid');
$fid = $q->param('fid');



$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html"); 
$template = 	sn_netbbs::get_file_contents("$data_dir/sn_search_page.html");
$ptitle = sn_netbbs::get_page_title("sn_search_page");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$dropdown = 	sn_netbbs::get_file_contents("$data_dir/sn_search_dropdown.html");

(@settings) = sn_netbbs::get_global_settings;

#$ftop = sn_netbbs::print_forum_gen_top ("Search", $settings[11], "Search Forums");

### GET MENU DROP DOWN

#$seloptions = "<select name="D1" size="1">";

	open (CTABLE, "$data_dir/sn_boardtable.dat");
		while (defined($bline=<CTABLE>))
			{		
			($cid1, $cname) = split(/\t/,$bline);
			
				if ($cid == $cid1){$ccname = $cname;}
			
				if ($gencount != 0)
					{
					$seloptions = $seloptions . "<option value=\"\"></option>";
					}
				$seloptions = $seloptions . "<option value=\"\">--- $cname ---</option>";
				$gencount++;  
				
				### GET BOARDS
				
				open (BTABLE, "$data_dir/$cid1/forumtable.dat");
						while (defined($fline=<BTABLE>))
							{		
							($bid, $bname) = split(/\t/,$fline);
							
							if ($fid == $bid){$cbname = $bname;}
							
							$bvalue = "$cid1" . "_" . "$bid";
							
							$selected = "";
							if ($q->param('gts') eq "gts")
								{
								if (($cid1 eq $q->param('cid')) and ($bid eq $q->param('fid')))
									{
									$selected = "selected";
									}
								}
							
							$seloptions = $seloptions . "<option $selected value=\"$bvalue\">$bname</option>";
							}
				close (BTABLE);
				
			}
	close (CTABLE);

 #$seloptions = $seloptions ." </select>";
 
 $dropdown =~ s/!!forum_options!!/$seloptions/gi;
 $template =~ s/!!forumsearch_dropdown!!/$dropdown/gi;
 
 $template =~ s/!!search_script!!/$scripts_url\/sn_search.cgi/gi;
 
 $hvars = qq[
 <input type="hidden" name="fct" value="search">
 <input type="hidden" name="cid" value="$cid">
 <input type="hidden" name="fid" value="$fid">
 <input type="hidden" name="gts" value="gts">
 </form>
 ];
 
 $template =~ s/<\/form>/$hvars/gi;
 
 if ($problem eq "")
 	{
 	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
 	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY"); 
 	}
 	elsif ($problem eq "error1")
 	{
 	$template = sn_netbbs::display_errors($template, "error1", ""); 
 	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY"); 
 	}
 	elsif ($problem eq "error2")
 	{
 	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
 	$template = sn_netbbs::display_errors($template, "error2", ""); 
 	}

  
 ################


#($fselbox, $current_catname, $current_boardname) = sn_netbbs::get_forum_selbox_details();

		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$loclink = "http://$domain/forumindex.html";
			$loclink = qq[<a href="$loclink">$settings[11]</a>];
			}
			else
			{
			$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
			}

$template =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe; 


}



