#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $web_path $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_upload.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

&start; exit;


#### START ########################################################

sub start
{

my ($file, $FileToWrite, $rfname, $bytesread, $file, $buffer, $bytesread, $filename,
	 $errorbox, $template, $ftop, @settings, $type,$size,$mtime,$width,$height,$colors,
	 $username, $password, $cuser, $userfile, @usettings, $returned, $duserm, $cuser);

$rfname = time();
$file = $q->param('own_image');
$FileToWrite = "$web_path/user_imagesc";
$filename = $file;
$filename =~ s!^.*(\\|\/)!!;

########## ERROR CHECKING
(@puset) = sn_netbbs::check_username_password ($q->param('user'), $q->param('ps'));

if ($puset[0] eq "ERROR")
	{
	sn_netbbs::fatal_error("Your user name or password was incorrect.");
	}
elsif ($filename eq "")
	{

		print qq[<html>
		<head>
		<title></title>
		<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_profile.cgi?fct=upload_error&error=error4">
		</head>
		<body>
		</body>
		</html>
		];
		exit;
	
	#$errorbox = sn_netbbs::fatal_error("You have to specify a file name to upload.");
	}
	elsif ((substr($filename, length($filename) - 4,4) ne ".jpg") and (substr($filename, length($filename) - 4,4) ne ".gif"))
	{

		print qq[<html>
		<head>
		<title></title>
		<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_profile.cgi?fct=upload_error&error=error5">
		</head>
		<body>
		</body>
		</html>
		];
		exit;	
		
	#$errorbox = sn_netbbs::problembox("Only .gif and .jpg files are accepted.");
	}


######### TOP
@settings = sn_netbbs::get_global_settings();

$template = sn_netbbs::get_file_contents("$data_dir/sn_profile_saved.html");
$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");


############ DO UPLOAD
	
	open (OUTFILE, ">$FileToWrite/$filename");
	 if ($flocking ne "No"){flock (OUTFILE,2);}
		while ($bytesread = read($file, $buffer, 1024)) 
			{
			print OUTFILE $buffer;
			}
	 if ($flocking ne "No"){flock (OUTFILE,8);}
	close (OUTFILE);

	
########### ERROR CHECKING

	$allsett = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
	(@fsettings) = split (/\n/, $allsett);
	
	$filesize = (-s "$FileToWrite/$filename");
	
	if ($fsettings[16] eq "") { $fsettings[16] = 5; }
	
	$ksize = $fsettings[16];
	
	$fsettings[16] = ($fsettings[16] * 1000) + 1;
	
	if ($filesize > $fsettings[16])
		{

			print qq[<html>
				<head>
				<title></title>
				<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_profile.cgi?fct=upload_error&error=error3">
				</head>
				<body>
				</body>
				</html>
				];
				exit;	

		}


### WRITE CHANGES TO USER

$username = $q->param('user');
$password = $q->param('ps');

$cuser = $username;
$cuser =~ s/ /_/g;
$duser = $cuser;
$duser = $cuser . substr($filename, length($filename) - 4, 4);
$cuser = $cuser . ".dat";
$userfile = sn_netbbs::get_file_contents("$data_dir/users/$cuser");
(@usettings) = split(/\n/, $userfile);

$returned = rename("$FileToWrite/$filename","$FileToWrite/$duser");

open (USERFILE, "> $data_dir/users/$cuser");
 if ($flocking ne "No"){flock (USERFILE,2);}

	print USERFILE $usettings[0] . "\n" . 			## 0
						$usettings[1] . "\n" . 			## 1
						$usettings[2] . "\n" . 			## 2
						$usettings[3] . "\n" . 			## 3
						$usettings[4] . "\n" . 			## 4
						$usettings[5] . "\n" . 			## 5
						$usettings[6] . "\n" . 			## 6
						$usettings[7] . "\n" . 			## 7
						$usettings[8] . "\n" . 			## 8
						$usettings[9] . "\n" . 			## 9
						$usettings[10] . "\n" . 		## 10
						$usettings[11] . "\n" . 		## 11
						$usettings[12] . "\n" . 		## 12
						$usettings[13] . "\n" . 		## 13
						$usettings[14] . "\n" . 		## 14
						"USER_DEFINED" . $duser . "\n"; 	## 15
 
 if ($flocking ne "No"){flock (USERFILE,8);}
close (USERFILE);

######################



$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$fsettings[11]</a>];
$template =~ s/!!location!!/$loclink/g;

$template =~ s/!!edit_profile_link!!/$scripts_url\/sn_profile.cgi/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;
	
$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$fsettings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$fsettings[11]/gi; 

$globalframe =~ s/!web_url!/$web_url/g;
	
print $globalframe;



}


