#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use fmspm;
use pseek;
use Time::Local;  

&get_setup;
fmspm::check_spamb("tadds.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

$id = $q->param('id'); $id =~ s/[^0-9]//g;

print "Content-type: text/html\n\n";
if ($id eq "") { exit; }


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  


$sql = "SELECT * FROM advertgrp WHERE groupid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 
while ( @row = $sth->fetchrow() )
	{
	$maximp = $row[2];
	$expirdate = $row[3];
	$currentimp = $row[6];
	}


### IF EXPIRY TIME REACHED

if ($expirdate eq "2050-01-01") { $expirdate = "2020-01-01"; }

($pyear, $pmonth, $pday) = split (/-/, $expirdate);
$pmonth = $pmonth -1;
$exptime = timelocal(0,0,0, $pday,$pmonth,$pyear); 
$nowtime = time();
if ($nowtime > $exptime) { $display_default = "true"; }


### IF MAX IMPRESSIONS REACHED

if ($maximp != 0)
	{
	if ($currentimp >= $maximp) { $display_default = "true"; }
	}
	

### DISPLAY DEFAULT GROUP IF MAX IMPRESSIONS REACHED OR EXPIRED

if ($display_default eq "true")
	{
	$defadd = pseek::get_file_contents("$data_dir/defadvert.dat"); 
	($id, $gname) = split (/-/, $defadd);
	if (int($id) < 1) { print ""; exit; }
	}


$sql = "SELECT * FROM adverts WHERE groupid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 

$wcnt = 0;
while ( @row = $sth->fetchrow() )
	{
	$advert{$row[0]} = $row[3];
	
		for ($ms = 0; $ms < $row[4]; $ms++)
			{
			$waddvert{$wcnt} = "$row[0]";
			$wcnt++;
			}
	
	}

 
$randnr = rand($wcnt);
$randnr = int($randnr);

$ad_display = $advert{$waddvert{$randnr}};
$ad_display =~ s/<a href/<a target="_top" href/gi;

$current_aid = $waddvert{$randnr};


###########################

  # 0 1 2 3 4 5 6 7 8
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$mon++; $year += 1900;
	$nowtime = $year . "-" . $mon . "-" . $mday;

$sql = "UPDATE adlogs SET 	impressions = (impressions + 1)
									WHERE adate = '$nowtime' AND 
									aid = '$current_aid' AND 
									groupid = '$id'
									";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 

	if ($rows < 1)
		{
		$sql = "INSERT INTO adlogs SET 	aid = '$current_aid', 
													groupid = '$id',
													impressions = '1',
													clicks = '0',
													adate = '$nowtime'";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
		$rows = $sth->rows(); 
		}


if ($maximp != 0)
	{
	$sql = "UPDATE advertgrp SET current_imp = (current_imp + 1) WHERE groupid = '$id'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	$rows = $sth->rows(); 
	}


$sth->finish;
$dbh->disconnect;  



print qq[<html>
<head>
<title>Random Links</title>
<style type="text/css">
<!--
body { margin: 0; padding: 0; }
-->
</style>
</head>
</body>
$ad_display
</body>
</html>
];


#print "<BR><BR>--> $randnr<BR><BR>";
#for ($ms = 0; $ms < $wcnt; $ms++)
#	{
# 	print "--> $ms = " . $waddvert{$ms} . "<BR>";
# 	}
 
 


################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

