#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use frc4;


&get_setup;
fmspm::check_spamb("addurlpp.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";

if ($q->param('asd') ne "") {&start;}

#################

sub start
{


eval "use LWP::UserAgent";
if($@)
	{
	$lwp_useragent = "N";
	$lwp_useragent_err = $@;
	$lwp_notice = "<font color='red'>LWP::UserAgent</font><br>";
 	}
$@ = "";

##############

eval "use HTTP::Request::Common qw(GET)";
if($@)
	{
	$httprequest = "N";
	$httprequest_err = $@;
	$httprequest_notice = "<font color='red'>HTTP::Request::Common</font><br>";
 	}
$@ = "";

##############

eval "use Crypt::SSLeay";
if($@)
	{
	$cryptssl = "N";
	$cryptssl_err = $@;
	$cryptssl_notice = "<font color='red'>Crypt::SSLeay</font><br>";
 	}
$@ = "";



if (($lwp_useragent eq "") and ($lwp_useragent eq "") and ($lwp_useragent eq ""))
	{
		#### redirect do paypal
		
		$asd = $q->param('asd');
		
		print qq[<html>
		<head>
		<title>Add URL</title>
		<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=addurlpp2.cgi?asd=$asd">
		</head>
		<body>
		</body>
		</html>
		];
		
	}
	else
	{
		$use_perl_modules = "N";
		
		$module_warning = qq[
		<table width="94%"  align="center">
					 <tr class="normaltext">
					      <td valign="top">
					        <p>The premium link was submitted but the order could not be processed with PayPal because <b>your web host or web server does not have the following Perl module(s) installed:</b></p>
					        <blockquote>
					          <p><strong>$lwp_notice $httprequest_notice $cryptssl_notice</strong></p>
				            </blockquote>
					        <p> To use Paypal you will need to  install the above mentioned Perl module(s). If you are on a shared host then send an email to your web host and ask them to install the module(s) for you or ask them how you should go about the install the module(s). If this is your own server then install the above mentioned modules.</p>			          </td>
				        </tr>
 		</table>
		];
		
		pseek::display_error("Error: Your web host or web server does not have the following Perl module(s) installed:", $module_warning);
		exit;

	
	}

}




#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

