#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use frc4;

use LWP::UserAgent;
use HTTP::Request::Common qw(GET);
use Crypt::SSLeay;

use URI::Escape;
  

&get_setup;
fmspm::check_spamb("addurlpp2.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";
if ($q->param('asd') eq "") { pseek::display_error("Critical Error", "Invalid PayPal Data addurlpp2.cgi"); exit; }


###### Get asd Settings

$asd = $q->param('asd');
$tdecode = &RC4(&hex2string($asd),$password);  # Dec Message
@sitems = split (/\&/, $tdecode);

foreach $item (@sitems)
	{
		($key, $val) = split (/\=/, $item);
		$fields{$key} = $val;
	}

#$fields{'customform'}
#print "-->LNKID: $fields{'linkid'}<br> PRICE: $fields{'price'}<BR> OPT: $fields{'optionchosen'}";



if ($fields{'customform'} ne "")
	{
		$conf_file = "$data_dir/addmod_" . $fields{'customform'} . ".dat";
		$conf_file_data = pseek::get_file_contents($conf_file);
		@paypsettings = split (/\n/, $conf_file_data);
		$paypalmode  = $paypsettings[11];
	}
	else
	{
		$premsettings = pseek::get_file_contents("$data_dir/prem.cfg");
		@pconfig = split (/\n/, $premsettings);
		$paypalmode = $pconfig[8];
	}


##### exit if no mode
if ($paypalmode eq "") { pseek::display_error("Custom Premium Add URL form not configured", "To configure go to the Control Panel >> Settings >> Extra Add URL / Modify Forms >> Click Settings Next to '$fields{'customform'}'"); exit;  }


if ($paypalmode eq "sandbox")
	{
	$paypalvers = "85.0-2512177";
	$paypal_URL = "https://api-3t.sandbox.paypal.com/nvp";
	$paypal_PROCESS = "https://www.sandbox.paypal.com/webscr?cmd=_express-checkout&token=";
	}
	else
	{
	$paypalvers = "85.0-2512177";
	$paypal_URL = "https://api-3t.paypal.com/nvp";
	$paypal_PROCESS = "https://www.paypal.com/webscr?cmd=_express-checkout&token=";
	}

&start; 

#################







sub start
{


##### GET PAYPAL SETTINGS & LISTING SETTINGS

if ($fields{'customform'} eq "") ### if not custom add url form
{
	$pdset = pseek::get_file_contents("$data_dir/paypalset.dat");
	@ppsettings = split (/\n/, $pdset);

		$usepaypal = $ppsettings[0];
		$paypaluser = $ppsettings[1];
		$paypalpass = $ppsettings[2];
		$paypalsign = $ppsettings[3];
		$pcurrency = $ppsettings[4];
		$pitemname = $ppsettings[5];

	$expset = pseek::get_file_contents("$data_dir/pexpiryopt.dat");
	@expsettings = split (/\n/, $expset);

	$setline = $expsettings[$fields{'optionchosen'}];
	# usdprice / premium_expire_days / premium_orderform_url / standard_orderform_url
	($usdprice, $prem_exp_days, $prem1tmp, $prem2tmp) = split (/::/, $setline);
}
else ### if custom form
{
	# from @paypsettings
	$usepaypal  = $paypsettings[7];
	$paypaluser = $paypsettings[8];
	$paypalpass = $paypsettings[9];
	$paypalsign = $paypsettings[10];
	$pcurrency = $paypsettings[42];
	$pitemname = $paypsettings[43];

	$expsettings[0] = $paypsettings[12] . "::" .  $paypsettings[13] . "::" .  $paypsettings[14] . "::";
	$expsettings[1] = $paypsettings[15] . "::" .  $paypsettings[16] . "::" .  $paypsettings[17] . "::";
	$expsettings[2] = $paypsettings[18] . "::" .  $paypsettings[19] . "::" .  $paypsettings[20] . "::";
	$expsettings[3] = $paypsettings[21] . "::" .  $paypsettings[22] . "::" .  $paypsettings[23] . "::";
	$expsettings[4] = $paypsettings[24] . "::" .  $paypsettings[25] . "::" .  $paypsettings[26] . "::";
	$expsettings[5] = $paypsettings[27] . "::" .  $paypsettings[28] . "::" .  $paypsettings[29] . "::";
	$expsettings[6] = $paypsettings[30] . "::" .  $paypsettings[31] . "::" .  $paypsettings[32] . "::";
	$expsettings[7] = $paypsettings[33] . "::" .  $paypsettings[34] . "::" .  $paypsettings[35] . "::";
	$expsettings[8] = $paypsettings[36] . "::" .  $paypsettings[37] . "::" .  $paypsettings[38] . "::";
	$expsettings[9] = $paypsettings[39] . "::" .  $paypsettings[40] . "::" .  $paypsettings[41] . "::";

	$setline = $expsettings[$fields{'optionchosen'}];
	# usdprice / premium_expire_days / premium_orderform_url / standard_orderform_url
	($usdprice, $prem_exp_days, $prem1tmp, $prem2tmp) = split (/::/, $setline);
	
	$custom_urlform = "&customform=$fields{'customform'}";
}



###### RETURN URL

$retvalues = "linkid=$fields{'linkid'}&price=$fields{'price'}&optionchosen=$fields{'optionchosen'}" . $custom_urlform;
$retvalues = frc4::string2hex(&RC4($retvalues,$password));

$return_url = "$script_url/addurlpp3.cgi?asd=$retvalues";


### If cancel pressed 
$gsettings = new_gsettings tseek;
if ($gsettings->{addurl_reg_system} ne "Yes") ### If reg system not in use
	{	
		$topvar = pseek::get_file_contents("$data_dir/frontlink.dat"); 
		$return_fail = "$topvar";
	}
	else ### If reg system in use
	{
		$return_fail = "$script_url/rgs_login.cgi";
	}



##### DO PAYPAL
#print "<BR><BR> paypaluser = $paypaluser<BR>";
#print "paypalpass = $paypalpass<BR>";
#print "paypalsign = $paypalsign<BR>";
#print "paypalvers = $paypalvers<BR>";
#print "usdprice = $usdprice<BR>";
#print "days = $prem_exp_days<BR>";
#print "custom form = $custom_urlform<br>";
#print "return_url = $return_url<BR>";
#print "return_fail = $return_fail<BR>";
#exit;

my $ua = LWP::UserAgent->new;

if ($pcurrency eq "") { $pcurrency = "USD"; }
if ($pitemname eq "") { $pitemname = "Premium Listing"; }

my $response = $ua->post($paypal_URL, 
			{
				'USER' => $paypaluser, 
				'PWD' => $paypalpass, 
				'SIGNATURE' => $paypalsign, 
				'VERSION' => $paypalvers, 
				'PAYMENTREQUEST_0_PAYMENTACTION' => 'Sale', 
				'PAYMENTREQUEST_0_AMT' => $usdprice, 
				'PAYMENTREQUEST_0_CURRENCYCODE' => $pcurrency,
				'RETURNURL' => $return_url, 
				'CANCELURL' => $return_fail, 
				'METHOD' => 'SetExpressCheckout',
				
				'L_PAYMENTREQUEST_0_NAME0' => $pitemname,
				'L_PAYMENTREQUEST_0_QTY0' => 1,
				'L_PAYMENTREQUEST_0_AMT0' => $usdprice
			}
			); 

#PAYMENTREQUEST_0_AMT = "AMOUNT!";
 
if ($response->is_success) 
	{
      $respons_string = $response->decoded_content();
      @respitems = split (/\&/, $respons_string);
      
      foreach $item (@respitems)
      	{
      		($key, $val) = split (/\=/, $item);
				$fields{$key} = $val;
				$fields{$key} = uri_unescape($fields{$key});
      	}
		
		
			if ($fields{'ACK'} ne "Success")
				{
					$module_warning = qq[
						<table width="94%"  align="center">
						<tr class="normaltext">
						<td valign="top">
						<p>Error Code: <strong>$fields{'L_ERRORCODE0'}<br>
						</strong>$fields{'L_SHORTMESSAGE0'} <br>
						<strong>$fields{'L_LONGMESSAGE0'} </strong></p></td>
						</tr>
						</table>
					];
					pseek::display_error("Critical PayPal Error", $module_warning);
					exit;
				}
				else ### PayPal Success
				{
					$paypal_PROCESS = $paypal_PROCESS . $fields{'TOKEN'};
					
					print qq[
						<html>
						<head>
						<title></title>
						<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$paypal_PROCESS">
						</head>
						<body>
						</body>
						</html>
					]; 
					exit;
				}
		
   }
 	else 
 	{
     die $response->status_line;
  	}


}




#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

