#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use frc4;

use LWP::UserAgent;
use HTTP::Request::Common qw(GET);
use Crypt::SSLeay;

use URI::Escape;
  

&get_setup;
fmspm::check_spamb("addurlpp3.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";
if ($q->param('asd') eq "") { pseek::display_error("Critical Error", "Invalid PayPal Data addurlpp3.cgi"); exit; }


###### Get asd Settings

$asd = $q->param('asd');
$tdecode = &RC4(&hex2string($asd),$password);  # Dec Message
@sitems = split (/\&/, $tdecode);

foreach $item (@sitems)
	{
		($key, $val) = split (/\=/, $item);
		$fields{$key} = $val;
	}

#$fields{'customform'}
#print "-->LNKID: $fields{'linkid'}<br> PRICE: $fields{'price'}<BR> OPT: $fields{'optionchosen'}";


if ($fields{'customform'} ne "")
	{
		$conf_file = "$data_dir/addmod_" . $fields{'customform'} . ".dat";
		$conf_file_data = pseek::get_file_contents($conf_file);
		@paypsettings = split (/\n/, $conf_file_data);
		$paypalmode  = $paypsettings[11];
	}
	else
	{
		$premsettings = pseek::get_file_contents("$data_dir/prem.cfg");
		@pconfig = split (/\n/, $premsettings);
		$paypalmode = $pconfig[8];
	}


##### exit if no mode
if ($paypalmode eq "") { pseek::display_error("Custom Premium Add URL form not configured", "To configure go to the Control Panel >> Settings >> Extra Add URL / Modify Forms >> Click Settings Next to '$fields{'customform'}'"); exit;  }


if ($paypalmode eq "sandbox")
	{
	$paypalvers = "85.0-2512177";
	$paypal_URL = "https://api-3t.sandbox.paypal.com/nvp";
	$paypal_PROCESS = "https://www.sandbox.paypal.com/webscr?cmd=_express-checkout&token=";
	}
	else
	{
	$paypalvers = "85.0-2512177";
	$paypal_URL = "https://api-3t.paypal.com/nvp";
	$paypal_PROCESS = "https://www.paypal.com/webscr?cmd=_express-checkout&token=";
	}

&start; 




#################

sub start
{

if ($fields{'linkid'} eq "") { pseek::display_error("Critical PayPal Error: LinkID Error:", "Invalid data obtained from PayPal"); }
$lnkid = $fields{'linkid'};


##### GET PAYPAL SETTINGS & LISTING SETTINGS

if ($fields{'customform'} eq "") ### if not custom add url form
{
	$pdset = pseek::get_file_contents("$data_dir/paypalset.dat");
	@ppsettings = split (/\n/, $pdset);

		$usepaypal = $ppsettings[0];
		$paypaluser = $ppsettings[1];
		$paypalpass = $ppsettings[2];
		$paypalsign = $ppsettings[3];
		$pcurrency = $ppsettings[4];

	$expset = pseek::get_file_contents("$data_dir/pexpiryopt.dat");
	@expsettings = split (/\n/, $expset);

	$setline = $expsettings[$fields{'optionchosen'}];
	# usdprice / premium_expire_days / premium_orderform_url / standard_orderform_url
	($usdprice, $prem_exp_days, $prem1tmp, $prem2tmp) = split (/::/, $setline);
}
else
{
	# from @paypsettings
	$usepaypal  = $paypsettings[7];
	$paypaluser = $paypsettings[8];
	$paypalpass = $paypsettings[9];
	$paypalsign = $paypsettings[10];
	$pcurrency = $paypsettings[42];

	$expsettings[0] = $paypsettings[12] . "::" .  $paypsettings[13] . "::" .  $paypsettings[14] . "::";
	$expsettings[1] = $paypsettings[15] . "::" .  $paypsettings[16] . "::" .  $paypsettings[17] . "::";
	$expsettings[2] = $paypsettings[18] . "::" .  $paypsettings[19] . "::" .  $paypsettings[20] . "::";
	$expsettings[3] = $paypsettings[21] . "::" .  $paypsettings[22] . "::" .  $paypsettings[23] . "::";
	$expsettings[4] = $paypsettings[24] . "::" .  $paypsettings[25] . "::" .  $paypsettings[26] . "::";
	$expsettings[5] = $paypsettings[27] . "::" .  $paypsettings[28] . "::" .  $paypsettings[29] . "::";
	$expsettings[6] = $paypsettings[30] . "::" .  $paypsettings[31] . "::" .  $paypsettings[32] . "::";
	$expsettings[7] = $paypsettings[33] . "::" .  $paypsettings[34] . "::" .  $paypsettings[35] . "::";
	$expsettings[8] = $paypsettings[36] . "::" .  $paypsettings[37] . "::" .  $paypsettings[38] . "::";
	$expsettings[9] = $paypsettings[39] . "::" .  $paypsettings[40] . "::" .  $paypsettings[41] . "::";

	$setline = $expsettings[$fields{'optionchosen'}];
	# usdprice / premium_expire_days / premium_orderform_url / standard_orderform_url
	($usdprice, $prem_exp_days, $prem1tmp, $prem2tmp) = split (/::/, $setline);
	
	#$custom_urlform = "&customform=$fields{'customform'}";
}


##### DO PAYPAL

$ptoken = $q->param('token');

my $ua = LWP::UserAgent->new;

my $response = $ua->post($paypal_URL, 
			{
				'USER' => $paypaluser, 
				'PWD' => $paypalpass, 
				'SIGNATURE' => $paypalsign, 
				'VERSION' => $paypalvers, 
				'TOKEN' => $ptoken, 
				'METHOD' => 'GetExpressCheckoutDetails' 
			}
			); 



##### PAYMENTREQUEST_0_AMT = "AMOUNT!";
 
if ($response->is_success) 
	{
      $respons_string = $response->decoded_content();
      @respitems = split (/\&/, $respons_string);
      
      foreach $item (@respitems)
      	{
      		($key, $val) = split (/\=/, $item);
				$fields{$key} = $val;
				$fields{$key} = uri_unescape($fields{$key});
      	}
		
		
			if ($fields{'ACK'} ne "Success")
				{
					$module_warning = qq[
						<table width="94%"  align="center">
						<tr class="normaltext">
						<td valign="top">
						<p>Error Code: <strong>$fields{'L_ERRORCODE0'}<br>
						</strong>$fields{'L_SHORTMESSAGE0'} <br>
						<strong>$fields{'L_LONGMESSAGE0'} </strong></p></td>
						</tr>
						</table>
					];
					pseek::display_error("Critical PayPal Error: GetExpressCheckoutDetails", $module_warning);
					exit;
				}
				else ### PayPal Success
				{	
				
					$PAYERID = $fields{'PAYERID'};
				
					if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
					$dbh = DBI->connect($dsn, $db_username, $db_password);
					if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
					
						$fields{'TIMESTAMP'} = $dbh->quote($fields{'TIMESTAMP'});
						$fields{'CORRELATIONID'} = $dbh->quote($fields{'CORRELATIONID'});
						$fields{'TOKEN'} = $dbh->quote($fields{'TOKEN'});
						$fields{'EMAIL'} = $dbh->quote($fields{'EMAIL'});
						$fields{'PAYERID'} = $dbh->quote($fields{'PAYERID'});
						$fields{'PAYERSTATUS'} = $dbh->quote($fields{'PAYERSTATUS'});
						$fields{'FIRSTNAME'} = $dbh->quote($fields{'FIRSTNAME'});
						$fields{'LASTNAME'} = $dbh->quote($fields{'LASTNAME'});
						$fields{'COUNTRYCODE'} = $dbh->quote($fields{'COUNTRYCODE'});
						$fields{'BUSINESS'} = $dbh->quote($fields{'BUSINESS'});
						$fields{'PAYMENTREQUEST_0_SHIPTONAME'} = $dbh->quote($fields{'PAYMENTREQUEST_0_SHIPTONAME'});
						$fields{'PAYMENTREQUEST_0_SHIPTOSTREET'} = $dbh->quote($fields{'PAYMENTREQUEST_0_SHIPTOSTREET'});
						$fields{'PAYMENTREQUEST_0_SHIPTOCITY'} = $dbh->quote($fields{'PAYMENTREQUEST_0_SHIPTOCITY'});
						$fields{'PAYMENTREQUEST_0_SHIPTOSTATE'} = $dbh->quote($fields{'PAYMENTREQUEST_0_SHIPTOSTATE'});
						$fields{'PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE'} = $dbh->quote($fields{'PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE'});
						$fields{'PAYMENTREQUEST_0_SHIPTOCOUNTRYNAME'} = $dbh->quote($fields{'PAYMENTREQUEST_0_SHIPTOCOUNTRYNAME'});
						$fields{'PAYMENTREQUEST_0_SHIPTOZIP'} = $dbh->quote($fields{'PAYMENTREQUEST_0_SHIPTOZIP'});
						$fields{'PAYMENTREQUEST_0_ADDRESSID'} = $dbh->quote($fields{'PAYMENTREQUEST_0_ADDRESSID'});
						$fields{'PAYMENTREQUEST_0_ADDRESSSTATUS'} = $dbh->quote($fields{'PAYMENTREQUEST_0_ADDRESSSTATUS'});

						$sql = "INSERT INTO paypalpremium SET 	lnkid = '$fields{'linkid'}',
																			TIMESTAMP = $fields{'TIMESTAMP'},
																			CORRELATIONID = $fields{'CORRELATIONID'},
																			TOKEN = $fields{'TOKEN'},
																			EMAIL = $fields{'EMAIL'},
																			PAYERID = $fields{'PAYERID'},
																			PAYERSTATUS = $fields{'PAYERSTATUS'},
																			FIRSTNAME = $fields{'FIRSTNAME'},
																			LASTNAME = $fields{'LASTNAME'},
																			COUNTRYCODE = $fields{'COUNTRYCODE'},
																			BUSINESS = $fields{'BUSINESS'},
																			PAYMENTREQUEST_0_SHIPTONAME = $fields{'PAYMENTREQUEST_0_SHIPTONAME'},
																			PAYMENTREQUEST_0_SHIPTOSTREET = $fields{'PAYMENTREQUEST_0_SHIPTOSTREET'},
																			PAYMENTREQUEST_0_SHIPTOCITY = $fields{'PAYMENTREQUEST_0_SHIPTOCITY'},
																			PAYMENTREQUEST_0_SHIPTOSTATE = $fields{'PAYMENTREQUEST_0_SHIPTOSTATE'},
																			PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE = $fields{'PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE'},
																			PAYMENTREQUEST_0_SHIPTOCOUNTRYNAME = $fields{'PAYMENTREQUEST_0_SHIPTOCOUNTRYNAME'},
																			PAYMENTREQUEST_0_SHIPTOZIP = $fields{'PAYMENTREQUEST_0_SHIPTOZIP'},
																			PAYMENTREQUEST_0_ADDRESSID = $fields{'PAYMENTREQUEST_0_ADDRESSID'},
																			PAYMENTREQUEST_0_ADDRESSSTATUS = $fields{'PAYMENTREQUEST_0_ADDRESSSTATUS'}
																			";
				
						$sth = $dbh->prepare($sql);
						$sth->execute;
						$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	
						
						$sth= $dbh->prepare("SELECT transid FROM paypalpremium WHERE transid = LAST_INSERT_ID()");
						$sth->execute;
						$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
						while ( @row = $sth->fetchrow() ) { $transid = $row[0]; }  
						
					$sth->finish;
					$dbh->disconnect;
					
				}
		
   }
 	else 
 	{
     die $response->status_line;
  	}


###########  

$PAYMENTREQUEST_0_AMT = $fields{'price'};

my $ua = LWP::UserAgent->new;

########'PAYMENTREQUEST_0_PAYMENTACTION' => 'Authorization', 

#PAYMENTREQUEST_0_CURRENCYCODE=currencyID
#https://cms.paypal.com/us/cgi-bin/?cmd=_render-content&content_ID=developer/e_howto_api_nvp_currency_codes
#pg 20 of docs

if ($pcurrency eq "") { $pcurrency = "USD"; }

my $response = $ua->post($paypal_URL, 
			{
				'USER' => $paypaluser, 
				'PWD' => $paypalpass, 
				'SIGNATURE' => $paypalsign, 
				'VERSION' => $paypalvers, 
				'PAYMENTREQUEST_0_PAYMENTACTION' => 'Sale', 
				'PAYERID' => $PAYERID, 
				'TOKEN' => $ptoken, 
				'PAYMENTREQUEST_0_AMT' => $PAYMENTREQUEST_0_AMT, 
				'METHOD' => 'DoExpressCheckoutPayment',
				'PAYMENTREQUEST_0_CURRENCYCODE' => $pcurrency
			}
			); 


if ($response->is_success) 
	{
	
      $respons_string = $response->decoded_content();
      @respitems = split (/\&/, $respons_string);
      
      foreach $item (@respitems)
      	{
      		($key, $val) = split (/\=/, $item);
				$fields{$key} = $val;
				$fields{$key} = uri_unescape($fields{$key});
      	}
		
		
		if ($fields{'ACK'} ne "Success")
		{
			$module_warning = qq[
				<table width="94%"  align="center">
				<tr class="normaltext">
				<td valign="top">
				<p>Error Code: <strong>$fields{'L_ERRORCODE0'}<br>
				</strong>$fields{'L_SHORTMESSAGE0'} <br>
				<strong>$fields{'L_LONGMESSAGE0'} </strong></p></td>
				</tr>
				</table>
			];
			pseek::display_error("Critical PayPal Error: DoExpressCheckoutPayment", $module_warning);
			exit;
   	}
 		else 
 		{
   	  
   	  ####### $transid
   	  
   	  	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		   $dbh = DBI->connect($dsn, $db_username, $db_password);
		  	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
		  					
						$fields{'TIMESTAMP'} = $dbh->quote($fields{'TIMESTAMP'});
						$fields{'CORRELATIONID'} = $dbh->quote($fields{'CORRELATIONID'});
						$fields{'TOKEN'} = $dbh->quote($fields{'TOKEN'});
						$fields{'PAYMENTREQUEST_0_TRANSACTIONID'} = $dbh->quote($fields{'PAYMENTREQUEST_0_TRANSACTIONID'});
						$fields{'PAYMENTREQUEST_0_TRANSACTIONTYPE'} = $dbh->quote($fields{'PAYMENTREQUEST_0_TRANSACTIONTYPE'});
						$fields{'PAYMENTREQUEST_0_PAYMENTTYPE'} = $dbh->quote($fields{'PAYMENTREQUEST_0_PAYMENTTYPE'});
						$fields{'PAYMENTREQUEST_0_ORDERTIME'} = $dbh->quote($fields{'PAYMENTREQUEST_0_ORDERTIME'});

						$fields{'PAYMENTREQUEST_0_AMT'} = $dbh->quote($fields{'PAYMENTREQUEST_0_AMT'});
						$fields{'PAYMENTREQUEST_0_CURRENCYCODE'} = $dbh->quote($fields{'PAYMENTREQUEST_0_CURRENCYCODE'});
						$fields{'PAYMENTREQUEST_0_TAXAMT'} = $dbh->quote($fields{'PAYMENTREQUEST_0_TAXAMT'});
						$fields{'PAYMENTREQUEST_0_PAYMENTSTATUS'} = $dbh->quote($fields{'PAYMENTREQUEST_0_PAYMENTSTATUS'});
						$fields{'PAYMENTREQUEST_0_PENDINGREASON'} = $dbh->quote($fields{'PAYMENTREQUEST_0_PENDINGREASON'});
						$fields{'PAYMENTREQUEST_0_REASONCODE'} = $dbh->quote($fields{'PAYMENTREQUEST_0_REASONCODE'});

						$sql = "UPDATE paypalpremium SET		A_TIMESTAMP = $fields{'TIMESTAMP'},
																		A_CORRELATIONID = $fields{'CORRELATIONID'},
																		A_TOKEN = $fields{'TOKEN'},
																		A_PAYMENTREQUEST_0_TRANSACTIONID = $fields{'PAYMENTREQUEST_0_TRANSACTIONID'},
																		A_PAYMENTREQUEST_0_TRANSACTIONTYPE = $fields{'PAYMENTREQUEST_0_TRANSACTIONTYPE'},
																		A_PAYMENTREQUEST_0_PAYMENTTYPE = $fields{'PAYMENTREQUEST_0_PAYMENTTYPE'},
																		A_PAYMENTREQUEST_0_ORDERTIME = $fields{'PAYMENTREQUEST_0_ORDERTIME'},
																		A_PAYMENTREQUEST_0_AMT = $fields{'PAYMENTREQUEST_0_AMT'},
																		A_PAYMENTREQUEST_0_CURRENCYCODE = $fields{'PAYMENTREQUEST_0_CURRENCYCODE'},
																		A_PAYMENTREQUEST_0_TAXAMT = $fields{'PAYMENTREQUEST_0_TAXAMT'},
																		A_PAYMENTREQUEST_0_PAYMENTSTATUS = $fields{'PAYMENTREQUEST_0_PAYMENTSTATUS'},
																		A_PAYMENTREQUEST_0_PENDINGREASON = $fields{'PAYMENTREQUEST_0_PENDINGREASON'},
																		A_PAYMENTREQUEST_0_REASONCODE = $fields{'PAYMENTREQUEST_0_REASONCODE'},
																		paymentcomplete = 'Y'

																	WHERE transid = '$transid'";
				
						$sth = $dbh->prepare($sql);
						$sth->execute;
						$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	

						$timep = time();
						$expire_seconds = $prem_exp_days * 86400;
						$expire_seconds = $expire_seconds + $timep;

						$sql = "UPDATE links SET 	premium = '1', 
															subs_expire = '$expire_seconds'
															WHERE lnkid = '$lnkid'
															";
						$sth = $dbh->prepare($sql);
						$sth->execute;
						$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}				

						
  			$sth->finish;
			$dbh->disconnect;
   	  
   	  ##################


			$gsettings = new_gsettings tseek;
			
			###### If reg system not in use
			if ($gsettings->{addurl_reg_system} ne "Yes") 
				{	
					$paypalthanks = pseek::get_file_contents("$data_dir/reg_success_paypal.html");
					if ($paypalthanks eq "") { $paypalthanks = pseek::get_file_contents("$data_dir/add_url_success.html"); } 
				}
			####### If reg system in use
			else 
				{
					$paypalthanks = pseek::get_file_contents("$data_dir/rgs_regsuccess_paypal.html");
					if ($paypalthanks eq "") { $paypalthanks = pseek::get_file_contents("$data_dir/rgs_add_url_success.html"); } 
				}


   	  
   	  
   	  	$paypalthanks = pseek::ts_insert_template_includes($paypalthanks);
		  	$paypalthanks = pseek::fill_vars($paypalthanks); 
			print $paypalthanks;
   	   exit;
   	  
  		}
  		
  	}
  	else
  	{
  	  die $response->status_line;
  	}


}




#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


