#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use acs;
use IO::Socket;
use fmunpack;

$upgrade_cgi_version = "PowerSeek SQL 6.0.3";

eval 'use Image::Magick;';
if ($@ ne "") { $IM = "false"; } else { $IM = "true"; }

eval 'use Image::Resize;';
if ($@ ne "") { $IMRES = "false"; } else { $IMRES = "true"; }


$q = CGI->new;
&get_setup;



acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################
if ($q->param('fct') eq "logoff") {&logoff;}

print "Content-type: text/html\n\n";
if ($q->param('upgrade') ne "") {&upgrade;}
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "upgrades") {&upgrades;}
if ($q->param('fct') eq "conf") {&conf;}
if ($q->param('fct') eq "setpass") {&setpass;}
if ($q->param('fct') eq "notes") {&anotes;}
if ($q->param('fct') eq "savenotes") {&savenotes;}
if ($q->param('fct') eq "logintime") {&logintime;}


#### GET CONFIGURATION #######################################################

sub logintime
{

open (RLA, "> $data_dir/relogin.dat");
print RLA $q->param('remember');
close (RLA);

$hbox = acs::get_heading_box("$web_url/ic_gear.gif", "Login time saved", "Your login will be remembered for the time you specified, next time you login. <br><a href='admin.cgi?fct=conf'>Click Here to continue</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];


}



sub setpass
{

if ((-w $config_cgi) < 1) 	
	{
	$boxdiz = qq[
	At present PowerSeek is unable to update the PowerSeek configuration to accept the user name and password changes.
	To solve the problem FTP into your hosting account and change the file permission setting of:<BR>
	<b>$admin_url/config.cgi</b><BR>	
	to 777 so that PowerSeek can modify it with the new user name and password changes.
	<BR><BR>
	You can normally change the file permission setting of a file by right clicking on it with your FTP program.
	<BR><BR>
	<b><a href="" onClick="history.go(-1); return false;">Go Back</a></b>
	];
	
	$hbox = acs::get_heading_box("$web_url/ic_gear.gif", "config.cgi is not writable", $boxdiz);
 
print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

exit;
}
 

if ($q->param('psusern') eq "") { acs::problem_popup("You have to supply a User Name for the Control Panel"); }
if ($q->param('pspass1') eq "") { acs::problem_popup("You have to supply a Password for the Control Panel"); }
if ($q->param('pspass2') eq "") { acs::problem_popup("You have to supply a Verify Password for the Control Panel"); }

if ($q->param('pspass1') ne $q->param('pspass2')) { acs::problem_popup("The two passwords you specified do not match."); }

$boxdiz = qq[
Note that you will need to log into the PowerSeek Control Panel with the new user name and password.<BR>
<a href="javascript:onClick=window.close()">Close this Window</a>
];

$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "User Name and Password Changed", $boxdiz);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
]; 


&write_var("USERNAME", $q->param('psusern'));
&write_var("PASSWORD", $q->param('pspass1'));




}



sub conf
{

$headingd = acs::get_heading_box("$web_url/ic_gear.gif", "PowerSeek Configuration & Paths", "Displaying the PowerSeek configuration information and set-up paths.");

if ($mysql_hostname eq "") { $mysql_hostname = "N/A"; }
if ($mysql_port eq "") { $mysql_port = "N/A"; }


if ($IM eq "true") { $im_magic = "Yes"; } else { $im_magic = "No"; }
if ($IMRES eq "true") { $im_resmod = "Yes"; } else { $im_resmod = "No"; }


$js_errors = acs::get_js_errors;

$submitstr = "pspass1::You have to provide a Password::pspass2::You have to provide a verify password.";



$remlogin = acs::get_file_contents("$data_dir/relogin.dat"); 

if ($remlogin eq "")
	{
	$rsel[1] = "selected";
	}
	else
	{
	$rsel[$remlogin] = "selected";
	}



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
$js_errors

<script LANGUAGE="JavaScript">

function checkd()
	{
	var ssf = check_errors_blank('$submitstr');
	if (ssf == false) { return false; }
	
	if (document.getElementById('pspass1').value != document.getElementById('pspass2').value) {alert ('The password you specified to not match'); return false; }
	}
</script>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>
<form name="form1" method="post" action="$admin_url/admin.cgi" onSubmit="return checkd();">
$headingd
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
    <tr class="bar7">
      <td class="normaltext" colspan="2"><strong>Control Panel Login Details:</strong></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Control Panel User Name:</strong></td>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$username</strong></font></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Control Panel Password:</strong></td>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>*********</strong></font></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Assign New User Name:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="psusern" type="text" id="psusern" value="$username"></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Assign new Control Panel Password:</strong></td>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><label>
        <input type="password" name="pspass1" id="pspass1">
      </label></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Verify Password: (Type the same password specified above again)</strong></td>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><input name="pspass2" type="password" id="pspass2"></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext">Note that if you change the user name and password that you will need to log into the PowerSeek Control Panel again with the new user name and password.</td>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><label>
        <input type="submit" class="psbutton" name="button" id="button" value="Assign New Password and User Name">
      </label>
        <input name="fct" type="hidden" id="fct" value="setpass"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
<form id="form2" name="form2" method="post" action="$admin_url/admin.cgi">
  <table width="100%"
height="46" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr class="bar7">
      <td class="normaltext" colspan="2"><strong>Login Time:</strong></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>How long should PowerSeek remember your Login:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><select name="remember" id="remember">
        <option value="0" $rsel[0]>Don't remember Login</option>
        <option value="1" $rsel[1]>24 Hours</option>
        <option value="2" $rsel[2]>1 Week</option>
        <option value="3" $rsel[3]>1 Month</option>
        <option value="4" $rsel[4]>3 Months</option>
        <option value="5" $rsel[5]>6 Months</option>
        <option value="6" $rsel[6]>1 Year</option>
      </select></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td width="50%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" name="button2" id="button2" value="   Apply    " class="psbutton" />
      <input name="fct" type="hidden" id="fct" value="logintime" /></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr class="bar7">
    <td class="normaltext" colspan="2"><strong>DataBase Details:</strong></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Database Name:</strong></td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$db_name</strong></font></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Database User Name:</strong></td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$db_username</strong></font></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Database Password:</strong></td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$db_password</strong></font></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Remote Host:</strong></td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$mysql_hostname</strong></font></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Remote Host Port:</strong></td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$mysql_port</strong></font></td>
  </tr>
</table>


<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>


<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr class="bar7">
    <td class="normaltext" colspan="2"><strong>URL Paths:</strong></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>General PowerSeek Script Files:<br>
    </strong>This is the URL location of where the PowerSeek Script files are located:</td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$script_url</strong></font></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Admin PowerSeek Script Files:<br>
    </strong>This is the URL location of where the PowerSeek Admin Script files are located:</td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$admin_url</strong></font></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Image &amp; File Generation
    Directory:<br>
    </strong>This is the URL location where all PowerSeek image files are stored and where
    PowerSeek places generated HTML files. (Also referred to as the 'HTML' directory in the
    installation instructions)</td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$web_url</strong></font></td>
  </tr>
</table>


<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>


<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr class="bar7">
    <td class="normaltext" colspan="2"><strong>Full Server Paths:</strong></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Image &amp; File Generation
    Directory:<br>
    </strong>This is the full server path where all PowerSeek image files are stored and where
    PowerSeek places generated HTML files. (Also referred to as the 'HTML' directory in the
    installation instructions)</td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$web_dir</strong></font></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Data Directory<br>
    </strong>This is the full server path to the Directory that holds PowerSeek's 'data'
    files. Templates, Settings, and other data are stored in PowerSeek's 'data' files.</td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$data_dir</strong></font></td>
  </tr>
</table>


<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr class="bar7">
    <td class="normaltext" colspan="2"><strong>Email Details:</strong></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Email Method:</strong></td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$mail_method</strong></font></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr class="bar7">
    <td class="normaltext" colspan="2"><strong>Image Resizing Perl Modules Installed:</strong></td>
  </tr>
  <tr>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><strong>Image Magick</strong></td>
    <td width="50%" bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$im_magic</strong></font></td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext"><strong>Image::Resize</strong></td>
    <td bgcolor="#FFFFFF" class="normaltext"><font color="#0000A0"><strong>$im_resmod</strong></font></td>
  </tr>
</table>



</body>
</html>
];



}





sub upgrades
{


### CHECK IF THERE IS A NEW VERSION OF POWERSEEK SQL AVAILABLE
($txt, $httpheader, $docdate, $server, $tmp, $cstatus) = &get_html_document ("http://www.focalmedia.net/cgi-bin/psmembers/upgrcheck.cgi?sr=$swr");


if ($cstatus eq "False")
	{
	
print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>
<br><br>
<table width="480" border="0" align="center" cellpadding="6" cellspacing="1">
  <tr>
    <td width="1%"><img src="$web_url/ic_gear.gif" width="55" height="55"></td>
    <td width="99%"><p class="normaltext12">
	 <strong>The connection to Focalmedia.net failed.</strong><br>
  This might be due to a firewall blocking outside connections from scripts on this host. It
  might also be due to network related problems where the route to FocalMedia.Net cannot be
  reached.
    <br><strong>Click here to <a href="javascript:onClick=window.close()">close</a> this window.</strong>
    </p></td>
  </tr>
</table>

</body>
</html>
];
exit;
	}

#######

@retlines = split (/\n/, $txt);
foreach $ritem (@retlines)
	{
	if ($ritem =~ /PowerSeek SQL/)
		{
		$latest_version = $ritem;
		}
	}

#######

if (($upgrade_cgi_version ne $latest_version) and ($latest_version ne ""))
	{
print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>

$headingd

<br><br>
<table width="480" border="0" align="center" cellpadding="6" cellspacing="1">
  <tr>
    <td width="1%"><img src="$web_url/ic_gear.gif" width="55" height="55"></td>
    <td width="99%"><p class="normaltext12"><strong>$latest_version </strong>is Now Available!<br>
        <a href="http://www.focalmedia.net/cgi-bin/psmembers/members.cgi" target="_blank">Click
        here to download the lastest version and to upgrade your copy</a></font></p>
      <p class="normaltext12">Upgrade instructions is available in the PowerSeek manual
    or you may also <a href="http://www.focalmedia.net/pseekmanual/pseek1.html#1_4"
  target="_blank">find it online here.</a>
  <br><strong>Click here to <a href="javascript:onClick=window.close()">close</a> this window.</strong>
  </p>
  </td>
  </tr>
</table>

</body>
</html>

];
	}
	else
	{


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>

<body>

$headingd

<br><br>
<table width="310" border="0" align="center" cellpadding="6" cellspacing="1">
  <tr>
    <td width="1%"><img src="$web_url/ic_gear.gif" width="55" height="55"></td>
    <td width="99%"><p class="normaltext12"><strong>Your current version is up to date!</strong><a href="http://www.focalmedia.net/pseekmanual/pseek1.html#1_4"
  target="_blank"></a>
  <br><strong>Click here to <a href="javascript:onClick=window.close()">close</a> this window.</strong>
  </p></td>
  </tr>
</table>


</body>
</html>
];
	
	
	}



}


sub logoff
{

my ($query, $thecookie1, $thecookie2, $scripts_admin);

$query = new CGI;

$thecookie1 = $query->cookie(-name=>'nuser',
			    					  -value=>'',
			    					  -expires=>'+1s',
			    					  -path=>'/');

$thecookie2 = $query->cookie(	-name=>'npass',
			    						-value=>'',
			    						-expires=>'+1s',
			    						-path=>'/');

print $query->header(-cookie=>[$thecookie1, $thecookie2]); 

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title></title>
<meta HTTP-EQUIV="REFRESH" CONTENT="3;URL=$admin_url/admin.cgi">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>
<p align="center"><strong><font face="Verdana" size="1">&nbsp;</font></strong></p>
<p align="center"><strong><font face="Verdana" size="1">&nbsp;</font></strong></p>
<p align="center"><strong><font face="Verdana" size="1">&nbsp;</font></strong></p>
<p align="center"><strong><font face="Verdana" size="1">&nbsp;</font></strong></p>
<p align="center"><strong><font size="1" face="Verdana" class="normaltext">Logging Off... Please wait...</font></strong></p>
</body>
</html>
];

exit;

}





sub start
{

### DO CHANGES IF UPGRADE TO VER 4 OR EARLIER VERSION

$exists = (-e "$data_dir/upg5.dat");
if ($exists < 1)
	{
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	
		$sql_query = "UPDATE links SET extf4 = ''";
		$sth = $dbh->prepare($sql_query);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_query";}

		$sql = 			  "CREATE TABLE IF NOT EXISTS advertgrp
								(
								groupid			int NOT NULL auto_increment,
								groupname		varchar(255) NOT NULL,
								maximp			int,
								expirdate		date,
								username			varchar(255),
								password			varchar(255),
								current_imp		int,
								current_clc    int,
								userchange		char(1),
								
								PRIMARY 	KEY(groupid),
								INDEX (groupname),
								INDEX (maximp),
								INDEX (expirdate),
								INDEX (username),
								INDEX (password)
								)";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 


		$sql = 			  "CREATE TABLE IF NOT EXISTS adverts
								(
								aid				int NOT NULL auto_increment,
								groupid			int,
								adname			varchar(255) NOT NULL,
								advert			text,
								weight			int,
								tracker1			varchar(255),
								trcclicks1		int,
								tracker2			varchar(255),
								trcclicks2		int,
								tracker3			varchar(255),
								trcclicks3		int,
								tracker4			varchar(255),
								trcclicks4		int,
								tracker5			varchar(255),
								trcclicks5		int,
								impres			int,
								PRIMARY 	KEY(aid),
								INDEX (groupid),
								INDEX (adname)
								)";

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	


		$sql = 			  "CREATE TABLE IF NOT EXISTS adlogs
								(
								logid				int NOT NULL auto_increment,
								aid				int,
								groupid			int,
								adate				date,
								impressions		int,
								clicks			int,

								PRIMARY 	KEY(logid),
								INDEX (aid),
								INDEX (groupid),
								INDEX (adate)
								)";

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	



		$sql = 			  "CREATE TABLE IF NOT EXISTS dpos
								(
								pid				int NOT NULL auto_increment,
								cid				int,
								cpos				int,

								PRIMARY 	KEY(pid),
								INDEX (cid),
								INDEX (cpos)
								)";

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	


		$sql = "CREATE TABLE IF NOT EXISTS exaddurl
							(
							id				int NOT NULL auto_increment,
							lnkid			int,
							formname		varchar(255),
							tmpwork		int,
							PRIMARY KEY(id),
							INDEX (lnkid), 
							INDEX (formname),
							INDEX (tmpwork)
							)"; 
								

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	

	
	$sth->finish;
	$dbh->disconnect;

	
	open (EXF, "> $data_dir/upg5.dat");
		print EXF "Complete!";
	close (EXF);
	}

###################################


$exists = (-e "$data_dir/upg6.dat");
if ($exists < 1)
	{
		if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		$dbh = DBI->connect($dsn, $db_username, $db_password);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

		$sth = $dbh->prepare("SHOW COLUMNS FROM lnkusers");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	
	
		while ( @row = $sth->fetchrow() )
			{
			if ($row[0] eq "fbid") { $foundfpid = "true"; }
			}
	
		if ($foundfpid ne "true")
			{
			$sth = $dbh->prepare("ALTER TABLE lnkusers ADD fbid INT, ADD INDEX (fbid)");
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	
			}
	
		########### 
		
			$foundfpid = "";
			$sth = $dbh->prepare("SHOW TABLES");
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	

				while ( @row = $sth->fetchrow() )
					{
					if ($row[0] eq "paypalpremium") { $foundfpid = "true"; }
					if ($row[0] eq "addurliplog") { $foundiplog = "true"; }
					}

			if ($foundfpid ne "true")
				{

					$sql = "CREATE TABLE paypalpremium
											(
											transid				int NOT NULL auto_increment,
											lnkid					int,
											userid				int,
											TIMESTAMP			date,
											CORRELATIONID		varchar(255),
											TOKEN					varchar(255),
											EMAIL					varchar(255),
											PAYERID				varchar(255),
											PAYERSTATUS			varchar(255),
											FIRSTNAME			varchar(255),
											LASTNAME				varchar(255),
											COUNTRYCODE			varchar(255),
											BUSINESS				varchar(255),
											PAYMENTREQUEST_0_SHIPTONAME				varchar(255),
											PAYMENTREQUEST_0_SHIPTOSTREET				varchar(255),
											PAYMENTREQUEST_0_SHIPTOCITY				varchar(255),
											PAYMENTREQUEST_0_SHIPTOSTATE				varchar(255),
											PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE		varchar(255),
											PAYMENTREQUEST_0_SHIPTOCOUNTRYNAME		varchar(255),
											PAYMENTREQUEST_0_SHIPTOZIP					varchar(255),
											PAYMENTREQUEST_0_ADDRESSID					varchar(255),
											PAYMENTREQUEST_0_ADDRESSSTATUS			varchar(255),

											A_TIMESTAMP				date,
											A_CORRELATIONID		varchar(255),
											A_TOKEN					varchar(255),
											A_PAYMENTREQUEST_0_TRANSACTIONID			varchar(255),
											A_PAYMENTREQUEST_0_TRANSACTIONTYPE		varchar(255),
											A_PAYMENTREQUEST_0_PAYMENTTYPE			varchar(255),
											A_PAYMENTREQUEST_0_ORDERTIME				varchar(255),
											A_PAYMENTREQUEST_0_AMT						varchar(255),
											A_PAYMENTREQUEST_0_CURRENCYCODE			varchar(255),
											A_PAYMENTREQUEST_0_TAXAMT					varchar(255),
											A_PAYMENTREQUEST_0_PAYMENTSTATUS			varchar(255),
											A_PAYMENTREQUEST_0_PENDINGREASON			varchar(255),
											A_PAYMENTREQUEST_0_REASONCODE				varchar(255),
											paymentcomplete								varchar(1),

											ext1	varchar(255),
											ext2	varchar(255),
											ext3	varchar(255),
											ext4	varchar(255),
											ext5	varchar(255),

											PRIMARY KEY(transid),	
											INDEX (lnkid), 
											INDEX (userid), 
											INDEX (EMAIL),
											INDEX (PAYERID),
											INDEX (paymentcomplete)
											)";

					$sth = $dbh->prepare($sql);
					$sth->execute;
					$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}  
				}


			if ($foundiplog ne "true")
				{
				$sql = "CREATE TABLE addurliplog
									(
									ipid					int NOT NULL auto_increment,
									lnkid					int,
									ip						varchar(255),
									hostname				varchar(255),
									rem_ident			varchar(255),
									http_user_agent	varchar(255),
									http_referer		varchar(255),
									
									PRIMARY KEY(ipid),
									INDEX (lnkid), 
									INDEX (ip)
									)";

				$sth = $dbh->prepare($sql);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}  
				}

		########## Indexes for reviews table
		

		$sth = $dbh->prepare("SHOW INDEX FROM reviews");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}			
	
		while ( @row = $sth->fetchrow() )
			{
				if ($row[2] eq "rname") { $found_findexes = "true"; }
			}
	
		
		if ($found_findexes ne "true")
			{
			$sql = "CREATE INDEX rname ON reviews (rname)";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}			

			$sql = "CREATE INDEX remail ON reviews (remail)";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}			

			$sql = "CREATE INDEX review ON reviews (review(100))";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}			
			
			$sql = "ALTER TABLE reviews ADD FULLTEXT (rname,remail,review)";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}			
			}
		
				
	
		$sth->finish;
		$dbh->disconnect;
		
	open (EXF, "> $data_dir/upg6.dat");
		print EXF "Complete!";
	close (EXF);
}



$temp = $ENV{'QUERY_STRING'};
if ($temp =~ /upgrade/) 
{
	&upgrade2; exit;
}



###################################

if ($config_cgi ne "../config.cgi")
{
$nlck = $config_cgi;
$nlck =~ s/config\.cgi/admin\/unlock\.cgi/gi;
}
else
{
$nlck = "unlock.cgi";
}



if ((-e "$data_dir/flcontrol") > 0)
	{

	opendir(DIR,"$data_dir/flcontrol");
	@files = readdir(DIR);
	foreach $filename (@files)
		{
			if (($filename ne ".") and ($filename ne ".."))
			{
				unlink ("$data_dir/flcontrol/$filename");
			}
		}

	}
	
	
	

if ((-e $nlck) < 1)
	{
$rg = qq[
<table border="0" cellspacing="1"
    width="95%" cellpadding="6" bgcolor="#C0C0C0" height="46">
      <tr>
        <td width="30%" bgcolor="#FFFFFF"><p align="center"><a
        href="http://www.focalmedia.net/order_options.html" target="_blank"><strong>Purchase PowerSeek</strong></a>
        <br>
        Upgrade to the commercial version and remove trial limitations.</td>
      </tr>
    </table>
    </center></div><div align="center"><center><table border="0" cellpadding="0"
    cellspacing="0" width="95%" background="$web_url/shadow.gif">
      <tr>
        <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
        <td width="99%"></td>
      </tr>
    </table>
];    

	}




#if (length($retlines[1]) > 20)
#	{
#	$rg = $rg . "$retlines[1]";
#	}

if ($swr eq ""){&upgrade2;}

$template = acs::get_template("HOME"); 




#if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
#$dbh = DBI->connect($dsn, $db_username, $db_password);
#if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$nowtime = time();


#$sql = "SELECT lnkid FROM links WHERE (premium > 0) AND (premium IS NOT NULL) AND (subs_expire < '$nowtime') AND (subs_expire IS NOT NULL) AND (subs_expire != '0')";
#$sth = $dbh->prepare($sql);
#$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

#while ( @row = $sth->fetchrow() )
#	{
#	print "--> $row[0]";
#	}

#$sql = "UPDATE links SET premium = '0' WHERE (premium > 0) AND (premium IS NOT NULL) AND (subs_expire < '$nowtime') AND (subs_expire IS NOT NULL) AND (subs_expire != '0')";
#$sth = $dbh->prepare($sql);
#$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

#$sth->finish;
#$dbh->disconnect; 




##### GET INSTALLATION STATUS

#$perms = sprintf "%04o", (stat("$config_cgi"))[2] & 0777; 
#if ($perms eq "0777")
#	{
#	$swarning1 = "<img src=\"$web_url/ic_exc.gif\">config.cgi is writable. Please set config.cgi to the permission setting of 755.<BR>";
#	}


$exists = (-e "setup.cgi");
if ($exists > 0)
	{
	$swarning2 = "<img src=\"$web_url/ic_exc.gif\">setup.cgi is present in your cgi-bin directory. Please delete it. Leaving it there creates a security hole.<BR>";
	}

$exists = (-e "upgrade.cgi");
if ($exists > 0)
	{
	$swarning3 = "<img src=\"$web_url/ic_exc.gif\">upgrade.cgi is present in your cgi-bin directory. Please delete it. Leaving it there creates a security hole.<BR>";
	}

if (($swarning1 ne "") or ($swarning2 ne "") or ($swarning3 ne ""))
	{
	$warning4 = "<p>$swarning1 $swarning2 $swarning3</p>";
	}

if ($warning4 eq "") { $warning4 = ""; }


########################################


$boxdiz = qq[
<img src="$web_url/lar3.gif">
<a href="$admin_url/startup.cgi" onClick="popup('$admin_url/startup.cgi',screen.width-200,screen.height-200);return false;" title="If you are new to PowerSeek then use the 'Startup Wizard' to get started in the shortest amount of time possible.">Startup Wizard - For New Users</a> | 
<a href="$admin_url/wiz.cgi" onClick="popup('$admin_url/wiz.cgi',800,600);return false;">Other Wizards</a>
];

$headingd = acs::get_heading_box("$web_url/homeb.gif", "Welcome!", $boxdiz);


if ($warning4 ne "")
	{
	$warning4 = qq[
<table border="0" cellspacing="1" width="95%" cellpadding="6" bgcolor="#DDDDDD">
  <tr>
    <td align="left" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Warnings:</strong></td>
  </tr>
  <tr>
    <td width="30%" align="left" bgcolor="#FFFFFF">$warning4</td>
  </tr>
</table>
<table border="0" cellpadding="0"
    cellspacing="0" width="95%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>	
	];
	
	}


$homedata = qq[
$headingd
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="70%" valign="top"><table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD" height="46">
	
      <tr>
        <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img
        src="$web_url/ics_dir.gif"><br><img src="$web_url/55.gif" height="1" width="55"></td>
        <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><table
        border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td width="99%" align="left"><font class="normaltext"><strong><a href="$admin_url/admin2.cgi">Dir
            Manager</a></strong> <br>
            The Directory Manager enables you to create and manage your directory.</font></td>
            <td align="right" width="1%"><a href="http://www.focalmedia.net/pseekmanual/pseek4.html"
            target="_blank"><img src="$web_url/ics_help.gif" border="0"></a></td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/ics_spn.gif"></td>
        <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><table
        border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td width="99%" align="left"><strong class="normaltext"><a href="$admin_url/admin10.cgi">Settings</a><br>
            </strong><span class="normaltext">Various settings and options available to change the way
            in which your search engine operate.</span></td>
            <td align="right" width="1%"><a href="http://www.focalmedia.net/pseekmanual/pseek3.html"
            target="_blank"><img src="$web_url/ics_help.gif" border="0"></a></td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/ics_user.gif"></td>
        <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><table
        border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td width="99%" align="left" class="normaltext"><strong><a href="$admin_url/admin55.cgi">User Manager</a><br>
            </strong>Manage User Accounts. Note that the user manager can only be used if the user
            registration system is in use. If the user registration system is not in use then users
            don't have to register accounts in order to submit links.</td>
            <td width="1%"><a href="http://www.focalmedia.net/pseekmanual/pseek8.html"
            target="_blank"><img src="$web_url/ics_help.gif" border="0"></a></td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img
        src="$web_url/ics_tmpl.gif"></td>
        <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><table
        border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td width="99%" align="left" class="normaltext"><strong><a href="$admin_url/admin6.cgi">Template
            Manager</a><br>
            </strong>The template manager enables you to edit the look and feel of your Search Engine
            &amp; Directory. </td>
            <td width="1%"><a href="http://www.focalmedia.net/pseekmanual/pseek6.html"
            target="_blank"><img src="$web_url/ics_help.gif" border="0"></a></td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img
        src="$web_url/ics_plug.gif"></td>
        <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><table
        border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td width="99%" align="left" class="normaltext"><strong><a href="$admin_url/plugins.cgi">Plug-Ins</a><br>
            </strong>Contains various add-ons and plugable modules.</td>
            <td width="1%"><a href="http://www.powerseek.net/docs11.html"
            target="_blank"><img src="$web_url/ics_help.gif" border="0"></a></td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img
        src="$web_url/ics_todo.gif"></td>
        <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><table
        border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td width="99%" align="left" class="normaltext"><strong><a href="$admin_url/todo.cgi">To Do</a></strong><br>
            Lists various tasks that enable you to maintain your directory and search engine.</td>
            <td width="1%"><a href="http://www.focalmedia.net/pseekmanual/pseek9.html"
            target="_blank"><img src="$web_url/ics_help.gif" border="0"></a></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    <table border="0" cellpadding="0" cellspacing="0" width="100%"
    background="$web_url/shadow.gif">
      <tr>
        <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
        <td width="99%"></td>
      </tr>
    </table>
    </td>
    <td width="30%" align="right" valign="top"><table border="0" cellspacing="1" width="95%"
    cellpadding="6" bgcolor="#DDDDDD" height="46">
        <tr>
          <td align="left" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Help<span class="verd">:</span></strong></td>
        </tr>
        <tr>
          <td width="30%" align="left" bgcolor="#FFFFFF" class="normaltext"><img src="$web_url/lar3.gif"><a href="http://www.focalmedia.net/pseekmanual/" target="_blank">PowerSeek Manual</a><br>
          <img src="$web_url/lar3.gif"><a href="http://www.focalmedia.net/support.html" target="_blank">PowerSeek Support</a><br>
          <img src="$web_url/lar3.gif"><a href="$admin_url/wiz.cgi" onClick="popup('$admin_url/wiz.cgi',screen.width-200,screen.height-200);return false;">Wizards</a>
          </td>
        </tr>
      </table>
      <table border="0" cellpadding="0"
    cellspacing="0" width="95%" background="$web_url/shadow.gif">
        <tr>
          <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
          <td width="99%"></td>
        </tr>
      </table>
     
      <table border="0" cellspacing="1" width="95%" cellpadding="6"
    bgcolor="#DDDDDD" height="46">
      <tr>
        <td align="left" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Upgrades
          &amp; Configuration:</strong></td>
        </tr>
      <tr>
        <td width="30%" align="left" bgcolor="#FFFFFF" class="verd"><span class="normaltext"><strong>Current Version:</strong><br>
          $upgrade_cgi_version<br>
          <BR>
          <strong><img src="$web_url/lar3.gif"></strong><a href="$admin_url/admin.cgi?fct=upgrades"
        onClick="popup('$admin_url/admin.cgi?fct=upgrades',500,300);return false;">Check for New Upgrades</a><strong><br>
            </strong></span><strong><span class="normaltext"><img
        src="$web_url/lar3.gif"></span></strong><span class="normaltext"><a href="$admin_url/admin.cgi?fct=conf" 
        onClick="popup('$admin_url/admin.cgi?fct=conf',800,600);return false;">Configuration
              Info</a></span></td>
        </tr>
    </table>
    <table border="0" cellpadding="0"
    cellspacing="0" width="95%" background="$web_url/shadow.gif">
      <tr>
        <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
        <td width="99%"></td>
      </tr>
    </table>
    $warning4    </td>
  </tr>
</table>
];

$template =~ s/!!data!!/$homedata/g;



#$template =~ s/%%inst%%/$warning4/g;
$template =~ s/%%inst%%//g;

print "$template";
 
}







sub upgrade2
{


$exists = (-w "$config_cgi");
if ($exists < 1)
	{
	acs::problem_popup("Unable to write to config.cgi - Please ensure that config.cgi situated in your cgi-bin directory is set to the permission setting of 777.");
	}


if ($config_cgi ne "../config.cgi")
{
$nlck = $config_cgi;
$nlck =~ s/config\.cgi/admin\/unlock\.cgi/gi;
}
else
{
$nlck = "unlock.cgi";
}


if ((-e "$nlck") < 1)
	{
	$ppd = qq[Enter <b>TEST-SERIAL</b> if this is the free trial version of PowerSeek.];
	$ppds = "false";
	}


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body topmargin="0" leftmargin="0">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%" bgcolor="#0000A0"><img src="$web_url/pscp.jpg"></td>
  </tr>
  <tr>
    <td bgcolor="#00006A">&nbsp;</td>
  </tr>
</table>


<p>&nbsp;</p>
<table width="60%" border="0" align="center" cellpadding="6" cellspacing="1" class="aborder">
  <tr>
    <td background="$web_url/inp4.png"><strong class="normaltext12">Please Enter
      Your PowerSeek Serial:</strong></td>
  </tr>
  <tr>
    <td><ul>
        <li class="normaltext12">If this is the Free Version then enter<strong> 'FREE' </strong>without the quotes as the serial. Keep in mind that you can at any time upgrade the free version to the full version.</li>
        <li class="normaltext12">If you purchased PowerSeek then your serial should have been sent to you when you purchased PowerSeek. </li>
      </ul>
      <form method="post" action="http://www.powerseek.net/cgi-bin/psmembers/members.cgi">
        <table width="278" border="0" align="center"
  cellpadding="5" cellspacing="0">
          <tr>
            <td width="102"><strong class="normaltext12">Serial:</strong></td>
            <td valign="top" width="156"><input type="text" name="serial"
      size="39"></td>
            <td valign="top" width="156"><input type="submit" class="psbutton"
      value="Submit" name="B1"></td>
          </tr>
        </table>
        <input type="hidden" name="domain" value="$admin_url">
        <input type="hidden" name="unl" value="$ppds">
        <input type="hidden" name="fct" value="register_ps">
      </form></td>
  </tr>
</table>
</body>
</html>
];

exit;

}



sub upgrade
{

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Upgrade</title>
</head>
<body topmargin="0" leftmargin="0"><br>
<form method="POST" action="http://www.focalmedia.net/cgi-bin/tseek2rg/rg.cgi">
  <div align="center"><center><table border="0" cellpadding="10" cellspacing="0"
  width="100%" style="border: 1px solid">
    <tr>
      <td width="119"><strong><font face="Verdana" size="1">Order ID: </font></strong></td>
      <td width="589"><font face="Verdana" size="1"><input type="text" name="orderid" size="20"><br>
      You should have received an order ID when you registered.</font></td>
    </tr>
    <tr>
      <td width="119"><strong><font face="Verdana" size="1">Serial: </font></strong></td>
      <td width="589"><font face="Verdana" size="1"><input type="text" name="rgs" size="39"><br>
      You should have received a serial when you registered.</font></td>
    </tr>
    <tr>
      <td width="119"></td>
      <td width="589"><input type="submit" class="psbutton" value="   Next   " name="B1"></td>
    </tr>
  </table>
  </center></div>
</form>
];


}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

if ($line =~ /^MAIL_METHOD/){$mail_method = &get_setup_line($line, MAIL_METHOD);}
if ($line =~ /^SENDMAIL/){$sendmail = &get_setup_line($line, SENDMAIL);}
if ($line =~ /^SMTP_SERVER/){$smtp_server = &get_setup_line($line, SMTP_SERVER);}
if ($line =~ /^SMTP_USER/){$smtp_user = &get_setup_line($line, SMTP_USER);}
if ($line =~ /^SMTP_PASS/){$smtp_pass = &get_setup_line($line, SMTP_PASS);} 


if ($line =~ /^SWR/){$swr = &get_setup_line($line, SWR);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}


if ($q->param('fctt') eq "w34AAERE4777wERW3452jawewerrwerweja4JkshfUsr") 
	{
	print "Content-type: text/html\n\n";
	&write_var("SWR", $q->param('s'));

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek SQL</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="2;URL=$admin_url/admin.cgi">
</head>
<body>

<p><img src="$web_url/working.gif" width="270" height="36"
alt="working.gif (6143 bytes)"><br>
<font face="Arial" size="2"><strong>&nbsp; Validating...</strong></font></p>

</body>
</html>
];


	exit;
	}	


}







sub get_html_document
{

my ($document) = @_;

my ($EOL, $BLANK, $remote, $rval, @hitems, @ritems, $Rhttpheader, $host, $Rdocdate, $Rserver, $TCPconnect);


 ($host,$port,$document) = $document =~ m@http://([^/:]+)(:\d+)?(.*)@;

 if ($document eq "") {$document = "/";}

 $remote = IO::Socket::INET->new( 
 										Proto => "tcp",
                              PeerAddr  => $host,
                              PeerPort  => "http(80)",
                              Timeout => 5
                                 );

        unless ($remote)
        		{
        		$Rhttpheader = "Connection failed when trying to connect to http daemon at $document";
        		$TCPconnect = "False";
        		}

#print "$Rhttpheader - $TCPconnect";

if ($TCPconnect ne "False")
	{
   
   $remote->autoflush(1);

	print $remote "GET $document HTTP/1.0\r\n";
	print $remote "Host: $host\r\n";
	print $remote "\r\n";
	
  		while (defined($line=<$remote>))
 			{
			$rval = $rval . $line;
  			}
      close $remote;

@ritems = split(/\n/,$rval);
$Rhttpheader = $ritems[0];
$Rdocdate = $ritems[1];
$Rserver = $ritems[2];
	}

$Rdocument = $document;
$Rehost = $host;

$REMR1 = "GET $document HTTP/1.0";
$REMR2 = "Host: $host";

return ($rval, $Rhttpheader, $Rdocdate, $Rserver, $Rdocument, $TCPconnect);

}





sub write_var
{

my ($identifier, $write_crit) = @_;

my ($line, $tocheck, $towrite, $idmatch);

$towrite = "";


if ((-w $config_cgi) < 1) 	
	{

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
</head>
<body topmargin="0" leftmargin="0">
<p align="center"><br>
<br>
<img src="$web_url/pscp.jpg" border="0"></p>
<hr size="1" color="#E6E6E6" width="80%">
<p align="center"><font face="Arial" size="4" color="#000000"><strong>config.cgi is not writable</strong></font></p>
<div align="center"><center>
<table border="0" cellpadding="0" cellspacing="0" width="80%">
  <tr>
    <td width="100%"><p align="center"><font face="Arial" size="2">To solve the problem set
    config.cgi to the permission setting of 777<br>
    <br>
    <br>
    <strong><a href="$admin_url/admin.cgi">Click this link when config.cgi has been set to the
    permission setting of 777</a></strong></font></td>
  </tr>
</table>
</center></div>
<hr size="1" color="#E6E6E6" width="80%">
<p><font face="Arial" size="2"><br>
</font></p>
</body>
</html>


	];
	exit;
	}	

open (STP, "$config_cgi");

	while (defined($line=<STP>))
		{

		if ($line =~ m/#/g)
			{
			$r = pos($line);
			$tocheck = substr($line, 0, $r - 1);
			}
			else
			{
			$tocheck = $line;
			}
			
		if ($tocheck =~ /^$identifier/)
			{
			$line = "$identifier \"$write_crit\"\n";
			$idmatch = "true";
			}

		$towrite = $towrite . $line;

		}

	##print "$identifier : $idmatch <br>";
	
	if ($idmatch ne "true")
		{
		$towrite = $towrite . "\n\n$identifier \"$write_crit\"\n";
		}

close (STP);


open (STP, "> $config_cgi");
	print STP $towrite;
close (STP);

}





sub anotes
{
    
    
$adnotes = acs::get_file_contents("/public_html/notes/ps.txt"); 


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>$prg_ver Setup</title>
<link href="$web_url/adesk.css" rel="stylesheet" type="text/css"> 
<style type="text/css">
.setupbig {
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 32px;
	color: #666;
}
.setupsmall {
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
.setupsmallstrong {
	color: #999;
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
.setupbig2 {
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 24px;
}
</style>
</head>
<body>
<table width="90%" border="0" align="center" cellpadding="6" cellspacing="1">
  <tr>
    <td><span class="setupbig2">Notes:</span></td>
  </tr>
</table>
<table width="85%" border="0" align="center" cellpadding="10" cellspacing="0"
style="border: 1px solid rgb(230,230,230)">
  <tr>
    <td bgcolor="#FFFFFF" width="963" height="17"><form id="form1" name="form1" method="post" action="$admin_url/admin.cgi">
    <input type="hidden" name="fct" value="savenotes">
      <p>
        <label for="notes"></label>
        <textarea name="notes" id="notes" cols="45" rows="40" style="width: 100%">$adnotes</textarea>
      </p>
      <p>
        <input type="submit" class="psbutton" name="Save" id="Save" value="          Save          " />
      </p>
    </form></td>
  </tr>
</table>
</body>
</html>
];

}




sub savenotes
{
    
    open (ANOTES, "> /public_html/notes/ps.txt");
        print ANOTES $q->param('notes');
    close (ANOTES);
    
    print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>$prg_ver Setup</title>
<link href="$web_url/adesk.css" rel="stylesheet" type="text/css"> 
<style type="text/css">
.setupbig {
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 32px;
	color: #666;
}
.setupsmall {
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
.setupsmallstrong {
	color: #999;
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
.setupbig2 {
	font-family: Tahoma, Geneva, sans-serif;
	font-size: 24px;
}
</style>
</head>
<body>
<table width="90%" border="0" align="center" cellpadding="6" cellspacing="1">
  <tr>
    <td><span class="setupbig2">Notes Saved</span></td>
  </tr>
</table>
<table width="85%" border="0" align="center" cellpadding="10" cellspacing="0"
style="border: 1px solid rgb(230,230,230)">
  <tr>
    <td bgcolor="#FFFFFF" width="963" height="17"><form id="form1" name="form1" method="post" action="$admin_url/admin.cgi">
      <p>
        <label for="notes"></label>
        <input type="submit" class="psbutton" name="Save" id="Save" value="    Continue    " />
        <input name="fct" type="hidden" id="fct" value="notes" />
      </p>
</form></td>
  </tr>
</table>

]; 
    
}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

