#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

eval 'use Image::Magick;';
if ($@ ne "") { $IM = "false"; } else { $IM = "true"; }

eval 'use Image::Resize;';
if ($@ ne "") { $IMRES = "false"; } else { $IMRES = "true"; }

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

$gsettings = new_gsettings acs;

###########

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "global_settings") {&global_settings;}
if ($q->param('fct') eq "global_settings_save") {&global_settings_save;}


##################################################################################

sub global_settings_save
{

$nextpage = $q->param('nextpage');
$prevpage =  $q->param('prevpage');
$pages =  $q->param('pages');
$norating =  $q->param('norating');
$comments =  $q->param('comments');
$rateit =  $q->param('rateit');
$openpopup_rateit =  $q->param('openpopup_rateit');
$openpopup_comments =  $q->param('openpopup_comments');
$nextprev_seperator =  $q->param('nextprev_seperator');
$location_seperator =  $q->param('location_seperator');
$no_match_text =  $q->param('no_match_text');
$no_comments_text =  $q->param('no_comments_text');
$search_res_newwin =  $q->param('search_res_newwin');
$dir_newwin =  $q->param('dir_newwin');
$add_url_link =  $q->param('add_url_link');
$nr_links_dirs =  $q->param('nr_links_dirs');
$gen_file_ext =  $q->param('gen_file_ext');
$gen_default_index =  $q->param('gen_default_index');
$verbose_silent =  $q->param('verbose_silent');
$dir_sort_links =  $q->param('dir_sort_links');
$nrlinks_per_page =  $q->param('nrlinks_per_page');
$hide_urls =  $q->param('hide_urls');
$search_nrlinks_perpage =  $q->param('search_nrlinks_perpage');
$diz_chars =  $q->param('diz_chars');
$addurl_check_duplicates =  $q->param('addurl_check_duplicates');
$addurl_present =  $q->param('addurl_present');
$cp_link_listings =  $q->param('cp_link_listings');
$cp_search_listings =  $q->param('cp_search_listings');
$hideurls = $q->param('hideurls');
$dyn_stat = $q->param('dyn_stat');
$nomatch_template = $q->param('nomatch_template');

$modify_text = $q->param('modify_text');
$report_dead_link = $q->param('report_dead_link');

$add_url_form = $q->param('add_url_form');
$welcome_email = $q->param('welcome_email');

$add_url_premium = $q->param('add_url_premium');

$informer_email = $q->param('informer_email');

$modify_pass_check = $q->param('modify_pass_check');

$whatsnew_link_no = $q->param('whatsnew_link_no');
$tophits_link_no = $q->param('tophits_link_no');

$newlinks = $q->param('newlinks');
$days1 = $q->param('days1');
$days2 = $q->param('days2');
$days3 = $q->param('days3');
$popular_links = $q->param('popular_links');
$pop_links_amount = $q->param('pop_links_amount');
$modif_password = $q->param('modif_password');

$searchmeth = $q->param('searchmeth');

$date_format = $q->param('date_format');

$strip_html_code = $q->param('strip_html_code');

$img_auth = $q->param('img_auth');

$remove_duplicates = $q->param('remove_duplicates');

$c_image_auth = $q->param('c_image_auth');

$comments_nr = $q->param('comments_nr');

$newsubmissions_results = $q->param('newsubmissions_results');

$dirsearch_nrlinks_perpage = $q->param('dirsearch_nrlinks_perpage');

$dirsearch_cat_sep = $q->param('dirsearch_cat_sep');

$floodcontrol = $q->param('floodcontrol');

$flood_seconds = $q->param('flood_seconds');

$addurl_reg_system = $q->param('addurl_reg_system');

$custom_pagetitle = $q->param('custom_pagetitle');

$enable_reciprocal = $q->param('enable_reciprocal');

$reciprocal_link_back = $q->param('reciprocal_link_back');

$enable_reciprocal_premium = $q->param('enable_reciprocal_premium');

$default_image = $q->param('default_image');
$image_width = $q->param('image_width');
$image_height = $q->param('image_height');

$enable_image_uploads = $q->param('enable_image_uploads');

$upload_max_filesize = $q->param('upload_max_filesize');

$comment_max_chars = $q->param('comment_max_chars');

$rateit_user_reg = $q->param('rateit_user_reg');
$comments_reg_system = $q->param('comments_reg_system');

$comment_sorting = $q->param('comment_sorting');

$htmldisplay = $q->param('htmldisplay');

$new_account_validation = $q->param('new_account_validation');

$img_auth_brlinks = $q->param('img_auth_brlinks');

$searches_per_hour = $q->param('searches_per_hour');

$category_page_names = $q->param('category_page_names');

$more_info_naming = $q->param('more_info_naming');

$premium_first_search_results = $q->param('premium_first_search_results');

$log_search_keywords = $q->param('log_search_keywords');

$remove_duplicates_filter = $q->param('remove_duplicates_filter');

$reg_img_auth = $q->param('reg_img_auth');

$generation_permissions = $q->param('generation_permissions');

$notfound404 = $q->param('notfound404');

$facebookappid = $q->param('facebookappid');

$admin_email = $q->param('admin_email');

$commpagebreak =  $q->param('commpagebreak');

$cp_encoding_to_use =  $q->param('cp_encoding_to_use');
$cp_encoding_to_use =~ s/&/&amp;/g;
$cp_encoding_to_use =~ s/</&lt;/g;
$cp_encoding_to_use =~ s/>/&gt;/g;
$qchr = "\"";
$cp_encoding_to_use =~ s/$qchr/&quot;/g;
$cp_encoding_to_use =~ s/'/&apos;/g;
open (ENCW, "> $data_dir/cpencoding.dat");
	print ENCW $cp_encoding_to_use;
close (ENCW);



open (GLS, "> $data_dir/gsettings.dat");
	print GLS 
	
		"nextpage=$nextpage" . "\n" . 
		"prevpage=$prevpage" . "\n" . 
		"pages=$pages" . "\n" . 
		"norating=$norating" . "\n" . 
		"comments=$comments" . "\n" . 
		"rateit=$rateit" . "\n" . 
		"openpopup_rateit=$openpopup_rateit" . "\n" . 
		"openpopup_comments=$openpopup_comments" . "\n" . 
		"nextprev_seperator=$nextprev_seperator" . "\n" . 
		"location_seperator=$location_seperator" . "\n" . 
		"no_match_text=$no_match_text" . "\n" . 
		"no_comments_text=$no_comments_text" . "\n" . 
		"search_res_newwin=$search_res_newwin" . "\n" . 
		"dir_newwin=$dir_newwin" . "\n" . 
		"add_url_link=$add_url_link" . "\n" . 
		"nr_links_dirs=$nr_links_dirs" . "\n" . 
		"gen_file_ext=$gen_file_ext" . "\n" . 
		"gen_default_index=$gen_default_index" . "\n" . 
		"verbose_silent=$verbose_silent" . "\n" . 
		"dir_sort_links=$dir_sort_links" . "\n" . 
		"nrlinks_per_page=$nrlinks_per_page" . "\n" . 
		"hide_urls=$hide_urls" . "\n" . 
		"search_nrlinks_perpage=$search_nrlinks_perpage" . "\n" . 
		"diz_chars=$diz_chars" . "\n" . 
		"addurl_check_duplicates=$addurl_check_duplicates" . "\n" . 
		"addurl_present=$addurl_present" . "\n" . 
		"cp_link_listings=$cp_link_listings" . "\n" . 
		"cp_search_listings=$cp_search_listings" . "\n" . 
		"hideurls=$hideurls" . "\n" . 
		"dyn_stat=$dyn_stat" . "\n" . 
		"nomatch_template=$nomatch_template" . "\n" .
		"modify_text=$modify_text" . "\n" . 
		"report_dead_link=$report_dead_link" . "\n" . 
		"add_url_form=$add_url_form" . "\n" . 
		"welcome_email=$welcome_email" . "\n" .
		"add_url_premium=$add_url_premium" . "\n" .
		"informer_email=$informer_email" . "\n" .
		"modify_pass_check=$modify_pass_check" . "\n" . 
		"whatsnew_link_no=$whatsnew_link_no" . "\n" . 
		"tophits_link_no=$tophits_link_no" . "\n" . 
		"newlinks=$newlinks" . "\n" . 
		"days1=$days1" . "\n" . 
		"days2=$days2" . "\n" . 
		"days3=$days3" . "\n" . 
		"popular_links=$popular_links" . "\n" . 
		"pop_links_amount=$pop_links_amount" . "\n" . 
		"modif_password=$modif_password" . "\n" . 
		"searchmeth=$searchmeth" . "\n" .
		"date_format=$date_format" . "\n" .
		"strip_html_code=$strip_html_code" . "\n" .
		"img_auth=$img_auth" . "\n". 
		"remove_duplicates=$remove_duplicates" . "\n" . 
		"c_image_auth=$c_image_auth" . "\n" . 
		"comments_nr=$comments_nr" . "\n" . 
		"newsubmissions_results=$newsubmissions_results" . "\n" . 
		"dirsearch_nrlinks_perpage=$dirsearch_nrlinks_perpage" . "\n" . 
		"dirsearch_cat_sep=$dirsearch_cat_sep" . "\n" . 
		"floodcontrol=$floodcontrol" . "\n" . 
		"flood_seconds=$flood_seconds" . "\n" .
		"addurl_reg_system=$addurl_reg_system" . "\n" . 
		"custom_pagetitle=$custom_pagetitle" . "\n" . 
		"enable_reciprocal=$enable_reciprocal" . "\n" . 
		"reciprocal_link_back=$reciprocal_link_back" . "\n" .
		"enable_reciprocal_premium=$enable_reciprocal_premium" . "\n" .
		"default_image=$default_image" . "\n" . 
		"image_width=$image_width" . "\n" . 
		"image_height=$image_height" . "\n" . 
		"enable_image_uploads=$enable_image_uploads" . "\n" . 
		"upload_max_filesize=$upload_max_filesize" . "\n" . 
		"comment_max_chars=$comment_max_chars" . "\n" . 
		"rateit_user_reg=$rateit_user_reg" . "\n" . 
		"comments_reg_system=$comments_reg_system" . "\n" . 
		"comment_sorting=$comment_sorting" . "\n" . 
		"htmldisplay=$htmldisplay" . "\n" . 
		"new_account_validation=$new_account_validation" . "\n" .
		"img_auth_brlinks=$img_auth_brlinks" . "\n" . 
		"searches_per_hour=$searches_per_hour" . "\n" . 
		"category_page_names=$category_page_names" . "\n" .
		"more_info_naming=$more_info_naming" . "\n" . 
		"premium_first_search_results=$premium_first_search_results" . "\n" . 
		"log_search_keywords=$log_search_keywords" . "\n" .
		"remove_duplicates_filter=$remove_duplicates_filter" . "\n" . 
		"reg_img_auth=$reg_img_auth" . "\n" . 
		"generation_permissions=$generation_permissions" . "\n" . 
		"notfound404=$notfound404" . "\n" .
		"facebookappid=$facebookappid" . "\n" . 
		"admin_email=$admin_email"  . "\n" . 
		"commpagebreak=$commpagebreak" . "\n";
		

close (GLS);



### CONFIGURE WHAT TO USE FOR IMAGE RESIZING
if ((-e "$data_dir/imgresconf.dat") < 1)
	{
		if (($IM eq "true") and ($IMRES eq "false")) ### IMAGE MAGICK
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IM";
			close (DDT);
			}
		elsif (($IM eq "false") and ($IMRES eq "true"))  ### IMAGE RESIZE MODULE
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IMRES";
			close (DDT);	
			}
		else ### IF BOTH MODS INSTALLED USE image::resize
			{
			open (DDT, "> $data_dir/imgresconf.dat");
				print DDT "IMRES";
			close (DDT);	
			}
	}


### RESIZE SETTINGS

if (($q->param('img_width') ne "") or  ($q->param('img_height') ne ""))
	{
		open (IMGRH, "> $data_dir/imgres.dat");
			print IMGRH $q->param('img_width') . "\n";
			print IMGRH $q->param('img_height');
		close (IMGRH);
	}


$boxdiz = qq[You may <a href="javascript:onClick=window.close()">close</a> this window.];

$hbox = acs::get_heading_box("$web_url/ic_settings5.gif", "Global Engine Settings Saved", $boxdiz);


if ($dyn_stat eq "Mod_Rewrite")
	{

@urlitems = split (/\//, $script_url);

	$cnt=0;
	foreach $item (@urlitems)
		{
		if ($cnt > 2)
			{
			$redirp = $redirp . "/" . $item;
			}
		$cnt++;
		}


$modrules = qq[
Options +Indexes
RewriteEngine On

RewriteRule ^([0-9]+)/([0-9]+)/([0-9]+)(.*)\.html\$ $redirp/dirs2.cgi?cid=\$1&st=\$2&nd=\$3
RewriteRule ^([0-9]+)(.*)\.html\$ $redirp/dirs2.cgi?cid=\$1
RewriteRule ^info/([0-9]+)(.*)\.html\$ $redirp/linfo.cgi?id=\$1
];

$m_urlpath = "$web_url/.htaccess";
$m_serverpath = "$web_dir/.htaccess";
	
	$mwbox = qq[
	<table width="100%" border="0" cellpadding="6" class="aborder">
		  <tr>
		    <td background="$web_url/bar6.gif" class="normaltext"><strong>Important - Please Read - Mod Rewrite Instructions: </strong></td>
		  </tr>
		  <tr>
		    <td class="normaltext"><p>You have chosen to use Mod_Rewrite. There is an additional step required from you so that we can tell your web server how to handle the rewriting of URLs.</p>
		    <p>To enable Mod_Rewrite on your web-server or host do the following:</p>
		    <p><strong>Step 1</strong>: Create a file with a text editor with the name .htaccess (You can use Windows Notepad for example)</p>
		<p><strong>The contents of the file should look like this:</strong> (Copy and paste the code below into the file)</p>
		    <form id="form1" name="form1" method="post" action="">
		      <label for="textarea"></label>
		      <textarea name="textarea" id="textarea" cols="50" rows="10" style="width:100%">$modrules</textarea>
		    </form>
		    <p><strong>Step 2</strong>: <strong>Upload .htaccess to your web server or web host.</strong></p>
		    <p>Now that you have created the file called .htaccess upload it to the following location on your web server or web host:</p>
		    <p>The URL path where this file should be available is:<br />
		      <strong>$m_urlpath </strong></p>
		<p>The full server path where this file should be available is:<br />
		  <strong>$m_serverpath</strong></p></td>
		  </tr>
</table>
	];
	}




print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Settings Saved</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
$mwbox
</body>
</html>
];


}


######################




sub global_settings
{

$nextpage = 					$gsettings->{nextpage};
$prevpage =  					$gsettings->{prevpage};
$pages =  						$gsettings->{pages};
$norating =  					$gsettings->{norating};
$comments =  					$gsettings->{comments};
$rateit =  						$gsettings->{rateit};
$openpopup_rateit =  		$gsettings->{openpopup_rateit};
$openpopup_comments =  		$gsettings->{openpopup_comments};
$nextprev_seperator =  		$gsettings->{nextprev_seperator};
$location_seperator =  		$gsettings->{location_seperator};
$no_match_text =  			$gsettings->{no_match_text};
$no_comments_text =  		$gsettings->{no_comments_text};
$search_res_newwin =  		$gsettings->{search_res_newwin};
$dir_newwin =  				$gsettings->{dir_newwin};
$add_url_link =  				$gsettings->{add_url_link};
$nr_links_dirs =  			$gsettings->{nr_links_dirs};
$gen_file_ext =  				$gsettings->{gen_file_ext};
$gen_default_index =  		$gsettings->{gen_default_index};
$verbose_silent =  			$gsettings->{verbose_silent};
$dir_sort_links =  			$gsettings->{dir_sort_links};
$nrlinks_per_page = 			$gsettings->{nrlinks_per_page};
$hide_urls =  					$gsettings->{hide_urls};
$search_nrlinks_perpage =  $gsettings->{search_nrlinks_perpage};
$diz_chars =  					$gsettings->{diz_chars};
$addurl_check_duplicates = $gsettings->{addurl_check_duplicates};
$addurl_present =  			$gsettings->{addurl_present};

$cp_link_listings =  			$gsettings->{cp_link_listings};
$cp_search_listings =  			$gsettings->{cp_search_listings};
$hideurls = 						$gsettings->{hideurls};
$dyn_stat = 						$gsettings->{dyn_stat};
$nomatch_template = 				$gsettings->{nomatch_template};

$modify_text = 				$gsettings->{modify_text};
$report_dead_link = 			$gsettings->{report_dead_link};

$add_url_form = $gsettings->{add_url_form};
$welcome_email = $gsettings->{welcome_email};

$add_url_premium = $gsettings->{add_url_premium};

$informer_email = $gsettings->{informer_email};

$modify_pass_check = $gsettings->{modify_pass_check};

$whatsnew_link_no = $gsettings->{whatsnew_link_no};
$tophits_link_no = $gsettings->{tophits_link_no};

$newlinks =  $gsettings->{newlinks};
$days1 =  $gsettings->{days1};
$days2 =  $gsettings->{days2};
$days3 =  $gsettings->{days3};
$popular_links =  $gsettings->{popular_links};
$pop_links_amount =  $gsettings->{pop_links_amount};

$modif_password = $gsettings->{modif_password};

$searchmeth = $gsettings->{searchmeth};

$date_format = $gsettings->{date_format};

$date_format_ar[$date_format] = "selected";

$strip_html_code = $gsettings->{strip_html_code};

$img_auth = $gsettings->{img_auth};

$remove_duplicates = $gsettings->{remove_duplicates};

$c_image_auth = $gsettings->{c_image_auth};

$comments_nr = $gsettings->{comments_nr};

$newsubmissions_results = $gsettings->{newsubmissions_results};

$dirsearch_nrlinks_perpage = $gsettings->{dirsearch_nrlinks_perpage};

$dirsearch_cat_sep = $gsettings->{dirsearch_cat_sep};

$floodcontrol = $gsettings->{floodcontrol};

$flood_seconds = $gsettings->{flood_seconds}; if ($flood_seconds eq "") { $flood_seconds = "2"; }

$addurl_reg_system = $gsettings->{addurl_reg_system}; 

$custom_pagetitle = $gsettings->{custom_pagetitle}; 
if ($custom_pagetitle eq "") { $custom_pagetitle = "%%pagetitle%%"; }


$reciprocal_link_back = $gsettings->{reciprocal_link_back}; 

$enable_reciprocal = $gsettings->{enable_reciprocal}; 

$enable_reciprocal_premium = $gsettings->{enable_reciprocal_premium}; 

$default_image = $gsettings->{default_image}; 

$image_width = $gsettings->{image_width}; 

$image_height = $gsettings->{image_height}; 

$upload_max_filesize = $gsettings->{upload_max_filesize}; if ($upload_max_filesize eq "") { $upload_max_filesize = 50; }

$enable_image_uploads = $gsettings->{enable_image_uploads};

$comment_max_chars = $gsettings->{comment_max_chars};

$rateit_user_reg = $gsettings->{rateit_user_reg};

$comments_reg_system = $gsettings->{comments_reg_system};

$comment_sorting = $gsettings->{comment_sorting};

$new_account_validation = $gsettings->{new_account_validation};

$img_auth_brlinks = $gsettings->{img_auth_brlinks};

$searches_per_hour = $gsettings->{searches_per_hour};


$log_search_keywords = $gsettings->{log_search_keywords};


$remove_duplicates_filter = $gsettings->{remove_duplicates_filter};

$reg_img_auth = $gsettings->{reg_img_auth};

$facebookappid = $gsettings->{facebookappid};

$admin_email = $gsettings->{admin_email};

$commpagebreak =  $gsettings->{commpagebreak};

if ($commpagebreak eq "Yes")
	{
	$commpagebreak_Y = "selected";
	}
	else
	{
	$commpagebreak_N = "selected";
	}


$cp_encoding_to_use = acs::get_file_contents("$data_dir/cpencoding.dat");
if ($cp_encoding_to_use eq "")
	{
	$cp_encoding_to_use = qq[&lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=utf-8&quot;&gt;]; 
	}

$notfound404 = $gsettings->{notfound404};
if ($notfound404 eq "") { $notfound404 = "http://"; }


$generation_permissions = $gsettings->{generation_permissions};
if ($generation_permissions eq "") { $generation_permissions = "0777"; }



if ($reg_img_auth eq "Yes")
	{
	$reg_img_auth_yes = "selected";
	}
	else
	{
	$reg_img_auth_no = "selected";
	}



if ($remove_duplicates_filter eq "Title")
	{
	$remove_duplicates_filter_title = "selected";
	}
	else
	{
	$remove_duplicates_filter_URL = "selected";
	}
	

if ($log_search_keywords eq "Yes") 
	{
	$log_search_keywords_yes = "selected";
	}
	else
	{
	$log_search_keywords_no = "selected";
	}




if ($searches_per_hour eq "") { $searches_per_hour = 0; }



if ($comment_sorting eq "new") { $comment_sorting_new = "selected"; } else { $comment_sorting_old = "selected"; }

if ($rateit_user_reg eq "Yes") { $rateit_user_reg_yes = "selected"; } else { $rateit_user_reg_no = "selected"; }
if ($comments_reg_system eq "Yes") { $comments_reg_system_yes = "selected"; } else { $comments_reg_system_no = "selected"; }

$htmldisplay = $gsettings->{htmldisplay};


$category_page_names = $gsettings->{category_page_names};

$more_info_naming = $gsettings->{more_info_naming};


$premium_first_search_results = $gsettings->{premium_first_search_results};




if ($more_info_naming eq "linktitles") 
	{
	$linktitles_sel = "selected";
	}
	else
	{
	$linkids_sel = "selected";
	}





if ($category_page_names eq "categorynames") 
	{
	$categorynames_sel = "selected";
	}
	else
	{
	$more_sel = "selected";
	}





if ($htmldisplay eq "htmlon")
	{
	$htmlon = "selected";
	}
	else
	{
	$htmloff = "selected";
	}



if ($enable_image_uploads eq "Yes")
	{
	$enable_image_uploads_yes = "selected"; 
	}
	else
	{
	$enable_image_uploads_no = "selected"; 
	}



if ($enable_reciprocal_premium eq "Yes")
	{
	$enable_reciprocal_premium_y = "selected";
	}
	else
	{
	$enable_reciprocal_premium_n = "selected";
	}



if ($enable_reciprocal eq "Yes")
	{
	$enable_reciprocal_y = "selected";
	}
	else
	{
	$enable_reciprocal_n = "selected";
	}



#####

if ($c_image_auth eq "Yes")
	{
	$c_image_auth_y = "selected";
	}
	else
	{
	$c_image_auth_n = "selected";
	}



if ($searchmeth eq "pseek")
	{
	$pseek_sel = "selected";
	}
	else
	{
	$mysql_sel = "selected";
	}


if ($newlinks eq "Yes")
	{
	$newlinks_yes = "selected";
	}
	else
	{
	$newlinks_no = "selected";
	}
#$newlinks_yes = "selected";

if ($popular_links eq "Yes")
	{
	$popular_links_yes = "selected";
	}
	else
	{
	$popular_links_no = "selected";
	}

#openpopup_rateit
#openpopup_comments
#search_res_newwin
#dir_newwin
#nr_links_dirs
#verbose_silent
#dir_sort_links
#hide_urls
#addurl_check_duplicates
#addurl_present

if ($openpopup_rateit eq "Yes")
	{
	$openpopup_rateit_yes = "selected";
	}
	else
	{
	$openpopup_rateit_no = "selected";
	}

#########

if ($openpopup_comments eq "Yes")
	{
	$openpopup_comments_yes = "selected";
	}
	else
	{
	$openpopup_comments_no = "selected";
	}

########

if ($search_res_newwin eq "Yes")
	{
	$search_res_newwin_yes = "selected";
	}
	else
	{
	$search_res_newwin_no = "selected";
	}

########

if ($dir_newwin eq "Yes")
	{
	$dir_newwin_yes = "selected";
	}
	else
	{
	$dir_newwin_no = "selected";
	}

########

if ($nr_links_dirs eq "Yes")
	{
	$nr_links_dirs_yes = "selected";
	}
	else
	{
	$nr_links_dirs_no = "selected";
	}

########

if ($verbose_silent eq "Verbose")
	{
	$verbose_silent_verbose = "selected";
	}
	else
	{
	$verbose_silent_silent = "selected";
	}

########

if ($dir_sort_links eq "Popularity")
	{
	$dir_sort_links_popularity = "selected";
	}
elsif ($dir_sort_links eq "Alphabetical")
	{
	$dir_sort_links_alphabetical = "selected";
	}
elsif ($dir_sort_links eq "Hits")
	{
	$dir_sort_links_hits = "selected";
	}
elsif ($dir_sort_links eq "Votes")
	{
	$dir_sort_links_votes = "selected";
	}
elsif ($dir_sort_links eq "Ratings")
	{
	$dir_sort_links_ratings = "selected";
	}
elsif ($dir_sort_links eq "Newest")
	{
	$dir_sort_links_new = "selected";
	}
elsif ($dir_sort_links eq "Random")
	{
	$dir_sort_links_random = "selected";
	}
elsif ($dir_sort_links eq "Reviews")
	{
	$dir_sort_links_reviews = "selected";
	}



########

if ($hide_urls eq "Yes")
	{
	$hide_urls_yes = "selected";
	}
	else
	{
	$hide_urls_no = "selected";
	}


########

if ($addurl_check_duplicates eq "Yes")
	{
	$addurl_check_duplicates_yes = "selected";
	}
	else
	{
	$addurl_check_duplicates_no = "selected";
	}

########

if ($addurl_present eq "Yes")
	{
	$addurl_present_yes = "selected";
	}
	else
	{
	$addurl_present_no = "selected";
	}

#########

if ($hideurls eq "Yes")
	{
	$hideurls_yes = "selected";
	}
	else
	{
	$hideurls_no = "selected";
	}


#######

if ($dyn_stat eq "Static")
	{
	$dyn_stat_static = "selected";
	}
	elsif ($dyn_stat eq "Dynamic")
	{
	$dyn_stat_dynamic = "selected";
	}
	else
	{
	$dyn_stat_mod = "selected";
	}


#######

if ($nomatch_template eq "nomatch_tmpl")
	{
	$nomatch_template_nomatch_tmpl = "selected";
	}
	else
	{
	$nomatch_template_default_tmpl = "selected";
	}

#######

if ($add_url_form eq "medium")
	{
	$add_url_form_medium = "selected";
	}
	else
	{
	$add_url_form_large = "selected";
	}

########

if ($welcome_email eq "Yes")
	{
	$welcome_email_yes = "selected";
	}
	else
	{
	$welcome_email_no = "selected";
	}

#########

if ($informer_email eq "Yes")
	{
	$informer_email_yes = "selected";
	}
	else
	{
	$informer_email_no = "selected";
	}

#########

if ($modify_pass_check eq "Yes")
	{
	$modify_pass_check_yes = "selected";
	}
	else
	{
	$modify_pass_check_no = "selected";
	}

#########

if ($modif_password ne "No")
	{
	$modif_password_yes = "selected";
	}
	else
	{
	$modif_password_no = "selected";
	}

#########

if ($strip_html_code ne "No")
	{
	$strip_html_code_yes = "selected";
	}
	else
	{
	$strip_html_code_no = "selected";
	}

###########

if ($img_auth ne "No")
	{
	$img_auth_yes = "selected";
	}
	else
	{
	$img_auth_no = "selected";
	}

###########

if ($remove_duplicates eq "Yes")
	{
	$remove_duplicates_yes = "selected";
	}
	else
	{
	$remove_duplicates_no = "selected";
	}


####
if ($remove_duplicates eq "Yes")
	{
	$remove_duplicates_yes = "selected";
	}
	else
	{
	$remove_duplicates_no = "selected";
	}


if ($floodcontrol eq "No")
	{
	$floodcontrol_no = "selected";
	}
	else
	{
	$floodcontrol_yes = "selected";
	}


if ($floodcontrol eq "No")
	{
	$floodcontrol_no = "selected";
	}
	else
	{
	$floodcontrol_yes = "selected";
	}


if ($addurl_reg_system eq "Yes")
	{
	$addurl_reg_system_yes = "selected";
	}
	else
	{
	$addurl_reg_system_no = "selected";
	}


if ($new_account_validation eq "No")
	{
	$new_account_validation_no = "selected";
	}
	else
	{
	$new_account_validation_yes = "selected";
	}


if ($img_auth_brlinks eq "Yes")
	{
	$img_auth_brlinks_yes = "selected";
	}
	else
	{
	$img_auth_brlinks_no = "selected";
	}


if ($premium_first_search_results eq "Y")
	{
	$premium_first_search_results_yes = "selected";
	}
	else
	{
	$premium_first_search_results_no = "selected";
	}









### IMAGE RESIZING HEIGHT / WIDTH

if (($IM eq "true") or ($IMRES eq "true"))
	{
	$resdata = acs::get_file_contents("$data_dir/imgres.dat");
	my @resoptions = split (/\n/, $resdata);
	$img_width = $resoptions[0];
	$img_height = $resoptions[1];
	
$img_resize_settings = qq[

<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass"><p><strong>Image Resizing Options:      (Leave blank if no image resizing is required) <span class="normaltext"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('<ul>    <li>Leave the width and height options blank if the standard upload field is not going to be used for images or leave it blank if you do not want images to be resized when images are being uploaded.</li>    <li>Specify a width and/or height value above if you would like to have images automatically resized when an image is uploaded for the default file/image upload field available for all listings/links. </li>    <li>If you want to keep the aspect ratio of the image, only provide one  value for the width or height. For example: leave the height property  blank and provide a value for the width property to resize the image to  a specific width but keep the aspect ratio. (The height will  automatically be resized to keep the aspect ratio)</li>    <li>Note that this resize setting is globally valid for the file/image upload field that comes with all links by default. </li>    <li>If invalid images are uploaded then no resizing will be done on the file as the file will not be a valid image file.</li>  </ul>  ');" onmouseout="tooltip.hide();" /></span><br>
        </strong>Note that this setting is available for the standard file/image upload field available for all listings by default.</p>
    </td>
    <td class="tdclass" valign="top"><table width="100%" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td width="7%"><p><strong>Width:</strong> </p></td>
        <td width="93%" height="30"><p>
            <input name="img_width" type="text" id="img_width" value="$img_width" size="10">
          pixels</p></td>
      </tr>
      <tr>
        <td><p><strong>Height:</strong></p></td>
        <td height="30"><p>
            <input name="img_height" type="text" id="img_height" value="$img_height" size="10">
          pixels </p></td>
      </tr>
    </table></td>
  </tr>

  ];
	
	}

 
$boxdiz = qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="99%" class="normaltext">See the documentation for more detailed explanations of the settings that
    are available here. 
      <ul>
      <li>1. <a href="#1">General Settings </a></li>
      <li>2. <a href="#2">HTML File Generation Settings </a></li>
      <li>3. <a href="#3">Directory/Category Listing Settings </a></li>
      <li>4. <a href="#4">Search Settings </a></li>
      <li>5. <a href="#5">New Submission Settings </a></li>
      <li>6. <a href="#6">Comment/Reviews Submission Settings </a></li>
      <li>7. <a href="#7">Control Panel Settings </a></li>
      <li>8. <a href="#8">What's New &amp; Top Hits Settings </a></li>
      <li>9. <a href="#9">New &amp; Popular Indication Settings </a></li>
      <li>10. <a href="#10">Modifying of links </a></li>
    </ul>
    </td>
    <td width="1%" valign="top"><a href="$admin_url/help.cgi?fct=settings" target="_blank"><strong><img
    src="$web_url/bhelps.gif" border="0"></strong></a></td>
  </tr>
</table>
];

$hbox = acs::get_heading_box("$web_url/ic_settings5.gif", "Global Engine Settings", $boxdiz);

$tooltipst = acs::get_tooltip;


$shadow = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>
];



print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek SQL</title>
$HTML_ENCODING_USE
$tooltipst
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

<form method="POST" action="$admin_url/admin10.cgi">
  <input type="hidden" name="fct" value="global_settings_save"><input type="hidden" name="$newlinks_yes" value="Yes">
  
$hbox
 

<style type="text/css">

.tdclass
{
    border-color: #E4E4E4;
    border-width: 0px 0px 1px 1px;
    border-style: solid;
    margin: 0;
    padding: 6px;
	font-family: Tahoma, Helvetica, sans-serif;
	font-size: 11px;
	line-height: 18px;    
}

.tdtable 
{
border-width: 1px 1px 0px 0px; 
border-style: solid;
border-color: #E4E4E4;
}
</style>


<table border="0" cellpadding="6" width="100%" class="tdtable" cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><span class="normaltext"><a name="1"></a> <strong>1. General Settings</strong></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';" style="display:none">
    <td class="tdclass"><strong>Administrator Email Address:</strong></td>
    <td class="tdclass" valign="top"><input name="admin_email" type="text" id="admin_email" value="$admin_email" size="50"> <span class="normaltext"><img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onMouseOver="tooltip.show('Email from the \\'contact us\\' form will be sent to this email address. PowerSeek will also send various other Administrative PowerSeek related email to this email address.');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Are you going to run a static or dynamic directory?</strong></span></td>
    <td class="tdclass" width="50%" valign="top"><span class="normaltext">
      <select name="dyn_stat" size="1">
        <option $dyn_stat_static value="Static"> Static </option>
        <option $dyn_stat_dynamic value="Dynamic"> Dynamic </option>
        <option $dyn_stat_mod value="Mod_Rewrite"> Mod_Rewrite </option>
      </select>      
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onMouseOver=" tooltip.show('<p><b>Static:</b> A complete browsable set of HTML files are generated (created) that is browsable. Light on server resources (very fast), search engine friendly and highly recommended. Note that you will have to generate the files by clicking the <b>Dir Manager</b> button. Then click <b>Generate HTML files</b>. When any links are changed or added, the HTML files will have to be updated (with the update option) or regenerated to reflect the changes. <br><br> <b>Dynamic:</b> HTML files are generated on the fly while users browse the directory. All changes to links and directories/categories are immediate; and no HTML files need to be generated.</p> <p><strong>Mod_Rewrite:</strong> Almost the same as Dynamic but URLs will be Search Engine friendly. HTML files are generated on the fly while users browse the directory. All changes to links and directories/categories are immediate; and no HTML files need to be generated.</p>');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Next Page Text:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <input type="text" name="nextpage"
    size="19" value="$nextpage">    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('The <b>next page</b> text is clickable to navigate between pages in directories/categories and the search results.');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Previous Page Text:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <input type="text" name="prevpage"
    size="19" value="$prevpage">    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('The <b>previous page</b> text is clickable to navigate between pages in directories/categories and the search results.');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Text before number
    of pages:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <input type="text" name="pages" size="19"
    value="$pages"> 
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('The text that is displayed to indicate the number of pages for a directory/category or the search results. ');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Separator between
    next and previous page:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <input type="text"
    name="nextprev_seperator" size="4" value="$nextprev_seperator"> 
    </span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Category separator:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <input type="text"
    name="location_seperator" size="4" value="$location_seperator">    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('This separator is used when displaying the category/directory path when browsing the directory. ');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>No comments text:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <input type="text" name="no_comments_text"
    size="52" value="$no_comments_text">    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('This text will be displayed if there are no comments when viewing comments for links.  ');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Open new windows for
    links in directories/categories:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <select name="dir_newwin" size="1">
        <option $dir_newwin_yes value="Yes"> Yes </option>
        <option $dir_newwin_no value="No"> No </option>
      </select>    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('If this is set to <b>Yes</b> then links from the directories/categories will open in new windows when clicked. ');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Number of links
    displayed next to directories/categories?</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <select name="nr_links_dirs" size="1">
        <option $nr_links_dirs_yes value="Yes"> Yes </option>
        <option $nr_links_dirs_no value="No"> No </option>
      </select>    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('The number of links will be displayed next to directories/categories in brackets when sub directories are listed in directories/categories.');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Hide URLs when
    displaying link listings: <br>
    </strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <select name="hideurls" size="1">
        <option $hideurls_yes value="Yes"> Yes </option>
        <option $hideurls_no value="No"> No </option>
      </select>    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('If set to <b>Yes</b>, URLs will not be visible when end users browse categories or search for link listings (URLs will not display in the status bar of the browser). Note that if this is set to <b>No</b>, then hits will not be counted. ');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>What date format
    should be used when displaying dates?</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <select name="date_format" size="1">
        <option $date_format_ar[0] value="0"> Month dd, yyyy (Apr 10, 2003) </option>
        <option $date_format_ar[1] value="1"> dd Month yyyy (10 Apr 2003) </option>
        <option $date_format_ar[2] value="2"> yyyy-mm-dd (2003-05-10) </option>
        <option $date_format_ar[3] value="3"> mm-dd-yyyy (05-10-2003) </option>
        <option $date_format_ar[4] value="4"> dd-mm-yyyy (10-05-2003) </option>
      </select>
    </span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="50%" class="tdclass"><span class="normaltext"><strong>Enable Image
    Authentication for the 'Report Broken Links' function:</strong></span></td>
    <td class="tdclass" width="50%" valign="top"
    ><span class="normaltext">
      <select name="img_auth_brlinks" size="1">
        <option $img_auth_brlinks_yes value="Yes"> Yes </option>
        <option $img_auth_brlinks_no value="No"> No </option>
      </select>    
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('When this is enabled then visitors reporting broken links will need to type letters of letter boxes displayed. This option is available so that spammers cannot spam this function. ');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>

  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" ><span class="normaltext"><strong>URL to redirect to when a link was not found: </strong></span></td>
    <td class="tdclass" valign="top"
    >
      <span class="normaltext">
      <label>
        <input name="notfound404" type="text" id="notfound404" value="$notfound404" size="50">
      </label>      
    <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('In some situations a link may be removed from the database but may still be available with generated HTML files. If a URL is supplied in this setting then users will be redirected to it if the link they are trying to click does not exist anymore. ');" onMouseOut="tooltip.hide();" /></span></td>
  </tr>  
</table>
$shadow









<table border="0" cellpadding="6" width="100%" class="tdtable" cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><a name="2"></a> <strong>2. HTML File Generation Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Generated File
      Extensions:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="gen_file_ext"
    size="8" value="$gen_file_ext">
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('HTML files that is generated will have this file extension. ');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Default Index File:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text"
    name="gen_default_index" size="17" value="$gen_default_index">
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This is the first file in any generated directory that will be loaded when no file name was given to access a directory. ');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Generating from
      telnet/ssh:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="verbose_silent" size="1">
        <option $verbose_silent_verbose value="Verbose"> Verbose </option>
        <option $verbose_silent_silent value="Silent"> Silent </option>
      </select>
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('<b>Verbose</b> = Displays information when generating HTML files to the console <BR><BR><b>Silent</b> = Displays no information when generating HTML files ');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Category pages
      naming convention:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="category_page_names"
    size="1">
        <option $categorynames_sel value="categorynames"> Use category names </option>
        <option $more_sel value="more"> Use the 'more' name </option>
      </select>
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('In previous versions of PowerSeek (prior to ver 3.1) more than one page listing links in categories would have the names more1.html, more2.html, etc. Category names can now be used for these file names instead of more1, more2, etc. ');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>'More Info' pages
      naming convention:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="more_info_naming" size="1">
        <option $linktitles_sel value="linktitles"> Use link titles for file names </option>
        <option $linkids_sel value="linkids"> Use link IDs for file names </option>
      </select>
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('In previous versions of PowerSeek (prior to ver 3.1) <b>More Info</b> pages would be named 123.html, 124.html for example. (<B>More Info<b> pages would have numerical names). <b>More Info</b> pages can now have file names according to the title of the link. ');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" ><strong>File Permission Setting of Generated Files &amp; Directories:</strong></td>
    <td class="tdclass" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><label><span  style="border-left: 1px solid rgb(221,221,221)">
      <input name="generation_permissions" type="text" id="generation_permissions" value="$generation_permissions" size="10">
      (The default setting is: 0777)</span></label></td>
  </tr>
</table>

$shadow












<table border="0" cellpadding="6" width="100%" class="tdtable" cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><a name="3"></a> <strong>3. Directory/Category Listing Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Listings in
    Directories Sorted by:</strong></td>
    <td class="tdclass" width="50%" ><select name="dir_sort_links" size="1">
      <option value="Popularity" $dir_sort_links_popularity> Popularity </option>
      <option value="Alphabetical" $dir_sort_links_alphabetical> Alphabetical </option>
      <option value="Hits" $dir_sort_links_hits> Hits </option>
      <option value="Votes" $dir_sort_links> Votes </option>
      <option value="Ratings" $dir_sort_links_ratings> Ratings </option>
      <option value="Newest" $dir_sort_links_new> Newest to Oldest </option>
      <option value="Reviews" $dir_sort_links_reviews> Most to Least Comments/Reviews </option>
    </select> 
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('<b>Popularity</b> = Each vote, hit & rating receives a score and the listings with the highest scores are listed first. <BR><BR><b>Alphabetical</b> = Listings are alphabetically listed in directories/categories <BR><BR><b>Hits</b> = Listings are sorted from most hits to least hits <BR><BR><b>Votes</b> = Listings are sorted from most votes to least votes <BR><BR><b>Ratings</b> = Listings are sorted from highest to lowest rating <BR><BR><b>Newest to Oldest</b> = New or updated listings first. <BR><BR><b>Most to Least Comments/Reviews</b> = Links with reviews/comments are listed first. ');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of listings
    to list on a per page basis in categories:</strong></td>
    <td class="tdclass" width="50%" 
    ><input type="text" name="nrlinks_per_page"
    size="8" value="$nrlinks_per_page"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Substitute with the
    following text if the category has no title and %%custom_pagetitle%% has been used:</strong></td>
    <td class="tdclass" width="50%" 
    ><input type="text" name="custom_pagetitle"
    size="50" value="$custom_pagetitle"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><p><strong>Default image to display if you are displaying images with link listings:</strong><br>
      Only applicable to the standard upload field available by default.
    </p></td>
    <td class="tdclass" width="50%" 
    ><input type="text" name="default_image"
    size="50" value="$default_image">
       <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If you are using an uploaded image with link listings and there is no image for the link listing then you can specify the path to a default image that will display: (Leaving it blank will results in nothing being displayed)<br><br>Note that this setting is available for the standard file/image upload field available for all listings by default. <br><BR>Example: $web_url/some_image.gif');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><p><strong>Would you like
        uploaded images displayed with a fixed width and height?</strong><br>
      Only applicable to the standard upload field available by default.    </p></td>
    <td class="tdclass" width="50%" 
    >Width: <input type="text"
    name="image_width" size="11" value="$image_width"> (Pixels) / Height: <input type="text"
    name="image_height" size="11" value="$image_height"> 
      (Pixels) <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Would you like uploaded images displayed with link listings to have a fixed width and height? If so then please supply the width and height. If not then set the values to be zero.<BR><BR>Note that this setting is available for the standard file/image upload field available for all listings by default.');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Enable image
    uploading from submission forms?<br>
    </strong>If you want users to be able to upload any files or images then this setting has to be set to 'Yes'. </td>
    <td class="tdclass" width="50%" 
    ><select name="enable_image_uploads"
    size="1">
      <option $enable_image_uploads_yes value="Yes"> Yes </option>
      <option $enable_image_uploads_no value="No"> No </option>
    </select></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>What is the maximum
    size of an image file that may be uploaded?<br>
    </strong>Note that this setting is available for the standard file/image upload field available for all listings by default.</td>
    <td class="tdclass" width="50%" 
    ><input type="text"
    name="upload_max_filesize" size="8" value="$upload_max_filesize"> 
      Kilobytes  <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If a user uploads an image that exceeds this size then the image will not be accepted.');" onMouseOut="tooltip.hide();"></span></td>
  </tr>

$img_resize_settings
  
</table>

$shadow






<table border="0" cellpadding="6" width="100%" class="tdtable" cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><a name="4"></a> <strong>4. Search Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Search Method:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><select name="searchmeth" size="1">
      <option $pseek_sel value="pseek"> Use PowerSeek's Relevance Formula </option>
      <option $mysql_sel value="fulltext"> Use MySQL's FULLTEXT Searching </option>
    </select> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('<b>PowerSeek Relevance Formula:</b><BR>Higher accuracy than fulltext searching but requires more server resources.<BR><BR><b>MySQL FULLTEXT Searching:</b><BR>Faster with large amounts of links');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>List 'Premium' links first 
    that matched keywords in 'Search Results'?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><select
    name="premium_first_search_results" size="1">
      <option value="Y" $premium_first_search_results_yes>Yes</option>
      <option value="N" $premium_first_search_results_no>No</option>
    </select> 
      <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Setting this to <b>Yes</b> will display Premium Links in search results above Standard Links.');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>What to use when a
    search revealed no matches?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><select name="nomatch_template" size="1">
      <option $nomatch_template_nomatch_tmpl value="nomatch_tmpl"> Use and display the template called 'nomatch.html' </option>
      <option $nomatch_template_default_tmpl value="default_tmpl"> Use the template called 'searchres.html' with the 'no match text below' </option>
    </select> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Text when a search
    revealed no matches?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><input type="text" name="no_match_text"
    size="62" value="$no_match_text"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Open new windows for
    links from search results?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><select name="search_res_newwin" size="1">
      <option $search_res_newwin_yes value="Yes"> Yes </option>
      <option $search_res_newwin_no value="No"> No </option>
    </select> 
       <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If this is set to <b>Yes</b>, links will open in new windows when links from search results are clicked. ');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of listings
    per page?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><input type="text"
    name="search_nrlinks_perpage" size="8" value="$search_nrlinks_perpage"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Remove duplicate
    links from search results?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><select name="remove_duplicates" size="1">
      <option $remove_duplicates_yes value="Yes"> Yes </option>
      <option $remove_duplicates_no value="No"> No </option>
    </select> 
       <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Set this to <b>Yes</b> if you have duplicate links (links with the same URL) and do not want the duplicates displayed in the search results.');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" ><strong>If you've chosen to remove duplicates by what should it be filtered:</strong></td>
    <td class="tdclass" valign="top" 
    ><span  >
      <select name="remove_duplicates_filter" size="1" id="remove_duplicates_filter">
        <option value="URL" $remove_duplicates_filter_URL>Don't display links that has the same URL more than once</option>
        <option value="Title" $remove_duplicates_filter_title>Don't display links that has the same Title more than once</option>
      </select>
    </span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of listings
    per page when searching categories from advanced search form:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><input type="text"
    name="dirsearch_nrlinks_perpage" size="8" value="$dirsearch_nrlinks_perpage"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Separator to
    separate categories in category search results when searching categories from advanced
    search form:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><input type="text"
    name="dirsearch_cat_sep" size="8" value="$dirsearch_cat_sep"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Would you like to
    use flood control?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><select name="floodcontrol" size="1">
      <option $floodcontrol_yes value="Yes"> Yes </option>
      <option $floodcontrol_no value="No"> No </option>
    </select>
    <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Flood control is used so that people cannot press the search button continuously in a short time period that might cause significant server resource usage. (In other words searches will only be done within a specific time period like for example 2 seconds for individual users)');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of seconds to
    wait when a user tries to press the search button (flood the search script) continuously.</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><input type="text" name="flood_seconds"
    size="8" value="$flood_seconds"> 
    seconds  <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If the search button is pressed more than once in a 2 second time period then this is the amount of time the script will wait before attempting a search. If you are not sure about this value, leave it at 2 seconds. ');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of searches
    allowed by unique IP Address:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    ><input type="text"
    name="searches_per_hour" size="8" value="$searches_per_hour"> 
       <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This will limit the amount of searches you allow each visitor <b>per hour</b>. This is to avoid spammers submitting spam searches. If set to 0 (zero) then visitors can make an unlimited amount of searches. ');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" ><strong>Log Search Keywords:</strong></td>
    <td class="tdclass" valign="top" 
    ><span  >
      <select name="log_search_keywords" size="1" id="log_search_keywords">
        <option $log_search_keywords_yes value="Yes"> Yes </option>
        <option $log_search_keywords_no value="No"> No </option>
      </select>
       <span  ><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Enabling this will <b>log</b> keywords for the <b>Search Term Statistics</b> plugin so that you can see what was searched for. ');" onMouseOut="tooltip.hide();"></span></span></td>
  </tr>
</table>

$shadow






<table border="0" cellpadding="6" width="100%" class="tdtable"
cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><a name="5"></a> <strong>5. New Submission Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Would you like to
    use the user registration system?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="addurl_reg_system" size="1">
      <option $addurl_reg_system_yes value="Yes"> Yes </option>
      <option $addurl_reg_system_no value="No"> No </option>
    </select> 
        <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('If you use this then users will be required to register an verify their email addresses before they are able to submit links. Note that different <b>Add URL</b> and <b>Link Modify</b> templates are used as this option provides a control panel to users who submit links. Click the template manager tab for more details from the main control panel.');" onmouseout="tooltip.hide();" /></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>If you are using the
    'User Registration System', would you like users to validate new accounts by email?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="new_account_validation"
    size="1">
      <option $new_account_validation_yes value="Yes"> Yes </option>
      <option $new_account_validation_no value="No"> No </option>
    </select> 
       <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('<b>Yes</b> = When users register a new account they will then receive an email to validate the account before being able to login. Validating the account involves clicking a link sent to them via email. <BR><BR><b>No</b> = When users register a new account then they will be able to login without validating the new account via email. ');" onmouseout="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" ><strong>If you are using the
    'User Registration System', would you like to enable Image Authentication to the Registration form? </strong></td>
    <td class="tdclass" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><span  style="border-left: 1px solid rgb(221,221,221)">
      <select name="reg_img_auth"
    size="1">
        <option value="Yes" $reg_img_auth_yes> Yes </option>
        <option value="No" $reg_img_auth_no> No </option>
      </select>
    </span></td>
  </tr>
  
  <tr style="display:none">
    <td class="tdclass" ><strong>If you are using the
    'User Registration System', would you like people to be able to login with their FaceBook Accounts? If so then enter a FaceBook App ID: </strong></td>
    <td class="tdclass" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input name="facebookappid" type="text" id="facebookappid" value="$facebookappid" size="40"> 
      <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a FaceBook App ID visit https://developers.facebook.com/apps - Log in with your facebook details and click the Create New App button. Supply the details asked from you and you will receive an App ID / API Key - Enter the APP ID / API Key here.');" onmouseout="tooltip.hide();" /></span>
      </td>
  </tr>
  
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Would you like users
    to register an account to be able to post comments for links?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="comments_reg_system"
    size="1">
      <option $comments_reg_system_yes value="Yes"> Yes </option>
      <option $comments_reg_system_no value="No"> No </option>
    </select> 
       <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('Note that this setting has no effect if you are not using the user registration system.');" onmouseout="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Would you like users
    to register an account to be able to rate links?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="rateit_user_reg" size="1">
      <option $rateit_user_reg_yes value="Yes"> Yes </option>

      <option $rateit_user_reg_no value="No"> No </option>
    </select> 
       <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('Note that this setting has no effect if you are not using the user registration system.');" onmouseout="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>What 'Add URL' form
    will you be using?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="add_url_form" size="1">
      <option $add_url_form_medium value="medium"> Medium Sized Search Engine </option>
      <option $add_url_form_large value="large"> Large Search Engine </option>
    </select> 
       <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('Medium Sized Search Engine: The <b>add url</b> form for medium sized search engines, is recommended for search engines that is using less than 2000 directories. The directory tree is available as a drop down box on the submission form. <BR><BR><b>Large Sized Search Engine:</b> The <b>add url</b> form for large sized search engines is recommended for search engines that is using more than 2000 directories. The directory tree is not available as a drop down box on the submission form. Users have to go to the category where they would like to submit a new url and then click on the <b>add url</b> link.');" onmouseout="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Maximum Number of
    Description Characters?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="diz_chars"
    size="8" value="$diz_chars"> 
         <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('(Recommended 255)  - This is the maximum characters allowed in the description field when a link is submitted.');" onmouseout="tooltip.hide();" /></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Check for duplicates
    when new URLs are submitted?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="addurl_check_duplicates"
    size="1">
      <option $addurl_check_duplicates_yes value="Yes"> Yes </option>
      <option $addurl_check_duplicates_no value="No"> No </option>
    </select> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Check that a URL is
    present in the submission form?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="addurl_present" size="1">
      <option $addurl_present_yes value="Yes"> Yes </option>
      <option $addurl_present_no value="No"> No </option>
    </select> 
    <strong> <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('This setting is here to support a situation where a listing might not have a URL - so that it is accepted. ');" onmouseout="tooltip.hide();" /></span></strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Check that a modify
    password was entered?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="modify_pass_check" size="1">
      <option $modify_pass_check_yes value="Yes"> Yes </option>
      <option $modify_pass_check_no value="No"> No </option>
    </select> 
    <strong> <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('Users will not be able to modify their links/listings when set to <b>No</b>. When set to <b>Yes</b>, users will be authenticated before modifications are allowed.  ');" onmouseout="tooltip.hide();" /></span></strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Send 'Welcome Email'
    email?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="welcome_email" size="1">
      <option $welcome_email_yes value="Yes"> Yes </option>
      <option $welcome_email_no value="No"> No </option>
    </select> 
    <strong> <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('If set to <b>Yes</b>, a welcome email will be sent to the submitter of a of new submission. You can edit this email by clicking on the settings button in the control panel. Then click <b>Customize Emails </b>.');" onmouseout="tooltip.hide();" /></span></strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Be informed when new
    submissions are made?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="informer_email" size="1">
      <option $informer_email_yes value="Yes"> Yes </option>
      <option $informer_email_no value="No"> No </option>
    </select> 
    <strong> <span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('If set to <b>Yes</b>, an email will be sent to you, informing you of a new submission. ');" onmouseout="tooltip.hide();" /></span></strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Strip HTML Code from
    descriptions:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="strip_html_code" size="1">
      <option $strip_html_code_yes value="Yes"> Yes </option>
      <option $strip_html_code_no value="No"> No </option>
    </select> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Enable Image
    Authentication:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="img_auth" size="1">
      <option $img_auth_yes value="Yes"> Yes </option>
      <option $img_auth_no value="No"> No </option>
    </select> 
       <strong><span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('Note that if this is enabled then <b>Submission Services</b> will not be able to submit links to your search engine. This function has been implemented so that <b>Submission Services</b> are not able to do spam submissions. See the PowerSeek manual for more on this. ');" onmouseout="tooltip.hide();" /></span></strong></td>

  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of results to
    display on a 'per page' basis when approving new submissions:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text"
    name="newsubmissions_results" size="4" value="$newsubmissions_results"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Enable the
    reciprocal link checker for standard URLs?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="enable_reciprocal" size="1">
      <option $enable_reciprocal_y value="Yes"> Yes </option>
      <option $enable_reciprocal_n value="No"> No </option>
    </select> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Enable the
    reciprocal link checker for premium URLs?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="enable_reciprocal_premium"
    size="1">
      <option $enable_reciprocal_premium_y value="Yes"> Yes </option>
      <option $enable_reciprocal_premium_n value="No"> No </option>
    </select> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>If you answered
    'Yes' above then specify the URL that should be looked for at the submitters web site:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text"
    name="reciprocal_link_back" size="48" value="$reciprocal_link_back"> 
       <strong><span  style="border-left: 1px solid rgb(221,221,221)"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('When a user makes a submission then the URL that they provide (where they have linked to your web site) will be checked for the link you specify here. If it was not found then the user cannot submit a link. ');" onmouseout="tooltip.hide();" /></span></strong></td>
  </tr>
</table>

$shadow






<table border="0" cellpadding="6" width="100%" class="tdtable"
cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><a name="6"></a> <strong>6. Comment/Reviews Submission
    Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" valign="top" ><strong>Enable Image
    Authentication when visitors post comments:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="c_image_auth" size="1">
      <option $c_image_auth_y value="Yes"> Yes </option>
      <option $c_image_auth_n value="No"> No </option>
    </select> 
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This setting will block automated services from spamming via the comments feature. (Posting comments) ');" onMouseOut="tooltip.hide();"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" valign="top" ><strong>Number of comments
    to display on a per page basis when approving comments from the Control Panel:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="comments_nr"
    size="4" value="$comments_nr"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" valign="top" ><strong>Maximum amount of
    characters that may be used when adding a new comment:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text"
    name="comment_max_chars" size="6" value="$comment_max_chars"> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" valign="top" ><strong>When displaying
    Comments/Reviews sort them from:</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="comment_sorting" size="1">
      <option value="new" $comment_sorting_new> Latest to Oldest </option>
      <option value="old" $comment_sorting_old> Oldest to Latest </option>
    </select></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" valign="top" ><strong>Convert carriage returns to page breaks when displaying comments:</strong></td>
    <td class="tdclass" valign="top">
      <select name="commpagebreak" size="1" id="commpagebreak">
        <option $commpagebreak_Y value="Yes"> Yes </option>
        <option $commpagebreak_N value="No"> No </option>
      </select>
</td>
  </tr>
</table>

$shadow






<table border="0" cellpadding="6" width="100%" class="tdtable"
cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top"
    background="$web_url/bar7.gif"><a name="7"></a> <strong>7. Control Panel Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%"><strong>Number of link
    listings per page:</strong></td>
    <td class="tdclass" width="50%" valign="top"
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="cp_link_listings"
    size="4" value="$cp_link_listings"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%"><strong>Number of link
    listings per page when searching:</strong></td>
    <td class="tdclass" width="50%" valign="top"
    style="border-left: 1px solid rgb(221,221,221)"><input type="text"
    name="cp_search_listings" size="4" value="$cp_search_listings"></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">

    <td class="tdclass" width="50%"><strong>Display of HTML:</strong></td>
    <td class="tdclass" width="50%" valign="top"
    style="border-left: 1px solid rgb(221,221,221)"><select name="htmldisplay" size="1">
      <option value="htmlon" $htmlon> Display of HTML code on </option>
      <option value="htmloff" $htmloff> Display of HTML code off </option>
    </select>
       <span class="normaltext"><img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If link listings contain HTML code then errors in this HTML code may cause incorrect displays of links inside the Directory Manager. It can also cause situations where the links cannot be edited/moved/copied/deleted because the HTML errors inside links interfere with the HTML code of the Directory Manager. You can solve this problem by turning on the display of HTML code so that HTML code inside listings are ignored. (Not interpreted as HTML) ');" onMouseOut="tooltip.hide();"></span></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" ><strong>HTML Encoding to use in Control Panel: </strong></td>
    <td class="tdclass" valign="top"
    style="border-left: 1px solid rgb(221,221,221)">      <input name="cp_encoding_to_use" type="text" id="cp_encoding_to_use" style="width:100%" value="$cp_encoding_to_use"></td>
  </tr>
</table>
$shadow





<table border="0" cellpadding="6" width="100%" class="tdtable"
cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><a name="8"></a> <strong>8. What's New &amp; Top Hits
    Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of links to
    display on the What's New page?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="whatsnew_link_no"
    size="4" value="$whatsnew_link_no"> 
       <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If you for example specify 20, then the 20 latest additions will be displayed.');" onMouseOut="tooltip.hide();"><br></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" ><strong>Number of links to
    display on Top Hits page?</strong></td>
    <td class="tdclass" width="50%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="tophits_link_no"
    size="4" value="$tophits_link_no"> 
     <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If you for example specify 20, then the 20 links that had the most <b>hits</b> will be displayed. ');" onMouseOut="tooltip.hide();">&nbsp;&nbsp; </td>
  </tr>
</table>
$shadow







<table border="0" cellpadding="6" width="100%" class="tdtable" cellspacing="0">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top" 
    background="$web_url/bar7.gif"><a name="9"></a> <strong>9. New &amp; Popular Indication
    Settings</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="74%"><strong>How old should a
    link be where it will receive a 'New' indication? <br>
    </strong>(This is applicable for new1.gif) <br>
    new1.gif is located here: <br>
    <strong>$web_url/new1.gif</strong></td>
    <td class="tdclass" width="26%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="days1" size="7"
    value="$days1"> Days </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="74%"><strong>How old should a
    link be where it will receive a 'New' indication? <br>
    </strong>(This is applicable for new2.gif) <br>
    new2.gif is located here: <strong><br>
    $web_url/new2.gif</strong></td>
    <td class="tdclass" width="26%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="days2" size="7"
    value="$days2"> Days </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="74%"><strong>How old should a
    link be where it will receive a 'New' indication? <br>
    </strong>(This is applicable for new3.gif) <br>
    new3.gif is located here: <strong><br>
    $web_url/new3.gif</strong></td>
    <td class="tdclass" width="26%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="days3" size="7"
    value="$days3"> Days </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="74%"><strong>Would you like to
    display a 'Pop' (Popular) Graphic next to links that is considered to be popular? <br>
    </strong>pop.gif that is used is located here: <strong><br>
    $web_url/pop.gif</strong></td>
    <td class="tdclass" width="26%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><select name="popular_links" size="1">
      <option $popular_links_yes value="Yes"> Yes </option>
      <option $popular_links_no value="No"> No </option>
    </select> </td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="74%"><strong>How many hits/clicks
    should a link have received before it is considered as being popular?</strong></td>
    <td class="tdclass" width="26%" valign="top" 
    style="border-left: 1px solid rgb(221,221,221)"><input type="text" name="pop_links_amount"
    size="12" value="$pop_links_amount"> </td>
  </tr>
</table>


$shadow



<table border="0" cellpadding="6" width="100%" class="tdtable" cellspacing="0" >
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" colspan="2" valign="top"  height="21"
    background="$web_url/bar7.gif"><a name="10"></a> <strong>10. Modifying of links</strong></td>
  </tr>
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="tdclass" width="50%" valign="top"><strong>Require
    users to supply a password to be able to modify links? <br>
    </strong>    (This setting is only valid if the
    registration system is not in use)</td>
    <td class="tdclass" width="50%" valign="top"
    style="border-left: 1px solid rgb(221,221,221)"><select name="modif_password" size="1">
      <option $modif_password_yes value="Yes"> Yes </option>
      <option $modif_password_no value="No"> No </option>
    </select></td>
  </tr>
</table>

$shadow



<table border="0" cellpadding="6" width="100%" style="border: 1px solid rgb(221,221,221)">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="101%" valign="top"><input type="submit" class="psbutton" value="     Save     " name="add"> <span
    class="normaltext">Click the save button to save all settings on this page. </span></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
];


}




sub start
{

if ($gsettings->{addurl_reg_system} eq "Yes")
	{
	$reg_system_note = "<b>The user registration system is currently in use.</b>";
	}
	else
	{
	$reg_system_note = "<b>The user registration system is currently not use. See the PowerSeek documentation on turning it on if you would like to use it.</b>";
	}


$boxdiz = qq[Various settings and options that lets you change the way in which your Search Engine & Directory operates.];
$headingd = acs::get_heading_box("$web_url/ic_settings3_1_main.gif", "Settings", $boxdiz); 

$stmpl = qq[



$headingd
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="859">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><p align="center"><img
    src="$web_url/ics_settings5.gif"><br>
        <img src="$web_url/55.gif" width="54" height="1"> </td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin10.cgi?fct=global_settings"
    onClick="popup('$admin_url/admin10.cgi?fct=global_settings',950,650);return false;">Global
      Engine Settings </a><br>
      </strong>These settings affect the way in which your Search Engine &amp; Directory
      functions. </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ics_email1.gif"></td>
    <td height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin85.cgi"
    onClick="popup('$admin_url/admin85.cgi',750,600);return false;">Contact Us Form Settings</a><br>
    </strong>These settings are used to configure the contact form when visitors fills in the contact form to contact you.</td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ics_settings4.gif"></td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin50.cgi"
    onClick="popup('$admin_url/admin50.cgi',750,600);return false;">HTML Generation Resource
      Usage </a><br>
      </strong>PowerSeek can use a lot of server resources when you generate HTML files. You can
      slow down the generation process to conserve server resource usage with the settings
      provided in this section. </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><p align="center"><img
    src="$web_url/ics_settings6.gif"> </td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin16.cgi"
    onClick="popup('$admin_url/admin16.cgi',950,650);return false;">Customize
      Emails </a><br>
      </strong>These emails are sent out to users when they submit new listings, modify
      listings, or register user accounts. </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><p align="center"><img
    src="$web_url/ics_texts.gif"> </td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin35.cgi"
    onClick="popup('$admin_url/admin35.cgi',950,650);return false;">Text
      Configurations </a><br>
      </strong>You can customize the text in this section. These texts are used in various
      responses to errors, (when users complete forms) and other situations. </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/icm_premium.gif" alt=""></td>
    <td height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/admin23.cgi" 
    onClick="popup('$admin_url/admin23.cgi',950,650, 'fieldkey');return false;"><strong>Premium Link Settings</strong></a><strong><br>
    </strong>Settings regarding Premium Links.</td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img src="$web_url/ics_key.gif"></td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin37.cgi"
    onClick="popup('$admin_url/admin37.cgi',950,650, 'fieldkey');return false;">Extra
      Fields/Keys </a><br>
      </strong>Add/Remove/Change extra fields/keys. Extra fields enable you to collect
      additional data for links like for example: telephone numbers, addresses or any other
      details that you would like included with links. </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ics_ukey.gif"></td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin53.cgi"
    onClick="popup('$admin_url/admin53.cgi',950,650, 'fieldkey');return false;">User
      Extra Fields/Keys Settings</a><br>
      </strong>When you use the user registration system where users are required to create an
      account before being able to post a link then you can collect extra information from users
      by defining extra fields/keys when a user account is registered. $reg_system_note </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ics_comment.gif"></td>
    <td height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin53.cgi?fct=comfields"
    onClick="popup('$admin_url/admin53.cgi?fct=comfields',950,650, 'fieldkey');return false;">Comments/Reviews Extra Fields/Keys Settings</a><br>
      </strong>This option enables you to Add/Remove/Change extra fields/keys for user reviews. With the extra field/key functionality for comments/reviews you can collect extra information from users posting comments/reviews for links. </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" height="30" align="center"><img src="$web_url/ics_add.gif"></td>
    <td height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/p_addurl.cgi" 
    onClick="popup('$admin_url/p_addurl.cgi',990,650);return false;">Extra Add URL / Modify Forms</a></strong><br>
      Let's you create extra 'Add URL' and 'Modify' forms for the  submission of special links or listings. If you   have a  Directory of links and an Article section and you   also want people to  submit Articles then you would for use an   extra 'Add URL' form especially available for the submission of Articles.</td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" height="30" align="center"><img src="$web_url/ics_smap.gif"></td>
    <td height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/p_gmap.cgi" 
    onClick="popup('$admin_url/p_gmap.cgi',950,650);return false;">Google SiteMaps</a></strong><br>
      Enables you to edit Google SiteMap settings and SiteMap settings regarding categories and links.
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img src="$web_url/ics_rss.gif"></td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/admin71.cgi"
    onClick="popup('$admin_url/admin71.cgi',950,650);return false;">RSS
      Feed Configuration </a><br>
      </strong>Configure RSS Feeds for the Directory. </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ics_search22.gif"></td>
    <td width="99%" height="65" bgcolor="#FFFFFF" class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong><a
    href="$admin_url/p_specsearch.cgi"
    onClick="popup('$admin_url/p_specsearch.cgi',950,650, 'fieldkey');return false;">Create/Configure
      Advanced Searches</a><br>
      </strong>This functionality lets you create custom searches with their own look and feel.
      It allows you create for example, price range searches, city searches, city/state
      searches, etc. The list of searches that could be created is practically endless.</td>
  </tr>
  
</table>


<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>
];

$template = acs::get_template("SETTINGS");
$template =~ s/!!data!!/$stmpl/gi;
print "$template";

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

