#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "getstats") {&getstats;}
if ($q->param('fct') eq "del_stats") {&del_stats;}
if ($q->param('fct') eq "delete_final") {&delete_final;}
if ($q->param('fct') eq "delete") {&delete_keyword;}

if ($q->param('fct') eq "save_settings") {&save_settings;}



##################################################################################

sub save_settings
{

$log_search_keywords = $q->param('log_search_keywords');

$restrict = $q->param('restrict');
$maxlen  = $q->param('maxlen');

acs::write_config("log_search_keywords", $log_search_keywords);

open (DTA, "> $data_dir/searchlog.dat");
	print DTA $maxlen . "\n";
	print DTA $restrict . "\n";
close (DTA);

$hbox = acs::get_heading_box("$web_url/ic_stats.gif", "Settings Saved", qq[<a href="$admin_url/admin32.cgi">Click Here to Continue.</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];


}




sub delete_keyword
{

$keywords = $q->param('keywords');
$keywords =~ s/'/\\'/g; 

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "DELETE FROM keywlog WHERE keyword = '$keywords'";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

$sth->finish;
$dbh->disconnect; 

$hbox = acs::get_heading_box("$web_url/ic_stats.gif", "Search Term Statistics", qq[Keyword deleted from keyword statistics.<BR><a href="$admin_url/admin32.cgi"><b>Click Here to Continue.</b></a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];


}



sub delete_final
{
if ($q->param('bno') eq "   No   "){&start; exit;}

$from_date = $q->param('from_date');

$to_date = $q->param('to_date');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "DELETE FROM keywlog WHERE (kwdate >= '$from_date') AND (kwdate <= '$to_date')";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

$sth->finish;
$dbh->disconnect; 



$hbox = acs::get_heading_box("$web_url/ic_stats.gif", "Search Term Statistics Deleted", qq[<a href="$admin_url/admin32.cgi">Click Here to Continue.</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

}



sub del_stats
{

$kstatsdate_from = $q->param('dstatsdate_from');
($from_year, $from_month, $from_day) = split (/-/, $kstatsdate_from);
$from_date = "$from_year-$from_month-$from_day";

if (length($from_day) eq "1"){ $from_day = "0" . $from_day; }
if (length($from_month) eq "1"){ $from_month = "0" . $from_month; }

$from_date = "$from_year-$from_month-$from_day";


##########

$kstatsdate_to = $q->param('dstatsdate_to');
($to_year, $to_month, $to_day) = split (/-/, $kstatsdate_to);
$to_date = "$to_year-$to_month-$to_day";

if (length($to_day) == 1){ $to_day = "0" . $to_day; }
if (length($to_month) == 1){ $to_month = "0" . $to_month; }

########

$to_date = "$to_year-$to_month-$to_day";

$boxdiz = qq[
<span class="normaltext">This will delete all search term statistics from <strong>$from_date </strong>to <strong>$to_date
</strong></span>
<form method="POST" action="$admin_url/admin32.cgi">
  <input type="hidden" name="fct" value="delete_final"><input type="hidden" name="from_date"
  value="$from_date"><input type="hidden" name="to_date" value="$to_date"><p><strong>Are you
  sure? </strong><BR><BR><input type="submit" class="psbutton" value="   Yes   " name="byes"> <input type="submit" class="psbutton"
  value="   No   " name="bno"> </p>
</form>
];

$hbox = acs::get_heading_box("$web_url/ic_stats.gif", "Search Term Statistics", $boxdiz);



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

}






sub getstats
{

$gsettings = new_gsettings acs; 
$searchmeth = $gsettings->{searchmeth};

if ($searchmeth eq "pseek")
	{
	$searche_script = "$script_url/search.cgi";
	}
	else
	{
	$searche_script = "$script_url/search2.cgi";
	}

$kstatsdate_from = $q->param('kstatsdate_from');
($from_year, $from_month, $from_day) = split (/-/, $kstatsdate_from);
$from_date = "$from_year-$from_month-$from_day";

$kstatsdate_to = $q->param('kstatsdate_to');
($to_year, $to_month, $to_day) = split (/-/, $kstatsdate_to);
$to_date = "$to_year-$to_month-$to_day";

$total_records = $q->param('total_records');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

if ($total_records eq "")
	{
	$sql = "SELECT COUNT(*) FROM keywlog";
	$sth = $dbh->prepare($sql);
	$sth->execute;	
	while ( @row = $sth->fetchrow() )
		{
		$total_records = $row[0];
		}
	}



$hbox = acs::get_heading_box("$web_url/ic_stats.gif", "Search Term Statistics", qq[Total Searches: $total_records]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
<span class="normaltext">
<strong><a href="$admin_url/admin32.cgi">Search Term Statistics </a>&gt; Statistics </strong>from
<strong>$from_date </strong>to <strong>$to_date </strong></span><BR><BR>
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DBDBDB">
  <tr>
    <td width="15%" background="$web_url/bar7.gif" class="normaltext"><strong>Keyword </strong></td>
    <td width="15%" background="$web_url/bar7.gif" class="normaltext"><strong>Last Searched </strong></td>
    <td width="10%" background="$web_url/bar7.gif" class="normaltext"><strong>Searches </strong></td>
    <td width="10%" background="$web_url/bar7.gif" class="normaltext"><strong>Delete </strong></td>
    <td width="50%" background="$web_url/bar7.gif" class="normaltext"><strong>Graph </strong></td>
  </tr>
];

##############


$keywords = $q->param('keywords');
$per_page = $q->param('per_page');

if ($keywords ne "")
	{
	$kwmatch = "AND (keyword like '%$keywords%')";
	}


#######




$st = $q->param('st');
$nd = $q->param('nd');
$nr_searchres = $q->param('searchnr');
$searchnr = $q->param('searchnr');
$total = $q->param('total');

if ($total ne "")
	{
	$limit = "LIMIT $st, $nr_searchres";
	$rows = $total;
	$high_number =  $q->param('high_number');
	$highc = 10;
	}
	else
	{

	$sql = "SELECT kwdate, keyword, COUNT(*) AS val FROM keywlog 
	WHERE (keyword != '') AND (kwdate >= '$from_date') AND (kwdate <= '$to_date')
	$kwmatch
	GROUP BY keyword ORDER BY val DESC";
	$sth = $dbh->prepare($sql);
	$sth->execute;	
	$rows = $sth->rows();

	$limit = "LIMIT 0, $nr_searchres";
	$high_number = 0;
	$highc = 0;
	}



$sql = "SELECT kwdate, keyword, COUNT(*) AS val FROM keywlog 
WHERE (keyword != '') AND (kwdate >= '$from_date') AND (kwdate <= '$to_date')
$kwmatch
GROUP BY keyword ORDER BY val DESC $limit";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}





### PREPARE PAGES
$icnt = $rows;


$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}


if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}
$ippc = 1; 
$cc = 0;
 



while ( @row = $sth->fetchrow() )
	{
	if ($highc == 0){$high_number = $row[2];}	$highc++;

	$ratio = $row[2] * 100 / $high_number;
	$ratio = sprintf("%5.2f",$ratio); 
	$ratio = $ratio . "%"; 	
	
	$kwsearch = $row[1];
	$kwsearch =~ s/ /+/gi;
	$kwsearch =~ s/<//g; $kwsearch =~ s/>//g;
	$row[1] =~ s/<//g; $row[1] =~ s/>//g;
	
	$rev_ratio = 100 - $ratio;
	
print qq[
 <tr>
    <td width="15%" bgcolor="#FFFFFF" class="normaltext"><a href="$searche_script?keywords=$kwsearch"
    target="_blank">$row[1] </a></td>
    <td width="15%" bgcolor="#FFFFFF" class="normaltext">$row[0] </td>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext">$row[2] </td>
    <td width="10%" bgcolor="#FFFFFF" class="normaltext"><a
    href="$admin_url/admin32.cgi?keywords=$kwsearch&amp;fct=delete">Delete </a></td>
    <td bgcolor="#FFFFFF" width="50%">
<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)">
<tr>
<td width="$ratio%" background="$web_url/bar.gif" height="20"> </td>
<td width="$rev_ratio%"> </td>
</tr>
</table>
    </td>
  </tr>
];


	#print "$row[0] <br>";
	#print "$row[1] <br>";
	#print "$row[2] <br><br>";

	
	$ippc++; 
	$total_records = $total_records + $row[2];
	}

$sth->finish;
$dbh->disconnect; 

##########


#### PAGES 

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/admin32.cgi?st=$st1&nd=$nd1&fct=getstats&from_day=$from_day&from_month=$from_month&from_year=$from_year&to_day=$to_day&to_month=$to_month&to_year=$to_year&keywords=$keywords&searchnr=$searchnr&total=$rows&high_number=$high_number&total_records=$total_records\">$pg</a> ";
		}
	}







if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}

$page_crit = $page_crit .  $pgstring . "<BR><BR>"; 



print qq[
</table>
<span class="normaltext">
<p><a href="$admin_url/admin32.cgi"><b><< Go Back</b></a></p>
$page_crit
</span>
</body>
</html>
];


}



######


sub start
{


$gsettings = new_gsettings acs;

$log_search_keywords = $gsettings->{log_search_keywords};

if ($log_search_keywords eq "Yes")
	{
	$log_search_keywords_yes = "selected"; 
	}
	else
	{
	$log_search_keywords_no = "selected"; 
	}


$details = acs::get_file_contents("$data_dir/searchlog.dat");
($maxlen, $restrict) = split (/\n/, $details);

if ($maxlen eq "") { $maxlen = "30"; }

if ($restrict eq "No")
	{
	$restrict_no = "selected";
	}
	else
	{
	$restrict_yes = "selected";
	}


($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$year = $year + 1900;
$mon++;
if (length($mon) == 1) { $mon = "0" . $mon; }
if (length($mday) == 1) { $mday = "0" . $mday; }


$kstatsdate_from = $year . "-" . $mon . "-" . "01";
$kstatsdate_to = $year . "-" . $mon . "-" . $mday;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT COUNT(*) FROM keywlog");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - SELECT COUNT(*) FROM keywlog";}
while ( @row = $sth->fetchrow() ){$total_nr_searches = $row[0];}
 
$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_stats.gif", "Search Term Statistics", qq[Statistics on what keywords was searched for and what keywords was searched for the most.]);

print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
<link href="$web_url/calendar.css" rel="stylesheet" type="text/css" /> 
<script SRC="$web_url/calender_db.js"></script>

<script language="JavaScript">
var A_TCALDEF = {
	'months' : ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
	'weekdays' : ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
	'yearscroll': true, // show year scroller
	'weekstart': 0, // first day of week: 0-Su or 1-Mo
	'centyear'  : 70, // 2 digit years less than 'centyear' are in 20xx, othewise in 19xx.
	'imgpath' : '$web_url/' // directory with calendar images
}

function checkdt (fromd, tod)
	{
	var rtd1 = f_tcalParseDate(document.getElementById(fromd).value);
	if (rtd1 == undefined) { return false; }
	
	var rtd2 = f_tcalParseDate(document.getElementById(tod).value);
	if (rtd2 == undefined) { return false; }
	}

function checkbv()
	{
	if (document.getElementById('maxlen').value < 5)
		{
		alert ('Please provide a value for the maximum length a keyword may be. It must be larger than 4.');
		return false;
		}
	
	}

</script> 

</head>
<body>
$hbox
<form method="POST" action="$admin_url/admin32.cgi" name="kstats" onSubmit="return checkdt('kstatsdate_from', 'kstatsdate_to')" >
  <input type="hidden" name="fct" value="getstats"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="780" height="30" colspan="2" background="$web_url/bar7.gif" class="normaltext"><strong>Keywords Statistics </strong></td>
    </tr>
    <tr>
      <td width="766" colspan="2" bgcolor="#F4F4F4" class="normaltext">Choose a date range below for keyword
      statistics between a time frame: </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">From Date: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext">
	  <input name="kstatsdate_from" type="text" id="kstatsdate_from" value="$kstatsdate_from" size="15" />
	  <script language="JavaScript">
new tcal ({
'formname': 'kstats',
'controlname': 'kstatsdate_from'
});
</script>    
  
  (yyyy-mm-dd) </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">To Date:&nbsp; </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext">
	   <input name="kstatsdate_to" type="text" id="kstatsdate_to" value="$kstatsdate_to" size="15" /> 
	  <script language="JavaScript">
new tcal ({
'formname': 'kstats',
'controlname': 'kstatsdate_to'
});
</script>
	  (yyyy-mm-dd) </td>
    </tr>
    <tr>
      <td width="144" valign="top" bgcolor="#FFFFFF" class="normaltext">Terms/Keywords: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="keywords" size="32"> Optional <br>
      Leave blank if you just want to know the 'most searched for' terms/keywords between a
      specific time frame. </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">How many keyword to display on a 'per page' basis: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="searchnr" size="1">
        <option value="20"> 20 </option>
        <option value="50"> 50 </option>
        <option value="100"> 100 </option>
        <option value="200" selected> 200 </option>
        <option value="300"> 300 </option>
        <option value="400"> 400 </option>
        <option value="500"> 500 </option>
        <option value="700"> 700 </option>
        <option value="1000"> 1000 </option>
        <option value="5000"> 5000 </option>
      </select> </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" value="   Get Statistics   "
      name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0">
  <tr>
    <td bgcolor="#F4F4F4" width="766"><p align="left">Total Number of Searches Recorded: <strong>$total_nr_searches
    (log entries) </strong></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table><BR>


<form method="POST" action="$admin_url/admin32.cgi" name="dstats" onSubmit="return checkdt('dstatsdate_from', 'dstatsdate_to')">
  <input type="hidden" name="fct" value="del_stats"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="780" height="30" colspan="2" background="$web_url/bar7.gif" class="normaltext"><strong>Delete Keyword Statistics </strong></td>
    </tr>
    <tr>
      <td width="766" colspan="2" bgcolor="#F4F4F4" class="normaltext">It is usually a good idea to delete keyword
      statistics to conserve disk space. </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">From Date: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext">
       <input name="dstatsdate_from" type="text" id="dstatsdate_from" value="$dstatsdate_from" size="15" /> 
	  <script language="JavaScript">
new tcal ({
'formname': 'dstats',
'controlname': 'dstatsdate_from'
});
</script> 
	  (yyyy-mm-dd) </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">To Date:&nbsp; </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"> 
	  <input name="dstatsdate_to" type="text" id="dstatsdate_to" value="$dstatsdate_to" size="15" /> 
	  <script language="JavaScript">
new tcal ({
'formname': 'dstats',
'controlname': 'dstatsdate_to'
});
</script> 
	  (yyyy-mm-dd) </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" value="   Delete Statistics  "
      name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
<form method="POST" action="$admin_url/admin32.cgi" onSubmit="return checkbv()">
  <input type="hidden" name="fct" value="save_settings"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td height="30" colspan="2" background="$web_url/bar7.gif" class="normaltext"><strong>Keyword Logging Settings</strong></td>
    </tr>
    <tr>
      <td width="221" bgcolor="#FFFFFF" class="normaltext">Enable Keyword Logging?</td>
      <td width="983" bgcolor="#FFFFFF" class="normaltext"><select name="log_search_keywords" size="1">
        <option $log_search_keywords_yes value="Yes">Yes</option>
        <option $log_search_keywords_no value="No">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="221" bgcolor="#FFFFFF" class="normaltext">Maximum length of keywords:</td>
      <td width="983" bgcolor="#FFFFFF" class="normaltext"><label><input
      name="maxlen" type="text" id="maxlen" value="$maxlen" size="8">
      </label><br>
      If a keyword or set of keywords exceeds this length then it won't be recorded.</td>
    </tr>
    <tr>
      <td width="221" valign="top" bgcolor="#FFFFFF" class="normaltext">Implement Character Restrictions?</td>
      <td width="983" bgcolor="#FFFFFF" class="normaltext"><label></label><select name="restrict"
      size="1">
        <option value="Yes" $restrict_yes>Yes - Recommended</option>
        <option value="No" $restrict_no>No</option>
      </select><br>
      Choosing 'Yes' will have the effect of keywords that doesn't contain letters within the
      English alphabet not being logged. This is here to block spammers trying to spam the 'Top
      Search Term Includes' if you are using this plugin. The 'Top Search Term Includes' plugin
      allows you to display keywords that was most searched for.<label></label></td>
    </tr>
    <tr>
      <td width="221" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="983" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Save Settings  " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>

];

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

