#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

eval 'use Image::Magick;';
if ($@ ne "") { $IM = "false"; } else { $IM = "true"; }

eval 'use Image::Resize;';
if ($@ ne "") { $IMRES = "false"; } else { $IMRES = "true"; }

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "edit") {&edit_keyfield;}
if ($q->param('fct') eq "save_field_key") {&save_field_key;}
if ($q->param('fct') eq "add_field") {&add_field;}
if ($q->param('fct') eq "add_field2") {&add_field2;}
if ($q->param('fct') eq "add_field_final") {&add_field_final;}
if ($q->param('fct') eq "add_field_final2") {&add_field_final2;}
if ($q->param('fct') eq "delfield") {&delfield;}
if ($q->param('fct') eq "delfield_final") {&delfield_final;}
if ($q->param('fct') eq "delfield_final2") {&delfield_final2;}
if ($q->param('fct') eq "fix") {&fix_indexes;}

if ($q->param('fct') eq "describe_field_type") {&describe_field_type;}
if ($q->param('fct') eq "implement") {&implement;}


##################################################################################

sub implement
{

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;

$curf = $q->param('p');

foreach $kitem (@akeys)
	{
	if ($q->param('p') == $nrc)
		{
		($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $kitem);
		
				### DETERMINE FIELD TYPE
				if ($numberfield eq "Y") 
						{
						$numberfield = "Numbers";
						$e_field_type = "Number Field";
						}
				elsif ($numberfield eq "Upload") 
						{
						$numberfield = "Upload"; 
						$e_field_type = "Upload Field";
						}
				elsif ($imagef eq "Yes") 
						{
						$numberfield = "Image"; 
						$e_field_type = "Image Field";
						}
				elsif ($numberfield eq "Content") 
						{
						$numberfield = "Content"; 
						$e_field_type = "Content Field";
						}
					else
						{ 
						$numberfield = "Characters"; 
						$e_field_type = "Character Field";
						}
						
						$c_keyname = $keyname;
						
		}
	$nrc++;
	}





$boxdiz = qq[
This section explains how to display the contents of this extra field with link listings. It will also explain how to implement this field within 'Add URL' and 'Modify' forms.
<BR><a href="$admin_url/admin37.cgi"><b>Go Back</b></a><BR><BR>
<b>Field Name:</b> $keyname<BR>
<b>Field Description:</b> $description<BR>
<b>Field Type:</b> $numberfield
];

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Extra Field Implementation For: $c_keyname", $boxdiz);


	$t1_links =  "&lt;b&gt;$description&lt;/b&gt; : !!" . $keyname . "!!";
	$t1_linksp = "&lt;b&gt;$description&lt;/b&gt; : !!" . $keyname . "!!";
	
if ($numberfield eq "Upload")
	{
	$add_url = qq[$description: &lt;input type=&quot;file&quot; name=&quot;$keyname&quot; size=&quot;20&quot;&gt;];
	$modify = qq[%%!!keyname!!_file_with_link%%<br />\n
[!!keyname!!_no_filename_text]No File Available[!!keyname!!_no_filename_text_end]<br />\n
&lt;br&gt; &lt;input type=&quot;file&quot; name=&quot;!!keyname!!&quot; size=&quot;20&quot;&gt;&lt;br&gt;<br />\n
[!!keyname!!_del_text]Delete File? [!!keyname!!_del_text_end]%%!!keyname!!_checkbox%%];
	$modify =~ s/!!keyname!!/$keyname/gi;
	
	$upnotice = qq[<blockquote><font class="normaltext">Modify the &lt;FORM&gt; tag of the Add URL form so that it looks like this: <b><br>&lt;form method="POST" action="!!addurlcgi!!" ENCTYPE="multipart/form-data"&gt;</font></b></blockquote>];
	
	$mupnotice = qq[<blockquote><font class="normaltext">Modify the &lt;FORM&gt; tag of the Modify form so that it looks like this: <b><br>&lt;form method="POST" action="!!modify_cgi!!" ENCTYPE="multipart/form-data"&gt;</font></b></blockquote>];
	
	}
	elsif ($numberfield eq "Content")
	{

$add_url_plain = qq[
<script type="text/javascript" src="$web_url/edt/tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
tinyMCE.init({
// General options
mode : "specific_textareas",
editor_selector : "mceEditor",
theme : "advanced",
plugins : "autolink,lists,spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",

// Theme options
theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,spellchecker,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,blockquote,pagebreak,|,insertfile,insertimage",
theme_advanced_toolbar_location : "top",
theme_advanced_toolbar_align : "left",
theme_advanced_statusbar_location : "bottom",
theme_advanced_resizing : true,

// Skin options
skin : "o2k7",
skin_variant : "silver",

// Example content CSS (should be your site CSS)
content_css : "$web_url/ps.css",

template_external_list_url : "js/template_list.js",
external_link_list_url : "js/link_list.js",
external_image_list_url : "js/image_list.js",
media_external_list_url : "js/media_list.js"

});
</script>
<textarea name="Article" id="mceEditor" class="mceEditor" cols="45" rows="20" style="width:100%">!!keyname!!</textarea>
];

$add_url_plain =~ s/&/&amp;/gi;
$add_url_plain =~ s/</&lt;/gi;
$add_url_plain =~ s/>/&gt;/gi;

$add_url_plain =~ s/!!keyname!!/!!$keyname!!/gi;

$add_url	= qq[Copy and paste the code below into Add URL template:<textarea name="textarea" id="textarea" cols="45" rows="20" style="width:100%">$add_url_plain</textarea>];


##########################################
	
$modify	= qq[Copy and paste the code below into Add URL template:<textarea name="textarea" id="textarea" cols="45" rows="20" style="width:100%">$add_url_plain</textarea>];
	
	
	
	}
	else #####
	{
	$add_url = qq[$description: &lt;input type=&quot;text&quot; name=&quot;$keyname&quot; size=&quot;20&quot; value=&quot;!!$keyname!!&quot;&gt;];
	$add_url =~ s/!!keyname!!/$keyname/gi;
	$modify = qq[$description: &lt;input type=&quot;text&quot; name=&quot;!!keyname!!&quot; size=&quot;20&quot; value=&quot;!!!!keyname!!!!&quot;&gt;];
	$modify =~ s/!!keyname!!/$keyname/gi;
	}

$jspopup_code = acs::get_popupjs;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<script LANGUAGE="JavaScript">
$jspopup_code 
</script>
</head>
<body>
$hbox


<p><strong>How to display this field ( $c_keyname ) with link listings:</strong></p>
<blockquote>
  <p><strong>Displaying this field with links inside Categories:</strong></p>
  <blockquote>
    <p><strong>Step 1:</strong> (Edit Standard Link Style Template)<br>
      To display the contents of this field within links inside categories go to the <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank");return false;"><strong>1. Default Category/Directory Templates</strong></a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch',screen.width-280,screen.height-280);return false;"><strong>Links Style</strong></a> - You may also <strong><a href="$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch',screen.width-280,screen.height-280);return false;">click here</a></strong> to edit the Standard Link Style Template. Add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
      </tr>
    </table>
    <p><strong>Step 2:</strong> (Edit Premium Link Style Template)<br>
      To display the contents of this field within premium links inside categories go to the <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank");return false;"><strong>1. Default Category/Directory Templates</strong></a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem',screen.width-280,screen.height-280);return false;"><strong>Premium Links Style</strong></a> - You may also <strong><a href="$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem',screen.width-280,screen.height-280);return false;">click here</a></strong> to edit the Premium Link Style Template. Add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_linksp</strong></td>
      </tr>
    </table>
  </blockquote>
  <p>&nbsp;</p>
  <p><strong>Displaying this field within  'Link Info' or also called 'More Info' pages:</strong></p>
  <blockquote>
    <p><strong>Step 1:</strong> (Edit Standard Link Info Template)<br>
      To display the contents of this field within Link Info pages (individual information pages for links) go to the <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank");return false;"><strong>1. Default Category/Directory Templates</strong></a><a href="$admin_url/admin6.cgi?t=1#1" target="_blank"></a></strong> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?fct=edit_template&template=linkinfo" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=linkinfo',screen.width-280,screen.height-280);return false;">Link Info</a></strong> - You may also <strong><a href="$admin_url/admin6.cgi?fct=edit_template&template=linkinfo" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=linkinfo',screen.width-280,screen.height-280);return false;">click here</a></strong> to edit the Standard Link Info Template. Add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
      </tr>
    </table>
    <p><strong>Step 2:</strong> (Edit Premium Link Info Template)<br>
      To display the contents of this field within Premium Link Info pages (individual information pages for links) go to the <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank");return false;"><strong>1. Default Category/Directory Templates</strong></a><a href="$admin_url/admin6.cgi?t=1#1" target="_blank" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=dir_templates', 'result1', 1);return false;"></a></strong> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?fct=edit_template&template=linkinfop" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=linkinfop',screen.width-280,screen.height-280);return false;">Premium Link Info</a></strong> - You may also <strong><a href="$admin_url/admin6.cgi?fct=edit_template&template=linkinfop" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=linkinfop',screen.width-280,screen.height-280);return false;">click here</a></strong> to edit the Standard Link Info Template. Add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_linksp</strong></td>
      </tr>
    </table>
  </blockquote>
  <p>&nbsp;</p>
  <p><strong>Displaying this field within Search Results:</strong></p>
  <blockquote>
    <p><strong>Step 1:</strong>  (Edit Standard Link Style Search Template)<br>
To display the contents of this field within with links that matched as search results go to the <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=2#2" target="_blank"><strong>2. Search Result Templates</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc"
onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc',screen.width-280,screen.height-280);return false;"><strong>Link Style</strong></a> - You may also <a href="$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the Standard Search Link Style template. Add the following HTML code to the template:<br>
    </p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
      </tr>
    </table>
    <p><strong>Step 2:</strong> (Edit Premium Link Style Search Template)<br>
To display the contents of this field within with premium links that matched as search results go to the <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=2#2" target="_blank"><strong>2. Search Result Templates</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc_prem"
onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc_prem',screen.width-280,screen.height-280);return false;"><strong>Premium Link Style</strong></a> - You may also <a href="$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc_prem"
onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc_prem',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the Standard Search Link Style template. Add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_linksp</strong></td>
      </tr>
    </table>
  </blockquote>
  <p>&nbsp;</p>
  <p><strong>Letting users add data to this field when Submitting a Link or Modifying a link</strong></p>
  <blockquote>
    <p><strong>Step 1:</strong> (Edit 'Add URL' form)<br>
      To let users submit to this extra field when doing a new submission go to the Control Panel &gt;&gt; 
    <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=3#3" target="_blank"><strong>3. Add URL Templates</strong></a> &gt;&gt;<strong> Scroll down to the section reading: User Registration System Add URL Templates</strong> &gt;&gt; <strong>Click on the <a href="$system_in_use_addurl"
    onClick="popup('$system_in_use_addurl',screen.width-280,screen.height-280);return false;">'Add URL Template 1'</a> Link</strong> - You may also <a href="$system_in_use_addurl"  onClick="popup('$system_in_use_addurl',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the 'Add URL' template. Now add the following HTML code to the template between the &lt;FORM&gt; tags:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$add_url</strong></td>
      </tr>
    </table>
    $upnotice
    <p><strong>Step 2:</strong> (Edit Premium 'Add URL' form)<br>
    To let users submit to this extra field when doing a premium new submission go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=3#3" target="_blank"><strong>3. Add URL Templates</strong></a> &gt;&gt;<strong> Scroll down to the section reading: User Registration System Add URL Templates</strong> &gt;&gt; <strong>Click on the <a href="$system_in_use_prem_addurl"  onClick="popup('$system_in_use_prem_addurl',screen.width-280,screen.height-280);return false;">'Paid Add URL Template 1'</a> Link</strong> - You may also <a href="$system_in_use_prem_addurl" onClick="popup('$system_in_use_prem_addurl',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the Premium 'Add URL' template. Now add the following HTML code to the template between the &lt;FORM&gt; tags:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$add_url</strong></td>
      </tr>
    </table>
    $upnotice
    <p><strong>Step 3:</strong> (Edit 'Modify' form)<br>
      To let users  modify this extra field when modifying a link, go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=3#3" target="_blank"><strong>3. Add URL Templates</strong></a> &gt;&gt;<strong> Scroll down to the section reading: User Registration System Add URL Templates</strong> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin57.cgi?fct=edit_template&template=rgs_modify_link_edit" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=rgs_modify_link_edit',screen.width-280,screen.height-280);return false;">Modify/Edit Link Standard</a>' Link</strong> - You may also <a href="$admin_url/admin57.cgi?fct=edit_template&template=rgs_modify_link_edit" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=rgs_modify_link_edit',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the 'Modify' template. Now add the following HTML code to the template between the &lt;FORM&gt; tags:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$modify</strong></td>
      </tr>
    </table>
    $mupnotice
    <p><strong>Step 4:</strong> (Edit Premium 'Modify' form)<br>
    To let users  modify this extra field for premium links, go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=3#3" target="_blank"><strong>3. Add URL Templates</strong></a> &gt;&gt;<strong> Scroll down to the section reading: User Registration System Add URL Templates</strong> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin57.cgi?fct=edit_template&template=rgs_modify_link_editp" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=rgs_modify_link_editp',screen.width-280,screen.height-280);return false;">Modify/Edit Link Premium'</a> Link</strong> - You may also <a href="admin57.cgi?fct=edit_template&template=rgs_modify_link_editp" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=rgs_modify_link_editp',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the 'Modify' template. Now add the following HTML code to the template between the &lt;FORM&gt; tags:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$modify</strong></td>
      </tr>
    </table>
    $mupnotice</blockquote>
<p>&nbsp;</p>
<p><strong>Displaying this field with links on the What's New Page</strong></p>
  <blockquote>
    <p><strong>Step 1: </strong>(Edit What's New Link Style Template)<br>
      You can also display this field on the What's New Page where the latest additions to the Directory is displayed. To do this, go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=6#6" target="_blank"><strong>6. What's New Templates</strong></a> &gt;&gt; <strong>Click on the '<a href="admin6.cgi?fct=edit_template&template=whatsnew_lists" onClick="popup('admin6.cgi?fct=edit_template&template=whatsnew_lists',screen.width-280,screen.height-280);return false;">What's New Listings Style'</a> Link</strong> - You may also <a href="admin6.cgi?fct=edit_template&template=whatsnew_lists" onClick="popup('admin6.cgi?fct=edit_template&template=whatsnew_lists',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
      </tr>
    </table>
    <p><strong>Step 2: </strong>(Edit What's New Premium Link Style Template)<br>
      Go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=6#6" target="_blank"><strong>6. What's New Templates</strong></a> &gt;&gt; <strong>Click on the '<a href="admin6.cgi?fct=edit_template&template=whatsnew_lists_prem" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_lists_prem',screen.width-280,screen.height-280);return false;">What's New Listings Premium Style'</a> Link</strong> - You may also <a href="admin6.cgi?fct=edit_template&template=whatsnew_lists_prem" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_lists_prem',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_linksp</strong></td>
      </tr>
    </table>
  </blockquote>
<p>&nbsp;</p>
<p><strong>Displaying this field with links on the Top Hits Page</strong></p>
<blockquote>
  <p><strong>Step 1: </strong>(Edit Top Hits Link Style Template)<br>
    You can also display this field on the Top Hits Page where the latest additions to the Directory is displayed. To do this, go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=7#7" target="_blank"><strong>7. Top Hits Templates</strong></a> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings',screen.width-280,screen.height-280);return false;">Top Hits Listings Style'</a> Link</strong> - You may also <a href="$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
  <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
    <tr>
      <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
    </tr>
  </table>
  <p><strong>Step 2: </strong>(Edit Top Hits Premium Link Style Template)<br>
Go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=7#7" target="_blank"><strong>7. Top Hits Templates</strong></a> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings_prem" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings_prem',screen.width-280,screen.height-280);return false;">Top Hits Listings Premium Style'</a> Link</strong> - You may also <a href="$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings_prem" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tophits_listings_prem',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
  <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
    <tr>
      <td bgcolor="#FFFFFF"><strong>$t1_linksp</strong></td>
    </tr>
  </table>
</blockquote>
<p>&nbsp;</p>
<p><strong>Displaying this field within Favorites</strong></p>
<blockquote>
  <p><strong>Step 1: </strong>(Edit Standard Link Style for Favorites)<br>
    PowerSeek comes with functionality where users can choose to add a link to their 'Favorites'. To display the extra field with links on the 'Favorites' pages, go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=9#9" target="_blank"><strong>9. Favorites</strong></a> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin57.cgi?fct=edit_template&template=fav_standard" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=fav_standard',screen.width-280,screen.height-280);return false;">Favorites Link Style'</a> Link</strong> - You may also <a href="$admin_url/admin57.cgi?fct=edit_template&template=fav_standard" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=fav_standard',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
  <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
    <tr>
      <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
    </tr>
  </table>
  <p><strong>Step 2: </strong>(Edit Premium Link Style for Favorites)<br>
    To display the extra field with premium links on the 'Favorites' pages, go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=9#9" target="_blank"><strong>9. Favorites</strong></a> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin57.cgi?fct=edit_template&template=fav_premium" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=fav_premium',screen.width-280,screen.height-280);return false;">Favorites Premium Link Style'</a> Link</strong> - You may also <a href="$admin_url/admin57.cgi?fct=edit_template&template=fav_premium"  onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=fav_premium',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
  <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
    <tr>
      <td bgcolor="#FFFFFF"><strong>$t1_linksp</strong></td>
    </tr>
  </table>
</blockquote>
<p>&nbsp;</p>
<p><strong>Displaying this field with Links on the Link Rating Page</strong>s</p>
  <blockquote>
    <p><strong>Step 1: </strong>(Edit Comment/Review Template)<br> 
    When users choose to 'Rate' a link then the link details can be displayed on the 'Rating' page before the user 'rates' a link. You can also display this extra field on the rating page. To do this go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=4#4" target="_blank"><strong>4. Rating Templates</strong></a> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin6.cgi?fct=edit_template&template=rate_it"  onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=rate_it',screen.width-280,screen.height-280);return false;">Main Rating Page'</a> Link</strong> - You may also <a href="$admin_url/admin6.cgi?fct=edit_template&template=rate_it" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=rate_it',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
      </tr>
    </table>
    <p>&nbsp;</p>
  </blockquote>
  <p><strong>Displaying this field with Links on the Comment/Review Pages</strong></p>
  <blockquote>
    <p><strong>Step 1: </strong><strong> </strong>(Edit Comments/Reviews Template)<br>
      When users click the 'Comments' link with a link then the Comments/Reviews page of the link is displayed. You can also display this extra field on this page. To do this go to the Control Panel &gt;&gt; <strong><a href="$admin_url/admin.cgi" target="_blank">Control Panel</a></strong> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank"><strong>Template Manager</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=5#5" target="_blank"><strong> 5. Comment/Review Templates</strong></a> &gt;&gt; <strong>Click on the '<a href="$admin_url/admin6.cgi?fct=edit_template&template=review_it" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=review_it',screen.width-280,screen.height-280);return false;">Main Comment/Review Page'</a> Link</strong> - You may also <a href="$admin_url/admin6.cgi?fct=edit_template&template=review_it" onClick="popup('$admin_url/admin6.cgi?fct=edit_template&template=review_it',screen.width-280,screen.height-280);return false;"><strong>click here</strong></a> to edit the  template. Now add the following HTML code to the template:</p>
    <table width="95%" align="center" cellpadding="6" cellspacing="1" class="normaltext" bgcolor="#E0E0E0">
      <tr>
        <td bgcolor="#FFFFFF"><strong>$t1_links</strong></td>
      </tr>
    </table>
  </blockquote>
  <p>&nbsp;</p>
</blockquote>

</body>
</html>
];



}




sub fix_indexes
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;


	foreach $kitem (@akeys)
		{
		($keyname, $visible, $size1, $searched1, $description, $na, $imagef, $numberfield) = split (/\t/, $kitem);
		if ($searched1 eq "Yes"){$index_crit = $index_crit . "$keyname" . "_cust,";}
		}
		
		chop($index_crit);

	### DROP EXISTING FULLTEXT INDEXES
		$sql = "SHOW CREATE TABLE links";
		$sth = $dbh->prepare($sql);
		if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
		while ( @row = $sth->fetchrow() )
		{

			@createlines = split (/\n/, $row[1]);
		
			foreach $cline (@createlines)
				{
						if ($cline =~ m/FULLTEXT KEY/g)
						{
						$cline =~ s/FULLTEXT KEY //gi;
						@ssdata = split (/\(/, $cline);
						$ssdata[0] =~ s/ //g;
						$ssdata[0] =~ s/`//g;
						push (@dropfulltext, "ALTER TABLE links DROP INDEX $ssdata[0]");
						$index_to_drop = "true";
						}
				}
			
		}

		if ($index_to_drop eq "true")
			{
				foreach $i_item (@dropfulltext)
				{
				$sth = $dbh->prepare($i_item);
				$sth->execute;
				if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
				}
			}


	###### ADD FULLTEXT INDEX
	
	$sql = "ALTER TABLE links ADD FULLTEXT INDEX (title,description,keywords,url,email,$index_crit)";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect; 


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
</head>
<body>
<p>Indexes has been rebuilt and fixed.</p>
</body>
</html>
];

}




sub delfield_final
{

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Deleting Extra Field. Please Wait...", qq[<img src="$web_url/working.gif">]);


$line_nr = $q->param('p');

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek SQL</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin37.cgi?fct=delfield_final2&p=$line_nr">
</head>
<body>
$hbox
</body>
</html>
];



}





sub delfield_final2
{

$line_nr = $q->param('p');

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;

open (KF, "> $data_dir/keys.dat")  or die "Could not open $data_dir/keys.dat : $!";;

foreach $kitem (@akeys)
	{
	if ($line_nr != $nrc)
		{
		print KF $kitem . "\n";
		($c_keyname, $c_visible, $c_size, $c_searched, $c_description, $c_na, $c_imagef, $c_numberfield) = split (/\t/, $kitem);
		push (@allfields, $c_keyname);
		}
		else
		{
		($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield) = split (/\t/, $kitem);
		}
	$nrc++;
	}
close (KF);


###### IF UPLOAD FIELD REMOVE UPLOAD DETAILS
$ukdata = acs::get_file_contents("$data_dir/keysupl.dat");

@ukitems = split (/:-o_:/, $ukdata);

foreach $uitem (@ukitems)
	{
	my @udetails = split (/:o:-:o:/, $uitem);

	$foundm = "false";	
	foreach $chitem (@allfields)
		{
		if ($udetails[0] eq $chitem){$foundm = "true";}
		}
		
	if ($foundm eq "true") { push(@to_write_upkeys, $uitem); $write_f = "true";}
	}


if ($write_f eq "true")
{
	open (UPFILE, "> $data_dir/keysupl.dat");

		foreach $item (@to_write_upkeys)
			{
			print UPFILE $item . ":-o_:";
			}
			
	close (UPFILE);
}




######

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$keyname = $keyname . "_cust";

$sql = "ALTER TABLE links DROP COLUMN $keyname";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}


$sql = "ALTER TABLE modified DROP COLUMN $keyname";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}


$sth->finish;
$dbh->disconnect; 

######

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Extra Field/Key Deleted.", qq[<a href="$admin_url/admin37.cgi">Click here to continue</a>]);


print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek SQL</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



sub delfield
{

$fnumber = $q->param('p');

$boxdiz = qq[
<p><strong>If there is any data available in this field then it will be lost. </strong></p>
<p><strong>Are you sure? <a
href="$admin_url/admin37.cgi?fct=delfield_final&amp;p=$fnumber">Yes</a> | <a
href="$admin_url/admin37.cgi">No</a></strong></p>
<p><font color="#FF0000"><strong>Important Note:</strong></font> - Please make a backup of
your data before altering any extra fields/keys. The operations performed on your database
is destructive. </p>
];

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Delete Extra Field", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox
</body>
</html>

];

}




sub add_field_final
{

$fieldname = $q->param('fieldname');
$diz = $q->param('diz');
$size = $q->param('size');
$visible = $q->param('visible');
$searched = $q->param('searched');
$images = $q->param('images');
$numchar = $q->param('numchar');
$na = $q->param('na');
$submitv = $q->param('submitv');
$allow_html = $q->param('allow_html');
$carriage_pagebreak = $q->param('carriage_pagebreak');

### FOR UPLOAD FIELDS
$filetypes = $q->param('filetypes');
$preappend = $q->param('preappend');
$append = $q->param('append');
$uploadsize = $q->param('uploadsize');
$filetype_error = $q->param('filetype_error');
$reqtext = $q->param('reqtext');
$filesize_error = $q->param('filesize_error');

if ($numchar eq "Upload") ### IF UPLOAD FIELD DO ERROR CHECKING
	{
	if ($filetypes eq "") { &problem_popup ("You have to specify a value for the 'Accepted File Types'."); }
	if (int($uploadsize) < 1) { &problem_popup ("You have to specify a value for the 'Maximum Upload File Size'."); }
	if ($filetype_error eq "") { &problem_popup ("You have to specify a value for the 'Error Text' indicating that a file type is incorrect."); }
	if (($reqtext eq "") and ($q->param('submitv') eq "Yes")) { &problem_popup ("You have chosen to require that a file is uploaded but have specified no 'Error Text' to display when a user has not uploaded a file where a file upload is required."); }
	if ($filesize_error eq "") { &problem_popup ("You have to specify a value for the 'Error Text' indicating that the file size is to large."); }
	}


### CHECK FOR DUPLICATES
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield) = split (/\t/, $kitem);
	if (lc($q->param('fieldname')) eq lc($keyname))
		{
		&problem_popup ("The field/key name you are trying to add, already exists.");
		}
	
	if ($searched eq "Yes")
		{
		$search_cnt++;
		}
	}

if (($search_cnt >= 11) and ($q->param('searched') eq "Yes"))
	{
	acs::problem_popup ("The maximum number of fields that can be searched is 11.");
	}


if ($fieldname eq "image") {&problem_popup ("You cannot use the name 'image' for the field name. Please choose another name."); }


#### IF UPLOAD FIELD

if ($numchar eq "Upload")
	{
	open (KEYSTEMP, "> $data_dir/keysupl.tmp");
	print KEYSTEMP $filetypes . ":o:-:o:" . $preappend . ":o:-:o:" . $append . ":o:-:o:" . $uploadsize . ":o:-:o:" . $filetype_error . ":o:-:o:" . $reqtext . ":o:-:o:" . $filesize_error;
	close (KEYSTEMP);
	
		if (($q->param('width') ne "") or ($q->param('height') ne ""))
		{
			$field_filename = "$data_dir/imgres" . "_" . $fieldname . ".dat";
			open (IFF, "> $field_filename");
				print IFF $q->param('width') . "\n";
				print IFF $q->param('height');
			close (IFF);
		}
	
		if ($q->param('mconf') ne "")
			{
				open (DDT, "> $data_dir/imgresconf.dat");
					print DDT $q->param('mconf');
				close (DDT);	
			}
	
	}
	elsif ($numchar eq "Characters")
	{
	open (KEYSTEMP, "> $data_dir/keyschar.tmp");
		print KEYSTEMP $q->param('preappend') . ":-oPreo-:" . $q->param('append');
	close (KEYSTEMP);
	}



$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Adding Extra Field/Key. Please Wait...", qq[<img id="wrk" src="$web_url/working.gif" style="visibility:hidden;">]);



print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek SQL</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin37.cgi?fct=add_field_final2&fieldname=$fieldname&diz=$diz&size=$size&visible=$visible&searched=$searched&images=$images&numchar=$numchar&na=$na&submitv=$submitv&allow_html=$allow_html&carriage_pagebreak=$carriage_pagebreak">
</head>
<body>

$hbox
<script language="JavaScript">
document.getElementById("wrk").style.visibility  = 'visible';
</script>

</body>
</html>
];

}







sub add_field_final2
{

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$keynr = @akeys;

if ($keynr == 41) {&problem_popup ("The extra field/key limit is 40."); }

$search_cnt = 0;


### CHECK FOR DUPLICATES
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield) = split (/\t/, $kitem);
	if ($q->param('fieldname') eq $keyname)
		{
		&problem_popup ("The field/key name you are trying to add, already exists.");
		}
	
	if ($searched eq "Yes")
		{
		$search_cnt++;
		}
	}

if (($search_cnt >= 11) and ($q->param('searched') eq "Yes"))
	{
	&problem_popup ("The maximum number of fields that can be searched is 11.");
	}

### CHECK FIELD NAME

for ($ms = 0; $ms < length($q->param('fieldname')); $ms++) 
	{
	$oneletter = substr($q->param('fieldname'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/))
		{
		&problem_popup ("The name of the field/key you are trying to add is invalid. Ensure that the name only contains alphabetical letters or numerical numbers.");
		}
	}




### CHECK IF FIELDS HAS BEEN FILLED IN
	
if ($q->param('fieldname') eq ""){&problem_popup ("The name of the field/key you are trying to add is invalid.");}
if ($q->param('size') < 1){&problem_popup ("The field/key length you supplied is invalid.");}

$fieldsize = $q->param('size');



### ADD EXTRA FIELD

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$efield_name = $q->param('fieldname'); $efield_name = $efield_name . "_cust";
$field_size = $q->param('size');
$numchar = $q->param('numchar');
$searched = $q->param('searched');

if ($field_size > 255) { $size = "text"; } else { $size = "varchar($field_size)"; }

if ($numchar eq "Numbers") { $size = "int"; $numfk = "Y"; $fieldsize = 11; }

if ($numchar eq "Upload") { $size = "varchar(20)"; $numfk = "Upload"; $fieldsize = 255; }

if ($numchar eq "Content") { $size = "text"; $numfk = "Content";}



if ($q->param('images') eq "Yes") 
	{
	$size = "varchar(255)"; 
	$searched = "No"; 
	$numfk = "";
	$fieldsize = 255;
	}

$sql = "ALTER TABLE links ADD $efield_name $size";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}




if (($searched eq "Yes") and ($numchar ne "Numbers"))
	{

	foreach $kitem (@akeys)
		{
		($keyname, $visible, $size1, $searched1, $description, $na, $imagef, $numberfield) = split (/\t/, $kitem);
		if ($searched1 eq "Yes"){$index_crit = $index_crit . "$keyname" . "_cust,";}
		}
		

	if ($index_crit ne "") { $index_crit = $index_crit . $efield_name; } else {$index_crit = $efield_name; }
	


		### DROP EXISTING FULLTEXT INDEXES
		$sql = "SHOW CREATE TABLE links";
		$sth = $dbh->prepare($sql);
		if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
		while ( @row = $sth->fetchrow() )
		{

			@createlines = split (/\n/, $row[1]);
		
			foreach $cline (@createlines)
				{
						if ($cline =~ m/FULLTEXT KEY/g)
						{
						$cline =~ s/FULLTEXT KEY //gi;
						@ssdata = split (/\(/, $cline);
						$ssdata[0] =~ s/ //g;
						$ssdata[0] =~ s/`//g;
						push (@dropfulltext, "ALTER TABLE links DROP INDEX $ssdata[0]");
						$index_to_drop = "true";
						}
				}
			
		}

		if ($index_to_drop eq "true")
			{
				foreach $i_item (@dropfulltext)
				{
				$sth = $dbh->prepare($i_item);
				$sth->execute;
				if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
				}
			}


	###### ADD FULLTEXT INDEX
	
	$sql = "ALTER TABLE links ADD FULLTEXT INDEX (title,description,keywords,url,email,$index_crit)";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	}


### UPDATE MODIFY TABLE
$sql = "ALTER TABLE modified ADD $efield_name $size";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}


### UPDATE keys.dat

$not_avail = $q->param('na');
$not_avail =~ s/\t//g;
$not_avail =~ s/\n//g;
$crit = chr(10); $not_avail =~ s/$crit//g;
$crit = chr(13); $not_avail =~ s/$crit//g; 


open (KDTA, ">> $data_dir/keys.dat") or acs::problem_popup ("Could not write to $data_dir/keys.dat - $@"); 

	print KDTA 			$q->param('fieldname') . "\t" . 
							$q->param('visible') . "\t" .	
							$fieldsize . "\t" . 
							$searched . "\t" . 
							$q->param('diz') . "\t" . 
							$not_avail . "\t" . 
							$q->param('images') . "\t" . 
							$numfk . "\t" . 
							$q->param('submitv') . "\t" . 
							$q->param('allow_html') . "\t" . 
							$q->param('carriage_pagebreak') . "\n";
							
							

close (KDTA);

### UPDATE keysupload.dat IF UPLOAD FIELD

if ($numfk eq "Upload")
	{
	$uplkeydata = acs::get_file_contents("$data_dir/keysupl.tmp");
	($filetypes, $preappend, $append, $uploadsize, $filetype_error, $reqtext, $filesize_error) = split (/:o:-:o:/,$uplkeydata);
	open (FILEUPL, ">> $data_dir/keysupl.dat");
		print FILEUPL $q->param('fieldname') . ":o:-:o:" . $filetypes . ":o:-:o:" . $preappend . ":o:-:o:" . $append . ":o:-:o:"  . $uploadsize . ":o:-:o:" .  $filetype_error . ":o:-:o:" .  $reqtext  . ":o:-:o:" .  $filesize_error . ":-o_:";
	close (FILEUPL);
	}


if ($numchar eq "Characters")
	{
	$charapp = acs::get_file_contents("$data_dir/keyschar.tmp");
	($cha_pre, $cha_app) = split (/:-oPreo-:/, $charapp);
	
	$appprefname = "chapp_" . $q->param('fieldname') . ".dat";
	
	open (CHAPPE, "> $data_dir/$appprefname");
		print CHAPPE $cha_pre . ":-oPreo-:" . $cha_app;
	close (CHAPPE);
	}


$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Extra Field/Key Added.", qq[<a href="$admin_url/admin37.cgi">Click here to continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek SQL</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

</body>
</html>

];


}




sub add_field2
{

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$keynr = @akeys;

if ($keynr == 41) {&problem_popup ("The extra field/key limit is 40."); }

@clash_fields = ('title', 'description', 'keywords', 'url', 'image', 'imagelinked', 'name', 'email', 'rating', 'votes', 'hits', 'premium', 'modified', 'newsubm', 'userid', 
					  'urldate', 'subscribed', 'csuggest', 'cidsubm', 'subs_expire', 'lnkpassword', 'rev_no', 'extf2', 'extf3', 'extf4');
					  
foreach $item (@clash_fields)
	{
	if ($item eq $q->param('fieldname'))
		{
		acs::problem_popup ("It is not possible to add the field/key name: <b>" . $q->param('fieldname') . "</b> because it's name would conflict with the same name already used internally within the PowerSeek database. Please choose another name.");
		}
	
	}


### CHECK FOR DUPLICATES
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield) = split (/\t/, $kitem);
	if (lc($q->param('fieldname')) eq lc($keyname))
		{
		acs::problem_popup ("The field/key name you are trying to add, already exists.");
		}
	}


$field_type = $q->param('field_type');

if ($q->param('fieldname') eq "") { acs::problem_popup ("You have to provide a Field/Key name."); }
if ($q->param('diz') eq "") { acs::problem_popup ("You have to provide a descriptive name for the Field/Key name."); }

### CHECK FOR DUPLICATES / MAX SEARCHABLE FIELDS

for ($ms = 0; $ms < length($q->param('fieldname')); $ms++) 
	{
	$oneletter = substr($q->param('fieldname'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/))
		{
		&problem_popup ("The name of the field/key you are trying to add is invalid. Ensure that the name only contains alphabetical letters or numerical numbers.");
		}
	}

if ($field_type eq "Character_Field") { &create_character_field; }
elsif ($field_type eq "Number_Field") { &create_number_field; }
elsif ($field_type eq "Image_Field") { &create_image_field; }
elsif ($field_type eq "File_Upload_Field") { &create_file_upload_field; }
elsif ($field_type eq "Content_Field") { &create_article_field; }

}





sub create_article_field
{

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Add a New Article Field ", qq[Article Fields are just like 'Character Fields'. The difference is that PowerSeek provides you with a Wysiwyg Editor to edit these fields. The content to be added could be articles containing photos, tables, and other HTML elements. Note that Article Fields can hold tens of thousands of characters. It's definition is that it is a large field. This functionality also ads the option to use PowerSeek as a CMS (Content Management System)]);


$fieldname = $q->param('fieldname');
$diz = $q->param('diz');


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox

<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="allow_html" value="Yes">
  <input type="hidden" name="carriage_pagebreak" value="No">
  <input type="hidden" name="diz" value="$diz">
  <input type="hidden" name="fct" value="add_field_final">
  <input type="hidden" name="fieldname" value="$fieldname">
  <input type="hidden" name="images" value="No">
  <input type="hidden" name="numchar" value="Content">
  <input type="hidden" name="size" value="1000">
  <input type="hidden" name="visible" value="No">
  

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E5E5E5">
  <tr>
    <td width="100%" height="30" colspan="2" class="normaltext" background="$web_url/bar7.gif"><strong>Article
    Field Details:</strong></td>
  </tr>
  <tr>
    <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key Name: </strong></td>
    <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$fieldname</b></td>
  </tr>
  <tr>
    <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key
    Descriptive Name: </strong></td>
    <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$diz</b></td>
  </tr>
  <tr>
    <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text or HTML if
    field is empty:</strong></td>
    <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="na"
    cols="33" style="width:100%"></textarea> <br>
    You could for example use: <strong>N/A </strong>or <strong>Not Available - </strong>This
    text is displayed when this field/key has no value in your link listings. You can also
    use <strong>HTML code</strong> in the above box.</td>
  </tr>
  <tr>
    <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Required with
    new submissions?</strong></td>
    <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
    name="submitv"> <strong>Yes </strong>- Require visitors to specify a value for this field
    when making a new submission<br>
    <input type="radio" value="No" name="submitv" checked> <strong>No </strong>- Don't require
    visitors to specify a value for this field when making a new submission</td>
  </tr>
  <tr>
    <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Do you want this
    field/key to be searched? </strong></td>
    <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
    name="searched"> <strong>Yes </strong>- Search this field when a search is performed <br>
    <input type="radio" value="No" name="searched" checked> <strong>No </strong>- Don't search
    this field when a search is performed. <br>
    <font color="#FFFFFF">_ </font><br>
    If you choose 'Yes' above then this field will be searched for matches when end users
    search your search engine.</td>
  </tr>
  <tr>
    <td width="37%" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
    <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
    value="Add Field/Key" name="B1"> <br>
    <br>
    Please make a backup of your data before adding any extra fields/keys. The operations
    performed on your database is destructive. </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
    <td width="99%"></td>
  </tr>
</table>


</form>

</body>
</html>
];


}




sub create_file_upload_field
{


$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Add a New File Upload Field ", qq[A File Upload Field lets you upload files like image files, pdf files, videos, etc. It can also enable visitors (users doing submissions) to upload images, pdf files, videos, or any other file types with their listings. You can for example use a File Upload Field to display images with link listings. You could also for example use it to provide .zip or .pdf downloads with link listings. It could also be used to display videos (or the functionality to view them) on the 'More Info' pages of listings.]);

$fieldname = $q->param('fieldname');
$diz = $q->param('diz');




### CHECK FOR IMAGE RESIZING MODULES

if (($IM eq "false") and ($IMRES eq "false"))
	{
	$no_image_res_modules = "true";
	}
	else
	{

	$field_filename = "$data_dir/imgres" . "_" . $keyname . ".dat";
	$fieldwh = acs::get_file_contents($field_filename);
	
	($w, $h) = split(/\n/, $fieldwh);

	$img_res_options = qq[
	
 	<tr>
 <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Image Resizing Options:</strong><br>(Ignore if this field won't be holding images)</td>
       <td bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellspacing="0" cellpadding="0">
         <tr>
           <td width="7%"><p><strong>Width:</strong> </p></td>
           <td width="93%" height="30"><p>
             <input name="width" type="text" id="width" value="$w" size="10">
           pixels</p></td>
         </tr>
         <tr>
           <td><p><strong>Height:</strong></p></td>
           <td height="30"><p>
             <input name="height" type="text" id="height" value="$h" size="10">
           pixels</p></td>
         </tr>
         <tr>
           <td height="15" colspan="2">&nbsp;</td>
         </tr>
         <tr>
           <td height="30" colspan="2"><ul>
               <li class="normaltext">Leave the width and height options blank if this field is not going to be used for images or leave it blank if you don't want images to be resized when uploaded for this field.</li>
               <li class="normaltext">Specify a width and/or height value above if you would like to have images automatically resized when an image is uploaded for this upload field.</li>
               <li class="normaltext">If you want to keep the aspect ratio of the image, only provide one  value for the width or height. For example: leave the height property  blank and provide a value for the width property to resize the image to  a specific width but keep the aspect ratio. (The height will  automatically be resized to keep the aspect ratio)</li>
               <li class="normaltext">Note that this resize setting is globally valid for this field.</li>
               <li class="normaltext">When end users upload images when submitting or modifying listings then the image will automatically be resized to the width and/or height specified here.</li>
               <li><span class="normaltext">If invalid images are uploaded then no resizing will be done on the file as the file will not be a valid image file.</span></li>
             </ul></td>
           </tr>
       </table>
      </td>
    </tr>	
	];


			### CONFIGURE WHAT TO USE FOR IMAGE RESIZING
			if ((-e "$data_dir/imgresconf.dat") < 1)
				{
					if (($IM eq "true") and ($IMRES eq "false")) ### IMAGE MAGICK
						{
						open (DDT, "> $data_dir/imgresconf.dat");
							print DDT "IM";
						close (DDT);
						}
					elsif (($IM eq "false") and ($IMRES eq "true"))  ### IMAGE RESIZE MODULE
						{
						open (DDT, "> $data_dir/imgresconf.dat");
							print DDT "IMRES";
						close (DDT);	
						}
					else ### IF BOTH MODS INSTALLED USE image::resize
						{
						open (DDT, "> $data_dir/imgresconf.dat");
							print DDT "IMRES";
						close (DDT);	
						}
				}

			##################
	
			if (($IM eq "true") and ($IMRES eq "true"))
				{
				$img_res_setting = acs::get_file_contents("$data_dir/imgresconf.dat");
				
				if ($img_res_setting eq "IM") { $im_im = "checked"; } else { $im_res = "checked"; }
			
				$im_choose = qq[
				 <tr>
					<td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Choose a module to use to resize images:</strong><br>(Ignore if this field won't be holding images)</td>
					<td bgcolor="#FFFFFF" class="normaltext">
					 <strong> 
						<input name="mconf" type="radio" value="IM" $im_im>Image Magick<br>
						<input name="mconf" type="radio" value="IMRES" $im_res>Image::Resize (Perl Module)
					 </strong>
					</td>
				</tr>		
				];

				}
	
	
	}






print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox


<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="add_field_final">
  <input type="hidden" name="diz" value="$diz">
  <input type="hidden" name="fieldname" value="$fieldname">
  <input type="hidden" name="images" value="No">
  <input type="hidden" name="numchar" value="Upload">
  <input type="hidden" name="size" value="255">
  <input type="hidden" name="searched" value="No">
  <input type="hidden" name="allow_html" value="No">
  <input type="hidden" name="carriage_pagebreak" value="No">
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="30" colspan="2" class="normaltext" background="$web_url/bar7.gif"><strong>File
      Upload Field Details:</strong></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$fieldname</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key
      Descriptive Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$diz</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Visible when
      browsing control panel?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" checked> <strong>Yes </strong>- Display the uploaded file name with
      listings.<br>
      <input type="radio" value="No" name="visible"> <strong>No </strong>- Don't display the
      uploaded file name with listings.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text or HTML if
      no file is available: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="na"
      cols="33" style="width:100%"></textarea> <br>
      You could for example use: <strong>N/A </strong>or <strong>Not Available - </strong>This
      text is displayed when this field/key has no value in link listings. You could also
      use <strong>HTML code</strong> in the above box.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Accepted File
      Types?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="filetypes"
      cols="33" style="width:100%">*</textarea><br>
      Place a * in the above box if all file types are allowed. If you are only allowing certain
      file types like for example .avi, .jpg, .gif, etc.. Then enter them in a comma delimited
      format. <br>
      <strong>For example: .avi,.gif,.jpg</strong><BR>
      <b>Don't place any white space within this section.</b></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Error text indicating that the file type is incorrect:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="filetype_error" type="text" value="The file type for '$fieldname' you are trying to uploaded is not valid." style="width:100%" >
      If you only accept certain file types to be uploaded (With 'Add URL' and 'Modify' forms) then this error message will be displayed to indicate that the file could not be uploaded because the file-type is incorrect.
      <b>Note that this text will also be diplayed when a file has no extension.</b>
      What this means that files to be uploaded has to have an extension.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Required with
      new submissions?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="submitv"> <strong>Yes </strong>- Require visitors to upload a file with new
      submissions. <br>
      <input type="radio" value="No" name="submitv" checked> <strong>No </strong>- Don't Require
      visitors to upload a file with new submissions</td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text indicating that a file upload is required:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <input name="reqtext" type="text" value="You are required to upload a file '$fieldname'" style="width:100%" >
        If you are going to require that users submit/upload an image from the 'Add URL' or 'Modify' forms then specify the text displayed to them if they didn't specify a file to upload with the 'Add URL' or 'Modify' forms.</label></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Pre-Append HTML
      or Text:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="preappend"
      cols="33" style="width:100%"></textarea><br>
      This option allows you to pre-append text or HTML code when the value of this field is
      displayed with links or on 'More Info' pages.<br>
      &nbsp; <br>
      <strong>For example:<br>
      </strong>If this field is going to contain uploaded images you would like to display with link listings then 
      you could use the following HTML code here:<br>
      <font color="#0000FF"><strong>&lt;img src=&quot;</strong></font><br>
      and in the <strong>'Append HTML or Text' </strong>box below:<br>
      <font color="#0000FF"><strong>&quot; width=&quot;16&quot; height=&quot;16&quot;
      alt=&quot;Some Alt Text&quot;&gt;</strong></font><p>The above example will then display an
      image when you simply place the name of this field with exclamation marks on both sides in
      any PowerSeek <a href="$admin_url/admin6.cgi?fct=edit_template&amp;template=tmplsearch"
      target="_blank">link style</a> template.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Append HTML
      or Text:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="append"
      cols="33" style="width:100%"></textarea><br>
      This option allows you to append text or HTML code when the value of this field is displayed with links or on 'More Info' pages.
      <p><strong>For example:<br>
      </strong>If this field is going to contain uploaded images that you would like to display
      with link listings then you could use the following HTML code for the <strong>'Pre-Append
      HTML or Text':</strong><br>
      <font color="#0000FF"><strong>&lt;img src=&quot;</strong></font><br>
      and in here you could use:<br>
      <font color="#0000FF"><strong>&quot; width=&quot;16&quot; height=&quot;16&quot;
      alt=&quot;Some Alt Text&quot;&gt;</strong></font></p>
      <p>The above example will then display an image when you simply place the name of this
      field with exclamation marks on both sides in any PowerSeek <a
      href="$admin_url/admin6.cgi?fct=edit_template&amp;template=tmplsearch" target="_blank">link
      style</a> template.</td>
    </tr>

<tr>
    <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Maximum Upload
    File Size:</strong></td>
    <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="uploadsize"
    size="8" value="10"> <b>KB</b> (Kilobytes)</td>
  </tr>
<tr>
  <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text indicating that the file size is to large:</strong></td>
  <td bgcolor="#FFFFFF" class="normaltext"><label>
    <input name="filesize_error" type="text" value="The file you are trying to upload for '$fieldname' is to large in size." style="width:100%" >
    This text will be displayed when a user uploads a file that exceeds the maximum file size from the 'Add URL' or 'Modify' forms.</label></td>
</tr>

$img_res_options
$im_choose

    <tr>
      <td width="37%" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="Add Field/Key" name="B1"> <br>
      <br>
      Please make a backup of your data before adding any extra fields/keys. The operations
      performed on your database is destructive. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];

}




sub create_image_field
{

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Add a New Number Field ", qq[Image fields/keys holds URLs to images. When used in  link listings, the image is   automatically displayed - you just enter a URL path to an image and it is displayed with   your links.<strong>Note</strong> that this field   type cannot be searched as it holds URLs to image files.]);

$fieldname = $q->param('fieldname');
$diz = $q->param('diz');


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox


<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="add_field_final">
  <input type="hidden" name="diz" value="$diz">
  <input type="hidden" name="fieldname" value="$fieldname">
  <input type="hidden" name="images" value="Yes">
  <input type="hidden" name="numchar" value="Characters">
  <input type="hidden" name="size" value="255">
  <input type="hidden" name="searched" value="No">
  <input type="hidden" name="allow_html" value="No">
  <input type="hidden" name="carriage_pagebreak" value="No">

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="30" colspan="2" class="normaltext" background="$web_url/bar7.gif"><strong>Image
      Field Details:</strong></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$fieldname</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key
      Descriptive Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$diz</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Visible when
      browsing control panel?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" checked> <strong>Yes </strong>- Images will be displayed with listings in
      the Control Panel<br>
      <input type="radio" value="No" name="visible"> <strong>No </strong>- Images will not be
      displayed with listings in the Control Panel<br>
      <font color="#FFFFFF">_ </font><br>
      It might be a good idea to set this to 'No' if this field/key is going to contain large
      images which may take a long time to load.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text if no image
      is available: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="na"
      cols="33"  style="width:100%" ></textarea> <br>
      You could for example use: <strong>N/A </strong>or <strong>Not Available - </strong>This
      text is displayed when this field/key has no value in link listings. You could also
      use HTML code in the above box to display a 'default' image indicating that there is no
      image available yet.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Required with
      new submissions?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="submitv"> <strong>Yes </strong>- Require visitors to provide a URL Path to an image.<br>
      <input type="radio" value="No" name="submitv" checked> <strong>No </strong>- Don't Require
      users to provide a URL path to an image.<br>
      </td>
    </tr>
    <tr>
      <td width="37%" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="Add Field/Key" name="B1"> <br>
      <br>
      Please make a backup of your data before adding any extra fields/keys. The operations
      performed on your database is destructive. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



</body>
</html>
];



}





sub create_number_field
{

$boxdiz = qq[
A Number Field lets you store numbers within it.
<blockquote>
  <p><strong>Important Notes Regarding 'Number Fields':</strong>&nbsp; </p>
</blockquote>
<ul>
  <li class="normaltext">This field type cannot hold <strong>spaces, dashes or any other
    characters</strong> except valid numerical numbers.</li>
  <li class="normaltext">Numerical fields <strong>cannot be searched by PowerSeek's default
    search scripts.</strong> Only the <strong>advanced searches</strong> can search through
    these fields. (Note that you have to create advanced searches with PowerSeek)</li>
</ul>
];

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Add a New Number Field ", $boxdiz);

$fieldname = $q->param('fieldname');
$diz = $q->param('diz');


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox

<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >

  <input type="hidden" name="fct" value="add_field_final">
  <input type="hidden" name="diz" value="$diz">
  <input type="hidden" name="fieldname" value="$fieldname">
  <input type="hidden" name="images" value="No">
  <input type="hidden" name="numchar" value="Numbers">
  <input type="hidden" name="size" value="1">
  <input type="hidden" name="searched" value="No">
  <input type="hidden" name="allow_html" value="No">
  <input type="hidden" name="carriage_pagebreak" value="No">
  
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="30" colspan="2" class="normaltext" background="$web_url/bar7.gif"><strong>Number
      Field Details:</strong></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$fieldname</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key
      Descriptive Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$diz</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Visible when
      browsing control panel?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" checked> <strong>Yes </strong>- This field will be visible inside the
      Control Panel with listings. <br>
      <input type="radio" value="No" name="visible"> <strong>No </strong>- This field will be
      hidden in the Control Panel when viewing listings. <br>
       </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text if no value
      is available: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="na"
      size="23"  style="width:100%" > <br>
      You could for example use: <strong>N/A </strong>or <strong>Not Available - </strong>This
      text is displayed when this field/key has no value in link listings. </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Required with
      new submissions?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="submitv"> <strong>Yes </strong>- Require visitors to provide a value for this field
      when doing a new submissions. <br>
      <input type="radio" value="No" name="submitv" checked> <strong>No </strong>- Don't Require
      visitors to provide a value for this field with new submissions. <br>
      </td>
    </tr>
    <tr>
      <td width="37%" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="Add Field/Key" name="B1"> <br>
      <BR>Please make a backup of your data before adding any extra fields/keys. The operations
      performed on your database is destructive. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


</body>
</html>
];


}



sub create_character_field
{

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Add a New Character Field ", qq[A Character Field lets you store any characters within it. A character field could hold a street address or zip code or telephone number, etc. A Character Field lets you store any kind of characters inside it and it also lets you collect texts (or characters) from visitors doing new submissions. You could for example create chracter fields to collect Addresses, Cities, States, Zip Codes,etc. from a visitors submitting a new listings. ]);

$fieldname = $q->param('fieldname');
$diz = $q->param('diz');


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox

<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="add_field_final">
  <input type="hidden" name="fieldname" value="$fieldname">
  <input type="hidden" name="diz" value="$diz">
  <input type="hidden" name="images" value="No">
  <input type="hidden" name="numchar" value="Characters">
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="30" colspan="2" class="normaltext" background="$web_url/bar7.gif"><strong>Character
      Field Details:</strong></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$fieldname</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key
      Descriptive Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$diz</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key size:
      (Number of characters) </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="size"
      size="13"> <br>
      Keep in mind that large fields/keys (bigger than 255 characters) may have the effect of
      slowing down searches - depending on the amount of links you have or are going to have. </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Visible when
      browsing control panel?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" checked> <strong>Yes </strong>- This field will be visible inside the
      Control Panel with listings. <br>
      <input type="radio" value="No" name="visible"> <strong>No </strong>- This field will be
      hidden in the Control Panel when viewing listings. <br>
      <font color="#FFFFFF">_ </font><br>
      It might be a good idea to set this to 'No' if this field/key is going to contain large
      amounts of text. When links has a lot of text the pages listing the links in their respective directories/categories inside the PowerSeek Control Panel might load slowly. </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Do you want this
      field/key to be searched? </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="searched"> <strong>Yes </strong>- Search this field when a search is performed <br>
      <input type="radio" value="No" name="searched" checked> <strong>No </strong>- Don't search
      this field when a search is performed. <br>
      <font color="#FFFFFF">_ </font><br>
      If you choose 'Yes' above then this field will be searched for matches when end users
      performs a search. </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text if no value
      is available: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="na"
      size="23"  style="width:100%"> <br>
      You could for example use: <strong>N/A </strong>or <strong>Not Available - </strong>This
      text is displayed when this field/key has no value in link listings. </td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Pre-Append HTML
        or Text:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><p>
        <textarea rows="4" name="preappend"
      cols="33" style="width:100%"></textarea>
        <br>
        This option allows you to pre-append text or HTML code when the value of this field is
        displayed with links or on 'More Info' pages. This comes in handy if you need  to display something before the value of this field and nothing when the field has no value.</p></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Append HTML or
        Text:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="append"
      cols="33" style="width:100%"></textarea>
        <br>
        This option allows you to append text or HTML code when the value of this field is
        displayed with links or on 'More Info' pages. This comes in handy if you need  to display something after the value of this field and nothing when the field has no value.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Required with
      new submissions?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="submitv"> <strong>Yes </strong>- Require visitors to provide a value for this field
      when doing a new submissions. <br>
      <input type="radio" value="No" name="submitv" checked> <strong>No </strong>- Don't Require
      visitors to provide a value for this field with new submissions. <br>
      </td>
    </tr>
    <tr>
      <td width="41%" bgcolor="#FFFFFF" class="normaltext"><strong>HTML allowed in this field?</strong></td>
      <td width="73%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Y"
      name="allow_html"> <strong>Yes </strong>- HTML code is allowed inside this field. (To
      create tables, pagebreaks, etc.) <br>
      <input type="radio" value="N" name="allow_html" checked> <strong>No </strong>- HTML code
      will be converted to display as HTML code inside this field when displayed. </td>
    </tr>
    <tr>
      <td width="41%" bgcolor="#FFFFFF" class="normaltext"><strong>Convert Carraige Returns to
      Pagebreaks? </strong></td>
      <td width="73%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Y"
      name="carriage_pagebreak"> <strong>Yes </strong>- Convert carriage returns in this field
      to page breaks. (Convert to &lt;br&gt;) <br>
      <input type="radio" value="N" name="carriage_pagebreak" checked> <strong>No </strong>-
      Don't convert carriage returns to page breaks. (Carriage returns has no effect) </td>
    </tr>
    <tr>
      <td width="37%" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="Add Field/Key" name="B1"> <br>
      <BR>Please make a backup of your data before adding any extra fields/keys. The operations
      performed on your database is destructive. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];



}






sub describe_field_type
{

if ($q->param('field_type') eq "Character_Field")
		{
		print qq[
		<p><strong>What is a Character Field Type?<br>
		</strong>A Character Field lets you store any characters within it. A character field
		could hold a street address or zip code or telephone number, etc. A Character Field lets
		you store any kind of characters inside it and it also lets you collect texts (or
		characters) from visitors doing new submissions. You could for example create chracter
		fields to collect Addresses, Cities, States, Zip Codes,etc. from a visitors submitting a
		new listings.</p>
		];
		}
		elsif ($q->param('field_type') eq "Number_Field")
		{
		print qq[<p><strong>What is a Number Field?<br>
</strong>A Number Field lets you store numbers within it.</p>
<blockquote>
  <p><strong>Important Notes Regarding 'Number Fields':</strong>&nbsp; </p>
</blockquote>
<ul>
  <li class="normaltext">This field   type cannot hold <strong>spaces, dashes or any other characters</strong> except valid numerical numbers.</li>
  <li class="normaltext">Numerical fields <strong>cannot be searched by PowerSeek's default search scripts.</strong> Only the <strong>advanced searches</strong> can search through these fields. (Note that you have to create advanced searches with PowerSeek)</li>
</ul>
];
		}
		elsif ($q->param('field_type') eq "Image_Field")
		{
		print qq[<p><strong>What is an Image Field?<br>
</strong>Image fields/keys holds URLs to images. When used in  link listings, the image is   automatically displayed - you just enter a URL path to an image and it is displayed with   your links. <span class="normaltext"><strong>Note</strong> that this field   type cannot be searched as it holds URLs to image files.</span></p>
];
		}
		elsif ($q->param('field_type') eq "File_Upload_Field")
		{
		print qq[

<p><strong>What is a File Upload Field?<br>
</strong>A File Upload Field lets you upload files like image files, pdf files, videos, etc. 
It can also enable visitors (users doing submissions) to upload images, pdf files, videos, or any other file types with their listings. You can for example use a File Upload Field to display images with link listings. You could also for example use it to provide .zip or .pdf downloads with link listings. It could also be used to display videos (or the functionality to view them) on the 'More Info' pages of listings.</p>
];

		}
		elsif ($q->param('field_type') eq "Content_Field")
		{
		print qq[<p><strong>What is a Content Field?<br>
</strong>Content Fields are just like 'Character Fields'. The difference is that PowerSeek provides you with a Wysiwyg Editor to edit these fields. The content to be added could be articles containing photos, tables, and other HTML elements. Note that Content Fields can hold tens of thousands of characters. It's definition is that it is a large field. This functionality also ads the option to use PowerSeek as a CMS (Content Management System)</p>
];
		}


}




sub add_field
{

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$keynr = @akeys;

if ($keynr == 41) {&problem_popup ("The extra field/key limit is 40."); }


$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Add a New Extra Field/Key ", qq[<font color="#FF0000"><strong>Important Note:</strong></font> Please make a backup of your data before adding any extra fields/keys. The operations performed on your database is destructive. You can find out how to make a backup in the PowerSeek documentation. <BR><a href="$admin_url/admin37.cgi"><b>Go Back</b></a>]);


##<option value="Article_Field">Article Field</option>

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script language="Javascript">

function xmlhttpPost(strURL, display_area) 
	 {
    var xmlHttpReq = false;
    var self = this;
    
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest(); }
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}

	 strURL = '$admin_url/admin37.cgi?fct=describe_field_type&field_type=' + strURL;
	 // alert(strURL);
	
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function() 
    	   {
         if (self.xmlHttpReq.readyState == 4) 
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText; 
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
}

</script>

</head>
<body>

$hbox


<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="add_field2"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="30" colspan="2" class="normaltext" background="$web_url/bar7.gif"><strong>Add
      an Extra Field/Key ( Up to 40 ) - Note that the maximum searchable fields that can be
      added is 11</strong></td>
    </tr>
    <tr>
      <td width="100%" height="30" colspan="2" bgcolor="#FFFFFF" class="normaltext"><strong>Plan
      your extra fields/keys well. </strong>You may add up to 40 extra fields/keys. </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field Type:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext">
      <select name="field_type" size="1" onchange="JavaScript:xmlhttpPost(field_type.options[field_type.selectedIndex].value, 'result')">
        <option value="Character_Field">Character Field</option>
        <option value="Number_Field">Number Field</option>
        <option value="Image_Field">Image Field</option>
        <option value="File_Upload_Field">File Upload Field</option>
        <option value="Content_Field">Content Field</option>
      </select>
      <div id="result"></div>
      </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key Name:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="fieldname"
      size="34"> <br>
      Only alphabetical and numerical characters allowed. This name will be used to create a field within the database table.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key
      Descriptive Name:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="diz"
      size="34"> <br>
      This name will be identified with this field name.<br>
      <strong>For example: </strong>City, Country, Telephone Number, etc...</td>
    </tr>
    <tr>
      <td width="37%" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="  << Go Back  " name="B2" onClick="history.go(-1); return false;"> <input type="submit" class="psbutton" value="    Next >>    " name="B1"><br>
      &nbsp; <br>
      Please make a backup of your data before adding any extra fields/keys. The operations
      performed on your database is destructive. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


<script language="Javascript">
xmlhttpPost('Character_Field', 'result');
</script>

</body>
</html>

];

}





sub save_field_key
{

### ERROR CHECKING IF UPLOAD FIELD
if ($q->param('upload_field') eq "true")
	{
	if ($q->param('filetypes') eq "") { &problem_popup ("You have to specify a value for the 'Accepted File Types'."); }
	if (int($q->param('uploadsize')) < 1) { &problem_popup ("You have to specify a value for the 'Maximum Upload File Size'."); }
	if ($q->param('filetype_error') eq "") { &problem_popup ("You have to specify a value for the 'Error Text' indicating that a file type is incorrect."); }
	if ($q->param('filesize_error') eq "") { &problem_popup ("You have to specify a value for the 'Error Text' indicating that the file size is to large."); }
	if (($q->param('req') eq "Yes") and ($q->param('reqtext') eq "")) { &problem_popup ("You have chosen to require that a file is uploaded but have specified no 'Error Text' to display when a user has not uploaded a file where a file upload is required."); }
	}


$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;

$not_avail = $q->param('na');
$not_avail =~ s/\n//g;
$not_avail =~ s/\t//g;
$crit = chr(10); $not_avail =~ s/$crit//g;
$crit = chr(13); $not_avail =~ s/$crit//g; 

open (KF, "> $data_dir/keys.dat");

foreach $kitem (@akeys)
	{
	if ($q->param('nrc') == $nrc)
		{
		($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $kitem);

		print KF $keyname . "\t" . 
					$q->param('visible') . "\t" . 
					$size . "\t" .
					$searched . "\t" .
					$q->param('description') . "\t" . 
					$not_avail . "\t" . 
					$imagef . "\t" .
					$numberfield . "\t" . 
					$q->param('req') . "\t" . 
					$q->param('allow_html') . "\t" . 
					$q->param('carriage_pagebreak') . "\n";
		}
		else
		{
		print KF $kitem . "\n";
		}
	$nrc++;
	}
close (KF);

#### 

if ($q->param('type') eq "character")
	{
	$appprefname = "chapp_" . $keyname . ".dat";
	open (CHA, "> $data_dir/$appprefname");
		print CHA $q->param('preappend') . ":-oPreo-:" . $q->param('append');
	close (CHA);
	}


#### IF UPLOAD FIELD

if ($q->param('upload_field') eq "true")
	{
	$key_upload_data = acs::get_file_contents("$data_dir/keysupl.dat");

	@upl_items = split (/:-o_:/, $key_upload_data);

	$filetypes_save = $q->param('filetypes');
	$filetypes_save =~ s/ //gi;
	$filetypes_save =~ s/\n//g;
	$crit = chr(10); $filetypes_save =~ s/$crit//g;
	$crit = chr(13); $filetypes_save =~ s/$crit//g; 


	open (KEYW, "> $data_dir/keysupl.dat");

		foreach $item (@upl_items)
			{
			($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t) = split (/:o:-:o:/, $item);
				
				if ($keyname eq $fieldname_t)
					{
					print KEYW $keyname .	":o:-:o:" . $filetypes_save . 
													":o:-:o:" . $q->param('preappend') . 
													":o:-:o:" . $q->param('append') . 
													":o:-:o:" . $q->param('uploadsize') . 
													":o:-:o:" . $q->param('filetype_error') . 
													":o:-:o:" . $q->param('reqtext') . 
													":o:-:o:" . $q->param('filesize_error') . 
													":-o_:";
					}
					else
					{
					print KEYW $item . ":-o_:";
					}
			}
			
	close (KEYW);
	
	
	#### WRITE RESIZE WIDTH/HEIGHT IF REQUIRED
	
	$field_filename = "$data_dir/imgres" . "_" . $keyname . ".dat";
	open (IFF, "> $field_filename");
		print IFF $q->param('width') . "\n";
		print IFF $q->param('height');
	close (IFF);
	
	
		if ($q->param('mconf') ne "")
			{
				open (DDT, "> $data_dir/imgresconf.dat");
					print DDT $q->param('mconf');
				close (DDT);	
			}
	
	}


##########


$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Field/Key Settings saved", qq[<a href="$admin_url/admin37.cgi">Click here to continue.</a>]);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html>
];


}






sub edit_keyfield
{

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;

foreach $kitem (@akeys)
	{
	if ($q->param('p') == $nrc)
		{
		($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $kitem);

		### DETERMINE FIELD TYPE
		if ($numberfield eq "Y") 
				{
				$numberfield = "Numbers";
				$e_field_type = "Number Field";
				}
		elsif ($numberfield eq "Upload") 
				{
				$numberfield = "Upload"; 
				$e_field_type = "Upload Field";
				}
		elsif ($imagef eq "Yes") 
				{
				$numberfield = "Image"; 
				$e_field_type = "Image Field";
				}
		elsif ($numberfield eq "Content") 
				{
				$numberfield = "Content"; 
				$e_field_type = "Content Field";
				}
			else
				{ 
				$numberfield = "Characters"; 
				$e_field_type = "Character Field";
				}
		
		if ($visible eq "Yes") { $visible_yes = "checked"; } else  { $visible_no = "checked"; }
		
		if ($req eq "Yes") { $req_yes = "checked"; } else  { $req_no = "checked"; } 
		
		if ($allow_html eq "N") { $allow_html_no = "checked"; } else  { $allow_html_yes = "checked"; }
		
		if ($carriage_pagebreak eq "Y") { $carriage_pagebreak_yes = "checked"; } else  { $carriage_pagebreak_no = "checked"; } 
		
		$orig_size = $size;
		
		}
	$nrc++;
	}

$nrc = $q->param('p');


$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Editing Extra Field/Key", qq[Enables you to change some aspects of this extra key/field.<BR><a href="$admin_url/admin37.cgi"><b>Go Back</b></a>]);  


#############################################################################
#### IF NUMBER FIELD
#############################################################################

if ($numberfield eq "Numbers")
	{
	
	#print "dsfsdf";
	
	# * description
	# * visible
	# * na
	# * req
	#allow_html
	#carriage_pagebreak


print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>


$hbox

<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="save_field_key">
  <input type="hidden" name="nrc" value="$nrc">
  <input type="hidden" name="allow_html" value="N">
  <input type="hidden" name="carriage_pagebreak" value="N">
  
  
<table border="0" cellpadding="6" width="100%" cellspacing="1" bgcolor="#E5E5E5">
    <tr>
      <td height="30" colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF"
      class="normaltext"><strong>Key/Field Details: </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Field Type:</strong></td>
      <td width="68%"  bgcolor="#FFFFFF" class="normaltext"><strong>$e_field_type</strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Key/Field Name: </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><strong>$keyname </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Descriptive Name: </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="description"
      size="50" value="$description">
      </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Visible in the Control Panel:
      </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" $visible_yes> <strong>Yes </strong>- This field will be visible inside the
      Control Panel with listings. <br>
      <input type="radio" value="No" name="visible" $visible_no> <strong>No </strong>- This
      field will be hidden in the Control Panel when viewing listings. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Not Available Text: </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="na"
      size="50" value="$na"> <br>
      Displayed with link listings when this field/key does not have a value. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Required with new
      submissions? </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="req" $req_yes> <strong>Yes </strong>- Require visitors to provide a value for this
      field when doing a new submissions. <br>
      <input type="radio" value="No" name="req" $req_no> <strong>No </strong>- Don't Require
      visitors to provide a value for this field with new submissions. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];
	
	}

#############################################################################
#### IF UPLOAD FIELD
#############################################################################

elsif ($numberfield eq "Upload")
{

$key_upload_data = acs::get_file_contents("$data_dir/keysupl.dat");

@upl_items = split (/:-o_:/, $key_upload_data);

foreach $item (@upl_items)
	{
	if ($item ne "")
	  {
	  ($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t, $filetype_error_t, $reqtext_t, $filesize_error_t) = split (/:o:-:o:/, $item);
		
		if ($keyname eq $fieldname_t)
			{
			$filetypes = $filetypes_t;
			$preappend = $preappend_t;
			$append = $append_t;
			$uploadsize = $uploadsize_t;
			
			$filetype_error = $filetype_error_t;
			$reqtext = $reqtext_t;
			$filesize_error = $filesize_error_t;
			}
	  }
	}
	


### CHECK FOR IMAGE RESIZING MODULES

if (($IM eq "false") and ($IMRES eq "false"))
	{
	$no_image_res_modules = "true";
	}
	else
	{

	$field_filename = "$data_dir/imgres" . "_" . $keyname . ".dat";
	$fieldwh = acs::get_file_contents($field_filename);
	
	($w, $h) = split(/\n/, $fieldwh);

	$img_res_options = qq[
	
 	<tr>
 <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Image Resizing Options:</strong><br>(Ignore if this field won't be holding images)</td>
       <td bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellspacing="0" cellpadding="0">
         <tr>
           <td width="7%"><p><strong>Width:</strong> </p></td>
           <td width="93%" height="30"><p>
             <input name="width" type="text" id="width" value="$w" size="10">
           pixels</p></td>
         </tr>
         <tr>
           <td><p><strong>Height:</strong></p></td>
           <td height="30"><p>
             <input name="height" type="text" id="height" value="$h" size="10">
           pixels</p></td>
         </tr>
         <tr>
           <td height="15" colspan="2">&nbsp;</td>
         </tr>
         <tr>
           <td height="30" colspan="2"><ul>
               <li class="normaltext">Leave the width and height options blank if this field is not going to be used for images or leave it blank if you don't want images to be resized when uploaded for this field.</li>
               <li class="normaltext">Specify a width and/or height value above if you would like to have images automatically resized when an image is uploaded for this upload field.</li>
               <li class="normaltext">If you want to keep the aspect ratio of the image, only provide one  value for the width or height. For example: leave the height property  blank and provide a value for the width property to resize the image to  a specific width but keep the aspect ratio. (The height will  automatically be resized to keep the aspect ratio)</li>
               <li class="normaltext">Note that this resize setting is globally valid for this field.</li>
               <li class="normaltext">When end users upload images when submitting or modifying listings then the image will automatically be resized to the width and/or height specified here.</li>
               <li><span class="normaltext">If invalid images are uploaded then no resizing will be done on the file as the file will not be a valid image file.</span></li>
             </ul></td>
           </tr>
       </table>
      </td>
    </tr>	
	];


			### CONFIGURE WHAT TO USE FOR IMAGE RESIZING
			if ((-e "$data_dir/imgresconf.dat") < 1)
				{
					if (($IM eq "true") and ($IMRES eq "false")) ### IMAGE MAGICK
						{
						open (DDT, "> $data_dir/imgresconf.dat");
							print DDT "IM";
						close (DDT);
						}
					elsif (($IM eq "false") and ($IMRES eq "true"))  ### IMAGE RESIZE MODULE
						{
						open (DDT, "> $data_dir/imgresconf.dat");
							print DDT "IMRES";
						close (DDT);	
						}
					else ### IF BOTH MODS INSTALLED USE image::resize
						{
						open (DDT, "> $data_dir/imgresconf.dat");
							print DDT "IMRES";
						close (DDT);	
						}
				}

			##################
	
			if (($IM eq "true") and ($IMRES eq "true"))
				{
				$img_res_setting = acs::get_file_contents("$data_dir/imgresconf.dat");
				
				if ($img_res_setting eq "IM") { $im_im = "checked"; } else { $im_res = "checked"; }
			
				$im_choose = qq[
				 <tr>
					<td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Choose a module to use to resize images: </strong><br>(Ignore if this field won't be holding images)</td>
					<td bgcolor="#FFFFFF" class="normaltext">
					 <strong> 
						<input name="mconf" type="radio" value="IM" $im_im>Image Magick<br>
						<input name="mconf" type="radio" value="IMRES" $im_res>Image::Resize (Perl Module)
					 </strong>
					</td>
				</tr>		
				];

				}
	
	
	}



print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox

<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="save_field_key"><input type="hidden" name="nrc"
  value="$nrc"><input type="hidden" name="upload_field" value="true"><input type="hidden"
  name="allow_html" value="N"><input type="hidden" name="carriage_pagebreak" value="N"><table
  border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="30" colspan="2" class="normaltext" background="$web_url/bar7.gif"><strong>File
      Upload Field Details:</strong></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><b>$keyname</b></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Field/Key
      Descriptive Name: </strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext" height="30"><input type="text"
      name="description" size="34" value="$description"></td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Visible when
      browsing control panel?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" $visible_yes> <strong>Yes </strong>- Display uploaded file name with
      listings<br>
      <input type="radio" value="No" name="visible" $visible_no> <strong>No </strong>- Don't
      display uploaded file name with listings</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text or HTML if
      no file is available:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="na"
      cols="33" style="width:100%">$na</textarea> <br>
      You could for example use: <strong>N/A </strong>or <strong>Not Available - </strong>This
      text is displayed when this field/key has no value in your link listings. You could also
      use <strong>HTML code</strong> in the above box.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Accepted File
      Types?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="filetypes"
      cols="33" style="width:100%">$filetypes</textarea><br>
      Place a * in the above box if all file types are allowed. If you are only allowing certain
      file types like for example .avi, .jpg, .gif, etc.. Then enter them in a comma delimited
      format. <br>
      <strong>For example: .avi,.gif,.jpg</strong><BR>
      <b>Don't place any white space within this section.</b></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Error text indicating that
      the file type is incorrect:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="filetype_error" type="text"
      value="$filetype_error" style="width:100%" size="20"><br>
      If you only accept certain file types to be uploaded then this error message will be
      displayed to indicate that the file could not be uploaded because the file-type is
      incorrect. <b>Note that this text will also be diplayed when a file has no extension.</b>
      What this means that files to be uploaded has to have an extension.     </td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Required with
      new submissions?</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="req" $req_yes> <strong>Yes </strong>- Require visitors to upload a file with new
      submissions. <br>
      <input type="radio" value="No" name="req" $req_no> <strong>No </strong>- Don't Require
      visitors to upload a file with new submissions</td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text indicating that a file
      upload is required:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label><input name="reqtext" type="text"
      value="$reqtext" style="width:100%" size="20"></label><br>
      If you are going to require that users submit/upload an image from the 'Add URL' or
      'Modify' forms then specify the text displayed to them if they didn't specify a file to
      upload with the 'Add URL' or 'Modify' forms</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Pre-Append HTML
      or Text:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="preappend"
      cols="33" style="width:100%">$preappend</textarea><br>
      This option allows you to pre-append text or HTML code when the value of this field is
      displayed with links or on 'More Info' pages. <br>
      &nbsp; <br>
      <strong>For example:<br>
      </strong>If this field is going to contain uploaded images you would like to display with
      &nbsp; listings then you could use the following HTML code here:<br>
      <font color="#0000FF"><strong>&lt;img src=&quot;</strong></font><br>
      and in the <strong>'Append HTML or Text' </strong>box below:<br>
      <font color="#0000FF"><strong>&quot; width=&quot;16&quot; height=&quot;16&quot;
      alt=&quot;Some Alt Text&quot;&gt;</strong></font><p>The above example will then display an
      image when you simply place the name of this field with exclamation marks on both sides in
      any PowerSeek <a href="$admin_url/admin6.cgi?fct=edit_template&amp;template=tmplsearch"
      target="_blank">link style</a> template.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Append HTML or
      Text:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="append"
      cols="33" style="width:100%">$append</textarea><br>
      This option allows you to append text or HTML code when the value of this field is
      displayed with links or on 'More Info' pages. <p><strong>For example:<br>
      </strong>If this field is going to contain uploaded images that you would like to display
      with&nbsp; listings then you could use the following HTML code for the <strong>'Pre-Append
      HTML or Text':</strong><br>
      <font color="#0000FF"><strong>&lt;img src=&quot;</strong></font><br>
      and in here you could use:<br>
      <font color="#0000FF"><strong>&quot; width=&quot;16&quot; height=&quot;16&quot;
      alt=&quot;Some Alt Text&quot;&gt;</strong></font></p>
      <p>The above example will then display an image when you simply place the name of this
      field with exclamation marks on both sides in any PowerSeek <a
      href="$admin_url/admin6.cgi?fct=edit_template&amp;template=tmplsearch" target="_blank">link
      style</a> template.</td>
    </tr>
    <tr>
      <td width="37%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Maximum Upload
      File Size:</strong></td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="uploadsize"
      size="8" value="$uploadsize"> <strong>KB </strong>(Kilobytes)</td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Text indicating that the
      file size is to large:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><label><input name="filesize_error" type="text"
      value="$filesize_error" style="width:100%" size="20"></label><br>
      This text will be displayed when a user uploads a file that exceeds the maximum file size
      from the 'Add URL' or 'Modify' forms</td>
    </tr>
   $img_res_options
   $im_choose
    <tr>
      <td width="37%" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="63%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="    Save    " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>

];


}
#############################################################################
#### IF CHARACTER FIELD
#############################################################################

elsif ($numberfield eq "Characters")
{

$appprefname = "chapp_" . $keyname . ".dat";
$apppredata = acs::get_file_contents("$data_dir/$appprefname");

($preappend, $append) = split (/:-oPreo-:/, $apppredata);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="save_field_key">
  <input type="hidden" name="nrc" value="$nrc">
  <input type="hidden" name="type" value="character">
  <table border="0" cellpadding="6" width="100%" cellspacing="1" bgcolor="#E5E5E5">
    <tr>
      <td height="30" colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF"
      class="normaltext"><strong>Character Key/Field Details: </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Key/Field Name: </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><strong>$keyname </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Size: </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><strong>$size </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Searched?</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><strong>$searched</strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Descriptive Name:</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="description"
      size="34" value="$description">
      </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Visible in the Control Panel:
      </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" $visible_yes> <strong>Yes </strong>- This field will be visible inside the
      Control Panel with listings. <br>
      <input type="radio" value="No" name="visible" $visible_no> <strong>No </strong>- This
      field will be hidden in the Control Panel when viewing listings. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Not Available Text:</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="na"
      size="34" value="$na"> <br>
      Displayed in your link listings when this field/key does not have a value. </td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Pre-Append HTML
        or Text:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><p>
        <textarea rows="4" name="preappend"
      cols="33" style="width:100%">$preappend</textarea>
        <br>
        This option allows you to pre-append text or HTML code when the value of this field is
        displayed with links or on 'More Info' pages. This comes in handy if you need  to display something before the value of this field and nothing when the field has no value.</p></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Append HTML or
        Text:</strong></td>
      <td bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="append"
      cols="33" style="width:100%">$append</textarea>
        <br>
        This option allows you to append text or HTML code when the value of this field is
        displayed with links or on 'More Info' pages. This comes in handy if you need  to display something after the value of this field and nothing when the field has no value.</td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Required with new
      submissions?</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="req" $req_yes> <strong>Yes </strong>- Require visitors to provide a value for this
      field when doing a new submissions. <br>
      <input type="radio" value="No" name="req" $req_no> <strong>No </strong>- Don't Require
      visitors to provide a value for this field with new submissions. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>HTML allowed in this field?</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Y"
      name="allow_html" $allow_html_yes> <strong>Yes </strong>- HTML code is allowed inside this
      field. (To create tables, pagebreaks, etc.) <br>
      <input type="radio" value="N" name="allow_html" $allow_html_no> <strong>No </strong>- HTML
      code will be converted to display as code inside this field when displayed. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Convert Carraige Returns to
      Pagebreaks? </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Y"
      name="carriage_pagebreak" $carriage_pagebreak_yes> <strong>Yes </strong>- Convert carriage
      returns in this field to page breaks. (Convert to &lt;br&gt;) <br>
      <input type="radio" value="N" name="carriage_pagebreak" $carriage_pagebreak_no> <strong>No
      </strong>- Don't convert carriage returns to page breaks. (Carriage returns has no effect)
      </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];


}
#############################################################################
#### IF IMAGE FIELD
#############################################################################
elsif ($numberfield eq "Image")
{

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

$hbox

<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="save_field_key">
  <input type="hidden" name="nrc" value="$nrc">
  <input type="hidden" name="allow_html" value="N">
  <input type="hidden" name="carriage_pagebreak" value="N">

<table border="0" cellpadding="6" width="100%" cellspacing="1" bgcolor="#E5E5E5">
    <tr>
      <td height="30" colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF"
      class="normaltext"><strong>Image Key/Field Details: </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Key/Field Name: </strong></td>
      <td width="68%" height="40" bgcolor="#FFFFFF" class="normaltext"><strong>$keyname </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Descriptive Name: </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="description"
      size="34" value="$description"> <br>
      The descriptive name of this field/key </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Visible in the Control Panel:
      </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="visible" $visible_yes> <strong>Yes </strong>- Images will be displayed inside the
      Control Panel<br>
      <input type="radio" value="No" name="visible" $visible_no> <strong>No </strong>- Images
      won't be displayed inside the Control Panel</td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Not Available Text: </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="na"
      cols="37"  style="width:100%">$na</textarea> <br>
      Displayed in your link listings when this field/key does not have a value. You could also
      include HTML code here. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Required with new
      submissions? </strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="req" $req_yes> <strong>Yes </strong>- Require visitors to provide a value for this
      field when doing a new submissions. <br>
      <input type="radio" value="No" name="req" $req_no> <strong>No </strong>- Don't Require
      visitors to provide a value for this field with new submissions. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>


];

}
#############################################################################
#### IF ARTIVLE FIELD
#############################################################################

if ($numberfield eq "Content")
	{

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

$hbox

<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="save_field_key">
  <input type="hidden" name="nrc" value="$nrc">
  <input type="hidden" name="allow_html" value="N">
  <input type="hidden" name="visible" value="No">
  <input type="hidden" name="carriage_pagebreak" value="N">
  
  <table border="0" cellpadding="6" width="100%" cellspacing="1" bgcolor="#E5E5E5">
    <tr>
      <td height="30" colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF"
      class="normaltext"><strong>Article Key/Field Details: </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Key/Field Name: </strong></td>
      <td width="68%" height="40" bgcolor="#FFFFFF" class="normaltext"><strong>$keyname </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Size: </strong></td>
      <td width="68%" height="40" bgcolor="#FFFFFF" class="normaltext"><strong>Large </strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Searched?</strong></td>
      <td width="68%" height="40" bgcolor="#FFFFFF" class="normaltext"><strong>$searched</strong></td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Descriptive Name:</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="description"
      size="34" value="$description"> <br>
      The descriptive name of this field/key</td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext" valign="top"><strong>Text or HTML if
      field is empty:</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="na"
      cols="33" style="width:100%">$na</textarea> <br>
      You could for example use: <strong>N/A </strong>or <strong>Not Available - </strong>This
      text is displayed when this field/key has no value in your link listings. You could also
      use <strong>HTML code</strong> in the above box.</td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"><strong>Required with new
      submissions?</strong></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="Yes"
      name="req" $req_yes> <strong>Yes </strong>- Require visitors to provide a value for this
      field when doing a new submissions. <br>
      <input type="radio" value="No" name="req" $req_no> <strong>No </strong>- Don't Require
      visitors to provide a value for this field with new submissions. </td>
    </tr>
    <tr>
      <td width="32%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="68%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


</body>
</html>
];
	
	}


}





sub start
{

$top_keytable = qq[
<table border="0" cellpadding="6" width="100%" class="tdtable1" cellspacing="1">
  <tr>
    <td class="tdclass1" width="100%" colspan="8" valign="top" background="$web_url/bar6.gif" ><strong>Extra Fields/Keys: </strong></td>
  </tr>
  <tr>
    <td width="10%"  class="tdclass1" bgcolor="#F4F4F4"><strong>Field Name</strong></td>
    <td width="35%"  class="tdclass1" bgcolor="#F4F4F4"><strong>Description </strong></td>
    <td width="5%" align="center"  class="tdclass1" bgcolor="#F4F4F4"><strong>Type</strong></td>
    <td width="5%" align="center"  class="tdclass1" bgcolor="#F4F4F4"><strong>Size</strong></td>
    <td width="5%" align="center"  class="tdclass1" bgcolor="#F4F4F4"><strong>Visible?</strong></td>
    <td width="5%" align="center"  class="tdclass1" bgcolor="#F4F4F4"><strong>Searched? </strong></td>
    <td width="5%" align="center"  class="tdclass1" bgcolor="#F4F4F4"><strong>Required </strong></td>
    <td width="30%" align="center"  class="tdclass1" bgcolor="#F4F4F4"><strong>Implementation / Edit / Del</strong></td>
  </tr>
];


$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;

$number_of_keys = @akeys;


### CHECK FOR FIELD RELATED ERRORS


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "show columns from links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 
	while ( @row = $sth->fetchrow() )
	{
	if ($row[0] =~ /_cust/)
		{
		push (@dbarr, $row[0]);
		}
	}


$sql = "SELECT count(*) FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 
	while ( @row = $sth->fetchrow() )
	{
	$linkcount = $row[0];
	}

$sth->finish;
$dbh->disconnect;



$dbfields_number = @dbarr;
$psfiekds_number = @akeys;


if ($dbfields_number ne $psfiekds_number)
	{
	$out_of_sync = qq[

<BR>
<table border="0" cellpadding="10" cellspacing="0" width="100%" style="border: 2px solid rgb(255,0,0)">
  <tr>
    <td width="100%" align="center" class="normaltext"><span class="style1">WARNING: </span><br>
    Your database contains extra fields that PowerSeek is not configured for. This can cause
    search related problems and SQL related errors. <br>
    <a href="$admin_url/repairfields.cgi"><strong>Click here to repair the problem. </strong></a></td>
  </tr>
</table>
<BR>
	
	];
	}







foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req_text) = split (/\t/, $kitem);
	
	if ($numberfield eq "Y") { $numberfield = "Numbers"; $fcolor = "#8080C0";} 
	elsif ($numberfield eq "Upload") { $numberfield = "Upload"; $fcolor = "#804040";}
	elsif ($numberfield eq "Content") { $numberfield = "Content"; $size = "Large"; $fcolor = "#800080"; } 
	else 
		{
		$numberfield = "Chars"; $fcolor = "#8080C0";
		if ($size > 255) { $size = "Large"; }
		}

	if ($imagef eq "Yes") { $numberfield = "Image"; $fcolor = "#008040";}

	if (($keyname eq "pslat") or ($keyname eq "pslon"))
		{
			$keytable = $keytable . qq[
			<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
			 <td class="tdclass1"><strong><font color="$fcolor">$keyname </font></strong></td>
			 <td class="tdclass1">$description </td>
			 <td align="center" class="tdclass1"><b>$numberfield</b> </td>
			 <td align="center" class="tdclass1">$size </td>
			 <td align="center" class="tdclass1">$visible </td>
			  <td align="center" class="tdclass1">$searched </td>
			 <td align="center" class="tdclass1">$req_text </td>
			 <td align="center" class="tdclass1">Google Map Fields</td>
			</tr>
			];
		}
		else
		{
			$keytable = $keytable . qq[
			<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
			 <td class="tdclass1"><strong><font color="$fcolor">$keyname </font></strong></td>
			 <td class="tdclass1">$description </td>
			 <td align="center" class="tdclass1"><b>$numberfield</b> </td>
			 <td align="center" class="tdclass1">$size </td>
			 <td align="center" class="tdclass1">$visible </td>
			  <td align="center" class="tdclass1">$searched </td>
			 <td align="center" class="tdclass1">$req_text </td>
			 <td align="center" class="tdclass1"><a href="$admin_url/admin37.cgi?fct=implement&amp;p=$nrc" class="bordtext">Implementation</a>  <a
			 href="$admin_url/admin37.cgi?fct=edit&amp;p=$nrc" class="bordtext">Edit</a>  <a
			 href="$admin_url/admin37.cgi?fct=delfield&amp;p=$nrc" class="bordtext">Del </a></td>
			</tr>
			];
		}

	$nrc++;
	}



if ($keytable ne "")
	{
		$top_keytable = $top_keytable . $keytable  . qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
	  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
		</table>
		];
	}
	else
	{
		$keytable = qq[
		<tr>
		  <td width="114%" colspan="10" class="normaltext">No extra fields/keys present in the database</td>
		</tr>
		];

		$top_keytable = $top_keytable . $keytable  . qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
		  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
		</table>
		];
	}



if ($linkcount < 10000)
	{
	$warning = "";
	}
	else
	{
	$warning = "<BR><BR><b>Important Note:</b> Your database currently has more than 10 000 links. It is strongly recommended that you make a backup of your database before adding any extra fields. You can make a backup of your database by clicking the 'Plug-ins' tab and there after 'Data Backups'";
	}



$hbox = acs::get_heading_box("$web_url/ic_key.gif", "Extra Fields/Keys Settings", qq[Extra fields/keys enables you to add additional fields for your link listings. This enables you to collect or add additional information with link listings like telephone numbers, addresses, zip codes, countries, file uploads, uploaded images, etc. This section also enables you to change some aspects of your extra fields/keys or add extra fields/keys. $warning ]);  

	
print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
$out_of_sync
$top_keytable
<form method="POST" action="$admin_url/admin37.cgi" style="margin-bottom:0; margin-top:0;" >
  <input type="hidden" name="fct" value="add_field"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" style="border: 1px solid rgb(221,221,221)">
    <tr>
      <td width="100%"><input type="submit" class="psbutton" value="Add a New Extra Field" name="B1"> </td>
    </tr>
    <tr>
      <td width="100%"><ul>
        <li class="normaltext"><strong>Please make a backup of your data before editing or adding any extra fields. </strong></li>
        <li class="normaltext"><strong>The operations performed on your database is destructive. </strong></li>
      </ul>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(216,216,216)">
  <tr>
    <td colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Options Legend:</strong></td>
  </tr>
  <tr>
    <td width="21%" class="normaltext"><strong>Key/Field Name:</strong></td>
    <td width="79%" class="normaltext">The name of the field/key.</td>
  </tr>
  <tr>
    <td width="21%" bgcolor="#FBFBFB" class="normaltext"><strong>Description:</strong></td>
    <td width="79%" bgcolor="#FBFBFB" class="normaltext">The descriptive name of the field/key
    - used to describe the field/key in the control panel.</td>
  </tr>
  <tr>
    <td width="21%" class="normaltext"><strong>Type:</strong></td>
    <td width="79%" class="normaltext">The field type. (Characters, Numbers, Images, Upload or
    Content)</td>
  </tr>
  <tr>
    <td width="21%" bgcolor="#FBFBFB" class="normaltext"><strong>Size:</strong></td>
    <td width="79%" bgcolor="#FBFBFB" class="normaltext">The size of the field/key.</td>
  </tr>
  <tr>
    <td width="21%" class="normaltext"><strong>Visible?</strong></td>
    <td width="79%" class="normaltext">Is the values of this field/key visible in the control
    panel? </td>
  </tr>
  <tr>
    <td width="21%" class="normaltext" bgcolor="#FBFBFB"><strong>Searched? </strong></td>
    <td width="79%" class="normaltext" bgcolor="#FBFBFB">Is the field/key searched when end
    users do searches? </td>
  </tr>
  <tr>
    <td width="21%" bgcolor="#FFFFFF" class="normaltext"><strong>Required </strong></td>
    <td width="79%" bgcolor="#FFFFFF" class="normaltext">Is it required that end users supply
    a value for this field/key when doing a new submission? </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
</form>
</body>
</html>
];



}

####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

