#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "lchecker") {&do_search;}
if ($q->param('fct') eq "users") {&do_search;}


##################################################################################

sub do_search
{


$fct = $q->param('fct');

$pcode = acs::get_popupjs;

$page_top = qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

$pcode

function checkall(formname,thestate)
	{
	BoxNames=new Array(!!sel_options!!)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}


function submitForm(theForm, selv) 
  {
  BoxNames=new Array(!!sel_options!!)
  windowName = "PowerSeek";
  windowURL = theForm.action + '?';
  var c = 0; 
	for (c=0;c < BoxNames.length; c++)
		{
		chvl = eval("theForm." + BoxNames[c] + ".checked");
		if (chvl)
			{
			boxnm = eval("theForm." + BoxNames[c] + ".value");
			windowURL = windowURL + BoxNames[c] + '=' + boxnm + '&';
			}
		}
	
    windowURL = windowURL + 'itemnrs=!!itemnrs!!&';
    
    if (selv == 1)
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown1.value;
    	}
    	else
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown.value;
    	}
    
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=600,height=400'";
    var popupwin = null;
    
    var random = parseInt(Math.random()*10000)
    
    myWindow = window.open(windowURL, 'popupwin' + random, myspecs);
    myWindow.focus();
  } 

// End Hide -->
</script>


</head>
<body>
];


### WRITE RESULTS PER PAGE
if ($q->param('per_page') ne "") 
	{
	$resperpage = $q->param('per_page');
	open (RSP, "> $data_dir/lnkchk.dat");
		print RSP $resperpage;
	close (RSP);
	}



### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }




### GET ERROR CODES FOR FILTER

if ($q->param('fct') eq "lchecker") 
{
$filter_by = $q->param('filter_by');

$sql = "SELECT problemid FROM brokenlnks2 GROUP BY problemid";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();

while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq $filter_by) { $selected = "selected"; } else { $selected = ""; }
	
	($ertext,$tmp) = &get_web_server_error($row[0]);
	if ($ertext ne "") { $ertext = "(" . $ertext . ")"; }
	
	$foptions = $foptions . qq[<option value="$row[0]" $selected>Filter by Error Code $row[0] $ertext</option>];
	}

if ($rows > 0)
	{

$filterbox = qq[
<select name="filter_by" size="1">
<option value="nofilter">No Filter</option>
$foptions
</select> <input type="submit" class="psbutton" value="   Go   " name="B1">
];
	}
	
}



### GET EXTRA KEYS/FIELDS 

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;




### PREPARE SQL QUERY

$sth = $dbh->prepare("SELECT COUNT(*) FROM brokenlnks");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ){$broken_link_count = $row[0];}

if ($fct eq "lchecker") ### IF MANAGING BROKEN LINKS CHECKED BY BROKEN LINK CHECKER
{
if (($q->param('filter_by') ne "") and ($q->param('filter_by') ne "nofilter"))
	{
	$tfilter= $q->param('filter_by');
	$to_filter = "AND (C.problemid = '$tfilter')";
	}

$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*, C.lnkproblem, C.problemid
			 FROM links AS A,
		       	dirs AS B, 
		       	brokenlnks2 AS C
		       	WHERE 
		       	(A.cid = B.cid) AND (C.lnkid = A.lnkid) $to_filter
		       	ORDER BY C.lnkproblem, A.premium DESC
	       ";
}
else
{

$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*, C.lnkproblem, C.lnknotes
			 FROM links AS A,
		       	dirs AS B, 
		       	brokenlnks AS C
		       	WHERE 
		       	(A.cid = B.cid) AND (C.lnkid = A.lnkid) $to_filter
		       	ORDER BY C.lnkproblem, A.premium DESC
	       ";

}

	
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();


### PREPARE PAGES

$gsettings = new_gsettings acs; 


$icnt = $rows;

$respp = acs::get_file_contents("$data_dir/lnkchk.dat");
if ($respp eq "") {$respp = 50;}
$nr_searchres = int($respp);


$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;




############


if (int($respp) == 10) { $sel10 = "selected"; }
if (int($respp) == 20) { $sel20 = "selected"; }
if (int($respp) == 50) { $sel50 = "selected"; }
if (int($respp) == 100) { $sel100 = "selected"; }
if (int($respp) == 200) { $sel200 = "selected"; }
if (int($respp) == 500) { $sel500 = "selected"; }
if (int($respp) == 1000) { $sel1000 = "selected"; }



if ($fct eq "users") { $grx = "$web_url/ic_users.gif"; } else {  $grx = "$web_url/ic_dirs.gif"; } 
if ($fct eq "users") { $heading = "Broken Links Reported by Visitors"; } else {  $heading = "Broken Links Reported by Link Checker"; } 


$hbox = acs::get_heading_box("$web_url/ic_dirs.gif", "$heading", qq[Displaying<strong> $rows</strong> broken links. | <strong><a href="$admin_url/admin44.cgi">Go Back</a> | <a href="javascript:onClick=window.close()">Close</a> this window</strong>]);


if ($rows > 0)
{
$page_middle = qq[

$hbox

<form method="POST" action="$admin_url/admin58.cgi">
<input type="hidden" name="fct" value="$fct">
  <table border="0" cellpadding="6" cellspacing="1" width="100%" class="aborder">
    <tr>
      <td width="50%">
		$filterbox
      </td>
      <td width="50%" align="right"><select name="per_page" size="1">
        <option value="10" $sel10>List 10 Results Per Page</option>
        <option value="20" $sel20>List 20 Results Per Page</option>
        <option value="50" $sel50>List 50 Results Per Page</option>
        <option value="100" $sel100>List 100 Results Per Page</option>
        <option value="200" $sel200>List 200 Results Per Page</option>
        <option value="500" $sel500>List 500 Results Per Page</option>
        <option value="1000" $sel1000>List 1000 Results Per Page</option>
      </select> <input type="submit" class="psbutton" value="   Go   " name="B2"></td>
    </tr>
  </table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>   
</form>

<form name = "select_all" method="POST" action="$admin_url/admin39.cgi" style="margin-bottom:0; margin-top:0;" >
<table width="100%%" cellspacing="0" cellpadding="0">
  <tr>
    <td height="32">
    <img src="$web_url/dbut5.gif">
      <input type="hidden" name="fct" value="$fct">
        <select name="daction1" size="1">
          <option value="quedelete">Only Remove Checked Items From Queue (Don't Delete Links)</option>
          <option value="delete">Remove Checked Items From Queue and Delete Links</option>
        </select>
        <input type="submit" class="psbutton" value="   Go   " name="B3">
    </td>
  </tr>
</table>
];
}
else
{


$page_middle = $hbox . qq[<form method="POST" action="$admin_url/admin58.cgi">
<input type="hidden" name="fct" value="$fct">
  <table border="0" cellpadding="6" cellspacing="1" width="100%" class="aborder">
    <tr>
      <td width="50%">
		$filterbox
      </td>
      <td width="50%" align="right"><select name="per_page" size="1">
        <option value="10" $sel10>List 10 Results Per Page</option>
        <option value="20" $sel20>List 20 Results Per Page</option>
        <option value="50" $sel50>List 50 Results Per Page</option>
        <option value="100" $sel100>List 100 Results Per Page</option>
        <option value="200" $sel200>List 200 Results Per Page</option>
        <option value="500" $sel500>List 500 Results Per Page</option>
        <option value="1000" $sel1000>List 1000 Results Per Page</option>
      </select> <input type="submit" class="psbutton" value="   Go   " name="B2"></td>
    </tr>
  </table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>   
</form>
];
}



############


$form_c_counter = 0;
$c_counter = 0;
$printcrit = "";
$highnr = 0; $bcnt = 0;
while ( @row = $sth->fetchrow() )
	{
	if ($highnr == 0){$high_number = $row[44 + $knr];}
	$highnr++;
	
	if (($ippc > $st) and ($ippc <= $nd))
    {
		$cats = "";
		for ($ms = 0; $ms < 16; $ms++) 
			{
			if ($row[$ms] ne "")
				{
				$cats = $cats . $row[$ms] . "/";
				}
			}
			
	 ### GET ENCODED CAT
			#if ($q->param('fct') eq "blinks") 
				#{
				$jscript_boxes = $jscript_boxes . "'C" . "$bcnt',";
				$bname = "C" . $bcnt; $bcnt++;
				$cbox = "<input type=\"checkbox\" name=\"$bname\" value=\"$row[17]\">";
				#}
				#else
				#{
				#$cbname = "C" . $c_counter;
				#$cb_val = $row[17] . "-" . $row[16];
				#$cbox = "<input type=\"checkbox\" name=\"$cbname\" value=\"$cb_val\">";
				#$c_counter++;
				#}
			
			$printcrit = $printcrit . "$cbox<b> $ippc. <a href=\"$row[22]\" target=\"_blank\">$row[19]</a></b><BR>";
			$printcrit = $printcrit .  "$row[20]<BR>";
			$printcrit = $printcrit .  "<b>$row[22]</b><BR>";

			#### EXTRA KEYS/FIELDS
			$field_key_count = 44;
			foreach $kitem (@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);

			   if (($visible eq "No") and ($nmbr eq "Content"))
			   	{
			   	$blankv = "";
			   	if (length($row[$field_key_count]) < 10) { $blankv = "- <b>Empty</b>"; }
			   	$printcrit = $printcrit . qq[<a href="$admin_url/admin80.cgi?id=$row[17]&key=$keyname&fct=edit" onClick="popup('$admin_url/admin80.cgi?id=$row[17]&key=$keyname&fct=edit',screen.width-200,screen.height-200);return false;"><font color="#800080"><b>$description</b></font></a> <i>(Content Field $blankv)</i><BR>];
			   	}				
				elsif (($nmbr eq "Upload") and ($visible eq "Yes"))
					{
						if ($row[$field_key_count] ne "")
							{
							$e_imagelink = "$web_url/imagefiles/$row[17]/$keyname" . "." .  $row[$field_key_count];
							$printcrit = $printcrit .  qq[<b><font color="#804040">$description:</font></b> <a href="$e_imagelink" target="_blank">$e_imagelink</a><br>];
							}
							else
							{
							$printcrit = $printcrit .  qq[<b><font color="#804040">$description:</font></b> $na<br>];
							}
					}
				elsif (($visible eq "Yes") and ($imgk ne "Yes"))
					{
						$printcrit = $printcrit .  "<b><font color=\"#8080C0\">$description:</font></b> $row[$field_key_count]<br>";
					}
					elsif (($imgk eq "Yes") and ($visible eq "Yes"))
					{
						if ($row[$field_key_count] ne "")
							{
							$printcrit = $printcrit .  "<img src=\"$row[$field_key_count]\"><br>";
							}
					}
					
				$field_key_count++;
				}

			$ecat = "";
			@acts = split (/\//, $cats);
			foreach $citem (@acts)
				{
				$ecat = $ecat . acs::encode_dir($citem) . "-";
				}
			chop($ecat);

			$printcrit = $printcrit . "<b>ID: $row[17]</b><BR>";

			$printcrit = $printcrit .  "<img src=\"$web_url/dir.gif\"> From: <a href=\"$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]\" 
			onClick=\"self.opener.location='$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]'; self.opener.focus(); return false;\"> $cats</a><BR>";

$printcrit = $printcrit . qq[
 <a href="$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]',850, 700, 300, 100);return false;" class="bordtext2">Edit</a>  
 <a href="$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]',850, 700, 300, 100);return false;" class="bordtext2">Move</a>  
 <a href="$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]',850, 700, 300, 100);return false;" class="bordtext2">Copy</a> 
];
		

			$printcrit = $printcrit .  "<br><font color=\"#FF8000\"><b>Problem:</b> $row[$field_key_count]<br>";
			$printcrit = $printcrit .  "<b>Notes:</b> $row[$field_key_count +1]</font><br><br>";

				$prem_listingg = "";
				if ($row[30] > 0)
					{
						if ($row[38] > 0)
							{
							$expire_date = acs::decode_date($row[39]);
							}
							else
							{
							$expire_date = "No Date Set";
							}
						$prem_listingg = "<img src=\"$web_url/premi2.gif\" border=\"0\">";
						$prem_pos = "<font color=\"#FF0000\"><b>Premium postion: $row[31]</b></font><br><font color=\"#FF8040\"><b>Expires: $expire_date</b></font><br>";

						$all_matches = $all_matches . qq[<table width="100%" class="aborder"><tr><td width="1%" valign="top">$prem_listingg</td><td width="99%" class="normaltext">$printcrit</td></tr></table><BR>];
					}
					else
					{
						$all_matches =  $all_matches . qq[<table width="100%" class="aborder"><tr><td width="1%" valign="top">$prem_listingg</td><td width="99%" class="normaltext">$printcrit</td></tr></table><BR>];
					}
					$printcrit = "";


		 $form_c_counter++;
		}
	$ippc++;
	}

########

if (($broken_link_count > 0) and ($rows == 0))
	{
	$sth = $dbh->prepare("DELETE FROM brokenlnks");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	}

########

$sth->finish;
$dbh->disconnect;


#$all_matches = $all_matches .  "<hr size=\"1\" color=\"#E8E8E8\">";



#### PAGES 
$fct= $q->param('fct');

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " <span class=\"bordtext2\"><b>[ $pg ]</b></span> ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/admin58.cgi?st=$st1&nd=$nd1&fct=$fct&filter_by=$filter_by&per_page=$nr_searchres\" class=\"bordtext2\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "<span class=\"bordtext2\"><b>Pages:</b></span> " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}

$allpages = $page_crit .  $pgstring . "<BR><BR>";


### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin58.cgi?st=$st1&nd=$nd1&fct=$fct&filter_by=$filter_by&per_page=$nr_searchres\" class=\"bordtext2\"><b>Next Page >></b></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin58.cgi?st=$st1&nd=$nd1&fct=$fct&filter_by=$filter_by&per_page=$nr_searchres\" class=\"bordtext2\"><b><< Prev Page</b></a> ";
		}
  
	$prevnext = $prev .  $nextt;

if ($rows > 0)
	{
	$page_crit = $page_crit .  qq[
	
	<table width="100%%" cellspacing="0" cellpadding="0">
	  <tr>
	    <td width="50%">
	    <span class="normaltext"><a href="javascript:checkall('select_all',true)" class="bordtext2">Check All</a>   <a href="javascript:checkall('select_all',false)"  class="bordtext2">UnCheck All</a>
	    </span></td>
	    <td align="right" class="normaltext">$prevnext <span class="bordtext2"><b>Page $targpage of $pg</b></span></td>
	  </tr>
	</table>
	<BR>
	];
	}




if ($rows > 0)
	{
	$jscript_boxes = substr($jscript_boxes, 0, length($jscript_boxes) - 1);

$all_matches = $all_matches . qq[
<img src="$web_url/dbut6.gif">
<input type="hidden" name="inumber" value="$highnr">
 <select name="daction" size="1">
    <option value="quedelete">Only Remove Checked Items From Queue (Don't Delete Links)</option>
    <option value="delete">Remove Checked Items From Queue and Delete Links</option>
  </select> <input type="submit" class="psbutton" value="   Go   " name="B4">
</form>

<script LANGUAGE="JavaScript">
<!-- Hide
function checkall(formname,thestate)
	{
	BoxNames=new Array($jscript_boxes);
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c]);
		boxname.checked = thestate;
		}
	}
// End Hide -->
</script>
<BR>

];

	}


$all_matches = $all_matches . "</body></html>";


### FILL JAVASCRIPT VARS

for ($ms = 0; $ms < $form_c_counter; $ms++) 
	{
	$sel_options = $sel_options . "'C" . $ms . "',";
	}
	$sel_options = substr($sel_options, 0, length($sel_optionss) - 1);

$page_top =~ s/!!sel_options!!/$sel_options/gi;
$page_top =~ s/!!itemnrs!!/$form_c_counter/gi;


print $page_top . $page_middle . $page_crit .  $all_matches . "<span class=\"normaltext\">" . $page_crit  . $allpages . "</span>";
}





sub get_web_server_error
{
my ($werr) = @_;

$all_errors = acs::get_file_contents("$data_dir/wserver_errors.dat");

@elines = split (/\n/, $all_errors);

foreach $erl (@elines)
	{
	($ecode, $ediz, $eldiz) = split (/::/, $erl);
	
	if ($werr eq $ecode)
		{
		$ret_ecode = $ecode;
		$ret_ediz = $ediz;
		$ret_eldiz = $eldiz;
		}
	}

return ($ret_ediz, $ret_eldiz);

}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

