#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use fmtmplman;
use fmparse;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES  

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

if ($q->param('fct') eq "download") {&download;}

##################################################################################

if ($q->param('fct') eq "")  
	{
	acs::extend_login;
	}
	else
	{
	print "Content-type: text/html\n\n";
	}

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "edit_template") {&edit_template;}
if ($q->param('fct') eq "save_template") {&save_template;}
if ($q->param('fct') eq "tinfo") {&tinfo;}
if ($q->param('fct') eq "restore_default_template") {&restore_template_check;}
if ($q->param('fct') eq "view_default") {&view_default;}
if ($q->param('fct') eq "upload") {&upload;}
if ($q->param('fct') eq "set_maximize") {&set_maximize;}
if ($q->param('fct') eq "set_minimized") {&set_minimized;}
if ($q->param('fct') eq "turnoff_previews") {&turnoff_previews;}
if ($q->param('fct') eq "turnon_previews") {&turnon_previews;}

if ($q->param('fct') eq "change_editor") {&change_editor;}



##################################################################################

sub change_editor
{

$template = $q->param('template');

$editor = $q->param('editor');

$admin57 = $q->param('admin57');

if ($admin57 eq "true")
	{
	$adminscript = "admin57.cgi";
	}
	else
	{
	$adminscript = "admin6.cgi";
	}

open (DTAE, "> $data_dir/editor.dat");
	print DTAE $editor;
close (DTAE);


if ($editor eq "source")
	{
	$changetext = "Editor changed to 'Source Code'";
	}
	else
	{
	$changetext = "Editor changed to Wysiwyg Editor";
	}

$lnk = qq[<a href="$adminscript?fct=edit_template&template=$template">Click Here to Continue</a>];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", $changetext, $lnk);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}



sub turnon_previews
{

open (TOFP, "> $data_dir/previews.dat");
close (TOFP);

$template = $q->param('template');

if ($q->param('a') eq "a")
	{
	$lnk = qq[<a href="$admin_url/admin57.cgi?fct=edit_template&template=$template">Click Here to Continue</a>];
	}
	else
	{
	$lnk = qq[<a href="$admin_url/admin6.cgi?fct=edit_template&template=$template">Click Here to Continue</a>];
	}


$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Template Previews turned on", $lnk);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];
}





sub turnoff_previews
{

open (TOFP, "> $data_dir/previews.dat");
	print TOFP "false";
close (TOFP);

$template = $q->param('template');

if ($q->param('a') eq "a")
	{
	$lnk = qq[<a href="$admin_url/admin57.cgi?fct=edit_template&template=$template">Click Here to Continue</a>];
	}
	else
	{
	$lnk = qq[<a href="$admin_url/admin6.cgi?fct=edit_template&template=$template">Click Here to Continue</a>];
	}

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Template Previews turned off", $lnk);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>
$hbox
</body>
</html>
];
}


sub get_template_descriptions
{

$dir_templates_1 = "These templates are the default templates used when displaying categories. These templates enables you to change the look and feel of categories and categories displaying links. ";
$searchresults_2 = "These templates are used to display search results (when end users search the Directory)";
#$d_addurl_3 = ""
$rating_4 = "These templates are used when users assign ratings to listings.";
$comments_5 = "These templates are used when users view and post comments about listings.";
$wnew_6 = "This set of templates is used for the 'Whats New' page. The 'Whats New' page lists new listings in the Directory.";
$top_hits7 = "This set of templates is used for the 'Top Hits' page. The 'Top Hits' page lists the most popular listings in the Directory.";
$broken_lnk8 = "This set of templates is used when end users report broken links.";
$favorites9 = "This set of templates are used to display link listings that visitors flagged as their favorites. When visitors flag links as favorites the link IDs of the links are set as cookies to the visitors browser enabling the visitor to go back and view links that he/she has flagged as favorites.";
$contactus_diz = "These templates are used when visitors uses the contact form.";
$mailing11 = "These templates are used when users want to unsubscribe from the mailing list. Each link owner can subscribe to the mailing list if they choose to do so when doing a new submission. They can then also unsubscribe if they choose to do so. See the documentation for complete information on the mailing list functions that come with PowerSeek.";

}


sub set_minimized
{

	open MXT, "> $data_dir/tmplmax.dat";
    print MXT "";
	close MXT;

&start;

}






sub maximized_display
{

$gsettings = new_gsettings acs; 


if ($gsettings->{add_url_form} eq "medium")
	{
	$medium_sized = "<font color=\"#0000FF\"><b>In Use</b></font>";
	$large_sized = "<font color=\"#0000FF\"><b>Not In Use</b></font>";
	$add_urlinst = "<font color=\"#0000FF\"><b>Not In Use</b></font>";
	}
	else
	{
	$large_sized = "<font color=\"#0000FF\"><b>Currently in Use</b></font>";
	$medium_sized = "<font color=\"#0000FF\"><b>Not in Use</b></font>";
	$add_urlinst = "<font color=\"#0000FF\"><b>Currently in Use</b></font>";
	}


$ajax_script = &get_ajax_script;

$hbox = &get_theading("MAXIMIZED");


$d_dir_templates = fmtmplman::dir_templates();
$d_searchresults = fmtmplman::search_results();
$d_rating = fmtmplman::ratings_templates();
$d_comments = fmtmplman::comments();
$d_wnew = fmtmplman::whatsnew();
$d_top_hits = fmtmplman::tophits();
$d_broken_lnk = fmtmplman::broke_templ();
$d_favorites = fmtmplman::favorites();
$d_mailing = fmtmplman::mail_remove();
$d_contact = fmtmplman::contactus();

&get_template_descriptions;



if ($gsettings->{addurl_reg_system} eq "Yes")
	{
	
	if ($gsettings->{rateit_user_reg} eq "Yes") { $rate_enabled = "Enabled"; } else { $rate_enabled = "Disabled"; }
	if ($gsettings->{comments_reg_system} eq "Yes") { $comment_enabled = "Enabled"; } else { $comment_enabled = "Disabled"; }
	
	$d_addurl = fmtmplman::add_url_tmpls;

	$boxd1 = qq[
	These templates are used when users submit URLs to the directory and you have chosen to use the user registration system. 
	The user registration system requires users to register and verify their email addresses before they can submit links. (Verification of email addresses are optional)
	You can configure the use of the registration system clicking the 'Settings Tab' >> Global Engine Settings >> New Subimission Settings. 
	Note that the Standard Add URL & Modify Templates are not used when you use the user registration system.
	$d_addurl
	];

	$add_url_templates = &get_heading_box_tmpl("$web_url/ics_users.gif", qq[<a name="3"></a>3. Add URL Templates], $boxd1, qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T3" style="display: none;">]);

	}
	else
	{
	$d_addurl = fmtmplman::add_url_tmpls2;
	
	$add_url_templates = &get_heading_box_tmpl("$web_url/ics_users.gif", qq[<a name="3"></a>3. Add URL Templates (No User Registration)], qq[These templates are used when users submit URLs to the Directory and you have chosen not to use the user registration system. The user registration system requires users to register and verify their email addresses before they can submit links. You can configure the use of the registration system by clicking the 'Settings Tab' >> Global Engine Settings >> New Subimission Settings. $d_addurl], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T3" style="display: none;">]);
	}




$defbox = &get_heading_box_tmpl("$web_url/ics_dirs.gif", qq[<a name="1"></a><b>1. Default Category/Directory Templates</b>], qq[$dir_templates_1 $d_dir_templates ],qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T1" style="display: none;">]);

$search_results = &get_heading_box_tmpl("$web_url/ics_search.gif", qq[<a name="2"></a>2. Search Result Templates], qq[$searchresults_2 $d_searchresults], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T2" style="display: none;">]);

$rating_templates = &get_heading_box_tmpl("$web_url/ics_pop2.gif", qq[<a name="4"></a>4. Rating Templates], qq[$rating_4 $d_rating], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T4" style="display: none;">]);

$comment_templates = &get_heading_box_tmpl("$web_url/ics_comment.gif", qq[<a name="5"></a>5. Comment/Review Templates], qq[$comments_5 $d_comments],qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T5" style="display: none;">]);

$whatsnew_templates = &get_heading_box_tmpl("$web_url/ics_newsub.gif", qq[<a name="6"></a>6. What's New Templates], qq[$wnew_6 $d_wnew], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T6" style="display: none;">]);

$tophits_templates = &get_heading_box_tmpl("$web_url/ics_pop.gif", qq[<a name="7"></a>7. Top Hits Templates], qq[$top_hits7 $d_top_hits], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T7" style="display: none;">]);

$broken_link_templates = &get_heading_box_tmpl("$web_url/ics_brlnks.gif", qq[<a name="8"></a>8. Broken Link Templates], qq[$broken_lnk8 $d_broken_lnk],qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T8" style="display: none;">]);

$Favorites = &get_heading_box_tmpl("$web_url/ics_fav.gif", qq[<a name="9"></a>9. Favorites], qq[$favorites9 $d_favorites],qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T9" style="display: none;">]);

$contactus = &get_heading_box_tmpl("$web_url/ics_email1.gif", qq[<a name="10"></a>10. Contact Us Templates], qq[$contactus_diz $d_contact],qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T10" style="display: none;">]);

$mail_remove = &get_heading_box_tmpl("$web_url/ics_email4.gif", qq[<a name="11"></a>11. Mailing List Removal Templates], qq[$mailing11 $d_mailing],qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T10" style="display: none;">]);


#$contactus = &get_heading_box_tmpl("$web_url/ics_email1.gif", qq[<a name="10"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=contactus', 'result10', 10);return false;">10. Contact Us Templates</a><img src="$web_url/ldown.gif" border=0>], qq[$contactus_diz <div id="result10"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T10" style="display: none;">]);

$tmplm = qq[
$hbox
$defbox
$search_results
$add_url_templates
$rating_templates
$comment_templates
$whatsnew_templates
$tophits_templates
$broken_link_templates
$Favorites
$contactus
$mail_remove<br><br>
];

$template = acs::get_template("TEMPLATES"); 
$template =~ s/<\/head>/$ajax_script <\/head>/g;
$template =~ s/!!data!!/$tmplm/g;

print $template;

}


sub set_maximize
{

	open MXT, "> $data_dir/tmplmax.dat";
    print MXT "MAX";
	close MXT;
	
	&start;

}


sub upload
{

if ($q->param('upfile') eq "") { acs::problem_popup("You have to specify a file name to upload."); }


$template = $q->param('template'); $curr_template = $template;
$ufname = "$data_dir/$template" . ".html";

		### DO UPLOAD
		$upload_filehandle = $q->param('upfile');
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;	


$boxdj = qq[
<ul>
 <li class="normaltext"><a href="$admin_url/admin6.cgi?fct=edit_template&template=$curr_template">Click here to go back to editing</a></li>
 <li class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&amp;template=$curr_template" target="_blank">Click here to Preview this template</a></li>
 <li class="normaltext"><a href="javascript:onClick=window.close()">Click here to close this window</a> </li>
</ul>
];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Template Saved", $boxdj);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>
$hbox
</body>
</html>
];

}





sub download
{

print "Content-type: text/plain\n\n";

$template = $q->param('template');
$tcontents = acs::get_file_contents("$data_dir/$template" . ".html");
print $tcontents;

exit;
}



sub view_default
{

$curr_template = $q->param('template');

if ($q->param('extraform') ne "") 
	{
	$erpl = $q->param('extraform') . "_";
	$curr_template =~ s/$erpl//gi;
	}



$deftemplate = acs::get_file_contents("$data_dir/$curr_template.def");

$bbxdiz = qq[
<form method="POST" action="$admin_url/admin6.cgi">
<input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.etemplate.focus();this.form.etemplate.select(); return false;">
<textarea rows="25" name="etemplate" cols="101" style="width:100%">
$deftemplate
</textarea>
<input type="submit" class="psbutton" value="     Close This Window     " name="B3" onClick="javascript:onClick=window.close();return false;">
</form>
];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Viewing the factory default template for: $curr_template.html", $bbxdiz);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



sub tinfo
{

$curr_template = $q->param('template');

($dir_details, $vars_available, $titlediz) = fmtmplman::get_tmpl_details($curr_template);

$boxdiz = qq[
The variables listed below is avilable inside the template.<BR><BR>
<b>$titlediz</b> - $dir_details<BR><BR>
<b>Variables:</b><BR><BR>
<blockquote>
  $vars_available
</blockquote>
];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Variables Used In Template", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}

#--------------------


sub restore_template_check
{
if ($q->param('Yes') eq "   Yes   ")
	{&restore_template_final;}
	else
	{&edit_template;}
}


#====================
sub restore_template_final
{

$curr_template = $q->param('template');

$template_html = acs::get_file_contents("$data_dir/$curr_template.def");


open (htmfn, "> $data_dir/$curr_template.html"); #overwrite
print htmfn $template_html;
close (htmfn); 


if ($q->param('rgs_templates') ne "")
	{
	$adminl = "admin57.cgi";
	}
	else
	{
	$adminl = "admin6.cgi";
	}


$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Template Restored", qq[<a href="$admin_url/$adminl?fct=edit_template&amp;template=$curr_template">Click here to Continue</a>]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}






sub restore_template_areyousure
{

$curr_template = $q->param('template');

if ($q->param('rgs_templates') ne "")
	{
	$rgs_templates = qq[<input type="hidden" name="rgs_templates" value="true">];
	$formscript = "admin57.cgi";
	}
	else
	{
	$formscript = "admin6.cgi";
	}


$boxdiz = qq[
This functionality offers you the option to restore this template to it's factory default template. This feature comes in handy 
if something that did work is not working due to a template problem. Things that stop working can be due to HTML errors, missing variables, 
missing hidden variables, missing FORM tags, etc. Restoring the default template should get everything back to working order. After
restoring the factory default template you will need to re-customize it.
<BR>
<BR>
<form method="POST" action="$admin_url/$formscript">
  <span class="normaltext"><strong>Are you sure? </strong>This action will replace the current template called: <strong>$curr_template.html </strong>        </span>
  <p>
  <input type="submit" class="psbutton" value="   Yes   " name="Yes"> 
  <input type="submit" class="psbutton" value="   No   " name="No">       
  <input type="hidden" name="fct" value="restore_default_template">
  <input type="hidden" name="template" value="$curr_template">
  $rgs_templates
  </p>
</form>
];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Restore Default Template", $boxdiz);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>

$hbox

</body>
</html>
];



}



#====================
sub save_template
{

	if ($q->param('B2') ne "")
	{	
	&restore_template_areyousure;
	exit;
	}

$curr_template = $q->param('template');

$tmpln = "$data_dir/$curr_template" . ".html";

########

open (TMPLF, "> $tmpln");
	print TMPLF $q->param('etemplate');
close TMPLF;

$extraform = $q->param('extraform');

	if (($extraform ne "") or ($q->param('rgs_templates') ne ""))
		{
		$backedit = "admin57.cgi";
		}
		else
		{
		$backedit = "admin6.cgi";
		}

$boxda = qq[
<ul>
 <li class="normaltext"><a href="$admin_url/$backedit?fct=edit_template&template=$curr_template&extraform=$extraform">Click here to go back to editing</a></li>
 <li class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$curr_template&f=$extraform" target="_blank">Click here to Preview this template</a></li>
 <li class="normaltext"><a href="javascript:onClick=window.close()">Click here to close this window</a> </li>
</ul>
];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Template Saved", $boxda);



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   
</head>
<body>
$hbox
</body>
</html>
];


}



##################

sub edit_template
{

&get_template_help;

$curr_template = $q->param('template');

($dir_details, $vars_available, $template_title) = fmtmplman::get_tmpl_details($curr_template);

$template_html = acs::get_file_contents("$data_dir/$curr_template.html");

if (-w "$data_dir/$curr_template.html") #-w writable by current user?
{ 
	$write_permission = 0;
} 
else
{ 
	$write_permission = 1;
} 


####################


if ($write_permission == 1) 
	{
	$template_writing .= qq[<font face="Verdana" color="#FF0080"><strong>&nbsp;&nbsp; This file is not
   Writeable. Please ensure that the permission is set to 777. Please refer<br>
   to our documentation on &quot;Assigning permissions to directories and files&quot;.<br>
   </strong></font>];
   } 
   else 
   {
   $template_writing .= qq[<font face="Verdana" color="#FF0080"><strong>&nbsp;&nbsp;<br></strong></font>];
   }


$dir_details =~ s/<br>/ - /gi;



##########################################################################################

$editor = acs::get_file_contents("$data_dir/editor.dat");
if ($editor eq "wysiwyg")
	{
	
	### Get CSS being used inside template
	$cssdetails = fmparse::get_css_used($template_html);
	
	### Replace !build_url!
	$template_html =~ s/!build_url!/$web_url/gi;
	
	### See if fullpage is being used
	$fullpage_option = "fullpage,";
	@non_fullpage_items = ("tmplsearch", "tmplsearch_prem", "subdirs", "directories1", "related1", "related2", "lsearchres_loc", "lsearchres_loc_prem", "lsearchres_locdir",
									"rgs_acclinks", "rgs_acclinksp", "rgs_nolinks", "whatsnew_lists", "whatsnew_lists_prem", "tophits_listings", "tophits_listings_prem",
									"fav_standard", "fav_premium");
	foreach $nonitem (@non_fullpage_items)
		{
			if ($curr_template eq $nonitem)
				{
				$fullpage_option = "";
				}
		}
	##################################
	

$head_details = qq[
<script type="text/javascript" src="$web_url/edt/tiny_mce/tiny_mce.js" ></script >

<script type="text/javascript">
tinyMCE.init({
// General options
mode : "textareas",
theme : "advanced",
plugins : "$fullpage_option autolink,lists,spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",

// Theme options
theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,spellchecker,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,blockquote,pagebreak,|,insertfile,insertimage",
theme_advanced_toolbar_location : "top",
theme_advanced_toolbar_align : "left",
theme_advanced_statusbar_location : "bottom",
theme_advanced_resizing : true,

// Skin options
skin : "o2k7",
skin_variant : "silver",

// Example content CSS (should be your site CSS)
content_css : "$cssdetails",

// Drop lists for link/image/media/template dialogs
template_external_list_url : "js/template_list.js",
external_link_list_url : "js/link_list.js",
external_image_list_url : "js/image_list.js",
media_external_list_url : "js/media_list.js"

});
</script>

];

		$editor_buttons = qq[
	      <strong class="buttab_selected">Wysiwyg Editor</strong>
	      <strong><a href="admin6.cgi?template=$curr_template&fct=change_editor&editor=source" class="buttab" onClick="return turnoff();">Template HTML Source Code</a></strong> 
		];

	}
	else
	{
		$copypaste_msg = qq[<span class="normaltext12">Copy and paste the HTML code into your web editor. When finished, copy and paste the HTML code back to this box. You may
      also manually open the HTML file above with your favorite HTML editor and edit it. </span>
      ];
      
      $selectall = qq[<input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.etemplate.focus();this.form.etemplate.select(); return false;">];

		$editor_buttons = qq[
	      <strong><a href="admin6.cgi?template=$curr_template&fct=change_editor&editor=wysiwyg" class="buttab" onClick="return turnoff();">Wysiwyg Editor</a></strong>
	      <strong class="buttab_selected">Template HTML Source Code</strong> 
		];      
	}



##########################################################################################

$boxde = qq[
<b>Editing: $template_title</b> - $dir_details<BR>
];

$varlinks = qq[
<b>Help:</b> 
<a href="$admin_url/admin78.cgi?fct=explain&t=$curr_template&body=true" onClick="popup('$admin_url/admin78.cgi?fct=explain&t=$curr_template&body=true',800,600, 130, 130);return false;" title="Provides you with a list of words or variables that can be used within<BR> the current template. The words are enclosed by !! or %% and are<BR> variables used in this template. These variable words are replaced<BR> with data.">Variables Available</a> | 
<a href="$admin_url/admin78.cgi?fct=global_vars&body=true" onClick="popup('$admin_url/admin78.cgi?fct=global_vars&body=true',800,600, 130, 130);return false;" title="Displays a list of global variables (words enclosed by !! or %%)<BR> that can be used within all PowerSeek templates.">Global Variables</a> | 
<a href="$admin_url/admin78.cgi?fct=how_to_edit&body=true" onClick="popup('$admin_url/admin78.cgi?fct=how_to_edit&body=true',800,600, 130, 130);return false;" title="Explains how to edit templates">How To Edit Templates</a> | 
<a href="$admin_url/admin78.cgi?fct=manual_edit&body=true" onClick="popup('$admin_url/admin78.cgi?fct=manual_edit&body=true',800,600, 130, 130);return false;" title="Explains how to manually edit templates">Manual Editing</a> | 
<a href="$admin_url/admin78.cgi?fct=images_in_templates&body=true" onClick="popup('$admin_url/admin78.cgi?fct=images_in_templates&body=true',800,600, 130, 130);return false;" title="Explains how to use images inside templates">Template Images How To</a> | 
<a href="http://www.focalmedia.net/pseekmanual/pseek6.html" target="_blank" title="PowerSeek template editing instructions">Instructions</a>
];

#####################

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Editing Template: $data_dir/$curr_template.html", $boxde);


$upload_box = qq[

<form method="POST" action="$admin_url/admin6.cgi" ENCTYPE="multipart/form-data">
  <table width="100%" border="0" cellpadding="6" cellspacing="1"
  bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td colspan="4" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><b>Upload/Download Template:</b></td>
    </tr>
    <tr>
      <td width="11%" align="center" bgcolor="#FFFFFF" class="normaltext"><strong>Upload Template:</strong></td>
      <td width="40%" bgcolor="#FFFFFF" class="normaltext"><input type="file" name="upfile" size="40" id="upfile">
          <input type="submit" class="psbutton" name="Upload" id="Upload" value="    Upload    ">
        	 <input name="fct" type="hidden" id="fct" value="upload">
          <input name="template" type="hidden" id="template" value="$curr_template"></td>
      <td width="11%" align="right" bgcolor="#FFFFFF" class="normaltext"><strong>Download Template:</strong></td>
      <td width="38%" bgcolor="#FFFFFF"><a href="$admin_url/admin6.cgi?fct=download&template=$curr_template" title="Right Click this button and choose 'Save As'"><img src="$web_url/downloadt.png" border="0"></a>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="147%"></td>
    </tr>
  </table>
</form>

];


$template_html =~ s/&/&amp;/gi;
$template_html =~ s/</&lt;/gi;
$template_html =~ s/>/&gt;/gi;


$tooltip = acs::get_tooltip;

$prev_display = acs::get_file_contents("$data_dir/previews.dat");

if ($prev_display ne "false")
	{
	$tpreviews = qq[
				<table width="100%" border="0" cellpadding="6" cellspacing="1" bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)">
				  <tr>
					 <td width="95%" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><b>Template Only Preview:</b></td>
				 <td width="5%" align="right" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext">
					 <form name="form1" method="post" action="$admin_url/admin6.cgi" onSubmit="return turnoff();">
					 <input type="hidden" name="template" value="$curr_template">
					 <input type="hidden" name="fct" value="turnoff_previews">
						<input type="submit" class="psbutton" name="button" id="button" value="Turn off template previews">
					 </form>
				</td>
				  </tr>
				  <tr>
					 <td colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Important Preview Note:</strong>
					 Take note that many templates are combined with other templates to form one page. In other
					 words, many templates work together with other templates. This preview pane will not
					 display templates combined with other templates and will display the preview of the single
					 template being edited now only.</td>
				  </tr>
				  <tr>
					 <td colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext">
					 <IFRAME src="$admin_url/admin79.cgi?fct=preview&template=$curr_template" width="100%" height="500">
					 <!--webbot bot="HTMLMarkup" endspan --> <!--webbot bot="HTMLMarkup" startspan -->
					 </IFRAME>
						</td>
				  </tr>
				</table>
				<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
				  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
				</table>


				<table width="100%" border="0" cellpadding="6" cellspacing="1" bordercolor="#DDDDDD"
				style="border: 1px solid rgb(225,225,225)">
				  <tr>
					 <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><b>Live Preview:</b></td>
				  </tr>
				  <tr>
					 <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Important Preview Note:</strong> 
					 This preview pane will display the current template being edited combined with other 
					 templates (if applicable) to form a complete page. Some templates work together with other 
					 templates to form one page. Note that in some instances that some templates work alone and 
					 are not combined with other templates. Take note that most hyperlinks in the template 
					 displayed below won't work. The display is only for previewing purposes.</td>
				  </tr>
				  <tr>
					 <td valign="top" bgcolor="#FFFFFF" class="normaltext"><!--webbot bot="HTMLMarkup"
					 startspan --><IFRAME src="$admin_url/admin68.cgi?fct=prev&amp;template=$curr_template" width="100%" height="500"><!--webbot bot="HTMLMarkup" endspan --> <!--webbot bot="HTMLMarkup"
					 startspan --><!--webbot bot="HTMLMarkup" endspan --> <!--webbot bot="HTMLMarkup"
					 startspan -->
					 </IFRAME>
						</td>
				  </tr>
				</table>
				<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
				  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
				</table>
				<!--webbot bot="HTMLMarkup" endspan --></td>
				  </tr>
				</table>	
	];
	}
	else
	{
	$tpreviews = qq[
	<form name="form1" method="post" action="$admin_url/admin6.cgi?fct=turnoff_previews&template=$curr_template" onSubmit="return turnoff();">
	 <input type="hidden" name="template" value="$curr_template">
	 <input type="hidden" name="fct" value="turnon_previews">
		<input type="submit" class="psbutton" name="button" id="button" value="Turn on template previews">
	 </form>
	];
	}
	

$jspopup_code = acs::get_popupjs;



###############################################################################################################################################


$template_writing = qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">   

$tooltip

$head_details

<SCRIPT LANGUAGE="JavaScript">

var dropdownstat = 0;
var lastdropdown = 0;

function xmlhttpPost(strURL, display_area, ddown) 
	 {
	 document.getElementById('AJImg').style.display='block';
	 
    var xmlHttpReq = false;
    var self = this;
  
  	 if (dropdownstat == ddown)
  	 	{
  	 	strURL = '$admin_url/admin77.cgi?fct=blank'; dropdownstat = 0;
  	 	}
  	 	else { dropdownstat = ddown; }
  
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
	
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function() 
    	   {
         if (self.xmlHttpReq.readyState == 4) 
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText; 
         		document.getElementById('AJImg').style.display='none';
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
}

function turnoff()
	{
	var agree=confirm("This action will discard any changes that you have made to the existing template you are editing. If you made changes to the existing template then first save the changes before taking this action. Are you sure you want to continue?");
	if (agree)
	return true;
	else
	return false;
	}

$jspopup_code 

</script>
</head>
<body>

$hbox

<div id="result1"></div>

<style>

.buttab_selected {
	text-decoration:none;
	padding-top: 5px;
	padding-right: 9px;
	padding-bottom: 7px;
	padding-left: 9px;
	border-top: 1px solid #DDD;
	border-left: 1px solid #DDD;
	border-right: 1px solid #DDD;
	background: url($web_url/inp2.gif);
	//line-height: 25px;
}

.buttab {
	text-decoration:none;
	padding-top: 5px;
	padding-right: 9px;
	padding-bottom: 5px;
	padding-left: 9px;
	border-top: 1px solid #DDD;
	border-left: 1px solid #DDD;
	border-right: 1px solid #DDD;
	background: url($web_url/inp3.png);
	line-height: 25px;
}

a.buttab { color: #000; }
a.buttab_selected { color: #000; }

.buttab:hover {
	padding-top: 5px;
	padding-right: 9px;
	padding-bottom: 4px;
	padding-left: 9px;
	border-top: 1px solid #DDD;
	border-left: 1px solid #DDD;
	border-right: 1px solid #DDD;
	background: url($web_url/inp2.gif);
	line-height: 25px;
	text-decoration:none;
}
</style>

<form method="POST" action="$admin_url/admin6.cgi">
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td width="31%" class="normaltext12">
      $editor_buttons
      </td>
      <td width="69%" align="right" class="normaltext">$varlinks $selectall</td>
    </tr>
  </table>
  <table width="100%" border="0" cellpadding="6" cellspacing="1"
  bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td width="100%" valign="top" bgcolor="#FFFFFF">
      <textarea rows="35" name="etemplate" cols="101" style="width:100%">$template_html</textarea>
			$copypaste_msg
      </td>
    </tr>
    <tr>
      <td align="center" bgcolor="#FFFFFF"><dd align="center">
          <input type="submit" class="psbutton" value="     Save Template     " name="B1">
          <input type="submit" class="psbutton" value="    Restore Default    " name="B2" 
          title="This option let's you restore the default factory template<BR>
          that was available when PowerSeek was first installed.<BR>
          This can be handy in the event where something stopped <BR>
          working and you need to restore the default template to<BR>
          get it back to working order.">
          <input type="submit" class="psbutton" value="     View Default     " name="B3" title="View the HTML source code of the default factory template." 
          onClick="popup('$admin_url/admin6.cgi?fct=view_default&template=$curr_template',screen.width-250,screen.height-250);return false;">
          
          <input type="hidden" name="fct" value="save_template"> 
          <input type="hidden" name="template" value="$curr_template"> 
      </dd>      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="147%"></td>
    </tr>
  </table>
</form>



$upload_box
$tpreviews

</body>
</html>

];

print $template_writing;

}














sub get_template_help
{

$template_help = qq[

<p><strong><font face="Verdana" size="2">Te<a name="templatehelp"></a>mplate Help</font><font
face="Verdana" size="1"><br>
</strong><br>
Templates are used in conjunction with all aspects <strong>of displaying your directory
to end users</strong>. Each template <strong>consists of</strong> <strong>HTML code</strong>
with <strong>variable words</strong> and is used in combination with each other. These
variable words are enclosed by %% or !! characters. <strong>For example: %%date%%</strong>.
Most of these variables words need to be present to do a certain task. These variable words
are <strong>replaced by data</strong> when displayed to end users of your directory.</font></p>

<p><font face="Verdana" size="1">Probably the easiest way to understand how templates work
is to <strong>play around with the HTML code of templates:</strong> Open the HTML
templates with your web editor or copy and paste the HTML code into your
web editor and start editing. Experiment with the templates and try
different combinations. You'll be surprised with what you can come up. The templates gives
you total control on the look and feel of your search engine and directory.</font></p>
<strong>

<p><font face="Verdana" size="1">Note that when you make use of images</strong> in the
HTML code of templates, you must use a URL link to indicate their locations. <br>
For example:</font></p>

<blockquote>
  <p><font face="Verdana" size="1"><strong><font color="#ff8000">&lt;img
  src=&quot;someimage.gif&quot;&gt; </font>will not work.</strong><br>
  &nbsp; <br>
  <strong>You have to indicate the entire URL</strong> <strong>where someimage.gif is
  located. For example:</strong><br>
  &nbsp;&nbsp;&nbsp;&nbsp; <br>
  <font color="#ff8000"><strong>&lt;img
  src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt;</strong><br>
  </font>&nbsp;&nbsp;&nbsp; <br>
  The <strong>&lt;img</strong> is an HTML tag indicating that you want to insert an image in
  the HTML page. The <strong>src= </strong>part indicates that you want to specify the
  location of the image to be inserted. Some web editors will support inserting images from
  a web url and some won't. If your web editor does not support this, insert the image into
  the HTML page like usual and when finished edit the source of the HTML code and manually
  insert the URL path's to the images. Ensure that the images are on the server for the URL
  path's you specify.</font></p>
  <blockquote>
    <p><font face="Verdana" size="1"><strong>Example, editing the HTML source code:</strong></font></p>
  </blockquote>
  <blockquote>
    <p><font face="Verdana" size="1"><strong>Replace <font color="#ff8000">&lt;img
    src=&quot;someimage.gif&quot;&gt;</font> with<br>
    <font color="#ff8000">&lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt;</font></strong></font></p>
  </blockquote>
</blockquote>
];


}








sub start
{

$mdisp = acs::get_file_contents("$data_dir/tmplmax.dat");

if ($mdisp eq "MAX")
	{
	&maximized_display;
	exit;
	}


#####################

$gsettings = new_gsettings acs; 


if ($gsettings->{add_url_form} eq "medium")
	{
	$medium_sized = "<font color=\"#0000FF\"><b>In Use</b></font>";
	$large_sized = "<font color=\"#0000FF\"><b>Not In Use</b></font>";
	$add_urlinst = "<font color=\"#0000FF\"><b>Not In Use</b></font>";
	}
	else
	{
	$large_sized = "<font color=\"#0000FF\"><b>Currently in Use</b></font>";
	$medium_sized = "<font color=\"#0000FF\"><b>Not in Use</b></font>";
	$add_urlinst = "<font color=\"#0000FF\"><b>Currently in Use</b></font>";
	}


if ($gsettings->{addurl_reg_system} eq "Yes")
	{
	
	if ($gsettings->{rateit_user_reg} eq "Yes") { $rate_enabled = "Enabled"; } else { $rate_enabled = "Disabled"; }
	if ($gsettings->{comments_reg_system} eq "Yes") { $comment_enabled = "Enabled"; } else { $comment_enabled = "Disabled"; }
	
	
	$add_in_use_reg = "In Use";
	$add_in_use_standard = "Not In Use";
	

$boxid = qq[<a name="3"></a><a href="$admin_url/admin77.cgi?fct=add_url_tmpls" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=add_url_tmpls&' + parseInt(Math.random()*10000), 'result3', 3);return false;">3. Add URL Templates</a><img src="$web_url/ldown.gif" border=0>];
$boxid2 = qq[
These templates are used when users submit URLs to the directory and you have chosen to use the user registration system. 
The user registration system requires users to register and verify their email addresses before they can submit links. (Verification of email addresses are optional)
You can configure the use of the registration system clicking the 'Settings Tab' >> Global Engine Settings >> New Subimission Settings. 
Note that the Standard Add URL & Modify Templates are not used when you use the user registration system.
<div id="result3"></div>
];

$add_url_templates = &get_heading_box_tmpl("$web_url/ics_users.gif", $boxid, $boxid2, qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T3" style="display: none;">]);

	$sysurltype = "$admin_url/admin77.cgi?fct=add_url_tmpls";
	}
	else
	{
	
	$add_in_use_reg = "Currently not in use (The templates are not being used;";
	$add_in_use_standard =  "Currently In Use"; 


$add_url_templates = &get_heading_box_tmpl("$web_url/ics_users.gif", qq[<a name="3"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=add_url_tmpls2&' + parseInt(Math.random()*10000), 'result3', 3);return false;">3. Add URL Templates (No User Registration)</a><img src="$web_url/ldown.gif" border=0>], qq[These templates are used when users submit URLs to the Directory and you have chosen not to use the user registration system. The user registration system requires users to register and verify their email addresses before they can submit links. You can configure the use of the registration system by clicking the 'Settings Tab' >> Global Engine Settings >> New Subimission Settings. <div id="result3"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T3" style="display: none;">]);

	$sysurltype = "$admin_url/admin77.cgi?fct=add_url_tmpls2";
	}




$hbox = &get_theading;

&get_template_descriptions;

$fpbox = acs::get_heading_box("$web_url/ic_banner.gif", qq[<a href="$admin_url/admin26.cgi" onClick="popup('$admin_url/admin26.cgi',screen.width-200,screen.height-200);return false;">Create/Configure Front Page or Index Page</a>], qq[Enables you to generate or create the front page or index page of your directory and set various settings regarding it. ]);




$defbox = &get_heading_box_tmpl("$web_url/ics_dirs.gif", 
qq[<a name="1"></a><a href="$admin_url/admin77.cgi?fct=dir_templates" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=dir_templates', 'result1', 1);return false;"><b>1. Default Category/Directory Templates</b></a><img src="$web_url/ldown.gif" border=0>], qq[$dir_templates_1 <div id="result1"></div> ], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T1" style="display: none;">]);

$search_results = &get_heading_box_tmpl("$web_url/ics_search.gif", qq[<a name="2"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=search_results', 'result2', 2);return false;">2. Search Result Templates</a><img src="$web_url/ldown.gif" border=0>],  qq[$searchresults_2 <div id="result2"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T2" style="display: none;">]);

$rating_templates = &get_heading_box_tmpl("$web_url/ics_pop2.gif", qq[<a name="4"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=ratings_templates', 'result4', 4);return false;">4. Rating Templates</a><img src="$web_url/ldown.gif" border=0>], qq[$rating_4 <div id="result4"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T4" style="display: none;">]);

$comment_templates = &get_heading_box_tmpl("$web_url/ics_comment.gif", qq[<a name="5"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=comments', 'result5', 5);return false;">5. Comment/Review Templates</a><img src="$web_url/ldown.gif" border=0>],  qq[$comments_5<div id="result5"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T5" style="display: none;">]);

$whatsnew_templates = &get_heading_box_tmpl("$web_url/ics_newsub.gif", qq[<a name="6"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=whatsnew', 'result6', 6);return false;">6. What's New Templates</a><img src="$web_url/ldown.gif" border=0>], qq[$wnew_6 <div id="result6"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T6" style="display: none;">]);

$tophits_templates = &get_heading_box_tmpl("$web_url/ics_pop.gif", qq[<a name="7"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=tophits', 'result7', 7);return false;">7. Top Hits Templates</a><img src="$web_url/ldown.gif" border=0>], qq[$top_hits7 <div id="result7"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T7" style="display: none;">]);

$broken_link_templates = &get_heading_box_tmpl("$web_url/ics_brlnks.gif", qq[<a name="8"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=broke_templ', 'result8', 8);return false;">8. Broken Link Templates</a><img src="$web_url/ldown.gif" border=0>], qq[$broken_lnk8 <div id="result8"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T8" style="display: none;">]);

$Favorites = &get_heading_box_tmpl("$web_url/ics_fav.gif", qq[<a name="9"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=favorites', 'result9', 9);return false;">9. Favorites</a><img src="$web_url/ldown.gif" border=0>], qq[$favorites9 <div id="result9"></div> ], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T9" style="display: none;">]);

$contactus = &get_heading_box_tmpl("$web_url/ics_email1.gif", qq[<a name="10"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=contactus', 'result10', 10);return false;">10. Contact Us Templates</a><img src="$web_url/ldown.gif" border=0>], qq[$contactus_diz <div id="result10"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T10" style="display: none;">]);

$mail_remove = &get_heading_box_tmpl("$web_url/ics_email4.gif", qq[<a name="11"></a><a href="" onClick="xmlhttpPost('$admin_url/admin77.cgi?fct=mail_remove', 'result11', 11);return false;">11. Mailing List Removal Templates</a><img src="$web_url/ldown.gif" border=0>], qq[$mailing11 <div id="result11"></div>], qq[<img src="$web_url/ajload3.gif" width="16" height="16" id="T11" style="display: none;">]);


########################

$ajax_script = &get_ajax_script;

####### IF WE NEED TO OPEN INDIVIDUAL TEMPLATE DETAILS

if ($q->param('t') == 1) { $ajlink = "$admin_url/admin77.cgi?fct=dir_templates";  $ajreulst = "result1";  $ajnr = "1"; $ajtrue = 1;}
if ($q->param('t') == 2) { $ajlink = "$admin_url/admin77.cgi?fct=search_results";  $ajreulst = "result2";  $ajnr = "2"; $ajtrue = 1;}
if ($q->param('t') == 3) { $ajlink = $sysurltype;  $ajreulst = "result3";  $ajnr = "3"; $ajtrue = 1;}
if ($q->param('t') == 4) { $ajlink = "$admin_url/admin77.cgi?fct=ratings_templates";  $ajreulst = "result4";  $ajnr = "4"; $ajtrue = 1;}
if ($q->param('t') == 5) { $ajlink = "$admin_url/admin77.cgi?fct=comments";  $ajreulst = "result5";  $ajnr = "5"; $ajtrue = 1;}
if ($q->param('t') == 6) { $ajlink = "$admin_url/admin77.cgi?fct=whatsnew";  $ajreulst = "result6";  $ajnr = "6"; $ajtrue = 1;}
if ($q->param('t') == 7) { $ajlink = "$admin_url/admin77.cgi?fct=tophits";  $ajreulst = "result7";  $ajnr = "7"; $ajtrue = 1;}
if ($q->param('t') == 8) { $ajlink = "$admin_url/admin77.cgi?fct=broke_templ";  $ajreulst = "result8";  $ajnr = "8"; $ajtrue = 1;}
if ($q->param('t') == 9) { $ajlink = "$admin_url/admin77.cgi?fct=favorites";  $ajreulst = "result9";  $ajnr = "9"; $ajtrue = 1;}
if ($q->param('t') == 10) { $ajlink = "$admin_url/admin77.cgi?fct=mail_remove"; $ajreulst = "result10";  $ajnr = "10"; $ajtrue = 1;}

if ($ajtrue ne ""){$t_event = qq[<script type="text/javascript">\n xmlhttpPost('$ajlink', '$ajreulst', $ajnr);\n</script>];}


########

$tooltip = acs::get_tooltip;

$tmplm = qq[
$hbox
$defbox
$search_results
$add_url_tmpls
$add_url_templates
$rating_templates
$comment_templates
$whatsnew_templates
$tophits_templates
$broken_link_templates
$Favorites
$contactus
$mail_remove
$t_event
];

$template = acs::get_template("TEMPLATES"); 
$template =~ s/<\/head>/$ajax_script <\/head>/g;
$template =~ s/!!data!!/$tmplm/g;

print $template;

}




sub checkvars
{

my (@cvars) = @_;

$etm = $q->param('etemplate');

foreach $item (@cvars)
	{
	if ($etm !~ /$item/i)
		{
		$rwarn = $rwarn . "<ul><b>$item</b> not found.</ul>";
		}
	}


if ($rwarn ne "")
	{
$rwarn = "<br><br></strong><strong><font face=\"Verdana\" size=\"1\" color=\"#FF8000\">Note:</font></strong>
<font face=\"Verdana\" size=\"1\" color=\"#400000\">
The following variables was not found in the template. In some situations you will naturally not want these variables in the template. Ignore this if these variables has been intentionally left out." . $rwarn . "</font>";
	}

return ($rwarn);
}





sub get_heading_box_tmpl
{

my ($h_icon, $h_heading, $h_text, $dv) = @_;

$h_return = qq[
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="1%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td align="center" valign="middle"><img src="$web_url/55.gif" width="55" height="8"><br><img src="$h_icon"></td>
      </tr>
      <tr>
        <td height="16" align="center">$dv</td>
      </tr>
    </table>
    </td>
    <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td background="$web_url/bar6.gif"><strong class="normaltext">$h_heading</strong></td>
        </tr>
      <tr>
        <td class="normaltext">$h_text</td>
        </tr>
    </table></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


];

return ($h_return);


}




sub get_ajax_script
{

$areturn = qq[<script LANGUAGE="JavaScript">

var dropdownstat = ['0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0'] ;

function xmlhttpPost(strURL, display_area, ddown) 
	 {
	 
	 if (display_area == 'result1')  { document.getElementById('T1').style.display='block'; }
	 if (display_area == 'result2')  { document.getElementById('T2').style.display='block'; }
 	 if (display_area == 'result3')  { document.getElementById('T3').style.display='block'; }
 	 if (display_area == 'result4')  { document.getElementById('T4').style.display='block'; }
 	 if (display_area == 'result5')  { document.getElementById('T5').style.display='block'; }
	 if (display_area == 'result6')  { document.getElementById('T6').style.display='block'; }
	 if (display_area == 'result7')  { document.getElementById('T7').style.display='block'; }
 	 if (display_area == 'result8')  { document.getElementById('T8').style.display='block'; }
 	 if (display_area == 'result9')  { document.getElementById('T9').style.display='block'; }
 	 if (display_area == 'result10') { document.getElementById('T10').style.display='block'; }
 	 if (display_area == 'result11') { document.getElementById('T11').style.display='block'; }
	 
    var xmlHttpReq = false;
    var self = this;
  
  	 if (dropdownstat[ddown] == 1)
  	 	{
  	 	strURL = '$admin_url/admin77.cgi?fct=blank'; dropdownstat[ddown] = 0;
  	 	}
  	 else if  (dropdownstat[ddown] == 0)
  	 	{
  	 	dropdownstat[ddown] = 1; 
  	 	}
  	 	
  
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
	
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function() 
    	   {
         if (self.xmlHttpReq.readyState == 4) 
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText; 
         		
         			 if (display_area == 'result1')  { document.getElementById('T1').style.display='none'; }
						 if (display_area == 'result2')  { document.getElementById('T2').style.display='none'; }
					 	 if (display_area == 'result3')  { document.getElementById('T3').style.display='none'; }
					 	 if (display_area == 'result4')  { document.getElementById('T4').style.display='none'; }
					 	 if (display_area == 'result5')  { document.getElementById('T5').style.display='none'; }
						 if (display_area == 'result6')  { document.getElementById('T6').style.display='none'; }
						 if (display_area == 'result7')  { document.getElementById('T7').style.display='none'; }
					 	 if (display_area == 'result8')  { document.getElementById('T8').style.display='none'; }
					 	 if (display_area == 'result9')  { document.getElementById('T9').style.display='none'; }
					 	 if (display_area == 'result10') { document.getElementById('T10').style.display='none'; }
					 	 if (display_area == 'result11') { document.getElementById('T11').style.display='none'; }
         		
         		}
    		}
    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
	}

</script>
];

return ($areturn);
}



sub get_theading
{
my ($win_state) = @_;



$template_inc_nr = 0;
opendir(DIR,"$data_dir");
@files = readdir(DIR);
foreach $filename (@files)
	{
	if ((substr($filename, 0, 5) eq "incl_") and (substr($filename, length($filename) - 5, 5) eq ".html"))
		{
		$template_inc_nr++;
		}
	}
closedir(DIR);



if ($win_state eq "MAXIMIZED")
	{
	$msetting = qq[<a href="$admin_url/admin6.cgi?fct=set_minimized"><b>Minimize Template Displays</b></a></strong> <img src="$web_url/ldown2.gif" border=0>];
	}
	else
	{
	$msetting = qq[<a href="$admin_url/admin6.cgi?fct=set_maximize"><b>Maximize Template Displays</b></a></strong> <img src="$web_url/ldown.gif" border=0>];
	}

$hreturn = qq[
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="1%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center" valign="middle"><img src="$web_url/ic_template.gif"></td>
        </tr>
        <tr>
          <td height="16" align="center"></td>
        </tr>
      </table></td>
    <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="0">
        <tr>
          <td background="$web_url/bar6.gif"><table width="100%" class="normaltext" height="30">
              <tr>
                <td><strong class="normaltext">Template Manager</strong></td>
                <td align="right">$msetting</td>
              </tr>
            </table></td>
        </tr>
        <tr>
          <td class="normaltext"><table width="100%" cellpadding="0" cellspacing="3">
              <tr>
                <td height="30">PowerSeek uses none of it's own HTML. It uses templates (ordinary HTML files) to determine the look and feel of all functions used by end users.
                  In this section you can edit the HTML pages and/or HTML pieces that is used for all end user displays.</td>
              </tr>
            </table></td>
        </tr>
      </table></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

<table width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td height="40" valign="top"><span class="normaltext"><b><a title="This is the most basic and quickest way to setup the Front Page of your Directory" href="$admin_url/startup.cgi?fct=quickfp" onclick="popup('$admin_url/startup.cgi?fct=quickfp',950,650);return false;" class="bordtext_button"><strong>Front Page Quick Setup</strong></a></b> 
    <b><a href="$admin_url/admin26.cgi" onclick="popup('$admin_url/admin26.cgi',950, 650);return false;" class="bordtext_button">Front Page Setups</a></b> 
    <b><a href="$admin_url/admin17.cgi" onclick="popup('$admin_url/admin17.cgi',950, 650);return false;" class="bordtext_button" title="Template Includes are pieces of HTML code that can be included &lt;BR&gt;
			in any template. These pieces of HTML code could be headers, footers, &lt;BR&gt; menu bars, etc. It almost works like SSI's (server side includes).">Template Includes</a></b> 
	<b><a href="$admin_url/p_tmpglobal.cgi" onclick="popup('$admin_url/p_tmpglobal.cgi',950, 650);return false;" title="This function allows you to upload a master template (normal HTML file) and implement this template throughout all PowerSeek templates to give all PowerSeek end user pages the  look and feel of the master template. It will act like a frame around 
			all end-user PowerSeek pages. This template could contain your logo, graphics, layout, menu bars, etc." class="bordtext_button">Implement Global Template</a></b> 
			<b><a href="$admin_url/p_tmptool.cgi" onclick="popup('$admin_url/p_tmptool.cgi',950, 650);return false;" title="PowerSeek comes with a number of pre-created template sets (themes)<br> that you can use. This tool enables you to switch to any<br> of the pre-created templates that comes with PowerSeek." class="bordtext_button">Template Switching</a></b> 
	<b><a href="" onclick="xmlhttpPost('$admin_url/admin77.cgi?fct=template_functions&' + Math.random()*10000, 'result12', 12);return false;" class="bordtext_button">More</a></b></span></td>
    <td valign="top"><img src="$web_url/ajload3.gif" width="16" height="16" id="T11" style="display: none;"></td>
  </tr>
</table>
<span id="result12"></span>
];



return($hreturn);

}



####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

