#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use dmodrw;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$gsettings = new_gsettings acs;

$pages_prev = "5";
$pages_next = "5";

###################################################################################
print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&manage_dirs;}
if ($q->param('fct') eq "manage_dirs") {&manage_dirs;}

###################################################################################





sub manage_dirs
{

#$template = acs::get_template("DIR_MANAGER");

$cpenc = acs::get_file_contents("$data_dir/cpencoding.dat");
if ($cpenc eq "") 
{ 
$html_encoding_to_use = qq[<meta http-equiv="Content-Type" content="text/html; charset=utf-8">]; 
}
else
{
$html_encoding_to_use = $cpenc;
$html_encoding_to_use =~ s/&amp;/&/g;
$html_encoding_to_use =~ s/&lt;/</g;
$html_encoding_to_use =~ s/&gt;/>/g;
$qchr = "\"";
$html_encoding_to_use =~ s/&quot;/$qchr/g;
$html_encoding_to_use =~ s/&apos;/'/g;
}


$jspopup_code = acs::get_popupjs;

$template = qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Powerseek</title>
$html_encoding_to_use
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
<script SRC="$web_url/qtip.js"></script>

<!-- Hide !!JSCRIPT!! // End Hide -->

<script LANGUAGE="JavaScript">
$jspopup_code

	preload_image = new Image(34,11); 
	preload_image.src="$web_url/subdirani.gif"; 
	
	preload_image2 = new Image(16,16); 
	preload_image2.src="$web_url/ajload3.gif"; 

function showloader2 (loadid)
	{
	document.getElementById(loadid).style.display = 'inline';
	}

function showloader (loadid)
	{
		if (loadid > 0)
		{
		var loadname = 'a' + loadid;
		document.getElementById(loadname).src = "$web_url/subdirani.gif";
		}
		else
		{
		document.getElementById('loader').style.display = 'block';
		}
	}
</script>

<style type="text/css">
body
{ 
margin: 2;
padding: 2;
}

div#qTip { padding: 10px; border: 1px solid #DBDBDB; width:350px; display: none; background: url("$web_url/tooltback.gif"); color: #000; font: 11px Arial, sans-serif; text-align: left; position: absolute; z-index: 1000; }

#addir { display: block; width: 66px; height: 22px; background: url("$web_url/dm_add.gif") no-repeat 0 0; } /*CCSSLVA*/
#addir:hover { background-position: 0 -22px; } /*CCSSLVA*/
#addir span {display: none; } /*CCSSLVA*/

#addirm { display: block; width: 125px; height: 22px; background: url("$web_url/dm_addm.gif") no-repeat 0 0; } /*CCSSLVA*/
#addirm:hover { background-position: 0 -22px; } /*CCSSLVA*/
#addirm span {display: none; } /*CCSSLVA*/

#gend { display: block; width: 74px; height: 22px; background: url("$web_url/dm_gen.gif") no-repeat 0 0; } /*CCSSLVA*/
#gend:hover { background-position: 0 -22px; } /*CCSSLVA*/
#gend span {display: none; } /*CCSSLVA*/

#dm_addl { display: block; width: 70px; height: 22px; background: url("$web_url/dm_addl.gif") no-repeat 0 0; } /*CCSSLVA*/
#dm_addl:hover { background-position: 0 -22px; } /*CCSSLVA*/
#dm_addl span {display: none; } /*CCSSLVA*/

#dm_addlm { display: block; width: 132px; height: 22px; background: url("$web_url/dm_addlm.gif") no-repeat 0 0; } /*CCSSLVA*/
#dm_addlm:hover { background-position: 0 -22px; } /*CCSSLVA*/
#dm_addlm span {display: none; } /*CCSSLVA*/

#dm_import { display: block; width: 60px; height: 22px; background: url("$web_url/dm_import.gif") no-repeat 0 0; } /*CCSSLVA*/
#dm_import:hover { background-position: 0 -22px; } /*CCSSLVA*/ 
#dm_import span {display: none; } /*CCSSLVA*/

#dm_crawl { display: block; width: 51px; height: 22px; background: url("$web_url/dm_crawl.gif") no-repeat 0 0; } /*CCSSLVA*/
#dm_crawl:hover { background-position: 0 -22px; } /*CCSSLVA*/
#dm_crawl span {display: none; } /*CCSSLVA*/

#dm_odp { display: block; width: 40px; height: 22px; background: url("$web_url/dm_odp.gif") no-repeat 0 0; } /*CCSSLVA*/
#dm_odp:hover { background-position: 0 -22px; } /*CCSSLVA*/
#dm_odp span {display: none; } /*CCSSLVA*/

#dm_xml { display: block; width: 40px; height: 22px; background: url("$web_url/dm_xml.gif") no-repeat 0 0; } /*CCSSLVA*/
#dm_xml:hover { background-position: 0 -22px; } /*CCSSLVA*/
#dm_xml span {display: none; } /*CCSSLVA*/
 
.gbutton { font-family: "MS Sans Serif", "New York", serif; font-size: 8px; }
</style>

</head>
<body>
<div style="position: absolute; cursor: pointer; top:0px; right:0px; background-color:#FFF; border:1px solid #CCC; padding-top:3px; padding-left:3px; padding-right:3px" title="loading" id="loader">
<img src="$web_url/loader.gif" border="0">
</div>
<script LANGUAGE="JavaScript">
pic1 = new Image(50,50); 
pic1.src = '$web_url/loader.gif';
document.getElementById('loader').style.display = 'none';
</script>
!!data!!
</body>
</html>
];



if ($gsettings->{searchmeth} eq "fulltext")
	{
	$template =~ s/!!!search!!!/search2\.cgi/g;
	}
	else
	{
	$template =~ s/!!!search!!!/search\.cgi/g;
	}

$cid = $q->param('cid');
$rid = $q->param('rid');

##### LEVEL

$lv = $q->param('lv');
$rlv = $lv;
if ($lv eq "") { $lv = 0; }

$ct = $q->param('ct');


###### DIR OPTIONS BUTTONS FOR ROOT DIR
if ($q->param('ct') eq "")
	{
$toplinks = qq[<table width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="1%"><img src="$web_url/dbut.gif"></td>
    <td width="1%" height="40"><a href="$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv" id="addir" 
      onClick="popup('$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv',950,570);return false;"></a></td>
    <td width="1%"><a href="$admin_url/admin2.cgi?fct=addir_m&amp;ct=" id="addirm" 
      onClick="popup('$admin_url/admin2.cgi?fct=addir_m&amp;ct=',950,650);return false;"></a></td>
    <td width="1%"><a href="$admin_url/admin8.cgi" id="gend" onClick="popup('$admin_url/admin8.cgi',700,600);return false;"  title="Generate current category and it's sub categories (if any) as HTML files"></a></td>
    <td width="96%">&nbsp;</td>
  </tr>
</table>
<br><br>
];

#<a href="$admin_url/admin33.cgi" onClick="popup('$admin_url/admin33.cgi',600,400);return false;"><img src="$web_url/emailb.gif" border="0"></a>

	}
	else ### OTHER BUTTONS WHEN IN CATEGORY
	{


$toplinks = qq[
<table width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="1" height="40"><img src="$web_url/dbut.gif"></td>
    <td width="1%"><a href="$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv&amp;cust_tmpl=!!cust_template!!" id="addir" 
          onClick="popup('$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv&amp;cust_tmpl=!!cust_template!!',950,570);return false;"><span>Add Dir</span></a></td>
    <td width="1%"><a href="$admin_url/admin2.cgi?fct=addir_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;cust_tmpl=!!cust_template!!" id="addirm" 
          onClick="popup('$admin_url/admin2.cgi?fct=addir_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;cust_tmpl=!!cust_template!!',950,650);return false;"><span>Add Multiple Dirs</span></a></td>
    <td width="1%"><a href="$admin_url/admin4.cgi?fct=add_listing&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid" id="dm_addl" 
          onClick="popup('$admin_url/admin4.cgi?fct=add_listing&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',950,650);return false;"><span>Add Link</span></a></td>
    <td width="1%"><a href="$admin_url/admin4.cgi?fct=add_listing_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid" id="dm_addlm" 
          onClick="popup('$admin_url/admin4.cgi?fct=add_listing_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',950,650);return false;"><span>Add Multiple</span></a></td>
    <td width="1%"><a href="$admin_url/admin38.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid" id="dm_import" 
          onClick="popup('$admin_url/admin38.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',950,650);return false;"><span>Import</span></a></td>
    <td width="1%"><a href="$admin_url/admin41.cgi?cid=$cid&amp;ct=$ct" id="dm_crawl" 
          onClick="popup('$admin_url/admin41.cgi?cid=$cid&amp;ct=$ct',950,650);return false;"><span>Crawl</span></a></td>
    <td width="1%"><a href="$admin_url/odp.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid" id="dm_odp" 
          onClick="popup('$admin_url/odp.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',950,650);return false;"><span>ODP</span></a></td>
    <td width="1%"><a href="$admin_url/xmlimp.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid" id="dm_xml" 
          onClick="popup('$admin_url/xmlimp.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',950,650);return false;"><span>RSS</span></a></td>
    <td width="80%"><a href="$admin_url/generate.cgi?fct=part_build&amp;cid=$cid" id="gend" 
          onClick="popup('$admin_url/generate.cgi?fct=part_build&amp;cid=$cid',750,600);return false;" title="Generate current category and it's sub categories (if any) as HTML files"></a></td>
    <td width="300" valign="middle" align="right" class="normaltext"><b>!!expand_retract!!</b><img src="$web_url/wspc.gif"></td>
  </tr>
</table>
];

	}

#    <a href="$admin_url/admin33.cgi?cid=$cid"   onClick="popup('$admin_url/admin33.cgi?cid=$cid',600,400);return false;"><img src="$web_url/emailb.gif" border="0"></a> 


##### TOP LINKS


##### RETRIEVE DIRS
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password) || die "Database connection not made: $DBI::errstr";


if ($lv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') ORDER BY shortname ASC");
	}
	else
	{
	$lv++;
	@adir = split (/-/, $ct);
	#$rct = acs::decode_dir($ct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $lv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$dsql = "SELECT * FROM dirs WHERE (level = '$lv') and $querystr ORDER BY shortname ASC";
	$sth = $dbh->prepare($dsql);
	
	#print "--> SELECT * FROM dirs WHERE (level = '$lv') and $querystr ORDER BY shortname ASC <BR>";
	}

#print $dsql;
	
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

#print "$rows <BR>";

if ($rid ne "") {$rid = $rid . "-"; }

### 
$nowtime = time();

while ( @row = $sth->fetchrow() )
	{
	## $row[29]
	
	$cust_template = $row[27];
	
	$lv = $row[1];
	
	$dirstring = ""; 
	for ($dms = 2; $dms < 18; $dms++) 
		{
		if ($dms == 2)
			{
			$dirstring = acs::encode_dir($row[$dms]);
			$dirstring_modr = $row[$dms];
			}
		elsif ($row[$dms] ne "")
			{
			$dirstring = $dirstring . "-" . acs::encode_dir($row[$dms]);
			$dirstring_modr = $dirstring_modr . "-" . $row[$dms];
			}
		}
	

	if ($row[20] eq "") { $row[20] = 0; }

	if ($row[27] eq "") { $row[27] = "Default"; }
	
	if (($row[30] eq "") and ($row[31] eq "") and ($row[32] eq "") and ($row[33] eq "") and ($row[34] eq "")) 
		{
		$bannerstat = "None";
		}
		else
		{
		$bannerstat = "Defined";
		}

##########

	if ($row[29] > 0) ### IF THIS IS A CROSSLINKED CATEGORY
		{
		$cross_linksqlw = $cross_linksqlw . " (cid = '$row[29]') OR"; 

		if ($colcnt > 0) 
			{
			$colcolor = "#F9F9F9"; $colcnt = 0;
			}
			else
			{
			$colcolor = "#FFFFFF"; $colcnt++;
			}
	
		$loadern = "a" . $row[0];
	
	
	### CROSSLINKED CATEGORY
$dirtable_middle = $dirtable_middle . qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="normaltext"><strong><img src="$web_url/dircross.gif"><a href="-$row[29]-CRSLINK" title="-$row[29]-ONMOVER">$row[28]</a></strong> @ (-$row[29]-CRSLCNTS)</td>
     <td  align="center" class="normaltext">
    		 <a href="$admin_url/admin2.cgi?fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid" 
    	    onClick="popup('$admin_url/admin2.cgi?&amp;fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid',750,300);return false;" class="bordtext">Edit</a> 
    		 <span class="bordtext">Move</span>  <a href="$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;crossl=true&amp;prev_cid=$cid" 
     onClick="popup('$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;$row[0]&amp;crossl=true&amp;prev_cid=$cid',750,250);return false;" class="bordtext">Delete</a></td>
    <td align="center" class="normaltext"><span class="bordtext">Generate</span></td>
    <td align="center" class="normaltext"><a href="$admin_url/admin31.cgi?cid=$row[29]" onClick="popup('$admin_url/admin31.cgi?cid=$row[29]',750,600);return false;" class="bordtext">$bannerstat</a></td>
    <td align="center" class="normaltext"><a href="$admin_url/admin28.cgi?cid=$row[29]" onClick="popup('$admin_url/admin28.cgi?cid=$row[29]',750,600);return false;" class="bordtext">$row[27]</a></td>
    <td align="center" bgcolor="#F2F9FF" class="normaltext"><a href="-$row[29]-PRVLINK" target="_blank" class="bordtext">Preview</a></td>
  </tr>

];

		}
		else ### IF NORMAL LINK
		{
		#print "==> $nowtime <BR>";
		
		$catlock = "";  $fontcolor = ""; $fontcolor2 = ""; $textdecor = "";
		if ($row[22] eq "Y") { $catlock = "<img src=\"$web_url/locked.gif\">"; } 
		if ($row[22] eq "H") { $fontcolor = "<font color=\"#808080\">"; $fontcolor2 = "</font>"; $textdecor = qq[STYLE="text-decoration:none"];}
		
		### CHECK IF NEW1
		$newgif = "";
		$new1secs = $gsettings->{days1} * 86400;
		$new1time = $nowtime - $new1secs;
		if ($row[23] > $new1time)
			{
			$newgif = "<img src=\"$web_url/new1.gif\">";
			}
		
		### CHECK IF NEW2
		if ($newgif eq "")
		{
		$new1secs = $gsettings->{days2} * 86400;
		$new1time = $nowtime - $new1secs;
		if ($row[23] > $new1time)
			{
			$newgif = "<img src=\"$web_url/new2.gif\">";
			}
		}
		
		### CHECK IF NEW3
		if ($newgif eq "")
		{
		$new1secs = $gsettings->{days3} * 86400;
		$new1time = $nowtime - $new1secs;
		if ($row[23] > $new1time)
			{
			$newgif = "<img src=\"$web_url/new3.gif\">";
			}
		}


		if ($colcnt > 0) 
			{
			$colcolor = "#F9F9F9"; $colcnt = 0;
			}
			else
			{
			$colcolor = "#FFFFFF"; $colcnt++;
			}


		if ($row[22] eq "H")
			{
			$genlink = qq[<span class="bordtext">Generate</span>];
			} 
			else
			{ 
			$genlink = qq[<a href="$admin_url/generate.cgi?fct=part_build&amp;cid=$row[0]" onClick="popup('$admin_url/generate.cgi?fct=part_build&amp;cid=$row[0]',700,600);return false;" title="Generate category and it's sub categories (if any) as HTML files." class="bordtext">Generate</a>];
			}


	$loadern = "a" . $row[0];
	
	#<img src="$web_url/ajload3.gif" id="$loadern" style="display:none">


	if ($gsettings->{dyn_stat} eq "Mod_Rewrite")	
		{
		$modr_dirs = &convert_cat($dirstring_modr);
		$prvlink = qq[<a href="$web_url/$row[0]-$modr_dirs.html" target="_blank" class="bordtext">Preview</a>];
		}
		else ### display static link
		{
		$prvlink = qq[<a href="$script_url/dirs.cgi?lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]" target="_blank" class="bordtext">Preview</a>];
		}

#### DISPLAY CATEGORIES
$dirtable_middle = $dirtable_middle . qq[ <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td class="normaltext"><img src="$web_url/subdir.gif" id="$loadern"> <strong><a href="$admin_url/admin83.cgi?fct=manage_dirs&lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]" $textdecor 
			onClick="showloader($row[0]);">$fontcolor $row[28]$fontcolor2</a></strong> ($row[20]) $catlock $newgif </td>
    <td align="center" class="normaltext"><a href="$admin_url/admin2.cgi?fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid" 
      	onClick="popup('$admin_url/admin2.cgi?&amp;fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid',950,550);return false;" class="bordtext">Edit</a> 
      	<a href="$admin_url/admin62.cgi?lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;&amp;rid=$rid$row[0]&amp;prev_cid=$cid" 
      	onClick="popup('$admin_url/admin62.cgi?lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]&amp;prev_cid=$cid',750,650);return false;" class="bordtext">Move</a> 
    		<a href="$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;&amp;rid=$rid$row[0]&amp;prev_cid=$cid" 
    	  onClick="popup('$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]&amp;prev_cid=$cid',750,250);return false;" class="bordtext">Delete</a></td>
    <td align="center" class="normaltext">$genlink</td>
    <td align="center" class="normaltext"><a href="$admin_url/admin31.cgi?cid=$row[0]" onClick="popup('$admin_url/admin31.cgi?cid=$row[0]',750,600);return false;" class="bordtext">$bannerstat</a></td>
    <td align="center" class="normaltext"><a href="$admin_url/admin28.cgi?cid=$row[0]" onClick="popup('$admin_url/admin28.cgi?cid=$row[0]',750,600);return false;" class="bordtext">$row[27]</a></td>
    <td align="center" bgcolor="#F2F9FF" class="normaltext">
    $prvlink
    </td>
  </tr>
];

		}



	$curcidi = $row[0];
	}

### GET CROSSLINKS IF ANY

if ($cross_linksqlw ne ""){&get_crosslinks;} 


#### RETRACT BOX

$exp_ext = acs::get_file_contents("$data_dir/expext.dat");
if ($exp_ext eq "retract")
	{
	$sth = $dbh->prepare("SELECT COUNT(*) FROM links WHERE cid = '$cid'");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	while ( @row = $sth->fetchrow() ){$total_links = $row[0];}
	
	$expand_extract = qq[<a href="$admin_url/admin59.cgi?fct=retract" onClick="popup('$admin_url/admin59.cgi?fct=retract',500,300);return false;" class="bordtext">Expand Links</a>];
	
	$retract_box = qq[
<BR>
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0">
  <tr>
    <td bgcolor="#FFFFFF" valign="top"><p align="center">Note that links has been <b>set to be retracted or hidden</b>. This means that links will not
    display in the Directory Manager. Click the 'Expand Links' to the right to have links
    display inside the Directory Manager. In some situations not displaying links makes it
    fast to browse the Directory Manager and work with categories/directories.</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
	
	];
	
	}
	else
	{
	&get_links;
	$expand_extract = qq[<a href="$admin_url/admin59.cgi?fct=expand" onClick="popup('$admin_url/admin59.cgi?fct=expand',500,300);return false;" class="bordtext" title="Hide Links">Hide Links</a>];
	}


#### LOCATION
$nria = @adir;

if ($nria != 0)
	{
		$lcstring = $lcstring . qq[<font color="#0080FF"> <b>Location: <img src="$web_url/loc.gif"></b>&nbsp;&nbsp;</font> <a href="$admin_url/admin83.cgi?fct=manage_dirs" onClick="showloader2('rloader');">Root</a> ];
	}
	else
	{
		$sth = $dbh->prepare("SELECT COUNT(*) FROM links");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		while ( @row = $sth->fetchrow() ){$links_t = $row[0];}

		$sth = $dbh->prepare("SELECT COUNT(*) FROM dirs");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		while ( @row = $sth->fetchrow() ){$dirs_t = $row[0];}

		$lcstring = $lcstring . qq[<font color="#0080FF"><b> Location: <img src="$web_url/loc.gif">&nbsp;&nbsp;</b></font> <b>Root</b> ($dirs_t Dirs - $links_t Links)];
		$prev_fp = qq[ 
		| <a href="$admin_url/startup.cgi?fct=quickfp" onClick="popup('$admin_url/startup.cgi?fct=quickfp',950,650);return false;" title="This is the most basic and quickest way to setup the Front Page of your Directory">Front Page Quick Setup</a>
		| <a href="$admin_url/admin26.cgi" onClick="popup('$admin_url/admin26.cgi',950,650);return false;" title="There are many ways to configure/setup your Front Page. Click this option to see the options available.">Front Page Setups</a> | <a href="$script_url/fp.cgi" target="_blank" title="The 'Front Page Template Method' is used for this preview. You can edit the Front Page template by clicking the 'Front Page Setups' link to the left >> 1. Setup/Configure Front Page >> Choose 'Front Page Template' and click next. Note that there are other methods available to configure/setup your Front Page for flexibility. See the manual for detailed instructions.">Front Page Preview (Template Method)</a>
		 | <a href="$admin_url/startup.cgi" onClick="popup('$admin_url/startup.cgi',1000,650);return false;"  title="Use this wizard if you are new to PowerSeek to get started rapidly in 3 steps.">Startup Wizard</a>
		];
	}

## <a href="$script_url/fp.cgi" target="_blank">Preview Front Page</a> | 

$sth->finish;
$dbh->disconnect;


@riditems = split (/-/, $rid); 

$lcount = 1;
foreach $item (@adir)
	{
	
	$nc = $lcount - 1;
	
	if ($nc == 0)
		{
		$rrd = $riditems[$nc];
		}
		else
		{
		$rrd = $rrd . "-" . $riditems[$nc];
		}
	
	$item =~ s/\\'/'/g; #####
	
	if ($lcount == 1)
		{
		$ctst_rl = $ctst_rl . acs::encode_dir($item);
		}
		else
		{
		$ctst_rl = $ctst_rl . "-" . acs::encode_dir($item);
		}
	
	
	if ($nria == $lcount)
		{
		#$item = acs::decode_dir($item);
		$lcstring = $lcstring . " > <b>$item</b> ";
		}
		else
		{
		#$item = acs::decode_dir($item);
		@idit = split (/-/, $rrd);
		$nr_idit = @idit; $nr_idit = $nr_idit - 1;
		$cur_cid = $idit[$nr_idit];
		
		$lcstring = $lcstring . " > <a href=\"$admin_url/admin83.cgi?fct=manage_dirs&lv=$lcount&ct=$ctst_rl&rid=$rrd&cid=$cur_cid\" onClick=\"showloader2('rloader');\">$item</a> ";
		}
	
	$lcount++;
	$cdr = $item;
	}


if ($ct ne "")
{
$plv = $lv - 1;
$lstn = &get_last_dirname($ct);

	if ($gsettings->{dyn_stat} eq "Mod_Rewrite")	
		{
		my @ctitems = split(/-/, $ct);
		foreach $ctmitem (@ctitems) { $ctmd = $ctmd . "-" . acs::decode_dir($ctmitem); }
		
		$ctmodddir = &convert_cat($ctmd);
		$prv = " | <a href=\"$web_url/$cid" . "$ctmodddir.html\" target=\"_blank\">Preview <b>$lstn</b></a>";
		}
		else
		{
		$prv = " | <a href=\"$script_url/dirs.cgi?lv=$plv&ct=$ct\" target=\"_blank\">Preview <b>$lstn</b></a>";
		}

}

#$lcstring = $lcstring . "<br><b>$rows</b> Sub Directories &amp; <b>$total_links</b> Links in Current Dir $prev_fp";
#$lcstring = $lcstring . "$prv</font>";

$catstats = $catstats . "<b>$rows</b> Sub Directories &amp; <b>$total_links</b> Links in Current Dir $prev_fp";
$catstats = $catstats . "$prv";


if ($lcount == 1){$rloc = "Root ";} else {$rloc = $cdr; }


#### TOP DIRTABLE

if ($dirtable_middle ne "")
	{

$dirtable_top = qq[
<table width="100%" cellpadding="4" cellspacing="1" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="40%" height="25" background="$web_url/bar6.gif" class="normaltext"><img src="$web_url/dir.gif"><strong> $rloc </strong></td>
    <td width="23%" align="center" background="$web_url/bar6.gif" class="normaltext"><strong>Edit | Move | Delete</strong></td>
    <td width="9%" align="center" background="$web_url/bar6.gif" class="normaltext"><strong>Generate</strong></td>
    <td width="9%" align="center" background="$web_url/bar6.gif" class="normaltext"><strong>Adverts</strong></td>
    <td width="9%" align="center" background="$web_url/bar6.gif" class="normaltext"><strong>Template</strong></td>
    <td width="9%" align="center" background="$web_url/bar6.gif" class="normaltext"><font color="#000000"><strong>Preview</strong></font></td>
  </tr>
];

$dirtable_bot = qq[</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="10" bgcolor="#FFFFFF"></td>
    <td width="99%" height="7"></td>
  </tr>
</table>
];
	}


$toplinks =~ s/!!expand_retract!!/$expand_extract/gi;
$toplinks =~ s/!!cust_template!!/$cust_template/gi;




$dirtable = qq[
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><img src="$web_url/ic_dirm.gif"></td>
    <td width="99%" valign="top" bgcolor="#FFFFFF">
    
    <table width="100%" border="0" cellpadding="6">
      <tr>
        <td colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Directory Manager</strong></td>
      </tr>
      <tr>
        <td class="normaltext">$catstats</td>
        <td align="right" class="normaltext">
        [ <a href="#" onClick="window.location.reload()">Refresh Page</a> ]
        </td>
      </tr>
    </table></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="10" bgcolor="#FFFFFF" height="6"></td><td width="99%"></td></tr>
</table>
<p class="normaltext12">$lcstring <img src="$web_url/ajload3.gif" id="rloader" style="display:none; vertical-align:text-top"></p>

$dirtable_top
$dirtable_middle
$dirtable_bot
$toplinks
$all_lnks
$retract_box
];


$template =~ s/!!data!!/$dirtable/g; 

print "$template";
 
}








sub get_links
{

$nowtime = time();

### GET FIELDS/KEYS

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

if ($q->param('rev') eq "true") { $only_list_reviews = "AND rev_no > 0"; }

### GET SORTING

if ($gsettings->{dir_sort_links} eq "Popularity")
	 {
	 $pop1 = ", (IFNULL(A.rating,0) + IFNULL(A.votes,0) + IFNULL(A.hits,0)) AS popul ";
	 $pop2 = ", popul DESC, title ASC ";
	 }
elsif ($gsettings->{dir_sort_links} eq "Alphabetical")
	 {
	 $pop2 = ", title ASC";
	 }
elsif ($gsettings->{dir_sort_links} eq "Hits")
	 {
	 $pop2 = ", hitsort DESC, title ASC";
	 }
elsif ($gsettings->{dir_sort_links} eq "Votes")
	 {
	 $pop2 = ", votesort DESC, title ASC";
	 }
elsif ($gsettings->{dir_sort_links} eq "Ratings")
	 {
	 $pop2 = ", ratingsort DESC, title ASC";
	 }
	 elsif ($gsettings->{dir_sort_links} eq "Newest")
	 {
	 $pop2 = ", urldate DESC, title ASC";
	 }


### PREPARE SQL QUERY

	$links_sql = "SELECT A.*, 
				IFNULL(premium, 0) AS premsort,
				IFNULL(rating, 0) AS ratingsort,
				IFNULL(votes, 0) AS votesort,
				IFNULL(hits, 0) AS hitsort
				$pop1
				
	FROM links AS A
	WHERE cid = '$cid' AND ((newsubm = '') OR (newsubm IS NULL)) 
	ORDER BY premsort DESC $pop2";




### WHERE cid = '$cid' AND ((newsubm = '') OR (newsubm IS NULL)) 
### SELECT * FROM links WHERE cid = '$cid' AND ((newsubm = '') OR (newsubm IS NULL)) ORDER BY premium DESC, title

#print "--> $links_sql<BR><BR>";

$sth = $dbh->prepare($links_sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $links_sql";}

$total_links = $sth->rows();

$nr_searchres = $gsettings->{cp_link_listings};
if ($nr_searchres eq "") { $nr_searchres = 100; }

#### CREATE START OF SELECT FORM

$all_lnks = qq[
<form name="select_all" method="POST" action="$admin_url/admin5.cgi" style="margin-bottom:0; margin-top:0;">
<input type="hidden" name="fct" value="link_functions">
<input type="hidden" name="ct" value="$ct">
<input type="hidden" name="rid" value="$rid">
<input type="hidden" name="cid" value="$cid">
<span class="normaltext">
%%linkoptions%%
];


#### PAGES
$icnt = $total_links;

if ($icnt > 0)
	{
	$modp = ($icnt % $nr_searchres);
	$pages = ($icnt - $modp) / $nr_searchres;
	if ($modp != 0) {$pages++;}
	}

	
$st = $q->param('st');
$nd = $q->param('nd');

$main_nd = $nd;
$main_st = $st;

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}
	
$ippc = 1;
$nr_disp = 0;

############

$nowtime = time();

while ( @row = $sth->fetchrow() )
	{
	$chknm = "C" . $nr_disp;
	

if (($ippc > $st) and ($ippc <= $nd))
   {		
	$chkstring = $chkstring . "'$chknm',";


if ($gsettings->{htmldisplay} eq "htmlon")
	{
	$row[3] =~ s/</&lt;/g; $row[3] =~ s/>/&gt;/g; 
	$row[4] =~ s/</&lt;/g; $row[4] =~ s/>/&gt;/g; 
	}


	if ($row[3] ne ""){$row[3] = $row[3] . "<br>";}
	if ($row[4] ne ""){$row[4] = "Keywords: <b>$row[4]</b><br>";}	
	if ($row[5] ne ""){$row[5] = "$row[5]";}
	
	if ($row[10] eq ""){$row[10] = "0";}
	if ($row[11] eq "") {$row[11] = "0";}
	if ($row[12] eq "") {$row[12] = "0";}
	$popnr = $row[12];

	
	if (($row[21] == 0) and ($row[13] > 0))
	{ $row[21] = 99999999999999; }
	

	####### PREMIUM LISTINGS
	if ($row[13] eq "") {$row[13] = "0";}
	$is_prem_listing = "";
	$pexp_date = "";
	if (($row[13] > 0) and ($row[21] > $nowtime))
		{
		$is_prem_listing = "<img src=\"$web_url/premi2.gif\">";
		$pexp_date = "";
		if (($row[21] > 0) and ($row[21] != 99999999999999))
			{
			$row[21] = acs::decode_date($row[21]);
			$pexp_date = " - <strong><font color=\"#FF0000\">Expiry Date: $row[21]</font></strong>";
			}
			else
			{
			$pexp_date = " - <strong><font color=\"#FF0000\">Never Expires</font></strong>";			
			}
		}
	############
	
	
	if ($row[8] ne ""){$row[8] = "<BR>Name: <b>$row[8]</b><br>";}
	if ($row[9] ne ""){$row[9] = "Email: <b>$row[9]</b>";}
	
	$row[10] = "<b>$row[10]</b>";
	$row[11] = "<b>$row[11]</b>";
	$row[12] = "<b>$row[12]</b>";
	$row[13] = "<b>$row[13]</b>";
	
	$date = acs::decode_date($row[17]);

	
	#### KEYS
	if ($knr > 0)
		{
		$key_disp_data = "";
		$rkcnt = 27;
		foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $notext, $imgf, $fieldtype) = split (/\t/, $k_item);

		   if (($visible eq "No") and ($fieldtype eq "Content"))
		   	{
		   	$blankv = "";
		   	if (length($row[$rkcnt]) < 10) { $blankv = "- <b>Empty</b>"; }
		   	$key_disp_data = $key_disp_data . qq[<a href="" onClick="popup('$admin_url/admin80.cgi?id=$row[0]&key=$keyname&fct=edit',screen.width-200,screen.height-200);return false;"><font color="#800080"><b>$description</b></font></a> <i>(Content Field $blankv)</i><BR>];
		   	}
			elsif ($visible eq "Yes")
				{

					if ($fieldtype eq "Upload")
						{
							if ($row[$rkcnt] ne "") 
								{
								$ifname = "$web_url/imagefiles/$row[0]/$keyname" . "." . $row[$rkcnt];
								$key_disp_data = $key_disp_data . qq[<font color="#804040"><b>$description:</b> <a href="$ifname" target="_blank">$ifname</a></font><BR>];
								}
								else
								{
								$key_disp_data = $key_disp_data . qq[<font color="#804040"><b>$description:</b> N/A</font><BR>];
								}
						}
						
				elsif ($imgf eq "Yes")
					{
						if ($row[$rkcnt] ne "") {$key_disp_data = $key_disp_data . "<img src=\"$row[$rkcnt]\"><br>";}
					}
				else
					{
						if ($row[$rkcnt] eq "") { $row[$rkcnt] = $notext; }
							
						### IF HTML ON
						if ($gsettings->{htmldisplay} eq "htmlon"){ $row[$rkcnt] =~ s/</&lt;/g; $row[$rkcnt] =~ s/>/&gt;/g; }
								
						$key_disp_data = $key_disp_data . qq[<font color="#8080C0"><b>$description:</b> $row[$rkcnt]</font><br>];
					}

				}
		$rkcnt++;
		}
	}
	

	###########
	
	$rvws = "";
	if ($row[23] eq "") { $row[23] = 0; }
	$rvws = "  <a href=\"$admin_url/admin15.cgi?lnkid=$row[0]\" onClick=\"popup('$admin_url/admin15.cgi?lnkid=$row[0]',750,600);return false;\" class=\"bordtext\">Reviews ($row[23])</a> ";

	if ($row[22] eq "") { $row[22] = "N/A"; }

	### CHECK IF THIS IS A NEW LINK
	$newgif = "";
	$new1secs = $gsettings->{days1} * 86400;
	$new1time = $nowtime - $new1secs;
	if ($row[17] > $new1time)
		{
		$newgif = "<img src=\"$web_url/new1.gif\">";
		}

	### CHECK IF NEW2
	if ($newgif eq "")
	{
	$new1secs = $gsettings->{days2} * 86400;
	$new1time = $nowtime - $new1secs;
	if ($row[17] > $new1time)
		{
		$newgif = "<img src=\"$web_url/new2.gif\">";
		}
	}
		
	### CHECK IF NEW3
	if ($newgif eq "")
	{
	$new1secs = $gsettings->{days3} * 86400;
	$new1time = $nowtime - $new1secs;
	if ($row[17] > $new1time)
		{
		$newgif = "<img src=\"$web_url/new3.gif\">";
		}
	}


### POP GRAPHIC
$popgr = "";
if ($popnr > $gsettings->{pop_links_amount})
	{
	$popgr = "<img src=\"$web_url/pop.gif\">";
	}



if ($gsettings->{htmldisplay} eq "htmlon") ### IF HTML ON
	{
	$row[2] =~ s/</&lt;/g; $row[2] =~ s/>/&gt;/g; 
	}

if (($row[5] eq "http://") or ($row[5] eq ""))
	{
	$cplinkds = "<b>$row[2]</b>";
	$display_url = "No URL";
	}
	else
	{
	$cplinkds = "<a href=\"$row[5]\" target=\"_blank\"><b>$row[2]</b></a>";
	$display_url = $row[5];
	}

### NEW SUBMISSIONS
#$newsubm = ""; $input_box = "";
#if ($row[15] ne "")
#	{
#	$newsubm = "<font color=\"#FF8000\"><b><i>New Submission - Waiting for Approval</i></b></font>";
#	}

$recip = "";
if ($row[25] ne "") { $recip = qq[<BR><font color="#0080FF"> Reciprocal Link: <a href="$row[25]" target="_blank">$row[25]</a></font>]; }



	$user_account_jump = "";
	if ($row[16] > 0) ### IF USER ACCOUNT EXISTS FOR LINK
		{
		$user_account_jump = qq[ <a href="$admin_url/admin55.cgi?fct=editacc&userid=$row[16]" onClick="popup('$admin_url/admin55.cgi?fct=editacc&userid=$row[16]',750,600);return false;" class="bordtext">User Account</a>];
		}


$imagedis = "";
if ($row[6] ne "")
	{

		if ((lc($row[6]) eq "tif") or (lc($row[6]) eq "png") or (lc($row[6]) eq "jpg") or (lc($row[6]) eq "jpeg") or (lc($row[6]) eq "gif") or (lc($row[6]) eq "bmp"))
		{
			if (($gsettings->{image_width} > 0) and ($gsettings->{image_height} > 0))
				{
				$width = $gsettings->{image_width};
				$height = $gsettings->{image_height};
				$imgwh = qq[width="$width" height="$height"];
				}
		$imagedis = qq[<BR><img src="$web_url/imagefiles/$row[0].$row[6]" $imgwh><BR>];
		}
		else
		{
		$imagedis = qq[<b>File:</b> <a href="$web_url/imagefiles/$row[0].$row[6]" target="_blank">$row[0].$row[6]</a><BR>];
		
		}
	}



$cc_val = $row[0] . "-" . $row[1];


if ($gsettings->{addurl_reg_system} ne "Yes")
	{
	$modify_password = "Password: <b>$row[22]</b><br>";
	}

$all_lnks = $all_lnks . qq[
<table border="0" cellpadding="6" cellspacing="0" width="100%" class="aborder" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
  <tr>
    <td width="1%" valign="top"><input type="checkbox" name="$chknm" value="$row[0]"><br>$is_prem_listing</td>
    <td width="99%" class="normaltext"><b>$ippc.</b>  $cplinkds $newgif $popgr $newsubm<br>
    $row[3] $row[4] <b>$display_url</b><br>
    $date<br>
    $modify_password
    Rating: $row[10] | Votes: $row[11] | Hits: $row[12]<br>
    Premium Pos: $row[13] $pexp_date $row[8] $row[9] $recip <BR>ID: <b>$row[0]</b> <br>
    $key_disp_data 
    $imagedis
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td height="30" class="normaltext"><b><a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Edit" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Edit',950,650);return false;" class="bordtext">Edit</a> 
     <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Move" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Move',800,650);return false;" class="bordtext">Move</a> 
     <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Copy" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Copy',800,650);return false;" class="bordtext">Copy</a> 
     <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Delete" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Delete',550,150);return false;" class="bordtext">Delete</a> 
    $rvws $user_account_jump </b></td>
  </tr>
</table>

<BR>
];




#<input type="checkbox" name="$chknm" value="$row[0]"><b>$ippc.</b> $is_prem_listing $cplinkds $newgif $newsubm<br>
#$row[3]
#$row[4]
#<b>$display_url</b><br>
#$date<br>
#Password: <b>$row[22]</b><br>
#Rating: $row[10]
#Votes: $row[11]
#Hits: $row[12]
#Premium: $row[13] $pexp_date
#$row[8]
#$row[9] $recip
#$rvws 
#ID: <b>$row[0]</b>
#<br>
#$key_disp_data 
#$user_account_jump $imagedis
#<br><br>


  $nr_disp++;

	$crit = "<img src=\""; $all_lnks =~ s/\[img\]/$crit/gi;
	$crit = "\">"; $all_lnks =~ s/\[\/img\]/$crit/gi;

	$crit = "<a href=\"$row[5]\" target=\"_blank\"><img src=\""; $all_lnks =~ s/\[imglnk\]/$crit/gi;
	$crit = "\" border=\"0\"></a>"; $all_lnks =~ s/\[\/imglnk\]/$crit/gi;

  }
$ippc++;
}
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }



if ($total_links > 0)
	{
	
	######## PAGES
	$nwrid = $rid;
	chop($nwrid);
	

	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}
		
	if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

	$hiddenstr = "";
	$pgstring = "";
	
	if ($main_nd eq "") {$main_nd = $nr_searchres;}
	
	for ($ms = 0; $ms < $pages; $ms++)
		{
		$pg = $ms + 1;
		
			if ($main_nd == ($pg * $nr_searchres))
				{
				$pgstring = $pgstring . " <span class=\"bordtext\"><b>[$pg]</b></span> ";
				$currentpage = $pg;
				}
			  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
				{
				$st = ($pg * $nr_searchres) - $nr_searchres;
				$nd = ($pg * $nr_searchres);
				$pgstring = $pgstring . "<a href=\"$admin_url/admin83.cgi?st=$st&nd=$nd&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\" class=\"bordtext\" onClick=\"showloader2('pageloader1');\">$pg</a> ";
			   }
      } 

			####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;
				
				$pgstring = "<a href=\"$admin_url/admin83.cgi?st=$pvst&nd=$pvnd&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\" class=\"bordtext\" onClick=\"showloader2('pageloader1');\"><<</a> " . $pgstring;
				}

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = $pgstring . "<a href=\"$admin_url/admin83.cgi?st=$pvst&nd=$pvnd&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\" class=\"bordtext\" onClick=\"showloader2('pageloader1');\">>></a> ";
				}


	$pgstring = "<b class=\"bordtext\">Pages: 1</b> " . $pgstring . qq[ <img src="$web_url/ajload3.gif" id="pageloader1" style="display:none; vertical-align:text-top"> ];

#vertical-align:text-top

### PREV NEXT PAGES

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}


$spls = $modp;
if ($spls == 0){$spls++;}

if ($nd <= ($icnt - $spls))
{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin83.cgi?st=$st1&nd=$nd1&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\" class=\"bordtext\" onClick=\"showloader2('nextploader1');\">Next Page >></a> ";
}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin83.cgi?st=$st1&nd=$nd1&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\" class=\"bordtext\" onClick=\"showloader2('nextploader1');\"><< Previous Page</a> ";
		}

#if (($prev ne "") and ($nextt ne ""))
#	{
#	$spcer = " | ";
#	}
#	else
#	{
#	$spcer = " ";
#	}
	  
	$prevnext = "<img src=\"$web_url/ajload3.gif\" id=\"nextploader1\" style=\"display:none; vertical-align:text-top\"> " . $prev . "$spcer" . $nextt;

	#if (length($prevnext) > 5){$myspacer = " | ";}
	#$pgstring = $pgstring . $myspacer . $prevnext;



### SET UP CHECK UNCHECK ALL
	
chop ($chkstring);
	
	
	##window.location.href='$admin_url/admin76.cgi?' + windowURL;
	## myWin = open('$admin_url/admin76.cgi?' + windowURL);
	#document.select_all.listperpage.selectedIndex


$jscr = qq[
<script LANGUAGE="JavaScript">
<!-- Hide

function submit_linksperpage(selval)
	{
		 var windowURL;
	    windowURL =  'nr_links=' + selval + '&';
	    windowURL = windowURL + 'ct=$ct&';
	    windowURL = windowURL + 'lv=$lv&';
	    windowURL = windowURL + 'rid=$rid&';
	    windowURL = windowURL + 'cid=$cid&';
    	 windowURL = windowURL + 'fct=link_functions';
    	 window.location.href = '$admin_url/admin76.cgi?' + windowURL;
	}


function checkall(formname,thestate)
	{
	BoxNames=new Array($chkstring)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

function submitForm(theForm, selv) 
  {
  BoxNames=new Array($chkstring)
  windowName = "PowerSeek";
  windowURL = theForm.action + '?';
  var c = 0;
  var bsel = '';
  
	for (c=0;c < BoxNames.length; c++)
		{
		chvl = eval("theForm." + BoxNames[c] + ".checked");
		if (chvl)
			{
			boxnm = eval("theForm." + BoxNames[c] + ".value");
			windowURL = windowURL + BoxNames[c] + '=' + boxnm + '&';
			bsel = boxnm;
			}
		}
		
		
		
		if (bsel == '') { alert ('You have to select at least one listing.'); return false;}
		
		
    windowURL = windowURL + 'nr_links=$nr_disp&';
    windowURL = windowURL + 'ct=$ct&';
    windowURL = windowURL + 'lv=$lv&';
    windowURL = windowURL + 'rid=$rid&';
    windowURL = windowURL + 'cid=$cid&';
    windowURL = windowURL + 'fct=link_functions&';


    if (theForm.opaction1.value == "Delete")
    	{
    	 var wval = 750;
	    var hval = 150;
    	}
    	else
    	{
	    var wval = 950;
	    var hval = 625;
    	}


    var winl = ((screen.width-wval)/2);
	 var wint = ((screen.height-hval)/2) - 50;

    
    if (selv == 1)
    	{
    	windowURL = windowURL + 'opaction1=' + theForm.opaction1.value;
    	}
    	else
    	{
    	windowURL = windowURL + 'opaction=' + theForm.opaction.value;
    	}
    
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=1,titlebar=0,toolbar=0,scrollbars=1,width=' + wval + ',height=' + hval + ',top=' + wint + ',left=' + winl;
    var popupwin = null;
    
    var random = parseInt(Math.random()*10000)
    
    myWindow = window.open(windowURL, 'popupwin' + random, myspecs);
    myWindow.focus();
  } 

// -->
</script>
];
	
	$template =~ s/<!-- Hide !!JSCRIPT!! \/\/ End Hide -->/$jscr/gi;


#### LINK BOTTOM	

$rv_lv = $lv - 1;
$rv_rid = substr($rid, 0, length($rid) -1);

#if ($q->param('rev') eq "true") 
#	{
#	$list_oreviews = "<a href=\"$admin_url/admin2.cgi?lv=$rv_lv&ct=$ct&cid=$cid&rid=$rv_rid\">List All</a>";
#	}
#	else
#	{
#	$list_oreviews = "<a href=\"$admin_url/admin2.cgi?lv=$rv_lv&ct=$ct&cid=$cid&rid=$rv_rid&rev=true\">Only list links with reviews</a>";
#	}

$selv{$gsettings->{cp_link_listings}} = "selected"; 

#onmouseover="this.style.border = '1px solid #008080'" onmouseout="this.style.border = '1px solid #EEE'"

$link_option_table = qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%" align="center" >
  <tr>
    <td width="100%"><table width="100%" border="0" cellpadding="1" align="center">
      <tr>
        <td width="73%" height="30"  class="normaltext"><p>
        
        <a href="javascript:checkall('select_all',true)"><b class="bordtext">Check All</b></a>  <a href="javascript:checkall('select_all',false)"><b class="bordtext">UnCheck All</b></a> $pgstring</p></td>
        
        <td width="27%" align="right" class="normaltext"><b>$prevnext</b></td>
      </tr>
    </table>
      <table width="100%" border="0" align="center" cellpadding="3" cellspacing="0" >
        <tr>
        <td width="1%"><select name="opaction1" size="1">
          <option value="Edit">Edit Checked Items</option>
          <option value="Move">Move Checked Items</option>
          <option value="Copy">Copy Checked Items</option>
          <option value="Delete">Delete Checked Items</option>
        </select></td>
        <td width="1%"><input type="submit" class="psbutton" value="   Go   " name="topb"
    onClick="submitForm(document.select_all,1); return false;"></td>
        <td width="1%"><img src="$web_url/55.gif" width="10" height="1"></td>
        <td width="1%" align="right"><select name="listperpage1" size="1">
          <option value="10" $selv{10}>List 10 Links Per Page</option>
          <option value="20" $selv{20}>List 20 Links Per Page</option>
          <option value="30" $selv{30}>List 30 Links Per Page</option>
          <option value="40" $selv{40}>List 40 Links Per Page</option>
          <option value="50" $selv{50}>List 50 Links Per Page</option>
          <option value="75" $selv{75}>List 75 Links Per Page</option>
          <option value="100" $selv{100}>List 100 Links Per Page</option>
          <option value="200" $selv{200}>List 200 Links Per Page</option>
          <option value="500" $selv{500}>List 500 Links Per Page</option>
          <option value="1000" $selv{1000}>List 1000 Links Per Page</option>
        </select></td>
        <td width="1%"><input type="submit" class="psbutton" value="   Go   " name="ppga" onClick="submit_linksperpage(listperpage1.value,1); return false;"></td>
        <td width="1%"><img src="$web_url/55.gif" width="10" height="1"></td>
        <td width="1%"><label>
          <input name="keywords_cat_search1" type="text" id="keywords" size="25" value="Search Only This Category" onclick="this.value='';">
        </label></td>
        <td width="93%" height="30"><input type="submit" class="psbutton" value="   Search   " name="csearch" onclick="popup('$admin_url/admin11.cgi?ct=$ct&keywords=' + select_all.keywords_cat_search1.value,900,650);return false;" id="csearch"></td>
      </tr>
  </table></td>
  </tr>
</table>
];


#<input type="submit" class="psbutton" value="   Go   " name="topb" style="font-family: MS Sans Serif; font-size: 8">
#<input src="$web_url/go.gif" name="topb" type="image" onClick="submitForm(document.select_all); return false;" value="submit">

#$hlinev = qq[<hr size="1" color="#DBDBDB" noshade width="100%">];

$all_lnks =~ s/%%linkoptions%%/$link_option_table $hlinev<br>/g;

$link_option_table =~ s/opaction1/opaction/g;
$link_option_table =~ s/listperpage1/listperpage/g;
$link_option_table =~ s/keywords_cat_search1/keywords_cat_search/g;

$link_option_table =~ s/pageloader1/pageloader2/g;
$link_option_table =~ s/nextploader1/nextploader2/g;

$link_option_table =~ s/document.select_all,1/document.select_all,0/g;

$all_lnks = $all_lnks . qq[
$hlinev
$link_option_table
<input type="hidden" name="nr_links" value="$nr_disp">
];
	
	#$list_oreviews
	#<input type="submit" class="psbutton" value="Go" name="B1" onClick="submitForm(document.select_all); return false;">
	#<input src="$web_url/go.gif" name="I1" type="image" onClick="submitForm(document.select_all); return false;" value="submit"></td>
	}
	else
	{
	$all_lnks =~ s/%%linkoptions%%//g;
	}





$all_lnks = $all_lnks . "</span>";



}





sub get_crosslinks
{
$cross_linksqlw = substr($cross_linksqlw, 0, length($cross_linksqlw) - 2);

$csql = "SELECT * FROM dirs WHERE $cross_linksqlw";

$sth = $dbh->prepare($csql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $csql";} 

while ( @row = $sth->fetchrow() )
	{
	$cats3 = ""; $rccat = ""; $mwcat = "";
	for ($ms3 = 2; $ms3 < 18; $ms3++) 
		{
		if ($row[$ms3] ne "")
			{
			$rccat = $rccat . "/" . $row[$ms3];
			$cats3 = $cats3 . acs::encode_dir($row[$ms3]) . "-";
			$mwcat = $mwcat . "-" . $row[$ms3];
			}
		} 
	$cats3 = substr($cats3, 0, length($cats3) -1);
	
	$lvc = $row[1];
	$cidc = $row[0];

		if ($gsettings->{dyn_stat} eq "Mod_Rewrite")	
		{
			$modr_dirs = &convert_cat($mwcat);
			$prlink = "-$row[0]-PRVLINK";
			$prrlink = "$web_url/$row[0]" . $modr_dirs . ".html";
			$dirtable_middle =~ s/$prlink/$prrlink/g;
		}
		else ### display static link
		{
			$prlink = "-$row[0]-PRVLINK";
			$prrlink = "$script_url/dirs.cgi?cid=$cidc&lv=$lvc&ct=$cats3";
			$dirtable_middle =~ s/$prlink/$prrlink/g;
		}

	
	$cclink = "-$row[0]-CRSLINK";
	$ccrlink = "$admin_url/admin34.cgi?cid=$cidc&lv=$lvc&ct=$cats3";
	$dirtable_middle =~ s/$cclink/$ccrlink/g;


	$ccstbar = "-$row[0]-ONMOVER";
	$dirtable_middle =~ s/$ccstbar/$rccat/g;
	
	if ($row[20] eq "")  { $row[20] = "0"; }
	$ccnumbers = "-$row[0]-CRSLCNTS";
	$dirtable_middle =~ s/$ccnumbers/$row[20]/g;
	}

}








sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


 