#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Raw SQL Query Tool
# DIZ: Enables you to do raw SQL queries on your database.
# GRAPHIC: ic_sql.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "save_settings") { &save_settings; }


####################################################################################

sub save_settings
{

$contact_us_email = 	$q->param('contact_us_email');
$autoresponse = 		$q->param('autoresponse');
$htmlemail = 			$q->param('htmlemail');
$from_name = 			$q->param('from_name');
$from_email = 			$q->param('from_email');
$subject = 				$q->param('subject');

$message = $q->param('message');

open (CEML, "> $data_dir/contactus1.dat");
	print CEML "$contact_us_email" . "\n";		#0
	print CEML "$autoresponse" . "\n";			#1
	print CEML "$htmlemail" . "\n";				#2
	print CEML "$from_name" . "\n";				#3
	print CEML "$from_email" . "\n";				#4
	print CEML "$subject" . "\n";					#5
close (CEML);

open (CEML, "> $data_dir/contactus2.dat");
	print CEML $message;
close (CEML);

$hbox = acs::get_heading_box("$web_url/ic_email1.gif", "Settings Saved", "<a href='admin85.cgi'>Click Here to Continue</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Includes</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
]; 

}






sub start
{

$contactus1 = acs::get_file_contents("$data_dir/contactus1.dat"); 
@contactus_items = split (/\n/, $contactus1);

$contact_us_email = 	$contactus_items[0];
$autoresponse = 		$contactus_items[1];
$htmlemail = 			$contactus_items[2];
$from_name =			$contactus_items[3];
$from_email = 			$contactus_items[4];
$subject = 				$contactus_items[5];

$message = acs::get_file_contents("$data_dir/contactus2.dat"); 


if ($autoresponse eq "Y") { $autoresponse_checked = "checked"; }
if ($htmlemail eq "Y") { $htmlemail_checked = "checked"; }


if ($from_name eq "") { $from_name = "Your Web Site Name"; }
if ($from_email eq "") { $from_email = "email\@somewhere.com"; }
if ($subject eq "") { $subject = "Thanks for contacting us!"; }

if ($message eq "") 
{
$message = qq[Dear !!name!!,

Thanks for contacting us.

We will get back to you as soon as possible.

Kind Regards
];
}

##################

$contactus3 = acs::get_file_contents("$data_dir/contactus3.dat"); 
@contactus_items2 = split (/\n/, $contactus3);

$no_name 			= $contactus_items2[0];
$invalid_email 	= $contactus_items2[1];
$no_subject			= $contactus_items2[2];
$no_message 		= $contactus_items2[3];
$wrong_captchas 	= $contactus_items2[4];

if ($no_name eq "") 			{ $no_name = "You have to specify a name."; }
if ($invalid_email eq "") 	{ $invalid_email = "The email address you provided is not valid."; }
if ($no_subject eq "") 		{ $no_subject = "You have to specify a subject for your message."; }
if ($no_message eq "") 		{ $no_message = "You have to provide a message."; }
if ($wrong_captchas eq "") { $wrong_captchas = "The image letters you provided was incorrect."; }


#################


$jser = acs::get_js_errors;

$hbox = acs::get_heading_box("$web_url/ic_email1.gif", "Contact Us Form Settings", "Please choose options below.");

$qhdiz = qq[
<b>The templates for the contact form can be edited by click the '<a href="admin6.cgi" target="_blank">Template Manager</a>' tab >> 10. Contact Us Templates</b>
<hr>

<p><STRONG>HTML Design Email  Guidelines When Sending HTML Email:</STRONG>
<UL>
  <LI>Send yourself a test    message to get a preview of how the HTML email will arrive.</LI>
  <LI>It is very important that    you keep your HTML email simple due to Email readers not interpreting all HTML email    equally. It would be necessary that you test the HTML message with Outlook, Eudora, AOL, Yahoo Mail, Google's Gmail,    Hotmail, etc.</LI>
  <LI>All images used need to be    hard linked. In other words: <STRONG>&lt;img src="btnSource.gif"&gt;</STRONG> won't work but <STRONG>&lt;img src="http://www.yourdomain.com/btnSource.gif"&gt;</STRONG> will work.</LI>
  <LI>You can use CSS for basic    fonts and colors but use it sparingly. Many email readers won't support or interpret it    correctly.</LI>
  <LI>Use Inline CSS that is not    linked to files. (Available inside the HTML email message)</LI>
  <LI>When using CSS, use it    below the body tag as browser based email applications (like Gmail, Hotmail, Yahoo, etc)    strip out HTML, HEAD and BODY tags so that they don't interfere with their own web pages.    (The web page displaying the email)</LI>
  <LI>JavaScript, ActiveX    Controls, Flash and embedded movie files will normally not work. The reason they will    normally not work or not work properly is because most people have antivirus software that    will block these.</LI>
  <LI>Background colors and    images will normally not work with browser based email services like Gmail, Yahoo,    Hotmail, etc. The reason for this is that they strip out HTML, HEAD and BODY tags from    HTML email received.</LI>
</UL>
<HR>
<p><STRONG>Spam Filter  Details and Guidelines When Sending HTML Email:</STRONG>
<UL>
  <LI>You will need a good    balance between images and text else spam filters will flag the email as spam.</LI>
  <LI>Make sure your HTML code    has no errors and ensure that your email message contains proper grammar and spelling.    Spammers are renowned for sloppy HTML code and grammar.</LI>
</UL>



];

$helpb = acs::quick_help("Help:",$qhdiz); 

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PPC Feed</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
$jser

<script LANGUAGE="JavaScript">
function check_email ()
	{
	if (document.getElementById('contact_us_email').value == '') { alert ('You have to provide an email address to which email will be sent from visitors'); return false; }
	
	if (document.getElementById('autoresponse').value == 'Y')
		{
			if (document.getElementById('from_name').value == '')  { alert('You have enabled the auto response feature. For the auto-response to be sent you have to provide a name from which the email is going to be sent.');	return false; }
			if (document.getElementById('from_email').value == '') { alert('You have enabled the auto response feature. For the auto-response to be sent you have to provide an email address from which the email is going to be sent.');	return false; }
			if (document.getElementById('subject').value == '')    { alert('You have enabled the auto response feature. For the auto-response to be sent you have to provide an email subject.');	return false; }
			if (document.getElementById('message').value == '')    { alert('You have enabled the auto response feature. For the auto-response to be sent you have to provide a message.');	return false; }
		}

	}
</script>

</head>
<body>
$hbox



<script SRC="$web_url/qtip.js"></script>

<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style>


<form method="POST" action="admin85.cgi" onSubmit="return check_email(); ">
  <table border="0"
  cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr class="bar7">
      <td colspan="2" valign="top" class="normaltext"><strong>General 'Contact Us' form settings:</strong></td>
    </tr>
    <tr>
      <td width="224" valign="top" bgcolor="#FFFFFF" class="normaltext">Email Address:</td>
      <td width="633" bgcolor="#FFFFFF" class="normaltext"><input name="contact_us_email" type="text" id="contact_us_email" value="$contact_us_email" size="50">
        <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('When a user completes the contact form then the contents of the contact form will be sent to this email address.');" onMouseOut="tooltip.hide();" /></td>
    </tr>
    <tr>
      <td width="224" valign="top" bgcolor="#FFFFFF" class="normaltext">Send an auto-response?</td>
      <td width="633" bgcolor="#FFFFFF" class="normaltext"><input name="autoresponse" type="checkbox" id="autoresponse" value="Y" $autoresponse_checked>
        <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('If enabled then the email below will be sent to the person that completed the contact form.');" onMouseOut="tooltip.hide();" /></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">Auto-Response email: </td>
      <td bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellspacing="1" cellpadding="3">
          <tr class="normaltext">
            <td><strong>HTML Email?</strong></td>
            <td><input name="htmlemail" type="checkbox" id="htmlemail" value="Y" $htmlemail_checked>
              <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('If enabled then you can use HTML in the message below.');" onMouseOut="tooltip.hide();" /></td>
          </tr>
          <tr class="normaltext">
            <td width="21%"><strong>From Name:</strong></td>
            <td width="79%"><input name="from_name" type="text" id="from_name" value="$from_name" size="40"></td>
          </tr>
          <tr class="normaltext">
            <td><strong>From Email:</strong></td>
            <td><input name="from_email" type="text" id="from_email" value="$from_email" size="40"></td>
          </tr>
          <tr class="normaltext">
            <td><strong>Subject: </strong></td>
            <td><input name="subject" type="text" id="subject" style="width:100%" value="$subject" size="40"></td>
          </tr>
          <tr class="normaltext">
            <td valign="top"><strong>Message:</strong></td>
            <td><textarea name="message" id="message" cols="45" rows="10" style="width:100%">$message</textarea></td>
          </tr>
        </table></td>
    </tr>
    <tr class="bar7">
      <td colspan="2"  class="normaltext"><strong>Error Text Responses:</strong></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">When no name was specified:</td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="no_name" type="text" id="no_name" style="width:100%" value="$no_name"></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">When invalid email address specified:</td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="invalid_email" type="text" id="invalid_email" style="width:100%" value="$invalid_email"></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">When no subject was specified:</td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="no_subject" type="text" id="no_subject" style="width:100%" value="$no_subject"></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">When no message was specified:</td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="no_message" type="text" id="no_message" style="width:100%" value="$no_message"></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">When Captcha images did not match:</td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="wrong_captchas" type="text" id="wrong_captchas" style="width:100%" value="$wrong_captchas"></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"></td>
      <td bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
    </tr>
    <tr>
      <td width="224" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="633" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" value="   Save Settings   " name="B1">
        <input type="hidden" name="fct" value="save_settings"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

$helpb

</body>
</html>
];
 

}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

