#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
if ($q->param('fct') eq "hidemenu") { &hidemenu; exit;}

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "menu") { &menuopp; }
if ($q->param('fct') eq "displaymenu") { &displaymenu; exit;}


####################################################################################

sub hidemenu
{

acs::write_config("cp_file_menu", "false");
print "Location: $web_url/psbadge.gif\n\n";
exit;

}


sub displaymenu
{
acs::write_config("cp_file_menu", "");

print qq[
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin.cgi">
</head>
<body>
</body>
</html>
];

}



sub menuopp
{

print "";


}


sub start
{

$tid = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM paypalpremium WHERE transid = '$tid' ";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$row = $sth->fetchrow_hashref();
%cols = %$row;


$sql = "SELECT * FROM links WHERE lnkid = '$cols{'lnkid'}' ";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$row2 = $sth->fetchrow_hashref();
%cols2 = %$row2;


$sth->finish;
$dbh->disconnect;


($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($cols2{'subs_expire'});
$year = $year + 1900; #### "20" . substr($year, 1, 2);
@marray = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"); 
$mon++;
if (length($mday) == 1) { $mday = "0" . $mday; }
if (length($mon) == 1) { $mon = "0" . $mon; }
$expdate = "$year-$mon-$mday";


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>

<table width="100%" border="0" cellpadding="6" cellspacing="1" class="aborder">
  <tr class="bar6">
    <td  height="15" colspan="2" valign="top" 
      ><span class="normaltext"><strong>PayPal Payment Details for Premium Listing:</strong></span></td>
  </tr>
  <tr>
    <td class="normaltext" width="31%" valign="top"><span class="normaltext"><strong>Link ID:</strong></span></td>
    <td class="normaltext" width="69%" valign="top">$cols{'lnkid'}</td>
  </tr>
  <tr>
    <td class="normaltext" valign="top"><strong>Link:</strong></td>
    <td class="normaltext" valign="top"><a href="$cols2{'url'}" target="_blank">$cols2{'title'}</a></td>
  </tr>
  <tr>
    <td class="normaltext" valign="top"><strong><span class="normaltext">Submission Date:</span></strong></td>
    <td class="normaltext" valign="top">$cols{'TIMESTAMP'}</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong><span class="normaltext">Premium Expiry Date:</span></strong></td>
    <td class="normaltext" valign="top">$expdate</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong>PayPal PAYERID:</strong></td>
    <td class="normaltext" valign="top">$cols{'PAYERID'}</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong>Email:</strong></td>
    <td class="normaltext" valign="top">$cols{'EMAIL'}</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong>First Name:</strong></td>
    <td class="normaltext" valign="top">$cols{'FIRSTNAME'}</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong>Last Name: </strong></td>
    <td class="normaltext" valign="top">$cols{'LASTNAME'}</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong>Country Code: </strong></td>
    <td class="normaltext" valign="top">$cols{'COUNTRYCODE'}</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong>Payment Amount:</strong></td>
    <td class="normaltext" valign="top">$cols{'A_PAYMENTREQUEST_0_AMT'}</td>
  </tr>
  <tr >
    <td class="normaltext" valign="top"><strong>Currency:</strong></td>
    <td class="normaltext" valign="top">$cols{'A_PAYMENTREQUEST_0_CURRENCYCODE'}</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td  width="99%"></td>
  </tr>
</table>

</body>
</html>
];
 

}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

