#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi


# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#if (!$ENV{REQUEST_METHOD}) {     use CGI.pm    $input = new CGI; }

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use acs;
use htbuild;
use psfp;
use glsitemap;

&get_setup;

$q = CGI->new;

#$default_permissions = 0755; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES - This setting is decpriciated since PowerSeek Ver 5.0 - It can be set by 
#going to the PowerSeek Control Panel >> Settings >> Global Engine Settings >> 2. HTML File Generation Settings
#
#umask (0); ### DIRECTORY CREATION MASK SET TO 777




### REPAIR TABLES
$repair_tables = "N"; ### Y/N

### RECOUNT LINKS
$do_recount = "Y";


### TELNET/SSH BUILD RESOURCE USAGE
$wait_telnet = htbuild::get_file_contents2("$data_dir/tel_build.cfg");
if ($wait_telnet eq "") { $wait_telnet = 0; }


### BROWSER BUILD RESOURCE USAGE
$web_build = htbuild::get_file_contents2("$data_dir/web_build.cfg");
@wb_vars = split(/\n/, $web_build);
$wcats_per_build = $wb_vars[0];
$wait_web = $wb_vars[1];

if ($wcats_per_build eq "") { $wcats_per_build = 5; }
if ($wait_web eq "") { $wait_web = 1; }


### BATCHES OF CATEGORIES IN TMP FILES / TELNET / SSH
#$wait_telnet = 5;
$wait_includes = 0;

$cats_per_file = 5000;
$cats_per_build = 50;

### BATCHES OF CATEGORIES IN TMP FILES / BROWSER
#$wait_web = 2;
$wcats_per_file = 1000;
#$wcats_per_build = 1; ### HOW MANY CATEGORIES TO BUILD AT ONCE

##################################################################################

$gsettings = new_gsettings acs;

if ($gsettings->{generation_permissions} eq "") { $gsettings->{generation_permissions} = "0777"; }
$default_permissions = oct($gsettings->{generation_permissions}); 

### FOR IMAGE AUTHENTICATION
if ((-e "$data_dir/idirs.dat") < 1)
	{
	open (DF, "> $data_dir/idirs.dat");
		opendir(DIR,"$web_dir");
			@allfiles = readdir(DIR);
			foreach $filename (@allfiles)
				{
					if (($filename ne ".") and ($filename ne "..") and (substr($filename, 0, 1) eq "A"))
					{
						if (substr($filename, length($filename) - 4, 4) eq ".gif")
							{
							print DF $filename . "\n";
							}
					}
				}
		closedir(DIR);
	close (DF);
	}
########



if ($q->param('fct') eq "get_top") { &get_top; }
if ($q->param('fct') eq "dobuild") { &dobuild; }

if ($q->param('fct') eq "telnb") 
	{
	print "Content-type: text/plain\n\n";
	acs::check_access($username, $password, $q->param('username'), $q->param('password')); 
	&generate_files;
	}
	elsif ($q->param('fct') eq "web")
	{
	print "Content-type: text/html\n\n";
	acs::check_access($username, $password, $q->param('username'), $q->param('password')); 
	&web_build;
	}
	elsif ($q->param('fct') eq "part_build")
	{
	&part_build;
	}
	elsif ($q->param('fct') eq "")
	{
	&generate_files;
	}

####################################################################################

sub part_build
{

print "Content-type: text/html\n\n";

$catid = $q->param('cid');

($nrfiles, $tcats) = &create_temp_files($catid);

$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=0&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";

#$header = &get_header($strlnk, 0);
#$hbox = acs::get_heading_box("$web_url/ic_dirm.gif", "Preparing to Start Building....", qq[$nrfiles read/swap files created.]);
#print $header . $hbox;
#print "</font></body></html>";
	
open (BLT, "> $data_dir/build.dat") or die "Cannot open $data_dir/build.dat : $!";
close (BLT);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
</head>
<frameset framespacing="0" border="false" rows="96,*" frameborder="0">
  <frame name="header" scrolling="no" noresize target="main" src="$admin_url/generate.cgi?fct=get_top">
  <frame name="main" src="$strlnk">
  <noframes>
  <body>
  <p>This page uses frames, but your browser doesn't support them.</p>
  </body>
  </noframes>
</frameset>
</html>
];



}



sub dobuild_finish
{

### DELETE TMP FILES

opendir(DIR,"$data_dir") or die "Cannot open $data_dir : $!";
@files = readdir(DIR);
	foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 4, 4) eq ".tmp")
		{
		unlink ("$data_dir/$filename");
		}
	}
closedir (DIR);

$rfile = htbuild::get_file_contents2("$data_dir/build.dat");
$rfile =~ s/<br>//g;
$rfile =~ s/<b>//g;
$rfile =~ s/<\/b>//g;

@fitems = split (/\n/, $rfile);

$pages = 0;
$cats = 0;
foreach $fnm (@fitems)
	{
	$br = "";
	if ($fnm !~ /====/) {$br = "<br>"; $cats++;}
	
	$blnk = "$web_url" . $fnm;
	$blnk =~ s/ //g; $blnk =~ s/=//g; $blnk =~ s/>//g;
	$buildl = $buildl . "$br <a href=\"$blnk\" target=\"_blank\">$fnm</a> <Br>";
	$pages++;
	}


$hbox = acs::get_heading_box("$web_url/ic_dirm.gif", "HTML Generation completed.", qq[$pages Category Pages Built<br>$cats Directories/Categories Built <br>$buildl]);



print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
<script LANGUAGE="JavaScript">
		parent.frames['header'].document.getElementById('working').innerHTML = '';
		parent.frames['header'].document.getElementById('working2').innerHTML = '';
</script> 
$hbox
</body>
</html>
];


}






sub dobuild
{

### fn = current filename
### fpos = file position number
### tfn = total files

print "Content-type: text/html\n\n";

if ($q->param('fn') eq "") ### CREATE SWAP FILES FOR GENERATION
	{
			$innerh = "<img src=\"$web_url/working.gif\">";
			
			print qq[
			<script LANGUAGE="JavaScript">
						parent.frames['header'].document.getElementById('working').innerHTML = '$innerh';
			</script> 
			];

			## $tcat = number of categories
			## $nrfiles = number of swap files

			($nrfiles, $tcats) = &create_temp_files;
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=total&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);

			$hbox = acs::get_heading_box("$web_url/ic_dirm.gif", "Preparing to Start Building....", qq[$nrfiles read/swap files created.]);

			print $header . $hbox;
			print "</body></html>";

			open (BLT, "> $data_dir/build.dat") or die "Cannot open $data_dir/build.dat : $!";
			close (BLT);
	}
	elsif ($q->param('fn') eq "total") ### GENERATE TOTAL LINK INCLUDE 
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";

			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');

			#$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=new&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=expire&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);

			&start_gen("Writing Total Link Include....");
				&compile_total_link_include;
			&end_gen;

			print $header;

			print "</body></html>";
	
	}

	elsif ($q->param('fn') eq "expire") ### EXPIRE LINKS IF IT NEEDS TO EXPIRE
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";

			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');

			#$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=new&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=fpgen1&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);

			&start_gen("Checking if links needs to be expired....");
				print "Checking...";
				acs::expire_links;
			&end_gen;

			print $header;

			print "</body></html>";
	}
	elsif ($q->param('fn') eq "fpgen1") ### GENERATE FRONT PAGE 1 of 4
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";

			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');

			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=fpgen2&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 1);

			&start_gen("Updating Front Page");
				&compile_fp1;
			&end_gen;

			print $header;

			print "</body></html>";
	}
	elsif ($q->param('fn') eq "fpgen2") ### GENERATE FRONT PAGE 2 of 4
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";

			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');

			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=fpgen3&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 1);

			&start_gen("Updating Front Page");
				&compile_fp2;
			&end_gen;

			print $header;

			print "</body></html>";
	}
	elsif ($q->param('fn') eq "fpgen3") ### GENERATE FRONT PAGE 3 of 4
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";

			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');

			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=fpgen4&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 1);

			&start_gen("Updating Front Page");
				&compile_fp3;
			&end_gen;

			print $header;

			print "</body></html>";
	}
	elsif ($q->param('fn') eq "fpgen4") ### GENERATE FRONT PAGE 4 of 4
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";

			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');

			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=new&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 1);

			&start_gen("Updating Front Page");
				&compile_fp4;
			&end_gen;

			print $header;

			print "</body></html>";
	}
	elsif ($q->param('fn') eq "new") ### GENERATE WHAT'S NEW FILES
	{

			#print "<img src=\"$web_url/working.gif\"><BR><BR>";
			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=pop&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);

			print $header;

			&start_gen("Please Wait...");
			&build_whats_new("web");
			&end_gen;

			print "</body></html>";
	
	}
	elsif ($q->param('fn') eq "pop") ### GENERATE POPULAR LINKS
	{

			#print "<img src=\"$web_url/working.gif\"><BR><BR>";
			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=popnew_includes&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);
			print $header;

				&start_gen("Please Wait...");
				&build_top_hits("web");
				&end_gen;

			print "</body></html>";
	
	}
	elsif ($q->param('fn') eq "popnew_includes") ### GENERATE POPULAR AND NEW LINK INCLUDES
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";
			$wbuild = "web";
			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=keyword_includes&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);

			print $header;

			&start_gen("Generating/Updating Popular & New Link Includes if any. Please Wait...");
			&build_popnew_includes;
			&end_gen;

			print "</body></html>";
	}
	elsif ($q->param('fn') eq "keyword_includes") ### GENERATE KEYWORD INCLUDES
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";
			$wbuild = "web";
			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=category_includes&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);

			print $header;

			&start_gen("Generating/Updating Keyword Includes if any. Please Wait...");
			&build_keyword_includes;
			&end_gen;

			print "</body></html>";
	}
	elsif ($q->param('fn') eq "category_includes") ### GENERATE CATEGORY INCLUDES
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";
			$wbuild = "web";
			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=gsmap&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);


			print $header;
			&start_gen("Generating/Updating Category Includes if any. Please Wait...");
			&build_category_includes;
			&end_gen;
			print "</body></html>";
	}
	elsif ($q->param('fn') eq "gsmap") ### GENERATE GOOGLE SITEMAP FILE
	{
			#print "<img src=\"$web_url/working.gif\"><BR><BR>";
			$wbuild = "web";
			$nrfiles = $q->param('tfn');
			$tcats = $q->param('tcats');
			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=0&fpos=0&tfn=$nrfiles&tcats=$tcats&pcnt=1";
			$header = &get_header($strlnk, 0);

			$sitemapfile = htbuild::get_file_contents2("$data_dir/sitemap.dat");
			
					print $header;
					&start_gen("Creating Google SiteMap File if any. Please Wait...");
					print "Working...";
					if ($sitemapfile ne "") { glsitemap::create_gsitemap; }
					&end_gen;
					print "</body></html>";
				
	}
	else ### GENERATE HTML FILES
	{
			$fn = $q->param('fn'); ### CURRENT CATEGORY
			$fpos = $q->param('fpos'); 
			$tfn = $q->param('tfn'); ### TOTAL CATEGORIES
			$tcats = $q->param('tcats');
			$pcnt = $q->param('pcnt');

			if ($fn > $tfn){&dobuild_finish; exit;} ### EXIT IF WE ARE AT THE LAST CATEGORY

			#print "<img src=\"$web_url/working.gif\"><BR><BR>";

			$fname = "$data_dir/" . ($fn + 1) . ".tmp";
			$rfile = htbuild::get_file_contents2($fname);
			@qlines = split (/\n/, $rfile);

			$fn_amount = $fpos + $wcats_per_build;

			$lcnt = 0;
			for ($ms5 = $fpos; $ms5 < $fn_amount; $ms5++)
				{
				if ($qlines[$ms5] ne "")
					{
					$sqlq = $sqlq . " (cid = '$qlines[$ms5]') or";
					}

				$lcnt = $ms5;
				$pcnt++;
				}
				$lcnt++;


			#print "$sqlq <br><Br>";
			if ($sqlq ne "") { $btext = &build_pages($sqlq);}


			if ($qlines[$lcnt] eq "")
					{
					### SWITCH TO A NEW TMP READ FILE
					$fn++;
					$fpos = 0;
					}
					else
					{
					### STAY WITH CURRENT FILE
					$fpos = $lcnt;
					}

			$strlnk = "$admin_url/generate.cgi?fct=dobuild&fn=$fn&fpos=$fpos&tfn=$tfn&tcats=$tcats&pcnt=$pcnt";
			$header = &get_header($strlnk);

			if ($pcnt > $tcats) { $pcnt = $tcats; }

			if ($tcats > 0)
				{
				$perc = $pcnt / $tcats * 100;
				$perc = sprintf("%5.0f",$perc);
				}
				else
				{
				$perc = 1;
				}

			########
			open (BLT, ">> $data_dir/build.dat")  or die "Cannot open $data_dir/build.dat : $!";
				print BLT $btext;
			close (BLT);

			if ($btext ne "") { $btext2 = "Directories/Categories Built:<br>"; }

			print $header;

			#&start_gen("Generating Files. Pleas Wait...");
			#print "$perc% Complete";
			#&end_gen;
			
			### Progress bar
			print qq[
			<script LANGUAGE="JavaScript">
			parent.frames['header'].document.getElementById('working').innerHTML = '<img src=\"$web_url/working.gif\">';
			parent.frames['header'].document.getElementById('working2').innerHTML = '<img src=\"$web_url/122.gif\">';
			</script> 
			
			<table width="100%" border="0" cellpadding="3" cellspacing="1" bgcolor="#E1E1E1">
			  <tr>
				 <td width="1%" align="center" bgcolor="#FFFFFF"><img src="$web_url/ajload.gif" width="24" height="24" /></td>
				 <td width="99%" height="25" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Generating Files. Pleas Wait... </strong></td>
			  </tr>
			  <tr>
				 <td height="25" colspan="2" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="0" cellspacing="0" >
					  <tr>
						 <td colspan="2" align="center" class="normaltext"><strong>$perc% Complete</strong></td>
						 <td width="80%" ><table width="$perc%" border="0" cellpadding="1" cellspacing="1">
							  <tr>
								 <td background="$web_url/progress.gif" height="25"></td>
							  </tr>
							</table></td>
					  </tr>
					</table></td>
			  </tr>
			</table>
			<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
			  <tr>
				 <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
				 <td width="99%"></td>
			  </tr>
			</table>
		];


	if (($btext ne "") and ($btext2 ne ""))
		{
		print qq[<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
		 <tr>
		  <td width="99%" valign="top" bgcolor="#FFFFFF">
			<table width="100%" border="0" cellpadding="6">
			 <tr>
			  <td background="$web_url/bar6.gif"><strong class="normaltext">$btext2</strong></td>
				</tr>
				<tr>
				  <td class="normaltext">$btext</td>
				</tr>
			 </table>    </td>
		  </tr>
		</table>
		<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
		  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
		</table>];
		}


			#<font face=\"Verdana\" size=\"1\">Building.... <strong>Please wait...</strong><br><br>";
			#print "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" bgcolor=\"#FFE135\"><tr><td width=\"16%\"><font face=\"Verdana\" size=\"1\"><b>$perc% Complete</b></font></td>";
			#print "<td width=\"84%\"><hr size=\"10\" color=\"#8080C0\" width=\"$perc%\" align=\"left\"></td></tr></table><br>$btext2 $btext</font></body></html>";

			#print "$strlnk <br>";
			#print "fn = $fn <br>";
			#print "fpos = $fpos <br>";
			#print "tfn = $tfn <br>";
	}


}



sub build_keyword_includes
{

$searchmeth = $gsettings->{searchmeth};

if ($searchmeth eq "pseek")
	{
	$searche_script = "$script_url/search.cgi";
	}
	else
	{
	$searche_script = "$script_url/search2.cgi";
	}

########### GET KEYWORD INCLUDES

$incls = acs::get_file_contents("$data_dir/kwincludes.dat"); 
@all_inc = split (/\n/, $incls);

$i_highnumber = 0;
foreach $item (@all_inc)
	{
	($ii_name, $ii_nr) = split (/\t/, $item);
	if ($ii_nr > $i_highnumber) { $i_highnumber = $ii_nr; }
	}


if ($i_highnumber > 0)
{

	########### FETCH KEYWORDS

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 
	
	$sql = "SELECT keyword, COUNT(*) AS val FROM keywlog 
	GROUP BY keyword ORDER BY val DESC LIMIT $i_highnumber";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	
	$ret_incl = "";
	$tmplname = "kwinc_" . $q->param('iname') . ".html";
	$incls2 = acs::get_file_contents("$data_dir/$tmplname"); 
	
	while ( @row = $sth->fetchrow() )
		{
		$tmp = push(@ARkeywords, $row[0] . "\t" . $row[1]);
		}

	$sth->finish;
	$dbh->disconnect;
	
	############ WRITE INCLUDE FILES
	
	foreach $kitem (@all_inc)
		{
		($ii_name, $ii_nr) = split (/\t/, $kitem);
		
			$tmplname = "kwinc_" . $ii_name . ".html";
			$incls2 = acs::get_file_contents("$data_dir/$tmplname"); 
			$include_to_write = "";
			
			for ($ms2 = 0; $ms2 < $ii_nr; $ms2++)
				{
				$kwtmp = $ARkeywords[$ms2];
				($realkw, $realkwnr) = split (/\t/, $kwtmp);
				
				$tmp_realkw = $realkw; $tmp_realkw =~ s/ /+/gi;
				$searche_script2 = $searche_script . "?keywords=$tmp_realkw";
				
				$tmplincl = $incls2;
				$tmplincl =~ s/!!keyword!!/$realkw/gi;
				$tmplincl =~ s/!!keyword_link!!/$searche_script2/gi;
				$tmplincl =~ s/!!nr!!/$realkwnr/gi;
				$include_to_write = $include_to_write . "$tmplincl";
				}
			
			if ($include_to_write ne "") ### WRITE INCLUDE
				{
				$include_to_write =~ s/\n/ /g;
				$ccrit = chr(10); $include_to_write =~ s/$ccrit/ /g;
				$ccrit = chr(13); $include_to_write =~ s/$ccrit/ /g;
				$include_to_write =~ s/'/\\'/g; 
				
				open (WDR, "> $web_dir/$ii_name.js");
					print WDR "function get_" . $ii_name . "()\n";
					print WDR "{\n";
					print WDR "document.write ('" . $include_to_write . "');\n";
					print WDR "}\n";
				close (WDR);
				
				chmod($default_permissions,"$web_dir/$ii_name.js");
				
					if ($wbuild eq "web")
						{
						print "<b>Written:</b> $web_dir/$ii_name.js<br>";
						}
						else
						{
						if (($gsettings->{verbose_silent} eq "Verbose")or ($q->param('fct') eq "telnb"))
								{
								print "Written: $web_dir/$ii_name.js\n\n";
								}
						}

				
				}
		}
	
		
} ### END OF HIGHNUMBER


}



sub get_top
{
$time = time();
$date = acs::decode_date($time);

open (TBUILD, "> $data_dir/gentime.dat")  or die "Cannot open $data_dir/gentime.dat : $!";
	print TBUILD $date;
close (TBUILD);

print "Content-type: text/html\n\n";
print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
<table border="0" cellpadding="0" cellspacing="3" width="100%" class="aborder">
  <tr>
    <td width="1%"><img src="$web_url/psgen.jpg"></td>
    <td width="49%"><span id="working"><img src="$web_url/working.gif"></span></td>
    <td width="50%" align="right" valign="top">
    		<table width="100%%" cellspacing="1" cellpadding="3"><tr><td height="3"></td></tr></table>
    		<span id="working2"></span></td>
  </tr>
</table>
</body>
</html>
];

}





sub web_build
{


if ((-e "$data_dir/changed_rec.dat") > 0) { $stat = unlink ("$data_dir/changed_rec.dat"); }
if ((-e "$data_dir/changed_all.dat") > 0) { $stat = unlink ("$data_dir/changed_all.dat"); }
if ((-e "$data_dir/changed_lnks.dat") > 0) { $stat = unlink ("$data_dir/changed_lnks.dat"); }
if ((-e "$data_dir/changed_part.dat") > 0) { $stat = unlink ("$data_dir/changed_part.dat"); }
if ((-e "$data_dir/changed_whole.dat") > 0) { $stat = unlink ("$data_dir/changed_whole.dat"); }
if ((-e "$data_dir/changed_cats.dat") > 0) { $stat = unlink ("$data_dir/changed_cats.dat"); }


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
</head>
<frameset framespacing="0" border="false" rows="85,*" frameborder="0">
  <frame name="header" scrolling="no" noresize target="main" src="$admin_url/generate.cgi?fct=get_top">
  <frame name="main" src="$admin_url/generate.cgi?fct=dobuild">
  <noframes>
  <body>
  <p>This page uses frames, but your browser doesn't support them.</p>
  </body>
  </noframes>
</frameset>
</html>
];

}






sub generate_files
{

if ($q->param('fct') eq "telnb") { $ARGV[0] = "777"; $ARGV[1] = "no_delete"; }

if (((lc($ARGV[0]) eq "755") or (lc($ARGV[0]) eq "")) and ((lc($ARGV[1]) ne "delete") and (lc($ARGV[1]) ne "no_delete")))
	{
	
	if (lc($ARGV[0]) !~ /cid=/)
		{
		print "\n====================================================================== \n";
		print "Clean up old files and directories that was previously generated? \n";
		print "All sub directories with it's contents in \n";
		print "$web_dir will be deleted! \n";
		print "PLEASE USE WITH CAUTION!!! \n";
		print "Must I remove the previously generated files & directories? (Y/N): ";
		}
	
	$answer1 = <STDIN>;
	$answer1 =~ s/\n//g;
	
	}
	else
	{
	
	if (lc($ARGV[0]) eq "delete")
		{
		$answer1 = "y";
		}
		elsif (lc($ARGV[0]) eq "no_delete")
		{
		$answer1 = "";
		}
		elsif (lc($ARGV[1]) eq "delete")
		{
		$answer1 = "y";
		}
		elsif (lc($ARGV[1]) eq "no_delete")
		{
		$answer1 = "";
		}	
		elsif (lc($ARGV[0]) =~ /cid=/)
		{
		$answer1 = "cid";
		}
	}


### REMOVE PREVIOUSLY GENERATED FILES
if (lc($answer1) eq "y")
{

@build_dirs = &get_total_dirs($web_dir);


if ($gsettings->{verbose_silent} eq "Verbose")
	{
	print "\nRemoving Files...\n";
	}


foreach $direc (@build_dirs)
	{

	if (($direc ne "$web_dir") and ($direc !~ "$web_dir/templates") and ($direc !~ "$web_dir/edt") and ($direc !~ "$web_dir/imagefiles"))
	 {
	 opendir(DDR,"$direc")  or die "Cannot open $direc : $!";
			@bdfiles = readdir(DDR);
			foreach $delfile (@bdfiles)
				{
				if (($delfile ne ".") and ($delfile ne ".."))
					{unlink ("$direc/$delfile");}
				}
	 close (DDR);
	 }
	
	}


if ($gsettings->{verbose_silent} eq "Verbose")
	{
	print "\nRemoving Directories...\n\n";
	}


foreach $direc (@build_dirs)
	{
	if (($direc ne "$build_dir") and ($direc ne "$web_dir/templates") and ($direc ne "$web_dir/edt"))
	   {
	   $stat = rmdir($direc);
	   }
	}

}


#### REPAIR TABLES

if ($repair_tables eq "Y")
{

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{print "Checking & Repairing 'Links' Table.. Please wait... \n";}
	$sql = "REPAIR TABLE links";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}


	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{print "Checking & Repairing 'Dirs' Table.. Please wait... \n";}
	$sql = "REPAIR TABLE dirs";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}


	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{print "Checking & Repairing 'balogs' Table.. Please wait... \n";}
	$sql = "REPAIR TABLE balogs";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}

	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{print "Checking & Repairing 'bannergrp' Table.. Please wait... \n";}
	$sql = "REPAIR TABLE bannergrp";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}

	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{print "Checking & Repairing 'banners' Table.. Please wait... \n";}
	$sql = "REPAIR TABLE banners";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}

	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{print "Checking & Repairing 'keywlog' Table.. Please wait... \n";}
	$sql = "REPAIR TABLE keywlog";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}

	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{print "Checking & Repairing 'reviews' Table.. Please wait... \n";}
	$sql = "REPAIR TABLE reviews";
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}

	$sth->finish;
	$dbh->disconnect;
}




#### RECOUNT LINKS

if ($do_recount eq "Y")
	{
	
		if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		$dbh = DBI->connect($dsn, $db_username, $db_password);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

		if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		$dbh2 = DBI->connect($dsn, $db_username, $db_password);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

		###### RECOUNT REVIEWS

		$sql = "UPDATE links SET rev_no = '0' WHERE rev_no > 0";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

		######

		$sql = "SELECT * FROM reviews ORDER BY lnkid";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

		$rvcnt = (0 - 1);

		while ( @row = $sth->fetchrow() )
		{

		if ($current_rv ne $row[2])
			{
			$rvcnt++;	
			$all_revs[$rvcnt] = "$row[2]" . "\t" . "1";
			$current_rv = $row[2];
			}
			else
			{
			($lid, $rvn) = split (/\t/, $all_revs[$rvcnt]);

			#print "$lid, $rvn\n";

			$rvn++;
			$all_revs[$rvcnt] = $lid . "\t" . $rvn;
			}
		}


		$sql = qq{UPDATE links SET rev_no = ? 
					 WHERE lnkid = ?};

		$sth = $dbh->prepare($sql);
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

		foreach $item (@all_revs)
			{
			($lid, $rvn) = split (/\t/, $item);
			#print "==> $lid - $rvn \n";
			$sth->bind_param(1, $rvn); 
			$sth->bind_param(2, $lid); 
		   $sth->execute;
			$serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
			}

		########### RECOUNT LINKS

		$sel_dirs = "SELECT cid FROM dirs";
		$sth = $dbh->prepare($sel_dirs);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

			while ( @row = $sth->fetchrow() )
			{
			$current_cid = $row[0];

			$cat_link_numbers_sql = "SELECT COUNT(*) FROM links WHERE cid = '$current_cid'";
			$sth2 = $dbh2->prepare($cat_link_numbers_sql);
			if ( !defined $dbh2 ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sel_dirs"; }
			$sth2->execute;
			$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

			while ( @row2 = $sth2->fetchrow() ){$linknr = $row2[0];}
			
			if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
				{
				print "==> Counting.. Please wait.. Found $linknr links in CATID: $current_cid\n";
				}

			$update_sql = "UPDATE dirs SET ext1 = '$linknr' WHERE cid = '$current_cid'";
			$sth2 = $dbh2->prepare($update_sql);
			$sth2->execute;
			$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 
			}


		##################

		if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
			{
			print "Preparing to update link numbers... \n\n";
			}


		$sel_dirs = "SELECT * FROM dirs";
		$sth = $dbh->prepare($sel_dirs);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

			while ( @row = $sth->fetchrow() )
			{
			$sql = ""; $dirname = "";
				for ($ms = 2; $ms < 18; $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$dirname = $dirname . "/$row[$ms]";

					$row[$ms] =~ s/'/\\'/g;
					$level = "l" . ($ms - 1);
					$sql = $sql . " ($level = '$row[$ms]') AND";
					}
				}
				$sql = substr($sql, 0, length($sql) - 3);

			#### GET TOTALS

		if ($sql ne "")
		{

			$get_totals_sql = "SELECT ext1 FROM dirs WHERE $sql";
			$sth2 = $dbh2->prepare($get_totals_sql);
			$sth2->execute;
			#$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

					$total_dir_links = 0;
					while ( @row2 = $sth2->fetchrow() )
					{
					$total_dir_links = $total_dir_links + $row2[0];
					}

		}

			#### UPDATE LINK NUMBERS
			
			if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
				{
				print "Updating $dirname - $total_dir_links links\n";
				}

			$update_totals_sql = "UPDATE dirs SET linknrs = '$total_dir_links' WHERE cid = '$row[0]'";

			#print "==> $update_totals_sql \n\n";

			$sth2 = $dbh2->prepare($update_totals_sql);
			$sth2->execute;
			$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

			}


		$sth->finish;
		$dbh->disconnect;

		$sth2->finish;
		$dbh2->disconnect;
	}


### EXPIRE LINKS IF REQUIRED

acs::expire_links;


### GENERATE GOOGLE SITEMAP FILE IF REQUIRED

$sitemapfile = htbuild::get_file_contents2("$data_dir/sitemap.dat");
glsitemap::create_gsitemap;


#### GENERATE FILES

if ($answer1 ne "cid")
	{

	&compile_total_link_include; 
	if ($wait_includes > 0){ sleep ($wait_includes); }

	&build_whats_new(); 
	if ($wait_includes > 0){ sleep ($wait_includes); }

	&build_top_hits();
	if ($wait_includes > 0){ sleep ($wait_includes); }

	&build_popnew_includes();
	if ($wait_includes > 0){ sleep ($wait_includes); }

	&build_keyword_includes();
	if ($wait_includes > 0){ sleep ($wait_includes); }

	&build_category_includes();
	if ($wait_includes > 0){ sleep ($wait_includes); }
	
	}



if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{
	print "Removing temporary read/swap files if found... \n";
	}


if ($answer1 ne "cid")
	{
	&create_temp_files;
	}
	else
	{
	($tmpv, $rcid) = split(/=/,$ARGV[0]);

			if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
			{
			print "Partially Building Category ID: $rcid\n";
			}
	
	&create_temp_files($rcid);
	}

#### BUILD 50 CATEGORIES AT A TIME
#print "\n\n\n\n ---> $filecnt \n\n";
#$filecnt = 1;


for ($ms2 = 1; $ms2 < ($filecnt + 1); $ms2++)
	{
	#print "\nProcessing: $data_dir/$ms2.tmp\n";
	#print "==============================\n";

	$swap_readf = htbuild::get_file_contents2("$data_dir/$ms2.tmp");

	@swaprlines = split (/\n/, $swap_readf);

		$qcnt = 0;
		foreach $cat_id (@swaprlines)
			{
			
			if ($qcnt < $cats_per_build)
				{
				$sqlq = $sqlq . " (cid = '$cat_id') or";
				}
				else
				{
				#if ($wait_telnet != 0) {sleep ($wait_telnet);}
				$sqlq = $sqlq . " (cid = '$cat_id') or";
				&build_pages($sqlq);
				#print "---> $sqlq \n\n\n\n";
				$qcnt = 0;
				$sqlq = "";
				}

			$qcnt++;
			}
	}

if ($sqlq ne "") { &build_pages($sqlq);}

#print "$gnrx Real Categories\n";


### DELETE TMP FILES

	opendir(DIR,"$data_dir")  or die "Cannot open $data_dir : $!";
	@files = readdir(DIR);
		foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 4, 4) eq ".tmp")
			{
			unlink ("$data_dir/$filename");
			}
		}
	closedir (DIR);

####################

$time = time();
$date = acs::decode_date($time);

open (TBUILD, "> $data_dir/gentime.dat")  or die "Cannot open $data_dir/gentime.dat : $!";
	print TBUILD $date;
close (TBUILD);


if ((-e "$data_dir/changed_rec.dat") > 0) { $stat = unlink ("$data_dir/changed_rec.dat"); }
if ((-e "$data_dir/changed_all.dat") > 0) { $stat = unlink ("$data_dir/changed_all.dat"); }
if ((-e "$data_dir/changed_lnks.dat") > 0) { $stat = unlink ("$data_dir/changed_lnks.dat"); }
if ((-e "$data_dir/changed_part.dat") > 0) { $stat = unlink ("$data_dir/changed_part.dat"); }
if ((-e "$data_dir/changed_whole.dat") > 0) { $stat = unlink ("$data_dir/changed_whole.dat"); }
if ((-e "$data_dir/changed_cats.dat") > 0) { $stat = unlink ("$data_dir/changed_cats.dat"); }


if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{
	print "$telnet_categories_built categories built\n";
	print "$telnet_pages_build pages built\n";
	}


}






sub build_pages
{
my ($cid_sql) = @_;

$cid_sql = substr($cid_sql, 0, length($cid_sql) - 2);
$cid_sql = "SELECT * FROM dirs WHERE $cid_sql";

#####

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$sth = $dbh->prepare($cid_sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}
$links_sel = $sth->rows();

$acnt = 0; @atree = ("");

while ( @row = $sth->fetchrow() )
	{

	if ($row[2] ne "")  {$dec_string = $row[2]; $row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];}
	if ($row[3] ne "")  {$dec_string = $dec_string . ":_:$row[3]"; $row[3] = acs::encode_dir($row[3]); $dirstring = $dirstring . "-$row[3]";}
	if ($row[4] ne "")  {$dec_string = $dec_string . ":_:$row[4]"; $row[4] = acs::encode_dir($row[4]); $dirstring = $dirstring . "-$row[4]";}
	if ($row[5] ne "")  {$dec_string = $dec_string . ":_:$row[5]"; $row[5] = acs::encode_dir($row[5]); $dirstring = $dirstring . "-$row[5]";}
	if ($row[6] ne "")  {$dec_string = $dec_string . ":_:$row[6]"; $row[6] = acs::encode_dir($row[6]); $dirstring = $dirstring . "-$row[6]";}
	if ($row[7] ne "")  {$dec_string = $dec_string . ":_:$row[7]"; $row[7] = acs::encode_dir($row[7]); $dirstring = $dirstring . "-$row[7]";}
	if ($row[8] ne "")  {$dec_string = $dec_string . ":_:$row[8]"; $row[8] = acs::encode_dir($row[8]); $dirstring = $dirstring . "-$row[8]";}
	if ($row[9] ne "")  {$dec_string = $dec_string . ":_:$row[9]"; $row[9] = acs::encode_dir($row[9]); $dirstring = $dirstring . "-$row[9]";}
	if ($row[10] ne "") {$dec_string = $dec_string . ":_:$row[10]"; $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring . "-$row[10]";}
	if ($row[11] ne "") {$dec_string = $dec_string . ":_:$row[11]"; $row[11] = acs::encode_dir($row[11]); $dirstring = $dirstring . "-$row[11]";}
	if ($row[12] ne "") {$dec_string = $dec_string . ":_:$row[12]"; $row[12] = acs::encode_dir($row[12]); $dirstring = $dirstring . "-$row[12]";}
	if ($row[13] ne "") {$dec_string = $dec_string . ":_:$row[13]"; $row[13] = acs::encode_dir($row[13]); $dirstring = $dirstring . "-$row[13]";}
	if ($row[14] ne "") {$dec_string = $dec_string . ":_:$row[14]"; $row[14] = acs::encode_dir($row[14]); $dirstring = $dirstring . "-$row[14]";}
	if ($row[15] ne "") {$dec_string = $dec_string . ":_:$row[15]"; $row[15] = acs::encode_dir($row[15]); $dirstring = $dirstring . "-$row[15]";}
	if ($row[16] ne "") {$dec_string = $dec_string . ":_:$row[16]"; $row[16] = acs::encode_dir($row[16]); $dirstring = $dirstring . "-$row[16]";}
	if ($row[17] ne "") {$dec_string = $dec_string . ":_:$row[17]"; $row[17] = acs::encode_dir($row[17]); $dirstring = $dirstring . "-$row[17]";}

	$atree[$acnt] = $dirstring . 	"\t" . 	#### FULL PATH
						 $row[0] . 		"\t" . 	#### CID
						 $row[1] . 		"\t" .  	#### LEVEL
						 $row[28] .    "\t" .  	#### NAME
						 $dec_string;
	$acnt++;
	}

$sth->finish;
$dbh->disconnect;





#### BUILD HTML PAGES

@atree = sort(@atree);

$pages_build = 0;

foreach $item (@atree)
	{
	($dirstr, $cid, $level, $tmp_name, $dec_str) = split (/\t/, $item);

			
			
		### GET MORE PAGES NAME

		if ($gsettings->{category_page_names} eq "categorynames")
			{
				$dir_name = "";
				$tmp_name = lc($tmp_name);
				$tmp_name =~ s/ /_/gi;
				for ($ms = 0; $ms < length($tmp_name); $ms++) 
				{
				$oneletter = substr($tmp_name, $ms, 1);
				if (($oneletter =~ /[0-9a-zA-Z]/) or ($oneletter eq "_"))
					{
					$dir_name = $dir_name . $oneletter;
					}
				}
			}
			else
			{
			$dir_name = "more";
			}


	$dirstr_path = $dirstr;
	$dirstr_path =~ s/-/\//g;
	
	if ((-e "$web_dir/$dirstr_path") < 1)
		{
		mkdir ("$web_dir/$dirstr_path", $default_permissions);
		chmod($default_permissions,"$web_dir/$dirstr_path");
		}
	
	
	
	($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat($dirstr, $level, "STATIC");
	$gen_default_index = $gsettings->{gen_default_index};
	

	
	### GET CID's (FOR SUB LEVELS) OF CATEGORIES FOR $dirstr INCLUDING $dirstr

	if ($q->param('fct') ne "dobuild")
		{
			if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
				{
				print "Writing: /$dirstr_path/$gen_default_index\n";
				}
		if ($wait_telnet > 0){ sleep ($wait_telnet); }
		#print "--> $wait_telnet \n";
		}
		else
		{
		$rtext = $rtext . "<b>/$dirstr_path/$gen_default_index</b><br>\n";
		}
	
	#print "--> $web_dir/$dirstr_path/$gen_default_index <BR>";
	
	open (NEWP, "> $web_dir/$dirstr_path/$gen_default_index") or die "Cannot write $web_dir/$dirstr_path/$gen_default_index : $! - Likely related to file/directory permissions";
		print NEWP $newpage;
	close (NEWP);
	chmod($default_permissions,"$web_dir/$dirstr_path/$gen_default_index");

	$pages_build++;
	$telnet_pages_build++;
	$telnet_categories_built++;

	if ($cpages > 1) ### BUILD 'MORE' PAGES
		{
		for ($ms1 = 2; $ms1 < ($cpages + 1); $ms1++)
			{
			$stw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1));
			$ndw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1)) + $gsettings->{nrlinks_per_page};
			
			($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat($dirstr, $level, "STATIC", $stw, $ndw, "", "", $dir_name);
			$gen_default_index = $gsettings->{gen_default_index};
			
					#$fname = "$web_dir/$dirstr_path/more" . "$ms1" . $gsettings->{gen_file_ext};
					#$cfname = "/$dirstr_path/more" . "$ms1" . $gsettings->{gen_file_ext};

					$fname = "$web_dir/$dirstr_path/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};
					$cfname = "/$dirstr_path/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};

					
					if ($q->param('fct') ne "dobuild")
						{
							if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
									{
									print "    =====> $cfname\n";
									}
						if ($wait_telnet > 0){ sleep ($wait_telnet); }
						}
						else
						{
						$rtext = $rtext . "====> $cfname<br>\n";
						}
					
					
					open (NEWP2, "> $fname")  or die "Cannot open $fname : $! - Likely related to file/directory permissions";
						print NEWP2 $newpage;
					close (NEWP2);
					chmod($default_permissions,$fname);
					
					
			$pages_build++;
			$telnet_pages_build++;
			}

		}
	
	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
			{
			print "\n";
			}
	}

return ($rtext);

#print "BUILD COMPLETED. PAGES BUILT: $pages_build";
}










sub create_temp_files
{

my ($cid_tobuild) = @_;

### DELETE TMP FILES

	opendir(DIR,"$data_dir")  or die "Cannot open $data_dir : $!";
	@files = readdir(DIR);
		foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 4, 4) eq ".tmp")
			{
			unlink ("$data_dir/$filename");
			}
		}
	closedir (DIR);


### CREATE READ/SWAP FILES

if ($q->param('fct') eq "") 
		{
		if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
				{
				print "Preparing Build... Please Wait...";
				}
		}

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($cid_tobuild eq "")
	{
	$wsql = "SELECT cid, level, crosslinkid FROM dirs ORDER BY level ASC";
	$sth = $dbh->prepare($wsql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	}
	else
	{
	$sql_lev = "SELECT l1,l2,l3,l4,l5,l6,l7,l8,l9,l10,l11,l12,l13,l14,l15,l16 FROM dirs WHERE (cid = '$cid_tobuild')"; 
	$sth = $dbh->prepare($sql_lev);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
		while ( @row = $sth->fetchrow() )
		{
		
			for ($ms = 0; $ms < 16; $ms++) 
				{

					if ($row[$ms] ne "")
					{
					$cat_str = $row[$ms]; $cat_str =~ s/'/\\'/g;
					$csql_q = $csql_q . "(l" . ($ms + 1) . " = '$cat_str') AND ";
					
					$encoded_dir = acs::encode_dir($row[$ms]);
					
					$dir_to_create = $dir_to_create . "$encoded_dir";
					
						### CREATE DIR STRUCTURE IF NOT ALREADY EXIST
						if ((-e "$web_dir/$dir_to_create") < 1)
							{
							mkdir ("$web_dir/$dir_to_create", $default_permissions);
							chmod($default_permissions,"$web_dir/$dir_to_create");
							}
						
					$dir_to_create = $dir_to_create . "/";

					}
				} 
		
		}
		
		$csql_q = substr($csql_q, 0, length($csql_q) - 4);
	
		### GET CATEGORIES TO BUILD
		$wsql = "SELECT cid, level, crosslinkid FROM dirs WHERE $csql_q ORDER BY level ASC";
		$sth = $dbh->prepare($wsql);
		if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
		
	}

$sth->execute;
$rows = $sth->rows();
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

$acnt = 0;
$filecnt = 1;
while ( @row = $sth->fetchrow() )
	{
	
	if ($row[2] < 1)
	{
	
	if ($acnt == 0)
		{
		open (DTF, "> $data_dir/$filecnt.tmp")  or die "Cannot open $data_dir/$filecnt.tmp : $!";
				
				if ($q->param('fct') eq "") 
					{
						if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
							{
							print "Creating temporary read/swap file $filecnt $crt";
							}
					}
				
		print DTF $row[0] . "\n";
		$acnt++;
		}
		elsif (($acnt > 0) and ($acnt < $cats_per_file))
		{
			print DTF $row[0] . "\n";
		}
		elsif($acnt == $cats_per_file)
		{
			print DTF $row[0] . "\n";
			close(DTF);
			chmod(0777,"$data_dir/$filecnt.tmp");
			$acnt = 0;
			$filecnt++;
		}
	
	if ($acnt != 0) { $acnt++; }
	}
	
	}

close(DTF);
chmod(0777,"$data_dir/$filecnt.tmp");

####################################################

$sth->finish;
$dbh->disconnect;

return ($filecnt, $rows);

}




sub get_header
{

my ($flink, $wseconds) = @_;

if ($wseconds eq "")
	{
	$wseconds = $wait_web;
	}
	else
	{
	$wait_web = $wseconds;
	}

$ftop = qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>

<style type="text/css">
<!--

p {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
		
	
}
.normaltext {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
	
}

-->
</style>

$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
<meta HTTP-EQUIV="REFRESH" CONTENT="$wait_web;URL=$flink">
</head>
<body>
];

return ($ftop);

}



sub build_popnew_includes
{

#### BUILD POP & NEW INCLUDES IF ANY

 $pop_includes = htbuild::get_file_contents2("$data_dir/tmpl_inc.dat");
 @all_inc = split (/\n/, $pop_includes);
 
 foreach $item (@all_inc)
	{
	if ($item ne "")
	{
	($i_iname, $i_itype, $i_cid, $i_isort, $i_inumber, $i_prem) = split (/\t/, $item);
	
	$popcrit = $i_iname . ":" . $i_cid . ":" . $i_isort . ":" . $i_inumber . ":" . $i_itype . ":" . $i_prem;
			
	($linki, $pop_cpages, $pop_curpage, $pop_lnks_processed) = htbuild::get_cat("", "", "STATIC", "", "", "include", $popcrit);
		
		$linki =~ s/\n/ /g;
		$crit = chr(13); $linki =~ s/$crit/ /g;
		$crit = chr(10); $linki =~ s/$crit/ /g;
		$linki =~ s/'/\\'/g;
		
		open (LIF, "> $web_dir/$i_iname.js");
			print LIF "function get_$i_iname()\n";
			print LIF "{\n";
			print LIF "document.write ('" . $linki . "');\n";
			print LIF "}\n";
		close (LIF);
		chmod($default_permissions,"$web_dir/$i_iname.js");

	if ($wbuild eq "web")
		{
		print "<b>Written Link Include: $i_iname</b><br>";
		print "$web_dir/$i_iname.js<br>";
		}
		else
		{
		if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
				{
				print "Written Link Include: $i_iname\n";
				print "$web_dir/$i_iname.js\n\n";
				}
		}



	}
	}


}



sub build_top_hits
{
my ($wbuild) = @_;

$dfidx = $gsettings->{gen_default_index};

($top_hits, $pop_cpages, $pop_curpage, $pop_lnks_processed) = htbuild::get_cat("", "", "STATIC", "", "", "pop");

	if ((-e "$web_dir/pop") < 1)
		{
		mkdir ("$web_dir/pop", $default_permissions);
		chmod($default_permissions,"$web_dir/pop");
		}
			
	open (WNEW, "> $web_dir/pop/$dfidx") or die "Cannot open $web_dir/pop/$dfidx : $!";
		print WNEW $top_hits;
	close (WNEW);
	chmod($default_permissions,"$web_dir/pop/$dfidx");

if ($wbuild eq "web")
	{
	print "<b>Compiling 'Top Hits' Links'</b><br>";
	print "/pop/$dfidx<br>";
	}
	else
	{
	if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
			{
			print "Compiling 'Top Hits' Links'\n";
			print "/pop/$dfidx\n";
			}
	}

	for ($ms1 = 2; $ms1 < ($pop_cpages + 1); $ms1++)
		{
					
		$stw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1));
		$ndw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1)) + $gsettings->{nrlinks_per_page};
			
		($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat("", $level, "STATIC", $stw, $ndw, "pop");

				#$fname = "$web_dir/pop/more" . "$ms1" . $gsettings->{gen_file_ext};
				#$cfname = "/pop/more" . "$ms1" . $gsettings->{gen_file_ext};
				
				$fname = "$web_dir/pop/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};
				$cfname = "/pop/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};

				
				if ($wbuild eq "web")
					{
					print "    =====> $cfname<br>";
					}
					else
					{
						if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
							{
							print "    =====> $cfname\n";
							}
					}

			open (NEWP2, "> $fname")  or die "Cannot open $fname : $!";
				print NEWP2 $newpage;
			close (NEWP2);
			chmod($default_permissions,$fname);

			$pages_build++;
			$telnet_pages_build++;
			}

}






sub compile_total_link_include
{

#not templ incl
#java incl
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

#------ calc dirs
$dir_sql = "SELECT COUNT(*) FROM dirs";
$sth = $dbh->prepare($dir_sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ){$total_dirs = $row[0];}

#------ calc links

$link_sql = "SELECT COUNT(*) FROM links";
$sth = $dbh->prepare($link_sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ){$total_links = $row[0];}

$sth->finish;
$dbh->disconnect;

# get file & replace var
$style_template = acs::get_file_contents("$data_dir/total_link.html");
$style_template =~ s/!!links!!/$total_links/g;
$style_template =~ s/!!dirs!!/$total_dirs/g;
#print "templ: $style_template";

# GENERATE final java / html 'include file'
$jname = "total_link"; #was $q->param('jname');
$fullpath = "$web_dir/$jname" . ".js";
$urlpath = "$web_url/$jname" . ".js";


$head_script = qq[
<script SRC="$urlpath"></script>
];

$body_script = qq[
<script LANGUAGE="JavaScript" TYPE="text/javascript">
<!--
get_$jname();
// -->
</script>
];

$style_template =~ s/\n/ /g;
$crit = chr(10); $style_template =~ s/$crit/ /g;
$crit = chr(13); $style_template =~ s/$crit/ /g;
$style_template =~ s/'/\\'/g;
# write html incl file AND JAVASCRIPT INCLUDE FILE
open (J_file, "> $fullpath"); # || acs::problem_popup
#("Couldn't write to file $fullpath :$! - Please ensure that the file has the permission setting of 777");
	#print J_file $style_template; #write content: [!!links!! !!dirs!!] eg. $allcats=generated categories;
	print J_file "function get_$jname()\n";
	print J_file "{\n";
	print J_file "document.write ('" . $style_template . "');\n";
	print J_file "}\n";
close (J_file);
$stat = chmod($default_permissions,"$fullpath");


if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{
	print "\nCreating Total Link Include - $total_links Links / $total_dirs Categories\n\n";
	}


#############################################
### GENERATING FRONT PAGE

$time = time();
$date = acs::decode_date($time);

open (TBUILD, "> $data_dir/fpgentime.dat");
	print TBUILD $date;
close (TBUILD);
chmod(0777,"$data_dir/fpgentime.dat"); 

}





sub compile_fp4
{

### WRITE TEMPLATE FRONT PAGE

$allcats = psfp::generate_categories("fp_template.cfg");
$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;

$fpwrite_file = acs::get_file_contents("$data_dir/fpwrite.dat");
if (length($fpwrite_file) < 2)
	{
	$fpwrite_file = "$web_dir/fp.html";
	}

$fphtml = acs::get_file_contents("$data_dir/psfp.html");
$fphtml =~ s/!!categories!!/$allcats/gi;
$fphtml = acs::ts_insert_template_includes($fphtml); 
$fphtml = acs::fill_vars($fphtml); 

open (FPW, "> $fpwrite_file");
	print FPW $fphtml;
close (FPW);


if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{
	print "\nFront Page Template Method (4/4)\n\n";
	}

}





sub compile_fp3
{

### WRITE IFRAME

	$allcats = psfp::generate_categories("fp_iframe.cfg");
	$allcats =~ s/\n/ /g;
	$crit = chr(10); $allcats =~ s/$crit/ /g;
	$crit = chr(13); $allcats =~ s/$crit/ /g;

	open (IFRMP, "> $web_dir/iframe_pg.html") || acs::problem_popup("Could not write to file $web_dir/iframe_pg.html :$!");
		print IFRMP $allcats;
	close (IFRMP);

	
if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{
	print "\nIFRAME Method (3/4)\n\n";
	}	

}



sub compile_fp2
{


### WRITE SSI

$fpsettings1 = acs::get_file_contents("$data_dir/fp_ssi.cfg");
(@fp_settings1) = split (/\n/, $fpsettings1);

$allcats = psfp::generate_categories("fp_ssi.cfg");
$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;

	if ($fp_settings1[9] ne "")
	{
		open (IFILE, "> $fp_settings1[9]"); #|| acs::problem_popup("Could not write to file $fp_settings1[9] :$! - Ensure that the server path you are using exists. If the path exists and is correct then the script may not have permission to write to this directory. <b>If you are not familiar with SSI then it would be best to use the JavaScript Include method for your front page. <a href=\"$admin_url/admin26.cgi?fct=settings\">click here to change the path where the include file is written to.</a></b>");
		 print IFILE $allcats;
		close (IFILE);
		$stat = chmod($default_permissions,"$fp_settings1[9]");
	}

if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{
	print "\SSI Method (2/4)\n\n";
	}


}




sub compile_fp1
{

### WRITE JAVASCRIPT 

$fpsettings1 = acs::get_file_contents("$data_dir/fp_jscript.cfg");
(@fp_settings1) = split (/\n/, $fpsettings1);

$allcats = psfp::generate_categories("fp_jscript.cfg");
$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;
$allcats =~ s/'/\\'/g;

$script_to_write = qq[
	function get_categories()
	{
	document.write ('$allcats');
	}
];

$presc = qq[document.write('<script type="text/javascript" src="$web_url/categories2.js?' + (new Date()).getTime() + '"></script>');];

	open (SCRW, "> $web_dir/categories.js")  || acs::problem_popup("Could not write to file $web_dir/categories.js :$!");
		print SCRW $presc;
	close (SCRW);
	$stat = chmod($default_permissions,"$web_dir/categories.js");

	open (SCRW, "> $web_dir/categories2.js") || acs::problem_popup("Could not write to file $web_dir/categories2.js :$!");
		print SCRW $script_to_write;
	close (SCRW);
	$stat = chmod($default_permissions,"$web_dir/categories2.js");


if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
	{
	print "\nJavaScript Method (1/4)\n\n";
	}


}




sub build_whats_new
{
my ($wbuild) = @_;

$dfidx = $gsettings->{gen_default_index};

	($whats_new, $new_cpages, $new_curpage, $new_lnks_processed) = htbuild::get_cat("", "", "STATIC", "", "", "new");
	
	if ((-e "$web_dir/new") < 1)
		{
		mkdir ("$web_dir/new", $default_permissions);
		chmod($default_permissions,"$web_dir/new");
		}
			
	open (WNEW, "> $web_dir/new/$dfidx")  or die "Cannot open $web_dir/new/$dfidx : $!";
		print WNEW $whats_new;
	close (WNEW);
	chmod($default_permissions,"$web_dir/new/$dfidx");

	if ($wbuild eq "web")
		{
		print "<b>Compiling 'What's New Links'</b><br>";
		print "/new/$dfidx<br>";
		}
		else
		{
		if (($gsettings->{verbose_silent} eq "Verbose")or ($q->param('fct') eq "telnb"))
				{
				print "Compiling 'What's New Links'\n";
				print "/new/$dfidx\n";
				}
		}

	for ($ms1 = 2; $ms1 < ($new_cpages + 1); $ms1++)
		{
				
		$stw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1));
		$ndw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1)) + $gsettings->{nrlinks_per_page};
		
		($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat("", $level, "STATIC", $stw, $ndw, "new");

				$fname = "$web_dir/new/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};
				$cfname = "/new/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};
				
				#$fname = "$web_dir/new/more" . "$ms1" . $gsettings->{gen_file_ext};
				#$cfname = "/new/more" . "$ms1" . $gsettings->{gen_file_ext};

				

				if ($wbuild eq "web")
					{
					print "    =====> $cfname<br>";
					}
					else
					{
						if (($gsettings->{verbose_silent} eq "Verbose") or ($q->param('fct') eq "telnb"))
								{
								print "    =====> $cfname\n";
								}
					}

			open (NEWP2, "> $fname")  or die "Cannot open $fname : $!";
				print NEWP2 $newpage;
			close (NEWP2);
			chmod($default_permissions,$fname);

			$pages_build++;
			$telnet_pages_build++;
			
		}

##########

	

}




sub get_total_dirs
{
my ($dtdir) = @_;
my (@dsubdirs, @subdirs, $thing, $tmp, $alldnr, $adir);

$dirlist[0] = $dtdir;

foreach $adir (@dirlist)
	{
		@subdirs = &get_dir_contents ($adir);
		$tmp = push(@dirlist, @subdirs);
	}

$alldnr = push(@dirlist);
$alldnr = $alldnr - 1;

foreach $adir (@dirlist)
	{
	$dsubdirs[$alldnr] = $adir;
	#print "==>$alldnr $dsubdirs[$alldnr] \n";
	$alldnr = $alldnr - 1;
	}

return (@dsubdirs);
}




sub get_dir_contents
{

my ($dirname) = @_;
my ($cntr,@files,$item,@subdirs,$isdir);

$cntr = 0;
opendir(DIR,"$dirname")  or die "Cannot open $dirname : $!";
	@files = readdir(DIR);
		foreach $item (@files)
			{
			$isdir = (-d "$dirname/$item");
			
			if (($isdir == 1) and ($item ne ".") and ($item ne ".."))
				{
				$subdirs[$cntr] = "$dirname/$item";
				$cntr++;
				}
			}
closedir (DIR);

return (@subdirs);

}
 



sub build_category_includes
{

opendir(INCLDIR,"$data_dir");
@all_incl_files = readdir(INCLDIR);
@all_incl_files = sort(@all_incl_files);

foreach $include_filename (@all_incl_files)
	{
	if (substr($include_filename, length($include_filename) - 4, 4) eq ".fpi")
		{
		$allcats = psfp::generate_categories("$include_filename");

		$allcats =~ s/\n/ /g;
		$crit = chr(10); $allcats =~ s/$crit/ /g;
		$crit = chr(13); $allcats =~ s/$crit/ /g;
		$allcats =~ s/'/\\'/g;
		
		$fullpath = "$web_dir/$include_filename";
		$fullpath =~ s/\.fpi/\.js/gi;
		$iname = $include_filename; $iname =~ s/\.fpi//gi; 
		
		open (FPS, "> $fullpath");
			print FPS "function get_$iname()\n";
			print FPS "{\n";
			print FPS "document.write ('" . $allcats . "');\n";
			print FPS "}\n";
		close (FPS);
		chmod($default_permissions,"$fullpath"); 
		
			if ($wbuild eq "web")
					{
					print "<b>Written:</b> $fullpath<br>";
					}
					else
					{
					if (($gsettings->{verbose_silent} eq "Verbose")or ($q->param('fct') eq "telnb"))
							{
							print "Written: $fullpath\n\n";
							}
					}
	   }
	}
closedir(INCLDIR);

}





sub start_gen
{
my ($stc_crit) = @_;

print qq[
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
 <tr>
  <td width="1%" bgcolor="#FFFFFF">
   <img src="$web_url/ajload.gif"></td>
  <td width="99%" valign="top" bgcolor="#FFFFFF">
   <table width="100%" border="0" cellpadding="6">
    <tr>
     <td background="$web_url/bar6.gif"><strong class="normaltext">$stc_crit</strong></td>
      </tr>
    </table>
    </td>
  </tr>
 <tr>
   <td colspan="2" valign="top" bgcolor="#FFFFFF"><table width="100%%" cellspacing="1" cellpadding="6">
     <tr>
       <td class="normaltext">
];




}

sub end_gen
{
print qq[ </td>
     </tr>
   </table></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>         
];

}






####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

