#!/usr/bin/perl

#<ENC>50</ENC>

package globaltmpl;

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use MIME::Base64 qw(decode_base64 encode_base64);


require Exporter;
use vars qw/@ISA @EXPORT @EXPORT_OK $copyright $prgname/;

@ISA = qw(Exporter);

@EXPORT = qw(get_global_templates
	    		 get_tnames);

@EXPORT_OK = qw(d_tmplates);

&get_setup;

##################################################################################################################


sub get_tnames
{


@d_tmplates = (
"psfp:Home",
"defdir:%%custom_pagetitle%%",
"linkinfo:!!title_without_link!!",
"linkinfop:!!title_without_link!!",
"searchres:Searching",
"searchadv:Advanced Search",
"nomatch:No Match Found",
"searchresdir:Searching",
"rate_it:Cast Rating",
"rate_it_success:Rating Recorded",
"rate_it_fail:Problem",
"gethtml:Get HTML Code",
"review_it:Add a Comment or Review",
"reviewadded:Success",
"reviewproblem:Problem",
"whatsnew_main:What's New",
"tophits_main:Most Popular",
"brokenlink:Broken Link",
"brokenlink_success:Success",
"mlist1:Mailing List",
"mlist2:Mailing List",
"mlist3:Mailing List",
"add_url_med:Add URL",
"add_url:Add URL",
"add_url_medp:Add URL",
"add_urlp:Add URL",
"add_url_instructions:Add URL",
"locked:Locked Category",
"add_url_problem:Add URL Problem",
"add_url_success:Add URL Success",
"modify_link:Modify",
"modify_link_problem:Problem",
"modify_link_success:Success",
"modify_link_edit:Modify",
"modify_link_editp:Modify",
"modify_instructions:Modify",
"retrievepass:Retrieve Password",
"retrievepass_ok:Success",
"retrievepass_prb:Problem",
"rgs_msgregister:Register",
"rgs_register:Register",
"rgs_regsuccess:Register",
"rgs_actsuccess:Success",
"rgs_actfailed:Problem",
"rgs_resend:Register",
"rgs_sent:Success",
"rgs_login:Login",
"rgs_logout:Logout",
"rgs_retrievepass:Retrieve Password",
"rgs_retrievepass_ok:Success",
"rgs_cpmain:Control Panel",
"rgs_editacc:Edit Account",
"rgs_saveacc:Saved",
"rgs_add_url_med:Add URL",
"rgs_add_url:Add URL",
"rgs_add_url_medp:Add URL",
"rgs_add_urlp:Add URL",
"rgs_add_url_instructions:Add URL",
"rgs_locked:Category Locked",
"rgs_add_url_problem:Problem",
"rgs_add_url_success:Success",
"rgs_modify_link_edit:Modify",
"rgs_modify_link_editp:Modify",
"rgs_modify_link_problem:Problem",
"rgs_modify_link_success:Success",
"rgs_modify_instructions:Modify",
"rgs_rcomment:Comment",
"rgs_rrate:Rating",
"fav_main:Favorits",
"rgs_regsuccess_paypal:Success",
"rgs_upgrade:Order Options",
"rgs_upgrade_paypal_success:Success",
"contact_form:Contact Us",
"contact_thank:Thanks",
"tmplsearch:LINKSTYLE",
"tmplsearch_prem:LINKSTYLE",
"fav_premium:LINKSTYLE",
"fav_standard:LINKSTYLE",
"lsearchres_loc:LINKSTYLE",
"lsearchres_loc_prem:LINKSTYLE",
"rgs_acclinks:LINKSTYLE",
"rgs_acclinksp:LINKSTYLE",
"tophits_listings:LINKSTYLE",
"tophits_listings_prem:LINKSTYLE",
"whatsnew_lists:LINKSTYLE",
"whatsnew_lists_prem:LINKSTYLE",
"incl_gluser_cp_links:LINKSTYLE",
"subdirs:LINKSTYLE",
"directories1:LINKSTYLE",
"related1:LINKSTYLE",
"related2:LINKSTYLE",
"lsearchres_locdir:LINKSTYLE",
"rgs_nolinks:LINKSTYLE",
"reviewlinks:LINKSTYLE"
);


return (@d_tmplates);

}




sub get_global_templates
{

$this = {};



$this->{reviewlinks} = qq[
<blockquote>
<p class="link_description">  %%review%%<br>
  <b class="plain_text">By: %%reviewer%% | Date: %%date%%</b></p>
</blockquote>
];



$this->{rgs_nolinks} = qq[
<blockquote>
  <p class="plain_text"><strong>You are now logged in and can add your link. </strong></p>
</blockquote>
<blockquote>
  <ul>
    <li>
      <p class="plain_text">To add your link click on the 'Add URL' buttons above and you will be taken to the 'Add
        URL' form. </p>
    </li>
  </ul>
  <span class="plain_text">Your account at present contains no links. </span></blockquote>
<blockquote>&nbsp;</blockquote>
];



$this->{lsearchres_locdir} = qq[
<table width="95%" border="0" align="center" cellpadding="6" cellspacing="1" class="link_border">
  <tr>
    <td class="plain_text"><strong>!!nr!! !!category!! </strong><br>
      !!description!!</td>
  </tr>
</table>
<BR>
];



$this->{subdirs} = qq[
<BR>
<table width="90%" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td valign="top" width="50%">%%subdirs1%%</td>
    <td valign="top" width="50%">%%subdirs2%%</td>
  </tr>
</table>
];

$this->{directories1} = qq[<img src="!build_url!/bl3.gif"> <span class="plain_text">%%substyle%% !!new!!</span>];

$this->{related1} = qq[<span class="plain_text"><b>Related</b> %%related_categories%%</span>];

$this->{related2} = qq[ : %%related_categories%%];


$this->{incl_gluser_cp_links} = qq[
<strong><span class="plain_text">[ <a href="!!my_links!!">Links</a> | <a href="!!account_details!!">Account Details</a> | <a href="!!log_out!!">Log Out</a> ]</span></strong>
];


### CATEGORY LINKS STYLE

$this->{tmplsearch} = qq[
<table width="95%" border="0" align="center" cellpadding="3" cellspacing="1" class="link_border">
  <tr>
    <td align="left"><strong class="link_title">!!nr!! !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!! </td>
  </tr>
  <tr>
    <td align="left" class="link_description">!!description!! </td>
  </tr>
  <tr>
    <td align="left" class="link_url">!!url!! </td>
  </tr>
  <tr>
    <td align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!] </td>
  </tr>
  <tr>
    <td align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites</a> | <a
    href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];



### PREMIUM CATEGORY LINKS STYLE
$this->{tmplsearch_prem} = qq[

<table width="95%" border="0" align="center" cellpadding="3" cellspacing="1" class="link_border">
  <tr>
    <td width="99%" align="left"><strong class="link_title">!!nr!! !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!!</td>
    <td width="1%" rowspan="2" valign="top" align="right"><strong><img src="!build_url!/ic_premium.gif"> </strong></td>
  </tr>
  <tr>
    <td width="99%" align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!]</td>
  </tr>
  <tr>
    <td colspan="2" align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites </a> | 
    <a href="!!rate_link_url!!">Rate It </a> | 
    <a href="!!review_link_url!!">Comments </a>| <a href="!!report_dead_link!!">Report </a>| <a
    href="!!more_info_url!!">More Info</a></span><a
    href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];




### fav_premium
$this->{fav_premium} = qq[
<table width="95%" border="0" align="center" cellpadding="3" cellspacing="1" class="link_border">
  <tr>
    <td width="99%" align="left"><strong class="link_title">!!nr!!. !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!! </td>
    <td width="1%" rowspan="2" valign="top" align="right"><strong><img src="!build_url!/ic_premium.gif"> </strong></td>
  </tr>
  <tr>
    <td width="99%" align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] </td>
  </tr>
  <tr>
    <td colspan="2" align="right"><span class="link_functions"><a href="!!remove_link!!">Remove From Favorites</a> | <a
    href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];



### fav_standard
$this->{fav_standard} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td align="left"><strong class="link_title">!!nr!!. !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!!</td>
  </tr>
  <tr>
    <td align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!]</td>
  </tr>
  <tr>
    <td align="right"><span class="link_functions"><a href="!!remove_link!!">Remove From Favorites</a> | <a
    href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];


### lsearchres_loc
$this->{lsearchres_loc} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td align="left"><strong class="link_title">!!nr!!. !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!!</td>
  </tr>
  <tr>
    <td align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!]</td>
  </tr>
  <tr>
    <td align="left"><strong class="relevance">Relevance: !!relevance!! !!rgraphic!!</strong></td>
  </tr>
  <tr>
    <td align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites</a> | <a
    href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];




### lsearchres_loc_prem
$this->{lsearchres_loc_prem} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td width="99%" align="left"><strong class="link_title">!!nr!!. !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!! </td>
    <td width="1%" rowspan="2" valign="top" align="right"><strong><img src="!build_url!/ic_premium.gif"> </strong></td>
  </tr>
  <tr>
    <td width="99%" align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!]</td>
  </tr>
  <tr>
    <td colspan="2" align="left"><strong class="relevance">Relevance: !!relevance!! !!rgraphic!!</strong></td>
  </tr>
  <tr>
    <td colspan="2" align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites</a> | <a
    href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];



### rgs_acclinks
$this->{rgs_acclinks} = qq[
<table border="0" cellpadding="3" cellspacing="1" width="95%" class="link_border" align="center">
  <tr>
    <td align="left"><strong class="link_title">!!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!!</td>
  </tr>
  <tr>
    <td align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td align="left"><strong class="link_url">!!url!!</strong></td>
  </tr>
  <tr>
    <td align="left" class="plain_text"><strong>Keywords: </strong>!!keywords!!</td>
  </tr>
  <tr>
    <td align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!] | !!date!!</td>
  </tr>
  <tr>
    <td align="left" class="from_category">Category: <strong>!!category!!</strong></td>
  </tr>
  <tr>
    <td width="923" align="left"><strong class="link_approval_status">Approval Status: !!aproval_status!!</strong></td>
  </tr>
  <tr>
    <td align="right" class="link_functions"><a href="!!cp_modify!!">Modify</a> | <a href="!!cp_com!!">Comments</a> | <a href="!!more_info_url!!">More Info</a></td>
    </tr>
</table>
<BR>
];



### rgs_acclinksp
$this->{rgs_acclinksp} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td width="929" colspan="2" align="left"><strong class="link_title">!!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!! <strong class="link_premium_indicate">(Premium Link) </strong></td>
  </tr>
  <tr>
    <td width="929" colspan="2" align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td width="929" colspan="2" align="left"><strong class="link_url">!!url!!</strong></td>
  </tr>
  <tr>
    <td width="929" colspan="2" align="left" class="plain_text"><strong>Keywords: </strong>!!keywords!!</td>
  </tr>
  <tr>
    <td width="923" colspan="2" align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!] | !!date!! </td>
  </tr>
  <tr>
    <td width="923" colspan="2" align="left" class="from_category">Category: <strong>!!category!!</strong></td>
  </tr>
  <tr>
    <td width="923" colspan="2" align="left"><strong class="link_approval_status">Premium Link Expiry Date: !!premium_expiry!! </strong></td>
  </tr>
  <tr>
    <td width="923" colspan="2" align="left"><strong class="link_approval_status">Approval Status: !!aproval_status!! </strong></td>
  </tr>
  <tr>
    <td width="462"></td>
    <td width="461" align="right"><span class="link_functions"><a href="!!cp_modify!!">Modify </a>| <a href="!!cp_com!!">Comments
    </a>| <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];



### tophits_listings
$this->{tophits_listings} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td align="left"><strong class="link_title">!!nr!! !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!! </td>
  </tr>
  <tr>
    <td align="left" class="link_description">!!description!! </td>
  </tr>
  <tr>
    <td align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!] </td>
  </tr>
  <tr>
    <td align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites</a> | <a
    href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];





### tophits_listings_prem
$this->{tophits_listings_prem} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td width="99%" align="left"><strong class="link_title">!!nr!! !!title_with_link!! </strong>!!rating_image!!  !!new!! !!pop!! </td>
    <td width="1%" rowspan="2" valign="top" align="right"><strong><img src="!build_url!/ic_premium.gif"></strong></td>
  </tr>
  <tr>
    <td width="864" align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td width="896" colspan="2" align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td width="896" colspan="2" align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td width="896" colspan="2" align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits:
    [!!hits!!] </td>
  </tr>
  <tr>
    <td width="896" colspan="2" align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites</a> |
        <a href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span> </td>
  </tr>
</table>
<BR>
];





### whatsnew_lists
$this->{whatsnew_lists} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td align="left"><strong class="link_title">!!nr!! !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!! </td>
  </tr>
  <tr>
    <td align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!] </td>
  </tr>
  <tr>
    <td align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites </a>| <a
    href="!!rate_link_url!!">Rate It </a>| <a href="!!review_link_url!!">Comments </a>| <a
    href="!!report_dead_link!!">Report </a>| <a href="!!more_info_url!!">More Info</a><a href="!!more_info_url!!"></a></span> </td>
  </tr>
</table>
<BR>
];




### whatsnew_lists_prem
$this->{whatsnew_lists_prem} = qq[
<table width="95%" border="0" cellpadding="3" cellspacing="1" class="link_border" align="center">
  <tr>
    <td width="99%" align="left"><strong class="link_title">!!nr!! !!title_with_link!! </strong>!!rating_image!! !!new!! !!pop!! </td>
    <td width="1%" rowspan="2" valign="top" align="right"><strong><img src="!build_url!/ic_premium.gif"> </strong></td>
  </tr>
  <tr>
    <td width="99%" align="left" class="link_description">!!description!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="link_url">!!url!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="from_category">From: !!category!!</td>
  </tr>
  <tr>
    <td colspan="2" align="left" class="ratings_votes">Rating: [!!rating!!] Votes: [!!votes!!] Hits: [!!hits!!]</td>
  </tr>
  <tr>
    <td colspan="2" align="right"><span class="link_functions"><a href="!!add_to_favorites!!">Add to Favorites</a> | <a
    href="!!rate_link_url!!">Rate It</a> | <a href="!!review_link_url!!">Comments</a> | <a
    href="!!report_dead_link!!">Report</a> | <a href="!!more_info_url!!">More Info</a></span><a href="!!more_info_url!!"> </a></td>
  </tr>
</table>
<BR>
];




### FRONT PAGE
$this->{psfp} = qq[
<table border="0" cellpadding="0" cellspacing="0" width="95%" align="center">
  <tr>
    <td width="100%">!!categories!!<br>
    </td>
  </tr>
</table>
];


### DEFAULT DIRECTORY TEMPLATE

$this->{defdir} = qq[
<table width="95%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td width="99%" align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: %%location%%</td>
    <td valign="top" width="1%">!!rss!!</td>
  </tr>
</table>
<table width="95%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td colspan="2" align="left" valign="top" class="plain_text">%%subdirectories%%</td>
  </tr>
  <tr>
    <td align="left" valign="top" class="plain_text">%%prevnext%%</td>
    <td align="right" valign="top" class="plain_text">%%pages%%</td>
  </tr>
  <tr>
    <td colspan="2" align="left" valign="top" class="plain_text">%%searchresults%%</td>
  </tr>
  <tr>
    <td align="left" valign="top" class="plain_text">%%prevnext%%</td>
    <td align="right" valign="top" class="plain_text">%%pages%%</td>
  </tr>
  <tr>
    <td width="100%" colspan="2" align="left" valign="top" class="plain_text">%%related%%</td>
  </tr>
</table>
];



### FAVORITES

$this->{fav_main} = qq[
<table width="95%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td width="100%" height="17" align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Favorites</td>
  </tr>
</table>
<table width="95%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" height="17" align="left">
    %%favorites%%
    </td>
  </tr>
</table>

];



#### LINK INFO

$this->{linkinfo} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: <a
    href="!!category_link!!">!!category!!</a> : More Info</td>
  </tr>
  <tr>
    <td valign="top"><table width="89%" border="0" align="center" cellpadding="6"
    cellspacing="1">
        <tr>
          <td width="100%" align="left"><strong class="link_title">!!title_with_link!! </strong>!!rating_image!! </td>
        </tr>
        <tr>
          <td width="100%" align="left" class="link_description">!!description!!</td>
        </tr>
        <tr>
          <td width="100%" align="left"><strong class="link_url">!!url!!</strong></td>
        </tr>
        <tr>
          <td width="100%" align="left" class="from_category">From: <strong>!!category!! </strong></td>
        </tr>
        <tr>
          <td width="100%" align="left" class="ratings_votes">Rating: <strong>!!rating!! </strong> | Votes: <strong>!!votes!! </strong> | Hits: <strong>!!Hits!! </strong></td>
        </tr>
      </table>
      <form method="POST" action="!!rate_it!!">
        <table width="89%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td align="left"><span class="plain_text"><strong>Rate This Link: </strong>
              <select
          name="rating" size="1">
                <option value="10"> 10 - The Best </option>
                <option value="9"> 9 </option>
                <option value="8"> 8 </option>
                <option value="7"> 7 </option>
                <option value="6"> 6 </option>
                <option value="5"> 5 </option>
                <option value="4"> 4 </option>
                <option value="3"> 3 </option>
                <option value="2"> 2 </option>
                <option value="1"> 1 - The Poorest </option>
              </select>
              <input type="submit" class="psbutton" value="Rate It" name="B12" >
              <input type="hidden" name="ct" value="!!ct!!" >
              <input type="hidden" name="fct"
      value="cast_rating" >
              <input type="hidden" name="id" value="!!id!!-!!cid!!" >
              </span></td>
          </tr>
        </table>
      </form>
      <table width="89%" border="0" align="center" cellpadding="6" cellspacing="1">
        <tr>
          <td width="100%" align="left"><p><strong>User Comments:</strong></p>
            <p class="user_comments">%%reviews%%</p></td>
        </tr>
      </table>
      <BR >
      <form method="POST" action="!!review_it!!">
        <table width="89%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td colspan="2" class="plain_text"><strong>Add a Comment: </strong></td>
          </tr>
          <tr>
            <td width="20%" class="plain_text"><strong>Name: </strong></td>
            <td width="80%" class="plain_text"><input type="text" name="name"
          size="29" ></td>
          </tr>
          <tr>
            <td width="20%" class="plain_text"><strong>Email: </strong></td>
            <td width="80%" class="plain_text"><input type="text" name="email"
          size="29" >
              (Optional)</td>
          </tr>
          <tr>
            <td width="20%" valign="top" class="plain_text"><strong>Comment: </strong></td>
            <td width="80%" class="plain_text">%%description_box%%</td>
          </tr>
          <tr>
            <td width="20%" class="plain_text">&nbsp;</td>
            <td width="80%" class="plain_text">%%imgbox%% <br >
              <input type="text" name="letters" size="10">
              <br >
              Type in the letters that apear in the image box </td>
          </tr>
          <tr>
            <td width="20%" class="plain_text">&nbsp;</td>
            <td width="80%" class="plain_text"><input type="submit" class="psbutton"
          value="   Add   " name="B1" >
              <input type="hidden" name="ct" value="!!ct!!">
              <input type="hidden" name="fct"
      value="save_review" >
              <input type="hidden" name="id" value="!!id!!">
              <input type="hidden"
      name="ia" value="!!ia!!" ></td>
          </tr>
        </table>
        <BR >
      </form></td>
  </tr>
</table>

];


$this->{linkinfop} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: <a
    href="!!category_link!!">!!category!!</a> : More Info</td>
  </tr>
  <tr>
    <td valign="top"><table width="89%" border="0" align="center" cellpadding="6"
    cellspacing="1">
        <tr>
          <td width="99%" align="left"><strong class="link_title">!!title_with_link!! </strong>!!rating_image!! </td>
          <td width="1%" rowspan="2" align="right"><img src="!build_url!/ic_premium.gif"></td>
        </tr>
        <tr>
          <td width="99%" align="left" class="link_description">!!description!!</td>
        </tr>
        <tr>
          <td width="100%" colspan="2" align="left"><strong class="link_url">!!url!!</strong></td>
        </tr>
        <tr>
          <td width="100%" colspan="2" align="left" class="from_category">From: <strong>!!category!! </strong></td>
        </tr>
        <tr>
          <td width="100%" colspan="2" align="left" class="ratings_votes">Rating: <strong>!!rating!! </strong> | Votes: <strong>!!votes!! </strong> | Hits: <strong>!!Hits!! </strong></td>
        </tr>
      </table>
      <form method="POST" action="!!rate_it!!">
        <table width="89%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td align="left"><span class="plain_text"><strong>Rate This Link: </strong>
              <select
          name="rating" size="1">
                <option value="10"> 10 - The Best </option>
                <option value="9"> 9 </option>
                <option value="8"> 8 </option>
                <option value="7"> 7 </option>
                <option value="6"> 6 </option>
                <option value="5"> 5 </option>
                <option value="4"> 4 </option>
                <option value="3"> 3 </option>
                <option value="2"> 2 </option>
                <option value="1"> 1 - The Poorest </option>
              </select>
              <input type="submit" class="psbutton" value="Rate It" name="B12" >
              <input type="hidden" name="ct" value="!!ct!!" >
              <input type="hidden" name="fct"
      value="cast_rating" >
              <input type="hidden" name="id" value="!!id!!-!!cid!!" >
              </span></td>
          </tr>
        </table>
      </form>
      <table width="89%" border="0" align="center" cellpadding="6" cellspacing="1">
        <tr>
          <td width="100%" align="left"><p><strong>User Comments:</strong></p>
            <p class="user_comments">%%reviews%%</p></td>
        </tr>
      </table>
      <BR >
      <form method="POST" action="!!review_it!!">
        <table width="89%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td colspan="2" class="plain_text"><strong>Add a Comment:</strong></td>
          </tr>
          <tr>
            <td width="20%" class="plain_text"><strong>Name: </strong></td>
            <td width="80%" class="plain_text"><input type="text" name="name"
          size="29" ></td>
          </tr>
          <tr>
            <td width="20%" class="plain_text"><strong>Email: </strong></td>
            <td width="80%" class="plain_text"><input type="text" name="email"
          size="29" >
              (Optional)</td>
          </tr>
          <tr>
            <td width="20%" valign="top" class="plain_text"><strong>Comment: </strong></td>
            <td width="80%" class="plain_text">%%description_box%%</td>
          </tr>
          <tr>
            <td width="20%" class="plain_text">&nbsp;</td>
            <td width="80%" class="plain_text">%%imgbox%% <br >
              <input type="text" name="letters" size="10" >
              <br >
              Type in the letters that apear in the image box </td>
          </tr>
          <tr>
            <td width="20%" class="plain_text">&nbsp;</td>
            <td width="80%" class="plain_text"><input type="submit" class="psbutton"
          value="   Add   " name="B1" >
              <input type="hidden" name="ct" value="!!ct!!" >
              <input type="hidden" name="fct"
      value="save_review" >
              <input type="hidden" name="id" value="!!id!!" >
              <input type="hidden"
      name="ia" value="!!ia!!" ></td>
          </tr>
        </table>
        <BR >
      </form></td>
  </tr>
</table>

];



$this->{searchres} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td colspan="2" align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Searching
    For '%%keywords%%'</td>
  </tr>
  <tr>
    <td colspan="2" align="left" valign="top" class="plain_text">Found <strong>%%link_matches%% </strong>Matches</td>
  </tr>
  <tr>
    <td align="left" valign="top" class="plain_text"><strong>%%prevnext%%</strong></td>
    <td align="right" valign="top" class="plain_text">%%pages%% </td>
  </tr>
  <tr>
    <td colspan="2" align="left" valign="top" class="plain_text">%%searchresults%%</td>
  </tr>
  <tr>
    <td align="left" valign="top" class="plain_text"><strong>%%prevnext%% </strong></td>
    <td align="right" valign="top" class="plain_text">%%pages%%</td>
  </tr>
</table>
];


$this->{searchadv} = qq[
<form method="POST" action="!!advanced_search!!">
  <table width="97%"
  border="0" align="center" cellpadding="6" cellspacing="1">
    <tr>
      <td colspan="2" align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> ::
        Advanced Search Form</td>
    </tr>
    <tr>
      <td width="23%" align="left" valign="top" class="plain_text"><strong>Your Keywords: </strong></td>
      <td width="77%" align="left" valign="top" class="plain_text"><input type="text" name="keywords" size="59"
      value="!!keywords!!"></td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"><strong>Choose the fields to Search: </strong></td>
      <td align="left" valign="top" class="plain_text"><input type="checkbox" name="title"
      value="title" checked>
        Title <br>
        <input type="checkbox" name="diz" value="description" checked>
        Description <br>
        <input type="checkbox" name="kw" value="keywords" checked>
        Keywords <br>
        <input type="checkbox" name="url" value="url" checked>
        URL </td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"><strong>Search with: </strong></td>
      <td align="left" valign="top" class="plain_text"><input type="radio" value="internal"
      name="mtype" checked>
        Determine the best matches for me. </td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"></td>
      <td align="left" valign="top" class="plain_text"><input type="radio" value="andkeywords"
      name="mtype">
        All the keywords supplied must match a link before it will be displayed as a
        match. </td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"></td>
      <td align="left" valign="top" class="plain_text"><input type="radio" value="phrase" name="mtype">
        Search with the exact phrase. (The phrase must match to find a match) </td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"></td>
      <td align="left" valign="top" class="plain_text"><input type="submit" class="psbutton" value="Search" name="B1">
        <input type="hidden" name="fct" value="advanced"></td>
    </tr>
  </table>
</form>
<BR>
<form method="POST" action="!!cat_search!!">
  <table width="97%" border="0" align="center" cellpadding="6" cellspacing="1">
    <tr>
      <td colspan="2" align="left" valign="top" class="plain_text"><strong>Category Search: </strong>(This
        search will only search categories for keywords)</td>
    </tr>
    <tr>
      <td width="23%" align="left" valign="top" class="plain_text"><strong>Keywords: </strong></td>
      <td width="77%" align="left" valign="top" class="plain_text"><input type="text" name="cat_keywords" size="59"></td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"><strong>Search with: </strong></td>
      <td align="left" valign="top" class="plain_text"><input type="radio" value="internal"
      name="mtype" checked>
        At least one keyword should match a category name </td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"></td>
      <td align="left" valign="top" class="plain_text"><input type="radio" value="andkeywords"
      name="mtype">
        All the keywords supplied must match category names </td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"></td>
      <td align="left" valign="top" class="plain_text"><input type="radio" value="phrase" name="mtype">
        Search with the exact phrase. (The phrase must match to find a match) </td>
    </tr>
    <tr>
      <td align="left" valign="top" class="plain_text"></td>
      <td align="left" valign="top" class="plain_text"><input type="submit" class="psbutton" value="Search" name="B2"></td>
    </tr>
  </table>
</form>
];


$this->{nomatch} = qq[

<table border="0" cellpadding="7" cellspacing="0" width="97%" align="center">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Searching For '%%keywords%%'
    </td>
  </tr>
  <tr>
    <td align="left" valign="top" class="plain_text">Your search for <strong>%%keywords%% </strong>revealed no
    matches. Try to use more or different keywords. </td>
  </tr>
</table>

];


$this->{searchresdir} = qq[
<table border="0" cellpadding="6" cellspacing="1" width="97%" align="center">
  <tr>
    <td colspan="2" class="page_heading"><a href="!!top!!">Top</a> :: Searching Categories For '%%keywords%%'</td>
  </tr>
  <tr>
    <td colspan="2" class="plain_text">Found <strong>%%link_matches%%</strong> Matches</td>
  </tr>
  <tr>
    <td class="plain_text"><strong>%%prevnext%%</strong></td>
    <td align="right" class="plain_text">%%pages%%</td>
  </tr>
  <tr>
    <td colspan="2" class="plain_text">%%searchresults%%</td>
  </tr>
  <tr>
    <td class="plain_text"><strong>%%prevnext%%</strong></td>
    <td align="right" class="plain_text">%%pages%%</td>
  </tr>
</table>
];



$this->{rate_it} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="link_title"><a href="!!top!!">Top</a> :: Cast Rating</td>
  </tr>
  <tr>
    <td valign="top"><form method="POST" action="!!rate_it!!">
        <div align="center">
          <table
      border="0" cellpadding="6" cellspacing="1" width="95%">
            <tr>
              <td width="100%" height="10"></td>
            </tr>
            <tr>
              <td width="100%" align="left"><select name="rating" size="1">
                  <option value="10"> 10 - The Best </option>
                  <option value="9"> 9 </option>
                  <option value="8"> 8 </option>
                  <option value="7"> 7 </option>
                  <option value="6"> 6 </option>
                  <option value="5"> 5 </option>
                  <option value="4"> 4 </option>
                  <option value="3"> 3 </option>
                  <option value="2"> 2 </option>
                  <option value="1"> 1 - The Poorest </option>
                </select>
                <input type="submit" class="psbutton" value="Rate It" name="B1">
                <input type="hidden" name="ct" value="!!ct!!" >
                <input type="hidden" name="fct"
      value="cast_rating" >
                <input type="hidden" name="id" value="!!id!!" ></td>
            </tr>
            <tr>
              <td width="100%" height="20" align="left"></td>
            </tr>
            <tr>
              <td width="100%" align="left"><strong class="link_title">!!title_with_link!! </strong>!!rating_image!!</td>
            </tr>
            <tr>
              <td width="100%" align="left" class="link_description">!!description!! </td>
            </tr>
            <tr>
              <td width="100%" align="left"><strong class="link_url">!!url!! </strong></td>
            </tr>
            <tr>
              <td width="100%" align="left" class="from_category">From: <strong>!!category!! </strong></td>
            </tr>
            <tr>
              <td width="100%" align="left" class="ratings_votes">Rating: <strong>!!rating!! | </strong>Votes:<strong>!!votes!! </strong> |Hits: <strong>!!Hits!!</strong></td>
            </tr>
            <tr>
              <td width="100%" height="20" align="left"></td>
            </tr>
            <tr>
              <td width="100%" align="left" class="plain_text">Is this your link? <a
          href="!!scripts_url!!/gethtml.cgi?id=!!id!!">Allow users to vote for it from your web
                site. </a></td>
            </tr>
            <tr>
              <td align="left" class="plain_text"><strong>Go back to: !!category_with_link!! &gt;&gt; <a
          href="!!more_info_url!!">!!title_without_link!! </a></strong></td>
            </tr>
          </table>
          </center>
        </div>
      </form></td>
  </tr>
</table>

];


$this->{rate_it_success} = qq[
<table border="0" cellpadding="7" cellspacing="0" width="97%" align="center">
  <tr>
    <td valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Your Rating Has Been Recorded</td>
  </tr>
  <tr>
    <td valign="top" align="left">&nbsp;
      <table width="95%" border="0" align="center"
    cellpadding="3" cellspacing="0">
        <tr>
          <td width="706"><strong class="plain_text">Your rating has been recorded for:</strong></td>
        </tr>
        <tr>
          <td width="706" height="15"></td>
        </tr>
        <tr>
          <td width="706"><strong class="link_title">!!title_with_link!! </strong>!!rating_image!! </td>
        </tr>
        <tr>
          <td width="706" class="link_description">!!description!! </td>
        </tr>
        <tr>
          <td width="706"><strong class="link_url">!!url!! </strong></td>
        </tr>
        <tr>
          <td width="706" class="from_category">From: <strong>!!category!! </strong></td>
        </tr>
        <tr>
          <td width="706" class="ratings_votes">Votes: <strong>!!votes!! | </strong>Rating:<strong> !!rating!! | </strong>Hits:<strong> !!hits!! </strong></td>
        </tr>
        <tr>
          <td width="706" height="20">&nbsp;</td>
        </tr>
        <tr>
          <td width="706" class="plain_text"><strong>Go back to: !!category_with_link!! &gt;&gt; <a
        href="!!more_info_url!!">!!title_without_link!! </a></strong></td>
        </tr>
        <tr>
          <td width="706" height="20">&nbsp;</td>
        </tr>
      </table></td>
  </tr>
</table>
];


$this->{rate_it_fail} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Problem </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote>
      <p><span class="plain_text"><br>
        Your rating for this link has already been recorded. </span></p>
      <p><span class="plain_text"><strong>Go back to: !!category_with_link!! &gt;&gt; <a href="!!more_info_url!!">!!title_without_link!!</a></strong><BR><BR></span><br>
      </p>
    </blockquote>
    </td>
  </tr>
</table>
];


$this->{gethtml} = qq[
<table border="0" cellpadding="6" cellspacing="1" width="97%" align="center">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Get Rating HTML Code</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!rate_it!!"><p><strong>Enable Your
      Visitors To Rate Your Link <br>
      </strong>Use the methods below to enable your visitors to rate your listing from your web
      site. </p>
      <p><strong><br>
        Text Links <br>
      </strong>You may link to the rating form via text link. Use the following text link to
      link to the rating form. </p>
      <blockquote>
        <p><strong>%%textlink%% </strong></p>
        <p>You may also use the HTML code below. </p>
        <p>%%textlink_code%% </p>
        </blockquote>
      <p><strong>Remote Rating Forms <br>
          </strong>You may also place a remote rating form on your web site. Copy and paste the HTML
          code listed below into your web pages. </p>
      <blockquote>
        <p>%%remoteform_code%%</p>
      </blockquote>
      <p><strong><br>
        The Above Remote Rating Options is Available For: </strong></p>
      <div align="center"><table border="0" cellpadding="6" cellspacing="1" width="90%">
        <tr>
          <td width="100%" align="left"><strong class="link_title">%%title_with_link%% </strong>%%rating_image%% </td>
        </tr>
        <tr>
          <td width="100%" align="left" class="link_description">%%description%%</td>
        </tr>
        <tr>
          <td width="100%" align="left"><strong class="link_url">%%url%% </strong></td>
        </tr>
        <tr>
          <td width="100%" align="left" class="from_category">From: <strong>%%category%% </strong></td>
        </tr>
        <tr>
          <td width="100%" align="left" class="ratings_votes">Rating: <strong>%%rating%% | </strong>Votes: <strong><strong>%%votes%% | </strong></strong>Hits:<strong> <strong><strong>%%Hits%%</strong></strong></strong></td>
        </tr>
      </table>
      </center></div><BR >
      <span class="plain_text"><strong>Go back to: !!category_with_link!! &gt;&gt; <a
          href="!!more_info_url!!">!!title_without_link!!</a></strong></span><BR >
    </form>
    </td>
  </tr>
</table>
];


$this->{review_it} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Comments</td>
  </tr>
  <tr>
    <td valign="top"><table width="95%" border="0" align="center" cellpadding="6"
    cellspacing="1">
        <tr>
          <td width="100%" class="link_title">!!title_with_link!! !!rating_image!! </td>
        </tr>
        <tr>
          <td width="100%" class="link_description">!!description!!</td>
        </tr>
        <tr>
          <td width="100%"><strong class="link_url">%%url%% </strong></td>
        </tr>
        <tr>
          <td width="100%" class="from_category">From: <strong>!!category!! </strong></td>
        </tr>
        <tr>
          <td width="100%" class="ratings_votes">Rating: <strong>!!rating!! </strong>| Votes: <strong>!!votes!! </strong> | Hits: <strong>!!Hits!!</strong></td>
        </tr>
        <tr>
          <td width="100%" height="20">&nbsp;</td>
        </tr>
        <tr>
          <td width="100%"><strong class="plain_text">Comments: </strong> <span class="user_comments">%%review_listings%%</span></td>
        </tr>
        <tr>
          <td align="left">&nbsp;</td>
        </tr>
      </table>
      <form method="POST" action="!!review_it!!">
        <table width="95%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td height="25" colspan="2" align="left" class="plain_text"><strong>Add a
              Comment:</strong></td>
          </tr>
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="185" class="plain_text"><strong>Name: </strong></td>
            <td width="1033" class="plain_text"><input name="name" type="text" value="!!cname!!"
          size="29"></td>
          </tr>
          <tr>
            <td width="185" class="plain_text"><strong>Email: </strong></td>
            <td width="1033" class="plain_text"><input name="email" type="text" value="!!cemail!!"
          size="29">
            (Optional) </td>
          </tr>
          <tr>
            <td width="185" valign="top" class="plain_text"><strong>Comment: </strong></td>
            <td width="1033" class="plain_text">%%description_box%% </td>
          </tr>
          <tr>
            <td width="185" class="plain_text"></td>
            <td width="1033" class="plain_text">%%imgbox%% <br>
              Type in the letters as indicated above: <br>
              <input type="text" name="letters" size="20">
            <br></td>
          </tr>
          <tr>
            <td width="185" height="24" align="left" class="plain_text"></td>
            <td width="1033" class="plain_text"><input type="submit" class="psbutton"
          value="   Add   " name="B1">
              <input type="hidden" name="ct" value="!!ct!!" >
              <input type="hidden" name="fct"
      value="save_review" >
              <input type="hidden" name="id" value="!!id!!" >
              <input type="hidden" 
      name="ia" value="!!ia!!" ></td>
          </tr>
          <tr>
            <td height="24" align="left" class="plain_text"></td>
            <td height="24" class="plain_text">&nbsp;</td>
          </tr>
          <tr>
            <td height="24" colspan="2" class="plain_text"><strong>Go back to: !!category_with_link!! &gt;&gt; <a
    href="!!more_info_url!!">!!title_without_link!! </a></strong></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>
];


$this->{reviewadded} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Comment Added</td>
  </tr>
  <tr>
    <td><table width="95%" border="0" align="center" cellpadding="6"
    cellspacing="1">
      <tr>
        <td width="100%" align="left"></td>
      </tr>
      <tr>
        <td width="100%" align="left"><strong class="plain_text">Your comment has been added for: </strong></td>
      </tr>
      <tr>
        <td width="100%"><strong class="link_title">!!title_with_link!! </strong>!!rating_image!! </td>
      </tr>
      <tr>
        <td width="100%" class="link_description">!!description!! </td>
      </tr>
      <tr>
        <td width="100%"><strong class="link_url">!!url!! </strong></td>
      </tr>
      <tr>
        <td width="100%" class="from_category">From: <strong>!!category!! </strong></td>
      </tr>
      <tr>
        <td width="100%" class="ratings_votes">Rating: <strong>!!rating!! | </strong>Votes:<strong> !!votes!! | </strong>Hits:<strong> !!hits!!</strong></td>
      </tr>
      <tr>
        <td width="100%" height="20" align="left">&nbsp;</td>
      </tr>
      <tr>
        <td width="100%"><span class="plain_text"><strong>Go back to: !!category_with_link!! &gt;&gt; <a
        href="!!more_info_url!!">!!title_without_link!!</a></strong></span><strong><a
        href="!!more_info_url!!"> </a></strong></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
];


$this->{reviewproblem} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Problem </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote>
      <p class="plain_text">      <br>
        %%problem%% </p>
      <p class="plain_text"><strong><a href="" onClick="history.go(-1); return false;">Go Back</a></strong></p>
      <p class="plain_text"><strong>Go back to: !!category_with_link!! &gt;&gt; <a href="!!more_info_url!!">!!title_without_link!!
      </a></strong><br>
      <br>
      <br>
      </p>
    </blockquote>
    </td>
  </tr>
</table>
];


$this->{whatsnew_main} = qq[
<table border="0" cellpadding="7" cellspacing="0" width="95%" align="center">
  <tr>
    <td  colspan="2" align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> ::  What's New</td>
  </tr>
  <tr>
    <td  class="plain_text">%%prevnext%%</td>
    <td  align="right" class="plain_text">%%pages%%</td>
  </tr>
  <tr>
    <td valign="top" colspan="2"  align="left">%%whats_new_listings%%</td>
  </tr>
  <tr>
    <td  class="plain_text">%%prevnext%%</td>
    <td  align="right" class="plain_text">%%pages%%</td>
  </tr>
</table>
];


$this->{tophits_main} = qq[

<table border="0" cellpadding="7" cellspacing="0" width="95%" align="center">
  <tr>
    <td  colspan="2" align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Top Hits </td>
  </tr>
  <tr>
    <td align="left" class="plain_text">%%prevnext%% </td>
    <td align="right" class="plain_text">%%pages%% </td>
  </tr>
  <tr>
    <td valign="top" colspan="2"  align="left">%%tophits_listings%% </td>
  </tr>
  <tr>
    <td align="left" class="plain_text">%%prevnext%% </td>
    <td align="right" class="plain_text">%%pages%% </td>
  </tr>
</table>
];



$this->{brokenlink} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Report a Broken Link </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!broken_link_script!!">
        <blockquote class="plain_text"> <span class="plain_text">You have chosen to report the following listing as broken: <br>
          <br>
          </span> <a href="!!url!!"><strong>!!title_with_link!! </strong></a><strong> <br>
          <br>
          Please select the problem you are having with this listing: </strong><br>
          <input type="radio" value="404 Not Found" name="problem" checked>
          404 Not Found <br>
          <input type="radio" value="Moved" name="problem">
          Moved <br>
          <input type="radio" value="500 Server Error" name="problem">
          500 Server Error <br>
          <input type="radio" value="DNS: Name Not Found" name="problem">
          DNS: Name Not Found <br>
          <input type="radio" value="Cannot Connect" name="problem">
          Cannot Connect <br>
          <input type="radio" value="401 Authorization Required" name="problem">
          401 Authorization
          Required <br>
          <input type="radio" value="Not Sure" name="problem">
          Not Sure <br>
          <input type="radio" value="Other" name="problem">
          Other
          <p><strong>Would you like to add something about this link? (Optional) <br>
            </strong>%%notesbox%%<br>
            500 chars max <br>
            <br>
            %%imgbox%% <br>
            Type in the letters as indicated above: <br>
            <input type="text" name="letters" size="20">
            <br>
            <br>
            <input type="submit" class="psbutton" value="Report Broken Link" name="B1">
            <input type="hidden" name="cid" value="!!cid!!" >
            <input type="hidden" name="id"
        value="!!id!!" >
            <span style="color:#FF0000">!!problem!!</span> <br>
            <br>
            <strong>Go back to: !!category_with_link!! &gt;&gt; <a href="!!more_info_url!!">!!title_without_link!! </a></strong>
        </blockquote>
      </form></td>
  </tr>
</table>
];



$this->{brokenlink_success} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><strong><a href="!!top!!">Top</a> :: Report a Broken Link </strong></td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote><span class="plain_text">Thanks for informing us! <br>
        <br>
        <strong>Go back to: !!category_with_link!! &gt;&gt; <a href="!!more_info_url!!">!!title_without_link!!
        </a></strong></span></blockquote>
    </td>
  </tr>
</table>
];



$this->{mlist1} = qq[

<table border="0" cellpadding="7" cellspacing="0" width="97%" align="center">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Mailing List Removal</td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote>
        <form method="POST" action="!!removalscript!!">
          <p class="plain_text"><strong>Please enter your email
            address below to be removed from the mailing list: </strong></p>
          <p class="plain_text">Email Address:
            <input type="text" name="email" size="46">
            <input type="submit" class="psbutton" value="Remove" name="B1">
            <input type="hidden" name="fct" value="remove_email" >
          </p>
        </form>
      </blockquote></td>
  </tr>
</table>


];



$this->{mlist2} = qq[
<table border="0" cellpadding="7" cellspacing="0" width="97%" align="center">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Problem</td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote class="plain_text"> The email address you entered was not found in the database.<strong><a href="" onClick="history.go(-1); return false;"><br>
      <br>
      Go Back</a></strong>    </blockquote>
    </td>
  </tr>
</table>
];




$this->{mlist3} = qq[
<table border="0" cellpadding="7" cellspacing="0" width="97%" align="center">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Mailing List Removal </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote class="plain_text"> Your email address has been removed from the list.</blockquote>
    </td>
  </tr>
</table>
];





$this->{add_url_med} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add URL</td>
  </tr>
  <tr>
    <td valign="top"><form method="POST" action="!!addurlcgi!!">
     <table width="95%" border="0" align="center" cellpadding="6" cellspacing="1">
        <tr>
          <td colspan="2"><span class="plain_text"><span style="color:red"><strong>!!error_text!!</strong></span></span></td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Category: </strong></td>
          <td width="70%" align="left" class="plain_text">%%category_dropdown%% </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Title: </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="text" name="title" size="50"> </td>
        </tr>
        <tr>
          <td width="30%" valign="top" class="plain_text"><strong>Description:</strong></td>
          <td width="70%" align="left" class="plain_text">%%submissionbox%%<br>
          Max 255 Characters </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Keywords: </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="text" name="keywords" size="50"> </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>URL: </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="text" name="url" size="50" value="http://"> </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Modify Password: </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="password" name="password1" size="20"> </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Confirm Modify Password: </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="password" name="password2" size="20"> </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Suggest a Category: </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="text" name="csuggestion" size="50"> </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Contact Person for this link: </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="text" name="sname" size="30"> </td>
        </tr>
        <tr>
          <td class="plain_text"><strong>Contact Email Address For This Link:</strong></td>
          <td align="left" class="plain_text"><input type="text" name="email2" size="50"></td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"><strong>Subscribe to mailing list? </strong></td>
          <td width="70%" align="left" class="plain_text"><input type="checkbox" name="mlist" value="Y" checked> </td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"></td>
          <td width="70%" align="left" class="plain_text">          %%imgbox%%<br>
          Please type the letters listed above:<br>
          <input type="text" name="letters" size="20"></td>
        </tr>
        <tr>
          <td width="30%" class="plain_text"></td>
          <td width="70%" align="left" class="plain_text"><input type="submit" class="psbutton" value="   Submit   " name="B1">
            <input type="hidden" name="ia" value="!!ia!!">
            <input type="hidden" name="p" value="!!p!!"></td>
        </tr>
      </table>
   
    </form>
    </td>
  </tr>
</table>
];




$this->{add_url} = qq[


<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add URL</td>
  </tr>
  <tr>
    <td valign="top"><form method="POST" action="!!addurlcgi!!">
        <table width="95%" border="0" align="center" cellpadding="5" cellspacing="1">
          <tr>
            <td  colspan="2" class="normaltext"><span class="plain_text" style="color:red"><strong>!!error_text!!</strong></span></td>
          </tr>
              <tr>
                <td colspan="2" align="left" class="plain_text">You have chosen to add your URL in the following category: <strong><br>
                %%add_category%%<br><br>
                </strong></td>
              </tr>
              <tr>
                <td width="30%" align="left" class="plain_text"><strong>Title: </strong></td>
                <td width="70%" align="left" class="plain_text"><input type="text" name="title" size="50"></td>
              </tr>
              <tr>
                <td width="30%" align="left" valign="top" class="plain_text"><strong>Description: </strong></td>
                <td width="70%" align="left" class="plain_text">%%submissionbox%% <br>
                  Max 255 Characters </td>
              </tr>
              <tr>
                <td width="30%" align="left" valign="top" class="plain_text"><strong>Keywords: </strong></td>
                <td width="70%" align="left" class="plain_text"><input type="text" name="keywords" size="50"></td>
              </tr>
              <tr>
                <td width="30%" align="left" class="plain_text"><strong>URL: </strong></td>
                <td width="70%" align="left" class="plain_text"><input type="text" name="url" size="50" value="http://"></td>
              </tr>
              <tr>
                <td width="30%" align="left" valign="top" class="plain_text"><strong>Modify Password: </strong></td>
                <td width="70%" align="left" class="plain_text"><input type="password" name="password1" size="20"></td>
              </tr>
              <tr>
                <td width="30%" align="left" valign="top" class="plain_text"><strong>Confirm Modify Password: </strong></td>
                <td width="70%" align="left" class="plain_text"><input type="password" name="password2" size="20"></td>
              </tr>
              <tr>
                <td width="30%" align="left" valign="top" class="plain_text"><strong>Suggest a Category: </strong></td>
                <td width="70%" align="left" class="plain_text"><input type="text" name="csuggestion" size="50"></td>
              </tr>
              <tr>
                <td width="30%" align="left" valign="top" class="plain_text"><strong>Contact Person for This Link:</strong></td>
                <td width="70%" align="left" class="plain_text"><input type="text" name="sname" size="30"></td>
              </tr>
              <tr>
                <td align="left" class="plain_text"><strong>Contact Email Address For This Link:</strong></td>
                <td align="left" class="plain_text"><input type="text" name="email" size="50"></td>
              </tr>
              <tr>
                <td width="30%" align="left" class="plain_text"><strong>Subscribe to mailing list? </strong></td>
                <td width="70%" align="left" class="plain_text"><input type="checkbox" name="mlist" value="Y" checked></td>
              </tr>
              <tr>
                <td width="30%" align="left" class="plain_text"></td>
                <td width="70%" align="left" class="plain_text"> %%imgbox%% <br>
                  Please type the letters listed above: <br>
                  <input type="text" name="letters" size="22"></td>
              </tr>
              <tr>
                <td width="30%" align="left"></td>
                <td width="70%" align="left"><input type="submit" class="psbutton" value="   Submit   " name="B1">
                  <input type="hidden" name="catid" value="!!catid!!">
                  <input type="hidden" name="ia"
      value="!!ia!!">
                  <input type="hidden" name="p" value="!!p!!"></td>
              </tr>
            </table>
    </form></td>
  </tr>
</table>



];





$this->{add_url_medp} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add Premium URL</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!addurlcgi!!">
      <table border="0" cellpadding="5" cellspacing="1" width="95%">
        <tr>
          <td colspan="2"><span class="plain_text"><span style="color:red"><strong>!!error_text!!</strong></span></span></td>
        </tr>
        <tr>
          <td width="30%" class="relevance">Category: </td>
          <td width="70%" align="left" class="plain_text">%%category_dropdown%% </td>
        </tr>
        <tr>
          <td class="relevance">Title: </td>
          <td align="left" class="plain_text"><input type="text" name="title" size="50"> </td>
        </tr>
        <tr>
          <td valign="top" class="relevance">Description: </td>
          <td align="left" class="plain_text">%%submissionbox%% <br>
          Max 255 Characters </td>
        </tr>
        <tr>
          <td class="relevance">Keywords: </td>
          <td align="left" class="plain_text"><input type="text" name="keywords" size="50"> </td>
        </tr>
        <tr>
          <td class="relevance">URL: </td>
          <td align="left" class="plain_text"><input type="text" name="url" size="50" value="http://"> </td>
        </tr>
        <tr>
          <td class="relevance">Modify Password: </td>
          <td align="left" class="plain_text"><input type="password" name="password1" size="20"> </td>
        </tr>
        <tr>
          <td class="relevance">Confirm Modify Password: </td>
          <td align="left" class="plain_text"><input type="password" name="password2" size="20"> </td>
        </tr>
        <tr>
          <td class="relevance">Suggest a Category: </td>
          <td align="left" class="plain_text"><input type="text" name="csuggestion" size="40"> </td>
        </tr>
        <tr>
          <td class="relevance">Contact Person for This Link:</td>
          <td align="left" class="plain_text"><input type="text" name="sname" size="30"></td>
        </tr>
        <tr>
          <td class="plain_text"><strong>Contact Email Address For This Link:</strong></td>
          <td align="left" class="plain_text"><input type="text" name="email" size="50"></td>
        </tr>
        <tr>
          <td class="relevance">Subscribe to mailing list?</td>
          <td align="left" class="plain_text"><input type="checkbox" name="mlist" value="Y" checked> </td>
        </tr>
        <tr>
          <td class="plain_text"></td>
          <td align="left" class="plain_text">          %%imgbox%% <br>
          Please type the letters listed above: <br>
          <input type="text" name="letters" size="22"></td>
        </tr>
        <tr>
          <td class="plain_text"></td>
          <td align="left" class="plain_text"><input type="submit" class="psbutton" value="   Submit   " name="B1">
            <input type="hidden" name="ia" value="!!ia!!">
            <input type="hidden" name="p" value="!!p!!"></td>
        </tr>
      </table>
    </form>
    </td>
  </tr>
</table>
];



$this->{add_urlp} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add Premium URL</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!addurlcgi!!">
      <table width="95%"  border="0" align="center" cellpadding="5" cellspacing="1">
          <tr>
            <td colspan="2"><span class="plain_text"><span style="color:red"><strong>!!error_text!!</strong></span></span></td>
          </tr>
          <tr>
            <td colspan="2" align="left" class="plain_text">You have chosen to add your URL in the following category: <br>
              <strong>%%add_category%%</strong><br>
            <br></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>Title: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="title" size="50"> </td>
          </tr>
          <tr>
            <td width="30%" align="left" valign="top" class="plain_text"><strong>Description: </strong></td>
            <td width="70%" align="left" class="plain_text">%%submissionbox%% <br>
            Max 255 Characters </td>
          </tr>
          <tr>
            <td width="30%" align="left" valign="top" class="plain_text"><strong>Keywords: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="keywords" size="50"> </td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>URL: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="url" size="50" value="http://"> </td>
          </tr>
          <tr>
            <td width="30%" align="left" valign="top" class="plain_text"><strong>Modify Password: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="password" name="password1" size="20"> </td>
          </tr>
          <tr>
            <td width="30%" align="left" valign="top" class="plain_text"><strong>Confirm Modify Password: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="password" name="password2" size="20"> </td>
          </tr>
          <tr>
            <td width="30%" align="left" valign="top" class="plain_text"><strong>Suggest a Category: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="csuggestion" size="40"> </td>
          </tr>
          <tr>
            <td width="30%" align="left" valign="top" class="plain_text"><strong>Contact Person for This Link:</strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="sname" size="30"> </td>
          </tr>
          <tr>
            <td align="left" class="plain_text"><strong>Contact Email Address For This Link:</strong></td>
            <td align="left" class="plain_text"><input type="text" name="email" size="50"></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>S</strong><strong>ubscribe to mailing list?</strong></td>
            <td width="70%" align="left" class="plain_text"><input type="checkbox" name="mlist" value="Y" checked> </td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"></td>
            <td width="70%" align="left" class="plain_text">          %%imgbox%% <br>
              Please type the letters listed above: <br>
            <input type="text" name="letters" size="22"></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"></td>
            <td width="70%" align="left" class="plain_text"><input type="submit" class="psbutton" value="   Submit   " name="B1">
              <input type="hidden" name="catid" value="!!catid!!">
              <input type="hidden" name="ia"
      value="!!ia!!">
            <input type="hidden" name="p" value="!!p!!"></td>
          </tr>
        </table>
    </form>    </td>
  </tr>
</table>

];




$this->{add_url_instructions} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add URL Instructions </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote class="plain_text"> You are currently not in a category where a url can be added. <br>
        <br>
To add your URL, please go to the category where you think your web site
    would suite the category best. Then click on 'Add Url' to add your web site to the index.         </blockquote></td>
  </tr>
</table>
];



$this->{locked} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Category Locked </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote><span class="plain_text">You cannot submit a new submission to this category because it is locked.
      Please use a sub category of this category to submit your submission to.<br>
      <br>      
      <strong><a href="" onClick="history.go(-1); return false;">Go Back</a></strong></span><br>
      
    </blockquote>
    </td>
  </tr>
</table>
];



$this->{add_url_problem} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Problem </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote> <span class="plain_text"><strong>%%problem%% </strong>      <a href="" onClick="history.go(-1); return false;"><br>
      <br>
      Go Back</a></span> </blockquote>
    </td>
  </tr>
</table>
];



$this->{add_url_success} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left"><span class="page_heading"><a href="!!top!!">Top</a> :: Thanks for submitting
    your URL</span></td>
  </tr>
  <tr>
    <td align="center" class="plain_text">Your URL will be visible in our directory as soon as we have reviewed
      your listing. 
    </td>
  </tr>
</table>
];



$this->{modify_link} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Modify Link </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!modify_cgi!!">
      <table width="95%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td><strong class="link_title">!!title_with_link!! </strong>!!rating_image!! </td>
          </tr>
          <tr>
            <td><span class="link_description">!!description!! </span></td>
          </tr>
          <tr>
            <td><strong class="link_url">!!url!! </strong></td>
          </tr>
          <tr>
            <td><span class="from_category">From: <strong>!!category!! </strong></span></td>
          </tr>
          <tr>
            <td><span class="ratings_votes">Rating: <strong>!!rating!! | </strong>Votes: <strong>!!votes!! | </strong>Hits: <strong>!!Hits!! </strong></span></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td><span class="plain_text"><strong class="plain_text">Modify Password:</strong>
                <input type="password" name="password" size="30">
                <input
            type="submit" class="psbutton" value="    Modify    " name="B1">
                <input type="hidden" name="cid" value="!!cid!!">
                <input type="hidden" name="id"
        value="!!id!!">
            </span></td>
          </tr>
        <tr>
            <td><span class="plain_text">Lost your password? <a href="!!scripts_url!!/modify4.cgi">Click here to retrieve your
            password</a></span></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>
];



$this->{modify_link_problem} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left"><span class="page_heading"><a href="!!top!!">Top</a> :: Problem</span></td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote> <span class="plain_text">%%problem%%      <br>
      <br>
      <strong><a href="" onClick="history.go(-1); return false;">Go Back</a></strong></span><br>
    </blockquote>
    </td>
  </tr>
</table>
];



$this->{modify_link_success} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Success </td>
  </tr>
  <tr>
    <td align="center" valign="top" class="plain_text">Your link has been modified. Your changes are currently pending review and will take
    effect as soon as it has been reviewed. </td>
  </tr>
</table>
];



$this->{modify_link_edit} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Modify Link</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!modify_cgi!!"
    ENCTYPE="multipart/form-data">
        <table width="95%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td width="30%" class="plain_text"><strong>Title: </strong></td>
            <td width="70%" class="plain_text"><input type="text" name="title" size="30" value="%%title%%"></td>
          </tr>
          <tr>
            <td valign="top" class="plain_text"><strong>Description: </strong></td>
            <td class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td valign="top" class="plain_text"><strong>Keywords: </strong></td>
            <td class="plain_text"><input type="text" name="keywords" size="50"
          value="%%keywords%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>URL: </strong></td>
            <td class="plain_text"><input type="text" name="url" size="50" value="%%url%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>Your Name: </strong></td>
            <td class="plain_text"><input type="text" name="name" size="30" value="%%name%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>Email: </strong></td>
            <td class="plain_text"><input type="text" name="email" size="50" value="%%email%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>Modify Password: </strong></td>
            <td class="plain_text"><input type="text" name="password" size="30"
          value="%%password%%"></td>
          </tr>
          <tr>
            <td class="plain_text"></td>
            <td class="plain_text">If you want to have this link moved to another category,
              please specify the category below. Also use the box below to let us know if you have any
              comments/notes regarding the modification of this link. <strong>(Optional) </strong><br>
              %%notesbox%% </td>
          </tr>
          <tr>
            <td class="plain_text"></td>
            <td class="plain_text"><input type="submit" class="psbutton" value="   Apply Changes   " name="B1">
              <input type="hidden" name="cid" value="!!cid!!">
              <input type="hidden" name="id"
      value="!!id!!">
              <input type="hidden" name="lnkpassword" value="!!password!!">
              Note
              that all modifications are first reviewed  before 
              changes are applied. </td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>

];


$this->{modify_link_editp} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Modify Premium Link</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!modify_cgi!!">
        <table width="95%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td width="30%" class="plain_text"><strong>Title: </strong></td>
            <td width="70%" class="plain_text"><input type="text" name="title" size="30" value="%%title%%"></td>
          </tr>
          <tr>
            <td valign="top" class="plain_text"><strong>Description: </strong></td>
            <td class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td valign="top" class="plain_text"><strong>Keywords: </strong></td>
            <td class="plain_text"><input type="text" name="keywords" size="50"
          value="%%keywords%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>URL: </strong></td>
            <td class="plain_text"><input type="text" name="url" size="50" value="%%url%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>Your Name: </strong></td>
            <td class="plain_text"><input type="text" name="name" size="30" value="%%name%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>Email: </strong></td>
            <td class="plain_text"><input type="text" name="email" size="50" value="%%email%%"></td>
          </tr>
          <tr>
            <td class="plain_text"><strong>Modify Password: </strong></td>
            <td class="plain_text"><input type="text" name="password" size="30"
          value="%%password%%"></td>
          </tr>
          <tr>
            <td class="plain_text"></td>
            <td class="plain_text">If you want to have this link moved to another category,
              please specify the category below. Also use the box below to let us know if you have any
              comments/notes regarding the modification of this link. <strong>(Optional) </strong><br>
              %%notesbox%% </td>
          </tr>
          <tr>
            <td class="plain_text"></td>
            <td class="plain_text"><input type="submit" class="psbutton" value="   Apply Changes   " name="B1">
              <input type="hidden" name="cid" value="!!cid!!">
              <input type="hidden" name="id"
      value="!!id!!">
              <input type="hidden" name="lnkpassword" value="!!password!!">
              Note
              that all modifications are first reviewed before
              changes are applied. </td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>

];


$this->{modify_instructions} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Modify Link</td>
  </tr>
  <tr>
    <td align="center" class="plain_text">To modify your link, please search for your link. Once you've found it click on the
    'Modify' link that should be available with your link.</td>
  </tr>
</table>
];


$this->{retrievepass} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Modify Link </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote> <span class="plain_text">Enter your email address below and your password will be sent to you via
        email. </span><br><br>
        <form method="POST" action="!!email_script!!">
          <span class="plain_text"><strong>Your Email Address: </strong>
          <input type="text" name="email" size="50">
          <input
        type="submit" class="psbutton" value="Send Password" name="sbutton">
          </span>
        </form>
      </blockquote></td>
  </tr>
</table>
];


$this->{retrievepass_ok} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Password Sent </td>
  </tr>
  <tr>
    <td align="center" class="plain_text">Your password has been sent. You should receive your password via email shortly.    </td>
  </tr>
</table>
];


$this->{retrievepass_prb} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Problem </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote> <span class="plain_text">The password that you entered was incorrect or there are no link in our database
      associated with the password you entered. <br>
      <br>
    </span>      <strong class="plain_text"><a href="" onClick="history.go(-1); return false;">Go Back</a> </strong>    </blockquote>
    </td>
  </tr>
</table>
];


$this->{rgs_msgregister} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add URL </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!rgs_login!!">
        <table width="90%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td colspan="2" align="center" class="plain_text"><span class="plain_text" style="text-align:center">You have to be logged in to be able to add your link. If you don't have an account, then <a
      href="!!account_create!!">click here to create one.</a></span></td>
          </tr>
          <tr>
            <td width="40%" align="right" class="plain_text"><strong>User Name: </strong></td>
            <td width="60%" align="left" class="plain_text"><input name="rgs_user" size="20"></td>
          </tr>
          <tr>
            <td width="40%" align="right" class="plain_text"><strong>Password: </strong></td>
            <td width="60%" align="left" class="plain_text"><input type="password" name="rgs_pass" size="20"></td>
          </tr>
          <tr>
            <td width="40%" align="left" class="plain_text"></td>
            <td width="60%" align="left" class="plain_text"><input type="submit" class="psbutton" value="   Login   " name="B1"></td>
          </tr>
          <tr>
            <td width="40%" align="left" class="plain_text"></td>
            <td width="60%" align="left" class="plain_text">Lost your password? <a href="!!retreive_password!!">Click here to retrieve your
              password </a></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>
];




$this->{rgs_register} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Register/Create an
      Account </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!rgs_register!!">
        <table width="95%" border="0" align="center"
      cellpadding="6" cellspacing="1">
          <tr>
            <td width="100%" colspan="2" align="left" class="plain_text">Account registration allows you to submit your
              link and/or post comments about any links. Note that an email message is sent to you to
              activate your account after you have filled in this form. You will then need to click the
              link that is available in the email to activate your account. <strong>Note that you have
              to have cookies enabled to be able to log into your account to add your link. </strong></td>
          </tr>
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong> <span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="30%" class="plain_text"><strong>Choose a User Name: </strong></td>
            <td width="70%" class="plain_text"><input type="text" name="rgs_user" size="20"
          value="!!rgs_user!!"></td>
          </tr>
          <tr>
            <td class="relevance">Choose a Password: </td>
            <td class="plain_text"><input type="password" name="rgs_pass" size="20" value="!!rgs_pass!!"></td>
          </tr>
          <tr>
            <td class="relevance">Verify Password: </td>
            <td class="plain_text"><input type="password" name="rgs_pass2" size="20" value="!!rgs_pass2!!"></td>
          </tr>
          <tr>
            <td class="relevance">Name: </td>
            <td class="plain_text"><input type="text" name="name" size="32" value="!!name!!"></td>
          </tr>
          <tr>
            <td class="relevance">Email Address: </td>
            <td class="plain_text"><input type="text" name="email" size="32" value="!!email!!"></td>
          </tr>
          <tr>
            <td class="relevance">Confirm Email Address: </td>
            <td class="plain_text"><input type="text" name="email2" size="32" value="!!email2!!"></td>
          </tr>
          <tr>
            <td class="relevance">Subscribe to Newsletter? </td>
            <td class="plain_text"><input type="checkbox" name="mlist" value="Y" checked></td>
          </tr>
          <tr>
            <td class="plain_text"></td>
            <td class="plain_text">%%imgbox%% <br>
              Type in the letters as indicated above: <br>
              <input type="text" name="letters" size="20"></td>
          </tr>
          <tr>
            <td></td>
            <td><input type="submit" class="psbutton" value="Create Account" name="B1">
              <input type="hidden" name="fct" value="register"></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>
];


$this->{rgs_regsuccess} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: An account has been
    created for you. </td>
  </tr>
  <tr>
    <td valign="top" align="center"><p><span class="plain_text">An activation email has been sent to the email address you supplied. Inside this email
      will be a link that you will need to click to activate your account. You can log into your
    account and submit your link when you have activated your account. </span></p></td>
  </tr>
</table>
];





$this->{rgs_actsuccess} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Your account has been
      activated! </td>
  </tr>
  <tr>
    <td><form method="POST" action="!!rgs_login!!">
        <table width="95%" border="0" align="center" cellpadding="5">
          <tr>
            <td width="45%" align="right" class="plain_text"><strong>Login: </strong></td>
            <td width="55%" class="plain_text"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text">User Name: </td>
            <td class="plain_text"><input type="text" name="rgs_user" size="20"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text">Password: </td>
            <td class="plain_text"><input type="password" name="rgs_pass" size="20"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text"></td>
            <td class="plain_text"><input type="submit" class="psbutton" value="Login" name="B1"></td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>
];




$this->{rgs_actfailed} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: The link you clicked to
      activate your account was not valid. </td>
  </tr>
  <tr>
    <td valign="top" align="left">
      <form method="POST" action="!!rgs_resendact!!">
      <table width="95%" border="0" align="center" cellpadding="5">
          <tr>
            <td colspan="2" align="center" class="plain_text"><strong>Re-send activation email? </strong></td>
          </tr>
          <tr>
            <td colspan="2" align="center" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="45%" align="right" class="plain_text">User Name: </td>
            <td width="55%" class="plain_text"><input type="text" name="rgs_user" size="20"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text">Password: </td>
            <td class="plain_text"><input type="password" name="rgs_pass" size="20"></td>
          </tr>
          <tr>
            <td align="left"></td>
            <td><input type="submit" class="psbutton" value="Re-send Activation Email"
          name="B1"></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>
];


$this->{rgs_resend} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Resend Activation Email</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!rgs_resendact!!">
        <table width="95%" border="0" align="center" cellpadding="5">
          <tr>
            <td width="100%" colspan="2" align="center" class="plain_text"><strong>Re-send activation email? </strong></td>
          </tr>
          <tr>
            <td colspan="2" align="center" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="45%" align="right" class="plain_text">User Name: </td>
            <td width="50%" class="plain_text"><input type="text" name="rgs_user" size="20"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text">Password: </td>
            <td class="plain_text"><input type="password" name="rgs_pass" size="20"></td>
          </tr>
          <tr>
            <td></td>
            <td><input type="submit" class="psbutton" value="Re-send Activation Email"
          name="B1"></td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>
];


$this->{rgs_sent} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Your account activation
    email has been sent. </td>
  </tr>
  <tr>
    <td valign="top" align="center"><span class="plain_text">You will receive your account activation email shortly. </span></td>
  </tr>
</table>
];




$this->{rgs_login} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Login </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!rgs_login!!">
        <table width="95%" border="0" align="center" cellpadding="5">
          <tr>
            <td width="40%" align="right" class="plain_text">&nbsp;</td>
            <td width="60%" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!! </span></strong></td>
          </tr>
          <tr>
            <td align="right" class="plain_text">User Name: </td>
            <td align="left" class="plain_text"><input type="text" name="rgs_user" size="20"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text">Password: </td>
            <td align="left" class="plain_text"><input type="password" name="rgs_pass" size="20"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text"></td>
            <td align="left" class="plain_text"><input type="submit" class="psbutton" value="Login" name="B1"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text"></td>
            <td align="left" class="plain_text">Lost your Password? <a href="!!retrieve_password!!">Retrieve
              Password </a><br>
              <br>
              <a href="!!resend_activation!!">Resend Activation Email </a></td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>

];


$this->{rgs_logout} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="center" valign="top" class="plain_text"><strong>You have been logged out. </strong></td>
  </tr>
</table>
];



$this->{rgs_retrievepass} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Retrieve Password </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!rgs_pretrieve!!">
        <table width="95%" border="0" align="center" cellpadding="5">
          <tr>
            <td width="100%" height="18" align="center" class="plain_text"><strong> <span style="color:#FF0000"> !!error_text!! </span></strong></td>
          </tr>
          <tr>
            <td width="100%" height="23" align="center" class="plain_text">Please provide your email address:
              <input
          type="text" name="email" size="42">
              <input type="submit" class="psbutton" value="Send" name="B1"></td>
          </tr>
          <tr>
            <td height="23" align="left" class="plain_text">&nbsp;</td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>
];



$this->{rgs_retrievepass_ok} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Password Information
    Sent </td>
  </tr>
  <tr>
    <td align="center">
      <span class="plain_text">Your password information has been sent to your email address. You should receive it within a couple of minutes. </span></td>
  </tr>
</table>
];


$this->{rgs_cpmain} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left"><strong class="page_heading">You are Logged-In!</strong></td>
  </tr>
  <tr>
    <td valign="top" align="left">!!user_links!! </td>
  </tr>
</table>

];




$this->{rgs_editacc} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading">Edit Account Details</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!save_details!!">
        <table width="95%" border="0" align="center"
      cellpadding="5" cellspacing="1">
          <tr>
            <td width="706" colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="706" align="left" class="plain_text"><strong>User Name: </strong></td>
            <td width="70%" align="left" class="plain_text"><strong>!!rgsuser!! </strong></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Password: </td>
            <td align="left" class="plain_text"><input type="text" name="rgspass" size="20"
          value="!!rgspass!!"></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Name: </td>
            <td align="left" class="plain_text"><input type="text" name="rgsname" size="30"
          value="!!rgsname!!"></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Email Address: </td>
            <td align="left" class="plain_text"><input type="text" name="rgsemail" size="50"
          value="!!rgsemail!!"></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Subscribe to Newsletter? </td>
            <td align="left" class="plain_text"><input type="checkbox" name="mlist" value="Y" !!checked!!></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"></td>
            <td align="left" class="plain_text"><input type="submit" class="psbutton" value="   Save   " name="B1">
              <input type="hidden" name="fct" value="save"></td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>
];




$this->{rgs_saveacc} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top">%%incl_gluser_cp_links%% </td>
  </tr>
</table>

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" class="page_heading">Account Details Updated</td>
  </tr>
  <tr>
    <td align="center" valign="top"><strong><a href="!!rgs_login!!" class="plain_text">Click
    here to continue</a></strong></td>
  </tr>
</table>
];



$this->{rgs_add_url_med} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%%</td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add URL </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!addurlcgi!!"
    ENCTYPE="multipart/form-data">
        <table width="95%" border="0" align="center" cellpadding="5" cellspacing="1">
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>Category: </strong></td>
            <td width="70%" align="left" class="plain_text">%%category_dropdown%% </td>
          </tr>
          <tr>
            <td align="left" class="relevance">Title: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="title" type="text" value="!!title!!" size="30">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Description: </td>
            <td align="left" class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Keywords: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="keywords" type="text" value="!!keywords!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="relevance">URL: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input type="text" name="url" size="50" value="!!url!!">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Suggest a Category: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="csuggestion" type="text" value="!!csuggestion!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Contact Person for This Link: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="sname" type="text" value="!!sname!!" size="30">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Contact Email Address For This Link: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="email" type="text" value="!!email!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="relevance"></td>
            <td align="left" class="plain_text"> %%imgbox%% <br>
              Type the letters listed above: <br>
              <input type="text" name="letters" size="17"></td>
          </tr>
          <tr>
            <td align="left"></td>
            <td align="left"><input type="submit" class="psbutton" value="   Submit   " name="B1">
              <input type="hidden" name="ia" value="!!ia!!">
              <input type="hidden" name="p" value="!!p!!"></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>

];





$this->{rgs_add_url} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add URL</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!addurlcgi!!">
        <table width="95%"
      border="0" align="center" cellpadding="5" cellspacing="1">
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td colspan="2" align="left" class="plain_text">You have chosen to add your URL in the following category: <strong>%%add_category%% </strong></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>Title: </strong></td>
            <td width="70%" align="left" class="plain_text"><span class="normaltext">
              <input name="title" type="text" value="!!title!!" size="30">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Description: </strong></td>
            <td align="left" class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Keywords: </strong></td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="keywords" type="text" value="!!keywords!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"><strong>URL: </strong></td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input type="text" name="url" size="50" value="!!url!!">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Suggest a Category: </strong></td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="csuggestion" type="text" value="!!csuggestion!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Your Name: </strong></td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="sname" type="text" value="!!sname!!" size="30">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"><strong>Contact Email Address For This Link: </strong></td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="email" type="text" value="!!email!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"></td>
            <td align="left" class="plain_text"> %%imgbox%% <br>
              Type the letters listed above: <br>
              <input type="text" name="letters" size="17"></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"></td>
            <td align="left" class="plain_text"><input type="submit" class="psbutton" value="   Submit   " name="B1">
              <input type="hidden" name="catid" value="!!catid!!">
              <input type="hidden" name="ia"
      value="!!ia!!">
              <input type="hidden" name="p" value="!!p!!"></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>
];





$this->{rgs_add_url_medp} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add Premium URL </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!addurlcgi!!"
    ENCTYPE="multipart/form-data">
        <table width="95%" border="0" align="center" cellpadding="5" cellspacing="1">
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>Category: </strong></td>
            <td width="70%" align="left" class="plain_text">%%category_dropdown%% </td>
          </tr>
          <tr>
            <td align="left" class="relevance">Title: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="title" type="text" value="!!title!!" size="30">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Description: </td>
            <td align="left" class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Keywords: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="keywords" type="text" value="!!keywords!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="relevance">URL: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input type="text" name="url" size="50" value="!!url!!">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Suggest a Category: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="csuggestion" type="text" value="!!csuggestion!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Contact Person for This Link: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="sname" type="text" value="!!sname!!" size="30">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Contact Email Address For This Link: </td>
            <td align="left" class="plain_text"><span class="normaltext">
              <input name="email" type="text" value="!!email!!" size="50">
            </span></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"></td>
            <td align="left" class="plain_text"> %%imgbox%% <br>
              Type the letters listed above: <br>
              <input type="text" name="letters" size="17"></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"></td>
            <td align="left" class="plain_text"><input type="submit" class="psbutton" value="   Submit   " name="B1">
              <input type="hidden" name="ia" value="!!ia!!">
              <input type="hidden" name="p" value="!!p!!"></td>
          </tr>
        </table>
    </form></td>
  </tr>
</table>
];




$this->{rgs_add_urlp} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add Premium URL</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!addurlcgi!!">
        <table width="95%"
      border="0" align="center" cellpadding="5" cellspacing="1">
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td colspan="2" align="left" class="plain_text">You have chosen to add your URL in the following category: <strong>%%add_category%% </strong></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>Title: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="title" size="30" ></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Description: </strong></td>
            <td align="left" class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Keywords: </strong></td>
            <td align="left" class="plain_text"><input type="text" name="keywords" size="50"
          ></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"><strong>URL: </strong></td>
            <td align="left" class="plain_text"><input type="text" name="url" size="50" value="http://"
          ></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Suggest a Category: </strong></td>
            <td align="left" class="plain_text"><input type="text" name="csuggestion" size="50"
          ></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="plain_text"><strong>Your Name: </strong></td>
            <td align="left" class="plain_text"><input type="text" name="sname" size="30"></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"><strong>Contact Email Address For This Link: </strong></td>
            <td align="left" class="plain_text"><input type="text" name="email" size="50"></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"></td>
            <td align="left" class="plain_text"> %%imgbox%% <br>
              Type the letters listed above: <br>
              <input type="text" name="letters" size="17"></td>
          </tr>
          <tr>
            <td align="left"></td>
            <td align="left"><input type="submit" class="psbutton" value="   Submit   " name="B1">
              <input type="hidden" name="catid" value="!!catid!!">
              <input type="hidden" name="ia"
      value="!!ia!!">
              <input type="hidden" name="p" value="!!p!!"></td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>
];




$this->{rgs_add_url_instructions} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Add URL Instructions</td>
  </tr>
  <tr>
    <td align="left" valign="top" class="plain_text">You are currently not in a category where a url can be added. <br>
      <br>
      To add your URL, please go to the category where you think your web site
      would suite the category best. <br>
      <br>
      Then click on 'Add Url' to add your web site to the index. You may also use the <a href="!!advanced!!">category search </a>from the
      advanced search form. </td>
  </tr>
</table>
];



$this->{rgs_locked} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Category Locked </td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote class="plain_text"> You cannot submit to this category because it is locked.
        <br><br>
        Please use a sub category of this category to submit your submission to.      
        <br><br>
        <strong><a href="" onClick="history.go(-1); return false;">Go Back</a></strong></blockquote>
    </td>
  </tr>
</table>
];



$this->{rgs_add_url_problem} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Problem</td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote> <span class="plain_text"><strong>%%problem%% <br>
      <br>
    </strong>      <a href="" onClick="history.go(-1); return false;">Go Back</a> </span><br>
    </blockquote>
    </td>
  </tr>
</table>
];




$this->{rgs_add_url_success} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Thanks for submitting
      your URL</td>
  </tr>
  <tr>
    <td valign="top" align="center"><span class="plain_text">Your URL will be visible in our directory as soon as we have reviewed your listing.      <strong><a href="!!rgs_login!!">Click here to continue.</a></strong></span></td>
  </tr>
</table>
];



$this->{rgs_modify_link_edit} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading">Modify Link</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!modify_cgi!!"
    ENCTYPE="multipart/form-data">
        <table width="95%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>Title: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="title" size="30" value="%%title%%"
          ></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Description: </td>
            <td align="left" class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Keywords: </td>
            <td align="left" class="plain_text"><input type="text" name="keywords" size="50"
          value="%%keywords%%" ></td>
          </tr>
          <tr>
            <td align="left" class="relevance">URL: </td>
            <td align="left" class="plain_text"><input type="text" name="url" size="50" value="%%url%%"></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Contact Person: </td>
            <td align="left" class="plain_text"><input type="text" name="name" size="30" value="%%name%%"></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Contact Email Address for this Link: </td>
            <td align="left" class="plain_text"><input type="text" name="email" size="50" value="%%email%%"></td>
          </tr>
          <tr>
            <td align="left" class="relevance"></td>
            <td align="left" class="plain_text">If you want to have this link moved to another category,
              please specify the category below. Also use the box below to let us know if you have any
              comments/notes regarding the modification of this link. <strong>(Optional) </strong><br>
              %%notesbox%% <br></td>
          </tr>
          <tr>
            <td align="left" class="plain_text"></td>
            <td align="left" class="plain_text"><input type="submit" class="psbutton" value="   Apply Changes   " name="B1">
              <input type="hidden" name="cid" value="!!cid!!">
              <input type="hidden" name="id"
      value="!!id!!">
              <input type="hidden" name="lnkpassword" value="!!password!!">
              Note
              that all modifications are first reviewed  before changes are applied. </td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>


];





$this->{rgs_modify_link_editp} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading">Modify Premium Link </td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!modify_cgi!!" ENCTYPE="multipart/form-data">
        <table border="0" cellpadding="6" cellspacing="1" >
          <tr>
            <td colspan="2" align="left" class="plain_text"><strong><span style="color:#FF0000">!!error_text!!</span></strong></td>
          </tr>
          <tr>
            <td width="30%" align="left" class="plain_text"><strong>Title: </strong></td>
            <td width="70%" align="left" class="plain_text"><input type="text" name="title" size="30" value="%%title%%"
          ></td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Description: </td>
            <td align="left" class="plain_text">%%submissionbox%% <br>
              Max 255 Characters </td>
          </tr>
          <tr>
            <td align="left" valign="top" class="relevance">Keywords: </td>
            <td align="left" class="plain_text"><input type="text" name="keywords" size="50"
          value="%%keywords%%" ></td>
          </tr>
          <tr>
            <td align="left" class="relevance">URL: </td>
            <td align="left" class="plain_text"><input type="text" name="url" size="50" value="%%url%%"
          ></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Contact Person: </td>
            <td align="left" class="plain_text"><input type="text" name="name" size="30" value="%%name%%"></td>
          </tr>
          <tr>
            <td align="left" class="relevance">Contact Email Address for this Link: </td>
            <td align="left" class="plain_text"><input type="text" name="email" size="50" value="%%email%%"></td>
          </tr>
          <tr>
            <td align="left" class="relevance"></td>
            <td align="left" class="plain_text">If you want to have this link moved to another category,
              please specify the category below. Also use the box below to let us know if you have any
              comments/notes regarding the modification of this link. <strong>(Optional) </strong><br>
              %%notesbox%% <br></td>
          </tr>
          <tr>
            <td align="left" class="relevance"></td>
            <td align="left" class="plain_text"><input type="submit" class="psbutton" value="   Apply Changes   " name="B1">
              <input type="hidden" name="cid" value="!!cid!!">
              <input type="hidden" name="id" value="!!id!!">
              <input type="hidden" name="lnkpassword" value="!!password!!">
              Note
              that all modifications are first reviewed before 
              changes are applied. </td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>
];




$this->{rgs_modify_link_problem} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading">Modify Link</td>
  </tr>
  <tr>
    <td valign="top" align="left"><span class="plain_text">%%problem%% </span> <span class="plain_text"><strong><a href="" onClick="history.go(-1); return false;"><br>
      <br>
      Go Back</a> </strong></span></td>
  </tr>
</table>
];




$this->{rgs_modify_link_success} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%%</td>
  </tr>
</table>

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading">Link Modified</td>
  </tr>
  <tr>
    <td valign="top" align="left"><blockquote class="plain_text"> Your link has been modified. Your changes are currently pending review and will take
    effect as soon as it has been reviewed. <a href="!!rgs_login!!"><strong><br>
    <br>
    Click here to continue</strong></a> </blockquote> </td>
  </tr>
</table>
];




$this->{rgs_modify_instructions} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td valign="top" align="left">%%incl_gluser_cp_links%% </td>
  </tr>
</table>
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading">Modify Link</td>
  </tr>
  <tr>
    <td valign="top" align="left"><form method="POST" action="!!rgs_login!!">
        <table width="70%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr>
            <td colspan="2" align="left" class="plain_text"><p class="plain_text">You have to be logged in to be able to modify your link. If this is your link but you
                don't have an account for it or the link is not linked to your account then contact us so
                that we can add this link to your account. Note that you will need an account if you would
                like us to add this link to your account. </p>
              <p class="plain_text">If you don't have an account and you would like to add your link, then <a
        href="!!account_create!!">click here to create one. </a></p></td>
          </tr>
          <tr>
            <td width="40%" align="right" class="plain_text"><strong>Login:</strong></td>
            <td width="60%" align="left" class="plain_text">&nbsp;</td>
          </tr>
          <tr>
            <td width="20%" align="right" class="plain_text"><strong>User Name: </strong></td>
            <td width="80%" align="left" class="plain_text"><input name="rgs_user" size="20"></td>
          </tr>
          <tr>
            <td width="20%" align="right" class="plain_text"><strong>Password: </strong></td>
            <td width="80%" align="left" class="plain_text"><input type="password" name="rgs_pass" size="20"></td>
          </tr>
          <tr>
            <td width="20%" align="right" class="plain_text"></td>
            <td width="80%" align="left" class="plain_text"><input type="submit" class="psbutton" value="   Login   " name="B1"></td>
          </tr>
          <tr>
            <td align="right" class="plain_text"></td>
            <td align="left" class="plain_text">Lost your password? <a href="!!retreive_password!!">Click here to retrieve your
              password </a></td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>

];



$this->{rgs_rcomment} = qq[
<table border="0" cellpadding="7" cellspacing="0" width="97%" align="center">
  <tr>
    <td valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Comments</td>
  </tr>
  <tr>
    <td align="center" valign="top" class="plain_text">&nbsp; You can at present not post a comment because
    you need to register an account to post a comment. <br>    
    <a href="!!register!!" target="_blank"><strong>You can click here to register an account.</strong></a><br>
    <br>
    If you have already registered an account then please <br>
    <a href="!!rgs_login!!" target="_blank"><strong>click here to log into your account.</strong></a></td>
  </tr>
</table>
];


$this->{rgs_rrate} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Cast Rating</td>
  </tr>
  <tr>
    <td align="center" class="plain_text">You can at present not rate this link because
    you need to register an account to rate a link. <br>
    <a href="!!register!!" target="_blank"><strong>You can click here to register an account. </strong></a><br>
    <br>
    If you have already registered an account then please <br>
    <a href="!!rgs_login!!" target="_blank"><strong>click here to log into your account.</strong></a></td>
  </tr>
</table>

];



$this->{rgs_regsuccess_paypal} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Submission Received</td>
  </tr>
  <tr>
    <td align="center" valign="top" class="plain_text">&nbsp;Thanks for purchasing a premium listing!</td>
  </tr>
</table>
];


$this->{rgs_upgrade} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Order Options</td>
  </tr>
  <tr>
    <td align="center" valign="top" class="plain_text">The <em>premium Add URL Order Settings section</em> will provide you with HTML code to place here. <br>
      To get the HTML code, go to the PowerSeek control panel &gt;&gt; settings &gt;&gt; Premium Link Settings<br>
      You will receive HTML code that you can place here after saving the settings.<br>
      The HTML code will represent ordering options that users can choose when buying a premium link.</td>
  </tr>
</table>
];


$this->{rgs_upgrade_paypal_success} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Upgrade Complete</td>
  </tr>
  <tr>
    <td align="center" valign="top" class="plain_text">Thanks for uprading your listing to a premium listing!</td>
  </tr>
</table>
];


$this->{contact_form} = qq[

<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><a href="!!top!!">Top</a> :: Contact Us</td>
  </tr>
  <tr>
    <td valign="top"><form name="form1" method="post" action="contactp.cgi">
        <table width="90%" border="0" align="center" cellpadding="6" cellspacing="1">
          <tr class="normaltext">
            <td colspan="2" valign="middle"><span class="plain_text"><span style="color:red"><strong>!!error!!</strong></span></span></td>
          </tr>
          <tr class="normaltext">
            <td valign="middle" width="23%"><span class="plain_text"><strong>Name:</strong></span></td>
            <td width="77%"><span class="plain_text">
              <input name="name" type="text" id="name" value="!!name!!" size="50">
              </span></td>
          </tr>
          <tr class="normaltext">
            <td valign="middle"><span class="plain_text"><strong>Email Address:</strong></span></td>
            <td><span class="plain_text">
              <input name="email" type="text" id="email" value="!!email!!" size="50">
              </span></td>
          </tr>
          <tr class="normaltext">
            <td valign="middle"><span class="plain_text"><strong>Subject: </strong></span></td>
            <td><span class="plain_text">
              <input name="subject" type="text" id="subject" value="!!subject!!" size="50">
              </span></td>
          </tr>
          <tr class="normaltext">
            <td valign="top"><span class="plain_text"><strong>Message:</strong></span></td>
            <td valign="top"><span class="plain_text">
              <textarea name="message" id="message" cols="50" rows="15">!!message!!</textarea>
              </span></td>
          </tr>
          <tr class="normaltext">
            <td valign="top">&nbsp;</td>
            <td valign="top"><span class="plain_text">%%imgbox%% <br>
              Type in the letters as indicated above: <br>
              <input type="text" name="letters" size="20">
              <strong></span></td>
          </tr>
          <tr class="normaltext">
            <td valign="top">&nbsp;</td>
            <td valign="top"><span class="plain_text">
              <input type="submit" name="button" id="button" value="Contact Us">
              </span></td>
          </tr>
        </table>
      </form></td>
  </tr>
</table>

];


$this->{contact_thank} = qq[
<table width="97%" border="0" align="center" cellpadding="7" cellspacing="0">
  <tr>
    <td align="left" valign="top" class="page_heading"><strong><a href="!!top!!">Top</a> :: Contact Us</strong></td>
  </tr>
  <tr>
    <td valign="top"><strong class="plain_text">Thanks! We will get back to you as soon as possible!</strong></td>
  </tr>
</table>
];


bless $this;
return $this;
}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line2($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line2($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line2($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line2($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line2($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line2($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line2($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line2($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line2($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line2($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line2($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line2($line, PASSWORD);}

if ($line =~ /^MAIL_METHOD/){$mail_method = &get_setup_line2($line, MAIL_METHOD);}
if ($line =~ /^SENDMAIL/){$sendmail = &get_setup_line2($line, SENDMAIL);}
if ($line =~ /^SMTP_SERVER/){$smtp_server = &get_setup_line2($line, SMTP_SERVER);}
if ($line =~ /^SMTP_USER/){$smtp_user = &get_setup_line2($line, SMTP_USER);}
if ($line =~ /^SMTP_PASS/){$smtp_pass = &get_setup_line2($line, SMTP_PASS);}

			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}

}


sub get_setup_line2
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}


1;