#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Category Drop Down Navigator
# DIZ: Allow visitors to navigate PowerSeek categories with dropdown menus.
# GRAPHIC: ic_dirm.gif
# VERSION: 0.9
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "gethtml") { &gethtml; }

####################################################################################

sub gethtml
{

$cid = $q->param('id');

if ($cid eq "")
	{
	print "<BR><b>Problem:</b>	 Please choose a category or specify a category ID."; exit;
	}

$iframe = qq[<iframe width="100%" id="display_iframe_dropdowns" 
name="cdropdowns"
src="$script_url/dropd.cgi?cid=$cid&amp;sub=y"
height="30"
scrolling="NO" 
frameborder="0"
> An iframe capable browser is 
required to view this web site.
</iframe>
];

print qq[<BR><textarea name="code2" id="code2" cols="70" rows="9">$iframe</textarea>
<BR>Place the above HTML code inside any PowerSeek template or external web page to display the sub categories of the chosen category.
];


}


sub start
{

$hbox = acs::get_heading_box("$web_url/ic_folders.gif", "Category Drop Down Navigator", qq[The Category Drop Down Navigator allows visitors to navigate PowerSeek categories with dropdown menus.]);

$catroot = qq[
<iframe width="100%" id="display_iframe_dropdowns" 
name="cdropdowns"
src="$script_url/dropd.cgi"
height="30"
scrolling="NO" 
frameborder="0"
> An iframe capable browser is 
required to view this web site.
</iframe>
];

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<script LANGUAGE="JavaScript">
<!-- Hide

$jspopup_code 

var dropdownstat = 0;
var lastdropdown = 0;

function xmlhttpPost(strURL, display_area, ddown) 
	 {

	 document.getElementById('AJImg').style.display='block';
	 
    var xmlHttpReq = false;
    var self = this;
  
  	 if (dropdownstat == ddown)
  	 	{
  	 	strURL = '$admin_url/admin77.cgi?fct=blank'; dropdownstat = 0;
  	 	}
  	 	//else { dropdownstat = ddown; }
  
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
	
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function() 
    	   {
         if (self.xmlHttpReq.readyState == 4) 
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText; 
         		document.getElementById('AJImg').style.display='none';
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
    
}


    
 // End Hide -->
 </script>
 <link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<form method="post" action="$admin_url/p_dropd.cgi" name="addu">
  <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
    <tr>
      <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
        <tr>
          <td background="$web_url/bar6.gif" class="normaltext"><strong>HTML Code For Category Displays From the Root Category:</strong></td>
        </tr>
        <tr>
          <td class="normaltext"> Place the following HTML code inside any PowerSeek template or external web page to display category dropdown menus:<BR>
            <BR>
            <b>
              <label>
                <textarea name="code" id="code" cols="70" rows="9">$catroot</textarea>
              </label>
            </b></td>
        </tr>
      </table></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
    <tr>
      <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
        <tr>
          <td background="$web_url/bar6.gif" class="normaltext"><strong>HTML Code For Sub Category Displays:</strong></td>
        </tr>
        <tr>
          <td class="normaltext"><p>If you would like to provide drop down menus of sub categories of a category then choose a category below.</p>
            <p>
              <label>
                <input type="submit" class="psbutton" name="choosecat" id="choosecat" value="Choose Category" onClick="popup('$admin_url/admin67.cgi',750,600, 400, 100);return false;">
              </label>
            </p>
            <p>Or supply category ID: 
              <label>
                <input name="crosslinkid" type="text" id="crosslinkid" size="10">
              </label>
            </p>
            <p> After choosing a category or specifying a category ID press the 'Get HTML button'.</p>
            <table width="100%" cellspacing="0" cellpadding="0">
              <tr>
                <td width="8%"><input type="submit" class="psbutton" name="choosecat2" id="choosecat2" value="Get HTML Code" 
              onClick="xmlhttpPost('$admin_url/p_dropd.cgi?fct=gethtml&id=' + addu.crosslinkid.value, 'result1', 1);return false;"></td>
                <td width="1%">&nbsp;</td>
                <td width="91%"><img src="$web_url/ajload.gif" width="24" height="24" id="AJImg" style="display: none;"></td>
              </tr>
            </table>
            <div id="result1"></div>
            </td>
        </tr>
      </table></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];

#<textarea name="code2" id="code2" cols="70" rows="15"></textarea>
#<img src="http://www/pseek5/ajload.gif" width="24" height="24" id="AJImg" style="display: none;">


}


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

