#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Raw SQL Query Tool
# DIZ: Enables you to do raw SQL queries on your database.
# GRAPHIC: ic_sql.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "configure") { &configure; }
if ($q->param('fct') eq "savesettings") { &savesettings; }
if ($q->param('fct') eq "instructions") { &instructions; }

####################################################################################

sub instructions
{

$gsettings = new_gsettings acs;
$fapi = $gsettings->{facebookappid};

if ($fapi < 1)
	{

		$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin", "The PowerSeek Facebook Login requires a Facebook App ID. <a href='p_facebook.cgi?fct=configure'>Click Here to supply the Facebook App ID</a>");

		print qq[
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>Facebook Plugin</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
		</head>
		<body>
		$hbox
		</body>
		</html>
		];
		exit;
	}
	



eval "use LWP::UserAgent";
if($@)
	{
	$lwp_useragent = "N";
	$lwp_useragent_err = $@;
	$lwp_notice = "<font color='red'>LWP::UserAgent</font><br>";
 	}
$@ = "";

##############

eval "use HTTP::Request::Common qw(GET)";
if($@)
	{
	$httprequest = "N";
	$httprequest_err = $@;
	$httprequest_notice = "<font color='red'>HTTP::Request::Common</font><br>";
 	}
$@ = "";

##############

eval "use Crypt::SSLeay";
if($@)
	{
	$cryptssl = "N";
	$cryptssl_err = $@;
	$cryptssl_notice = "<font color='red'>Crypt::SSLeay</font><br>";
 	}
$@ = "";

##############


if (($lwp_useragent eq "") and ($lwp_useragent eq "") and ($lwp_useragent eq ""))
	{
		$use_perl_modules = "Y";
	}
	else
	{
		$use_perl_modules = "N";
		
		$module_warning = qq[
		
		<table width="94%"  align="center">
		 <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
		      <td valign="top">&nbsp;</td>
		      <td valign="top">
		      <hr noshade size="1" width="100%" align="center">
		      	<p><b>Note that your web host or web server does not have the following Perl module(s) installed:</b></p>
		        <blockquote>
		          <p><strong>$lwp_notice $httprequest_notice $cryptssl_notice</strong></p>
		        </blockquote>
		      <p> It is recommended that you install the above mentioned Perl module(s) if possible so that they can be used in conjunction with your Facebook Login. PowerSeek will use alternative methods to connect users to Facebook but note that the alternative connection methods is not as secure. <strong>It is strongly recommended that you install the modules as mentioned above.</strong></p>
				<hr noshade size="1" width="100%" align="center">
		      </td>
 			</tr>
 		</table>
		];
	}

	

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin :: Implement Facebook Login", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<blockquote>
  <p><span class="normaltext"><strong>To implement the Facebook Login with PowerSeek do the following:</strong></span></p>
  <p><strong>Step 1:</strong></p>
  <blockquote>
    <p>Go to the PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt; 3. Add URL Templates &gt;&gt; Click on: <STRONG>User   Login</STRONG> to edit the User Login Template.</p>
  </blockquote>
  <p><strong>Step 2:</strong></p>
  <blockquote>
    <p>Inside the User Login template place the following text where you would like the Facebook Login button to appear: </p>
    <blockquote>
      <p><strong>!!facebook_login_button!!</strong></p>
    </blockquote>
    <p>After you placed !!facebook_login_button!! inside the Login Template the Facebook Login will be available to your visitors.</p>
  </blockquote>
  <p>&nbsp;</p>
</blockquote>
$module_warning
</body>
</html>
];


}





sub savesettings
{

acs::write_config("facebookappid", $q->param('fapi')); 

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin :: Configuration Saved", "<a href='p_facebook.cgi'>Click Here to Continue</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub configure
{

eval "use LWP::UserAgent";
if($@)
	{
	$lwp_useragent = "N";
	$lwp_useragent_err = $@;
	$lwp_notice = "<font color='red'>LWP::UserAgent</font><br>";
 	}
$@ = "";

##############

eval "use HTTP::Request::Common qw(GET)";
if($@)
	{
	$httprequest = "N";
	$httprequest_err = $@;
	$httprequest_notice = "<font color='red'>HTTP::Request::Common</font><br>";
 	}
$@ = "";

##############

eval "use Crypt::SSLeay";
if($@)
	{
	$cryptssl = "N";
	$cryptssl_err = $@;
	$cryptssl_notice = "<font color='red'>Crypt::SSLeay</font><br>";
 	}
$@ = "";

##############


if (($lwp_useragent eq "") and ($lwp_useragent eq "") and ($lwp_useragent eq ""))
	{
		$use_perl_modules = "Y";
	}
	else
	{
		$use_perl_modules = "N";
		
		$module_warning = qq[
		 <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
		      <td valign="top">&nbsp;</td>
		      <td valign="top">
		      <hr noshade size="1" width="100%" align="center">
		      	<p><b>Note that your web host or web server does not have the following Perl module(s) installed:</b></p>
		        <blockquote>
		          <p><strong>$lwp_notice $httprequest_notice $cryptssl_notice</strong></p>
		        </blockquote>
		      <p> It is recommended that you install the above mentioned Perl module(s) if possible so that they can be used in conjunction with your Facebook Login. PowerSeek will use alternative methods to connect users to Facebook but note that the alternative connection methods is not as secure. <strong>It is strongly recommended that you install the modules as mentioned above.</strong></p>
				<hr noshade size="1" width="100%" align="center">
		      </td>
 			</tr>
		];
	}




 
######################

$gsettings = new_gsettings acs;
$fapi = $gsettings->{facebookappid};

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin :: Configure Facebook Login", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<form name="form1" method="post" action="">
  <table width="93%" border="0" align="center" cellpadding="6" cellspacing="1">
    <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td width="22%"><strong><span class="normaltext">Facebook App ID: </span></strong></td>
      <td width="78%"><span class="normaltext">
        <input name="fapi" type="text" id="fapi" value="$fapi" size="30">
      </span></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top"><p>To get a FaceBook App ID visit <a href="https://developers.facebook.com/apps" target="_blank">https://developers.facebook.com/apps</a> - Log in with your facebook details and click the Create New App button. Supply the details asked from you and you will receive an App ID / API Key - Enter the APP ID / API Key here.</p>
      <p>Note that you also need to specify the URL of your domain name. You do this by clicking on 'Website'. You will see the 'Web Site' option on the page where your APP ID is displayed.</p></td>
    </tr>
   
    	$module_warning
    
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top"><input type="submit" class="psbutton" name="Save" id="Save" value="Save">
      <input name="fct" type="hidden" id="fct" value="savesettings" /></td>
    </tr>
  </table>
</form>

</body>
</html>
];



}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin", "Choose an option below");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<ul>
  <li><span class="normaltext"><a href="?fct=configure"><strong>Configure Facebook Login</strong></a><br>
  Here you need to enter the Facebook App ID and specify other configuration options.</span></li>
</ul>
<ul>
  <li><strong><span class="normaltext"><a href="?fct=instructions">Implement Facebook Login</a></span></strong><span class="normaltext"><a href="?fct=instructions"></a><br>
    Instructions on how to implement the Facebook Login with PowerSeek.
  </span></li>
</ul>

</body>
</html>
];
 


}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


