#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Raw SQL Query Tool
# DIZ: Enables you to do raw SQL queries on your database.
# GRAPHIC: ic_sql.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "create") { &create; }
if ($q->param('fct') eq "create2") { &create2; }
if ($q->param('fct') eq "edit") { &edit; }
if ($q->param('fct') eq "save") { &save; }
if ($q->param('fct') eq "del") { &del; }
if ($q->param('fct') eq "gethtml") { &gethtml; }



sub gethtml
{

$incl = $q->param('i');
$display_iframe = "display_fpiframe_" . $incl;

@domain_items = split (/\//, $script_url);
$domain_name = $domain_items[2];
$dcntr = 0;
foreach $ditem (@domain_items)
	{
		if ($dcntr > 2)
			{
			$domain_items = $domain_items . "/" . $ditem;
			}
	$dcntr++;
	}


$getFPHeight = "get_height_" . $incl;


$htmlcode = qq[
<iframe width="100%" id="$display_iframe"  
onLoad="$getFPHeight();" 
src=""
scrolling="NO" 
frameborder="0" 
height="50">An iframe capable browser is 
required to view this web site.
</iframe>
<script language="JavaScript">
function GetDomain(url) { return url.match(/:\\/\\/(.[^/]+)/)[1]; }
function $getFPHeight () {
var the_height = document.getElementById('$display_iframe').contentWindow.document.body.scrollHeight;
document.getElementById('$display_iframe').height = the_height;
}
var realurl = 'http://' + GetDomain(document.URL) + '$domain_items/disprnd.cgi?newpop=rnd&i=$incl';
document.getElementById('$display_iframe').src = realurl;
</script>
];



#$htmlcode = qq[<form name="form1" method="post" action="">
#<label>
#<textarea name="code" id="code" cols="70" rows="15"><script language="JavaScript">
#<!--
#function getHeight()
#{
#var the_height = document.getElementById('display_iframe').contentWindow.document.body.scrollHeight;
#document.getElementById('display_iframe').height = the_height;
#}
#//-->
#</script>
#<iframe width="100%" id="display_iframe" 
#onLoad="getHeight();" 
#src="$script_url/disprnd.cgi?newpop=rnd&i=$incl"
#scrolling="NO" 
#frameborder="0" 
#height="1"> An iframe capable browser is 
#required to view this web site.
#</iframe>
#    </textarea>
#  </label>
#</form>
#];


$hbox = acs::get_heading_box("$web_url/ic_rand.gif", "Get HTML Code for: $incl", qq[Place the following HTML code inside any PowerSeek template or external web page to display random links.<BR><a href="$admin_url/p_rand.cgi"><b>Go Back</b></a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<textarea name="code" id="code" cols="70" rows="20" style="width:100%">$htmlcode</textarea>
</body>
</html>
];


}



sub del
{

$iname = $q->param('i');
$ifilen = "inclr_" . $iname . ".dat";
unlink ("$data_dir/$ifilen");


$rincludes = &get_file_contents("$data_dir/rand_includes.dat");
@r_incl = split (/\n/, $rincludes);

open (WRF, "> $data_dir/rand_includes.dat");

foreach $item (@r_incl)
	{
	if ($iname ne $item)
		{
		print WRF $item . "\n";
		}
	}
close (WRF);


$hbox = acs::get_heading_box("$web_url/ic_rand.gif", "Random Link Include Deleted", qq[<a href="$admin_url/p_rand.cgi">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}



sub save
{

$iname = $q->param('i');

$ifilen = "inclr_" . $iname . ".dat";

open (INCL, "> $data_dir/$ifilen");
	print INCL $q->param('diz') . "\n";
	print INCL $q->param('related_categories') . "\n";
	print INCL $q->param('interval') . "\n";
	print INCL $q->param('premonly') . "\n";
	print INCL $q->param('subcats_incl') . "\n";
	print INCL $q->param('rnolinks') . "\n";
	print INCL "::inchtml::" . $q->param('link_template') . "\n";
	print INCL "::inchtml::" . $q->param('link_template2') . "\n";
close (INCL);


$hbox = acs::get_heading_box("$web_url/ic_rand.gif", "Random Link Include Saved", qq[<a href="$admin_url/p_rand.cgi">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



sub edit
{
$iname = $q->param('i');

	$ifilen = "inclr_" . $iname . ".dat";
	$i_details = &get_file_contents("$data_dir/$ifilen");
	
	($ind_det, $link_template, $link_template2) = split (/::inchtml::/, $i_details);
	
	@ridet = split (/\n/, $ind_det);
	
	$incl_name = $iname;
	$diz = $ridet[0];
	$category =  $ridet[1];
	$interval =  $ridet[2];
	$premonly =  $ridet[3];
	$incl_cats = $ridet[4];
	$rnolinks = $ridet[5];


	if ($interval eq "always") 	{ $intv[0] = "Selected"; }
	if ($interval eq "hours6") 	{ $intv[1] = "Selected"; }
	if ($interval eq "hours12")	{ $intv[2] = "Selected"; }
	if ($interval eq "day1") 		{ $intv[3] = "Selected"; }
	if ($interval eq "day3") 		{ $intv[4] = "Selected"; }
	if ($interval eq "week") 		{ $intv[5] = "Selected"; }
	if ($interval eq "month") 		{ $intv[6] = "Selected"; }

	if ($premonly eq "Y") { $pchk = "checked"; }
	if ($incl_cats eq "Y") { $incl_check = "checked"; }



$hbox = acs::get_heading_box("$web_url/ic_rand.gif", "Edit Random Link Include", qq[<a href="$admin_url/p_rand.cgi">Go Back</a>]);

$timefile = "$data_dir/inclr_" . $iname . ".tim";
if ((-e "$timefile") > 0)
	{
	unlink ($timefile);
	}

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin2', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }
 // End Hide -->
 </script>
 
</head>
<body>
$hbox
<form method="post" action="$admin_url/p_rand.cgi" name="addu">
  
       <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
         <tr>
           <td colspan="2" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Edit Random Link Include:</strong></td>
         </tr>
         <tr>
           <td width="32%" valign="top" bgcolor="#FFFFFF" class="normaltext">Random Link Include Name: <br>
           </td>
           <td width="68%" valign="top" bgcolor="#FFFFFF" class="normaltext">
             <strong>$incl_name</strong>
           </td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Description:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input name="diz" type="text" id="diz" style="width:100%" value="$diz">
           </label>
             Description for your own informational purposes.</td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Number of Random Links to display?</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input name="rnolinks" type="text" id="rnolinks" value="$rnolinks" size="5">
           (10 for example)</label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Category where links should be taken from:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input name="related_categories" type="text" value="$category" size="60">
              (<a href="$admin_url/admin67.cgi"  onclick="popup('$admin_url/admin67.cgi?fct=related',600,600);return false;">Category Browser</a>)<br>
             Leave blank if any link can be taken from the whole Database.<br>
             Please specify related category IDs in a comma-separated list above. Use the 'Category Broswer' to get category IDs.<br>
           <strong>For example: 10, 313, 423, 35</strong></label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Include Sub Categories of Categories selected above:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input type="checkbox" name="subcats_incl" id="subcats_incl" $incl_check value="Y">
           (This setting will have no effect if you selected no categories)</label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">How often should links be randomized:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <select name="interval" id="interval">
               <option value="always" $intv[0]>Each load should display random links</option>
               <option value="hours6" $intv[1]>Every 6 Hours</option>
               <option value="hours12" $intv[2]>Every 12 Hours</option>
               <option value="day1" $intv[3]>Every Day</option>
               <option value="day3" $intv[4]>Every 3 Days</option>
               <option value="week" $intv[5]>Every Week</option>
               <option value="month" $intv[6]>Every Month</option>
             </select>
           </label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Only display Premium Links:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input type="checkbox" name="premonly" value="Y" $pchk>
           (Only Premium Links will be displayed if this option is checked)</label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Link Style Template:<br>
             <a href="$admin_url/admin78.cgi?t=tophits_listings&fct=explain&body=true" onclick="popup('$admin_url/admin78.cgi?t=tophits_listings&fct=explain&body=true',800,600);return false;">Click Here</a> for a list of variables that can be used in the link style template.</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <textarea name="link_template" id="link_template" cols="45" rows="10" style="width:100%">$link_template</textarea>
           </label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Template Around Links:<br>
           This template will act like a frame around the random links listed when displaying the random links. The variable !!random_links!! inside the template will be replaced by the random links.</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea name="link_template2" id="link_template2" cols="45" rows="10" style="width:100%">$link_template2</textarea></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" name="button" id="button" value="Save Random Include">
           <input name="fct" type="hidden" id="fct" value="save">
           <input name="i" type="hidden" value="$iname"></td>
         </tr>
       </table>
       <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
         <tr>
           <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
           <td width="99%"></td>
         </tr>
  </table>
       <label><br>
       </label>
  </form>
</body>
</html>];

}





sub create2
{

$iname = $q->param('incl_name');

for ($ms = 0; $ms < length($iname); $ms++) 
	{
	$oneletter = substr($iname, $ms, 1);
	if ($oneletter !~ /[0-9a-zA-Z]/)
		{
		acs::problem_popup ("The include name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		}
	}

if ($q->param('incl_name') eq ""){acs::problem_popup("You have to provide a name for the include.");}

open (INF, ">> $data_dir/rand_includes.dat");
print INF $q->param('incl_name') . "\n";
close (INF);

$ifilen = "inclr_" . $q->param('incl_name') . ".dat";

open (INCL, "> $data_dir/$ifilen");
	print INCL $q->param('diz') . "\n";
	print INCL $q->param('related_categories') . "\n";
	print INCL $q->param('interval') . "\n";
	print INCL $q->param('premonly') . "\n";
	print INCL $q->param('subcats_incl') . "\n";
	print INCL $q->param('rnolinks') . "\n";
	print INCL "::inchtml::" . $q->param('link_template') . "\n";
	print INCL "::inchtml::" . $q->param('link_template2') . "\n";
close (INCL);

$hbox = acs::get_heading_box("$web_url/ic_rand.gif", "Random Link Include Created", qq[<a href="$admin_url/p_rand.cgi">Click Here to Continue</a>]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



sub create
{

$hbox = acs::get_heading_box("$web_url/ic_rand.gif", "Create Random Link Include", qq[<a href="$admin_url/p_rand.cgi">Go Back</a>]);

$link_template2 = qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Random Links</title>
<style type="text/css">
<!--
body { margin: 0; padding: 0; }
-->
</style>
</head>
</body>
!!random_links!!
</body>
</html>
];


$link_template = &get_file_contents("$data_dir/lsearchres_loc.html");

print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin2', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }
 // End Hide -->
 </script>
</head>
<body>
$hbox
  <form method="post" action="$admin_url/p_rand.cgi" name="addu">
       <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
         <tr>
           <td colspan="2" valign="top" background="$web_url/bar7.gif" class="normaltext"><strong>Create a New Random Link Includes:</strong></td>
         </tr>
         <tr>
           <td width="32%" valign="top" bgcolor="#FFFFFF" class="normaltext">Choose a name for the Random Link Include Name: <br>           </td>
           <td width="68%" valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input name="incl_name" type="text" id="incl_name" size="30">
             </label>
             Only use alphabetical or numerical characters.</td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Number of Random Links to display?</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input name="rnolinks" type="text" id="rnolinks" size="5">
             (10 for example)</label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Description: </td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input type="text" name="diz" id="diz" style="width:100%">
           </label>
             Supply a description for your own informational purposes.</td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Category where links should be taken from:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input name="related_categories" type="text" id="category" size="60">
              (<a href="$admin_url/admin67.cgi?fct=related" onclick="popup('$admin_url/admin67.cgi?fct=related',600,600);return false;">Category Browser</a>)<br>
             Leave blank if any link can be taken from the Database.<br>
             Please specify related category IDs in a comma-separated list above. Use the 'Category Broswer' to get category IDs.<br>
           <strong>For example: 10, 313, 423, 35</strong></label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Include Sub Categories of Categories selected above:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input type="checkbox" name="subcats_incl" id="subcats_incl" $incl_check value="Y">
             (This setting will have no effect if you selected no categories)</label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">How often should links be randomized:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <select name="interval" id="interval">
               <option value="always">Each load should display random links</option>
               <option value="hours6">Every 6 Hours</option>
               <option value="hours12">Every 12 Hours</option>
               <option value="day1">Every Day</option>
               <option value="day3">Every 3 Days</option>
               <option value="week">Every Week</option>
               <option value="month">Every Month</option>
             </select>
           </label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Only display Premium Links:</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <input type="checkbox" name="premonly" value="Y">
           (Only Premium Links will be displayed if this option is checked)</label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Link Style Template:<br>
             <a href="" onclick="popup('$admin_url/admin78.cgi?t=tophits_listings&fct=explain&body=true',800,600);return false;">Click Here</a> for a list of variables that can be used in the link style template.</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
             <textarea name="link_template" id="link_template" cols="45" rows="10" style="width:100%">$link_template</textarea>
           </label></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">Template Around Links:<br>
             This template will act like a frame around the links listed when displaying the random links.</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea name="link_template2" id="link_template2" cols="45" rows="10" style="width:100%">$link_template2</textarea></td>
         </tr>
         <tr>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
           <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" name="button" id="button" value="Create Random Include">
           <input name="fct" type="hidden" id="fct" value="create2"></td>
         </tr>
       </table>
       <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
         <tr>
           <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
           <td width="99%"></td>
         </tr>
   </table>
       <label><br>
       </label>
  </form>
</body>
</html>
];

}





sub start
{


$rincludes = &get_file_contents("$data_dir/rand_includes.dat");
@r_incl = split (/\n/, $rincludes);

foreach $item (@r_incl)
	{
	$ifilen = "inclr_" . $item . ".dat";
	$i_details = &get_file_contents("$data_dir/$ifilen");
	
	($ind_det, $link_html) = split (/::inchtml::/, $i_details);
	
	@ridet = split (/\n/, $ind_det);
	
	$diz = $ridet[0];
	
	$interval = $ridet[2];
	if ($interval eq "always") 	{ $dint = "Always Random"; }
	if ($interval eq "hours6") 	{ $dint = "Every 6 Hours"; }
	if ($interval eq "hours12")	{ $dint = "Every 12 Hours"; }
	if ($interval eq "day1") 		{ $dint = "Every Day"; }
	if ($interval eq "day3") 		{ $dint = "Every 3 Days"; }
	if ($interval eq "week") 		{ $dint = "Every Week"; }
	if ($interval eq "month") 		{ $dint = "Every Month"; }
	
	if ($ridet[3] eq "Y" ) { $premonly = "Yes"; } else { $premonly = "No"; } 
	
	$ilines = $ilines . qq[<tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$admin_url/p_rand.cgi?fct=edit&i=$item" title="$diz"><b>$item</b></a></td>
    <td align="center" valign="top" bgcolor="#FFFFFF" class="normaltext">$dint</td>
    <td align="center" valign="top" bgcolor="#FFFFFF" class="normaltext">$premonly</td>
    <td align="center" valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$admin_url/p_rand.cgi?fct=gethtml&i=$item" title="Get HTML code to place inside any PowerSeek Template or External Web Page to display random links."><b>Get HTML</b></a></td>
    <td align="center" valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$admin_url/p_rand.cgi?fct=del&i=$item"><b>Delete</b></a></td>
    <td align="center" valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$admin_url/p_rand.cgi?fct=edit&i=$item"><b>Edit</b></a></td>
    <td align="center" valign="top" bgcolor="#FFFFFF" class="normaltext"><a href="$script_url/disprnd.cgi?newpop=rnd&i=$item" target="_blank"><b>Preview</b></a></td>
  </tr>];
	}


$hbox = acs::get_heading_box("$web_url/ic_rand.gif", "Random Link Includes", qq[Enables you to include random selections of links out of the database or specified categories in PowerSeek templates or any external web page.]);


if ($ilines ne "")
{
$rndibox = qq[
<table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
  <tr>
    <td width="38%" valign="top" background="$web_url/bar7.gif" class="normaltext"><strong>Random Link Includes:</strong></td>
    <td width="13%" align="center" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Interval Rotation</strong></td>
    <td width="11%" align="center" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Only</strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Get HTML</strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Delete</strong></td>
    <td width="8%" align="center" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Edit</strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Preview</strong></td>
  </tr>
$ilines
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
];
}
else
{
$rndibox = "<span class='normaltext'><b>There are currently no 'Random Link Includes'.</b></span><br><br>";
}




print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<script SRC="$web_url/qtip.js"></script>
<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style>
</head>
<body>
$hbox

$rndibox

<form name="form1" method="post" action="$admin_url/p_rand.cgi">
  <label>
    <input type="submit" class="psbutton" name="button" id="button" value="Create New Random Include">
  </label>
  <input name="fct" type="hidden" id="fct" value="create">
</form>

</body>
</html>
];

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

