#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Total Link Include
# DIZ: Enables you to display the total amount of links and categories in your search engine in any PowerSeek template or external web page.
# GRAPHIC: ic_up.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
#use psfp;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
# not below if's - else bypassed...
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "edit_include") {&edit_include;}
if ($q->param('fct') eq "save_include") {&save_include;}

if ($q->param('fct') eq "generate_scripts") {&generate_scripts;}


####################################################################################

sub generate_scripts
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


$dir_sql = "SELECT cid FROM dirs";
$sth = $dbh->prepare($dir_sql);
	
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$total_dirs = $sth->rows(); #from dirs table


$link_sql = "SELECT lnkid FROM links";
$sth = $dbh->prepare($link_sql);
	
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$total_links = $sth->rows();


$sth->finish;
$dbh->disconnect;

# get file & replace var
$style_template = acs::get_file_contents("$data_dir/total_link.html");
$style_template =~ s/!!links!!/$total_links/g;
$style_template =~ s/!!dirs!!/$total_dirs/g;
#print "templ: $style_template";

# GENERATE final java / html 'include file'
$jname = $q->param('jname');
$fullpath = "$web_dir/$jname.js";
$urlpath = "$web_url/$jname.js";

$head_script = qq[
<script SRC="$urlpath"></script>
];


$body_script = qq[
<script LANGUAGE="JavaScript" TYPE="text/javascript">
<!--
get_$jname();
// -->
</script>
];



$style_template =~ s/\n/ /g;
$crit = chr(10); $style_template =~ s/$crit/ /g;
$crit = chr(13); $style_template =~ s/$crit/ /g;
$style_template =~ s/'/\\'/g;
# write html incl file AND JAVASCRIPT INCLUDE FILE
open (J_file, "> $fullpath") || acs::problem_popup
("Couldn't write to file $jname.js :$! - Please ensure that the directory where this file needs to be written to, exists.");
	#print J_file $style_template; #write content: [!!links!! !!dirs!!] eg. $allcats=generated categories;
	print J_file "function get_$jname()\n";
	print J_file "{\n";
	print J_file "document.write ('" . $style_template . "');\n";
	print J_file "}\n";

close (J_file);
$stat = chmod($default_permissions,"$fullpath","$fullpath");

#PREVIEW PART # regenerated above before viewing
if ($q->param('preview') eq "true")
{print $style_template; exit;}



$hbox = acs::get_heading_box("$web_url/add.gif", "Total Link Include", qq[Place the following JavaScript inside a web page or any PowerSeek template.]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<table border="0" cellPadding="6" style="border: 1px solid rgb(216,216,216)" width="100%">
  <tr>
    <td width="101%" vAlign="top" background="$web_url/bar6.gif" class="normaltext"><strong>HTML
    CODE </strong></td>
  </tr>
  <tr>
    <td width="101%" vAlign="top" class="normaltext"><strong>Note that Includes are also automatically created or updated when
    you generate/build HTML files. </strong>This means that this include will be automatically
    updated/generated when you generate HTML files. Below is HTML Code or JavaScript code
    which you can place inside existing web pages or templates of PowerSeek.<form
    action="--WEBBOT-SELF--" method="POST">
      <!--webbot bot="SaveResults" startspan S-Label-Fields="TRUE"
      U-File="_private/form_results.txt" S-Format="TEXT/CSV" -->
  <!--webbot bot="SaveResults"
      endspan --><p><strong>Place the following between the body tags of web pages or PowerSeek
      templates. You can place this code any where inside the body tags where you would like the
      link includes to be displayed. </strong></p>
      <p><textarea cols="46" name="S2" rows="5">$head_script  
$body_script
</textarea> </p>
    </form>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

<p><a href="$admin_url/p_total_link.cgi"><strong>Go Back </strong></a></p>
</body>
</html>
];

}




sub edit_include
{
$vars = "<strong>!!links!!</strong><br>
This variable will be replaced with the amount of links/urls you have.<br>
<br>
<strong>!!dirs!!</strong><br>
This variable will be replaced with the amount of directories you have.<br>
";

# 'editing variable'
$style_template = acs::get_file_contents("$data_dir/total_link.html");



$hbox = acs::get_heading_box("$web_url/ic_up.gif", "Edit Total Link Include ", qq[Enables you to configure the style of text that displays the total amount of links in any PowerSeek template or any external web page:<BR><b><a href="$admin_url/p_total_link.cgi">Go Back</a></b>]);
 


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

<form method="POST" action="$admin_url/p_total_link.cgi">
  <input type="hidden" name="fct" value="save_include"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#D8D8D8">
    <tr>
      <td width="100%" height="30" background="$web_url/bar7.gif" class="normaltext"><strong>Include Style: </strong></td>
    </tr>
    <tr>
      <td width="100%" height="30" bgcolor="#FFFFFF" class="normaltext"><p>
          <textarea rows="6" name="include_template" cols="85"  style="width:100%">$style_template</textarea> 
          <br>
          <br>
          <input type="submit" class="psbutton" value="Save Template" name="T1"> 
      </p>
      <p>This template file is situated at: <strong>$data_dir/total_link.html</strong></p></td>
    </tr>
  </table>
  <div align="center"><center><table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  </center></div><table border="0" cellspacing="1" width="100%" cellpadding="6"
  bgcolor="#D8D8D8">
    <tr>
      <td width="100%" height="30" background="$web_url/bar7.gif" class="normaltext"><strong>Variables Available
      for use in this Template:</strong></td>
    </tr>
    <tr>
      <td width="100%" height="30" bgcolor="#FFFFFF" class="normaltext">$vars</td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
  </table>
</form>
</body>
</html>
];

}


sub save_include
{

$laa = ($q->param('T1'));

if ($laa = "Save Template")
{

$tmplfile = "$data_dir/total_link" . ".html";
open (TMPLF, "> $tmplfile");
print TMPLF $q->param('include_template'); #name of templ_ebox
close TMPLF;

$hbox = acs::get_heading_box("$web_url/ic_up.gif", "Template Saved", qq[<a href="$admin_url/p_total_link.cgi">Click Here to Continue</a>]); 

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}
}






sub start
{

 
$boxdiz = qq[
<p><span class="normaltext">This section enables you to generate or create a 'Total Links' Include to place inside
your PowerSeek template or any existing web page. A 'Total Link Include' allows you to place JavaScript inside any 
web page or PowerSeek template that will display the total number of Categories and Links inside your Directory.
</span>
<ul>
  <li class="normaltext"><a href="$admin_url/p_total_link.cgi?fct=edit_include"><strong>Edit Total Link Include <br>
    </strong></a>Edit your template layout. <br>
    &nbsp; </li>
  <li class="normaltext"><strong><a href="$admin_url/p_total_link.cgi?fct=generate_scripts&amp;jname=total_link">Generate
    the include/Get html code </a><br>
    </strong>Click here to retrieve the HTML code that you may place inside your PowerSeek
    templates or any existing web page of your web site. <br>
    &nbsp; </li>
  <li class="normaltext"><strong><a href="$admin_url/p_total_link.cgi?fct=generate_scripts&amp;preview=true"
    target="_blank">Preview your generated Total Link Include </a><br>
    </strong>Click the above link to see a preview of the Include. </li>
</ul>
];

$hbox = acs::get_heading_box("$web_url/ic_up.gif", "Generate Total Link Include", $boxdiz); 

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

#############



$total_template =~ s/%%style_template%%/$style_template/g;
# will receive these vars from html
#Total Number of links: !!links!! <BR>
#Total Number of Categories: !!dirs!!

print $total_template;

}







sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

