#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use Fcntl qw(:DEFAULT :flock);
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version/;

$version = "2.0.3";
$debug = "OFF";
$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));
if ($q->param('fct') eq "myforum1") {&myforum1;}

print $q->header();

if ($q->param('fct') eq "add_category") {&add_category; exit;}
if ($q->param('fct') eq "add_category_final") {&add_category_final; exit;}
if ($q->param('fct') eq "add_forum") {&add_forum; exit;}
if ($q->param('fct') eq "create_new_forum") {&create_new_forum;exit;}
if ($q->param('fct') eq "edit_cat") {&edit_cat;exit;}
if ($q->param('fct') eq "save_cat_name") {&save_cat_name;exit;}
if ($q->param('fct') eq "getuserinfo") {&getuserinfo;exit;}
if ($q->param('fct') eq "save_member_info") {&save_member_info;exit;}
if ($q->param('fct') eq "edit_forum") {&edit_forum;exit;}
if ($q->param('fct') eq "save_forum_settings") {&save_forum_settings;exit;}
if ($q->param('fct') eq "del_cat") {&del_cat;exit;}
if ($q->param('fct') eq "delete_catfinal") {&delete_catfinal;exit;}
if ($q->param('fct') eq "re-ordercategories") {&reordercategories;exit;}
if ($q->param('fct') eq "reorder_catfinal") {&reorder_catfinal;exit;}
if ($q->param('fct') eq "re_order_forums") {&re_order_forums;exit;}
if ($q->param('fct') eq "reorder_forumfinal") {&reorder_forumfinal;exit;}
if ($q->param('fct') eq "delete_topics_scr") {&delete_topics_scr;exit;}
if ($q->param('fct') eq "delete_topics_final") {&delete_topics_final;exit;}
if ($q->param('fct') eq "deleteuser") {&deleteuser;exit;}
if ($q->param('fct') eq "add_user") {&add_user;exit;}
if ($q->param('fct') eq "create_user") {&create_user;exit;}



###############################################################################

#&print_top;

	if ($q->param('fct') eq "") {&start;}
	if ($q->param('fct') eq "boardmanager") {&boardmanager;}
   if ($q->param('fct') eq "save_cust") {&save_cust;}
	if ($q->param('fct') eq "delete_forum") {&delete_forum;}
	if ($q->param('fct') eq "usermanager") {&usermanager;}
	if ($q->param('fct') eq "get_users") {&get_users;}
	if ($q->param('fct') eq "rgst") {&myforum;}
	if ($q->param('fct') eq "mailinglist") {&mailinglist;}
	if ($q->param('fct') eq "mailinglist2") {&mailinglist2;}
	if ($q->param('fct') eq "title_setup") {&title_setup;}
	if ($q->param('fct') eq "save_titles") {&save_titles;}
	if ($q->param('fct') eq "banipscr") {&banipscr;}
	if ($q->param('fct') eq "ban_ip") {&ban_ip;}
	if ($q->param('fct') eq "delbannedip") {&delbannedip;}


##############################################################################




sub delbannedip
{

my ($iptban, $ipdata, @aips, $item, $rip, $ipdiz);

$iptban = $q->param('ip');
$ipdata = sn_netbadmin::get_file_contents("$data_dir/sn_banned_ips.dat");
@aips = split(/\n/, $ipdata);

open (BIPS, "> $data_dir/sn_banned_ips.dat");
if ($flocking ne "No"){flock (BIPS,2);}
foreach $item (@aips)
	{
	($rip, $ipdiz) = split (/\t/,$item);
		if ($rip ne $iptban)
			{
			print BIPS $item . "\n";
			}
	}
if ($flocking ne "No"){flock (BIPS,8);}
close (BIPS);

&banipscr;

}



sub ban_ip
{

if ($q->param('ipaddress') eq "")
	{
	&banipscr; exit;
	}

open (IPBANNS, ">> $data_dir/sn_banned_ips.dat");
if ($flocking ne "No"){flock (IPBANNS,2);}
	print IPBANNS $q->param('ipaddress') . "\t" . $q->param('reason') . "\n";
if ($flocking ne "No"){flock (IPBANNS,8);}
close (IPBANNS);

&banipscr;

}



sub banipscr
{

my (@files, $usernumber, $banned_table, $ip, $reason);

opendir(DIR,"$data_dir/users");
	@files = readdir(DIR);
closedir(DIR);
$usernumber = push(@files);

#### BANNED TABLE TOP
$banned_table = <<END_OF_BTOP;
<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="#E0E0E0">
  <tr>
    <td width="100%" height="30" colspan="3" background="$web_url/sn_bar6.gif"><font
    face="Verdana" size="2" color="#000000"><strong>Banned IP's</strong></font></td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F8F8F8" height="18"><strong><font face="Verdana" size="1"
    color="#000000">IP Address</font></strong></td>
    <td width="61%" bgcolor="#F8F8F8" height="18"><strong><font face="Verdana" size="1"
    color="#000000">Ban Reason</font></strong></td>
    <td width="14%" bgcolor="#F8F8F8" height="18" align="center"><strong><font face="Verdana"
    size="2" color="#FFFFFF"></font><font face="Verdana" size="1" color="#000000">Delete</font></strong></td>
  </tr>
END_OF_BTOP

##### GET BANNS

open (BNIPS, "$data_dir/sn_banned_ips.dat");
	while (defined($line=<BNIPS>))
	{
	($ip, $reason) = split (/\t/, $line);

$banned_table = $banned_table . <<END_OF_TLINE;
   <tr>
     <td width="25%" bgcolor="#FFFFFF" height="18"><font face="Verdana" size="1"
     color="#000000">$ip</font></td>
     <td width="61%" bgcolor="#FFFFFF" height="18"><font face="Verdana" size="1"
     color="#000000">$reason</font></td>
     <td width="14%" bgcolor="#FFFFFF" height="18" align="center"><font face="Verdana" size="1"
     color="#000000"><strong></strong><a
     href="$scripts_admin/sn_admin.cgi?fct=delbannedip&amp;ip=$ip">Delete</a></font></td>
  </tr>
END_OF_TLINE
	}
	
close (BNIPS);

##### BOTTOM TBLBANN
$banned_table = $banned_table . "</table></div>";


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_userman2.gif", " 	User Manager > Ban Users Via IP Address", qq[
To get a users IP address, go to the message that was posted by him/her. Click on IP Logged and log in. The users IP address will be displayed to you. Come back here and enter the users IP. Banned users will not be able to post messages. Note that only moderators and administrators can view IP addresses.
]);



#####  DUMP SCREEN
print <<END_OF_BANNU;
<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>

<body>

<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="ban_ip">
  
$hbox
  
  <table border="0" cellpadding="3" cellspacing="1" width="100%" height="79">
    <tr>
      <td width="26%" height="18"><img src="$web_url/sn_first.gif"><font face="Verdana" size="1">
      Enter IP Address:</font></td>
      <td width="74%" height="18" valign="top"><input type="text" name="ipaddress" size="20"
      style="font-family: MS Sans Serif; font-size: 8" value="IP Address"
      onfocus="ipaddress.value='';"> <font face="Verdana" size="1">(Example: 192.168.0.1)</font></td>
    </tr>
    <tr>
      <td width="26%" height="18"><img src="$web_url/sn_first.gif"><font face="Verdana" size="1">
      Reason for Banning:</font></td>
      <td width="74%" height="18" valign="top"><input type="text" name="reason" size="46"
      style="font-family: MS Sans Serif; font-size: 8" onfocus="reason.value='';"
      value="This acts like a reminder why this IP was banned"></td>
    </tr>
    <tr>
      <td width="26%" bgcolor="#FFFFFF" height="18"></td>
      <td width="74%" bgcolor="#FFFFFF" height="18" valign="top"><input type="submit"
      value="   Ban   " name="B1" style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
  </table>
</form>
</body>
</html>


<p>$banned_table</p>
END_OF_BANNU

}




sub deleteuser
{

my ($user, $allusers, @allu, $item);

$user = $q->param('user');

$allusers = sn_netbadmin::get_file_contents("$data_dir/users/users.dat");
@allu = split (/\n/, $allusers);
foreach $item (@allu)
	{
	if (lc($item) eq lc($user))
		{
		$user = $item;
		}
	}

$user =~ s/ /_/g;

if ((-e "$data_dir/users/$user.dat") < 1)
	{

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "Problem", qq[
Cloud not find user.<BR>
<form method="POST" action>
  <p><input type="submit" value="    Close Window    " name="B1"
  onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8"></p>
</form>
]);


print <<END_OF_NONEFOUND;
<html>
<head>
<title>Problem</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox


</body>
</html>

END_OF_NONEFOUND

	}
	else
	{
	
	my ($udata, @iusers, $item, $cuser);
	
	$cuser = $user;
	$cuser =~ s/_/ /g;
	unlink ("$data_dir/users/$user.dat");
	
	$udata = sn_netbadmin::get_file_contents("$data_dir/users/users.dat");
	@iusers = split (/\n/, $udata);
	
	open (UDATA, "> $data_dir/users/users.dat");
	if ($flocking ne "No"){flock (UDATA,2);}
	 foreach $item (@iusers)
		{
		if ($item ne $cuser)
			{
			print UDATA $item . "\n";
			}
		}
	if ($flocking ne "No"){flock (UDATA,8);}
	close (UDATA);



$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "$user has been deleted", qq[
<form method="POST" action>
  <p><input type="submit" value="    Close Window    " name="B1"
  onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8"></p>
</form>
]);


print <<END_OF_DELETED;
<html>
<head>
<title>Deleted</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox
</body>
</html>


END_OF_DELETED

	}

}




sub delete_topics_final
{

my ($cid, $fid, $topicdata, @topics, $item, @titems, $chbox, $writ_crit, $statdata,
	 @astats, $bcn, $stat_crit);

$cid = $q->param('cid');
$fid = $q->param('fid');

$topicdata = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@topics = split(/\n/, $topicdata);

$statdata = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@astats = split (/\n/, $statdata);

$bcn = 0;
foreach $item (@topics)
	{
	(@titems) = split(/\t/,$item);
	$chbox = "C_" . $titems[0];
	if ($q->param($chbox) ne "Y")
			{
			$writ_crit = $writ_crit . $item . "\n";
			$stat_crit = $stat_crit . $astats[$bcn] . "\n";
			}
			else
			{
			unlink ("$data_dir/$cid/$fid/$titems[0].dat");
			if (-e "$data_dir/$cid/$fid/$titems[0].cnt")
				{
				unlink ("$data_dir/$cid/$fid/$titems[0].cnt");
				}
			}
	$bcn++;
	}

open (TOPICTABLE, "> $data_dir/$cid/$fid/topics.dat");
if ($flocking ne "No"){flock (TOPICTABLE,2);}
	print TOPICTABLE $writ_crit;
if ($flocking ne "No"){flock (TOPICTABLE,8);}
close (TOPICTABLE);

open (STATST, "> $data_dir/$cid/$fid/tstats.dat");
if ($flocking ne "No"){flock (STATST,2);}
	print STATST $stat_crit;
if ($flocking ne "No"){flock (STATST,8);}
close (STATST);

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "Topics Deledete", qq[
<p><a href="http://" onClick="self.close();return false">Close This Window</a> | <a
href="$scripts_admin/sn_admin.cgi?fct=delete_topics_scr&amp;amp;cid=1193&amp;amp;fid=1195">Delete
More Topics</a></p>
]);


print <<END_OF_DELTED;
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>


END_OF_DELTED

}





sub delete_topics_scr
{

my ($topicdata, $cid, @alltopics, $item, @topics, $cid, $fidm, $ttop, $statdata, 
	 @stats, $bcn, $checkboxname, $icon, $tmp, $posts, $views, $fid, $lastpost,
	 $topiclink, $icnt, $nr_searchres, $modp, $pages, $st, $nd, $ippc, $ms, $pg, 
	 $pgstring, $targpage, $st1, $nd1, $spls, $prev, $nextt, $spcer, $java_aname, 
	 $page_header, $checkall, $mst);


$cid = $q->param('cid');
$fid = $q->param('fid');

#### CHECK IF THERE IS MODERATED MESSAGES IN QUE

$moderate_data = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
@mod_items = split (/\n/, $moderate_data);

if (length($moderate_data) > 1)
		{
		$mditems = @mod_items;
		
	sysopen(FH, "$data_dir/$cid/$fid/mtopics.cnt", O_RDWR|O_CREAT) or die "can't open mtopics.cnt: $!";
	  flock(FH, LOCK_EX)                           or die "can't f-lock mtopics.cnt: $!";
	  seek(FH, 0, 0)                               or die "can't rewind mtopics.cnt: $!";
	  truncate(FH, 0)                              or die "can't truncate mtopics.cnt: $!";
	  print FH $mditems                        	   or die "can't write mtopics.cnt: $!";
	close (FH)                                      or die "can't close mtopics.cnt: $!";

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "Problem", qq[
You cannot delete messages when there are messages that need approval (moderation) for display.
]);


print <<END_OF_NODEL;
<html>
<head>
<title>Delete Messages</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
END_OF_NODEL

		exit;
		}


$topicdata = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@alltopics = split(/\n/, $topicdata);

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "Delete Topics > $fcatname > $forname", qq[
Note that you can delete or edit individual messages by viewing them from the Forums.
]);


$ttop = <<END_OF_TT;
$hbox
<form name="delete_topics" method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="cid" value="$cid"><input type="hidden" name="fct"
  value="delete_topics_final"><input type="hidden" name="fid" value="$fid">

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E0E0E0">
  <tr>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Del</strong></font></td>
    <td height="30" background="$web_url/sn_bar6.gif"><font color="#000000"></font></td>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Topic</strong></font></td>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Author / Last Post</strong></font></td>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Replies</strong></font></td>
  </tr>
END_OF_TT

####################################

$statdata = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@stats = split (/\n/,$statdata);
$bcn = 0;


### PAGES
$icnt = @stats;

if (($q->param('all') eq "all") and ($icnt != 0)) 
 {
 $nr_searchres = $icnt;
 }
 else
 {
 $nr_searchres = 30;
 }


$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

foreach $item (@alltopics)
{

  if (($ippc > $st) and ($ippc <= $nd))
    {
	
	(@topics) = split (/\t/,$item);

		$checkboxname = "C_" . $topics[0];
		
		($tmp, $posts, $views, $lastpost) = split(/\t/, $stats[$bcn]);
		$posts = $posts - 1;
		$bcn++;
		$lastpost = sn_netbadmin::decode_date($lastpost);

		#### ICONS
		if (($topics[4] eq "NONE") or ($topics[4] eq "")) 
				{
				$icon = "";
				#$topiclink = "<a href=\"$scripts_url/sn_forumpr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				$topiclink = "<a href=\"$scripts_url/sn_forumr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				}
				elsif ($topics[4] eq "POLLQ123")
				{
				$icon = "<center><img src=\"$web_url/sn_poll.gif\"></center>";
				$posts = "<center><img src=\"$web_url/sn_poll.gif\"></center>"; 
				#$topiclink = "<a href=\"$scripts_url/sn_forumpr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				$topiclink = "<a href=\"$scripts_url/sn_forumpr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				}
				else
				{
				$icon = "<center><img src=\"$web_url/icons/$topics[4]\"></center>";
				#$topiclink = "<a href=\"$scripts_url/sn_forumr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				$topiclink = "<a href=\"$scripts_url/sn_forumr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				}

$java_aname = $java_aname . "'$checkboxname',";

$ttop = $ttop . <<END_OF_TT2;
  <tr>
    <td width="4%" bgcolor="#FFFFFF"><input type="checkbox" name="$checkboxname" value="Y"></td>
    <td width="4%" bgcolor="#FFFFFF">$icon</td>
    <td width="50%" bgcolor="#FFFFFF"><font face="Verdana" size="1">$topiclink</font></td>
    <td width="29%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><b>$topics[1]</b><br>$lastpost</font></td>
    <td width="9%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><p align="center">$posts</font></td>
  </tr>
END_OF_TT2


   } ### END OF PAGE RESULTS

  $ippc++;

} ### END OF LOOP THROUGH TOPICS


#######
chop($java_aname);

$page_header = <<END_OF_PGHEAD;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css"> 
<script>

function checkall(formname,thestate)
	{
	BoxNames=new Array($java_aname)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

</script>
</head>
<body>
END_OF_PGHEAD


$ttop = $page_header . $ttop;

#########

if ($ippc > 1) 
{
$ttop = $ttop . <<END_OFTE;
</table><p><input type="submit" value="Delete" name="B1" style="font-family: MS Sans Serif; font-size: 8"><br>
  <font face="Verdana" size="1">Check the checkbox next to topic(s) and click the delete
  button to delete topics.<br>
  <br><a href="javascript:checkall('delete_topics',true)">Check All</a> | <a href="javascript:checkall('delete_topics',false)">Uncheck All</a>
  </font></p>
</form>
<hr size="1" color="#C0C0C0">
END_OFTE
}
else
{

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "No Topics", qq[
There are no Topics To Delete
<BR><BR>
<form method="POST" action>
<input type="submit" value="Close This Window" name="B1" onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8pt" maxlength="50">
</form>
]);

print qq[<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

exit;
}

### PAGES

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . " <a href=\"$scripts_admin/sn_admin.cgi?fct=delete_topics_scr&cid=$cid&fid=$fid&st=$st1&nd=$nd1\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	$ttop = $ttop . "<br><font face=\"Verdana\" size=\"1\">$pgstring</font>";
	}
	else
	{
	$pgstring = "";
	}



####### PREVIOUS / NEXT

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = " <a href=\"$scripts_admin/sn_admin.cgi?fct=delete_topics_scr&cid=$cid&fid=$fid&st=$st1&nd=$nd1\">Next Page </a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = " <a href=\"$scripts_admin/sn_admin.cgi?fct=delete_topics_scr&cid=$cid&fid=$fid&st=$st1&nd=$nd1\"> Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}

   $ttop = $ttop . "<br><br><font face=\"Verdana\" size=\"1\">$prev $spcer $nextt</font>";


########
	$ippc = $ippc - 1;
	
	$ttop = $ttop . "<p><font face=\"Verdana\" size=\"1\">Total topics: <strong>$ippc</strong>";
	
   if ($pg > 1)
    {
   $ttop = $ttop . "  | Listing <strong>$nr_searchres</strong> topics per page. ";    
	$ttop = $ttop . "| <a href=\"$scripts_admin/sn_admin.cgi?fct=delete_topics_scr&cid=$cid&fid=$fid&all=all\">List All Topics</a> </font></p>";
	 }

print $ttop;

}




sub reorder_forumfinal
{

my ($fort, @citems, $item, $tt, $fname, $pval, $position, @sortedcat, $allcats, $cid);

$cid = $q->param('cid');

### GET FORUMS
$fort = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
@citems = split (/\n/, $fort);

### ERROR CHECKING
$allcats = push(@citems);

#print "ITEMS: $allcats <Br><Br>";

foreach $item (@citems)
	{
	($tt, $fname) = split (/\t/, $item);
	$pval = "C_" . $tt;
	
	$position = $q->param($pval);
	
	if ($position > $allcats) {sn_netbadmin::errorbox("You specified an invalid sort order number that was higher than the amount of categories present."); exit;}
	if ($position < 1) {sn_netbadmin::errorbox("You cannot specify numbers less than 1."); exit;}
	if ($position eq "") {sn_netbadmin::errorbox("Every Category has to have a corresponding number."); exit;}
	
	$position = $position - 1;
	
			### CHECK FOR DUPLICATES
			if ($sortedcat[$position] eq "")
				{
				$sortedcat[$position] = $item;
				}
				else
				{
				sn_netbadmin::errorbox("You specified a number more than once. Duplicate numbers is not allowed."); exit;
				}
	
	}



#open (BTBL, "$data_dir/$cid/forumtable.dat");
open (BTBL, "> $data_dir/$cid/forumtable.dat");
 if ($flocking ne "No"){flock (BTBL,2);}
 foreach $item (@sortedcat)
	{
	print BTBL $item . "\n";
	#print $item . "<br>";
	}
 if ($flocking ne "No"){flock (BTBL,8);}
close (BTBL);



$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_folders.gif", "Forums Re-Ordered", qq[
<form method="POST" action>
<input type="submit" value="    Close Window    " name="B1" onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8">
</form>
]);



print <<END_OF_ROR2;
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css"> 
</head>
<body onUnload="opener.location.reload(true);">

$hbox

</body>
</html>

END_OF_ROR2

}




sub re_order_forums
{
my ($fort, @citems, $sc, $item, $tt, $fname, $vname, $psdata, $ccat, $cid);

$cid = $q->param('cid');

$ccat = &get_cat_name ($cid);

$fort = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
@citems = split (/\n/, $fort);

$sc = 1;
foreach $item (@citems)
	{
	($tt, $fname) = split (/\t/, $item);
	
	$vname = "C_" . $tt;
	$psdata = $psdata . "<font size=\"2\" face=\"Verdana\"><br>Position: <input type=\"text\" name=\"$vname\" size=\"2\" value=\"$sc\">&nbsp; $fname</font>";
	$sc++;
	}



$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_folders.gif", "Re-order Forums in Category $ccat", qq[
<form method="POST" action="$scripts_admin/sn_admin.cgi">
<input type="hidden" name="fct" value="reorder_forumfinal"><input type="hidden" name="cid" value="$cid">
$psdata
<RB><BR><BR>
<input type="submit" value="Save Positions" name="B1"></p>
</form>
]);



print <<END_OF_PSS;
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<font size="2" face="Verdana">Position 1 indicates that a category is listed first.
Position 2 will indicate that a category is listed second, etc...</font>
</body>
</html>

END_OF_PSS

}

##############################################################################

sub reorder_catfinal
{

my ($fort, @citems, $item, $tt, $fname, $pval, $position, @sortedcat, $allcats);

### GET FORUMS
$fort = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
@citems = split (/\n/, $fort);

### ERROR CHECKING
$allcats = push(@citems);

#print "ITEMS: $allcats <Br><Br>";

foreach $item (@citems)
	{
	($tt, $fname) = split (/\t/, $item);
	$pval = "C_" . $tt;
	
	$position = $q->param($pval);
	
	if ($position > $allcats) {sn_netbadmin::errorbox("You specified an invalid sort order number that was higher than the amount of categories present."); exit;}
	if ($position < 1) {sn_netbadmin::errorbox("You cannot specify numbers less than 1."); exit;}
	if ($position eq "") {sn_netbadmin::errorbox("Every Category has to have a corresponding number."); exit;}
	
	$position = $position - 1;
	
			### CHECK FOR DUPLICATES
			if ($sortedcat[$position] eq "")
				{
				$sortedcat[$position] = $item;
				}
				else
				{
				sn_netbadmin::errorbox("You specified a number more than once. Duplicate numbers is not allowed."); exit;
				}
	
	}



#open (BTBL, "$data_dir/sn_boardtable.dat");
open (BTBL, "> $data_dir/sn_boardtable.dat");
if ($flocking ne "No"){flock (BTBL,2);}
foreach $item (@sortedcat)
	{
	print BTBL $item . "\n";
	#print $item . "<br>";
	}
if ($flocking ne "No"){flock (BTBL,8);}
close (BTBL);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_folders.gif", "Forum Categories Re-Ordered", qq[
<form method="POST" action>
  <p><input type="submit" value="    Close Window    " name="B1"
  onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8"></p>
</form>

]);


print <<END_OF_ROR;
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css"> 
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>

END_OF_ROR

}


sub reordercategories
{

my ($fort, @citems, $sc, $item, $tt, $fname, $vname, $psdata);

$fort = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
@citems = split (/\n/, $fort);

$sc = 1;
foreach $item (@citems)
	{
	($tt, $fname) = split (/\t/, $item);
	
	$vname = "C_" . $tt;
	$psdata = $psdata . "<font size=\"2\" face=\"Verdana\"><br>Position: <input type=\"text\" name=\"$vname\" size=\"2\" value=\"$sc\">&nbsp; $fname</font>";
	$sc++;
	}


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_folders.gif", "Re-order Categories", qq[
<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="reorder_catfinal">$psdata
  <BR><BR><p><input type="submit" value="Save Positions" name="B1"></p>
</form>

<p><font size="2" face="Verdana">Position 1 indicates that a category is listed first.
Position 2 will indicate that a category is listed second, etc...</font></p>
]); 

print <<END_OF_PSS;
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_PSS

}



sub delete_catfinal
{

my ($cid, $fort, @forums, $item, $fid, $fname, @files, $file, $stat, $currcat, @bcats,
	 $cat, $cname);

$cid = $q->param('cid');


$fort = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
@forums = split (/\n/,$fort);

foreach $item (@forums)
	{
	($fid, $fname) = split(/\t/, $item);
		opendir(DIR,"$data_dir/$cid/$fid");
			@files = readdir(DIR);
		closedir(DIR);		
			
			foreach $file (@files)
				{
				if (($file ne ".") or ($file ne ".."))
					{
					unlink ("$data_dir/$cid/$fid/$file");
					}
				}
		
		$stat = rmdir("$data_dir/$cid/$fid");

	}


unlink ("$data_dir/$cid/forumtable.dat");
$stat = rmdir("$data_dir/$cid");


### CATEGORY TABLE
$fort = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
@bcats = split (/\n/, $fort);

open (CATBLE, "> $data_dir/sn_boardtable.dat");
if ($flocking ne "No"){flock (CATBLE,2);}
	foreach $item (@bcats)
		{
		($cat, $cname) = split (/\t/, $item);
			if ($cat ne "$cid")
				{
				print CATBLE $item . "\n";
				}
		}
if ($flocking ne "No"){flock (CATBLE,8);}
close (CATBLE);	

$currcat = &get_cat_name ($cid);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "Category Deleted", qq[
<form method="POST" action>
<input type="submit" value="    Close Window    " name="B1" onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8">
</form>
]);



print <<END_OF_DELETED;
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>
END_OF_DELETED

}



sub del_cat
{

my ($cid);

$cid = $q->param('cat');

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_spam3.gif", "Delete Category", qq[
<font face="Verdana" size="1"><font color="#FF0000"><strong>Note:</strong></font> All
 forums with their messages residing in this category will be lost!</font></p>
<form method="POST" action="$scripts_admin/sn_admin.cgi">
 <input type="hidden" name="cid" value="$cid"><input type="hidden" name="fct"
  value="delete_catfinal"><p><input type="submit" value="Delete Category" name="B1"
  style="font-family: MS Sans Serif; font-size: 8pt">
</form>
]);



print <<END_OF_DELC;
<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>
END_OF_DELC

}



sub save_forum_settings
{

my ($cid, $fid, $fort, @fprop, $chid, $item, $frid, $fname);

$cid = $q->param('cid');
$fid = $q->param('fid');

### ERROR CHECKING
if ($q->param('forum_name') eq "") 
		{
		sn_netbadmin::errorbox("Your Forum Needs a Name.");
		exit;
		}
		
if ($q->param('forum_description') eq "") 
		{
		sn_netbadmin::errorbox("Your Forum Needs a Description.");
		exit;
		}

if ($q->param('moderators') eq "") 
		{
		sn_netbadmin::errorbox("Your Forum Needs a Moderator Name.");
		exit;
		}

$fort = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fprop = split(/\n/,$fort);

$chid = $fprop[0];

open (FORUMCONF, "> $data_dir/$cid/$fid/config.dat");
if ($flocking ne "No"){flock (FORUMCONF,2);}

	print FORUMCONF $fprop[0] . "\n" . 										### 0 FORUM ID
						 $q->param('forum_name') . "\n" . 					### 1 FORUM NAME
						 $q->param('forum_description') . "\n" . 			### 2 DESCRIPTION
						 $q->param('moderators') . "\n" . 					### 3 MODERATOR NAMES
						 $q->param('whopost') . "\n" . 						### 4 WHO MAY POST
						 $q->param('polls') . "\n" . 							### 5 ALLOW POLLS
						 $q->param('html_msg') . "\n" . 						### 6 ALLOW HTML IN MESSAGES
						 $q->param('moderated') . "\n" .						### 7 IS THIS FORUM MODERATED?
						 $q->param('graphic') . "\n" .						### 8 CUSTOM GRAPHIC?
						 $q->param('icons') . "\n" .							### 9 SMILEY ICONS?
						 $q->param('password_protected') . "\n" .			### 10 PASSWORD PROTECT FORUM?
						 $q->param('fpassword') . "\n" .						### 11 FORUM PASSWORD
						 $q->param('post_priv') . "\n";						### 12 CAN USERS POST

						 
						 
if ($flocking ne "No"){flock (FORUMCONF,8);}
close (FORUMCONF);

### WRITE TO FORUM TABLE

$fort = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
@fprop = split(/\n/,$fort);

open (FTBL, "> $data_dir/$cid/forumtable.dat");
if ($flocking ne "No"){flock (FTBL,2);}

	foreach $item (@fprop)
		{
	   ($frid, $fname) = split (/\t/, $item);
	   	if ($frid eq $chid)
	   		{
	   		print FTBL "$chid" . "\t" . $q->param('forum_name') . "\n";
	   		}
	   		else
	   		{
	   		print FTBL $item . "\n";
	   		}
		}

if ($flocking ne "No"){flock (FTBL,8);}
close (FTBL);

sn_netbadmin::close_window_continue("NO_CLOSE");

}







sub edit_forum
{

my (@fprop, $cid, $fid, $fort, $whop1, $whop2, $whop3, $polls1, $polls2, $ahtml1, 
	 $ahtml2, $fcatname, $forname);

$cid = $q->param('cid');
$fid = $q->param('fid');

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);


$fort = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fprop = split(/\n/,$fort);

if ($fprop[4] eq "Any"){$whop1 = "selected";}
if ($fprop[4] eq "Registered"){$whop2 = "selected";}
if ($fprop[4] eq "Moderators"){$whop3 = "selected";}

if ($fprop[5] eq "Y"){$polls1 = "selected";}
	else
	{$polls2 = "selected";}
	
if ($fprop[6] eq "Y"){$ahtml1 = "selected";}
	else
	{$ahtml2 = "selected";}


if ($fprop[7] eq "Y"){$modr1 = "selected";}
	else
	{$modr2 = "selected";}

if ($fprop[9] eq "N"){$iconno = "selected";}
	else
	{$iconyes = "selected";}

if ($fprop[10] eq "Y"){$pspyes = "selected";}
	else
	{$pspno = "selected";}


if ($fprop[12] eq "N"){$postprvno = "selected";}
	else
	{$postprvyes = "selected";}



######################

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_settings.gif", "Forum Settings > $fcatname > $forname", qq[
Please change any of the settings for this forum below.
]);


print <<END_OF_CF2;

<html>
<head>
<title>Settings</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox
<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="cid" value="$cid"><input type="hidden" name="fct"
  value="save_forum_settings"><input type="hidden" name="fid" value="$fid"><div
  align="center"><center><table border="0" cellpadding="6" width="100%" cellspacing="1"
  bgcolor="#E0E0E0">
    <tr>
      <td width="30%" bgcolor="#FFFFFF" height="30" background="$web_url/sn_bar6.gif"><font
      face="Verdana" size="1" color="#000000"><strong>Setting Description:</strong></font></td>
      <td width="70%" bgcolor="#FFFFFF" height="16" background="$web_url/sn_bar6.gif"><strong><font
      face="Verdana" size="1">Setting:</font></strong></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Forum Name:</font></td>
      <td width="70%" bgcolor="#FFFFFF"><input type="text" name="forum_name" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt; width:100%" maxlength="50"
      value="$fprop[1]"></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Forum Description:</font></td>
      <td width="70%" bgcolor="#FFFFFF"><input type="text" name="forum_description" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt; width:100%" value="$fprop[2]"></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Forum Moderator(s):</font></td>
      <td width="70%" bgcolor="#FFFFFF"><input type="text" name="moderators" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt; width:100%" value="$fprop[3]"><br>
      <font face="Verdana" size="1" color="#000000">If this forum has more than 1 moderator
      separate them via comma. You can assign moderators and administrators for forums by going
      to the <strong>User Manager</strong> and then by editing the users profile.</font></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Who may post messages?</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="whopost" size="1"
      style="font-family: MS Sans Serif; font-size: 8pt">
        <option value="Registered">Registered Users Only</option>
        <option value="Moderators">Only Moderators</option>
      </select></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Allow Users to post polls?</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="polls" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $polls1 value="Y">Yes</option>
        <option $polls2 value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Allow HTML in messages:</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="html_msg" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $ahtml1 value="Y">Yes</option>
        <option $ahtml2 value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Is this forum moderated?</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="moderated" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $modr1 value="Y">Yes</option>
        <option $modr2 value="N">No</option>
      </select><br>
      <font face="Verdana" size="1" color="#000000">When the above is set to yes, new messages
      posted requires approval by the moderator(s) before it is displayed.</font></td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Graphic to use?</font></td>
      <td width="70%" bgcolor="#FFFFFF"><input type="text" name="graphic" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$fprop[8]"><font face="Verdana"
      size="1" color="#000000"><br>
      If you use a custom graphic, upload the graphic to:<br>
      <strong>$web_url</strong></font></td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Do you want to password protect this forum?</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="password_protected" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $pspyes value="Y">Yes</option>
        <option $pspno value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Password, if password protected:</font></td>
      <td width="70%" bgcolor="#FFFFFF"><input type="text" name="fpassword" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$fprop[11]"></td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> May messages be posted in this forum?</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="post_priv" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $postprvyes value="Y">Yes</option>
        <option $postprvno value="N">No</option>
      </select><br>
      <font face="Verdana" size="1" color="#000000">If this is set to 'No', users will only be
      able to read messages.</font></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF"></td>
      <td width="70%" bgcolor="#FFFFFF"><input type="submit" value="   Save Settings   "
      name="B1" style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
  </table>
  </center></div>
</form>

</body>
</html>

END_OF_CF2

}


sub save_titles
{

open (ADVM, "> $data_dir/sn_usertitles.dat");
if ($flocking ne "No"){flock (ADVM,2);}

	print ADVM 		$q->param('posts1') . "\t" . $q->param('title1') . "\n" . 
						$q->param('posts2') . "\t" . $q->param('title2') . "\n" . 
						$q->param('posts3') . "\t" . $q->param('title3') . "\n" . 
						$q->param('posts4') . "\t" . $q->param('title4') . "\n" . 
						$q->param('posts5') . "\t" . $q->param('title5');

if ($flocking ne "No"){flock (ADVM,8);}
close (ADVM);

sn_netbadmin::click_continue("$scripts_admin/sn_admin.cgi?fct=usermanager");

}




sub title_setup
{

my (@files, $usernumber, $tdata, @eltdata, $uitem, $scn, $scor, $utitle, @titled, $ctemplate, $disphtml);


opendir(DIR,"$data_dir/users");
	@files = readdir(DIR);
closedir(DIR);
$usernumber = push(@files);
$usernumber = $usernumber -3;


$tdata = sn_netbadmin::get_file_contents("$data_dir/sn_usertitles.dat");
@eltdata = split(/\n/,$tdata);

	$scn = 0;
	foreach $uitem (@eltdata)
		{
		($scor, $utitle) = split (/\t/,$uitem);
		$titled[$scn] = $scor;
		$scn++;
		$titled[$scn] = $utitle;
		$scn++;
		}
 


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_userman2.gif", "User Manager > Member/Moderator/Administrator Title Configuration", qq[
Configure user rank/status for the amounts of posts made by users. 
]);


 
$disphtml = $disphtml . <<END_OF_MTS;

<html>

<head>
<title>Title Configuration</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox

<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="save_titles"><table border="0" cellspacing="1"
  width="100%" bgcolor="#E0E0E0" cellpadding="6">
    <tr>
      <td width="284" bgcolor="#FFFFFF" height="30" background="$web_url/sn_bar6.gif"><font
      color="#000000" face="Verdana" size="1"><strong>Level 1:</strong></font></td>
      <td width="922" bgcolor="#FFFFFF" height="30" background="$web_url/sn_bar6.gif"></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Number of posts:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="posts1" size="9" style="font-family: MS Sans Serif; font-size: 8" value="$titled[0]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Member Title:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="title1" size="45" style="font-family: MS Sans Serif; font-size: 8"
      value="$titled[1]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"><font
      color="#000000" face="Verdana" size="1"><strong>Level 2:</strong></font></td>
      <td width="922" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Number of posts:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="posts2" size="8" style="font-family: MS Sans Serif; font-size: 8" value="$titled[2]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Member Title:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="title2" size="45" style="font-family: MS Sans Serif; font-size: 8"
      value="$titled[3]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"><font
      color="#000000" face="Verdana" size="1"><strong>Level 3:</strong></font></td>
      <td width="922" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Number of posts:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="posts3" size="8" style="font-family: MS Sans Serif; font-size: 8" value="$titled[4]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Member Title:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="title3" size="45" style="font-family: MS Sans Serif; font-size: 8"
      value="$titled[5]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"><font
      color="#000000" face="Verdana" size="1"><strong>Level 4:</strong></font></td>
      <td width="922" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Number of posts:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="posts4" size="7" style="font-family: MS Sans Serif; font-size: 8" value="$titled[6]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Member Title:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="title4" size="45" style="font-family: MS Sans Serif; font-size: 8"
      value="$titled[7]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"><font
      color="#000000" face="Verdana" size="1"><strong>Level 5:</strong></font></td>
      <td width="922" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Number of posts:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="posts5" size="7" style="font-family: MS Sans Serif; font-size: 8" value="$titled[8]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Member Title:</font></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="text"
      name="title5" size="45" style="font-family: MS Sans Serif; font-size: 8"
      value="$titled[9]"></font></td>
    </tr>
    <tr>
      <td width="284" bgcolor="#FFFFFF"></td>
      <td width="922" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="submit"
      value="    Save    " name="B1" style="font-family: MS Sans Serif; font-size: 8pt"></font></td>
    </tr>
  </table>
</form>

</body>
</html>

END_OF_MTS

print $disphtml;

}


sub mailinglist
{

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_ic_moder.gif", "User Manager > Retrieve Email Addresses For Mailing List", qq[
By pressing the retrieve button, you will receive a complete list of email addresses which you can copy and paste into your mailing list software.
]);

print <<END_OF_EMA;

<html>
<head>
<title>Retrieve Email Addresses</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox

<font face="Verdana" size="1" color="#000000"><strong>Choose which extra fields you
would like included. These fields will be delimited via semi colon if any is chosen.</strong></font><BR><BR>

<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="mailinglist2"><table border="0" width="300"
  cellpadding="4" cellspacing="1">
    <tr>
      <td width="140" height="20"><img src="$web_url/sn_first.gif"><font face="Verdana" size="1">
      Member Name: </font></td>
      <td width="140" height="20"><input type="checkbox" name="membername" value="Y"></td>
    </tr>
    <tr>
      <td width="140" height="20"><img src="$web_url/sn_first.gif"><font face="Verdana" size="1">
      Password:</font></td>
      <td width="140" height="20"><input type="checkbox" name="password" value="Y"></td>
    </tr>
    <tr>
      <td width="140" height="20"><img src="$web_url/sn_first.gif"><font face="Verdana" size="1">
      Home Page Name:</font></td>
      <td width="140" height="20"><input type="checkbox" name="homepage" value="Y"></td>
    </tr>
    <tr>
      <td width="140" height="20"><img src="$web_url/sn_first.gif"><font face="Verdana" size="1">
      Home Page URL:</font></td>
      <td width="140" height="20"><input type="checkbox" name="URL" value="Y"></td>
    </tr>
  </table>
  <BR>
  <input type="submit" value="Retrieve" name="B1"
  style="font-family: MS Sans Serif; font-size: 8">
</form>
</body>
</html>

END_OF_EMA



}





sub mailinglist2
{

my (@files, $usernumber, $memail, $fdetails, $fcnts, @tmpcont, $ctemplate, $disphtml);


opendir(DIR,"$data_dir/users");
	@files = readdir(DIR);
closedir(DIR);
$usernumber = push(@files);


foreach $memail (@files)
	{
	if (($memail ne ".") and ($memail ne "..") and ($memail ne "users.dat"))
		{
		$fcnts = sn_netbadmin::get_file_contents("$data_dir/users/$memail");
		@tmpcont = split(/\n/, $fcnts);
		
		####
		
		$fdetails = $fdetails . $tmpcont[2];
	    	
	    	if ($q->param('membername') eq "Y") 
	    		{
	    		$fdetails = $fdetails . ";" . $tmpcont[0];
	    		}

	    	if ($q->param('password') eq "Y") 
	    		{
	    		$fdetails = $fdetails . ";" . $tmpcont[1];
	    		}

	    	if ($q->param('homepage') eq "Y") 
	    		{
	    		if ($tmpcont[4] eq ""){$tmpcont[4] = "Not Specified";}
	    		$fdetails = $fdetails . ";" . $tmpcont[4];
	    		}		

	    	if ($q->param('URL') eq "Y") 
	    		{
	    		if ($tmpcont[6] eq ""){$tmpcont[6] = "Not Specified";}
	    		$fdetails = $fdetails . ";" . $tmpcont[6];
	    		}		

		$fdetails = $fdetails . "<br>\n";
		
		}
	}

print <<END_OF_MLIST;

<html>

<head>
<title>Retrieve Email Addresses</title>
</head>
<body>
<p><font face="Verdana" size="1"><strong>User Manager  Retrieve Email Addresses For
Mailing List<br>
</strong>Copy and paste the email addresses below into your mailing list software.</font></p>
<p><font face="Verdana" size="1">$fdetails</font></p>
<p>&nbsp;</p>
</body>
</html>

END_OF_MLIST

}






sub save_member_info
{

my ($mname, $uid, $homepage_diz,  $interests, $signature, $ufcontents, @oui);

### ERROR CHECKING

if ($q->param('email_address') eq "") {sn_netbadmin::errorbox("The current user needs to have an email address."); exit;}
if ($q->param('password') eq "") {sn_netbadmin::errorbox("The current user needs to have a password."); exit;}

###################

$mname = $q->param('member');
$mname =~ s/ /_/g;
$uid = $q->param('uid');

$homepage_diz = $q->param('homepage_diz');
$homepage_diz =~ s/\n/<br>/g;

$interests = $q->param('interests');
$interests =~ s/\n/<br>/g;

$signature = $q->param('signature');
$signature =~ s/\n/<br>/g;

$ufcontents = sn_netbadmin::get_file_contents("$data_dir/users/$mname.dat");
@oui = split(/\n/,$ufcontents);


if (substr($q->param('mstatus'), 0, 2) ne "Me")
	{
	if ($q->param('mod_not') eq "Y")
		{
		$memails = "15MODERATOR_MESSAGE_NOTIFICATION=Y";
		}
	}
	else
	{
	$memails = "15MODERATOR_MESSAGE_NOTIFICATION=N";
	}


open (USFILE, "> $data_dir/users/$mname.dat");
if ($flocking ne "No"){flock (USFILE,2);}

	print USFILE 	$uid . "\n" . 								### 0 USER ID
						$q->param('password') . "\n" . 			### 1 EMAIL ADDRESS
						$q->param('email_address') . "\n" . 		### 2 EMAIL ADDRESS
						$q->param('email_visible') . "\n" . 		### 3 EMAIL VISIBLE
						$q->param('home_page') . "\n" . 		### 4 HOME PAGE NAME
						$homepage_diz . "\n" . 				### 5 HOME PAGE DIZ
						$q->param('home_page_url') . "\n" .		### 6 HOME PAGE URL
						$q->param('icq_number') . "\n" . 		### 7 ICQ NUMBER
						$q->param('location') . "\n" . 			### 8 LOCATION
						$interests . "\n" . 							### 9 INTEREST
						$q->param('occupation') . "\n" .			### 10 OCCUPATION
						$signature . "\n" . 							### 11 SIGNATURE
						$q->param('mstatus') . "\n" . 			### 12 MEMBER STATUS
						$oui[13] . "\n" . 							### 13 JOINED ON DATE
						$oui[14] . "\n" .	 							### 14 TOTAL POSTS
						$oui[15] . "\n" .	 							### 15 TOTAL POSTS
						$memails . "\n";	 							### 16 MODERATOR NOTIFICATION

if ($flocking ne "No"){flock (USFILE,8);}
close (USFILE);

sn_netbadmin::close_window_continue("NO_CLOSE");

}





sub getuserinfo
{

my ($themember, $membername, $fcnts, $fli, @tmpcont, $emy, $emn, $sel1, $sel2, $sel3,
	 $userimage, $allusers, @allu, $item);

$fli = $q->param('user');

$allusers = sn_netbadmin::get_file_contents("$data_dir/users/users.dat");
@allu = split (/\n/, $allusers);
foreach $item (@allu)
	{
	if (lc($item) eq lc($fli))
		{
		$fli = $item;
		}
	}


$fli =~ s/ /_/g;

if ((-e "$data_dir/users/$fli.dat") < 1)
	{


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_foruman2.gif", "Problem > Could not find user $fli", qq[
<form method="POST" action>
  <p><input type="submit" value="    Close Window    " name="B1"
  onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8"></p>
</form>
]);

	
print <<END_OF_PRB;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

END_OF_PRB
exit;
	
	}


$fcnts = sn_netbadmin::get_file_contents("$data_dir/users/$fli.dat");
@tmpcont = split(/\n/, $fcnts);

$tmpcont[5] =~ s/<br>/\n/g;
$tmpcont[9] =~ s/<br>/\n/g;
$tmpcont[11] =~ s/<br>/\n/g;
$membername = $fli;
$membername =~ s/_/ /g;

if ($tmpcont[3] eq "N")
	{
	$emn = "selected";
	}
	else
	{
	$emy = "selected";
	}



if (substr($tmpcont[12], 0, 2) eq "Ad")
	{
	$sel1 = "selected";
	}
	elsif (substr($tmpcont[12], 0, 2) eq "Mo")
	{
	$sel2 = "selected";
	}
	else
	{
	$sel3 = "selected";
	}

$tmpcont[13] = sn_netbadmin::decode_date("$tmpcont[13]");

if ($tmpcont[15] =~ /USER_DEFINED/)
	{
	$tmpcont[15] =~ s/USER_DEFINED//g;
	$userimage = "<img src=\"$web_url/user_imagesc/$tmpcont[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}
	elsif ($tmpcont[15] ne "")
	{
	$userimage = "<img src=\"$web_url/user_images/$tmpcont[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}
	else
	{
	$userimage = "None";
	}


if ($tmpcont[16] eq "15MODERATOR_MESSAGE_NOTIFICATION=Y")
	{
	$modn_yes = "selected";
	}
	else
	{
	$modn_no = "selected";
	}


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_foruman2.gif", "User Manager  Member Info", qq[
Editing account for: <b>$membername</b>
]);



print <<END_OF_MINFO;

<html>
<head>
<title>Member Info</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="save_member_info"><input type="hidden" name="uid"
  value="$tmpcont[0]"><input type="hidden" name="member" value="$membername"><table
  border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E0E0E0">
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Member Name:</font></td>
      <td width="64%" bgcolor="#FFFFFF" height="27"><strong><font face="Verdana" size="1">$membername</font></strong></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Email Address:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="email_address" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$tmpcont[2]"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Password:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="password" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$tmpcont[1]"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Email Address Visible in Posts?</font></td>
      <td width="64%" bgcolor="#FFFFFF"><select name="email_visible" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $emy value="Y">Yes</option>
        <option $emn value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Home Page Name:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="home_page" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$tmpcont[4]"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1"> Home Page Description:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><textarea rows="6" name="homepage_diz" cols="32"
      style="font-family: MS Sans Serif; font-size: 8pt">$tmpcont[5]</textarea></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Home Page URL:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="home_page_url" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$tmpcont[6]"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> ICQ Number:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="icq_number" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$tmpcont[7]"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Location:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="location" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$tmpcont[8]"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Interests:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><textarea rows="6" name="interests" cols="32"
      style="font-family: MS Sans Serif; font-size: 8pt">$tmpcont[9]</textarea></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Occupation:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="occupation" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value="$tmpcont[10]"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Signature:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><textarea rows="6" name="signature" cols="32"
      style="font-family: MS Sans Serif; font-size: 8pt">$tmpcont[11]</textarea></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Member Status:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><select name="mstatus" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $sel1 value="Administrator">Administrator</option>
        <option $sel2 value="Moderator">Moderator</option>
        <option $sel3 value="Member">Member</option>
      </select></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1"> Receive Email Notification:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><select name="mod_not" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $modn_yes value="Y">Yes</option>
        <option $modn_no value="N">No</option>
      </select><br>
      <font face="Verdana" size="1">Setting this to 'Yes' will have the effect of this user
      recieving email notification of each new message posted in forums where this user is a
      moderator. This option is only valid for moderators and administrators of forums.</font></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top" height="27"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Member Since:</font></td>
      <td width="64%" bgcolor="#FFFFFF" height="27"><strong><font face="Verdana" size="1">$tmpcont[13]</font></strong></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top" height="27"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Total Posts:</font></td>
      <td width="64%" bgcolor="#FFFFFF" height="27"><strong><font face="Verdana" size="1">$tmpcont[14]</font></strong></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top" height="27"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> User Image</font></td>
      <td width="64%" bgcolor="#FFFFFF" height="27"><font face="Verdana" size="1"><strong>$userimage</strong></font></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="submit" value="     Save    " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
  </table>
</form>

</body>
</html>

END_OF_MINFO

}



sub myforum1
{
&write_var ("RSTS", $q->param('serial'));

$serial = $q->param('serial');
$orderid = $q->param('Order_ID');
$name = $q->param('name');

print "Location: http://www.focalmedia.net/cgi-bin/regnetboard/rg2.cgi?ss=$serial&id=$orderid&name=$name\n\n";
exit;

}




sub myforum
{


$disphtml = <<END_OF_MF;


<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="myforum1"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" bgcolor="#E2E2E2">
    <tr>
      <td width="100%" colspan="2" background="$web_url/sn_bar6.gif" height="30"><font
      color="#000000" face="Verdana" size="2"><strong>Register SiteNet BBS</strong></font></td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><font face="Verdana" size="2"><strong>Serial Number:<br>
      </strong>You should have received this number/code via email. </font></td>
      <td width="52%" bgcolor="#FFFFFF"><font face="Verdana" size="2"><input type="text"
      name="serial" size="38"></font></td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><font face="Verdana" size="2"><strong>Order ID:<br>
      </strong>This ID will be present in the subject line of one of the emails you received
      after registration. It will look something like this: <strong>20020109184617</strong></font></td>
      <td width="52%" bgcolor="#FFFFFF"><font face="Verdana" size="2"><input type="text"
      name="Order_ID" size="38"></font></td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"><font face="Verdana" size="2"><strong>Full Name or
      Company Name:</strong></font></td>
      <td width="52%" bgcolor="#FFFFFF"><font face="Verdana" size="2"><input type="text"
      name="name" size="38"></font></td>
    </tr>
    <tr>
      <td width="48%" bgcolor="#FFFFFF"></td>
      <td width="52%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><input type="submit"
      value="Register" name="B1"></font></td>
    </tr>
  </table>
</form>

END_OF_MF

$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;


}




sub get_users
{

my ($usernumber, @files, $uletter, $fdetails, $fli, $fcnts, @tmpcont, $uname, $ctemplate, $disphtml);

opendir(DIR,"$data_dir/users");
	@files = readdir(DIR);
closedir(DIR);

$usernumber = @files;

$uletter = $q->param('letter');

$disphtml = &get_umanage_top($usernumber);


foreach $fli (@files)
	{
	if ($fli ne "users.dat")
		{
		if ((substr($fli, 0, 1) eq $uletter) or (substr($fli, 0, 1) eq lc($uletter)))
			{
			$uname = $fli;
			$uname =~ s/\.dat//g;
			$fdetails = $fdetails . "<a href=\"$scripts_admin/sn_admin.cgi?fct=getuserinfo&user=$uname\" onClick=\"popup('$scripts_admin/sn_admin.cgi?fct=getuserinfo&user=$uname',screen.width -200,screen.height -200);return false;\">$uname</a><Br>";
			}
		}
	}


$disphtml = $disphtml . <<END_OF_USTART;
<div align="right">
<table border="0" cellspacing="3" width="100%">
  <tr>
    <td width="100%"><font face="Verdana" size="2"><strong>Members Starting With The Letter: <font
    color="#8080C0">$uletter</font><br>
    </strong></font><font face="Verdana" size="1">Click on a member name to view/edit the
    members details.<br>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </font></td>
  </tr>
  <tr>
    <td width="100%"><font face="Verdana" size="1"></font><font face="Verdana" size="2">$fdetails</font><font
    face="Verdana" size="1"></font></td>
  </tr>
</table>
</div>
END_OF_USTART



$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;


}





sub usermanager
{

my (@a, $usernumber, @files, $uitem, $uletter, $acount, $uitem, $usernumber, $ctemplate, $disphtml);

@a = ("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N",
		"O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "0", "1", 
		"2", "3", "4",	"5", "6", "7", "8", "9", "0");

opendir(DIR,"$data_dir/users");
	@files = readdir(DIR);
closedir(DIR);

$usernumber = push(@files);


foreach $uitem (@files)
	{
   if (($uitem ne "users.dat") and ($uitem ne ".") and ($uitem ne ".."))
     {
     
	$acount = 0;
	foreach $uletter(@a)
		{
		
		#print substr($uitem, 0, 1) . " - " . lc($uletter) . "-" . "$uletter" . "<br>";
		
		if ((substr($uitem, 0, 1) eq $uletter) or (substr($uitem, 0, 1) eq lc($uletter)))
			{
			$a[$acount] = "<a href=\"$scripts_admin/sn_admin.cgi?fct=get_users&letter=$a[$acount]\">$a[$acount]</a>";
			}
		$acount++;
		
	 	 }
	  }
	}

$disphtml = $disphtml . &get_umanage_top($usernumber);

$disphtml = $disphtml . <<END_OF_UM;


<table border="0" cellspacing="1" width="100%" bgcolor="#E0E0E0" cellpadding="6">
  <tr>
    <td width="100%" background="$web_url/sn_bar6.gif" height="30"><strong><font face="Verdana"
    size="2">Click on a letter below to view users:<br>
    </font></strong><font face="Verdana" size="1">User names will start with the specific
    letters.</font></td>
  </tr>
</table><BR>
<table border="0" cellspacing="3" width="100%">
  <tr>
    <td width="7%"><font face="Verdana" size="2">$a[0]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[1]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[2]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[3]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[4]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[5]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[6]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[7]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[8]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[9]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[10]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[11]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[12]</font></td>
  </tr>
  <tr>
    <td width="7%"><font face="Verdana" size="2">$a[13]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[14]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[15]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[16]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[17]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[18]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[19]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[20]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[21]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[22]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[23]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[24]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[25]</font></td>
  </tr>
  <tr>
    <td width="7%"><font face="Verdana" size="2">$a[26]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[27]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[28]</font></td>
    <td width="7%"><font face="Verdana" size="2">$a[29]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[30]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[31]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[32]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[33]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[34]</font></td>
    <td width="8%"><font face="Verdana" size="2">$a[35]</font></td>
    <td width="8%"></td>
    <td width="8%"></td>
    <td width="8%"></td>
  </tr>
</table>
<BR>
<table border="0" cellspacing="1" width="100%" cellpadding="3">
  <tr>
    <td width="100%"><hr noshade size="1" color="#C0C0C0">
    </td>
  </tr>
</table>


END_OF_UM


$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;
}





sub chksetupid
{

if ((-e "$data_dir/users") < 1)
	{
	mkdir("$data_dir/users",0777);
	chmod(0777,"$data_dir/users","$data_dir/users");
	}

$exists = (-e "$data_dir/sn_id2.dat");
if ($exists < 1)
	{
open (BIPS, "> $data_dir/sn_id2.dat");
if ($flocking ne "No"){flock (BIPS,2);}
print BIPS <<END_OF_ST;
60,112,32,97,108,105,103,110,61,34,99,101,110,116,101,114,34,62,60,102,111,110,116,32,102,97,99,101,61,34,86,101,114,100,97,110,97,34,32,115,105,122,101,61,34,49,34,62,80,111,119,101,114,101,100,32,98,121,32,60,97,13,10,104,114,101,102,61,34,104,116,116,112,58,47,47,119,119,119,46,102,111,99,97,108,109,101,100,105,97,46,110,101,116,47,99,103,105,45,98,105,110,47,102,109,115,105,116,101,98,98,115,46,99,103,105,34,62,83,105,116,101,78,101,116,32,66,66,83,60,47,97,62,32,124,32,83,105,116,101,78,101,116,32,66,66,83,13,10,67,111,112,121,114,105,103,104,116,32,33,33,121,109,33,33,32,60,97,32,104,114,101,102,61,34,104,116,116,112,58,47,47,119,119,119,46,102,111,99,97,108,109,101,100,105,97,46,110,101,116,34,32,116,97,114,103,101,116,61,34,95,98,108,97,110,107,34,62,70,111,99,97,108,77,101,100,105,97,46,78,101,116,60,47,97,62,60,47,102,111,110,116,62,60,47,112,62,
END_OF_ST
if ($flocking ne "No"){flock (BIPS,8);}
close (BIPS);
$stat = chmod(0777,"$data_dir/sn_id2.dat","$data_dir/sn_id2.dat");

open (BIPS2, "> $data_dir/sn_id3.dat");
print BIPS2 <<END_OF_BIPS;
75,76,74,108,107,115,100,102,44,76,106,115,108,115,105,51,108,44,78,119,
101,101,119,108,107,106,44,79,105,105,101,119,106,114,108,44,74,108,119,
101,114,73,119,101,44,102,115,74,108,74,97,108,51,44,50,51,52,106,74,108,
97,97,44,51,50,52,106,75,97,101,100,44,115,102,100,51,50,48,48,100,44,74,
108,106,100,105,101,112,119,44,57,50,51,52,106,114,108,44,106,108,106,115,
102,105,51,57,44,76,106,107,102,100,105,112,119,44,56,48,50,51,52,55,49,
56,44,74,107,108,115,100,102,119,112,44,57,55,50,51,107,100,106,102,44,57,
51,50,52,108,119,106,115,44,57,50,51,52,55,115,108,107,44,57,50,106,57,102,
115,102,48,44,57,102,115,52,57,107,115,100,44,74,57,115,100,102,108,119,51,
44,55,57,50,51,106,100,44,115,100,102,56,52,51,48,50,44,115,107,102,115,
102,51,56,50,13,10,
END_OF_BIPS
close (BIPS2);
$stat = chmod(0777,"$data_dir/sn_id3.dat","$data_dir/sn_id3.dat");

	}




}




sub save_cat_name
{

my ($cid, $catname, $fsize, $allcats, @icats, $item, $rcid, $cname, $rcrit, $rcidm);

$catname = $q->param('catname');
$cid = $q->param('cid');

### CHECK FOR ERRORS
if ($catname eq "") {sn_netbadmin::errorbox("You need to specify a name for the category."); exit;}


$fsize = (-s "$data_dir/sn_boardtable.dat");
 open (RVF, "$data_dir/sn_boardtable.dat");
	read(RVF,$allcats,$fsize);
 close (RVF);

(@icats) = split(/\n/,$allcats);

foreach $item (@icats)
	{
	($rcidm, $cname)  = split(/\t/,$item);
		
		if ($rcidm == $cid)
			{
			$cname = $catname;
			}
	
	$rcrit = $rcrit . $rcidm . "\t" . $cname . "\n";
	
	}


 open (RVF, "> $data_dir/sn_boardtable.dat");
  if ($flocking ne "No"){flock (RVF,2);}
 	print RVF $rcrit;
  if ($flocking ne "No"){flock (RVF,8);}
 close (RVF);


sn_netbadmin::close_window_continue;

}



sub edit_cat
{

my ($catname, $cid2);

$cid2 = $q->param('cat');

$catname = &get_cat_name($cid2);
$catname =~ s/\n//g;


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_foruman2.gif", "Edit Category Name", qq[
<form method="POST" action="$scripts_admin/sn_admin.cgi">
<input type="hidden" name="cid" value="$cid2">
<input type="hidden" name="fct" value="save_cat_name">
<font face="Verdana" size="1">Category Name: </font>
<input type="text" name="catname" size="55" style="font-family: MS Sans Serif; font-size: 8pt" value="$catname"> 
<input type="submit" value="Save" name="B1" style="font-family: MS Sans Serif; font-size: 8pt"></p>
    </form>
]);


print <<END_OF_EN;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>


END_OF_EN

}




sub delete_forum
{

my ($cid, $fid, @files, $item, $stat, $line, $tfid, $fname, $newcrit);

$cid = $q->param('cid');
$fid = $q->param('fid');

opendir(DIR,"$data_dir/$cid/$fid");
	@files = readdir(DIR);
closedir(DIR);

	foreach $item(@files)
		{
	 	if (($item ne ".") and ($item ne ".."))
		 	{
			unlink "$data_dir/$cid/$fid/$item";
			}
		}

	$stat = rmdir("$data_dir/$cid/$fid");

 open (RVF, "$data_dir/$cid/forumtable.dat");
	while (defined($line=<RVF>))	
		{
		($tfid, $fname) = split(/\t/,$line);
			if ($tfid ne $fid)
				{
				$newcrit = $newcrit . $line;
				}
		}
 close (RVF);


open (RVF, "> $data_dir/$cid/forumtable.dat");
if ($flocking ne "No"){flock (RVF,2);}
	print RVF $newcrit;
if ($flocking ne "No"){flock (RVF,8);}
close (RVF);

$disphtml = sn_netbadmin::main_settings_saved("Forum Manager", "$scripts_admin/sn_admin.cgi?fct=boardmanager");
$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;



}





sub create_new_forum
{

my ($newid, $catid, $catname);


### CHECK FOR ERRORS
if ($q->param('forum_name') eq "") 
	{sn_netbadmin::errorbox("You need to specify a name for your forum."); exit;}

if ($q->param('forum_description') eq "") 
	{sn_netbadmin::errorbox("You need to specify a description for your forum."); exit;}

if ($q->param('moderators') eq "") 
	{sn_netbadmin::errorbox("You need to specify a moderator for your forum."); exit;}

if ($q->param('moderators') eq "") 
	{sn_netbadmin::errorbox("You need to specify a moderator for your forum."); exit;}


$catid = $q->param('cat');

$catname = &get_cat_name($catid);

$newid = &increment_id;

mkdir("$data_dir/$catid/$newid",0777);

open (FTBL, ">> $data_dir/$catid/forumtable.dat");
if ($flocking ne "No"){flock (FTBL,2);}
	print FTBL $newid . "\t" . $q->param('forum_name') . "\n";
if ($flocking ne "No"){flock (FTBL,8);}
close (FTBL);

open (FTBL, ">> $data_dir/$catid/$newid/config.dat");
 if ($flocking ne "No"){flock (FTBL,2);}
 
	print FTBL  $newid . "\n" . 								### 0 ID
				$q->param('forum_name') . "\n" .				### 1 FORUM NAME
				$q->param('forum_description') . "\n" .	### 2 FORUM DESCRIPTION
				$q->param('moderators') . "\n" .				### 3 MODERATOR
				$q->param('whopost') . "\n" . 				### 4 WHO MAY POST
				$q->param('polls') . "\n" . 					### 5 MAY POLLS BE POSTED
				$q->param('html_msg') . "\n" .				### 6 HTML ALLOWED
				$q->param('moderated') . "\n" . 				### 7 MODERATED
			   $q->param('graphic') . "\n" .					### 8 CUSTOM GRAPHIC?
				$q->param('icons') . "\n" .					### 9 SMILEY ICONS?
				$q->param('password_protected') . "\n" .	### 10 PASSWORD PROTECT FORUM?
				$q->param('fpassword') . "\n" .				### 11 FORUM PASSWORD
				$q->param('post_priv') . "\n";				### 12 CAN USERS POST



 if ($flocking ne "No"){flock (FTBL,8);}
close (FTBL);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_foruman2.gif", "Forum Created", qq[
<form method="POST" action>
      <p>&nbsp; <input type="submit" value="Close This Window" name="B1"
      onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8pt" maxlength="50"></p>
    </form>
]);


print <<END_OF_CRET;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>

END_OF_CRET


}




sub add_forum
{

my ($catname, $catid);

$catid = $q->param('cat');

$catname = &get_cat_name ($catid);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_foruman2.gif", "Add Forum To  $catname", qq[
Please specify the configuration details below.
]);



print <<END_OF_CF;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="cat" value="$catid"><input type="hidden" name="fct"
  value="create_new_forum"><div align="center"><center><table border="0" cellpadding="6"
  cellspacing="1" width="100%" bgcolor="#E0E0E0">
    <tr>
      <td width="33%" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"><font
      face="Verdana" size="1" color="#000000"><strong>Forum Settings Description:</strong></font></td>
      <td width="67%" bgcolor="#FFFFFF" background="$web_url/sn_bar6.gif" height="30"><font
      face="Verdana" size="1" color="#000000"><strong>Settings:</strong></font></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Forum Name:</font></td>
      <td width="67%" bgcolor="#FFFFFF"><input type="text" name="forum_name" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt; width:100%" maxlength="80"></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Forum Description:</font></td>
      <td width="67%" bgcolor="#FFFFFF"><input type="text" name="forum_description" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt; width:100%" maxlength="255"></td>
    </tr>
    <tr>
      <td width="33%" valign="top" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Forum Moderator(s):</font></td>
      <td width="67%" bgcolor="#FFFFFF"><input type="text" name="moderators" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt; width:100%" maxlength="50"><br>
      <font face="Verdana" size="1" color="#000000">If this forum has more than 1 moderator
      seperate them via comma. You can assign moderators and administrators for forums by going
      to the <strong>User Manager</strong> and then by editing the users profile.</font></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Who may post messages?</font></td>
      <td width="67%" bgcolor="#FFFFFF"><select name="whopost" size="1"
      style="font-family: MS Sans Serif; font-size: 8pt">
        <option value="Registered">Registered Users Only</option>
        <option value="Moderators">Only Moderators</option>
      </select></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Allow Users to post polls?</font></td>
      <td width="67%" bgcolor="#FFFFFF"><select name="polls" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option selected value="Y">Yes</option>
        <option value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1" color="#000000"> Allow HTML in messages?</font></td>
      <td width="67%" bgcolor="#FFFFFF"><select name="html_msg" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option selected value="Y">Yes</option>
        <option value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Is this forum moderated?</font></td>
      <td width="67%" bgcolor="#FFFFFF"><select name="moderated" size="1"
      style="FONT-FAMILY: MS Sans Serif; FONT-SIZE: 8px">
        <option value="Y">Yes</option>
        <option selected value="N">No</option>
      </select><br>
      <font face="Verdana" size="1" color="#000000">When the above is set to yes, new messages
      posted requires aproval by the moderator(s) before it is displayed.</font></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Graphic to use?</font></td>
      <td width="67%" bgcolor="#FFFFFF"><input type="text" name="graphic" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt" value="sn_logo1.jpg"><font face="Verdana"
      size="1" color="#000000"><br>
      If you use a custom graphic, upload the graphic to:<br>
      <strong>$web_url</strong></font></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> Do you want to password protect this forum?</font></td>
      <td width="67%" bgcolor="#FFFFFF"><select name="password_protected" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option value="Y">Yes</option>
        <option selected value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000">&nbsp; Password, if password protected:</font></td>
      <td width="67%" bgcolor="#FFFFFF"><input type="text" name="fpassword" size="31"
      style="font-family: MS Sans Serif; font-size: 8pt"></td>
    </tr>
    <tr>
      <td width="33%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1" color="#000000"> May messages be posted in this forum?</font></td>
      <td width="67%" bgcolor="#FFFFFF"><select name="post_priv" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option $postprvyes value="Y">Yes</option>
        <option $postprvno value="N">No</option>
      </select><br>
      <font face="Verdana" size="1" color="#000000">If this is set to 'No', users will only be
      able to read messages.</font></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF"></td>
      <td bgcolor="#FFFFFF"><input type="submit" value="   Create Forum   " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
  </table>
  </center></div>
</form>


</body>
</html>

END_OF_CF

}






sub add_category_final
{

my ($newid);

if ($q->param('catname') eq "") 
	{
	sn_netbadmin::errorbox("You have to specify a category name."); exit; 
	}

$newid = &increment_id;

open (CTABLE, ">> $data_dir/sn_boardtable.dat");
 if ($flocking ne "No"){flock (CTABLE,2);}
	print CTABLE "$newid" . "\t" . $q->param('catname') . "\n";
 if ($flocking ne "No"){flock (CTABLE,8);}
close (CTABLE);

mkdir("$data_dir/$newid",0777);


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_add.gif", "Category Successfully Added!", qq[
<form method="POST" action>
  <p><input type="submit" value="Close This Window" name="B1"
  onClick="self.close();return false"></p>
</form>
]);


print <<END_OF_NC;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>

END_OF_NC

}






sub add_category
{

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_add.gif", "Add a New Forum Category", qq[
<form method="POST" action="$scripts_admin/sn_admin.cgi">
      <input type="hidden" name="fct" value="add_category_final"><font face="Verdana" size="1">
      Category Name: </font><input type="text" name="catname" size="60"
      style="font-family: MS Sans Serif; font-size: 8pt"> <input type="submit" value="Add"
      name="B1" style="font-family: MS Sans Serif; font-size: 8pt">
    </form>
]); 


print <<END_OF_ADD;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_ADD

}






sub boardmanager
{

my ($catnumber, $boardnumber, $categories, $line, $id, $catname, $catdata,
	$fline, $fid, $fname, $catforums, @fsettings, $tposts, $views, $treps, $fsz, $mtopics, $mpic,
	$totalmsgs, $ctemplate, $disphtml, $custname);


### GET CATEGORIES

open (BTABLE, "$data_dir/sn_boardtable.dat");
	while (defined($line=<BTABLE>))
		{
		($id, $catname) = split(/\t/,$line,2);

		##### GET FORUMS
		
		$catforums = "";
		
		$fsz = (-s "$data_dir/$id/forumtable.dat");
		if ((-e "$data_dir/$id/forumtable.dat") and ($fsz != 0))
			{
			open (FTABLE, "$data_dir/$id/forumtable.dat");
				while (defined($fline=<FTABLE>))
					{
					($fid, $fname) = split(/\t/,$fline,2);
					
					(@fsettings) = &get_forum_settings ($id, $fid);
					
					($tposts, $treps, $views) = sn_netbadmin::get_stats($id, $fid, $data_dir);
					
					$mtopics = sn_netbadmin::get_file_contents("$data_dir/$id/$fid/mtopics.cnt");
					
					if ($mtopics > 0) {$mtopics = "<br>Qued:<b>$mtopics</b>";} else {$mtopics = "";}

	
	if ($fsettings[7] eq "Y") { $mpic = "<img src=\"$web_url/sn_modr.gif\" alt=\"Moderated Forum\"> ";}
									else
									  { $mpic = "<img src=\"$web_url/sn_modrn.gif\" alt=\"Moderated Forum\"> ";}
	
	
	$totalmsgs = $tposts + $treps;

	$custname = "<br>Default";
   if ((-e "$data_dir/$id/$fid/cust_tmpl.dat") > 0)
   	{
   	$custname = sn_netbadmin::get_file_contents("$data_dir/$id/$fid/cust_tmpl.dat");
   	$custname =~ s/\.html//g;
   	$custname = "<br>$custname";
   	}
					
$catforums = $catforums . <<END_OF_CFORUMS;
  <tr>
    <td width="40%" bgcolor="#FFFFFF" colspan="1"><b><a
    href="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$id&amp;fid=$fid" target="_blank"><font
    face="Verdana" size="1">$fname</font></a> <font face="Verdana" size="2"><br>
    </font></b><font face="Verdana" size="1">$fsettings[2]<br>
    <b>Topics: $tposts Replies: $treps Total: $totalmsgs</b><br>
    <br>
    </font></td>
    <td width="10%" bgcolor="#FFFFFF" align="center"><font face="Verdana" size="1"><a
    href="$scripts_admin/sn_admin.cgi?fct=delete_topics_scr&amp;cid=$id&amp;fid=$fid"
    onClick="popup('$scripts_admin/sn_admin.cgi?fct=delete_topics_scr&amp;cid=$id&amp;fid=$fid',screen.width -200,screen.height -200);return false;">Delete
    Topics</a></font> </td>
    <td width="10%" bgcolor="#FFFFFF" align="center"><font face="Verdana" size="1"><a
    href="$scripts_admin/sn_admin2.cgi?fct=move_topics&amp;cid=$id&amp;fid=$fid"
    onClick="popup('$scripts_admin/sn_admin2.cgi?fct=move_topics&amp;cid=$id&amp;fid=$fid',screen.width -200,screen.height -200);return false;">Move</a>
    | <a
    href="$scripts_admin/sn_admin2.cgi?fct=move_topics&amp;cid=$id&amp;fid=$fid&amp;tcopy=tcopy"
    onClick="popup('$scripts_admin/sn_admin2.cgi?fct=move_topics&amp;cid=$id&amp;fid=$fid&amp;tcopy=tcopy',screen.width -200,screen.height -200);return false;">Copy</a></font>
    </td>
    <td width="10%" bgcolor="#FFFFFF" align="center"><font face="Verdana" size="1">$mpic<a
    href="$scripts_admin/sn_admin3.cgi?fct=moderate&amp;cid=$id&amp;fid=$fid"
    onClick="popup('$scripts_admin/sn_admin3.cgi?fct=moderate&amp;cid=$id&amp;fid=$fid',screen.width -200,screen.height -200);return false;">Moderation</a>
    $mtopics</font></td>
    <td width="10%" bgcolor="#FFFFFF" align="center"><font color="#0000FF" face="Verdana"
    size="1"><a href="$scripts_admin/sn_admin.cgi?fct=delete_forum&amp;cid=$id&amp;fid=$fid"
    onClick="var returner = areyousure('Delete'); return returner">Delete Forum</a></font> </td>
    <td width="10%" bgcolor="#FFFFFF" align="center"><font color="#0000FF" face="Verdana"
    size="1"><a href="$scripts_admin/sn_admin.cgi?fct=edit_forum&amp;cid=$id&amp;fid=$fid"
    onClick="popup('$scripts_admin/sn_admin.cgi?fct=edit_forum&amp;cid=$id&amp;fid=$fid',screen.width -200,screen.height -300);return false;">Forum
    Settings</a></font></td>
  </tr>
	
END_OF_CFORUMS
						}
			close (FTABLE);
			}
			else
			{
			
			### NO FORUMS
$catforums = $catforums . <<END_OF_NOF;
  <tr>
    <td bgcolor="#FFFFFF" colspan="7"><font color="#000000" face="Verdana"
    size="1">This category currently has no forums. Please add a forum to this category by
    clicking the <strong>'Add Forum'</strong> Link.</font></td>
  </tr>
END_OF_NOF
			
			}
	
##### GET CATEGORY NAME
$categories = $categories . <<END_OF_TBL;

<table border="0" cellpadding="4" cellspacing="1" width="100%" bgcolor="#E2E2E2">
  <tr>
    <td width="100%" colspan="7" height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="2" color="#000000"><b><img src="$web_url/sn_arr.gif"></b><strong>
    $catname</strong></font></td>
  </tr>
  <tr>
    <td width="40%" bgcolor="#F9F9F9" colspan="1" height="25"><font face="Verdana" size="1"
    color="#000000"><strong>Forum Names &amp; Descriptions</strong></font></td>
    <td width="30%" bgcolor="#F9F9F9" height="25" colspan="4"><p align="center"><font face="Verdana"
    size="1" color="#000000"><strong>Topic Maintenance</strong></font></td>
    <td width="30%" bgcolor="#F9F9F9" height="25" colspan="1"><p align="center"><font face="Verdana"
    size="1" color="#000000"><strong>Forum Settings &amp; Options</strong></font></td>
  </tr>
  $catforums
  <tr>
    <td width="100%" bgcolor="#F9F9F9" colspan="7"><b><font face="Verdana" size="2"
    color="#000000"><img src="$web_url/sn_arr.gif"></font></b><font face="Verdana" size="1"><b> <a
    href="$scripts_admin/sn_admin.cgi?fct=add_forum&amp;cat=$id"
    onClick="popup('$scripts_admin/sn_admin.cgi?fct=add_forum&amp;cat=$id',screen.width -200,screen.height -200);return false;">Add
    Forum to This Category</a> | <a href="$scripts_admin/sn_admin.cgi?fct=edit_cat&amp;cat=$id"
    onClick="popup('$scripts_admin/sn_admin.cgi?fct=edit_cat&amp;cat=$id',600,300);return false;">Edit
    Category Name</a> | <a href="$scripts_admin/sn_admin.cgi?fct=del_cat&amp;cat=$id"
    onClick="popup('$scripts_admin/sn_admin.cgi?fct=del_cat&amp;cat=$id',600,300);return false;">Delete
    Category</a> | <a href="$scripts_admin/sn_admin.cgi?fct=re_order_forums&amp;cid=$id"
    onClick="popup('$scripts_admin/sn_admin.cgi?fct=re_order_forums&amp;cid=$id',600,800);return false;">Re-Order
    Forum Positions in This Category</a></b></font></td>
  </tr>

</table>
<br>
END_OF_TBL

			
		}
close (BTABLE);



$addfvbutton = sn_netbadmin::get_flip_button("$scripts_admin/sn_admin.cgi?fct=add_category", "sn_addf2.gif",  "sn_addf1.gif", 600, 300);
$re_orderf = sn_netbadmin::get_flip_button("$scripts_admin/sn_admin.cgi?fct=re-ordercategories", "sn_repord2.gif",  "sn_repord1.gif", 600, 800);
$viewformus = sn_netbadmin::get_flip_button("$scripts_url/sn_forum.cgi", "sn_viewf2.gif",  "sn_viewf1.gif", "blank");

$addfvbutton2 = sn_netbadmin::get_flip_button("$scripts_admin/sn_admin.cgi?fct=add_category", "sn_addf2.gif",  "sn_addf1.gif", 600, 300);
$re_orderf2 = sn_netbadmin::get_flip_button("$scripts_admin/sn_admin.cgi?fct=re-ordercategories", "sn_repord2.gif",  "sn_repord1.gif", 600, 800);
$viewformus2 = sn_netbadmin::get_flip_button("$scripts_url/sn_forum.cgi", "sn_viewf2.gif",  "sn_viewf1.gif", "blank");


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_foruman2.gif", "Forum Manager", qq[The forum manager enables you to add new forums and to manage any aspect of your forums.]); 


$disphtml = $disphtml . <<END_OF_MANAGER;

<SCRIPT LANGUAGE="JavaScript">
function areyousure(sindex)
{
	if (sindex == 'Delete')
	{
	  var status = confirm ("Are you sure? This will delete the forum and all it's contents.");
	  if (status == true) {return true;} 
	  if (status == false){return false;}
	}
	else
	{
	  return true; 
	}
}
</SCRIPT>

$hbox

$addfvbutton $re_orderf $viewformus

<p><font face="Verdana" color="#333333" size="2"><b>$categories</b></font>

$addfvbutton2 $re_orderf2 $viewformus2

</p>

END_OF_MANAGER


if ($categories eq "")
	{
$disphtml = $disphtml . <<END_OF_FC;
<blockquote>
  <p><font face="Verdana" color="#333333" size="2">Click on <strong>'Add New Forum Category'</strong>
  to add a forum category. There are presently no forum categories. You will need a <strong>forum
  category or categories</strong> in order to create forums. A good idea might be to start
  out with <strong>an announcement category</strong>. This announcement category can for
  example contain all your announcement forums. You can also add this later because the
  order in which forums and categories are displayed in is configurable. Once you have <strong>added
  a category you will be able to create new forums in that category.</strong></font></p>
</blockquote>
END_OF_FC
	}


$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;

}







sub start
{


my ($disphtml, $ctemplate, $setupwarn);

if ((-e "setup.cgi") > 0)
	{
	$security = sn_netbadmin::get_heading_box("$web_url/sn_problem.gif", "Setup Warning", qq[
	<font face="Verdana" size="2"><font color="#FF0000"><strong>Security
	    Problem:</strong></font> setup.cgi is present where the admin control panel CGI script
	    files are stored. Please delete this file now to secure your forums. Leaving it in your
    cgi-bin directory where the admin cgi script files are located creates a security whole.</font>
	]); 
	}




#if ($idtmpl ne "")
#	{
#$templd = <<END_OFD;
#  <tr>
#    <td width="5%" valign="top"><p align="center"><img src="$web_url/sn_regsh.gif"></td>
#    <td width="95%"><font face="Arial" size="4" color="#0000A0"><strong>Register</strong></font><blockquote>
#      <p><img src="$web_url/sn_arrow.gif"> <a
#      href="http://www.focalmedia.net/cgi-bin/snbbs/snbbs.cgi?url=register" target="_blank"><strong><font
#      face="Verdana" size="2">Register SiteNet BBS</font><font face="Verdana" color="#000000"
#      size="2"><br>
#      </font></strong></a><font face="Verdana" size="1">License &amp; upgrade your copy to the
#      commercial version of SiteNet BBS.</font></p>
#    </blockquote>
#    </td>
#  </tr>
#END_OFD
#	}

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_foruman2.gif", "Forum Admin Control Panel", qq[Welcome! Below are a summary of the main options available in the control panel.]); 
&chksetupid;

$management = sn_netbadmin::get_heading_box("$web_url/sn_manage.gif", "Management", 
qq[
<blockquote>
  <p><img src="$web_url/sn_arrow.gif"> <font face="Verdana" size="2"><strong><a
  href="$scripts_admin/sn_admin.cgi?fct=boardmanager">Forum Manager</a><br>
  </strong></font><font face="Verdana" size="1">The forum manager enables you to: </font><ul>
    <li><font face="Verdana" size="1">create/edit/delete forum categories</font></li>
    <li><font face="Verdana" size="1">create/edit/delete forums</font></li>
    <li><font face="Verdana" size="1">delete/move/copy/moderate topics or messages posted on
      your forums</font></li>
    <li><font face="Verdana" size="1">re-order your forum positions</font></li>
  </ul>
  <p><img src="$web_url/sn_arrow.gif"> <font face="Verdana" size="2"><strong><a
  href="$scripts_admin/sn_admin.cgi?fct=usermanager">User Manager</a><br>
  </strong></font><font face="Verdana" size="1">The user manager enables you to:</font><ul>
    <li><font face="Verdana" size="1">edit/delete registered users.</font></li>
    <li><font face="Verdana" size="1">find users so that you can edit their details</font></li>
    <li><font face="Verdana" size="1">grant moderator/administrator status to users</font></li>
    <li><font face="Verdana" size="1">edit user titles according to the number of posts they
      have made</font></li>
    <li><font face="Verdana" size="1">get user email addresses for mailing list purposes</font></li>
  </ul>
  <p><img src="$web_url/sn_arrow.gif"> <font face="Verdana" size="2"><strong><a
  href="$scripts_url/sn_forum.cgi" target="_blank">View Forums</a><br>
  </strong></font></p>
</blockquote>
]
); 



$customization = sn_netbadmin::get_heading_box("$web_url/sn_custf.gif", "Customization", 
qq[
<blockquote>
  <p><img src="$web_url/sn_arrow.gif"> <font face="Verdana" size="2"><strong><a
  href="$scripts_admin/sn_admin4.cgi">Settings</a><br>
  </strong></font><font face="Verdana" size="1">Enables you to change forum colors and some
  aspects of how your forums operates.</font></p>
  <p><img src="$web_url/sn_arrow.gif"> <font face="Verdana" size="2"><strong><a
  href="$scripts_admin/sn_admin5.cgi?fct=templates">Template Manager</a><br>
  </strong></font><font face="Verdana" size="1">The template manager enables you to provide
  your forums with the look and feel of your site.<br>
  &nbsp; </font></p>
</blockquote>
]
); 


$help = sn_netbadmin::get_heading_box("$web_url/sn_help.gif", "Help", 
qq[
<blockquote>
  <p><img src="$web_url/sn_arrow.gif"> <a
  href="http://www.focalmedia.net/cgi-bin/snbbs/snbbs.cgi?url=manual" target="_blank"><strong><font
  face="Verdana" size="2">Online Documentation</font><font face="Verdana" color="#000000"
  size="2"><br>
  </font></strong></a><font face="Verdana" color="#000000" size="1">Full online
  documentation</font></p>
  <strong><font face="Verdana" color="#000000" size="2"><p></font></strong><img
  src="$web_url/sn_arrow.gif"> <strong><a href="http://www.focalmedia.net" target="_blank"><font
  face="Verdana" size="2" color="#0000FF">SiteNet BBS Home Page</font></a></strong><font
  face="Verdana" color="#000000" size="2"><br>
  </font><font face="Verdana" color="#000000" size="1">Go to the home page of SiteNet BBS</font></p>
</blockquote>
]
); 



$disphtml = <<END_OF_START;
$hbox
$security
$management
$customization
$help
END_OF_START


$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;

}



#################################################################################

sub increment_id
{

#### GET ID COUNTER, INCREMENT AND WRITE CHANGES

my ($currentid);

open (IDC, "$data_dir/sn_id.dat");
	$currentid = <IDC>;
close (IDC);

$currentid++;

open (IDC, "> $data_dir/sn_id.dat");
 if ($flocking ne "No"){flock (IDC,2);}
	print IDC $currentid;
 if ($flocking ne "No"){flock (IDC,8);}
close (IDC);

return ($currentid);

}



sub get_cat_name
{

### GET CATEGORY NAME VIA ID FROM CATEGORY TABLE

my ($ccid) = @_;
my ($cid, $ccatname, $cline, $rcat);

open (DCT, "$data_dir/sn_boardtable.dat");
	while (defined($cline=<DCT>))
		{
		($cid, $ccatname) = split(/\t/,$cline,2);
		if ($cid == $ccid){$rcat = $ccatname;}
		}
close (DCT);

return ($rcat);

}




sub get_forum_settings
{

### GET FORUM SETTINGS

my ($fr_cat_id, $fr_ow_id) = @_;
my ($frsize, $rdata, @rvdata);

$frsize = (-s "$data_dir/$fr_cat_id/$fr_ow_id/config.dat");
open (SMFDATA, "$data_dir/$fr_cat_id/$fr_ow_id/config.dat");
	read(SMFDATA,$rdata,$frsize);
close (SMFDATA);

(@rvdata) = split(/\n/,$rdata);

return (@rvdata);

}












sub get_umanage_top
{

my ($usern1) = @_;
my ($rvv);

$usern1 = $usern1 - 3;


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_userman2.gif", "User Manager", qq[
The User Manager enables you to manage all registered users of your forums.
]);


$membert = sn_netbadmin::get_heading_box("$web_url/sn_ic_title.gif", 
qq[<a href="$scripts_admin/sn_admin.cgi?fct=title_setup"
   onClick="popup('$scripts_admin/sn_admin.cgi?fct=title_setup',screen.width -200,screen.height -200);return false;">Member
   Title Configurations</a>], 
qq[Enables you to configure the titles of members according to the number of posts they have made.]);


$uemail = sn_netbadmin::get_heading_box("$web_url/sn_ic_email1.gif", 
qq[<a href="$scripts_admin/sn_admin.cgi?fct=mailinglist"
   onClick="popup('$scripts_admin/sn_admin.cgi?fct=mailinglist',screen.width -200,screen.height -200);return false;">
    Get User Email Addresses</a>], 
qq[Enables you to obtain email addresses to send email to registered users.]);

$uip = sn_netbadmin::get_heading_box("$web_url/sn_ic_lock.gif", 
qq[<a href="$scripts_admin/sn_admin.cgi?fct=banipscr"
   onClick="popup('$scripts_admin/sn_admin.cgi?fct=banipscr',screen.width -200,screen.height -200);return false;">
    Ban Users</a>], 
qq[Ban Users Via IP Address.]);

$aduser = sn_netbadmin::get_heading_box("$web_url/sn_ic_mod.gif", 
qq[<a href="$scripts_admin/sn_admin.cgi?fct=add_user"
   onClick="popup('$scripts_admin/sn_admin.cgi?fct=add_user',screen.width -200,screen.height -200);return false;">
   Add a Moderator, Administrator or User</a>], 
qq[Enables you to add Moderator, Administrator or User accounts.]);


$fduser = sn_netbadmin::get_heading_box("$web_url/sn_ic_search2.gif", 
qq[Find or Delete a User Account], 
qq[
<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="user_options"><table border="0" cellspacing="0"
  width="100%" cellpadding="0">
    <tr>
      <td width="50%"><font face="Verdana" size="2"><strong>Find User:</strong></font><font
      face="Verdana" size="1"> </font><input type="text" name="username" size="20"
      style="font-family: MS Sans Serif; font-size: 8" value="Username"
      onfocus="username.value='';"> <input type="submit" value="     Find     " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"
      onClick="popup('$scripts_admin/sn_admin.cgi?fct=getuserinfo&amp;user=' + username.value,screen.width -200,screen.height -200);return false;"></td>
      <td width="50%"><font face="Verdana" size="2"><strong>Delete User:</strong></font><font
      face="Verdana" size="1"> </font><input type="text" name="username2" size="20"
      style="font-family: MS Sans Serif; font-size: 8" value="Username"
      onfocus="username2.value='';"> <input type="submit" value="Delete" name="B2"
      style="font-family: MS Sans Serif; font-size: 8"
      onClick="popup('$scripts_admin/sn_admin.cgi?fct=deleteuser&amp;user=' + username2.value,750,300);return false;"></td>
    </tr>
  </table>
</form>
]);





#sn_ic_email4.gif

$rvv = <<END_OF_RVV;

$hbox
$membert
$uemail
$uip
$aduser
$fduser

END_OF_RVV

return ($rvv);

}



sub write_var
{

my ($identifier, $write_crit) = @_;

my ($line, $tocheck, $towrite, $idmatch);

$towrite = "";


$wtest = (-w "$config_cgi");
if ($wtest < 1)
{

print "Content-type: text/html\n\n";

$disphtml = qq[<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E2E2E2">
  <tr>
    <td width="100%" background="$web_url/sn_bar6.gif" height="30"><font color="#000000"
    face="Verdana" size="2"><strong>Problem</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF"><font face="Verdana" size="2">config.cgi is not
    writable. Please change it's permission setting to 777</font><p><font face="Verdana"
    size="2">After doing the above, <a href onClick="history.go(-1); return false;">click here
    </a>to go back and try again.</font></td>
  </tr>
</table>
];

$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;


exit;

}


open (STP, "$config_cgi");

	while (defined($line=<STP>))
		{

		if ($line =~ m/#/g)
			{
			$r = pos($line);
			$tocheck = substr($line, 0, $r - 1);
			}
			else
			{
			$tocheck = $line;
			}
			
		if ($tocheck =~ /$identifier/)
			{
			$line = "$identifier \"$write_crit\"\n";
			$idmatch = "true";
			}

		$towrite = $towrite . $line;

		}

	##print "$identifier : $idmatch <br>";
	
	if ($idmatch ne "true")
		{
		$towrite = $towrite . "\n\n$identifier \"$write_crit\"\n";
		}

close (STP);


open (STP, "> $config_cgi");
	print STP $towrite;
close (STP);

}




sub add_user
{


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_userman2.gif", "User Manager > Add a New Moderator, Administrator or User", qq[
Note that Moderators and Administrators have special privileges to manage forums. SiteNet BBS also includes a special Moderator Admin Control Panel where moderators can delete and moderate messages. Moderators can also set settings of the forums they are moderators for.
]);



print <<END_OF_UC;

<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>

<body>


$hbox
  
<form method="POST" action="$scripts_admin/sn_admin.cgi">
  <input type="hidden" name="fct" value="create_user"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" bgcolor="#E0E0E0">
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Forum User Name:</font></td>
      <td width="64%" bgcolor="#FFFFFF" height="27"><input type="text" name="fusername"
      size="34" style="font-family: MS Sans Serif; font-size: 8pt"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Email Address:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="email_address" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Member Status:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><select name="mstatus" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option value="Administrator">Administrator</option>
        <option value="Moderator">Moderator</option>
        <option selected value="Member">Member</option>
      </select></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Password:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="password" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Email Address Visible in Posts?</font></td>
      <td width="64%" bgcolor="#FFFFFF"><select name="email_visible" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option selected value="Y">Yes</option>
        <option value="N">No</option>
      </select></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1"> Receive Email Notification:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><select name="mod_not" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option selected value="Y">Yes</option>
        <option value="N">No</option>
      </select><br>
      <font face="Verdana" size="1">Setting this to 'Yes' will have the effect of this user
      recieving email notification of each new message posted in forums where this user is a
      moderator. This option is only valid for moderators and administrators.</font></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Home Page Name:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="home_page" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      face="Verdana" size="1"> Home Page Description:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><textarea rows="6" name="homepage_diz" cols="32"
      style="font-family: MS Sans Serif; font-size: 8pt"></textarea></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font face="Verdana"
      size="1"> Home Page URL:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="home_page_url" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt"></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Location:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="location" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Interests:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><textarea rows="6" name="interests" cols="32"
      style="font-family: MS Sans Serif; font-size: 8pt"></textarea></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF"><img src="$web_url/sn_first.gif"><font color="#000000"
      face="Verdana" size="1"> Occupation:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="text" name="occupation" size="34"
      style="font-family: MS Sans Serif; font-size: 8pt" value></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"><img src="$web_url/sn_first.gif"><font
      color="#000000" face="Verdana" size="1"> Signature:</font></td>
      <td width="64%" bgcolor="#FFFFFF"><textarea rows="6" name="signature" cols="32"
      style="font-family: MS Sans Serif; font-size: 8pt"></textarea></td>
    </tr>
    <tr>
      <td width="36%" bgcolor="#FFFFFF" valign="top"></td>
      <td width="64%" bgcolor="#FFFFFF"><input type="submit" value="   Add   " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
  </table>
</form>

</body>
</html>


END_OF_UC

}







sub create_user
{

if ($q->param('fusername') eq "") { 	$error_text = "You have to specify a user name"; }

if ($q->param('email_address') eq "") { 	$error_text = "You have to specify an email address"; }

if ($q->param('password') eq "") { 	$error_text = "You have to specify a password"; }




### CHECK INPUT
for ($ms = 0; $ms < length($q->param('fusername')); $ms++) 
	{
	$oneletter = substr($q->param('fusername'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne " "))
		{
		$error_text = "The user name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.";
		}
	}


### CHECK IF DUPLICATE USER NAME
if ($error_text eq "")
	{
	$ausers = sn_netbadmin::get_file_contents("$data_dir/users/users.dat");
	
	@all_users = split (/\n/,$ausers);
		foreach $user_item (@all_users)
			{
			if (lc($q->param('fusername')) eq lc($user_item))
				{
				$error_text = "The user name you specified already exists. Please choose another.";
				}
			}
	}


if ($error_text ne "") 
	{
	sn_netbadmin::errorbox($error_text);
	}
	else
	{
	&create_user2;
	}

}






sub create_user2
{

$member_name = $q->param('fusername');

$userfilename = $q->param('fusername');
$userfilename =~ s/ /_/g;

$homepage_diz = $q->param('homepage_diz');
$homepage_diz =~ s/\n/<br>/g;

$interests = $q->param('interests');
$interests =~ s/\n/<br>/g;

$signature = $q->param('signature');
$signature =~ s/\n/<br>/g;


########################

if ($q->param('mstatus') eq "Administrator")
	{
	$mstatus = "Ad";
	}
	elsif ($q->param('mstatus') eq "Moderator")
	{
	$mstatus = "Mo";
	}
	elsif ($q->param('mstatus') eq "Member")
	{
	$mstatus = "Me";
	}

$current_time = time();

if (($mstatus ne "Me") and ($q->param('mod_not') eq "Y"))
	{
	$modemail = "15MODERATOR_MESSAGE_NOTIFICATION=Y";
	}
	else
	{
	$modemail = "15MODERATOR_MESSAGE_NOTIFICATION=N";
	}

$u_password = $q->param('password');

########################

open (USERDATA, "> $data_dir/users/$userfilename.dat");
 if ($flocking ne "No"){flock (USERDATA,2);}
	print USERDATA "$member_name" . "\n" .						#### 0 USERNAME
						$q->param('password') . "\n" .			#### 1 PASSWORD
						$q->param('email_address') . "\n" .		#### 2 EMAIL ADDRESS
						$q->param('email_visible') . "\n" .	   #### 3 EMAIL VISIBLE
						$q->param('home_page') . "\n" .			#### 4 HOMEPAGE NAME
						$homepage_diz . "\n" .						#### 5 HOME PAGE DESCRIPTION
						$q->param('home_page_url') . "\n" .		#### 6 HOME PAGE URL
						$q->param('icq_number') . "\n" .			#### 7 ICQ NUMBER
						$q->param('location') . "\n" .			#### 8 LOCATION
						$interests . "\n" .							#### 9 INTERESTS
						$q->param('occupation') . "\n" .			#### 10 OCUPATION
						$signature . "\n" . 							#### 11 SIGNATURE
						$mstatus . "\n" . 							#### 12 MEMBER STATUS
						$current_time . "\n" . 						#### 13 DATE JOINED
						"0" . "\n" . 									#### 14 TOTAL POSTS
						"" . "\n" .										#### 15 USER IMAGE
						$modemail . "\n";								#### 16 NOTIFICATION
																			
 if ($flocking ne "No"){flock (USERDATA,8);}
close (USERDATA);

########################

open (MAINUSERFILE, ">> $data_dir/users/users.dat");
 if ($flocking ne "No"){flock (MAINUSERFILE,2);}
	print MAINUSERFILE "$member_name" . "\n";
 if ($flocking ne "No"){flock (MAINUSERFILE,8);}
close (MAINUSERFILE);

########################

$u_password =~ s/ /+/g;
$member_name =~ s/ /+/g;



$hbox = sn_netbadmin::get_heading_box("$web_url/sn_userman2.gif", "User Manager > User Account Successfully Created", qq[
<a href="$scripts_url/sn_profile.cgi?fct=edit_profile&amp;username=$member_name&amp;password=$u_password"
    target="_blank">Click here to upload or assign a user image for this user.</a></font>
    
<form method="POST" action>
  <p><input type="submit" value="Close This Window" name="B1"
  onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8pt"></p>
</form>
    
]);



print <<END_OF_USERI;

<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>


END_OF_USERI

}




### &get_forum_settings (CATEGORY ID, BOARD ID);
### CATNAME = &get_cat_name (CATEGORY ID);
### NEWID = &increment_id;
### UMANAGER = &get_umanage_top($usernumber);




