#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

use FindBin;
use lib $FindBin::Bin;
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;
use sn_tmpl;

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));


if ($q->param('fct') eq "dologin") {&dologin; exit;}



$preview_only = "$scripts_admin/sn_admin12.cgi?fct=lprev";

print $q->header();

if ($q->param('fct') eq "preview") {&start; exit;}
if ($q->param('fct') eq "") {&lprev; exit;}
if ($q->param('fct') eq "lprev") {&lprev; exit;}
if ($q->param('fct') eq "if_prev") {&if_prev; exit;}


###############################################################################


sub if_prev
{

$template = $q->param('template');

$tpreview = sn_netbadmin::get_file_contents("$data_dir/$template.html");
$tpreview =~ s/!web_url!/$web_url/gi;

print $tpreview;

}



sub dologin
{

$cookval = $q->param('u') . ":" . $q->param('p');
&setCookie("USER",$cookval); 

print $q->header();

$fid = $q->param('fid');
$cid = $q->param('cid');

if ($q->param('fac') eq "dologin")
	{
	$goto_url = "$scripts_url/sn_moderate.cgi";
	}
elsif ($q->param('fac') eq "del_topics")
	{
	$goto_url = "$scripts_url/sn_moderate.cgi?fct=del_topics&fid=$fid&cid=$cid";
	}
elsif ($q->param('fac') eq "fsettings")
	{
	$goto_url = "$scripts_url/sn_moderate.cgi?fct=fsettings&fid=$fid&cid=$cid";
	}



print qq[
<html>
<head>
<title>SiteNet BBS</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$goto_url">
</head>
<body> 
</body>
</html>
];
exit;



}



sub setCookie
{
	my($name, $value, $expiration, $path, $domain, $secure) = @_;

$filesize = (-s "$data_dir/sn_settings.dat");
open (TFILECNTS, "$data_dir/sn_settings.dat");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
@gbs = split(/\n/,$thefile);

if ($gbs[18] ne "N")
{
 $query = new CGI;
 $tcookie = $query->cookie(-name=>$name,
		     -value=>$value,
	        -expires=>'+12M');
 print "Set-Cookie: $tcookie\n";
}


}
 



sub lprev
{

print qq[
<html>
<head>
<title>Preview</title>
</head>
<body>
<p>&nbsp;</p>
<p align="center"><strong><font face="Verdana" size="4">Preview Only</font><br>
</strong><font face="Verdana" size="2">This template is only displayed for previewing
purposes and some links won't work in the previews.</font></p>
</body>
</html>
];

exit;

}


sub start
{

if (($q->param('template') eq "sn_globalframe") or ($q->param('template') eq "sn_globlocation") or ($q->param('template') eq "sn_globalmodstyle") or ($q->param('template') eq "sn_fp_moderators") 
   or ($q->param('template') eq "sn_last_visitors") or ($q->param('template') eq "sn_fp_frame") 
    or ($q->param('template') eq "sn_fp_toptable")  or ($q->param('template') eq "sn_fp_celcat")  or ($q->param('template') eq "sn_fp_forumcel"))
	{
	&redirect("$scripts_url/sn_forum.cgi");
	}
elsif (($q->param('template') eq "sn_globalnewdd") or ($q->param('template') eq "sn_globaljump") or
		($q->param('template') eq "sn_topic_globalframe") or 
		($q->param('template') eq "sn_topic_list_table_top") or
		($q->param('template') eq "sn_topic_list_table_cells") or
		($q->param('template') eq "sn_topic_list_poll_cells"))
	{
	$redirurl = &display_topics_thread;
	&redirect($redirurl);
	}
elsif ($q->param('template') eq "sn_topic_list_no_topics") 
	{
	$sn_topic_list_no_topics = sn_netbadmin::get_file_contents("$data_dir/sn_topic_list_no_topics.html");
	
	$sn_topic_list_no_topics = qq[<table border="0" width="100%">] . $sn_topic_list_no_topics . "</table>" . qq[
	<hr noshade size="1" color="#DFDFDF">
	<p>
	<font face="Verdana" size="2"><font color="#FF0000"><strong>Preview Note:</strong></font>
	This template is not previewed as 'combined' with other templates. This template will be
	displayed as a topic cell if there are no topics available inside a Forum.</font></p>
	];
	
	print $sn_topic_list_no_topics;
	
	}
elsif ($q->param('template') eq "sn_passwd") 
	{
	$redirurl = &display_topics_thread;
	&redirect($redirurl . "&preview=sn_passwd");
	}
elsif (($q->param('template') eq "sn_topmsg_frame") or ($q->param('template') eq "sn_first_msg") or ($q->param('template') eq "sn_reply_msg"))
	{
	($redirurl, $tfid, $tcid, $ttid) = &display_topic;
	&redirect($redirurl);
	}
elsif ($q->param('template') eq "sn_quote")
	{
	$bdata = sn_netbadmin::get_file_contents("$data_dir/sn_quote.html");
	
	$bdata =~ s/!!quote!!/A quote will look like this inside a message./gi;
	
	print qq[$bdata<BR><BR><hr noshade size="1" color="#DFDFDF">
		<p><font face="Verdana" size="2"><font color="#FF0000"><strong>Preview Note:</strong></font>
		This template is not previewed as 'combined' with other templates. This template just
		demonstrates how a quote will look like inside a message.</font></p>];
	
	exit;
	}
elsif (($q->param('template') eq "sn_poll") or ($q->param('template') eq "sn_vote_frame_table") or  
       ($q->param('template') eq "sn_vote_table_cells") or ($q->param('template') eq "sn_results_frame_table") or 
       ($q->param('template') eq "sn_results_table_cells"))
	{
	
		if (($q->param('template') eq "sn_results_frame_table") or ($q->param('template') eq "sn_results_table_cells"))
			{
			$vote_prv = "voted";
			}
			else
			{
			$vote_prv = "notvoted";
			}
		
	

	$bdata = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
		
	if ($bdata eq "") { &preview_error("There are no Forums available yet."); }
	
		@fcats = split (/\n/, $bdata);
	
		foreach $item (@fcats)
			{
			($cid, $cname) = split (/\t/, $item);
			
			$tdata = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
			
			my @tditems = split (/\n/, $tdata);
			
				foreach $titem (@tditems)
					{
					($fid, $fname) = split (/\t/, $titem);
					
						$fpoll = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/topics.dat");
						
						my @ftopics = split (/\n/, $fpoll);
						
						foreach $fitem (@ftopics)
							{
							 my @infitems = split (/\t/, $fitem);
							 
							 if ($infitems[4] eq "POLLQ123") 
							 	{
									&redirect("$scripts_url/sn_forumpr.cgi?fid=$fid&cid=$cid&tid=$infitems[0]&pg=1&sc=20&preview=$vote_prv");
									exit;
							 	}
							 
							}
					
					}
			
			}
		

	&preview_error("Could not find any polls inside any Forums."); 
	}
elsif ($q->param('template') eq "sn_post_topic")
	{
	($usr, $ps) = &get_user;
	
	($redir, $r_fid, $r_cid, $r_tid) = &display_topic;
	&redirect("$scripts_url/sn_login.cgi?fid=$r_fid&cid=$r_cid&fct=login&l=postnew&username=$usr&password=$ps");
	}
elsif ($q->param('template') eq "sn_post_reply")
	{
	($usr, $ps) = &get_user;
	($redir, $r_fid, $r_cid, $r_tid) = &display_topic;
	&redirect("$scripts_url/sn_login.cgi?fid=$r_fid&cid=$r_cid&tid=$r_tid&fct=login&l=reply&username=$usr&password=$ps");
	}
elsif ($q->param('template') eq "sn_post_reply_prev")
	{
	($redir, $r_fid, $r_cid, $r_tid) = &display_topic;
	&redirect("$scripts_url/sn_forump.cgi?cid=$r_cid&fct=postmessage&fid=$r_fid&messagetopic=Preview+Topic&message=This+is+a+test+message&preview=Y&icong=NONE");
	}
elsif ($q->param('template') eq "sn_post_success")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_post_success.html");
	
	$template =~ s/!!topic_link!!/$preview_only/gi;
	$template =~ s/!!posted_forum_name!!/Forum Name/gi;
	$template =~ s/!!forum_link!!/$preview_only/gi;
	$template =~ s/!!posted_forum_link!!/$preview_only/gi;
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_post_success_mod")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_post_success_mod.html");
	
	$template =~ s/!!topic_link!!/$preview_only/gi;
	$template =~ s/!!posted_forum_name!!/Forum Name/gi;
	$template =~ s/!!forum_link!!/$preview_only/gi;
	$template =~ s/!!posted_forum_link!!/$preview_only/gi;
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_post_poll")
	{
	($usr, $ps) = &get_user;
	($redir, $r_fid, $r_cid, $r_tid) = &display_topic;
	&redirect("$scripts_url/sn_login.cgi?fid=$r_fid&cid=$r_cid&tid=$r_tid&fct=login&l=postpoll&username=$usr&password=$ps");
	}
elsif ($q->param('template') eq "sn_post_poll_success")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_post_poll_success.html");
	
	$template =~ s/!!goto_poll!!/$preview_only/gi;
	$template =~ s/!!posted_forum_link!!/$preview_only/gi;
	$template =~ s/!!forum_link!!/$preview_only/gi;
	$template =~ s/!!posted_forum_name!!/Forum Name/gi;
	$template =~ s/!!forum_link!!/$preview_only/gi;
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_post_poll_success_mod")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_post_poll_success_mod.html");
	
	$template =~ s/!!goto_poll!!/$preview_only/gi;
	$template =~ s/!!posted_forum_link!!/$preview_only/gi;
	$template =~ s/!!forum_link!!/$preview_only/gi;
	$template =~ s/!!posted_forum_name!!/Forum Name/gi;
	$template =~ s/!!forum_link!!/$preview_only/gi;
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_not_logged_in")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_not_logged_in.html");
	$template =~ s/!!login_script!!/$preview_only/gi;
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_edit_msg")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_edit_msg.html");
	
	$template = sn_netbadmin::display_errors($template, "del_topic", ""); 
	$template = sn_netbadmin::display_errors($template, "del_msg", ""); 
	$template = sn_netbadmin::display_errors($template, "stick", ""); 
	$template = sn_netbadmin::display_errors($template, "unstick", ""); 
	$template = sn_netbadmin::display_errors($template, "lock_topic", ""); 
	$template = sn_netbadmin::display_errors($template, "unlock_topic", ""); 
	$template = sn_netbadmin::display_errors($template, "mod_adm_ipdisplay", ""); 

	$template =~ s/!!ip!!/123\.123\.123\.123/g;
	$template =~ s/!!message!!/Some Message.../g;
	
	$template =~ s/!!edit_script!!/$preview_only/g;
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_edit_saved")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_edit_saved.html");
	$template =~ s/!!view_message_link!!/$preview_only/gi;
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_edit_unable")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_edit_unable.html");
	print &get_global($template);
	} 	
elsif ($q->param('template') eq "sn_msgtags")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_msgtags.html");
	print &get_global($template);
	} 	
elsif ($q->param('template') eq "sn_terms")
	{
	&redirect("$scripts_url/sn_register.cgi");
	} 	 	
elsif ($q->param('template') eq "sn_regform")
	{
	&redirect("$scripts_url/sn_register.cgi?fct=register_user_scr");
	} 	 	
elsif ($q->param('template') eq "sn_edit_profile")
	{
	($usr, $ps) = &get_user;
	&redirect("$scripts_url/sn_login.cgi?fct=login&l=profile&username=$usr&password=$ps");
	}
elsif ($q->param('template') eq "sn_profile_saved")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_profile_saved.html");
	$template =~ s/!!forum_link!!/$preview_only/gi;	
	$template =~ s/!!edit_profile_link!!/$preview_only/gi;	
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_reg_success")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_reg_success.html");
	$template =~ s/!!forum_link!!/$preview_only/gi;	
	$template =~ s/!!edit_profile_link!!/$preview_only/gi;	
	print &get_global($template);
	}
elsif ($q->param('template') eq "sn_view_profile")
	{
	($usr, $ps) = &get_user;
	&redirect("$scripts_url/sn_proview.cgi?user=$usr");
	}
elsif ($q->param('template') eq "sn_view_profile_login")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_view_profile_login.html");
	$template =~ s/!!login_script!!/$preview_only/gi;	
	print &get_global($template);
	} 	
elsif ($q->param('template') eq "sn_login_screen")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_login_screen.html");
	$template = sn_netbadmin::display_errors($template, "error1", "");
	$template =~ s/!!login_script!!/$preview_only/gi;	
	$template =~ s/!!retrieve_password_link!!/$preview_only/gi;	
	print &get_global($template);
	} 	
elsif ($q->param('template') eq "sn_login_success")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_login_success.html");
	$template =~ s/!!forum_link!!/$preview_only/gi;	
	print &get_global($template);
	} 	
elsif ($q->param('template') eq "sn_logout_screen")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_logout_screen.html");
	$template =~ s/!!forum_link!!/$preview_only/gi;	
	print &get_global($template);
	} 	
elsif ($q->param('template') eq "sn_retrieveps")
	{
	&redirect("$scripts_url/sn_lostps.cgi");
	}
elsif ($q->param('template') eq "sn_passwd_sent")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_passwd_sent.html");
	$template =~ s/!!forum_link!!/$preview_only/gi;	
	print &get_global($template);
	} 
elsif (($q->param('template') eq "sn_search_page") or ($q->param('template') eq "sn_search_dropdown"))
	{
	&redirect("$scripts_url/sn_search.cgi");
	}
elsif (($q->param('template') eq "sn_search_results_page") or ($q->param('template') eq "sn_search_results"))
	{
	($redirurl, $tfid, $tcid, $ttid) = &display_topic;
	
	$topic_details = sn_netbadmin::get_file_contents("$data_dir/$tcid/$tfid/$ttid.dat");
	
	@sitems = split (/\t/, $topic_details);
	
	$keywords = $sitems[0]; $keywords =~ s/ /+/g;
	
	$d1v = $tcid . "_" . $tfid;
	
	&redirect("$scripts_url/sn_search.cgi?search_crit=$keywords&smethod=or&D1=$d1v&fct=search");
	}
elsif ($q->param('template') eq "sn_search_nomatch")
	{
	($redirurl, $tfid, $tcid, $ttid) = &display_topic;
	
	$topic_details = sn_netbadmin::get_file_contents("$data_dir/$tcid/$tfid/$ttid.dat");
	
	@sitems = split (/\t/, $topic_details);
	
	$keywords = $sitems[0]; $keywords =~ s/ /+/g;
	
	$d1v = $tcid . "_" . $tfid;
	
	&redirect("$scripts_url/sn_search.cgi?search_crit=sdfsdfweriyeriuyertiuyert&smethod=or&D1=$d1v&fct=search");
	}
elsif ($q->param('template') eq "sn_mod_login")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_login.html");
	$template =~ s/!!forum_link!!/$preview_only/gi;	
	
	$template = sn_netbadmin::display_errors($template, "error1", "NODISPLAY");
	$template = sn_netbadmin::display_errors($template, "error2", "NODISPLAY");
	
	$template =~ s/!!retrieve_password_link!!/$preview_only/gi;
	$template =~ s/!!login_script!!/$preview_only/gi;
	
	print &get_global($template);
	}
elsif (($q->param('template') eq "sn_mod_global") or ($q->param('template') eq "sn_mod_table_main") or ($q->param('template') eq "sn_mod_cells_cat") or 
		($q->param('template') eq "sn_mod_cells_forum"))
	{
		
	($fuser, $fpass, $fcid, $ffid) = &get_forum_moderator;
	
		if ($current_mod eq "") { &preview_error("Could not find a moderator. Make sure that accounts exist for moderator names that has been assigned to Forums. A moderator account can be created by going to the Control Panel >> User Manager >> Add a Moderator, Administrator or User - After doing that assign the moderator account created by going to the Control Panel >> Forum Manager >> Click 'Settings' next to any Forum."); }
	
		$url = "$scripts_admin/sn_admin12.cgi?fct=dologin&u=$fuser&p=$fpass&fac=dologin";
	
	print qq[
	<html>
	<head>
	<title>SiteNet BBS</title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$url">
	</head>
	<body> 
	</body>
	</html>
	];
	exit;
	}
elsif (($q->param('template') eq "sn_mod_del_table") or ($q->param('template') eq "sn_mod_del_cells"))
	{
	($fuser, $fpass, $ffid, $fcid) = &get_forum_moderator;
	
	$url = "$scripts_admin/sn_admin12.cgi?fct=dologin&u=$fuser&p=$fpass&cid=$fcid&fid=$ffid&fac=del_topics";
	
	print qq[
	<html>
	<head>
	<title>SiteNet BBS</title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$url">
	</head>
	<body> 
	</body>
	</html>
	];
	exit;	
	
	}
elsif ($q->param('template') eq "sn_mod_del_unable") 
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_del_unable.html");
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	print &get_global($mglobal);
	}
elsif ($q->param('template') eq "sn_mod_del_error") 
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_del_error.html");
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	print &get_global($mglobal);
	}
elsif ($q->param('template') eq "sn_mod_del_success") 
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_del_success.html");
	$template =~ s/!!delete_area!!/$preview_only/gi;
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	print &get_global($mglobal);
	}
elsif ($q->param('template') eq "sn_forum_settings") 
	{
	($fuser, $fpass, $ffid, $fcid) = &get_forum_moderator;
	
	$url = "$scripts_admin/sn_admin12.cgi?fct=dologin&u=$fuser&p=$fpass&cid=$fcid&fid=$ffid&fac=fsettings";
	
	print qq[
	<html>
	<head>
	<title>SiteNet BBS</title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$url">
	</head>
	<body> 
	</body>
	</html>
	];
	exit;		
	}
 elsif ($q->param('template') eq "sn_forum_settings_saved") 
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_forum_settings_saved.html");
	$template =~ s/!!mcp_home!!/$preview_only/gi;
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	print &get_global($mglobal);
	}	
  elsif (($q->param('template') eq "sn_mod_mod_frame") or  ($q->param('template') eq "sn_mod_mod_cells"))
	{

	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_mod_frame.html");
	$template =~ s/!!moderation_script!!/$preview_only/gi;
	$template =~ s/!!current_forum_category!!/Name of all Forums/gi;
	$template =~ s/!!forum_name!!/Name of Forum/gi;
	
	### GET CELLS
	$cell_tmpl = sn_netbadmin::get_file_contents("$data_dir/sn_mod_mod_cells.html");
	$ics = qq[<img src="$web_url/sn_dir.gif">];
	$chk = qq[<input type="checkbox" name="C1" value="ON">];
	for ($ms = 0; $ms < 5; $ms++) 
		{
		$ctemp = $cell_tmpl;
		$ctemp =~ s/!!icon!!/$ics/gi;
		$ctemp =~ s/!!checkbox!!/$chk/gi;
		$ctemp =~ s/!!message_link!!/$preview_only/gi;
		$ctemp =~ s/!!message!!/Fictional Test Topic.../gi;
		$ctemp =~ s/!!poster!!/Fictional Poster/gi;
		
		$altt = $altt . $ctemp;
		} 
	
	$template =~ s/!!message_cells!!/$altt/gi;
	
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	print &get_global($mglobal);
	
	}		
 elsif ($q->param('template') eq "sn_mod_mod_success_appr")
	{
	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_mod_success_appr.html");
	$template =~ s/!!mcp_home!!/$preview_only/gi;
	$template =~ s/!!current_forum_category!!/Name of all Forums/gi;
	$template =~ s/!!forum_name!!/Name of Forum/gi;
	$template =~ s/!!appr_area!!/$preview_only/gi;
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	print &get_global($mglobal);
	}	
 elsif ($q->param('template') eq "sn_mod_mod_del")
 	{

	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_mod_del.html");
	$template =~ s/!!mcp_home!!/$preview_only/gi;
	$template =~ s/!!current_forum_category!!/Name of all Forums/gi;
	$template =~ s/!!forum_name!!/Name of Forum/gi;
	$template =~ s/!!appr_area!!/$preview_only/gi;
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	print &get_global($mglobal); 	
 	
 	}
 elsif ($q->param('template') eq "sn_mod_mod_error")
 	{

	$template = sn_netbadmin::get_file_contents("$data_dir/sn_mod_mod_error.html");
	$template =~ s/!!mcp_home!!/$preview_only/gi;
	$template =~ s/!!current_forum_category!!/Name of all Forums/gi;
	$template =~ s/!!forum_name!!/Name of Forum/gi;
	$template =~ s/!!appr_area!!/$preview_only/gi;
	
	$mglobal =  sn_netbadmin::get_file_contents("$data_dir/sn_mod_global.html");
	$mglobal =~ s/!!modadm_functions!!/$template/gi;
	$mglobal =~ s/!!mcp_home!!/$preview_only/gi;
	$mglobal =~ s/!!view_forums!!/$preview_only/gi;
	print &get_global($mglobal); 	
 	
 	}




}




sub get_forum_moderator
{


##### GET FORUM MODERATOR
		
		$bdata = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
			
		if ($bdata eq "") { &preview_error("There are no Forums available yet."); }
		
			@fcats = split (/\n/, $bdata);
		
			foreach $item (@fcats)
				{
				($cid, $cname) = split (/\t/, $item);
				
				$tdata = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
				
				my @tditems = split (/\n/, $tdata);
				
					foreach $titem (@tditems)
						{
						($fid, $fname) = split (/\t/, $titem);
						
							$fcf = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/config.dat");
							
							my @fconfig = split (/\n/, $fcf);
							
							if (($modnb eq "") and ($fconfig[3] ne "") and (-s "$data_dir/$cid/$fid/config.dat" > 100) and (-s "$data_dir/$cid/$fid/moderate.dat" < 10))
								{
								$modnb = $fconfig[3];
								$c_fid = $fconfig[0];
								$c_cid = $cid;
								}
						}
			}
			
		##### LOGIN MODERATOR
		
		if ($modnb =~ /,/)
			{
			@mod_items = split (/,/, $modnb);
			$current_mod = $mod_items[0];
			}
			else
			{
			$current_mod = $modnb;
			}
		
		if (substr($current_mod, length($current_mod) - 1, 1) eq " ") { $current_mod = substr($current_mod, 0, length($current_mod) - 1); }
		if (substr($current_mod, 0, 1) eq " ") { $current_mod = substr($current_mod, 1, length($current_mod) - 1); } 
		

	$allusers = sn_netbadmin::get_file_contents("$data_dir/users/users.dat");
	@allu = split (/\n/, $allusers);
	foreach $item (@allu)
		{
		if (lc($item) eq lc($current_mod))
			{
			$theuser = $item;
			}
		}
	
	$theuser =~ s/ /_/g;
	
	$usett = sn_netbadmin::get_file_contents("$data_dir/users/$theuser.dat");
	@usettings = split (/\n/, $usett);
 	
 	$current_mod =~ s/ /+/gi;
 	
return ($current_mod, $usettings[1], $c_fid, $c_cid);


}




sub get_global
{

my ($tmpl) = @_;

$globalframe = sn_netbadmin::get_file_contents("$data_dir/sn_globalframe.html");
 
$globalframe =~ s/!!forums!!/$tmpl/g;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 

$gfs = sn_netbadmin::get_file_contents("$data_dir/sn_settings.dat");
@gfsettings = split (/\n/, $gfs);

$globalframe =~ s/!!location!!/$gfsettings[11]/g;

$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 

$forumlogo = qq[<img src="$web_url/$gfsettings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 

$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;

return ($globalframe);

}



sub get_user
{

opendir(DIR,"$data_dir/users");
@alusers = readdir(DIR);
closedir(DIR);

if ($alusers[4] eq "")
	{
	&preview_error("Could not find a user account. Please register/create a user account to see a preview of this template."); 
	exit;
	}


$userfile = sn_netbadmin::get_file_contents("$data_dir/users/$alusers[4]");

@usrlines = split (/\n/, $userfile);

return ($usrlines[0], $usrlines[1]);
}



sub display_topic
{

$bdata = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
		
	if ($bdata eq "") { &preview_error("There are no Forums available yet."); }
	
		@fcats = split (/\n/, $bdata);
	
		($cid, $cname) = split (/\t/, $fcats[0]);
		
		$forumtable = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
		
		if ($forumtable eq "") { &preview_error("Could not find topics in the first forum. This preview will work correctly if all forums contains at least 1 topic."); }
		
		@ftitems = split (/\n/, $forumtable);
		
		($fid, $fname) = split (/\t/, $ftitems[0]);
		
		$topicstat = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
		
		@topicstat_items = split (/\n/, $topicstat);
		
		$highpost = 0;
		foreach $item (@topicstat_items)
			{
			($tid, $posts, $views) = split (/\t/, $item);
			
			if ($posts > $highpost)
				{
				$highpost = $posts;
				$ptid = $tid;
				}
			}
			
		
		if (($ptid ne "") and ($fid ne "") and ($cid ne ""))
			{
			$redir = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$ptid&pg=10&sc=20&x=0";
			}
			else
			{
			&preview_error("This error is occurring because all forums requires messages for the preview functions to work properly.");
			}
		

return ($redir, $fid, $cid, $tid);


}




sub display_topics_thread
{

$bdata = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
		
	if ($bdata eq "") { &preview_error("There are no Forums available yet."); }
	
		@fcats = split (/\n/, $bdata);
	
		($cid, $cname) = split (/\t/, $fcats[0]);
		
		$forumtable = sn_netbadmin::get_file_contents("$data_dir/$cid/forumtable.dat");
		
		@ftitems = split (/\n/, $forumtable);
		
		($fid, $fname) = split (/\t/, $ftitems[0]);
		
		if ($fid ne "")
			{
			$redir = "$scripts_url/sn_forum.cgi?fid=$fid&cid=$cid&fct=gotoforum";
			}
			else
			{
			&preview_error("No Forums has been created yet.");
			}

return ($redir);

}



sub preview_error
{

my ($problem) = @_;

print qq[<p><font face="Verdana" size="2"><strong>Unable to Preview Template:</strong><br>
$problem</font></p>];

exit;

}



sub redirect
{
my ($url) = @_;

print qq[
<html>
<head>
<title>SiteNet BBS</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$url">
</head>
<body> 
</body>
</html>
];
exit;

}
