#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use Fcntl qw(:DEFAULT :flock);
use CGI;
#use strict; 
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;
use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$version = "2.0";
$debug = "OFF";
$q = CGI->new;

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


#################################################################################



$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}



#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print $q->header();

if ($q->param('fct') eq "move_topics") {&move_topics; exit;}
if ($q->param('fct') eq "choose_cats_4move") {&choose_cats_4move; exit;}
if ($q->param('fct') eq "move_final") {&move_final; exit;}



##############################################################

sub move_final
{

my ($groupname, $mcid, $mfid, $ctopiclines, $cstatlines, @statlines, @topiclines, $line, 
    $statlcount, $towrite_topics, @titems, $new_topics, $new_stats, $towrite_stats, $seltopic, 
    $ncid, $nfid, $returned, $config_cgi_contents, $tentire, $centire, $idname, $idname2, $idcount);

$groupname = $q->param('groupname');
($ncid, $nfid) = split (/_/, $groupname);

### TOPICS TO BE MOVED

$mcid = $q->param('from_cid');
$mfid = $q->param('from_fid');

$ctopiclines = sn_netbadmin::get_file_contents("$data_dir/$mcid/$mfid/topics.dat");
@topiclines = split (/\n/, $ctopiclines);

$cstatlines = sn_netbadmin::get_file_contents("$data_dir/$mcid/$mfid/tstats.dat");
@statlines = split (/\n/, $cstatlines);

$idcount = sn_netbadmin::get_file_contents("$data_dir/sn_id.dat");
$idcount++;

$statlcount = 0;

 foreach $line (@topiclines)
 	{
 	@titems = split (/\t/, $line);
	
	$seltopic = "C_" . $titems[0];
	
	if ($q->param($seltopic) ne "Y")
		{
			$new_topics = $new_topics . "$line" . "\n";
			$new_stats = $new_stats . $statlines[$statlcount] . "\n";
	 	}
	 	else
	 	{
	 	
	 	if ($q->param('tcopy') ne "tcopy") ### MOVE
			{
	 		$returned = rename("$data_dir/$mcid/$mfid/$titems[0].dat","$data_dir/$ncid/$nfid/$idcount.dat");
	 		$returned = rename("$data_dir/$mcid/$mfid/$titems[0].cnt","$data_dir/$ncid/$nfid/$idcount.cnt");
	 		
	 		$optext = "Moved";
	 		$optext2 = "Move";
	 		
	 		}
	 		else ### COPY
	 		{
	 		$config_cgi_contents = sn_netbadmin::get_file_contents("$data_dir/$mcid/$mfid/$titems[0].dat");
			open (BTM, "> $data_dir/$ncid/$nfid/$idcount.dat");
				if ($flocking ne "No"){flock (BTM,2);}
				  print BTM $config_cgi_contents;
				if ($flocking ne "No"){flock (BTM,8);}
			close (BTM);

	 		$config_cgi_contents = sn_netbadmin::get_file_contents("$data_dir/$mcid/$mfid/$titems[0].cnt");

	 			if ($config_cgi_contents ne "")
	 			 {
					open (BTM, "> $data_dir/$ncid/$nfid/$idcount.cnt");
						if ($flocking ne "No"){flock (BTM,2);}
						  print BTM $config_cgi_contents;
						if ($flocking ne "No"){flock (BTM,8);}
					close (BTM);
				 }
			
			$optext = "Copied";
			$optext2 = "Copy";
			$tcopy = "tcopy=tcopy";
	 		}

		$idname = $titems[0] . "\t";
		$idname2 = $idcount . "\t";
		
		$line =~ s/$idname/$idname2/g;
		$statlines[$statlcount] =~ s/$idname/$idname2/g;

		######
	 		$towrite_topics = $towrite_topics . $line . "\n";
	 		$towrite_stats = $towrite_stats . $statlines[$statlcount] . "\n";
	 	#######
		
		$idcount++;
	 	}
	 	
	$statlcount++;
 	}


open (CFI, "> $data_dir/sn_id.dat");
 if ($flocking ne "No"){flock (CFI,2);}
  print CFI $idcount;
 if ($flocking ne "No"){flock (CFI,8);}  
close (CFI);


if ($q->param('tcopy') ne "tcopy")
{

	### REMAINING TOPICS

	open (BTM, "> $data_dir/$mcid/$mfid/topics.dat");
		if ($flocking ne "No"){flock (BTM,2);}
		  print BTM $new_topics;
		if ($flocking ne "No"){flock (BTM,8);}
	close (BTM);

	### REMAINING STATS

	open (BTM, "> $data_dir/$mcid/$mfid/tstats.dat");
		if ($flocking ne "No"){flock (BTM,2);}
		  print BTM $new_stats;
		if ($flocking ne "No"){flock (BTM,8);}
	close (BTM);

}



### NEW MOVED ITEMS

$tentire = sn_netbadmin::get_file_contents("$data_dir/$ncid/$nfid/topics.dat");
#$towrite_topics = $towrite_topics . $tentire;
@tentopics = split (/\n/, $tentire);

$centire = sn_netbadmin::get_file_contents("$data_dir/$ncid/$nfid/tstats.dat");
#$towrite_stats = $towrite_stats . $centire;
@tentstats = split (/\n/, $centire);

$ti_cnt = 0;
foreach $new_topic_i (@tentopics)
	{
	(@from_topic_items) = split (/\t/, $new_topic_i);
	if ($from_topic_items[10] eq "Y")
		{
		$sticky_topics_new = $sticky_topics_new . $new_topic_i . "\n";
		$sticky_stats_new = $sticky_stats_new . $tentstats[$ti_cnt] . "\n";
		}
		else
		{
		$tentire_new = $tentire_new . $new_topic_i . "\n";
		$centire_new = $centire_new . $tentstats[$ti_cnt] . "\n";
		}
	$ti_cnt++;
	}
###

$towrite_topics = $towrite_topics . $tentire_new;
$towrite_stats = $towrite_stats . $centire_new;

if ($sticky_topics_new ne "")
	{
	$towrite_topics = $sticky_topics_new . $towrite_topics;
	$towrite_stats =  $sticky_stats_new . $towrite_stats;
	}


### WRITE TOPICS

open (BTM, "> $data_dir/$ncid/$nfid/topics.dat");
	if ($flocking ne "No"){flock (BTM,2);}
	  print BTM $towrite_topics;
	if ($flocking ne "No"){flock (BTM,8);}
close (BTM);

### WRITE REMAINING STATS

open (BTM, "> $data_dir/$ncid/$nfid/tstats.dat");
	if ($flocking ne "No"){flock (BTM,2);}
	  print BTM $towrite_stats;
	if ($flocking ne "No"){flock (BTM,8);}
close (BTM);


##########################


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_add.gif", "Topics $optext", qq[
<p><a href="http://" onClick="self.close();return false">Close This Window</a> | <a
href="$scripts_admin/sn_admin2.cgi?fct=move_topics&cid=$mcid&fid=$mfid&$tcopy">$optext2 More Topics</a></p>
]);


print <<END_OF_MOVED;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>

END_OF_MOVED

}






sub choose_cats_4move
{

my ($boardtable, @board_lines, $line, $cid, $cat_name, $move_table, $forumtable, $fline, @all_forums, 
    $forum_name, $fid, $radio_value, $fcatname, $forname, $fid1, $cid1, $topic_contents, @ititems, 
    $selectedv, $hidden_topics_selected, @stopics, $checkedval, $opptype);

$cid = $q->param('cid');
$fid = $q->param('fid');

### CHECK IF SOMETHING HAS BEEN SELECTED
	
$topic_contents = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@stopics = split (/\n/, $topic_contents);

foreach $line (@stopics)
	{
	@ititems = split (/\t/, $line);
	$selectedv = "C_" . $ititems[0];
	
	if ($q->param($selectedv) eq "Y")
		{
		$hidden_topics_selected = $hidden_topics_selected . "<input type=\"hidden\" name=\"$selectedv\" value=\"Y\">";
		}
	}

if ($hidden_topics_selected eq "") 
	{
	sn_netbadmin::errorbox ("You have to select a topic to be moved/copied."); exit;
	}

########################################

$boardtable = sn_netbadmin::get_file_contents("$data_dir/sn_boardtable.dat");
@board_lines = split (/\n/, $boardtable);

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);


$move_table = "<form method=\"POST\" action=\"$scripts_admin/sn_admin2.cgi\"><input type=\"hidden\" name=\"fct\" value=\"move_final\">
				   <input type=\"hidden\" name=\"from_cid\" value=\"$cid\">
					<input type=\"hidden\" name=\"from_fid\" value=\"$fid\"><font face=\"Verdana\" size=\"1\">
					$hidden_topics_selected";

if ($q->param('tcopy') eq "tcopy") 
		{
		$move_table = $move_table . "<input type=\"hidden\" name=\"tcopy\" value=\"tcopy\">";
		$opptype = "Copy"; 
		} 
		else 
		{ 
		$opptype = "Move"; 
		}

$move_table = $move_table . "$opptype Topics From: <b>$fcatname  $forname</b> to:<br><Br>";


	foreach $line (@board_lines)
		{
		($cid1, $cat_name) = split (/\t/, $line);
		$move_table = $move_table . "<img src=\"$web_url/sn_dir.gif\" width=\"16\" height=\"11\" alt=\"Main Category\"> <strong>$cat_name</strong><br>";
            
         	$forumtable = sn_netbadmin::get_file_contents("$data_dir/$cid1/forumtable.dat");
         	@all_forums = split (/\n/, $forumtable);
         	
         	foreach $fline (@all_forums)
         		{
            	($fid1, $forum_name) = split (/\t/, $fline);
            	
            	if ($fid1 != $fid)
            		{
            		if ($radio_value eq "") {$checkedval = "checked";} else {$checkedval = "";}
	            	$radio_value = $cid1 . "_" . $fid1;
            		$move_table = $move_table . "<input type=\"radio\" value=\"$radio_value\" $checkedval name=\"groupname\"><img src=\"$web_url/sn_dire.gif\" width=\"15\" height=\"15\"><img src=\"$web_url/sn_dir.gif\" width=\"16\" height=\"11\" alt=\"Select Forum\"> &nbsp; $forum_name<br>";
            		}
            	}
      
      $move_table = $move_table . "<BR>";
		}

$move_table = $move_table . "</font><input type=\"submit\" value=\"$opptype\" name=\"B1\" style=\"font-family: MS Sans Serif; font-size: 8\">";


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_add.gif", "$opptype Topics", qq[
<b>Choose a Forum Category to where you would like to $opptype the topics you selected.</b>
<BR><br>
$move_table
]);


print qq[<html>
<head>
<title>Moving Topics</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}





###

sub move_topics
{


my ($topicdata, $cid, @alltopics, $item, @topics, $cid, $fidm, $ttop, $statdata, 
	 @stats, $bcn, $checkboxname, $icon, $tmp, $posts, $views, $fid, $lastpost,
	 $topiclink, $icnt, $nr_searchres, $modp, $pages, $st, $nd, $ippc, $ms, $pg, 
	 $pgstring, $targpage, $st1, $nd1, $spls, $prev, $nextt, $spcer, $fcatname, $forname,
	 $opptype, $cvar, $opptypes, $parmp, $allboxes, $page_header, $mst);


$cid = $q->param('cid');
$fid = $q->param('fid');


#### CHECK IF THERE IS MODERATED MESSAGES IN QUE
$moderate_data = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
@mod_items = split (/\n/, $moderate_data);

if (length($moderate_data) > 1)
		{
		$mditems = @mod_items;
		
	sysopen(FH, "$data_dir/$cid/$fid/mtopics.cnt", O_RDWR|O_CREAT) or die "can't open mtopics.cnt: $!";
	  flock(FH, LOCK_EX)                           or die "can't flock mtopics.cnt: $!";
	  seek(FH, 0, 0)                               or die "can't rewind mtopics.cnt: $!";
	  truncate(FH, 0)                              or die "can't truncate mtopics.cnt: $!";
	  print FH $mditems                        	   or die "can't write mtopics.cnt: $!";
	close (FH)                                      or die "can't close mtopics.cnt: $!";


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_add.gif", "Move Topics", qq[
You cannot move/copy messages when there is messages that needs aproval (moderation) for display.
]);

print <<END_OF_NODEL;
<html>
<head>
<title>Delete Messages</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
END_OF_NODEL

		exit;
		}


$topicdata = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@alltopics = split(/\n/, $topicdata);

$fcatname = sn_netbadmin::get_cat_name($cid);
$forname = sn_netbadmin::get_forum_name($cid, $fid);

if ($q->param('tcopy') eq "tcopy") 
		{
		$opptypes = "Copied"; 
		$opptype = "Copy"; 
		$cvar = "<input type=\"hidden\" name=\"tcopy\" value=\"tcopy\">";
		$parmp = "tcopy=tcopy";
		} 
		else 
		{
		$opptypes = "Moved"; 
		$opptype = "Move"; 
		}


$hbox = sn_netbadmin::get_heading_box("$web_url/sn_add.gif", "$opptype Topics > $fcatname > $forname", qq[
Choose Topics to $opptype
]);

$ttop = <<END_OF_TT;
$hbox
<form name="movecopy" method="POST" action="$scripts_admin/sn_admin2.cgi">$cvar
  <input type="hidden" name="cid" value="$cid"><input type="hidden" name="fct"
  value="choose_cats_4move"><input type="hidden" name="fid" value="$fid">
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#E0E0E0">
  <tr>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Move</strong></font></td>
    <td height="30" background="$web_url/sn_bar6.gif"></td>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Topic</strong></font></td>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Author / Last Post</strong></font></td>
    <td height="30" background="$web_url/sn_bar6.gif"><font face="Verdana" size="1"
    color="#000000"><strong>Replies</strong></font></td>
  </tr>
END_OF_TT

#<td bgcolor="#8080C0" height="27"><p align="center"><font face="Verdana" size="1" color="#FFFFFF"><strong>Views</strong></font></td>


####################################

$statdata = sn_netbadmin::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@stats = split (/\n/,$statdata);
$bcn = 0;


### PAGES
$icnt = @stats;

if (($q->param('all') eq "all") and ($icnt != 0)) 
 {
 $nr_searchres = $icnt;
 }
 else
 {
 $nr_searchres = 30;
 }


$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

foreach $item (@alltopics)
{

  if (($ippc > $st) and ($ippc <= $nd))
    {
	
	(@topics) = split (/\t/,$item);

		$checkboxname = "C_" . $topics[0];
		
		($tmp, $posts, $views, $lastpost) = split(/\t/, $stats[$bcn]);
		$posts = $posts - 1;
		$bcn++;
		$lastpost = sn_netbadmin::decode_date($lastpost);

		#### ICONS
		if (($topics[4] eq "NONE") or ($topics[4] eq "")) 
				{
				$icon = "";
				$topiclink = "<a href=\"$scripts_url/sn_forumpr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				}
				elsif ($topics[4] eq "POLLQ123")
				{
				$icon = "<center><img src=\"$web_url/sn_poll.gif\"></center>";
				$posts = "<center><img src=\"$web_url/sn_poll.gif\"></center>"; 
				$topiclink = "<a href=\"$scripts_url/sn_forumpr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				}
				else
				{
				$icon = "<center><img src=\"$web_url/icons/$topics[4]\"></center>";
				$topiclink = "<a href=\"$scripts_url/sn_forumr.cgi?tid=$topics[0]&cid=$cid&fid=$fid\" target=\"_blank\">$topics[3]</a>";
				}

$allboxes = $allboxes . "'$checkboxname',";

$ttop = $ttop . <<END_OF_TT2;
  <tr>
    <td width="4%" bgcolor="#FFFFFF"><input type="checkbox" name="$checkboxname" value="Y"></td>
    <td width="4%" bgcolor="#FFFFFF">$icon</td>
    <td width="50%" bgcolor="#FFFFFF"><font face="Verdana" size="1">$topiclink</font></td>
    <td width="29%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><b>$topics[1]</b><br>$lastpost</font></td>
    <td width="9%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><p align="center">$posts</font></td>
  </tr>
END_OF_TT2


   } ### END OF PAGE RESULTS

  $ippc++;

} ### END OF LOOP THROUGH TOPICS

chop($allboxes);

##########

if ($ippc < 2)
	{

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_add.gif", "No Topics", qq[
There are no topics available to be moved or copied.
<BR><BR>
<form method="POST" action>
<input type="submit" value="Close This Window" name="B1" onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8pt" maxlength="50">
</form>
]);

print qq[<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];
	exit;
	}


$page_header = <<END_OF_PGHEAD;

<html>
<head>
<title>SiteNet BBS</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
<script>

function checkall(formname,thestate)
	{
	BoxNames=new Array($allboxes)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}
 
</script>
</head>
<body>
END_OF_PGHEAD

###########
$ttop = $page_header . $ttop;

$ttop = $ttop . <<END_OFTE;
</table><p><input type="submit" value="Choose Forum where topics will be $opptypes" name="B1" style="font-family: MS Sans Serif; font-size: 8"><br>
  <font face="Verdana" size="1">Check the checkbox next to topic(s) to select topics to be moved.
  <br><br><a href="javascript:checkall('movecopy',true)">Check All</a> | <a href="javascript:checkall('movecopy',false)">Uncheck All</a>
  </font></p>
</form>
<hr size="1" color="#C0C0C0">
END_OFTE


### PAGES

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . " <a href=\"$scripts_admin/sn_admin2.cgi?fct=move_topics&cid=$cid&fid=$fid&st=$st1&nd=$nd1&$parmp\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	$ttop = $ttop . "<br><font face=\"Verdana\" size=\"1\">$pgstring</font>";
	}
	else
	{
	$pgstring = "";
	}



####### PREVIOUS / NEXT

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = " <a href=\"$scripts_admin/sn_admin2.cgi?fct=move_topics&cid=$cid&fid=$fid&st=$st1&nd=$nd1&$parmp\">Next Page </a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = " <a href=\"$scripts_admin/sn_admin2.cgi?fct=move_topics&cid=$cid&fid=$fid&st=$st1&nd=$nd1&$parmp\"> Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}

   $ttop = $ttop . "<br><br><font face=\"Verdana\" size=\"1\">$prev $spcer $nextt</font>";





########
	$ippc = $ippc - 1;
	
	$ttop = $ttop . "<p><font face=\"Verdana\" size=\"1\">Total topics: <strong>$ippc</strong>";

if ($q->param('tcopy') eq "tcopy") 
		{
		$tallcrit = "tcopy=tcopy";
		}
	
   if ($pg > 1)
    {
    $ttop = $ttop . "  | Listing <strong>$nr_searchres</strong> topics per page. ";    
	 $ttop = $ttop . "| <a href=\"$scripts_admin/sn_admin2.cgi?fct=move_topics&cid=$cid&fid=$fid&all=all&$tallcrit\">List All Topics</a> </font></p>";
	 }


print $ttop;

}
