#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin; 
#use lib $FindBin::Bin;
use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$version = "3.0";
$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}



#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));

print $q->header();

if ($q->param('fct') eq "templates") {&start;}


######################################################################




sub start
{

my ($ctemplate, $disphtml);

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Templates Manager", qq[
The template manager enables you to change the look and feel of all elements displayed to end users.
]);



#$custom_templates = sn_netbadmin::get_heading_box("$web_url/sn_ic_fav.gif", "Assign a Pre-Defined Template Set", qq[
#This option allows you to assign a pre-created template set to your forums. <BR>
#<form method="POST" action="$scripts_admin/sn_admin5.cgi">
#  <input type="hidden" name="fct" value="assign_custom_template"><p><font face="Verdana"
#  size="2"><b>Template Set Name:</b> </font><select name="tname" size="1"
#  style="font-family: MS Sans Serif; font-size: 8">
#    <option value="Default">Default Factory Templates</option>
#  </select><input type="submit" value="Assign Template" name="B1"
#  style="font-family: MS Sans Serif; font-size: 8"></p>
#</form>
#]);


#$t_includes = sn_netbadmin::get_heading_box("$web_url/sn_ic_newsub.gif", qq[<a href="$scripts_admin/sn_admin6.cgi?fct=includes_start"
#onClick="popup('$scripts_admin/sn_admin6.cgi?fct=includes_start',screen.width-200,screen.height-200);return false;">Template Includes</a>], qq[
#Template Includes are pieces of HTML code which you can include in any template. These pieces of HTML code 
#could be headers, footers or menu bars. It almost works like SSIs (server side includes) or Java 
#Script Includes. Note that the template includes will only work in the SiteNet BBS templates. It will work 
#in any template used by SiteNet BBS. 
#]);


$global_frame_template = sn_netbadmin::get_heading_box("$web_url/sn_ic_tmplincl.gif", 
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=global&template=globalframe" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=global&template=globalframe', 'result2', 2);return false;">
1. Global Templates & Gadgets</a>], 
qq[
These templates are responsible for displaying global items used on several pages of the Forums. (Items that is available throughout all forum pages.)
<div id="result2"></div>
]);


#This template acts like a frame around all the pages of the forum. Edit this template to include your logo's, menu's, and other links of your web site.



$front_p_template = sn_netbadmin::get_heading_box("$web_url/sn_ic_frontp3.gif", 
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=fp_templates" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=fp_templates', 'result1', 1);return false;">
2. Forum Front Page & Category Templates</a>], 
qq[
These templates are responsible for the look and feel of the Forum Front Page. (The Front Page listing all Forum categories and their Forums.)
<div id="result1"></div>
]);


$topics_template = sn_netbadmin::get_heading_box("$web_url/sn_ic_dirs.gif", 
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=topic_templates" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=topic_templates', 'result3', 3);return false;">
3. Topic List Display Templates</a>], 
qq[
These templates are used to display the topics of Forums
<div id="result3"></div>
]);


#$gadgets = sn_netbadmin::get_heading_box("$web_url/sn_ic_dirs.gif", 
#qq[
#<a href="$scripts_admin/sn_admin8.cgi?fct=gadgets" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=gadgets', 'result10', 10);return false;">
#10. Gadgets</a>], 
#qq[
#These templates are responsible for the look and feel of the 'last visitor' displays.
#<div id="result10"></div>
#]);


$topic_msg_templates = sn_netbadmin::get_heading_box("$web_url/sn_ic_email4.gif", 
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=topic_msg_templates" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=topic_msg_templates', 'result4', 4);return false;">
4. Topic/Message Display Templates</a>], 
qq[
These templates are responsible for the look and feel of the Topic and Message displays.
<div id="result4"></div>
]);


$post_msg_templates = sn_netbadmin::get_heading_box("$web_url/sn_ic_comment.gif", 
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=post_msg_templates" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=post_msg_templates', 'result5', 5);return false;">
5. Message Posting / Poll Posting / Message Editing</a>], 
qq[
These templates are responsible for the look and feel when users post new topics or posts replies or polls.
<div id="result5"></div>
]);


$reg_templates = sn_netbadmin::get_heading_box("$web_url/sn_ic_users.gif",
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=reg_templates" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=reg_templates', 'result6', 6);return false;">
6. User Registration / Edit Profiles / View Profiles / Login</a>], 
qq[
These templates are used when a new user registers an account.
<div id="result6"></div>
]);


$search_templates = sn_netbadmin::get_heading_box("$web_url/sn_ic_search.gif",
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=search_templates" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=search_templates', 'result7', 7);return false;">
7. Search Templates</a>], 
qq[
These templates are used when performing a search.
<div id="result7"></div>
]);

$mod_templates = sn_netbadmin::get_heading_box("$web_url/sn_icmod.gif",
qq[
<a href="$scripts_admin/sn_admin8.cgi?fct=mod_templates" onClick="xmlhttpPost('$scripts_admin/sn_admin8.cgi?fct=mod_templates', 'result8', 8);return false;">
8. Moderator Templates</a>], 
qq[
These templates are used for moderator functions.
<div id="result8"></div>
]);



$disphtml = qq[

$hbox

$custom_templates

$t_includes

$global_frame_template

$front_p_template

$topics_template

$topic_msg_templates

$post_msg_templates

$reg_templates

$search_templates

$mod_templates

$gadgets

];


$ctemplate = sn_netbadmin::get_cpanel_template;
$ctemplate =~ s/!!criteria!!/$disphtml/g;
print $ctemplate;

}
















########







