#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "premlinks") {&premlinks;}
if ($q->param('fct') eq "customcats") {&customcats;}
if ($q->param('fct') eq "targetads") {&targetads;}
if ($q->param('fct') eq "extrafields") {&extrafields;}
if ($q->param('fct') eq "reciprocal") {&reciprocal;}
if ($q->param('fct') eq "contentfield") {&contentfield;}
if ($q->param('fct') eq "gallery") {&gallery;}
if ($q->param('fct') eq "tincludes") {&tincludes;}

##################################################################################

sub tincludes
{

$boxdiz = qq[
Template Includes are pieces of HTML code that can be included in any template. These pieces of HTML code could be headers, footers, menu bars, etc. It almost works like SSI's (server side includes).
];

$hbox = acs::get_heading_box("$web_url/ic_tmplincl.gif", "How to use Headers, Footers, Menu Bars, etc. inside templates so that they automatically change throughout all templates ", $boxdiz);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Wizards</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox

<p><strong>How to use Headers, Footers, Menu Bars, etc. 
  inside templates so that they automatically change throughout all templates</strong>
</p>
<blockquote>
  <p><strong>How it works:</strong></p>
  <p>Powerseek comes with functionality where you can include pieces of HTML code inside any PowerSeek template. When you change any aspect of the pieces of HTML code then it will automatically change throughout all templates. </p>
  <p><strong>Another Explanation:</strong></p>
  <p>Template Includes works with PowerSeek like SSI (server side includes)  would work with a web server. Template includes are pieces of HTML code  that you can include in any of the templates used by PowerSeek. The  pieces of HTML code could be menu bars, footers, headers, search boxes,  etc.</p>
  <p>You could for example create a template include that will be a menu bar  that you would like placed on the left side of all your Search Engine  &amp; Directory pages. Without template includes you would have to open  each template and insert the menu bar. With template includes you just  insert a variable word inside any template and the HTML code that is  contained within the Template Include is replaced by the variable. In  the event where something of your menu bar changes, you just edit the  Template Include and the rest of the templates containing the menu bar  via the Template Include changes. Note that if you run an <a href="$admin_url/help.cgi?fct=template_includes" target="_blank">HTML Generated (Static) Directory</a> that you will need        to regenerate HTML files if you have changed a Template Include.</p>
</blockquote>
<p><strong>How to create a Template Include:</strong></p>
<p><strong>Step 1 - Create a 'Header' Template Include</strong></p>
<blockquote>
  <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt;</strong> <strong><a tiptitle="Template Includes are pieces of HTML code that can be included &lt;BR&gt;  in any template. These pieces of HTML code could be headers, footers, &lt;BR&gt;  menu bars, etc. It almost works like SSI's (server side includes)." href="$admin_url/admin17.cgi" onclick="popup('$admin_url/admin17.cgi',screen.width-250,screen.height-250);return false;">Create/Edit Template Includes</a></strong></p>
  <p> Now choose and specify a name under the heading reading: <strong>Add a New Template Include</strong></p>
  <p>Also specify the HTML code of the 'Header' you would like to use. The 'Header' could contain your logo, and menu bar, search box, etc. Listed below are global variables that you can place inside your <strong>'Header' Include:</strong></p>
  <blockquote>
    <p><strong>!build_url! </strong><br />
      This is always replaced by the URL path to the 'html' directory, or the directory where    all generated HTML files are stored. <br />
      <br />
      <strong>!!add_url_link!! </strong><br />
      This is always replaced by a URL path to the 'Add URL' form or the cgi script that    displays the 'Add URL' form. <br />
      <br />
      <strong>!!add_premium_url_link!! </strong><br />
      This is always replaced by a URL path to the 'Premium Link Add URL' form or the cgi script    that displays the 'Premium Link Add URL' form. <br />
      <br />
      <strong>!!whatsnew!! </strong><br />
      This is always replaced by a URL path to the page that indicates the latest link additions    to your directory. <br />
      <br />
      <strong>!!tophits!! </strong><br />
      This is always replaced by a URL path to the page that indicates most popular links inside    your directory. <br />
      <br />
      <strong>!!modify_link_url!! </strong><br />
      This is always replaced by a URL path to the modify CGI script that enable users to modify    their links. </p>
    <p><strong>!!register!! </strong><br />
      This is replaced by a link to the registration form that visitors complete to register an    account. Note that you have to use the user registration system. </p>
    <p><strong>!!rgs_loginl!! </strong><br />
      This is replaced by a link to the login page where visitors log into their accounts. (To    add links or view/modify them) <br />
      <br />
      <strong>!!contactus!!</strong><br />
This is always replaced by the URL path to the contact form.<br />
      <br />
      <strong>!!tseeksearch!! </strong><br />
      This is always replaced by the URL path to the search CGI scripts. The search CGI scripts    are the scripts that searches through your Directory when a visitor invokes a search.  </p>
  </blockquote>
  <p><strong>The Search Box HTML Code you can use inside your 'Header' Include is: </strong></p>
  <blockquote>
    <p>&lt;form method=&quot;POST&quot; action=&quot;!!tseeksearch!!&quot;&gt;<br />
      &lt;input type=&quot;text&quot; name=&quot;keywords&quot; size=&quot;20&quot;&gt;<br />
      &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br />
      &lt;/form&gt;</p>
  </blockquote>
  <p><strong>Your 'Header' Include could look like something like this for example:</strong></p>
  <blockquote>
    <p>&lt;h1&gt;Some Search Engine &amp; Directory Name&lt;/h1&gt;<br />
      &lt;form method=&quot;POST&quot; action=&quot;!!tseeksearch!!&quot;&gt;<br />
      &lt;input type=&quot;text&quot; name=&quot;keywords&quot; size=&quot;20&quot;&gt;<br />
      &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br />
      &lt;/form&gt;<br />
    &lt;a href=&quot;!!add_url_link!! &quot;&gt;Add URL&lt;/a&gt; | &lt;a href=&quot;!!add_url_link!! &quot;&gt;Add Premium URL&lt;/a&gt; | &lt;a href=&quot;!!whatsnew!!&quot;&gt;What's New&lt;/a&gt; | &lt;a href=&quot;!!tophits!!&quot;&gt;Most Popular&lt;/a&gt; | &lt;a href=&quot;!!register!!&quot;&gt;Register&lt;/a&gt; | &lt;a href=&quot;!!rgs_login!!&quot;&gt;Login&lt;/a&gt; </p>
  </blockquote>
  <p><strong>If you would like to use Images inside the HTML Code of the 'Header' Include then follow the instructions below:</strong></p>
  <blockquote>
    <p>When you make use of images in the HTML code of templates  then you must use a URL link to indicate their locations. <strong><br />
      </strong><br />
    <strong>For example: </strong></p>
    <blockquote>
      <p><strong>&lt;img src=&quot;someimage.gif&quot;&gt; will not work. </strong><br />
        <br />
        <strong>You have to indicate the entire URL where someimage.gif is located. For example: </strong><br />
        <br />
        <strong>&lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong><br />
        <br />
        The <strong>&lt;img </strong>is an HTML tag indicating that you want to insert an image in    the HTML page. The <strong>src= </strong>part indicates that you want to specify the    location of the image to be inserted. Some web editors will support inserting images from    a web url and some won't. If your web editor does not support this, insert the image into    the HTML page like usual and when finished edit the source of the HTML code and manually    insert the URL path's to the images. Ensure that the images are on the server for the URL    path's you specify. </p>
      <blockquote>
        <p><strong>Example, editing the HTML source code: </strong></p>
      
        <p><strong>Replace &lt;img src=&quot;someimage.gif&quot;&gt; with <br />
          &lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong></p>
      </blockquote>
    </blockquote>
  </blockquote>
  <p>After you have specified a name and HTML code for the Template Include, click the 'Add New Include' button to add the Include.</p>
</blockquote>
<p>&nbsp;</p>
<p><strong>Step 2 - Implement the 'Header' Include:</strong><br />
</p>
<blockquote>
  <blockquote>
    <p>Now that you have created a 'Template Include' you will see a column reading: '<strong>Include text to use in templates' - </strong>You can use the word or variable listed in this column next to the Include you created inside any PowerSeek template. The word/variable will contain double percentage signs on both sides of it. When this word is available inside a PowerSeek template then it will be replaced by the HTML code of the Template Include.</p>
    <p>You can now edit and insert the word/variable representing the 'Template Include' inside any PowerSeek Template. All PowerSeek Templates used are available from the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a></strong> for editing.</p>
    <p>&nbsp;</p>
  </blockquote>
</blockquote>
<p><strong></strong><strong>Step 3 - Using Template Includes when Implementing a Global Template</strong></p>
<blockquote>
  <p>The '<strong>Implement a Global Template'</strong> functionality let's you upload a global template so that all PowerSeek templates takes on it's look and feel. <strong>When uploading a global template you can also include 'Template Include' words/variables inside it for global 'headers', 'footers', 'menu bars', etc.</strong></p>
  <p>You can find out how to implement a Global Template in the  <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a></strong> &gt;&gt; <strong><a tiptitle="This function allows you to upload a master template (normal HTML file) and   implement this template throughout all PowerSeek templates to give all PowerSeek end   user pages the  look and feel of the master template. It will act like a frame around   all end-user PowerSeek pages. This template could contain your logo, graphics, layout,   menu bars, etc." href="$admin_url/p_tmpglobal.cgi" onclick="popup('$admin_url/p_tmpglobal.cgi',screen.width-250,screen.height-250);return false;">Implement Global Template</a></strong> &gt;&gt; <strong>
  <a href="$admin_url/p_tmpglobal.cgi?fct=wizard1"
  onclick="popup('$admin_url/p_tmpglobal.cgi?fct=wizard1',screen.width-250,screen.height-250, 'fieldkey');return false;">Start the Wizard to Implement a Global      Template</a></strong></p>
  <p><strong>Notes: </strong></p>
  <ul>
    <li>
      <p>If you want to use <strong>Template Includes</strong> inside the <strong>Global Template</strong> you plan on uploading then you will first need to create the <strong>Template Includes</strong> and then include the variable words inside the Global Template. After that you can upload the Global Template with the  '<strong>Implement a Global Template'</strong> functionality.</p>
    </li>
    <li>
      <p>Including Template Includes in a Global Template that is to be implemented is the quickest and fastest way to add configurable 'Headers', 'Footers', 'Menu Bars', etc. to PowerSeek templates.</p>
    </li>
  </ul>
  <p>&nbsp;</p>
  <p>&nbsp;</p>
</blockquote>

</body>
</html>
];






}


sub gallery
{

$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "How to build an Image Gallery with PowerSeek", qq[This Wizard explains how to build an Image Gallery with PowerSeek.]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox

<p>This Wizard will explain how to build an Image Gallery with  PowerSeek. It mostly involves changing aspects of the PowerSeek  templates.</p>
<p><strong>Requirements</strong>:</p>
<blockquote>
  <p>PowerSeek requires one of the following Perl modules to automatically resize images to thumbnails: <a href="http://www.imagemagick.org/" target="_blank">Image::Magick</a> or <a href="http://cpan.uwinnipeg.ca/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a></p>
  <p>PowerSeek  will tell you if one of these are not available on your host when you  want to perform an image resizing operation. If you don't have one of  the Perl modules installed then contact your web host and ask them to  install the Perl module called <a href="http://www.imagemagick.org/" target="_blank">Image::Magick</a> or <a href="http://cpan.uwinnipeg.ca/htdocs/Image-Resize/Image/Resize.html" target="_blank">Image::Resize</a> - Note that it is much easier to install <a href="http://cpan.uwinnipeg.ca/htdocs/Image-Resize/Image/Resize.html">Image::Resize</a> than <a href="http://www.imagemagick.org/">Image::Magick.</a></p>
</blockquote>
<p><strong>Step 1 - Add an Upload Extra Field</strong></p>
<blockquote>
  <p>Below  is an explanation on adding an extra upload field. This field will be  used to store large image files for the image gallery. </p>
  <p>Go to the <strong> <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <strong><a href="$admin_url/admin37.cgi" onclick="popup('$admin_url/admin37.cgi',900,650, 'fieldkey');return false;">Extra        Fields/Keys </a></strong></strong></p>
  <p>Click<strong> 'Add a New Extra Field'</strong></p>
  <p>From the '<strong>Field Type:</strong>' drop down menu choose '<strong>File Upload Field</strong>'.</p>
  <p>Specify a <strong>Field/Key Name</strong>. In this example we will use the name <strong>BigImage.</strong></p>
  <p>For the '<strong>Field/Key        Descriptive Name:</strong>' we will specify the name <strong>'Big Image'</strong>.</p>
  <p>Now click the <strong>'Next'</strong> button.</p>
  <p>On the next screen for the setting: '<strong>Visible when        browsing control panel?</strong>' specify <strong>'No'</strong></p>
  <p>For the setting:  '<strong>Accepted File        Types?</strong>' specify: .jpg,.jpeg</p>
  <p>For the setting: '<strong>Required with        new submissions?</strong>' specify: <strong>'Yes'</strong></p>
  <p>Leave the settings for: '<strong>Pre-Append HTML        or Text:</strong> and '<strong>Append HTML or        Text:</strong>' blank. </p>
  <p>Set the setting: '<strong>Maximum Upload        File Size:</strong>' to 2000</p>
  <p>Click the <strong>'Add Field/Key'</strong> button.</p>
  <p>We have now just added an upload field that will store large images for the image gallery. </p>
</blockquote>
<p><strong>Step 2 - Upload Images</strong></p>
<blockquote>
  <p>PowerSeek  by default has one standard image field where an image can be uploaded.  In this example we will use the standard image field available with  PowerSeek to store thumbnails of large images. We will display these  thumbnails within categories as thumbnail images and when clicked we  will be displaying the larger image on a 'more info' page. The larger  image will be stored in the <strong>'BigImage' </strong>extra field we added in Step 1. </p>
  <p>To  upload images go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin2.cgi" target="_blank"><strong>Dir Manager</strong></a> &gt;&gt;  <strong>Enter any category</strong>. If you don't have categories then add some. Click  the <strong>'Add Link' </strong>button when in a category. A popup window will appear. In the popup window, to add a link specify a <strong>title</strong> for the image. Scroll down to the <strong>'Image:' </strong>field and click <strong>'Resize Options'</strong>. Another 'popup window' will appear. Leave the '<strong>Image Width in Pixels to resize to:</strong>' setting blank. Set the<strong> 'Image Height in Pixels to resize to:' </strong>setting to <strong>130</strong> and click the 'Save' button.</p>
  <blockquote>
    <p><em>The Resize Options lets you specify to what width and/or height images will be resized to when uploaded.</em></p>
  </blockquote>
  <p>You should now have specified a title and configured the resize settings for the standard <strong>'Image'</strong> field. Now, click the <strong>'Browse' </strong>button for the <strong>'Image'</strong> field and choose an image from your hard drive to upload. This image  will be uploaded and automatically be resized to the thumbnail size  when this listing is added.</p>
  <p>Now next to the <strong>'Big Image' </strong> field click the 'Browse' button and choose the same image as you have chosen for the <strong>'Image'</strong> field. This image will not be resized and will serve as the large image. </p>
  <blockquote>
    <p><em><strong>Note:</strong> There is a plugin available that can help you rapidly add images if you  have thousands of images for example. The way this plugin works is that  you upload your images via FTP. This plugin will then automatically  take these images and resize them as thumbnails and add them as  listings for image gallery purposes. In other words it will resize the  image and place it in the standard image field as a thumbnail and place  the larger image in an extra upload field in a batch-like process. This  plugin is available in the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a></strong> &gt;&gt; <a href="$admin_url/plugins.cgi#utils" target="_blank">Utility Plugins</a> &gt;&gt; <a href="$admin_url/p_thumb.cgi" onclick="popup('$admin_url/p_thumb.cgi',900,650);return false;"><strong>Thumbnail Batch Resizer &amp; Importer</strong></a></strong></em></p>
  </blockquote>
</blockquote>
<p><strong>Step 3 - Edit Templates to Display Thumbnails and Images in Categories</strong></p>
<blockquote>
  <p>For  us to continue you will need at least 10 listings containing images in  at least one category. What this means is that you need at least 10  listings containing a thumbnail in the standard 'Image Field' and an  image in the 'Big Image' field. If you do not have this amount of  listings with images then add more listings with images. (This is  explained in step 2 above) </p>
  <p><strong>Edit  the Default Category/Directory Templates</strong>:</p>
  <blockquote>
    <p> Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong></strong> &gt;&gt;- Edit the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=defdir" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',900,650);return false;"><strong>Main Category/Directory</strong></a>'</strong> template. Replace the text reading:  %%searchresults%% with the following HTML code:</p>
    <p>&lt;table width="100%" border="0" cellspacing="0" cellpadding="3"&gt;<br>
      &lt;tr&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults2%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults3%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults4%%&lt;/td&gt;<br>
      &lt;/tr&gt;<br>
    &lt;/table&gt;</p>
    <p><strong>Explanation of the HTML code used above:</strong> The HTML code above defines 4 columns that will list thumbnails. Up to  6 columns can be used. %%searchresults%% represents the first column.  %%searchresults2%% represents the second column, etc. Note that you can  use columns not only to create image galleries but to list  links/listings in columns for example. </p>
  </blockquote>
  <p><strong>Edit the Directory Links Style Template:</strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong> PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong> </strong>- Click on the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch',900,650);return false;">Links Style</a>'</strong> link to edit the 'Links Style' template. Remove the existing HTML code and place the following HTML code inside this template:</p>
    <p>&lt;table border="0" cellspacing="0" cellpadding="0"&gt;<br>
      &lt;tr&gt;&lt;td height="170" align="center" valign="top"&gt;<br>
      &lt;p&gt;&lt;a href="!!more_info_url!!"&gt;!!link_image!!&lt;/a&gt;&lt;br&gt;<br>
      &lt;a href="!!add_to_favorites!!"&gt; Add to  Favorites&lt;/a&gt;&lt;br&gt;!!rating_image!!&lt;br&gt;!!new!!&lt;br&gt;!!pop!!&lt;/p&gt;<br>
      &lt;/td&gt;&lt;/tr&gt;<br>
    &lt;/table&gt;</p>
    <p><strong>Explanation of the HTML code used above:</strong> The HTML code above defines a thumbnail that will be displayed inside category pages.</p>
    <p><em><strong>Note:</strong> You can still create premium listings with thumbnails to display some  thumbnails first just like with premium links. If you would like to do  that then you can edit the 'Premium Links Style' template and </em>place the same HTML code inside it as indicated above. </p>
  </blockquote>
  <p><strong>Edit the Link Info or also referred to as the 'More Info' template:</strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong></strong>- Click on the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=linkinfo" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=linkinfo',900,650);return false;">Link Info</a>' </strong> link to edit the 'Links Info' template. This template is also referred to as the <strong>'More Info'</strong> template some times. Place the following HTML code inside this template  where you want the larger image to appear when a thumbnail is clicked:<br>
      <strong>&lt;img src="!!BigImage!!" width="750" alt="Wallpaper"&gt;</strong></p>
    <p>Note  that you will probably want to remove or re-arrange other things inside  the 'Link Info' template like the Listing Title, URL since no URL is  being used, Description,  etc.. </p>
  </blockquote>
  <p><strong>Preview the changes you just made.</strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin2.cgi" target="_blank"><strong>Dir Manager</strong></a> and preview the category where you have uploaded the images as explained in <strong>Step 2.</strong></p>
  </blockquote>
</blockquote>
<p><strong>Step 4 - Edit Other Templates to Display Thumbnails</strong></p>
<blockquote>
  <p><strong>Edit Search Results Templates to display Thumbnails</strong>:</p>
  <blockquote>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a><a href="$admin_url/admin2.cgi" target="_blank"></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=2#2" target="_blank">2. Search Result Templates</a></strong> - Edit the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=searchres" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=searchres',900,650);return false;"><strong>Main Search Page</strong></a>'</strong> template. Replace the text reading:  %%searchresults%% with the following HTML code:</p>
    <p>&lt;table width="100%" border="0" cellspacing="0" cellpadding="3"&gt;<br>
      &lt;tr&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults2%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults3%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%searchresults4%%&lt;/td&gt;<br>
      &lt;/tr&gt;<br>
    &lt;/table&gt;</p>
    <p><strong>Explanation of the HTML code used above:</strong> The HTML code above defines 4 columns that will list thumbnails. Up to  6 columns can be used. %%searchresults%% represents the first column.  %%searchresults2%% represents the second column, etc. Note that you can  use columns not only to create image galleries but to list  links/listings in columns for example.</p>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a><a href="$admin_url/admin2.cgi" target="_blank"></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=2#2" target="_blank">2. Search Result Templates</a></strong>- Click on the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc',900,650);return false;">Links   Style</a>'</strong> link to edit the 'Links Style' template. Replace the existing HTML code with the following HTML code:</p>
    <p>&lt;table border="0" cellspacing="0" cellpadding="0"&gt;<br>
      &lt;tr&gt;&lt;td height="200" align="center" valign="top" class="plain_text"&gt;<br>
      From:&lt;BR&gt;<br>
      !!category!!&lt;BR&gt;<br>
      &lt;a href="!!more_info_url!!"&gt;!!link_image!!&lt;/a&gt;&lt;br&gt;<br>
      !!rating_image!!&lt;br&gt;<br>
      !!new!!&lt;br&gt;<br>
      !!pop!!&lt;/td&gt;&lt;/tr&gt;<br>
    &lt;/table&gt;</p>
    <p><strong>Explanation of the HTML code used above:</strong> The HTML code above defines a thumbnail that will be displayed when a match is found when a search is performed. </p>
  </blockquote>
  <p><strong>Edit the What's New Templates to display thumbnails:</strong></p>
  <blockquote>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a><a href="$admin_url/admin2.cgi" target="_blank"></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=6#6" target="_blank">6. What's New Templates</a></strong>- Edit the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_main" title="This template is used when displaying the latest additions to the directory." onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_main',900,650);return false;">Main   What's New Page</a>'</strong> template. Replace the text reading: <strong>%%whats_new_listings%%</strong> with the following HTML code:</p>
    <p>&lt;table width="100%" border="0" cellspacing="0" cellpadding="3"&gt;<br>
      &lt;tr&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%whats_new_listings%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%whats_new_listings2%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%whats_new_listings3%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%whats_new_listings4%%&lt;/td&gt;<br>
      &lt;/tr&gt;<br>
    &lt;/table&gt;</p>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a><a href="$admin_url/admin2.cgi" target="_blank"></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=6#6" target="_blank">6. What's New Templates</a></strong> - Click on the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_lists" title="This template reflects the HTML code used when displaying new link listings." onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_lists',900,650);return false;">What's   New Listings Style</a>'</strong> link to edit the 'Links Style' template. Replace the existing HTML code with the following HTML code:</p>
    <p>&lt;table border="0" cellspacing="0" cellpadding="0"&gt;<br>
      &lt;tr&gt;&lt;td height="200" align="center" valign="top" class="plain_text"&gt;<br>
      From:&lt;BR&gt;<br>
      !!category!!&lt;BR&gt;<br>
      &lt;a href="!!more_info_url!!"&gt;!!link_image!!&lt;/a&gt;&lt;br&gt;<br>
      !!rating_image!!&lt;br&gt;!!new!!&lt;br&gt;!!pop!!&lt;/td&gt;<br>
      &lt;/tr&gt;<br>
    &lt;/table&gt;</p>
  </blockquote>
  <p><strong>Edit the Top Hits Templates to display thumbnails:</strong></p>
  <blockquote>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a><a href="$admin_url/admin2.cgi" target="_blank"></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=7#7">7. Top Hits Templates</a></strong> - Edit the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=tophits_main" title="This template is used when displaying the most clicked links in the directory." onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tophits_main',900,650);return false;">Main   Top Hits Page</a>'</strong> template. Replace the text reading:<strong>%%tophits_listings%%</strong>with the following HTML code:</p>
    <p>&lt;table width="100%" border="0" cellspacing="0" cellpadding="3"&gt;<br>
      &lt;tr&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%tophits_listings%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%tophits_listings2%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%tophits_listings3%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%tophits_listings4%%&lt;/td&gt;<br>
      &lt;/tr&gt;<br>
    &lt;/table&gt;</p>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a><a href="$admin_url/admin2.cgi" target="_blank"></a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=7#7">7. Top Hits Templates</a></strong> - Click on the <strong>'Links Style'</strong> link to edit the 'Links Style' template. Replace the existing HTML code with the following HTML code:</p>
    <p>&lt;table border="0" cellspacing="0" cellpadding="0"&gt;<br>
      &lt;tr&gt;&lt;td height="200" align="center" valign="top" class="plain_text"&gt;<br>
      From:&lt;BR&gt;<br>
      !!category!!&lt;BR&gt;<br>
      &lt;a href="!!more_info_url!!"&gt;!!link_image!!&lt;/a&gt;&lt;br&gt;<br>
      !!rating_image!!&lt;br&gt;!!new!!&lt;br&gt;!!pop!!&lt;/td&gt;<br>
      &lt;/tr&gt;<br>
    &lt;/table&gt;</p>
  </blockquote>
  <p><strong>Edit the Favorites Templates to display thumbnails:</strong></p>
  <blockquote>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=9#9">9. Favorites</a></strong>- Edit the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=fav_main" title="This template acts like a frame around favorite links that has been flagged by visitors as their favourites." onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=fav_main',900,650);return false;"><strong>Main Favorites</strong></a>'</strong> template. Replace the text reading:<strong>!!favorites!!</strong><strong> or %%favorites%% </strong>with the following HTML code:</p>
    <p>&lt;table width="100%" border="0" cellspacing="0" cellpadding="3"&gt;<br>
      &lt;tr&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%favorites%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%favorites2%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%favorites3%%&lt;/td&gt;<br>
      &lt;td width="25%" align="center" valign="top"&gt;%%favorites4%%&lt;/td&gt;<br>
      &lt;/tr&gt;<br>
    &lt;/table&gt;</p>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=9#9">9. Favorites</a> </strong>- Click on the <strong>'<a href="$admin_url/admin6.cgi?fct=edit_template&template=fav_standard" title="This template reflects the HTML code used when displaying a visitor's favorite links." onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=fav_standard',900,650);return false;">Favorites Link Style</a>'</strong> link to edit the 'Links Style' template. Replace the existing HTML code with the following HTML code:</p>
    <p>&lt;table border="0" cellspacing="0" cellpadding="0"&gt;<br>
      &lt;tr&gt;&lt;td height="200" align="center" valign="top" class="plain_text"&gt;<br>
      From:&lt;BR&gt;<br>
      !!category!!&lt;BR&gt;<br>
      &lt;a href="!!more_info_url!!"&gt;!!link_image!!&lt;/a&gt;&lt;br&gt;<br>
      &lt;a href="!!remove_link!!"&gt;Remove&lt;/a&gt;&lt;br&gt;<br>
      !!rating_image!!&lt;/td&gt;&lt;/tr&gt;<br>
    &lt;/table&gt;</p>
  </blockquote>
  <p><strong>Step 5 - Change Settings </strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi?fct=global_settings" onclick="popup('$admin_url/admin10.cgi?fct=global_settings',900,650);return false;"><strong>Global Engine Settings</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi?fct=global_settings#4" onclick="popup('$admin_url/admin10.cgi?fct=global_settings#4',900,650);return false;"><strong>4. Search Settings</strong></a></p>
    <p>Make sure that the setting reading: '<strong>Remove duplicate      links from search results?</strong>' is set to <strong>'No'</strong></p>
  </blockquote>
  <p><strong>Step 6 - Edit the Add URL and Modify templates to let users upload images</strong></p>
  <blockquote>
    <p>Follow  the instructions below if you want to let users upload images. Note  that if you don't want users to upload or submit images then you can  remove the 'Add URL' links from the templates. You can skip this step  if you don't want to let users upload or submit images or listings. </p>
    <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi?fct=global_settings" onclick="popup('$admin_url/admin10.cgi?fct=global_settings',900,650);return false;"><strong>Global Engine Setttings</strong></a><strong> </strong>&gt;&gt; Click on<strong> <a href="$admin_url/admin10.cgi?fct=global_settings#3" onclick="popup('$admin_url/admin10.cgi?fct=global_settings#3',900,650);return false;"><strong>3. Directory/Category Listing      Settings</strong></a></strong> - Make sure that the setting reading: '<strong>Enable image      uploading from submission forms?</strong>' is set to <strong>'Yes'</strong></p>
    <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi?fct=global_settings" onclick="popup('$admin_url/admin10.cgi?fct=global_settings',900,650);return false;"><strong>Global Engine Setttings</strong></a><strong> </strong>&gt;&gt; Click on<strong><a href="$admin_url/admin10.cgi?fct=global_settings#3" onclick="popup('$admin_url/admin10.cgi?fct=global_settings#3',900,650);return false;"><strong>3. Directory/Category Listing      Settings</strong></a></strong> - Make sure that the setting reading: '<strong>What is the maximum      size of an image file that may be uploaded?</strong>' is set to <strong>10 </strong>or a setting that is acceptable for the thumbnail size that will be uploaded by end users. </p>
    <p>Go to the <strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=3#3" target="_blank">3. Add URL Templates</a></strong>- Copy and paste the HTML code of the <strong>'Add URL'</strong> template that is 'in use' into your web editor.</p>
    <p>Look        at the source of template and find the form declaration. It will look something like this:</p>
    <blockquote>
      <p><strong>&lt;form method="POST" action="!!addurlcgi!!"&gt;</strong></p>
    </blockquote>
    <p>Modify it so that it looks like this:</p>
    <blockquote>
      <p><strong>&lt;form method="POST" action="!!addurlcgi!!"           ENCTYPE="multipart/form-data"&gt;</strong></p>
    </blockquote>
    <p>Now  add the following to the Add URL form: (This is the upload field that  visitors will see when submitting a listing/image)</p>
    <blockquote>
      <p><strong>Upload a thumbnail: &lt;input type="file" name="image"          size="51"&gt;</strong></p>
    </blockquote>
    <p>In step 1 we added an extra upload field called: <strong>BigImage</strong> - Now add the following to the template so that users can specify a large image to upload:</p>
    <blockquote>
      <p><strong>Upload an Image: &lt;input type="file" name="BigImage"          size="51"&gt;</strong></p>
    </blockquote>
    <p>Now copy and paste the source code of the Add URL template back and save the template.</p>
    <p>Go to the<strong><a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin6.cgi?t=3#3" target="_blank">3. Add URL Templates</a> </strong>- Copy and paste the HTML code of the <strong>'Modify'</strong> template into your web editor.</p>
    <p>Look        at the source of template and find the form declaration. It will look something like this:</p>
    <blockquote>
      <p><strong>&lt;form method="POST" action="!!addurlcgi!!"&gt;</strong></p>
    </blockquote>
    <p>Modify it so that it looks like this:</p>
    <blockquote>
      <p><strong>&lt;form method="POST" action="!!addurlcgi!!"           ENCTYPE="multipart/form-data"&gt;</strong></p>
    </blockquote>
    <p>Now add the following HTML code to the template. This code is used so that users can upload a new thumbnail image. </p>
    <blockquote>
      <p><strong>Upload a New Thumbnail: %%image%% [imgtext]No Image Available[endimgtxt]&lt;br&gt;<br>
        &lt;input type="file" name="image" size="51"&gt; </strong></p>
    </blockquote>
    <p>Also  add the following HTML code to the template. This code is used so that  users can upload a new image. Remember that in Step 1 that we created  an extra upload field called <strong>BigImage</strong></p>
    <blockquote>
      <p><strong>Upload a New Image: %%BigImage_file_with_link%%<br>
        [BigImage_no_filename_text]No File Available [BigImage_no_filename_text_end]&lt;br&gt;<br>
        &lt;input type="file" name="BigImage" size="51"&gt;&lt;br&gt;</strong></p>
    </blockquote>
    <p>Now copy and paste the source code of the Modify template back and save the template.</p>
  </blockquote>
  <p><strong>Note: </strong>If  you are going to have images that is treated like premium links and are  going to have premium submission and premium modify forms then you will  need to edit the 'premium add url' and 'premium modify' templates in  the same way as explained above. </p>
</blockquote>


</body>
</html>
];


}




sub contentfield
{

$hbox = acs::get_heading_box("$web_url/ic_texts.gif", "How to use PowerSeek as a CMS", qq[How to use PowerSeek as a CMS with extra content fields.]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox
<p>As of version 4.1, PowerSeek comes with functionality where extra <strong>'Content Fields'</strong> can be added. <strong><a href="$admin_url/admin37.cgi" onclick="popup('$admin_url/admin37.cgi',900,650, 'fieldkey');return false;">Extra Fields/Keys</a></strong> gives you the ability to add/collect extra information with link  listings like addresses, telephone numbers, images, files, videos, etc. <strong>Content fields</strong> have the ability to store articles and  additionally these fields comes with a WYSIWYG editor to add/edit the  contents of these fields. The WYSIWYG editor is a fully functional Web  Editor and also has CSS ability where CSS files are also supported. The  WYSIWYG Editor allows you to add any kind of content with font styles,  font colors, tables, or content with any kind of HTML elements with  ease.</p>
<p>In the example below we will add a <strong>Content Field</strong> so that we can store an article with each link listing. In the example  below we will build a typical Article Directory that stores articles  and provides articles to it's visitors. </p>
<p><strong>Step 1 - Create an extra content field to store articles</strong></p>
<blockquote>
  <p>To do this go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <strong><a href="$admin_url/admin37.cgi" onclick="popup('$admin_url/admin37.cgi',900,650, 'fieldkey');return false;">Extra        Fields/Keys </a></strong></p>
  <p>Click the <strong>'Add a New Extra Field'</strong> button</p>
  <p>After doing that choose<strong> 'Content Field'</strong> from the <strong>'Field Type' </strong>selection  box. Then specify a name and descriptive name for the Content Field you  are about to add and click the 'Next' button. In this example we will  use <strong>Article </strong>as the field/key name and <strong>Article</strong> as the descriptive name. </p>
  <p>Go through the details of the following screen and click the 'Add Field/Key' button.</p>
</blockquote>
<p><strong>Step 2 - Add an Article</strong></p>
<blockquote>
  <p>Go  to any category (if you already have categories) in the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt;  <a href="$admin_url/admin2.cgi" target="_blank"><strong>Dir Manager</strong></a>. You will see that all link listings  listed in your categories will have an extra clickable link that you  can click that has the descriptive name of the Content Field you just  created in step 1. When this link is clicked a Wysiwyg Editor is opened  where you can add an article with the WYSIWYG Editor. </p>
  <p>To  add a new link listing with an Article click the 'Add Link' button to  add a new link listing in any category. Note that a link listing only  needs a title as this field is the minimum requirement for a link  listing to be created. After clicking the 'Add Link' button to add a  new link listing a popup window will appear. Now specify a title for  the new link listing and click the 'Add Listing' to add the new  listing. After the listing have been added you will be presented with  the option to edit the Content Field you added in Step 1. Click this  option and the WYSIWYG Editor will appear for you to add a new article  that will be associated with the link listing you just added.</p>
</blockquote>
<p><strong>Step 3 - Display Articles on 'More Info' pages of listings. </strong></p>
<blockquote>
  <p>You should now have created a Content Field in step 1 and added an Article in step 2.</p>
  <p>To  display Articles on the 'more info' pages of link listings go to the  <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong></strong> &gt;&gt;  <strong><a href="$admin_url/admin6.cgi?fct=edit_template&amp;template=linkinfo" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&amp;template=linkinfo',900,650);return false;">Link Info</a></strong> (linkinfo.html)</p>
  <p>Now add add <strong>!!Article!!</strong> somewhere inside the 'more info' template or also called the 'link info'  template where we would like the contents of articles to display. Note  that <strong>Article</strong> is the field/key name we specified in  step 1 as the name of the extra content field/key. If you used another  name then use the other name with double exclamation marks on each  side. Save the template after the changes has been made.</p>
  <p>Now  go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin2.cgi" target="_blank"><strong>Dir Manager</strong></a> - find or browse to the  listing you added in step 2 and click the 'Preview' link to view a  preview of the category containing the link where you have also added  an article to it. When viewing/previewing the link in the category,  click the 'More Info' link available with it to view the 'More Info'  page of the link. You will now see the article that you added in 'step  2'. </p>
</blockquote>
<p><strong>Step 4 - Accept Article Submissions with the Wysiwyg Editor (Optional Step) </strong></p>
<blockquote>
  <p>If  you want your visitors to be able to submit articles with the Wysiwyg  Editor when submitting a listing then follow this step. If you don't  want users to be able to submit articles with the Wysiwyg Editor then  you can skip this step. Here we will add the <strong>Wysiwyg Editor </strong>to the <strong>Add URL</strong> and <strong>Modify forms.</strong> Note that this step can only be done if you are using the User Registration System to accept new submissions. This setting is enabled by default with PowerSeek.</p>
  <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; </strong><a href="$admin_url/admin6.cgi?t=3#3" target="_blank"><strong>3. Add URL Templates</strong></a></p>
  <p>Now click to <strong>edit your standard or premium 'Add URL' template</strong> that is used when a user submits a new listing. </p>
  <p>After doing the above the window will open displaying the HTML code of the template for you. When here, click on: <strong>Explanation of Variables Used Inside This Template</strong></p>
  <p>After clicking on '<strong>Explanation of Variables Used Inside This Template</strong>'  scroll down. You will see a table listing the extra fields you have  created and suggested HTML code to use. Copy and paste the suggested  HTML code for the <strong>content field </strong> and place it inside  your standard and/or premium Add URL template(s). This HTML code will  represent the Wysiwyg Editor and will be used to display the Wysiwyg  Editor when a user does a new submission.</p>
  <p>In the  explanation above you should now have added the HTML code to the Add  URL template(s) that is used to provide the Wysiwyg Editor to users  when submitting a new listing. Note that you can add the HTML code for  the Wysiwyg Editor to the Standard and/or Premium Add URL templates. We  will now add the Wysiwyg editor to the 'Modify' templates so that users  can also use the Wysiwyg editor to 'Modify' content fields when  modifying their listings. </p>
  <p> To add the Wysiwyg Editor to the modify forms do the following:<br />
    <br />
    <strong>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; </strong><a href="$admin_url/admin6.cgi?t=3#3" target="_blank"><strong>3. Add URL Templates</strong></a></strong></p>
  <p>Now click on 'Modify/Edit Link Standard' or 'Modify/Edit Link Premium' to edit a modify template.</p>
  <p>After doing the above the window will open that lets you edit the Modify Template. After the window has opened click on: <strong>Explanation of Variables Used Inside This Template</strong></p>
  <p>After clicking on '<strong>Explanation of Variables Used Inside This Template</strong>'  scroll down. You will see a table listing the extra fields you have  created and suggested HTML code to use. Copy and paste the suggested  HTML code for the <strong>content field </strong> and place it inside  your standard and/or premium Modify template(s). This HTML code will  represent the Wysiwyg Editor and will be used to display the Wysiwyg  Editor when a user modifies the content field of an existing listing. </p>
</blockquote>
<p><strong>Notes</strong>:</p>
<blockquote>
  <p>The Wysiwyg Editor in 'Add URL' and 'Modify' forms is not recommended for a Directory where the User Registration System is not in use.</p>
  <p>If you run a Static Directory then you will need to generate the HTML files for your articles to show up.</p>
  <p>The  Wysiwyg editor is a fully functional web editor where you can use any  kind of HTML elements including editing the HTML source code.</p>
  <p>The contents of <strong>Content Fields</strong> can also be displayed in link listings when categories are browsed or  searched. The contents of the Content fields can also be displayed in  the 'Top Hits', 'Whats New', Favorites, Ratings, and Add Comments pages.</p>
  <p>You  can modify the HTML or JavaScript code used for the the Wysiwyg Editor  in the Add URL and Modify Forms to resize it or to alter it's  behavior. <a href="http://www.focalmedia.net/pseekmanual/weditor/default.htm" target="_blank">Instructions for this can be found here.</a></p>
</blockquote>

</body>
</html>
];


}




sub reciprocal
{

$hbox = acs::get_heading_box("$web_url/ic_settings6_long.gif", "Enabling Reciprocal Link Checking and Link Validation", qq[This Wizard explains how to add the ability to check if a submitter placed a reciprocal link to your web site when he/she does a new submission. It also explains how to check if your existing reciprocal link exists on previous links submitted that contained reciprocal links.]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox

<p><strong>What is a reciprocal link?</strong></p>
<p>A reciprocal link is where some one links to your web site in exchange for the link they submit to you.</p>
<p><strong>How it works:</strong></p>
<p>The Reciprocal Link Checker will check if a submitter placed a link to  your web site when he/she does a new submission. You can have this  enabled when visitors submit standard and/or premium links. PowerSeek also comes with a Reciprocal Link Checker where the Reciprocal Link Checker will check if your link still exists on the web site URL that the submitter specified when submitting his/her link. The Reciprocal Link Checker also has functions to send email to users who removed your reciprocal link. This email could contain a message asking the user to place your link back.</p>
<p><strong>Follow the following steps to enable reciprocal        link checking:</strong></p>
<p><strong>Step 1 - Enable the Reciprocal        Link Checker Settings</strong></p>
<blockquote>
  <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi?fct=global_settings" onclick="popup('$admin_url/admin10.cgi?fct=global_settings',900,650);return false;"><strong>Global Engine Settings</strong></a> &gt;&gt; <strong> <a href="$admin_url/admin10.cgi?fct=global_settings#5" onclick="popup('$admin_url/admin10.cgi?fct=global_settings#5',900,650);return false;"><strong>5. New Submission Settings</strong></a></strong></p>
  <p><strong>Look for 3 settings that reads:</strong></p>
  <blockquote>
    <p><strong>Enable the reciprocal link checker for standard          URL's?<br />
    </strong>If you would like to check for a reciprocal link when a visitors submits a          standard link then set this to 'Yes'.</p>
    <p><strong>Enable the reciprocal link checker for premium          URL's?<br />
    </strong>If you would like to check for a reciprocal link when a visitors submits a          premium link then set this to 'Yes'.</p>
    <p><strong>If you answered 'Yes' above then specify the URL          that should be looked for at the submitters web site:<br />
    </strong>On  your submission forms you will need to provide the submitter with HTML  code that he/she can place on his/her web site. This HTML code will  need to include a URL to your web site. Specify that URL in this  setting. The reciprocal link checker will connect to the submitter's web  site and download the page and look for this URL inside the page. The  page it downloads will be the reciprocal link the submitter provides on  the Add URL form.</p>
    <p>&nbsp;</p>
  </blockquote>
</blockquote>
<p><strong>Step 2 - Edit Add URL forms</strong></p>
<blockquote>
  <p>Go  to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt;</strong> <strong><a href="$admin_url/admin6.cgi?t=3#3" target="_blank">3.  Add URL Templates</a></strong>. These are the forms that is displayed to visitors  when they need to enter their link details to do a submission.</p>
  <p>If  you enabled reciprocal link checking for standard links then edit your  standard Add URL form/template. Add the following to the form/template  within the scope of the &lt;FORM&gt; tags of the page:</p>
  <p><strong>Reciprocal  Link: &lt;input type=&quot;text&quot; name=&quot;reciprocal&quot; size=&quot;45&quot;&gt; (This it  the URL on your web site where you have placed a link to us)</strong></p>
  <p>If  you enabled reciprocal link checking when visitors submit a premium  link then edit the Premium Add URL form as well and add the same HTML  code. </p>
  <p>Now you will only be able to accept submissions from        visitors who have placed a link to your web site.</p>
</blockquote>
<p>&nbsp;</p>
<p><strong>Step 3 - Edit Modify forms</strong></p>
<blockquote>
  <p>Go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt;</strong> <strong><a href="$admin_url/admin6.cgi?t=3#3" target="_blank">3.  Add URL Templates</a></strong></p>
  <p>If  you enabled reciprocal link checking for standard links then edit your  standard modify form/template. Add the following to the form/template  within the scope of the &lt;FORM&gt; tags of the page:</p>
  <p><strong>Reciprocal  Link: &lt;input name=&quot;reciprocal&quot; type=&quot;text&quot; value=&quot;!!modify_recip!!&quot;  size=&quot;45&quot;&gt; (This it the URL on your web site where you have placed a  link to us)</strong></p>
  <p>If you enabled reciprocal link  checking when visitors submit a premium link then edit the Premium  Modify form as well and add the same HTML code.</p>
  <p>&nbsp;</p>
</blockquote>
<p><strong>Reciprocal Link Validation</strong></p>
<blockquote>
  <p>Powerseek  also comes with a 'Reciprocal Link Checker/Validator' plugin that will  check that your link is still available on web sites that placed a link  to your own site when they did a submission. This plugin will go  through all links that has a reciprocal link and check that your link  is still available. After it checked all reciprocal links it will  provide you with options to email link owners where your reciprocal  link was not found anymore. Also included in the options provided to  you is an option to remove sites from the Index where your reciprocal  link could not be found. </p>
  <p>The Reciprocal link  checker will also keep track of the times when it checked links for  your back link. You can for example send link owners a warning if your  link has been removed. If you checked it the third time in 3 weeks for  example and your link is still not back (even after sending email to  the user with the built-in mailer function) then you can remove the  user's link from the Index.</p>
  <p>The plugin can be found in the <strong><a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a></strong> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank">Advertisement Plugins</a> &gt;&gt; <a href="$admin_url/p_recip.cgi" onclick="popup('$admin_url/p_recip.cgi',900,650);return false;"><strong>Reciprocal Link Checker</strong></a></strong></p>
</blockquote>
</body>
</html>
];


}





sub extrafields
{

$hbox = acs::get_heading_box("$web_url/ic_key.gif", "How to Add Extra Fields", qq[This Wizard explains how to add extra fields to link listings. These fields can contain phone numbers, addresses, articles, files (that can be uploaded), videos, images, etc.]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox
<p><strong>What are extra fields?</strong></p>
<p>Extra fields/keys allows you to add additional fields for your <strong>link  listings</strong>. You can have up to 40 extra fields/keys. These fields can  contain <strong>phone numbers, addresses, articles, files</strong> (that can be  uploaded),<strong> videos, images, </strong>etc. Note that specialized searches may also  be created in regards to extra fields to only search extra fields or to  create price range searches for example. </p>
<p><strong>Step 1 - Add Extra Fields</strong></p>
<blockquote>
  <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <strong><a href="$admin_url/admin37.cgi" onclick="popup('$admin_url/admin37.cgi',900,650, 'fieldkey');return false;">Extra        Fields/Keys </a></strong></p>
  <p>Click the 'Add New Extra Field' button.</p>
  <p>From the drop down menu choose 'Character Field'.</p>
  <p>Specify a name for the extra field and a Descriptive Name.</p>
  <p>Then click on 'Next'.</p>
  <p>Now specify values for the various options asked and click the 'Add Field/Key' button.</p>
</blockquote>
<p><strong>Step 2 - Display Extra Field with link listings and let users provide values for the extra fields when doing a new submission</strong></p>
<blockquote>
  <p>Now the extra field has been created. To display the extra field with link listings and to let people doing new submissions specify values for this field, click the 'Implementation' link next to the extra field you added in Step 1 and follow the instructions displayed to you.</p>
</blockquote>
<p><strong>Notes: </strong></p>
<ul>
  <li>
    <p>When you click the 'Implementation Link' all possible scenarios where you can display extra fields with links are covered. In reality you will probably not want to display the extra fields everywhere.</p>
  </li>
  <li>
    <p>Adding an extra <strong>Upload Field</strong> or an <strong>Extra Content </strong>field involves the same process as explained in Step 1. The implementation will be slightly different and this will be explained when you click the 'Implementation Link'.</p>
  </li>
</ul>



</body>
</html>
];



}


sub targetads
{

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", " How to target Advertisements or Banners at specific categories", qq[This Wizard explains how to target Text/HTML based Advertisements or Banner Advertisements at specific categories.]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox

<p><strong>How to target Advertisements at specific categories</strong>:</p>
<blockquote>
  <p><strong>Step 1 - Create an Advert Group</strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a></strong> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank"><strong>Advertisement Plugins</strong></a> &gt;&gt;<a href="$admin_url/p_tadd.cgi" onclick="popup('$admin_url/p_tadd.cgi',900,650);return false;"><strong>Text/HTML Ad Manager</strong></a> - Click on the 'Add New Advert Group' button. Then choose and specify a name for the 'Advert Group' and click on the 'Add New Advert Group' button. </p>
    <p>A new Advert Group will now be added. Choose 'Add/Edit/Delete Adverts of Group' from the drop down menu and click on the 'Go' button.<br>
      <br>
      Now click on the 'Add New Advert' button. Then specify a name for the Advert and specify it's text or HTML code and click the 'Add New Advert' button. </p>
    <p>Continue adding adverts that you would like to have rotated in the Advert Group you have created.</p>
  </blockquote>
  <p><strong>Step 2 - Edit Category Template to Include Adverts to be targeted at categories</strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong></strong> &gt;&gt; Click on: <a tiptitle="This template is used when displaying link listings in directories/categories." href="$admin_url/admin6.cgi?fct=edit_template&template=defdir" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',900,650);return false;"><strong>Main Category/Directory</strong></a> and add the word %%bannerslot1%% to the template where you want the Adverts rotated in the <strong>Advert Group </strong>you created in Step 1 above.</p>
  </blockquote>
  <p><strong>Step 3 - Targeting Adverts at Categories</strong></p>
  <blockquote>
    <p>Now go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt;</strong> <a href="$admin_url/admin2.cgi" target="_blank"><strong>Dir Manager</strong></a> &gt;&gt; There will be an <strong>Adverts</strong> column with the word 'None' displayed next to each category. Click on 'None' next to a category where you would like to rotate Adverts in the <strong>Advert Group</strong> you created in Step 1. Once clicked a popup window will open. You can now select the <strong>Advert Group</strong> you created in Step 1 to be rotated in the place of the word %%bannerslot1%% you placed inside the category template in Step 2.</p>
  </blockquote>
  <p><strong>Notes:</strong></p>
  <ul>
    <li>
      <p>You can target up to 5 <strong>Advert Groups</strong> inside categories by using %%bannerslot1%%, %%bannerslot2%%, %%bannerslot3%%, %%bannerslot4%% and %%bannerslot5%% inside the <a tiptitle="This template is used when displaying link listings in directories/categories." href="$admin_url/admin6.cgi?fct=edit_template&template=defdir" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',900,650);return false;"><strong>Main Category/Directory</strong></a> template.</p>
    </li>
    <li>
      <p>You can also Target Advert Groups with the use of <strong><a href="$admin_url/admin27.cgi" onclick="popup('$admin_url/admin27.cgi',900,650);return false;">Custom Category/Directory Template Sets</a></strong> with %%bannerslot1%%, %%bannerslot2%%, %%bannerslot3%%, %%bannerslot4%% and %%bannerslot5%%.</p>
    </li>
    <li>
      <p>This targeting functionality is only valid inside the <a tiptitle="This template is used when displaying link listings in directories/categories." href="$admin_url/admin6.cgi?fct=edit_template&template=defdir" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',900,650);return false;"><strong>Main Category/Directory</strong></a> template of PowerSeek. If you want to display Adverts in other PowerSeek templates or external web pages then go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a></strong> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank"><strong>Advertisement Plugins</strong></a> &gt;&gt;<a href="$admin_url/p_tadd.cgi" onclick="popup('$admin_url/p_tadd.cgi',900,650);return false;"><strong>Text/HTML Ad Manager</strong></a> &gt;&gt; Choose the Advert Group and select: 'Get HTML Code for Use on Other Pages' from the drop down menu. Then press the 'Go' button and you will be provided with HTML code that you can place inside any other PowerSeek templates or External Web Pages to rotate Adverts from the Advert Group.</p>
    </li>
  </ul>
</blockquote>
<p><strong>How to target Banners at specific categories</strong>:</p>
<blockquote>
  <p><strong>Step 1 - Create a Banner Group</strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a></strong> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank"><strong>Advertisement Plugins</strong></a> &gt;&gt;<a href="$admin_url/admin29.cgi" onclick="popup('$admin_url/admin29.cgi',900,650);return false;"><strong> Banner Ad Manager</strong></a><a href="$admin_url/p_tadd.cgi" onclick="popup('$admin_url/p_tadd.cgi',900,650);return false;"></a> - Click on the 'Add New Banner Group' button. Then choose and specify a name for the 'Banner Group' and click on the 'Add New Banner Group' button. </p>
    <p>A new Banner Group will now be added. Choose 'Add/Edit/Delete Banners of Group' from the drop down menu and click on the 'Go' button.<br>
      <br>
      Now click on the 'Add New Banner' button. Then specify a name for the Banner and upload a banner image  or specify a URL path to the banner image.</p>
    <p>Continue adding banners that you would like to have rotated in the Banner Group you have created.</p>
  </blockquote>
  <p><strong>Step 2 - Edit Category Template to Include Banners to be targeted at categories</strong></p>
  <blockquote>
    <p>Go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong></strong> &gt;&gt; Click on: <a tiptitle="This template is used when displaying link listings in directories/categories." href="$admin_url/admin6.cgi?fct=edit_template&template=defdir" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',900,650);return false;"><strong>Main Category/Directory</strong></a> and add the word %%bannerslot1%% to the template where you want the Banners rotated in the <strong>Banner Group </strong>you created in Step 1 above.</p>
  </blockquote>
  <p><strong>Step 3 - Targeting Banners at Categories</strong></p>
  <blockquote>
    <p>Now go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt;</strong> <a href="$admin_url/admin2.cgi" target="_blank"><strong>Dir Manager</strong></a> &gt;&gt; There will be an <strong>Adverts</strong> column with the word 'None' displayed next to each category. Click on 'None' next to a category where you would like to rotate Banners in the <strong>Banner Group</strong> you created in Step 1. Once clicked a popup window will open. You can now select the <strong>Banner Group</strong> you created in Step 1 to be rotated in the place of the word %%bannerslot1%% you placed inside the category template in Step 2.</p>
  </blockquote>
  <p><strong>Notes:</strong></p>
  <ul>
    <li>
      <p>You can target up to 5 <strong>Banner Groups</strong> inside categories by using %%bannerslot1%%, %%bannerslot2%%, %%bannerslot3%%, %%bannerslot4%% and %%bannerslot5%% inside the <a tiptitle="This template is used when displaying link listings in directories/categories." href="$admin_url/admin6.cgi?fct=edit_template&template=defdir" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',900,650);return false;"><strong>Main Category/Directory</strong></a> template.</p>
    </li>
    <li>
      <p>You can also Target Banner Groups with the use of <strong><a href="$admin_url/admin27.cgi" onclick="popup('$admin_url/admin27.cgi',900,650);return false;">Custom Category/Directory Template Sets</a></strong> with %%bannerslot1%%, %%bannerslot2%%, %%bannerslot3%%, %%bannerslot4%% and %%bannerslot5%%.</p>
    </li>
    <li>
      <p>This targeting functionality is only valid inside the <a tiptitle="This template is used when displaying link listings in directories/categories." href="$admin_url/admin6.cgi?fct=edit_template&template=defdir" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=defdir',900,650);return false;"><strong>Main Category/Directory</strong></a> template of PowerSeek. If you want to display Banners in other PowerSeek templates or external web pages then go to the <a href="$admin_url/admin.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a></strong> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank"><strong>Advertisement Plugins</strong></a> &gt;&gt; <a href="$admin_url/admin29.cgi" onclick="popup('$admin_url/admin29.cgi',900,650);return false;"><strong>Banner Ad Manager</strong></a> &gt;&gt; Choose the Banner Group and select: 'Get HTML Code for Use on Other Pages' from the drop down menu. Then press the 'Go' button and you will be provided with HTML code that you can place inside any other PowerSeek templates or External Web Pages to rotate Banners from the Banner Group.</p>
    </li>
  </ul>
</blockquote>

</body>
</html>
];



}



sub customcats
{

$hbox = acs::get_heading_box("$web_url/ic_folders.gif", "How to give certain categories it's own look and feel with Custom Category templates", qq[This Wizard explains how to create and assign custom category template sets to specified categories. This gives you the ability to give specified categories and the links residing in them a completely different look and feel. The 'More Info' or 'Link Info' pages for links listed in these categories can also have an original or different look and feel.]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox

<p><strong>Step 1 - How to create a 'Custom Category Template' set</strong></p>
<blockquote>
  <p>To create a custom category template set, go to the  <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt;</strong> <strong><strong><a href="$admin_url/admin6.cgi?t=1#1">1. Default Category/Directory Templates</a></strong></strong> &gt;&gt; <strong><a href="$admin_url/admin27.cgi" onclick="popup('$admin_url/admin27.cgi',900,650);return false;">Create or Edit Custom   Category/Directory Template Sets </a></strong> - A popup window will appear. Click on the 'Add New Category/Directory Template'. </p>
  <p>You will now have to specify a name for this 'Custom Category Template' set. You will also now see various boxes with HTML code representing the templates used to display categories and the links within them. The HTML code displayed here is the HTML code used for categories by default. (It comes from the templates used in categories by default) You can copy and paste the HTML code available for the templates into your Web Editor to edit or change aspects of the templates or change the look and feel of the templates. Once you changed aspects of the templates you can copy and paste it back into the boxes containing the HTML code.</p>
  <p>After changing aspects of the HTML code for the various templates, you can click the 'Add New Template Set' button to create the 'Custom Category Template' set.</p>
</blockquote>
<p><strong>Step 2 - Assigning the 'Custom Category Template' set to categories:</strong></p>
<blockquote>
  <p>Go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin2.cgi" target="_blank">Dir Manager</a></strong>. Now click on any 'Default' link next to any category. (The 'Default' link will be displayed under the 'Template' column). After doing this a popup Window will appear where you can select and assign the 'Custom Category Template Set' that you created in <strong>Step 1.</strong></p>
</blockquote>
<p><strong>Notes:</strong></p>
<ul>
  <li>
    <p>You can create as many 'Custom Category Template Sets' as you require.</p>
  </li>
  <li>
    <p>Link style templates of the 'Custom Category Template Sets' can for example be modified/changed so  links, displays extra fields for a specific category or categories. <a href="$admin_url/help.cgi?fct=user_fields" target="_blank">You can find out more about what extra fields does here.</a></p>
  </li>
  <li>
    <p>'More Info' or 'Link Info' pages of links  can be modified/changed so that extra information from extra fields are displayed on the 'More Info' pages in specific categories. You can for example have a 'Video' category where the 'More Info' pages of links inside this category displays Videos. In this instance you could create a 'Custom Category Template' set for the 'Video' category where the 'More Info' templates of this 'Custom Category Template' set displays videos. <a href="$admin_url/help.cgi?fct=user_fields" target="_blank">You can find out more about what extra fields does here.</a> (You can create extra upload fields with extra fields as well to store files like videos for example)</p>
  </li>
</ul>
<blockquote>
  <p>&nbsp;</p>
</blockquote>

</body>
</html>
];

}





sub premlinks
{


$hbox = acs::get_heading_box("$web_url/ic_premium.gif", "How to configure and change the look and feel of premium links", qq[This Wizard explains how to change premium link configurations and how to change the look and feel of premium links so that they look differently than standard links.]);


$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>
</head>
<body>
$hbox

<p><strong>Step 1 - How to Add a Premium Link</strong></p>
<blockquote>
  <p>Premium links are links that are always displayed first before any other link listings in      any category. </p>
  <p>You can add premium links by clicking the 'Add Link' button when in the <a href="$admin_url/admin2.cgi" target="_blank"><strong>Dir Manager</strong></a> and residing in any category. When adding a link, assign a value in the <strong>Premium  Position field</strong> to make it a premium link. You can provide any value here. If you have more than one premium link in the same  category, the premium link values will determine which premium links  are displayed first. The premium link with the highest value (number)  will be displayed first and the premium link with the second highest  value will be displayed second, etc. You can also add a <strong>Premium Expiry Date:</strong>. If there is an expiry date then the Premium link will expire and turn into a standard link if this date is reached. If a link has  no expiry date (if the Premium Expiry Date is blank) then the Premium link will never expire if the Premium Position field has a value.</p>
  <p><strong>Notes:</strong></p>
  <ul>
    <li>
      <p>You can  change any existing standard links into premium links by editing  any standard links and assigning Premium Position values to them and/or Premium Expiry Dates.</p>
    </li>
    <li>
      <p>If a link has a Premium Position value and has no expiry date set (the expiry date field is left blank) then the Premium link will never expire.</p>
    </li>
    <li>
      <p>If a link has a Premium Position value and has an expiry date set then the link will turn into a standard link if the expiry date has been reached.</p>
    </li>
    <li>
      <p>You can turn a Premium link into a Standard link by removing its Premium Position value and if applicable its Premium Expiry Date.</p>
    </li>
  </ul>
</blockquote>
<p><strong>Step 2 - Configuring Premium Link Settings</strong></p>
<blockquote>
  <p>To configure various settings of Premium links you can go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <a href="$admin_url/admin23.cgi" onclick="popup('$admin_url/admin23.cgi',900,650, 'fieldkey');return false;"><strong>Premium Link Settings</strong></a> - You can also <a href="$admin_url/admin23.cgi" onclick="popup('$admin_url/admin23.cgi',900,650, 'fieldkey');return false;"><strong>Click Here</strong></a> to configure the settings. </p>
  <p><strong>Below are explanations of some of the settings.</strong></p>
  <p><strong>Premium Link Order Form URL:        (URL to your order processor)</strong> - After adding a new premium listing the users will be redirected to the URL (Payment Form)  you supply above to pay for their premium listing. The URL  could be a link to your  order processors payment form that has been set up by you, like 2checkout.com, WorldPay, etc...  To receive credit card payment from users wanting to add a premium listing you could have  an account from 2checkout.com, WorldPay, etc... Set up an order form with them and have users  redirected after adding/submitting their premium listing so that they can pay for the  listing. The premium links/listings that has been added are always listed first in the<strong> <a href="$admin_url/admin2.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/todo.cgi" target="_blank">To Do</a> &gt;&gt; <a href="$admin_url/admin20.cgi" onclick="popup('$admin_url/admin20.cgi',900,650, 'fieldkey');return false;">Approve/Edit New Submissions</a></strong> section and the Premium submitted submissions is also  indicated.</p>
  <p><strong>If you would like to sell        standard listings as well then provide the Order Form URL for standard listings here:</strong> - If you want to accept payment for standard links as well then you could also specify an order form URL here. After users submitted standard links then they will be redirected to the URL of the order form of your order processor.</p>
</blockquote>
<p>&nbsp;</p>
<p><strong>Step 3 - Configuring Email Responses when Premium Links are Submitted</strong></p>
<blockquote>
  <p>You can configure the various auto-responder email messages that is involved when users submit premium links by going to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank">Advertisement Plugins</a></strong> &gt;&gt; <a href="$admin_url/admin23.cgi?fct=prem_main" onclick="popup('$admin_url/admin23.cgi?fct=prem_main',900,650);return false;"><strong>Premium Link Manager</strong></a> &gt;&gt; <strong>Email Customization</strong></p>
</blockquote>
<p>&nbsp;</p>
<p><strong>Step 4 - Configuring the Look and Feel of Premium Link Displays</strong></p>
<blockquote>
  <p><strong>Premium Links inside Categories:</strong></p>
  <blockquote>
    <p>If you would like to change the look and feel of premium links displayed in categories go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong></strong> &gt;&gt; Click on: <a tiptitle="This template reflects the HTML code used when displaying link listings in  									directories/categories. This template is used in combination with the main category/directory template." href="$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem',900,650);return false;"><strong>Premium Links Style</strong></a> - This is the style that defines the look and feel of Premium Links when displayed inside categories to end users.</p>
  </blockquote>
  <p><strong>More Info or also called Link Info pages of Premium Links</strong>:</p>
  <blockquote>
    <p>If you would like to change the look and feel of premium link details displayed on More Info pages then go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=1#1" target="_blank">1. Default Category/Directory Templates</a></strong></strong> &gt;&gt; Click on:<strong> <a href="$admin_url/admin6.cgi?fct=edit_template&template=linkinfop"
    onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=linkinfop',900,650);return false;">Link Info Premium</a></strong> - This is the style that defines the look and feel of Premium Links displayed on More Info or also called Link Info pages of Premium Links.</p>
  </blockquote>
  <p><strong>Premium Links Inside Search Results:</strong></p>
  <blockquote>
    <p>If you would like to change the look and feel of premium links displayed in search results (when users perform searches) then go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=2#2" target="_blank">2. Search Results Templates</a></strong></strong> &gt;&gt; Click on: <a tiptitle="This template reflects the HTML code used when displaying link listings in  									directories/categories. This template is used in combination with the main category/directory template." href="$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc_prem" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem',900,650);return false;"><strong>Premium Links Style</strong></a> - This is the style that defines the look and feel of Premium Links when displayed in search results.</p>
  </blockquote>
  <p><strong>Premium Links displayed in the Whats New section:</strong></p>
  <blockquote>
    <p>If you would like to change the look and feel of premium links displayed when a user clicks Whats New then go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=6#6" target="_blank">6. Whats New Templates</a></strong></strong> &gt;&gt; Click on: <a tiptitle="This template reflects the HTML code used when displaying new premium link listings." href="$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_lists_prem" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=whatsnew_lists_prem',900,650);return false;"><strong>Whats   New Listings Premium Style</strong></a> - This is the style that defines the look and feel of Premium Links when displaying the latest links in the Directory.</p>
  </blockquote>
  <p><strong>Premium Links displayed in the Most Popular section:</strong></p>
  <blockquote>
    <p>If you would like to change the look and feel of premium links displayed when a user clicks Most Popular then go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <strong><a href="$admin_url/admin6.cgi?t=7#7" target="_blank">7. Top Hits Templates</a></strong></strong> &gt;&gt; Click on: <a tiptitle="This template reflects the HTML code used when displaying link listings in  									directories/categories. This template is used in combination with the main category/directory template." href="$admin_url/admin6.cgi?fct=edit_template&template=lsearchres_loc_prem" onclick="popup('$admin_url/admin6.cgi?fct=edit_template&template=tmplsearch_prem',900,650);return false;"><strong>Premium Links Style</strong></a>  - This is the style that defines the look and feel of Premium Links when displaying the most popular links in the Directory.</p>
  </blockquote>
</blockquote>
<p><strong>Notes:</strong></p>
<ul>
  <li>
    <p>If you have many Premium Links then there is a <strong><a href="$admin_url/admin66.cgi" onclick="popup('$admin_url/admin66.cgi',900,650);return false;">Browse/Edit Premium Links</a></strong> function available to browse/review or edit all your Premium links. This function is available from the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank">Advertisement Plugins</a></strong> &gt;&gt; <a href="$admin_url/admin23.cgi?fct=prem_main" onclick="popup('$admin_url/admin23.cgi?fct=prem_main',900,650);return false;"><strong>Premium Link Manager</strong></a> &gt;&gt;<strong><a href="$admin_url/admin66.cgi" onclick="popup('$admin_url/admin66.cgi',900,650);return false;">Browse/Edit Premium Links</a></strong></p>
  </li>
  <li>
    <p>You could easily display extra information (like addresses, photos, etc.) with Premium Links by adding extra fields and only including the extra fields for display with Premium Links by editing the templates as explained in Step 4 above. You can find detailed instructions on creating extra fields in the <a href="http://www.focalmedia.net/pseekmanual/" target="_blank"><strong>PowerSeek documentation</strong></a><strong>.</strong></p>
  </li>
  <li>
    <p>You can send email to all Premium Link Owners by going to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> <strong>&gt;&gt; <a href="$admin_url/plugins.cgi" target="_blank">Plug Ins</a> &gt;&gt; <a href="$admin_url/plugins.cgi#adv" target="_blank">Advertisement Plugins</a></strong> &gt;&gt; <a href="$admin_url/admin23.cgi?fct=prem_main" onclick="popup('$admin_url/admin23.cgi?fct=prem_main',900,650);return false;"><strong>Premium Link Manager</strong></a> &gt;&gt; <strong>Premium Link Email Functions</strong></p>
  </li>
  <li>
    <p>You can configure PowerSeek to display Premium Links first in search results. To do this go to the <a href="$admin_url/admin2.cgi" target="_blank"><strong>PowerSeek Control Panel</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi" target="_blank"><strong>Settings</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi?fct=global_settings" onclick="popup('$admin_url/admin10.cgi?fct=global_settings',900,650);return false;"><strong>Global Engine Setttings</strong></a> &gt;&gt; <a href="$admin_url/admin10.cgi?fct=global_settings#4" onclick="popup('$admin_url/admin10.cgi?fct=global_settings#4',900,650);return false;"><strong>4. Search Settings </strong></a> &gt;&gt; Look for the setting reading: <strong>List Premium first       that matched keywords in Search Results?</strong></p>
  </li>
</ul>

</body>
</html>
];




}


sub start
{
$hbox = acs::get_heading_box("$web_url/ic_fav.gif", "Wizards", qq[Please select a Wizard below.]);

$jspopup_code = acs::get_popupjs;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>

</head>
<body>
$hbox

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD" height="265">
  <tr class="normaltext">
    <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img
        src="$web_url/ics_wiz.gif"><br>
      <img src="$web_url/55.gif" height="1" width="43"></td>
    <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/startup.cgi" onClick="popup('$admin_url/startup.cgi',900,650);return false;"> <strong>Startup Wizard</strong></a><br>
      If you are new to PowerSeek then use the 'Startup Wizard' to get started in the shortest amount of time possible.</td>
  </tr>
  <tr class="normaltext">
    <td width="1%" height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/icm_banner.gif"></td>
    <td width="99%" height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><strong> <a href="$admin_url/startup.cgi?fct=quickfp" onClick="popup('$admin_url/startup.cgi?fct=quickfp',900,650);return false;">Quick Setup for the Front Page of your Directory</a></strong><br>
      The quickest and easiest way to set up the Front Page of your Directory</td>
  </tr>

  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/ics_tmplincl.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=tincludes" onClick="popup('$admin_url/wiz.cgi?fct=tincludes',900,650);return false;"><strong>
    How to use Headers, Footers, Menu Bars, etc. inside templates so that they automatically change throughout all templates </strong></a><br>
    Template Includes are pieces of HTML code that can be included in any template. These pieces of HTML code could be headers, footers, menu bars, etc. It almost works like SSI's (server side includes).
	</td>
  </tr>

  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/icm_premium.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=premlinks" onClick="popup('$admin_url/wiz.cgi?fct=premlinks',900,650);return false;"><strong>How to configure and change the look and feel of premium links</strong></a><br>
    This Wizard explains how to change premium link configurations and how to change the look and feel of premium links so that they look differently than standard links.</td>
  </tr>
  
  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/icm_cat.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=customcats" onClick="popup('$admin_url/wiz.cgi?fct=customcats',900,650);return false;"><strong>How to give certain categories it's own look and feel with Custom Category templates</strong></a><br>
    This Wizard explains how to create and assign custom category template sets to specified categories. This gives you the ability to give specified categories and the links residing in them a completely different look and feel. The 'More Info' or 'Link Info' pages for links listed in these categories can also have an original or different look and feel.</td>
  </tr>
  
  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/icm_banner.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=targetads" onClick="popup('$admin_url/wiz.cgi?fct=targetads',900,650);return false;"><strong>
    How to target Advertisements or Banners at specific categories</strong></a><br>
    This Wizard explains how to target Text/HTML based Advertisements or Banner Advertisements at specific categories.
    </td>
  </tr>

  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/ics_key.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=extrafields" onClick="popup('$admin_url/wiz.cgi?fct=extrafields',900,650);return false;"><strong>
    How to Add Extra Fields</strong></a><br>
    This Wizard explains how to add extra fields to link listings. These fields can contain phone numbers, addresses, articles, files (that can be uploaded), videos, images, etc.
    </td>
  </tr>

  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/icm_recip.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=reciprocal" onClick="popup('$admin_url/wiz.cgi?fct=reciprocal',900,650);return false;"><strong>
    Enabling Reciprocal Link Checking and Link Validation</strong></a><br>
    This Wizard explains how to add the ability to check if a submitter placed a reciprocal link to your web site when he/she does a new submission. It also explains how to 
    check if your existing reciprocal link exists on previous links submitted that contained reciprocal links.
    </td>
  </tr>

  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/ics_texts.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=contentfield" onClick="popup('$admin_url/wiz.cgi?fct=contentfield',900,650);return false;"><strong>
    How to use PowerSeek as a CMS</strong></a><br>
	 How to use PowerSeek as a CMS with extra content fields.
	</td>
  </tr>  

  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/icm_banner2.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/wiz.cgi?fct=gallery" onClick="popup('$admin_url/wiz.cgi?fct=gallery',900,650);return false;"><strong>
    How to build an Image Gallery with PowerSeek</strong></a><br>
	 This Wizard explains how to build an Image Gallery with PowerSeek
	</td>
  </tr>  

  <tr class="normaltext">
    <td height="30" align="center" bgcolor="#FFFFFF"><img src="$web_url/ics_add.gif"></td>
    <td height="65" align="left" bgcolor="#FFFFFF" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><a href="$admin_url/p_addurl.cgi?fct=help" onClick="popup('$admin_url/p_addurl.cgi?fct=help',900,650);return false;"><strong>
    How to have multiple Add URL / Modify Forms for different kinds of submissions</strong></a><br>
	 This Wizard explains how create extra 'Add URL' and 'Modify' forms for the submission of special links or listings. If you have for example a Directory of links and an Article section and you also want people to submit Articles then you would for example use an extra 'Add URL' especially available for the submission of Articles. 
	</td>
  </tr>  


</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
    background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

	
</body>
</html>
];

 
}





####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


