#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use LWP::Simple;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;
use URI::Escape;
use fmparse;
use Time::Local;  

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "get_feed") {&get_feed;}


sub get_feed
{

$url = $q->param('rssurl');
$cid = $q->param('cid');

$contents = get($url);
if (length($contents) < 50)
	{
	&display_error;
	}


##############

acs::htmlencode4;

@xml_items = fmparse::extract_matches_ar($contents, "<item>", "</item>");

$itemnr = @xml_items;

if ($itemnr < 1) { acs::problem_popup("Could not find any feed related data.");  }


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

foreach $item (@xml_items)
	{
	$title = fmparse::extract_matches($item, "<title>", "</title>");
	$description = fmparse::extract_matches($item, "<description>", "</description>");
	$pubDate = fmparse::extract_matches($item, "<pubDate>", "</pubDate>");
	$link = fmparse::extract_matches($item, "<link>", "</link>");
	$datenr = &get_date ($pubDate);

	$title =~ s/<!\[CDATA\[//g; $title =~ s/\]\]>//g;
	$description =~ s/<!\[CDATA\[//g; $description =~ s/\]\]>//g;
	$link =~ s/<!\[CDATA\[//g; $link =~ s/\]\]>//g;

	$title =~ s/'/\\'/g; 
	
		$description =~ s/&lt;/</gi;
		$description =~ s/&gt;/>/gi;
	
	$description =~ s/'/\\'/g; 
	$link =~ s/'/\\'/g; 
	
	
	
	$dontadd = "false";
	if ($q->param('dupcheck') eq "Y")
		{
		$sql = "SELECT lnkid FROM links WHERE url = '$link'";
		$sth = $dbh->prepare($sql);
		if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
		$rows = $sth->rows();
		if ($rows > 0) 
			{
			$dontadd = "true"; 
			$dupitems = $dupitems . qq[<a href="$link" target="_blank">$title</a><BR>$description<br>$pubDate<br><br>];
			}
		}
	
	if ($dontadd ne "true")
		{
		$sql = "INSERT INTO links SET cid = '$cid', title = '$title', description = '$description', url = '$link', urldate = '$datenr'";
		$sth = $dbh->prepare($sql);
		if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
		$imported_items = $imported_items . qq[<a href="$link" target="_blank">$title</a><BR>$description<br>$pubDate<br><br>];
		}
		
	}


$sth->finish;
$dbh->disconnect;


if ($dupitems ne "") { $dupitems = "<b>The following items was not imported as they would create duplicates:</b><BR><BR>$dupitems"; }
if ($imported_items ne "") { $imported_items = "<b>The following items was imported:</b><BR><BR>$imported_items"; }


$URL= $q->param('URL');
$hbox = acs::get_heading_box("$web_url/ic_rss.gif", "Import Complete", qq[<a href="javascript:onClick=window.close()">Close this window.</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Add New Directories</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body onUnload="opener.location.reload(true);">
$hbox
<blockquote><p>$imported_items
$dupitems
</p></blockquote>
</body>
</html>
];


}





sub get_date
{
my ($pdate) = @_;

	($day, $rdate) = split (/,/, $pdate);
	if (substr($rdate, 0, 1) eq " ") { $rdate = substr($rdate, 1, length($rdate) - 1); }
	my @ditems = split (/ /, $rdate);
	$day = $ditems[0];
	$mon = $ditems[1];
	$year = $ditems[2];
	
	if ($mon eq "Jan") { $mon = 0; }
	if ($mon eq "Feb") { $mon = 1; }
	if ($mon eq "Mar") { $mon = 2; }
	if ($mon eq "Apr") { $mon = 3; }
	if ($mon eq "May") { $mon = 4; }
	if ($mon eq "Jun") { $mon = 5; }
	if ($mon eq "Jul") { $mon = 6; }
	if ($mon eq "Aug") { $mon = 7; }
	if ($mon eq "Sep") { $mon = 8; }
	if ($mon eq "Oct") { $mon = 9; }
	if ($mon eq "Nov") { $mon = 10; }
	if ($mon eq "Dec") { $mon = 11; }
	
	

eval { $rettime = timelocal(0,0,0, $day,$mon,$year);  }; #warn $@ if $@;
if ($@ ne "") { $rettime = ""; } 	

return ($rettime);

}



sub display_error
{
$URL= $q->param('URL');
$hbox = acs::get_heading_box("$web_url/ic_rss.gif", "Error", qq[Error connecting to $URL $@ - <a href="" onClick="history.go(-1); return false;">Go Back</a>.]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Add New Directories</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];
exit;
}




sub start
{

$ct = $q->param('ct');
$cid = $q->param('cid');
$rid = $q->param('rid');

$location = acs::get_location_string($ct);


$hbox = acs::get_heading_box("$web_url/ic_rss.gif", "Import RSS Feed Into Category: $location", "Please provide the details below.");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
<form name="form1" method="post" action="">
$hbox
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E1E1E1">
    <tr>
    <td height="25" colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>RSS Feed URL to Import:</strong></td>
  </tr>
  <tr>
    <td width="27%" bgcolor="#FFFFFF" class="normaltext"><strong>RSS Feed URL to Import:</strong></td>
    <td width="73%" bgcolor="#FFFFFF" class="normaltext"><input name="rssurl" type="text" id="rssurl" value="http://" size="80"></td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext"><strong>Do not import items that would create duplicates:</strong></td>
    <td bgcolor="#FFFFFF" class="normaltext"><input name="dupcheck" type="checkbox" id="dupcheck" value="Y" checked>
(Matched against URLs in the PowerSeek database)</td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
    <td bgcolor="#FFFFFF" class="normaltext"><p>
      <input type="submit" class="psbutton" name="Import" id="Import" value="Import">
      <input name="fct" type="hidden" id="fct" value="get_feed">
      <input name="cid" type="hidden" value="$cid">
    </p></td>
  </tr>
</table>
</form>

</body>
</html>
];



}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

