#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;

&get_setup;
fmspm::check_spamb("adrldropd.cgi", "header", "$data_dir");
$q = CGI->new;


################# 

print "Content-type: text/html\n\n";


if ($q->param('cid') eq "")
	{
	exit;
	}
	else ###################################################
	{
	
	$etext = pseek::get_file_contents("$data_dir/addurl2.txt"); 
	@texts = split (/\n/, $etext);
	
	if ($texts[19] eq "")
		{
		$catsel_text = "Please Select a Subcategory if Applicable";
		}
		else
		{
		$catsel_text = $texts[19];
		}
	
	$cid = $q->param('cid'); 
	
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	
	$sql_str = "SELECT * FROM dirs WHERE cid = '$cid'";
	$sth = $dbh->prepare($sql_str);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n $sql_str"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	while ( @row = $sth->fetchrow() )
		{
		$curent_level = $row[1];
		
			for ($ms = 2; $ms < 17; $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$row[$ms] =~ s/'/\\'/g;
					$cat_wsel = $cat_wsel . " (l" . ($ms - 1) . " = '$row[$ms]') AND";
					}
				}
		
		}
	
	chop($cat_wsel); chop($cat_wsel); chop($cat_wsel);
	

	$curent_level++;
	
	
		$sql_str = "SELECT * FROM dirs WHERE level = '$curent_level' AND $cat_wsel ORDER BY shortname";
		#print "--> $sql_str <BR>"; 
		
		$sth = $dbh->prepare($sql_str);
		if ( !defined $dbh ) {die "Cannot connect to mySQL server: $DBI::errstr\n $sql_str"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_str";}
		
		$rows = $sth->rows();
		if ($rows < 1) { print "\n"; exit; }
		
		
		$selrow = $curent_level + 1;
		
		while ( @row = $sth->fetchrow() )
			{
						if ($row[29] < 1)
								{
								$selbox = $selbox . qq[<option value="$row[0]">$row[$selrow]</option>];
								}
			}
		

	$sth->finish;
	$dbh->disconnect;
	
	$newlevel = $q->param('s') + 1;
	$resbox = "result" . $newlevel;
	
	$catname = "cat" . $curent_level;
	
	$curent_level2 = $curent_level; $curent_level2++; 
	
	### cat2 cat3 cat4 etc.
	
	$selbox = qq[<select name="$catname" id="$catname" onchange="xmlhttpPost('$newlevel', '$resbox', '$catname', '$curent_level2');">] . qq[<option value="">$catsel_text</option>] . $selbox . "</select>";
	
		
		$selbox = qq[<table width="100%" cellspacing="0" cellpadding="0"><tr><td height="25" valign="bottom">
		$selbox
		</td></tr></table>
		];
	
	print $selbox; 
	exit;
	}






#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

