#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use htbuild;

&get_setup;
fmspm::check_spamb("dirs.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";

$include_name = $q->param('i');
if ($q->param('i') eq "") { exit; }


for ($ms = 0; $ms < length($q->param('i')); $ms++) 
	{
	$oneletter = substr($q->param('i'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/))
		{
		$error_t = "true";
		}
	}

if ($error_t eq "true")
	{
	print "Invalid Random Include Name";
	exit;
	}



$ifilen = "inclr_" . $include_name . ".dat";
$i_details = &get_file_contents("$data_dir/$ifilen");
	
($ind_det, $link_html, $link_html2) = split (/::inchtml::/, $i_details);
	
@ridet = split (/\n/, $ind_det);

$diz = $ridet[0];
$categories = $ridet[1];
$interval = $ridet[2];
$premonly = $ridet[3];
$cat_inlc = $ridet[4];
$rno_links = $ridet[5];

##########

if ($interval ne "always")
	{
	$timefile = "inclr_" . $include_name . ".tim";
	$time_details = &get_file_contents("$data_dir/$timefile");
	$rnowtime = time();

	if ($time_details eq "")
		{
			open (TF, "> $data_dir/$timefile");
				print TF $rnowtime;
			close (TF);
		}
		else
		{
		
		if ($interval eq "hours6") 	{ $timelaps = "21600"; }
		if ($interval eq "hours12")	{ $timelaps = "43200"; }
		if ($interval eq "day1") 		{ $timelaps = "86400"; }
		if ($interval eq "day3") 		{ $timelaps = "259200"; }
		if ($interval eq "week") 		{ $timelaps = "604800"; }
		if ($interval eq "month") 		{ $timelaps = "2592000"; }			
		
		if ($rnowtime < ($time_details + $timelaps))
			{
				$written_file = &get_file_contents("$data_dir/" . "inclr_" . $include_name . ".phtml");
				print $written_file;
				exit;
			}
			else
			{
				open (TF, "> $data_dir/$timefile");
					print TF $rnowtime;
				close (TF);
			}
		
		}

	}

#################


#Print "--> $diz : $categories : $interval : $premonly <BR><BR>";

if (($categories ne ""))
	{
	$categories =~ s/ //g;
	@all_rnd_cats = split (/,/, $categories);
	foreach $item (@all_rnd_cats)
		{
		if (int($item) > 0)
			{
			$rnd_catstring = $rnd_catstring . " (B.cid = '$item') OR ";
			$catselr = $catselr . " (cid = '$item') OR";
			}
		}
	
	if ($cat_inlc ne "Y")
		{
		chop($rnd_catstring); chop($rnd_catstring); chop($rnd_catstring);
		$rnd_catstring = " AND (" . $rnd_catstring . ")";
		}
		else
		{
		
			if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
			$dbh = DBI->connect($dsn, $db_username, $db_password);
			if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

			chop($catselr); chop($catselr);
			$sth = $dbh->prepare("SELECT * FROM dirs WHERE $catselr");
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";} 

			while ( @row = $sth->fetchrow() ) 
				{
					$crselect = "";
					for ($ms = 2; $ms < 18; $ms++) 
						{
						if ($row[$ms] ne "")
							{
							$crselect = $crselect . " (l" . ($ms - 1) . " = '$row[$ms]') AND";
							}
						}
					
					$crselect = substr($crselect, 0, length($crselect) - 3);
					$crselect = "(" . $crselect . ")";
					$rallsubs = $rallsubs . $crselect . " OR ";
				} 

			$rallsubs = substr($rallsubs, 0, length($rallsubs) - 3);
			
			#print "---> SELECT cid FROM dirs WHERE $rallsubs <BR><BR>";	
			
			$rnd_catstring = "";
			
			$sth = $dbh->prepare("SELECT cid FROM dirs WHERE $rallsubs");
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";} 
			
				while ( @row = $sth->fetchrow() ) 
				{
				$rnd_catstring = $rnd_catstring . " (B.cid = '$row[0]') OR";
				}
			
			chop($rnd_catstring); chop($rnd_catstring);
			$rnd_catstring = " AND (" . $rnd_catstring . ")";
			
			$sth->finish;
			$dbh->disconnect; 
		}
	
	
	
	}
 

############

if ($premonly eq "Y")
	{
	$rnowtime = time();
	$prempar = "AND (((A.premium > '0') AND (A.subs_expire > '$rnowtime')) OR ((A.premium > '0') AND (A.subs_expire = ''))) ";
	}

############

$r_template = "";

############
if ($rno_links eq "") { $rno_links = 10; }

$paramc = $rnd_catstring . ":x:_:" . $prempar . ":x:_:" . $link_html . ":x:_:"  . $link_html2 . ":x:_:" . $rno_links;


($curcat, $pg, $cpg, $rw) = htbuild::get_cat("", "", "", "", "", "rnd", $paramc);

$wrfile = "$data_dir/" . "inclr_" . $include_name . ".phtml";
open (WRT, "> $wrfile");
print WRT $curcat;
close (WRT);

print $curcat;






 


################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

