#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;

&get_setup;
$q = CGI->new;

################# 
if ($q->param('fct') eq "fb_logged_in") { &fb_logged_in; }


######################################

sub fb_logged_in
{

$Fuser_email = $q->param('e');
$Fuser_name = $q->param('n');
$Fresponsetoken = $q->param('t');
$Fuserid = $q->param('i');
$Fuser_firstname = $q->param('fn');
$Fetime = $q->param('et');


########################################################
#### OATH2

eval "use LWP::UserAgent";
if($@)
	{
	$lwp_useragent = "N";
 	}
$@ = "";

##############

eval "use HTTP::Request::Common";
if($@)
	{
	$httprequest = "N";
 	}
$@ = "";

##############

eval "use Crypt::SSLeay";
if($@)
	{
	$cryptssl = "N";
 	}
$@ = "";
	
if (($cryptssl eq "") and ($httprequest eq "") and ($lwp_useragent eq "")) ### If all modules available
{
	$randomnumber = int(rand(999999));  
		print "Content-type: text/html\n\n"; 
		print qq[
		<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
		<html>
		<head>
		<title></title>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
		<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=fb_login2.cgi?aa=$randomnumber&e=$Fuser_email&n=$Fuser_name&t=$Fresponsetoken&i=$Fuserid&fn=$Fuser_firstname&et=$Fetime&fct=fb_logged_in">
		</head>
		<body>
		</body>
		</html>
		];
	exit;
}


#### Continue

$Frealtime = frc4::RC4(frc4::hex2string($Fetime),$password);


### Error checking

($etime, $euser) = split (/::/, $Frealtime);

	if ($euser ne $username)
		{
		&facebook_login_critical_error ("Invalid Facebook Login. Error code: U7MH3237 <a href='rgs_login.cgi'>Please Try Again.</a>");
		}

############

$nowtime = time();
$secondspast = $nowtime - $etime;


if ($secondspast > 300)
	{

	$randomnumber = int(rand(999999));  

		print "Content-type: text/html\n\n"; 
		print qq[
		<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
		<html>
		<head>
		<title></title>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
		<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=rgs_login.cgi?$randomnumber">
		</head>
		<body>
		</body>
		</html>
		];
	exit;
	}

############

if ($Fuser_email eq "")
	{
	&facebook_login_critical_error ("Invalid Facebook Login. Error code: EMMH88337 <a href='rgs_login.cgi'>Please Try Again.</a>");
	}

if ($Fuser_name eq "")
	{
	&facebook_login_critical_error ("Invalid Facebook Login. Error code: UN83244487 <a href='rgs_login.cgi'>Please Try Again.</a>");
	}

if ($Fresponsetoken eq "")
	{
	&facebook_login_critical_error ("Invalid Facebook Login. Error code: FT82100872 <a href='rgs_login.cgi'>Please Try Again.</a>");
	}

if ($Fuserid eq "")
	{
	&facebook_login_critical_error ("Invalid Facebook Login. Error code: FU33210087 <a href='rgs_login.cgi'>Please Try Again.</a>");
	}

if ($Fuser_firstname eq "")
	{
	&facebook_login_critical_error ("Invalid Facebook Login. Error code: FFN3323087 <a href='rgs_login.cgi'>Please Try Again.</a>");
	}


#################################

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }   

$sth = $dbh->prepare("SELECT * FROM lnkusers WHERE fbid = '$Fuserid' AND rgsemail = '$Fuser_email'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}  
$rows = $sth->rows();

if ($rows < 1) 
	{
		$initial = substr($Fuser_name, 0, 1);

		@tmpn = split (/ /, $Fuser_name);
		
		$cntr = 0;
		foreach $item (@tmpn)
			{
			if ($cntr > 0)
				{
				$surname = $surname . $item;
				}
			$cntr++;
			}
		
		$pusername = $initial . $surname;
		$pusername = lc($pusername);
		$pusername = $pusername . int(rand(100));
		$pusername =~ s/'//g; 
		
		$passed_user  = $pusername;
		
		$pusername = $dbh->quote($pusername);
		
		####################

		@letters1 = ("a", "e", "i", "o", "u", "y", "b", "c", "d", "f", "g", "h", "j", "k", "l", "m", "n", "p", "q", "r", "s", "t", "v", "w", "x", "z", "1", "2", "3", "4", "5", "6", "7", "8", "9");
		for ($ms = 0; $ms < 5; $ms++) 
			{
			$rand1 = rand(35);
			$gpassword = $gpassword . $letters1[$rand1];
			}
		
		#######################
		
		$Fuser_name = $dbh->quote($Fuser_name);
		$Fuser_email = $dbh->quote($Fuser_email);		
		
		$sth = $dbh->prepare("INSERT INTO lnkusers SET rgsuser = $pusername,
																	  rgspass = '$gpassword',
																	  rgsname = $Fuser_name,
																	  rgsemail = $Fuser_email,
																	  activated = 'Y',
																	  fbid = '$Fuserid'
																	  ");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") { die "SQL Syntax Error: $serror \n From: $sql"; }

			$thecookie1 = $q->cookie(-name=>'cpuser',
						    					  -value=>$passed_user,
						    					  -expires=>'+24h',
						    					  -path=>'/');
			
			$thecookie2 = $q->cookie(	-name=>'cppass',
						    						-value=>$gpassword,
						    						-expires=>'+24h',
						    						-path=>'/');
			
			print $q->header(-cookie=>[$thecookie1, $thecookie2]);
		
			print qq[<html>
						<head>
						<title></title>
						<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_cp.cgi">
						</head>
						<body>
						</body>
						</html>
				  		];

			$sth->finish;
			$dbh->disconnect;
				  		
			exit;		

	}
	else ### LOGIN WITH EXISTING DETAILS
	{
			while ( @row = $sth->fetchrow() )
				{
				$rgsuser = $row[1];
				$rgspass = $row[2];
				}

			$thecookie1 = $q->cookie(-name=>'cpuser',
						    					  -value=>$rgsuser,
						    					  -expires=>'+24h',
						    					  -path=>'/');
			
			$thecookie2 = $q->cookie(	-name=>'cppass',
						    						-value=>$rgspass,
						    						-expires=>'+24h',
						    						-path=>'/');
			
			print $q->header(-cookie=>[$thecookie1, $thecookie2]);
		
			print qq[<html>
						<head>
						<title></title>
						<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_cp.cgi">
						</head>
						<body>
						</body>
						</html>
				  		];
			
			$sth->finish;
			$dbh->disconnect;
			
			exit;		
				
	}


}




sub facebook_login_critical_error
{

my ($errtext) = @_;

$hbox = pseek::get_heading_box("$web_url/ic_alert.gif", "Critical Error", $errtext);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reviews</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>

<br><br><br>
<table width="50%" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td>$hbox</td>
  </tr>
</table>
<br><br><br>

</body>
</html>
];

exit; 
}





#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

