#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use fms_acs;

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

&get_setup;
$q = CGI->new;

$default_permissions = 0777;  ### DEFAULT PERMISSIONS THAT IS USED FOR DATA FILES IN DATA DIRECTORY

#####
#$setupcrit = &get_setup;
#($data_dir, $web_url, $script_url, $username, $password, $webroot) = split (/\t/, $setupcrit);
#####

fms_acs::check_access($username, $password, $q->param('username'), $q->param('password'));

($template, $popup) = fms_acs::gtemplate("ctl");



##################################################################################

if ($q->param('fct') eq "mysearch") {&mysearch;}

print "Content-type: text/html\n\n";

#################################################################################

if ($q->param('fct') eq "stats") {&stats; exit;}
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "what_search") {&what_search;}
if ($q->param('fct') eq "what_search1") {&what_search1;}
if ($q->param('fct') eq "what_search2") {&what_search2;}
if ($q->param('fct') eq "save_dirs") {&save_dirs;}
if ($q->param('fct') eq "search_settings") {&search_settings;}
if ($q->param('fct') eq "save_ss") {&save_ss;}
if ($q->param('fct') eq "html_code") {&html_code;}
if ($q->param('fct') eq "upgrade") {&tmplup;}
if ($q->param('fct') eq "templates") {&template_scr;}
if ($q->param('fct') eq "template_edit") {&template_edit;}
if ($q->param('fct') eq "template_editw") {&template_edit;}
if ($q->param('fct') eq "save_template") {&save_template;}
if ($q->param('fct') eq "save_dirs2") {&save_dirs2;}
if ($q->param('fct') eq "prev_template") {&prev_template;}
if ($q->param('fct') eq "save_setup") {&save_setup;}


#################################################################################

sub prev_template
{

if (($q->param('template') eq "main_layout.html") or ($q->param('template') eq "listings.html"))
	{

$hbox = fms_acs::get_heading_box("$web_url/fms_ic_template.gif", "Provide a keyword to search for:", qq[
<form method="POST" action="$script_url/fms_fmsearch.cgi"><p align="center"><input type="text" name="keywords" size="34">
<input    type="submit" value="Search" name="B1"> <a href="$script_url/fms_advanced.cgi" target="_blank"><strong>Advanced </strong></a> </p>
</form>
]);

print qq[

<html>

<head>
<title>FM SiteSearch Pro</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}



.verd
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 10px;
	line-height: 18px;
}


p
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}

.normaltext
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}


.blanktext
{ color: #FFFFFF;
}


.popup
{
COLOR: #0000FF;
CURSOR: help;
TEXT-DECORATION: none
}
</style>
</head>
<body>
$hbox
</body>
</html>
];

	}

	elsif ($q->param('template') eq "preferences_saved.html")
	{
print qq[

<html>
<head>
<title>FocalMedia.Net Support</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/fms_prefs.cgi?fct=save&results=10&new_window=Yes">
</head>

<body bgcolor="#000095" topmargin="0" leftmargin="0">
</body>
</html>

];
	
	}
	elsif (($q->param('template') eq "layout.html") or ($q->param('template') eq "advanced.html"))
	{
print qq[

<html>

<head>
<title>FocalMedia.Net Support</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/fms_advanced.cgi">
</head>

<body bgcolor="#000095" topmargin="0" leftmargin="0">
</body>
</html>

];
	
	}
	elsif ($q->param('template') eq "preferences.html") 
	{

print qq[

<html>

<head>
<title>FocalMedia.Net Support</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/fms_prefs.cgi">
</head>

<body bgcolor="#000095" topmargin="0" leftmargin="0">
</body>
</html>

];	
	
	}


}


sub save_dirs2
{

$totalitems = $q->param('totalitems');

### GET SELECTED AND DESELECTED ITEMS
$sel_count = 0;
$dsel_count = 0;

for ($ms = 0; $ms < $totalitems; $ms++)
	{
	$dname = "D" . $ms;
	
	if ($q->param($dname) ne "") ### SELECTED ITEMS
		{
		$sel_list[$sel_count] = $q->param($dname);
		#print "==> S = $sel_list[$sel_count]<BR>";
		
		#######################
		if ($q->param('include') eq "y") ### SELECT SUB DIRECTORIES FOR SEARCH
			{
			$tdirs_crit = "$webroot" . $q->param($dname);
			#print "==> $tdirs_crit<BR>";
			@totalseldirs = &get_total_dirs($tdirs_crit);
				$crcount = 0;
				foreach $ss (@totalseldirs)
					{
					$totalseldirs[$crcount] =~ s/$webroot//g;
					$crcount++;
					}
			
			push(@sel_list, @totalseldirs);
			$itcounter = @totalseldirs; $itcounter = $itcounter - 1;
			$sel_count = $sel_count + $itcounter;
			}
		#####################
		
		$sel_count++;
		}
		else
		{
		$cname = "C" . $ms; ### DESELECTED ITEMS
		$dsel_list[$dsel_count] = $q->param($cname);
		#print "!!==> S = $dsel_list[$dsel_count]<BR>";
		
				#######################
				if ($q->param('exclude') eq "y") ### SELECT SUB DIRECTORIES FOR SEARCH
					{
					$tdirs_crit = "$webroot" . $q->param($cname);
					#print "==> $tdirs_crit<BR>";
					@totalseldirs = &get_total_dirs($tdirs_crit);
						$crcount = 0;
						foreach $ss (@totalseldirs)
							{
							$totalseldirs[$crcount] =~ s/$webroot//g;
							$crcount++;
							}
					
					push(@dsel_list, @totalseldirs);
					$itcounter = @totalseldirs; $itcounter = $itcounter - 1;
					$dsel_count = $dsel_count + $itcounter;
					}
				#####################

		
		$dsel_count++
		}
	}	

$selected_dirs = &get_file_contents("$data_dir/searchloc.dat");
@alldselected = split (/\n/, $selected_dirs);

$allscnt = @alldselected;


### REMOVE DIRS THAT WAS DESELECTED OR NOT SELECTED
$ccount = 0;
foreach $dir_to_be_searched (@alldselected)
	{
	
	$found_dir = "";
		foreach $unselected_dir (@dsel_list)
			{
			#print "U--> $unselected_dir<br>";
			
			if ($unselected_dir eq $dir_to_be_searched)
				{
				$found_dir = "true";
				}
			}
	
	if ($found_dir ne "true")
		{
		$currentdirs[$ccount] = $dir_to_be_searched;
		$ccount++;
		}
	}

### ADD DIRS THAT HAS BEEN SELECTED
$dta_count = 0;

foreach $sel_item (@sel_list)
	{
	$already_present = "";
	
		foreach $curritem (@currentdirs)
			{
			if ($curritem eq $sel_item)
				{
				$already_present = "true";
				}
			}
	
	## ADD DIR IF NOT ALREADY PRESENT
	if ($already_present ne "true")
		{
		push(@currentdirs, $sel_item);
		$dta_count++;
		}
	}

$dvvc = @currentdirs;

if ((length($popup) < 1) and ($dvvc > 1)){&stats("GS");}


open (SEARCHF, "> $data_dir/searchloc.dat");

foreach $item (@currentdirs)
	{
	if ($item ne "/")
		{
		print SEARCHF "$item\n";
		}
	}


if ($q->param('public') eq "yes")
	{
	print SEARCHF "/\n";
	}

close(SEARCHF);

$current_pos = $q->param('current_pos');

&saved_settings("Settings Saved.", "$script_url/fms_admin.cgi?fct=what_search2&lc=$current_pos", "WHAT_TO_SEARCH");

}




sub save_template
{

$tmplfname = $q->param('template');


if ($q->param('wys') ne "Y")
	{

	$template_contents = $q->param('template_contents');
	open (TMPLF, "> $data_dir/$tmplfname");
		print TMPLF $template_contents;
	close (TMPLF);

	&saved_settings("Template Saved.", "$script_url/fms_admin.cgi?fct=templates", "TEMPLATES");
	}
	else
	{

	$template_contents = $q->param('htmlc');


	open (TMPLF, "> $data_dir/$tmplfname");
		print TMPLF $template_contents;
	close (TMPLF);


print qq[
<html>
<head>
<title>Saved</title>
</head>
<body>
<table border="0" cellpadding="3" cellspacing="0" width="100%">
  <tr>
    <td width="3%" valign="top"><img src="$web_url/fms_ic_settings3.gif"></td>
    <td width="97%" valign="top"><font face="Arial" size="4"><strong>Template Saved<br>
    </strong></font><font face="Verdana" size="1">You may now <a
    href="javascript:onClick=window.close()">close</a> this window.</font></td>
  </tr>
</table>
</body>
</html>
];
	}
	

}


#################################################################################



sub template_edit
{


$tname = $q->param('template');

if ($tname eq "main_layout.html")
	{
	$use_of_template = "<b>Search Results Main Layout</b><br>This template is used as a wrapper for the search results page. You can add your own HTML code, graphics and menu bars to this template.";
	$template_contents = &get_file_contents("$data_dir/main_layout.html");
	
	$vars_used = qq[<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="12%" class="normaltext"><strong> !!results!! </strong> </td>
    <td width="88%" class="normaltext"> Indicates the number of matches that was      found. </td>
  </tr>
  <tr>
    <td width="12%" class="normaltext"><strong> !!pages!! </strong> </td>
    <td width="88%" class="normaltext"> Replaced by page navigation links. </td>
  </tr>
  <tr>
    <td width="12%" class="normaltext"><strong> !!next_prev_pages!! </strong> </td>
    <td width="88%" class="normaltext"> Replaced by page navigation links. </td>
  </tr>
  <tr>
    <td width="12%" class="normaltext"><strong> !!searchresults!! </strong> </td>
    <td width="88%" class="normaltext"> Replaced by search results. </td>
  </tr>
  <tr>
    <td width="12%" class="normaltext"><strong> !!keywords!! </strong> </td>
    <td width="88%" class="normaltext"> Replaced by the keywords that was searched      for. </td>
  </tr>
  <tr>
    <td width="12%" class="normaltext"><strong> !!script_url!! </strong> </td>
    <td width="88%" class="normaltext"> Replaced by the URL to the CGI Scripts. </td>
  </tr>
</table>
	];
	}

if ($tname eq "listings.html")
	{
	$use_of_template = "<b>Search Result Listings</b><br>This template is used in conjunction with the main layout template. The search result listings template represents the look and feel of search result listings. You can change the fonts and styles of text in it.";
	$template_contents = &get_file_contents("$data_dir/listings.html");
	
	$vars_used = qq[
	<table border="0" cellpadding="6" cellspacing="0" width="100%">
	  <tr>
	    <td width="11%" align="right" class="normaltext"><strong> !!no!! </strong> </td>
	    <td width="89%" class="normaltext"> Replaced by the number of a search result       match. </td>
	  </tr>
	  <tr>
	    <td width="11%" align="right" class="normaltext"><strong> !!title_with_link!! </strong> </td>
	    <td width="89%" class="normaltext"> Replaced by the title of of a search result       match. (Obtained from path titles) </td>
	  </tr>
	  <tr>
	    <td width="11%" align="right" class="normaltext"><strong> !!description!! </strong> </td>
	    <td width="89%" class="normaltext"> Replaced by the description of a search       result match. </td>
	  </tr>
	  <tr>
	    <td width="11%" align="right" class="normaltext"><strong> !!matching_text!! </strong> </td>
	    <td width="89%" class="normaltext"> Replaced by text that matched the keywords       that was searched for. </td>
	  </tr>
	  <tr>
	    <td width="11%" align="right" class="normaltext"><strong> !!URL!! </strong> </td>
	    <td width="89%" class="normaltext"> Replaced by the URL of a search result       match. </td>
	  </tr>
	  <tr>
	    <td width="11%" align="right" class="normaltext"><strong> !!rgraphic!! </strong> </td>
	    <td width="89%" class="normaltext"> Replaced by a graphic indicating the       relevance of a link that was matched. </td>
	  </tr>
	  <tr>
	    <td width="11%" align="right" class="normaltext"><strong> !!rpercent!! </strong> </td>
	    <td width="89%" class="normaltext"> Replaced by a percentage match of a search       result match. </td>
	  </tr>
	</table>

];

	}

if ($tname eq "layout.html")
	{
	$use_of_template = "<b>Advanced Search and Preferences</b><br>This template is used when a user wants to do an advanced search or when he/she wants to change his/her search preferences.";
	$template_contents = &get_file_contents("$data_dir/layout.html");

	$vars_used = qq[<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="12%" class="normaltext"><strong> !!replacement_data!!</strong></td>
    <td width="88%" class="normaltext"> Replaced by data (for advanced search or      user preferences)</td>
  </tr>
</table>
	];

	}

if ($tname eq "preferences.html")
	{
	$use_of_template = "<b>Search Preferences</b><br>This template is used when in conjunction with layout.html - This is the form displayed to visitors who would like to change their search preferences.";
	$template_contents = &get_file_contents("$data_dir/preferences.html");
	
	$vars_used = qq[<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%" align="center" class="normaltext"> No variables used in this template.</td>
  </tr>
</table>
	];
	}

if ($tname eq "advanced.html")
	{
	$use_of_template = "<b>Advanced Search</b><br>This template is used when in conjunction with layout.html - This form is used when a user would like to do an advanced search. You are also welcome to construct your own .html page for an advanced search option.";
	$template_contents = &get_file_contents("$data_dir/advanced.html");
	
	$vars_used = qq[<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%" align="center" class="normaltext"> No variables used in this template.</td>
  </tr>
</table>];
	}

if ($tname eq "preferences_saved.html")
	{
	$use_of_template = "<b>Search Preferences Saved</b><br>This template is used when in conjunction with layout.html - It is displayed to inform a user that his/her search preferences has been saved.";
	$template_contents = &get_file_contents("$data_dir/preferences_saved.html");
	
	$vars_used = qq[<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%" align="center" class="normaltext"> No variables used in this template.</td>
  </tr>
</table>];
	}




if ($q->param('fct') eq "template_editw") 
{


$template_contents =~ s/&/&amp;/g;
$template_contents =~ s/</&lt;/g;
$template_contents =~ s/>/&gt;/g;

$template_contents =~ s/!!web_url!!/$web_url/gi;

print qq[<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<script language="Javascript" src="$web_url/edt/scripts/innovaeditor.js"></script>
</head>
<body>

<form method="post" action="$script_url/fms_admin.cgi" id="Form1">
<input type="hidden" name="fct" value="save_template">
<input type="hidden" name="template" value="$tname">
<input type="hidden" name="wys" value="Y">
	<textarea id="txtContent" name="htmlc" rows=4 cols=30>
	$template_contents
	</textarea>
<script>
var oEdit1 = new InnovaEditor("oEdit1");
oEdit1.width="100%";
oEdit1.height="96%";
oEdit1.mode="XHTML";
oEdit1.REPLACE("txtContent");
</script>

<input type="submit" value="Save"> <font face="Arial" size="2"><strong>Template: <font color="#0000A0">$tname</font></strong></font>
</form>

</body>
</html>
];


}
else
{


$hbox = fms_acs::get_heading_box("$web_url/fms_ic_template.gif", "Templates", qq[
The templates enables you to completely customize your search results and any FM SiteSearch Pro related pages to the look of your web site.
]);


$tmpledit = <<END_OF_TMPL;

$hbox

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"      bgcolor="#FFFFFF" class="normaltext"><strong> Editing Template:       $tname</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"> $use_of_template</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><span class="blanktext">_</span> </td>
    <td width="99%"></td>
  </tr>
</table>
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr class="normaltext" background="$web_url/fms_bar7.gif">
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"><strong> Copy and paste the HTML code below       into your web editor to customize it.</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF"><form method="POST"      action="$script_url/fms_admin.cgi">
        <div align="center">
          <center>
            <p> <strong> Leave         The Words enclosed by !! intact. These words are replaced by data. </strong> </p>
          </center>
        </div>
        <div align="center">
          <center>
            <p>
              <textarea rows="18" name="template_contents" cols="91"  style="width:98%" >$template_contents</textarea>
            </p>
          </center>
        </div>
        <div align="center">
          <center>
            <p> <strong> &nbsp;&nbsp; <br>
              </strong> You can also manually edit this template. It is located at: <br>
              <strong> $data_dir/
              $tname </strong> </p>
          </center>
        </div>
        <div align="center">
          <center>
            <p>
              <input type="submit" value="     Save     "        name="B1">
              <input type="hidden" name="fct" value="save_template">
              <input type="hidden" name="template"        value="$tname">
            </p>
          </center>
        </div>
      </form></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"      bgcolor="#FFFFFF" class="normaltext"><strong> Variables used in       this template </strong> </td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"> $vars_used </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"      bgcolor="#FFFFFF" class="normaltext"><strong>How to insert &amp; use images</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"><p>Note that when you make use of images  in   templates, you must use a URL link to indicate their locations. <br>
        For example: </p>
      <blockquote>
        <p> <strong> &lt;img     src=&quot;someimage.gif&quot;&gt; 
          
          will not work. </strong> <br>
          &nbsp; <br>
          <strong> You have to indicate the entire URL </strong> <strong> where someimage.gif is     located. For example: </strong> <br>
          &nbsp;&nbsp;&nbsp;&nbsp; <br>
          <strong> &lt;img     src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong> <br>
          &nbsp;&nbsp;&nbsp; <br>
          The <strong> &lt;img </strong> is an HTML tag indicating that you want to insert an image in     the HTML page. The <strong> src= </strong> part indicates that you want to specify the     location of the image to be inserted. Some web editors will support inserting images from     a web url and some won't. If your web editor does not support this, insert the image into     the HTML page like usual and when finished edit the source of the HTML code and manually     insert the URL path's to the images. Ensure that the images are on the server for the URL     path's you specify. </p>
        <blockquote>
          <p> <strong> Example, editing the HTML source code: </strong> </p>
        </blockquote>
        <blockquote>
          <p> <strong> Replace 
            &lt;img       src=&quot;someimage.gif&quot;&gt;
            with <br>
            &lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong> </p>
        </blockquote>
      </blockquote></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>

END_OF_TMPL

$template = fms_acs::insbuttons($template, "TEMPLATES");
$template =~ s/!!controlpanel!!/$tmpledit/g;
print $template;
}


}






sub mysearch
{
$rder = $q->param('Order_ID');
$sr = $q->param('serial');

&write_var("RG", $sr);
print "Location: http://www.focalmedia.net/cgi-bin/regfmsitesearch/rg4.cgi?s=$sr&rder=$rder\n\n";
exit;
}




sub tmplup
{

$tmpledit = <<END_OF_TMPLH;



<form method="POST" action="$script_url/fms_admin.cgi">
  <table width="100%" border="0" cellpadding="6"        cellspacing="1" bordercolorlight="#C0C0C0" bgcolor="#DBDBDB">
              <tr>
                <td height="35" colspan="2" background="$web_url/fms_bar7.gif" bgcolor="#F8D752" class="normaltext"><strong> Register FM SiteSearch Pro</strong></td>
              </tr>
              <tr>
                <td width="30%" bgcolor="#FFFFFF" class="normaltext"><strong> Serial Number: <br>
                  </strong> You should have received this number/code via email. </td>
                <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text"            name="serial" size="38"  value="$rg">
                </td>
              </tr>
              <tr>
                <td width="30%" bgcolor="#FFFFFF" class="normaltext"><strong> Order ID: <br>
                  </strong> This ID will be present in the subject line of one of the emails you received            after registration. It will look something like this: <strong> 246137 </strong> </td>
                <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text"            name="Order_ID" size="38" >
                </td>
              </tr>
              <tr>
                <td width="30%" bgcolor="#FFFFFF" class="normaltext"><strong> Name or Company            Name: </strong> </td>
                <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text"            name="name" size="38" >
                </td>
              </tr>
              <tr>
                <td width="30%" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
                <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="Register" name="B1" >
                <input type="hidden" name="fct" value="mysearch">                </td>
              </tr>
  </table>
</form>

END_OF_TMPLH

$template = fms_acs::insbuttons($template, "HOME");
$template =~ s/!!controlpanel!!/$tmpledit/g;
print $template;

}




sub template_scr
{

$hbox = fms_acs::get_heading_box("$web_url/fms_ic_template.gif", "Templates", qq[
The templates enables you to completely customize your search results and any FM SiteSearch Pro related pages to the look of your web site.
]);



$thelp = <<END_OF_TMPL;

$hbox


<table cellSpacing="1" cellPadding="6" width="100%" bgColor="#E9E9E9" border="0">
  <tr>
    <td width="1%" height="30" bgColor="#FFFFFF" class="normaltext"><p align="center"> <img      src="$web_url/fms_gethtml.gif"> </td>
    <td width="90%" height="80" bgColor="#ffffff" class="normaltext"><strong> 1.      Search Results Main Layout (</strong>main_layout.html<strong>)</strong>
      <blockquote>
        <p> This template is used as a wrapper for the search results        page. You can add your own HTML code, graphics and menu bars to this template.<br>
          <strong> This template is located on        your server/host at:</strong><br>
          <strong> $data_dir/main_layout.html </strong> </p>
      </blockquote>
      <p> <a href="$script_url/fms_admin.cgi?fct=template_edit&amp;template=main_layout.html"> <img      src="$web_url/fms_htmlbut.gif" border="0"></a><a      href="$script_url/fms_admin.cgi?fct=template_editw&amp;template=main_layout.html"      target="_blank"><img src="$web_url/fms_wbut.gif" alt="Wysiwyg Editor" border="0"></a></td>
    <td width="1%" height="80" align="center" bgColor="#FFFFFF" class="normaltext"><a target="_blank"      href="$script_url/fms_admin.cgi?fct=prev_template&amp;template=main_layout.html"> <strong> Preview</strong></a></td>
  </tr>
  <tr>
    <td width="1%" height="30" bgColor="#FFFFFF" class="normaltext"><img src="$web_url/fms_gethtml.gif"></td>
    <td width="90%" height="80" bgColor="#ffffff" class="normaltext"><strong> 2.      Search Result Listings (</strong>listings.html<strong>)</strong>
      <blockquote>
        <p> This template is used in conjunction with the main layout        template. The search result listings template represents the look and feel of search        result listings. You can change the fonts and styles of text in it.<br>
          <strong> This template is located on your server/host at:</strong><br>
          <strong> $data_dir/listings.html</strong></p>
      </blockquote>
    <p> <a href="$script_url/fms_admin.cgi?fct=template_edit&amp;template=listings.html"> <img      src="$web_url/fms_htmlbut.gif" border="0"></a><a      href="$script_url/fms_admin.cgi?fct=template_editw&amp;template=listings.html" target="_blank"><img      src="$web_url/fms_wbut.gif" alt="Wysiwyg Editor" border="0"></a></td>
    <td width="1%" height="80" align="center" bgColor="#FFFFFF" class="normaltext"><a target="_blank"      href="$script_url/fms_admin.cgi?fct=prev_template&amp;template=listings.html"> <strong> Preview</strong></a></td>
  </tr>
  <tr>
    <td width="1%" height="30" bgColor="#FFFFFF" class="normaltext"><img src="$web_url/fms_gethtml.gif"></td>
    <td width="90%" height="80" bgColor="#ffffff" class="normaltext"><strong> 3.      Advanced Search and Preferences (</strong>layout.html<strong>)</strong>
      <blockquote>
        <p> This template is used when a user wants to do an advanced        search or when he/she wants to change his/her search preferences.<br>
          <strong> This template is located on your server/host at:</strong><br>
          <strong> $data_dir/layout.html</strong></p>
      </blockquote>
      <p> <a href="$script_url/fms_admin.cgi?fct=template_edit&amp;template=layout.html"> <img      src="$web_url/fms_htmlbut.gif" border="0"></a><a      href="$script_url/fms_admin.cgi?fct=template_editw&amp;template=layout.html" target="_blank"><img      src="$web_url/fms_wbut.gif" alt="Wysiwyg Editor" border="0"></a></td>
    <td width="1%" height="80" align="center" bgColor="#FFFFFF" class="normaltext"><a target="_blank"      href="$script_url/fms_admin.cgi?fct=prev_template&amp;template=layout.html"> <strong> Preview</strong></a></td>
  </tr>
  <tr>
    <td width="1%" height="30" bgColor="#FFFFFF" class="normaltext"><img src="$web_url/fms_gethtml.gif"></td>
    <td width="90%" height="80" bgColor="#ffffff" class="normaltext"><strong> 4.      Search Preferences (</strong>preferences.html<strong>)</strong>
      <blockquote>
        <p> This template is used when in conjunction with        layout.html - This is the form displayed to visitors who would like to change their search        preferences.<br>
          <strong> This template is located on your server/host at:</strong><br>
          <strong> $data_dir/preferences.html</strong></p>
      </blockquote>
      <p> <a href="$script_url/fms_admin.cgi?fct=template_edit&amp;template=preferences.html"> <img      src="$web_url/fms_htmlbut.gif" border="0"></a><a      href="$script_url/fms_admin.cgi?fct=template_editw&amp;template=preferences.html"      target="_blank"><img src="$web_url/fms_wbut.gif" alt="Wysiwyg Editor" border="0"></a></td>
    <td width="1%" height="80" align="center" bgColor="#FFFFFF" class="normaltext"><a target="_blank"      href="$script_url/fms_admin.cgi?fct=prev_template&amp;template=preferences.html"> <strong> Preview</strong></a></td>
  </tr>
  <tr>
    <td width="1%" height="30" bgColor="#FFFFFF" class="normaltext"><img src="$web_url/fms_gethtml.gif"></td>
    <td width="90%" height="80" bgColor="#ffffff" class="normaltext"><strong> 5.      Advanced Search (</strong>advanced.html<strong>)</strong>
      <blockquote>
        <p> This template is used when in conjunction with        layout.html - This form is used when a user would like to do an advanced search. You are        also welcome to construct your own .html page for an advanced search option.<br>
          <strong> This template is located on your server/host at:</strong><br>
          <strong> $data_dir/advanced.html</strong></p>
      </blockquote>
      <p> <a href="$script_url/fms_admin.cgi?fct=template_edit&amp;template=advanced.html"> <img      src="$web_url/fms_htmlbut.gif" border="0"></a><a      href="$script_url/fms_admin.cgi?fct=template_editw&amp;template=advanced.html" target="_blank"><img      src="$web_url/fms_wbut.gif" alt="Wysiwyg Editor" border="0"></a></td>
    <td width="1%" height="80" align="center" bgColor="#FFFFFF" class="normaltext"><a target="_blank"      href="$script_url/fms_admin.cgi?fct=prev_template&amp;template=advanced.html"> <strong> Preview</strong></a></td>
  </tr>
  <tr>
    <td height="30" bgColor="#FFFFFF" class="normaltext"><img src="$web_url/fms_gethtml.gif"></td>
    <td height="80" bgColor="#ffffff" class="normaltext"><strong> 6.      Search Preferences Saved (</strong>preferences_saved.html<strong>)</strong>
        <blockquote>
          <p> This template is used when in conjunction with        layout.html - It is displayed to inform a user that his/her search preferences has been saved. <br>
              <strong> This template is located on your server/host at:</strong><br>
              <strong> $data_dir/preferences_saved.html</strong></p>
        </blockquote>
      <p> <a href="$script_url/fms_admin.cgi?fct=template_edit&template=preferences_saved.html"> <img      src="$web_url/fms_htmlbut.gif" border="0"></a><a      href="$script_url/fms_admin.cgi?fct=template_editw&template=preferences_saved.html" target="_blank"><img      src="$web_url/fms_wbut.gif" alt="Wysiwyg Editor" border="0"></a></td>
    <td height="80" align="center" bgColor="#FFFFFF" class="normaltext"><a target="_blank"      href="$script_url/fms_admin.cgi?fct=prev_template&template=preferences_saved.html"> <strong> Preview</strong></a></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>

END_OF_TMPL

$template = fms_acs::insbuttons($template, "TEMPLATES");
$template =~ s/!!controlpanel!!/$thelp/g;
print $template;

}





sub html_code
{

if ($use_mysql eq "Yes")
	{
	$searc_scr = "$script_url/fms_fmsearch2.cgi";
	}
	else
	{
	$searc_scr = "$script_url/fms_fmsearch.cgi";
	}


$htmlcode = <<END_OF_HT;

<form method="GET" action="$searc_scr">
  <p><input type="text" name="keywords" size="34"> <input type="submit" value="Search"
  name="B1"> <a href="$script_url/fms_advanced.cgi" target="_blank"><font face="Verdana"
  size="1"><strong>Advanced</strong></font></a></p>
</form>

END_OF_HT



###################

$advanced_htmlcode = <<END_OF_ADV;

<form method="POST" action="$searc_scr">
  <input type="hidden" name="advanced" value="advanced"><p>Keywords: <input type="text"
  name="keywords" size="40"></p>
  <p><input type="checkbox" name="phrase" value="ON" checked>Do phrase matches. Phrases
  matching the order in which you typed keywords above.</p>
  <p><input type="checkbox" name="whole_word" value="ON" checked>Do whole word matching.
  Whole words is a word on it's own - partial words is where a word matches within a word.</p>
  <p><input type="checkbox" name="partial" value="ON" checked>Do partial word matching.</p>
  <p><input type="checkbox" name="and_matches" value="ON" checked>Give extra high relevance
  if all keywords is present on a page. (These matches will be displayed first)</p>
  <p><input type="checkbox" name="spt" value="ON" checked>Search page titles</p>
  <p><input type="checkbox" name="spmd" value="ON" checked>Search page meta descriptions</p>
  <p><input type="checkbox" name="spmk" value="ON" checked>Search page meta keywords</p>
  <p><input type="checkbox" name="spc" value="ON" checked>Search page contents</p>
  <p><input type="checkbox" name="e_phrase" value="ON">Extra high relevance for phrase
  matches</p>
  <p><input type="checkbox" name="e_whole" value="ON">Extra high relevance for whole word
  matches</p>
  <p><input type="submit" value="   Search   " name="B1"></p>
</form>

END_OF_ADV

####################

$selected_dirs = &get_file_contents("$data_dir/searchloc.dat");
@alldselected = split (/\n/, $selected_dirs);

foreach $item (@alldselected)
	{
	if ($item ne "/")
		{
		$spc_code = $spc_code . "<option value=\"$item\">$item - please rename</option>";
		}
	}	

$special_htmlcode = <<END_OF_SP;

<form method="POST" action="$searc_scr">
  <p>Keywords: <input type="text" name="keywords" size="27"> <select name="dir" size="1">
    <option value="All">All</option>
    $spc_code
  </select><input type="submit" value="   Search   " name="B1"></p>
</form>
END_OF_SP



$hbox = fms_acs::get_heading_box("$web_url/fms_ic_newsub.gif", "Get HTML Code", qq[
Place the HTML code listed in the boxes below in your web pages. Feel free to customize it to your liking. See the online documentation for more information.
]);



$paged = <<END_OF_HTMLC;

$hbox

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"      bgcolor="#FFFFFF" class="normaltext"><strong> Do a test search here:</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"> $htmlcode</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"      bgcolor="#FFFFFF" class="normaltext"><strong> Search Box HTML Code</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"><form method="POST"      action="--WEBBOT-SELF--">
        <!--webbot bot="SaveResults" startspan U-File="_private/form_results.txt"        S-Format="TEXT/CSV" S-Label-Fields="TRUE" -->
        <!--webbot bot="SaveResults" endspan -->
        <p>
          <textarea rows="5" name="htmlcode" cols="52"  style="width:98%">$htmlcode</textarea>
        </p>
      </form></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"      bgcolor="#FFFFFF" class="normaltext"><strong>Advanced      Search Box HTML Code</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"><form method="POST" action="--WEBBOT-SELF--">
        <!--webbot bot="SaveResults" startspan U-File="_private/form_results.txt"        S-Format="TEXT/CSV" S-Label-Fields="TRUE" -->
        <!--webbot bot="SaveResults" endspan -->
        <p>
          <textarea rows="9" name="htmlcode" cols="52"  style="width:98%">$advanced_htmlcode</textarea>
        </p>
      </form></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
  <tr>
    <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"      bgcolor="#FFFFFF" class="normaltext"><strong> Specialized Search Box Code</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Specialized      searches enable you to specify directories of your web site that users can search through.      These directories can for example contain web pages on specific topics. With the      specialized search function of FM SiteSearch your visitors are able to limit searches to a      specific directory or which can be referred to as a category or topic.
      <p> Below is the HTML code for directory specific searches. <strong> Open      the HTML code in your web editor and in the 'drop down selection box', rename the path      names to category/topic names. Leave the values of the names in tact. </strong> </p>
      <p> If your public HTML directory contains no sub      directories, then this function won't be available. If you have selected no sub      directories of your public HTML directory to be searched, then this function will also not      be available. Click the 'What to Search' button above to select sub directories to search. </td>
  </tr>
  <tr>
    <td width="100%" valign="top" bgcolor="#FFFFFF"><form method="POST"      action="--WEBBOT-SELF--">
        <!--webbot bot="SaveResults" startspan U-File="_private/form_results.txt"        S-Format="TEXT/CSV" S-Label-Fields="TRUE" -->
        <!--webbot bot="SaveResults" endspan -->
        <p>
          <textarea rows="9" name="htmlcode" cols="52"  style="width:98%">$special_htmlcode</textarea>
        </p>
      </form></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
    <td width="99%"></td>
  </tr>
</table>

END_OF_HTMLC

$template = fms_acs::insbuttons($template, "HTML_CODE");
$template =~ s/!!controlpanel!!/$paged/g;
print $template;
}




sub save_ss
{

$exclude_files = $q->param('exclude_search');
$exclude_files = &remove_spacing($exclude_files);

$extensions = $q->param('extensions');
$extensions = &remove_spacing($extensions);

$kwicon			= $q->param('kwicon');			### Keywords matched icon
$kw_bcolor		= $q->param('kw_bcolor');		### Keywords matched background color
$kw_tcolor		= $q->param('kw_tcolor');		### Keywords matched text color

$dwicon			= $q->param('dwicon');			### Description icon
$d_bcolor		= $q->param('d_bcolor');		### Description background color
$t_tcolor		= $q->param('t_tcolor');		### Description text color

$nr_results		= $q->param('nr_results');		### Results per page
$new_window		= $q->param('new_window');		### Links in new window
$no_match_text	= $q->param('no_match_text');	### No mathing text
$min_keywords	= $q->param('min_keywords');	### Minimum chars in Keywords
$method 			= $q->param('method');			### Minimum chars in Keywords

$nextpage 		= $q->param('nextpage');		### Next page text
$prevpage 		= $q->param('prevpage');		### Previous page text
$sql_method		= $q->param('sql_method');		### Search method

$spamsearch		= $q->param('spamsearch');	### Number of searches to allow per unique IP

#######
     
open (SETTINGS, "> $data_dir/settings.dat");

	print SETTINGS 	$extensions . "\n" .  		#### 0 FILE EXTENSIONS TO SEARCH
							$exclude_files ."\n" .		#### 1 FILES TO EXCLUDE FROM SEARCH
							$kwicon ."\n" .				#### 2 Keywords matched icon
							$kw_bcolor ."\n" .			#### 3 Keywords matched background color
							$kw_tcolor ."\n" . 			#### 4 Keywords matched text color
							$dwicon ."\n" .				#### 5 Description icon
							$d_bcolor ."\n" .				#### 6 Description background color
							$t_tcolor ."\n" .				#### 7 Description text color
							$nr_results . "\n" . 		#### 8 Results per page
							$new_window . "\n" . 		#### 9 Links in new window
							$no_match_text . "\n" . 	#### 10 No mathing text
							$min_keywords . "\n" . 		#### 11 Minimum chars in Keywords
							$method . "\n" . 				#### 12 INDEXING METHOD
							$nextpage . "\n" .   		#### 13 NEXT PAGES TEXT
							$prevpage . "\n" .			#### 14 PREVIOUS PAGES TEXT
							$sql_method . "\n" .			#### 15 MYSQL SEARCH METHOD
							$spamsearch;					#### NR SEARCHES PER IP
							
close (SETTINGS);

#######

&saved_settings("Your settings has been saved.", "$script_url/fms_admin.cgi?fct=search_settings", "SEARCH_SETTINGS");

}






sub search_settings
{

$settings_data = &get_file_contents("$data_dir/settings.dat");

@settings = split (/\n/, $settings_data);

if ($settings[9] eq "Yes")
	{
	$nw_yes = "selected";
	}
	else
	{
	$nw_no = "selected";
	}


if ($settings[12] eq "index")
	{
	$searchindex = "selected";
	}
	else
	{
	$plain = "selected";
	}

if ($settings[15] eq "fulltext")
	{
	$mysql_ftext = "selected";
	}
	else
	{
	$mysql_default = "selected";
	}




$hbox = fms_acs::get_heading_box("$web_url/fms_ic_settings3.gif", "Search Settings", qq[
Set various settings on how your search engine will operate.
]);




$paged = <<END_OF_ST;

$hbox


<form method="POST" action="$script_url/fms_admin.cgi">
  <table border="0" cellpadding="6"    cellspacing="1" width="100%" bgcolor="#DFDFDF">
    <tr>
      <td width="100%" height="35" valign="middle" background="$web_url/fms_bar7.gif"        bgcolor="#FFFFFF" class="normaltext"><strong> Search Method</strong></td>
    </tr>
    <tr>
      <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong> How        would you like to Fm SiteSearch to search your web site: </strong>
        <p>
          <select        name="method" size="1">
            <option value="plain" $plain> Plain - Open files and search through them on the fly </option>
            <option value="index" $searchindex> Search Index - Build a search index and search the index - Fastest </option>
          </select>
        </p>
        <p> <strong> Explanation of the above setting: </strong> </p>
        <p> <strong> Plain - Open files and search through them on the        fly <br>
          </strong> When you use this method, you do not have to build a search index. FM SiteSearch        will just open all files on the fly and search through them. Recommended if your web site        has 200 pages or less. </p>
        <p> <strong> Search Index - Build a search index and search        the index <br>
          </strong> Recommended if you want the fastest searches possible. When you use this method        of searching you will need to index all your files before any searches can take place. All        'data' is indexed into a database or database file especially structured for speed. <strong> Note that you will need to build this index by clicking the 'Build Search Index' button        above before you can search. </strong> If you are not using Mysql this should be        appropriate for approximately 1000 web pages. If you have more than 1000 web pages, you        will need to use Mysql. If you use mysql this setting defaults to the use of a search        index. <strong> See the documentation for more information. <br>
          </strong> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"    background="$web_url/fms_shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
    <tr>
      <td width="100%" height="35" colspan="2" valign="middle" background="$web_url/fms_bar7.gif"        bgcolor="#FFFFFF" class="normaltext"><strong> Blocking Spammers </strong> </td>
    </tr>
    <tr>
      <td width="48%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong> Number        of searches allowed per hour: </strong> <br>
        (You can limit the number of searches you allow on an hourly basis per unique IP address        to avoid/block spammers repeatedly searching for keywords) </td>
      <td width="52%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="spamsearch"        size="6" value="$settings[16]">
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"    background="$web_url/fms_shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
    <tr>
      <td width="100%" height="35" colspan="2" valign="middle" background="$web_url/fms_bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong> File        Search Settings</strong></td>
    </tr>
    <tr>
      <td width="48%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong> File        types to search: <br>
        </strong> Please separate via comma. <br>
        <strong> Example: </strong> .html, .htm, .shtml, .txt, </td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="5"        name="extensions" cols="39">
$settings[0]

</textarea>
      </td>
    </tr>
    <tr>
      <td width="48%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong> File        names which you would like excluded from searches: <br>
        </strong> Please separate via comma. <br>
        <strong> Example: </strong> somefile.html, anotherfile.htm, yetanotherfile.html </td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="5"        name="exclude_search" cols="39">
$settings[1]
</textarea>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"    background="$web_url/fms_shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
    <tr>
      <td width="100%" height="35" colspan="2" valign="middle" background="$web_url/fms_bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong> Search        Listing Settings - </strong> These settings are used for matched listing displays. </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Matched        keywords icon:</strong><br>
        Situated in: $web_url/fms_kicon.gif </td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="kwicon" size="17"        value="$settings[2]">
      </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Background        color of keyword matches in matched descriptions:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="kw_bcolor" size="17"        value="$settings[3]">
      </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Text        color of keyword matches in matched descriptions:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="kw_tcolor" size="17"        value="$settings[4]">
      </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Icon        displayed next to matched link meta description:</strong><br>
        Situated in: $web_url/fms_dicon.gif</td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="dwicon" size="17"        value="$settings[5]">
      </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Background        color of meta description text:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="d_bcolor" size="17"        value="$settings[6]">
        Leave blank if none </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Text        color of of meta description:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="t_tcolor" size="17"        value="$settings[7]">
        Leave blank if none </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> How        many results would you like to display per page:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="nr_results" size="5"        value="$settings[8]">
        User preferences that has been set        will override this setting </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Would        you like a new window to be opened when a user clicks on a matched link listing?</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><select name="new_window" size="1">
          <option value="Yes" $nw_yes> Yes </option>
          <option value="No" $nw_no> No </option>
        </select>
        User preferences that has been set will override        this setting </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Text        when no matches or search results found:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="no_match_text" size="50"        value="$settings[10]">
      </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> Minimum        characters in keywords that is allowed when specifying keywords to search for:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="min_keywords" size="5"        value="$settings[11]">
      </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> 'Next        Page' Text:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="nextpage" size="50"        value="$settings[13]">
      </td>
    </tr>
    <tr>
      <td width="48%" valign="middle" bgcolor="#FFFFFF" class="normaltext"><strong> 'Previous        Page' Text:</strong></td>
      <td width="52%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="prevpage" size="50"        value="$settings[14]">
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"    background="$web_url/fms_shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DFDFDF">
    <tr>
      <td width="100%"        height="35" valign="middle" background="$web_url/fms_bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong> MySQL Settings (Only valid if you use        Mysql - Ignore if you are not using MySQL) </strong> </td>
    </tr>
    <tr>
      <td width="100%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong> How        would you like Mysql to search? </strong>
        <p>
          <select name="sql_method" size="1">
            <option value="normal" $mysql_default> Default SQL </option>
            <option value="fulltext" $mysql_ftext> Full Text Searching </option>
          </select>
        </p>
        <p> <strong> Explanation of the above setting: </strong> </p>
        <p> <strong> Default SQL <br>
          </strong> Slower but more accurate matching. </p>
        <p> <strong> Full Text Searching <br>
          </strong> Faster but less accurate matching. Recommended if you have many thousands of        pages. <strong> <br>
          </strong> &nbsp;&nbsp;&nbsp;&nbsp; </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"    background="$web_url/fms_shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
      <td width="99%"></td>
    </tr>
  </table>
  <p>
    <input type="submit" value="Save All Settings" name="B1">
    <input type="hidden" name="fct" value="save_ss">
  </p>
</form>

END_OF_ST

$template = fms_acs::insbuttons($template, "SEARCH_SETTINGS");
$template =~ s/!!controlpanel!!/$paged/g;
print $template;

}



sub save_setup
{

$w_root = $q->param('webroot');

if ((-e $w_root) < 1)
	{
	print qq[<html>
<head>
<title>FM SiteSearch Pro</title>

<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}

p
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}

.normaltext
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
</style>

</head>
<body>


<p>&nbsp;</p>
<form name="form1" method="post" action="fms_admin.cgi">
  <label></label>
  <table width="80%" border="0" align="center" cellpadding="10"
  cellspacing="1" bgcolor="#EEEEEE">
    <tr>
      <td width="100%" bgcolor="#F8F8F8"><p><strong>Could not complete setup due to the follow: </strong></p></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF"><p>The full server path to your Public HTML directory does not exist.</p>
        <p><strong>Use the back button of your browser to go back. </strong></p></td>
    </tr>
  </table>
</form>
<p>&nbsp;</p>
</body></html>];

	exit;
	}


&write_var ("WEBROOT", $q->param('webroot'));
&write_var ("URLROOT", $q->param('urlroot'));

print qq[
<html>
<head>
<title>FM SiteSearch Pro</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/fms_admin.cgi">
</head>
<body>
</body>
</html>
];
exit;


}




sub start
{

if (($webroot eq "") or ($urlroot eq ""))
	{

#if ((-e "rgs_login.cgi") > 0)
#	{
	
if ((-w "config.cgi") < 1)	
	{
	
print qq[<html>
<head>
<title>FM SiteSearch Pro</title>

<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}

p
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}

.normaltext
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
</style>

</head>
<body>


<p>&nbsp;</p>
<form name="form1" method="post" action="fms_admin.cgi">
  <label></label>
  <table width="80%" border="0" align="center" cellpadding="10"
  cellspacing="1" bgcolor="#EEEEEE">
    <tr>
      <td width="100%" bgcolor="#F8F8F8"><p><strong>FM SiteSearch Pro Setup: </strong></p></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF"><p>FM SiteSearch Pro needs to complete it's setup. At the present moment config.cgi of the PowerSeek installation does not have the permission setting of 777 - To continue please assign the permission setting of 777 to config.cgi of the PowerSeek installation. <strong>After that refresh this page.</strong> </p>
      <ul>
        <li class="normaltext"><strong><a href="fms_admin.cgi">Refresh this page.</a></strong><br>
        </li>
        <li class="normaltext"><a href="./admin/admin.cgi"><strong>Go back to the PowerSeek Control Panel</strong></a></li>
      </ul></td>
    </tr>
  </table>
</form>
<p>&nbsp;</p>
</body></html>];

	exit;
	}
	else
	{
	
	
	if ($webroot eq "")
		{
			foreach $key (keys(%ENV)) 
			{

				if ($key eq "DOCUMENT_ROOT") 
					{
					if ($ENV{$key} ne "")
						{
						$webroot = $ENV{$key};
						}
					}

				}
		}
	
	
	if ($urlroot eq "")
			{
			
			$reffr = $ENV{'HTTP_REFERER'};

			if ($reffr ne "")
				{
				@refitems = split (/\//, $reffr);
				$urlroot = $refitems[2];
				$urlroot = "http://" . $urlroot;
				}

			}
	
	
	print qq[
	
	<html>
	<head>
	<title>FM SiteSearch Pro</title>
	
	<style type="text/css">
	A {COLOR: #0000FF}
	A:visited {COLOR: #0000FF}
	A:active {COLOR: #000000}
	A:hover {COLOR: #000000}
	
	p
	{
		font-family: Arial, Helvetica, sans-serif;
		font-size: 12px;
		line-height: 18px;
	}
	
	.normaltext
	{
		font-family: Arial, Helvetica, sans-serif;
		font-size: 12px;
		line-height: 18px;
	}
	</style>
	
	</head>
	<body>
	<p>&nbsp;</p>
	<form name="form1" method="post" action="fms_admin.cgi">
	  <label></label>
	  <table width="80%" border="0" align="center" cellpadding="10"
	  cellspacing="1" bgcolor="#EEEEEE">
	    <tr>
	      <td colspan="2" bgcolor="#F8F8F8"><p><strong>FM SiteSearch Pro Setup: </strong></p></td>
	    </tr>
	    <tr>
	      <td colspan="2" valign="top" bgcolor="#FFFFFF"><p>FM SiteSearch Pro needs the paths below to complete it's setup. </p></td>
	    </tr>
	    <tr>
	      <td width="30%" valign="top" bgcolor="#FFFFFF"><p>Full server path to the Public HTML Directory:</p></td>
	      <td width="70%" valign="top" bgcolor="#FFFFFF"><input name="webroot" type="text" id="webroot" value="$webroot" size="70"></td>
	    </tr>
	    <tr>
	      <td width="30%" valign="top" bgcolor="#FFFFFF"><p>URL Path to your public HTML Directory:</p></td>
	      <td width="70%" valign="top" bgcolor="#FFFFFF"><input name="urlroot" type="text" id="webroot2" value="$urlroot" size="70"></td>
	    </tr>
	    <tr>
	      <td valign="top" bgcolor="#FFFFFF">&nbsp;</td>
	      <td valign="top" bgcolor="#FFFFFF"><label>
	        <input type="submit" name="Submit" value="Complete Setup">
	        <input name="fct" type="hidden" id="fct" value="save_setup">
	      </label></td>
	    </tr>
	  </table>
	  </form>
	<p>&nbsp;</p>
</body>
</html>

	];
	
	exit;
	
	}
	
	}
	#}


$hbox = fms_acs::get_heading_box("$web_url/fms_homeb.gif", "Welcome!", qq[
You have been logged in. The login will remember you for 24 hours. After 24 hours you will have to login again.
]);


$mitem1 = fms_acs::get_heading_box("$web_url/fms_ic_settings3.gif", 
qq[<a href="$script_url/fms_admin.cgi?fct=search_settings">1. Search Settings</a>], 
qq[You have been logged in. The login will remember you for 24 hours. After 24 hours you will have to login again.]);

$mitem2 = fms_acs::get_heading_box("$web_url/fms_ic_search.gif", 
qq[<a href="$script_url/fms_admin.cgi?fct=what_search">2. Choose What To Search</a>], 
qq[Choose the directories inside your public HTML directory that you would like searched.]);

$mitem3 = fms_acs::get_heading_box("$web_url/fms_ctmpl.gif", 
qq[<a href="$script_url/fms_admin.cgi?fct=templates">3. Templates</a>], 
qq[Displays various statistics about what visitors searched for. See the keywords that has been most searched for. Categorized in a monthly format.]);


	if ($use_mysql eq "Yes")
		{
		$slnk = "$script_url/fms_admin4.cgi?fct=web";
		}
		else
		{
		$slnk = "$script_url/fms_admin3.cgi?fct=web";
		}


$mitem4 = fms_acs::get_heading_box("$web_url/fms_ic_misc.gif", 
qq[<a href="$slnk"
onclick="popup('$slnk',600,600);return false;"
>4.  Build Search Index </a>], 
qq[Build an index that will be used by FM SiteSearch when searching. A search index is used to ensure optimum speed when searching.]);

$mitem5 = fms_acs::get_heading_box("$web_url/fms_ic_newsub.gif", 
qq[<a href="$script_url/fms_admin.cgi?fct=html_code">5. HTML Code</a>], 
qq[Get the 'Search Box' HTML code which you can place on your web pages.]);

$mitem6 = fms_acs::get_heading_box("$web_url/fms_ic_stats.gif", 
qq[<a href="$script_url/fms_admin.cgi?fct=stats">6. Search Statistics</a>], 
qq[Displays various statistics about what visitors searched for. See the keywords that has been most searched for. Categorized in a monthly format.]);



if ($template =~ /unregistered/i)
	{
	$mitem7 = fms_acs::get_heading_box("$web_url/fms_ic_hand.gif", 
	qq[<a href="http://www.focalmedia.net/cgi-bin/fms/fmsearch.cgi?url=register">7. Register/Purchase FM SiteSearch Pro</a>], 
	qq[Upgrade to the commercial version of FM SiteSearch Pro]);

	$rgsi = qq[<img src="$web_url/fms_ic_hand.gif">];
	}


$home = <<END_OF_HOME;

$hbox
$mitem1
$mitem2
$mitem3
$mitem4
$mitem5
$mitem6
$mitem7

END_OF_HOME


$template = fms_acs::insbuttons($template, "HOME");
$template =~ s/!!controlpanel!!/$home/g;

print $template;

}


################################################################################

sub what_search
{


$hbox = fms_acs::get_heading_box("$web_url/fms_ic_search.gif", "Choose Where To Search", qq[
This section allows you to choose what sub directories needs to be searched inside your Public HTML directory.
]);


$hdirs = fms_acs::get_heading_box("$web_url/fms_ic_dir2.gif", 
qq[<a href="$script_url/fms_admin.cgi?fct=what_search1">View Entire Directory Structure</a>],
qq[View the entire directory structure of your Public HTML directory. Recommended for web sites with less than 100 sub directories in the Public HTML directory.]);


$hdirs2 = fms_acs::get_heading_box("$web_url/fms_ic_dirm.gif", 
qq[<a href="$script_url/fms_admin.cgi?fct=what_search2">Direcory Browser</a>],
qq[Click the above link to browse the sub directories of your Public HTML directory to choose what directories is to be searched. Recommended if you have thousands of sub directories in your Public HTML directory.]);



$whats = <<END_OF_WS;

$hbox
$hdirs
$hdirs2

END_OF_WS

$template = fms_acs::insbuttons($template, "WHAT_TO_SEARCH");
$template =~ s/!!controlpanel!!/$whats/g;
print $template;


}





sub what_search2
{

$selected_dirs = &get_file_contents("$data_dir/searchloc.dat");
@seldirs = split (/\n/, $selected_dirs);

$lc = $q->param('lc');

$original_lc = $lc;

if ($lc eq "") 
	{
	@alldirs = &get_total_dirs($webroot);
	@alldirs = sort(@alldirs);
	$current_loc = "Location: Public HTML"; 
	
		foreach $tsel (@seldirs)
			{
			if ($tsel eq "/"){ $rootsel = "checked"; }
			}
	$output_dirs = $output_dirs . "<input type=\"checkbox\" name=\"public\" value=\"yes\" $rootsel><img src=\"$web_url/fms_subdir.gif\" width=\"29\" height=\"11\"><b>Public HTML Directory</b><br>";
	
	}
	else
	{
	$orig_lc = $lc;
	
	@lcitems = split (/\//, $lc);
		
		foreach $lcitem (@lcitems)
			{
			if ($lcitem ne "")
			{
			#print "==> $lcitem <BR>";
			
			$current_i = $current_i . "/$lcitem";
			$locstring = $locstring . " >> <a href=\"$script_url/fms_admin.cgi?fct=what_search2&lc=$current_i\">$lcitem</a> ";
			}
			}
	
	$webroot = "$webroot" . "$lc";
	
	@alldirs = &get_total_dirs($webroot);
	@alldirs = sort(@alldirs);
	$current_loc = "Location: <a href=\"$script_url/fms_admin.cgi?fct=what_search2&lc=\">Public HTML</a> " . $locstring;
	}

$dcount = 0;
foreach $itemd (@alldirs)
	{
	$itemd =~ s/$webroot//g;
	$oitemd = $itemd;
	@tmpa = split (/\//, $itemd);
	$nri = @tmpa;
	
	if ($nri == 2)
		{
		$oitemd = $orig_lc . $oitemd;
		
		@allss = &get_total_dirs($webroot . "$itemd");
		$snr = 0;
		$snr = @allss; $snr = $snr - 1; $itemd =~ s/\///g;
		
		$cname = "D" . $dcount;
		
		$jscb = $jscb . "'$cname',";
		
		### CHECK IF DIRS WHERE SELECTED
		
		$checkedb = "";
		foreach $sdir (@seldirs)
			{
			if ($oitemd eq $sdir)
				{
				$checkedb = "checked";
				}
			}
		
		### KEEP TRACK OF WHAT WAS NOT SELECTED
		$dname = "C" . $dcount;
 		$hstrings = $hstrings . "<input type=\"hidden\" name=\"$dname\" value=\"$oitemd\">";
		
		$dcount++;
		
		if ($snr > 0)
			{
			$output_dirs = $output_dirs . " &nbsp;&nbsp; <input type=\"checkbox\" name=\"$cname\" value=\"$oitemd\" $checkedb><img src=\"$web_url/fms_subdir.gif\" width=\"29\" height=\"11\"> <a href=\"$script_url/fms_admin.cgi?fct=what_search2&lc=$oitemd\">$itemd</a> ($snr)<br>";
			}
			else
			{
			$output_dirs = $output_dirs . " &nbsp;&nbsp; <input type=\"checkbox\" name=\"$cname\" value=\"$oitemd\" $checkedb><img src=\"$web_url/fms_subdir.gif\" width=\"29\" height=\"11\"> $itemd ($snr)<br>";
			}
		
		
		}
	
	}

if ($output_dirs eq "")
	{
	$output_dirs = "<b>No sub directories in this directory.</b> Use the back button of your browser to go back.";
	}


chop($jscb);


$hbox = fms_acs::get_heading_box("$web_url/fms_ic_dirm.gif", "Choose Where To Search", qq[
Please choose the directories that you would like saerched below.
]);


$whats = <<END_OF_WS;

<script LANGUAGE="JavaScript">
<!-- Hide

function checkall(formname,thestate)
	{
	BoxNames=new Array($jscb);
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}
// End Hide -->
</script>

$hbox

<table border="0" cellspacing="1" width="100%" cellpadding="9">
  <tr>
    <td width="907" height="74"><form method="POST" name="select_all"      action="$script_url/fms_admin.cgi">
        <span class="normaltext">$hstrings <b> $current_loc</b></span><br>
          <br>
          <span class="normaltext">$output_dirs</span><BR>
        <div align="center"><center>
          <table border="0" cellpadding="6" cellspacing="1" width="100%"        style="border: 1px solid rgb(223,223,223)" background="$web_url/fms_bbar.gif">
              <tr>
                <td width="3%" valign="top"><p>
                  <input type="checkbox" name="include" value="y">
                </p></td>
                <td width="97%" class="normaltext"><p><strong> Include the sub directories to be            searched of directories selected. <br>
                </strong> Use this option to include all sub directories of your directory selection here            so that they are searched. </p></td>
              </tr>
              <tr>
                <td width="3%" valign="top"><p>
                  <input type="checkbox" name="exclude" value="y">
                </p></td>
                <td width="97%" class="normaltext"><p><strong> Remove sub directories to not be            searched of directories not selected. </strong> <br>
                  Use this option to exclude all sub directories of directories not selected here when            performing searches. </p></td>
              </tr>
              <tr>
                <td width="100%" valign="top" colspan="2"><input type="submit" value="Save" name="B1"> <input type="hidden" name="current_pos" value="$original_lc">
                  <input type="hidden"        name="fct" value="save_dirs2">
                  <input type="hidden" name="totalitems" value="$dcount">                </td>
              </tr>
            </table>
          </center>
        </div>
        <table border="0" cellpadding="0" cellspacing="0" width="100%"        background="$web_url/fms_shadow.gif">
          <tr>
            <td width="1%" bgcolor="#FFFFFF" class="blanktext"> _ </td>
            <td width="99%"></td>
          </tr>
        </table>
        <p><strong> <span class="normaltext">The number of sub directories is displayed next        to each directory in brackets. </span></strong>  </p>
        <p class="normaltext"><a href="javascript:checkall('select_all',true)">Check        All </a> | <a href="javascript:checkall('select_all',false)"> UnCheck All </a> </p>
    </form></td>
  </tr>
</table>
END_OF_WS

$template = fms_acs::insbuttons($template, "WHAT_TO_SEARCH");
$template =~ s/!!controlpanel!!/$whats/g;
print $template;


#@allss = &get_total_dirs("/home/httpd/www/articles");
#foreach $item (@allss)
#	{
#	print "--> $item<br>";
#	}

}





sub what_search1
{

@alldirs = &get_total_dirs($webroot);
@alldirs = sort(@alldirs);

#$output_dirs = "<font face=\"Verdana\" size=\"1\">";

$itemcount = 0;


$selected_dirs = &get_file_contents("$data_dir/searchloc.dat");
@alldselected = split (/\n/, $selected_dirs);


### PREPARE PREV/NEXT PAGES

$icnt = @alldirs - 1;
$nr_searchres = 400;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

############

foreach $item (@alldirs)
	{

	$item =~ s/$webroot//g;
	
	$spc = "";
	for ($ms = 0; $ms <= length($item); $ms++)
		{
		$onechar = substr($item, $ms, 1);
		if ($onechar eq "/")
			{
			$spc = $spc . "&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			
		}	
		
	if ($item eq "") 
		{
		$item = "<b>Your Public HTML Document Root</b>"; 
		$item2 = "/";
		}
		else
		{
		$item2 = $item;
		@allits = split (/\//, $item);
		$lasti = @allits;
		$lasti = $lasti - 1;
		$item = $allits[$lasti];
		}
	
	####### GET SELECTED DIRS
	
	$checked = "";
	foreach $prevs (@alldselected)
		{
		if ($item2 eq $prevs)
			{
			$checked = "checked";
			}
		}
	#######
	
	
	$nameval = "D" . $itemcount;
	
	####### DISPLAY DIRECTORIES

	#if (($ippc > $st) and ($ippc <= $nd))
	#   {
	   $jscb = $jscb . "'$nameval',";
	   
	   $output_dirs = $output_dirs . "$spc  <input type=\"checkbox\" name=\"$nameval\" value=\"$item2\" $checked> <img src=\"$web_url/fms_subdir.gif\" width=\"29\" height=\"11\"> $item<br>";
	#	}

	$ippc++;
	$itemcount++;
	}


chop($jscb);


#### PAGES 
# 
# for ($ms = 0; $ms < $pages; $ms++) 
# 	{
# 	$pg = $ms + 1;
# 	if ($nd == ($pg * $nr_searchres))
# 		{
# 		$pgstring = $pgstring . " [$pg] ";
# 		$targpage = $pg;
# 		}
# 	  	else
# 		{
# 		$st1 = ($pg * $nr_searchres) - $nr_searchres;
# 		$nd1 = ($pg * $nr_searchres);
# 		$pgstring = $pgstring . "<a href=\"$script_url/fms_admin.cgi?fct=what_search1&st=$st1&nd=$nd1\">$pg</a> ";
# 		}
# 	}
# 
# if ($pages > 1)
# 	{
# 	$pgstring = "Pages: " . $pgstring;
# 	}
# 	else
# 	{
# 	$pgstring = "";
# 	}
# 
# 
# 
### PREV NEXT PAGES
# 
# $spls = $modp;
# if ($spls == 0){$spls++;}
# 
#  if ($nd <= ($icnt - $spls))
#  	{
# 	$st1 = $st + $nr_searchres;
# 	$nd1 = $nd + $nr_searchres;
# 	$nextt = "<a href=\"$script_url/fms_admin.cgi?fct=what_search1&st=$st1&nd=$nd1\">Next Page </a> ";
# 	}
# 
#  if ($st > 0)
# 	 	{
# 		$st1 = $st - $nr_searchres;
# 		$nd1 = $nd - $nr_searchres;
# 		$prev = "<a href=\"$script_url/fms_admin.cgi?fct=what_search1&st=$st1&nd=$nd1\"> Prev Page</a> ";
# 		}
# 
# if (($prev ne "") and ($nextt ne ""))
# 	{
# 	$spcer = " | ";
# 	}
# 	else
# 	{
# 	$spcer = " ";
# 	}
# 	  
# 	$prevnext = $prev . "$spcer" . $nextt;
# 
# 	if (length($prevnext) > 5){$myspacer = " | ";}
# 
# if ($icnt > 0)
# 	{
# 	$prnxt =  "$prevnext $myspacer Page $targpage of $pg";
# 	}


$hbox = fms_acs::get_heading_box("$web_url/fms_ic_dir2.gif", "Choose Where To Search", qq[
Please choose the directories that you would like saerched below. Your public
    HTML directory tree is displayed below.
]);




$whats = <<END_OF_WS;

<script LANGUAGE="JavaScript">
<!-- Hide

function checkall(formname,thestate)
	{
	BoxNames=new Array($jscb);
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}
// End Hide -->
</script>


$hbox

<table border="0" cellspacing="1" width="100%" cellpadding="6">
  <tr>
    <td width="907" height="74"><form method="POST" action="$script_url/fms_admin.cgi"      name="select_all">
    <span class="normaltext">$output_dirs</span>
    
          <BR>
          <input type="submit" value="Save" name="B1">
          <input type="hidden" name="totalitems" value="$itemcount">
          <input type="hidden" name="fct"        value="save_dirs">
        
         <span class="normaltext">$prnxt </span><br>
        <p> <span class="normaltext">Total Sub Directories: $icnt <br>
          <br>
            <a href="javascript:checkall('select_all',true)"> Check All</a> | <a href="javascript:checkall('select_all',false)"> UnCheck All </a></span> </p>
    </form></td>
  </tr>
</table>

END_OF_WS

$template = fms_acs::insbuttons($template, "WHAT_TO_SEARCH");
$template =~ s/!!controlpanel!!/$whats/g;
print $template;

}






###########################################################################################

sub save_dirs
{

$selected_dirs = &get_file_contents("$data_dir/searchloc.dat");
@alldselected = split (/\n/, $selected_dirs);

$cdcount=0;
for ($ms = 0; $ms <= $q->param('totalitems'); $ms++)
		{
		$cval = "D" . $ms;
		if ($q->param($cval) ne "")
			{
			$cdcount++;
			}
		}
if ((length($popup) < 1) and ($cdcount > 1))
	{
	&stats("GS"); exit;
	}


open (SEARCHD, "> $data_dir/searchloc.dat");
for ($ms = 0; $ms <= $q->param('totalitems'); $ms++)
		{	
		$cval = "D" . $ms;
		if ($q->param($cval) ne "")
			{
			$to_write = $q->param($cval);
			print SEARCHD "$to_write\n";
			}
		}
close (SEARCHD);


$stat = chmod($default_permissions,"$data_dir/searchloc.dat","$data_dir/searchloc.dat");

&saved_settings("Your settings has been saved.", "$script_url/fms_admin.cgi?fct=what_search", "WHAT_TO_SEARCH");

}





sub saved_settings
{
my ($settings_text, $return_link, $sbutt) = @_;

$hbox = fms_acs::get_heading_box("$web_url/fms_ic_settings3.gif", "$settings_text", qq[
<a href="$return_link">Click here to continue</a>
]);


$template = fms_acs::insbuttons($template, $sbutt);
$template =~ s/!!controlpanel!!/$hbox/g;
print $template;

exit;
}







sub get_total_dirs
{
my ($dtdir) = @_;
my (@dirlist, @subdirs, $thing, $tmp, $adir, $alldnr, @dsubdirs);

$dirlist[0] = $dtdir;

foreach $adir (@dirlist)
	{
	@subdirs = &get_dir_contents ($adir);
	$tmp = push(@dirlist, @subdirs);
	}

$alldnr = push(@dirlist);

foreach $adir (@dirlist)
	{
	$alldnr = $alldnr - 1;
	$dsubdirs[$alldnr] = $adir;
	}

return (@dsubdirs);

}




sub get_dir_contents
{

my ($dirname) = @_;
my ($cntr,@files,$item,@subdirs,$isdir);

$cntr = 0;
opendir(DIR,"$dirname");
	@files = readdir(DIR);
		foreach $item (@files)
			{
			$isdir = (-d "$dirname/$item");
			
			if (($isdir == 1) and ($item ne ".") and ($item ne ".."))
				{
				$subdirs[$cntr] = "$dirname/$item";
				$cntr++;
				}
			}
closedir (DIR);

return (@subdirs);

}





sub stats
{
my ($locs) = @_;


if ($template !~ /unregistered/i)
	{
print qq[
<html>
<head>
<title>FM SiteSearch Pro</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/fms_admin2.cgi">
</head>
<body>
</body>
</html>
];
exit;
	}
	else
	{
	
$whats = <<END_OF_W;	


<table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E2E2E2">
  <tr>
    <td height="35" valign="top" background="$web_url/fms_bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>This functionality is not available in the shareware version</strong></td>
  </tr>
  <tr>
    <td width="907" height="148" valign="top" bgcolor="#FFFFFF" class="normaltext"><ul>
      <li>You can only select one directory to be      searched and the stats are not available in the shareware version.<br>
        <span class="blanktext">_</span></li>
      <li>The registered/commercial version of FM SiteSearch comes with all      functions.<br>
        <span class="blanktext">_</span></li>
      <li> Upgrading your copy of FM SiteSearch to the commercial version is a simple process and      should take you approximately 2 minutes. You can upgrade your existing installation to the      commercial version where no re-installation or configuration is required.</li>
    </ul>
      <div align="center">
        <center>
          <table border="0" cellpadding="6" cellspacing="1" width="100%">
            <tr>
              <td width="1"><img src="$web_url/fms_fb.gif"></td>
              <td width="99%"><a          href="http://www.focalmedia.net/cgi-bin/fms/fmsearch.cgi?url=register" class="normaltext"> <strong> Click Here          To Register/Purchase FM SiteSearch</strong></a></td>
            </tr>
          </table>
        </center>
      </div></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><span class="blanktext">_</span> </td>
    <td width="99%"></td>
  </tr>
</table>



<table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E2E2E2">
  <tr>
    <td height="35" valign="top" background="$web_url/fms_bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Registering/Purchasing FM      SiteSearch Includes The Following:</strong></td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext"><ul>
      <li> The ability to search an      unlimited number of Directories.<br>
            <span class="blanktext">_</span></li>
      <li> Detailed reports &amp;      statistics about what visitors searched for.<br>
            <span class="blanktext">_</span></li>
      <li> All FocalMedia.Net      copyright notices and 'powered by' texts displayed on end user pages are removed.<br>
            <span class="blanktext">_</span></li>
      <li> Free email support for      the life-time of version 1. Our support team is geared to provide you with solutions and      to ensure that you are satisfied with our product.<br>
            <span class="blanktext">_</span></li>
      <li> Free      upgrades/updates/patches/add-on's for the lifetime of version 1.</li>
    </ul></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"  background="$web_url/fms_shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><span class="blanktext">_</span> </td>
    <td width="99%"></td>
  </tr>
</table>

END_OF_W

#if ($locs eq "") 
#	{
#	print "Content-type: text/html\n\n";
#	}

$template = fms_acs::insbuttons($template, "SEARCH_STATISTICS");
$template =~ s/!!controlpanel!!/$whats/g;
print $template; exit;
  
	}

}



sub remove_spacing
{

my ($moderator_line) = @_;
my (@mitems, $mite, $bcnt, @moderatorsr);

$bcnt = 0;

@mitems = split (/,/, $moderator_line);

$return_str = "";

foreach $mite (@mitems)
	{

	if (substr($mite, 0, 2) eq "  ")
		{
		$mite = substr ($mite, 2, length($mite)- 2);
		}

	if (substr($mite, 0, 1) eq " ")
		{
		$mite = substr ($mite, 1, length($mite) - 1);
		}

	if (substr($mite, length($mite) - 2, 2) eq "  ")
		{
		$mite = substr ($mite, 0, length($mite) - 2);
		}

	if (substr($mite, length($mite) - 1, 1) eq " ")
		{
		$mite = substr ($mite, 0, length($mite) - 1);
		}

	if ($mite ne "")
		{
		$return_str = $return_str . $mite . ",";
		}
	
	$bcnt++;
	}

$return_str =~ s/\n//g;
$crit = chr(13); $return_str =~ s/$crit//g; 
$crit = chr(10); $return_str =~ s/$crit//g;

$return_str = substr($return_str, 0, length($return_str) -1);

return ($return_str);

}





sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

$filesize = (-s "$filename");
open (TFILECNTS, "$filename");
 #if ($flocking ne "No"){flock (TFILECNTS,2);}
	read(TFILECNTS,$thefile,$filesize);
 #if ($flocking ne "No"){flock (TFILECNTS,2);}
close (TFILECNTS);

return ($thefile);
}






sub write_var
{

my ($identifier, $write_crit) = @_;

my ($line, $tocheck, $towrite, $idmatch);

$towrite = "";

open (STP, "$config_cgi");

	while (defined($line=<STP>))
		{

		if ($line =~ m/#/g)
			{
			$r = pos($line);
			$tocheck = substr($line, 0, $r - 1);
			}
			else
			{
			$tocheck = $line;
			}
			
		if ($tocheck =~ /^$identifier/)
			{
			$line = "$identifier \"$write_crit\"\n";
			$idmatch = "true";
			}

		$towrite = $towrite . $line;

		}

	##print "$identifier : $idmatch <br>";
	
	if ($idmatch ne "true")
		{
		$towrite = $towrite . "\n\n$identifier \"$write_crit\"\n";
		}

close (STP);


open (STP, "> $config_cgi");
	print STP $towrite;
close (STP);

}





sub write_var
{

my ($identifier, $write_crit) = @_;

my ($line, $tocheck, $towrite, $idmatch);

$towrite = "";

open (STP, "$config_cgi");

	while (defined($line=<STP>))
		{

		if ($line =~ m/#/g)
			{
			$r = pos($line);
			$tocheck = substr($line, 0, $r - 1);
			}
			else
			{
			$tocheck = $line;
			}
			
		if ($tocheck =~ /^$identifier/)
			{
			$line = "$identifier \"$write_crit\"\n";
			$idmatch = "true";
			}

		$towrite = $towrite . $line;

		}

	##print "$identifier : $idmatch <br>";
	
	if ($idmatch ne "true")
		{
		$towrite = $towrite . "\n\n$identifier \"$write_crit\"\n";
		}

close (STP);


open (STP, "> $config_cgi");
	print STP $towrite;
close (STP);

}  




#### GET CONFIGURATION ########################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}
if ($line =~ /^WEBROOT/){$webroot = &get_setup_line($line, WEBROOT);}
if ($line =~ /^URLROOT/){$urlroot = &get_setup_line($line, URLROOT);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

if ($line =~ /^USE_MYSQL/){$use_mysql = &get_setup_line($line, USE_MYSQL);}
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^RG/){$rg = &get_setup_line($line, RG);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

			}
	close (STP);
	
	}
	else
	{
	print "Could not find $config_cgi"; exit;
	
	}
}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

