#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

use FindBin;
use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use fms_acs;
use DBI; 		#mysql mod

&get_env;

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

&get_setup;

$wait_web = 1;

$web_build_pages_at_a_time = 100;

$build_script = "$script_url/fms_admin4.cgi";

$default_permissions = 0777;  ### DEFAULT PERMISSIONS THAT IS USED FOR DATA FILES IN DATA DIRECTORY



if ($ARGV[0] eq lc("cron")){$crontab = "true";}

if ($fields{'fct'} eq "web") ### INITIALIZE WEB BUILD
{
print "Content-type: text/html\n\n";

$exists = (-e "$data_dir/index.dat");
if ($exists > 0)
	{
	unlink ("$data_dir/index.dat"); # destroy index
	}
&create_swop_files;
}
elsif ($fields{'fct'} eq "web_move") ### WEB BUILD INDEXES
{
print "Content-type: text/html\n\n";
&web_build_move;
}
else
{
$do_telnet_ssh_v = "true";
&do_telnet_ssh;
}


########################################################################

sub web_build_move
{


#######################################
if ($use_mysql eq "Yes")
{
#$dsn = "DBI:mysql:$db_name";
#$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
#if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
# ExternHOST
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

}
#######################################


### GET FILES THAT SHOULD NOT BE SEARCHED
$ssettings = fms_acs::get_file_contents2("$data_dir/settings.dat");
@settings = split (/\n/, $ssettings);
@s_extionsions = split (/,/, $settings[0]);
@s_exlusions = split (/,/, $settings[1]);


$from_pages = $fields{'current'};
$to_pages = $fields{'current'} + $web_build_pages_at_a_time;

$line_counter = 0;
open (STP, "$data_dir/swap.dat");
	while (defined($line=<STP>))
		{
		$line =~ s/\n//g; 
		$crit = chr(13);$line =~ s/$crit//g;
		$crit = chr(10);$line =~ s/$crit//g;
		
		### GET FILE NAME
		@fitems = split (/\//, $line);
		$fnr = @fitems; $fnr = $fnr - 1;
		$filename3 = $fitems[$fnr];
		
		### GET PATH
		$fpathf = "";
		for ($ms = 0; $ms < $fnr; $ms++)
			{
			$fpathf = $fpathf . "/$fitems[$ms]";
			}
			$fpathf = substr($fpathf, 1, length($fpathf) - 1);
		
		if (($line_counter < $to_pages) and ($line_counter > ($fields{'current'} - 1)))
			{
			&do_index($fpathf, $filename3); #filename as param to index proc - ssh get dbname; filenm
			
			$chop_path = $fitems[$fnr -1];
			$indexing = $indexing . "$line_counter. Indexing: ..../$chop_path/$filename3<br>";
			}
		
		$line_counter++;
		}


#######################################
if (($use_mysql eq "Yes") and ($sql1 ne ""))
{
$sth->finish;
$dbh->disconnect;
}
#######################################

if ($to_pages > $fields{'total'})
{

#print <<END_OF_SWPF;
#<html>
#<head>
#<title>Building....</title>
#</head>
#<body topmargin="0" leftmargin="0">
#<div align="center"><center>
#<table border="0" cellpadding="5" cellspacing="0" width="100%" height="73">
#  <tr>
#    <td width="100%" bgcolor="#0000A0" height="38"><font face="Verdana" size="4"
#    color="#FFFFFF">Building Index...<br>
#    </font><font face="Verdana" size="1" color="#FFFFFF">Please wait...</font></td>
#  </tr>
#  <tr>
#    <td width="100%" height="15"><font face="Verdana" size="1">Build Completed. <strong>Indexed:
#    $fields{'total'} pages.</strong></font></td>
#  </tr>
#</table>
#</center></div>
#</body>
#</html>
#END_OF_SWPF


print fms_acs::indexprogress($wait_web, "", "Search Index Built",
qq[Click here to <a href="javascript:onClick=window.close()">close</a> this window.], 100, 100);


#######
	if ($use_mysql eq "Yes")
	{
	$exists = (-e "$data_dir/index.dat");
	if ($exists > 0)
		{
		unlink ("$data_dir/index.dat"); # destroy index
		}
	}
######

}
else
{
$tonew_pages = $to_pages - 1;

print fms_acs::indexprogress($wait_web, "$build_script?fct=web_move&current=$to_pages&total=$fields{'total'}", "Building Search Index...",
qq[
<font face="Verdana" size="1">Indexing from page <strong> $from_pages to $tonew_pages</strong> ... 
<br>Total Pages: <b>$fields{'total'}</b>
<p>$indexing
</font>
], $from_pages, $fields{'total'});


#print <<END_OF_SWPF;
#<html>
#<head>
#<title>Building....</title>
#<meta HTTP-EQUIV="REFRESH" CONTENT="$wait_web;URL=$build_script?fct=web_move&current=$to_pages&total=$fields{'total'}"> 
#</head>
#<body topmargin="0" leftmargin="0">
#<div align="center"><center>
#<table border="0" cellpadding="5" cellspacing="0" width="100%" height="73">
#  <tr>
#    <td width="100%" bgcolor="#0000A0" height="38"><font face="Verdana" size="4"
#    color="#FFFFFF">Indexing...<br>
#    </font><font face="Verdana" size="1" color="#FFFFFF">Please wait...</font></td>
#  </tr>
#  <tr>
#    <td width="100%" height="15"><font face="Verdana" size="1">Indexing from page <strong>$from_pages
#    to $tonew_pages</strong> ... <br>Total Pages: <b>$fields{'total'}</b></font><p><font face="Verdana" size="1">$indexing</font></td>
#  </tr>
#</table>
#</center></div>
#</body>
#</html>
#END_OF_SWPF

}


}



sub create_swop_files
{

$ssearch_locations = fms_acs::get_file_contents2("$data_dir/searchloc.dat"); 
@search_locations = split (/\n/, $ssearch_locations);


### GET FILES THAT SHOULD NOT BE SEARCHED
$ssettings = fms_acs::get_file_contents2("$data_dir/settings.dat");
@settings = split (/\n/, $ssettings);
@s_extionsions = split (/,/, $settings[0]);
@s_exlusions = split (/,/, $settings[1]);

### 

$pgic = 0;

open (SWP, "> $data_dir/swap.dat");

foreach $item (@search_locations)
	{

	if ($item eq "/")
		{
		$dname = $webroot;
		}
		else
		{
		$dname = $webroot . $item;
		}

	opendir(DIR,"$dname");
	@files = readdir(DIR);
	
	foreach $filename (@files)
		{
		if (($filename ne ".") and ($filename ne ".."))
			{
			foreach $ext (@s_extionsions)
				{
				if (lc($ext) eq lc(substr($filename, (length($filename) - length($ext)), length($ext))))
					{
			   	print SWP "$dname/$filename\n";
			   	$pgic++;
					}
				}

			}
		}
	
	}

close(SWP);

##### DROP MYSQL DATABASE AND CREATE A NEW ONE

if ($use_mysql eq "Yes")
{

#$dsn = "DBI:mysql:$db_name";
#$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
#if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
# ExternHOST
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sth = $dbh->prepare("DROP TABLE IF EXISTS fmidx");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

#  could use 'replace code' instead of drop code
$sth = $dbh->prepare("
CREATE TABLE fmidx
(
url             char(255) not null,
title           char(128) not null,
description     char(255),
keywords        char(60),
pagecontents    text not null,
id              INT NOT NULL auto_increment,
 
PRIMARY         KEY(id),
INDEX (url),
INDEX (title),
INDEX (keywords),
FULLTEXT (title,description,keywords,pagecontents)
) TYPE=MyISAM
"); 

if ( !defined $dbh ) {die "Cannot connect to mySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

$sth->finish;
$dbh->disconnect;
}


print fms_acs::indexprogress($wait_web, "$build_script?fct=web_move&current=0&total=$pgic", "Building Search Index",
qq[
<font face="Verdana" size="1"><strong>Creating Swap File to Index $pgic Pages... </strong></font>
], 0, 100);

#print <<END_OF_SWPF;
#<html>
#<head>
#<title>Building....</title>
#<meta HTTP-EQUIV="REFRESH" CONTENT="$wait_web;URL=$build_script?fct=web_move&current=0&total=$pgic"> 
#</head>
#<body topmargin="0" leftmargin="0">
#<div align="center"><center>
#<table border="0" cellpadding="5" cellspacing="0" width="100%" height="73">
#  <tr>
#    <td width="100%" bgcolor="#0000A0" height="38"><font face="Verdana" size="4"
#    color="#FFFFFF">Building Index...<br>
#    </font><font face="Verdana" size="1" color="#FFFFFF">Please wait...</font></td>
#  </tr>
#  <tr>
#    <td width="100%" height="15"><font face="Verdana" size="1"><strong>Creating Swap File to
#    Index $pgic Pages... </strong>Please Wait...</font></td>
#  </tr>
#</table>
#</center></div>
#</body>
#END_OF_SWPF

}





sub do_telnet_ssh
{

if ($use_mysql eq "Yes")
{
#$dsn = "DBI:mysql:$db_name";
#$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
#if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
# ExternHOST
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sth = $dbh->prepare("DROP TABLE IF EXISTS fmidx");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

#  could use 'or replace' code instead of drop code
$sth = $dbh->prepare("
CREATE TABLE fmidx
(
url             char(255) not null,
title           char(128) not null,
description     char(255),
keywords        char(60),
pagecontents    text not null,
id              INT NOT NULL auto_increment,
 
PRIMARY         KEY(id),
FULLTEXT (title,description,keywords,pagecontents)
) TYPE=MyISAM
");

$sth->execute;
if ( !defined $dbh ) {die "Cannot connect to mySQL server: $DBI::errstr\n"; }
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

$exists = (-e "$data_dir/index.dat");
if ($exists > 0)
	{
	unlink ("$data_dir/index.dat"); # destroy index file
	}


}

unlink ("$data_dir/index.dat"); # destroy index file

$ssearch_locations = fms_acs::get_file_contents2("$data_dir/searchloc.dat");
@search_locations = split (/\n/, $ssearch_locations);

$ssettings = fms_acs::get_file_contents2("$data_dir/settings.dat");
@settings = split (/\n/, $ssettings);

@s_extionsions = split (/,/, $settings[0]);
@s_exlusions = split (/,/, $settings[1]);

## $ssettings[0] = search extensiosn #erm.. extentions (rv)
## $ssettings[1] = search exlusions

$pgic = 0;

foreach $item (@search_locations)
	{

	if ($item eq "/")
		{
		$dname = $webroot;
		}
		else
		{
		$dname = $webroot . $item;
		}
	
	opendir(DIR,"$dname");
	@files = readdir(DIR);
	
	foreach $filename (@files)
		{
		if (($filename ne ".") and ($filename ne ".."))
			{
			foreach $ext (@s_extionsions)
				{
				if (lc($ext) eq lc(substr($filename, (length($filename) - length($ext)), length($ext))))
					{
			   	&do_index($dname, $filename);
			   	$pgic++;
					}
				}

			}
		}
	
	}

$stat = chmod($default_permissions,"$data_dir/index.dat","$data_dir/index.dat");



#if ($use_mysql eq "Yes") #[not supported]
#	{
#	&pack_db;
#	}


if ($crontab ne "true")
	{
	print "$pgic Pages Indexed. \n\n";
	}


if (($use_mysql eq "Yes") and ($sql1 ne ""))
{
$sth->finish;
$dbh->disconnect;
}


}




#-----------
sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

if ((-e "$filename") > 0) 
	{
$filesize = (-s "$filename");
open (TFILECNTS, "$filename");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
	}

#$thefile =~ s/!!web_url!!/$web_url/g;
#$thefile =~ s/!!scripts_url!!/$scripts_url/g;

return ($thefile);
}



#----------
sub pack_db
{

#$dsn = "DBI:mysql:$db_name";
#$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
#if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
# ExternHOST
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sth = $dbh->prepare("DROP TABLE IF EXISTS fmidx");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

#  could use 'or replace' code instead of drop code
$sth = $dbh->prepare("
CREATE TABLE fmidx
(
url             char(255) not null,
title           char(128) not null,
description     char(255),
keywords        char(60),
pagecontents    text not null,
id              INT NOT NULL auto_increment,
 
PRIMARY         KEY(id),
FULLTEXT (title,description,keywords,pagecontents)
) TYPE=MyISAM
");

if ( !defined $dbh ) {die "Cannot connect to mySQL server: $DBI::errstr\n"; }
$sth->execute;

###$sth = $dbh->prepare("LOAD DATA LOCAL INFILE '$data_dir/index.dat' INTO TABLE fmidx"); #[not supported]

$current_row = fms_acs::get_file_contents2("$data_dir/index.dat");
@row = split(/\n/, $current_row);
chop @row;

$count = 0;
foreach $count (@row)
	{ #print "Count: $count (@row)\n";

	#split further \tabs
	#foreach row or 1 to 4
	@item = split(/\t/, $count); #$row[1]

	$item[4] =~ s/'/\\'/g; 
	$item[1] =~ s/'/\\'/g; 
	$item[2] =~ s/'/\\'/g; 
	$item[3] =~ s/'/\\'/g; 
	
	
	#debugging tests print $item[0];
	
	$sql = qq {INSERT INTO fmidx SET url = '$item[0]',
					title = '$item[1]',
					description = '$item[2]',
					keywords = '$item[3]',
					pagecontents = '$item[4]'
						}; # use auto for id
					
	$sth = $dbh->prepare($sql);

	if ( !defined $dbh ) {die "Cannot connect to mySQL server: $DBI::errstr\n";}
	$sth->execute;
	
	} # end foreach
$sth->finish;
$dbh->disconnect;
}




############################################################

sub do_index
{
my ($path, $flname, $fullp) = @_;

$toind = "";

foreach $exclu (@s_exlusions)
	{
	if ($flname eq $exclu)
		{
		$toind = "false";
		}
	}


if ($toind ne "false")
	{
	&do_index2("$path", "$flname");
	}

}




############################################################

sub do_index2
{

my ($path2, $flname2) = @_;


$ftoindex = "$path2/$flname2";

$fcnts = fms_acs::get_file_contents2("$ftoindex");


### REMOVE JAVASCRIPT

if ($fcnts =~ /<script/i)
	{
	$fcnts = &remove_tag_contents("<script", "</script>", $fcnts);
	}

if ($fcnts =~ /<style/i)
	{
	$fcnts = &remove_tag_contents("<style", "</style>", $fcnts);
	}



### REMOVE CARRIAGE RETURNS

$fcnts =~ s/\n/ /g;
$crit = chr(13); $fcnts =~ s/$crit/ /g;
$crit = chr(10); $fcnts =~ s/$crit/ /g;

$fcnts =~ s/\t/ /g;


### TITLE

$title = &parse_link_listing($fcnts, "<title>", "</title>");
$title =~ s/<[^>]*>//g;


$fcnts =~ s/\/>/>/gi;

### META DESCRIPTION
$meta_diz = &parse_link_listing($fcnts, "<META NAME=\"description\"", ">");

if ($meta_diz eq ""){$meta_diz = &parse_link_listing($fcnts, "<META NAME= \"description\"", ">");}
if ($meta_diz eq ""){$meta_diz = &parse_link_listing($fcnts, "<META NAME =\"description\"", ">");}
if ($meta_diz eq ""){$meta_diz = &parse_link_listing($fcnts, "<META NAME = \"description\"", ">");}

$crit = "content=\""; $meta_diz =~ s/$crit//gi;
$crit = "content =\""; $meta_diz =~ s/$crit//gi;
$crit = "content = \""; $meta_diz =~ s/$crit//gi;
$crit = "content= \""; $meta_diz =~ s/$crit//gi;

$meta_diz =~ s/<[^>]*>//g;


$meta_strip1 = substr($meta_diz, 0, length($meta_diz) - 5);
$meta_strip2 = substr($meta_diz, length($meta_diz) - 5, 5);

$meta_strip2 =~ s/\///gi;
$mtsc = "\"";
$meta_strip2 =~ s/$mtsc//gi;


$meta_diz = $meta_strip1 . $meta_strip2;



### META KEYWORDS

$meta_keys = &parse_link_listing($fcnts, "<META NAME=\"keywords\"", "\">");

if ($meta_keys eq ""){$meta_keys = &parse_link_listing($fcnts, "<META NAME =\"keywords\"", "\">");}
if ($meta_keys eq ""){$meta_keys = &parse_link_listing($fcnts, "<META NAME= \"keywords\"", "\">");}
if ($meta_keys eq ""){$meta_keys = &parse_link_listing($fcnts, "<META NAME = \"keywords\"", "\">");}

$crit = "content=\""; $meta_keys =~ s/$crit//gi;
$crit = "content =\""; $meta_keys =~ s/$crit//gi;
$crit = "content = \""; $meta_keys =~ s/$crit//gi;
$crit = "content= \""; $meta_keys =~ s/$crit//gi;

$meta_keys =~ s/<[^>]*>//g;





### ENTIRE PAGE

$fcnts =~ s/<[^>]*>//g;

###

$path2 =~ s/$webroot//g;

###################################

if ($title eq ""){ $title1 = "N/A"; } else { $title1 = $title; }
if ($meta_diz eq ""){ $meta_diz1 = "N/A"; }  else { $meta_diz1 = $meta_diz; }
if ($meta_keys eq ""){ $meta_keys1 = "N/A"; }  else { $meta_keys1 = $meta_keys; }



if ($crontab ne "true")
	{
	if ($do_telnet_ssh_v eq "true")
		{
		print "Indexing: $ftoindex\n";
		}
#print "Indexing: $ftoindex\n";
#print "Title: $title1\n";
#print "Description: $meta_diz1\n";
#print "Keywords: $meta_keys1\n\n";
	}




$fcnts =~ s/&gt;/ /g;
$fcnts =~ s/&lt;/ /g;
$fcnts =~ s/&amp;/ /g;
$fcnts =~ s/&nbsp;/ /g;
$fcnts =~ s/         / /gi;
$fcnts =~ s/        / /gi;
$fcnts =~ s/       / /gi;
$fcnts =~ s/      / /gi;
$fcnts =~ s/     / /gi;
$fcnts =~ s/    / /gi;
$fcnts =~ s/   / /gi;
$fcnts =~ s/  / /gi;

if ($use_mysql eq "Yes")
{


# remove undesirable items 
$paurl = "$path2/$flname2"; 
			# kill slashes then add new \' if see '
$paurl =~ s/\\//g; 
			$paurl =~ s/'/\\'/g; 
$title =~ s/\\//g; 				
			$title =~ s/'/\\'/g;
$meta_diz =~ s/\\//g; 				
			$meta_diz =~ s/'/\\'/g;
$meta_keys =~ s/\\//g; 			
			$meta_keys =~ s/'/\\'/g;
$fcnts =~ s/\\//g; 				
			$fcnts =~ s/'/\\'/g;


$sql1 = qq {INSERT INTO fmidx SET url = '$paurl',
				title = '$title',
				description = '$meta_diz',
				keywords = '$meta_keys',
				pagecontents = '$fcnts'
				}; # use auto for id
				
$sth = $dbh->prepare($sql1);
if ( !defined $dbh ) {die "Cannot connect to mySQL server: $DBI::errstr\n";}
$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

}
else
{
open (IDXFILE, ">> $data_dir/index.dat");  

	print IDXFILE "$path2/$flname2" . "\t" . 		#### 0 Location of file
					  $title . "\t" . 					#### 1 Title
					  $meta_diz . "\t" . 				#### 2 Meta Description
					  $meta_keys . "\t" . 				#### 3 Meta Keywords
					  $fcnts . "\n";						#### 4 Entire page
					  
close (IDXFILE);
}

### IF MYSQL IS IN USE, ADD THE RECORDS


}







sub parse_link_listing
{
my ($tobeparsed, $c_start, $c_end) = @_;

$foundmatch = "false";
  
if ($tobeparsed =~ m/$c_start/gi)
{
$r = pos($tobeparsed);
$tobeparsed = substr($tobeparsed, $r, length($tobeparsed) - $r);
$foundmatch = "true";
}

if (($c_end ne "DIZ") and ($foundmatch eq "true"))
	{
		if ($tobeparsed =~ m/$c_end/gi)
		{
		$r = pos($tobeparsed);
		$tobeparsed= substr($tobeparsed, 0, $r - length($c_end));
		}
	}
	else
	{
	$tobeparsed = "";
	}

return ($tobeparsed);

}









sub get_env
{
if ($ENV{'QUERY_STRING'} ne "") {
								$temp = $ENV{'QUERY_STRING'};
								}
								else
								{
								read(STDIN, $temp, $ENV{'CONTENT_LENGTH'});
								}

@pairs=split(/&/,$temp);

foreach $item(@pairs) {
	($key,$content)=split (/=/,$item,2);
	$content=~tr/+/ /;
	$content=~ s/%(..)/pack("c",hex($1))/ge;
	$fields{$key}=$content;
}

$fields{'comment'}=~s/\cM//g;
$fields{'comment'}=~s/\n\n/<p>/g;
$fields{'comment'}=~s/\n/<br>/g;
}




sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

$filesize = (-s "$filename");
open (TFILECNTS, "$filename");
 #if ($flocking ne "No"){flock (TFILECNTS,2);}
	read(TFILECNTS,$thefile,$filesize);
 #if ($flocking ne "No"){flock (TFILECNTS,2);}
close (TFILECNTS);

return ($thefile);
}





sub remove_tag_contents
{

my ($start_tag, $end_tag, $cpagecontents) = @_;

	$scrcount = 0;
	while ($cpagecontents =~ m/$start_tag/gi)
		{
		$scrcount++;
		}
	
	for ($ms_s = 0; $ms_s <= $scrcount; $ms_s++)
		{
		
		if ($cpagecontents =~ m/$start_tag/gi)
			{
			$scriptpos = pos($cpagecontents);
			}

		if ($cpagecontents =~ m/$end_tag/gi)
			{
			$scriptpos2 = pos($cpagecontents);
			}

		$fcnts_start = substr($cpagecontents, 0, ($scriptpos - 7));
		$fcnts_end = substr($cpagecontents, $scriptpos2, length($cpagecontents) - length($scriptpos2));
		
		$cpagecontents = $fcnts_start . $fcnts_end;
		}

return ($cpagecontents);
}





#### GET CONFIGURATION ########################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}
if ($line =~ /^WEBROOT/){$webroot = &get_setup_line($line, WEBROOT);}
if ($line =~ /^URLROOT/){$urlroot = &get_setup_line($line, URLROOT);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

if ($line =~ /^USE_MYSQL/){$use_mysql = &get_setup_line($line, USE_MYSQL);}
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^RG/){$rg = &get_setup_line($line, RG);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

			}
	close (STP);
	
	}
	else
	{
	print "Could not find $config_cgi"; exit;
	
	}
}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

