#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use frc4;


&get_setup;
fmspm::check_spamb("ppupgrade.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

print "Content-type: text/html\n\n";
if ($q->param('lnkid') ne ""){&start;} 

#################

sub start
{

$lnkid = int($q->param('lnkid'));
if ($lnkid < 1) { exit; }


#########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT * FROM exaddurl WHERE lnkid = '$lnkid'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows();
if ($rows > 0)
	{
	while ( @row = $sth->fetchrow() )
		{
		$custom_form_name = $row[2];
		}
	
	$custom_form_settings_file = pseek::get_file_contents("$data_dir/addmod_" . $custom_form_name . ".dat");
	@custom_form_settings = split (/\n/, $custom_form_settings_file);
	}

$sth->finish;
$dbh->disconnect;

if ($custom_form_name eq "") 
	{ 
	pseek::display_error("Fatal Error:", "Invalid Custom Add URL Form");
	}


#################

$premoption = int($q->param('premoption'));
if ($premoption < 1) 
{ 
$premoption = 0;
}
else
{
$premoption = $premoption - 1;
}

$expsettings[0] = $custom_form_settings[12] . "::" .  $custom_form_settings[13] . "::" .  $custom_form_settings[14] . "::";
$expsettings[1] = $custom_form_settings[15] . "::" .  $custom_form_settings[16] . "::" .  $custom_form_settings[17] . "::";
$expsettings[2] = $custom_form_settings[18] . "::" .  $custom_form_settings[19] . "::" .  $custom_form_settings[20] . "::";
$expsettings[3] = $custom_form_settings[21] . "::" .  $custom_form_settings[22] . "::" .  $custom_form_settings[23] . "::";
$expsettings[4] = $custom_form_settings[24] . "::" .  $custom_form_settings[25] . "::" .  $custom_form_settings[26] . "::";
$expsettings[5] = $custom_form_settings[27] . "::" .  $custom_form_settings[28] . "::" .  $custom_form_settings[29] . "::";
$expsettings[6] = $custom_form_settings[30] . "::" .  $custom_form_settings[31] . "::" .  $custom_form_settings[32] . "::";
$expsettings[7] = $custom_form_settings[33] . "::" .  $custom_form_settings[34] . "::" .  $custom_form_settings[35] . "::";
$expsettings[8] = $custom_form_settings[36] . "::" .  $custom_form_settings[37] . "::" .  $custom_form_settings[38] . "::";
$expsettings[9] = $custom_form_settings[39] . "::" .  $custom_form_settings[40] . "::" .  $custom_form_settings[41] . "::";

($usdprice, $premium_expire_days, $premium_orderform_url, $standard_orderform_url) = split (/::/, $expsettings[$premoption]);

if ($premium_orderform_url eq "") { $premium_orderform_url = $custom_form_settings[5]; }

if ($premium_orderform_url eq "")
	{
	pseek::display_error("Fatal Error:", "No Premium Link Order Options has been configured. To configure go to the Conrol Panel >> Settings >> Extra Add URL / Modify Forms >> Click on 'Settings' next to: <b>$custom_form_name</b>");
	}


print qq[
<html>
<head>
<title></title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$premium_orderform_url">
</head>
<body>
</body>
</html>
]; 
exit; 

}






#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

