#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;
use LWP::Simple;
use fmresize;

&get_setup;
fmspm::check_spamb("modify3.cgi", "header", "$data_dir");
$q = CGI->new;

#################

$default_permissions = 0777;

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; }



sub start
{

$gsettings = new_gsettings tseek;

$cid = $q->param('cid'); $cid =~ s/[^0-9]//g;
$lnkid = $q->param('id'); $lnkid =~ s/[^0-9]//g;
$lnkpassword = $q->param('lnkpassword');

if ($lnkid eq "") { &display_modify_problem("There is a problem with the 'Modify' template. LINK ID required inside template as hidden variable. Please inform the webmaster."); }
if ($cid eq "") { &display_modify_problem("There is a problem with the 'Modify' template. CATEGORY ID required inside template as hidden variable. Please inform the webmaster."); }


### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET MODIFY ERROR TEXTS
$modify_etxt = pseek::get_file_contents("$data_dir/modify2.txt");
@mtext = split (/\n/, $modify_etxt); 


### IF REG SYSTEM NOT IN USE
if (($gsettings->{modif_password} ne "No") and ($gsettings->{addurl_reg_system} ne "Yes"))
{
### CHECK PASSWORD
	$wsql = "SELECT * FROM links WHERE lnkid = '$lnkid' AND lnkpassword = '$lnkpassword'";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	$rows = $sth->rows();

	if ($rows < 1)
		{
		##### 0 The password you entered was incorrect.
		$error_text = $mtext[0];
		}
}


#### CHECK FOR ERRORS

$addurltext = pseek::get_file_contents("$data_dir/addurl2.txt");
@ctexts = split (/\n/, $addurltext);



### CHECK TO SEE IF THIS LINK USES A CUSTOM MODIFY FORM

$sth = $dbh->prepare("SELECT * FROM exaddurl WHERE lnkid = '$lnkid'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows();
if ($rows > 0)
	{
	while ( @row = $sth->fetchrow() )
		{
		$custom_form_name = $row[2];
		}
	
	$custom_form_settings_file = pseek::get_file_contents("$data_dir/addmod_" . $custom_form_name . ".dat");
	@custom_form_settings = split (/\n/, $custom_form_settings_file);
	}


#### 1 Please supply a title for your link listing
if ($q->param('title') eq ""){$error_text = $mtext[1];}


if (($custom_form_name ne "") and ((-e "$data_dir/" . $custom_form_name . "_rgs_modify_link_edit.html") > 0)) ## IF CUSTOM FORM
	{
	@reqitems = split (/::/, $custom_form_settings[2]);
	
	foreach $ritem (@reqitems)
		{
		if (($ritem eq "description") and ($q->param('description') eq "")) {$error_text = $mtext[2];}
		elsif (($ritem eq "keywords") and ($q->param('keywords') eq "")) {$error_text = $mtext[3];}
		elsif (($ritem eq "url") and ($q->param('url') eq "")) {$error_text =  $mtext[4];}
		elsif (($ritem eq "url") and ($q->param('url') eq "http://")) {$error_text =  $mtext[4];}
		elsif (($ritem eq "sname") and ($q->param('name') eq "")) {$error_text =  $mtext[5];}
		elsif (($ritem eq "email") and ($q->param('email') eq "")) {$error_text =  $mtext[6];}
		elsif (($ritem ne "description") and ($ritem ne "keywords") and ($ritem ne "url") and ($ritem ne "sname") and ($ritem ne "email")) { push (@cust_e_fields, $ritem); }
		}
	}
	else
	{
	#### 2 Please supply a description for your link listing.
	if ($q->param('description') eq ""){$error_text = $mtext[2];}

	#### 4 The description you supplied is to long.
	if (length($q->param('description')) > $gsettings->{diz_chars})
		{
		$error_text = $ctexts[4];
		}
	
	#### 3 Please supply keywords for your link listing.
	if ($q->param('keywords') eq ""){$error_text = $mtext[3];}

	#### 4 Please supply a URL for your link listing.
	if ($gsettings->{addurl_present} ne "No")
		{
			if ($q->param('url') eq ""){$error_text = $mtext[4];}
		}

	#### 5 Please supply a name for your link listing.
	if ($q->param('name') eq ""){$error_text = $mtext[5];}

	#### 6 Please supply an email address for your link listing.
	if ($q->param('email') eq ""){$error_text = $mtext[6];}

	#### 7 Please supply a password for your link listing.
	if (($q->param('password') eq "") and ($gsettings->{addurl_reg_system} ne "Yes")) {$error_text = $mtext[7];}

	}



#### KEY OPERATIONS
$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$upload_key_data = pseek::get_file_contents("$data_dir/keysupl.dat"); ### Upload texts
@up_keys = split (/:-o_:/, $upload_key_data);


foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item); 
	
		#### IF CUSTOM FORM
		if (($custom_form_name ne "") and ((-e "$data_dir/" . $custom_form_name . "_rgs_modify_link_edit.html") > 0)) ## IF CUSTOM FORM
		{
			
			foreach $ritem (@cust_e_fields)
				{
					if ($keyname eq $ritem)
						{
							if ($numberfield eq "Upload")
							{
								$hidind = $keyname . "_hid";
								if (($q->param($hidind) eq "") and ($q->param($keyname) eq "")) { &modify_problem_upload($keyname, "UPLOAD_REQUIRED"); } #print "Error: Value required for: $keyname"; exit; }
							}
							else
							{
								if ($q->param($keyname) eq "")
									{
									##You have not completed all the required fields. Please complete the '%%extra_field%%' field.
									$error_text = $mtext[8];
									$error_text =~ s/%%extra_field%%/$description1/g;
									}
							}
						
						}
				}
			
			if ($numberfield eq "Upload")
				{
				$hidind = $keyname . "_hid";
					if ($q->param($keyname) ne "") ### IF FILE UPLOAD
						{

						  ### CHECK FILE EXTENSION, FILE SIZE, FILE TYPE & UPLOAD TEMP FILE
						  if ($q->param($keyname) ne "") {&upload_check_image($keyname, $lnkid);}
						  push (@file_uploads, $keyname);

						}
						elsif ($q->param($hidind) ne "") #### IF EXISTIG FILE STAYS UNCHANGED
						{
						  push (@old_keep_files, $keyname . "." . $q->param($hidind));
						}
				}
		
		}
		else ### IF NON CUSTOM FORM
		{
				if ($numberfield eq "Upload")
					{
						 ### CHECK REQUIRED
						 $hidind = $keyname . "_hid";

						 if (($q->param($hidind) eq "") and ($req eq "Yes") and ($q->param($keyname) eq "")) { &modify_problem_upload($keyname, "UPLOAD_REQUIRED"); } #print "Error: Value required for: $keyname"; exit; }

						 if ($q->param($keyname) ne "") ### IF FILE UPLOAD
							{

							  ### CHECK FILE EXTENSION, FILE SIZE, FILE TYPE & UPLOAD TEMP FILE
							  if ($q->param($keyname) ne "") {&upload_check_image($keyname, $lnkid);}
							  push (@file_uploads, $keyname);

							}
							elsif ($q->param($hidind) ne "") #### IF EXISTIG FILE STAYS UNCHANGED
							{
							  push (@old_keep_files, $keyname . "." . $q->param($hidind));
							}

					}
				elsif ($req eq "Yes")
					{
					if ($q->param($keyname) eq "")
						{
						##You have not completed all the required fields. Please complete the '%%extra_field%%' field.
						$error_text = $mtext[8];
						$error_text =~ s/%%extra_field%%/$description1/g;
						}
					}
		}

	}




#### PLACE UPLOADED EXTRA FIELD FILES

foreach $uploaded_item (@file_uploads)
	{
	$oupfile_ext = &get_file_extension($q->param($uploaded_item), $uploaded_item);
	
	$tmp_up_fname = $lnkid . "_" . $uploaded_item . "." . $oupfile_ext;
	
	&mkdirps("$web_dir/imagefiles");
	&mkdirps("$web_dir/imagefiles/$lnkid");
	&mkdirps("$web_dir/edt");
	&mkdirps("$web_dir/edt/tmp");
	&mkdirps("$web_dir/edt/tmp/$lnkid");

	$up_write_file = "$web_dir/edt/tmp/$lnkid/" . $uploaded_item . "." . $oupfile_ext;
	
			open (UPLOADFILE, "$data_dir/tmp/$tmp_up_fname");
			open (UPLWRITE, "> $up_write_file") || die ("Could not write to: $up_write_file");

			  binmode (UPLOADFILE);
			  binmode (UPLWRITE);
			  
			  	while (defined($line=<UPLOADFILE>))
					{
					print UPLWRITE $line;
					}
			 
			close (UPLOADFILE);
			close (UPLWRITE);
	
	fmresize::resize_image($uploaded_item, $up_write_file); ## (FIELDNAME, FILENAME) 
	
	unlink ("$data_dir/tmp/$tmp_up_fname");
	}




#### UPLOAD STANDARD IMAGE IF A NEW IMAGE WAS SPECIFIED, RESIZED IF NEEDED AND CHECK FILE SIZE

if (($q->param('image') ne "") and ($gsettings->{enable_image_uploads} eq "Yes"))
	{

		### CHECK IF UPLOAD DIR EXISTS
		$upload_dir = "$web_dir/imagefiles";
		if ((-e $upload_dir) < 1) {
		mkdir ($upload_dir, $default_permissions);
		chmod($default_permissions,"$upload_dir"); }
		#############################################################
		
		$upload_filename = $q->param('image'); 
		$upload_filename =~ s/.*[\/\\](.*)/$1/;
		(@fext) = split (/\./, $upload_filename);
		$fnr = @fext;
		$fextension = $fext[$fnr -1];
		$ufname = "$web_dir/imagefiles/m_" . "$lnkid" . "." . $fextension;

		$new_image_filename = "m_" . "$lnkid" . "." . $fextension;

		### DO UPLOAD
		$upload_filehandle = $q->param('image');
		
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;
		
		fmresize::resize_image("img_standard", $ufname); ## (FIELDNAME, FILENAME)

		### CHECK FILE SIZE
		$flsize = (-s "$ufname");
		$maxfsize = $gsettings->{upload_max_filesize}; if ($maxfsize eq "") { $maxfsize = 100; }
		$maxfsize = $maxfsize * 1000;
		
			if ($flsize > $maxfsize) #### THE FILE YOU ARE TRYING TO UPLOAD IS TOO BIG (LARGER THAN THE ALLOWED FILE SIZE)
			{
			$addurltext = pseek::get_file_contents("$data_dir/addurl2.txt");
			@ctexts = split (/\n/, $addurltext);		
		
			unlink($ufname);
			$error_text = $ctexts[17];
			$fextension = "";
			}
			

	}





### CHECK RECIPROCAL LINK IF ENABLED PREMIUM
if ($custom_form_name eq "")
	{
		if (($q->param('premium') eq "true") and ($gsettings->{enable_reciprocal_premium} eq "Yes"))
			{
			$recip = $q->param('reciprocal');

			$recip_domain = &get_domain($recip);

			if ($gsettings->{reciprocal_link_back} =~ /$recip_domain/i)
				{
				$error_text = $ctexts[16];
				}
			elsif ($q->param('reciprocal') eq "")
				{
				$error_text = $ctexts[16];
				}
			else
				{
				$url_to_get = $q->param('reciprocal');
				my $recip_url_page = get($url_to_get) or $error_text = $ctexts[16];
				$reciprocal_link_back = $gsettings->{reciprocal_link_back};
				if ($recip_url_page !~ /$reciprocal_link_back/){ $error_text = $ctexts[16]; }
				}
				$recip =~ s/'/\\'/g;
			}
	}



### CHECK RECIPROCAL LINK IF ENABLED STANDARD
if ($custom_form_name eq "")
	{
	if (($q->param('premium') ne "true") and ($gsettings->{enable_reciprocal} eq "Yes"))
		{
		$recip= $q->param('reciprocal');

		$recip_domain = &get_domain($recip);

		if ($gsettings->{reciprocal_link_back} =~ /$recip_domain/i)
			{
			$error_text = $ctexts[16];
			}
		elsif ($q->param('reciprocal') eq "")
			{
			$error_text = $ctexts[16];
			}
		else
			{
			$url_to_get = $q->param('reciprocal');
			my $recip_url_page = get($url_to_get) or $error_text = $ctexts[16];
			$reciprocal_link_back = $gsettings->{reciprocal_link_back};
			if ($recip_url_page !~ /$reciprocal_link_back/){ $error_text = $ctexts[16]; }
			}
			$recip =~ s/'/\\'/g;
		}
	}




################################################################

if ($error_text ne "")  ### IF ERROR
	{
	&display_modify_problem($error_text);
	}

################################################################





if ($gsettings->{addurl_reg_system} eq "Yes")
	{
		if (($custom_form_name ne "") and ((-e "$data_dir/" . $custom_form_name . "_rgs_modify_link_edit.html") > 0))
			{
			$modify_template = pseek::get_file_contents("$data_dir/$custom_form_name" . "_rgs_modify_link_success.html");
			}
			else
			{
			$modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_success.html");
			}
	}
	else
	{
	$modify_template = pseek::get_file_contents("$data_dir/modify_link_success.html");
	}

$modify_template =~ s/!!scripts_url!!/$script_url/g;

#########


if ($gsettings->{searchmeth} eq "fulltext")
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
	}
	else
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
	}


$modify_template =~ s/!build_url!/$web_url/g;
$modify_template =~ s/!!build_url!!/$web_url/g;




#### UPDATE CHANGES

$title = $q->param('title'); $title =~ s/'/\\'/g;
$description = $q->param('description'); $description =~ s/'/\\'/g;
$keywords = $q->param('keywords'); $keywords =~ s/'/\\'/g;
$url = $q->param('url'); $url =~ s/'/\\'/g;
$name = $q->param('name'); $name =~ s/'/\\'/g; 
$email = $q->param('email'); $email =~ s/'/\\'/g;
$password = $q->param('password'); $password =~ s/'/\\'/g;

$notes  = $q->param('notes'); $notes  =~ s/'/\\'/g;
$timep = time();



#### IF NEW IMAGE FILE WAS UPLOADED

if ($new_image_filename ne "") 
	{
	### CHECK IF AN OLD IMAGE WAS USED
	$wsql = "SELECT image FROM links WHERE lnkid = '$lnkid'";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	while ( @row = $sth->fetchrow() )
		{
		if ($row[0] ne "") { $old_img_fname = $lnkid . "." . $row[0]; }
		}
	
	$notes = $notes . ":::IMGF:::" . $new_image_filename . ":::IMGF:::" . $old_img_fname; 
	}




#### IF NO IMAGE FILE WAS UPLOADED AND THE EXISTING IMAGE WAS CHOSEN TO BE DELETED

if (($new_image_filename eq "") and ($q->param('delimgbox') eq "Y"))
	{
	### CHECK WHAT OLD IMAGE WAS IN USE
	$wsql = "SELECT image FROM links WHERE lnkid = '$lnkid'";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	while ( @row = $sth->fetchrow() )
		{
		if ($row[0] ne "") 
			{
			$old_img_fname = "$lnkid" . "." . $row[0];
			$notes = $notes . ":::IMGF:::" . "DEL" . ":::IMGF:::" . $old_img_fname; 
			}
		}
	
	}






##### KEY/FIELD OPERATIONS

foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item); 
	
	$keycrit = $q->param($keyname);

	if ($numberfield eq "Upload")
		{
		$del_cbox = $keyname . "_cbox";
		$hid_oldfile = $keyname . "_hid";
		
		   if ($keycrit ne "") ### IF FILE UPLOADED
			{
			  $file_ext_up = &get_file_extension($keycrit, $keyname);
			  $extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = '" . $file_ext_up . "'";
			}
			elsif ($q->param($del_cbox) eq "Y") ### IF DELETING IMAGE
			{
			  $extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = ''";
			}
			elsif ($q->param($hid_oldfile) ne "") ### IF KEEPING OLD UPLOADED FILE
			{
				$extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = '" . $q->param($hid_oldfile) . "'";
			}
			
		}
		else
		{
		$keycrit =~ s/'/\\'/g;
		$extrafield_sql = $extrafield_sql . ",$keyname" . "_cust" . " = '" . $keycrit . "'";
		}
	
	}

###### REMOVE OLD MODIFICATION RECORD OF THIS SAME LINK IF AVAILABLE
$del_sql = "DELETE FROM modified WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($del_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}


######

$msql = "INSERT INTO modified SET
													lnkid = '$lnkid',
													cid = '$cid',
													title = '$title',
													description = '$description',
													keywords = '$keywords',
													url = '$url',
													name = '$name',
													email = '$email',
													urldate = '$timep',
													lnkpassword = '$password',
													notes = '$notes'
													$extrafield_sql
													";


#print "0--> $msql<BR>";

$sth = $dbh->prepare($msql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $msql";}
$rows = $sth->rows();



#### PLACE OLD UPLOADED FILES SO THAT MODIFIED LISTING HAS OLD FILES THAT HAD NO CHANGES

foreach $kitem (@old_keep_files)
	{
	
		&mkdirps("$web_dir/edt");
		&mkdirps("$web_dir/edt/tmp");
		&mkdirps("$web_dir/edt/tmp/$lnkid");
		
#		print "-> $web_dir/edt/tmp/$lnkid <BR>"; exit;
		
		$exist_write_file = "$web_dir/edt/tmp/$lnkid/$kitem";
		
		open (EXISTINGFILE, "$web_dir/imagefiles/$lnkid/$kitem");
		open (UPLWRITE, "> $exist_write_file") || die ("Could not write to: $exist_write_file");
	
	   binmode (EXISTINGFILE);
	   binmode (UPLWRITE);
				  
	  	while (defined($line=<EXISTINGFILE>))
				{
				print UPLWRITE $line;
				}
				 
		close (EXISTINGFILE);
		close (UPLWRITE);

	}



#####

$modify_template =~ s/%%continue%%//gi;

#####

$sth->finish;
$dbh->disconnect;

$modify_template = pseek::ts_insert_template_includes($modify_template);
$modify_template = pseek::fill_vars($modify_template); 

&clean_temp_uploaded_files; ### CLEAN TEMP UPLOADED IMAGE FILES

print $modify_template;

}











sub get_domain
{
my ($sp_url) = @_;
 
$sp_url =~ s/http:\/\/www\.//gi;
$sp_url =~ s/http:\/\///gi;
@alitems = split (/\//, $sp_url);
$realdomain = $alitems[0];

return($realdomain);
}




sub upload_check_image
{

my ($upkeyname, $mid) = @_;

foreach $upitem (@up_keys)
	{
	($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t, $filetype_error_t, $reqtext_t, $filesize_error_t) = split (/:o:-:o:/, $upitem);
	if ($fieldname_t eq $upkeyname)
		{
		## CHECK FILE EXTENSION
		&check_valid_file_types($fieldname_t, $filetypes_t);
		
		## CHECK UPLOAD SIZE
		&upload_temp_file_check_image_size($fieldname_t, $uploadsize_t, $filesize_error_t, $mid);
		}
	}



}



sub upload_temp_file_check_image_size
{
my ($up_fkey, $upsize_max, $size_error, $link_id) = @_;

### UPLOAD FILE
	$up_filename = $q->param($up_fkey);
	$file_ext_up = &get_file_extension($up_filename, $up_fkey);
		
		$ufname = "$data_dir/tmp/" . "$link_id" . "_" . $up_fkey . "." . $file_ext_up;
		$upload_filehandle = $q->param($up_fkey);
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;	

$flsize = (-s "$ufname");

if ($flsize < 1) { &modify_problem_upload($up_fkey, "WRONG_FILESIZE"); }

$upsize_max = $upsize_max * 1000;
if ($flsize > $upsize_max) { &modify_problem_upload($up_fkey, "WRONG_FILESIZE"); }

}




sub check_valid_file_types
{

my ($uptkeyname, $valid_file_types) = @_;

$up_filename = $q->param($uptkeyname);

$up_file_ext = &get_file_extension($up_filename, $uptkeyname);

$up_file_ext = "." . $up_file_ext;

if ($valid_file_types ne "*")
	{
	my @allftypes = split (/,/, $valid_file_types);
	
	$file_type_ok = "";
	foreach $fitem (@allftypes)
		{
			if ($fitem eq $up_file_ext)
				{
				$file_type_ok = "true";
				}
		}
	
	if ($file_type_ok ne "true") { &modify_problem_upload($uptkeyname, "WRONG_EXTENSION"); }
	}

}




sub get_file_extension
{
($fullnamem, $ext_keyname) = @_;

if ($fullnamem !~ /\./) { &modify_problem_upload($ext_keyname, "WRONG_EXTENSION"); }

my @fext = split (/\./, $fullnamem);
$fnr = @fext;
$ret_ext = $fext[$fnr -1];

return($ret_ext);
} 





sub modify_problem_upload
{
my ($the_p_key, $kind_of_problem) = @_;


foreach $upitem (@up_keys)
	{
	($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t, $filetype_error_t, $reqtext_t, $filesize_error_t) = split (/:o:-:o:/, $upitem);
	if ($fieldname_t eq $the_p_key)
		{
		if ($kind_of_problem eq "UPLOAD_REQUIRED") { &display_modify_problem($reqtext_t); }
		elsif ($kind_of_problem eq "WRONG_EXTENSION") { &display_modify_problem($filetype_error_t); }
		elsif ($kind_of_problem eq "WRONG_FILESIZE") { &display_modify_problem($filesize_error_t); }
		}
	}


}








sub do_modify_tmpl_error_text
{

my ($premind, $disp_problem, $custom_vorm_template) = @_;


if ($custom_vorm_template ne "")
	{
	$mod_display_template =  pseek::get_file_contents($custom_vorm_template); ### Get custom modify template (standard/premium)
	}
elsif ($premind eq "premium")
	{
	$mod_display_template = pseek::get_file_contents("$data_dir/rgs_modify_link_editp.html");
	}
else
	{
	$mod_display_template = pseek::get_file_contents("$data_dir/rgs_modify_link_edit.html");
	}


$title = $q->param('title');
$mod_display_template =~ s/%%title%%/$title/gi;

$subd = $q->param('description');
$submissionbox = qq[<textarea rows="5" name="description" cols="29" style="width:100%">$subd</textarea>];
$mod_display_template =~ s/%%submissionbox%%/$submissionbox/gi;

$subd = $q->param('description');
$mod_display_template =~ s/%%description%%/$subd/gi;

$keywords = $q->param('keywords');
$mod_display_template =~ s/%%keywords%%/$keywords/gi;

$url = $q->param('url');
$mod_display_template =~ s/%%url%%/$url/gi;

$name = $q->param('name');
$mod_display_template =~ s/%%name%%/$name/gi;

$email = $q->param('email');
$mod_display_template =~ s/%%email%%/$email/gi;

$notes =  $q->param('notes');
$notesbox = qq[<textarea rows="5" name="notes" cols="29" style="width:100%">$notes</textarea>];
$mod_display_template =~ s/%%notesbox%%/$notesbox/gi;


$notes =  $q->param('notes');
$mod_display_template =~ s/!!notes!!/$notes/gi;


$mod_display_template = pseek::ts_insert_template_includes($mod_display_template);
$mod_display_template = pseek::fill_vars($mod_display_template); 

$mod_display_template =~ s/!!modify_cgi!!/$script_url\/modify3.cgi/gi;

$cid = $q->param('cid');
$mod_display_template =~ s/!!cid!!/$cid/gi;

$passw = $q->param('lnkpassword');
$mod_display_template =~ s/!!password!!/$passw/gi;

$id = $q->param('id');
$mod_display_template =~ s/!!id!!/$id/gi;



### Extra Fields
if ($custom_vorm_template ne "")
	{
	$custom_form_settings_file = pseek::get_file_contents("$data_dir/addmod_" . $custom_form_name . ".dat");
	@custom_form_settings = split (/\n/, $custom_form_settings_file);
	}


$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata); $knr = @akeys;

	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk, $typefield, $req) = split (/\t/, $k_item);
		
		$fieldnrep = $q->param($keyname);
		
		if ($typefield eq "Content")
			{
			#($field_contents, $this_css) = split (/o-_-o/, $row[$kstart]);
			#$field_contents =~ s/&/&amp;/g;
			#$field_contents =~ s/</&lt;/g;
			#$field_contents =~ s/>/&gt;/g;			
			
			$field_contents = $q->param($keyname);
			
			$mod_display_template =~ s/%%$keyname%%/$field_contents/gi;
			$mod_display_template =~ s/!!$keyname!!/$field_contents/gi;
			}
		elsif ($typefield eq "Upload")
			{
				
				if ($custom_vorm_template ne "")
					{
					$req_custom = "";
					@allexfields = split (/::/, $custom_form_settings[2]);
					foreach $citem (@allexfields)
						{
							if ($citem eq $keyname) { $req_custom = "Yes"; }
						}
					$req = $req_custom;
					}
				
				push(@upfields, $keyname . "\t" . $visible . "\t" . $size . "\t" . $searched . "\t" . $description1 . "\t" . $na . "\t" . $imgk . "\t" . $typefield . "\t" . $req);
				$msql = $msql . " $keyname" . "_cust" . ",";
			}
			else
			{
			$mod_display_template =~ s/%%$keyname%%/$fieldnrep/gi;
			$mod_display_template =~ s/!!$keyname!!/$fieldnrep/gi;
			}
		
		
		$kstart++;
		}


### If file uploads with form
if (@upfields > 0)
	{
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	
	$msql = substr($msql, 0, length($msql) - 1);
	$modsql = "SELECT $msql FROM links WHERE lnkid = '$id'";
	$sth = $dbh->prepare($modsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	$rows = $sth->rows();
	$row = $sth->fetchrow_hashref();
	%cols = %$row;  	
	$sth->finish;
	$dbh->disconnect;
	}

foreach $item (@upfields)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imgk, $typefield, $req) = split (/\t/, $item);
	$keynamecust = $keyname . "_cust";
	$replace_file_name = "%%" . $keyname . "_file_with_link%%";
	
	$curfile = "";
	if ($cols{$keynamecust} ne "")  ### If extra field has uploaded file
			{
					$curfile = $keyname . "." . $cols{$keynamecust};
					$curfile = qq[<a href="$web_url/imagefiles/$id/$curfile" target="_blank">$curfile</a>];

					$repfilename = "%%" . $keyname . "_file_with_link%%";
					$mod_display_template =~ s/$repfilename/$curfile/gi;

					$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_no_filename_text", $keyname . "_no_filename_text_end", "BLANK");

					$chboxrep = "%%" . $keyname . "_checkbox%%";

								if ($req eq "Yes") ### IF REQUIRED THEN DON'T DISPLAY OPTION TO DELETE FILE
								{
								$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_del_text", $keyname . "_del_text_end", "BLANK");
								$mod_display_template =~ s/$chboxrep//gi;
								}
								else  ### IF NOT REQUIRED THEN DISPLAY OPTION TO DELETE FILE
								{
								$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_del_text", $keyname . "_del_text_end", "");
								$chboxname = $keyname . "_cbox"; $modify_del_cbox = qq[<input type="checkbox" name="$chboxname" value="Y">];
								$mod_display_template =~ s/$chboxrep/$modify_del_cbox/gi;
								}
					$mod_hid_nm = $keyname . "_hid";
					$mod_hid_values = $mod_hid_values . qq[<input type="hidden" name="$mod_hid_nm" value="$cols{$keynamecust}">];
			}
			else ## If extra field value is blank
			{
					$mod_display_template =~ s/$replace_file_name//gi;
					$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_no_filename_text", $keyname . "_no_filename_text_end", "");
					$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_del_text", $keyname . "_del_text_end", "BLANK");
					$delcheckbox = "%%" . $keyname . "_checkbox%%"; $mod_display_template =~ s/$delcheckbox//gi;			
			}
	
	#print "--> $keyname : " . $cols{$keynamecust} . " - $curfile<BR>";
	}

if ($mod_hid_values ne "") { $mod_display_template =~ s/<\/form>/$mod_hid_values<\/form>/gi; }

if ($q->param('premium') eq "true") 
	{
	$premstr = qq[<input type="hidden" name="premium" value="true">];
	$mod_display_template =~ s/<\/form>/$premstr<\/form>/gi; 
	}

$mod_display_template =~ s/!!error_text!!/$disp_problem/gi;
print $mod_display_template;
exit;

}








sub display_modify_problem
{

my ($the_problem) = @_;

	if ($gsettings->{addurl_reg_system} eq "Yes")
		{
			
			### Check if custom add/modify form exists
			if (($custom_form_name ne "") and ((-e "$data_dir/" . $custom_form_name . "_rgs_modify_link_edit.html") < 1)) {$custom_form_name = "";}
		
			if ($custom_form_name ne "")
				{
						if ($q->param('premium') eq "true") 
							{
							$mproblem_template = pseek::get_file_contents("$data_dir/" . $custom_form_name . "_rgs_modify_link_editp.html");
								if ($mproblem_template !~ /!!error_text!!/) { $modify_template = pseek::get_file_contents("$data_dir/" . $custom_form_name . "_rgs_modify_link_problem.html"); } 
								else { &do_modify_tmpl_error_text("premium", $the_problem, "$data_dir/" . $custom_form_name . "_rgs_modify_link_editp.html"); exit; }
							}
							else
							{
							$mproblem_template = pseek::get_file_contents("$data_dir/" . $custom_form_name . "_rgs_modify_link_edit.html");
								if ($mproblem_template !~ /!!error_text!!/) { $modify_template = pseek::get_file_contents("$data_dir/" . $custom_form_name . "_rgs_modify_link_problem.html"); } 
								else { &do_modify_tmpl_error_text("", $the_problem, "$data_dir/" . $custom_form_name . "_rgs_modify_link_edit.html"); exit; }
							}
				}
			elsif ($q->param('premium') eq "true")
				{
				$mproblem_template = pseek::get_file_contents("$data_dir/rgs_modify_link_editp.html");
				if ($mproblem_template !~ /!!error_text!!/) { $modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_problem.html"); } else { &do_modify_tmpl_error_text("premium", $the_problem); exit; }
				}
			elsif ($q->param('premium') eq "")
				{
				$mproblem_template = pseek::get_file_contents("$data_dir/rgs_modify_link_edit.html");
				if ($mproblem_template !~ /!!error_text!!/) { $modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_problem.html"); } else { &do_modify_tmpl_error_text("", $the_problem); exit; }
				}
				
		}
		else ### If registration system not in use
		{

				if ($q->param('premium') eq "true")
					{
					$mproblem_template = pseek::get_file_contents("$data_dir/modify_link_editp.html");
					if ($mproblem_template =~ /!!error_text!!/) { &display_error_text_modify($mproblem_template, $the_problem, "true"); exit; }
					}
				elsif ($q->param('premium') eq "")
					{
					$mproblem_template = pseek::get_file_contents("$data_dir/modify_link_edit.html");
					if ($mproblem_template =~ /!!error_text!!/) { &display_error_text_modify($mproblem_template, $the_problem, ""); exit; }
					}
		
			
		
		$modify_template = pseek::get_file_contents("$data_dir/modify_link_problem.html");
		}
	
	$modify_template = pseek::ts_insert_template_includes($modify_template);
	$modify_template =~ s/!!scripts_url!!/$script_url/g;

if ($gsettings->{searchmeth} eq "fulltext")
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
	}
	else
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
	}

	
	$modify_template =~ s/!build_url!/$web_url/g;
	$modify_template =~ s/!!build_url!!/$web_url/g;
	$modify_template =~ s/%%problem%%/$the_problem/gi;
	$modify_template = pseek::fill_vars($modify_template); 
	print $modify_template; 

	&clean_temp_uploaded_files;
	
	exit; 
}




sub display_error_text_modify
{

my ($mod_display_template, $tmerror, $mprem) = @_;

$title = $q->param('title');
$mod_display_template =~ s/%%title%%/$title/gi;

$subd = $q->param('description');
$submissionbox = qq[<textarea rows="5" name="description" cols="29" style="width:100%">$subd</textarea>];
$mod_display_template =~ s/%%submissionbox%%/$submissionbox/gi;

$subd = $q->param('description');
$mod_display_template =~ s/%%description%%/$subd/gi;

$keywords = $q->param('keywords');
$mod_display_template =~ s/%%keywords%%/$keywords/gi;

$url = $q->param('url');
$mod_display_template =~ s/%%url%%/$url/gi;

$name = $q->param('name');
$mod_display_template =~ s/%%name%%/$name/gi;

$email = $q->param('email');
$mod_display_template =~ s/%%email%%/$email/gi;

$notes =  $q->param('notes');
$notesbox = qq[<textarea rows="5" name="notes" cols="29" style="width:100%">$notes</textarea>];
$mod_display_template =~ s/%%notesbox%%/$notesbox/gi;


$notes =  $q->param('notes');
$mod_display_template =~ s/!!notes!!/$notes/gi;


$mod_display_template = pseek::ts_insert_template_includes($mod_display_template);
$mod_display_template = pseek::fill_vars($mod_display_template); 

$mod_display_template =~ s/!!modify_cgi!!/$script_url\/modify3.cgi/gi;

$cid = $q->param('cid');
$mod_display_template =~ s/!!cid!!/$cid/gi;

$passw = $q->param('lnkpassword');
$mod_display_template =~ s/!!password!!/$passw/gi;

$id = $q->param('id');
$mod_display_template =~ s/!!id!!/$id/gi;

$modpswd = $q->param('password');
$mod_display_template =~ s/%%password%%/$modpswd/gi;



### Extra Fields

$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata); $knr = @akeys;

	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk, $typefield, $req) = split (/\t/, $k_item);
		
		$fieldnrep = $q->param($keyname);
		
		if ($typefield eq "Content")
			{
			#($field_contents, $this_css) = split (/o-_-o/, $row[$kstart]);
			#$field_contents =~ s/&/&amp;/g;
			#$field_contents =~ s/</&lt;/g;
			#$field_contents =~ s/>/&gt;/g;			
			
			$field_contents = $q->param($keyname);
			
			$mod_display_template =~ s/%%$keyname%%/$field_contents/gi;
			$mod_display_template =~ s/!!$keyname!!/$field_contents/gi;
			}
		elsif ($typefield eq "Upload")
			{
				push(@upfields, $keyname . "\t" . $visible . "\t" . $size . "\t" . $searched . "\t" . $description1 . "\t" . $na . "\t" . $imgk . "\t" . $typefield . "\t" . $req);
				$msql = $msql . " $keyname" . "_cust" . ",";
			}
			else
			{
			$mod_display_template =~ s/%%$keyname%%/$fieldnrep/gi;
			$mod_display_template =~ s/!!$keyname!!/$fieldnrep/gi;
			}
		
		
		$kstart++;
		}


### If file uploads with form
if (@upfields > 0)
	{
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	
	$msql = substr($msql, 0, length($msql) - 1);
	$modsql = "SELECT $msql FROM links WHERE lnkid = '$id'";
	$sth = $dbh->prepare($modsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $wsql";}
	$rows = $sth->rows();
	$row = $sth->fetchrow_hashref();
	%cols = %$row;  	
	$sth->finish;
	$dbh->disconnect;
	}

foreach $item (@upfields)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imgk, $typefield, $req) = split (/\t/, $item);
	$keynamecust = $keyname . "_cust";
	$replace_file_name = "%%" . $keyname . "_file_with_link%%";
	
	$curfile = "";
	if ($cols{$keynamecust} ne "")  ### If extra field has uploaded file
			{
					$curfile = $keyname . "." . $cols{$keynamecust};
					$curfile = qq[<a href="$web_url/imagefiles/$id/$curfile" target="_blank">$curfile</a>];

					$repfilename = "%%" . $keyname . "_file_with_link%%";
					$mod_display_template =~ s/$repfilename/$curfile/gi;

					$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_no_filename_text", $keyname . "_no_filename_text_end", "BLANK");

					$chboxrep = "%%" . $keyname . "_checkbox%%";

								if ($req eq "Yes") ### IF REQUIRED THEN DON'T DISPLAY OPTION TO DELETE FILE
								{
								$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_del_text", $keyname . "_del_text_end", "BLANK");
								$mod_display_template =~ s/$chboxrep//gi;
								}
								else  ### IF NOT REQUIRED THEN DISPLAY OPTION TO DELETE FILE
								{
								$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_del_text", $keyname . "_del_text_end", "");
								$chboxname = $keyname . "_cbox"; $modify_del_cbox = qq[<input type="checkbox" name="$chboxname" value="Y">];
								$mod_display_template =~ s/$chboxrep/$modify_del_cbox/gi;
								}
					$mod_hid_nm = $keyname . "_hid";
					$mod_hid_values = $mod_hid_values . qq[<input type="hidden" name="$mod_hid_nm" value="$cols{$keynamecust}">];
			}
			else ## If extra field value is blank
			{
					$mod_display_template =~ s/$replace_file_name//gi;
					$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_no_filename_text", $keyname . "_no_filename_text_end", "");
					$mod_display_template = &display_inbound_text($mod_display_template, $keyname . "_del_text", $keyname . "_del_text_end", "BLANK");
					$delcheckbox = "%%" . $keyname . "_checkbox%%"; $mod_display_template =~ s/$delcheckbox//gi;			
			}
	
	#print "--> $keyname : " . $cols{$keynamecust} . " - $curfile<BR>";
	}

if ($mod_hid_values ne "") { $mod_display_template =~ s/<\/form>/$mod_hid_values<\/form>/gi; }

if ($q->param('premium') eq "true") 
	{
	$premstr = qq[<input type="hidden" name="premium" value="true">];
	$mod_display_template =~ s/<\/form>/$premstr<\/form>/gi; 
	}

$mod_display_template =~ s/!!error_text!!/$tmerror/gi;
print $mod_display_template;
exit;

}



sub display_inbound_text
{

my ($worktemplate, $start_crit, $end_crit, $blankval) = @_;
my ($tmpl_return, $start_tmpl, $end_tmpl, $r1, $r2, $r);

if ($blankval eq "BLANK")
	{
	if ($worktemplate =~ m/\[$start_crit\]/g)
		{
		$r1 = pos($worktemplate);
		$start_tmpl = substr($worktemplate, 0, $r1 - length($start_crit) - 2);
		}

	if ($worktemplate =~ m/\[$end_crit\]/g)
		{
		$r2 = pos($worktemplate);
		$end_tmpl = substr($worktemplate, $r2, length($worktemplate) - $r);
		}
		
		if (($start_tmpl ne "") and ($end_tmpl ne ""))
			{
	 		$tmpl_return = $start_tmpl . $end_tmpl;
	 		}
	 		else
	 		{
	 		$tmpl_return = $worktemplate;
	 		}
	}
else
	{
	$worktemplate =~ s/\[$start_crit\]//gi;
	$worktemplate =~ s/\[$end_crit\]//gi;
	$tmpl_return = $worktemplate;
	}
	
return ($tmpl_return);

}





sub clean_temp_uploaded_files
{

opendir(DDR,"$data_dir/tmp");
@bdfiles = readdir(DDR);
closedir (DDR); 


foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item); 
	
	if ($numberfield eq "Upload")
		{
			$testfile = $lnkid . "_" . $keyname . ".";
			
			foreach $item (@bdfiles)
				{
				if (substr($item, 0, length($testfile)) eq $testfile)
					{
					unlink ("$data_dir/tmp/$item");
					}
				
				}
		}
	}

}





sub mkdirps
{
my ($dir_to_create) = @_;

if ((-e $dir_to_create) < 1) 
	{
	mkdir ($dir_to_create, $default_permissions) || die ("No permission to create directory: $dir_to_create");
	chmod($default_permissions,$dir_to_create); 
	}

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

