#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use htbuild;
use pseek;
use fmspm;


&get_setup;
fmspm::check_spamb("rgs_logout.cgi", "header", "$data_dir");
$q = CGI->new;

################

$query = new CGI;

$usercookie = $query->cookie('cpuser');
$passcookie = $query->cookie('cppass');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }   

$usercookie = $dbh->quote($usercookie);
$passcookie = $dbh->quote($passcookie);

$sth = $dbh->prepare("SELECT fbid FROM lnkusers WHERE rgsuser = $usercookie AND rgspass = $passcookie ");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}  
$rows = $sth->rows();

		while ( @row = $sth->fetchrow() )
			{
				$fbid = $row[0];
			}

$sth->finish;
$dbh->disconnect;


if ($fbid > 0) ### facebook user
	{
	
	$gsettings = new_gsettings pseek;
	$facebookappid = $gsettings->{facebookappid};
	
	$headhtml = qq[
	
	<div id="fb-root"></div>
	<script src="http://connect.facebook.net/en_US/all.js"></script>

	<script language="JavaScript">
	
		FB.init({  apiKey : '$facebookappid' });
		FB.getLoginStatus(handleSessionResponse);

	 function handleSessionResponse(response) 
	 {
    // if we dont have a session (which means the user has been logged out, redirect the user)

    	if (!response.session) 
    	{
    	
    	FB.logout(function(response) { 
		                             window.location = "$script_url/rgs_login.cgi"; 
		                            }); 

    	}

	    //if we do have a non-null response.session, call FB.logout(),
	    //the JS method will log the user out
	    //of Facebook and remove any authorization cookies
	  FB.logout(handleSessionResponse);
	}
		
	</script>
	];

	
	}



################# 

$thecookie1 = $query->cookie(-name=>'cpuser',
			    					  -value=>"",
			    					  -expires=>'+24h',
			    					  -path=>'/');
	
$thecookie2 = $query->cookie(	-name=>'cppass',
			    						-value=>"",
			    						-expires=>'+24h',
			    						-path=>'/');
	
print $query->header(-cookie=>[$thecookie1, $thecookie2]); 


$cp_template = pseek::get_file_contents("$data_dir/rgs_logout.html");
$cp_template = pseek::ts_insert_template_includes($cp_template);
$cp_template = pseek::fill_vars($cp_template);
$cp_template = pseek::fill_cp_vars($cp_template);

$cp_template =~ s/<head>/<head>$headhtml/gi;

print $cp_template;	




################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

