#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;

use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	sn_fmspm::check_spamb("sn_flogin.cgi", "header", $data_dir);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################


#print "Content-type: text/html\n\n";
#print "-WEB_URL> $web_url<BR>";
#print "-SCRIPT_URL> $scripts_url<BR>";
#print "-ADMIN_URL> $scripts_admin<BR>";
#print "-FILE_LOCKING> $flocking<BR>";
#print "-RSTS> $rsts<BR>";
#print "-WEB_DIR> $web_path<BR>";
#print "-SENDMAIL> $sendmail_loc<BR>";
#print "-MAIL_METHOD> $mail_method<BR>";
#print "-SMTP_SERVER> $smtp_server<BR>";
#print "-USERNAME> $c_username<BR>";
#print "-PASSWORD> $c_password<BR>";
#print "-DATA_DIR> $data_dir<BR>";


if ($q->param('fct') eq "access_psprotected_forum") {&start;}

####################################


sub start
{

$query = CGI->new;

$fid = $q->param('fid');
$cid = $q->param('cid');	

sn_netbbs::check_input($fid);
sn_netbbs::check_input($cid);



$passval = $q->param('forum_password');

$fcookie = $cid . "_" . $fid . "_" . "FORUMPASS";

#SET COOKIE;
$thecookie1 = $query->cookie(-name=>$fcookie,
			    				 -value=>$passval,
			    				 -expires=>'+1h',
			    				 -path=>'/');

print $query->header(-cookie=>[$thecookie1]);

#######

$settings_data = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
(@forum_settings) = split(/\n/,$settings_data);



if ($forum_settings[11] ne "$passval")
	{
	$frdta = &get_file_contents("$data_dir/sn_settings.dat");
	@settings = split (/\n/,$frdta);
	$retv = sn_netbbs::check_forum_password($settings_data, $cid, $fid, "error1");
	}
	else
	{
	
print <<END_OF_LOGININ;
<html>
<head>
<title>Logging in</title>
</head>
<body>

<script language="JavaScript">
<!--
window.location = "$scripts_url/sn_forum.cgi?fct=gotoforum&fid=$fid&cid=$cid"
// -->
</script>

</body>
</html>

END_OF_LOGININ

	}

}

