#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
#use strict;
use Time::Local;
use sn_netbbs;
use sn_fmspm; 

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 

#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc 
				$web_path $flocking/;

$q = CGI->new;




## READ CONFIGURATION ###############################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	sn_fmspm::check_spamb("sn_forump.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

if ($q->param('fct') eq "postmessage") {&postmessage; exit;}
if ($q->param('fct') eq "postreply") {&postmessage; exit;}

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&post_scr; exit;}
if ($q->param('fct') eq "reply") {&post_scr; exit;}
if ($q->param('fct') eq "emoticons") {&emoticons; exit;}


################################################################


sub emoticons
{

my (@settings);

(@settings) = sn_netbbs::get_global_settings;

$template = sn_netbbs::get_file_contents("$data_dir/sn_msgtags.html");
$ptitle = sn_netbbs::get_page_title("sn_msgtags");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

$globalframe =~ s/!!forums!!/$template/g;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 

$locationd = sn_netbbs::get_location($settings[11],$cid, $fid);
$globalframe =~ s/!!location!!/$locationd/g;


$forumlogo = $forumsettings[8];
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 

$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 

$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe;


}







sub postmessage 
{

my ($cid, $fid, $catname, $template, @settings, $ftop, @usettings, $error_text, $ccds,
	 $fs, @fmsettings, $ausern);

$cid = $q->param('cid');
$fid = $q->param('fid');

sn_netbbs::check_input($cid);
sn_netbbs::check_input($fid);

if ((-e "$data_dir/$cid/$fid/config.dat") < 1)
	{
	sn_netbbs::fatal_error("Invalid Forum / Category or Message");
	}

#### FORUM SETTINGS
$fs = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fmsettings = split (/\n/, $fs);

#if ($q->param('username') eq "")
#	{
#	$error_text = "You have to supply a user name in order to post a message.";
#	}


if ($q->param('fct') eq "postmessage")
 {
 if ($q->param('messagetopic') eq "")
	{
	#$error_text = "You have to supply a message topic in order to post a message.";
	print "Content-type: text/html\n\n";
	&post_scr("error2"); exit;
	}
 }

if ($q->param('message') eq "")
	{
	#$error_text = "You have to supply a message in order to post a message.";
	print "Content-type: text/html\n\n";
	&post_scr("error3"); exit;
	}




### CHECK IF USER IS LOGGED IN

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false

	if ($logged_in_status eq "false") 
	{
	print "Content-type: text/html\n\n";
	&post_scr("error1"); exit;
	}


@usettings = sn_netbbs::check_username_password($uname, $upass);
if ($usettings[0] eq "ERROR")
	{
	print "Content-type: text/html\n\n";
	print "Fatal Error: The user account you are trying to post with doesn't exist.";
	}


if ($fmsettings[4] eq "Moderators")
	{
	if ((substr($usettings[12], 0, 2) ne "Ad") and (substr($usettings[12], 0, 2) ne "Mo"))
		{
		print "Content-type: text/html\n\n";
		&post_scr("error4"); exit;
		}
	}



### GET SETTINGS

$catname = &get_cat_name($cid);
(@settings) = sn_netbbs::get_global_settings;

print "Content-type: text/html\n\n";
	
	if ($q->param('preview') eq "Y")
	{
	&preview_message;
	}
	else
	{
	&postmessage2;
	}
  

}





sub preview_message
{

my ($ftop, $cid, $fid, $tid, $catname, $template, @settings, $messagetopic, $message,
	 $icong, $signature, $notification, $preview, $username, $password, $fct, $messager,
	 $ud, @udetails, $timep, $mstdisplay, $iuser, $ccds, $uicon, $fdta, @forumsettings,
	 $crit);

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');

$catname = &get_cat_name($cid);

#if ((-e "$data_dir/$cid/$fid/cust_tmpl.dat") > 0)
#	{
#	$tmpl_to_open = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/cust_tmpl.dat");
#	$tmpl_to_open = "$data_dir/custom_templates/$tmpl_to_open";
#	$template = sn_netbbs::get_file_contents($tmpl_to_open);
#	}
#	else
#	{
#	$template = sn_netbbs::get_file_contents("$data_dir/template.html");	
#	}


$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$template = sn_netbbs::get_file_contents("$data_dir/sn_post_reply_prev.html");


if ($q->param('fct') eq "postmessage")
	{
	$post_button = qq[<input src="$web_url/sn_post.gif" type="image">];
	}
	else
	{
	$post_button = qq[<input src="$web_url/sn_postreply.gif" type="image">];
	}
$template =~ s/!!post_message_button!!/$post_button/gi;	

$goback_button = qq[<a href="http://"><img src="$web_url/sn_goback.gif" border="0" onClick="history.go(-1); return false;"></a>];

$template =~ s/!!go_back_button!!/$goback_button/gi;	




(@settings) = sn_netbbs::get_global_settings;
$ftop = sn_netbbs::print_forum_top("Post a New Message", "$catname", "$settings[11]", "REMOVE");

$icong = $q->param('icong');
$signature = $q->param('signature');
$notification = $q->param('notification');
#$username = $q->param('username');
#$password = $q->param('password');

### GET USER INFO

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($username, $password) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($username, $password); ### true / false

	if ($logged_in_status eq "false") 
	{
	print "Content-type: text/html\n\n";
	&post_scr("error1"); exit;
	}
	
############################

$fct = $q->param('fct');

### ICON
if ($icong ne "NONE"){$iuser = "<img src=\"$web_url/icons/$icong\"> ";}


#### GET USER DETAILS

$username =~ s/ /_/g;
$ud = sn_netbbs::get_file_contents("$data_dir/users/$username.dat");
@udetails = split(/\n/, $ud);

#### FORUM SETTINGS
$fdta = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
(@forumsettings) = split(/\n/, $fdta);

$messager = $q->param('message');
$message = $messager;

$crit = chr(34);
$messager =~ s/$crit//g;
$messager =~ s/<\/body>//g;



if ($forumsettings[6] ne "Y")
	{
	$message =~ s/<[^>]*>//g;
	} ### REMOVE HTML

$message =~ s/:\)/<img src="$web_url\/sn_happy.gif">/g;
$message =~ s/;\)/<img src="$web_url\/sn_happy2.gif">/g;
$message =~ s/:o/<img src="$web_url\/sn_ooo.gif">/g;
$message =~ s/\[biggrin\]/<img src="$web_url\/sn_grin.gif">/g;
$message =~ s/\[confused\]/<img src="$web_url\/sn_question.gif">/g;
$message =~ s/\[cool\]/<img src="$web_url\/sn_cool.gif">/g;
$message =~ s/\[award\]/<img src="$web_url\/sn_cup.gif">/g;
$message =~ s/\n/<br>/g;

$message = sn_netbbs::decode_icons($message);

if (($signature eq "Y") and ($udetails[11] ne ""))
	{
	$message = $message . "<br><br>" . $udetails[11];
	}

### GET MSG TOPIC
$timep = time();
$timep = sn_netbbs::decode_date ($timep);

$messagetopic = $q->param('messagetopic');

if ($messagetopic ne "")
	{
	$mstdisplay = "$messagetopic";
	}
	else
	{
	$mstdisplay =  $q->param('reply_to_topic');
	}

if ($q->param('sticky') eq "Y")
	{
	$sttopic = "Y";
	}

$message = sn_netbbs::decode_tags($message);

$template =~ s/!!icon!!/$iuser/gi;

$template =~ s/!!topic!!/$mstdisplay/gi;

$template =~ s/!!message!!/$message/gi;


$hvars = qq[
  <input type="hidden" name="fct" value="$fct">
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="fid" value="$fid">
  <input type="hidden" name="tid" value="$tid">
  <input type="hidden" name="messagetopic" value="$messagetopic">
  <input type="hidden" name="message" value="$messager">
  <input type="hidden" name="icong" value="$icong">
  <input type="hidden" name="signature" value="$signature">
  <input type="hidden" name="notification" value="$notification">
  <input type="hidden" name="username" value="$username">
  <input type="hidden" name="password" value="$password">
  <input type="hidden" name="sticky" value="$sttopic">
];

$template =~ s/<\/form>/$hvars/gi;

$template =~ s/!!post_script!!/$scripts_url\/sn_forump.cgi/gi;

$template =~ s/!!message!!/$mstdisplay/gi;

$template =~ s/!!topic!!/$messagetopic/gi;


if ($udetails[15] =~ /USER_DEFINED/)
	{
	$udetails[15]=~ s/USER_DEFINED//g; 
	$user_image = "<img src=\"$web_url/user_imagesc/$udetails[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}
	elsif ($udetails[15] ne "")
	{
	$user_image = "<img src=\"$web_url/user_images/$udetails[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}
	 	

$template =~ s/!!auth_image!!/$user_image/gi;

$template =~ s/!!auth_icon!!/$iuser/gi;

$template =~ s/!!auth_name!!/$udetails[0]/gi; 

$template =~ s/!!auth_link!!/$scripts_url\/sn_proview.cgi?user=$udetails[0]/gi; 


### GET TITLE SETTINGS

$sbcntr= 0;
open (UFINFO, "$data_dir/sn_usertitles.dat");
	while (defined($tline=<UFINFO>))
		{
		if ($tline ne "")
			{
			($ttval, $mmtitle) = split (/\t/,$tline);
			$titlevalues[$sbcntr] = $ttval;
			$sbcntr++;
			$titlevalues[$sbcntr] = $mmtitle;
			$sbcntr++;
			}
		}
close (UFINFO);


		if ($udetails[14] > $titlevalues[8]) ### 200
			{
			$memberposts = $titlevalues[9];
			$uposts = "<img src=\"$web_url/sn_rank5.gif\">";
			}
		elsif ($udetails[14] > $titlevalues[6]) ### 150
			{
			$memberposts = $titlevalues[7];
			$uposts = "<img src=\"$web_url/sn_rank4.gif\">";
			}
		elsif ($udetails[14] > $titlevalues[4]) ### 100
			{
			$memberposts = $titlevalues[5];
			$uposts = "<img src=\"$web_url/sn_rank3.gif\">";
			}
		elsif ($udetails[14] > $titlevalues[2]) ### 50
			{
			$memberposts = $titlevalues[3];
			$uposts = "<img src=\"$web_url/sn_rank2.gif\">";
			}
		else ### 25
			{
			$memberposts = $titlevalues[1];
			$uposts = "<img src=\"$web_url/sn_rank1.gif\">";
			} 

	$template =~ s/!!mem_icon!!/$uposts/gi;
	$template =~ s/!!mem_name!!/$memberposts/gi;
	


###########

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 

$globalframe =~ s/!!forums!!/$template/g;

$locationd = sn_netbbs::get_location($settings[11],$cid, $fid);
$globalframe =~ s/!!location!!/$locationd/g;

$forumlogo = $forumsettings[8];
$forumlogo = qq[<img src="$web_url/$forumsettings[8]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 

$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 


$globalframe =~ s/!web_url!/$web_url/g;


$ptitle = sn_netbbs::get_page_title("sn_post_reply_prev");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

print $globalframe;

exit;


}






sub postmessage2
{

my ($cid, $fid, $pfile, $newtopic, $newid, $username, $messagetopic, $message, $icong,
	 $signature, $notification, $preview, $timep, @udetails, $ud, $catname, $template, 
	 @settings, $ftop, $forumname, $tid, $tdata, $fdta, @forumsettings, $password, $cookval,
	 @remails, @gfsettings, $gfs, $userfn, $ip, $ccds, @usettings, $topic_file, @rtdata,
	 $topic_line, @to_items, $new_topic_thread, $topic_to_move, $stats_file, @mstat_lines,
	 $stat_line_counter, $stat_line_to_move, $alltstats, $mdisplay, $countf, $moderdata, $userstatus,
	 @all_moderators, $rens, $mod_user_conf, @muserconf, $modmessage, $fname, $acnt, $mtid, $messagetopic2);

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');

$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
@gfsettings = split (/\n/, $gfs);

@usettings = sn_netbbs::check_username_password($uname, $upass);
$username = $usettings[0];
$password = $upass;

if ($tid eq "")
	{
	$newid = sn_netbbs::increment_id;
	$tid = $newid;
	}


###################################################################
### GET FORUM SETTINGS

$fdta = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
(@forumsettings) = split(/\n/, $fdta);


###################################################################
### WRITE TOPIC

$messagetopic = $q->param('messagetopic');
$messagetopic =~ s/<[^>]*>//g;
$messagetopic =~ s/\n//g;

$message = $q->param('message');
$icong = $q->param('icong');
$signature = $q->param('signature');
$notification = $q->param('notification');
$preview = $q->param('preview');
$timep = time();
if ($icong eq "NONE") {$icong = "";}


		### GET USER DETAILS
		if ($password ne "")
	   {
	   $username = $usettings[0];
		$userfn = $usettings[0];
		$userfn =~ s/ /_/g;
		$ud = sn_netbbs::get_file_contents("$data_dir/users/$userfn.dat");
		@udetails = split(/\n/, $ud);
		$udetails[12] = substr($udetails[12], 0, 2);
		
		
		
		### INCREMENT POST NUMBER AND WRITE USER DETAILS
		$udetails[14]++;
		open (THEUFILE, "> $data_dir/users/$userfn.dat");
		 if ($flocking ne "No"){flock (THEUFILE,2);}
			print THEUFILE 	$udetails[0] . "\n" . 
									$udetails[1] . "\n" . 
									$udetails[2] . "\n" . 
									$udetails[3] . "\n" . 
									$udetails[4] . "\n" . 
									$udetails[5] . "\n" . 
									$udetails[6] . "\n" . 
									$udetails[7] . "\n" . 
									$udetails[8] . "\n" . 
									$udetails[9] . "\n" . 
									$udetails[10] . "\n" . 
									$udetails[11] . "\n" . 
									$udetails[12] . "\n" . 
									$udetails[13] . "\n" . 
									$udetails[14] . "\n" .
									$udetails[15] . "\n" .
									$udetails[16] . "\n";
		 if ($flocking ne "No"){flock (THEUFILE,8);}
		close (THEUFILE);
		}
		else
		{
		$notification = "N";
		}

@all_moderators = sn_netbbs::get_moderators($forumsettings[3]);

if (substr($udetails[12], 0, 2) ne "Ad")
{
	foreach $mdline (@all_moderators)
	{
	if (lc($mdline) eq lc($username)) { $mdst = "true"; }
	}
	#if ($mdst ne "true") {$udetails[12] = "Me";}
}
elsif (substr($udetails[12], 0, 2) eq "Ad")
	{
	$mdst = "true";
	}



#print "===> $forumsettings[3] - $udetails[12]";

$userstatus = substr($udetails[12], 0, 2);
if (($userstatus eq "Mo") or ($userstatus eq "Ad"))
	{
	if ($mdst eq "true")
		{
		if ($q->param('sticky') eq "Y") {$stickyt = "Y";}
		}
	$forumsettings[7] = "N";
	}



### IF MODERATED
if ($forumsettings[7] eq "Y")
		{
		$moderdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
		@mcnt = split (/\n/, $moderdata);
				
		$countf = @mcnt;
		if ($countf eq "") { $countf = 0; }
		$countf++;
		
		open (TWRITE, "> $data_dir/$cid/$fid/mtopics.cnt");
		 if ($flocking ne "No"){flock (TWRITE,2);}
			print TWRITE $countf;
		 if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);
		$mdisplay = "Y";

		if ($q->param('fct') ne "postmessage")
				{
				$mcontent = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.dat");
				@etmc = split (/\n/, $mcontent);
				$repnumber = @etmc;
				
				@lfmt = split (/\t/, $etmc[0]);
				$messagetopic = $lfmt[0];
				}
				else
				{
				$repnumber = 0;
				}

		$moderdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
		
		$moderdata= $tid . "\t" . 				### 0 TOPIC ID
						$repnumber . "\t" . 		### REPLY NUMBER
						$username . "\t" . 		### 1 USER
						$messagetopic . "\t" . 	### 2 MESSAGE TOPIC
						$timep . "\n" .			### 3 DATE TIME
						$moderdata;

		open (TWRITE, "> $data_dir/$cid/$fid/moderate.dat");
		 if ($flocking ne "No"){flock (TWRITE,2);}
			print TWRITE $moderdata;
		 if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);
		}


####################################################################
### GET TOPIC DATA

	$topic_file = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
	@rtdata = split (/\n/, $topic_file);

	$stats_file = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
	@mstat_lines = split (/\n/, $stats_file);


###################################################################
### WRITE TO TOPIC TABLE IF NEW TOPIC

if ($q->param('fct') eq "postmessage")
 {
 
	### PREPARE TOPIC ENTRY
	$newtopic = "$newid" . "\t" . 			 			 ## 0 TOPIC ID
					"$username" . "\t" . 					 ## 1 USER
					"$udetails[2]" . "\t" . 	          ## 2 USER EMAIL
					"$messagetopic" . "\t" . 				 ## 3 MESSAGE TOPIC
					"$icong" . "\t" . 					    ## 4 ICON
					"$notification" . "\t" .   			 ## 5 RECEIVE NOTIFICATION ON REPLY
					"1" . "\t" . 								 ## 6 (2 = LOCKED TOPIC)
					"$timep" . "\t" .							 ## 7 TIME POSTED
					substr($udetails[12], 0, 2) . "\t" . ## 8 USER STATUS (Mo=Moderator, Ad=Administrator, Me=Member)
					$mdisplay . "\t" .						 ## 9 Y = MODERATED (DON'T DISPLAY) / OK TO DISPLAY)
					$stickyt . "\n";							 ## 10 STICKY TOPIC (Y/N)


	### PREPARE TOPIC STATS
	$newstats =	$tid . "\t" . 				### TOPIC ID
					"1" . "\t" . 				### NUMBER OF POSTS
					"0" . "\t" .				### VIEWS
					"$timep" . "\t" .  		### LAST POST
					"$username" . "\n";		### USER


	### CHECK FOR STICKY TOPICS
	$tcounter = 0;
	foreach $topic_line (@rtdata)
		{
		@to_items = split (/\t/, $topic_line);
		if ($to_items[10] eq "Y")
			{
			$sticky_topic_data = $sticky_topic_data . "$topic_line" . "\n";
			$sticky_topic_stats = $sticky_topic_stats . $mstat_lines[$tcounter] . "\n";
			}
			else
			{
			$all_topic_data = $all_topic_data . $topic_line . "\n";
			$all_stat_data = $all_stat_data . $mstat_lines[$tcounter] . "\n";
			}
		$tcounter++;
		}

$all_topic_data = $newtopic . $all_topic_data;
$all_stat_data = $newstats . $all_stat_data;

if ($sticky_topic_data ne "")
	{
	$all_topic_data = $sticky_topic_data . $all_topic_data;
	$all_stat_data = $sticky_topic_stats . $all_stat_data;
	}

open (TWRITE, "> $data_dir/$cid/$fid/topics.dat");
 if ($flocking ne "No"){flock (TWRITE,2);}
	print TWRITE $all_topic_data;
 if ($flocking ne "No"){flock (TWRITE,8);}
close (TWRITE);

##########

open (TOPICSTATS, "> $data_dir/$cid/$fid/tstats.dat");
 if ($flocking ne "No"){flock (TOPICSTATS,2);}
	print TOPICSTATS $all_stat_data;
 if ($flocking ne "No"){flock (TOPICSTATS,8);}
close (TOPICSTATS);

 }




###################################################################
### MOVE TOPIC TO TOP IF SET AND THIS IS A REPLY

if (($q->param('fct') eq "postreply") and (lc($gfsettings[15]) eq "y"))
	{
	$stat_line_counter = 0;
	
	foreach $topic_line (@rtdata)
		{
		@to_items = split (/\t/, $topic_line);
		
			if ($to_items[10] eq "Y")
				{
				$sticky_topic_data = $sticky_topic_data . "$topic_line" . "\n";
				$sticky_topic_stats = $sticky_topic_stats . $mstat_lines[$stat_line_counter] . "\n";
				}
			elsif ($to_items[0] == $tid)
				{
				$topic_to_move = $topic_line . "\n";
				$stat_line_to_move = $mstat_lines[$stat_line_counter] . "\n";
				}
			else
				{
				$new_topic_thread = $new_topic_thread . $topic_line . "\n";
				$alltstats = $alltstats . $mstat_lines[$stat_line_counter] . "\n";
				}
		
		$stat_line_counter++;
		}
	
	$new_topic_thread = $topic_to_move . $new_topic_thread;
	$alltstats = $stat_line_to_move . $alltstats;

if ($sticky_topic_data ne "")
	{
	$new_topic_thread = $sticky_topic_data . $new_topic_thread;
	$alltstats = $sticky_topic_stats . $alltstats;
	}

	### 
	
	open (TWRITE, "> $data_dir/$cid/$fid/topics.dat");
	 if ($flocking ne "No"){flock (TWRITE,2);}
		print TWRITE $new_topic_thread;
	 if ($flocking ne "No"){flock (TWRITE,8);}
	close (TWRITE);
	
	### MOVE STATS

	open (TWRITE, "> $data_dir/$cid/$fid/tstats.dat");
	 if ($flocking ne "No"){flock (TWRITE,2);}
		print TWRITE $alltstats;
	 if ($flocking ne "No"){flock (TWRITE,8);}
	close (TWRITE);	
	
	}



###################################################################
### MODERATOR NOTIFICATION

$fname = sn_netbbs::get_cat_name($cid);
$fname =~ s/\n//g;
$fname = $fname . " : " . sn_netbbs::get_forum_name($cid, $fid);

#@all_moderators = sn_netbbs::get_moderators($forumsettings[3]);
#$acnt = @all_moderators;

	$rpm = $q->param('rpm') + 1;

	if ($newid eq "") ### REPLY
		{
		$mtid = $tid;
	   $messagetopic2 =  $q->param('reply_to_topic');
		
#		$modmessage = "You have indicated that you would like to receive moderator notification of new replies posted in the forums of '$gfsettings[11]'. Below is a new reply that has been posted.\n\n";
#	   $modmessage = $modmessage . "Posted In: $fname\n";
#		$modmessage = $modmessage . "Posted By: $username / $udetails[2]\n";   
#	   $modmessage = $modmessage . "Reply: " . $q->param('reply_to_topic') . "\n";
#	   $modmessage = $modmessage . "====================\n";
#	   $modmessage = $modmessage . "$message\n\n";

		} 
	else ### NEW TOPIC
		{
		$mtid = $newid;
	   #$modmessage = $modmessage . "$message\n\n";
		$messagetopic2 = $messagetopic;
		
#		$modmessage = "You have indicated that you would like to receive moderator notification of new messages/replies posted in the forums of '$gfsettings[11]'. Below is a new message that has been posted.\n\n";
#	   $modmessage = $modmessage . "Posted In: $fname\n";
#		$modmessage = $modmessage . "Posted By: $username / $udetails[2]\n";   
#	   $modmessage = $modmessage . "Topic: $messagetopic2\n";
#	   $modmessage = $modmessage . "====================\n";

		}

	
	($fromname, $fromemail, $emailsubject, $notific) = sn_netbbs::get_email_details("sn_modnotify.eml");

	$emailsubject =~ s/!!msgtopic!!/$messagetopic2/gi;
	
	$notific =~ s/!!forum_name!!/$gfsettings[11]/gi;
	$notific =~ s/!!forum!!/$fname/gi;
	$notific =~ s/!!posted_by!!/$username/gi;
	$notific =~ s/!!posted_email!!/$udetails[2]/gi;
	$notific =~ s/!!msgtopic!!/$messagetopic2/gi;
	$notific =~ s/!!message!!/$message/gi;
	
	$viewlink = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$mtid&all=all";
	$notific =~ s/!!viewlink!!/$viewlink/gi;

	$replylink = "$scripts_url/sn_forump.cgi?fid=$fid&cid=$cid&tid=$mtid&fct=reply";
	$notific =~ s/!!post_reply!!/$replylink/gi;

	$editlink = "$scripts_url/sn_forume.cgi?fid=$fid&cid=$cid&tid=$mtid&rpm=$rpm";
	$notific =~ s/!!edit!!/$editlink/gi;

	#$modmessage = $modmessage . "To view the message go to:\n";
	#$modmessage = $modmessage . "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$mtid&all=all\n\n";

	#$modmessage = $modmessage . "To post a reply in this message, go to:\n";
	#$modmessage = $modmessage . "$scripts_url/sn_forump.cgi?fid=$fid&cid=$cid&tid=$mtid&fct=reply\n\n";

	#$modmessage = $modmessage . "To edit this message, go to:\n";
	#$modmessage = $modmessage . "$scripts_url/sn_forume.cgi?fid=$fid&cid=$cid&tid=$mtid&rpm=$rpm\n\n";


foreach $rens (@all_moderators)
	{
	
	opendir(DIR,"$data_dir/users");
	@alusers = readdir(DIR);
	closedir(DIR);
	
		foreach $filename(@alusers)
			{
			$filename =~ s/\.dat//g;
			if (lc($filename) eq lc($rens))
				{
				$rens = $filename;
				}
			}
	
		#print "==> $rens<BR>";
		
		$rens =~ s/ /_/g;
	
		$mod_user_conf = sn_netbbs::get_file_contents("$data_dir/users/$rens.dat");
		
		@muserconf = split (/\n/, $mod_user_conf);
		
		

		if ($muserconf[16] eq "15MODERATOR_MESSAGE_NOTIFICATION=Y")
			{
				
				sn_netbbs::send_email($sendmail_loc,  										### LOCATION OF SENDMAIL
											$fromname,  											### SENDER NAME
											$fromemail,	 											### FROM EMAIL
											$muserconf[2], 										### TO EMAIL ADDRESS
											$emailsubject, 										### SUBJECT
											$notific);												### MESSAGE

			}
		
	}


###################################################################
### WRITE MSG

if ($q->param('fct') eq "postmessage")
 {
  open (TWRITE, "> $data_dir/$cid/$fid/$newid.dat");
    if ($flocking ne "No"){flock (TWRITE,2);}
 }
 else
 {
  &get_reply_emails("$data_dir/$cid/$fid/$tid.dat", $gfsettings[11], $gfsettings[12], $forumsettings[1], $fid, $cid, $tid);
  open (TWRITE, ">> $data_dir/$cid/$fid/$tid.dat");
  	 if ($flocking ne "No"){flock (TWRITE,2);}
 }


	## WRITE MESSAGE
	
	$ip = $ENV{'REMOTE_ADDR'};
	
	if ($forumsettings[6] ne "Y")
		{
		$message =~ s/<[^>]*>//g;
		} ### REMOVE HTML
	
	$message =~ s/\n/<br>/g;
	
	## MESSAGE ICONS
	$message =~ s/:\)/<img src="$web_url\/sn_happy.gif">/g;
	$message =~ s/;\)/<img src="$web_url\/sn_happy2.gif">/g;
	$message =~ s/:o/<img src="$web_url\/sn_ooo.gif">/g;
	$message =~ s/\[biggrin\]/<img src="$web_url\/sn_grin.gif">/g;
	$message =~ s/\[confused\]/<img src="$web_url\/sn_question.gif">/g;
	$message =~ s/\[cool\]/<img src="$web_url\/sn_cool.gif">/g;
	$message =~ s/\[award\]/<img src="$web_url\/sn_cup.gif">/g;

	## SIGNATURE
	if ($q->param('signature') eq "Y") {$message = $message . "<br><br>$udetails[11]";}

   #$start_qtable = "<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\" bgcolor=\"$settings[5]\"><tr><td width=\"100%\"><table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\"><tr><td bgcolor=\"$settings[2]\" height=\"27\" width=\"741\">";
   #$end_qtable = "</td></tr></table></td></tr></table>";
	#$message =~ s/\[StartQuote\]/$start_qtable/g;
	#$message =~ s/\[StartQuote\]/$end_qtable/g;
	#$message =~ s/\[EndQuote\]/<\/i>/g;
	
	if ($forumsettings[7] eq "Y") {$mdisplay = "Y";} else {$mdisplay = "N";} 
	
	print TWRITE 	"$messagetopic" . "\t" . 	## 0 MESSAGE TOPIC
						"$username" . "\t" . 		## 1 USER
						"$udetails[2]" . "\t" . 	## 2 USER EMAIL
						"$icong" . "\t" . 			## 3 ICON
						"$notification" . "\t" .   ## 4 RECEIVE NOTIFICATION ON REPLY
						"1" . "\t" . 					## 5 MESSAGES IN TOPIC
						"$timep" . "\t" .				## 6 TIME POSTED
						"$message" . "\t" .			## 7 MESSAGE
						"$ip" . "\t" .					## 8 IP ADDRESS
						"$mdisplay" . "\n";			## 9 Y = MODERATED (DON'T DISPLAY) / OK TO DISPLAY)
						
 if ($flocking ne "No"){flock (TWRITE,8);}
close (TWRITE);



###################################################################
#### WRITE STATS

if ($q->param('fct') eq "postreply")
 {
	if ($forumsettings[7] ne "Y")
			{

			 												 ### PLUS POSTS  ### PLUS VIEWS
			sn_netbbs::write_stats($cid, $fid, $tid, "1", "0", $timep, $username);
			}
 }


##### WRITE LAST MSG DATA
open (LMSGD, "> $data_dir/sn_last.dat");
 if ($flocking ne "No"){flock (LMSGD,2);}
	print LMSGD $timep . "\t" . $username;
 if ($flocking ne "No"){flock (LMSGD,8);}
close (LMSGD);

open (LMSGD, "> $data_dir/$cid/$fid/sn_last.dat");
 if ($flocking ne "No"){flock (LMSGD,2);}
	print LMSGD $timep . "\t" . $username;
 if ($flocking ne "No"){flock (LMSGD,8);}
close (LMSGD);



###################################################################
##### DUMP POSTED PAGE 
###################################################################

$catname = &get_cat_name($cid);

#if ((-e "$data_dir/$cid/$fid/cust_tmpl.dat") > 0)
#	{
#	$tmpl_to_open = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/cust_tmpl.dat");
#	$tmpl_to_open = "$data_dir/custom_templates/$tmpl_to_open";
#	$template = sn_netbbs::get_file_contents($tmpl_to_open);
#	}
#	else
#	{
#	$template = sn_netbbs::get_file_contents("$data_dir/template.html");	
#	}



	
(@settings) = sn_netbbs::get_global_settings;
#$ftop = sn_netbbs::print_forum_top("Post a New Message", "$catname", "$settings[11]", "REMOVE");



######



if (($forumsettings[7] eq "Y") and (substr($udetails[12], 0, 2) ne "Ad") and (substr($udetails[12], 0, 2) ne "Mo"))
	{
#$mtext = sn_netbbs::get_file_contents("$data_dir/moderated.txt");
#$goto_topic = <<END_OF_MM;
#<li>
#<font face="$settings[6]" size="1">
#$mtext<br><br>
#</font>
#</li>
#END_OF_MM
	
	$template = sn_netbbs::get_file_contents("$data_dir/sn_post_success_mod.html");
	$ptitle = sn_netbbs::get_page_title("sn_post_success_mod");
	}
	else
	{
	$template = sn_netbbs::get_file_contents("$data_dir/sn_post_success.html");
	$ptitle = sn_netbbs::get_page_title("sn_post_success");
	}


#if (($forumsettings[7] ne "Y") or ($q->param('fct') eq "postreply"))
# {
#$goto_topic = $goto_topic . <<END_OF_GTOPIC;
#    <li><p align="left"><a
#      href="$scripts_url/sn_forumr.cgi?fid=$fid&amp;cid=$cid&amp;tid=$tid&pg=1&sc=20">
#      <font face="$settings[6]" size="1">Go to the topic where you posted the message</font></a></p>
#    </li>
#END_OF_GTOPIC
# $template = sn_netbbs::get_file_contents("$data_dir/sn_post_success.html");
# }
# else
# {
# $template = sn_netbbs::get_file_contents("$data_dir/sn_post_success_mod.html");
# }




$goto_topic = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tid&pg=1&sc=20";
$template =~ s/!!topic_link!!/$goto_topic/gi;

$template =~ s/!!posted_forum_name!!/$forumsettings[1]/gi;
$goto_forum = "$scripts_url/sn_forum.cgi?fid=$fid&cid=$cid&fct=gotoforum";
$template =~ s/!!posted_forum_link!!/$goto_forum/gi;

$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;


$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 

$globalframe =~ s/!!forums!!/$template/g;


$locationd = sn_netbbs::get_location($settings[11],$cid, $fid);
$globalframe =~ s/!!location!!/$locationd/g;


$forumlogo = $forumsettings[8];
$forumlogo = qq[<img src="$web_url/$forumsettings[8]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 

$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 

$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe;

}





sub post_scr
{

my ($display_error) = @_;

my ($template, @settings, $ftop, $cid, $fid, $catname, $emicons,  
	 $fline, $scnt, $nbfct, $boxtext, $rfile,
	 @titems, $tid, $topictitle, $htext, @rawc, $item2, $key, $val, %cookies, $uname, $upass,
	 $rpm, $qmsg, $ccds, $whopost, $fdta, @forumsettings, $whopostb, $iprval, $tdata, 
	 @topics, $item, $htmluse, $tcount, $trpm, $alltstats, @astat, @stati, $rpm);


$cid = $q->param('cid');
$fid = $q->param('fid');
$nbfct = $q->param('fct');
$tid = $q->param('tid');
$rpm = $q->param('rpm');


sn_netbbs::check_input($cid);
sn_netbbs::check_input($fid);

if ($tid ne "") 
	{
	sn_netbbs::check_input($tid); 

		if ((-e "$data_dir/$cid/$fid/$tid.dat") < 1)
		{
		sn_netbbs::fatal_error("Invalid Forum / Category or Message");
		}
	
	}

if ((-e "$data_dir/$cid/$fid/config.dat") < 1)
	{
	sn_netbbs::fatal_error("Invalid Forum / Category or Message");
	}


if ($q->param('fct') eq "postreply") { 	$nbfct = "reply"; 	} ### IF REPLY ERROR




#### GET TEMPLATES
if ($nbfct eq "reply") ## IF REPLY or NEW TOPIC
	{
	$template = sn_netbbs::get_file_contents("$data_dir/sn_post_reply.html");
	$ptitle = sn_netbbs::get_page_title("sn_post_reply");
	}
	else
	{
	$template = sn_netbbs::get_file_contents("$data_dir/sn_post_topic.html");
	$ptitle = sn_netbbs::get_page_title("sn_post_topic");
	}


$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

### LOCK TOPIC CHECK
$tdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@topics = split (/\n/, $tdata);

$alltstats = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@astat = split (/\n/, $alltstats);

$tcount = 0;

open (TOPICF, "$data_dir/$cid/$fid/topics.dat");
	foreach $item (@topics)
		{
		(@titems) = split (/\t/, $item);
			if (($titems[0] == $tid) and ($titems[6] == 2)) ## IF TOPIC LOCKED
				{
print "<html><head><title></title></head><body>
<script language=\"JavaScript\">
<!--
window.location = \"$scripts_url/sn_forum.cgi\"
// -->
</script></body></html>";
close (TOPICF);
exit;
				}

		if ($titems[0] == $tid)
			{
			$trpm = $astat[$tcount];
			@stati = split (/\t/, $trpm);
			$trpm = $stati[1];
			}


		$tcount++;
		}
close (TOPICF);



###########

if ($rpm ne "")
	{
	$qmsg = &getmessage($rpm, $fid, $cid, $tid);
	}

$catname = &get_cat_name($cid);


### TEMPLATE INCLUDES
#$template = sn_netbbs::get_template_includes($template, "POST_PAGE");


### GET SETTINGS
(@settings) = sn_netbbs::get_global_settings;

#$ftop = sn_netbbs::print_forum_top("Post a New Message", "$catname", "$settings[11]");
#$ftop =~ s/!!page_data!!//g;
#$ftop =~ s/!!right_dscrit!!//g;



### CHECK IP
$iprval = &check_ip;
if ($iprval eq "true")
	{

$blockedmsg = <<END_OF_BANNED;
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#FFFFFF"
height="46" style="border: 1px solid rgb(214,214,214)">
  <tr>
    <td width="100%" height="35" background="$web_url/sn_bar6.gif"><p align="left"><font
    face="Verdana" size="2"><strong>You don't have access to post in this forum</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF" valign="top"><font face="Verdana" size="2">Unable to
    post message</font></td>
  </tr>
</table>
END_OF_BANNED

	$globalframe =~ s/!!forums!!/$blockedmsg/gi;

	$globalframe =~ s/!!login_script!!/$scripts_url\/sn_login.cgi/g;
	
 	$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
	@gfsettings = split (/\n/, $gfs);

	$forumlogo = qq[<img src="$web_url/$gfsettings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/g;


	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
 
 	$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 

	$globalframe =~ s/!web_url!/$web_url/g; 	
	
	print $globalframe;
	exit;
	}



$fdta = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
(@forumsettings) = split(/\n/, $fdta);


### FIGURE OUT IF POST OR REPLY

if ($nbfct eq "reply")
	{
	$rfile = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.dat");
	@titems = split (/\t/, $rfile);
	
	$htext = qq[<input type="hidden" name="fct" value="postreply">
	<input type="hidden" name="reply_to_topic" value="$titems[0]">
	<input type="hidden" name="rpm" value="$trpm">
	<input type="hidden" name="cid" value="$cid">
	<input type="hidden" name="fid" value="$fid">
	<input type="hidden" name="tid" value="$tid">
	];
	
	$template =~ s/!!reply_topic!!/$titems[0]/gi;
	}
	else
	{
	$topictitle = "<tr><td width=\"25%\" bgcolor=\"$settings[3]\"><font face=\"$settings[6]\" size=\"2\"><strong>Topic:<br></strong></font></td>
	<td width=\"75%\" bgcolor=\"$settings[4]\">&nbsp;<input type=\"text\" name=\"messagetopic\" size=\"47\" style=\"font-family: MS Sans Serif; font-size: 8pt\" maxlength=\"65\"></td></tr>";
	$htext = qq[<input type="hidden" name="fct" value="postmessage">
	<input type="hidden" name="cid" value="$cid">
	<input type="hidden" name="fid" value="$fid">
	<input type="hidden" name="fct" value="postmessage">
	];
	}



####### GET COOKIES AND CHECK IF USER IS LOGGED IN
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false


	#### IF NOT LOGGED IN
	
	if (($logged_in_status eq "false") and ($display_error ne "error1"))
	{
	$loggedin_tmpl = sn_netbbs::get_file_contents("$data_dir/sn_not_logged_in.html");
	$ptitle = sn_netbbs::get_page_title("sn_not_logged_in");
	
	if ($nbfct eq "reply")
		{
		$aval = "reply";
		}
		else
		{
		$aval = "postnew";
		}
	
	$hvars = qq[
	<input type="hidden" name="fct" value="login">
	<input type="hidden" name="l" value="$aval">
	<input type="hidden" name="cid" value="$cid">
	<input type="hidden" name="fid" value="$fid">
	<input type="hidden" name="tid" value="$tid">
	<input type="hidden" name="rpm" value="$rpm">
	</form>
	];
	
	$loggedin_tmpl =~ s/<\/form>/$hvars/gi;
	
	$globalframe =~ s/!!forums!!/$loggedin_tmpl/gi;

	$globalframe =~ s/!!login_script!!/$scripts_url\/sn_login.cgi/g;
	
	$forumlogo = qq[<img src="$web_url/$forumsettings[8]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/g;
 	
 	$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
	@gfsettings = split (/\n/, $gfs);

	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
 
 	$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 

	$globalframe =~ s/!web_url!/$web_url/g;
	
	$globalframe =~ s/!!pagetitle!!/$ptitle/g;
	
	print $globalframe;
	exit;
	} 


#### USE OF HTML ALLOWED OR NOT

if ($forumsettings[6] eq "Y")	
	{
	$template = sn_netbbs::display_errors($template, "HTMLon"); ### DISPLAYS TEXT IN TAGS
	$template = sn_netbbs::display_errors($template, "HTMLoff", "NODISPLAY"); ### DISPLAYS TEXT IN TAGS
	}
	else
	{
	$template = sn_netbbs::display_errors($template, "HTMLoff"); ### DISPLAYS TEXT IN TAGS
	$template = sn_netbbs::display_errors($template, "HTMLon", "NODISPLAY"); ### DISPLAYS TEXT IN TAGS
	}


##############

$htext = $htext . "</form>";
$template =~ s/<\/form>/$htext/gi;

if ($template =~ m/\[icons\]/g) { $startpos = pos($template);	}
if ($template =~ m/\[\/icons]/g) { $endpos = pos($template); }
$none_indicator = substr($template, $startpos, $endpos - $startpos - 8);

$template =~ s/$none_indicator//gi;
$emicons = &get_icons ($none_indicator);
$template =~ s/\[icons\]/\[icons\]$emicons/gi;
$template = sn_netbbs::display_errors($template, "icons"); ### DISPLAYS TEXT IN TAGS

$template =~ s/!!message_tags_link!!/$scripts_url\/sn_forump.cgi?fct=emoticons/gi;

### IF THERE ARE ERRORS

$prev_topic = $q->param('messagetopic');
$template =~ s/!!topic!!/$prev_topic/gi;


$prev_msg = $q->param('message');

if ($prev_msg eq "")
	{
	$prev_msg = $q->param('message');
	$prev_msg = $qmsg . $prev_msg;
	$template =~ s/!!message!!/$prev_msg/gi;
	}
	else
	{
	$template =~ s/!!message!!/$prev_msg/gi;
	}



if ($display_error eq "")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY"); 
	}
	elsif ($display_error eq "error1")
	{
	$template = sn_netbbs::display_errors($template, "error1"); 
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY"); 
	}
	elsif ($display_error eq "error2")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error2");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY"); 
	}
	elsif ($display_error eq "error3")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3"); 
	$template = sn_netbbs::display_errors($template, "error4", "NODISPLAY"); 
	}
	elsif ($display_error eq "error4")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY");
	$template = sn_netbbs::display_errors($template, "error3", "NODISPLAY"); 
	$template = sn_netbbs::display_errors($template, "error4"); 
	}

	

$globalframe =~ s/!!forums!!/$template/gi;

$forumlogo = qq[<img src="$web_url/$forumsettings[8]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/g;
 	
$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
@gfsettings = split (/\n/, $gfs);
 
$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 

$cc_log_string = sn_netbbs::get_location($gfsettings[11], $cid, $fid);
$globalframe =~ s/!!location!!/$cc_log_string/gi;

$globalframe =~ s/!!post_script!!/$scripts_url\/sn_forump.cgi/g;


$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 


$globalframe =~ s/!!pagetitle!!/$ptitle/gi;
$globalframe =~ s/!web_url!/$web_url/g;

print $globalframe;

}



sub getmessage
{

my ($frpm, $ffid, $fcid, $ftid) = @_;
my ($ctp, @tmft, $msg, @antt);

$ctp = sn_netbbs::get_file_contents("$data_dir/$fcid/$ffid/$ftid.dat");
@tmft = split (/\n/,$ctp);

$frpm = $frpm - 1;
(@antt) = split (/\t/,$tmft[$frpm]);

$antt[7] =~ s/<br>/\n/g;
$antt[7] = "[StartQuote]" . $antt[7] . "[EndQuote]\n";
$antt[7] =~ s/<i>//g;
$antt[7] =~ s/<\/i>//g;

return ($antt[7]);

}



sub get_reply_emails
{

my ($config_cgi, $forumname, $forumemail, $aforum, $nfid, $ncid, $ntid) = @_;
my ($atdata, @atlines, $mtopic, @toitems, @returnmails, $sbcn, @returnmails, $eitem,
	 $fma, $pemail, $msgctopic, $mmc, $emsg, $notific, $surl);

## GET EMAIL ADDRESSES OF USERS WHO REQUESTED NOTIFICATION OF REPLIES
$atdata = sn_netbbs::get_file_contents($config_cgi);
@atlines = split (/\n/, $atdata);

$sbcn = 0;
$mmc = 0;
foreach $mtopic (@atlines)
	{
	@toitems = split (/\t/,$mtopic);
	
	if ($mmc == 0) {$msgctopic = $toitems[0];}
	$mmc++;
	
		if ($toitems[4] eq "Y")
			{
				$fma = "";
				### CHECK DUPLICATES
				foreach $eitem (@returnmails)
					{
					if ($eitem eq $toitems[2])
						{
						$fma = "true";
						}
					}
		
			if ($fma eq "")
				{
				$returnmails[$sbcn] = $toitems[2];
				#print "==> $sbcn - $toitems[4] - $returnmails[$sbcn] <br>\n\n\n";
				$sbcn++;
				}
				
			}
	}


#### PREPAPER MESSAGE AND SEND EMAIL

if ($returnmails[0] ne "")
	{

	### PREPARE EMAIL
	
	($fromname, $fromemail, $emailsubject, $notific) = sn_netbbs::get_email_details("sn_replynotification.eml");
	
	#print "--> ($fromname, $fromemail, $emailsubject, $notific) <BR>"; exit;
	
	#$notific = sn_netbbs::get_file_contents("$data_dir/notification.txt");
	$notific =~ s/!!forumname!!/$forumname/g;
	$notific =~ s/!!forum_name!!/$forumname/g;
	$notific =~ s/!!msgtopic!!/$msgctopic/g;
	$notific =~ s/!!forum!!/$aforum/g;
	
	$emailsubject =~ s/!!msgtopic!!/$msgctopic/gi;
	$emailsubject =~ s/!!forum!!/$aforum/g;
	
	$surl = "$scripts_url/sn_forumr.cgi?fid=$nfid&cid=$ncid&tid=$ntid";
	$notific =~ s/!!topicurl!!/$surl/g;
		
	#print "\n\n\n\n$notific\n\n\n\n";
	
	### SEND EMAIL	
	foreach $pemail (@returnmails)
		{
		#print "->$sendmail_loc \n ->$forumname \n ->$forumemail \n ->$pemail \n ->$msgctopic \n ->$notific\n\n\n\n";
		
			sn_netbbs::send_email($sendmail_loc,  					### LOCATION OF SENDMAIL
										$fromname,  						### SENDER NAME
										$fromemail,	 						### FROM EMAIL
										$pemail, 							### TO EMAIL ADDRESS
										$emailsubject, 					### SUBJECT
										$notific);							### MESSAGE

		}
	
	}

}






sub check_ip
{

my ($ipfile, @ips, $ipa, $userip, $loopip, $rval, $tmpstuff);

$userip = $ENV{'REMOTE_ADDR'};

$ipfile = sn_netbbs::get_file_contents("$data_dir/sn_banned_ips.dat");
@ips = split (/\n/, $ipfile);
foreach $ipa(@ips)
	{
	($loopip, $tmpstuff) = split(/\t/, $ipa);
		if ($loopip eq $userip)
			{
			$rval = "true";
			}
	}

#$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
#@gfsettings = split (/\n/, $gfs);

return ($rval);

}






sub get_icons
{

my ($noneind) = @_;
my (@iconfiles, $nricons, $iic, @files, $icount, $emicons_ret, $icon, $crit1, $crit2);


$emicons_ret = <<END_OF_JS;
<script language="Javascript" type="text/javascript">
<!-- hide
function inserticon(theicon) 
{
document.postmessage.message.value += theicon;
document.postmessage.message.focus();
}
// -->
</script> 
END_OF_JS

### GET ICONS
opendir(DIR,"$web_path/icons");
	@iconfiles = readdir(DIR);
closedir(DIR);

$nricons = 0;

foreach $iic (@iconfiles)
	{
	if (($iic ne ".") and ($iic ne ".."))
		{
		if ($nricons == 0)
			{
			$files[$nricons] = "NONE";
			$nricons++;
			}
		
		$files[$nricons] = $iic;
		$nricons++;
		}
	}

@files = sort(@files);

$nricons = 0;

$nricons = @files;

if ($nricons < 6){$nricons = 5;}
elsif ($nricons < 11){$nricons = 10;}
elsif ($nricons < 16){$nricons = 15;}
elsif ($nricons < 21){$nricons = 20;}
elsif ($nricons < 26){$nricons = 25;}
elsif ($nricons < 31){$nricons = 30;}
elsif ($nricons < 36){$nricons = 35;}
elsif ($nricons < 41){$nricons = 40;}

$icount = 0;

$emicons_ret = $emicons_ret . "<table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\">\n";

for ($icon = 0; $icon < $nricons; $icon++) 
	{

	if ($icount == 0)
		{
		$emicons_ret = $emicons_ret . "<tr>\n";
		
		$crit1 = ""; $crit2 = "";
		
		if ($files[$icon] eq "NONE")
				{
				$crit1 = "<input type=\"radio\" value=\"NONE\" name=\"icong\" checked>";
				$crit2 = "$noneind";
				}
				else
				{
				$js_iconlink = $files[$icon]; $js_iconlink =~ s/\.gif//g; $js_iconlink = "[:-" . $js_iconlink . "-:]";
				if ($files[$icon] ne ""){$crit1 = "<input type=\"radio\" value=\"$files[$icon]\" name=\"icong\">";}
				if ($files[$icon] ne ""){$crit2 = "<a href=\"Javascript:inserticon('$js_iconlink')\"><img src=\"$web_url/icons/$files[$icon]\" border=\"0\">";}
				}

  		$emicons_ret = $emicons_ret . "<td width=\"2%\">$crit1</td>\n";
     	$emicons_ret = $emicons_ret . "<td width=\"10%\">$crit2</td>\n";
		}

	if ($icount == 1)
		{
		$crit1 = ""; $crit2 = "";
		$js_iconlink = $files[$icon]; $js_iconlink =~ s/\.gif//g; $js_iconlink = "[:-" . $js_iconlink . "-:]";
		
		if ($files[$icon] ne ""){$crit1 = "<input type=\"radio\" value=\"$files[$icon]\" name=\"icong\">";}
		#if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/icons/$files[$icon]\">";}
		if ($files[$icon] ne ""){$crit2 = "<a href=\"Javascript:inserticon('$js_iconlink')\"><img src=\"$web_url/icons/$files[$icon]\" border=\"0\">";}
		

  		$emicons_ret = $emicons_ret . "<td width=\"2%\">$crit1</td>\n";
     	$emicons_ret = $emicons_ret . "<td width=\"10%\">$crit2</td>\n";
		}
	
	if ($icount == 2)
		{
		$crit1 = ""; $crit2 = "";
		$js_iconlink = $files[$icon]; $js_iconlink =~ s/\.gif//g; $js_iconlink = "[:-" . $js_iconlink . "-:]";
		
		if ($files[$icon] ne ""){$crit1 = "<input type=\"radio\" value=\"$files[$icon]\" name=\"icong\">";}
		#if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/icons/$files[$icon]\">";}
		if ($files[$icon] ne ""){$crit2 = "<a href=\"Javascript:inserticon('$js_iconlink')\"><img src=\"$web_url/icons/$files[$icon]\" border=\"0\">";}

  		$emicons_ret = $emicons_ret . "<td width=\"2%\">$crit1</td>\n";
     	$emicons_ret = $emicons_ret . "<td width=\"10%\">$crit2</td>\n";
		}

	if ($icount == 3)
		{
		$crit1 = ""; $crit2 = "";
		$js_iconlink = $files[$icon]; $js_iconlink =~ s/\.gif//g; $js_iconlink = "[:-" . $js_iconlink . "-:]";
		
		if ($files[$icon] ne ""){$crit1 = "<input type=\"radio\" value=\"$files[$icon]\" name=\"icong\">";}
		#if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/icons/$files[$icon]\">";}
		if ($files[$icon] ne ""){$crit2 = "<a href=\"Javascript:inserticon('$js_iconlink')\"><img src=\"$web_url/icons/$files[$icon]\" border=\"0\">";}
		
  		$emicons_ret = $emicons_ret . "<td width=\"2%\">$crit1</td>\n";
     	$emicons_ret = $emicons_ret . "<td width=\"10%\">$crit2</td>\n";
		}


	if ($icount == 4)
		{
		$crit1 = ""; $crit2 = "";
		$js_iconlink = $files[$icon]; $js_iconlink =~ s/\.gif//g; $js_iconlink = "[:-" . $js_iconlink . "-:]";
		
		if ($files[$icon] ne ""){$crit1 = "<input type=\"radio\" value=\"$files[$icon]\" name=\"icong\">";}
		#if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/icons/$files[$icon]\">";}
		if ($files[$icon] ne ""){$crit2 = "<a href=\"Javascript:inserticon('$js_iconlink')\"><img src=\"$web_url/icons/$files[$icon]\" border=\"0\">";}
		
  		$emicons_ret = $emicons_ret . "<td width=\"2%\">$crit1</td>\n";
     	$emicons_ret = $emicons_ret . "<td width=\"10%\">$crit2</td>\n";
      
      $emicons_ret = $emicons_ret . "</tr>\n";
      $icount = 0;
		}
		else
		{ 
      $icount++;
		}

  }

$emicons_ret = $emicons_ret . "</table>\n\n\n";

}


