#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use CGI::Carp qw(fatalsToBrowser); 
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################



## READ CONFIGURATION ###############################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_forumpr.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

if ($q->param('fct') eq "castvote") {&castvote; exit;}

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}

#### START ########################################################


sub castvote
{

my ($cid, $fid, $tid, $votes, $vdata, @vlines, $vq, $nrvotes, $smc, $item, $votevalue,
	 @rawc, $item2, $key, $val, %cookies, $ip_address, $ipdata, $ipa, @ipi);

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');

sn_netbbs::check_input($cid);
sn_netbbs::check_input($fid);
sn_netbbs::check_input($tid);

if ((-e "$data_dir/$cid/$fid/$tid.dat") < 1)
	{
	sn_netbbs::fatal_error("Invalid Forum / Category or Message");
	}



$votes = $q->param('votes');
$votes++;
$vdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.dat");
@vlines = split (/\n/,$vdata);
$smc = 0;




### GET COOKIES
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}


### CHECK VOTES VIA COOKIES
 @citems = split (/_/,$cookies{'VOTE'});
	foreach $cval (@citems)
		{
		 ($ccid, $cfid, $ctid) = split (/:/,$cval);
			if (($ccid eq $cid) and ($cfid eq $fid) and ($ctid eq $tid))
				{
				$thisvote = "true";
				}
		}


(@settings) = sn_netbbs::get_global_settings;

if ($settings[19] ne "N")
	{

	### CHECK VOTES VIA IP
	$ip_address = $ENV{'REMOTE_ADDR'};
	
	$ipdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.ipl");
	@ipi = split (/\n/, $ipdata);
	 
	 foreach $ipa (@ipi)
	 	{
	 	if ($ipa eq $ip_address)
	 		{
	 		$thisvote = "true";
	 		}
	 	}

	}



$gfrs = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@forset = split (/\n/, $gfrs);



### CHECK USER NAME & PASSWORD TO CHECK IF USER IS A REGISTERED USER AND LOGGED IN

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false

if ($logged_in_status eq "false") 
	{
	print "Content-type: text/html\n\n";
	&start("NOTLOGGREDIN");
	exit;
	}



if (($forset[4] eq "Registered") or ($forset[4] eq "Moderators"))
	{

	#@usettings = sn_netbbs::check_username_password($q->param('username'), $q->param('password'));
	#if ($usettings[0] eq "ERROR"){$error_text = "The user name or password you specified is incorrect";}


   ### CHECK IF ALREADY VOTED VIA USERNAME
   $gfrs = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.usr");
   @usri = split (/\n/, $gfrs);
		
		foreach $uitem (@usri)
			{
			if (lc($uname) eq "$uitem")
				{
					print "Content-type: text/html\n\n";
					&start("ALREADYVOTED");
					exit;
				}
			}
	
			
	### RECORD VOTE
	open (UV, ">> $data_dir/$cid/$fid/$tid.usr");
		print UV lc($uname) . "\n";
	close (UV);


 } ### END OF CHECK USER NAME & PASSWORD & CHECKING USER VOTES



### RECORD IP ADDRESS

if ($thisvote ne "true") 
{

### RECORD IP

if ($ip_address ne "")
	{
	open (VDATA, ">> $data_dir/$cid/$fid/$tid.ipl");
		print VDATA "$ip_address\n";
	close (VDATA);	
	}

open (VDATA, "> $data_dir/$cid/$fid/$tid.dat");
 if ($flocking ne "No"){flock (VDATA,2);}
	foreach $item (@vlines)
		{
		$nrvotes = "";
		if ($item =~ /\t/)
			{
			($vq, $nrvotes) = split (/\t/, $item);
			}

		if ($smc == $votes)
			{
			$nrvotes++;
			print VDATA $vq . "\t" . $nrvotes . "\n";
			}
			else
			{
			print VDATA $item . "\n";
			}
		
		$smc++;
		}
   if ($flocking ne "No"){flock (VDATA,8);}
 close (VDATA);
}


$votevalue = $cookies{'VOTE'} . "_" . "$cid:$fid:$tid";
sn_netbbs::setCookie("VOTE","$votevalue");


print "Content-type: text/html\n\n";
print qq[<html>
<head>
<title>Turbo Seek Documentation</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_forumpr.cgi?fid=$fid&cid=$cid&tid=$tid">
</head>
<body>
</body>
</html>
];
exit;

}




sub start
{
my ($vote_error) = @_;


my ($template, $catname, @settings, $ftop, $cid, $fid, $tid, $pollcontents,
	 @plines, $polltable, $pquestion, $nrvotes, $ufle, @udata, $utype, $mpst,
	 $usernn, $totalposts, $whenjoined, $pqs, @rawc, $item2, $key, $val, %cookies,
	 $fct, $successvoted, $highvote, $colspan, @citems, $cval, $ccid, $cfid, 
	 $ctid, $thisvote, $user_image, $tmpl_to_open);

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');

sn_netbbs::check_input($cid);
sn_netbbs::check_input($fid);
sn_netbbs::check_input($tid);

if ((-e "$data_dir/$cid/$fid/$tid.dat") < 1)
	{
	sn_netbbs::fatal_error("Invalid Forum / Category or Message");
	}


### GET TEMPLATES

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html",1);
$sn_poll = sn_netbbs::get_file_contents("$data_dir/sn_poll.html");

$sn_vote_frame_table  = sn_netbbs::get_file_contents("$data_dir/sn_vote_frame_table.html");
$sn_vote_table_cells  = sn_netbbs::get_file_contents("$data_dir/sn_vote_table_cells.html");

$sn_results_frame_table  = sn_netbbs::get_file_contents("$data_dir/sn_results_frame_table.html");
$sn_results_table_cells  = sn_netbbs::get_file_contents("$data_dir/sn_results_table_cells.html");




### CHECK IF VOTED

if ($q->param('v') eq "viewresults") { $successvoted = "true"; }



### FORUM SETTINGS

$gfrs = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@forset = split (/\n/, $gfrs);


### GET GLOBAL FORUM SETTINGS
$forumconfig = "$data_dir/sn_settings.dat";
$fsize = (-s "$forumconfig");
open (RVF, "$forumconfig");
	read(RVF,$fsett,$fsize);
close (RVF);
(@fsettings) = split(/\n/,$fsett);



###### TOP #######

$template = sn_netbbs::get_file_contents("$data_dir/sn_poll.html");	

#$catname = sn_netbbs::get_cat_name($cid);
$plocation = sn_netbbs::get_location($fsettings[11], $cid, $fid); 
$template =~ s/!!location!!/$plocation/gi;

(@settings) = sn_netbbs::get_global_settings;
$ftop = sn_netbbs::print_forum_top("Post a New Poll", $catname, $settings[11], "");


### GET FORUM SETTINGS

$pollcontents = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.dat");
@plines = split(/\n/,$pollcontents);

### 0 POLL TOPIC
### 1 DESCRIPTION
### 2 QUESTIONS \t NR VOTES
### 3 QUESTIONS \t NR VOTES
### 4 QUESTIONS \t NR VOTESs
### 5 QUESTIONS \t NR VOTESs
### 6 QUESTIONS \t NR VOTESs
### 7 QUESTIONS \t NR VOTESs
### 8 User


### CHECK IF VOTED
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}

if ($cookies{'VOTE'} ne "")
	{
	@citems = split (/_/,$cookies{'VOTE'});
	foreach $cval (@citems)
		{
		if ($cval ne "")
		{
		 ($ccid, $cfid, $ctid) = split (/:/,$cval);
			if (($ccid eq $cid) and ($cfid eq $fid) and ($ctid eq $tid))
				{
				$thisvote = "true";
				$successvoted = "true";
				}
		}
		}
	}





if ($plines[1] ne "") 
{ 
	$plines[1] = sn_netbbs::decode_tags($plines[1]);
}


### POLL DESCRIPTION
$template =~ s/!!poll_topic!!/$plines[0]/gi;
$template =~ s/!!poll_description!!/$plines[1]/gi;






### GET POLL STATS

($pquestion, $nrvotes) = split (/\t/,$plines[2]); $highvote = $nrvotes;
($pquestion, $nrvotes) = split (/\t/,$plines[3]); $highvote = $highvote + $nrvotes;
($pquestion, $nrvotes) = split (/\t/,$plines[4]); $highvote = $highvote + $nrvotes;
($pquestion, $nrvotes) = split (/\t/,$plines[5]); $highvote = $highvote + $nrvotes;
($pquestion, $nrvotes) = split (/\t/,$plines[6]); $highvote = $highvote + $nrvotes;
($pquestion, $nrvotes) = split (/\t/,$plines[7]); $highvote = $highvote + $nrvotes;


#########################
#$successvoted = "";
#########################

if ($q->param('preview') eq "voted")
	{
		$successvoted = "true";
	}
	elsif ($q->param('preview') eq "notvoted")
	{
		$successvoted = "";
	}


### POLL TABLE MIDDLE

($pquestion, $nrvotes) = split (/\t/,$plines[2]);
if ($pquestion ne "") {$polltable = $polltable . &get_poll_tr($pquestion, $nrvotes, "1", "checked", $highvote, $successvoted);}

($pquestion, $nrvotes) = split (/\t/,$plines[3]);
if ($pquestion ne "") {$polltable = $polltable . &get_poll_tr($pquestion, $nrvotes, "2", "", $highvote, $successvoted); $pqs = 2;}

($pquestion, $nrvotes) = split (/\t/,$plines[4]);
if ($pquestion ne "") {$polltable = $polltable . &get_poll_tr($pquestion, $nrvotes, "3", "", $highvote, $successvoted); $pqs = 3;}

($pquestion, $nrvotes) = split (/\t/,$plines[5]);
if ($pquestion ne "") {$polltable = $polltable . &get_poll_tr($pquestion, $nrvotes, "4", "", $highvote, $successvoted); $pqs = 4;}

($pquestion, $nrvotes) = split (/\t/,$plines[6]);
if ($pquestion ne "") {$polltable = $polltable . &get_poll_tr($pquestion, $nrvotes, "5", "", $highvote, $successvoted); $pqs = 5;}

($pquestion, $nrvotes) = split (/\t/,$plines[7]);
if ($pquestion ne "") {$polltable = $polltable . &get_poll_tr($pquestion, $nrvotes, "6", "", $highvote, $successvoted); $pqs = 6;}




### POLL TABLE BOTTOM
if ($successvoted eq "true")
	{
	#$vote_table =~ s/!!results_cells!!/$polltable/gi;
	
	$sn_results_frame_table =~ s/!!results_cells!!/$polltable/gi;
	$template =~ s/!!vote_options_results!!/$sn_results_frame_table/gi;
	
	}
	else
	{
	$hidden_details = qq[
	<input type="hidden" name="fct" value="castvote">
	<input type="hidden" name="cid" value="$cid">
	<input type="hidden" name="fid" value="$fid">
	<input type="hidden" name="tid" value="$tid">
	<input type="hidden" name="pg" value="1">
	<input type="hidden" name="sc" value="20">
	</form>
	];
	$sn_vote_frame_table =~ s/<\/form>/$hidden_details/gi;
	
	$vscript = "$scripts_url/sn_forumpr.cgi";
	$sn_vote_frame_table =~ s/!!vote_script!!/$vscript/gi;
	
	
	if ($vote_error eq "") 
		{
		$sn_vote_frame_table = sn_netbbs::display_errors($sn_vote_frame_table, "error1", "NODISPLAY");
		$sn_vote_frame_table = sn_netbbs::display_errors($sn_vote_frame_table, "error2", "NODISPLAY");
		}
		else
		{
			
			if ($vote_error eq "NOTLOGGREDIN")
				{
				$sn_vote_frame_table = sn_netbbs::display_errors($sn_vote_frame_table, "error2", "");
				$sn_vote_frame_table = sn_netbbs::display_errors($sn_vote_frame_table, "error1", "NODISPLAY");
				}
				else
				{
				$sn_vote_frame_table = sn_netbbs::display_errors($sn_vote_frame_table, "error1", "");
				$sn_vote_frame_table = sn_netbbs::display_errors($sn_vote_frame_table, "error2", "NODISPLAY");
				}
			
		}
	
	$sn_vote_frame_table =~ s/!!vote_cells!!/$polltable/gi;
	
	$template =~ s/!!vote_options_results!!/$sn_vote_frame_table/gi;
	}









### USER DETAILS
$usernn = $plines[8];
$usernn =~ s/\n//g;
$usernn =~ s/ /_/g;
$ufle = sn_netbbs::get_file_contents("$data_dir/users/$usernn.dat");
(@udata) = split(/\n/,$ufle);

($mpst, $utype) = &get_title($udata[12], $udata[14]);


### CHECK TO SEE IF USER IS A MOD/ADM

@all_moderators = sn_netbbs::get_moderators($forset[3]);


if ((substr($udata[12], 0, 2) eq "Ad") or (substr($udata[12], 0, 2) eq "Mo"))
{
	$mdst = "false";
	foreach $mdline (@all_moderators)
	{
		if (lc($mdline) eq lc($plines[8])) { $mdst = "true"; }
	}
}


if ($mdst eq "true")
{
	if (substr($udata[12], 0, 2) eq "Mo")
	{
	$membertypename = "Moderator";
	}
	elsif (substr($udata[12], 0, 2) eq "Ad")
	{
	$membertypename = "Administrator";
	}
}
else
{
$membertypename = $mpst;
}




if ($udata[14] == 0) 
	{
	$udata[14] = "Unregistered";
	$whenjoined = "Unregistered";
	$utype = "";
	}
	else
	{
	$whenjoined = sn_netbbs::decode_date ($udata[13]);
	}


$totalposts = $udata[14];

$plines[9] = sn_netbbs::decode_date ($plines[9]);


#sn_netbbs::write_stats($cid, $fid, $tid, 0, 1);

if (-e "$data_dir/$cid/$fid/$tid.cnt" < 1)
	{
	$rstatv_count = 0;
	$viewdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
	@astln = split (/\n/, $viewdata);
	foreach $stat_item (@astln)
		{
		($stat_id, $stat_posts, $stat_views, $stat_date, $stat_lpost) = split (/\t/, $stat_item);
		if ($stat_id == $tid)
			{
			$rstatv_count = $rstatv_count + $stat_views;
			}
		}
	}


if (-e "$data_dir/$cid/$fid/$tid.cnt")
	{
	$old_stat_count2 = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.cnt");
	$rstatv_count = $rstatv_count + $old_stat_count2;
	}


$rstatv_count++;
open (VIEWS, ">$data_dir/$cid/$fid/$tid.cnt");
 if ($flocking ne "No"){flock (VIEWS,2);}
	print VIEWS $rstatv_count;	
 if ($flocking ne "No"){flock (VIEWS,8);}
close (VIEWS);

################################################





### USER IMAGE
if ($udata[15] =~ /USER_DEFINED/)
	{
	$udata[15] =~ s/USER_DEFINED//g;
	$user_image = "<img src=\"$web_url/user_imagesc/$udata[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}
	elsif ($udata[15] ne "")
	{
	$user_image = "<img src=\"$web_url/user_images/$udata[15]\" border=\"1\" width=\"70\" height=\"70\">";
	}


### INSERT USER DETAILS

$template =~ s/!!auth_name!!/$plines[8]/gi;
$authlname = $plines[8]; $authlname =~ s/ /+/g;

$autlink = "$scripts_url/sn_proview.cgi?user=$authlname";
$template =~ s/!!auth_link!!/$autlink/gi;

$template =~ s/!!post_date!!/$plines[9]/gi;
$template =~ s/!!total_mem_posts!!/$totalposts/gi;

$template =~ s/!!auth_image!!/$user_image/gi;

$template =~ s/!!mem_name!!/$membertypename/gi;
$template =~ s/!!mem_icon!!/$utype/gi;

$template =~ s/!!poll_answers!!/$pqs/gi;
$template =~ s/!!poll_votes!!/$highvote/gi;


$forumlogo = $forset[8]; $forumlogo = "<img src=\"$web_url/$forumlogo\">";
$template =~ s/!!logo!!/$forumlogo/gi;

$moderator_display = sn_netbbs::get_moderators_new($cid, $fid);
$template =~ s/!!moderators!!/$moderator_display/gi; 

$time_msg_box = sn_netbbs::get_newmsg_box($cid, $fid);
$template =~ s/!!new_messages_drop_down!!/$time_msg_box/gi;





$template =~ s/!!forum_name!!/$fsettings[11]/gi;


$template =~ s/!!netboard!!/$ftop/g; 

$globalframe =~ s/!!forums!!/$template/gi;

$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi;

$globalframe =~ s/!!forum_name!!/$fsettings[11]/gi; 

$forumlogo = qq[<img src="$web_url/$forset[8]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 

$globalframe =~ s/!!pagetitle!!/$plines[0]/gi;

$globalframe =~ s/!web_url!/$web_url/gi;

print $globalframe;

}





sub get_poll_tr
{

my ($question, $votes, $pollnumber, $chv, $highestvote, $successvoted) = @_;
my ($rval, $radio_name, $perc, $graph, @gsettings);

(@gsettings) = sn_netbbs::get_global_settings;


if ($successvoted eq "true")
	{
	if ($votes ne "0")
		{
		$perc = $votes / $highestvote * 100;
		$perc = sprintf("%5.0f",$perc);
		$perc = $perc . "%";
		}
		else
		{
		$perc = "0";
		}
	
	if ($perc ne "0")
		{
		$graph = "<hr width=\"$perc\" align=\"left\" noshade size=\"5\" color=\"$gsettings[1]\">";
		}
	
	$rval_tmp = $sn_results_table_cells;
	
	$rval_tmp =~ s/!!nr!!/$pollnumber/gi;
	$rval_tmp =~ s/!!vote_item!!/$question/gi;
	$rval_tmp =~ s/!!vote_perc!!/$perc/gi;
	$rval_tmp =~ s/!!votes!!/$votes/gi;
	
	$rval = $rval_tmp;
   }
	else
	{
	$rval_tmp = $sn_vote_table_cells;

	if ($pollnumber == 1) { $rval_tmp =~ s/!!checked!!/checked/gi; } else { $rval_tmp =~ s/!!checked!!//gi; } 

	$rval_tmp =~ s/!!vote_item!!/$question/gi;
	$rval_tmp =~ s/!!nr!!/$pollnumber/gi;
	$rval_tmp =~ s/!!vote_value!!/$pollnumber/gi;
	$rval_tmp =~ s/!!vote_checked!!/votes/gi;
	
	$rval = $rval_tmp;
	}

return ($rval);

}






sub get_title
{
my ($mtype, $posts) = @_;
my ($sbcntr, $tline, $ttval, $mmtitle, @titlevalues, $memberposts, $uposts, $rval);

$sbcntr= 0;
open (UFINFO, "$data_dir/sn_usertitles.dat");
	while (defined($tline=<UFINFO>))
		{
		if ($tline ne "")
			{
			($ttval, $mmtitle) = split (/\t/,$tline);
			$titlevalues[$sbcntr] = $ttval;
			$sbcntr++;
			$titlevalues[$sbcntr] = $mmtitle;
			$sbcntr++;
			}
		}
close (UFINFO);


if ($posts <= $titlevalues[0])
	{
	$memberposts = $titlevalues[1];
	$uposts = "<img src=\"$web_url/sn_rank1.gif\">";
	}
	elsif ($posts <= $titlevalues[2])
	{
	$memberposts = $titlevalues[3];
	$uposts = "<img src=\"$web_url/sn_rank2.gif\">";
	}
	elsif ($posts <= $titlevalues[4])
	{
	$memberposts = $titlevalues[5];
	$uposts = "<img src=\"$web_url/sn_rank3.gif\">";
	}
	elsif ($posts <= $titlevalues[6])
	{
	$memberposts = $titlevalues[7];
	$uposts = "<img src=\"$web_url/sn_rank4.gif\">";
	}
	else
	{
	$memberposts = $titlevalues[9];
	$uposts = "<img src=\"$web_url/sn_rank5.gif\">";
	}


return ($memberposts, $uposts);

}
