#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_ip.cgi", "header", $data_dir);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################



print "Content-type: text/html\n\n";

#if ($q->param('fct') eq "") {&start; exit;}
if ($q->param('fct') eq "") {&get_ip; exit;}
if ($q->param('fct') eq "locktopic") {&locktopic; exit;}
if ($q->param('fct') eq "locktopic_scr") {&locktopic_scr; exit;}
if ($q->param('fct') eq "unlocktopic") {&locktopic; exit;}
if ($q->param('fct') eq "unlocktopic_scr") {&locktopic_scr; exit;}

#### START ########################################################

sub locktopic_scr
{

my (@settings, $uname, $upass, @usettings, $fid, $cid, $tid, $tdata, @topics, $item, @titems,
	 $lockvalue, $lockheadline, $locktxt, $template, $txt);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
@settings = sn_netbbs::get_global_settings();

$uname = $q->param('username');
$upass = $q->param('password');

(@usettings) = sn_netbbs::check_username_password ($uname, $upass);

if (($usettings[0] eq "ERROR") or ((substr($usettings[12], 0, 2) ne "Ad") and (substr($usettings[12], 0, 2) ne "Mo")))
	{

$txt = <<END_OF_PROBL;
<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="$settings[5]">
  <tr>
    <td width="100%" bgcolor="$settings[2]" height="27"><font face="Verdana" size="4"><p
    align="center"></font><font face="$settings[6]" size="2" color="$settings[8]"><strong>Problem</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="$settings[3]"><font face="$settings[6]" size="2"><strong>&nbsp;&nbsp; <br>
    &nbsp;&nbsp; There was a problem when trying to Login.</strong><br>
    </font><font face="$settings[6]" size="1">&nbsp;&nbsp; It might be one of the following
    reasons.</font><ul>
      <li><font face="$settings[6]" size="1"><strong>Invalid User Name<br>
        </strong>The user name field was left blank or was incorrect.<br>
        &nbsp;&nbsp; </font></li>
      <li><font face="$settings[6]" size="1"><strong>Invalid Password<br>
        </strong>Your password was incorrect. <br>
        &nbsp;&nbsp; </font></li>
      <li><font face="$settings[6]" size="1"><strong>No Access<br>
        </strong>You don't have access to enter the area.</font></li>
    </ul>
    <p><font face="$settings[6]" size="2"><strong>&nbsp;&nbsp;&nbsp; Use the back button of your
    browser to go back<br>
    &nbsp;&nbsp;&nbsp;&nbsp; </strong></font></td>
  </tr>
</table>
END_OF_PROBL
	
	$template =~ s/!!netboard!!/$txt/g;
	print $template;
	
	}
	else
	{
	
	$fid = $q->param('fid');
	$cid = $q->param('cid');
	$tid = $q->param('tid');
	
	if ($q->param('fct') eq "locktopic_scr")	
		{
		$lockvalue = "2";
		$lockheadline = "Topic Locked";
		$locktxt = "No further posts is possible in this topic.";
		}
		elsif ($q->param('fct') eq "unlocktopic_scr")	
		{
		$lockvalue = "1";
		$lockheadline = "Topic Unlocked";
		$locktxt = "New posts is now possible in this topic.";
		}
	
	#### WRITE CHANGES TO TOPICS.DAT
	
	$tdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
	@topics = split (/\n/, $tdata);

	open (TOPICF, "> $data_dir/$cid/$fid/topics.dat");
	 if ($flocking ne "No"){flock (TOPICF,2);}
	
		foreach $item (@topics)
			{
			(@titems) = split (/\t/, $item);
				if ($titems[0] == $tid)
					{
					print TOPICF 	$titems[0] . "\t" . 
										$titems[1] . "\t" . 
										$titems[2] . "\t" . 
										$titems[3] . "\t" . 
										$titems[4] . "\t" . 
										$titems[5] . "\t" . 
										$lockvalue . "\t" . 
										$titems[7] . "\t" . 
										$titems[8] . "\t" . 
										$titems[9] . "\n";
					}
					else
					{
					print TOPICF $item . "\n";
					}
			}
	 if ($flocking ne "No"){flock (TOPICF,8);}
	close (TOPICF);
	

	
	
	
$txt = <<END_OF_LTOP;
<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="$settings[5]">
  <tr>
    <td width="100%" bgcolor="$settings[2]" height="27"><font face="$settings[6]" size="4"><p
    align="center"></font><font face="$settings[6]" size="2" color="$settings[8]"><strong>
    $lockheadline
    </strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="$settings[3]"><blockquote>
      <p><font face="$settings[6]" size="2"><strong>&nbsp;&nbsp; <br>
      </strong>$locktxt<strong>&nbsp;&nbsp; </strong></font><font
      face="$settings[6]" size="1">&nbsp;&nbsp;&nbsp;&nbsp; </font></p>
    </blockquote>
    </td>
  </tr>
</table>
END_OF_LTOP

	$template =~ s/!!netboard!!/$txt/g;
	print $template;
	
	}


}




sub locktopic
{

my ($lhtmldata, @rawc, $item2, $key, $val, %cookies, $uname, $upass, $template);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

if ($q->param('fct') eq "locktopic")
	{
	$lhtmldata = sn_netbbs::login_box("locktopic_scr", "$scripts_url/sn_ip.cgi", "Lock Topic", "Lock Topic");
	}
	elsif ($q->param('fct') eq "unlocktopic")
	{
	$lhtmldata = sn_netbbs::login_box("unlocktopic_scr", "$scripts_url/sn_ip.cgi", "Unlock Topic", "Unlock Topic");
	}
                 
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$lhtmldata =~ s/!!username!!/$uname/g;
$lhtmldata =~ s/!!password!!/$upass/g;

$template =~ s/!!netboard!!/$lhtmldata/g;
print $template;

}




sub get_ip
{

my (@usettings, $uname, $upass, $ip, $username, $email_add, $fid, $tid, $cid, $rpm,
	 $allidata, @allitems, @msgitems, @settings, $vp, $template, $txt);

#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

@settings = sn_netbbs::get_global_settings();


@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);


(@usettings) = sn_netbbs::check_username_password ($uname, $upass);

if (($usettings[0] eq "ERROR") or ((substr($usettings[12], 0, 2) ne "Ad") and (substr($usettings[12], 0, 2) ne "Mo")))
	{

$txt = <<END_OF_PROBL;
<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="$settings[5]">
  <tr>
    <td width="100%" bgcolor="$settings[2]" height="27"><font face="Verdana" size="4"><p
    align="center"></font><font face="$settings[6]" size="2" color="$settings[8]"><strong>Problem</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="$settings[3]"><font face="$settings[6]" size="2"><strong>&nbsp;&nbsp; <br>
    &nbsp;&nbsp; There was a problem when trying to Login.</strong><br>
    </font><font face="$settings[6]" size="1">&nbsp;&nbsp; It might be one of the following
    reasons.</font><ul>
      <li><font face="$settings[6]" size="1"><strong>Invalid User Name<br>
        </strong>The user name field was left blank or was incorrect.<br>
        &nbsp;&nbsp; </font></li>
      <li><font face="$settings[6]" size="1"><strong>Invalid Password<br>
        </strong>Your password was incorrect. <br>
        &nbsp;&nbsp; </font></li>
      <li><font face="$settings[6]" size="1"><strong>No Access<br>
        </strong>You don't have access to enter the area.</font></li>
    </ul>
    <p><font face="$settings[6]" size="2"><strong>&nbsp;&nbsp;&nbsp; Use the back button of your
    browser to go back<br>
    &nbsp;&nbsp;&nbsp;&nbsp; </strong></font></td>
  </tr>
</table>
END_OF_PROBL

	$template =~ s/!!netboard!!/$txt/g;
	print $template;
	
	}
	else
	{

#### GET IP ADDRESS

$cid = $q->param('cid');
$fid = $q->param('fid');
$tid = $q->param('tid');
$rpm = $q->param('rpm');
$vp = $q->param('vp');

$allidata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$tid.dat");
@allitems = split (/\n/, $allidata);

if ($vp ne "true")
	{
	$rpm = $rpm - 1;
	@msgitems = split (/\t/, $allitems[$rpm]);
	$ip = $msgitems[8];
	$username = $msgitems[1];
	$email_add = $msgitems[2];
	}
	else
	{
	$ip = $allitems[10];
	$username = $allitems[8];
	$email_add = "N/A";
	}


$txt = <<END_OF_IP;

<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="$settings[5]">
  <tr>
    <td width="100%" bgcolor="$settings[2]" height="27"><font face="$settings[6]" size="4"><p
    align="center"></font><font face="$settings[6]" size="2" color="$settings[8]"><strong>View IP Address</strong></font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="$settings[3]"><blockquote>
      <p><font face="$settings[6]" size="2"><strong>&nbsp;&nbsp; <br>
      </strong>IP Address of User: <strong>$ip</strong><br>
      User Name: <strong>$username</strong><br>
      Email Address: <strong>$email_add&nbsp;&nbsp; </strong></font><font face="$settings[6]"
      size="1">&nbsp;&nbsp;&nbsp;&nbsp; </font></p>
    </blockquote>
    </td>
  </tr>
</table>

END_OF_IP

	$template =~ s/!!netboard!!/$txt/g;	
	print $template;
	}


}




sub start
{

my ($lhtmldata, @rawc, $item2, $key, $val, %cookies, $uname, $upass, $template);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

$lhtmldata = sn_netbbs::login_box("get_ip", "$scripts_url/sn_ip.cgi", "Login", "Login");
                 
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$lhtmldata =~ s/!!username!!/$uname/g;
$lhtmldata =~ s/!!password!!/$upass/g;

$template =~ s/!!netboard!!/$lhtmldata/g;
print $template;

}

