#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	sn_fmspm::check_spamb("sn_lostps.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");	
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################


print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "retrieve_password") {&retrieve_password;}


#### START ########################################################

sub retrieve_password
{

my ($username, $error_text, $allusers, @allua, $uitem, $fmatch, $udetails, @udtls,
	 $sendps_text, @gsettings, $template, $txt);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

@gsettings = sn_netbbs::get_global_settings;

$username = $q->param('username');

if ($username eq "") { &start("error1"); exit;}

### CHECK IF USER NAME EXISTS

$allusers = sn_netbbs::get_file_contents("$data_dir/users/users.dat");
@allua = split(/\n/,$allusers);
	foreach $uitem (@allua)
		{
		if (lc($uitem) eq lc($username)) {$fmatch = "True"; $username = $uitem;}
		}

#####

if ($fmatch ne "True")
	{
	&start("error1"); exit;
	}

#####

	$username =~ s/ /_/g;
	$udetails = sn_netbbs::get_file_contents("$data_dir/users/$username.dat");
	@udtls = split (/\n/,$udetails);

	#$sendps_text = sn_netbbs::get_file_contents("$data_dir/sendps.txt");
	
	($fromname, $fromemail, $emailsubject, $sendps_text) = sn_netbbs::get_email_details("sn_psretrieve.eml");
	
	$sendps_text =~ s/!!forum_name!!/$gsettings[11]/g;
	$sendps_text =~ s/!!username!!/$udtls[0]/g;
	$sendps_text =~ s/!!password!!/$udtls[1]/g;
	
	$emailsubject =~ s/!!forumname!!/$gsettings[11]/g;
	$emailsubject =~ s/!!username!!/$udtls[0]/g;
	
	# SEND PASSWORD: REQUIRES 
	#  - location of sendmail
	#  - name
	#  - from email
	#  - to email address
	#  - subject
	#  - message
	
	sn_netbbs::send_email($sendmail_loc, $fromname, $fromemail, $udtls[2], $emailsubject, $sendps_text);


#########

$template = sn_netbbs::get_file_contents("$data_dir/sn_passwd_sent.html");
$ptitle = sn_netbbs::get_page_title("sn_passwd_sent");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

@settings = sn_netbbs::get_global_settings();

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$template =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 

$globalframe =~ s/!!logout!!/$scripts_url\/sn_login.cgi?fct=logout/g;

$globalframe =~ s/!web_url!/$web_url/g;
	
print $globalframe;
exit;

}



sub start
{

my ($problem) = @_;
my ($themt, @settings, $template);

#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

$template = sn_netbbs::get_file_contents("$data_dir/sn_retrieveps.html");
$ptitle = sn_netbbs::get_page_title("sn_retrieveps");

$template =~ s/!!retrieve_script!!/$scripts_url\/sn_lostps.cgi/gi;

$hvars = qq[
<input type="hidden" name="fct" value="retrieve_password">
</form>
];

$template =~ s/<\/form>/$hvars/gi;

if ($problem eq "")
	{
	$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
	}
	else
	{
	$template = sn_netbbs::display_errors($template, "error1", ""); 
	}


#################################

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

@settings = sn_netbbs::get_global_settings();


		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$loclink = "http://$domain/forumindex.html";
			$loclink = qq[<a href="$loclink">$settings[11]</a>];
			}
			else
			{
			$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
			}




$template =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 

$globalframe =~ s/!!logout!!/$scripts_url\/sn_login.cgi?fct=logout/g;

$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;
	
print $globalframe;

}


