#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use Fcntl qw(:DEFAULT :flock);
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_moderate.cgi", "header", $data_dir);
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");	
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################
	
	&start; ### CHECK ACCESS

	##########################	
	
	print "Content-type: text/html\n\n";
	
	@rawc = sn_netbbs::getCookies;
	foreach $item2(@rawc)
		{
		($key, $val) = split (/=/,$item2,2);
		$cookies{$key} = $val;
		}
	($uname, $upass) = split (/:/, $cookies{'USER'}, 2);
	
	
	if ($q->param('fct') eq "moderator_start_scr") {&moderator_start_scr($uname); exit;}	
	if ($q->param('fct') eq "") {&moderator_start_scr($uname); exit;}		
	if ($q->param('fct') eq "del_topics") {&del_topics; exit;}
	if ($q->param('fct') eq "delete_topics_final") {&delete_topics_final; exit;}
	if ($q->param('fct') eq "fsettings") {&fsettings; exit;}	
	if ($q->param('fct') eq "save_fsettings") {&save_fsettings; exit;}	

	if ($q->param('fct') eq "moderate") {&moderate_start; exit;}		
	if ($q->param('fct') eq "approve_msgs") {&approve_msgs; exit;}		

	



#### START ########################################################


sub moderate_start
{

my ($cid, $fid, $fcatname, $forname, $topicfile, @topics, $item, @tlines, $msgstatus, $topicds, @tline, @mtopic, $tt, 
    $nodisp, $tcount, $sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst, $modcrypt, $reply_bookmark);

@global_settings = sn_netbbs::get_global_settings;

$cid = $q->param('cid');
$fid = $q->param('fid');

$fcatname = sn_netbbs::get_cat_name($cid);
$forname = sn_netbbs::get_forum_name($cid, $fid);

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$modcrypt = crypt ($c_username, $mday);

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$ptitle = sn_netbbs::get_page_title("sn_mod_global");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_global.html");

$sn_mod_mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_mod_frame.html");
$sn_mod_mod_cells = sn_netbbs::get_file_contents("$data_dir/sn_mod_mod_cells.html");


#### PREPARE TOPIC / REPLY LIST TABLE

$hvars = qq[
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="fct" value="approve_msgs">
  <input type="hidden" name="fid" value="$fid">
  <input type="hidden" name="m" value="$username">
  <input type="hidden" name="p" value="$epassword">
  </form>
];
$sn_mod_mod_frame =~ s/<\/form>/$hvars/gi;

$sn_mod_mod_frame =~ s/!!moderation_script!!/$scripts_url\/sn_moderate.cgi/gi;

$sn_mod_mod_frame =~ s/!!current_forum_category!!/$fcatname/gi;

$sn_mod_mod_frame =~ s/!!forum_name!!/$forname/gi;


#### 

#$modtable = <<END_OF_TOP;
##<form method="POST" action="$scripts_url/sn_moderate.cgi">
#  <input type="hidden" name="cid" value="$cid">
#  <input type="hidden" name="fct" value="approve_msgs">
#  <input type="hidden" name="fid" value="$fid">
#  <input type="hidden" name="m" value="$username">
#  <input type="hidden" name="p" value="$epassword">
#$topbut
#<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="$global_settings[5]">
#  <tr>
#    <td bgcolor="$global_settings[5]"><table border="0" cellpadding="3" cellspacing="1" width="100%">
#      <tr>
#        <td bgcolor="$global_settings[1]" height="27"><p align="left">
#          <font face="$global_settings[6]" size="1" color="$global_settings[7]"><strong>Moderator Admin Panel</strong></font></td>
#      </tr>
#      <tr>
#        <td bgcolor="$global_settings[2]" height="27"><p align="left"><font
#        face="$global_settings[6]" size="1" color="$global_settings[8]">Moderate Messages 
#        $fcatname  $forname</font></td>
#      </tr>
#
#END_OF_TOP



############

$topicfile = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/moderate.dat");

@topics = split (/\n/, $topicfile);

$tcount = 0;

foreach $item (@topics)
{
$tcount++;

	 @tlines = split (/\t/, $item);

			### 0 TOPIC ID
			### 1 REPLY NUMBER
			### 2 USER
			### 3 MESSAGE TOPIC	 
			### 4 DATE TIME	 
			### 5 POLL
	
	### IF REPLY
	if ($tlines[1] > 0)
		{
		
		### PREPARE TOPIC HEADING
		$nodisp = "";
		
		foreach $tt (@mtopic)
			{
			if ($tt == $tlines[0])
				{
				$nodisp = "true";
				}
			}

			if ($nodisp ne "true") #### PRINT TOPIC (NO CHECKBOX)
				{
				$sn_mod_mod_cells_tmp = $sn_mod_mod_cells;
				
				$msglink = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all";
				$sn_mod_mod_cells_tmp =~ s/!!message_link!!/$msglink/gi;
				
				$messagenm = $tlines[3];
				$sn_mod_mod_cells_tmp =~ s/!!message!!/$messagenm/gi;
				
				$sn_mod_mod_cells_tmp =~ s/!!poster!!/$tlines[2]/gi;
				
				$micon = qq[<img src="$web_url/sn_dir.gif" border="0">];
				$sn_mod_mod_cells_tmp =~ s/!!icon!!/$micon/gi;
				
				$sn_mod_mod_cells_tmp =~ s/!!checkbox!!//gi;
				
				$topicds = $topicds . $sn_mod_mod_cells_tmp;
				
				#$topicds = $topicds . qq[
				#<tr>
 				#<td bgcolor="$global_settings[3]" height="27"><font face="$global_settings[6]" size="1">
 			   # &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
 			   ##  <img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all" target="_blank"><b>$tlines[3]</b></a>
 			   #</font></td>
				#</tr>
				#END_OF_MAIN
				
				push(@mtopic, $tlines[0]);
				}

		
		### PREPARE REPLY
		
			$msgstatus =  "T" . "_" . 
 	 					$tlines[0] . "_" . ### TOPIC ID
	 					$tlines[1];  ### REPLY NUMBER
			
			$reply_bookmark = $tlines[1] + 1;

			####
			
			$sn_mod_mod_cells_tmp = $sn_mod_mod_cells;

			$msglink = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all#$reply_bookmark";
			$sn_mod_mod_cells_tmp =~ s/!!message_link!!/$msglink/gi;
				
			$messagenm = $tlines[1];
			$sn_mod_mod_cells_tmp =~ s/!!message!!/$messagenm/gi;
			
			$micon = qq[<img src="$web_url/sn_dire.gif" border="0"><img src="$web_url/sn_dir.gif" border="0">];
			$sn_mod_mod_cells_tmp =~ s/!!icon!!/$micon/gi;
			
			$sn_mod_mod_cells_tmp =~ s/!!poster!!/$tlines[2]/gi;
			
			$checkb = qq[<input type="checkbox" name="$msgstatus" value="Y">];
			$sn_mod_mod_cells_tmp =~ s/!!checkbox!!/$checkb/gi;
			
			$topicds = $topicds  . $sn_mod_mod_cells_tmp;
			
			#$topicds = $topicds . qq[
			#<tr>
			# <td bgcolor="$global_settings[3]" height="27"><font face="$global_settings[6]" size="1">
			#  <input type="checkbox" name="$msgstatus" value="Y">
			#	&nbsp;<img src="$web_url/sn_dire.gif"><img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all#$reply_bookmark" target="_blank"><b>Reply $tlines[1]</b></a> by <b>$tlines[2]</b>
			#</font></td>
			#</tr>
			#];


		}
		else ### IF TOPIC
		{

		$msgstatus =  "T" . "_" . 
 					$tlines[0] . "_" . ### TOPIC ID
 					$tlines[1];  ### REPLY NUMBER


if ($tlines[5] eq "POLLQ123") ### IF POLL
	{
	
	$sn_mod_mod_cells_tmp = $sn_mod_mod_cells;
	
	$checkb = qq[<input type="checkbox" name="$msgstatus" value="Y">];
	$sn_mod_mod_cells_tmp =~ s/!!checkbox!!/$checkb/gi;
	
	$poll_link = "$scripts_url/sn_forumpr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt";
	$sn_mod_mod_cells_tmp =~ s/!!message_link!!/$poll_link/gi;
	
	$sn_mod_mod_cells_tmp =~ s/!!message!!/$tlines[3]/gi;
	
	$micon = qq[<img src="$web_url/sn_poll.gif">];
	$sn_mod_mod_cells_tmp =~ s/!!icon!!/$micon/gi;
	
	$sn_mod_mod_cells_tmp =~ s/!!poster!!/$tlines[2]/gi;
	
	$topicds = $topicds . $sn_mod_mod_cells_tmp;
	
	#$topicds = $topicds . <<END_OF_MAIN0;
	#<tr>
	# <td bgcolor="$global_settings[3]" height="27"><font face="$global_settings[6]" size="1">
	#	<input type="checkbox" name="$msgstatus" value="Y">
	#	<img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumpr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt" target="_blank">
	#	<b>$tlines[3]</b></a> <img src="$web_url/sn_poll.gif">  by <b>$tlines[2]</b>
	#</font></td>
	#</tr>
	#END_OF_MAIN0
	
	}
	else
	{
	
	$sn_mod_mod_cells_tmp = $sn_mod_mod_cells;
	
	$checkb = qq[<input type="checkbox" name="$msgstatus" value="Y">];
	$sn_mod_mod_cells_tmp =~ s/!!checkbox!!/$checkb/gi;
	
	$sn_mod_mod_cells_tmp =~ s/!!message!!/$tlines[3]/gi;
	
	$micon = qq[<img src="$web_url/sn_dir.gif" border="0"> ];
	$sn_mod_mod_cells_tmp =~ s/!!icon!!/$micon/gi;
	
	$msgl = "$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all";
	$sn_mod_mod_cells_tmp =~ s/!!message_link!!/$msgl/gi;
	
	$sn_mod_mod_cells_tmp =~ s/!!poster!!/$tlines[2]/gi;
	
	$topicds = $topicds . $sn_mod_mod_cells_tmp;
	
#$topicds = $topicds . <<END_OF_MAIN; ### IF TOPIC
#<tr>
# <td bgcolor="$global_settings[3]" height="27"><font face="$global_settings[6]" size="1">
#	<input type="checkbox" name="$msgstatus" value="Y">
#	<img src="$web_url/sn_dir.gif"> <a href="$scripts_url/sn_forumr.cgi?fid=$fid&cid=$cid&tid=$tlines[0]&mod=$modcrypt&all=all" target="_blank"><b>$tlines[3]</b></a>  by <b>$tlines[2]</b>
#</font></td>
#</tr>	
#END_OF_MAIN
	}

		}


}


$sn_mod_mod_frame =~ s/!!message_cells!!/$topicds/gi;

#$modtable = $modtable . $topicds;

#if ($tcount > 0)
#	{
#
#$modtable = $modtable . <<APPROVE_BUTTON;
#<tr>
# <td bgcolor="$global_settings[3]" height="27">
#   <input type="submit" value="Approve" name="B1" style="font-family: Arial; font-size: 8pt"> 
#   <input type="submit" value="Delete" name="B1" style="font-family: Arial; font-size: 8pt">
# </td>
#</tr>	
#APPROVE_BUTTON
#
#	}
#	else
#	{
#
#$modtable = $modtable . <<NO_MESSAGES;
# <tr>
#  <td bgcolor="$global_settings[3]" height="27"><font face="$global_settings[6]" size="1">
#	No message currently needs approval for display.
# </font></td>
# </tr>
#NO_MESSAGES
#	
#	}
#$modtable = $modtable . "</table></td></tr></table>";


#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
#$template =~ s/!!netboard!!/$modtable/g;
#print $template;


$mod_frame =~ s/!!modadm_functions!!/$sn_mod_mod_frame/gi;
$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;

$globalframe =~ s/!!forums!!/$mod_frame/gi;

@settings = sn_netbbs::get_global_settings();

$template =~ s/!!forum_name!!/$settings[11]/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$globalframe =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g; 

print $globalframe;


}








sub approve_msgs
{

my ($cid, $fid, $fcatname, $forname, $moderf, @mlines, @mdlines, $selval, $item, $selected, $modcrit, $topicfile, 
    $tline, @ititems, $acount, @topics, $msgfile, @msgs, $mline, @mits, $mcount, $statfile, @stats);

$cid = $q->param('cid');
$fid = $q->param('fid');

### GET TEMPLATES

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_global.html");
$ptitle = sn_netbbs::get_page_title("sn_mod_global");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;


$fcatname = sn_netbbs::get_cat_name($cid);
$forname = sn_netbbs::get_forum_name($cid, $fid);

$topicfile = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@topics = split (/\n/, $topicfile);

$statfile = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@stats = split (/\n/, $statfile);

$mcount = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/mtopics.cnt");

@global_settings = sn_netbbs::get_global_settings;

### GET MESSAGES THAT IS NOT VISIBLE

$moderf = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
@mlines = split (/\n/, $moderf);

foreach $item (@mlines)
	{
		@mdlines = split (/\t/, $item);
		### 0 TOPIC ID
		### 1 REPLY NUMBER
		### 2 USER
		### 3 MESSAGE TOPIC	 
		### 4 DATE TIME	 
		### 5 POLL
		
		$selval = "T_" . $mdlines[0] . "_" . $mdlines[1];
		
		if ($q->param($selval) eq "Y") ### IF MESSAGES SELECTED
			{
			$selected = "true";


				### IF TOPIC/POLL SELECTED SET TOPICS TO APPROVED (topic.dat)
				if ($mdlines[1] == 0)
					{
					
						$acount = 0;
						foreach $tline (@topics) ### GO THROUGH TOPICS
							{
							@ititems = split(/\t/, $tline);
					
									#########
									if ($ititems[0] == $mdlines[0])
										{
										if ($q->param('B1') eq "Delete") ### SET TOPIC FOR DELETION
												{
												$topics[$acount] = "TO:DELETE:THIS";
												$stats[$acount] = "TO:DELETE:THIS";
												}
												else ### CHANGE TOPIC TO APPROVED
												{
												$topics[$acount] = $ititems[0] ."\t". 
																		 $ititems[1] ."\t". 
																		 $ititems[2] ."\t". 
																		 $ititems[3] ."\t". 
																		 $ititems[4] ."\t".
															 		    $ititems[5] ."\t". 
															 		    $ititems[6] ."\t". 
															 		    $ititems[7] ."\t". 
															 		    $ititems[8] ."\t". 
															 		    "N" 			 ."\t". 
															 		    $ititems[10];
												}
										}
													#########
													
									$acount++;
							}
					
					}


		### SET MESSAGES APPROVED IN 'ID'.DAT
		$msgfile = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$mdlines[0].dat");
		@msgs = split (/\n/, $msgfile);
		$acount = 0;

				if ($mdlines[5] ne "POLLQ123") ### WRITE MESSAGES APPROVED IN 'ID'.DAT
				{
					
					open (TWRITE, "> $data_dir/$cid/$fid/$mdlines[0].dat");
					 if ($flocking ne "No"){flock (TWRITE,2);}
					
					
						#### FOREACH MESSAGE ######
					   foreach $mline (@msgs)
						{
						
						if ($mdlines[1] == $acount) ## GET MESSAGE LINE IN 'ID'.DAT
							{
								@mits = split (/\t/, $mline);
								
								if ($q->param('B1') ne "Delete")
									{
									print  TWRITE 	$mits[0] ."\t". 
														$mits[1] ."\t". 
														$mits[2] ."\t". 
														$mits[3] ."\t". 
														$mits[4] ."\t".
													   $mits[5] ."\t". 
													   $mits[6] ."\t". 
													   $mits[7] ."\t". 
													   $mits[8] ."\t". 
													   "N" ."\t".  
													   $mits[10] . "\n";
									
									if ($mdlines[1] != 0)
										{
										sn_netbbs::write_stats($cid, $fid, $mdlines[0], "1", "0", $mits[6], $mits[1]);
										}
									
									}
								$mcount = $mcount - 1;

							}
							else
							{
								print TWRITE $mline . "\n";
							}
							
						$acount++;
						}
						###########################
				 
					  if ($flocking ne "No"){flock (TWRITE,8);}
					 close (TWRITE);
					 
					 
				}
				elsif ($q->param('B1') eq "Delete")
				{
				if ((-e "$data_dir/$cid/$fid/$mdlines[0].cnt") > 0)
					{
					unlink("$data_dir/$cid/$fid/$mdlines[0].cnt");
					}
				unlink("$data_dir/$cid/$fid/$mdlines[0].dat");
				$mcount = $mcount - 1;
				}
				else
				{
				$mcount = $mcount - 1;
				}
				
				 
				 ## IF MESSAGE FILE IS EMPTY
				 $msgfile = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/$mdlines[0].dat");
				 if ($msgfile eq "") 
				 		{
				 		unlink("$data_dir/$cid/$fid/$mdlines[0].dat");
				 		unlink("$data_dir/$cid/$fid/$mdlines[0].cnt");
				 		}

			}
			else
			{
			### MODIFY ENTRIES LEFT
			$modcrit = $modcrit . $item . "\n";
			}

	} #### END OF LOOP THROUGH MODIFY ITEMS




##### WRITE CHANGED TOPIC DATA

if ($selected ne "true")
		{
		
		$error_template = sn_netbbs::get_file_contents("$data_dir/sn_mod_mod_error.html");

		$mod_frame =~ s/!!modadm_functions!!/$error_template/gi;
		$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
		$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;

		$globalframe =~ s/!!forums!!/$mod_frame/gi;

		@settings = sn_netbbs::get_global_settings();

		$template =~ s/!!forum_name!!/$settings[11]/gi;
		$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

		$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
		$globalframe =~ s/!!location!!/$loclink/g;

		$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
		$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
		$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
		$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
		$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
		$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
		$globalframe =~ s/!!logo!!/$forumlogo/gi; 
		$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
		$globalframe =~ s/!web_url!/$web_url/g; 
		
		print $globalframe;
		exit;
		
		#print "Please select a message for display in the forum."; exit;
		
		
		}
		else ### WRITE DATA
		{
		
		## WRITE MODERATE ENTRIES LEFT
		open (TWRITE, "> $data_dir/$cid/$fid/moderate.dat");
	    if ($flocking ne "No"){flock (TWRITE,2);}
		  print TWRITE $modcrit;
 		 if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);


		## WRITE EDITED TOPICS.DAT
		open (TWRITE, "> $data_dir/$cid/$fid/topics.dat");
	   if ($flocking ne "No"){flock (TWRITE,2);}
			foreach $item (@topics)
				{
				if ($item !~ /TO:DELETE:THIS/)
					{
					print TWRITE $item . "\n";
					}
				}
		if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);

		
		## UPDATE TSTATS.DAT IF DELETE
		if ($q->param('B1') eq "Delete")
			{
			open (TWRITE, "> $data_dir/$cid/$fid/tstats.dat");
		   if ($flocking ne "No"){flock (TWRITE,2);}
				foreach $item (@stats)
					{
					if ($item !~ /TO:DELETE:THIS/)
						{
						print TWRITE $item . "\n";
						}
					}
			if ($flocking ne "No"){flock (TWRITE,8);}
			close (TWRITE);
			
			$ad_template = sn_netbbs::get_file_contents("$data_dir/sn_mod_mod_del.html");
			
			}
			else
			{
			$ad_template = sn_netbbs::get_file_contents("$data_dir/sn_mod_mod_success_appr.html");
			}
			
		
		## MODERATOR COUNT MSG
		open (TWRITE, "> $data_dir/$cid/$fid/mtopics.cnt");
	   if ($flocking ne "No"){flock (TWRITE,2);}
			print TWRITE $mcount;
		if ($flocking ne "No"){flock (TWRITE,8);}
		close (TWRITE);


		$ad_template =~ s/!!current_forum_category!!/$fcatname/gi;
		
		$appalink = "$scripts_url/sn_moderate.cgi?fct=moderate&fid=$fid&cid=$cid";
		$ad_template =~ s/!!appr_area!!/$appalink/gi;

		$mod_frame =~ s/!!modadm_functions!!/$ad_template/gi;
		$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
		$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;

		$globalframe =~ s/!!forums!!/$mod_frame/gi;

		@settings = sn_netbbs::get_global_settings();

		$template =~ s/!!forum_name!!/$settings[11]/gi;
		$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

		$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
		$globalframe =~ s/!!location!!/$loclink/g;

		$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
		$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
		$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
		$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
		$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
		$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
		$globalframe =~ s/!!logo!!/$forumlogo/gi; 
		$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
		$globalframe =~ s/!web_url!/$web_url/g; 
		
		print $globalframe;
		exit;

		}


}





sub start
{

my ($lhtmldata, @rawc, $citem, $key, $val, %cookies, $item2, $uname, $upass, $template);



if ($q->param('login') eq "true") ### DO LOGIN IF WE NEED TO LOGIN
	{
	$username = $q->param('username');
	$password = $q->param('password');
	
	$cookval = $username . ":" . $password;
	sn_netbbs::setCookie("USER",$cookval);
	
	print "Content-type: text/html\n\n";

	print qq[<html>
	<head>
	<title></title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$scripts_url/sn_moderate.cgi?fct=moderator_start_scr">
	</head>
	<body>
	</body>
	</html>
	];	
	exit;
	}



####### GET COOKIES ####################################################
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}

($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

@usettings = sn_netbbs::check_username_password($uname, $upass);


if ($usettings[0] eq "ERROR")
	{
	### ACCOUNT DOESN'T EXIST
	$login_error = "error1";
	}

if ((substr($usettings[12], 0, 2) ne "Mo") and (substr($usettings[12], 0, 2) ne "Ad"))
	{
	### ACCOUNT NOT A MOD/ADM
	$login_error = "error2";
	}



if ($login_error ne "")
	{
	print "Content-type: text/html\n\n";
	
	@settings = sn_netbbs::get_global_settings();
	
	$template = sn_netbbs::get_file_contents("$data_dir/sn_mod_login.html");
	$ptitle = sn_netbbs::get_page_title("sn_mod_login");


		if (($uname eq "") and ($upass eq ""))
		{
		$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
		$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY"); 
		}
		elsif ($login_error eq "error1")
		{
		$template = sn_netbbs::display_errors($template, "error1", ""); 
		$template = sn_netbbs::display_errors($template, "error2", "NODISPLAY"); 
		}
		else
		{
		$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
		$template = sn_netbbs::display_errors($template, "error2", "");
		}
	
	$hvars = qq[
	<input type="hidden" name="login" value="true">
	</form>
	];
	
	$template =~ s/<\/form>/$hvars/gi;

	
	$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

	$globalframe =~ s/!!forums!!/$template/gi;
	$globalframe =~ s/!!login_script!!/$scripts_url\/sn_moderate.cgi/g;
	
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/g;

	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 


		if ($url_write eq "SEO_ENABLED")
			{	
			$domain = sn_netbbs::get_domain($web_url);
			$loclink = "http://$domain/forumindex.html";
			$loclink = qq[<a href="$loclink">$settings[11]</a>];
			}
			else
			{
			$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
			}

	$globalframe =~ s/!!location!!/$loclink/g;
 
 	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
 	
 	$globalframe =~ s/!!pagetitle!!/$ptitle/g;
 	$globalframe =~ s/!web_url!/$web_url/g;
 
	print $globalframe;
	exit;
	
	}

#$lhtmldata =~ s/!!username!!/$uname/g;
#$lhtmldata =~ s/!!password!!/$upass/g;

#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
#$template =~ s/!!netboard!!/$lhtmldata/g;
#print $template;

}









sub moderator_start_scr
{
my ($muser) = @_;


#$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
#$template = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_global.html");
$ptitle = sn_netbbs::get_page_title("sn_mod_global");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$sn_mod_table_main = sn_netbbs::get_file_contents("$data_dir/sn_mod_table_main.html");
$sn_mod_cells_cat = sn_netbbs::get_file_contents("$data_dir/sn_mod_cells_cat.html");
$sn_mod_cells_forum = sn_netbbs::get_file_contents("$data_dir/sn_mod_cells_forum.html");


#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");


### GLOBAL FORUM SETTINGS
@global_settings = sn_netbbs::get_global_settings;
$global_settings_line = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");


### USER SETTINGS
@usettings = sn_netbbs::check_username_password($uname, $upass);

$bcatdata = sn_netbbs::get_file_contents("$data_dir/sn_boardtable.dat");
@board_cats = split (/\n/, $bcatdata);

$forum_table_lines = "";

foreach $bcat(@board_cats)
	{
	($cid, $catname) = split (/\t/, $bcat);
	
	#print "<b>$catname</b><br>";
	
	$forumdata = sn_netbbs::get_file_contents("$data_dir/$cid/forumtable.dat");
	@forumlines = split (/\n/, $forumdata);

			####################
			
			$print_cat = "FALSE";
			$forum_table_lines = "";
			foreach $forumn (@forumlines)
				{
				($fid, $forumname) = split (/\t/, $forumn);
				$fdata0 = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
				@fdata1 = split (/\n/, $fdata0);
				@fmods = sn_netbbs::get_moderators($fdata1[3]);
					
					
				#### MODERATOR CHECK PER FORUM
					$if_moderator = "FALSE";
					foreach $fmoderator (@fmods)
						{
						if (lc($muser) eq lc($fmoderator))
							{
							$if_moderator = "TRUE";
							}
						}
					
					#print "==> $usettings[0] <br>";
					if (substr($usettings[12], 0, 2) eq "Ad") {$if_moderator = "TRUE";}
					
					if ($if_moderator eq "TRUE")
						{
						$sn_mod_cells_forum_tmp = $sn_mod_cells_forum;
						
						$sn_mod_cells_forum_tmp =~ s/!!forum_name!!/$forumname/gi;
						
						$forum_link = "$scripts_url/sn_forum.cgi?fct=gotoforum&fid=$fid&cid=$cid";
						$sn_mod_cells_forum_tmp =~ s/!!forum_link!!/$forum_link/gi;
						
						$del_link = "$scripts_url/sn_moderate.cgi?fct=del_topics&fid=$fid&cid=$cid";
						$sn_mod_cells_forum_tmp =~ s/!!delete_topics!!/$del_link/gi;
						
						if ($sn_mod_cells_forum_tmp =~ m/\[modr\]/g) { $startpos = pos($sn_mod_cells_forum_tmp); }
						if ($sn_mod_cells_forum_tmp =~ m/\[\/modr\]/g) { $endpos = pos($sn_mod_cells_forum_tmp); }
						$modtext = substr($sn_mod_cells_forum_tmp, $startpos, $endpos - $startpos - 5);
						
						if ((-s "$data_dir/$cid/$fid/moderate.dat") > 0)
							{
							$mlinkstart = qq[<a href="$scripts_url/sn_moderate.cgi?fct=moderate&fid=$fid&cid=$cid">];
							$linkend = "</a>";
							$sn_mod_cells_forum_tmp =~ s/\[modr\]/$mlinkstart/gi;
							$sn_mod_cells_forum_tmp =~ s/\[\/modr\]/$linkend/gi;
							}
							else
							{
							$sn_mod_cells_forum_tmp =~ s/\[modr\]//gi;
							$sn_mod_cells_forum_tmp =~ s/\[\/modr\]//gi;
							}
						
						$modtps = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/mtopics.cnt");
						if ($modtps eq "") { $modtps = 0; }
						$sn_mod_cells_forum_tmp =~ s/!!nr!!/$modtps/gi;
						
						$forset_link = "$scripts_url/sn_moderate.cgi?fct=fsettings&fid=$fid&cid=$cid";
						$sn_mod_cells_forum_tmp =~ s/!!forum_settings!!/$forset_link/gi;
						
						$forum_table_lines = $forum_table_lines . $sn_mod_cells_forum_tmp;
						#print &get_forum_lines($cid, $fid, $forumname, $global_settings_line);
						$print_cat = "TRUE";
						}
						
					###############################
				}


		if ($if_moderator eq "TRUE")
			{
			$sn_mod_cells_cat_tmp = $sn_mod_cells_cat;
			$sn_mod_cells_cat_tmp =~ s/!!category_name!!/$catname/gi;
			$cc_link = "$scripts_url/sn_forum.cgi?fct=showf&cid=$cid";
			$sn_mod_cells_cat_tmp =~ s/!!category_link!!/$cc_link/gi;
			
			$cforumtable = $cforumtable . $sn_mod_cells_cat_tmp;
			$cforumtable = $cforumtable . $forum_table_lines;
			}

	}


### TABLE TOP

$complete_table = $sn_mod_table_main;
$complete_table = $complete_table . $cforumtable;
$complete_table = $complete_table . "</table>";

############################

$mod_frame =~ s/!!modadm_functions!!/$complete_table/gi;
$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;

$globalframe =~ s/!!forums!!/$mod_frame/gi;

@settings = sn_netbbs::get_global_settings();

$template =~ s/!!forum_name!!/$settings[11]/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$globalframe =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g; 

print $globalframe;

}










sub del_topics
{

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_global.html");
$ptitle = sn_netbbs::get_page_title("sn_mod_global");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$sn_mod_del_table = sn_netbbs::get_file_contents("$data_dir/sn_mod_del_table.html");
$sn_mod_del_cells = sn_netbbs::get_file_contents("$data_dir/sn_mod_del_cells.html");
$sn_mod_del_unable = sn_netbbs::get_file_contents("$data_dir/sn_mod_del_unable.html");

@global_settings = sn_netbbs::get_global_settings();

$cid = $q->param('cid');
$fid = $q->param('fid');

$topicdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@alltopics = split(/\n/, $topicdata);

$fcatname = sn_netbbs::get_cat_name($cid);
$forname = sn_netbbs::get_forum_name($cid, $fid);

### TOP OF DEL TABLE #######

$hvars = qq[  <input type="hidden" name="cid" value="$cid">
<input type="hidden" name="fid" value="$fid">
<input type="hidden" name="fct" value="delete_topics_final">
</form>
];


$sn_mod_del_table =~ s/<\/form>/$hvars/gi;
$sn_mod_del_table =~ s/!!current_forum_category!!/$fcatname/gi;
$sn_mod_del_table =~ s/!!forum_name!!/$forname/gi;


#$topbut = &get_moderator_panel_buttons;
#$ttop = $ttop . <<END_OF_TOPT;
#<form name="delete_topics" method="POST" action="$scripts_url/sn_moderate.cgi">
#  <input type="hidden" name="cid" value="$cid">
#  <input type="hidden" name="fid" value="$fid">
#  <input type="hidden" name="fct" value="delete_topics_final">
#  <input type="hidden" name="m" value="$username">
#  <input type="hidden" name="p" value="$epassword">
#$topbut
#<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="$global_settings[5]">
#  <tr>
#    <td bgcolor="$global_settings[5]">
#       <table border="0" cellpadding="3" cellspacing="1" width="100%">
#      <tr>
#        <td bgcolor="$global_settings[1]" height="27" colspan="5"><p align="left"><font
#        face="$global_settings[6]" size="1" color="$global_settings[7]"><strong>Moderator Admin Panel</strong></font></td>
#      </tr>
#      <tr>
#        <td bgcolor="$global_settings[2]" height="27" colspan="5"><p align="left"><font
#        face="$global_settings[6]" size="1" color="$global_settings[8]">Delete Messages  $fcatname  $forname</font></td>
#      </tr>
#END_OF_TOPT


$moderate_data = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/moderate.dat");
@mod_items = split (/\n/, $moderate_data);


if (length($moderate_data) > 1)
		{
		$mditems = @mod_items;
		
	sysopen(FH, "$data_dir/$cid/$fid/mtopics.cnt", O_RDWR|O_CREAT) or die "can't open mtopics.cnt: $!";
	  flock(FH, LOCK_EX)                           or die "can't flock mtopics.cnt: $!";
	  seek(FH, 0, 0)                               or die "can't rewind mtopics.cnt: $!";
	  truncate(FH, 0)                              or die "can't truncate mtopics.cnt: $!";
	  print FH $mditems                        	  or die "can't write mtopics.cnt: $!";
	close (FH)                                     or die "can't close mtopics.cnt: $!";

	$sn_mod_del_unable =~ s///gi;

	$mod_frame =~ s/!!modadm_functions!!/$sn_mod_del_unable/gi;
	$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
	$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;
	
	$mod_frame =~ s/!!delete_script!!/$scripts_url\/sn_moderate.cgi/gi;
	
	$globalframe =~ s/!!forums!!/$mod_frame/gi;
	
	@settings = sn_netbbs::get_global_settings();
	
	$template =~ s/!!forum_name!!/$settings[11]/gi;
	$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;
	
	$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
	$globalframe =~ s/!!location!!/$loclink/g;
		
	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
		
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
		
	$globalframe =~ s/!web_url!/$web_url/g; 
	
	print $globalframe;
	exit;

#$ttop = $ttop . <<END_OF_NODEL;
#  <tr>
#    <td bgcolor="$global_settings[3]" height="27">
#     <font face="$global_settings[6]" size="1">
#      You cannot delete messages when there is messages that needs aproval (moderation) for display.
#      <br><br><b>Use the back button of your browser to go back</b>
#     </font>
#    </td>
#  </tr>
#</table></td></tr></table>
#END_OF_NODEL

		#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
		#$template =~ s/!!netboard!!/$ttop/g;
		
		#$sn_mod_del_table =~ s/!!delete_cells!!/$sn_mod_del_unable/gi;
		#print $sn_mod_del_unable;
		#exit;
		}


$statdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@stats = split (/\n/,$statdata);
$bcn = 0;


### PAGES
$icnt = @stats;

if (($q->param('all') eq "all") and ($icnt != 0))
 {
 $nr_searchres = $icnt;
 }
 else
 {
 $nr_searchres = 30;
 }

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

##########

foreach $item (@alltopics)
{

  if (($ippc > $st) and ($ippc <= $nd))
    {
	
	(@topics) = split (/\t/,$item);

		$checkboxname = "C_" . $topics[0];
		
		($tmp, $posts, $views, $lastpost) = split(/\t/, $stats[$bcn]);
		$posts = $posts - 1;
		$bcn++;
		$lastpost = sn_netbbs::decode_date($lastpost);

		#### ICONS
		if (($topics[4] eq "NONE") or ($topics[4] eq "")) 
				{
				$icon = "";
				$topiclink = "$scripts_url/sn_forumr.cgi?tid=$topics[0]&cid=$cid&fid=$fid";
				$topic_subject = $topics[3];
				}
				elsif ($topics[4] eq "POLLQ123")
				{
				$icon = "<img src=\"$web_url/sn_poll.gif\">";
				$posts = "<img src=\"$web_url/sn_poll.gif\">"; 
				$topiclink = "$scripts_url/sn_forumpr.cgi?tid=$topics[0]&cid=$cid&fid=$fid";
				$topic_subject = $topics[3];
				}
				else
				{
				$icon = "<img src=\"$web_url/icons/$topics[4]\">";
				$topiclink = "$scripts_url/sn_forumr.cgi?tid=$topics[0]&cid=$cid&fid=$fid";
				$topic_subject = $topics[3];
				}

$java_aname = $java_aname . "'$checkboxname',";

if ($icon eq "") { $icon = "&nbsp;"; }

$sn_mod_del_cells_tmp = $sn_mod_del_cells;

$checkbox = qq[<input type="checkbox" name="$checkboxname" value="Y">];
$sn_mod_del_cells_tmp =~ s/!!checkbox!!/$checkbox/g;

$sn_mod_del_cells_tmp =~ s/!!icon!!/$icon/g;

$sn_mod_del_cells_tmp =~ s/!!topic_link!!/$topiclink/g;
$sn_mod_del_cells_tmp =~ s/!!topic_subject!!/$topic_subject/g;

$sn_mod_del_cells_tmp =~ s/!!poster_name!!/$topics[1]/g;
$sn_mod_del_cells_tmp =~ s/!!post_time!!/$lastpost/g;

$sn_mod_del_cells_tmp =~ s/!!replies!!/$posts/g;

#$ttop = $ttop . <<END_OF_TT2;
#  <tr>
#    <td width="5%" bgcolor="$global_settings[3]"><input type="checkbox" name="$checkboxname" value="Y"></td>
#    <td width="5%" bgcolor="$global_settings[3]">$icon</td>
#    <td width="50%" bgcolor="$global_settings[3]"><font face="$global_settings[6]" size="1">$topiclink</font></td>
#    <td width="35%" bgcolor="$global_settings[3]"><font face="$global_settings[6]" size="1"><b>$topics[1]</b><br>$lastpost</font></td>
#    <td width="5%" bgcolor="$global_settings[3]"><font face="$global_settings[6]" size="1"><p align="center">$posts</font></td>
#  </tr>
#END_OF_TT2

$del_table_cells = $del_table_cells . $sn_mod_del_cells_tmp;

   } ### END OF PAGE RESULTS

  $ippc++;

} ### END OF LOOP THROUGH TOPICS


#######
chop($java_aname);

$java_function = qq[

<script language="javascript" type="text/javascript">
<!--

function checkall (formname,thestate)
	{
	BoxNames=new Array($java_aname)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c]);
		boxname.checked = thestate;
		}
	}

// -->
</script>
];

$sn_mod_del_table = $sn_mod_del_table . $java_function;

$jscript_all = "javascript:checkall('delete_topics',true)";
$sn_mod_del_table =~ s/!!check_all!!/$jscript_all/gi;

$jscript_unall = "javascript:checkall('delete_topics',false)";
$sn_mod_del_table =~ s/!!uncheck_all!!/$jscript_unall/gi;



### PLACE CELLS IN DELETE TABLE FRAME
$sn_mod_del_table =~ s/!!delete_cells!!/$del_table_cells/gi;


#$ttop = $page_header . $ttop;
#if ($ippc > 1) 
#{
#$ttop = $ttop . <<END_OFTE;
#</table></td></tr></table>
#<p><input type="submit" value="Delete" name="B1" style="font-family: MS Sans Serif; font-size: 8"><br>
#  <font face="$global_settings[6]" size="1">Check the checkbox next to topic(s) and click the delete button to delete topics.<br>
#  <br><a href="javascript:checkall('delete_topics',true)">Check All</a> | <a href="javascript:checkall('delete_topics',false)">Uncheck All</a>
#  </font></p>
#</form>
#END_OFTE
#}
#else
#{
#$ttop = $ttop . <<END_OFTE;
#<tr>
#  <td bgcolor="$global_settings[3]" height="27"><font face="$global_settings[6]" size="1">
#  There are no topics to delete. Use the back button of your browser to go back.
#</tr>
#</table></td></tr></table>
#</form>
#END_OFTE

#$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
#$template =~ s/!!netboard!!/$ttop/g;
#print $template;


### PAGES

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . " <a href=\"$scripts_url/sn_moderate.cgi?fct=del_topics&cid=$cid&fid=$fid&st=$st1&nd=$nd1\">$pg</a> ";
		}
	}


$sn_mod_del_table =~ s/!!pages!!/$pgstring/gi;



####### PREVIOUS / NEXT

$s_nextpage = sn_netbbs::get_file_contents("$data_dir/sn_nextp.html");
$s_prevpage = sn_netbbs::get_file_contents("$data_dir/sn_prevp.html");
$s_nextprev_sep = sn_netbbs::get_file_contents("$data_dir/sn_nextprevsep.html");

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = " <a href=\"$scripts_url/sn_moderate.cgi?fct=del_topics&cid=$cid&fid=$fid&st=$st1&nd=$nd1\">$s_nextpage</a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = " <a href=\"$scripts_url/sn_moderate.cgi?fct=del_topics&cid=$cid&fid=$fid&st=$st1&nd=$nd1\">$s_prevpage</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " $s_nextprev_sep ";
	}
	else
	{
	$spcer = " ";
	}

   $prevnext = "$prev $spcer $nextt";


$sn_mod_del_table =~ s/!!next_page!!/$prevnext/gi;   




########

	$ippc = $ippc - 1;
	
	#$ttop = $ttop . "<p><font face=\"$global_settings[6]\" size=\"1\">Total topics: <strong>$ippc</strong>";
	
	$sn_mod_del_table =~ s/!!total_topics!!/$ippc/gi;
	$sn_mod_del_table =~ s/!!topics_per_page!!/$nr_searchres/gi;
	
   #if ($pg > 1)
    #{
	   #$ttop = $ttop . "  | Listing <strong>$nr_searchres</strong> topics per page. ";    
		#$ttop = $ttop . "| <a href=\"$scripts_url/sn_moderate.cgi?fct=del_topics&cid=$cid&fid=$fid&all=all\">List All Topics</a> </font></p>";
	# }

#######

$all_tlink = "$scripts_url/sn_moderate.cgi?fct=del_topics&cid=$cid&fid=$fid&all=all";
$sn_mod_del_table =~ s/!!list_all_topics!!/$all_tlink/gi;

$mod_frame =~ s/!!modadm_functions!!/$sn_mod_del_table/gi;
$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;

$mod_frame =~ s/!!delete_script!!/$scripts_url\/sn_moderate.cgi/gi;

$globalframe =~ s/!!forums!!/$mod_frame/gi;

@settings = sn_netbbs::get_global_settings();

$template =~ s/!!forum_name!!/$settings[11]/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$globalframe =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g; 

print $globalframe;

}




sub delete_topics_final
{

$cid = $q->param('cid');
$fid = $q->param('fid');

@global_settings = sn_netbbs::get_global_settings();

$fcatname = sn_netbbs::get_cat_name($cid);
$forname = sn_netbbs::get_forum_name($cid, $fid);

$topicdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/topics.dat");
@topics = split(/\n/, $topicdata);

$statdata = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/tstats.dat");
@astats = split (/\n/, $statdata);

$bcn = 0;
foreach $item (@topics)
	{
	(@titems) = split(/\t/,$item);
	$chbox = "C_" . $titems[0];
	if ($q->param($chbox) ne "Y")
			{
			$writ_crit = $writ_crit . $item . "\n";
			$stat_crit = $stat_crit . $astats[$bcn] . "\n";
			}
			else
			{
			$something_selected = "true";
			unlink ("$data_dir/$cid/$fid/$titems[0].dat");
			if (-e "$data_dir/$cid/$fid/$titems[0].cnt")
				{
				unlink ("$data_dir/$cid/$fid/$titems[0].cnt");
				}
			}
	$bcn++;
	}

if ($something_selected eq "true")
	{

open (TOPICTABLE, "> $data_dir/$cid/$fid/topics.dat");
if ($flocking ne "No"){flock (TOPICTABLE,2);}
	print TOPICTABLE $writ_crit;
if ($flocking ne "No"){flock (TOPICTABLE,8);}
close (TOPICTABLE);

open (STATST, "> $data_dir/$cid/$fid/tstats.dat");
if ($flocking ne "No"){flock (STATST,2);}
	print STATST $stat_crit;
if ($flocking ne "No"){flock (STATST,8);}
close (STATST);

	#$opptext = "Messages Deleted | <a href=\"$scripts_url/sn_moderate.cgi?fct=del_topics&fid=$fid&cid=$cid&m=$username&p=$epassword\">Delete more messages in this forum</a>";
	
	$modlink = "$scripts_url/sn_moderate.cgi?fct=del_topics&fid=$fid&cid=$cid";
	
	$template = sn_netbbs::get_file_contents("$data_dir/sn_mod_del_success.html");
	$template =~ s/!!delete_area!!/$modlink/gi;
	
	}
else
	{
	#$opptext = "You need to select at least one topic to delete a topic. <br><b>Use the back button of your browser to go back.</b>";	
	$template = sn_netbbs::get_file_contents("$data_dir/sn_mod_del_error.html");
	}


$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

if ($q->param('indmsg') eq "true")
	{
	$sn_edit_saved = $template = sn_netbbs::get_file_contents("$data_dir/sn_edit_saved.html");

	#sn_forum.cgi?fid=1195&cid=1193&fct=gotoforum
	
	$sn_edit_saved =~ s/!!view_message_link!!/$scripts_url\/sn_forum.cgi?fid=$fid&cid=$cid&fct=gotoforum/gi;

	@settings = sn_netbbs::get_global_settings();

	$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
	$sn_edit_saved =~ s/!!location!!/$loclink/g;
		
	$globalframe =~ s/!!forums!!/$sn_edit_saved/gi;
	
	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
	$globalframe =~ s/!web_url!/$web_url/g;
	
	print $globalframe;
	exit;	
	}


$mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_global.html");
$ptitle = sn_netbbs::get_page_title("sn_mod_global");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$mod_frame =~ s/!!modadm_functions!!/$template/gi;
$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;


$globalframe =~ s/!!forums!!/$mod_frame/gi;

@settings = sn_netbbs::get_global_settings();

$template =~ s/!!forum_name!!/$settings[11]/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$globalframe =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g; 

print $globalframe;

exit;

}



sub get_moderator_panel_buttons
{

$mchbuttons = <<END_OF_BUT;

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%"><p align="right"><a
    href="$scripts_url/sn_moderate.cgi?fct=moderator_start_scr&amp;m=$username&amp;p=$epassword"><img
    src="$web_url/sn_mhome.gif" border="0"></a> <a href="$scripts_url/sn_forum.cgi"
    target="_blank"><img src="$web_url/sn_gotoforums.gif" border="0"></a></td>
  </tr>
</table>

END_OF_BUT

return ($mchbuttons);

}



sub fsettings
{

my ($display_error) = @_;

$cid = $q->param('cid');
$fid = $q->param('fid');

$fcatname = sn_netbbs::get_cat_name($cid);
$forname = sn_netbbs::get_forum_name($cid, $fid);

$fort = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fprop = split(/\n/,$fort);

#####

if ($fprop[4] eq "Any"){$whop2 = "selected";}
if ($fprop[4] eq "Registered"){$whop2 = "selected";}
if ($fprop[4] eq "Moderators"){$whop3 = "selected";}

if ($fprop[5] eq "Y"){$polls1 = "selected";}
	else
	{$polls2 = "selected";}
	
if ($fprop[6] eq "Y"){$ahtml1 = "selected";}
	else
	{$ahtml2 = "selected";}


if ($fprop[7] eq "Y"){$modr1 = "selected";}
	else
	{$modr2 = "selected";}

if ($fprop[9] eq "N"){$iconno = "selected";}
	else
	{$iconyes = "selected";}

if ($fprop[10] eq "Y"){$pspyes = "selected";}
	else
	{$pspno = "selected";}


if ($fprop[12] eq "N"){$postprvno = "selected";}
	else
	{$postprvyes = "selected";}

####

@global_settings = sn_netbbs::get_global_settings;

#$topbut = &get_moderator_panel_buttons;

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_global.html");
$ptitle = sn_netbbs::get_page_title("sn_mod_global");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

$sn_forum_settings = sn_netbbs::get_file_contents("$data_dir/sn_forum_settings.html");

$sn_forum_settings =~ s/!!forum_name!!/$fprop[1]/gi;
$sn_forum_settings =~ s/!!forum_description!!/$fprop[2]/gi;
$sn_forum_settings =~ s/!!forum_description!!/$fprop[2]/gi;

$sn_forum_settings =~ s/!!reg_select!!/$whop2/gi;
$sn_forum_settings =~ s/!!mod_select!!/$whop3/gi;

$sn_forum_settings =~ s/!!polls1!!/$polls1/gi;
$sn_forum_settings =~ s/!!polls2!!/$polls2/gi;

$sn_forum_settings =~ s/!!ahtml1!!/$ahtml1/gi;
$sn_forum_settings =~ s/!!ahtml2!!/$ahtml2/gi;

$sn_forum_settings =~ s/!!modr1!!/$modr1/gi;
$sn_forum_settings =~ s/!!modr2!!/$modr2/gi;

$sn_forum_settings =~ s/!!ahtml1!!/$ahtml1/gi;
$sn_forum_settings =~ s/!!ahtml2!!/$ahtml2/gi;

$sn_forum_settings =~ s/!!pspyes!!/$pspyes/gi;
$sn_forum_settings =~ s/!!pspno!!/$pspno/gi;

$sn_forum_settings =~ s/!!fpassword!!/$fprop[11]/gi;

$sn_forum_settings =~ s/!!postprvyes!!/$postprvyes/gi;
$sn_forum_settings =~ s/!!postprvno!!/$postprvno/gi;

#######

$sn_forum_settings =~ s/!!save_script!!/$scripts_url\/sn_moderate.cgi/gi;

$hvars = qq[
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="fct" value="save_fsettings">
  <input type="hidden" name="fid" value="$fid">
  </form>
];

$sn_forum_settings =~ s/<\/form>/$hvars/gi;

#######

if ($display_error eq "")
	{
	$sn_forum_settings = sn_netbbs::display_errors($sn_forum_settings, "error1", "NODISPLAY");
	$sn_forum_settings = sn_netbbs::display_errors($sn_forum_settings, "error2", "NODISPLAY");
	}
	elsif ($display_error eq "error1")
	{
	$sn_forum_settings = sn_netbbs::display_errors($sn_forum_settings, "error1", "");
	$sn_forum_settings = sn_netbbs::display_errors($sn_forum_settings, "error2", "NODISPLAY");
	}
	elsif ($display_error eq "error2")
	{
	$sn_forum_settings = sn_netbbs::display_errors($sn_forum_settings, "error1", "NODISPLAY");
	$sn_forum_settings = sn_netbbs::display_errors($sn_forum_settings, "error2", "");
	}


$sn_forum_settings =~ s/!!current_forum_category!!/$fcatname/gi;


$mod_frame =~ s/!!modadm_functions!!/$sn_forum_settings/gi;
$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;

$globalframe =~ s/!!forums!!/$mod_frame/gi;

@settings = sn_netbbs::get_global_settings();

$template =~ s/!!forum_name!!/$settings[11]/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$globalframe =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g; 

print $globalframe;
exit;


}




sub save_fsettings
{


#### ERROR CHECKING

if ($q->param('forum_name') eq "") 
	{
	&fsettings("error1");
	exit;
	#&mod_panel_error("You have to supply a forum name.");
	}

#if ($q->param('forum_description') eq "") {&mod_panel_error("You have to supply a forum description.");}

if (($q->param('password_protected') eq "Y") and ($q->param('fpassword') eq ""))
		{
		&fsettings("error2");
		exit;
		#&mod_panel_error("You have indicated that you want the forum password protected but have not supplied a password.");
		}

###################

$cid = $q->param('cid');
$fid = $q->param('fid');

$fcatname = sn_netbbs::get_cat_name($cid);
$forname = sn_netbbs::get_forum_name($cid, $fid);

$fort = sn_netbbs::get_file_contents("$data_dir/$cid/$fid/config.dat");
@fprop = split(/\n/,$fort);

open (FORUMCONF, "> $data_dir/$cid/$fid/config.dat");
if ($flocking ne "No"){flock (FORUMCONF,2);}

	print FORUMCONF $fprop[0] . "\n" . 										### 0 FORUM ID
						 $q->param('forum_name') . "\n" . 					### 1 FORUM NAME
						 $q->param('forum_description') . "\n" . 			### 2 DESCRIPTION
						 $fprop[3]  . "\n" . 									### 3 MODERATOR NAMES
						 $q->param('whopost') . "\n" . 						### 4 WHO MAY POST
						 $q->param('polls') . "\n" . 							### 5 ALLOW POLLS
						 $q->param('html_msg') . "\n" . 						### 6 ALLOW HTML IN MESSAGES
						 $q->param('moderated') . "\n" .						### 7 IS THIS FORUM MODERATED?
						 $fprop[8] . "\n" .										### 8 CUSTOM GRAPHIC?
						 $q->param('icons') . "\n" .							### 9 SMILEY ICONS?
						 $q->param('password_protected') . "\n" .			### 10 PASSWORD PROTECT FORUM?
						 $q->param('fpassword') . "\n" .						### 11 FORUM PASSWORD
						 $q->param('post_priv') . "\n";						### 12 CAN USERS POST
						 
if ($flocking ne "No"){flock (FORUMCONF,8);}
close (FORUMCONF);

#@global_settings = sn_netbbs::get_global_settings;

#$topbut = &get_moderator_panel_buttons;

$sn_forum_settings_saved = sn_netbbs::get_file_contents("$data_dir/sn_forum_settings_saved.html");
$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$mod_frame = sn_netbbs::get_file_contents("$data_dir/sn_mod_global.html");
$ptitle = sn_netbbs::get_page_title("sn_mod_global");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;


$mod_frame =~ s/!!modadm_functions!!/$sn_forum_settings_saved/gi;
$mod_frame =~ s/!!mcp_home!!/$scripts_url\/sn_moderate.cgi/gi;
$mod_frame =~ s/!!view_forums!!/$scripts_url\/sn_forum.cgi/gi;

$globalframe =~ s/!!forums!!/$mod_frame/gi;

@settings = sn_netbbs::get_global_settings();

$template =~ s/!!forum_name!!/$settings[11]/gi;
$template =~ s/!!forum_link!!/$scripts_url\/sn_forum.cgi/gi;

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$settings[11]</a>];
$globalframe =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
$globalframe =~ s/!web_url!/$web_url/g; 

print $globalframe;
exit;

}








sub mod_panel_error
{

my ($error_text) = @_;

@global_settings = sn_netbbs::get_global_settings;

$lhtmldata = <<END_OF_MERROR;

<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="$global_settings[5]">
  <tr>
    <td bgcolor="$global_settings[5]"><table border="0" cellpadding="3" cellspacing="1"
    width="100%">
      <tr>
        <td bgcolor="$global_settings[1]" height="27"><p align="left"><font
        face="$global_settings[6]" size="1" color="$global_settings[7]"><strong>Moderator Admin
        Panel</strong></font></td>
      </tr>
      <tr>
        <td bgcolor="$global_settings[2]" height="27"><p align="left"><font
        face="$global_settings[6]" size="1" color="$global_settings[8]">Problem</font></td>
      </tr>
      <tr>
        <td bgcolor="$global_settings[3]" height="27"><font face="$global_settings[6]" size="1"><br>
        $error_text<br>
        <br>
        <a href="$scripts_url/sn_moderate.cgi?fct=moderator_start_scr">Moderator Admin Panel Home</a>
        | </font><strong><font face="$global_settings[6]" size="1" color="$global_settings[8]">Use
        the back button of your browser to go back.</font></strong></td>
      </tr>
    </table>
    </td>
  </tr>
</table>

END_OF_MERROR

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");
$template =~ s/!!netboard!!/$lhtmldata/g;
print $template;
exit;
}
