#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $flocking/;

$q = CGI->new;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_proview.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}

#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";
&view_profile2;



#### START ########################################################

sub start
{

my (@rawc, $item2, $key, $val, %cookies, $uname, $upass, @usettings, $lhtmldata, $template);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

####### GET COOKIES
@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$usettings[0] = "";

if (($uname ne "") and ($upass ne ""))
	{
	@usettings = sn_netbbs::check_username_password ($uname, $upass);
	}

if (($usettings[0] eq "ERROR") or ($usettings[0] eq ""))
	{
																						   	 ### WINDOW NAME ### BUTTON NAME
	$lhtmldata = sn_netbbs::login_box("view_profile", "$scripts_url/sn_proview.cgi", "Login - It is required that you login in order to view user profiles.", "View Profile");
	$lhtmldata =~ s/!!username!!//g;
	$lhtmldata =~ s/!!password!!//g;
	
	$template =~ s/!!netboard!!/$lhtmldata/g;
	print $template;
	exit;
	}
	else
	{
	&view_profile2 ("NO_HEADER");
	}

}



sub view_profile
{

my ($uname, $upass, @usettings, $cookval, @settings, $template, $txt);

$template = sn_netbbs::get_file_contents("$data_dir/tmplpopup.html");

$uname = $q->param('username');
$upass = $q->param('password');



@usettings = sn_netbbs::check_username_password ($uname, $upass);

@settings = sn_netbbs::get_global_settings();


if ($usettings[0] eq "ERROR")
	{

print "Content-type: text/html\n\n";
$txt = <<END_OF_PROBLEM;
<form method="POST" action="$scripts_url/sn_login.cgi">
  <input type="hidden" name="fct" value="login"><table border="0" cellpadding="0"
  cellspacing="0" width="100%" bgcolor="$settings[5]">
    <tr>
      <td width="100%" bgcolor="$settings[5]"><table border="0" cellpadding="3" cellspacing="1"
      width="100%">
        <tr>
          <td width="100%" bgcolor="$settings[2]" height="27"><font face="$settings[6]" size="4"><div
          align="center"><center><p></font><font face="$settings[6]" size="2" color="$settings[8]"><strong>Problem</strong></font></td>
        </tr>
        <tr align="center">
          <td width="100%" bgcolor="$settings[3]" height="25"><div align="center"><center><p>&nbsp;&nbsp;&nbsp;&nbsp;
          <br>
          <font face="$settings[6]" size="2">The user name or password that you specified does not exist.</font><br>
          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font face="$settings[6]" size="2"><strong>Use the back
          button of your browser to go back.<br>
          &nbsp;&nbsp;&nbsp; </strong></font></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>
END_OF_PROBLEM

$template =~ s/!!netboard!!/$txt/g;
print $template;

exit;

	}
	else
	{

	#$cookval = $uname . ":" . $upass;
	#sn_netbbs::setCookie("USER",$cookval);
	&view_profile2;
	}


}



sub view_profile2
{

my ($cntt) = @_;
my (@userstat, $filecont, $user, @settings, $txt, $template);

$template = sn_netbbs::get_file_contents("$data_dir/sn_view_profile.html");
$ptitle = sn_netbbs::get_page_title("sn_view_profile");

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");
$globalframe =~ s/!!pagetitle!!/$ptitle/g;

@settings = sn_netbbs::get_global_settings();

$user = $q->param('user');
$user =~ s/ /_/g;


for ($ms = 0; $ms < length($q->param('user')); $ms++) 
	{
	$oneletter = substr($q->param('user'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne " "))
		{
		sn_netbbs::fatal_error("Invalid User"); 
		exit;
		}
	} 


if ($template =~ m/\[na\]/g) { $startpos = pos($template); }
if ($template =~ m/\[\/na]/g) { $endpos = pos($template); }
$na_text = substr($template, $startpos, $endpos - $startpos - 5);

$template = sn_netbbs::display_errors($template, "na", "NODISPLAY");  


### CHECK IF USER IS LOGGED IN

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}
($uname, $upass) = split (/:/, $cookies{'USER'}, 2);

$logged_in_status = sn_netbbs::checkuser($uname, $upass); ### true / false


	#### IF NOT LOGGED IN
	
	if ($logged_in_status eq "false")
	{
	$loggedin_tmpl = sn_netbbs::get_file_contents("$data_dir/sn_view_profile_login.html");
	
	$vuser = $q->param('user');
	
	$hvars = qq[
	<input type="hidden" name="fct" value="login">
	<input type="hidden" name="user" value="$vuser">
	<input type="hidden" name="l" value="view_profile">
	</form>
	];
	
	$loggedin_tmpl =~ s/<\/form>/$hvars/gi;
	
	$globalframe =~ s/!!forums!!/$loggedin_tmpl/gi;
	$globalframe =~ s/!web_url!/$web_url/g;
	$globalframe =~ s/!!login_script!!/$scripts_url\/sn_login.cgi/g;
	
	
 	$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
	@gfsettings = split (/\n/, $gfs);
	
	$forumlogo = qq[<img src="$web_url/$gfsettings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/g;

	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
 
 	$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 
 
	print $globalframe;
	exit;
	} 

##########



$filecont = sn_netbbs::get_file_contents("$data_dir/users/$user.dat");
(@userstat) = split (/\n/,$filecont);

if ($userstat[3] eq "Y")
	{
	$userstat[2] = "<a href=\"mailto:$userstat[2]\">$userstat[2]</a>";
	}
	else
	{
	$userstat[2] = "Not visible";
	}


if ($userstat[0] eq "") {$userstat[0] = $q->param('user');}
if ($userstat[2] eq "") {$userstat[2] = "$na_text";}
if ($userstat[4] eq "") {$userstat[4] = "$na_text";}
if ($userstat[5] eq "") {$userstat[5] = "$na_text";}

if ($userstat[6] eq "") {$userstat[6] = "$na_text";}
	else
	{
	if ($userstat[6] !~ /http:\/\//){$userstat[6] = "http://" . $userstat[6];}
	$userstat[6] = "<a href=\"$userstat[6]\" target=\"_blank\">$userstat[6]</a>";
	}

if ($userstat[7] eq "") {$userstat[7] = "$na_text";}
if ($userstat[8] eq "") {$userstat[8] = "$na_text";}
if ($userstat[9] eq "") {$userstat[9] = "$na_text";}
if ($userstat[10] eq "") {$userstat[10] = "$na_text";}
if ($userstat[12] eq "") {$userstat[12] = "$na_text";}
if ($userstat[14] eq "") {$userstat[14] = "$na_text";}

$modadm_data = sn_netbbs::get_file_contents("$data_dir/sn_modadm.txt");
($adm, $mod, $mname) = split (/:::/, $modadm_data);


if (substr($userstat[12], 0, 2) eq "Mo") {$userstat[12] = $mod;}
if (substr($userstat[12], 0, 2) eq "Ad") {$userstat[12] = $adm;}
if (substr($userstat[12], 0, 2) eq "Me") {$userstat[12] = $mname;}

if ($userstat[13] ne "")
	{
	$userstat[13] = sn_netbbs::decode_date ($userstat[13]);
	}
	else
	{
	$userstat[13] = "Not Available";
	}


$gfs = sn_netbbs::get_file_contents("$data_dir/sn_settings.dat");
@gfsettings = split (/\n/, $gfs);





$template =~ s/!!member_name!!/$userstat[0]/gi;
$template =~ s/!!homepage_name!!/$userstat[4]/gi;
$template =~ s/!!homepage_diz!!/$userstat[5]/gi;
$template =~ s/!!homepage_url!!/$userstat[6]/gi;
$template =~ s/!!locationcc!!/$userstat[8]/gi;
$template =~ s/!!interests!!/$userstat[9]/gi;
$template =~ s/!!occupation!!/$userstat[10]/gi;
$template =~ s/!!member_status!!/$userstat[12]/gi;
$template =~ s/!!member_since!!/$userstat[13]/gi;
$template =~ s/!!total_posts!!/$userstat[14]/gi;

$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");

$loclink = qq[<a href="$scripts_url/sn_forum.cgi">$gfsettings[11]</a>];
$template =~ s/!!location!!/$loclink/g;
	
$globalframe =~ s/!!forums!!/$template/gi;
	
$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
$forumlogo = qq[<img src="$web_url/$gfsettings[0]">]; 
$globalframe =~ s/!!logo!!/$forumlogo/gi; 
$globalframe =~ s/!!forum_name!!/$gfsettings[11]/gi; 
	
$globalframe =~ s/!!pagetitle!!/$ptitle/g;
$globalframe =~ s/!web_url!/$web_url/g;
	
print $globalframe;
exit;



$txt = <<END_OF_PRF;

<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="$settings[5]">
  <tr>
    <td width="100%" bgcolor="$settings[2]" height="27" colspan="2"><font face="$settings[6]"
    size="4"><p align="left"></font><font face="$settings[6]" size="2" color="$settings[8]"><strong>Member
    Profile For $userstat[0]</strong></font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" height="27" valign="middle"><font face="$settings[6]" size="1">Email Address:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[2]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" height="27" valign="middle"><font face="$settings[6]" size="1">Home Page Name:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[4]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" valign="middle" height="27"><font face="$settings[6]" size="1">Home Page Description:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[5]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" height="27" valign="middle"><font face="$settings[6]" size="1">Home Page URL:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[6]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" height="27" valign="middle"><font face="$settings[6]" size="1">ICQ Number:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[7]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" height="27" valign="middle"><font face="$settings[6]" size="1">Location:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[8]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" valign="middle" height="27"><font face="$settings[6]" size="1">Interests:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[9]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" height="27" valign="middle"><font face="$settings[6]" size="1">Occupation:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[10]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" valign="middle" height="27"><font face="$settings[6]" size="1">Member Status:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[12]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" valign="middle" height="27"><font face="$settings[6]" size="1">Member Since:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[13]</font></td>
  </tr>
  <tr>
    <td width="31%" bgcolor="$settings[3]" valign="middle" height="27"><font face="$settings[6]" size="1">Total Number of Posts:</font></td>
    <td width="69%" bgcolor="$settings[4]" valign="middle"><font face="$settings[6]" size="1">$userstat[14]</font></td>
  </tr>
</table>

<form method="POST" action="$scripts_url">
  <div align="left"><p><input type="submit" value="Close This Window" name="B1"
  onClick="self.close();return false" style="font-family: MS Sans Serif; font-size: 8"></p>
  </div>
</form>

END_OF_PRF

$template =~ s/!!netboard!!/$txt/g;
print $template;

}


