#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use strict;
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbbs;
use sn_fmspm; 

#use constant IS_MODPERL => $ENV{MOD_PERL};
#use subs qw(exit);
#*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $sendmail_loc $web_path $flocking/;

$q = CGI->new;



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	sn_fmspm::check_spamb("sn_usr_img.cgi", "header", $data_dir);
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&start; exit;}


#### START ########################################################

sub start
{

my (@files, $image_dropdown, $Ncount, $item, @files, $nricons, $iic, $icount, $emicons,
	 $icon, $crit2, $imc, $template);


opendir(DIR,"$web_path/user_images");
	@files = readdir(DIR);
closedir(DIR);

$nricons = 0;

foreach $iic (@files)
	{
	if (($iic ne ".") and ($iic ne ".."))
		{
		$files[$nricons] = $iic;
		$nricons++;
		}
	}

#######################

$icount = 0;
$emicons = $emicons . "<table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\">\n";
$imc = 1;

for ($icon = 0; $icon < $nricons; $icon++) 
	{

	if ($icount == 0)
		{
		$emicons = $emicons . "<tr>\n";
		$crit2 = "";
		if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/user_images/$files[$icon]\" border=\"1\"><br><strong><font face=\"Verdana\" size=\"1\">Image $imc</font></strong>";}
		$emicons = $emicons . "<td width=\"10%\">$crit2</td>\n";
		$imc++;
		}

	if ($icount == 1)
		{
		$crit2 = "";
		if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/user_images/$files[$icon]\" border=\"1\"><br><strong><font face=\"Verdana\" size=\"1\">Image $imc</font></strong>";}
     	$emicons = $emicons . "<td width=\"10%\">$crit2</td>\n";
     	$imc++;
		}
	
	if ($icount == 2)
		{
		$crit2 = "";
		if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/user_images/$files[$icon]\" border=\"1\"><br><strong><font face=\"Verdana\" size=\"1\">Image $imc</font></strong>";}
     	$emicons = $emicons . "<td width=\"10%\">$crit2</td>\n";
     	$imc++;
		}

	if ($icount == 3)
		{
		$crit2 = "";
		if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/user_images/$files[$icon]\" border=\"1\"><br><strong><font face=\"Verdana\" size=\"1\">Image $imc</font></strong>";}
     	$emicons = $emicons . "<td width=\"10%\">$crit2</td>\n";
     	$imc++;
		}

	if ($icount == 4)
		{
		$crit2 = "";
		if ($files[$icon] ne ""){$crit2 = "<img src=\"$web_url/user_images/$files[$icon]\" border=\"1\"><br><strong><font face=\"Verdana\" size=\"1\">Image $imc</font></strong>";}
     	$emicons = $emicons . "<td width=\"10%\">$crit2</td>\n</tr>\n";
      $emicons = $emicons . "\n";
      $icount = 0;
      $imc++;
		}
		else
		{ 
      $icount++;
		}

	}

if ($icount == 0) {$emicons = $emicons . "</table>\n";}
if ($icount == 1) {$emicons = $emicons . "<td width=\"10%\"></td><td width=\"10%\"></td><td width=\"10%\"></td></tr></table>\n";}
if ($icount == 2) {$emicons = $emicons . "<td width=\"10%\"></td><td width=\"10%\"></td></tr></table>\n";}
if ($icount == 3) {$emicons = $emicons . "<td width=\"10%\"></td></tr></table>\n";}

print qq[<html>
<head>
<title></title>
</head>
<body>
$emicons
</body>
</html>
];

}

